import { A as isRef, w as watch, r as ref, bF as tryOnScopeDispose, o as openBlock, f as createElementBlock, m as createBaseVNode } from './index-B_buVPU_.js';
import { ax as Observable, a7 as from$1 } from './event-BS8SI8SU.js';

function from(value, watchOptions) {
  if (isRef(value))
    return new Observable((subscriber) => watch(value, (val) => subscriber.next(val), watchOptions));
  return from$1(value);
}

function useObservable(observable, options) {
  const value = ref(options == null ? void 0 : options.initialValue);
  const subscription = observable.subscribe({
    next: (val) => value.value = val,
    error: options == null ? void 0 : options.onError
  });
  tryOnScopeDispose(() => {
    subscription.unsubscribe();
  });
  return value;
}

function useSubscription(subscription) {
  tryOnScopeDispose(() => {
    subscription.unsubscribe();
  });
}

const _hoisted_1$3 = {
  viewBox: "0 0 16 16",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$3 = /*#__PURE__*/createBaseVNode("path", {
  fill: "currentColor",
  d: "M6 5a1 1 0 0 0-1 1v4a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1V6a1 1 0 0 0-1-1zM1 8a7 7 0 1 1 14 0A7 7 0 0 1 1 8m7-6a6 6 0 1 0 0 12A6 6 0 0 0 8 2"
}, null, -1);
const _hoisted_3$3 = [
  _hoisted_2$3
];

function render$3(_ctx, _cache) {
  return (openBlock(), createElementBlock("svg", _hoisted_1$3, [..._hoisted_3$3]))
}

const StopIcon = { name: 'fluent-record-stop-16-regular', render: render$3 };
/* vite-plugin-components disabled */

const _hoisted_1$2 = {
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$2 = /*#__PURE__*/createBaseVNode("path", {
  fill: "currentColor",
  d: "M14 19h4V5h-4M6 19h4V5H6z"
}, null, -1);
const _hoisted_3$2 = [
  _hoisted_2$2
];

function render$2(_ctx, _cache) {
  return (openBlock(), createElementBlock("svg", _hoisted_1$2, [..._hoisted_3$2]))
}

const PauseIcon = { name: 'mdi-pause', render: render$2 };
/* vite-plugin-components disabled */

const _hoisted_1$1 = {
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2$1 = /*#__PURE__*/createBaseVNode("path", {
  fill: "currentColor",
  d: "M8 5.14v14l11-7z"
}, null, -1);
const _hoisted_3$1 = [
  _hoisted_2$1
];

function render$1(_ctx, _cache) {
  return (openBlock(), createElementBlock("svg", _hoisted_1$1, [..._hoisted_3$1]))
}

const PlayIcon = { name: 'mdi-play', render: render$1 };
/* vite-plugin-components disabled */

const _hoisted_1 = {
  viewBox: "0 0 24 24",
  width: "1.2em",
  height: "1.2em"
};
const _hoisted_2 = /*#__PURE__*/createBaseVNode("path", {
  fill: "currentColor",
  d: "M20 6.91L17.09 4L12 9.09L6.91 4L4 6.91L9.09 12L4 17.09L6.91 20L12 14.91L17.09 20L20 17.09L14.91 12z"
}, null, -1);
const _hoisted_3 = [
  _hoisted_2
];

function render(_ctx, _cache) {
  return (openBlock(), createElementBlock("svg", _hoisted_1, [..._hoisted_3]))
}

const RemoveIcon = { name: 'mdi-remove-bold', render };
/* vite-plugin-components disabled */

const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};

export { PlayIcon as P, RemoveIcon as R, StopIcon as S, _export_sfc as _, PauseIcon as a, useSubscription as b, from as f, useObservable as u };
