import './el-result-b--j129v.js';
import { d as defineComponent, a as useSubscription, b as useMutation, c as computed, o as openBlock, i as createBlock, j as withCtx, k as createVNode, f as createElementBlock, m as createBaseVNode, g as unref, l as createTextVNode, p as createApp } from './index-B_buVPU_.js';
import { E as EnvDocument, c as SetEnvDocument } from './event-BS8SI8SU.js';
import { a as getSharedStorage } from './fetch-FElFJLmr.js';
import './browser-polyfill-IrS90NOa.js';
import { c as ElOption, d as ElSelect, E as ElButton, e as commonProvider } from './common-provider-CCqMHVZB.js';
import './interval-DGm5uo8I.js';
import './context-CuoyyfJD.js';
import './server-DoNLbJ8S.js';

const _sfc_main$1 = /*@__PURE__*/ defineComponent({
    __name: 'env-switch',
    setup (__props) {
        const envSubscription = useSubscription(EnvDocument);
        const envMutation = useMutation(SetEnvDocument);
        const env = computed({
            get () {
                return envSubscription.result.value?.env;
            },
            set (value) {
                if (!value) {
                    return;
                }
                envMutation.mutate({
                    env: value
                });
            }
        });
        return (_ctx, _cache)=>{
            const _component_el_option = ElOption;
            const _component_el_select = ElSelect;
            return openBlock(), createBlock(_component_el_select, {
                modelValue: env.value,
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event)=>env.value = $event)
            }, {
                default: withCtx(()=>[
                        createVNode(_component_el_option, {
                            value: "production"
                        }),
                        createVNode(_component_el_option, {
                            value: "pre"
                        }),
                        createVNode(_component_el_option, {
                            value: "testing"
                        }),
                        createVNode(_component_el_option, {
                            value: "development"
                        })
                    ]),
                _: 1
            }, 8, [
                "modelValue"
            ]);
        };
    }
});

const _hoisted_1 = {
    class: "flex flex-col items-center w-screen"
};
const _hoisted_2 = {
    class: "w-[600px] m-16"
};
const _sfc_main = /*@__PURE__*/ defineComponent({
    __name: 'dev-page',
    setup (__props) {
        function clearData() {
            getSharedStorage().clear();
        }
        return (_ctx, _cache)=>{
            const _component_el_button = ElButton;
            return openBlock(), createElementBlock("div", _hoisted_1, [
                createBaseVNode("table", _hoisted_2, [
                    createBaseVNode("tbody", null, [
                        createBaseVNode("tr", null, [
                            _cache[0] || (_cache[0] = createBaseVNode("td", null, "Env", -1)),
                            createBaseVNode("td", null, [
                                createVNode(unref(_sfc_main$1))
                            ])
                        ]),
                        createBaseVNode("tr", null, [
                            _cache[2] || (_cache[2] = createBaseVNode("td", null, "Data", -1)),
                            createBaseVNode("td", null, [
                                createVNode(_component_el_button, {
                                    onClick: clearData
                                }, {
                                    default: withCtx(()=>_cache[1] || (_cache[1] = [
                                            createTextVNode("Clear Data")
                                        ])),
                                    _: 1
                                })
                            ])
                        ])
                    ])
                ])
            ]);
        };
    }
});

function setupDevPage() {
    createApp(_sfc_main).use(commonProvider()).mount('#app');
}

setupDevPage();
