import { $ as singleton, a0 as inject, a1 as UPLOADER_SERVICE, a2 as FILE_STASH_SERVICE, a3 as SELECT_ELEMENT_SERVICE, a4 as $logCls } from './fetch-FElFJLmr.js';
import { ap as __decorate, aq as __param, ar as __metadata, b as CommonEvent, a as ContentScriptToBackgroundEvent, p as commonjsGlobal, q as getDefaultExportFromCjs, x as Region, as as bind, F as FULL_VERSION, at as OAUTH_KEY, n as APP_ID_KEY, au as CLIENT, an as DEFAULT_LOCALE } from './event-BS8SI8SU.js';
import { bi as createI18n, bj as messages } from './index-B_buVPU_.js';

const BRIDGE_INJECTION_TOKEN = 'webext-bridge';
class RemoteUploaderService {
    bridge;
    static register(container, bridge) {
        container.register(BRIDGE_INJECTION_TOKEN, {
            useValue: bridge
        }).register(UPLOADER_SERVICE, {
            useToken: RemoteUploaderService
        }).register(FILE_STASH_SERVICE, {
            useToken: RemoteUploaderService
        }).register(SELECT_ELEMENT_SERVICE, {
            useToken: RemoteUploaderService
        });
    }
    constructor(bridge){
        this.bridge = bridge;
    }
    uploadTask(args) {
        return this.bridge.sendMessage(CommonEvent.UploadTask, args, 'offscreen');
    }
    cancelTask(args) {
        return this.bridge.sendMessage(CommonEvent.CancelTask, args, 'offscreen');
    }
    touchStashFile(args) {
        return this.bridge.sendMessage(CommonEvent.TouchStashFile, args, 'offscreen');
    }
    async markFileStashed(args) {
        return this.bridge.sendMessage(CommonEvent.MarkFileStashed, args, 'offscreen');
    }
    getFileStashStatus(taskId) {
        return this.bridge.sendMessage(CommonEvent.GetTaskUploadStatus, taskId, 'offscreen');
    }
    selectElementAction(action, frameId) {
        return this.bridge.sendMessage(ContentScriptToBackgroundEvent.SelectElementAction, {
            action,
            frameId
        }, 'background');
    }
}
RemoteUploaderService = __decorate([
    singleton(),
    __param(0, inject(BRIDGE_INJECTION_TOKEN)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [
        typeof BridgeType === "undefined" ? Object : BridgeType
    ])
], RemoteUploaderService);

var aegis_min = {exports: {}};

/**
 *  =================================================================
 * aegis-web-sdk@1.39.1 (c) 2024 TencentCloud Real User Monitoring.
 * Author pumpkincai.
 * Last Release Time Thu Jan 18 2024 10:11:02 GMT+0800 (中国标准时间).
 * Released under the MIT License.
 * Thanks for supporting RUM & Aegis!
 * =================================================================
 **/

(function (module, exports) {
	!function(e,t){module.exports=t();}(commonjsGlobal,function(){var q,j;function _(e){this.name="__st"+(1e9*Math.random()>>>0)+q+"__",null!=e&&e.forEach(this.add,this),q+=1;}Array.prototype.find||Object.defineProperty(Array.prototype,"find",{configurable:!0,writable:!0,value:function(e){if(null===this)throw new TypeError('"this" is null or not defined');var t=Object(this),n=t.length>>>0;if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var r=arguments[1],o=0;o<n;){var i=t[o];if(e.call(r,i,o,t))return i;o+=1;}}}),window.WeakSet||(q=Date.now()%1e9,_.prototype.add=function(e){var t=this.name;return e[t]||Object.defineProperty(e,t,{value:!0,writable:!0}),this},_.prototype.delete=function(e){return !!e[this.name]&&!(e[this.name]=void 0)},_.prototype.has=function(e){return !!e[this.name]},j=_,Object.defineProperty(window,"WeakSet",{value:function(e){return new j(e)}})),Object.assign||Object.defineProperty(Object,"assign",{enumerable:!1,configurable:!0,writable:!0,value:function(e){if(null==e)throw new TypeError("Cannot convert first argument to object");for(var t=Object(e),n=1;n<arguments.length;n++)if(null!=(r=arguments[n]))for(var r=Object(r),o=Object.keys(Object(r)),i=0,a=o.length;i<a;i++){var s=o[i],c=Object.getOwnPropertyDescriptor(r,s);null!=c&&c.enumerable&&(t[s]=r[s]);}return t}});var D=function(e,t){return (D=Object.setPrototypeOf||({__proto__:[]}instanceof Array?function(e,t){e.__proto__=t;}:function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);}))(e,t)},l=function(){return (l=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function u(){for(var e=0,t=0,n=arguments.length;t<n;t++)e+=arguments[t].length;for(var r=Array(e),o=0,t=0;t<n;t++)for(var i=arguments[t],a=0,s=i.length;a<s;a++,o++)r[o]=i[a];return r}var M=/_?t(\d)?(imestamp)?=\d+&?/g,B=["aegis.qq.com","tamaegis.com","/aegis-sdk","rumt-","/flog.core.min.js","pingfore.qq.com","pingfore.tencent.com","zhiyan.tencent-cloud.net","h.trace.qq.com","btrace.qq.com","beacon.qq.com","dmplog.qq.com","qq.com/report","svibeacon.onezapp.com","cube.weixinbridge.com","doubleclick.net","pcmgrmonitor.3g.qq.com","tdm.qq.com","report.qqweb.qq.com","tpstelemetry.tencent.com","insight.cloud.tencent.com","facebook.com","facebook.net","google","yahoo.com","twitter.com","ga-audiences","report.idqqimg.com","arms-retcode.aliyuncs.com","px.effirst.com","sentry","baidu.com","hot-update.json","u.c.b.r.o.w.s.e.r","report.url.cn","sockjs-node","m3u8"],F=["ResizeObserver loop limit exceeded","ResizeObserver loop completed","Failed to execute 'transaction'","window.indexedDB.deleteDatabase is not a function"],W=["ext1","ext2","ext3","level","trace","tag","seq","code"],G=["static","fetch"],b="unknown",X=(e.prototype.indexOf=function(e,t){for(var n=0;n<e.length;n++)if(e[n].callback===t)return n;return -1},e.prototype.on=function(e,t,n){var r;if(void 0===n&&(n=0),this)return (r=this.eventsList[e])||(this.eventsList[e]=[],r=this.eventsList[e]),-1===this.indexOf(r,t)&&r.push({name:e,type:n||0,callback:t}),this},e.prototype.one=function(e,t){this.on(e,t,1);},e.prototype.remove=function(e,t){if(this){var n=this.eventsList[e];if(n){if(t)return n.length&&(t=this.indexOf(n,t),n.splice(t,1)),this;try{delete this.eventsList[e];}catch(e){}}return null}},e.prototype.clear=function(){this.eventsList={};},e),V={generateTraceId:J(16),generateSpanId:J(8)},$=Array(32);function e(){var a=this;this.emit=function(e,t){if(a){var n;if(null!=(r=a.eventsList[e])&&r.length)for(var r=r.slice(),o=0;o<r.length;o++){n=r[o];try{var i=n.callback.apply(a,[t]);if(1===n.type&&a.remove(e,n.callback),!1===i)break}catch(e){throw e}}return a}},this.eventsList={};}function J(t){return function(){for(var e=0;e<2*t;e++)$[e]=Math.floor(16*Math.random())+48,58<=$[e]&&($[e]+=39);return String.fromCharCode.apply(null,$.slice(0,2*t))}}function K(){return ([1e7]+1e3+4e3+8e3+1e11).replace(/[018]/g,function(e){return (e^(16*Math.random()&15)>>e/4).toString(16)})}function z(){return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return ("x"===e?t:3&t|8).toString(16)})}function Q(e){for(var t,n,r,o="",i=0,a=(e=String(e)).length%3;i<e.length;){if(255<(t=e.charCodeAt(i++))||255<(n=e.charCodeAt(i++))||255<(r=e.charCodeAt(i++)))throw new TypeError("Failed to execute 'btoa': The string to be encoded contains characters outside of the Latin1 range.");o+=s.charAt((t=t<<16|n<<8|r)>>18&63)+s.charAt(t>>12&63)+s.charAt(t>>6&63)+s.charAt(63&t);}return a?o.slice(0,a-3)+"===".substring(a):o}function Y(e){if(e=String(e).replace(/[\t\n\f\r ]+/g,""),!ee.test(e))throw new TypeError("Failed to execute 'atob': The string to be decoded is not correctly encoded.");var t;e+="==".slice(2-(3&e.length));for(var n,r,o="",i=0;i<e.length;)t=s.indexOf(e.charAt(i++))<<18|s.indexOf(e.charAt(i++))<<12|(n=s.indexOf(e.charAt(i++)))<<6|(r=s.indexOf(e.charAt(i++))),o+=64===n?String.fromCharCode(t>>16&255):64===r?String.fromCharCode(t>>16&255,t>>8&255):String.fromCharCode(t>>16&255,t>>8&255,255&t);return o}function Z(e){var t,n="";return n="object"==typeof e&&(t=(e=function(e,t){for(var n=0;n<t.length;n++){var r=t[n],o=e[r]||"function"==typeof e.get&&e.get(r);if(o)return [r,o]}return ["",""]}(e,Object.keys(ne)))[0],e=e[1],t)?ne[t](e):n}var n,s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",ee=/^(?:[A-Za-z\d+\/]{4})*?(?:[A-Za-z\d+\/]{2}(?:==)?|[A-Za-z\d+\/]{3}=?)?$/,te=(t.prototype.generate=function(e,t,n){if(void 0===t&&(t={}),this.url=e,!this.isUrlIgnored()&&this.isUrlInTraceUrls()&&this.traceType){switch(this.traceType){case"traceparent":this.traceId=this.createTraceparent();break;case"b3":this.traceId=this.createB3();break;case"sw8":this.traceId=this.createSw8(n);break;case"sentry-trace":this.traceId=this.createSentryTrace();break;default:return console.warn("this trace key "+this.traceType+" is not supported"),void(this.traceId="")}return t[this.traceType]&&(this.traceId=t[this.traceType]),{name:this.traceType,value:this.traceId}}},t.prototype.createTraceparent=function(){var e=V.generateSpanId();return "00-"+V.generateTraceId()+"-"+e+"-0"+Number(1).toString(16)},t.prototype.createB3=function(){var e=V.generateSpanId();return V.generateTraceId()+"-"+e+"-1"},t.prototype.createSw8=function(e){var t="function"==typeof btoa?btoa:Q,e=e||{},n=e.host,n=void 0===n?"":n,e=e.pathname,e=void 0===e?"":e,r=z(),o=z();return "1-"+String(t(o))+"-"+String(t(r))+"-1-"+String(t("aegis"))+"-"+String(t("1.39.1"))+"-"+String(t(encodeURI(e)))+"-"+String(t(n))},t.prototype.createSentryTrace=function(){var e=K().substring(16);return K()+"-"+e+"-1"},t.prototype.isUrlIgnored=function(){if(Array.isArray(this.ignoreUrls)&&0!==this.ignoreUrls.length)for(var e=0,t=this.ignoreUrls;e<t.length;e++){var n=t[e];if(this.urlMatches(this.url,n))return !0}return !1},t.prototype.isUrlInTraceUrls=function(){if(!this.urls)return !0;if(Array.isArray(this.urls)){if(0===this.urls.length)return !1;for(var e=0,t=this.urls;e<t.length;e++){var n=t[e];if(this.urlMatches(this.url,n))return !0}}return !1},t.prototype.urlMatches=function(e,t){return "string"==typeof t?e===t:!!e.match(t)},t),ne={sw8:function(e){var t="function"==typeof atob?atob:Y,e=e.split("-")[1];return e?t(e):""},traceparent:function(e){return e.split("-")[1]},b3:function(e){return e.split("-")[0]},"sentry-trace":function(e){return e.split("-")[0]}},re=function(e){if(!e||0===e.length)return "{}";e=Array.isArray(e)?e:[e];var t=Object.keys(e[0]),n={};return t.forEach(function(t){n[t]=e.map(function(e){return e[t]});}),n.count=e.length,be(n)};function t(e,t,n){void 0===n&&(n=null),this.traceType=e,this.ignoreUrls=t,this.urls=n;}(o=n=n||{})[o.number=-1]="number",o.string="";function oe(e,t){return "number"==typeof e||"string"==typeof e?e:n.number}function E(e,t){return "string"==typeof e?e.split("?")[t?1:0]||"":e}function ie(e,t){return void 0===t&&(t=2048),String(e).replace(M,"").slice(0,t)}function ae(e){return "string"==typeof e&&/^\//.test(e)?"https:"===(null===location||void 0===location?void 0:location.protocol):/^https/.test(e)}function se(e,t,n){var r,o,i,a;try{if("function"==typeof(null==t?void 0:t.retCodeHandler))return i=(o=t.retCodeHandler(e,null==n?void 0:n.url,null==n?void 0:n.ctx,null==n?void 0:n.payload)||{}).code,a=o.isErr,{code:void 0===i?b:i,isErr:a};if(!(e="string"==typeof e?JSON.parse(e):e))return {code:b,isErr:!1};"function"==typeof(null==(r=null==t?void 0:t.ret)?void 0:r.join)&&(ye=[].concat(t.ret.map(function(e){return e.toLowerCase()})));var s=Object.getOwnPropertyNames(e).filter(function(e){return -1!==ye.indexOf(e.toLowerCase())});return s.length?{code:""+(i="未知"!==(i=e[s[0]])&&""!==i?i:b),isErr:0!==i&&"0"!==i&&i!==b}:{code:b,isErr:!1}}catch(e){return {code:b,isErr:!1}}}function ce(e,t,n){try{var r="function"==typeof t?t(e,null==n?void 0:n.url)||"":e;return Ee(r).slice(0,102400)}catch(e){return ""}}function R(t,e){return "string"!=typeof t||!t||e&&-1<t.indexOf(e)||Te.test(t)||B.some(function(e){return -1<t.indexOf(e)})}function ue(n,r){var o,i=[],a=n.config;return n.lifeCycle.on("destroy",function(){i.length=0;}),function(e,t){Array.isArray(e)?i=i.concat(e):i.push(e),r&&i.length>=r||n.sendNow&&0<i.length?(i=Se(i),t(i.splice(0,i.length)),o&&clearTimeout(o)):(o&&clearTimeout(o),o=setTimeout(function(){o=null,0<(i=Se(i)).length&&t(i.splice(0,i.length));},a.delay));}}function le(e,t){return Array.isArray(e)?t(e.map(function(e){return t=l(l({},e),{msg:"string"==typeof e.msg?e.msg:[].concat(e.msg).map(y).join(" ")}),W.forEach(function(e){t[e]||delete t[e];}),t;var t;})):t([l(l({},e),{msg:"string"==typeof e.msg?e.msg:y(e.msg)})])}function fe(c,u){return function(e,t){var n,r,o,i=Array.isArray(e),a=i?e:[e],s=(c.lifeCycle.emit("beforeRequest",e),c.config.beforeRequest);(a="function"==typeof s?a.map(function(t){try{var e=s({logs:t,logType:u});return (null==e?void 0:e.logType)===u&&null!=e&&e.logs?e.logs:!1!==e&&t}catch(e){return t}}).filter(function(e){return !1!==e}):a).length&&(n=a,e=W,!Array.isArray(n)||n.length<=1||(r=[],o=[],!(o="string"==typeof e?[e]:e))||o.length<=0||(o.forEach(function(t){n.forEach(function(e){null!=e&&e[t]&&r.push(t);});}),0<r.length&&(n=n.map(function(e){var t={};return r.forEach(function(e){t[e]="";}),l(l({},t),e)}))),a=n,t(i?a:a[0]));}}function de(o){return function(e,t){o.lifeCycle.emit("modifyRequest",e);var n=o.config.modifyRequest;if("function"==typeof n)try{var r=n(e);"object"==typeof r&&"url"in r&&(e=r);}catch(e){console.error(e);}t(e);}}function pe(r){return function(e,t){null!=(n=r.lifeCycle)&&n.emit("afterRequest",e);var n=(r.config||{}).afterRequest;"function"==typeof n&&!1===n(e)||t(e);}}function m(n){if(n&&n.reduce&&n.length)return 1===n.length?function(e,t){n[0](e,t||Ce);}:n.reduce(function(n,r){return function(e,t){return void 0===t&&(t=Ce),n(e,function(e){return null==r?void 0:r(e,t)})}});throw new TypeError("createPipeline need at least one function param")}function he(t,n){Object.getOwnPropertyNames(t).forEach(function(e){"function"==typeof t[e]&&"constructor"!==e&&(n?n[e]="sendPipeline"===e?function(){return function(){}}:function(){}:t[e]=function(){});});}function ge(){return void 0!==window.performance&&"function"==typeof performance.getEntriesByType&&"function"==typeof performance.now}function r(e){return -1!==He.indexOf(e)}var w,v,f,me=["application/xhtml+xml","application/xml","application/pdf","application/pkcs12","application/javascript","application/x-javascript","application/ecmascript","application/vnd.mspowerpoint","application/vnd.apple.mpegurl","application/ogg","text/css","text/javascript","image","audio","video","video/mp2t"],ve=/\.(json|js|css|jpg|jpeg|png|svg|apng|webp|gif|bmp|mp4|mp3|ts|mpeg|wav|webm|ogg|flv|m3u8|ttf|woff2|otf|eot|woff|html|htm|shtml|shtm|)$/i,ye=["ret","retcode","code","errcode"],we=function(){var n=new WeakSet;return function(e,t){if(t instanceof Error)return "Error.message: "+t.message+" \n  Error.stack: "+t.stack;if("object"==typeof t&&null!==t){if(n.has(t))return "[Circular "+(e||"root")+"]";n.add(t);}return t}},y=function(e){if("string"==typeof e)return e;try{return e instanceof Error?(JSON.stringify(e,we(),4)||"undefined").replace(/"/gim,""):JSON.stringify(e,we(),4)||"undefined"}catch(e){return "error happen when aegis stringify: \n "+e.message+" \n "+e.stack}},be=function(e){if("string"==typeof e)return e;try{return JSON.stringify(e,we())||"undefined"}catch(e){return "error happen when aegis stringify: \n "+e.message+" \n "+e.stack}},Ee=function(n,r){void 0===r&&(r=3);var o,i,a,s="";return Array.isArray(n)?(s+="[",o=n.length,n.forEach(function(e,t){s=(s+="object"==typeof e&&1<r?Ee(e,r-1):Oe(e))+(t===o-1?"":",");}),s+="]"):n instanceof Object?(s="{",i=Object.keys(n),a=i.length,i.forEach(function(e,t){"object"==typeof n[e]&&1<r?s+='"'+e+'":'+Ee(n[e],r-1):s+=Re(e,n[e]),s+=t===a-1||t<a-1&&void 0===n[i[t+1]]?"":",";}),s+="}"):s+=n,s},Re=function(e,t){var n=typeof t,r="";return "string"==n||"object"==n?r+='"'+e+'":"'+t+'"':"function"==typeof t?r+='"'+e+'":"function '+t.name+'"':"symbol"==typeof t?r+='"'+e+'":"symbol"':"number"!=typeof t&&"boolean"!=n||(r+='"'+e+'": '+t),r},Oe=function(e){var t=typeof e;return ""+("undefined"==t||"symbol"==t||"function"==t?"null":"string"==t||"object"==t?'"'+e+'"':e)},Te=/data:(image|text|application|font)\/.*;base64/,Se=((o=w=w||{}).INFO_ALL="-1",o.API_RESPONSE="1",o.INFO="2",o.ERROR="4",o.PROMISE_ERROR="8",o.AJAX_ERROR="16",o.SCRIPT_ERROR="32",o.IMAGE_ERROR="64",o.CSS_ERROR="128",o.CONSOLE_ERROR="256",o.MEDIA_ERROR="512",o.RET_ERROR="1024",o.REPORT="2048",o.PV="4096",o.EVENT="8192",o.PAGE_NOT_FOUND_ERROR="16384",o.WEBSOCKET_ERROR="32768",o.BRIDGE_ERROR="65536",o.LAZY_LOAD_ERROR="131072",(o=v=v||{}).LOG="log",o.SPEED="speed",o.PERFORMANCE="performance",o.OFFLINE="offline",o.WHITE_LIST="whiteList",o.VITALS="vitals",o.PV="pv",o.CUSTOM_PV="customPV",o.EVENT="event",o.CUSTOM="custom",o.SDK_ERROR="sdkError",o.SET_DATA="setData",o.LOAD_PACKAGE="loadPackage",(o=f=f||{}).production="production",o.development="development",o.gray="gray",o.pre="pre",o.daily="daily",o.local="local",o.test="test",o.others="others",function(e){return e.filter(function(n,r){return "static"!==n.type||!e.find(function(e,t){return n.url===e.url&&200===n.status&&r<t})})}),xe=function(e){e.level===w.INFO_ALL&&(e.level=w.INFO);},O={},T={},Pe=function(e){return O[e]||(O[e]=setTimeout(function(){T[e]={},O[e]=null;},6e4)),O[e]},Le=function(e){return (Array.isArray(e)?e:[e]).map(function(n){return Object.getOwnPropertyNames(n).reduce(function(e,t){return "ctx"!==t&&(e[t]=n[t]),e},{level:w.INFO,msg:""})})},ke=function(r){return function(e){return r.sendPipeline([function(e,n){return n({url:r.config.url||"",data:re(Le(e)),method:"post",contentType:"application/json",type:v.LOG,log:e,requestConfig:{timeout:5e3},success:function(){var t=r.config.onReport;"function"==typeof t&&e.forEach(function(e){t(e);}),"function"==typeof n&&n([]);}})}],v.LOG)(e)}},Ce=function(){},o=(S.use=function(e){-1===S.installedPlugins.indexOf(e)&&e.aegisPlugin&&S.installedPlugins.push(e);},S.unuse=function(e){e=S.installedPlugins.indexOf(e);-1!==e&&S.installedPlugins.splice(e,1);},S.prototype.init=function(e){this.setConfig(e);for(var t=0;t<S.installedPlugins.length;t++)try{S.installedPlugins[t].patch(this);}catch(e){this.sendSDKError(e);}this.lifeCycle.emit("onInited");},S.prototype.destroy=function(e){void 0===e&&(e=!1);var t,n,r=S.instances.indexOf(this);-1!==r&&S.instances.splice(r,1);for(var o=S.installedPlugins.length-1;0<=o;o--)try{S.installedPlugins[o].unpatch(this);}catch(e){this.sendSDKError(e);}if(this.lifeCycle.emit("destroy"),this.lifeCycle.clear(),e)t=this,n=Object.getOwnPropertyDescriptors(t),Object.keys(n).forEach(function(e){n[e].writable&&(t[e]=null);}),Object.setPrototypeOf(this,null);else {for(var i=this;i.constructor!==Object&&he(i,this),i=Object.getPrototypeOf(i););0===S.instances.length&&(r=Object.getPrototypeOf(this).constructor,he(r),he(S));}},S.prototype.setConfig=function(e){Object.assign(this.config,e);var e=this.config,t=e.id,n=e.uin,r=e.version,o=e.ext1,i=e.ext2,a=e.ext3,s=e.aid,c=e.env,u=void 0===c?"production":c,c=e.pageUrl,e=this.bean.id!==t||this.bean.uin!==n||this.bean.aid!==s;return this.bean.id=t||"",this.bean.uin=n||"",this.bean.version=r||"1.39.1",this.bean.aid=s||"",this.bean.env=function(){switch(u){case f.production:case f.development:case f.gray:case f.pre:case f.daily:case f.local:case f.test:case f.others:return 1;default:return}}()?u:f.others,c&&this.extendBean("from",encodeURIComponent(c.slice(0,2048))),o&&this.extendBean("ext1",encodeURIComponent(o)),i&&this.extendBean("ext2",encodeURIComponent(i)),a&&this.extendBean("ext3",encodeURIComponent(a)),e&&this.lifeCycle.emit("onConfigChange",this.config),this.config},S.prototype.extendBean=function(e,t){this.bean[e]=t;},S.prototype.send=function(e,o,i){var t=this;return m([de(this),function(n,r){t.request(n,function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];r({isErr:!1,result:e,logType:n.type,logs:n.log}),null!=o&&o.apply(void 0,e);},function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];r({isErr:!0,result:e,logType:n.type,logs:n.log}),null!=i&&i.apply(void 0,e);});},pe(this)])(e)},S.prototype.sendSDKError=function(e){var n=this;this.sendPipeline([function(e,t){t({url:n.config.url+"?id=1085&msg[0]="+encodeURIComponent(y(e))+"&level[0]=2&from="+n.config.id+"&count=1&version="+n.config.id+"(1.39.1)",addBean:!1,method:"get",type:v.SDK_ERROR,log:e});}],v.SDK_ERROR)(e);},S.prototype.sendPipeline=function(e,t){var n,i=this;return m(u([function(e,t){if("number"!=typeof n.config.random&&(console.warn("random must in [0, 1], default is 1."),n.config.random=1),!n.isHidden||!n.isGetSample)if(n.isGetSample)n.isHidden||t(e);else {if(n.isGetSample=!0,Math.random()<n.config.random)return n.isHidden=!1,t(e);n.isHidden=!0;}},fe(n=this,t)],e,[de(this),function(r,o){i.request(r,function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=!1;-1<(""+e[i.failRequestCount=0]).indexOf("403 forbidden")&&(n=!0,i.destroy()),o({isErr:n,result:e,logType:null==r?void 0:r.type,logs:null==r?void 0:r.log}),null!=(n=null==r?void 0:r.success)&&n.call.apply(n,u([r],e));},function(){for(var e,t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];60<=++i.failRequestCount&&i.destroy(),-1<(""+t[0]).indexOf("403 forbidden")&&i.destroy(),o({isErr:!0,result:t,logType:null==r?void 0:r.type,logs:null==r?void 0:r.log}),null!=(e=null==r?void 0:r.fail)&&e.call.apply(e,u([r],t));});},pe(this)]))},S.prototype.info=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n={level:w.INFO,msg:e};1===e.length&&e[0].msg&&Object.assign(n,l({},e[0]),{level:w.INFO}),this.normalLogPipeline(n);},S.prototype.infoAll=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n={level:w.INFO_ALL,msg:e};1===e.length&&e[0].msg&&Object.assign(n,l({},e[0]),{level:w.INFO_ALL}),this.normalLogPipeline(n);},S.prototype.report=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n={level:w.REPORT,msg:e};1===e.length&&e[0].msg&&Object.assign(n,l({},e[0])),this.normalLogPipeline(n);},S.prototype.error=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n={level:w.ERROR,msg:e};1===e.length&&e[0].msg&&Object.assign(n,l({},e[0]),{level:w.ERROR}),this.normalLogPipeline(n);},S.prototype.reportEvent=function(e){e&&((e="string"==typeof e?{name:e,ext1:this.config.ext1||"",ext2:this.config.ext2||"",ext3:this.config.ext3||""}:e).name?("string"!=typeof e.name&&(console.warn("reportEvent params name must be string"),e.name=String(e.name)),this.eventPipeline(e)):console.warn("reportEvent params error"));},S.prototype.reportT=function(e){var t=e.name,n=e.duration,r=e.ext1,r=void 0===r?"":r,o=e.ext2,o=void 0===o?"":o,i=e.ext3,i=void 0===i?"":i,e=e.from;if("string"==typeof t&&"number"==typeof n&&"string"==typeof r&&"string"==typeof o&&"string"==typeof i){if(!(n<0||6e4<n))return this.submitCustomTime(t,n,r,o,i,void 0===e?"":e);console.warn("reportTime: duration must between 0 and 60000");}else console.warn("reportTime: params error");},S.prototype.reportTime=function(e,t){if("object"==typeof e)return this.reportT(e);"string"==typeof e?"number"==typeof t?t<0||6e4<t?console.warn("reportTime: duration must between 0 and 60000"):this.submitCustomTime(e,t):console.warn("reportTime: second param must be number"):console.warn("reportTime: first param must be a string");},S.prototype.time=function(e){"string"==typeof e?this.timeMap[e]?console.warn("Timer "+e+" already exists"):this.timeMap[e]=Date.now():console.warn("time: first param must be a string");},S.prototype.timeEnd=function(e){"string"==typeof e?this.timeMap[e]?(this.submitCustomTime(e,Date.now()-this.timeMap[e]),delete this.timeMap[e]):console.warn("Timer "+e+" does not exist"):console.warn("timeEnd: first param must be a string");},S.prototype.ready=function(e,t,n){throw new Error('You need to override "ready" method')},S.prototype.request=function(e,t,n){throw new Error('You need to override "request" method')},S.prototype.speedLogPipeline=function(e){throw new Error('You need to override "speedLogPipeline" method')},Object.defineProperty(S.prototype,"__version__",{get:function(){return "1.39.1"},enumerable:!1,configurable:!0}),Object.defineProperty(S.prototype,"LogType",{get:function(){return w},enumerable:!1,configurable:!0}),S.prototype.reportPv=function(e){e&&console.warn("reportPv is deprecated, please use reportEvent");},S.prototype.submitCustomTime=function(e,t,n,r,o,i){this.customTimePipeline({name:e,duration:t,ext1:n||this.config.ext1,ext2:r||this.config.ext2,ext3:o||this.config.ext3,from:i||void 0});},S.version="1.39.1",S.instances=[],S.logType=w,S.environment=f,S.installedPlugins=[],S),i=(c.prototype.patch=function(e){this.canUse(e)&&this.exist(e)&&(this.instances.push(e),this.triggerInit(e),this.triggerOnNewAegis(e));},c.prototype.unpatch=function(e){var t=this.instances.indexOf(e);-1!==t&&(this.instances.splice(t,1),0===this.instances.length)&&this.uninstall(e);},c.prototype.countInstance=function(){return this.instances.length},c.prototype.uninstall=function(e){var t;null!=(t=null==(t=this.option)?void 0:t.destroy)&&t.apply(this,[e]);},c.prototype.walk=function(n){var r=this;this.instances.forEach(function(e){var t=r.canUse(e);t&&n(e,t);});},c.prototype.canUse=function(e){e=this.getConfig(e);return !(!e||"object"!=typeof e)||!!e},c.prototype.getConfig=function(e){return null==(e=e.config)?void 0:e[this.name]},c.prototype.exist=function(e){return -1===this.instances.indexOf(e)},c.prototype.triggerInit=function(e){var t;this.inited||(this.inited=!0,null==(t=null==(t=this.option)?void 0:t.init))||t.call(this.option,this.getConfig(e));},c.prototype.triggerOnNewAegis=function(e){var t;null!=(t=null==(t=this.option)?void 0:t.onNewAegis)&&t.call(this.option,e,this.getConfig(e));},c),Ae=new i({name:"aid",aid:"",init:function(e){try{var t=!0!==e&&e||window.localStorage.getItem("AEGIS_ID");t||(t="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return ("x"===e?t:3&t|8).toString(16)}),window.localStorage.setItem("AEGIS_ID",t)),this.aid=t;}catch(e){}},onNewAegis:function(e){e.bean.aid=this.aid,e.config.aid=this.aid;}}),Ie=function(t){var n;return t.payload?(n={},Object.keys(t).forEach(function(e){"payload"!==e&&(n[e]=t[e]);}),n):t},Ne=new i({name:"reportAssetSpeed"}),Ue=Ne=new i({name:"reportAssetSpeed",collectCur:0,collectEntryType:"resource",ASSETS_INITIATOR_TYPE:["img","css","script","link","audio","video"],onNewAegis:function(e){var t=this;ge()&&(this.collectSuccessLog(e),this.collectFailLog(e),performance.onresourcetimingbufferfull=function(){"function"==typeof performance.clearResourceTimings&&(t.collectCur=0,performance.clearResourceTimings());});},publish:function(t,n){this.$walk(function(e){e===n&&e.speedLogPipeline(t);});},publishMany:function(e,t){for(var n=t.config,r=0,o=e.length;r<o;r++){var i=e[r];-1===this.ASSETS_INITIATOR_TYPE.indexOf(i.initiatorType)||R(i.name,n.hostUrl)||this.publish(this.generateLog(i,n),t);}},collectSuccessLog:function(n){var e,t,r=this;"function"==typeof window.PerformanceObserver?(this.publishMany(performance.getEntriesByType(this.collectEntryType),n),(e=new window.PerformanceObserver(function(e){r.publishMany(e.getEntries(),n);})).observe({entryTypes:[this.collectEntryType]}),n.lifeCycle.on("destroy",function(){0===Ne.countInstance()&&e.disconnect();})):(t=setInterval(function(){var e=performance.getEntriesByType(r.collectEntryType),t=e.slice(r.collectCur);r.collectCur=e.length,r.publishMany(t,n);},3e3),n.lifeCycle.on("destroy",function(){0===Ne.countInstance()&&clearInterval(t);}));},collectFailLog:function(r){function e(e){var t,n;e&&(e=e.target||e.srcElement,!(t=(null==e?void 0:e.src)||(null==e?void 0:e.href))||"string"!=typeof t||-1<window.location.href.indexOf(t)||(e="function"==typeof(null==(e=i.api)?void 0:e.resourceTypeHandler)?null==(e=i.api)?void 0:e.resourceTypeHandler(t):"",n=performance.getEntriesByType(o.collectEntryType).find(function(e){return e.name===t}),R(t,i.hostUrl))||(n={url:ie(t),status:400,duration:Number(((null==n?void 0:n.duration)||0).toFixed(2)),method:"get",type:e||"static",isHttps:ae(t),urlQuery:E(t,!0),nextHopProtocol:"",domainLookup:0,connectTime:0},o.publish(n,r)));}var o=this,i=r.config;window.document.addEventListener("error",e,!0),r.lifeCycle.on("destroy",function(){0===Ne.countInstance()&&window.document.removeEventListener("error",e,!0);});},generateLog:function(e,t){var t="function"==typeof(null==(n=t.api)?void 0:n.resourceTypeHandler)?null==(n=t.api)?void 0:n.resourceTypeHandler(e.name):"",n=e.transferSize;return {url:ie(e.name),method:"get",duration:Number(e.duration.toFixed(2)),status:200,type:t||"static",isHttps:ae(e.name),nextHopProtocol:e.nextHopProtocol||"",urlQuery:E(e.name,!0),domainLookup:oe(e.domainLookupEnd-e.domainLookupStart),connectTime:oe(e.connectEnd-e.connectStart),transferSize:0<n?n:-1}},collectNotReportedLog:function(e){var t,n;ge()&&(t=(n=performance.getEntriesByType(this.collectEntryType)).length,"function"!=typeof window.PerformanceObserver)&&this.collectCur!==t&&(n=n.slice(this.collectCur),this.collectCur=t,this.publishMany(n,e,!0));},destroy:function(){this.option.publish=function(){};}}),He=window.navigator.userAgent.toLowerCase(),a={};function c(e){this.aegisPlugin=!0,this.name="",this.instances=[],this.inited=!1,e.$walk=this.walk.bind(this),e.$getConfig=this.getConfig.bind(this),this.option=e,this.name=e.name;}function S(e){var n,t,r,o,a,i,s,c,u,l,f,d,p,h,g=this;this.isGetSample=!1,this.isHidden=!1,this.config={version:0,delay:1e3,onError:!0,repeat:60,random:1,aid:!0,device:!0,pagePerformance:!0,webVitals:!0,speedSample:!0,onClose:!0,reportLoadPackageSpeed:!0,hostUrl:"https://aegis.qq.com",env:"production",url:"",offlineUrl:"",whiteListUrl:"",pvUrl:"",speedUrl:"",customTimeUrl:"",performanceUrl:"",performanceUrlForHippy:"",webVitalsUrl:"",eventUrl:"",setDataReportUrl:"",reportImmediately:!0},this.isWhiteList=!1,this.lifeCycle=new X,this.bean={},this.normalLogPipeline=m([ue(this,5),le,function(e,t){var r=n.config;t(e=e.map(function(e){var t,n=r.maxLength||102400;try{if(!e.msg||e.msg.length<=n)return e;e.msg=null==(t=e.msg)?void 0:t.substring(0,n);}catch(t){e.msg=y(e.msg).substring(0,r.maxLength);}return e}));},(h=(n=this).config,function(e,t){var n="number"==typeof h.repeat?h.repeat:60;if(n<=0)return t(e);var r=(null==h?void 0:h.id)+"_error",o=T[r]||{};t(e.filter(function(e){if(e.level===w.ERROR||e.level===w.PROMISE_ERROR||e.level===w.AJAX_ERROR||e.level===w.SCRIPT_ERROR||e.level===w.IMAGE_ERROR||e.level===w.CSS_ERROR||e.level===w.MEDIA_ERROR||e.level===w.RET_ERROR||e.level===w.BRIDGE_ERROR||e.level===w.PAGE_NOT_FOUND_ERROR||e.level===w.WEBSOCKET_ERROR||e.level===w.LAZY_LOAD_ERROR){e=e.msg.slice(0,200);if(o[e]>n)return O[r]||Pe(r),!1;o[e]=1+~~o[e],T[r]=o;}return !0}));}),(d=this.lifeCycle.emit,p=this.config,function(e,t){var n,r=p.logCreated;return "function"==typeof r?(n=e.filter(function(e){return !1!==r(e)}),d("beforeWrite",n),t(n)):(d("beforeWrite",e),t(e))}),(f=this,setTimeout(function(){var e=f.config,t=e.pvUrl,n=void 0===t?"":t,t=e.spa,e=-1<["web-sdk","mp-sdk"].indexOf("web-sdk");n&&(e&&!t||!e)&&f.sendPipeline([function(e,t){t({url:n,type:v.PV});}],v.PV)(null);},100),function(e,t){t(e);}),(u=c=s=!1,l=[],(a=this).lifeCycle.on("onConfigChange",function(){i&&clearTimeout(i),i=setTimeout(function(){var e,n;!u&&a.config&&(u=!0,e=a.config.whiteListUrl,(n=void 0===e?"":e)&&a.sendPipeline([function(e,t){t({url:n,type:v.WHITE_LIST,success:function(e){c=!0;try{var t=e.data||JSON.parse(e),n=t.retcode,r=t.result,o=void 0===r?{}:r,i=(0===n&&(s=o.is_in_white_list,a.isWhiteList=s,0<=o.rate)&&o.rate<=1&&(a.config.random=o.rate,a.isGetSample=!1),a.isWhiteList&&l.length?ke(a)(l.splice(0),function(){}):!a.isWhiteList&&l.length&&(l.length=0),a.config.onWhitelist);"function"==typeof i&&i(s);}catch(e){}},fail:function(){c=!0;}});}],v.WHITE_LIST)(null),u=!1);},a.config.uin?50:500);}),a.lifeCycle.on("destroy",function(){l.length=0;}),function(e,t){var n;s||null!=(n=null==(n=a.config)?void 0:n.api)&&n.reportRequest?t(e.concat(l.splice(0)).map(function(e){return xe(e),e})):(n=e.filter(function(e){return e.level!==w.INFO&&e.level!==w.API_RESPONSE?(xe(e),!0):(c||(l.push(e),200<=l.length&&(l.length=200)),!1)})).length&&t(n);}),function(e,t){try{var n=JSON.parse(JSON.stringify(e)),r=(g.lifeCycle.emit("beforeReport",n),g.config.beforeReport);(e="function"==typeof r?e.filter(function(e){return !1!==r(e)}):e).length&&t(e);}catch(e){}},ke(this)]),this.eventPipeline=m([ue(this,10),(o=this,function(e){o.sendPipeline([function(e,t){var n=e.map(function(e){return {name:e.name,ext1:e.ext1||o.config.ext1||"",ext2:e.ext2||o.config.ext2||"",ext3:e.ext3||o.config.ext3||""}});t({url:o.config.eventUrl+"?payload="+encodeURIComponent(JSON.stringify(n)),type:v.EVENT,log:e});}],v.EVENT)(e);})]),this.customTimePipeline=m([ue(this,10),(r=this,function(e){return r.sendPipeline([function(e,t){t({url:r.config.customTimeUrl+"?payload="+encodeURIComponent(JSON.stringify({custom:e})),type:v.CUSTOM,log:e});}],v.CUSTOM)(e)})]),this.timeMap={},this.failRequestCount=0,this.config=(t=this.config,void 0===(e=e.hostUrl)&&(e="https://aegis.qq.com"),t.url=t.url||e+"/collect",t.offlineUrl=t.offlineUrl||e+"/offline",t.whiteListUrl=t.whiteListUrl||e+"/collect/whitelist",t.pvUrl=t.pvUrl||e+"/collect/pv",t.eventUrl=t.eventUrl||e+"/collect/events",t.speedUrl=t.speedUrl||e+"/speed",t.customTimeUrl=t.customTimeUrl||e+"/speed/custom",t.performanceUrl=t.performanceUrl||e+"/speed/performance",t.performanceUrlForHippy=t.performanceUrlForHippy||e+"/speed/hippyPerformance",t.webVitalsUrl=t.webVitalsUrl||e+"/speed/webvitals",t.setDataReportUrl=t.SetDataReportUrl||e+"/speed/miniProgramData",t),S.instances.push(this);}a.macos=function(){return r("mac")},a.ios=function(){return a.iphone()||a.ipod()||a.ipad()},a.iphone=function(){return !a.windows()&&r("iphone")},a.ipod=function(){return r("ipod")},a.ipad=function(){var e="MacIntel"===navigator.platform&&1<navigator.maxTouchPoints;return r("ipad")||e},a.android=function(){return !a.windows()&&r("android")},a.androidPhone=function(){return a.android()&&r("mobile")},a.androidTablet=function(){return a.android()&&!r("mobile")},a.blackberry=function(){return r("blackberry")||r("bb10")},a.blackberryPhone=function(){return a.blackberry()&&!r("tablet")},a.blackberryTablet=function(){return a.blackberry()&&r("tablet")},a.windows=function(){return r("windows")},a.windowsPhone=function(){return a.windows()&&r("phone")},a.windowsTablet=function(){return a.windows()&&r("touch")&&!a.windowsPhone()},a.fxos=function(){return (r("(mobile")||r("(tablet"))&&r(" rv:")},a.fxosPhone=function(){return a.fxos()&&r("mobile")},a.fxosTablet=function(){return a.fxos()&&r("tablet")},a.meego=function(){return r("meego")},a.cordova=function(){return window.cordova&&"file:"===location.protocol},a.nodeWebkit=function(){return "object"==typeof window.process},a.mobile=function(){return a.androidPhone()||a.iphone()||a.ipod()||a.windowsPhone()||a.blackberryPhone()||a.fxosPhone()||a.meego()},a.tablet=function(){return a.ipad()||a.androidTablet()||a.blackberryTablet()||a.windowsTablet()||a.fxosTablet()},a.desktop=function(){return !a.tablet()&&!a.mobile()};function qe(){return {host:new URL(location.href).host,pathname:location.pathname}}function je(r,e,o){return null!=e&&e.length&&"object"==typeof r?e.reduce(function(e,t){var n=window.Headers&&r instanceof Headers?r.get(t):r[t];return n?e+(""===e?"":"\n\n")+o+" header "+t+": "+n:e},""):""}function _e(e,t){return e&&-1===["null","undefined"].indexOf(e)?t+": "+e:""}function De(e,t,n){void 0===t&&(t="");var r,o,e="function"==typeof(null==(o=e.api)?void 0:o.resourceTypeHandler)?null==(o=e.api)?void 0:o.resourceTypeHandler(n):"";return -1===G.indexOf(e)&&(r=void 0===t?"":t,o=(void 0===n?"":n).split("?")[0],e=ve.test(o)||me.some(function(e){return -1!==String(r).indexOf(e)})?"static":"fetch"),e}function Me(e,t){return e?w.AJAX_ERROR:t?w.RET_ERROR:w.API_RESPONSE}function Be(e,t){if(null!=(e=e.api)&&e.usePerformanceTiming&&"string"==typeof t.url){e=null==(e=performance.getEntriesByName(t.url))?void 0:e.pop();if(e)return {url:t.url,isHttps:ae(t.url),method:t.method,type:t.type,status:t.status,duration:Number(e.duration.toFixed(2)),nextHopProtocol:e.nextHopProtocol||"",domainLookup:oe(e.domainLookupEnd-e.domainLookupStart),connectTime:oe(e.connectEnd-e.connectStart)}}return {url:t.url,isHttps:ae(t.url),method:t.method,type:t.type,status:t.status,duration:Number(t.duration.toFixed(2)),nextHopProtocol:"",domainLookup:n.number,connectTime:n.number}}var Fe,We,Ge,Xe,d,Ve,$e,Je=!(a.isIE=function(){return "ActiveXObject"in window}),p=[],Ke=/^\/[^/]/,ze=!1,h=[],Qe=(new i({name:"reportApiSpeed"}),new i({name:"reportApiSpeed",override:!1,onNewAegis:function(e){var t,n;this.override||(this.override=!0,null!=(n=e.config.api)&&n.injectTraceHeader&&(this.traceRequestHeader=new te(n.injectTraceHeader,null!=(t=null==n?void 0:n.injectTraceIgnoreUrls)?t:[],null==n?void 0:n.injectTraceUrls)),this.overrideFetch(e.config,e),this.overrideXhr(e.config,e));},overrideFetch:function(m,v){var y=this,e=m.api,e={name:this.name,traceRequestHeader:null!=e&&e.injectTraceHeader?this.traceRequestHeader:null,then:function(f,d,p,h){var e,g;R(p,m.hostUrl)||(e=f.headers?f.headers.get("content-type"):"","fetch"===(g=De(m,e||"",p))?f.clone().text().then(function(n){var e,r=f.status<=0||400<=f.status,t=(null==(t=m.api)?void 0:t.reqHeaders)||[],o=je(null==h?void 0:h.headers,t,"req"),t=(null==(t=m.api)?void 0:t.resHeaders)||[],i=je(f.headers,t,"res"),a=Z(null==h?void 0:h.headers),t=se(n,m.api,{url:p,ctx:f,payload:null==h?void 0:h.body}),s=t.code,c=t.isErr,t=null==(t=m.api)?void 0:t.apiDetail,u=t?ce(null==h?void 0:h.body,null==(e=m.api)?void 0:e.reqParamHandler,{url:p}):"",l=t?ce(n,null==(e=m.api)?void 0:e.resBodyHandler,{url:p,ctx:f}):"";setTimeout(function(){var e=Be(m,{url:p,duration:d,type:g,status:f.status||0,method:(null==h?void 0:h.method)||"get"}),t=[r?"FETCH_ERROR: "+n:"","fetch req url: "+p,"res status: "+(e.status||0),"res duration: "+e.duration+"ms",o,i,"req method: "+(e.method||"GET"),"res retcode: "+s,_e(u,"req param"),_e(l,"res data")].filter(function(e){return e}).join("\n\n");e.payload=null==h?void 0:h.body,e.ret=s,e.isErr=+c,y.publishNormalLog({msg:t,level:Me(r,c),code:s,trace:a},v),y.publishSpeed(e,v);},0);}):setTimeout(function(){var e=Be(m,{url:p,duration:d,type:g,status:f.status||0,method:(null==h?void 0:h.method)||"get"});e.type="static",e.urlQuery=E(p,!0),y.publishSpeed(e,v);},0));},catch:function(t,n,r,o){var i,e,a,s,c;throw R(r,m.hostUrl)||(i=De(m,"",r),e=(null==(e=m.api)?void 0:e.reqHeaders)||[],a=je(null==o?void 0:o.headers,e,"req"),s=Z(null==o?void 0:o.headers),c=null!=(e=m.api)&&e.apiDetail?ce(null==o?void 0:o.body,null==(e=m.api)?void 0:e.reqParamHandler,{url:r}):"",setTimeout(function(){var e=Be(m,{url:r,duration:n,type:i,status:0,method:(null==o?void 0:o.method)||"get"}),e=(y.publishSpeed(e,v),"AJAX_ERROR: "+t+"\n                          \nreq url: "+r+"\n                          \nres status: 0\n                          \nres duration: "+e.duration+"ms\n                          \nreq method: "+((null==o?void 0:o.method)||"get")+"\n                          \nreq param: "+c+"\n                          \n"+a);y.publishNormalLog({msg:e,level:w.AJAX_ERROR,code:-400,trace:s},v);},0)),t}},l=(this.hackFetchOptions=e,this.hackFetchOptions),f=null==(e=m.api)?void 0:e.ignoreHackReg;if(void 0===f&&(f=/\.flv(\?|$)/gi),h.find(function(e){return e.name===l.name}))throw new Error("name '"+l.name+"' is already in hackFetch option list");h.push(l),!ze&&window.fetch&&(ze=!0,Xe=window.fetch,window.fetch=function(e,o){void 0===o&&(o={});var i="string"==typeof e?e:null==e?void 0:e.url;if(null!=(a=null==f?void 0:f.test)&&a.call(f,i))return Xe(i,o);Ke.test(i)&&(i=""+location.origin+i);var t,n,r,a=(l||{}).traceRequestHeader;a&&(t=void 0===(t=(o||{}).headers)?{}:t,n=(r=qe()).host,r=r.pathname,n=(a=a.generate(i,t,{host:n,pathname:r})||{}).name,r=a.value)&&n&&(o.headers=Object.assign(t,((a={})[n]=r,a)));for(var s=0;s<h.length;s++){var c=h[s];try{"function"==typeof c.beforeFetch&&c.beforeFetch(i,o);}catch(e){}}var u=Date.now();return Xe(e,o).then(function(e){for(var t=e.clone(),n=0;n<h.length;n++){var r=h[n];try{"function"==typeof r.then&&r.then(t,Date.now()-u,i,o);}catch(e){}}return t}).catch(function(e){for(var t=0;t<h.length;t++){var n=h[t];try{"function"==typeof n.catch&&n.catch(e,Date.now()-u,i,o);}catch(e){}}throw e})});},overrideXhr:function(v,y){var o,w=this,e={name:this.name,ignoreHackReg:null==(e=v.api)?void 0:e.ignoreHackReg,send:function(d,p){var e,t,r=Date.now(),h=(((null==v?void 0:v.api)||{}).injectTraceHeader&&(t=(e=qe()).host,e=e.pathname,e=(t=w.traceRequestHeader.generate(d.aegisUrl,{},{host:t,pathname:e})||{}).name,t=t.value,e)&&t&&d.setRequestHeader(e,t),d.addEventListener("loadend",function(){var u,n,e,l,f=d.aegisUrl||"";R(f,v.hostUrl)||"abort"===d.failType||(u="",(d.failType||!d.status||400<=d.status)&&(u=d.failType||"failed"),n=Date.now()-r,e=d.getResponseHeader("content-type")||"",l=De(v,e,f),setTimeout(function(){var r=Be(v,{url:f,duration:n,type:l,status:d.status,method:d.aegisMethod||"get"});if("fetch"===l){var e=(null==(e=v.api)?void 0:e.reqHeaders)||[],o=je(d.aegisXhrReqHeader,e,"req"),e=(null==(e=v.api)?void 0:e.resHeaders)||[],t=d.getAllResponseHeaders().split("\r\n").reduce(function(e,t){t=t.split(": ");return t[0]&&t[1]&&(e[t[0]]=t[1]),e},{}),i=je(t,e,"res"),a=Z(d.aegisXhrReqHeader),e=null==(t=v.api)?void 0:t.apiDetail,s=e?ce(p,null==(t=v.api)?void 0:t.reqParamHandler,{url:f}):"",c=e?ce(d.response,null==(t=v.api)?void 0:t.resBodyHandler,{url:f}):"";try{!function(e,t,n,r){var o,i,a,s;try{if("function"==typeof(null==t?void 0:t.retCodeHandlerAsync))return t.retCodeHandlerAsync(e,null==n?void 0:n.url,null==n?void 0:n.ctx,function(e){var t=e.code,e=e.isErr;null!=r&&r({code:void 0===t?b:t,isErr:e});});if("function"==typeof(null==t?void 0:t.retCodeHandler))return a=(i=t.retCodeHandler(e,null==n?void 0:n.url,null==n?void 0:n.ctx,null==n?void 0:n.payload)||{}).code,s=i.isErr,null!=r&&r({code:void 0===a?b:a,isErr:s});if(!(e="string"==typeof e?JSON.parse(e):e))return null!=r&&r({code:b,isErr:!1});"function"==typeof(null==(o=null==t?void 0:t.ret)?void 0:o.join)&&(ye=[].concat(t.ret.map(function(e){return e.toLowerCase()})));var c=Object.getOwnPropertyNames(e).filter(function(e){return -1!==ye.indexOf(e.toLowerCase())});if(c.length)return "未知"!==(a=e[c[0]])&&""!==a||(a=b),null!=r&&r({code:""+a,isErr:0!==a&&"0"!==a&&a!==b});null!=r&&r({code:b,isErr:!1});}catch(e){null!=r&&r({code:b,isErr:!1});}}(d.response,v.api,{url:f,ctx:d,payload:p},function(e){var t=e.code,e=e.isErr,n=[u?"AJAX_ERROR: request "+u:"","fetch req url: "+f,"res status: "+(r.status||0),"res duration: "+r.duration+"ms",o,i,"req method: "+(r.method||"GET"),"res retcode: "+t,_e(s,"req param"),_e(c,"res data")].filter(function(e){return e}).join("\n\n");r.ret=t,r.isErr=+e,r.payload=p,w.publishNormalLog({msg:n,level:Me(!!u,e),code:t,trace:a},y),w.publishSpeed(r,y);});}catch(e){r.ret=b,w.publishSpeed(r,y);}}else r.type="static",r.urlQuery=E(f,!0),w.publishSpeed(r,y);d.removeEventListener("abort",h),d.removeEventListener("error",g),d.removeEventListener("timeout",m);},0));}),function(){d.failType="abort";}),g=function(){d.failType="error";},m=function(){d.failType="timeout";};d.addEventListener("abort",h),d.addEventListener("error",g),d.addEventListener("timeout",m);}};this.hackXHROptions=e,o=this.hackXHROptions,p.find(function(e){return e.name===o.name})||(p.push(o),!Je&&window.XMLHttpRequest&&(Fe=window.XMLHttpRequest.prototype.send,We=window.XMLHttpRequest.prototype.open,Ge=window.XMLHttpRequest.prototype.setRequestHeader,Je=!0,window.XMLHttpRequest.prototype.open=function(){this.aegisMethod=arguments[0];var e,t=arguments[1];if(Ke.test(t)&&(t=""+location.origin+t),this.aegisUrl=t,null==(t=null==(e=o.ignoreHackReg)?void 0:e.test)||!t.call(e,this.aegisUrl))if(this.aegisXhrStartTime=Date.now(),this.sendByAegis)a.isIE()||(this.timeout=5e3);else for(var n=0;n<p.length;n++){var r=p[n];try{"function"==typeof r.open&&r.open(this);}catch(e){}}return We.apply(this,arguments)},window.XMLHttpRequest.prototype.setRequestHeader=function(){var e,t,n;return null!=(t=null==(n=o.ignoreHackReg)?void 0:n.test)&&t.call(n,this.aegisUrl)?Ge.apply(this,arguments):(t=arguments[0],n=arguments[1],this.aegisXhrReqHeader=null!=(e=this.aegisXhrReqHeader)?e:{},-1<["traceparent","b3","sw8","sentry-trace"].indexOf(t)&&(this.aegisXhrReqHeader[t]||(arguments[1]=n),this.aegisXhrReqHeader[t])?void 0:(this.aegisXhrReqHeader[t]=arguments[1],Ge.apply(this,arguments)))},window.XMLHttpRequest.prototype.send=function(){var e,t;if(!(null!=(t=null==(e=o.ignoreHackReg)?void 0:e.test)&&t.call(e,this.aegisUrl)||this.sendByAegis))for(var n=0;n<p.length;n++){var r=p[n];try{"function"==typeof r.send&&r.send(this,arguments[0]);}catch(e){}}return Fe.apply(this,arguments)}));},publishSpeed:function(n){var r=this;this.$walk(function(e){var t=r.$getConfig(e);"fetch"!==n.type||"function"!=typeof(null==t?void 0:t.urlHandler)?(n.url=E(n.url),e.speedLogPipeline(n)):e.speedLogPipeline(l(l({},n),{url:E(t.urlHandler(n.url,n.payload))}));});},publishNormalLog:function(t){this.$walk(function(e){e.normalLogPipeline(t);});},destroy:function(){var t,n,e;this.option.publishSpeed=function(){},this.option.publishNormalLog=function(){},this.option.hackXHROptions&&(t=this.option.hackXHROptions,-1!==(e=p.findIndex(function(e){return e.name===t.name})))&&p.splice(e,1),this.option.hackFetchOptions&&(n=this.option.hackFetchOptions,-1!==(e=h.findIndex(function(e){return e.name===n.name})))&&h.splice(e,1),this.option.override=!1;}})),Ye={},Ze=new i({name:"reportBridgeSpeed",override:!1,onNewAegis:function(e){this.override||(this.override=!0,this.overrideBridge(e));},publishSpeed:function(t,n){this.$walk(function(e){e===n&&e.speedLogPipeline(t);});},overrideBridge:function(c){var u=this,l=c.config;l.reportBridgeSpeed&&l.h5Bridge&&l.h5BridgeFunc.length&&l.h5BridgeFunc.forEach(function(e){var s=l.h5Bridge[e];Ye[e]=s,l.h5Bridge[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=e[0],o=e[1],n=e[2],i=e[3],a=Date.now();s(r,o,n,function(e){var t=se(e,l.api),n=t.code,t=t.isErr,n={url:r+"-"+o,name:r+"-"+o,duration:Date.now()-a,type:"bridge",ret:n,isErr:+t};u.publishSpeed(n,c),i(e);});};});},unHackBridge:function(t){Object.keys(Ye).forEach(function(e){Ye[e]&&(t.config.h5Bridge[e]=Ye[e]);}),Ye={};},destroy:function(e){this.option.publishSpeed=function(){},this.option.unHackBridge(e),this.option.override=!1;}});(k=d=d||{})[k.unknown=100]="unknown",k[k.wifi=1]="wifi",k[k.net2g=2]="net2g",k[k.net3g=3]="net3g",k[k.net4g=4]="net4g",k[k.net5g=5]="net5g",k[k.net6g=6]="net6g",(k=Ve=Ve||{})[k.android=1]="android",k[k.ios=2]="ios",k[k.windows=3]="windows",k[k.macos=4]="macos",k[k.linux=5]="linux",k[k.other=100]="other",(k=$e=$e||{})[k.unknown=100]="unknown",k[k.normal=0]="normal",k[k.weak=1]="weak",k[k.disconnected=2]="disconnected";function g(e,t,n,r){return void 0===n&&(n=15e3),void 0===r&&(r=0),(t=void 0===t?0:t)<=e&&e<=n?e:r}var x,P,et,tt,nt,L,rt,ot,it,k=new i({name:"device",onNewAegis:function(e){e.extendBean("platform",this.getPlatform()),e.extendBean("netType",d.unknown),this.getDpi(e),this.refreshNetworkTypeToBean(e),this.refreshNetworkStatusToBean(e);},getDpi:function(e){e.extendBean("vp",Math.round(window.innerWidth)+" * "+Math.round(window.innerHeight)),window.screen&&e.extendBean("sr",Math.round(window.screen.width)+" * "+Math.round(window.screen.height));},getPlatform:function(){var t={android:/\bAndroid\s*([^;]+)/,ios:/\b(iPad|iPhone|iPod)\b.*? OS ([\d_]+)/,windows:/\b(Windows NT)/,macos:/\b(Mac OS)/,linux:/\b(Linux)/i},e=Object.keys(t).find(function(e){return t[e].test(navigator.userAgent)});return e?Ve[e]:Ve.other},refreshNetworkTypeToBean:function(t){var n=this,e=t.config;e&&("function"==typeof e.getNetworkType?e.getNetworkType:at)(function(e){d[e]||(e=d.unknown),t.extendBean("netType",e),n.NetworkRefreshTimer=setTimeout(function(){n.refreshNetworkTypeToBean(t),clearTimeout(n.NetworkRefreshTimer);},1e4);});},refreshNetworkStatusToBean:function(t){var e,n=this,r=t.config;r&&null!=(e="function"==typeof r.getNetworkStatus?r.getNetworkStatus:e)&&e(function(e){void 0===$e[e]&&(e=$e.unknown),t.extendBean("netStatus",e),n.NetworkStatusRefreshTimer=setTimeout(function(){n.refreshNetworkStatusToBean(t),clearTimeout(n.NetworkStatusRefreshTimer);},1e4);});}}),at=function(e){var t="",n=navigator.userAgent.match(/NetType\/(\w+)/);n?t=n[1]:navigator.connection&&(t=navigator.connection.effectiveType||navigator.connection.type),e((n=t=t||b,0<=(n=String(n).toLowerCase()).indexOf("4g")?d.net4g:0<=n.indexOf("wifi")?d.wifi:0<=n.indexOf("5g")?d.net5g:0<=n.indexOf("6g")?d.net6g:0<=n.indexOf("3g")?d.net3g:0<=n.indexOf("2g")?d.net2g:d.unknown));},st=window.WebSocket,C=[],ct={construct:function(e,t){var a=new e(t[0],t[1]);return a.originSend=a.send,a.addEventListener("error",function(e){var e=(null==e?void 0:e.currentTarget)||{},t=e.url,n=e.readyState;null!=C&&C.forEach(function(e){e=e.onErr;null!=e&&e({msg:"无法获知具体错误信息，需在浏览器控制台查看！",readyState:n,connectUrl:t});});}),Object.defineProperty(a,"send",{get:function(){return function(e){null!=(t=a.originSend)&&t.call(a,e);var t=a.readyState,e=WebSocket.OPEN,n=WebSocket.CLOSED,r=WebSocket.CONNECTING,o=WebSocket.CLOSING;if(t!==e){var i={readyState:t,connectUrl:a.url};switch(t){case n:C.forEach(function(e){e=e.sendErr;null!=e&&e(l({msg:"消息发送失败，连接已关闭！"},i));});break;case r:C.forEach(function(e){(0, e.sendErr)(l({msg:"消息发送失败，正在连接中！"},i));});break;case o:C.forEach(function(e){(0, e.sendErr)(l({msg:"消息发送失败，连接正在关闭！"},i));});}}}}}),a}},ut=new i({name:"onError"}),lt=ut=new i({name:"onError",onNewAegis:function(e){this.startListen(e);},startListen:function(o){function e(e){var t,n=e&&y(e.reason);n&&s.publishErrorLog({msg:"PROMISE_ERROR: "+n,errorMsg:null==(t=null==(e=(null==(t=e.reason)?void 0:t.message)||(null==(t=e.reason)?void 0:t.errMsg)||n)?void 0:e.slice)?void 0:t.call(e,0,150),level:w.PROMISE_ERROR},o);}function t(e){var t;if(e=(null==e?void 0:e.target)||(null==e?void 0:e.srcElement)){var n=e.src||e.href||"",e=e.tagName,e=void 0===e?"script":e;if(!(R(t=n,o.config.hostUrl)||-1<window.location.href.indexOf(t))){var r={msg:e+" load fail: "+n,level:w.INFO};if(/\.js$/.test(n))r.level=w.SCRIPT_ERROR;else if(/\.css$/.test(n))r.level=w.CSS_ERROR;else switch(e.toLowerCase()){case"script":r.level=w.SCRIPT_ERROR;break;case"link":r.level=w.CSS_ERROR;break;case"img":r.level=w.IMAGE_ERROR;break;case"audio":case"video":r.level=w.MEDIA_ERROR;break;default:return}s.publishErrorLog(r,o);}}}var n,r,i,a,s=this,c=window.onerror;window.onerror=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n,r=y(e[0]);"string"!=typeof(n=r)||!n||F.some(function(e){return -1<n.indexOf(e)})||B.some(function(e){return -1<n.indexOf(e)})||s.publishErrorLog({msg:(r||"")+" @ ("+(y(e[1])||"")+":"+(e[2]||0)+":"+(e[3]||0)+")\n          \n"+y(e[4]||""),level:w.ERROR},o),null!=c&&c.call.apply(c,u([window],e));},window.addEventListener("unhandledrejection",e);window.document.addEventListener("error",t,!0),o.lifeCycle.on("destroy",function(){0===ut.countInstance()&&(window.document.removeEventListener("unhandledrejection",e),window.document.removeEventListener("error",t,!0));}),o.config.websocketHack&&(n={key:o.config.id+"-"+this.name,onErr:function(e){var t;null!=(t=s.publishWsErrorLog)&&t.call(s,e,o);},sendErr:function(e){var t;null!=(t=s.publishWsErrorLog)&&t.call(s,e,o);}},this.hackWebsocketConfig=n,n=this.hackWebsocketConfig,window.Proxy)&&window.WebSocket&&(r=window.WebSocket,window&&!r.isHack&&(i=new Proxy(WebSocket,ct),r.isHack=!0,window.WebSocket=i),a=n,C.find(function(e){return e.key===a.key})||a&&C.push(a));},publishErrorLog:function(t,n){this.$walk(function(e){e===n&&e.normalLogPipeline(t);});},publishWsErrorLog:function(e,t){var n=e.connectUrl,r=e.msg,e=e.readyState;this.publishErrorLog({msg:"WEBSOCKET_ERROR: \n              connect: "+n+"\n              readyState: "+e+"\n              msg: "+r,level:w.WEBSOCKET_ERROR},t);},destroy:function(){var t,e;this.option.publishErrorLog=function(){},this.option.hackWebsocketConfig&&(t=this.option.hackWebsocketConfig,window.WebSocket=st,-1!==(e=C.findIndex(function(e){return e.key===t.key})))&&C.splice(e,1);}}),ft=(new i({name:"pagePerformance"}),3),dt=new i({name:"pagePerformance",performanceMap:{},onNewAegis:function(e){ge()&&(x?this.publish(x,e):this.startCalcPerformance(e));},publish:function(e,t){var s=this;this.$walk(function(a){a===t&&a.sendPipeline([function(e,t){var n,r=[];for(n in e)r.push(n+"="+e[n]);var o,i=s.$getConfig(a);if(i)return o=-1===(null==(o=a.config.performanceUrl)?void 0:o.indexOf("?"))?"?":"&","function"==typeof i.urlHandler?t({url:a.config.performanceUrl+o+r.join("&")+"&from="+(encodeURIComponent(i.urlHandler())||window.location.href),beanFilter:["from"],type:v.PERFORMANCE,log:e}):t({url:a.config.performanceUrl+o+r.join("&"),type:v.PERFORMANCE,log:e})}],v.PERFORMANCE)(l({},e));});},startCalcPerformance:function(n){var r=this;try{this.getFirstScreenTiming(n,function(e){var t=performance.timing;t&&(x={dnsLookup:g(t.domainLookupEnd-t.domainLookupStart),tcp:g(t.connectEnd-t.connectStart),ssl:g(0===t.secureConnectionStart?0:t.requestStart-t.secureConnectionStart),ttfb:g(t.responseStart-t.requestStart),contentDownload:g(t.responseEnd-t.responseStart),domParse:g(t.domInteractive-t.domLoading,0,15e3,1070),resourceDownload:g(t.loadEventStart-t.domInteractive,0,15e3,1070),firstScreenTiming:g(Math.floor(e),0,15e3,15e3)},(t=n.config).extraPerformanceData&&"{}"!==JSON.stringify(t.extraPerformanceData)&&(t=(e=t.extraPerformanceData).engineInit,e=e.bundleLoad,x=l(l({},x),{engineInit:g(t,0,1e4),bundleLoad:g(e,0,1e4)})),r.publish(x,n));});}catch(n){}},getFirstScreenTiming:function(s,c){var u=this;s.lifeCycle.on("destroy",function(){m&&clearTimeout(m);});var l,f=this,n=["script","style","link","br"],d=[],p={},h=(-1<(null==(e=null==(e=window.PerformanceObserver)?void 0:e.supportedEntryTypes)?void 0:e.indexOf("paint"))&&(l=new PerformanceObserver(function(e){e.getEntries().forEach(function(e){var t;"paint"===e.entryType&&"first-contentful-paint"===e.name&&0<(t=document.querySelectorAll("[AEGIS-FIRST-SCREEN-TIMING]")).length&&(u.setFirstScreenInfo(s,e.startTime,t[0],t),null!=c&&c(e.startTime),h.disconnect(),l.disconnect());});})).observe({entryTypes:["paint"]}),new MutationObserver(function(e){var t={roots:[],ignores:[],rootsDomNum:[],time:performance.now()};e.forEach(function(e){e&&e.addedNodes&&Array.prototype.slice.call(e.addedNodes).forEach(function(e){f.isEleInArray(e,t.ignores)?t.ignores.push(e):1===e.nodeType&&e.hasAttribute("AEGIS-FIRST-SCREEN-TIMING")?(Object.prototype.hasOwnProperty.apply(p,[t.time])||(p[t.time]=[]),p[t.time].push(e)):1===e.nodeType&&(f.hasAncestorOrSelfWithAttribute(e,"AEGIS-IGNORE-FIRST-SCREEN-TIMING")?t.ignores.push(e):-1!==n.indexOf(e.nodeName.toLocaleLowerCase())||f.isEleInArray(e,t.roots)||(t.roots.push(e),t.rootsDomNum.push(f.walkAndCount(e)||0)));});}),t.roots.length&&d.push(t);}));h.observe(document,{childList:!0,subtree:!0});var e,g=function(n){(n=void 0===n?0:n)||(r=0,(e=Object.keys(p)).length?(n=Math.max.apply(null,e),u.setFirstScreenInfo(s,n,null==(e=p[n])?void 0:e[0],p)):d.forEach(function(e){for(var t=0;t<e.roots.length;t++)e.rootsDomNum[t]>r&&f.isInFirstScreen(e.roots[t])&&(r=e.rootsDomNum[t],n=e.time,u.setFirstScreenInfo(s,n,e.roots[t]));}),d.length=0,Object.keys(p).forEach(function(e){p[e]=p[e].map(function(e){var t={tagName:e.tagName},n=e.attributes;if(!n)return e;for(var r=0;r<n.length;r++){var o=n[r];o.name&&(t[o.name]=e.getAttribute(o.name));}return t});}));var r,e=performance.timing,t=e.domInteractive-e.domLoading,e=e.loadEventStart-e.domInteractive,o=n;m=null;for(var i=0,a=[t,e,o];i<a.length;i++)if(a[i]<=0&&0<ft){m=setTimeout(function(){return g(o)},3e3);break}m?--ft:(h.disconnect(),null!=l&&l.disconnect(),null!=c&&c(n));},m=setTimeout(function(){return g()},3e3);},setFirstScreenInfo:function(e,t,n,r){var o;e.config.id&&this.performanceMap[e.config.id]||(e.config.id&&(this.performanceMap[e.config.id]=!0),("object"!=typeof(null==(o=e.config)?void 0:o.pagePerformance)||null!=(o=e.config.pagePerformance)&&o.firstScreenInfo)&&(e.firstScreenInfo={element:n,timing:t,markDoms:r}));},isEleInArray:function(e,t){return !(!e||e===document.documentElement)&&(-1!==t.indexOf(e)||this.isEleInArray(e.parentElement,t))},isInFirstScreen:function(e){var t,n;return !(!e||"function"!=typeof e.getBoundingClientRect)&&(e=e.getBoundingClientRect(),t=window.innerHeight,n=window.innerWidth,0<=e.left)&&e.left<n&&0<=e.top&&e.top<t&&0<e.width&&0<e.height},walkAndCount:function(e){var t=0;if(e&&1===e.nodeType){t+=1;var n=e.children;if(null!=n&&n.length)for(var r=0;r<n.length;r++)1===n[r].nodeType&&n[r].hasAttribute("AEGIS-IGNORE-FIRST-SCREEN-TIMING")||(t+=this.walkAndCount(n[r]));}return t},hasAncestorOrSelfWithAttribute:function(e,t){for(var n=e;n&&n!==document.body;){if(n.hasAttribute(t))return !0;n=n.parentElement;}return !1}});function pt(){nt=[],et=-1,P=null,mt(addEventListener);}function ht(e,t){P||(P=t,et=e,tt=new Date,mt(removeEventListener),gt());}function gt(){var t;0<=et&&et<tt-rt&&(t={entryType:"first-input",name:P.type,target:P.target,cancelable:P.cancelable,startTime:P.timeStamp,processingStart:P.timeStamp+et},nt.forEach(function(e){e(t);}),nt=[]);}function mt(t){["mousedown","keydown","touchstart","pointerdown"].forEach(function(e){return t(e,ot,L)});}L={passive:!0,capture:!0},rt=new Date,ot=function(e){var t,n,r,o;function i(){ht(n,r),o();}function a(){o();}e.cancelable&&(t=(1e12<e.timeStamp?new Date:performance.now())-e.timeStamp,"pointerdown"==e.type?(n=t,r=e,o=function(){removeEventListener("pointerup",i,L),removeEventListener("pointercancel",a,L);},addEventListener("pointerup",i,L),addEventListener("pointercancel",a,L)):ht(t,e));},it="hidden"===document.visibilityState?0:1/0,addEventListener("visibilitychange",function e(t){"hidden"===document.visibilityState&&(it=t.timeStamp,removeEventListener("visibilitychange",e,!0));},!0),pt(),self.webVitals={firstInputPolyfill:function(e){nt.push(e),gt();},resetFirstInputPolyfill:pt,get firstHiddenTime(){return it}};function A(e,t){var n=qt(),r="navigate";return 0<=Ut?r="back-forward-cache":n&&(document.prerendering||0<jt()?r="prerender":document.wasDiscarded?r="restore":n.type&&(r=n.type.replace(/_/g,"-"))),{name:e,value:void 0===t?-1:t,rating:"good",delta:0,entries:[],id:"v3-".concat(Date.now(),"-").concat(Math.floor(8999999999999*Math.random())+1e12),navigationType:r}}function vt(e,t,n){try{var r;if(PerformanceObserver.supportedEntryTypes.includes(e))return (r=new PerformanceObserver(function(e){Promise.resolve().then(function(){t(e.getEntries());});})).observe(Object.assign({type:e,buffered:!0},n||{})),r}catch(e){}}function I(t,n,r,o){var i,a;return function(e){0<=n.value&&(e||o)&&((a=n.value-(i||0))||void 0===i)&&(i=n.value,n.delta=a,n.rating=(e=n.value)>r[1]?"poor":e>r[0]?"needs-improvement":"good",t(n));}}function yt(e){requestAnimationFrame(function(){return requestAnimationFrame(function(){return e()})});}function wt(t){function e(e){"pagehide"!==e.type&&"hidden"!==document.visibilityState||t(e);}addEventListener("visibilitychange",e,!0),addEventListener("pagehide",e,!0);}function bt(t){var n=!1;return function(e){n||(t(e),n=!0);}}function Et(){return U<0&&(U=_t(),Mt(),Ht(function(){setTimeout(function(){U=_t(),Mt();},0);})),{get firstHiddenTime(){return U}}}function Rt(e){document.prerendering?addEventListener("prerenderingchange",function(){return e()},!0):e();}function Ot(i,a){a=a||{},Rt(function(){var t,n=Et(),r=A("FCP"),o=vt("paint",function(e){e.forEach(function(e){"first-contentful-paint"===e.name&&(o.disconnect(),e.startTime<n.firstHiddenTime)&&(r.value=Math.max(e.startTime-jt(),0),r.entries.push(e),t(!0));});});o&&(t=I(i,r,Bt,a.reportAllChanges),Ht(function(e){r=A("FCP"),t=I(i,r,Bt,a.reportAllChanges),yt(function(){r.value=performance.now()-e.timeStamp,t(!0);});}));});}function Tt(){var t;0<=kt&&kt<Ct-Gt&&(t={entryType:"first-input",name:N.type,target:N.target,cancelable:N.cancelable,startTime:N.timeStamp,processingStart:N.timeStamp+kt},At.forEach(function(e){e(t);}),At=[]);}function St(e){var t,n,r,o;function i(){Xt(n,r),o();}function a(){o();}e.cancelable&&(t=(1e12<e.timeStamp?new Date:performance.now())-e.timeStamp,"pointerdown"==e.type?(n=t,r=e,o=function(){removeEventListener("pointerup",i,Wt),removeEventListener("pointercancel",a,Wt);},addEventListener("pointerup",i,Wt),addEventListener("pointercancel",a,Wt)):Xt(t,e));}function xt(t){["mousedown","keydown","touchstart","pointerdown"].forEach(function(e){return t(e,St,Wt)});}function Pt(e,t){function n(t,n,r,o){function i(e){"visibilitychange"===t&&"hidden"!==document.visibilityState||(o?setTimeout(function(){return n(e)},o):n(e),r&&removeEventListener(t,i,!0));}addEventListener(t,i,!0);}var r;n("visibilitychange",e,null==t?void 0:t.once,null==(r=null==t?void 0:t.delay)?void 0:r.visibilitychange),n("pagehide",e,null==t?void 0:t.once,null==(r=null==t?void 0:t.delay)?void 0:r.pagehide);}function Lt(e){var t=e.name;0<(e=e.value)&&(Kt[t]=e);}var N,kt,Ct,At,It,Nt,Ut=-1,Ht=function(t){addEventListener("pageshow",function(e){e.persisted&&(Ut=e.timeStamp,t(e));},!0);},qt=function(){return window.performance&&performance.getEntriesByType&&performance.getEntriesByType("navigation")[0]},jt=function(){var e=qt();return e&&e.activationStart||0},U=-1,_t=function(){return "hidden"!==document.visibilityState||document.prerendering?1/0:0},Dt=function(e){"hidden"===document.visibilityState&&-1<U&&(U="visibilitychange"===e.type?e.timeStamp:0,removeEventListener("visibilitychange",Dt,!0),removeEventListener("prerenderingchange",Dt,!0));},Mt=function(){addEventListener("visibilitychange",Dt,!0),addEventListener("prerenderingchange",Dt,!0);},Bt=[1800,3e3],Ft=[.1,.25],Wt={passive:!0,capture:!0},Gt=new Date,Xt=function(e,t){N||(N=t,kt=e,Ct=new Date,xt(removeEventListener),Tt());},Vt=[100,300],$t=[2500,4e3],Jt={},Kt=(new i({name:"webVitals"}),{FCP:-1,LCP:-1,FID:-1,CLS:-1}),zt=new i({name:"webVitals",onNewAegis:function(e){if(ge()&&"function"==typeof window.PerformanceObserver&&"function"==typeof performance.getEntriesByName)try{Ot(Lt),l=Lt,f={},Rt(function(){function e(e){(e=e[e.length-1])&&e.startTime<r.firstHiddenTime&&(o.value=Math.max(e.startTime-jt(),0),o.entries=[e],t());}var t,n,r=Et(),o=A("LCP"),i=vt("largest-contentful-paint",e);i&&(t=I(l,o,$t,f.reportAllChanges),n=bt(function(){Jt[o.id]||(e(i.takeRecords()),i.disconnect(),Jt[o.id]=!0,t(!0));}),["keydown","click"].forEach(function(e){addEventListener(e,function(){return setTimeout(n,0)},!0);}),wt(n),Ht(function(e){o=A("LCP"),t=I(l,o,$t,f.reportAllChanges),yt(function(){o.value=performance.now()-e.timeStamp,Jt[o.id]=!0,t(!0);});}));}),c=Lt,u={},Rt(function(){function t(e){e.startTime<n.firstHiddenTime&&(r.value=e.processingStart-e.startTime,r.entries.push(e),i(!0));}function e(e){e.forEach(t);}var n=Et(),r=A("FID"),o=vt("first-input",e),i=I(c,r,Vt,u.reportAllChanges);o&&wt(bt(function(){e(o.takeRecords()),o.disconnect();})),o&&Ht(function(){r=A("FID"),i=I(c,r,Vt,u.reportAllChanges),At=[],kt=-1,N=null,xt(addEventListener),At.push(t),Tt();});}),a=Lt,s={},Ot(bt(function(){function e(e){e.forEach(function(e){var t,n;e.hadRecentInput||(t=o[0],n=o[o.length-1],r&&e.startTime-n.startTime<1e3&&e.startTime-t.startTime<5e3?(r+=e.value,o.push(e)):(r=e.value,o=[e]));}),r>n.value&&(n.value=r,n.entries=o,t());}var t,n=A("CLS",0),r=0,o=[],i=vt("layout-shift",e);i&&(t=I(a,n,Ft,s.reportAllChanges),wt(function(){e(i.takeRecords()),t(!0);}),Ht(function(){n=A("CLS",r=0),t=I(a,n,Ft,s.reportAllChanges),yt(function(){return t()});}),setTimeout(t,0));})),Pt(this.publish.bind(this,e),{once:!0,delay:{visibilitychange:10}});}catch(e){}var a,s,c,u,l,f;},publish:function(t){this.$walk(function(i){var e;i===t&&null!=(e=i.sendPipeline)&&e.call(i,[function(e,t){var n,r=[];for(n in e)r.push(n+"="+e[n]);var o=-1===(null==(o=null==(o=i.config)?void 0:o.performanceUrl)?void 0:o.indexOf("?"))?"?":"&";t({url:i.config.webVitalsUrl+o+r.join("&"),type:v.VITALS,log:e,sendBeacon:!0});}],v.VITALS)(l({},Kt));});},destroy:function(){this.option.publish=function(){};}}),Qt=(new i({name:"spa"}),["replaceState","pushState","popstate","hashchange"]),Yt=new i({name:"spa",originFireUrl:"",onNewAegis:function(t){var n=this;history.pushState=this.wr("pushState")||history.pushState,history.replaceState=this.wr("replaceState")||history.replaceState,this.sendPv=this.sendPv.bind(this),t.config.spa&&this.sendPv(t),Qt.forEach(function(e){return window.addEventListener(e,function(){return n.sendPv.call(n,t)})});},wr:function(n){var r=history[n],e="__"+n+"__hasWrittenByTamSpa";return "function"==typeof r&&!history[e]&&(Object.defineProperty(history,e,{value:!0,enumerable:!1}),function(){var e=r.apply(this,arguments),t=null;return "function"==typeof Event?t=new Event(n):(t=document.createEvent("HTMLEvents")).initEvent(n,!1,!0),window.dispatchEvent(t),e})},sendPv:function(r){var o=this;setTimeout(function(){var t=location.pathname+location.hash+r.config.id;o.$walk(function(e){var n;e===r&&(n=e.config.pvUrl)&&t&&t!==o.originFireUrl&&(e.sendPipeline([function(e,t){t({url:""+n,type:v.PV});}],v.PV)(null),o.originFireUrl=t);});},0);},destroy:function(){this.option.sendPv=function(){};}}),o=(D(Nt=H,o=It=o),Nt.prototype=null===o?Object.create(o):(Zt.prototype=o.prototype,new Zt),H.prototype.getBean=function(t){var n=this;return void 0===t&&(t=[]),""+Object.getOwnPropertyNames(this.bean).filter(function(e){return -1===t.indexOf(e)}).map(function(e){return "from"===e?"from="+n.getCurrentPageUrl():e+"="+n.bean[e]}).join("&")},H.prototype.getCurrentPageUrl=function(){var e=this.config.pageUrl||location.href,e=(e="function"==typeof this.config.urlHandler?this.config.urlHandler()||location.href:e).slice(0,2048);return encodeURIComponent(e)},H.prototype.ready=function(){function i(){var e,n,r,o;t.reportRequestQueue.length&&(e=t.reportRequestQueue.splice(0,1)[0],n=e.options,r=e.success,o=e.fail,t.$request(n,function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];try{return null==r?void 0:r.apply(n,e)}finally{i();}},function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];try{return null==o?void 0:o.apply(n,e)}finally{i();}}));}var t=this;i(),this.isReportReady=!0;},H.prototype.request=function(e,t,n){this.config.reportImmediately||this.isReportReady?this.$request(e,t,n):this.reportRequestQueue.push({options:e,success:t,fail:n});},H.prototype.$request=function(s,e,t){var n,r,o,i;if(s&&"string"==typeof s.url&&""!==s.url&&this.bean.id)return i=s.url,!1!==s.addBean&&(i=function(e,t){var n,r,o,i=e,a=s.beanFilter||[];for(n in t)-1===a.indexOf(n)&&((o=(r=new RegExp("([?&])"+n+"(=([^&]*))?(?=&|$)")).exec(i))?o[2]&&""!==o[3]&&"undefined"!==o[3]||(i=i.replace(r,"$1"+n+"="+t[n])):(o=-1<i.indexOf("?")?"&":"?",i+=o+n+"="+t[n]));return i}(i,l(l({},this.bean),{from:this.getCurrentPageUrl()}))),s.url=i,i=s.method||"get",r=this.config.onBeforeRequest,(s=r?r(s,this):s)?s.url?void((null!=s&&s.sendBeacon||this.sendNow)&&"function"==typeof(null===navigator||void 0===navigator?void 0:navigator.sendBeacon)?navigator.sendBeacon(s.url,s.data):((n=new XMLHttpRequest).sendByAegis=!0,n.addEventListener("readystatechange",function(){4===n.readyState&&(400<=n.status||0===n.status?null!=t&&t(n.response):null!=e&&e(n.response));}),"get"===i.toLocaleLowerCase()?(n.open("get",(r=s.url,o=s.data,"string"!=typeof r?"":"object"==typeof o&&o?(i=Object.getOwnPropertyNames(o).map(function(e){var t=o[e];return e+"="+("string"==typeof t?encodeURIComponent(t):encodeURIComponent(JSON.stringify(t)))}).join("&").replace(/eval/gi,"evaI"),r+(-1===r.indexOf("?")?"?":"&")+i):r)),n.send()):(n.open("post",s.url),s.contentType&&n.setRequestHeader("Content-Type",s.contentType),"string"==typeof s.data&&(s.data=s.data.replace(/eval/gi,"evaI")),n.send(s.data)))):console.warn("Please handle the parameters reasonably, options.url is necessary"):console.warn("Sending request blocked")},H.prototype.publishPluginsLogs=function(){var e=H.installedPlugins.find(function(e){return "reportAssetSpeed"===e.name});null!=e&&e.option.collectNotReportedLog(this);},H.prototype.uploadLogs=function(e,t){var n;void 0===e&&(e={}),void 0===t&&(t={}),null!=(n=this.lifeCycle)&&n.emit("uploadLogs",e,t);},H.sessionID="session-"+Date.now(),H);function H(e){var t,n,r,a,s=It.call(this,e)||this;s.sendNow=!1,s.isReportReady=!1,s.reportRequestQueue=[],s.speedLogPipeline=m([ue(s),(a=s.config,function(e,t){var n,r,o,i="number"==typeof a.repeat?a.repeat:60;!a.speedSample||i<=0?t(e):(n=(null==a?void 0:a.id)||"0",r=T[n]||{},Array.isArray(e)?(o=e.filter(function(e){var t=!r[e.url]||r[e.url]<i;return t?(r[e.url]=1+~~r[e.url],T[n]=r):O[n]||Pe(n),t})).length&&t(o):!r[e.url]||r[e.url]<i?(r[e.url]=1+~~r[e.url],T[n]=r,t(e)):O[n]||Pe(n));}),(r=s,function(t,n){at(function(e){r.extendBean("netType",e),n(t);});}),function(e,t){null!=(n=s.lifeCycle)&&n.emit("beforeReportSpeed",e);var n,r=s.config.beforeReportSpeed;if((e="function"==typeof r?e.filter(function(e){return !1!==r(e)}):e).length)return t(e)},function(e,t){t(e.map(function(e){return void 0!==e.payload&&delete e.payload,e}));},function(e){return s.sendPipeline([function(e,t){var n,r,o,i;t({type:v.SPEED,url:""+s.config.speedUrl,method:"post",data:(t=e,n=l(l({},s.bean),{from:s.getCurrentPageUrl()}),o={fetch:[],static:[],bridge:[]},i=new FormData,Array.isArray(t)?t.forEach(function(e){var t=Ie(e);o[e.type].push(t);}):(r=Ie(t),o[t.type].push(r)),i.append("payload",be(l({duration:o},n))),i),log:e});}],v.SPEED)(e)}]),e.asyncPlugin=!0;try{"undefined"!=typeof document&&(e.uin=e.uin||(null!=(t=document.cookie.match(/\buin=\D+(\d*)/))?t:[])[1]||(null!=(n=document.cookie.match(/\bilive_uin=\D*(\d+)/))?n:[])[1]||""),s.init(e),s.extendBean("sessionId",H.sessionID),s.extendBean("from",s.getCurrentPageUrl()),"undefined"!=typeof document&&s.extendBean("referer",encodeURIComponent(document.referrer||"")),e.ext1&&s.extendBean("ext1",encodeURIComponent(e.ext1)),e.ext2&&s.extendBean("ext2",encodeURIComponent(e.ext2)),e.ext3&&s.extendBean("ext3",encodeURIComponent(e.ext3));}catch(e){console.warn(e),console.log("%cThe above error occurred in the process of initializing Aegis, which will affect your normal use of Aegis.\nIt is recommended that you contact us for feedback and thank you for your support.","color: red"),s.sendSDKError(e);}return s}function Zt(){this.constructor=Nt;}new i({name:"ie"}),new i({name:"onClose"});var en=new i({name:"onClose",onNewAegis:function(n){var r,o=this;a.desktop()?(r=window.onunload,window.onunload=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];o.publishNotReportedLog(n),null!=r&&r.call.apply(r,u([window],e));}):Pt(this.publishNotReportedLog.bind(this,n),{once:!0});},publishNotReportedLog:function(t){var n=this;this.$walk(function(e){e===t&&(e.sendNow=!0,e.publishPluginsLogs(),n.publishThrottlePipeLogs(e));});},publishThrottlePipeLogs:function(e){null!=e&&e.speedLogPipeline([]),null!=e&&e.eventPipeline([]),null!=e&&e.customTimePipeline([]),null!=e&&e.normalLogPipeline([]);}});return new i({name:"aid"}),o.use(lt),o.use(Qe),o.use(Ue),o.use(dt),o.use(zt),o.use(Ae),o.use(k),o.use(Yt),o.use(en),o.use(Ze),o}); 
} (aegis_min));

var aegis_minExports = aegis_min.exports;
const Aegis = /*@__PURE__*/getDefaultExportFromCjs(aegis_minExports);

class LoggerService {
    oauth;
    storage;
    region;
    aegis;
    constructor(oauth, storage, region){
        this.oauth = oauth;
        this.storage = storage;
        this.region = region;
        this.aegis = new Aegis({
            id: this.region === Region.CHINA ? '4e2YkS5m4KnQkk8JRw' : 'KJyq2SqLGY8wdvZwYm',
            reportApiSpeed: true,
            reportAssetSpeed: false,
            pagePerformance: false,
            webVitals: false,
            onError: true,
            hostUrl: Region.CHINA ? 'https://rumt-zh.com' : 'https://rumt-us.com',
            pvUrl: '',
            whiteListUrl: '',
            performanceUrl: '',
            webVitalsUrl: '',
            api: {
                resHeaders: [
                    'x-request-id',
                    'content-type',
                    'server',
                    'x-cos-request-id',
                    'x-cos-storage-class',
                    'x-cos-trace-id'
                ]
            }
        });
        oauth.token$.subscribe((token)=>{
            this.aegis.setConfig({
                uin: token?.userId
            });
        });
        bind(this);
    }
    setEnv(env) {
        this.aegis.setConfig({
            env: env === 'testing' ? 'test' : env
        });
    }
    event(name) {
        this.aegis.reportEvent(name);
    }
    logError(msg, extension) {
        this.aegis.error({
            msg,
            ext2: extension && JSON.stringify(extension),
            ext3: FULL_VERSION
        });
    }
    logErrorObject(msg, error, data = null) {
        console.error(msg, data, error);
        this.logError(msg, {
            message: error?.message ?? String(error),
            stack: error?.stack ?? '',
            data
        });
    }
    async logUploadFailure(subject, error, attributes, level = 'error') {
        const oauth = await this.storage.getItem(OAUTH_KEY);
        const appId = await this.storage.getItem(APP_ID_KEY);
        $logCls(this.region, [
            {
                time: Date.now(),
                contents: {
                    context: 'upload failure',
                    subject,
                    message: error?.message ?? '',
                    stack: error?.stack ?? '',
                    userId: oauth?.userId || '',
                    appId: appId || '',
                    client: CLIENT,
                    level,
                    attributes: JSON.stringify(attributes)
                }
            }
        ]);
    }
}

var uaParser = {exports: {}};

(function (module, exports) {
	/////////////////////////////////////////////////////////////////////////////////
	/* UAParser.js v1.0.38
	   Copyright © 2012-2021 Faisal Salman <f@faisalman.com>
	   MIT License *//*
	   Detect Browser, Engine, OS, CPU, and Device type/model from User-Agent data.
	   Supports browser & node.js environment. 
	   Demo   : https://faisalman.github.io/ua-parser-js
	   Source : https://github.com/faisalman/ua-parser-js */
	/////////////////////////////////////////////////////////////////////////////////

	(function (window, undefined$1) {

	    //////////////
	    // Constants
	    /////////////


	    var LIBVERSION  = '1.0.38',
	        EMPTY       = '',
	        UNKNOWN     = '?',
	        FUNC_TYPE   = 'function',
	        UNDEF_TYPE  = 'undefined',
	        OBJ_TYPE    = 'object',
	        STR_TYPE    = 'string',
	        MAJOR       = 'major',
	        MODEL       = 'model',
	        NAME        = 'name',
	        TYPE        = 'type',
	        VENDOR      = 'vendor',
	        VERSION     = 'version',
	        ARCHITECTURE= 'architecture',
	        CONSOLE     = 'console',
	        MOBILE      = 'mobile',
	        TABLET      = 'tablet',
	        SMARTTV     = 'smarttv',
	        WEARABLE    = 'wearable',
	        EMBEDDED    = 'embedded',
	        UA_MAX_LENGTH = 500;

	    var AMAZON  = 'Amazon',
	        APPLE   = 'Apple',
	        ASUS    = 'ASUS',
	        BLACKBERRY = 'BlackBerry',
	        BROWSER = 'Browser',
	        CHROME  = 'Chrome',
	        EDGE    = 'Edge',
	        FIREFOX = 'Firefox',
	        GOOGLE  = 'Google',
	        HUAWEI  = 'Huawei',
	        LG      = 'LG',
	        MICROSOFT = 'Microsoft',
	        MOTOROLA  = 'Motorola',
	        OPERA   = 'Opera',
	        SAMSUNG = 'Samsung',
	        SHARP   = 'Sharp',
	        SONY    = 'Sony',
	        XIAOMI  = 'Xiaomi',
	        ZEBRA   = 'Zebra',
	        FACEBOOK    = 'Facebook',
	        CHROMIUM_OS = 'Chromium OS',
	        MAC_OS  = 'Mac OS';

	    ///////////
	    // Helper
	    //////////

	    var extend = function (regexes, extensions) {
	            var mergedRegexes = {};
	            for (var i in regexes) {
	                if (extensions[i] && extensions[i].length % 2 === 0) {
	                    mergedRegexes[i] = extensions[i].concat(regexes[i]);
	                } else {
	                    mergedRegexes[i] = regexes[i];
	                }
	            }
	            return mergedRegexes;
	        },
	        enumerize = function (arr) {
	            var enums = {};
	            for (var i=0; i<arr.length; i++) {
	                enums[arr[i].toUpperCase()] = arr[i];
	            }
	            return enums;
	        },
	        has = function (str1, str2) {
	            return typeof str1 === STR_TYPE ? lowerize(str2).indexOf(lowerize(str1)) !== -1 : false;
	        },
	        lowerize = function (str) {
	            return str.toLowerCase();
	        },
	        majorize = function (version) {
	            return typeof(version) === STR_TYPE ? version.replace(/[^\d\.]/g, EMPTY).split('.')[0] : undefined$1;
	        },
	        trim = function (str, len) {
	            if (typeof(str) === STR_TYPE) {
	                str = str.replace(/^\s\s*/, EMPTY);
	                return typeof(len) === UNDEF_TYPE ? str : str.substring(0, UA_MAX_LENGTH);
	            }
	    };

	    ///////////////
	    // Map helper
	    //////////////

	    var rgxMapper = function (ua, arrays) {

	            var i = 0, j, k, p, q, matches, match;

	            // loop through all regexes maps
	            while (i < arrays.length && !matches) {

	                var regex = arrays[i],       // even sequence (0,2,4,..)
	                    props = arrays[i + 1];   // odd sequence (1,3,5,..)
	                j = k = 0;

	                // try matching uastring with regexes
	                while (j < regex.length && !matches) {

	                    if (!regex[j]) { break; }
	                    matches = regex[j++].exec(ua);

	                    if (!!matches) {
	                        for (p = 0; p < props.length; p++) {
	                            match = matches[++k];
	                            q = props[p];
	                            // check if given property is actually array
	                            if (typeof q === OBJ_TYPE && q.length > 0) {
	                                if (q.length === 2) {
	                                    if (typeof q[1] == FUNC_TYPE) {
	                                        // assign modified match
	                                        this[q[0]] = q[1].call(this, match);
	                                    } else {
	                                        // assign given value, ignore regex match
	                                        this[q[0]] = q[1];
	                                    }
	                                } else if (q.length === 3) {
	                                    // check whether function or regex
	                                    if (typeof q[1] === FUNC_TYPE && !(q[1].exec && q[1].test)) {
	                                        // call function (usually string mapper)
	                                        this[q[0]] = match ? q[1].call(this, match, q[2]) : undefined$1;
	                                    } else {
	                                        // sanitize match using given regex
	                                        this[q[0]] = match ? match.replace(q[1], q[2]) : undefined$1;
	                                    }
	                                } else if (q.length === 4) {
	                                        this[q[0]] = match ? q[3].call(this, match.replace(q[1], q[2])) : undefined$1;
	                                }
	                            } else {
	                                this[q] = match ? match : undefined$1;
	                            }
	                        }
	                    }
	                }
	                i += 2;
	            }
	        },

	        strMapper = function (str, map) {

	            for (var i in map) {
	                // check if current value is array
	                if (typeof map[i] === OBJ_TYPE && map[i].length > 0) {
	                    for (var j = 0; j < map[i].length; j++) {
	                        if (has(map[i][j], str)) {
	                            return (i === UNKNOWN) ? undefined$1 : i;
	                        }
	                    }
	                } else if (has(map[i], str)) {
	                    return (i === UNKNOWN) ? undefined$1 : i;
	                }
	            }
	            return str;
	    };

	    ///////////////
	    // String map
	    //////////////

	    // Safari < 3.0
	    var oldSafariMap = {
	            '1.0'   : '/8',
	            '1.2'   : '/1',
	            '1.3'   : '/3',
	            '2.0'   : '/412',
	            '2.0.2' : '/416',
	            '2.0.3' : '/417',
	            '2.0.4' : '/419',
	            '?'     : '/'
	        },
	        windowsVersionMap = {
	            'ME'        : '4.90',
	            'NT 3.11'   : 'NT3.51',
	            'NT 4.0'    : 'NT4.0',
	            '2000'      : 'NT 5.0',
	            'XP'        : ['NT 5.1', 'NT 5.2'],
	            'Vista'     : 'NT 6.0',
	            '7'         : 'NT 6.1',
	            '8'         : 'NT 6.2',
	            '8.1'       : 'NT 6.3',
	            '10'        : ['NT 6.4', 'NT 10.0'],
	            'RT'        : 'ARM'
	    };

	    //////////////
	    // Regex map
	    /////////////

	    var regexes = {

	        browser : [[

	            /\b(?:crmo|crios)\/([\w\.]+)/i                                      // Chrome for Android/iOS
	            ], [VERSION, [NAME, 'Chrome']], [
	            /edg(?:e|ios|a)?\/([\w\.]+)/i                                       // Microsoft Edge
	            ], [VERSION, [NAME, 'Edge']], [

	            // Presto based
	            /(opera mini)\/([-\w\.]+)/i,                                        // Opera Mini
	            /(opera [mobiletab]{3,6})\b.+version\/([-\w\.]+)/i,                 // Opera Mobi/Tablet
	            /(opera)(?:.+version\/|[\/ ]+)([\w\.]+)/i                           // Opera
	            ], [NAME, VERSION], [
	            /opios[\/ ]+([\w\.]+)/i                                             // Opera mini on iphone >= 8.0
	            ], [VERSION, [NAME, OPERA+' Mini']], [
	            /\bop(?:rg)?x\/([\w\.]+)/i                                          // Opera GX
	            ], [VERSION, [NAME, OPERA+' GX']], [
	            /\bopr\/([\w\.]+)/i                                                 // Opera Webkit
	            ], [VERSION, [NAME, OPERA]], [

	            // Mixed
	            /\bb[ai]*d(?:uhd|[ub]*[aekoprswx]{5,6})[\/ ]?([\w\.]+)/i            // Baidu
	            ], [VERSION, [NAME, 'Baidu']], [
	            /(kindle)\/([\w\.]+)/i,                                             // Kindle
	            /(lunascape|maxthon|netfront|jasmine|blazer)[\/ ]?([\w\.]*)/i,      // Lunascape/Maxthon/Netfront/Jasmine/Blazer
	            // Trident based
	            /(avant|iemobile|slim)\s?(?:browser)?[\/ ]?([\w\.]*)/i,             // Avant/IEMobile/SlimBrowser
	            /(?:ms|\()(ie) ([\w\.]+)/i,                                         // Internet Explorer

	            // Webkit/KHTML based                                               // Flock/RockMelt/Midori/Epiphany/Silk/Skyfire/Bolt/Iron/Iridium/PhantomJS/Bowser/QupZilla/Falkon
	            /(flock|rockmelt|midori|epiphany|silk|skyfire|bolt|iron|vivaldi|iridium|phantomjs|bowser|quark|qupzilla|falkon|rekonq|puffin|brave|whale(?!.+naver)|qqbrowserlite|qq|duckduckgo)\/([-\w\.]+)/i,
	                                                                                // Rekonq/Puffin/Brave/Whale/QQBrowserLite/QQ, aka ShouQ
	            /(heytap|ovi)browser\/([\d\.]+)/i,                                  // Heytap/Ovi
	            /(weibo)__([\d\.]+)/i                                               // Weibo
	            ], [NAME, VERSION], [
	            /\bddg\/([\w\.]+)/i                                                 // DuckDuckGo
	            ], [VERSION, [NAME, 'DuckDuckGo']], [
	            /(?:\buc? ?browser|(?:juc.+)ucweb)[\/ ]?([\w\.]+)/i                 // UCBrowser
	            ], [VERSION, [NAME, 'UC'+BROWSER]], [
	            /microm.+\bqbcore\/([\w\.]+)/i,                                     // WeChat Desktop for Windows Built-in Browser
	            /\bqbcore\/([\w\.]+).+microm/i,
	            /micromessenger\/([\w\.]+)/i                                        // WeChat
	            ], [VERSION, [NAME, 'WeChat']], [
	            /konqueror\/([\w\.]+)/i                                             // Konqueror
	            ], [VERSION, [NAME, 'Konqueror']], [
	            /trident.+rv[: ]([\w\.]{1,9})\b.+like gecko/i                       // IE11
	            ], [VERSION, [NAME, 'IE']], [
	            /ya(?:search)?browser\/([\w\.]+)/i                                  // Yandex
	            ], [VERSION, [NAME, 'Yandex']], [
	            /slbrowser\/([\w\.]+)/i                                             // Smart Lenovo Browser
	            ], [VERSION, [NAME, 'Smart Lenovo '+BROWSER]], [
	            /(avast|avg)\/([\w\.]+)/i                                           // Avast/AVG Secure Browser
	            ], [[NAME, /(.+)/, '$1 Secure '+BROWSER], VERSION], [
	            /\bfocus\/([\w\.]+)/i                                               // Firefox Focus
	            ], [VERSION, [NAME, FIREFOX+' Focus']], [
	            /\bopt\/([\w\.]+)/i                                                 // Opera Touch
	            ], [VERSION, [NAME, OPERA+' Touch']], [
	            /coc_coc\w+\/([\w\.]+)/i                                            // Coc Coc Browser
	            ], [VERSION, [NAME, 'Coc Coc']], [
	            /dolfin\/([\w\.]+)/i                                                // Dolphin
	            ], [VERSION, [NAME, 'Dolphin']], [
	            /coast\/([\w\.]+)/i                                                 // Opera Coast
	            ], [VERSION, [NAME, OPERA+' Coast']], [
	            /miuibrowser\/([\w\.]+)/i                                           // MIUI Browser
	            ], [VERSION, [NAME, 'MIUI '+BROWSER]], [
	            /fxios\/([-\w\.]+)/i                                                // Firefox for iOS
	            ], [VERSION, [NAME, FIREFOX]], [
	            /\bqihu|(qi?ho?o?|360)browser/i                                     // 360
	            ], [[NAME, '360 ' + BROWSER]], [
	            /(oculus|sailfish|huawei|vivo)browser\/([\w\.]+)/i
	            ], [[NAME, /(.+)/, '$1 ' + BROWSER], VERSION], [                    // Oculus/Sailfish/HuaweiBrowser/VivoBrowser
	            /samsungbrowser\/([\w\.]+)/i                                        // Samsung Internet
	            ], [VERSION, [NAME, SAMSUNG + ' Internet']], [
	            /(comodo_dragon)\/([\w\.]+)/i                                       // Comodo Dragon
	            ], [[NAME, /_/g, ' '], VERSION], [
	            /metasr[\/ ]?([\d\.]+)/i                                            // Sogou Explorer
	            ], [VERSION, [NAME, 'Sogou Explorer']], [
	            /(sogou)mo\w+\/([\d\.]+)/i                                          // Sogou Mobile
	            ], [[NAME, 'Sogou Mobile'], VERSION], [
	            /(electron)\/([\w\.]+) safari/i,                                    // Electron-based App
	            /(tesla)(?: qtcarbrowser|\/(20\d\d\.[-\w\.]+))/i,                   // Tesla
	            /m?(qqbrowser|2345Explorer)[\/ ]?([\w\.]+)/i                        // QQBrowser/2345 Browser
	            ], [NAME, VERSION], [
	            /(lbbrowser)/i,                                                     // LieBao Browser
	            /\[(linkedin)app\]/i                                                // LinkedIn App for iOS & Android
	            ], [NAME], [

	            // WebView
	            /((?:fban\/fbios|fb_iab\/fb4a)(?!.+fbav)|;fbav\/([\w\.]+);)/i       // Facebook App for iOS & Android
	            ], [[NAME, FACEBOOK], VERSION], [
	            /(Klarna)\/([\w\.]+)/i,                                             // Klarna Shopping Browser for iOS & Android
	            /(kakao(?:talk|story))[\/ ]([\w\.]+)/i,                             // Kakao App
	            /(naver)\(.*?(\d+\.[\w\.]+).*\)/i,                                  // Naver InApp
	            /safari (line)\/([\w\.]+)/i,                                        // Line App for iOS
	            /\b(line)\/([\w\.]+)\/iab/i,                                        // Line App for Android
	            /(alipay)client\/([\w\.]+)/i,                                       // Alipay
	            /(twitter)(?:and| f.+e\/([\w\.]+))/i,                               // Twitter
	            /(chromium|instagram|snapchat)[\/ ]([-\w\.]+)/i                     // Chromium/Instagram/Snapchat
	            ], [NAME, VERSION], [
	            /\bgsa\/([\w\.]+) .*safari\//i                                      // Google Search Appliance on iOS
	            ], [VERSION, [NAME, 'GSA']], [
	            /musical_ly(?:.+app_?version\/|_)([\w\.]+)/i                        // TikTok
	            ], [VERSION, [NAME, 'TikTok']], [

	            /headlesschrome(?:\/([\w\.]+)| )/i                                  // Chrome Headless
	            ], [VERSION, [NAME, CHROME+' Headless']], [

	            / wv\).+(chrome)\/([\w\.]+)/i                                       // Chrome WebView
	            ], [[NAME, CHROME+' WebView'], VERSION], [

	            /droid.+ version\/([\w\.]+)\b.+(?:mobile safari|safari)/i           // Android Browser
	            ], [VERSION, [NAME, 'Android '+BROWSER]], [

	            /(chrome|omniweb|arora|[tizenoka]{5} ?browser)\/v?([\w\.]+)/i       // Chrome/OmniWeb/Arora/Tizen/Nokia
	            ], [NAME, VERSION], [

	            /version\/([\w\.\,]+) .*mobile\/\w+ (safari)/i                      // Mobile Safari
	            ], [VERSION, [NAME, 'Mobile Safari']], [
	            /version\/([\w(\.|\,)]+) .*(mobile ?safari|safari)/i                // Safari & Safari Mobile
	            ], [VERSION, NAME], [
	            /webkit.+?(mobile ?safari|safari)(\/[\w\.]+)/i                      // Safari < 3.0
	            ], [NAME, [VERSION, strMapper, oldSafariMap]], [

	            /(webkit|khtml)\/([\w\.]+)/i
	            ], [NAME, VERSION], [

	            // Gecko based
	            /(navigator|netscape\d?)\/([-\w\.]+)/i                              // Netscape
	            ], [[NAME, 'Netscape'], VERSION], [
	            /mobile vr; rv:([\w\.]+)\).+firefox/i                               // Firefox Reality
	            ], [VERSION, [NAME, FIREFOX+' Reality']], [
	            /ekiohf.+(flow)\/([\w\.]+)/i,                                       // Flow
	            /(swiftfox)/i,                                                      // Swiftfox
	            /(icedragon|iceweasel|camino|chimera|fennec|maemo browser|minimo|conkeror|klar)[\/ ]?([\w\.\+]+)/i,
	                                                                                // IceDragon/Iceweasel/Camino/Chimera/Fennec/Maemo/Minimo/Conkeror/Klar
	            /(seamonkey|k-meleon|icecat|iceape|firebird|phoenix|palemoon|basilisk|waterfox)\/([-\w\.]+)$/i,
	                                                                                // Firefox/SeaMonkey/K-Meleon/IceCat/IceApe/Firebird/Phoenix
	            /(firefox)\/([\w\.]+)/i,                                            // Other Firefox-based
	            /(mozilla)\/([\w\.]+) .+rv\:.+gecko\/\d+/i,                         // Mozilla

	            // Other
	            /(polaris|lynx|dillo|icab|doris|amaya|w3m|netsurf|sleipnir|obigo|mosaic|(?:go|ice|up)[\. ]?browser)[-\/ ]?v?([\w\.]+)/i,
	                                                                                // Polaris/Lynx/Dillo/iCab/Doris/Amaya/w3m/NetSurf/Sleipnir/Obigo/Mosaic/Go/ICE/UP.Browser
	            /(links) \(([\w\.]+)/i,                                             // Links
	            /panasonic;(viera)/i                                                // Panasonic Viera
	            ], [NAME, VERSION], [
	            
	            /(cobalt)\/([\w\.]+)/i                                              // Cobalt
	            ], [NAME, [VERSION, /master.|lts./, ""]]
	        ],

	        cpu : [[

	            /(?:(amd|x(?:(?:86|64)[-_])?|wow|win)64)[;\)]/i                     // AMD64 (x64)
	            ], [[ARCHITECTURE, 'amd64']], [

	            /(ia32(?=;))/i                                                      // IA32 (quicktime)
	            ], [[ARCHITECTURE, lowerize]], [

	            /((?:i[346]|x)86)[;\)]/i                                            // IA32 (x86)
	            ], [[ARCHITECTURE, 'ia32']], [

	            /\b(aarch64|arm(v?8e?l?|_?64))\b/i                                 // ARM64
	            ], [[ARCHITECTURE, 'arm64']], [

	            /\b(arm(?:v[67])?ht?n?[fl]p?)\b/i                                   // ARMHF
	            ], [[ARCHITECTURE, 'armhf']], [

	            // PocketPC mistakenly identified as PowerPC
	            /windows (ce|mobile); ppc;/i
	            ], [[ARCHITECTURE, 'arm']], [

	            /((?:ppc|powerpc)(?:64)?)(?: mac|;|\))/i                            // PowerPC
	            ], [[ARCHITECTURE, /ower/, EMPTY, lowerize]], [

	            /(sun4\w)[;\)]/i                                                    // SPARC
	            ], [[ARCHITECTURE, 'sparc']], [

	            /((?:avr32|ia64(?=;))|68k(?=\))|\barm(?=v(?:[1-7]|[5-7]1)l?|;|eabi)|(?=atmel )avr|(?:irix|mips|sparc)(?:64)?\b|pa-risc)/i
	                                                                                // IA64, 68K, ARM/64, AVR/32, IRIX/64, MIPS/64, SPARC/64, PA-RISC
	            ], [[ARCHITECTURE, lowerize]]
	        ],

	        device : [[

	            //////////////////////////
	            // MOBILES & TABLETS
	            /////////////////////////

	            // Samsung
	            /\b(sch-i[89]0\d|shw-m380s|sm-[ptx]\w{2,4}|gt-[pn]\d{2,4}|sgh-t8[56]9|nexus 10)/i
	            ], [MODEL, [VENDOR, SAMSUNG], [TYPE, TABLET]], [
	            /\b((?:s[cgp]h|gt|sm)-\w+|sc[g-]?[\d]+a?|galaxy nexus)/i,
	            /samsung[- ]([-\w]+)/i,
	            /sec-(sgh\w+)/i
	            ], [MODEL, [VENDOR, SAMSUNG], [TYPE, MOBILE]], [

	            // Apple
	            /(?:\/|\()(ip(?:hone|od)[\w, ]*)(?:\/|;)/i                          // iPod/iPhone
	            ], [MODEL, [VENDOR, APPLE], [TYPE, MOBILE]], [
	            /\((ipad);[-\w\),; ]+apple/i,                                       // iPad
	            /applecoremedia\/[\w\.]+ \((ipad)/i,
	            /\b(ipad)\d\d?,\d\d?[;\]].+ios/i
	            ], [MODEL, [VENDOR, APPLE], [TYPE, TABLET]], [
	            /(macintosh);/i
	            ], [MODEL, [VENDOR, APPLE]], [

	            // Sharp
	            /\b(sh-?[altvz]?\d\d[a-ekm]?)/i
	            ], [MODEL, [VENDOR, SHARP], [TYPE, MOBILE]], [

	            // Huawei
	            /\b((?:ag[rs][23]?|bah2?|sht?|btv)-a?[lw]\d{2})\b(?!.+d\/s)/i
	            ], [MODEL, [VENDOR, HUAWEI], [TYPE, TABLET]], [
	            /(?:huawei|honor)([-\w ]+)[;\)]/i,
	            /\b(nexus 6p|\w{2,4}e?-[atu]?[ln][\dx][012359c][adn]?)\b(?!.+d\/s)/i
	            ], [MODEL, [VENDOR, HUAWEI], [TYPE, MOBILE]], [

	            // Xiaomi
	            /\b(poco[\w ]+|m2\d{3}j\d\d[a-z]{2})(?: bui|\))/i,                  // Xiaomi POCO
	            /\b; (\w+) build\/hm\1/i,                                           // Xiaomi Hongmi 'numeric' models
	            /\b(hm[-_ ]?note?[_ ]?(?:\d\w)?) bui/i,                             // Xiaomi Hongmi
	            /\b(redmi[\-_ ]?(?:note|k)?[\w_ ]+)(?: bui|\))/i,                   // Xiaomi Redmi
	            /oid[^\)]+; (m?[12][0-389][01]\w{3,6}[c-y])( bui|; wv|\))/i,        // Xiaomi Redmi 'numeric' models
	            /\b(mi[-_ ]?(?:a\d|one|one[_ ]plus|note lte|max|cc)?[_ ]?(?:\d?\w?)[_ ]?(?:plus|se|lite)?)(?: bui|\))/i // Xiaomi Mi
	            ], [[MODEL, /_/g, ' '], [VENDOR, XIAOMI], [TYPE, MOBILE]], [
	            /oid[^\)]+; (2\d{4}(283|rpbf)[cgl])( bui|\))/i,                     // Redmi Pad
	            /\b(mi[-_ ]?(?:pad)(?:[\w_ ]+))(?: bui|\))/i                        // Mi Pad tablets
	            ],[[MODEL, /_/g, ' '], [VENDOR, XIAOMI], [TYPE, TABLET]], [

	            // OPPO
	            /; (\w+) bui.+ oppo/i,
	            /\b(cph[12]\d{3}|p(?:af|c[al]|d\w|e[ar])[mt]\d0|x9007|a101op)\b/i
	            ], [MODEL, [VENDOR, 'OPPO'], [TYPE, MOBILE]], [
	            /\b(opd2\d{3}a?) bui/i
	            ], [MODEL, [VENDOR, 'OPPO'], [TYPE, TABLET]], [

	            // Vivo
	            /vivo (\w+)(?: bui|\))/i,
	            /\b(v[12]\d{3}\w?[at])(?: bui|;)/i
	            ], [MODEL, [VENDOR, 'Vivo'], [TYPE, MOBILE]], [

	            // Realme
	            /\b(rmx[1-3]\d{3})(?: bui|;|\))/i
	            ], [MODEL, [VENDOR, 'Realme'], [TYPE, MOBILE]], [

	            // Motorola
	            /\b(milestone|droid(?:[2-4x]| (?:bionic|x2|pro|razr))?:?( 4g)?)\b[\w ]+build\//i,
	            /\bmot(?:orola)?[- ](\w*)/i,
	            /((?:moto[\w\(\) ]+|xt\d{3,4}|nexus 6)(?= bui|\)))/i
	            ], [MODEL, [VENDOR, MOTOROLA], [TYPE, MOBILE]], [
	            /\b(mz60\d|xoom[2 ]{0,2}) build\//i
	            ], [MODEL, [VENDOR, MOTOROLA], [TYPE, TABLET]], [

	            // LG
	            /((?=lg)?[vl]k\-?\d{3}) bui| 3\.[-\w; ]{10}lg?-([06cv9]{3,4})/i
	            ], [MODEL, [VENDOR, LG], [TYPE, TABLET]], [
	            /(lm(?:-?f100[nv]?|-[\w\.]+)(?= bui|\))|nexus [45])/i,
	            /\blg[-e;\/ ]+((?!browser|netcast|android tv)\w+)/i,
	            /\blg-?([\d\w]+) bui/i
	            ], [MODEL, [VENDOR, LG], [TYPE, MOBILE]], [

	            // Lenovo
	            /(ideatab[-\w ]+)/i,
	            /lenovo ?(s[56]000[-\w]+|tab(?:[\w ]+)|yt[-\d\w]{6}|tb[-\d\w]{6})/i
	            ], [MODEL, [VENDOR, 'Lenovo'], [TYPE, TABLET]], [

	            // Nokia
	            /(?:maemo|nokia).*(n900|lumia \d+)/i,
	            /nokia[-_ ]?([-\w\.]*)/i
	            ], [[MODEL, /_/g, ' '], [VENDOR, 'Nokia'], [TYPE, MOBILE]], [

	            // Google
	            /(pixel c)\b/i                                                      // Google Pixel C
	            ], [MODEL, [VENDOR, GOOGLE], [TYPE, TABLET]], [
	            /droid.+; (pixel[\daxl ]{0,6})(?: bui|\))/i                         // Google Pixel
	            ], [MODEL, [VENDOR, GOOGLE], [TYPE, MOBILE]], [

	            // Sony
	            /droid.+ (a?\d[0-2]{2}so|[c-g]\d{4}|so[-gl]\w+|xq-a\w[4-7][12])(?= bui|\).+chrome\/(?![1-6]{0,1}\d\.))/i
	            ], [MODEL, [VENDOR, SONY], [TYPE, MOBILE]], [
	            /sony tablet [ps]/i,
	            /\b(?:sony)?sgp\w+(?: bui|\))/i
	            ], [[MODEL, 'Xperia Tablet'], [VENDOR, SONY], [TYPE, TABLET]], [

	            // OnePlus
	            / (kb2005|in20[12]5|be20[12][59])\b/i,
	            /(?:one)?(?:plus)? (a\d0\d\d)(?: b|\))/i
	            ], [MODEL, [VENDOR, 'OnePlus'], [TYPE, MOBILE]], [

	            // Amazon
	            /(alexa)webm/i,
	            /(kf[a-z]{2}wi|aeo[c-r]{2})( bui|\))/i,                             // Kindle Fire without Silk / Echo Show
	            /(kf[a-z]+)( bui|\)).+silk\//i                                      // Kindle Fire HD
	            ], [MODEL, [VENDOR, AMAZON], [TYPE, TABLET]], [
	            /((?:sd|kf)[0349hijorstuw]+)( bui|\)).+silk\//i                     // Fire Phone
	            ], [[MODEL, /(.+)/g, 'Fire Phone $1'], [VENDOR, AMAZON], [TYPE, MOBILE]], [

	            // BlackBerry
	            /(playbook);[-\w\),; ]+(rim)/i                                      // BlackBerry PlayBook
	            ], [MODEL, VENDOR, [TYPE, TABLET]], [
	            /\b((?:bb[a-f]|st[hv])100-\d)/i,
	            /\(bb10; (\w+)/i                                                    // BlackBerry 10
	            ], [MODEL, [VENDOR, BLACKBERRY], [TYPE, MOBILE]], [

	            // Asus
	            /(?:\b|asus_)(transfo[prime ]{4,10} \w+|eeepc|slider \w+|nexus 7|padfone|p00[cj])/i
	            ], [MODEL, [VENDOR, ASUS], [TYPE, TABLET]], [
	            / (z[bes]6[027][012][km][ls]|zenfone \d\w?)\b/i
	            ], [MODEL, [VENDOR, ASUS], [TYPE, MOBILE]], [

	            // HTC
	            /(nexus 9)/i                                                        // HTC Nexus 9
	            ], [MODEL, [VENDOR, 'HTC'], [TYPE, TABLET]], [
	            /(htc)[-;_ ]{1,2}([\w ]+(?=\)| bui)|\w+)/i,                         // HTC

	            // ZTE
	            /(zte)[- ]([\w ]+?)(?: bui|\/|\))/i,
	            /(alcatel|geeksphone|nexian|panasonic(?!(?:;|\.))|sony(?!-bra))[-_ ]?([-\w]*)/i         // Alcatel/GeeksPhone/Nexian/Panasonic/Sony
	            ], [VENDOR, [MODEL, /_/g, ' '], [TYPE, MOBILE]], [

	            // Acer
	            /droid.+; ([ab][1-7]-?[0178a]\d\d?)/i
	            ], [MODEL, [VENDOR, 'Acer'], [TYPE, TABLET]], [

	            // Meizu
	            /droid.+; (m[1-5] note) bui/i,
	            /\bmz-([-\w]{2,})/i
	            ], [MODEL, [VENDOR, 'Meizu'], [TYPE, MOBILE]], [
	                
	            // Ulefone
	            /; ((?:power )?armor(?:[\w ]{0,8}))(?: bui|\))/i
	            ], [MODEL, [VENDOR, 'Ulefone'], [TYPE, MOBILE]], [

	            // MIXED
	            /(blackberry|benq|palm(?=\-)|sonyericsson|acer|asus|dell|meizu|motorola|polytron|infinix|tecno)[-_ ]?([-\w]*)/i,
	                                                                                // BlackBerry/BenQ/Palm/Sony-Ericsson/Acer/Asus/Dell/Meizu/Motorola/Polytron
	            /(hp) ([\w ]+\w)/i,                                                 // HP iPAQ
	            /(asus)-?(\w+)/i,                                                   // Asus
	            /(microsoft); (lumia[\w ]+)/i,                                      // Microsoft Lumia
	            /(lenovo)[-_ ]?([-\w]+)/i,                                          // Lenovo
	            /(jolla)/i,                                                         // Jolla
	            /(oppo) ?([\w ]+) bui/i                                             // OPPO
	            ], [VENDOR, MODEL, [TYPE, MOBILE]], [

	            /(kobo)\s(ereader|touch)/i,                                         // Kobo
	            /(archos) (gamepad2?)/i,                                            // Archos
	            /(hp).+(touchpad(?!.+tablet)|tablet)/i,                             // HP TouchPad
	            /(kindle)\/([\w\.]+)/i,                                             // Kindle
	            /(nook)[\w ]+build\/(\w+)/i,                                        // Nook
	            /(dell) (strea[kpr\d ]*[\dko])/i,                                   // Dell Streak
	            /(le[- ]+pan)[- ]+(\w{1,9}) bui/i,                                  // Le Pan Tablets
	            /(trinity)[- ]*(t\d{3}) bui/i,                                      // Trinity Tablets
	            /(gigaset)[- ]+(q\w{1,9}) bui/i,                                    // Gigaset Tablets
	            /(vodafone) ([\w ]+)(?:\)| bui)/i                                   // Vodafone
	            ], [VENDOR, MODEL, [TYPE, TABLET]], [

	            /(surface duo)/i                                                    // Surface Duo
	            ], [MODEL, [VENDOR, MICROSOFT], [TYPE, TABLET]], [
	            /droid [\d\.]+; (fp\du?)(?: b|\))/i                                 // Fairphone
	            ], [MODEL, [VENDOR, 'Fairphone'], [TYPE, MOBILE]], [
	            /(u304aa)/i                                                         // AT&T
	            ], [MODEL, [VENDOR, 'AT&T'], [TYPE, MOBILE]], [
	            /\bsie-(\w*)/i                                                      // Siemens
	            ], [MODEL, [VENDOR, 'Siemens'], [TYPE, MOBILE]], [
	            /\b(rct\w+) b/i                                                     // RCA Tablets
	            ], [MODEL, [VENDOR, 'RCA'], [TYPE, TABLET]], [
	            /\b(venue[\d ]{2,7}) b/i                                            // Dell Venue Tablets
	            ], [MODEL, [VENDOR, 'Dell'], [TYPE, TABLET]], [
	            /\b(q(?:mv|ta)\w+) b/i                                              // Verizon Tablet
	            ], [MODEL, [VENDOR, 'Verizon'], [TYPE, TABLET]], [
	            /\b(?:barnes[& ]+noble |bn[rt])([\w\+ ]*) b/i                       // Barnes & Noble Tablet
	            ], [MODEL, [VENDOR, 'Barnes & Noble'], [TYPE, TABLET]], [
	            /\b(tm\d{3}\w+) b/i
	            ], [MODEL, [VENDOR, 'NuVision'], [TYPE, TABLET]], [
	            /\b(k88) b/i                                                        // ZTE K Series Tablet
	            ], [MODEL, [VENDOR, 'ZTE'], [TYPE, TABLET]], [
	            /\b(nx\d{3}j) b/i                                                   // ZTE Nubia
	            ], [MODEL, [VENDOR, 'ZTE'], [TYPE, MOBILE]], [
	            /\b(gen\d{3}) b.+49h/i                                              // Swiss GEN Mobile
	            ], [MODEL, [VENDOR, 'Swiss'], [TYPE, MOBILE]], [
	            /\b(zur\d{3}) b/i                                                   // Swiss ZUR Tablet
	            ], [MODEL, [VENDOR, 'Swiss'], [TYPE, TABLET]], [
	            /\b((zeki)?tb.*\b) b/i                                              // Zeki Tablets
	            ], [MODEL, [VENDOR, 'Zeki'], [TYPE, TABLET]], [
	            /\b([yr]\d{2}) b/i,
	            /\b(dragon[- ]+touch |dt)(\w{5}) b/i                                // Dragon Touch Tablet
	            ], [[VENDOR, 'Dragon Touch'], MODEL, [TYPE, TABLET]], [
	            /\b(ns-?\w{0,9}) b/i                                                // Insignia Tablets
	            ], [MODEL, [VENDOR, 'Insignia'], [TYPE, TABLET]], [
	            /\b((nxa|next)-?\w{0,9}) b/i                                        // NextBook Tablets
	            ], [MODEL, [VENDOR, 'NextBook'], [TYPE, TABLET]], [
	            /\b(xtreme\_)?(v(1[045]|2[015]|[3469]0|7[05])) b/i                  // Voice Xtreme Phones
	            ], [[VENDOR, 'Voice'], MODEL, [TYPE, MOBILE]], [
	            /\b(lvtel\-)?(v1[12]) b/i                                           // LvTel Phones
	            ], [[VENDOR, 'LvTel'], MODEL, [TYPE, MOBILE]], [
	            /\b(ph-1) /i                                                        // Essential PH-1
	            ], [MODEL, [VENDOR, 'Essential'], [TYPE, MOBILE]], [
	            /\b(v(100md|700na|7011|917g).*\b) b/i                               // Envizen Tablets
	            ], [MODEL, [VENDOR, 'Envizen'], [TYPE, TABLET]], [
	            /\b(trio[-\w\. ]+) b/i                                              // MachSpeed Tablets
	            ], [MODEL, [VENDOR, 'MachSpeed'], [TYPE, TABLET]], [
	            /\btu_(1491) b/i                                                    // Rotor Tablets
	            ], [MODEL, [VENDOR, 'Rotor'], [TYPE, TABLET]], [
	            /(shield[\w ]+) b/i                                                 // Nvidia Shield Tablets
	            ], [MODEL, [VENDOR, 'Nvidia'], [TYPE, TABLET]], [
	            /(sprint) (\w+)/i                                                   // Sprint Phones
	            ], [VENDOR, MODEL, [TYPE, MOBILE]], [
	            /(kin\.[onetw]{3})/i                                                // Microsoft Kin
	            ], [[MODEL, /\./g, ' '], [VENDOR, MICROSOFT], [TYPE, MOBILE]], [
	            /droid.+; (cc6666?|et5[16]|mc[239][23]x?|vc8[03]x?)\)/i             // Zebra
	            ], [MODEL, [VENDOR, ZEBRA], [TYPE, TABLET]], [
	            /droid.+; (ec30|ps20|tc[2-8]\d[kx])\)/i
	            ], [MODEL, [VENDOR, ZEBRA], [TYPE, MOBILE]], [

	            ///////////////////
	            // SMARTTVS
	            ///////////////////

	            /smart-tv.+(samsung)/i                                              // Samsung
	            ], [VENDOR, [TYPE, SMARTTV]], [
	            /hbbtv.+maple;(\d+)/i
	            ], [[MODEL, /^/, 'SmartTV'], [VENDOR, SAMSUNG], [TYPE, SMARTTV]], [
	            /(nux; netcast.+smarttv|lg (netcast\.tv-201\d|android tv))/i        // LG SmartTV
	            ], [[VENDOR, LG], [TYPE, SMARTTV]], [
	            /(apple) ?tv/i                                                      // Apple TV
	            ], [VENDOR, [MODEL, APPLE+' TV'], [TYPE, SMARTTV]], [
	            /crkey/i                                                            // Google Chromecast
	            ], [[MODEL, CHROME+'cast'], [VENDOR, GOOGLE], [TYPE, SMARTTV]], [
	            /droid.+aft(\w+)( bui|\))/i                                         // Fire TV
	            ], [MODEL, [VENDOR, AMAZON], [TYPE, SMARTTV]], [
	            /\(dtv[\);].+(aquos)/i,
	            /(aquos-tv[\w ]+)\)/i                                               // Sharp
	            ], [MODEL, [VENDOR, SHARP], [TYPE, SMARTTV]],[
	            /(bravia[\w ]+)( bui|\))/i                                              // Sony
	            ], [MODEL, [VENDOR, SONY], [TYPE, SMARTTV]], [
	            /(mitv-\w{5}) bui/i                                                 // Xiaomi
	            ], [MODEL, [VENDOR, XIAOMI], [TYPE, SMARTTV]], [
	            /Hbbtv.*(technisat) (.*);/i                                         // TechniSAT
	            ], [VENDOR, MODEL, [TYPE, SMARTTV]], [
	            /\b(roku)[\dx]*[\)\/]((?:dvp-)?[\d\.]*)/i,                          // Roku
	            /hbbtv\/\d+\.\d+\.\d+ +\([\w\+ ]*; *([\w\d][^;]*);([^;]*)/i         // HbbTV devices
	            ], [[VENDOR, trim], [MODEL, trim], [TYPE, SMARTTV]], [
	            /\b(android tv|smart[- ]?tv|opera tv|tv; rv:)\b/i                   // SmartTV from Unidentified Vendors
	            ], [[TYPE, SMARTTV]], [

	            ///////////////////
	            // CONSOLES
	            ///////////////////

	            /(ouya)/i,                                                          // Ouya
	            /(nintendo) ([wids3utch]+)/i                                        // Nintendo
	            ], [VENDOR, MODEL, [TYPE, CONSOLE]], [
	            /droid.+; (shield) bui/i                                            // Nvidia
	            ], [MODEL, [VENDOR, 'Nvidia'], [TYPE, CONSOLE]], [
	            /(playstation [345portablevi]+)/i                                   // Playstation
	            ], [MODEL, [VENDOR, SONY], [TYPE, CONSOLE]], [
	            /\b(xbox(?: one)?(?!; xbox))[\); ]/i                                // Microsoft Xbox
	            ], [MODEL, [VENDOR, MICROSOFT], [TYPE, CONSOLE]], [

	            ///////////////////
	            // WEARABLES
	            ///////////////////

	            /((pebble))app/i                                                    // Pebble
	            ], [VENDOR, MODEL, [TYPE, WEARABLE]], [
	            /(watch)(?: ?os[,\/]|\d,\d\/)[\d\.]+/i                              // Apple Watch
	            ], [MODEL, [VENDOR, APPLE], [TYPE, WEARABLE]], [
	            /droid.+; (glass) \d/i                                              // Google Glass
	            ], [MODEL, [VENDOR, GOOGLE], [TYPE, WEARABLE]], [
	            /droid.+; (wt63?0{2,3})\)/i
	            ], [MODEL, [VENDOR, ZEBRA], [TYPE, WEARABLE]], [
	            /(quest( \d| pro)?)/i                                               // Oculus Quest
	            ], [MODEL, [VENDOR, FACEBOOK], [TYPE, WEARABLE]], [

	            ///////////////////
	            // EMBEDDED
	            ///////////////////

	            /(tesla)(?: qtcarbrowser|\/[-\w\.]+)/i                              // Tesla
	            ], [VENDOR, [TYPE, EMBEDDED]], [
	            /(aeobc)\b/i                                                        // Echo Dot
	            ], [MODEL, [VENDOR, AMAZON], [TYPE, EMBEDDED]], [

	            ////////////////////
	            // MIXED (GENERIC)
	            ///////////////////

	            /droid .+?; ([^;]+?)(?: bui|; wv\)|\) applew).+? mobile safari/i    // Android Phones from Unidentified Vendors
	            ], [MODEL, [TYPE, MOBILE]], [
	            /droid .+?; ([^;]+?)(?: bui|\) applew).+?(?! mobile) safari/i       // Android Tablets from Unidentified Vendors
	            ], [MODEL, [TYPE, TABLET]], [
	            /\b((tablet|tab)[;\/]|focus\/\d(?!.+mobile))/i                      // Unidentifiable Tablet
	            ], [[TYPE, TABLET]], [
	            /(phone|mobile(?:[;\/]| [ \w\/\.]*safari)|pda(?=.+windows ce))/i    // Unidentifiable Mobile
	            ], [[TYPE, MOBILE]], [
	            /(android[-\w\. ]{0,9});.+buil/i                                    // Generic Android Device
	            ], [MODEL, [VENDOR, 'Generic']]
	        ],

	        engine : [[

	            /windows.+ edge\/([\w\.]+)/i                                       // EdgeHTML
	            ], [VERSION, [NAME, EDGE+'HTML']], [

	            /webkit\/537\.36.+chrome\/(?!27)([\w\.]+)/i                         // Blink
	            ], [VERSION, [NAME, 'Blink']], [

	            /(presto)\/([\w\.]+)/i,                                             // Presto
	            /(webkit|trident|netfront|netsurf|amaya|lynx|w3m|goanna)\/([\w\.]+)/i, // WebKit/Trident/NetFront/NetSurf/Amaya/Lynx/w3m/Goanna
	            /ekioh(flow)\/([\w\.]+)/i,                                          // Flow
	            /(khtml|tasman|links)[\/ ]\(?([\w\.]+)/i,                           // KHTML/Tasman/Links
	            /(icab)[\/ ]([23]\.[\d\.]+)/i,                                      // iCab
	            /\b(libweb)/i
	            ], [NAME, VERSION], [

	            /rv\:([\w\.]{1,9})\b.+(gecko)/i                                     // Gecko
	            ], [VERSION, NAME]
	        ],

	        os : [[

	            // Windows
	            /microsoft (windows) (vista|xp)/i                                   // Windows (iTunes)
	            ], [NAME, VERSION], [
	            /(windows (?:phone(?: os)?|mobile))[\/ ]?([\d\.\w ]*)/i             // Windows Phone
	            ], [NAME, [VERSION, strMapper, windowsVersionMap]], [
	            /windows nt 6\.2; (arm)/i,                                        // Windows RT
	            /windows[\/ ]?([ntce\d\. ]+\w)(?!.+xbox)/i,
	            /(?:win(?=3|9|n)|win 9x )([nt\d\.]+)/i
	            ], [[VERSION, strMapper, windowsVersionMap], [NAME, 'Windows']], [

	            // iOS/macOS
	            /ip[honead]{2,4}\b(?:.*os ([\w]+) like mac|; opera)/i,              // iOS
	            /(?:ios;fbsv\/|iphone.+ios[\/ ])([\d\.]+)/i,
	            /cfnetwork\/.+darwin/i
	            ], [[VERSION, /_/g, '.'], [NAME, 'iOS']], [
	            /(mac os x) ?([\w\. ]*)/i,
	            /(macintosh|mac_powerpc\b)(?!.+haiku)/i                             // Mac OS
	            ], [[NAME, MAC_OS], [VERSION, /_/g, '.']], [

	            // Mobile OSes
	            /droid ([\w\.]+)\b.+(android[- ]x86|harmonyos)/i                    // Android-x86/HarmonyOS
	            ], [VERSION, NAME], [                                               // Android/WebOS/QNX/Bada/RIM/Maemo/MeeGo/Sailfish OS
	            /(android|webos|qnx|bada|rim tablet os|maemo|meego|sailfish)[-\/ ]?([\w\.]*)/i,
	            /(blackberry)\w*\/([\w\.]*)/i,                                      // Blackberry
	            /(tizen|kaios)[\/ ]([\w\.]+)/i,                                     // Tizen/KaiOS
	            /\((series40);/i                                                    // Series 40
	            ], [NAME, VERSION], [
	            /\(bb(10);/i                                                        // BlackBerry 10
	            ], [VERSION, [NAME, BLACKBERRY]], [
	            /(?:symbian ?os|symbos|s60(?=;)|series60)[-\/ ]?([\w\.]*)/i         // Symbian
	            ], [VERSION, [NAME, 'Symbian']], [
	            /mozilla\/[\d\.]+ \((?:mobile|tablet|tv|mobile; [\w ]+); rv:.+ gecko\/([\w\.]+)/i // Firefox OS
	            ], [VERSION, [NAME, FIREFOX+' OS']], [
	            /web0s;.+rt(tv)/i,
	            /\b(?:hp)?wos(?:browser)?\/([\w\.]+)/i                              // WebOS
	            ], [VERSION, [NAME, 'webOS']], [
	            /watch(?: ?os[,\/]|\d,\d\/)([\d\.]+)/i                              // watchOS
	            ], [VERSION, [NAME, 'watchOS']], [

	            // Google Chromecast
	            /crkey\/([\d\.]+)/i                                                 // Google Chromecast
	            ], [VERSION, [NAME, CHROME+'cast']], [
	            /(cros) [\w]+(?:\)| ([\w\.]+)\b)/i                                  // Chromium OS
	            ], [[NAME, CHROMIUM_OS], VERSION],[

	            // Smart TVs
	            /panasonic;(viera)/i,                                               // Panasonic Viera
	            /(netrange)mmh/i,                                                   // Netrange
	            /(nettv)\/(\d+\.[\w\.]+)/i,                                         // NetTV

	            // Console
	            /(nintendo|playstation) ([wids345portablevuch]+)/i,                 // Nintendo/Playstation
	            /(xbox); +xbox ([^\);]+)/i,                                         // Microsoft Xbox (360, One, X, S, Series X, Series S)

	            // Other
	            /\b(joli|palm)\b ?(?:os)?\/?([\w\.]*)/i,                            // Joli/Palm
	            /(mint)[\/\(\) ]?(\w*)/i,                                           // Mint
	            /(mageia|vectorlinux)[; ]/i,                                        // Mageia/VectorLinux
	            /([kxln]?ubuntu|debian|suse|opensuse|gentoo|arch(?= linux)|slackware|fedora|mandriva|centos|pclinuxos|red ?hat|zenwalk|linpus|raspbian|plan 9|minix|risc os|contiki|deepin|manjaro|elementary os|sabayon|linspire)(?: gnu\/linux)?(?: enterprise)?(?:[- ]linux)?(?:-gnu)?[-\/ ]?(?!chrom|package)([-\w\.]*)/i,
	                                                                                // Ubuntu/Debian/SUSE/Gentoo/Arch/Slackware/Fedora/Mandriva/CentOS/PCLinuxOS/RedHat/Zenwalk/Linpus/Raspbian/Plan9/Minix/RISCOS/Contiki/Deepin/Manjaro/elementary/Sabayon/Linspire
	            /(hurd|linux) ?([\w\.]*)/i,                                         // Hurd/Linux
	            /(gnu) ?([\w\.]*)/i,                                                // GNU
	            /\b([-frentopcghs]{0,5}bsd|dragonfly)[\/ ]?(?!amd|[ix346]{1,2}86)([\w\.]*)/i, // FreeBSD/NetBSD/OpenBSD/PC-BSD/GhostBSD/DragonFly
	            /(haiku) (\w+)/i                                                    // Haiku
	            ], [NAME, VERSION], [
	            /(sunos) ?([\w\.\d]*)/i                                             // Solaris
	            ], [[NAME, 'Solaris'], VERSION], [
	            /((?:open)?solaris)[-\/ ]?([\w\.]*)/i,                              // Solaris
	            /(aix) ((\d)(?=\.|\)| )[\w\.])*/i,                                  // AIX
	            /\b(beos|os\/2|amigaos|morphos|openvms|fuchsia|hp-ux|serenityos)/i, // BeOS/OS2/AmigaOS/MorphOS/OpenVMS/Fuchsia/HP-UX/SerenityOS
	            /(unix) ?([\w\.]*)/i                                                // UNIX
	            ], [NAME, VERSION]
	        ]
	    };

	    /////////////////
	    // Constructor
	    ////////////////

	    var UAParser = function (ua, extensions) {

	        if (typeof ua === OBJ_TYPE) {
	            extensions = ua;
	            ua = undefined$1;
	        }

	        if (!(this instanceof UAParser)) {
	            return new UAParser(ua, extensions).getResult();
	        }

	        var _navigator = (typeof window !== UNDEF_TYPE && window.navigator) ? window.navigator : undefined$1;
	        var _ua = ua || ((_navigator && _navigator.userAgent) ? _navigator.userAgent : EMPTY);
	        var _uach = (_navigator && _navigator.userAgentData) ? _navigator.userAgentData : undefined$1;
	        var _rgxmap = extensions ? extend(regexes, extensions) : regexes;
	        var _isSelfNav = _navigator && _navigator.userAgent == _ua;

	        this.getBrowser = function () {
	            var _browser = {};
	            _browser[NAME] = undefined$1;
	            _browser[VERSION] = undefined$1;
	            rgxMapper.call(_browser, _ua, _rgxmap.browser);
	            _browser[MAJOR] = majorize(_browser[VERSION]);
	            // Brave-specific detection
	            if (_isSelfNav && _navigator && _navigator.brave && typeof _navigator.brave.isBrave == FUNC_TYPE) {
	                _browser[NAME] = 'Brave';
	            }
	            return _browser;
	        };
	        this.getCPU = function () {
	            var _cpu = {};
	            _cpu[ARCHITECTURE] = undefined$1;
	            rgxMapper.call(_cpu, _ua, _rgxmap.cpu);
	            return _cpu;
	        };
	        this.getDevice = function () {
	            var _device = {};
	            _device[VENDOR] = undefined$1;
	            _device[MODEL] = undefined$1;
	            _device[TYPE] = undefined$1;
	            rgxMapper.call(_device, _ua, _rgxmap.device);
	            if (_isSelfNav && !_device[TYPE] && _uach && _uach.mobile) {
	                _device[TYPE] = MOBILE;
	            }
	            // iPadOS-specific detection: identified as Mac, but has some iOS-only properties
	            if (_isSelfNav && _device[MODEL] == 'Macintosh' && _navigator && typeof _navigator.standalone !== UNDEF_TYPE && _navigator.maxTouchPoints && _navigator.maxTouchPoints > 2) {
	                _device[MODEL] = 'iPad';
	                _device[TYPE] = TABLET;
	            }
	            return _device;
	        };
	        this.getEngine = function () {
	            var _engine = {};
	            _engine[NAME] = undefined$1;
	            _engine[VERSION] = undefined$1;
	            rgxMapper.call(_engine, _ua, _rgxmap.engine);
	            return _engine;
	        };
	        this.getOS = function () {
	            var _os = {};
	            _os[NAME] = undefined$1;
	            _os[VERSION] = undefined$1;
	            rgxMapper.call(_os, _ua, _rgxmap.os);
	            if (_isSelfNav && !_os[NAME] && _uach && _uach.platform && _uach.platform != 'Unknown') {
	                _os[NAME] = _uach.platform  
	                                    .replace(/chrome os/i, CHROMIUM_OS)
	                                    .replace(/macos/i, MAC_OS);           // backward compatibility
	            }
	            return _os;
	        };
	        this.getResult = function () {
	            return {
	                ua      : this.getUA(),
	                browser : this.getBrowser(),
	                engine  : this.getEngine(),
	                os      : this.getOS(),
	                device  : this.getDevice(),
	                cpu     : this.getCPU()
	            };
	        };
	        this.getUA = function () {
	            return _ua;
	        };
	        this.setUA = function (ua) {
	            _ua = (typeof ua === STR_TYPE && ua.length > UA_MAX_LENGTH) ? trim(ua, UA_MAX_LENGTH) : ua;
	            return this;
	        };
	        this.setUA(_ua);
	        return this;
	    };

	    UAParser.VERSION = LIBVERSION;
	    UAParser.BROWSER =  enumerize([NAME, VERSION, MAJOR]);
	    UAParser.CPU = enumerize([ARCHITECTURE]);
	    UAParser.DEVICE = enumerize([MODEL, VENDOR, TYPE, CONSOLE, MOBILE, SMARTTV, TABLET, WEARABLE, EMBEDDED]);
	    UAParser.ENGINE = UAParser.OS = enumerize([NAME, VERSION]);

	    ///////////
	    // Export
	    //////////

	    // check js environment
	    {
	        // nodejs env
	        if (module.exports) {
	            exports = module.exports = UAParser;
	        }
	        exports.UAParser = UAParser;
	    }

	    // jQuery/Zepto specific (optional)
	    // Note:
	    //   In AMD env the global scope should be kept clean, but jQuery is an exception.
	    //   jQuery always exports to global scope, unless jQuery.noConflict(true) is used,
	    //   and we should catch that.
	    var $ = typeof window !== UNDEF_TYPE && (window.jQuery || window.Zepto);
	    if ($ && !$.ua) {
	        var parser = new UAParser();
	        $.ua = parser.getResult();
	        $.ua.get = function () {
	            return parser.getUA();
	        };
	        $.ua.set = function (ua) {
	            parser.setUA(ua);
	            var result = parser.getResult();
	            for (var prop in result) {
	                $.ua[prop] = result[prop];
	            }
	        };
	    }

	})(typeof window === 'object' ? window : commonjsGlobal); 
} (uaParser, uaParser.exports));

/* unplugin-vue-components disabled */

/* unplugin-vue-components disabled */

const i18n = createI18n({
    legacy: false,
    locale: DEFAULT_LOCALE,
    fallbackLocale: DEFAULT_LOCALE,
    messages
});

var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var Log = (function () {
    function Log(options) {
        var _a = options.debug, debug = _a === void 0 ? false : _a;
        this.debug = debug;
        this.lines = [];
    }
    Log.prototype.emit = function (level, message) {
        if (level in console) {
            var prefix = Log.prefix;
            console[level].apply(console, __spreadArray([prefix], message, false));
        }
    };
    Log.prototype.tailLogs = function () {
        var _this = this;
        this.lines.forEach(function (_a) {
            var level = _a[0], message = _a[1];
            return _this.emit(level, message);
        });
    };
    Log.prototype.getLogs = function () {
        return this.lines;
    };
    Log.prototype.write = function (level, message) {
        var buffer = Log.buffer;
        this.lines = __spreadArray(__spreadArray([], this.lines.slice(1 - buffer), true), [[level, message]], false);
        if (this.debug || level !== 'log') {
            this.emit(level, message);
        }
    };
    Log.prototype.info = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.write('log', message);
    };
    Log.prototype.warn = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.write('warn', message);
    };
    Log.prototype.error = function () {
        var message = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            message[_i] = arguments[_i];
        }
        this.write('error', message);
    };
    Log.buffer = 30;
    Log.prefix = '[apollo-cache-persist]';
    return Log;
}());

var Cache = (function () {
    function Cache(options) {
        var cache = options.cache, _a = options.serialize, serialize = _a === void 0 ? true : _a;
        this.cache = cache;
        this.serialize = serialize;
    }
    Cache.prototype.extract = function () {
        var data = this.cache.extract();
        if (this.serialize) {
            data = JSON.stringify(data);
        }
        return data;
    };
    Cache.prototype.restore = function (data) {
        if (this.serialize && typeof data === 'string') {
            data = JSON.parse(data);
        }
        if (data != null) {
            this.cache.restore(data);
        }
    };
    return Cache;
}());

var __awaiter$1 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$1 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Storage = (function () {
    function Storage(options) {
        var storage = options.storage, _a = options.key, key = _a === void 0 ? 'apollo-cache-persist' : _a;
        this.storage = storage;
        this.key = key;
    }
    Storage.prototype.read = function () {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                return [2, this.storage.getItem(this.key)];
            });
        });
    };
    Storage.prototype.write = function (data) {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.storage.setItem(this.key, data)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Storage.prototype.purge = function () {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.storage.removeItem(this.key)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Storage.prototype.getSize = function () {
        return __awaiter$1(this, void 0, void 0, function () {
            var data;
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.storage.getItem(this.key)];
                    case 1:
                        data = _a.sent();
                        if (data == null) {
                            return [2, 0];
                        }
                        else {
                            return [2, typeof data === 'string' ? data.length : null];
                        }
                }
            });
        });
    };
    return Storage;
}());

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Persistor = (function () {
    function Persistor(_a, options) {
        var log = _a.log, cache = _a.cache, storage = _a.storage;
        var _b = options.maxSize, maxSize = _b === void 0 ? 1024 * 1024 : _b, persistenceMapper = options.persistenceMapper;
        this.log = log;
        this.cache = cache;
        this.storage = storage;
        this.paused = false;
        if (persistenceMapper) {
            this.persistenceMapper = persistenceMapper;
        }
        if (maxSize) {
            this.maxSize = maxSize;
        }
    }
    Persistor.prototype.persist = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 6, , 7]);
                        data = this.cache.extract();
                        if (!(!this.paused && this.persistenceMapper)) return [3, 2];
                        return [4, this.persistenceMapper(data)];
                    case 1:
                        data = _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!(this.maxSize != null &&
                            typeof data === 'string' &&
                            data.length > this.maxSize &&
                            !this.paused)) return [3, 4];
                        return [4, this.purge()];
                    case 3:
                        _a.sent();
                        this.paused = true;
                        return [2];
                    case 4:
                        if (this.paused) {
                            return [2];
                        }
                        return [4, this.storage.write(data)];
                    case 5:
                        _a.sent();
                        this.log.info(typeof data === 'string'
                            ? "Persisted cache of size ".concat(data.length, " characters")
                            : 'Persisted cache');
                        return [3, 7];
                    case 6:
                        error_1 = _a.sent();
                        this.log.error('Error persisting cache', error_1);
                        throw error_1;
                    case 7: return [2];
                }
            });
        });
    };
    Persistor.prototype.restore = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4, this.storage.read()];
                    case 1:
                        data = _a.sent();
                        if (!(data != null)) return [3, 3];
                        return [4, this.cache.restore(data)];
                    case 2:
                        _a.sent();
                        this.log.info(typeof data === 'string'
                            ? "Restored cache of size ".concat(data.length, " characters")
                            : 'Restored cache');
                        return [3, 4];
                    case 3:
                        this.log.info('No stored cache to restore');
                        _a.label = 4;
                    case 4: return [3, 6];
                    case 5:
                        error_2 = _a.sent();
                        this.log.error('Error restoring cache', error_2);
                        throw error_2;
                    case 6: return [2];
                }
            });
        });
    };
    Persistor.prototype.purge = function () {
        return __awaiter(this, void 0, void 0, function () {
            var error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.storage.purge()];
                    case 1:
                        _a.sent();
                        this.log.info('Purged cache storage');
                        return [3, 3];
                    case 2:
                        error_3 = _a.sent();
                        this.log.error('Error purging cache storage', error_3);
                        throw error_3;
                    case 3: return [2];
                }
            });
        });
    };
    return Persistor;
}());

const onCacheWrite = (function (_a) {
    var cache = _a.cache;
    return function (persist) {
        var write = cache.write;
        var evict = cache.evict;
        var modify = cache.modify;
        var gc = cache.gc;
        cache.write = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = write.apply(cache, args);
            persist();
            return result;
        };
        cache.evict = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = evict.apply(cache, args);
            persist();
            return result;
        };
        cache.modify = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = modify.apply(cache, args);
            persist();
            return result;
        };
        cache.gc = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = gc.apply(cache, args);
            persist();
            return result;
        };
        return function () {
            cache.write = write;
            cache.evict = evict;
            cache.modify = modify;
            cache.gc = gc;
        };
    };
});

const onAppBackground = (function (_a) {
    var log = _a.log, cache = _a.cache;
    return function (persist) {
        log.warn('Trigger option `background` not available on web; using `write` trigger');
        return onCacheWrite({ cache: cache })(persist);
    };
});

var Trigger = (function () {
    function Trigger(_a, options) {
        var log = _a.log, persistor = _a.persistor;
        var _this = this;
        this.fire = function () {
            if (!_this.debounce) {
                _this.persist();
                return;
            }
            if (_this.timeout != null) {
                clearTimeout(_this.timeout);
            }
            _this.timeout = setTimeout(_this.persist, _this.debounce);
        };
        this.persist = function () {
            if (_this.paused) {
                return;
            }
            _this.persistor.persist();
        };
        var defaultDebounce = Trigger.defaultDebounce;
        var cache = options.cache, debounce = options.debounce, _b = options.trigger, trigger = _b === void 0 ? 'write' : _b;
        if (!trigger) {
            return;
        }
        this.debounce = debounce != null ? debounce : defaultDebounce;
        this.persistor = persistor;
        this.paused = false;
        switch (trigger) {
            case 'write':
                this.uninstall = onCacheWrite({ cache: cache })(this.fire);
                break;
            case 'background':
                if (debounce) {
                    log.warn('Debounce is not recommended with `background` trigger');
                }
                this.debounce = debounce;
                this.uninstall = onAppBackground({ cache: cache, log: log })(this.fire);
                break;
            default:
                if (typeof trigger === 'function') {
                    this.uninstall = trigger(this.fire);
                }
                else {
                    throw Error("Unrecognized trigger option: ".concat(trigger));
                }
        }
    }
    Trigger.prototype.pause = function () {
        this.paused = true;
    };
    Trigger.prototype.resume = function () {
        this.paused = false;
    };
    Trigger.prototype.remove = function () {
        if (this.uninstall) {
            this.uninstall();
            this.uninstall = null;
            this.paused = true;
        }
    };
    Trigger.defaultDebounce = 1000;
    return Trigger;
}());

var CachePersistor = (function () {
    function CachePersistor(options) {
        if (!options.cache) {
            throw new Error('In order to persist your Apollo Cache, you need to pass in a cache. ' +
                'Please see https://www.apollographql.com/docs/react/basics/caching.html for our default InMemoryCache.');
        }
        if (!options.storage) {
            throw new Error('In order to persist your Apollo Cache, you need to pass in an underlying storage provider. ' +
                'Please see https://github.com/apollographql/apollo-cache-persist#storage-providers');
        }
        var log = new Log(options);
        var cache = new Cache(options);
        var storage = new Storage(options);
        var persistor = new Persistor({ log: log, cache: cache, storage: storage }, options);
        var trigger = new Trigger({ log: log, persistor: persistor }, options);
        this.log = log;
        this.cache = cache;
        this.storage = storage;
        this.persistor = persistor;
        this.trigger = trigger;
    }
    CachePersistor.prototype.persist = function () {
        return this.persistor.persist();
    };
    CachePersistor.prototype.restore = function () {
        return this.persistor.restore();
    };
    CachePersistor.prototype.purge = function () {
        return this.persistor.purge();
    };
    CachePersistor.prototype.pause = function () {
        this.trigger.pause();
    };
    CachePersistor.prototype.resume = function () {
        this.trigger.resume();
    };
    CachePersistor.prototype.remove = function () {
        this.trigger.remove();
    };
    CachePersistor.prototype.getLogs = function (print) {
        if (print === void 0) { print = false; }
        if (print) {
            this.log.tailLogs();
        }
        else {
            return this.log.getLogs();
        }
    };
    CachePersistor.prototype.getSize = function () {
        return this.storage.getSize();
    };
    return CachePersistor;
}());

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var persistCacheSync = function (options) {
    var cachePersistor = new SynchronousCachePersistor(options);
    cachePersistor.restoreSync();
};
var SynchronousCachePersistor = (function (_super) {
    __extends(SynchronousCachePersistor, _super);
    function SynchronousCachePersistor(options) {
        var _this = _super.call(this, options) || this;
        _this.storage = new SynchronousStorage(options);
        _this.persistor = new SynchronousPersistor({ log: _this.log, cache: _this.cache, storage: _this.storage }, options);
        return _this;
    }
    SynchronousCachePersistor.prototype.restoreSync = function () {
        this.persistor.restoreSync();
    };
    return SynchronousCachePersistor;
}(CachePersistor));
var SynchronousPersistor = (function (_super) {
    __extends(SynchronousPersistor, _super);
    function SynchronousPersistor(_a, options) {
        var log = _a.log, cache = _a.cache, storage = _a.storage;
        return _super.call(this, { log: log, cache: cache, storage: storage }, options) || this;
    }
    SynchronousPersistor.prototype.restoreSync = function () {
        this.cache.restore(this.storage.readSync());
    };
    return SynchronousPersistor;
}(Persistor));
var SynchronousStorage = (function (_super) {
    __extends(SynchronousStorage, _super);
    function SynchronousStorage(options) {
        return _super.call(this, options) || this;
    }
    SynchronousStorage.prototype.readSync = function () {
        return this.storage.getItem(this.key);
    };
    return SynchronousStorage;
}(Storage));

var LocalStorageWrapper = (function () {
    function LocalStorageWrapper(storage) {
        this.storage = storage;
    }
    LocalStorageWrapper.prototype.getItem = function (key) {
        return this.storage.getItem(key);
    };
    LocalStorageWrapper.prototype.removeItem = function (key) {
        return this.storage.removeItem(key);
    };
    LocalStorageWrapper.prototype.setItem = function (key, value) {
        if (value !== null) {
            return this.storage.setItem(key, value);
        }
        else {
            return this.removeItem(key);
        }
    };
    return LocalStorageWrapper;
}());

export { LoggerService as L, RemoteUploaderService as R, LocalStorageWrapper as a, i18n as i, persistCacheSync as p };
