import { av as __extends$1, e as Subject$1, aw as innerFrom$1, ax as Observable$1, ay as createOperatorSubscriber$1, az as share, aA as isSymbol, ae as isObject$1, aB as getNative, ai as root, aC as overArg, aD as isPrototype, ah as isArrayLike$1, aE as arrayLikeKeys, a9 as isArray$2, aF as MapCache, aG as toString, aH as toSource, aI as Map$1, aJ as baseGetTag, a8 as Symbol$1, aK as eq, aL as Uint8Array$1, af as isBuffer, ag as Stack, aM as isTypedArray, ab as isObjectLike$2, aN as isLength, ak as isIndex, aa as isArguments, aO as identity$1, aP as __vitePreload, aQ as createFetch$1, aR as getApiOrigin, aS as FetchError, at as OAUTH_KEY, n as APP_ID_KEY, h as ENV_KEY, ao as LOCALE_KEY, aT as getServerOrigin, aU as VERSION, au as CLIENT, x as Region$1, aV as ofetch, aW as Token$1, aX as isDigit$1, aY as isNameStart, aZ as dedentBlockStringLines, a_ as isNameContinue, a$ as inspect$1, b0 as devAssert, b1 as Kind, b2 as OperationTypeNode$1, b3 as Location$1, b4 as print, b5 as isExecutableDefinitionNode, b6 as isTypeDefinitionNode, b7 as isTypeSystemDefinitionNode, b8 as isTypeSystemExtensionNode, b9 as isTypeExtensionNode, ba as visit, bb as visitInParallel, bc as Subscription$1, as as bind$1, p as commonjsGlobal, q as getDefaultExportFromCjs, ap as __decorate, ar as __metadata, m as fromEvent$1, a1 as filter, M as MAGIC, I as IntermediaryMessageTypes, bd as isDefinitionNode, be as sha1, bf as createDebug, o as StashFileType, i as isSafeInteger, R as REGION$1, bg as FIGMA_PLUGIN_OPENED_KEY, bh as FileStatus$1, bi as captureImage, aq as __param, f as firstValueFrom, bj as basename, bk as join$1, bl as uploadFiles, bm as createUploadFileItemParams, bn as getDemoCoverPath, l as ActionType, bo as STYLE_SHEET_FILE_TYPES, bp as tap, Y as map$1, bq as getStashFilename, br as CRITICAL_FILE_TYPES, an as DEFAULT_LOCALE, a0 as TIP_LORE_KEY, al as ClientRequestTypes, bs as ServerResponseTypes, F as FULL_VERSION, bt as BUSINESS, bu as DemoType, bv as RecordType, B as BehaviorSubject$1, bw as destr } from './event-BS8SI8SU.js';
import { d as dateTimestampProvider, i as interval, c as combineLatest } from './interval-DGm5uo8I.js';
import { b as browser } from './browser-polyfill-IrS90NOa.js';

var ReplaySubject = (function (_super) {
    __extends$1(ReplaySubject, _super);
    function ReplaySubject(_bufferSize, _windowTime, _timestampProvider) {
        if (_bufferSize === void 0) { _bufferSize = Infinity; }
        if (_windowTime === void 0) { _windowTime = Infinity; }
        if (_timestampProvider === void 0) { _timestampProvider = dateTimestampProvider; }
        var _this = _super.call(this) || this;
        _this._bufferSize = _bufferSize;
        _this._windowTime = _windowTime;
        _this._timestampProvider = _timestampProvider;
        _this._buffer = [];
        _this._infiniteTimeWindow = true;
        _this._infiniteTimeWindow = _windowTime === Infinity;
        _this._bufferSize = Math.max(1, _bufferSize);
        _this._windowTime = Math.max(1, _windowTime);
        return _this;
    }
    ReplaySubject.prototype.next = function (value) {
        var _a = this, isStopped = _a.isStopped, _buffer = _a._buffer, _infiniteTimeWindow = _a._infiniteTimeWindow, _timestampProvider = _a._timestampProvider, _windowTime = _a._windowTime;
        if (!isStopped) {
            _buffer.push(value);
            !_infiniteTimeWindow && _buffer.push(_timestampProvider.now() + _windowTime);
        }
        this._trimBuffer();
        _super.prototype.next.call(this, value);
    };
    ReplaySubject.prototype._subscribe = function (subscriber) {
        this._throwIfClosed();
        this._trimBuffer();
        var subscription = this._innerSubscribe(subscriber);
        var _a = this, _infiniteTimeWindow = _a._infiniteTimeWindow, _buffer = _a._buffer;
        var copy = _buffer.slice();
        for (var i = 0; i < copy.length && !subscriber.closed; i += _infiniteTimeWindow ? 1 : 2) {
            subscriber.next(copy[i]);
        }
        this._checkFinalizedStatuses(subscriber);
        return subscription;
    };
    ReplaySubject.prototype._trimBuffer = function () {
        var _a = this, _bufferSize = _a._bufferSize, _timestampProvider = _a._timestampProvider, _buffer = _a._buffer, _infiniteTimeWindow = _a._infiniteTimeWindow;
        var adjustedBufferSize = (_infiniteTimeWindow ? 1 : 2) * _bufferSize;
        _bufferSize < Infinity && adjustedBufferSize < _buffer.length && _buffer.splice(0, _buffer.length - adjustedBufferSize);
        if (!_infiniteTimeWindow) {
            var now = _timestampProvider.now();
            var last = 0;
            for (var i = 1; i < _buffer.length && _buffer[i] <= now; i += 2) {
                last = i;
            }
            last && _buffer.splice(0, last + 1);
        }
    };
    return ReplaySubject;
}(Subject$1));

var isArray$1 = Array.isArray;
function argsOrArgArray(args) {
    return args.length === 1 && isArray$1(args[0]) ? args[0] : args;
}

function race() {
    var sources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sources[_i] = arguments[_i];
    }
    sources = argsOrArgArray(sources);
    return sources.length === 1 ? innerFrom$1(sources[0]) : new Observable$1(raceInit(sources));
}
function raceInit(sources) {
    return function (subscriber) {
        var subscriptions = [];
        var _loop_1 = function (i) {
            subscriptions.push(innerFrom$1(sources[i]).subscribe(createOperatorSubscriber$1(subscriber, function (value) {
                if (subscriptions) {
                    for (var s = 0; s < subscriptions.length; s++) {
                        s !== i && subscriptions[s].unsubscribe();
                    }
                    subscriptions = null;
                }
                subscriber.next(value);
            })));
        };
        for (var i = 0; subscriptions && !subscriber.closed && i < sources.length; i++) {
            _loop_1(i);
        }
    };
}

function shareReplay(configOrBufferSize, windowTime, scheduler) {
    var _a, _b, _c;
    var bufferSize;
    var refCount = false;
    if (configOrBufferSize && typeof configOrBufferSize === 'object') {
        (_a = configOrBufferSize.bufferSize, bufferSize = _a === void 0 ? Infinity : _a, _b = configOrBufferSize.windowTime, windowTime = _b === void 0 ? Infinity : _b, _c = configOrBufferSize.refCount, refCount = _c === void 0 ? false : _c, scheduler = configOrBufferSize.scheduler);
    }
    else {
        bufferSize = (configOrBufferSize !== null && configOrBufferSize !== void 0 ? configOrBufferSize : Infinity);
    }
    return share({
        connector: function () { return new ReplaySubject(bufferSize, windowTime, scheduler); },
        resetOnError: true,
        resetOnComplete: false,
        resetOnRefCountZero: refCount,
    });
}

/** Used to match a single whitespace character. */
var reWhitespace = /\s/;

/**
 * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
 * character of `string`.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {number} Returns the index of the last non-whitespace character.
 */
function trimmedEndIndex(string) {
  var index = string.length;

  while (index-- && reWhitespace.test(string.charAt(index))) {}
  return index;
}

/** Used to match leading whitespace. */
var reTrimStart = /^\s+/;

/**
 * The base implementation of `_.trim`.
 *
 * @private
 * @param {string} string The string to trim.
 * @returns {string} Returns the trimmed string.
 */
function baseTrim(string) {
  return string
    ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
    : string;
}

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$1(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject$1(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

/** Used as references for various `Number` constants. */
var INFINITY$2 = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY$2 || value === -INFINITY$2) {
    var sign = (value < 0 ? -1 : 1);
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}

/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
  var result = toFinite(value),
      remainder = result % 1;

  return result === result ? (remainder ? result - remainder : result) : 0;
}

/* Built-in method references that are verified to be native. */
var WeakMap$1 = getNative(root, 'WeakMap');

/**
 * This method returns `undefined`.
 *
 * @static
 * @memberOf _
 * @since 2.3.0
 * @category Util
 * @example
 *
 * _.times(2, _.noop);
 * // => [undefined, undefined]
 */
function noop$1() {
  // No operation performed.
}

/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.isNaN` without support for number objects.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 */
function baseIsNaN(value) {
  return value !== value;
}

/**
 * A specialized version of `_.indexOf` which performs strict equality
 * comparisons of values, i.e. `===`.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1,
      length = array.length;

  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseIndexOf(array, value, fromIndex) {
  return value === value
    ? strictIndexOf(array, value, fromIndex)
    : baseFindIndex(array, baseIsNaN, fromIndex);
}

/**
 * A specialized version of `_.includes` for arrays without support for
 * specifying an index to search from.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && baseIndexOf(array, value, 0) > -1;
}

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

/** Used for built-in method references. */
var objectProto$3 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty$3.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike$1(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray$2(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

/** Error message constants. */
var FUNC_ERROR_TEXT$1 = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT$1);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray$2(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath(toString(value));
}

/** Used as references for various `Number` constants. */
var INFINITY$1 = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
}

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that invokes `func`, with the `this` binding and arguments
 * of the created function, while it's called less than `n` times. Subsequent
 * calls to the created function return the result of the last `func` invocation.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Function
 * @param {number} n The number of calls at which `func` is no longer invoked.
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new restricted function.
 * @example
 *
 * jQuery(element).on('click', _.before(5, addContactToList));
 * // => Allows adding up to 4 contacts to the list.
 */
function before(n, func) {
  var result;
  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  n = toInteger(n);
  return function() {
    if (--n > 0) {
      result = func.apply(this, arguments);
    }
    if (n <= 1) {
      func = undefined;
    }
    return result;
  };
}

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

/** Used for built-in method references. */
var objectProto$2 = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto$2.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray$2(object) ? result : arrayPush(result, symbolsFunc(object));
}

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

/* Built-in method references that are verified to be native. */
var DataView$1 = getNative(root, 'DataView');

/* Built-in method references that are verified to be native. */
var Promise$1 = getNative(root, 'Promise');

/* Built-in method references that are verified to be native. */
var Set$1 = getNative(root, 'Set');

/** `Object#toString` result references. */
var mapTag$1 = '[object Map]',
    objectTag$1 = '[object Object]',
    promiseTag = '[object Promise]',
    setTag$1 = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag$1 = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView$1),
    mapCtorString = toSource(Map$1),
    promiseCtorString = toSource(Promise$1),
    setCtorString = toSource(Set$1),
    weakMapCtorString = toSource(WeakMap$1);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView$1 && getTag(new DataView$1(new ArrayBuffer(1))) != dataViewTag$1) ||
    (Map$1 && getTag(new Map$1) != mapTag$1) ||
    (Promise$1 && getTag(Promise$1.resolve()) != promiseTag) ||
    (Set$1 && getTag(new Set$1) != setTag$1) ||
    (WeakMap$1 && getTag(new WeakMap$1) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag$1 ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag$1;
        case mapCtorString: return mapTag$1;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag$1;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$5 = 1,
    COMPARE_UNORDERED_FLAG$3 = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$5,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG$3) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$4 = 1,
    COMPARE_UNORDERED_FLAG$2 = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol$1 ? Symbol$1.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array$1(object), new Uint8Array$1(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG$4;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG$2;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$3 = 1;

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$2 = objectProto$1.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty$2.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$2 = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty$1 = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray$2(object),
      othIsArr = isArray$2(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG$2)) {
    var objIsWrapped = objIsObj && hasOwnProperty$1.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty$1.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike$2(value) && !isObjectLike$2(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      var result; 
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject$1(value);
}

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray$2(object) || isArguments(object));
}

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity$1;
  }
  if (typeof value == 'object') {
    return isArray$2(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

/**
 * Creates a function that is restricted to invoking `func` once. Repeat calls
 * to the function return the value of the first invocation. The `func` is
 * invoked with the `this` binding and arguments of the created function.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new restricted function.
 * @example
 *
 * var initialize = _.once(createApplication);
 * initialize();
 * initialize();
 * // => `createApplication` is invoked once
 */
function once(func) {
  return before(2, func);
}

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Creates a set object of `values`.
 *
 * @private
 * @param {Array} values The values to add to the set.
 * @returns {Object} Returns the new set.
 */
var createSet = !(Set$1 && (1 / setToArray(new Set$1([,-0]))[1]) == INFINITY) ? noop$1 : function(values) {
  return new Set$1(values);
};

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * The base implementation of `_.uniqBy` without support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 */
function baseUniq(array, iteratee, comparator) {
  var index = -1,
      includes = arrayIncludes,
      length = array.length,
      isCommon = true,
      result = [],
      seen = result;

  if (length >= LARGE_ARRAY_SIZE) {
    var set = iteratee ? null : createSet(array);
    if (set) {
      return setToArray(set);
    }
    isCommon = false;
    includes = cacheHas;
    seen = new SetCache;
  }
  else {
    seen = iteratee ? [] : result;
  }
  outer:
  while (++index < length) {
    var value = array[index],
        computed = iteratee ? iteratee(value) : value;

    value = (value !== 0) ? value : 0;
    if (isCommon && computed === computed) {
      var seenIndex = seen.length;
      while (seenIndex--) {
        if (seen[seenIndex] === computed) {
          continue outer;
        }
      }
      if (iteratee) {
        seen.push(computed);
      }
      result.push(value);
    }
    else if (!includes(seen, computed, comparator)) {
      if (seen !== result) {
        seen.push(computed);
      }
      result.push(value);
    }
  }
  return result;
}

/**
 * This method is like `_.uniq` except that it accepts `iteratee` which is
 * invoked for each element in `array` to generate the criterion by which
 * uniqueness is computed. The order of result values is determined by the
 * order they occur in the array. The iteratee is invoked with one argument:
 * (value).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 * @example
 *
 * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
 * // => [2.1, 1.2]
 *
 * // The `_.property` iteratee shorthand.
 * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
 * // => [{ 'x': 1 }, { 'x': 2 }]
 */
function uniqBy(array, iteratee) {
  return (array && array.length) ? baseUniq(array, baseIteratee(iteratee)) : [];
}

function hexToBuffer(value) {
    const uint8array = new Uint8Array(Math.ceil(value.length / 2));
    for(let i = 0; i < value.length; i += 2){
        uint8array[i / 2] = Number.parseInt(value.slice(i, i + 2), 16);
    }
    return uint8array.buffer;
}
function bufferToHex(value) {
    const stringBuffer = [];
    const uint8array = new Uint8Array(value);
    for(let i = 0; i < uint8array.length; i++){
        stringBuffer.push(uint8array[i].toString(16).padStart(2, '0'));
    }
    return stringBuffer.join('');
}
const IV_LENGTH = 12;
async function getCrypto(forcePolyfill = false) {
    if (typeof globalThis.crypto.subtle === 'object' && !forcePolyfill) {
        return globalThis.crypto;
    }
    const polyfill = await __vitePreload(() => import('./index.es-M5kwZ8rW.js'),true?[]:void 0);
    return polyfill.crypto;
}
async function getRandomValues$1(length) {
    const crypto = await getCrypto();
    const buffer = new ArrayBuffer(length);
    crypto.getRandomValues(new Uint8Array(buffer));
    return buffer;
}
async function encode(secret, record, forcePolyfill = false) {
    const crypto = await getCrypto(forcePolyfill);
    const json = JSON.stringify(record);
    const blob = new Blob([
        json
    ]);
    const compressionStream = new CompressionStream('gzip');
    const compressedStream = blob.stream().pipeThrough(compressionStream);
    const compressed = await new Response(compressedStream).arrayBuffer();
    const key = await crypto.subtle.importKey('raw', secret, 'aes-gcm', false, [
        'encrypt',
        'decrypt'
    ]);
    const iv = await getRandomValues$1(IV_LENGTH);
    const encrypted = await crypto.subtle.encrypt({
        name: 'aes-gcm',
        iv
    }, key, compressed);
    return new Blob([
        iv,
        encrypted
    ]);
}

const FetchContextKey = Symbol("$fetch");
const OAUTH_HEADER_KEY = "Authorization";
function getOAuthHeaderValue(token) {
  return "Bearer " + token;
}
var extendStatics = function(d, b) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
    d2.__proto__ = b2;
  } || function(d2, b2) {
    for (var p in b2)
      if (Object.prototype.hasOwnProperty.call(b2, p))
        d2[p] = b2[p];
  };
  return extendStatics(d, b);
};
function __extends(d, b) {
  if (typeof b !== "function" && b !== null)
    throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
  extendStatics(d, b);
  function __() {
    this.constructor = d;
  }
  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = { label: 0, sent: function() {
    if (t[0] & 1)
      throw t[1];
    return t[1];
  }, trys: [], ops: [] }, f, y, t, g;
  return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
    return this;
  }), g;
  function verb(n) {
    return function(v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f)
      throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _)
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
          return t;
        if (y = 0, t)
          op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return { value: op[1], done: false };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2])
              _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    if (op[0] & 5)
      throw op[1];
    return { value: op[0] ? op[1] : void 0, done: true };
  }
}
function __values(o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m)
    return m.call(o);
  if (o && typeof o.length === "number")
    return {
      next: function() {
        if (o && i >= o.length)
          o = void 0;
        return { value: o && o[i++], done: !o };
      }
    };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __read(o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m)
    return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
      ar.push(r.value);
  } catch (error) {
    e = { error };
  } finally {
    try {
      if (r && !r.done && (m = i["return"]))
        m.call(i);
    } finally {
      if (e)
        throw e.error;
    }
  }
  return ar;
}
function __spreadArray(to, from, pack) {
  if (arguments.length === 2)
    for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !(i in from)) {
        if (!ar)
          ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
  return to.concat(ar || Array.prototype.slice.call(from));
}
function __await(v) {
  return this instanceof __await ? (this.v = v, this) : new __await(v);
}
function __asyncGenerator(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g = generator.apply(thisArg, _arguments || []), i, q = [];
  return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function verb(n) {
    if (g[n])
      i[n] = function(v) {
        return new Promise(function(a, b) {
          q.push([n, v, a, b]) > 1 || resume(n, v);
        });
      };
  }
  function resume(n, v) {
    try {
      step(g[n](v));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r) {
    r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f, v) {
    if (f(v), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
}
function __asyncValues(o) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m = o[Symbol.asyncIterator], i;
  return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o[n] && function(v) {
      return new Promise(function(resolve, reject) {
        v = o[n](v), settle(resolve, reject, v.done, v.value);
      });
    };
  }
  function settle(resolve, reject, d, v) {
    Promise.resolve(v).then(function(v2) {
      resolve({ value: v2, done: d });
    }, reject);
  }
}
function isFunction(value) {
  return typeof value === "function";
}
function createErrorClass(createImpl) {
  var _super = function(instance) {
    Error.call(instance);
    instance.stack = new Error().stack;
  };
  var ctorFunc = createImpl(_super);
  ctorFunc.prototype = Object.create(Error.prototype);
  ctorFunc.prototype.constructor = ctorFunc;
  return ctorFunc;
}
var UnsubscriptionError = createErrorClass(function(_super) {
  return function UnsubscriptionErrorImpl(errors) {
    _super(this);
    this.message = errors ? errors.length + " errors occurred during unsubscription:\n" + errors.map(function(err, i) {
      return i + 1 + ") " + err.toString();
    }).join("\n  ") : "";
    this.name = "UnsubscriptionError";
    this.errors = errors;
  };
});
function arrRemove(arr, item) {
  if (arr) {
    var index = arr.indexOf(item);
    0 <= index && arr.splice(index, 1);
  }
}
var Subscription = function() {
  function Subscription2(initialTeardown) {
    this.initialTeardown = initialTeardown;
    this.closed = false;
    this._parentage = null;
    this._finalizers = null;
  }
  Subscription2.prototype.unsubscribe = function() {
    var e_1, _a, e_2, _b;
    var errors;
    if (!this.closed) {
      this.closed = true;
      var _parentage = this._parentage;
      if (_parentage) {
        this._parentage = null;
        if (Array.isArray(_parentage)) {
          try {
            for (var _parentage_1 = __values(_parentage), _parentage_1_1 = _parentage_1.next(); !_parentage_1_1.done; _parentage_1_1 = _parentage_1.next()) {
              var parent_1 = _parentage_1_1.value;
              parent_1.remove(this);
            }
          } catch (e_1_1) {
            e_1 = { error: e_1_1 };
          } finally {
            try {
              if (_parentage_1_1 && !_parentage_1_1.done && (_a = _parentage_1.return))
                _a.call(_parentage_1);
            } finally {
              if (e_1)
                throw e_1.error;
            }
          }
        } else {
          _parentage.remove(this);
        }
      }
      var initialFinalizer = this.initialTeardown;
      if (isFunction(initialFinalizer)) {
        try {
          initialFinalizer();
        } catch (e) {
          errors = e instanceof UnsubscriptionError ? e.errors : [e];
        }
      }
      var _finalizers = this._finalizers;
      if (_finalizers) {
        this._finalizers = null;
        try {
          for (var _finalizers_1 = __values(_finalizers), _finalizers_1_1 = _finalizers_1.next(); !_finalizers_1_1.done; _finalizers_1_1 = _finalizers_1.next()) {
            var finalizer = _finalizers_1_1.value;
            try {
              execFinalizer(finalizer);
            } catch (err) {
              errors = errors !== null && errors !== void 0 ? errors : [];
              if (err instanceof UnsubscriptionError) {
                errors = __spreadArray(__spreadArray([], __read(errors)), __read(err.errors));
              } else {
                errors.push(err);
              }
            }
          }
        } catch (e_2_1) {
          e_2 = { error: e_2_1 };
        } finally {
          try {
            if (_finalizers_1_1 && !_finalizers_1_1.done && (_b = _finalizers_1.return))
              _b.call(_finalizers_1);
          } finally {
            if (e_2)
              throw e_2.error;
          }
        }
      }
      if (errors) {
        throw new UnsubscriptionError(errors);
      }
    }
  };
  Subscription2.prototype.add = function(teardown) {
    var _a;
    if (teardown && teardown !== this) {
      if (this.closed) {
        execFinalizer(teardown);
      } else {
        if (teardown instanceof Subscription2) {
          if (teardown.closed || teardown._hasParent(this)) {
            return;
          }
          teardown._addParent(this);
        }
        (this._finalizers = (_a = this._finalizers) !== null && _a !== void 0 ? _a : []).push(teardown);
      }
    }
  };
  Subscription2.prototype._hasParent = function(parent) {
    var _parentage = this._parentage;
    return _parentage === parent || Array.isArray(_parentage) && _parentage.includes(parent);
  };
  Subscription2.prototype._addParent = function(parent) {
    var _parentage = this._parentage;
    this._parentage = Array.isArray(_parentage) ? (_parentage.push(parent), _parentage) : _parentage ? [_parentage, parent] : parent;
  };
  Subscription2.prototype._removeParent = function(parent) {
    var _parentage = this._parentage;
    if (_parentage === parent) {
      this._parentage = null;
    } else if (Array.isArray(_parentage)) {
      arrRemove(_parentage, parent);
    }
  };
  Subscription2.prototype.remove = function(teardown) {
    var _finalizers = this._finalizers;
    _finalizers && arrRemove(_finalizers, teardown);
    if (teardown instanceof Subscription2) {
      teardown._removeParent(this);
    }
  };
  Subscription2.EMPTY = function() {
    var empty = new Subscription2();
    empty.closed = true;
    return empty;
  }();
  return Subscription2;
}();
var EMPTY_SUBSCRIPTION = Subscription.EMPTY;
function isSubscription(value) {
  return value instanceof Subscription || value && "closed" in value && isFunction(value.remove) && isFunction(value.add) && isFunction(value.unsubscribe);
}
function execFinalizer(finalizer) {
  if (isFunction(finalizer)) {
    finalizer();
  } else {
    finalizer.unsubscribe();
  }
}
var config$1 = {
  onUnhandledError: null,
  onStoppedNotification: null,
  Promise: void 0,
  useDeprecatedSynchronousErrorHandling: false,
  useDeprecatedNextContext: false
};
var timeoutProvider = {
  setTimeout: function(handler, timeout) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
      args[_i - 2] = arguments[_i];
    }
    return setTimeout.apply(void 0, __spreadArray([handler, timeout], __read(args)));
  },
  clearTimeout: function(handle) {
    return (clearTimeout)(handle);
  },
  delegate: void 0
};
function reportUnhandledError(err) {
  timeoutProvider.setTimeout(function() {
    {
      throw err;
    }
  });
}
function noop() {
}
function errorContext(cb) {
  {
    cb();
  }
}
var Subscriber = function(_super) {
  __extends(Subscriber2, _super);
  function Subscriber2(destination) {
    var _this = _super.call(this) || this;
    _this.isStopped = false;
    if (destination) {
      _this.destination = destination;
      if (isSubscription(destination)) {
        destination.add(_this);
      }
    } else {
      _this.destination = EMPTY_OBSERVER;
    }
    return _this;
  }
  Subscriber2.create = function(next, error, complete) {
    return new SafeSubscriber(next, error, complete);
  };
  Subscriber2.prototype.next = function(value) {
    if (this.isStopped)
      ;
    else {
      this._next(value);
    }
  };
  Subscriber2.prototype.error = function(err) {
    if (this.isStopped)
      ;
    else {
      this.isStopped = true;
      this._error(err);
    }
  };
  Subscriber2.prototype.complete = function() {
    if (this.isStopped)
      ;
    else {
      this.isStopped = true;
      this._complete();
    }
  };
  Subscriber2.prototype.unsubscribe = function() {
    if (!this.closed) {
      this.isStopped = true;
      _super.prototype.unsubscribe.call(this);
      this.destination = null;
    }
  };
  Subscriber2.prototype._next = function(value) {
    this.destination.next(value);
  };
  Subscriber2.prototype._error = function(err) {
    try {
      this.destination.error(err);
    } finally {
      this.unsubscribe();
    }
  };
  Subscriber2.prototype._complete = function() {
    try {
      this.destination.complete();
    } finally {
      this.unsubscribe();
    }
  };
  return Subscriber2;
}(Subscription);
var _bind = Function.prototype.bind;
function bind(fn, thisArg) {
  return _bind.call(fn, thisArg);
}
var ConsumerObserver = function() {
  function ConsumerObserver2(partialObserver) {
    this.partialObserver = partialObserver;
  }
  ConsumerObserver2.prototype.next = function(value) {
    var partialObserver = this.partialObserver;
    if (partialObserver.next) {
      try {
        partialObserver.next(value);
      } catch (error) {
        handleUnhandledError(error);
      }
    }
  };
  ConsumerObserver2.prototype.error = function(err) {
    var partialObserver = this.partialObserver;
    if (partialObserver.error) {
      try {
        partialObserver.error(err);
      } catch (error) {
        handleUnhandledError(error);
      }
    } else {
      handleUnhandledError(err);
    }
  };
  ConsumerObserver2.prototype.complete = function() {
    var partialObserver = this.partialObserver;
    if (partialObserver.complete) {
      try {
        partialObserver.complete();
      } catch (error) {
        handleUnhandledError(error);
      }
    }
  };
  return ConsumerObserver2;
}();
var SafeSubscriber = function(_super) {
  __extends(SafeSubscriber2, _super);
  function SafeSubscriber2(observerOrNext, error, complete) {
    var _this = _super.call(this) || this;
    var partialObserver;
    if (isFunction(observerOrNext) || !observerOrNext) {
      partialObserver = {
        next: observerOrNext !== null && observerOrNext !== void 0 ? observerOrNext : void 0,
        error: error !== null && error !== void 0 ? error : void 0,
        complete: complete !== null && complete !== void 0 ? complete : void 0
      };
    } else {
      var context_1;
      if (_this && config$1.useDeprecatedNextContext) {
        context_1 = Object.create(observerOrNext);
        context_1.unsubscribe = function() {
          return _this.unsubscribe();
        };
        partialObserver = {
          next: observerOrNext.next && bind(observerOrNext.next, context_1),
          error: observerOrNext.error && bind(observerOrNext.error, context_1),
          complete: observerOrNext.complete && bind(observerOrNext.complete, context_1)
        };
      } else {
        partialObserver = observerOrNext;
      }
    }
    _this.destination = new ConsumerObserver(partialObserver);
    return _this;
  }
  return SafeSubscriber2;
}(Subscriber);
function handleUnhandledError(error) {
  {
    reportUnhandledError(error);
  }
}
function defaultErrorHandler(err) {
  throw err;
}
var EMPTY_OBSERVER = {
  closed: true,
  next: noop,
  error: defaultErrorHandler,
  complete: noop
};
var observable = function() {
  return typeof Symbol === "function" && Symbol.observable || "@@observable";
}();
function identity(x) {
  return x;
}
function pipeFromArray(fns) {
  if (fns.length === 0) {
    return identity;
  }
  if (fns.length === 1) {
    return fns[0];
  }
  return function piped(input) {
    return fns.reduce(function(prev, fn) {
      return fn(prev);
    }, input);
  };
}
var Observable = function() {
  function Observable2(subscribe) {
    if (subscribe) {
      this._subscribe = subscribe;
    }
  }
  Observable2.prototype.lift = function(operator) {
    var observable2 = new Observable2();
    observable2.source = this;
    observable2.operator = operator;
    return observable2;
  };
  Observable2.prototype.subscribe = function(observerOrNext, error, complete) {
    var _this = this;
    var subscriber = isSubscriber(observerOrNext) ? observerOrNext : new SafeSubscriber(observerOrNext, error, complete);
    errorContext(function() {
      var _a = _this, operator = _a.operator, source = _a.source;
      subscriber.add(operator ? operator.call(subscriber, source) : source ? _this._subscribe(subscriber) : _this._trySubscribe(subscriber));
    });
    return subscriber;
  };
  Observable2.prototype._trySubscribe = function(sink) {
    try {
      return this._subscribe(sink);
    } catch (err) {
      sink.error(err);
    }
  };
  Observable2.prototype.forEach = function(next, promiseCtor) {
    var _this = this;
    promiseCtor = getPromiseCtor(promiseCtor);
    return new promiseCtor(function(resolve, reject) {
      var subscriber = new SafeSubscriber({
        next: function(value) {
          try {
            next(value);
          } catch (err) {
            reject(err);
            subscriber.unsubscribe();
          }
        },
        error: reject,
        complete: resolve
      });
      _this.subscribe(subscriber);
    });
  };
  Observable2.prototype._subscribe = function(subscriber) {
    var _a;
    return (_a = this.source) === null || _a === void 0 ? void 0 : _a.subscribe(subscriber);
  };
  Observable2.prototype[observable] = function() {
    return this;
  };
  Observable2.prototype.pipe = function() {
    var operations = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      operations[_i] = arguments[_i];
    }
    return pipeFromArray(operations)(this);
  };
  Observable2.prototype.toPromise = function(promiseCtor) {
    var _this = this;
    promiseCtor = getPromiseCtor(promiseCtor);
    return new promiseCtor(function(resolve, reject) {
      var value;
      _this.subscribe(function(x) {
        return value = x;
      }, function(err) {
        return reject(err);
      }, function() {
        return resolve(value);
      });
    });
  };
  Observable2.create = function(subscribe) {
    return new Observable2(subscribe);
  };
  return Observable2;
}();
function getPromiseCtor(promiseCtor) {
  var _a;
  return (_a = promiseCtor !== null && promiseCtor !== void 0 ? promiseCtor : config$1.Promise) !== null && _a !== void 0 ? _a : Promise;
}
function isObserver(value) {
  return value && isFunction(value.next) && isFunction(value.error) && isFunction(value.complete);
}
function isSubscriber(value) {
  return value && value instanceof Subscriber || isObserver(value) && isSubscription(value);
}
function hasLift(source) {
  return isFunction(source === null || source === void 0 ? void 0 : source.lift);
}
function operate(init) {
  return function(source) {
    if (hasLift(source)) {
      return source.lift(function(liftedSource) {
        try {
          return init(liftedSource, this);
        } catch (err) {
          this.error(err);
        }
      });
    }
    throw new TypeError("Unable to lift unknown Observable type");
  };
}
function createOperatorSubscriber(destination, onNext, onComplete, onError, onFinalize) {
  return new OperatorSubscriber(destination, onNext, onComplete, onError, onFinalize);
}
var OperatorSubscriber = function(_super) {
  __extends(OperatorSubscriber2, _super);
  function OperatorSubscriber2(destination, onNext, onComplete, onError, onFinalize, shouldUnsubscribe) {
    var _this = _super.call(this, destination) || this;
    _this.onFinalize = onFinalize;
    _this.shouldUnsubscribe = shouldUnsubscribe;
    _this._next = onNext ? function(value) {
      try {
        onNext(value);
      } catch (err) {
        destination.error(err);
      }
    } : _super.prototype._next;
    _this._error = onError ? function(err) {
      try {
        onError(err);
      } catch (err2) {
        destination.error(err2);
      } finally {
        this.unsubscribe();
      }
    } : _super.prototype._error;
    _this._complete = onComplete ? function() {
      try {
        onComplete();
      } catch (err) {
        destination.error(err);
      } finally {
        this.unsubscribe();
      }
    } : _super.prototype._complete;
    return _this;
  }
  OperatorSubscriber2.prototype.unsubscribe = function() {
    var _a;
    if (!this.shouldUnsubscribe || this.shouldUnsubscribe()) {
      var closed_1 = this.closed;
      _super.prototype.unsubscribe.call(this);
      !closed_1 && ((_a = this.onFinalize) === null || _a === void 0 ? void 0 : _a.call(this));
    }
  };
  return OperatorSubscriber2;
}(Subscriber);
var ObjectUnsubscribedError = createErrorClass(function(_super) {
  return function ObjectUnsubscribedErrorImpl() {
    _super(this);
    this.name = "ObjectUnsubscribedError";
    this.message = "object unsubscribed";
  };
});
var Subject = function(_super) {
  __extends(Subject2, _super);
  function Subject2() {
    var _this = _super.call(this) || this;
    _this.closed = false;
    _this.currentObservers = null;
    _this.observers = [];
    _this.isStopped = false;
    _this.hasError = false;
    _this.thrownError = null;
    return _this;
  }
  Subject2.prototype.lift = function(operator) {
    var subject = new AnonymousSubject(this, this);
    subject.operator = operator;
    return subject;
  };
  Subject2.prototype._throwIfClosed = function() {
    if (this.closed) {
      throw new ObjectUnsubscribedError();
    }
  };
  Subject2.prototype.next = function(value) {
    var _this = this;
    errorContext(function() {
      var e_1, _a;
      _this._throwIfClosed();
      if (!_this.isStopped) {
        if (!_this.currentObservers) {
          _this.currentObservers = Array.from(_this.observers);
        }
        try {
          for (var _b = __values(_this.currentObservers), _c = _b.next(); !_c.done; _c = _b.next()) {
            var observer = _c.value;
            observer.next(value);
          }
        } catch (e_1_1) {
          e_1 = { error: e_1_1 };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return))
              _a.call(_b);
          } finally {
            if (e_1)
              throw e_1.error;
          }
        }
      }
    });
  };
  Subject2.prototype.error = function(err) {
    var _this = this;
    errorContext(function() {
      _this._throwIfClosed();
      if (!_this.isStopped) {
        _this.hasError = _this.isStopped = true;
        _this.thrownError = err;
        var observers = _this.observers;
        while (observers.length) {
          observers.shift().error(err);
        }
      }
    });
  };
  Subject2.prototype.complete = function() {
    var _this = this;
    errorContext(function() {
      _this._throwIfClosed();
      if (!_this.isStopped) {
        _this.isStopped = true;
        var observers = _this.observers;
        while (observers.length) {
          observers.shift().complete();
        }
      }
    });
  };
  Subject2.prototype.unsubscribe = function() {
    this.isStopped = this.closed = true;
    this.observers = this.currentObservers = null;
  };
  Object.defineProperty(Subject2.prototype, "observed", {
    get: function() {
      var _a;
      return ((_a = this.observers) === null || _a === void 0 ? void 0 : _a.length) > 0;
    },
    enumerable: false,
    configurable: true
  });
  Subject2.prototype._trySubscribe = function(subscriber) {
    this._throwIfClosed();
    return _super.prototype._trySubscribe.call(this, subscriber);
  };
  Subject2.prototype._subscribe = function(subscriber) {
    this._throwIfClosed();
    this._checkFinalizedStatuses(subscriber);
    return this._innerSubscribe(subscriber);
  };
  Subject2.prototype._innerSubscribe = function(subscriber) {
    var _this = this;
    var _a = this, hasError = _a.hasError, isStopped = _a.isStopped, observers = _a.observers;
    if (hasError || isStopped) {
      return EMPTY_SUBSCRIPTION;
    }
    this.currentObservers = null;
    observers.push(subscriber);
    return new Subscription(function() {
      _this.currentObservers = null;
      arrRemove(observers, subscriber);
    });
  };
  Subject2.prototype._checkFinalizedStatuses = function(subscriber) {
    var _a = this, hasError = _a.hasError, thrownError = _a.thrownError, isStopped = _a.isStopped;
    if (hasError) {
      subscriber.error(thrownError);
    } else if (isStopped) {
      subscriber.complete();
    }
  };
  Subject2.prototype.asObservable = function() {
    var observable2 = new Observable();
    observable2.source = this;
    return observable2;
  };
  Subject2.create = function(destination, source) {
    return new AnonymousSubject(destination, source);
  };
  return Subject2;
}(Observable);
var AnonymousSubject = function(_super) {
  __extends(AnonymousSubject2, _super);
  function AnonymousSubject2(destination, source) {
    var _this = _super.call(this) || this;
    _this.destination = destination;
    _this.source = source;
    return _this;
  }
  AnonymousSubject2.prototype.next = function(value) {
    var _a, _b;
    (_b = (_a = this.destination) === null || _a === void 0 ? void 0 : _a.next) === null || _b === void 0 ? void 0 : _b.call(_a, value);
  };
  AnonymousSubject2.prototype.error = function(err) {
    var _a, _b;
    (_b = (_a = this.destination) === null || _a === void 0 ? void 0 : _a.error) === null || _b === void 0 ? void 0 : _b.call(_a, err);
  };
  AnonymousSubject2.prototype.complete = function() {
    var _a, _b;
    (_b = (_a = this.destination) === null || _a === void 0 ? void 0 : _a.complete) === null || _b === void 0 ? void 0 : _b.call(_a);
  };
  AnonymousSubject2.prototype._subscribe = function(subscriber) {
    var _a, _b;
    return (_b = (_a = this.source) === null || _a === void 0 ? void 0 : _a.subscribe(subscriber)) !== null && _b !== void 0 ? _b : EMPTY_SUBSCRIPTION;
  };
  return AnonymousSubject2;
}(Subject);
var BehaviorSubject = function(_super) {
  __extends(BehaviorSubject2, _super);
  function BehaviorSubject2(_value) {
    var _this = _super.call(this) || this;
    _this._value = _value;
    return _this;
  }
  Object.defineProperty(BehaviorSubject2.prototype, "value", {
    get: function() {
      return this.getValue();
    },
    enumerable: false,
    configurable: true
  });
  BehaviorSubject2.prototype._subscribe = function(subscriber) {
    var subscription = _super.prototype._subscribe.call(this, subscriber);
    !subscription.closed && subscriber.next(this._value);
    return subscription;
  };
  BehaviorSubject2.prototype.getValue = function() {
    var _a = this, hasError = _a.hasError, thrownError = _a.thrownError, _value = _a._value;
    if (hasError) {
      throw thrownError;
    }
    this._throwIfClosed();
    return _value;
  };
  BehaviorSubject2.prototype.next = function(value) {
    _super.prototype.next.call(this, this._value = value);
  };
  return BehaviorSubject2;
}(Subject);
var isArrayLike = function(x) {
  return x && typeof x.length === "number" && typeof x !== "function";
};
function isPromise$1(value) {
  return isFunction(value === null || value === void 0 ? void 0 : value.then);
}
function isInteropObservable(input) {
  return isFunction(input[observable]);
}
function isAsyncIterable$2(obj) {
  return Symbol.asyncIterator && isFunction(obj === null || obj === void 0 ? void 0 : obj[Symbol.asyncIterator]);
}
function createInvalidObservableTypeError(input) {
  return new TypeError("You provided " + (input !== null && typeof input === "object" ? "an invalid object" : "'" + input + "'") + " where a stream was expected. You can provide an Observable, Promise, ReadableStream, Array, AsyncIterable, or Iterable.");
}
function getSymbolIterator() {
  if (typeof Symbol !== "function" || !Symbol.iterator) {
    return "@@iterator";
  }
  return Symbol.iterator;
}
var iterator = getSymbolIterator();
function isIterable(input) {
  return isFunction(input === null || input === void 0 ? void 0 : input[iterator]);
}
function readableStreamLikeToAsyncGenerator(readableStream) {
  return __asyncGenerator(this, arguments, function readableStreamLikeToAsyncGenerator_1() {
    var reader, _a, value, done;
    return __generator(this, function(_b) {
      switch (_b.label) {
        case 0:
          reader = readableStream.getReader();
          _b.label = 1;
        case 1:
          _b.trys.push([1, , 9, 10]);
          _b.label = 2;
        case 2:
          return [4, __await(reader.read())];
        case 3:
          _a = _b.sent(), value = _a.value, done = _a.done;
          if (!done)
            return [3, 5];
          return [4, __await(void 0)];
        case 4:
          return [2, _b.sent()];
        case 5:
          return [4, __await(value)];
        case 6:
          return [4, _b.sent()];
        case 7:
          _b.sent();
          return [3, 2];
        case 8:
          return [3, 10];
        case 9:
          reader.releaseLock();
          return [7];
        case 10:
          return [2];
      }
    });
  });
}
function isReadableStreamLike(obj) {
  return isFunction(obj === null || obj === void 0 ? void 0 : obj.getReader);
}
function innerFrom(input) {
  if (input instanceof Observable) {
    return input;
  }
  if (input != null) {
    if (isInteropObservable(input)) {
      return fromInteropObservable(input);
    }
    if (isArrayLike(input)) {
      return fromArrayLike(input);
    }
    if (isPromise$1(input)) {
      return fromPromise(input);
    }
    if (isAsyncIterable$2(input)) {
      return fromAsyncIterable(input);
    }
    if (isIterable(input)) {
      return fromIterable(input);
    }
    if (isReadableStreamLike(input)) {
      return fromReadableStreamLike(input);
    }
  }
  throw createInvalidObservableTypeError(input);
}
function fromInteropObservable(obj) {
  return new Observable(function(subscriber) {
    var obs = obj[observable]();
    if (isFunction(obs.subscribe)) {
      return obs.subscribe(subscriber);
    }
    throw new TypeError("Provided object does not correctly implement Symbol.observable");
  });
}
function fromArrayLike(array) {
  return new Observable(function(subscriber) {
    for (var i = 0; i < array.length && !subscriber.closed; i++) {
      subscriber.next(array[i]);
    }
    subscriber.complete();
  });
}
function fromPromise(promise) {
  return new Observable(function(subscriber) {
    promise.then(function(value) {
      if (!subscriber.closed) {
        subscriber.next(value);
        subscriber.complete();
      }
    }, function(err) {
      return subscriber.error(err);
    }).then(null, reportUnhandledError);
  });
}
function fromIterable(iterable) {
  return new Observable(function(subscriber) {
    var e_1, _a;
    try {
      for (var iterable_1 = __values(iterable), iterable_1_1 = iterable_1.next(); !iterable_1_1.done; iterable_1_1 = iterable_1.next()) {
        var value = iterable_1_1.value;
        subscriber.next(value);
        if (subscriber.closed) {
          return;
        }
      }
    } catch (e_1_1) {
      e_1 = { error: e_1_1 };
    } finally {
      try {
        if (iterable_1_1 && !iterable_1_1.done && (_a = iterable_1.return))
          _a.call(iterable_1);
      } finally {
        if (e_1)
          throw e_1.error;
      }
    }
    subscriber.complete();
  });
}
function fromAsyncIterable(asyncIterable) {
  return new Observable(function(subscriber) {
    process(asyncIterable, subscriber).catch(function(err) {
      return subscriber.error(err);
    });
  });
}
function fromReadableStreamLike(readableStream) {
  return fromAsyncIterable(readableStreamLikeToAsyncGenerator(readableStream));
}
function process(asyncIterable, subscriber) {
  var asyncIterable_1, asyncIterable_1_1;
  var e_2, _a;
  return __awaiter(this, void 0, void 0, function() {
    var value, e_2_1;
    return __generator(this, function(_b) {
      switch (_b.label) {
        case 0:
          _b.trys.push([0, 5, 6, 11]);
          asyncIterable_1 = __asyncValues(asyncIterable);
          _b.label = 1;
        case 1:
          return [4, asyncIterable_1.next()];
        case 2:
          if (!(asyncIterable_1_1 = _b.sent(), !asyncIterable_1_1.done))
            return [3, 4];
          value = asyncIterable_1_1.value;
          subscriber.next(value);
          if (subscriber.closed) {
            return [2];
          }
          _b.label = 3;
        case 3:
          return [3, 1];
        case 4:
          return [3, 11];
        case 5:
          e_2_1 = _b.sent();
          e_2 = { error: e_2_1 };
          return [3, 11];
        case 6:
          _b.trys.push([6, , 9, 10]);
          if (!(asyncIterable_1_1 && !asyncIterable_1_1.done && (_a = asyncIterable_1.return)))
            return [3, 8];
          return [4, _a.call(asyncIterable_1)];
        case 7:
          _b.sent();
          _b.label = 8;
        case 8:
          return [3, 10];
        case 9:
          if (e_2)
            throw e_2.error;
          return [7];
        case 10:
          return [7];
        case 11:
          subscriber.complete();
          return [2];
      }
    });
  });
}
function map(project, thisArg) {
  return operate(function(source, subscriber) {
    var index = 0;
    source.subscribe(createOperatorSubscriber(subscriber, function(value) {
      subscriber.next(project.call(thisArg, value, index++));
    }));
  });
}
var isArray = Array.isArray;
function callOrApply(fn, args) {
  return isArray(args) ? fn.apply(void 0, __spreadArray([], __read(args))) : fn(args);
}
function mapOneOrManyArgs(fn) {
  return map(function(args) {
    return callOrApply(fn, args);
  });
}
function mergeInternals(source, subscriber, project, concurrent, onBeforeNext, expand, innerSubScheduler, additionalFinalizer) {
  var buffer = [];
  var active = 0;
  var index = 0;
  var isComplete = false;
  var checkComplete = function() {
    if (isComplete && !buffer.length && !active) {
      subscriber.complete();
    }
  };
  var outerNext = function(value) {
    return active < concurrent ? doInnerSub(value) : buffer.push(value);
  };
  var doInnerSub = function(value) {
    active++;
    var innerComplete = false;
    innerFrom(project(value, index++)).subscribe(createOperatorSubscriber(subscriber, function(innerValue) {
      {
        subscriber.next(innerValue);
      }
    }, function() {
      innerComplete = true;
    }, void 0, function() {
      if (innerComplete) {
        try {
          active--;
          var _loop_1 = function() {
            var bufferedValue = buffer.shift();
            if (innerSubScheduler)
              ;
            else {
              doInnerSub(bufferedValue);
            }
          };
          while (buffer.length && active < concurrent) {
            _loop_1();
          }
          checkComplete();
        } catch (err) {
          subscriber.error(err);
        }
      }
    }));
  };
  source.subscribe(createOperatorSubscriber(subscriber, outerNext, function() {
    isComplete = true;
    checkComplete();
  }));
  return function() {
  };
}
function mergeMap(project, resultSelector, concurrent) {
  if (concurrent === void 0) {
    concurrent = Infinity;
  }
  if (isFunction(resultSelector)) {
    return mergeMap(function(a, i) {
      return map(function(b, ii) {
        return resultSelector(a, b, i, ii);
      })(innerFrom(project(a, i)));
    }, concurrent);
  } else if (typeof resultSelector === "number") {
    concurrent = resultSelector;
  }
  return operate(function(source, subscriber) {
    return mergeInternals(source, subscriber, project, concurrent);
  });
}
var nodeEventEmitterMethods = ["addListener", "removeListener"];
var eventTargetMethods = ["addEventListener", "removeEventListener"];
var jqueryMethods = ["on", "off"];
function fromEvent(target, eventName, options, resultSelector) {
  if (isFunction(options)) {
    resultSelector = options;
    options = void 0;
  }
  if (resultSelector) {
    return fromEvent(target, eventName, options).pipe(mapOneOrManyArgs(resultSelector));
  }
  var _a = __read(isEventTarget(target) ? eventTargetMethods.map(function(methodName) {
    return function(handler) {
      return target[methodName](eventName, handler, options);
    };
  }) : isNodeStyleEventEmitter(target) ? nodeEventEmitterMethods.map(toCommonHandlerRegistry(target, eventName)) : isJQueryStyleEventEmitter(target) ? jqueryMethods.map(toCommonHandlerRegistry(target, eventName)) : [], 2), add = _a[0], remove = _a[1];
  if (!add) {
    if (isArrayLike(target)) {
      return mergeMap(function(subTarget) {
        return fromEvent(subTarget, eventName, options);
      })(innerFrom(target));
    }
  }
  if (!add) {
    throw new TypeError("Invalid event target");
  }
  return new Observable(function(subscriber) {
    var handler = function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return subscriber.next(1 < args.length ? args : args[0]);
    };
    add(handler);
    return function() {
      return remove(handler);
    };
  });
}
function toCommonHandlerRegistry(target, eventName) {
  return function(methodName) {
    return function(handler) {
      return target[methodName](eventName, handler);
    };
  };
}
function isNodeStyleEventEmitter(target) {
  return isFunction(target.addListener) && isFunction(target.removeListener);
}
function isJQueryStyleEventEmitter(target) {
  return isFunction(target.on) && isFunction(target.off);
}
function isEventTarget(target) {
  return isFunction(target.addEventListener) && isFunction(target.removeEventListener);
}
class EventClass {
  constructor() {
    this.listeners = /* @__PURE__ */ new Map();
    this.onceListeners = /* @__PURE__ */ new Map();
    this.triggerdLabels = /* @__PURE__ */ new Map();
  }
  // help-function for onReady and onceReady
  // the callbackfunction will execute,
  // if the label has already been triggerd with the last called parameters
  _fCheckPast(label, callback) {
    if (this.triggerdLabels.has(label)) {
      callback(...this.triggerdLabels.get(label));
      return true;
    } else {
      return false;
    }
  }
  // execute the callback everytime the label is trigger
  on(label, callback, checkPast = false) {
    this.listeners.has(label) || this.listeners.set(label, []);
    this.listeners.get(label).push(callback);
    if (checkPast)
      this._fCheckPast(label, callback);
  }
  // execute the callback everytime the label is trigger
  // check if the label had been already called
  // and if so excute the callback immediately
  onReady(label, callback) {
    this.on(label, callback, true);
  }
  // execute the callback onetime the label is trigger
  once(label, callback, checkPast = false) {
    this.onceListeners.has(label) || this.onceListeners.set(label, []);
    if (!(checkPast && this._fCheckPast(label, callback))) {
      this.onceListeners.get(label).push(callback);
    }
  }
  // execute the callback onetime the label is trigger
  // or execute the callback if the label had been called already
  onceReady(label, callback) {
    this.once(label, callback, true);
  }
  // remove the callback for a label
  off(label, callback = true) {
    if (callback === true) {
      this.listeners.delete(label);
      this.onceListeners.delete(label);
    } else {
      const _off = (inListener) => {
        const listeners = inListener.get(label);
        if (listeners) {
          inListener.set(
            label,
            listeners.filter((value) => !(value === callback))
          );
        }
      };
      _off(this.listeners);
      _off(this.onceListeners);
    }
  }
  // trigger the event with the label
  trigger(label, ...args) {
    let res = false;
    this.triggerdLabels.set(label, args);
    const _trigger = (inListener, label2, ...args2) => {
      const listeners = inListener.get(label2);
      if (listeners && listeners.length) {
        listeners.forEach((listener) => {
          listener(...args2);
        });
        res = true;
      }
    };
    _trigger(this.onceListeners, label, ...args);
    _trigger(this.listeners, label, ...args);
    this.onceListeners.delete(label);
    return res;
  }
}
function createFetchError(ctx) {
  var _a, _b, _c, _d, _e, _f;
  let message = "";
  if (ctx.error) {
    message = ((_a = ctx.error) == null ? void 0 : _a.message) || ((_b = ctx.error) == null ? void 0 : _b.toString()) || "";
  }
  if (!message) {
    const method = ((_c = ctx.request) == null ? void 0 : _c.method) || ((_d = ctx.options) == null ? void 0 : _d.method) || "GET";
    const url = ((_e = ctx.request) == null ? void 0 : _e.url) || String(ctx.request) || "/";
    const requestStr = `[${method}] ${JSON.stringify(url)}`;
    const statusStr = ctx.response ? `${ctx.response.status} ${ctx.response.statusText}` : "<no response>";
    message = `${requestStr}: ${statusStr}`;
  }
  const fetchError = new FetchError(message, ctx.error ? { cause: ctx.error } : void 0);
  for (const key of ["request", "options", "response"]) {
    Object.defineProperty(fetchError, key, {
      get() {
        return ctx[key];
      }
    });
  }
  for (const [key, refKey] of [
    ["data", "_data"],
    ["status", "status"],
    ["statusCode", "status"],
    ["statusText", "statusText"]
  ]) {
    Object.defineProperty(fetchError, key, {
      get() {
        return ctx.response && ctx.response[refKey];
      }
    });
  }
  fetchError.statusMessage = (_f = ctx.error) == null ? void 0 : _f.statusMessage;
  return fetchError;
}
const $baseFetch = createFetch$1({
  defaults: {
    onResponse(context) {
      if (context.error) {
        return;
      }
      const data = context.response._data;
      if (!data || typeof data !== "object") {
        return;
      }
      if (data.error) {
        context.error = data.error;
      } else if ("data" in data) {
        context.response._data = data.data;
      }
    },
    createFetchError
  }
});
function getDefaultFetchOptions(oauth, env) {
  return {
    baseURL: getApiOrigin(env),
    async onRequest(context, next) {
      const accessToken = await oauth.getAccessToken();
      const headers = new Headers(context.options.headers);
      headers.set(OAUTH_HEADER_KEY, getOAuthHeaderValue(accessToken));
      context.options.headers = headers;
      await next();
    },
    async onResponse(context, next) {
      var _a;
      if (!context.response.ok && context.response.status === 401 && ((_a = context.response._data) == null ? void 0 : _a.error) === "Token Not Verified" && context.options.retry !== false) {
        await oauth.refreshToken();
        const currentFetch = context.$self;
        context.response = await currentFetch(context.request, {
          ...context.options,
          retry: false
        });
        return;
      }
      await next();
    }
  };
}
const createPublicFetch = $baseFetch.create;
function createOAuthFetch(oauth, options) {
  return $baseFetch.create(getDefaultFetchOptions(oauth, void 0 ), options);
}
var OAuthType = /* @__PURE__ */ ((OAuthType2) => {
  OAuthType2["PASSWORD_LOGIN"] = "PASSWORD_LOGIN";
  OAuthType2["PHONE_CAPTCHA_LOGIN"] = "PHONE_CAPTCHA_LOGIN";
  OAuthType2["GOOGLE_LOGIN"] = "GOOGLE_LOGIN";
  OAuthType2["FIGMA_LOGIN"] = "FIGMA_LOGIN";
  OAuthType2["AUTHORIZATION_CODE"] = "AUTHORIZATION_CODE";
  OAuthType2["REFRESH_TOKEN"] = "REFRESH_TOKEN";
  OAuthType2["CREATE_AUTHORIZATION_CODE"] = "CREATE_AUTHORIZATION_CODE";
  OAuthType2["CLIENT_CREDENTIALS"] = "CLIENT_CREDENTIALS";
  return OAuthType2;
})(OAuthType || {});
const DEFAULT_TOKEN_ENDPOINT = "/api/auth/token";
const DEFAULT_ANONYMOUS_ENDPOINT = "/api/auth/anon";
class OAuthClient extends EventClass {
  constructor(options = {}) {
    super();
    this.tokenEndpoint = options.tokenEndpoint || DEFAULT_TOKEN_ENDPOINT;
    this.anonEndpoint = options.anonEndpoint || DEFAULT_ANONYMOUS_ENDPOINT;
    this.$fetch = options.$fetch ?? createPublicFetch({
      baseURL: options.baseURL || getApiOrigin()
    });
  }
  setBaseURL(baseURL) {
    this.$fetch = this.$fetch.create({
      baseURL
    });
  }
  /**
   * signin with anonymous
   * @param data
   * @returns
   */
  async signinAnon(data) {
    if (!this.anonEndpoint) {
      throw new Error("anonymous endpoint is not set");
    }
    return this.$fetch(this.anonEndpoint, {
      method: "post",
      body: data
    }).then((oauthResult) => {
      this.trigger("signin");
      return {
        ...oauthResult,
        isAnonymous: true,
        expiresAt: this.expires2ExpiresAt(oauthResult.expires)
      };
    });
  }
  async signin(data) {
    return this.$fetch(this.tokenEndpoint, {
      method: "post",
      body: data
    }).then((oauthResult) => {
      this.trigger("signin");
      return {
        ...oauthResult,
        expiresAt: this.expires2ExpiresAt(oauthResult.expires)
      };
    });
  }
  async getTokenByCode(code) {
    return this.$fetch(this.tokenEndpoint, {
      method: "post",
      body: {
        code,
        grantType: OAuthType.AUTHORIZATION_CODE
      }
    }).then((oauthResult) => {
      this.trigger("getTokenByCode");
      return {
        ...oauthResult,
        expiresAt: this.expires2ExpiresAt(oauthResult.expires)
      };
    });
  }
  async refreshToken(oauth) {
    if (!oauth || !oauth.refreshToken) {
      console.warn("refreshToken: no refresh token");
      return null;
    }
    return this.$fetch(this.tokenEndpoint, {
      method: "post",
      body: {
        refreshToken: oauth.refreshToken,
        grantType: OAuthType.REFRESH_TOKEN
      }
    }).then((oauthResult) => {
      this.trigger("refreshToken");
      return {
        ...oauthResult,
        expiresAt: this.expires2ExpiresAt(oauthResult.expires)
      };
    }).catch(() => {
      this.trigger("refreshTokenFailed");
      return null;
    });
  }
  expires2ExpiresAt(expires) {
    return expires * 1e3 + Date.now();
  }
}
class OAuthController {
  constructor(options) {
    this.refresh$ = new Subject();
    this.logout$ = new Subject();
    this.token$ = new BehaviorSubject(null);
    this.fetch = async (input, init) => {
      const request2 = new Request(input, init);
      return this.mw(request2, fetch);
    };
    this.activeRefresh = null;
    this.refreshTimer = null;
    this.options = options;
    const { storage, storageKey = OAUTH_KEY } = options;
    this.storage = storage;
    this.storageKey = storageKey;
    this.broadcast = new BroadcastChannel(storageKey);
    this.getStoredTokenPromise = this.updateCache();
    this.storage.watch((_event, key) => {
      if (key !== this.storageKey) {
        return;
      }
      this.updateCache();
    });
    fromEvent(this.broadcast, "message").subscribe((e) => {
      var _a;
      switch ((_a = e.data) == null ? void 0 : _a.event) {
        case "refresh":
          this.refresh$.next();
          break;
        case "logout":
          this.logout$.next(e.data.payload);
          break;
      }
    });
  }
  get token() {
    return this.token$.getValue();
  }
  set token(value) {
    this.token$.next(value);
  }
  getUserId() {
    var _a;
    return (_a = this.token) == null ? void 0 : _a.userId;
  }
  /**
   * This function allows the fetch-mw to be called as more traditional
   * middleware.
   *
   * This function returns a middleware function with the signature
   *    (request, next): Response
   */
  // mw(): FetchMiddleware {
  //   return async (request, next) => {
  //     const accessToken = await this.getAccessToken();
  //     // Make a clone. We need to clone if we need to retry the request later.
  //     let authenticatedRequest = request.clone();
  //     authenticatedRequest.headers.set('Authorization', 'Bearer ' + accessToken);
  //     let response = await next(authenticatedRequest);
  //     if (!response.ok && response.status === 401) {
  //       const newToken = await this.refreshToken();
  //       authenticatedRequest = request.clone();
  //       authenticatedRequest.headers.set('Authorization', 'Bearer ' + newToken.accessToken);
  //       response = await next(authenticatedRequest);
  //     }
  //     return response;
  //   };
  // }
  /**
   * @deprecated
   */
  async mw(request2, fetcher) {
    const accessToken = await this.getAccessToken();
    let authenticatedRequest = request2.clone();
    authenticatedRequest.headers.set("Authorization", "Bearer " + accessToken);
    const response = await fetcher(authenticatedRequest);
    if (!response.ok && response.status === 401) {
      const res = await response.clone().json();
      if (res.error !== "Token Not Verified")
        return response;
      const newToken = await this.refreshToken();
      authenticatedRequest = request2.clone();
      authenticatedRequest.headers.set("Authorization", "Bearer " + newToken.accessToken);
      try {
        return await fetcher(authenticatedRequest);
      } catch (error) {
        return response;
      }
    }
    return response;
  }
  async setToken(token) {
    this.token = token;
    this.getStoredTokenPromise = Promise.resolve();
    await this.storage.setItem(this.storageKey, token);
    if (token && this.options.scheduleRefresh !== false) {
      this.scheduleRefresh();
    }
  }
  /**
   * Returns current token information.
   *
   * There result object will have:
   *   * accessToken
   *   * expiresAt - when the token expires, or null.
   *   * refreshToken - may be null
   *
   * This function will attempt to automatically refresh if stale.
   */
  async getToken() {
    await this.getStoredTokenPromise;
    if (this.token && (!this.token.expiresAt || this.token.expiresAt > Date.now())) {
      return this.token;
    }
    return this.refreshToken();
  }
  /**
   * Returns an access token.
   *
   * If the current access token is not known, it will attempt to fetch it.
   * If the access token is expiring, it will attempt to refresh it.
   */
  async getAccessToken() {
    const token = await this.getToken();
    return token.accessToken;
  }
  async getFallbackToken() {
    return null;
  }
  async doRefreshToken(oldToken) {
    var _a, _b;
    let newToken = null;
    try {
      if (oldToken == null ? void 0 : oldToken.refreshToken) {
        newToken = await this.options.client.refreshToken(oldToken);
      }
    } catch (err) {
      console.warn("refresh token not accepted");
    }
    if (!newToken) {
      newToken = await this.getFallbackToken();
    }
    if (!newToken) {
      const err = new Error("Please sign in  again");
      (_b = (_a = this.options).onError) == null ? void 0 : _b.call(_a, err);
      throw err;
    }
    return newToken;
  }
  /**
   * Forces an access token refresh
   */
  async refreshToken() {
    await this.getStoredTokenPromise;
    if (this.activeRefresh) {
      return this.activeRefresh;
    }
    this.activeRefresh = this.doRefreshToken(this.token);
    try {
      const token = await this.activeRefresh;
      await this.setToken(token);
      return token;
    } catch (err) {
      if (this.options.onError) {
        this.options.onError(err);
      }
      await this.logout();
      throw err;
    } finally {
      this.activeRefresh = null;
    }
  }
  async logout(payload, { broadcast = true } = {}) {
    this.token$.next(null);
    await this.storage.removeItem(this.storageKey);
    this.logout$.next(payload);
    if (broadcast) {
      this.broadcast.postMessage({
        event: "logout",
        payload
      });
    }
  }
  scheduleRefresh() {
    if (this.refreshTimer) {
      clearTimeout(this.refreshTimer);
      this.refreshTimer = null;
    }
    if (!this.token || !this.token.expiresAt || !this.token.refreshToken) {
      return;
    }
    const expiresIn = this.token.expiresAt - Date.now();
    if (expiresIn < 120 * 1e3) {
      return;
    }
    this.refreshTimer = setTimeout(
      async () => {
        try {
          await this.refreshToken();
        } catch (err) {
          console.error("error while doing a background OAuth2 auto-refresh", err);
        }
      },
      expiresIn - 60 * 1e3
    );
  }
  async readToken() {
    return this.storage.getItem(this.storageKey);
  }
  updateCache() {
    const promise = this.readToken().then((value) => {
      if (promise === this.getStoredTokenPromise) {
        this.token = value;
      }
    });
    this.getStoredTokenPromise = promise;
    return promise;
  }
}

function getFetchQuery(appId) {
    const query = {
        version: VERSION,
        client: CLIENT
    };
    if (appId) {
        query['appId'] = appId;
    }
    return query;
}
async function $logCls(region, logs) {
    const topic_id = region === Region$1.CHINA ? '3d602bc3-08c7-458a-bce1-5402fc1cffd6' : '5e212c4b-a5d0-422b-8182-7fd0b991ddfa';
    const baseURL = region === Region$1.CHINA ? 'https://ap-shanghai.cls.tencentcs.com' : `https://cls.demoway.com`;
    await ofetch('/tracklog', {
        baseURL,
        method: 'POST',
        query: {
            topic_id
        },
        body: {
            source: CLIENT,
            logs
        }
    });
}
function checkAppId(appId, region, getUserId, attr) {
    if (appId !== null && appId !== undefined && (typeof appId !== 'string' || appId === 'Infinity')) {
        const error = new Error();
        const attributes = JSON.stringify({
            ...attr,
            valueType: typeof appId
        });
        getUserId().then((userId)=>{
            return $logCls(region, [
                {
                    time: Date.now(),
                    contents: {
                        context: 'verify app id',
                        subject: 'invalid app id',
                        message: '',
                        stack: error.stack || '',
                        userId,
                        appId: appId,
                        client: CLIENT,
                        level: 'error',
                        attributes
                    }
                }
            ]);
        });
        return false;
    }
    return true;
}
function createFetch(storage, oauth, region) {
    return createOAuthFetch(oauth).create({
        async onRequest (context, next) {
            await next();
            const items = await storage.getItems([
                APP_ID_KEY,
                ENV_KEY,
                LOCALE_KEY
            ]);
            const values = Object.fromEntries(items.map(({ key, value })=>[
                    key,
                    value
                ]));
            const appId = values[APP_ID_KEY];
            const env = values[ENV_KEY];
            const locale = values[LOCALE_KEY];
            if (!checkAppId(appId, region, async ()=>{
                return oauth.token$.getValue()?.userId || '';
            }, {
                from: '$fetch'
            })) {
                oauth.logout();
                throw new Error('Please sign in again');
            }
            const headers = new Headers(context.options.headers);
            if (locale) {
                headers.set('Accept-Language', locale);
            }
            context.options.headers = headers;
            context.options.baseURL = getServerOrigin(env || 'production', region);
            const query = {
                ...context.options.query || {},
                ...getFetchQuery(appId)
            };
            context.options.query = query;
        }
    });
}

// Note: This file is autogenerated using "resources/gen-version.js" script and
// automatically updated by "npm version" command.

/**
 * An object containing the components of the GraphQL.js version string
 */

const versionInfo = Object.freeze({
  major: 16,
  minor: 9,
  patch: 0,
  preReleaseTag: null,
});

/**
 * Returns true if the value acts like a Promise, i.e. has a "then" function,
 * otherwise returns false.
 */
function isPromise(value) {
  return (
    typeof (value === null || value === void 0 ? void 0 : value.then) ===
    'function'
  );
}

/**
 * Return true if `value` is object-like. A value is object-like if it's not
 * `null` and has a `typeof` result of "object".
 */
function isObjectLike$1(value) {
  return typeof value == 'object' && value !== null;
}

function invariant(condition, message) {
  const booleanCondition = Boolean(condition);

  if (!booleanCondition) {
    throw new Error(
      message != null ? message : 'Unexpected invariant triggered.',
    );
  }
}

const LineRegExp = /\r\n|[\n\r]/g;
/**
 * Represents a location in a Source.
 */

/**
 * Takes a Source and a UTF-8 character offset, and returns the corresponding
 * line and column as a SourceLocation.
 */
function getLocation(source, position) {
  let lastLineStart = 0;
  let line = 1;

  for (const match of source.body.matchAll(LineRegExp)) {
    typeof match.index === 'number' || invariant(false);

    if (match.index >= position) {
      break;
    }

    lastLineStart = match.index + match[0].length;
    line += 1;
  }

  return {
    line,
    column: position + 1 - lastLineStart,
  };
}

/**
 * Render a helpful description of the location in the GraphQL Source document.
 */
function printLocation(location) {
  return printSourceLocation(
    location.source,
    getLocation(location.source, location.start),
  );
}
/**
 * Render a helpful description of the location in the GraphQL Source document.
 */

function printSourceLocation(source, sourceLocation) {
  const firstLineColumnOffset = source.locationOffset.column - 1;
  const body = ''.padStart(firstLineColumnOffset) + source.body;
  const lineIndex = sourceLocation.line - 1;
  const lineOffset = source.locationOffset.line - 1;
  const lineNum = sourceLocation.line + lineOffset;
  const columnOffset = sourceLocation.line === 1 ? firstLineColumnOffset : 0;
  const columnNum = sourceLocation.column + columnOffset;
  const locationStr = `${source.name}:${lineNum}:${columnNum}\n`;
  const lines = body.split(/\r\n|[\n\r]/g);
  const locationLine = lines[lineIndex]; // Special case for minified documents

  if (locationLine.length > 120) {
    const subLineIndex = Math.floor(columnNum / 80);
    const subLineColumnNum = columnNum % 80;
    const subLines = [];

    for (let i = 0; i < locationLine.length; i += 80) {
      subLines.push(locationLine.slice(i, i + 80));
    }

    return (
      locationStr +
      printPrefixedLines([
        [`${lineNum} |`, subLines[0]],
        ...subLines.slice(1, subLineIndex + 1).map((subLine) => ['|', subLine]),
        ['|', '^'.padStart(subLineColumnNum)],
        ['|', subLines[subLineIndex + 1]],
      ])
    );
  }

  return (
    locationStr +
    printPrefixedLines([
      // Lines specified like this: ["prefix", "string"],
      [`${lineNum - 1} |`, lines[lineIndex - 1]],
      [`${lineNum} |`, locationLine],
      ['|', '^'.padStart(columnNum)],
      [`${lineNum + 1} |`, lines[lineIndex + 1]],
    ])
  );
}

function printPrefixedLines(lines) {
  const existingLines = lines.filter(([_, line]) => line !== undefined);
  const padLen = Math.max(...existingLines.map(([prefix]) => prefix.length));
  return existingLines
    .map(([prefix, line]) => prefix.padStart(padLen) + (line ? ' ' + line : ''))
    .join('\n');
}

function toNormalizedOptions(args) {
  const firstArg = args[0];

  if (firstArg == null || 'kind' in firstArg || 'length' in firstArg) {
    return {
      nodes: firstArg,
      source: args[1],
      positions: args[2],
      path: args[3],
      originalError: args[4],
      extensions: args[5],
    };
  }

  return firstArg;
}
/**
 * A GraphQLError describes an Error found during the parse, validate, or
 * execute phases of performing a GraphQL operation. In addition to a message
 * and stack trace, it also includes information about the locations in a
 * GraphQL document and/or execution result that correspond to the Error.
 */

class GraphQLError extends Error {
  /**
   * An array of `{ line, column }` locations within the source GraphQL document
   * which correspond to this error.
   *
   * Errors during validation often contain multiple locations, for example to
   * point out two things with the same name. Errors during execution include a
   * single location, the field which produced the error.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array describing the JSON-path into the execution response which
   * corresponds to this error. Only included for errors during execution.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array of GraphQL AST Nodes corresponding to this error.
   */

  /**
   * The source GraphQL document for the first location of this error.
   *
   * Note that if this Error represents more than one node, the source may not
   * represent nodes after the first node.
   */

  /**
   * An array of character offsets within the source GraphQL document
   * which correspond to this error.
   */

  /**
   * The original error thrown from a field resolver during execution.
   */

  /**
   * Extension fields to add to the formatted error.
   */

  /**
   * @deprecated Please use the `GraphQLErrorOptions` constructor overload instead.
   */
  constructor(message, ...rawArgs) {
    var _this$nodes, _nodeLocations$, _ref;

    const { nodes, source, positions, path, originalError, extensions } =
      toNormalizedOptions(rawArgs);
    super(message);
    this.name = 'GraphQLError';
    this.path = path !== null && path !== void 0 ? path : undefined;
    this.originalError =
      originalError !== null && originalError !== void 0
        ? originalError
        : undefined; // Compute list of blame nodes.

    this.nodes = undefinedIfEmpty(
      Array.isArray(nodes) ? nodes : nodes ? [nodes] : undefined,
    );
    const nodeLocations = undefinedIfEmpty(
      (_this$nodes = this.nodes) === null || _this$nodes === void 0
        ? void 0
        : _this$nodes.map((node) => node.loc).filter((loc) => loc != null),
    ); // Compute locations in the source for the given nodes/positions.

    this.source =
      source !== null && source !== void 0
        ? source
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : (_nodeLocations$ = nodeLocations[0]) === null ||
          _nodeLocations$ === void 0
        ? void 0
        : _nodeLocations$.source;
    this.positions =
      positions !== null && positions !== void 0
        ? positions
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : nodeLocations.map((loc) => loc.start);
    this.locations =
      positions && source
        ? positions.map((pos) => getLocation(source, pos))
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : nodeLocations.map((loc) => getLocation(loc.source, loc.start));
    const originalExtensions = isObjectLike$1(
      originalError === null || originalError === void 0
        ? void 0
        : originalError.extensions,
    )
      ? originalError === null || originalError === void 0
        ? void 0
        : originalError.extensions
      : undefined;
    this.extensions =
      (_ref =
        extensions !== null && extensions !== void 0
          ? extensions
          : originalExtensions) !== null && _ref !== void 0
        ? _ref
        : Object.create(null); // Only properties prescribed by the spec should be enumerable.
    // Keep the rest as non-enumerable.

    Object.defineProperties(this, {
      message: {
        writable: true,
        enumerable: true,
      },
      name: {
        enumerable: false,
      },
      nodes: {
        enumerable: false,
      },
      source: {
        enumerable: false,
      },
      positions: {
        enumerable: false,
      },
      originalError: {
        enumerable: false,
      },
    }); // Include (non-enumerable) stack trace.

    /* c8 ignore start */
    // FIXME: https://github.com/graphql/graphql-js/issues/2317

    if (
      originalError !== null &&
      originalError !== void 0 &&
      originalError.stack
    ) {
      Object.defineProperty(this, 'stack', {
        value: originalError.stack,
        writable: true,
        configurable: true,
      });
    } else if (Error.captureStackTrace) {
      Error.captureStackTrace(this, GraphQLError);
    } else {
      Object.defineProperty(this, 'stack', {
        value: Error().stack,
        writable: true,
        configurable: true,
      });
    }
    /* c8 ignore stop */
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLError';
  }

  toString() {
    let output = this.message;

    if (this.nodes) {
      for (const node of this.nodes) {
        if (node.loc) {
          output += '\n\n' + printLocation(node.loc);
        }
      }
    } else if (this.source && this.locations) {
      for (const location of this.locations) {
        output += '\n\n' + printSourceLocation(this.source, location);
      }
    }

    return output;
  }

  toJSON() {
    const formattedError = {
      message: this.message,
    };

    if (this.locations != null) {
      formattedError.locations = this.locations;
    }

    if (this.path != null) {
      formattedError.path = this.path;
    }

    if (this.extensions != null && Object.keys(this.extensions).length > 0) {
      formattedError.extensions = this.extensions;
    }

    return formattedError;
  }
}

function undefinedIfEmpty(array) {
  return array === undefined || array.length === 0 ? undefined : array;
}

/**
 * Produces a GraphQLError representing a syntax error, containing useful
 * descriptive information about the syntax error's position in the source.
 */

function syntaxError(source, position, description) {
  return new GraphQLError(`Syntax Error: ${description}`, {
    source,
    positions: [position],
  });
}

/**
 * The set of allowed directive location values.
 */
var DirectiveLocation;

(function (DirectiveLocation) {
  DirectiveLocation['QUERY'] = 'QUERY';
  DirectiveLocation['MUTATION'] = 'MUTATION';
  DirectiveLocation['SUBSCRIPTION'] = 'SUBSCRIPTION';
  DirectiveLocation['FIELD'] = 'FIELD';
  DirectiveLocation['FRAGMENT_DEFINITION'] = 'FRAGMENT_DEFINITION';
  DirectiveLocation['FRAGMENT_SPREAD'] = 'FRAGMENT_SPREAD';
  DirectiveLocation['INLINE_FRAGMENT'] = 'INLINE_FRAGMENT';
  DirectiveLocation['VARIABLE_DEFINITION'] = 'VARIABLE_DEFINITION';
  DirectiveLocation['SCHEMA'] = 'SCHEMA';
  DirectiveLocation['SCALAR'] = 'SCALAR';
  DirectiveLocation['OBJECT'] = 'OBJECT';
  DirectiveLocation['FIELD_DEFINITION'] = 'FIELD_DEFINITION';
  DirectiveLocation['ARGUMENT_DEFINITION'] = 'ARGUMENT_DEFINITION';
  DirectiveLocation['INTERFACE'] = 'INTERFACE';
  DirectiveLocation['UNION'] = 'UNION';
  DirectiveLocation['ENUM'] = 'ENUM';
  DirectiveLocation['ENUM_VALUE'] = 'ENUM_VALUE';
  DirectiveLocation['INPUT_OBJECT'] = 'INPUT_OBJECT';
  DirectiveLocation['INPUT_FIELD_DEFINITION'] = 'INPUT_FIELD_DEFINITION';
})(DirectiveLocation || (DirectiveLocation = {}));
/**
 * The enum type representing the directive location values.
 *
 * @deprecated Please use `DirectiveLocation`. Will be remove in v17.
 */

/**
 * An exported enum describing the different kinds of tokens that the
 * lexer emits.
 */
var TokenKind;

(function (TokenKind) {
  TokenKind['SOF'] = '<SOF>';
  TokenKind['EOF'] = '<EOF>';
  TokenKind['BANG'] = '!';
  TokenKind['DOLLAR'] = '$';
  TokenKind['AMP'] = '&';
  TokenKind['PAREN_L'] = '(';
  TokenKind['PAREN_R'] = ')';
  TokenKind['SPREAD'] = '...';
  TokenKind['COLON'] = ':';
  TokenKind['EQUALS'] = '=';
  TokenKind['AT'] = '@';
  TokenKind['BRACKET_L'] = '[';
  TokenKind['BRACKET_R'] = ']';
  TokenKind['BRACE_L'] = '{';
  TokenKind['PIPE'] = '|';
  TokenKind['BRACE_R'] = '}';
  TokenKind['NAME'] = 'Name';
  TokenKind['INT'] = 'Int';
  TokenKind['FLOAT'] = 'Float';
  TokenKind['STRING'] = 'String';
  TokenKind['BLOCK_STRING'] = 'BlockString';
  TokenKind['COMMENT'] = 'Comment';
})(TokenKind || (TokenKind = {}));
/**
 * The enum type representing the token kinds values.
 *
 * @deprecated Please use `TokenKind`. Will be remove in v17.
 */

/**
 * Given a Source object, creates a Lexer for that source.
 * A Lexer is a stateful stream generator in that every time
 * it is advanced, it returns the next token in the Source. Assuming the
 * source lexes, the final Token emitted by the lexer will be of kind
 * EOF, after which the lexer will repeatedly return the same EOF token
 * whenever called.
 */

class Lexer {
  /**
   * The previously focused non-ignored token.
   */

  /**
   * The currently focused non-ignored token.
   */

  /**
   * The (1-indexed) line containing the current token.
   */

  /**
   * The character offset at which the current line begins.
   */
  constructor(source) {
    const startOfFileToken = new Token$1(TokenKind.SOF, 0, 0, 0, 0);
    this.source = source;
    this.lastToken = startOfFileToken;
    this.token = startOfFileToken;
    this.line = 1;
    this.lineStart = 0;
  }

  get [Symbol.toStringTag]() {
    return 'Lexer';
  }
  /**
   * Advances the token stream to the next non-ignored token.
   */

  advance() {
    this.lastToken = this.token;
    const token = (this.token = this.lookahead());
    return token;
  }
  /**
   * Looks ahead and returns the next non-ignored token, but does not change
   * the state of Lexer.
   */

  lookahead() {
    let token = this.token;

    if (token.kind !== TokenKind.EOF) {
      do {
        if (token.next) {
          token = token.next;
        } else {
          // Read the next token and form a link in the token linked-list.
          const nextToken = readNextToken(this, token.end); // @ts-expect-error next is only mutable during parsing.

          token.next = nextToken; // @ts-expect-error prev is only mutable during parsing.

          nextToken.prev = token;
          token = nextToken;
        }
      } while (token.kind === TokenKind.COMMENT);
    }

    return token;
  }
}
/**
 * @internal
 */

function isPunctuatorTokenKind(kind) {
  return (
    kind === TokenKind.BANG ||
    kind === TokenKind.DOLLAR ||
    kind === TokenKind.AMP ||
    kind === TokenKind.PAREN_L ||
    kind === TokenKind.PAREN_R ||
    kind === TokenKind.SPREAD ||
    kind === TokenKind.COLON ||
    kind === TokenKind.EQUALS ||
    kind === TokenKind.AT ||
    kind === TokenKind.BRACKET_L ||
    kind === TokenKind.BRACKET_R ||
    kind === TokenKind.BRACE_L ||
    kind === TokenKind.PIPE ||
    kind === TokenKind.BRACE_R
  );
}
/**
 * A Unicode scalar value is any Unicode code point except surrogate code
 * points. In other words, the inclusive ranges of values 0x0000 to 0xD7FF and
 * 0xE000 to 0x10FFFF.
 *
 * SourceCharacter ::
 *   - "Any Unicode scalar value"
 */

function isUnicodeScalarValue(code) {
  return (
    (code >= 0x0000 && code <= 0xd7ff) || (code >= 0xe000 && code <= 0x10ffff)
  );
}
/**
 * The GraphQL specification defines source text as a sequence of unicode scalar
 * values (which Unicode defines to exclude surrogate code points). However
 * JavaScript defines strings as a sequence of UTF-16 code units which may
 * include surrogates. A surrogate pair is a valid source character as it
 * encodes a supplementary code point (above U+FFFF), but unpaired surrogate
 * code points are not valid source characters.
 */

function isSupplementaryCodePoint(body, location) {
  return (
    isLeadingSurrogate(body.charCodeAt(location)) &&
    isTrailingSurrogate(body.charCodeAt(location + 1))
  );
}

function isLeadingSurrogate(code) {
  return code >= 0xd800 && code <= 0xdbff;
}

function isTrailingSurrogate(code) {
  return code >= 0xdc00 && code <= 0xdfff;
}
/**
 * Prints the code point (or end of file reference) at a given location in a
 * source for use in error messages.
 *
 * Printable ASCII is printed quoted, while other points are printed in Unicode
 * code point form (ie. U+1234).
 */

function printCodePointAt(lexer, location) {
  const code = lexer.source.body.codePointAt(location);

  if (code === undefined) {
    return TokenKind.EOF;
  } else if (code >= 0x0020 && code <= 0x007e) {
    // Printable ASCII
    const char = String.fromCodePoint(code);
    return char === '"' ? "'\"'" : `"${char}"`;
  } // Unicode code point

  return 'U+' + code.toString(16).toUpperCase().padStart(4, '0');
}
/**
 * Create a token with line and column location information.
 */

function createToken(lexer, kind, start, end, value) {
  const line = lexer.line;
  const col = 1 + start - lexer.lineStart;
  return new Token$1(kind, start, end, line, col, value);
}
/**
 * Gets the next token from the source starting at the given position.
 *
 * This skips over whitespace until it finds the next lexable token, then lexes
 * punctuators immediately or calls the appropriate helper function for more
 * complicated tokens.
 */

function readNextToken(lexer, start) {
  const body = lexer.source.body;
  const bodyLength = body.length;
  let position = start;

  while (position < bodyLength) {
    const code = body.charCodeAt(position); // SourceCharacter

    switch (code) {
      // Ignored ::
      //   - UnicodeBOM
      //   - WhiteSpace
      //   - LineTerminator
      //   - Comment
      //   - Comma
      //
      // UnicodeBOM :: "Byte Order Mark (U+FEFF)"
      //
      // WhiteSpace ::
      //   - "Horizontal Tab (U+0009)"
      //   - "Space (U+0020)"
      //
      // Comma :: ,
      case 0xfeff: // <BOM>

      case 0x0009: // \t

      case 0x0020: // <space>

      case 0x002c:
        // ,
        ++position;
        continue;
      // LineTerminator ::
      //   - "New Line (U+000A)"
      //   - "Carriage Return (U+000D)" [lookahead != "New Line (U+000A)"]
      //   - "Carriage Return (U+000D)" "New Line (U+000A)"

      case 0x000a:
        // \n
        ++position;
        ++lexer.line;
        lexer.lineStart = position;
        continue;

      case 0x000d:
        // \r
        if (body.charCodeAt(position + 1) === 0x000a) {
          position += 2;
        } else {
          ++position;
        }

        ++lexer.line;
        lexer.lineStart = position;
        continue;
      // Comment

      case 0x0023:
        // #
        return readComment(lexer, position);
      // Token ::
      //   - Punctuator
      //   - Name
      //   - IntValue
      //   - FloatValue
      //   - StringValue
      //
      // Punctuator :: one of ! $ & ( ) ... : = @ [ ] { | }

      case 0x0021:
        // !
        return createToken(lexer, TokenKind.BANG, position, position + 1);

      case 0x0024:
        // $
        return createToken(lexer, TokenKind.DOLLAR, position, position + 1);

      case 0x0026:
        // &
        return createToken(lexer, TokenKind.AMP, position, position + 1);

      case 0x0028:
        // (
        return createToken(lexer, TokenKind.PAREN_L, position, position + 1);

      case 0x0029:
        // )
        return createToken(lexer, TokenKind.PAREN_R, position, position + 1);

      case 0x002e:
        // .
        if (
          body.charCodeAt(position + 1) === 0x002e &&
          body.charCodeAt(position + 2) === 0x002e
        ) {
          return createToken(lexer, TokenKind.SPREAD, position, position + 3);
        }

        break;

      case 0x003a:
        // :
        return createToken(lexer, TokenKind.COLON, position, position + 1);

      case 0x003d:
        // =
        return createToken(lexer, TokenKind.EQUALS, position, position + 1);

      case 0x0040:
        // @
        return createToken(lexer, TokenKind.AT, position, position + 1);

      case 0x005b:
        // [
        return createToken(lexer, TokenKind.BRACKET_L, position, position + 1);

      case 0x005d:
        // ]
        return createToken(lexer, TokenKind.BRACKET_R, position, position + 1);

      case 0x007b:
        // {
        return createToken(lexer, TokenKind.BRACE_L, position, position + 1);

      case 0x007c:
        // |
        return createToken(lexer, TokenKind.PIPE, position, position + 1);

      case 0x007d:
        // }
        return createToken(lexer, TokenKind.BRACE_R, position, position + 1);
      // StringValue

      case 0x0022:
        // "
        if (
          body.charCodeAt(position + 1) === 0x0022 &&
          body.charCodeAt(position + 2) === 0x0022
        ) {
          return readBlockString(lexer, position);
        }

        return readString(lexer, position);
    } // IntValue | FloatValue (Digit | -)

    if (isDigit$1(code) || code === 0x002d) {
      return readNumber(lexer, position, code);
    } // Name

    if (isNameStart(code)) {
      return readName(lexer, position);
    }

    throw syntaxError(
      lexer.source,
      position,
      code === 0x0027
        ? 'Unexpected single quote character (\'), did you mean to use a double quote (")?'
        : isUnicodeScalarValue(code) || isSupplementaryCodePoint(body, position)
        ? `Unexpected character: ${printCodePointAt(lexer, position)}.`
        : `Invalid character: ${printCodePointAt(lexer, position)}.`,
    );
  }

  return createToken(lexer, TokenKind.EOF, bodyLength, bodyLength);
}
/**
 * Reads a comment token from the source file.
 *
 * ```
 * Comment :: # CommentChar* [lookahead != CommentChar]
 *
 * CommentChar :: SourceCharacter but not LineTerminator
 * ```
 */

function readComment(lexer, start) {
  const body = lexer.source.body;
  const bodyLength = body.length;
  let position = start + 1;

  while (position < bodyLength) {
    const code = body.charCodeAt(position); // LineTerminator (\n | \r)

    if (code === 0x000a || code === 0x000d) {
      break;
    } // SourceCharacter

    if (isUnicodeScalarValue(code)) {
      ++position;
    } else if (isSupplementaryCodePoint(body, position)) {
      position += 2;
    } else {
      break;
    }
  }

  return createToken(
    lexer,
    TokenKind.COMMENT,
    start,
    position,
    body.slice(start + 1, position),
  );
}
/**
 * Reads a number token from the source file, either a FloatValue or an IntValue
 * depending on whether a FractionalPart or ExponentPart is encountered.
 *
 * ```
 * IntValue :: IntegerPart [lookahead != {Digit, `.`, NameStart}]
 *
 * IntegerPart ::
 *   - NegativeSign? 0
 *   - NegativeSign? NonZeroDigit Digit*
 *
 * NegativeSign :: -
 *
 * NonZeroDigit :: Digit but not `0`
 *
 * FloatValue ::
 *   - IntegerPart FractionalPart ExponentPart [lookahead != {Digit, `.`, NameStart}]
 *   - IntegerPart FractionalPart [lookahead != {Digit, `.`, NameStart}]
 *   - IntegerPart ExponentPart [lookahead != {Digit, `.`, NameStart}]
 *
 * FractionalPart :: . Digit+
 *
 * ExponentPart :: ExponentIndicator Sign? Digit+
 *
 * ExponentIndicator :: one of `e` `E`
 *
 * Sign :: one of + -
 * ```
 */

function readNumber(lexer, start, firstCode) {
  const body = lexer.source.body;
  let position = start;
  let code = firstCode;
  let isFloat = false; // NegativeSign (-)

  if (code === 0x002d) {
    code = body.charCodeAt(++position);
  } // Zero (0)

  if (code === 0x0030) {
    code = body.charCodeAt(++position);

    if (isDigit$1(code)) {
      throw syntaxError(
        lexer.source,
        position,
        `Invalid number, unexpected digit after 0: ${printCodePointAt(
          lexer,
          position,
        )}.`,
      );
    }
  } else {
    position = readDigits(lexer, position, code);
    code = body.charCodeAt(position);
  } // Full stop (.)

  if (code === 0x002e) {
    isFloat = true;
    code = body.charCodeAt(++position);
    position = readDigits(lexer, position, code);
    code = body.charCodeAt(position);
  } // E e

  if (code === 0x0045 || code === 0x0065) {
    isFloat = true;
    code = body.charCodeAt(++position); // + -

    if (code === 0x002b || code === 0x002d) {
      code = body.charCodeAt(++position);
    }

    position = readDigits(lexer, position, code);
    code = body.charCodeAt(position);
  } // Numbers cannot be followed by . or NameStart

  if (code === 0x002e || isNameStart(code)) {
    throw syntaxError(
      lexer.source,
      position,
      `Invalid number, expected digit but got: ${printCodePointAt(
        lexer,
        position,
      )}.`,
    );
  }

  return createToken(
    lexer,
    isFloat ? TokenKind.FLOAT : TokenKind.INT,
    start,
    position,
    body.slice(start, position),
  );
}
/**
 * Returns the new position in the source after reading one or more digits.
 */

function readDigits(lexer, start, firstCode) {
  if (!isDigit$1(firstCode)) {
    throw syntaxError(
      lexer.source,
      start,
      `Invalid number, expected digit but got: ${printCodePointAt(
        lexer,
        start,
      )}.`,
    );
  }

  const body = lexer.source.body;
  let position = start + 1; // +1 to skip first firstCode

  while (isDigit$1(body.charCodeAt(position))) {
    ++position;
  }

  return position;
}
/**
 * Reads a single-quote string token from the source file.
 *
 * ```
 * StringValue ::
 *   - `""` [lookahead != `"`]
 *   - `"` StringCharacter+ `"`
 *
 * StringCharacter ::
 *   - SourceCharacter but not `"` or `\` or LineTerminator
 *   - `\u` EscapedUnicode
 *   - `\` EscapedCharacter
 *
 * EscapedUnicode ::
 *   - `{` HexDigit+ `}`
 *   - HexDigit HexDigit HexDigit HexDigit
 *
 * EscapedCharacter :: one of `"` `\` `/` `b` `f` `n` `r` `t`
 * ```
 */

function readString(lexer, start) {
  const body = lexer.source.body;
  const bodyLength = body.length;
  let position = start + 1;
  let chunkStart = position;
  let value = '';

  while (position < bodyLength) {
    const code = body.charCodeAt(position); // Closing Quote (")

    if (code === 0x0022) {
      value += body.slice(chunkStart, position);
      return createToken(lexer, TokenKind.STRING, start, position + 1, value);
    } // Escape Sequence (\)

    if (code === 0x005c) {
      value += body.slice(chunkStart, position);
      const escape =
        body.charCodeAt(position + 1) === 0x0075 // u
          ? body.charCodeAt(position + 2) === 0x007b // {
            ? readEscapedUnicodeVariableWidth(lexer, position)
            : readEscapedUnicodeFixedWidth(lexer, position)
          : readEscapedCharacter(lexer, position);
      value += escape.value;
      position += escape.size;
      chunkStart = position;
      continue;
    } // LineTerminator (\n | \r)

    if (code === 0x000a || code === 0x000d) {
      break;
    } // SourceCharacter

    if (isUnicodeScalarValue(code)) {
      ++position;
    } else if (isSupplementaryCodePoint(body, position)) {
      position += 2;
    } else {
      throw syntaxError(
        lexer.source,
        position,
        `Invalid character within String: ${printCodePointAt(
          lexer,
          position,
        )}.`,
      );
    }
  }

  throw syntaxError(lexer.source, position, 'Unterminated string.');
} // The string value and lexed size of an escape sequence.

function readEscapedUnicodeVariableWidth(lexer, position) {
  const body = lexer.source.body;
  let point = 0;
  let size = 3; // Cannot be larger than 12 chars (\u{00000000}).

  while (size < 12) {
    const code = body.charCodeAt(position + size++); // Closing Brace (})

    if (code === 0x007d) {
      // Must be at least 5 chars (\u{0}) and encode a Unicode scalar value.
      if (size < 5 || !isUnicodeScalarValue(point)) {
        break;
      }

      return {
        value: String.fromCodePoint(point),
        size,
      };
    } // Append this hex digit to the code point.

    point = (point << 4) | readHexDigit(code);

    if (point < 0) {
      break;
    }
  }

  throw syntaxError(
    lexer.source,
    position,
    `Invalid Unicode escape sequence: "${body.slice(
      position,
      position + size,
    )}".`,
  );
}

function readEscapedUnicodeFixedWidth(lexer, position) {
  const body = lexer.source.body;
  const code = read16BitHexCode(body, position + 2);

  if (isUnicodeScalarValue(code)) {
    return {
      value: String.fromCodePoint(code),
      size: 6,
    };
  } // GraphQL allows JSON-style surrogate pair escape sequences, but only when
  // a valid pair is formed.

  if (isLeadingSurrogate(code)) {
    // \u
    if (
      body.charCodeAt(position + 6) === 0x005c &&
      body.charCodeAt(position + 7) === 0x0075
    ) {
      const trailingCode = read16BitHexCode(body, position + 8);

      if (isTrailingSurrogate(trailingCode)) {
        // JavaScript defines strings as a sequence of UTF-16 code units and
        // encodes Unicode code points above U+FFFF using a surrogate pair of
        // code units. Since this is a surrogate pair escape sequence, just
        // include both codes into the JavaScript string value. Had JavaScript
        // not been internally based on UTF-16, then this surrogate pair would
        // be decoded to retrieve the supplementary code point.
        return {
          value: String.fromCodePoint(code, trailingCode),
          size: 12,
        };
      }
    }
  }

  throw syntaxError(
    lexer.source,
    position,
    `Invalid Unicode escape sequence: "${body.slice(position, position + 6)}".`,
  );
}
/**
 * Reads four hexadecimal characters and returns the positive integer that 16bit
 * hexadecimal string represents. For example, "000f" will return 15, and "dead"
 * will return 57005.
 *
 * Returns a negative number if any char was not a valid hexadecimal digit.
 */

function read16BitHexCode(body, position) {
  // readHexDigit() returns -1 on error. ORing a negative value with any other
  // value always produces a negative value.
  return (
    (readHexDigit(body.charCodeAt(position)) << 12) |
    (readHexDigit(body.charCodeAt(position + 1)) << 8) |
    (readHexDigit(body.charCodeAt(position + 2)) << 4) |
    readHexDigit(body.charCodeAt(position + 3))
  );
}
/**
 * Reads a hexadecimal character and returns its positive integer value (0-15).
 *
 * '0' becomes 0, '9' becomes 9
 * 'A' becomes 10, 'F' becomes 15
 * 'a' becomes 10, 'f' becomes 15
 *
 * Returns -1 if the provided character code was not a valid hexadecimal digit.
 *
 * HexDigit :: one of
 *   - `0` `1` `2` `3` `4` `5` `6` `7` `8` `9`
 *   - `A` `B` `C` `D` `E` `F`
 *   - `a` `b` `c` `d` `e` `f`
 */

function readHexDigit(code) {
  return code >= 0x0030 && code <= 0x0039 // 0-9
    ? code - 0x0030
    : code >= 0x0041 && code <= 0x0046 // A-F
    ? code - 0x0037
    : code >= 0x0061 && code <= 0x0066 // a-f
    ? code - 0x0057
    : -1;
}
/**
 * | Escaped Character | Code Point | Character Name               |
 * | ----------------- | ---------- | ---------------------------- |
 * | `"`               | U+0022     | double quote                 |
 * | `\`               | U+005C     | reverse solidus (back slash) |
 * | `/`               | U+002F     | solidus (forward slash)      |
 * | `b`               | U+0008     | backspace                    |
 * | `f`               | U+000C     | form feed                    |
 * | `n`               | U+000A     | line feed (new line)         |
 * | `r`               | U+000D     | carriage return              |
 * | `t`               | U+0009     | horizontal tab               |
 */

function readEscapedCharacter(lexer, position) {
  const body = lexer.source.body;
  const code = body.charCodeAt(position + 1);

  switch (code) {
    case 0x0022:
      // "
      return {
        value: '\u0022',
        size: 2,
      };

    case 0x005c:
      // \
      return {
        value: '\u005c',
        size: 2,
      };

    case 0x002f:
      // /
      return {
        value: '\u002f',
        size: 2,
      };

    case 0x0062:
      // b
      return {
        value: '\u0008',
        size: 2,
      };

    case 0x0066:
      // f
      return {
        value: '\u000c',
        size: 2,
      };

    case 0x006e:
      // n
      return {
        value: '\u000a',
        size: 2,
      };

    case 0x0072:
      // r
      return {
        value: '\u000d',
        size: 2,
      };

    case 0x0074:
      // t
      return {
        value: '\u0009',
        size: 2,
      };
  }

  throw syntaxError(
    lexer.source,
    position,
    `Invalid character escape sequence: "${body.slice(
      position,
      position + 2,
    )}".`,
  );
}
/**
 * Reads a block string token from the source file.
 *
 * ```
 * StringValue ::
 *   - `"""` BlockStringCharacter* `"""`
 *
 * BlockStringCharacter ::
 *   - SourceCharacter but not `"""` or `\"""`
 *   - `\"""`
 * ```
 */

function readBlockString(lexer, start) {
  const body = lexer.source.body;
  const bodyLength = body.length;
  let lineStart = lexer.lineStart;
  let position = start + 3;
  let chunkStart = position;
  let currentLine = '';
  const blockLines = [];

  while (position < bodyLength) {
    const code = body.charCodeAt(position); // Closing Triple-Quote (""")

    if (
      code === 0x0022 &&
      body.charCodeAt(position + 1) === 0x0022 &&
      body.charCodeAt(position + 2) === 0x0022
    ) {
      currentLine += body.slice(chunkStart, position);
      blockLines.push(currentLine);
      const token = createToken(
        lexer,
        TokenKind.BLOCK_STRING,
        start,
        position + 3, // Return a string of the lines joined with U+000A.
        dedentBlockStringLines(blockLines).join('\n'),
      );
      lexer.line += blockLines.length - 1;
      lexer.lineStart = lineStart;
      return token;
    } // Escaped Triple-Quote (\""")

    if (
      code === 0x005c &&
      body.charCodeAt(position + 1) === 0x0022 &&
      body.charCodeAt(position + 2) === 0x0022 &&
      body.charCodeAt(position + 3) === 0x0022
    ) {
      currentLine += body.slice(chunkStart, position);
      chunkStart = position + 1; // skip only slash

      position += 4;
      continue;
    } // LineTerminator

    if (code === 0x000a || code === 0x000d) {
      currentLine += body.slice(chunkStart, position);
      blockLines.push(currentLine);

      if (code === 0x000d && body.charCodeAt(position + 1) === 0x000a) {
        position += 2;
      } else {
        ++position;
      }

      currentLine = '';
      chunkStart = position;
      lineStart = position;
      continue;
    } // SourceCharacter

    if (isUnicodeScalarValue(code)) {
      ++position;
    } else if (isSupplementaryCodePoint(body, position)) {
      position += 2;
    } else {
      throw syntaxError(
        lexer.source,
        position,
        `Invalid character within String: ${printCodePointAt(
          lexer,
          position,
        )}.`,
      );
    }
  }

  throw syntaxError(lexer.source, position, 'Unterminated string.');
}
/**
 * Reads an alphanumeric + underscore name from the source.
 *
 * ```
 * Name ::
 *   - NameStart NameContinue* [lookahead != NameContinue]
 * ```
 */

function readName(lexer, start) {
  const body = lexer.source.body;
  const bodyLength = body.length;
  let position = start + 1;

  while (position < bodyLength) {
    const code = body.charCodeAt(position);

    if (isNameContinue(code)) {
      ++position;
    } else {
      break;
    }
  }

  return createToken(
    lexer,
    TokenKind.NAME,
    start,
    position,
    body.slice(start, position),
  );
}

const isProduction = globalThis.process && // eslint-disable-next-line no-undef
true;
const instanceOf = (
  /* c8 ignore next 6 */
  // FIXME: https://github.com/graphql/graphql-js/issues/2317
  isProduction ? function instanceOf2(value, constructor) {
    return value instanceof constructor;
  } : function instanceOf3(value, constructor) {
    if (value instanceof constructor) {
      return true;
    }
    if (typeof value === "object" && value !== null) {
      var _value$constructor;
      const className = constructor.prototype[Symbol.toStringTag];
      const valueClassName = (
        // We still need to support constructor's name to detect conflicts with older versions of this library.
        Symbol.toStringTag in value ? value[Symbol.toStringTag] : (_value$constructor = value.constructor) === null || _value$constructor === void 0 ? void 0 : _value$constructor.name
      );
      if (className === valueClassName) {
        const stringifiedValue = inspect$1(value);
        throw new Error(`Cannot use ${className} "${stringifiedValue}" from another module or realm.

Ensure that there is only one instance of "graphql" in the node_modules
directory. If different versions of "graphql" are the dependencies of other
relied on modules, use "resolutions" to ensure only one version is installed.

https://yarnpkg.com/en/docs/selective-version-resolutions

Duplicate "graphql" modules cannot be used at the same time since different
versions may have different capabilities and behavior. The data from one
version used in the function from another could produce confusing and
spurious results.`);
      }
    }
    return false;
  }
);

/**
 * A representation of source input to GraphQL. The `name` and `locationOffset` parameters are
 * optional, but they are useful for clients who store GraphQL documents in source files.
 * For example, if the GraphQL input starts at line 40 in a file named `Foo.graphql`, it might
 * be useful for `name` to be `"Foo.graphql"` and location to be `{ line: 40, column: 1 }`.
 * The `line` and `column` properties in `locationOffset` are 1-indexed.
 */
class Source {
  constructor(
    body,
    name = 'GraphQL request',
    locationOffset = {
      line: 1,
      column: 1,
    },
  ) {
    typeof body === 'string' ||
      devAssert(false, `Body must be a string. Received: ${inspect$1(body)}.`);
    this.body = body;
    this.name = name;
    this.locationOffset = locationOffset;
    this.locationOffset.line > 0 ||
      devAssert(
        false,
        'line in locationOffset is 1-indexed and must be positive.',
      );
    this.locationOffset.column > 0 ||
      devAssert(
        false,
        'column in locationOffset is 1-indexed and must be positive.',
      );
  }

  get [Symbol.toStringTag]() {
    return 'Source';
  }
}
/**
 * Test if the given value is a Source object.
 *
 * @internal
 */

function isSource(source) {
  return instanceOf(source, Source);
}

/**
 * Configuration options to control parser behavior
 */

/**
 * Given a GraphQL source, parses it into a Document.
 * Throws GraphQLError if a syntax error is encountered.
 */
function parse(source, options) {
  const parser = new Parser(source, options);
  return parser.parseDocument();
}
/**
 * This class is exported only to assist people in implementing their own parsers
 * without duplicating too much code and should be used only as last resort for cases
 * such as experimental syntax or if certain features could not be contributed upstream.
 *
 * It is still part of the internal API and is versioned, so any changes to it are never
 * considered breaking changes. If you still need to support multiple versions of the
 * library, please use the `versionInfo` variable for version detection.
 *
 * @internal
 */

class Parser {
  constructor(source, options = {}) {
    const sourceObj = isSource(source) ? source : new Source(source);
    this._lexer = new Lexer(sourceObj);
    this._options = options;
    this._tokenCounter = 0;
  }
  /**
   * Converts a name lex token into a name parse node.
   */

  parseName() {
    const token = this.expectToken(TokenKind.NAME);
    return this.node(token, {
      kind: Kind.NAME,
      value: token.value,
    });
  } // Implements the parsing rules in the Document section.

  /**
   * Document : Definition+
   */

  parseDocument() {
    return this.node(this._lexer.token, {
      kind: Kind.DOCUMENT,
      definitions: this.many(
        TokenKind.SOF,
        this.parseDefinition,
        TokenKind.EOF,
      ),
    });
  }
  /**
   * Definition :
   *   - ExecutableDefinition
   *   - TypeSystemDefinition
   *   - TypeSystemExtension
   *
   * ExecutableDefinition :
   *   - OperationDefinition
   *   - FragmentDefinition
   *
   * TypeSystemDefinition :
   *   - SchemaDefinition
   *   - TypeDefinition
   *   - DirectiveDefinition
   *
   * TypeDefinition :
   *   - ScalarTypeDefinition
   *   - ObjectTypeDefinition
   *   - InterfaceTypeDefinition
   *   - UnionTypeDefinition
   *   - EnumTypeDefinition
   *   - InputObjectTypeDefinition
   */

  parseDefinition() {
    if (this.peek(TokenKind.BRACE_L)) {
      return this.parseOperationDefinition();
    } // Many definitions begin with a description and require a lookahead.

    const hasDescription = this.peekDescription();
    const keywordToken = hasDescription
      ? this._lexer.lookahead()
      : this._lexer.token;

    if (keywordToken.kind === TokenKind.NAME) {
      switch (keywordToken.value) {
        case 'schema':
          return this.parseSchemaDefinition();

        case 'scalar':
          return this.parseScalarTypeDefinition();

        case 'type':
          return this.parseObjectTypeDefinition();

        case 'interface':
          return this.parseInterfaceTypeDefinition();

        case 'union':
          return this.parseUnionTypeDefinition();

        case 'enum':
          return this.parseEnumTypeDefinition();

        case 'input':
          return this.parseInputObjectTypeDefinition();

        case 'directive':
          return this.parseDirectiveDefinition();
      }

      if (hasDescription) {
        throw syntaxError(
          this._lexer.source,
          this._lexer.token.start,
          'Unexpected description, descriptions are supported only on type definitions.',
        );
      }

      switch (keywordToken.value) {
        case 'query':
        case 'mutation':
        case 'subscription':
          return this.parseOperationDefinition();

        case 'fragment':
          return this.parseFragmentDefinition();

        case 'extend':
          return this.parseTypeSystemExtension();
      }
    }

    throw this.unexpected(keywordToken);
  } // Implements the parsing rules in the Operations section.

  /**
   * OperationDefinition :
   *  - SelectionSet
   *  - OperationType Name? VariableDefinitions? Directives? SelectionSet
   */

  parseOperationDefinition() {
    const start = this._lexer.token;

    if (this.peek(TokenKind.BRACE_L)) {
      return this.node(start, {
        kind: Kind.OPERATION_DEFINITION,
        operation: OperationTypeNode$1.QUERY,
        name: undefined,
        variableDefinitions: [],
        directives: [],
        selectionSet: this.parseSelectionSet(),
      });
    }

    const operation = this.parseOperationType();
    let name;

    if (this.peek(TokenKind.NAME)) {
      name = this.parseName();
    }

    return this.node(start, {
      kind: Kind.OPERATION_DEFINITION,
      operation,
      name,
      variableDefinitions: this.parseVariableDefinitions(),
      directives: this.parseDirectives(false),
      selectionSet: this.parseSelectionSet(),
    });
  }
  /**
   * OperationType : one of query mutation subscription
   */

  parseOperationType() {
    const operationToken = this.expectToken(TokenKind.NAME);

    switch (operationToken.value) {
      case 'query':
        return OperationTypeNode$1.QUERY;

      case 'mutation':
        return OperationTypeNode$1.MUTATION;

      case 'subscription':
        return OperationTypeNode$1.SUBSCRIPTION;
    }

    throw this.unexpected(operationToken);
  }
  /**
   * VariableDefinitions : ( VariableDefinition+ )
   */

  parseVariableDefinitions() {
    return this.optionalMany(
      TokenKind.PAREN_L,
      this.parseVariableDefinition,
      TokenKind.PAREN_R,
    );
  }
  /**
   * VariableDefinition : Variable : Type DefaultValue? Directives[Const]?
   */

  parseVariableDefinition() {
    return this.node(this._lexer.token, {
      kind: Kind.VARIABLE_DEFINITION,
      variable: this.parseVariable(),
      type: (this.expectToken(TokenKind.COLON), this.parseTypeReference()),
      defaultValue: this.expectOptionalToken(TokenKind.EQUALS)
        ? this.parseConstValueLiteral()
        : undefined,
      directives: this.parseConstDirectives(),
    });
  }
  /**
   * Variable : $ Name
   */

  parseVariable() {
    const start = this._lexer.token;
    this.expectToken(TokenKind.DOLLAR);
    return this.node(start, {
      kind: Kind.VARIABLE,
      name: this.parseName(),
    });
  }
  /**
   * ```
   * SelectionSet : { Selection+ }
   * ```
   */

  parseSelectionSet() {
    return this.node(this._lexer.token, {
      kind: Kind.SELECTION_SET,
      selections: this.many(
        TokenKind.BRACE_L,
        this.parseSelection,
        TokenKind.BRACE_R,
      ),
    });
  }
  /**
   * Selection :
   *   - Field
   *   - FragmentSpread
   *   - InlineFragment
   */

  parseSelection() {
    return this.peek(TokenKind.SPREAD)
      ? this.parseFragment()
      : this.parseField();
  }
  /**
   * Field : Alias? Name Arguments? Directives? SelectionSet?
   *
   * Alias : Name :
   */

  parseField() {
    const start = this._lexer.token;
    const nameOrAlias = this.parseName();
    let alias;
    let name;

    if (this.expectOptionalToken(TokenKind.COLON)) {
      alias = nameOrAlias;
      name = this.parseName();
    } else {
      name = nameOrAlias;
    }

    return this.node(start, {
      kind: Kind.FIELD,
      alias,
      name,
      arguments: this.parseArguments(false),
      directives: this.parseDirectives(false),
      selectionSet: this.peek(TokenKind.BRACE_L)
        ? this.parseSelectionSet()
        : undefined,
    });
  }
  /**
   * Arguments[Const] : ( Argument[?Const]+ )
   */

  parseArguments(isConst) {
    const item = isConst ? this.parseConstArgument : this.parseArgument;
    return this.optionalMany(TokenKind.PAREN_L, item, TokenKind.PAREN_R);
  }
  /**
   * Argument[Const] : Name : Value[?Const]
   */

  parseArgument(isConst = false) {
    const start = this._lexer.token;
    const name = this.parseName();
    this.expectToken(TokenKind.COLON);
    return this.node(start, {
      kind: Kind.ARGUMENT,
      name,
      value: this.parseValueLiteral(isConst),
    });
  }

  parseConstArgument() {
    return this.parseArgument(true);
  } // Implements the parsing rules in the Fragments section.

  /**
   * Corresponds to both FragmentSpread and InlineFragment in the spec.
   *
   * FragmentSpread : ... FragmentName Directives?
   *
   * InlineFragment : ... TypeCondition? Directives? SelectionSet
   */

  parseFragment() {
    const start = this._lexer.token;
    this.expectToken(TokenKind.SPREAD);
    const hasTypeCondition = this.expectOptionalKeyword('on');

    if (!hasTypeCondition && this.peek(TokenKind.NAME)) {
      return this.node(start, {
        kind: Kind.FRAGMENT_SPREAD,
        name: this.parseFragmentName(),
        directives: this.parseDirectives(false),
      });
    }

    return this.node(start, {
      kind: Kind.INLINE_FRAGMENT,
      typeCondition: hasTypeCondition ? this.parseNamedType() : undefined,
      directives: this.parseDirectives(false),
      selectionSet: this.parseSelectionSet(),
    });
  }
  /**
   * FragmentDefinition :
   *   - fragment FragmentName on TypeCondition Directives? SelectionSet
   *
   * TypeCondition : NamedType
   */

  parseFragmentDefinition() {
    const start = this._lexer.token;
    this.expectKeyword('fragment'); // Legacy support for defining variables within fragments changes
    // the grammar of FragmentDefinition:
    //   - fragment FragmentName VariableDefinitions? on TypeCondition Directives? SelectionSet

    if (this._options.allowLegacyFragmentVariables === true) {
      return this.node(start, {
        kind: Kind.FRAGMENT_DEFINITION,
        name: this.parseFragmentName(),
        variableDefinitions: this.parseVariableDefinitions(),
        typeCondition: (this.expectKeyword('on'), this.parseNamedType()),
        directives: this.parseDirectives(false),
        selectionSet: this.parseSelectionSet(),
      });
    }

    return this.node(start, {
      kind: Kind.FRAGMENT_DEFINITION,
      name: this.parseFragmentName(),
      typeCondition: (this.expectKeyword('on'), this.parseNamedType()),
      directives: this.parseDirectives(false),
      selectionSet: this.parseSelectionSet(),
    });
  }
  /**
   * FragmentName : Name but not `on`
   */

  parseFragmentName() {
    if (this._lexer.token.value === 'on') {
      throw this.unexpected();
    }

    return this.parseName();
  } // Implements the parsing rules in the Values section.

  /**
   * Value[Const] :
   *   - [~Const] Variable
   *   - IntValue
   *   - FloatValue
   *   - StringValue
   *   - BooleanValue
   *   - NullValue
   *   - EnumValue
   *   - ListValue[?Const]
   *   - ObjectValue[?Const]
   *
   * BooleanValue : one of `true` `false`
   *
   * NullValue : `null`
   *
   * EnumValue : Name but not `true`, `false` or `null`
   */

  parseValueLiteral(isConst) {
    const token = this._lexer.token;

    switch (token.kind) {
      case TokenKind.BRACKET_L:
        return this.parseList(isConst);

      case TokenKind.BRACE_L:
        return this.parseObject(isConst);

      case TokenKind.INT:
        this.advanceLexer();
        return this.node(token, {
          kind: Kind.INT,
          value: token.value,
        });

      case TokenKind.FLOAT:
        this.advanceLexer();
        return this.node(token, {
          kind: Kind.FLOAT,
          value: token.value,
        });

      case TokenKind.STRING:
      case TokenKind.BLOCK_STRING:
        return this.parseStringLiteral();

      case TokenKind.NAME:
        this.advanceLexer();

        switch (token.value) {
          case 'true':
            return this.node(token, {
              kind: Kind.BOOLEAN,
              value: true,
            });

          case 'false':
            return this.node(token, {
              kind: Kind.BOOLEAN,
              value: false,
            });

          case 'null':
            return this.node(token, {
              kind: Kind.NULL,
            });

          default:
            return this.node(token, {
              kind: Kind.ENUM,
              value: token.value,
            });
        }

      case TokenKind.DOLLAR:
        if (isConst) {
          this.expectToken(TokenKind.DOLLAR);

          if (this._lexer.token.kind === TokenKind.NAME) {
            const varName = this._lexer.token.value;
            throw syntaxError(
              this._lexer.source,
              token.start,
              `Unexpected variable "$${varName}" in constant value.`,
            );
          } else {
            throw this.unexpected(token);
          }
        }

        return this.parseVariable();

      default:
        throw this.unexpected();
    }
  }

  parseConstValueLiteral() {
    return this.parseValueLiteral(true);
  }

  parseStringLiteral() {
    const token = this._lexer.token;
    this.advanceLexer();
    return this.node(token, {
      kind: Kind.STRING,
      value: token.value,
      block: token.kind === TokenKind.BLOCK_STRING,
    });
  }
  /**
   * ListValue[Const] :
   *   - [ ]
   *   - [ Value[?Const]+ ]
   */

  parseList(isConst) {
    const item = () => this.parseValueLiteral(isConst);

    return this.node(this._lexer.token, {
      kind: Kind.LIST,
      values: this.any(TokenKind.BRACKET_L, item, TokenKind.BRACKET_R),
    });
  }
  /**
   * ```
   * ObjectValue[Const] :
   *   - { }
   *   - { ObjectField[?Const]+ }
   * ```
   */

  parseObject(isConst) {
    const item = () => this.parseObjectField(isConst);

    return this.node(this._lexer.token, {
      kind: Kind.OBJECT,
      fields: this.any(TokenKind.BRACE_L, item, TokenKind.BRACE_R),
    });
  }
  /**
   * ObjectField[Const] : Name : Value[?Const]
   */

  parseObjectField(isConst) {
    const start = this._lexer.token;
    const name = this.parseName();
    this.expectToken(TokenKind.COLON);
    return this.node(start, {
      kind: Kind.OBJECT_FIELD,
      name,
      value: this.parseValueLiteral(isConst),
    });
  } // Implements the parsing rules in the Directives section.

  /**
   * Directives[Const] : Directive[?Const]+
   */

  parseDirectives(isConst) {
    const directives = [];

    while (this.peek(TokenKind.AT)) {
      directives.push(this.parseDirective(isConst));
    }

    return directives;
  }

  parseConstDirectives() {
    return this.parseDirectives(true);
  }
  /**
   * ```
   * Directive[Const] : @ Name Arguments[?Const]?
   * ```
   */

  parseDirective(isConst) {
    const start = this._lexer.token;
    this.expectToken(TokenKind.AT);
    return this.node(start, {
      kind: Kind.DIRECTIVE,
      name: this.parseName(),
      arguments: this.parseArguments(isConst),
    });
  } // Implements the parsing rules in the Types section.

  /**
   * Type :
   *   - NamedType
   *   - ListType
   *   - NonNullType
   */

  parseTypeReference() {
    const start = this._lexer.token;
    let type;

    if (this.expectOptionalToken(TokenKind.BRACKET_L)) {
      const innerType = this.parseTypeReference();
      this.expectToken(TokenKind.BRACKET_R);
      type = this.node(start, {
        kind: Kind.LIST_TYPE,
        type: innerType,
      });
    } else {
      type = this.parseNamedType();
    }

    if (this.expectOptionalToken(TokenKind.BANG)) {
      return this.node(start, {
        kind: Kind.NON_NULL_TYPE,
        type,
      });
    }

    return type;
  }
  /**
   * NamedType : Name
   */

  parseNamedType() {
    return this.node(this._lexer.token, {
      kind: Kind.NAMED_TYPE,
      name: this.parseName(),
    });
  } // Implements the parsing rules in the Type Definition section.

  peekDescription() {
    return this.peek(TokenKind.STRING) || this.peek(TokenKind.BLOCK_STRING);
  }
  /**
   * Description : StringValue
   */

  parseDescription() {
    if (this.peekDescription()) {
      return this.parseStringLiteral();
    }
  }
  /**
   * ```
   * SchemaDefinition : Description? schema Directives[Const]? { OperationTypeDefinition+ }
   * ```
   */

  parseSchemaDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('schema');
    const directives = this.parseConstDirectives();
    const operationTypes = this.many(
      TokenKind.BRACE_L,
      this.parseOperationTypeDefinition,
      TokenKind.BRACE_R,
    );
    return this.node(start, {
      kind: Kind.SCHEMA_DEFINITION,
      description,
      directives,
      operationTypes,
    });
  }
  /**
   * OperationTypeDefinition : OperationType : NamedType
   */

  parseOperationTypeDefinition() {
    const start = this._lexer.token;
    const operation = this.parseOperationType();
    this.expectToken(TokenKind.COLON);
    const type = this.parseNamedType();
    return this.node(start, {
      kind: Kind.OPERATION_TYPE_DEFINITION,
      operation,
      type,
    });
  }
  /**
   * ScalarTypeDefinition : Description? scalar Name Directives[Const]?
   */

  parseScalarTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('scalar');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    return this.node(start, {
      kind: Kind.SCALAR_TYPE_DEFINITION,
      description,
      name,
      directives,
    });
  }
  /**
   * ObjectTypeDefinition :
   *   Description?
   *   type Name ImplementsInterfaces? Directives[Const]? FieldsDefinition?
   */

  parseObjectTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('type');
    const name = this.parseName();
    const interfaces = this.parseImplementsInterfaces();
    const directives = this.parseConstDirectives();
    const fields = this.parseFieldsDefinition();
    return this.node(start, {
      kind: Kind.OBJECT_TYPE_DEFINITION,
      description,
      name,
      interfaces,
      directives,
      fields,
    });
  }
  /**
   * ImplementsInterfaces :
   *   - implements `&`? NamedType
   *   - ImplementsInterfaces & NamedType
   */

  parseImplementsInterfaces() {
    return this.expectOptionalKeyword('implements')
      ? this.delimitedMany(TokenKind.AMP, this.parseNamedType)
      : [];
  }
  /**
   * ```
   * FieldsDefinition : { FieldDefinition+ }
   * ```
   */

  parseFieldsDefinition() {
    return this.optionalMany(
      TokenKind.BRACE_L,
      this.parseFieldDefinition,
      TokenKind.BRACE_R,
    );
  }
  /**
   * FieldDefinition :
   *   - Description? Name ArgumentsDefinition? : Type Directives[Const]?
   */

  parseFieldDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    const name = this.parseName();
    const args = this.parseArgumentDefs();
    this.expectToken(TokenKind.COLON);
    const type = this.parseTypeReference();
    const directives = this.parseConstDirectives();
    return this.node(start, {
      kind: Kind.FIELD_DEFINITION,
      description,
      name,
      arguments: args,
      type,
      directives,
    });
  }
  /**
   * ArgumentsDefinition : ( InputValueDefinition+ )
   */

  parseArgumentDefs() {
    return this.optionalMany(
      TokenKind.PAREN_L,
      this.parseInputValueDef,
      TokenKind.PAREN_R,
    );
  }
  /**
   * InputValueDefinition :
   *   - Description? Name : Type DefaultValue? Directives[Const]?
   */

  parseInputValueDef() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    const name = this.parseName();
    this.expectToken(TokenKind.COLON);
    const type = this.parseTypeReference();
    let defaultValue;

    if (this.expectOptionalToken(TokenKind.EQUALS)) {
      defaultValue = this.parseConstValueLiteral();
    }

    const directives = this.parseConstDirectives();
    return this.node(start, {
      kind: Kind.INPUT_VALUE_DEFINITION,
      description,
      name,
      type,
      defaultValue,
      directives,
    });
  }
  /**
   * InterfaceTypeDefinition :
   *   - Description? interface Name Directives[Const]? FieldsDefinition?
   */

  parseInterfaceTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('interface');
    const name = this.parseName();
    const interfaces = this.parseImplementsInterfaces();
    const directives = this.parseConstDirectives();
    const fields = this.parseFieldsDefinition();
    return this.node(start, {
      kind: Kind.INTERFACE_TYPE_DEFINITION,
      description,
      name,
      interfaces,
      directives,
      fields,
    });
  }
  /**
   * UnionTypeDefinition :
   *   - Description? union Name Directives[Const]? UnionMemberTypes?
   */

  parseUnionTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('union');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const types = this.parseUnionMemberTypes();
    return this.node(start, {
      kind: Kind.UNION_TYPE_DEFINITION,
      description,
      name,
      directives,
      types,
    });
  }
  /**
   * UnionMemberTypes :
   *   - = `|`? NamedType
   *   - UnionMemberTypes | NamedType
   */

  parseUnionMemberTypes() {
    return this.expectOptionalToken(TokenKind.EQUALS)
      ? this.delimitedMany(TokenKind.PIPE, this.parseNamedType)
      : [];
  }
  /**
   * EnumTypeDefinition :
   *   - Description? enum Name Directives[Const]? EnumValuesDefinition?
   */

  parseEnumTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('enum');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const values = this.parseEnumValuesDefinition();
    return this.node(start, {
      kind: Kind.ENUM_TYPE_DEFINITION,
      description,
      name,
      directives,
      values,
    });
  }
  /**
   * ```
   * EnumValuesDefinition : { EnumValueDefinition+ }
   * ```
   */

  parseEnumValuesDefinition() {
    return this.optionalMany(
      TokenKind.BRACE_L,
      this.parseEnumValueDefinition,
      TokenKind.BRACE_R,
    );
  }
  /**
   * EnumValueDefinition : Description? EnumValue Directives[Const]?
   */

  parseEnumValueDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    const name = this.parseEnumValueName();
    const directives = this.parseConstDirectives();
    return this.node(start, {
      kind: Kind.ENUM_VALUE_DEFINITION,
      description,
      name,
      directives,
    });
  }
  /**
   * EnumValue : Name but not `true`, `false` or `null`
   */

  parseEnumValueName() {
    if (
      this._lexer.token.value === 'true' ||
      this._lexer.token.value === 'false' ||
      this._lexer.token.value === 'null'
    ) {
      throw syntaxError(
        this._lexer.source,
        this._lexer.token.start,
        `${getTokenDesc(
          this._lexer.token,
        )} is reserved and cannot be used for an enum value.`,
      );
    }

    return this.parseName();
  }
  /**
   * InputObjectTypeDefinition :
   *   - Description? input Name Directives[Const]? InputFieldsDefinition?
   */

  parseInputObjectTypeDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('input');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const fields = this.parseInputFieldsDefinition();
    return this.node(start, {
      kind: Kind.INPUT_OBJECT_TYPE_DEFINITION,
      description,
      name,
      directives,
      fields,
    });
  }
  /**
   * ```
   * InputFieldsDefinition : { InputValueDefinition+ }
   * ```
   */

  parseInputFieldsDefinition() {
    return this.optionalMany(
      TokenKind.BRACE_L,
      this.parseInputValueDef,
      TokenKind.BRACE_R,
    );
  }
  /**
   * TypeSystemExtension :
   *   - SchemaExtension
   *   - TypeExtension
   *
   * TypeExtension :
   *   - ScalarTypeExtension
   *   - ObjectTypeExtension
   *   - InterfaceTypeExtension
   *   - UnionTypeExtension
   *   - EnumTypeExtension
   *   - InputObjectTypeDefinition
   */

  parseTypeSystemExtension() {
    const keywordToken = this._lexer.lookahead();

    if (keywordToken.kind === TokenKind.NAME) {
      switch (keywordToken.value) {
        case 'schema':
          return this.parseSchemaExtension();

        case 'scalar':
          return this.parseScalarTypeExtension();

        case 'type':
          return this.parseObjectTypeExtension();

        case 'interface':
          return this.parseInterfaceTypeExtension();

        case 'union':
          return this.parseUnionTypeExtension();

        case 'enum':
          return this.parseEnumTypeExtension();

        case 'input':
          return this.parseInputObjectTypeExtension();
      }
    }

    throw this.unexpected(keywordToken);
  }
  /**
   * ```
   * SchemaExtension :
   *  - extend schema Directives[Const]? { OperationTypeDefinition+ }
   *  - extend schema Directives[Const]
   * ```
   */

  parseSchemaExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('schema');
    const directives = this.parseConstDirectives();
    const operationTypes = this.optionalMany(
      TokenKind.BRACE_L,
      this.parseOperationTypeDefinition,
      TokenKind.BRACE_R,
    );

    if (directives.length === 0 && operationTypes.length === 0) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.SCHEMA_EXTENSION,
      directives,
      operationTypes,
    });
  }
  /**
   * ScalarTypeExtension :
   *   - extend scalar Name Directives[Const]
   */

  parseScalarTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('scalar');
    const name = this.parseName();
    const directives = this.parseConstDirectives();

    if (directives.length === 0) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.SCALAR_TYPE_EXTENSION,
      name,
      directives,
    });
  }
  /**
   * ObjectTypeExtension :
   *  - extend type Name ImplementsInterfaces? Directives[Const]? FieldsDefinition
   *  - extend type Name ImplementsInterfaces? Directives[Const]
   *  - extend type Name ImplementsInterfaces
   */

  parseObjectTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('type');
    const name = this.parseName();
    const interfaces = this.parseImplementsInterfaces();
    const directives = this.parseConstDirectives();
    const fields = this.parseFieldsDefinition();

    if (
      interfaces.length === 0 &&
      directives.length === 0 &&
      fields.length === 0
    ) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.OBJECT_TYPE_EXTENSION,
      name,
      interfaces,
      directives,
      fields,
    });
  }
  /**
   * InterfaceTypeExtension :
   *  - extend interface Name ImplementsInterfaces? Directives[Const]? FieldsDefinition
   *  - extend interface Name ImplementsInterfaces? Directives[Const]
   *  - extend interface Name ImplementsInterfaces
   */

  parseInterfaceTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('interface');
    const name = this.parseName();
    const interfaces = this.parseImplementsInterfaces();
    const directives = this.parseConstDirectives();
    const fields = this.parseFieldsDefinition();

    if (
      interfaces.length === 0 &&
      directives.length === 0 &&
      fields.length === 0
    ) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.INTERFACE_TYPE_EXTENSION,
      name,
      interfaces,
      directives,
      fields,
    });
  }
  /**
   * UnionTypeExtension :
   *   - extend union Name Directives[Const]? UnionMemberTypes
   *   - extend union Name Directives[Const]
   */

  parseUnionTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('union');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const types = this.parseUnionMemberTypes();

    if (directives.length === 0 && types.length === 0) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.UNION_TYPE_EXTENSION,
      name,
      directives,
      types,
    });
  }
  /**
   * EnumTypeExtension :
   *   - extend enum Name Directives[Const]? EnumValuesDefinition
   *   - extend enum Name Directives[Const]
   */

  parseEnumTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('enum');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const values = this.parseEnumValuesDefinition();

    if (directives.length === 0 && values.length === 0) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.ENUM_TYPE_EXTENSION,
      name,
      directives,
      values,
    });
  }
  /**
   * InputObjectTypeExtension :
   *   - extend input Name Directives[Const]? InputFieldsDefinition
   *   - extend input Name Directives[Const]
   */

  parseInputObjectTypeExtension() {
    const start = this._lexer.token;
    this.expectKeyword('extend');
    this.expectKeyword('input');
    const name = this.parseName();
    const directives = this.parseConstDirectives();
    const fields = this.parseInputFieldsDefinition();

    if (directives.length === 0 && fields.length === 0) {
      throw this.unexpected();
    }

    return this.node(start, {
      kind: Kind.INPUT_OBJECT_TYPE_EXTENSION,
      name,
      directives,
      fields,
    });
  }
  /**
   * ```
   * DirectiveDefinition :
   *   - Description? directive @ Name ArgumentsDefinition? `repeatable`? on DirectiveLocations
   * ```
   */

  parseDirectiveDefinition() {
    const start = this._lexer.token;
    const description = this.parseDescription();
    this.expectKeyword('directive');
    this.expectToken(TokenKind.AT);
    const name = this.parseName();
    const args = this.parseArgumentDefs();
    const repeatable = this.expectOptionalKeyword('repeatable');
    this.expectKeyword('on');
    const locations = this.parseDirectiveLocations();
    return this.node(start, {
      kind: Kind.DIRECTIVE_DEFINITION,
      description,
      name,
      arguments: args,
      repeatable,
      locations,
    });
  }
  /**
   * DirectiveLocations :
   *   - `|`? DirectiveLocation
   *   - DirectiveLocations | DirectiveLocation
   */

  parseDirectiveLocations() {
    return this.delimitedMany(TokenKind.PIPE, this.parseDirectiveLocation);
  }
  /*
   * DirectiveLocation :
   *   - ExecutableDirectiveLocation
   *   - TypeSystemDirectiveLocation
   *
   * ExecutableDirectiveLocation : one of
   *   `QUERY`
   *   `MUTATION`
   *   `SUBSCRIPTION`
   *   `FIELD`
   *   `FRAGMENT_DEFINITION`
   *   `FRAGMENT_SPREAD`
   *   `INLINE_FRAGMENT`
   *
   * TypeSystemDirectiveLocation : one of
   *   `SCHEMA`
   *   `SCALAR`
   *   `OBJECT`
   *   `FIELD_DEFINITION`
   *   `ARGUMENT_DEFINITION`
   *   `INTERFACE`
   *   `UNION`
   *   `ENUM`
   *   `ENUM_VALUE`
   *   `INPUT_OBJECT`
   *   `INPUT_FIELD_DEFINITION`
   */

  parseDirectiveLocation() {
    const start = this._lexer.token;
    const name = this.parseName();

    if (Object.prototype.hasOwnProperty.call(DirectiveLocation, name.value)) {
      return name;
    }

    throw this.unexpected(start);
  } // Core parsing utility functions

  /**
   * Returns a node that, if configured to do so, sets a "loc" field as a
   * location object, used to identify the place in the source that created a
   * given parsed object.
   */

  node(startToken, node) {
    if (this._options.noLocation !== true) {
      node.loc = new Location$1(
        startToken,
        this._lexer.lastToken,
        this._lexer.source,
      );
    }

    return node;
  }
  /**
   * Determines if the next token is of a given kind
   */

  peek(kind) {
    return this._lexer.token.kind === kind;
  }
  /**
   * If the next token is of the given kind, return that token after advancing the lexer.
   * Otherwise, do not change the parser state and throw an error.
   */

  expectToken(kind) {
    const token = this._lexer.token;

    if (token.kind === kind) {
      this.advanceLexer();
      return token;
    }

    throw syntaxError(
      this._lexer.source,
      token.start,
      `Expected ${getTokenKindDesc(kind)}, found ${getTokenDesc(token)}.`,
    );
  }
  /**
   * If the next token is of the given kind, return "true" after advancing the lexer.
   * Otherwise, do not change the parser state and return "false".
   */

  expectOptionalToken(kind) {
    const token = this._lexer.token;

    if (token.kind === kind) {
      this.advanceLexer();
      return true;
    }

    return false;
  }
  /**
   * If the next token is a given keyword, advance the lexer.
   * Otherwise, do not change the parser state and throw an error.
   */

  expectKeyword(value) {
    const token = this._lexer.token;

    if (token.kind === TokenKind.NAME && token.value === value) {
      this.advanceLexer();
    } else {
      throw syntaxError(
        this._lexer.source,
        token.start,
        `Expected "${value}", found ${getTokenDesc(token)}.`,
      );
    }
  }
  /**
   * If the next token is a given keyword, return "true" after advancing the lexer.
   * Otherwise, do not change the parser state and return "false".
   */

  expectOptionalKeyword(value) {
    const token = this._lexer.token;

    if (token.kind === TokenKind.NAME && token.value === value) {
      this.advanceLexer();
      return true;
    }

    return false;
  }
  /**
   * Helper function for creating an error when an unexpected lexed token is encountered.
   */

  unexpected(atToken) {
    const token =
      atToken !== null && atToken !== void 0 ? atToken : this._lexer.token;
    return syntaxError(
      this._lexer.source,
      token.start,
      `Unexpected ${getTokenDesc(token)}.`,
    );
  }
  /**
   * Returns a possibly empty list of parse nodes, determined by the parseFn.
   * This list begins with a lex token of openKind and ends with a lex token of closeKind.
   * Advances the parser to the next lex token after the closing token.
   */

  any(openKind, parseFn, closeKind) {
    this.expectToken(openKind);
    const nodes = [];

    while (!this.expectOptionalToken(closeKind)) {
      nodes.push(parseFn.call(this));
    }

    return nodes;
  }
  /**
   * Returns a list of parse nodes, determined by the parseFn.
   * It can be empty only if open token is missing otherwise it will always return non-empty list
   * that begins with a lex token of openKind and ends with a lex token of closeKind.
   * Advances the parser to the next lex token after the closing token.
   */

  optionalMany(openKind, parseFn, closeKind) {
    if (this.expectOptionalToken(openKind)) {
      const nodes = [];

      do {
        nodes.push(parseFn.call(this));
      } while (!this.expectOptionalToken(closeKind));

      return nodes;
    }

    return [];
  }
  /**
   * Returns a non-empty list of parse nodes, determined by the parseFn.
   * This list begins with a lex token of openKind and ends with a lex token of closeKind.
   * Advances the parser to the next lex token after the closing token.
   */

  many(openKind, parseFn, closeKind) {
    this.expectToken(openKind);
    const nodes = [];

    do {
      nodes.push(parseFn.call(this));
    } while (!this.expectOptionalToken(closeKind));

    return nodes;
  }
  /**
   * Returns a non-empty list of parse nodes, determined by the parseFn.
   * This list may begin with a lex token of delimiterKind followed by items separated by lex tokens of tokenKind.
   * Advances the parser to the next lex token after last item in the list.
   */

  delimitedMany(delimiterKind, parseFn) {
    this.expectOptionalToken(delimiterKind);
    const nodes = [];

    do {
      nodes.push(parseFn.call(this));
    } while (this.expectOptionalToken(delimiterKind));

    return nodes;
  }

  advanceLexer() {
    const { maxTokens } = this._options;

    const token = this._lexer.advance();

    if (maxTokens !== undefined && token.kind !== TokenKind.EOF) {
      ++this._tokenCounter;

      if (this._tokenCounter > maxTokens) {
        throw syntaxError(
          this._lexer.source,
          token.start,
          `Document contains more that ${maxTokens} tokens. Parsing aborted.`,
        );
      }
    }
  }
}
/**
 * A helper function to describe a token as a string for debugging.
 */

function getTokenDesc(token) {
  const value = token.value;
  return getTokenKindDesc(token.kind) + (value != null ? ` "${value}"` : '');
}
/**
 * A helper function to describe a token kind as a string for debugging.
 */

function getTokenKindDesc(kind) {
  return isPunctuatorTokenKind(kind) ? `"${kind}"` : kind;
}

const MAX_SUGGESTIONS = 5;
/**
 * Given [ A, B, C ] return ' Did you mean A, B, or C?'.
 */

function didYouMean(firstArg, secondArg) {
  const [subMessage, suggestionsArg] = secondArg
    ? [firstArg, secondArg]
    : [undefined, firstArg];
  let message = ' Did you mean ';

  if (subMessage) {
    message += subMessage + ' ';
  }

  const suggestions = suggestionsArg.map((x) => `"${x}"`);

  switch (suggestions.length) {
    case 0:
      return '';

    case 1:
      return message + suggestions[0] + '?';

    case 2:
      return message + suggestions[0] + ' or ' + suggestions[1] + '?';
  }

  const selected = suggestions.slice(0, MAX_SUGGESTIONS);
  const lastItem = selected.pop();
  return message + selected.join(', ') + ', or ' + lastItem + '?';
}

/**
 * Returns the first argument it receives.
 */
function identityFunc(x) {
  return x;
}

/**
 * Creates a keyed JS object from an array, given a function to produce the keys
 * for each value in the array.
 *
 * This provides a convenient lookup for the array items if the key function
 * produces unique results.
 * ```ts
 * const phoneBook = [
 *   { name: 'Jon', num: '555-1234' },
 *   { name: 'Jenny', num: '867-5309' }
 * ]
 *
 * const entriesByName = keyMap(
 *   phoneBook,
 *   entry => entry.name
 * )
 *
 * // {
 * //   Jon: { name: 'Jon', num: '555-1234' },
 * //   Jenny: { name: 'Jenny', num: '867-5309' }
 * // }
 *
 * const jennyEntry = entriesByName['Jenny']
 *
 * // { name: 'Jenny', num: '857-6309' }
 * ```
 */
function keyMap(list, keyFn) {
  const result = Object.create(null);

  for (const item of list) {
    result[keyFn(item)] = item;
  }

  return result;
}

/**
 * Creates a keyed JS object from an array, given a function to produce the keys
 * and a function to produce the values from each item in the array.
 * ```ts
 * const phoneBook = [
 *   { name: 'Jon', num: '555-1234' },
 *   { name: 'Jenny', num: '867-5309' }
 * ]
 *
 * // { Jon: '555-1234', Jenny: '867-5309' }
 * const phonesByName = keyValMap(
 *   phoneBook,
 *   entry => entry.name,
 *   entry => entry.num
 * )
 * ```
 */
function keyValMap(list, keyFn, valFn) {
  const result = Object.create(null);

  for (const item of list) {
    result[keyFn(item)] = valFn(item);
  }

  return result;
}

/**
 * Creates an object map with the same keys as `map` and values generated by
 * running each value of `map` thru `fn`.
 */
function mapValue(map, fn) {
  const result = Object.create(null);

  for (const key of Object.keys(map)) {
    result[key] = fn(map[key], key);
  }

  return result;
}

/**
 * Returns a number indicating whether a reference string comes before, or after,
 * or is the same as the given string in natural sort order.
 *
 * See: https://en.wikipedia.org/wiki/Natural_sort_order
 *
 */
function naturalCompare(aStr, bStr) {
  let aIndex = 0;
  let bIndex = 0;

  while (aIndex < aStr.length && bIndex < bStr.length) {
    let aChar = aStr.charCodeAt(aIndex);
    let bChar = bStr.charCodeAt(bIndex);

    if (isDigit(aChar) && isDigit(bChar)) {
      let aNum = 0;

      do {
        ++aIndex;
        aNum = aNum * 10 + aChar - DIGIT_0;
        aChar = aStr.charCodeAt(aIndex);
      } while (isDigit(aChar) && aNum > 0);

      let bNum = 0;

      do {
        ++bIndex;
        bNum = bNum * 10 + bChar - DIGIT_0;
        bChar = bStr.charCodeAt(bIndex);
      } while (isDigit(bChar) && bNum > 0);

      if (aNum < bNum) {
        return -1;
      }

      if (aNum > bNum) {
        return 1;
      }
    } else {
      if (aChar < bChar) {
        return -1;
      }

      if (aChar > bChar) {
        return 1;
      }

      ++aIndex;
      ++bIndex;
    }
  }

  return aStr.length - bStr.length;
}
const DIGIT_0 = 48;
const DIGIT_9 = 57;

function isDigit(code) {
  return !isNaN(code) && DIGIT_0 <= code && code <= DIGIT_9;
}

/**
 * Given an invalid input string and a list of valid options, returns a filtered
 * list of valid options sorted based on their similarity with the input.
 */

function suggestionList(input, options) {
  const optionsByDistance = Object.create(null);
  const lexicalDistance = new LexicalDistance(input);
  const threshold = Math.floor(input.length * 0.4) + 1;

  for (const option of options) {
    const distance = lexicalDistance.measure(option, threshold);

    if (distance !== undefined) {
      optionsByDistance[option] = distance;
    }
  }

  return Object.keys(optionsByDistance).sort((a, b) => {
    const distanceDiff = optionsByDistance[a] - optionsByDistance[b];
    return distanceDiff !== 0 ? distanceDiff : naturalCompare(a, b);
  });
}
/**
 * Computes the lexical distance between strings A and B.
 *
 * The "distance" between two strings is given by counting the minimum number
 * of edits needed to transform string A into string B. An edit can be an
 * insertion, deletion, or substitution of a single character, or a swap of two
 * adjacent characters.
 *
 * Includes a custom alteration from Damerau-Levenshtein to treat case changes
 * as a single edit which helps identify mis-cased values with an edit distance
 * of 1.
 *
 * This distance can be useful for detecting typos in input or sorting
 */

class LexicalDistance {
  constructor(input) {
    this._input = input;
    this._inputLowerCase = input.toLowerCase();
    this._inputArray = stringToArray(this._inputLowerCase);
    this._rows = [
      new Array(input.length + 1).fill(0),
      new Array(input.length + 1).fill(0),
      new Array(input.length + 1).fill(0),
    ];
  }

  measure(option, threshold) {
    if (this._input === option) {
      return 0;
    }

    const optionLowerCase = option.toLowerCase(); // Any case change counts as a single edit

    if (this._inputLowerCase === optionLowerCase) {
      return 1;
    }

    let a = stringToArray(optionLowerCase);
    let b = this._inputArray;

    if (a.length < b.length) {
      const tmp = a;
      a = b;
      b = tmp;
    }

    const aLength = a.length;
    const bLength = b.length;

    if (aLength - bLength > threshold) {
      return undefined;
    }

    const rows = this._rows;

    for (let j = 0; j <= bLength; j++) {
      rows[0][j] = j;
    }

    for (let i = 1; i <= aLength; i++) {
      const upRow = rows[(i - 1) % 3];
      const currentRow = rows[i % 3];
      let smallestCell = (currentRow[0] = i);

      for (let j = 1; j <= bLength; j++) {
        const cost = a[i - 1] === b[j - 1] ? 0 : 1;
        let currentCell = Math.min(
          upRow[j] + 1, // delete
          currentRow[j - 1] + 1, // insert
          upRow[j - 1] + cost, // substitute
        );

        if (i > 1 && j > 1 && a[i - 1] === b[j - 2] && a[i - 2] === b[j - 1]) {
          // transposition
          const doubleDiagonalCell = rows[(i - 2) % 3][j - 2];
          currentCell = Math.min(currentCell, doubleDiagonalCell + 1);
        }

        if (currentCell < smallestCell) {
          smallestCell = currentCell;
        }

        currentRow[j] = currentCell;
      } // Early exit, since distance can't go smaller than smallest element of the previous row.

      if (smallestCell > threshold) {
        return undefined;
      }
    }

    const distance = rows[aLength % 3][bLength];
    return distance <= threshold ? distance : undefined;
  }
}

function stringToArray(str) {
  const strLength = str.length;
  const array = new Array(strLength);

  for (let i = 0; i < strLength; ++i) {
    array[i] = str.charCodeAt(i);
  }

  return array;
}

function toObjMap(obj) {
  if (obj == null) {
    return Object.create(null);
  }

  if (Object.getPrototypeOf(obj) === null) {
    return obj;
  }

  const map = Object.create(null);

  for (const [key, value] of Object.entries(obj)) {
    map[key] = value;
  }

  return map;
}

/**
 * Produces a JavaScript value given a GraphQL Value AST.
 *
 * Unlike `valueFromAST()`, no type is provided. The resulting JavaScript value
 * will reflect the provided GraphQL value AST.
 *
 * | GraphQL Value        | JavaScript Value |
 * | -------------------- | ---------------- |
 * | Input Object         | Object           |
 * | List                 | Array            |
 * | Boolean              | Boolean          |
 * | String / Enum        | String           |
 * | Int / Float          | Number           |
 * | Null                 | null             |
 *
 */

function valueFromASTUntyped(valueNode, variables) {
  switch (valueNode.kind) {
    case Kind.NULL:
      return null;

    case Kind.INT:
      return parseInt(valueNode.value, 10);

    case Kind.FLOAT:
      return parseFloat(valueNode.value);

    case Kind.STRING:
    case Kind.ENUM:
    case Kind.BOOLEAN:
      return valueNode.value;

    case Kind.LIST:
      return valueNode.values.map((node) =>
        valueFromASTUntyped(node, variables),
      );

    case Kind.OBJECT:
      return keyValMap(
        valueNode.fields,
        (field) => field.name.value,
        (field) => valueFromASTUntyped(field.value, variables),
      );

    case Kind.VARIABLE:
      return variables === null || variables === void 0
        ? void 0
        : variables[valueNode.name.value];
  }
}

/**
 * Upholds the spec rules about naming.
 */

function assertName(name) {
  name != null || devAssert(false, 'Must provide name.');
  typeof name === 'string' || devAssert(false, 'Expected name to be a string.');

  if (name.length === 0) {
    throw new GraphQLError('Expected name to be a non-empty string.');
  }

  for (let i = 1; i < name.length; ++i) {
    if (!isNameContinue(name.charCodeAt(i))) {
      throw new GraphQLError(
        `Names must only contain [_a-zA-Z0-9] but "${name}" does not.`,
      );
    }
  }

  if (!isNameStart(name.charCodeAt(0))) {
    throw new GraphQLError(
      `Names must start with [_a-zA-Z] but "${name}" does not.`,
    );
  }

  return name;
}
/**
 * Upholds the spec rules about naming enum values.
 *
 * @internal
 */

function assertEnumValueName(name) {
  if (name === 'true' || name === 'false' || name === 'null') {
    throw new GraphQLError(`Enum values cannot be named: ${name}`);
  }

  return assertName(name);
}

function isType(type) {
  return (
    isScalarType(type) ||
    isObjectType(type) ||
    isInterfaceType(type) ||
    isUnionType(type) ||
    isEnumType(type) ||
    isInputObjectType(type) ||
    isListType(type) ||
    isNonNullType(type)
  );
}
/**
 * There are predicates for each kind of GraphQL type.
 */

function isScalarType(type) {
  return instanceOf(type, GraphQLScalarType);
}
function isObjectType(type) {
  return instanceOf(type, GraphQLObjectType);
}
function isInterfaceType(type) {
  return instanceOf(type, GraphQLInterfaceType);
}
function isUnionType(type) {
  return instanceOf(type, GraphQLUnionType);
}
function isEnumType(type) {
  return instanceOf(type, GraphQLEnumType);
}
function isInputObjectType(type) {
  return instanceOf(type, GraphQLInputObjectType);
}
function isListType(type) {
  return instanceOf(type, GraphQLList);
}
function isNonNullType(type) {
  return instanceOf(type, GraphQLNonNull);
}
/**
 * These types may be used as input types for arguments and directives.
 */

function isInputType(type) {
  return (
    isScalarType(type) ||
    isEnumType(type) ||
    isInputObjectType(type) ||
    (isWrappingType(type) && isInputType(type.ofType))
  );
}
/**
 * These types may be used as output types as the result of fields.
 */

function isOutputType(type) {
  return (
    isScalarType(type) ||
    isObjectType(type) ||
    isInterfaceType(type) ||
    isUnionType(type) ||
    isEnumType(type) ||
    (isWrappingType(type) && isOutputType(type.ofType))
  );
}
/**
 * These types may describe types which may be leaf values.
 */

function isLeafType(type) {
  return isScalarType(type) || isEnumType(type);
}
/**
 * These types may describe the parent context of a selection set.
 */

function isCompositeType(type) {
  return isObjectType(type) || isInterfaceType(type) || isUnionType(type);
}
/**
 * These types may describe the parent context of a selection set.
 */

function isAbstractType(type) {
  return isInterfaceType(type) || isUnionType(type);
}
/**
 * List Type Wrapper
 *
 * A list is a wrapping type which points to another type.
 * Lists are often created within the context of defining the fields of
 * an object type.
 *
 * Example:
 *
 * ```ts
 * const PersonType = new GraphQLObjectType({
 *   name: 'Person',
 *   fields: () => ({
 *     parents: { type: new GraphQLList(PersonType) },
 *     children: { type: new GraphQLList(PersonType) },
 *   })
 * })
 * ```
 */

class GraphQLList {
  constructor(ofType) {
    isType(ofType) ||
      devAssert(false, `Expected ${inspect$1(ofType)} to be a GraphQL type.`);
    this.ofType = ofType;
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLList';
  }

  toString() {
    return '[' + String(this.ofType) + ']';
  }

  toJSON() {
    return this.toString();
  }
}
/**
 * Non-Null Type Wrapper
 *
 * A non-null is a wrapping type which points to another type.
 * Non-null types enforce that their values are never null and can ensure
 * an error is raised if this ever occurs during a request. It is useful for
 * fields which you can make a strong guarantee on non-nullability, for example
 * usually the id field of a database row will never be null.
 *
 * Example:
 *
 * ```ts
 * const RowType = new GraphQLObjectType({
 *   name: 'Row',
 *   fields: () => ({
 *     id: { type: new GraphQLNonNull(GraphQLString) },
 *   })
 * })
 * ```
 * Note: the enforcement of non-nullability occurs within the executor.
 */

class GraphQLNonNull {
  constructor(ofType) {
    isNullableType(ofType) ||
      devAssert(
        false,
        `Expected ${inspect$1(ofType)} to be a GraphQL nullable type.`,
      );
    this.ofType = ofType;
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLNonNull';
  }

  toString() {
    return String(this.ofType) + '!';
  }

  toJSON() {
    return this.toString();
  }
}
/**
 * These types wrap and modify other types
 */

function isWrappingType(type) {
  return isListType(type) || isNonNullType(type);
}
/**
 * These types can all accept null as a value.
 */

function isNullableType(type) {
  return isType(type) && !isNonNullType(type);
}
function getNullableType(type) {
  if (type) {
    return isNonNullType(type) ? type.ofType : type;
  }
}
/**
 * These named types do not include modifiers like List or NonNull.
 */

function isNamedType(type) {
  return (
    isScalarType(type) ||
    isObjectType(type) ||
    isInterfaceType(type) ||
    isUnionType(type) ||
    isEnumType(type) ||
    isInputObjectType(type)
  );
}
function getNamedType(type) {
  if (type) {
    let unwrappedType = type;

    while (isWrappingType(unwrappedType)) {
      unwrappedType = unwrappedType.ofType;
    }

    return unwrappedType;
  }
}
/**
 * Used while defining GraphQL types to allow for circular references in
 * otherwise immutable type definitions.
 */

function resolveReadonlyArrayThunk(thunk) {
  return typeof thunk === 'function' ? thunk() : thunk;
}
function resolveObjMapThunk(thunk) {
  return typeof thunk === 'function' ? thunk() : thunk;
}
/**
 * Custom extensions
 *
 * @remarks
 * Use a unique identifier name for your extension, for example the name of
 * your library or project. Do not use a shortened identifier as this increases
 * the risk of conflicts. We recommend you add at most one extension field,
 * an object which can contain all the values you need.
 */

/**
 * Scalar Type Definition
 *
 * The leaf values of any request and input values to arguments are
 * Scalars (or Enums) and are defined with a name and a series of functions
 * used to parse input from ast or variables and to ensure validity.
 *
 * If a type's serialize function returns `null` or does not return a value
 * (i.e. it returns `undefined`) then an error will be raised and a `null`
 * value will be returned in the response. It is always better to validate
 *
 * Example:
 *
 * ```ts
 * const OddType = new GraphQLScalarType({
 *   name: 'Odd',
 *   serialize(value) {
 *     if (!Number.isFinite(value)) {
 *       throw new Error(
 *         `Scalar "Odd" cannot represent "${value}" since it is not a finite number.`,
 *       );
 *     }
 *
 *     if (value % 2 === 0) {
 *       throw new Error(`Scalar "Odd" cannot represent "${value}" since it is even.`);
 *     }
 *     return value;
 *   }
 * });
 * ```
 */
class GraphQLScalarType {
  constructor(config) {
    var _config$parseValue,
      _config$serialize,
      _config$parseLiteral,
      _config$extensionASTN;

    const parseValue =
      (_config$parseValue = config.parseValue) !== null &&
      _config$parseValue !== void 0
        ? _config$parseValue
        : identityFunc;
    this.name = assertName(config.name);
    this.description = config.description;
    this.specifiedByURL = config.specifiedByURL;
    this.serialize =
      (_config$serialize = config.serialize) !== null &&
      _config$serialize !== void 0
        ? _config$serialize
        : identityFunc;
    this.parseValue = parseValue;
    this.parseLiteral =
      (_config$parseLiteral = config.parseLiteral) !== null &&
      _config$parseLiteral !== void 0
        ? _config$parseLiteral
        : (node, variables) => parseValue(valueFromASTUntyped(node, variables));
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN = config.extensionASTNodes) !== null &&
      _config$extensionASTN !== void 0
        ? _config$extensionASTN
        : [];
    config.specifiedByURL == null ||
      typeof config.specifiedByURL === 'string' ||
      devAssert(
        false,
        `${this.name} must provide "specifiedByURL" as a string, ` +
          `but got: ${inspect$1(config.specifiedByURL)}.`,
      );
    config.serialize == null ||
      typeof config.serialize === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "serialize" function. If this custom Scalar is also used as an input type, ensure "parseValue" and "parseLiteral" functions are also provided.`,
      );

    if (config.parseLiteral) {
      (typeof config.parseValue === 'function' &&
        typeof config.parseLiteral === 'function') ||
        devAssert(
          false,
          `${this.name} must provide both "parseValue" and "parseLiteral" functions.`,
        );
    }
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLScalarType';
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      specifiedByURL: this.specifiedByURL,
      serialize: this.serialize,
      parseValue: this.parseValue,
      parseLiteral: this.parseLiteral,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

/**
 * Object Type Definition
 *
 * Almost all of the GraphQL types you define will be object types. Object types
 * have a name, but most importantly describe their fields.
 *
 * Example:
 *
 * ```ts
 * const AddressType = new GraphQLObjectType({
 *   name: 'Address',
 *   fields: {
 *     street: { type: GraphQLString },
 *     number: { type: GraphQLInt },
 *     formatted: {
 *       type: GraphQLString,
 *       resolve(obj) {
 *         return obj.number + ' ' + obj.street
 *       }
 *     }
 *   }
 * });
 * ```
 *
 * When two types need to refer to each other, or a type needs to refer to
 * itself in a field, you can use a function expression (aka a closure or a
 * thunk) to supply the fields lazily.
 *
 * Example:
 *
 * ```ts
 * const PersonType = new GraphQLObjectType({
 *   name: 'Person',
 *   fields: () => ({
 *     name: { type: GraphQLString },
 *     bestFriend: { type: PersonType },
 *   })
 * });
 * ```
 */
class GraphQLObjectType {
  constructor(config) {
    var _config$extensionASTN2;

    this.name = assertName(config.name);
    this.description = config.description;
    this.isTypeOf = config.isTypeOf;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN2 = config.extensionASTNodes) !== null &&
      _config$extensionASTN2 !== void 0
        ? _config$extensionASTN2
        : [];

    this._fields = () => defineFieldMap(config);

    this._interfaces = () => defineInterfaces(config);

    config.isTypeOf == null ||
      typeof config.isTypeOf === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "isTypeOf" as a function, ` +
          `but got: ${inspect$1(config.isTypeOf)}.`,
      );
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLObjectType';
  }

  getFields() {
    if (typeof this._fields === 'function') {
      this._fields = this._fields();
    }

    return this._fields;
  }

  getInterfaces() {
    if (typeof this._interfaces === 'function') {
      this._interfaces = this._interfaces();
    }

    return this._interfaces;
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      interfaces: this.getInterfaces(),
      fields: fieldsToFieldsConfig(this.getFields()),
      isTypeOf: this.isTypeOf,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function defineInterfaces(config) {
  var _config$interfaces;

  const interfaces = resolveReadonlyArrayThunk(
    (_config$interfaces = config.interfaces) !== null &&
      _config$interfaces !== void 0
      ? _config$interfaces
      : [],
  );
  Array.isArray(interfaces) ||
    devAssert(
      false,
      `${config.name} interfaces must be an Array or a function which returns an Array.`,
    );
  return interfaces;
}

function defineFieldMap(config) {
  const fieldMap = resolveObjMapThunk(config.fields);
  isPlainObj(fieldMap) ||
    devAssert(
      false,
      `${config.name} fields must be an object with field names as keys or a function which returns such an object.`,
    );
  return mapValue(fieldMap, (fieldConfig, fieldName) => {
    var _fieldConfig$args;

    isPlainObj(fieldConfig) ||
      devAssert(
        false,
        `${config.name}.${fieldName} field config must be an object.`,
      );
    fieldConfig.resolve == null ||
      typeof fieldConfig.resolve === 'function' ||
      devAssert(
        false,
        `${config.name}.${fieldName} field resolver must be a function if ` +
          `provided, but got: ${inspect$1(fieldConfig.resolve)}.`,
      );
    const argsConfig =
      (_fieldConfig$args = fieldConfig.args) !== null &&
      _fieldConfig$args !== void 0
        ? _fieldConfig$args
        : {};
    isPlainObj(argsConfig) ||
      devAssert(
        false,
        `${config.name}.${fieldName} args must be an object with argument names as keys.`,
      );
    return {
      name: assertName(fieldName),
      description: fieldConfig.description,
      type: fieldConfig.type,
      args: defineArguments(argsConfig),
      resolve: fieldConfig.resolve,
      subscribe: fieldConfig.subscribe,
      deprecationReason: fieldConfig.deprecationReason,
      extensions: toObjMap(fieldConfig.extensions),
      astNode: fieldConfig.astNode,
    };
  });
}

function defineArguments(config) {
  return Object.entries(config).map(([argName, argConfig]) => ({
    name: assertName(argName),
    description: argConfig.description,
    type: argConfig.type,
    defaultValue: argConfig.defaultValue,
    deprecationReason: argConfig.deprecationReason,
    extensions: toObjMap(argConfig.extensions),
    astNode: argConfig.astNode,
  }));
}

function isPlainObj(obj) {
  return isObjectLike$1(obj) && !Array.isArray(obj);
}

function fieldsToFieldsConfig(fields) {
  return mapValue(fields, (field) => ({
    description: field.description,
    type: field.type,
    args: argsToArgsConfig(field.args),
    resolve: field.resolve,
    subscribe: field.subscribe,
    deprecationReason: field.deprecationReason,
    extensions: field.extensions,
    astNode: field.astNode,
  }));
}
/**
 * @internal
 */

function argsToArgsConfig(args) {
  return keyValMap(
    args,
    (arg) => arg.name,
    (arg) => ({
      description: arg.description,
      type: arg.type,
      defaultValue: arg.defaultValue,
      deprecationReason: arg.deprecationReason,
      extensions: arg.extensions,
      astNode: arg.astNode,
    }),
  );
}
function isRequiredArgument(arg) {
  return isNonNullType(arg.type) && arg.defaultValue === undefined;
}

/**
 * Interface Type Definition
 *
 * When a field can return one of a heterogeneous set of types, a Interface type
 * is used to describe what types are possible, what fields are in common across
 * all types, as well as a function to determine which type is actually used
 * when the field is resolved.
 *
 * Example:
 *
 * ```ts
 * const EntityType = new GraphQLInterfaceType({
 *   name: 'Entity',
 *   fields: {
 *     name: { type: GraphQLString }
 *   }
 * });
 * ```
 */
class GraphQLInterfaceType {
  constructor(config) {
    var _config$extensionASTN3;

    this.name = assertName(config.name);
    this.description = config.description;
    this.resolveType = config.resolveType;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN3 = config.extensionASTNodes) !== null &&
      _config$extensionASTN3 !== void 0
        ? _config$extensionASTN3
        : [];
    this._fields = defineFieldMap.bind(undefined, config);
    this._interfaces = defineInterfaces.bind(undefined, config);
    config.resolveType == null ||
      typeof config.resolveType === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "resolveType" as a function, ` +
          `but got: ${inspect$1(config.resolveType)}.`,
      );
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLInterfaceType';
  }

  getFields() {
    if (typeof this._fields === 'function') {
      this._fields = this._fields();
    }

    return this._fields;
  }

  getInterfaces() {
    if (typeof this._interfaces === 'function') {
      this._interfaces = this._interfaces();
    }

    return this._interfaces;
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      interfaces: this.getInterfaces(),
      fields: fieldsToFieldsConfig(this.getFields()),
      resolveType: this.resolveType,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

/**
 * Union Type Definition
 *
 * When a field can return one of a heterogeneous set of types, a Union type
 * is used to describe what types are possible as well as providing a function
 * to determine which type is actually used when the field is resolved.
 *
 * Example:
 *
 * ```ts
 * const PetType = new GraphQLUnionType({
 *   name: 'Pet',
 *   types: [ DogType, CatType ],
 *   resolveType(value) {
 *     if (value instanceof Dog) {
 *       return DogType;
 *     }
 *     if (value instanceof Cat) {
 *       return CatType;
 *     }
 *   }
 * });
 * ```
 */
class GraphQLUnionType {
  constructor(config) {
    var _config$extensionASTN4;

    this.name = assertName(config.name);
    this.description = config.description;
    this.resolveType = config.resolveType;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN4 = config.extensionASTNodes) !== null &&
      _config$extensionASTN4 !== void 0
        ? _config$extensionASTN4
        : [];
    this._types = defineTypes.bind(undefined, config);
    config.resolveType == null ||
      typeof config.resolveType === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "resolveType" as a function, ` +
          `but got: ${inspect$1(config.resolveType)}.`,
      );
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLUnionType';
  }

  getTypes() {
    if (typeof this._types === 'function') {
      this._types = this._types();
    }

    return this._types;
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      types: this.getTypes(),
      resolveType: this.resolveType,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function defineTypes(config) {
  const types = resolveReadonlyArrayThunk(config.types);
  Array.isArray(types) ||
    devAssert(
      false,
      `Must provide Array of types or a function which returns such an array for Union ${config.name}.`,
    );
  return types;
}

/**
 * Enum Type Definition
 *
 * Some leaf values of requests and input values are Enums. GraphQL serializes
 * Enum values as strings, however internally Enums can be represented by any
 * kind of type, often integers.
 *
 * Example:
 *
 * ```ts
 * const RGBType = new GraphQLEnumType({
 *   name: 'RGB',
 *   values: {
 *     RED: { value: 0 },
 *     GREEN: { value: 1 },
 *     BLUE: { value: 2 }
 *   }
 * });
 * ```
 *
 * Note: If a value is not provided in a definition, the name of the enum value
 * will be used as its internal value.
 */
class GraphQLEnumType {
  /* <T> */
  constructor(config) {
    var _config$extensionASTN5;

    this.name = assertName(config.name);
    this.description = config.description;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN5 = config.extensionASTNodes) !== null &&
      _config$extensionASTN5 !== void 0
        ? _config$extensionASTN5
        : [];
    this._values =
      typeof config.values === 'function'
        ? config.values
        : defineEnumValues(this.name, config.values);
    this._valueLookup = null;
    this._nameLookup = null;
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLEnumType';
  }

  getValues() {
    if (typeof this._values === 'function') {
      this._values = defineEnumValues(this.name, this._values());
    }

    return this._values;
  }

  getValue(name) {
    if (this._nameLookup === null) {
      this._nameLookup = keyMap(this.getValues(), (value) => value.name);
    }

    return this._nameLookup[name];
  }

  serialize(outputValue) {
    if (this._valueLookup === null) {
      this._valueLookup = new Map(
        this.getValues().map((enumValue) => [enumValue.value, enumValue]),
      );
    }

    const enumValue = this._valueLookup.get(outputValue);

    if (enumValue === undefined) {
      throw new GraphQLError(
        `Enum "${this.name}" cannot represent value: ${inspect$1(outputValue)}`,
      );
    }

    return enumValue.name;
  }

  parseValue(inputValue) /* T */
  {
    if (typeof inputValue !== 'string') {
      const valueStr = inspect$1(inputValue);
      throw new GraphQLError(
        `Enum "${this.name}" cannot represent non-string value: ${valueStr}.` +
          didYouMeanEnumValue(this, valueStr),
      );
    }

    const enumValue = this.getValue(inputValue);

    if (enumValue == null) {
      throw new GraphQLError(
        `Value "${inputValue}" does not exist in "${this.name}" enum.` +
          didYouMeanEnumValue(this, inputValue),
      );
    }

    return enumValue.value;
  }

  parseLiteral(valueNode, _variables) /* T */
  {
    // Note: variables will be resolved to a value before calling this function.
    if (valueNode.kind !== Kind.ENUM) {
      const valueStr = print(valueNode);
      throw new GraphQLError(
        `Enum "${this.name}" cannot represent non-enum value: ${valueStr}.` +
          didYouMeanEnumValue(this, valueStr),
        {
          nodes: valueNode,
        },
      );
    }

    const enumValue = this.getValue(valueNode.value);

    if (enumValue == null) {
      const valueStr = print(valueNode);
      throw new GraphQLError(
        `Value "${valueStr}" does not exist in "${this.name}" enum.` +
          didYouMeanEnumValue(this, valueStr),
        {
          nodes: valueNode,
        },
      );
    }

    return enumValue.value;
  }

  toConfig() {
    const values = keyValMap(
      this.getValues(),
      (value) => value.name,
      (value) => ({
        description: value.description,
        value: value.value,
        deprecationReason: value.deprecationReason,
        extensions: value.extensions,
        astNode: value.astNode,
      }),
    );
    return {
      name: this.name,
      description: this.description,
      values,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function didYouMeanEnumValue(enumType, unknownValueStr) {
  const allNames = enumType.getValues().map((value) => value.name);
  const suggestedValues = suggestionList(unknownValueStr, allNames);
  return didYouMean('the enum value', suggestedValues);
}

function defineEnumValues(typeName, valueMap) {
  isPlainObj(valueMap) ||
    devAssert(
      false,
      `${typeName} values must be an object with value names as keys.`,
    );
  return Object.entries(valueMap).map(([valueName, valueConfig]) => {
    isPlainObj(valueConfig) ||
      devAssert(
        false,
        `${typeName}.${valueName} must refer to an object with a "value" key ` +
          `representing an internal value but got: ${inspect$1(valueConfig)}.`,
      );
    return {
      name: assertEnumValueName(valueName),
      description: valueConfig.description,
      value: valueConfig.value !== undefined ? valueConfig.value : valueName,
      deprecationReason: valueConfig.deprecationReason,
      extensions: toObjMap(valueConfig.extensions),
      astNode: valueConfig.astNode,
    };
  });
}

/**
 * Input Object Type Definition
 *
 * An input object defines a structured collection of fields which may be
 * supplied to a field argument.
 *
 * Using `NonNull` will ensure that a value must be provided by the query
 *
 * Example:
 *
 * ```ts
 * const GeoPoint = new GraphQLInputObjectType({
 *   name: 'GeoPoint',
 *   fields: {
 *     lat: { type: new GraphQLNonNull(GraphQLFloat) },
 *     lon: { type: new GraphQLNonNull(GraphQLFloat) },
 *     alt: { type: GraphQLFloat, defaultValue: 0 },
 *   }
 * });
 * ```
 */
class GraphQLInputObjectType {
  constructor(config) {
    var _config$extensionASTN6, _config$isOneOf;

    this.name = assertName(config.name);
    this.description = config.description;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN6 = config.extensionASTNodes) !== null &&
      _config$extensionASTN6 !== void 0
        ? _config$extensionASTN6
        : [];
    this.isOneOf =
      (_config$isOneOf = config.isOneOf) !== null && _config$isOneOf !== void 0
        ? _config$isOneOf
        : false;
    this._fields = defineInputFieldMap.bind(undefined, config);
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLInputObjectType';
  }

  getFields() {
    if (typeof this._fields === 'function') {
      this._fields = this._fields();
    }

    return this._fields;
  }

  toConfig() {
    const fields = mapValue(this.getFields(), (field) => ({
      description: field.description,
      type: field.type,
      defaultValue: field.defaultValue,
      deprecationReason: field.deprecationReason,
      extensions: field.extensions,
      astNode: field.astNode,
    }));
    return {
      name: this.name,
      description: this.description,
      fields,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
      isOneOf: this.isOneOf,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function defineInputFieldMap(config) {
  const fieldMap = resolveObjMapThunk(config.fields);
  isPlainObj(fieldMap) ||
    devAssert(
      false,
      `${config.name} fields must be an object with field names as keys or a function which returns such an object.`,
    );
  return mapValue(fieldMap, (fieldConfig, fieldName) => {
    !('resolve' in fieldConfig) ||
      devAssert(
        false,
        `${config.name}.${fieldName} field has a resolve property, but Input Types cannot define resolvers.`,
      );
    return {
      name: assertName(fieldName),
      description: fieldConfig.description,
      type: fieldConfig.type,
      defaultValue: fieldConfig.defaultValue,
      deprecationReason: fieldConfig.deprecationReason,
      extensions: toObjMap(fieldConfig.extensions),
      astNode: fieldConfig.astNode,
    };
  });
}

function isRequiredInputField(field) {
  return isNonNullType(field.type) && field.defaultValue === undefined;
}

/**
 * Provided two types, return true if the types are equal (invariant).
 */
function isEqualType(typeA, typeB) {
  // Equivalent types are equal.
  if (typeA === typeB) {
    return true;
  } // If either type is non-null, the other must also be non-null.

  if (isNonNullType(typeA) && isNonNullType(typeB)) {
    return isEqualType(typeA.ofType, typeB.ofType);
  } // If either type is a list, the other must also be a list.

  if (isListType(typeA) && isListType(typeB)) {
    return isEqualType(typeA.ofType, typeB.ofType);
  } // Otherwise the types are not equal.

  return false;
}
/**
 * Provided a type and a super type, return true if the first type is either
 * equal or a subset of the second super type (covariant).
 */

function isTypeSubTypeOf(schema, maybeSubType, superType) {
  // Equivalent type is a valid subtype
  if (maybeSubType === superType) {
    return true;
  } // If superType is non-null, maybeSubType must also be non-null.

  if (isNonNullType(superType)) {
    if (isNonNullType(maybeSubType)) {
      return isTypeSubTypeOf(schema, maybeSubType.ofType, superType.ofType);
    }

    return false;
  }

  if (isNonNullType(maybeSubType)) {
    // If superType is nullable, maybeSubType may be non-null or nullable.
    return isTypeSubTypeOf(schema, maybeSubType.ofType, superType);
  } // If superType type is a list, maybeSubType type must also be a list.

  if (isListType(superType)) {
    if (isListType(maybeSubType)) {
      return isTypeSubTypeOf(schema, maybeSubType.ofType, superType.ofType);
    }

    return false;
  }

  if (isListType(maybeSubType)) {
    // If superType is not a list, maybeSubType must also be not a list.
    return false;
  } // If superType type is an abstract type, check if it is super type of maybeSubType.
  // Otherwise, the child type is not a valid subtype of the parent type.

  return (
    isAbstractType(superType) &&
    (isInterfaceType(maybeSubType) || isObjectType(maybeSubType)) &&
    schema.isSubType(superType, maybeSubType)
  );
}
/**
 * Provided two composite types, determine if they "overlap". Two composite
 * types overlap when the Sets of possible concrete types for each intersect.
 *
 * This is often used to determine if a fragment of a given type could possibly
 * be visited in a context of another type.
 *
 * This function is commutative.
 */

function doTypesOverlap(schema, typeA, typeB) {
  // Equivalent types overlap
  if (typeA === typeB) {
    return true;
  }

  if (isAbstractType(typeA)) {
    if (isAbstractType(typeB)) {
      // If both types are abstract, then determine if there is any intersection
      // between possible concrete types of each.
      return schema
        .getPossibleTypes(typeA)
        .some((type) => schema.isSubType(typeB, type));
    } // Determine if the latter type is a possible concrete type of the former.

    return schema.isSubType(typeA, typeB);
  }

  if (isAbstractType(typeB)) {
    // Determine if the former type is a possible concrete type of the latter.
    return schema.isSubType(typeB, typeA);
  } // Otherwise the types do not overlap.

  return false;
}

/**
 * Maximum possible Int value as per GraphQL Spec (32-bit signed integer).
 * n.b. This differs from JavaScript's numbers that are IEEE 754 doubles safe up-to 2^53 - 1
 * */

const GRAPHQL_MAX_INT = 2147483647;
/**
 * Minimum possible Int value as per GraphQL Spec (32-bit signed integer).
 * n.b. This differs from JavaScript's numbers that are IEEE 754 doubles safe starting at -(2^53 - 1)
 * */

const GRAPHQL_MIN_INT = -2147483648;
const GraphQLInt = new GraphQLScalarType({
  name: 'Int',
  description:
    'The `Int` scalar type represents non-fractional signed whole numeric values. Int can represent values between -(2^31) and 2^31 - 1.',

  serialize(outputValue) {
    const coercedValue = serializeObject(outputValue);

    if (typeof coercedValue === 'boolean') {
      return coercedValue ? 1 : 0;
    }

    let num = coercedValue;

    if (typeof coercedValue === 'string' && coercedValue !== '') {
      num = Number(coercedValue);
    }

    if (typeof num !== 'number' || !Number.isInteger(num)) {
      throw new GraphQLError(
        `Int cannot represent non-integer value: ${inspect$1(coercedValue)}`,
      );
    }

    if (num > GRAPHQL_MAX_INT || num < GRAPHQL_MIN_INT) {
      throw new GraphQLError(
        'Int cannot represent non 32-bit signed integer value: ' +
          inspect$1(coercedValue),
      );
    }

    return num;
  },

  parseValue(inputValue) {
    if (typeof inputValue !== 'number' || !Number.isInteger(inputValue)) {
      throw new GraphQLError(
        `Int cannot represent non-integer value: ${inspect$1(inputValue)}`,
      );
    }

    if (inputValue > GRAPHQL_MAX_INT || inputValue < GRAPHQL_MIN_INT) {
      throw new GraphQLError(
        `Int cannot represent non 32-bit signed integer value: ${inputValue}`,
      );
    }

    return inputValue;
  },

  parseLiteral(valueNode) {
    if (valueNode.kind !== Kind.INT) {
      throw new GraphQLError(
        `Int cannot represent non-integer value: ${print(valueNode)}`,
        {
          nodes: valueNode,
        },
      );
    }

    const num = parseInt(valueNode.value, 10);

    if (num > GRAPHQL_MAX_INT || num < GRAPHQL_MIN_INT) {
      throw new GraphQLError(
        `Int cannot represent non 32-bit signed integer value: ${valueNode.value}`,
        {
          nodes: valueNode,
        },
      );
    }

    return num;
  },
});
const GraphQLFloat = new GraphQLScalarType({
  name: 'Float',
  description:
    'The `Float` scalar type represents signed double-precision fractional values as specified by [IEEE 754](https://en.wikipedia.org/wiki/IEEE_floating_point).',

  serialize(outputValue) {
    const coercedValue = serializeObject(outputValue);

    if (typeof coercedValue === 'boolean') {
      return coercedValue ? 1 : 0;
    }

    let num = coercedValue;

    if (typeof coercedValue === 'string' && coercedValue !== '') {
      num = Number(coercedValue);
    }

    if (typeof num !== 'number' || !Number.isFinite(num)) {
      throw new GraphQLError(
        `Float cannot represent non numeric value: ${inspect$1(coercedValue)}`,
      );
    }

    return num;
  },

  parseValue(inputValue) {
    if (typeof inputValue !== 'number' || !Number.isFinite(inputValue)) {
      throw new GraphQLError(
        `Float cannot represent non numeric value: ${inspect$1(inputValue)}`,
      );
    }

    return inputValue;
  },

  parseLiteral(valueNode) {
    if (valueNode.kind !== Kind.FLOAT && valueNode.kind !== Kind.INT) {
      throw new GraphQLError(
        `Float cannot represent non numeric value: ${print(valueNode)}`,
        valueNode,
      );
    }

    return parseFloat(valueNode.value);
  },
});
const GraphQLString = new GraphQLScalarType({
  name: 'String',
  description:
    'The `String` scalar type represents textual data, represented as UTF-8 character sequences. The String type is most often used by GraphQL to represent free-form human-readable text.',

  serialize(outputValue) {
    const coercedValue = serializeObject(outputValue); // Serialize string, boolean and number values to a string, but do not
    // attempt to coerce object, function, symbol, or other types as strings.

    if (typeof coercedValue === 'string') {
      return coercedValue;
    }

    if (typeof coercedValue === 'boolean') {
      return coercedValue ? 'true' : 'false';
    }

    if (typeof coercedValue === 'number' && Number.isFinite(coercedValue)) {
      return coercedValue.toString();
    }

    throw new GraphQLError(
      `String cannot represent value: ${inspect$1(outputValue)}`,
    );
  },

  parseValue(inputValue) {
    if (typeof inputValue !== 'string') {
      throw new GraphQLError(
        `String cannot represent a non string value: ${inspect$1(inputValue)}`,
      );
    }

    return inputValue;
  },

  parseLiteral(valueNode) {
    if (valueNode.kind !== Kind.STRING) {
      throw new GraphQLError(
        `String cannot represent a non string value: ${print(valueNode)}`,
        {
          nodes: valueNode,
        },
      );
    }

    return valueNode.value;
  },
});
const GraphQLBoolean = new GraphQLScalarType({
  name: 'Boolean',
  description: 'The `Boolean` scalar type represents `true` or `false`.',

  serialize(outputValue) {
    const coercedValue = serializeObject(outputValue);

    if (typeof coercedValue === 'boolean') {
      return coercedValue;
    }

    if (Number.isFinite(coercedValue)) {
      return coercedValue !== 0;
    }

    throw new GraphQLError(
      `Boolean cannot represent a non boolean value: ${inspect$1(coercedValue)}`,
    );
  },

  parseValue(inputValue) {
    if (typeof inputValue !== 'boolean') {
      throw new GraphQLError(
        `Boolean cannot represent a non boolean value: ${inspect$1(inputValue)}`,
      );
    }

    return inputValue;
  },

  parseLiteral(valueNode) {
    if (valueNode.kind !== Kind.BOOLEAN) {
      throw new GraphQLError(
        `Boolean cannot represent a non boolean value: ${print(valueNode)}`,
        {
          nodes: valueNode,
        },
      );
    }

    return valueNode.value;
  },
});
const GraphQLID = new GraphQLScalarType({
  name: 'ID',
  description:
    'The `ID` scalar type represents a unique identifier, often used to refetch an object or as key for a cache. The ID type appears in a JSON response as a String; however, it is not intended to be human-readable. When expected as an input type, any string (such as `"4"`) or integer (such as `4`) input value will be accepted as an ID.',

  serialize(outputValue) {
    const coercedValue = serializeObject(outputValue);

    if (typeof coercedValue === 'string') {
      return coercedValue;
    }

    if (Number.isInteger(coercedValue)) {
      return String(coercedValue);
    }

    throw new GraphQLError(
      `ID cannot represent value: ${inspect$1(outputValue)}`,
    );
  },

  parseValue(inputValue) {
    if (typeof inputValue === 'string') {
      return inputValue;
    }

    if (typeof inputValue === 'number' && Number.isInteger(inputValue)) {
      return inputValue.toString();
    }

    throw new GraphQLError(`ID cannot represent value: ${inspect$1(inputValue)}`);
  },

  parseLiteral(valueNode) {
    if (valueNode.kind !== Kind.STRING && valueNode.kind !== Kind.INT) {
      throw new GraphQLError(
        'ID cannot represent a non-string and non-integer value: ' +
          print(valueNode),
        {
          nodes: valueNode,
        },
      );
    }

    return valueNode.value;
  },
});
const specifiedScalarTypes = Object.freeze([
  GraphQLString,
  GraphQLInt,
  GraphQLFloat,
  GraphQLBoolean,
  GraphQLID,
]);
function isSpecifiedScalarType(type) {
  return specifiedScalarTypes.some(({ name }) => type.name === name);
} // Support serializing objects with custom valueOf() or toJSON() functions -
// a common way to represent a complex value which can be represented as
// a string (ex: MongoDB id objects).

function serializeObject(outputValue) {
  if (isObjectLike$1(outputValue)) {
    if (typeof outputValue.valueOf === 'function') {
      const valueOfResult = outputValue.valueOf();

      if (!isObjectLike$1(valueOfResult)) {
        return valueOfResult;
      }
    }

    if (typeof outputValue.toJSON === 'function') {
      return outputValue.toJSON();
    }
  }

  return outputValue;
}

/**
 * Test if the given value is a GraphQL directive.
 */

function isDirective(directive) {
  return instanceOf(directive, GraphQLDirective);
}
/**
 * Custom extensions
 *
 * @remarks
 * Use a unique identifier name for your extension, for example the name of
 * your library or project. Do not use a shortened identifier as this increases
 * the risk of conflicts. We recommend you add at most one extension field,
 * an object which can contain all the values you need.
 */

/**
 * Directives are used by the GraphQL runtime as a way of modifying execution
 * behavior. Type system creators will usually not create these directly.
 */
class GraphQLDirective {
  constructor(config) {
    var _config$isRepeatable, _config$args;

    this.name = assertName(config.name);
    this.description = config.description;
    this.locations = config.locations;
    this.isRepeatable =
      (_config$isRepeatable = config.isRepeatable) !== null &&
      _config$isRepeatable !== void 0
        ? _config$isRepeatable
        : false;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    Array.isArray(config.locations) ||
      devAssert(false, `@${config.name} locations must be an Array.`);
    const args =
      (_config$args = config.args) !== null && _config$args !== void 0
        ? _config$args
        : {};
    (isObjectLike$1(args) && !Array.isArray(args)) ||
      devAssert(
        false,
        `@${config.name} args must be an object with argument names as keys.`,
      );
    this.args = defineArguments(args);
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLDirective';
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      locations: this.locations,
      args: argsToArgsConfig(this.args),
      isRepeatable: this.isRepeatable,
      extensions: this.extensions,
      astNode: this.astNode,
    };
  }

  toString() {
    return '@' + this.name;
  }

  toJSON() {
    return this.toString();
  }
}

/**
 * Used to conditionally include fields or fragments.
 */
const GraphQLIncludeDirective = new GraphQLDirective({
  name: 'include',
  description:
    'Directs the executor to include this field or fragment only when the `if` argument is true.',
  locations: [
    DirectiveLocation.FIELD,
    DirectiveLocation.FRAGMENT_SPREAD,
    DirectiveLocation.INLINE_FRAGMENT,
  ],
  args: {
    if: {
      type: new GraphQLNonNull(GraphQLBoolean),
      description: 'Included when true.',
    },
  },
});
/**
 * Used to conditionally skip (exclude) fields or fragments.
 */

const GraphQLSkipDirective = new GraphQLDirective({
  name: 'skip',
  description:
    'Directs the executor to skip this field or fragment when the `if` argument is true.',
  locations: [
    DirectiveLocation.FIELD,
    DirectiveLocation.FRAGMENT_SPREAD,
    DirectiveLocation.INLINE_FRAGMENT,
  ],
  args: {
    if: {
      type: new GraphQLNonNull(GraphQLBoolean),
      description: 'Skipped when true.',
    },
  },
});
/**
 * Constant string used for default reason for a deprecation.
 */

const DEFAULT_DEPRECATION_REASON = 'No longer supported';
/**
 * Used to declare element of a GraphQL schema as deprecated.
 */

const GraphQLDeprecatedDirective = new GraphQLDirective({
  name: 'deprecated',
  description: 'Marks an element of a GraphQL schema as no longer supported.',
  locations: [
    DirectiveLocation.FIELD_DEFINITION,
    DirectiveLocation.ARGUMENT_DEFINITION,
    DirectiveLocation.INPUT_FIELD_DEFINITION,
    DirectiveLocation.ENUM_VALUE,
  ],
  args: {
    reason: {
      type: GraphQLString,
      description:
        'Explains why this element was deprecated, usually also including a suggestion for how to access supported similar data. Formatted using the Markdown syntax, as specified by [CommonMark](https://commonmark.org/).',
      defaultValue: DEFAULT_DEPRECATION_REASON,
    },
  },
});
/**
 * Used to provide a URL for specifying the behavior of custom scalar definitions.
 */

const GraphQLSpecifiedByDirective = new GraphQLDirective({
  name: 'specifiedBy',
  description: 'Exposes a URL that specifies the behavior of this scalar.',
  locations: [DirectiveLocation.SCALAR],
  args: {
    url: {
      type: new GraphQLNonNull(GraphQLString),
      description: 'The URL that specifies the behavior of this scalar.',
    },
  },
});
/**
 * Used to indicate an Input Object is a OneOf Input Object.
 */

const GraphQLOneOfDirective = new GraphQLDirective({
  name: 'oneOf',
  description:
    'Indicates exactly one field must be supplied and this field must not be `null`.',
  locations: [DirectiveLocation.INPUT_OBJECT],
  args: {},
});
/**
 * The full list of specified directives.
 */

const specifiedDirectives = Object.freeze([
  GraphQLIncludeDirective,
  GraphQLSkipDirective,
  GraphQLDeprecatedDirective,
  GraphQLSpecifiedByDirective,
  GraphQLOneOfDirective,
]);
function isSpecifiedDirective(directive) {
  return specifiedDirectives.some(({ name }) => name === directive.name);
}

/**
 * Returns true if the provided object is an Object (i.e. not a string literal)
 * and implements the Iterator protocol.
 *
 * This may be used in place of [Array.isArray()][isArray] to determine if
 * an object should be iterated-over e.g. Array, Map, Set, Int8Array,
 * TypedArray, etc. but excludes string literals.
 *
 * @example
 * ```ts
 * isIterableObject([ 1, 2, 3 ]) // true
 * isIterableObject(new Map()) // true
 * isIterableObject('ABC') // false
 * isIterableObject({ key: 'value' }) // false
 * isIterableObject({ length: 1, 0: 'Alpha' }) // false
 * ```
 */
function isIterableObject$1(maybeIterable) {
  return (
    typeof maybeIterable === 'object' &&
    typeof (maybeIterable === null || maybeIterable === void 0
      ? void 0
      : maybeIterable[Symbol.iterator]) === 'function'
  );
}

/**
 * Produces a GraphQL Value AST given a JavaScript object.
 * Function will match JavaScript/JSON values to GraphQL AST schema format
 * by using suggested GraphQLInputType. For example:
 *
 *     astFromValue("value", GraphQLString)
 *
 * A GraphQL type must be provided, which will be used to interpret different
 * JavaScript values.
 *
 * | JSON Value    | GraphQL Value        |
 * | ------------- | -------------------- |
 * | Object        | Input Object         |
 * | Array         | List                 |
 * | Boolean       | Boolean              |
 * | String        | String / Enum Value  |
 * | Number        | Int / Float          |
 * | Unknown       | Enum Value           |
 * | null          | NullValue            |
 *
 */

function astFromValue$1(value, type) {
  if (isNonNullType(type)) {
    const astValue = astFromValue$1(value, type.ofType);

    if (
      (astValue === null || astValue === void 0 ? void 0 : astValue.kind) ===
      Kind.NULL
    ) {
      return null;
    }

    return astValue;
  } // only explicit null, not undefined, NaN

  if (value === null) {
    return {
      kind: Kind.NULL,
    };
  } // undefined

  if (value === undefined) {
    return null;
  } // Convert JavaScript array to GraphQL list. If the GraphQLType is a list, but
  // the value is not an array, convert the value using the list's item type.

  if (isListType(type)) {
    const itemType = type.ofType;

    if (isIterableObject$1(value)) {
      const valuesNodes = [];

      for (const item of value) {
        const itemNode = astFromValue$1(item, itemType);

        if (itemNode != null) {
          valuesNodes.push(itemNode);
        }
      }

      return {
        kind: Kind.LIST,
        values: valuesNodes,
      };
    }

    return astFromValue$1(value, itemType);
  } // Populate the fields of the input object by creating ASTs from each value
  // in the JavaScript object according to the fields in the input type.

  if (isInputObjectType(type)) {
    if (!isObjectLike$1(value)) {
      return null;
    }

    const fieldNodes = [];

    for (const field of Object.values(type.getFields())) {
      const fieldValue = astFromValue$1(value[field.name], field.type);

      if (fieldValue) {
        fieldNodes.push({
          kind: Kind.OBJECT_FIELD,
          name: {
            kind: Kind.NAME,
            value: field.name,
          },
          value: fieldValue,
        });
      }
    }

    return {
      kind: Kind.OBJECT,
      fields: fieldNodes,
    };
  }

  if (isLeafType(type)) {
    // Since value is an internally represented value, it must be serialized
    // to an externally represented value before converting into an AST.
    const serialized = type.serialize(value);

    if (serialized == null) {
      return null;
    } // Others serialize based on their corresponding JavaScript scalar types.

    if (typeof serialized === 'boolean') {
      return {
        kind: Kind.BOOLEAN,
        value: serialized,
      };
    } // JavaScript numbers can be Int or Float values.

    if (typeof serialized === 'number' && Number.isFinite(serialized)) {
      const stringNum = String(serialized);
      return integerStringRegExp$2.test(stringNum)
        ? {
            kind: Kind.INT,
            value: stringNum,
          }
        : {
            kind: Kind.FLOAT,
            value: stringNum,
          };
    }

    if (typeof serialized === 'string') {
      // Enum types use Enum literals.
      if (isEnumType(type)) {
        return {
          kind: Kind.ENUM,
          value: serialized,
        };
      } // ID types can use Int literals.

      if (type === GraphQLID && integerStringRegExp$2.test(serialized)) {
        return {
          kind: Kind.INT,
          value: serialized,
        };
      }

      return {
        kind: Kind.STRING,
        value: serialized,
      };
    }

    throw new TypeError(`Cannot convert value to AST: ${inspect$1(serialized)}.`);
  }
  /* c8 ignore next 3 */
  // Not reachable, all possible types have been considered.

  invariant(false, 'Unexpected input type: ' + inspect$1(type));
}
/**
 * IntValue:
 *   - NegativeSign? 0
 *   - NegativeSign? NonZeroDigit ( Digit+ )?
 */

const integerStringRegExp$2 = /^-?(?:0|[1-9][0-9]*)$/;

const __Schema = new GraphQLObjectType({
  name: '__Schema',
  description:
    'A GraphQL Schema defines the capabilities of a GraphQL server. It exposes all available types and directives on the server, as well as the entry points for query, mutation, and subscription operations.',
  fields: () => ({
    description: {
      type: GraphQLString,
      resolve: (schema) => schema.description,
    },
    types: {
      description: 'A list of all types supported by this server.',
      type: new GraphQLNonNull(new GraphQLList(new GraphQLNonNull(__Type))),

      resolve(schema) {
        return Object.values(schema.getTypeMap());
      },
    },
    queryType: {
      description: 'The type that query operations will be rooted at.',
      type: new GraphQLNonNull(__Type),
      resolve: (schema) => schema.getQueryType(),
    },
    mutationType: {
      description:
        'If this server supports mutation, the type that mutation operations will be rooted at.',
      type: __Type,
      resolve: (schema) => schema.getMutationType(),
    },
    subscriptionType: {
      description:
        'If this server support subscription, the type that subscription operations will be rooted at.',
      type: __Type,
      resolve: (schema) => schema.getSubscriptionType(),
    },
    directives: {
      description: 'A list of all directives supported by this server.',
      type: new GraphQLNonNull(
        new GraphQLList(new GraphQLNonNull(__Directive)),
      ),
      resolve: (schema) => schema.getDirectives(),
    },
  }),
});
const __Directive = new GraphQLObjectType({
  name: '__Directive',
  description:
    "A Directive provides a way to describe alternate runtime execution and type validation behavior in a GraphQL document.\n\nIn some cases, you need to provide options to alter GraphQL's execution behavior in ways field arguments will not suffice, such as conditionally including or skipping a field. Directives provide this by describing additional information to the executor.",
  fields: () => ({
    name: {
      type: new GraphQLNonNull(GraphQLString),
      resolve: (directive) => directive.name,
    },
    description: {
      type: GraphQLString,
      resolve: (directive) => directive.description,
    },
    isRepeatable: {
      type: new GraphQLNonNull(GraphQLBoolean),
      resolve: (directive) => directive.isRepeatable,
    },
    locations: {
      type: new GraphQLNonNull(
        new GraphQLList(new GraphQLNonNull(__DirectiveLocation)),
      ),
      resolve: (directive) => directive.locations,
    },
    args: {
      type: new GraphQLNonNull(
        new GraphQLList(new GraphQLNonNull(__InputValue)),
      ),
      args: {
        includeDeprecated: {
          type: GraphQLBoolean,
          defaultValue: false,
        },
      },

      resolve(field, { includeDeprecated }) {
        return includeDeprecated
          ? field.args
          : field.args.filter((arg) => arg.deprecationReason == null);
      },
    },
  }),
});
const __DirectiveLocation = new GraphQLEnumType({
  name: '__DirectiveLocation',
  description:
    'A Directive can be adjacent to many parts of the GraphQL language, a __DirectiveLocation describes one such possible adjacencies.',
  values: {
    QUERY: {
      value: DirectiveLocation.QUERY,
      description: 'Location adjacent to a query operation.',
    },
    MUTATION: {
      value: DirectiveLocation.MUTATION,
      description: 'Location adjacent to a mutation operation.',
    },
    SUBSCRIPTION: {
      value: DirectiveLocation.SUBSCRIPTION,
      description: 'Location adjacent to a subscription operation.',
    },
    FIELD: {
      value: DirectiveLocation.FIELD,
      description: 'Location adjacent to a field.',
    },
    FRAGMENT_DEFINITION: {
      value: DirectiveLocation.FRAGMENT_DEFINITION,
      description: 'Location adjacent to a fragment definition.',
    },
    FRAGMENT_SPREAD: {
      value: DirectiveLocation.FRAGMENT_SPREAD,
      description: 'Location adjacent to a fragment spread.',
    },
    INLINE_FRAGMENT: {
      value: DirectiveLocation.INLINE_FRAGMENT,
      description: 'Location adjacent to an inline fragment.',
    },
    VARIABLE_DEFINITION: {
      value: DirectiveLocation.VARIABLE_DEFINITION,
      description: 'Location adjacent to a variable definition.',
    },
    SCHEMA: {
      value: DirectiveLocation.SCHEMA,
      description: 'Location adjacent to a schema definition.',
    },
    SCALAR: {
      value: DirectiveLocation.SCALAR,
      description: 'Location adjacent to a scalar definition.',
    },
    OBJECT: {
      value: DirectiveLocation.OBJECT,
      description: 'Location adjacent to an object type definition.',
    },
    FIELD_DEFINITION: {
      value: DirectiveLocation.FIELD_DEFINITION,
      description: 'Location adjacent to a field definition.',
    },
    ARGUMENT_DEFINITION: {
      value: DirectiveLocation.ARGUMENT_DEFINITION,
      description: 'Location adjacent to an argument definition.',
    },
    INTERFACE: {
      value: DirectiveLocation.INTERFACE,
      description: 'Location adjacent to an interface definition.',
    },
    UNION: {
      value: DirectiveLocation.UNION,
      description: 'Location adjacent to a union definition.',
    },
    ENUM: {
      value: DirectiveLocation.ENUM,
      description: 'Location adjacent to an enum definition.',
    },
    ENUM_VALUE: {
      value: DirectiveLocation.ENUM_VALUE,
      description: 'Location adjacent to an enum value definition.',
    },
    INPUT_OBJECT: {
      value: DirectiveLocation.INPUT_OBJECT,
      description: 'Location adjacent to an input object type definition.',
    },
    INPUT_FIELD_DEFINITION: {
      value: DirectiveLocation.INPUT_FIELD_DEFINITION,
      description: 'Location adjacent to an input object field definition.',
    },
  },
});
const __Type = new GraphQLObjectType({
  name: '__Type',
  description:
    'The fundamental unit of any GraphQL Schema is the type. There are many kinds of types in GraphQL as represented by the `__TypeKind` enum.\n\nDepending on the kind of a type, certain fields describe information about that type. Scalar types provide no information beyond a name, description and optional `specifiedByURL`, while Enum types provide their values. Object and Interface types provide the fields they describe. Abstract types, Union and Interface, provide the Object types possible at runtime. List and NonNull types compose other types.',
  fields: () => ({
    kind: {
      type: new GraphQLNonNull(__TypeKind),

      resolve(type) {
        if (isScalarType(type)) {
          return TypeKind.SCALAR;
        }

        if (isObjectType(type)) {
          return TypeKind.OBJECT;
        }

        if (isInterfaceType(type)) {
          return TypeKind.INTERFACE;
        }

        if (isUnionType(type)) {
          return TypeKind.UNION;
        }

        if (isEnumType(type)) {
          return TypeKind.ENUM;
        }

        if (isInputObjectType(type)) {
          return TypeKind.INPUT_OBJECT;
        }

        if (isListType(type)) {
          return TypeKind.LIST;
        }

        if (isNonNullType(type)) {
          return TypeKind.NON_NULL;
        }
        /* c8 ignore next 3 */
        // Not reachable, all possible types have been considered)

        invariant(false, `Unexpected type: "${inspect$1(type)}".`);
      },
    },
    name: {
      type: GraphQLString,
      resolve: (type) => ('name' in type ? type.name : undefined),
    },
    description: {
      type: GraphQLString,
      resolve: (
        type, // FIXME: add test case
      ) =>
        /* c8 ignore next */
        'description' in type ? type.description : undefined,
    },
    specifiedByURL: {
      type: GraphQLString,
      resolve: (obj) =>
        'specifiedByURL' in obj ? obj.specifiedByURL : undefined,
    },
    fields: {
      type: new GraphQLList(new GraphQLNonNull(__Field)),
      args: {
        includeDeprecated: {
          type: GraphQLBoolean,
          defaultValue: false,
        },
      },

      resolve(type, { includeDeprecated }) {
        if (isObjectType(type) || isInterfaceType(type)) {
          const fields = Object.values(type.getFields());
          return includeDeprecated
            ? fields
            : fields.filter((field) => field.deprecationReason == null);
        }
      },
    },
    interfaces: {
      type: new GraphQLList(new GraphQLNonNull(__Type)),

      resolve(type) {
        if (isObjectType(type) || isInterfaceType(type)) {
          return type.getInterfaces();
        }
      },
    },
    possibleTypes: {
      type: new GraphQLList(new GraphQLNonNull(__Type)),

      resolve(type, _args, _context, { schema }) {
        if (isAbstractType(type)) {
          return schema.getPossibleTypes(type);
        }
      },
    },
    enumValues: {
      type: new GraphQLList(new GraphQLNonNull(__EnumValue)),
      args: {
        includeDeprecated: {
          type: GraphQLBoolean,
          defaultValue: false,
        },
      },

      resolve(type, { includeDeprecated }) {
        if (isEnumType(type)) {
          const values = type.getValues();
          return includeDeprecated
            ? values
            : values.filter((field) => field.deprecationReason == null);
        }
      },
    },
    inputFields: {
      type: new GraphQLList(new GraphQLNonNull(__InputValue)),
      args: {
        includeDeprecated: {
          type: GraphQLBoolean,
          defaultValue: false,
        },
      },

      resolve(type, { includeDeprecated }) {
        if (isInputObjectType(type)) {
          const values = Object.values(type.getFields());
          return includeDeprecated
            ? values
            : values.filter((field) => field.deprecationReason == null);
        }
      },
    },
    ofType: {
      type: __Type,
      resolve: (type) => ('ofType' in type ? type.ofType : undefined),
    },
    isOneOf: {
      type: GraphQLBoolean,
      resolve: (type) => {
        if (isInputObjectType(type)) {
          return type.isOneOf;
        }
      },
    },
  }),
});
const __Field = new GraphQLObjectType({
  name: '__Field',
  description:
    'Object and Interface types are described by a list of Fields, each of which has a name, potentially a list of arguments, and a return type.',
  fields: () => ({
    name: {
      type: new GraphQLNonNull(GraphQLString),
      resolve: (field) => field.name,
    },
    description: {
      type: GraphQLString,
      resolve: (field) => field.description,
    },
    args: {
      type: new GraphQLNonNull(
        new GraphQLList(new GraphQLNonNull(__InputValue)),
      ),
      args: {
        includeDeprecated: {
          type: GraphQLBoolean,
          defaultValue: false,
        },
      },

      resolve(field, { includeDeprecated }) {
        return includeDeprecated
          ? field.args
          : field.args.filter((arg) => arg.deprecationReason == null);
      },
    },
    type: {
      type: new GraphQLNonNull(__Type),
      resolve: (field) => field.type,
    },
    isDeprecated: {
      type: new GraphQLNonNull(GraphQLBoolean),
      resolve: (field) => field.deprecationReason != null,
    },
    deprecationReason: {
      type: GraphQLString,
      resolve: (field) => field.deprecationReason,
    },
  }),
});
const __InputValue = new GraphQLObjectType({
  name: '__InputValue',
  description:
    'Arguments provided to Fields or Directives and the input fields of an InputObject are represented as Input Values which describe their type and optionally a default value.',
  fields: () => ({
    name: {
      type: new GraphQLNonNull(GraphQLString),
      resolve: (inputValue) => inputValue.name,
    },
    description: {
      type: GraphQLString,
      resolve: (inputValue) => inputValue.description,
    },
    type: {
      type: new GraphQLNonNull(__Type),
      resolve: (inputValue) => inputValue.type,
    },
    defaultValue: {
      type: GraphQLString,
      description:
        'A GraphQL-formatted string representing the default value for this input value.',

      resolve(inputValue) {
        const { type, defaultValue } = inputValue;
        const valueAST = astFromValue$1(defaultValue, type);
        return valueAST ? print(valueAST) : null;
      },
    },
    isDeprecated: {
      type: new GraphQLNonNull(GraphQLBoolean),
      resolve: (field) => field.deprecationReason != null,
    },
    deprecationReason: {
      type: GraphQLString,
      resolve: (obj) => obj.deprecationReason,
    },
  }),
});
const __EnumValue = new GraphQLObjectType({
  name: '__EnumValue',
  description:
    'One possible value for a given Enum. Enum values are unique values, not a placeholder for a string or numeric value. However an Enum value is returned in a JSON response as a string.',
  fields: () => ({
    name: {
      type: new GraphQLNonNull(GraphQLString),
      resolve: (enumValue) => enumValue.name,
    },
    description: {
      type: GraphQLString,
      resolve: (enumValue) => enumValue.description,
    },
    isDeprecated: {
      type: new GraphQLNonNull(GraphQLBoolean),
      resolve: (enumValue) => enumValue.deprecationReason != null,
    },
    deprecationReason: {
      type: GraphQLString,
      resolve: (enumValue) => enumValue.deprecationReason,
    },
  }),
});
var TypeKind;

(function (TypeKind) {
  TypeKind['SCALAR'] = 'SCALAR';
  TypeKind['OBJECT'] = 'OBJECT';
  TypeKind['INTERFACE'] = 'INTERFACE';
  TypeKind['UNION'] = 'UNION';
  TypeKind['ENUM'] = 'ENUM';
  TypeKind['INPUT_OBJECT'] = 'INPUT_OBJECT';
  TypeKind['LIST'] = 'LIST';
  TypeKind['NON_NULL'] = 'NON_NULL';
})(TypeKind || (TypeKind = {}));
const __TypeKind = new GraphQLEnumType({
  name: '__TypeKind',
  description: 'An enum describing what kind of type a given `__Type` is.',
  values: {
    SCALAR: {
      value: TypeKind.SCALAR,
      description: 'Indicates this type is a scalar.',
    },
    OBJECT: {
      value: TypeKind.OBJECT,
      description:
        'Indicates this type is an object. `fields` and `interfaces` are valid fields.',
    },
    INTERFACE: {
      value: TypeKind.INTERFACE,
      description:
        'Indicates this type is an interface. `fields`, `interfaces`, and `possibleTypes` are valid fields.',
    },
    UNION: {
      value: TypeKind.UNION,
      description:
        'Indicates this type is a union. `possibleTypes` is a valid field.',
    },
    ENUM: {
      value: TypeKind.ENUM,
      description:
        'Indicates this type is an enum. `enumValues` is a valid field.',
    },
    INPUT_OBJECT: {
      value: TypeKind.INPUT_OBJECT,
      description:
        'Indicates this type is an input object. `inputFields` is a valid field.',
    },
    LIST: {
      value: TypeKind.LIST,
      description: 'Indicates this type is a list. `ofType` is a valid field.',
    },
    NON_NULL: {
      value: TypeKind.NON_NULL,
      description:
        'Indicates this type is a non-null. `ofType` is a valid field.',
    },
  },
});
/**
 * Note that these are GraphQLField and not GraphQLFieldConfig,
 * so the format for args is different.
 */

const SchemaMetaFieldDef = {
  name: '__schema',
  type: new GraphQLNonNull(__Schema),
  description: 'Access the current type schema of this server.',
  args: [],
  resolve: (_source, _args, _context, { schema }) => schema,
  deprecationReason: undefined,
  extensions: Object.create(null),
  astNode: undefined,
};
const TypeMetaFieldDef = {
  name: '__type',
  type: __Type,
  description: 'Request the type information of a single type.',
  args: [
    {
      name: 'name',
      description: undefined,
      type: new GraphQLNonNull(GraphQLString),
      defaultValue: undefined,
      deprecationReason: undefined,
      extensions: Object.create(null),
      astNode: undefined,
    },
  ],
  resolve: (_source, { name }, _context, { schema }) => schema.getType(name),
  deprecationReason: undefined,
  extensions: Object.create(null),
  astNode: undefined,
};
const TypeNameMetaFieldDef = {
  name: '__typename',
  type: new GraphQLNonNull(GraphQLString),
  description: 'The name of the current Object type at runtime.',
  args: [],
  resolve: (_source, _args, _context, { parentType }) => parentType.name,
  deprecationReason: undefined,
  extensions: Object.create(null),
  astNode: undefined,
};
const introspectionTypes = Object.freeze([
  __Schema,
  __Directive,
  __DirectiveLocation,
  __Type,
  __Field,
  __InputValue,
  __EnumValue,
  __TypeKind,
]);
function isIntrospectionType(type) {
  return introspectionTypes.some(({ name }) => type.name === name);
}

/**
 * Test if the given value is a GraphQL schema.
 */

function isSchema(schema) {
  return instanceOf(schema, GraphQLSchema);
}
function assertSchema(schema) {
  if (!isSchema(schema)) {
    throw new Error(`Expected ${inspect$1(schema)} to be a GraphQL schema.`);
  }

  return schema;
}
/**
 * Custom extensions
 *
 * @remarks
 * Use a unique identifier name for your extension, for example the name of
 * your library or project. Do not use a shortened identifier as this increases
 * the risk of conflicts. We recommend you add at most one extension field,
 * an object which can contain all the values you need.
 */

/**
 * Schema Definition
 *
 * A Schema is created by supplying the root types of each type of operation,
 * query and mutation (optional). A schema definition is then supplied to the
 * validator and executor.
 *
 * Example:
 *
 * ```ts
 * const MyAppSchema = new GraphQLSchema({
 *   query: MyAppQueryRootType,
 *   mutation: MyAppMutationRootType,
 * })
 * ```
 *
 * Note: When the schema is constructed, by default only the types that are
 * reachable by traversing the root types are included, other types must be
 * explicitly referenced.
 *
 * Example:
 *
 * ```ts
 * const characterInterface = new GraphQLInterfaceType({
 *   name: 'Character',
 *   ...
 * });
 *
 * const humanType = new GraphQLObjectType({
 *   name: 'Human',
 *   interfaces: [characterInterface],
 *   ...
 * });
 *
 * const droidType = new GraphQLObjectType({
 *   name: 'Droid',
 *   interfaces: [characterInterface],
 *   ...
 * });
 *
 * const schema = new GraphQLSchema({
 *   query: new GraphQLObjectType({
 *     name: 'Query',
 *     fields: {
 *       hero: { type: characterInterface, ... },
 *     }
 *   }),
 *   ...
 *   // Since this schema references only the `Character` interface it's
 *   // necessary to explicitly list the types that implement it if
 *   // you want them to be included in the final schema.
 *   types: [humanType, droidType],
 * })
 * ```
 *
 * Note: If an array of `directives` are provided to GraphQLSchema, that will be
 * the exact list of directives represented and allowed. If `directives` is not
 * provided then a default set of the specified directives (e.g. `@include` and
 * `@skip`) will be used. If you wish to provide *additional* directives to these
 * specified directives, you must explicitly declare them. Example:
 *
 * ```ts
 * const MyAppSchema = new GraphQLSchema({
 *   ...
 *   directives: specifiedDirectives.concat([ myCustomDirective ]),
 * })
 * ```
 */
class GraphQLSchema {
  // Used as a cache for validateSchema().
  constructor(config) {
    var _config$extensionASTN, _config$directives;

    // If this schema was built from a source known to be valid, then it may be
    // marked with assumeValid to avoid an additional type system validation.
    this.__validationErrors = config.assumeValid === true ? [] : undefined; // Check for common mistakes during construction to produce early errors.

    isObjectLike$1(config) ||
      devAssert(false, 'Must provide configuration object.');
    !config.types ||
      Array.isArray(config.types) ||
      devAssert(
        false,
        `"types" must be Array if provided but got: ${inspect$1(config.types)}.`,
      );
    !config.directives ||
      Array.isArray(config.directives) ||
      devAssert(
        false,
        '"directives" must be Array if provided but got: ' +
          `${inspect$1(config.directives)}.`,
      );
    this.description = config.description;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN = config.extensionASTNodes) !== null &&
      _config$extensionASTN !== void 0
        ? _config$extensionASTN
        : [];
    this._queryType = config.query;
    this._mutationType = config.mutation;
    this._subscriptionType = config.subscription; // Provide specified directives (e.g. @include and @skip) by default.

    this._directives =
      (_config$directives = config.directives) !== null &&
      _config$directives !== void 0
        ? _config$directives
        : specifiedDirectives; // To preserve order of user-provided types, we add first to add them to
    // the set of "collected" types, so `collectReferencedTypes` ignore them.

    const allReferencedTypes = new Set(config.types);

    if (config.types != null) {
      for (const type of config.types) {
        // When we ready to process this type, we remove it from "collected" types
        // and then add it together with all dependent types in the correct position.
        allReferencedTypes.delete(type);
        collectReferencedTypes(type, allReferencedTypes);
      }
    }

    if (this._queryType != null) {
      collectReferencedTypes(this._queryType, allReferencedTypes);
    }

    if (this._mutationType != null) {
      collectReferencedTypes(this._mutationType, allReferencedTypes);
    }

    if (this._subscriptionType != null) {
      collectReferencedTypes(this._subscriptionType, allReferencedTypes);
    }

    for (const directive of this._directives) {
      // Directives are not validated until validateSchema() is called.
      if (isDirective(directive)) {
        for (const arg of directive.args) {
          collectReferencedTypes(arg.type, allReferencedTypes);
        }
      }
    }

    collectReferencedTypes(__Schema, allReferencedTypes); // Storing the resulting map for reference by the schema.

    this._typeMap = Object.create(null);
    this._subTypeMap = Object.create(null); // Keep track of all implementations by interface name.

    this._implementationsMap = Object.create(null);

    for (const namedType of allReferencedTypes) {
      if (namedType == null) {
        continue;
      }

      const typeName = namedType.name;
      typeName ||
        devAssert(
          false,
          'One of the provided types for building the Schema is missing a name.',
        );

      if (this._typeMap[typeName] !== undefined) {
        throw new Error(
          `Schema must contain uniquely named types but contains multiple types named "${typeName}".`,
        );
      }

      this._typeMap[typeName] = namedType;

      if (isInterfaceType(namedType)) {
        // Store implementations by interface.
        for (const iface of namedType.getInterfaces()) {
          if (isInterfaceType(iface)) {
            let implementations = this._implementationsMap[iface.name];

            if (implementations === undefined) {
              implementations = this._implementationsMap[iface.name] = {
                objects: [],
                interfaces: [],
              };
            }

            implementations.interfaces.push(namedType);
          }
        }
      } else if (isObjectType(namedType)) {
        // Store implementations by objects.
        for (const iface of namedType.getInterfaces()) {
          if (isInterfaceType(iface)) {
            let implementations = this._implementationsMap[iface.name];

            if (implementations === undefined) {
              implementations = this._implementationsMap[iface.name] = {
                objects: [],
                interfaces: [],
              };
            }

            implementations.objects.push(namedType);
          }
        }
      }
    }
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLSchema';
  }

  getQueryType() {
    return this._queryType;
  }

  getMutationType() {
    return this._mutationType;
  }

  getSubscriptionType() {
    return this._subscriptionType;
  }

  getRootType(operation) {
    switch (operation) {
      case OperationTypeNode$1.QUERY:
        return this.getQueryType();

      case OperationTypeNode$1.MUTATION:
        return this.getMutationType();

      case OperationTypeNode$1.SUBSCRIPTION:
        return this.getSubscriptionType();
    }
  }

  getTypeMap() {
    return this._typeMap;
  }

  getType(name) {
    return this.getTypeMap()[name];
  }

  getPossibleTypes(abstractType) {
    return isUnionType(abstractType)
      ? abstractType.getTypes()
      : this.getImplementations(abstractType).objects;
  }

  getImplementations(interfaceType) {
    const implementations = this._implementationsMap[interfaceType.name];
    return implementations !== null && implementations !== void 0
      ? implementations
      : {
          objects: [],
          interfaces: [],
        };
  }

  isSubType(abstractType, maybeSubType) {
    let map = this._subTypeMap[abstractType.name];

    if (map === undefined) {
      map = Object.create(null);

      if (isUnionType(abstractType)) {
        for (const type of abstractType.getTypes()) {
          map[type.name] = true;
        }
      } else {
        const implementations = this.getImplementations(abstractType);

        for (const type of implementations.objects) {
          map[type.name] = true;
        }

        for (const type of implementations.interfaces) {
          map[type.name] = true;
        }
      }

      this._subTypeMap[abstractType.name] = map;
    }

    return map[maybeSubType.name] !== undefined;
  }

  getDirectives() {
    return this._directives;
  }

  getDirective(name) {
    return this.getDirectives().find((directive) => directive.name === name);
  }

  toConfig() {
    return {
      description: this.description,
      query: this.getQueryType(),
      mutation: this.getMutationType(),
      subscription: this.getSubscriptionType(),
      types: Object.values(this.getTypeMap()),
      directives: this.getDirectives(),
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
      assumeValid: this.__validationErrors !== undefined,
    };
  }
}

function collectReferencedTypes(type, typeSet) {
  const namedType = getNamedType(type);

  if (!typeSet.has(namedType)) {
    typeSet.add(namedType);

    if (isUnionType(namedType)) {
      for (const memberType of namedType.getTypes()) {
        collectReferencedTypes(memberType, typeSet);
      }
    } else if (isObjectType(namedType) || isInterfaceType(namedType)) {
      for (const interfaceType of namedType.getInterfaces()) {
        collectReferencedTypes(interfaceType, typeSet);
      }

      for (const field of Object.values(namedType.getFields())) {
        collectReferencedTypes(field.type, typeSet);

        for (const arg of field.args) {
          collectReferencedTypes(arg.type, typeSet);
        }
      }
    } else if (isInputObjectType(namedType)) {
      for (const field of Object.values(namedType.getFields())) {
        collectReferencedTypes(field.type, typeSet);
      }
    }
  }

  return typeSet;
}

/**
 * Implements the "Type Validation" sub-sections of the specification's
 * "Type System" section.
 *
 * Validation runs synchronously, returning an array of encountered errors, or
 * an empty array if no errors were encountered and the Schema is valid.
 */

function validateSchema(schema) {
  // First check to ensure the provided value is in fact a GraphQLSchema.
  assertSchema(schema); // If this Schema has already been validated, return the previous results.

  if (schema.__validationErrors) {
    return schema.__validationErrors;
  } // Validate the schema, producing a list of errors.

  const context = new SchemaValidationContext(schema);
  validateRootTypes(context);
  validateDirectives(context);
  validateTypes(context); // Persist the results of validation before returning to ensure validation
  // does not run multiple times for this schema.

  const errors = context.getErrors();
  schema.__validationErrors = errors;
  return errors;
}
/**
 * Utility function which asserts a schema is valid by throwing an error if
 * it is invalid.
 */

function assertValidSchema(schema) {
  const errors = validateSchema(schema);

  if (errors.length !== 0) {
    throw new Error(errors.map((error) => error.message).join('\n\n'));
  }
}

class SchemaValidationContext {
  constructor(schema) {
    this._errors = [];
    this.schema = schema;
  }

  reportError(message, nodes) {
    const _nodes = Array.isArray(nodes) ? nodes.filter(Boolean) : nodes;

    this._errors.push(
      new GraphQLError(message, {
        nodes: _nodes,
      }),
    );
  }

  getErrors() {
    return this._errors;
  }
}

function validateRootTypes(context) {
  const schema = context.schema;
  const queryType = schema.getQueryType();

  if (!queryType) {
    context.reportError('Query root type must be provided.', schema.astNode);
  } else if (!isObjectType(queryType)) {
    var _getOperationTypeNode;

    context.reportError(
      `Query root type must be Object type, it cannot be ${inspect$1(
        queryType,
      )}.`,
      (_getOperationTypeNode = getOperationTypeNode(
        schema,
        OperationTypeNode$1.QUERY,
      )) !== null && _getOperationTypeNode !== void 0
        ? _getOperationTypeNode
        : queryType.astNode,
    );
  }

  const mutationType = schema.getMutationType();

  if (mutationType && !isObjectType(mutationType)) {
    var _getOperationTypeNode2;

    context.reportError(
      'Mutation root type must be Object type if provided, it cannot be ' +
        `${inspect$1(mutationType)}.`,
      (_getOperationTypeNode2 = getOperationTypeNode(
        schema,
        OperationTypeNode$1.MUTATION,
      )) !== null && _getOperationTypeNode2 !== void 0
        ? _getOperationTypeNode2
        : mutationType.astNode,
    );
  }

  const subscriptionType = schema.getSubscriptionType();

  if (subscriptionType && !isObjectType(subscriptionType)) {
    var _getOperationTypeNode3;

    context.reportError(
      'Subscription root type must be Object type if provided, it cannot be ' +
        `${inspect$1(subscriptionType)}.`,
      (_getOperationTypeNode3 = getOperationTypeNode(
        schema,
        OperationTypeNode$1.SUBSCRIPTION,
      )) !== null && _getOperationTypeNode3 !== void 0
        ? _getOperationTypeNode3
        : subscriptionType.astNode,
    );
  }
}

function getOperationTypeNode(schema, operation) {
  var _flatMap$find;

  return (_flatMap$find = [schema.astNode, ...schema.extensionASTNodes]
    .flatMap(
      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      (schemaNode) => {
        var _schemaNode$operation;

        return (
          /* c8 ignore next */
          (_schemaNode$operation =
            schemaNode === null || schemaNode === void 0
              ? void 0
              : schemaNode.operationTypes) !== null &&
            _schemaNode$operation !== void 0
            ? _schemaNode$operation
            : []
        );
      },
    )
    .find((operationNode) => operationNode.operation === operation)) === null ||
    _flatMap$find === void 0
    ? void 0
    : _flatMap$find.type;
}

function validateDirectives(context) {
  for (const directive of context.schema.getDirectives()) {
    // Ensure all directives are in fact GraphQL directives.
    if (!isDirective(directive)) {
      context.reportError(
        `Expected directive but got: ${inspect$1(directive)}.`,
        directive === null || directive === void 0 ? void 0 : directive.astNode,
      );
      continue;
    } // Ensure they are named correctly.

    validateName(context, directive); // TODO: Ensure proper locations.
    // Ensure the arguments are valid.

    for (const arg of directive.args) {
      // Ensure they are named correctly.
      validateName(context, arg); // Ensure the type is an input type.

      if (!isInputType(arg.type)) {
        context.reportError(
          `The type of @${directive.name}(${arg.name}:) must be Input Type ` +
            `but got: ${inspect$1(arg.type)}.`,
          arg.astNode,
        );
      }

      if (isRequiredArgument(arg) && arg.deprecationReason != null) {
        var _arg$astNode;

        context.reportError(
          `Required argument @${directive.name}(${arg.name}:) cannot be deprecated.`,
          [
            getDeprecatedDirectiveNode(arg.astNode),
            (_arg$astNode = arg.astNode) === null || _arg$astNode === void 0
              ? void 0
              : _arg$astNode.type,
          ],
        );
      }
    }
  }
}

function validateName(context, node) {
  // Ensure names are valid, however introspection types opt out.
  if (node.name.startsWith('__')) {
    context.reportError(
      `Name "${node.name}" must not begin with "__", which is reserved by GraphQL introspection.`,
      node.astNode,
    );
  }
}

function validateTypes(context) {
  const validateInputObjectCircularRefs =
    createInputObjectCircularRefsValidator(context);
  const typeMap = context.schema.getTypeMap();

  for (const type of Object.values(typeMap)) {
    // Ensure all provided types are in fact GraphQL type.
    if (!isNamedType(type)) {
      context.reportError(
        `Expected GraphQL named type but got: ${inspect$1(type)}.`,
        type.astNode,
      );
      continue;
    } // Ensure it is named correctly (excluding introspection types).

    if (!isIntrospectionType(type)) {
      validateName(context, type);
    }

    if (isObjectType(type)) {
      // Ensure fields are valid
      validateFields(context, type); // Ensure objects implement the interfaces they claim to.

      validateInterfaces(context, type);
    } else if (isInterfaceType(type)) {
      // Ensure fields are valid.
      validateFields(context, type); // Ensure interfaces implement the interfaces they claim to.

      validateInterfaces(context, type);
    } else if (isUnionType(type)) {
      // Ensure Unions include valid member types.
      validateUnionMembers(context, type);
    } else if (isEnumType(type)) {
      // Ensure Enums have valid values.
      validateEnumValues(context, type);
    } else if (isInputObjectType(type)) {
      // Ensure Input Object fields are valid.
      validateInputFields(context, type); // Ensure Input Objects do not contain non-nullable circular references

      validateInputObjectCircularRefs(type);
    }
  }
}

function validateFields(context, type) {
  const fields = Object.values(type.getFields()); // Objects and Interfaces both must define one or more fields.

  if (fields.length === 0) {
    context.reportError(`Type ${type.name} must define one or more fields.`, [
      type.astNode,
      ...type.extensionASTNodes,
    ]);
  }

  for (const field of fields) {
    // Ensure they are named correctly.
    validateName(context, field); // Ensure the type is an output type

    if (!isOutputType(field.type)) {
      var _field$astNode;

      context.reportError(
        `The type of ${type.name}.${field.name} must be Output Type ` +
          `but got: ${inspect$1(field.type)}.`,
        (_field$astNode = field.astNode) === null || _field$astNode === void 0
          ? void 0
          : _field$astNode.type,
      );
    } // Ensure the arguments are valid

    for (const arg of field.args) {
      const argName = arg.name; // Ensure they are named correctly.

      validateName(context, arg); // Ensure the type is an input type

      if (!isInputType(arg.type)) {
        var _arg$astNode2;

        context.reportError(
          `The type of ${type.name}.${field.name}(${argName}:) must be Input ` +
            `Type but got: ${inspect$1(arg.type)}.`,
          (_arg$astNode2 = arg.astNode) === null || _arg$astNode2 === void 0
            ? void 0
            : _arg$astNode2.type,
        );
      }

      if (isRequiredArgument(arg) && arg.deprecationReason != null) {
        var _arg$astNode3;

        context.reportError(
          `Required argument ${type.name}.${field.name}(${argName}:) cannot be deprecated.`,
          [
            getDeprecatedDirectiveNode(arg.astNode),
            (_arg$astNode3 = arg.astNode) === null || _arg$astNode3 === void 0
              ? void 0
              : _arg$astNode3.type,
          ],
        );
      }
    }
  }
}

function validateInterfaces(context, type) {
  const ifaceTypeNames = Object.create(null);

  for (const iface of type.getInterfaces()) {
    if (!isInterfaceType(iface)) {
      context.reportError(
        `Type ${inspect$1(type)} must only implement Interface types, ` +
          `it cannot implement ${inspect$1(iface)}.`,
        getAllImplementsInterfaceNodes(type, iface),
      );
      continue;
    }

    if (type === iface) {
      context.reportError(
        `Type ${type.name} cannot implement itself because it would create a circular reference.`,
        getAllImplementsInterfaceNodes(type, iface),
      );
      continue;
    }

    if (ifaceTypeNames[iface.name]) {
      context.reportError(
        `Type ${type.name} can only implement ${iface.name} once.`,
        getAllImplementsInterfaceNodes(type, iface),
      );
      continue;
    }

    ifaceTypeNames[iface.name] = true;
    validateTypeImplementsAncestors(context, type, iface);
    validateTypeImplementsInterface(context, type, iface);
  }
}

function validateTypeImplementsInterface(context, type, iface) {
  const typeFieldMap = type.getFields(); // Assert each interface field is implemented.

  for (const ifaceField of Object.values(iface.getFields())) {
    const fieldName = ifaceField.name;
    const typeField = typeFieldMap[fieldName]; // Assert interface field exists on type.

    if (!typeField) {
      context.reportError(
        `Interface field ${iface.name}.${fieldName} expected but ${type.name} does not provide it.`,
        [ifaceField.astNode, type.astNode, ...type.extensionASTNodes],
      );
      continue;
    } // Assert interface field type is satisfied by type field type, by being
    // a valid subtype. (covariant)

    if (!isTypeSubTypeOf(context.schema, typeField.type, ifaceField.type)) {
      var _ifaceField$astNode, _typeField$astNode;

      context.reportError(
        `Interface field ${iface.name}.${fieldName} expects type ` +
          `${inspect$1(ifaceField.type)} but ${type.name}.${fieldName} ` +
          `is type ${inspect$1(typeField.type)}.`,
        [
          (_ifaceField$astNode = ifaceField.astNode) === null ||
          _ifaceField$astNode === void 0
            ? void 0
            : _ifaceField$astNode.type,
          (_typeField$astNode = typeField.astNode) === null ||
          _typeField$astNode === void 0
            ? void 0
            : _typeField$astNode.type,
        ],
      );
    } // Assert each interface field arg is implemented.

    for (const ifaceArg of ifaceField.args) {
      const argName = ifaceArg.name;
      const typeArg = typeField.args.find((arg) => arg.name === argName); // Assert interface field arg exists on object field.

      if (!typeArg) {
        context.reportError(
          `Interface field argument ${iface.name}.${fieldName}(${argName}:) expected but ${type.name}.${fieldName} does not provide it.`,
          [ifaceArg.astNode, typeField.astNode],
        );
        continue;
      } // Assert interface field arg type matches object field arg type.
      // (invariant)
      // TODO: change to contravariant?

      if (!isEqualType(ifaceArg.type, typeArg.type)) {
        var _ifaceArg$astNode, _typeArg$astNode;

        context.reportError(
          `Interface field argument ${iface.name}.${fieldName}(${argName}:) ` +
            `expects type ${inspect$1(ifaceArg.type)} but ` +
            `${type.name}.${fieldName}(${argName}:) is type ` +
            `${inspect$1(typeArg.type)}.`,
          [
            (_ifaceArg$astNode = ifaceArg.astNode) === null ||
            _ifaceArg$astNode === void 0
              ? void 0
              : _ifaceArg$astNode.type,
            (_typeArg$astNode = typeArg.astNode) === null ||
            _typeArg$astNode === void 0
              ? void 0
              : _typeArg$astNode.type,
          ],
        );
      } // TODO: validate default values?
    } // Assert additional arguments must not be required.

    for (const typeArg of typeField.args) {
      const argName = typeArg.name;
      const ifaceArg = ifaceField.args.find((arg) => arg.name === argName);

      if (!ifaceArg && isRequiredArgument(typeArg)) {
        context.reportError(
          `Object field ${type.name}.${fieldName} includes required argument ${argName} that is missing from the Interface field ${iface.name}.${fieldName}.`,
          [typeArg.astNode, ifaceField.astNode],
        );
      }
    }
  }
}

function validateTypeImplementsAncestors(context, type, iface) {
  const ifaceInterfaces = type.getInterfaces();

  for (const transitive of iface.getInterfaces()) {
    if (!ifaceInterfaces.includes(transitive)) {
      context.reportError(
        transitive === type
          ? `Type ${type.name} cannot implement ${iface.name} because it would create a circular reference.`
          : `Type ${type.name} must implement ${transitive.name} because it is implemented by ${iface.name}.`,
        [
          ...getAllImplementsInterfaceNodes(iface, transitive),
          ...getAllImplementsInterfaceNodes(type, iface),
        ],
      );
    }
  }
}

function validateUnionMembers(context, union) {
  const memberTypes = union.getTypes();

  if (memberTypes.length === 0) {
    context.reportError(
      `Union type ${union.name} must define one or more member types.`,
      [union.astNode, ...union.extensionASTNodes],
    );
  }

  const includedTypeNames = Object.create(null);

  for (const memberType of memberTypes) {
    if (includedTypeNames[memberType.name]) {
      context.reportError(
        `Union type ${union.name} can only include type ${memberType.name} once.`,
        getUnionMemberTypeNodes(union, memberType.name),
      );
      continue;
    }

    includedTypeNames[memberType.name] = true;

    if (!isObjectType(memberType)) {
      context.reportError(
        `Union type ${union.name} can only include Object types, ` +
          `it cannot include ${inspect$1(memberType)}.`,
        getUnionMemberTypeNodes(union, String(memberType)),
      );
    }
  }
}

function validateEnumValues(context, enumType) {
  const enumValues = enumType.getValues();

  if (enumValues.length === 0) {
    context.reportError(
      `Enum type ${enumType.name} must define one or more values.`,
      [enumType.astNode, ...enumType.extensionASTNodes],
    );
  }

  for (const enumValue of enumValues) {
    // Ensure valid name.
    validateName(context, enumValue);
  }
}

function validateInputFields(context, inputObj) {
  const fields = Object.values(inputObj.getFields());

  if (fields.length === 0) {
    context.reportError(
      `Input Object type ${inputObj.name} must define one or more fields.`,
      [inputObj.astNode, ...inputObj.extensionASTNodes],
    );
  } // Ensure the arguments are valid

  for (const field of fields) {
    // Ensure they are named correctly.
    validateName(context, field); // Ensure the type is an input type

    if (!isInputType(field.type)) {
      var _field$astNode2;

      context.reportError(
        `The type of ${inputObj.name}.${field.name} must be Input Type ` +
          `but got: ${inspect$1(field.type)}.`,
        (_field$astNode2 = field.astNode) === null || _field$astNode2 === void 0
          ? void 0
          : _field$astNode2.type,
      );
    }

    if (isRequiredInputField(field) && field.deprecationReason != null) {
      var _field$astNode3;

      context.reportError(
        `Required input field ${inputObj.name}.${field.name} cannot be deprecated.`,
        [
          getDeprecatedDirectiveNode(field.astNode),
          (_field$astNode3 = field.astNode) === null ||
          _field$astNode3 === void 0
            ? void 0
            : _field$astNode3.type,
        ],
      );
    }

    if (inputObj.isOneOf) {
      validateOneOfInputObjectField(inputObj, field, context);
    }
  }
}

function validateOneOfInputObjectField(type, field, context) {
  if (isNonNullType(field.type)) {
    var _field$astNode4;

    context.reportError(
      `OneOf input field ${type.name}.${field.name} must be nullable.`,
      (_field$astNode4 = field.astNode) === null || _field$astNode4 === void 0
        ? void 0
        : _field$astNode4.type,
    );
  }

  if (field.defaultValue !== undefined) {
    context.reportError(
      `OneOf input field ${type.name}.${field.name} cannot have a default value.`,
      field.astNode,
    );
  }
}

function createInputObjectCircularRefsValidator(context) {
  // Modified copy of algorithm from 'src/validation/rules/NoFragmentCycles.js'.
  // Tracks already visited types to maintain O(N) and to ensure that cycles
  // are not redundantly reported.
  const visitedTypes = Object.create(null); // Array of types nodes used to produce meaningful errors

  const fieldPath = []; // Position in the type path

  const fieldPathIndexByTypeName = Object.create(null);
  return detectCycleRecursive; // This does a straight-forward DFS to find cycles.
  // It does not terminate when a cycle was found but continues to explore
  // the graph to find all possible cycles.

  function detectCycleRecursive(inputObj) {
    if (visitedTypes[inputObj.name]) {
      return;
    }

    visitedTypes[inputObj.name] = true;
    fieldPathIndexByTypeName[inputObj.name] = fieldPath.length;
    const fields = Object.values(inputObj.getFields());

    for (const field of fields) {
      if (isNonNullType(field.type) && isInputObjectType(field.type.ofType)) {
        const fieldType = field.type.ofType;
        const cycleIndex = fieldPathIndexByTypeName[fieldType.name];
        fieldPath.push(field);

        if (cycleIndex === undefined) {
          detectCycleRecursive(fieldType);
        } else {
          const cyclePath = fieldPath.slice(cycleIndex);
          const pathStr = cyclePath.map((fieldObj) => fieldObj.name).join('.');
          context.reportError(
            `Cannot reference Input Object "${fieldType.name}" within itself through a series of non-null fields: "${pathStr}".`,
            cyclePath.map((fieldObj) => fieldObj.astNode),
          );
        }

        fieldPath.pop();
      }
    }

    fieldPathIndexByTypeName[inputObj.name] = undefined;
  }
}

function getAllImplementsInterfaceNodes(type, iface) {
  const { astNode, extensionASTNodes } = type;
  const nodes =
    astNode != null ? [astNode, ...extensionASTNodes] : extensionASTNodes; // FIXME: https://github.com/graphql/graphql-js/issues/2203

  return nodes
    .flatMap((typeNode) => {
      var _typeNode$interfaces;

      return (
        /* c8 ignore next */
        (_typeNode$interfaces = typeNode.interfaces) !== null &&
          _typeNode$interfaces !== void 0
          ? _typeNode$interfaces
          : []
      );
    })
    .filter((ifaceNode) => ifaceNode.name.value === iface.name);
}

function getUnionMemberTypeNodes(union, typeName) {
  const { astNode, extensionASTNodes } = union;
  const nodes =
    astNode != null ? [astNode, ...extensionASTNodes] : extensionASTNodes; // FIXME: https://github.com/graphql/graphql-js/issues/2203

  return nodes
    .flatMap((unionNode) => {
      var _unionNode$types;

      return (
        /* c8 ignore next */
        (_unionNode$types = unionNode.types) !== null &&
          _unionNode$types !== void 0
          ? _unionNode$types
          : []
      );
    })
    .filter((typeNode) => typeNode.name.value === typeName);
}

function getDeprecatedDirectiveNode(definitionNode) {
  var _definitionNode$direc;

  return definitionNode === null || definitionNode === void 0
    ? void 0
    : (_definitionNode$direc = definitionNode.directives) === null ||
      _definitionNode$direc === void 0
    ? void 0
    : _definitionNode$direc.find(
        (node) => node.name.value === GraphQLDeprecatedDirective.name,
      );
}

function typeFromAST(schema, typeNode) {
  switch (typeNode.kind) {
    case Kind.LIST_TYPE: {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new GraphQLList(innerType);
    }

    case Kind.NON_NULL_TYPE: {
      const innerType = typeFromAST(schema, typeNode.type);
      return innerType && new GraphQLNonNull(innerType);
    }

    case Kind.NAMED_TYPE:
      return schema.getType(typeNode.name.value);
  }
}

/**
 * Executable definitions
 *
 * A GraphQL document is only valid for execution if all definitions are either
 * operation or fragment definitions.
 *
 * See https://spec.graphql.org/draft/#sec-Executable-Definitions
 */
function ExecutableDefinitionsRule(context) {
  return {
    Document(node) {
      for (const definition of node.definitions) {
        if (!isExecutableDefinitionNode(definition)) {
          const defName =
            definition.kind === Kind.SCHEMA_DEFINITION ||
            definition.kind === Kind.SCHEMA_EXTENSION
              ? 'schema'
              : '"' + definition.name.value + '"';
          context.reportError(
            new GraphQLError(`The ${defName} definition is not executable.`, {
              nodes: definition,
            }),
          );
        }
      }

      return false;
    },
  };
}

/**
 * Fields on correct type
 *
 * A GraphQL document is only valid if all fields selected are defined by the
 * parent type, or are an allowed meta field such as __typename.
 *
 * See https://spec.graphql.org/draft/#sec-Field-Selections
 */
function FieldsOnCorrectTypeRule(context) {
  return {
    Field(node) {
      const type = context.getParentType();

      if (type) {
        const fieldDef = context.getFieldDef();

        if (!fieldDef) {
          // This field doesn't exist, lets look for suggestions.
          const schema = context.getSchema();
          const fieldName = node.name.value; // First determine if there are any suggested types to condition on.

          let suggestion = didYouMean(
            'to use an inline fragment on',
            getSuggestedTypeNames(schema, type, fieldName),
          ); // If there are no suggested types, then perhaps this was a typo?

          if (suggestion === '') {
            suggestion = didYouMean(getSuggestedFieldNames(type, fieldName));
          } // Report an error, including helpful suggestions.

          context.reportError(
            new GraphQLError(
              `Cannot query field "${fieldName}" on type "${type.name}".` +
                suggestion,
              {
                nodes: node,
              },
            ),
          );
        }
      }
    },
  };
}
/**
 * Go through all of the implementations of type, as well as the interfaces that
 * they implement. If any of those types include the provided field, suggest them,
 * sorted by how often the type is referenced.
 */

function getSuggestedTypeNames(schema, type, fieldName) {
  if (!isAbstractType(type)) {
    // Must be an Object type, which does not have possible fields.
    return [];
  }

  const suggestedTypes = new Set();
  const usageCount = Object.create(null);

  for (const possibleType of schema.getPossibleTypes(type)) {
    if (!possibleType.getFields()[fieldName]) {
      continue;
    } // This object type defines this field.

    suggestedTypes.add(possibleType);
    usageCount[possibleType.name] = 1;

    for (const possibleInterface of possibleType.getInterfaces()) {
      var _usageCount$possibleI;

      if (!possibleInterface.getFields()[fieldName]) {
        continue;
      } // This interface type defines this field.

      suggestedTypes.add(possibleInterface);
      usageCount[possibleInterface.name] =
        ((_usageCount$possibleI = usageCount[possibleInterface.name]) !==
          null && _usageCount$possibleI !== void 0
          ? _usageCount$possibleI
          : 0) + 1;
    }
  }

  return [...suggestedTypes]
    .sort((typeA, typeB) => {
      // Suggest both interface and object types based on how common they are.
      const usageCountDiff = usageCount[typeB.name] - usageCount[typeA.name];

      if (usageCountDiff !== 0) {
        return usageCountDiff;
      } // Suggest super types first followed by subtypes

      if (isInterfaceType(typeA) && schema.isSubType(typeA, typeB)) {
        return -1;
      }

      if (isInterfaceType(typeB) && schema.isSubType(typeB, typeA)) {
        return 1;
      }

      return naturalCompare(typeA.name, typeB.name);
    })
    .map((x) => x.name);
}
/**
 * For the field name provided, determine if there are any similar field names
 * that may be the result of a typo.
 */

function getSuggestedFieldNames(type, fieldName) {
  if (isObjectType(type) || isInterfaceType(type)) {
    const possibleFieldNames = Object.keys(type.getFields());
    return suggestionList(fieldName, possibleFieldNames);
  } // Otherwise, must be a Union type, which does not define fields.

  return [];
}

/**
 * Fragments on composite type
 *
 * Fragments use a type condition to determine if they apply, since fragments
 * can only be spread into a composite type (object, interface, or union), the
 * type condition must also be a composite type.
 *
 * See https://spec.graphql.org/draft/#sec-Fragments-On-Composite-Types
 */
function FragmentsOnCompositeTypesRule(context) {
  return {
    InlineFragment(node) {
      const typeCondition = node.typeCondition;

      if (typeCondition) {
        const type = typeFromAST(context.getSchema(), typeCondition);

        if (type && !isCompositeType(type)) {
          const typeStr = print(typeCondition);
          context.reportError(
            new GraphQLError(
              `Fragment cannot condition on non composite type "${typeStr}".`,
              {
                nodes: typeCondition,
              },
            ),
          );
        }
      }
    },

    FragmentDefinition(node) {
      const type = typeFromAST(context.getSchema(), node.typeCondition);

      if (type && !isCompositeType(type)) {
        const typeStr = print(node.typeCondition);
        context.reportError(
          new GraphQLError(
            `Fragment "${node.name.value}" cannot condition on non composite type "${typeStr}".`,
            {
              nodes: node.typeCondition,
            },
          ),
        );
      }
    },
  };
}

/**
 * Known argument names
 *
 * A GraphQL field is only valid if all supplied arguments are defined by
 * that field.
 *
 * See https://spec.graphql.org/draft/#sec-Argument-Names
 * See https://spec.graphql.org/draft/#sec-Directives-Are-In-Valid-Locations
 */
function KnownArgumentNamesRule(context) {
  return {
    // eslint-disable-next-line new-cap
    ...KnownArgumentNamesOnDirectivesRule(context),

    Argument(argNode) {
      const argDef = context.getArgument();
      const fieldDef = context.getFieldDef();
      const parentType = context.getParentType();

      if (!argDef && fieldDef && parentType) {
        const argName = argNode.name.value;
        const knownArgsNames = fieldDef.args.map((arg) => arg.name);
        const suggestions = suggestionList(argName, knownArgsNames);
        context.reportError(
          new GraphQLError(
            `Unknown argument "${argName}" on field "${parentType.name}.${fieldDef.name}".` +
              didYouMean(suggestions),
            {
              nodes: argNode,
            },
          ),
        );
      }
    },
  };
}
/**
 * @internal
 */

function KnownArgumentNamesOnDirectivesRule(context) {
  const directiveArgs = Object.create(null);
  const schema = context.getSchema();
  const definedDirectives = schema
    ? schema.getDirectives()
    : specifiedDirectives;

  for (const directive of definedDirectives) {
    directiveArgs[directive.name] = directive.args.map((arg) => arg.name);
  }

  const astDefinitions = context.getDocument().definitions;

  for (const def of astDefinitions) {
    if (def.kind === Kind.DIRECTIVE_DEFINITION) {
      var _def$arguments;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203

      /* c8 ignore next */
      const argsNodes =
        (_def$arguments = def.arguments) !== null && _def$arguments !== void 0
          ? _def$arguments
          : [];
      directiveArgs[def.name.value] = argsNodes.map((arg) => arg.name.value);
    }
  }

  return {
    Directive(directiveNode) {
      const directiveName = directiveNode.name.value;
      const knownArgs = directiveArgs[directiveName];

      if (directiveNode.arguments && knownArgs) {
        for (const argNode of directiveNode.arguments) {
          const argName = argNode.name.value;

          if (!knownArgs.includes(argName)) {
            const suggestions = suggestionList(argName, knownArgs);
            context.reportError(
              new GraphQLError(
                `Unknown argument "${argName}" on directive "@${directiveName}".` +
                  didYouMean(suggestions),
                {
                  nodes: argNode,
                },
              ),
            );
          }
        }
      }

      return false;
    },
  };
}

/**
 * Known directives
 *
 * A GraphQL document is only valid if all `@directives` are known by the
 * schema and legally positioned.
 *
 * See https://spec.graphql.org/draft/#sec-Directives-Are-Defined
 */
function KnownDirectivesRule(context) {
  const locationsMap = Object.create(null);
  const schema = context.getSchema();
  const definedDirectives = schema
    ? schema.getDirectives()
    : specifiedDirectives;

  for (const directive of definedDirectives) {
    locationsMap[directive.name] = directive.locations;
  }

  const astDefinitions = context.getDocument().definitions;

  for (const def of astDefinitions) {
    if (def.kind === Kind.DIRECTIVE_DEFINITION) {
      locationsMap[def.name.value] = def.locations.map((name) => name.value);
    }
  }

  return {
    Directive(node, _key, _parent, _path, ancestors) {
      const name = node.name.value;
      const locations = locationsMap[name];

      if (!locations) {
        context.reportError(
          new GraphQLError(`Unknown directive "@${name}".`, {
            nodes: node,
          }),
        );
        return;
      }

      const candidateLocation = getDirectiveLocationForASTPath(ancestors);

      if (candidateLocation && !locations.includes(candidateLocation)) {
        context.reportError(
          new GraphQLError(
            `Directive "@${name}" may not be used on ${candidateLocation}.`,
            {
              nodes: node,
            },
          ),
        );
      }
    },
  };
}

function getDirectiveLocationForASTPath(ancestors) {
  const appliedTo = ancestors[ancestors.length - 1];
  'kind' in appliedTo || invariant(false);

  switch (appliedTo.kind) {
    case Kind.OPERATION_DEFINITION:
      return getDirectiveLocationForOperation(appliedTo.operation);

    case Kind.FIELD:
      return DirectiveLocation.FIELD;

    case Kind.FRAGMENT_SPREAD:
      return DirectiveLocation.FRAGMENT_SPREAD;

    case Kind.INLINE_FRAGMENT:
      return DirectiveLocation.INLINE_FRAGMENT;

    case Kind.FRAGMENT_DEFINITION:
      return DirectiveLocation.FRAGMENT_DEFINITION;

    case Kind.VARIABLE_DEFINITION:
      return DirectiveLocation.VARIABLE_DEFINITION;

    case Kind.SCHEMA_DEFINITION:
    case Kind.SCHEMA_EXTENSION:
      return DirectiveLocation.SCHEMA;

    case Kind.SCALAR_TYPE_DEFINITION:
    case Kind.SCALAR_TYPE_EXTENSION:
      return DirectiveLocation.SCALAR;

    case Kind.OBJECT_TYPE_DEFINITION:
    case Kind.OBJECT_TYPE_EXTENSION:
      return DirectiveLocation.OBJECT;

    case Kind.FIELD_DEFINITION:
      return DirectiveLocation.FIELD_DEFINITION;

    case Kind.INTERFACE_TYPE_DEFINITION:
    case Kind.INTERFACE_TYPE_EXTENSION:
      return DirectiveLocation.INTERFACE;

    case Kind.UNION_TYPE_DEFINITION:
    case Kind.UNION_TYPE_EXTENSION:
      return DirectiveLocation.UNION;

    case Kind.ENUM_TYPE_DEFINITION:
    case Kind.ENUM_TYPE_EXTENSION:
      return DirectiveLocation.ENUM;

    case Kind.ENUM_VALUE_DEFINITION:
      return DirectiveLocation.ENUM_VALUE;

    case Kind.INPUT_OBJECT_TYPE_DEFINITION:
    case Kind.INPUT_OBJECT_TYPE_EXTENSION:
      return DirectiveLocation.INPUT_OBJECT;

    case Kind.INPUT_VALUE_DEFINITION: {
      const parentNode = ancestors[ancestors.length - 3];
      'kind' in parentNode || invariant(false);
      return parentNode.kind === Kind.INPUT_OBJECT_TYPE_DEFINITION
        ? DirectiveLocation.INPUT_FIELD_DEFINITION
        : DirectiveLocation.ARGUMENT_DEFINITION;
    }
    // Not reachable, all possible types have been considered.

    /* c8 ignore next */

    default:
      invariant(false, 'Unexpected kind: ' + inspect$1(appliedTo.kind));
  }
}

function getDirectiveLocationForOperation(operation) {
  switch (operation) {
    case OperationTypeNode$1.QUERY:
      return DirectiveLocation.QUERY;

    case OperationTypeNode$1.MUTATION:
      return DirectiveLocation.MUTATION;

    case OperationTypeNode$1.SUBSCRIPTION:
      return DirectiveLocation.SUBSCRIPTION;
  }
}

/**
 * Known fragment names
 *
 * A GraphQL document is only valid if all `...Fragment` fragment spreads refer
 * to fragments defined in the same document.
 *
 * See https://spec.graphql.org/draft/#sec-Fragment-spread-target-defined
 */
function KnownFragmentNamesRule(context) {
  return {
    FragmentSpread(node) {
      const fragmentName = node.name.value;
      const fragment = context.getFragment(fragmentName);

      if (!fragment) {
        context.reportError(
          new GraphQLError(`Unknown fragment "${fragmentName}".`, {
            nodes: node.name,
          }),
        );
      }
    },
  };
}

/**
 * Known type names
 *
 * A GraphQL document is only valid if referenced types (specifically
 * variable definitions and fragment conditions) are defined by the type schema.
 *
 * See https://spec.graphql.org/draft/#sec-Fragment-Spread-Type-Existence
 */
function KnownTypeNamesRule(context) {
  const schema = context.getSchema();
  const existingTypesMap = schema ? schema.getTypeMap() : Object.create(null);
  const definedTypes = Object.create(null);

  for (const def of context.getDocument().definitions) {
    if (isTypeDefinitionNode(def)) {
      definedTypes[def.name.value] = true;
    }
  }

  const typeNames = [
    ...Object.keys(existingTypesMap),
    ...Object.keys(definedTypes),
  ];
  return {
    NamedType(node, _1, parent, _2, ancestors) {
      const typeName = node.name.value;

      if (!existingTypesMap[typeName] && !definedTypes[typeName]) {
        var _ancestors$;

        const definitionNode =
          (_ancestors$ = ancestors[2]) !== null && _ancestors$ !== void 0
            ? _ancestors$
            : parent;
        const isSDL = definitionNode != null && isSDLNode(definitionNode);

        if (isSDL && standardTypeNames.includes(typeName)) {
          return;
        }

        const suggestedTypes = suggestionList(
          typeName,
          isSDL ? standardTypeNames.concat(typeNames) : typeNames,
        );
        context.reportError(
          new GraphQLError(
            `Unknown type "${typeName}".` + didYouMean(suggestedTypes),
            {
              nodes: node,
            },
          ),
        );
      }
    },
  };
}
const standardTypeNames = [...specifiedScalarTypes, ...introspectionTypes].map(
  (type) => type.name,
);

function isSDLNode(value) {
  return (
    'kind' in value &&
    (isTypeSystemDefinitionNode(value) || isTypeSystemExtensionNode(value))
  );
}

/**
 * Lone anonymous operation
 *
 * A GraphQL document is only valid if when it contains an anonymous operation
 * (the query short-hand) that it contains only that one operation definition.
 *
 * See https://spec.graphql.org/draft/#sec-Lone-Anonymous-Operation
 */
function LoneAnonymousOperationRule(context) {
  let operationCount = 0;
  return {
    Document(node) {
      operationCount = node.definitions.filter(
        (definition) => definition.kind === Kind.OPERATION_DEFINITION,
      ).length;
    },

    OperationDefinition(node) {
      if (!node.name && operationCount > 1) {
        context.reportError(
          new GraphQLError(
            'This anonymous operation must be the only defined operation.',
            {
              nodes: node,
            },
          ),
        );
      }
    },
  };
}

/**
 * Lone Schema definition
 *
 * A GraphQL document is only valid if it contains only one schema definition.
 */
function LoneSchemaDefinitionRule(context) {
  var _ref, _ref2, _oldSchema$astNode;

  const oldSchema = context.getSchema();
  const alreadyDefined =
    (_ref =
      (_ref2 =
        (_oldSchema$astNode =
          oldSchema === null || oldSchema === void 0
            ? void 0
            : oldSchema.astNode) !== null && _oldSchema$astNode !== void 0
          ? _oldSchema$astNode
          : oldSchema === null || oldSchema === void 0
          ? void 0
          : oldSchema.getQueryType()) !== null && _ref2 !== void 0
        ? _ref2
        : oldSchema === null || oldSchema === void 0
        ? void 0
        : oldSchema.getMutationType()) !== null && _ref !== void 0
      ? _ref
      : oldSchema === null || oldSchema === void 0
      ? void 0
      : oldSchema.getSubscriptionType();
  let schemaDefinitionsCount = 0;
  return {
    SchemaDefinition(node) {
      if (alreadyDefined) {
        context.reportError(
          new GraphQLError(
            'Cannot define a new schema within a schema extension.',
            {
              nodes: node,
            },
          ),
        );
        return;
      }

      if (schemaDefinitionsCount > 0) {
        context.reportError(
          new GraphQLError('Must provide only one schema definition.', {
            nodes: node,
          }),
        );
      }

      ++schemaDefinitionsCount;
    },
  };
}

const MAX_LISTS_DEPTH = 3;
function MaxIntrospectionDepthRule(context) {
  /**
   * Counts the depth of list fields in "__Type" recursively and
   * returns `true` if the limit has been reached.
   */
  function checkDepth(node, visitedFragments = Object.create(null), depth = 0) {
    if (node.kind === Kind.FRAGMENT_SPREAD) {
      const fragmentName = node.name.value;

      if (visitedFragments[fragmentName] === true) {
        // Fragment cycles are handled by `NoFragmentCyclesRule`.
        return false;
      }

      const fragment = context.getFragment(fragmentName);

      if (!fragment) {
        // Missing fragments checks are handled by `KnownFragmentNamesRule`.
        return false;
      } // Rather than following an immutable programming pattern which has
      // significant memory and garbage collection overhead, we've opted to
      // take a mutable approach for efficiency's sake. Importantly visiting a
      // fragment twice is fine, so long as you don't do one visit inside the
      // other.

      try {
        visitedFragments[fragmentName] = true;
        return checkDepth(fragment, visitedFragments, depth);
      } finally {
        visitedFragments[fragmentName] = undefined;
      }
    }

    if (
      node.kind === Kind.FIELD && // check all introspection lists
      (node.name.value === 'fields' ||
        node.name.value === 'interfaces' ||
        node.name.value === 'possibleTypes' ||
        node.name.value === 'inputFields')
    ) {
      // eslint-disable-next-line no-param-reassign
      depth++;

      if (depth >= MAX_LISTS_DEPTH) {
        return true;
      }
    } // handles fields and inline fragments

    if ('selectionSet' in node && node.selectionSet) {
      for (const child of node.selectionSet.selections) {
        if (checkDepth(child, visitedFragments, depth)) {
          return true;
        }
      }
    }

    return false;
  }

  return {
    Field(node) {
      if (node.name.value === '__schema' || node.name.value === '__type') {
        if (checkDepth(node)) {
          context.reportError(
            new GraphQLError('Maximum introspection depth exceeded', {
              nodes: [node],
            }),
          );
          return false;
        }
      }
    },
  };
}

/**
 * No fragment cycles
 *
 * The graph of fragment spreads must not form any cycles including spreading itself.
 * Otherwise an operation could infinitely spread or infinitely execute on cycles in the underlying data.
 *
 * See https://spec.graphql.org/draft/#sec-Fragment-spreads-must-not-form-cycles
 */
function NoFragmentCyclesRule(context) {
  // Tracks already visited fragments to maintain O(N) and to ensure that cycles
  // are not redundantly reported.
  const visitedFrags = Object.create(null); // Array of AST nodes used to produce meaningful errors

  const spreadPath = []; // Position in the spread path

  const spreadPathIndexByName = Object.create(null);
  return {
    OperationDefinition: () => false,

    FragmentDefinition(node) {
      detectCycleRecursive(node);
      return false;
    },
  }; // This does a straight-forward DFS to find cycles.
  // It does not terminate when a cycle was found but continues to explore
  // the graph to find all possible cycles.

  function detectCycleRecursive(fragment) {
    if (visitedFrags[fragment.name.value]) {
      return;
    }

    const fragmentName = fragment.name.value;
    visitedFrags[fragmentName] = true;
    const spreadNodes = context.getFragmentSpreads(fragment.selectionSet);

    if (spreadNodes.length === 0) {
      return;
    }

    spreadPathIndexByName[fragmentName] = spreadPath.length;

    for (const spreadNode of spreadNodes) {
      const spreadName = spreadNode.name.value;
      const cycleIndex = spreadPathIndexByName[spreadName];
      spreadPath.push(spreadNode);

      if (cycleIndex === undefined) {
        const spreadFragment = context.getFragment(spreadName);

        if (spreadFragment) {
          detectCycleRecursive(spreadFragment);
        }
      } else {
        const cyclePath = spreadPath.slice(cycleIndex);
        const viaPath = cyclePath
          .slice(0, -1)
          .map((s) => '"' + s.name.value + '"')
          .join(', ');
        context.reportError(
          new GraphQLError(
            `Cannot spread fragment "${spreadName}" within itself` +
              (viaPath !== '' ? ` via ${viaPath}.` : '.'),
            {
              nodes: cyclePath,
            },
          ),
        );
      }

      spreadPath.pop();
    }

    spreadPathIndexByName[fragmentName] = undefined;
  }
}

/**
 * No undefined variables
 *
 * A GraphQL operation is only valid if all variables encountered, both directly
 * and via fragment spreads, are defined by that operation.
 *
 * See https://spec.graphql.org/draft/#sec-All-Variable-Uses-Defined
 */
function NoUndefinedVariablesRule(context) {
  let variableNameDefined = Object.create(null);
  return {
    OperationDefinition: {
      enter() {
        variableNameDefined = Object.create(null);
      },

      leave(operation) {
        const usages = context.getRecursiveVariableUsages(operation);

        for (const { node } of usages) {
          const varName = node.name.value;

          if (variableNameDefined[varName] !== true) {
            context.reportError(
              new GraphQLError(
                operation.name
                  ? `Variable "$${varName}" is not defined by operation "${operation.name.value}".`
                  : `Variable "$${varName}" is not defined.`,
                {
                  nodes: [node, operation],
                },
              ),
            );
          }
        }
      },
    },

    VariableDefinition(node) {
      variableNameDefined[node.variable.name.value] = true;
    },
  };
}

/**
 * No unused fragments
 *
 * A GraphQL document is only valid if all fragment definitions are spread
 * within operations, or spread within other fragments spread within operations.
 *
 * See https://spec.graphql.org/draft/#sec-Fragments-Must-Be-Used
 */
function NoUnusedFragmentsRule(context) {
  const operationDefs = [];
  const fragmentDefs = [];
  return {
    OperationDefinition(node) {
      operationDefs.push(node);
      return false;
    },

    FragmentDefinition(node) {
      fragmentDefs.push(node);
      return false;
    },

    Document: {
      leave() {
        const fragmentNameUsed = Object.create(null);

        for (const operation of operationDefs) {
          for (const fragment of context.getRecursivelyReferencedFragments(
            operation,
          )) {
            fragmentNameUsed[fragment.name.value] = true;
          }
        }

        for (const fragmentDef of fragmentDefs) {
          const fragName = fragmentDef.name.value;

          if (fragmentNameUsed[fragName] !== true) {
            context.reportError(
              new GraphQLError(`Fragment "${fragName}" is never used.`, {
                nodes: fragmentDef,
              }),
            );
          }
        }
      },
    },
  };
}

/**
 * No unused variables
 *
 * A GraphQL operation is only valid if all variables defined by an operation
 * are used, either directly or within a spread fragment.
 *
 * See https://spec.graphql.org/draft/#sec-All-Variables-Used
 */
function NoUnusedVariablesRule(context) {
  let variableDefs = [];
  return {
    OperationDefinition: {
      enter() {
        variableDefs = [];
      },

      leave(operation) {
        const variableNameUsed = Object.create(null);
        const usages = context.getRecursiveVariableUsages(operation);

        for (const { node } of usages) {
          variableNameUsed[node.name.value] = true;
        }

        for (const variableDef of variableDefs) {
          const variableName = variableDef.variable.name.value;

          if (variableNameUsed[variableName] !== true) {
            context.reportError(
              new GraphQLError(
                operation.name
                  ? `Variable "$${variableName}" is never used in operation "${operation.name.value}".`
                  : `Variable "$${variableName}" is never used.`,
                {
                  nodes: variableDef,
                },
              ),
            );
          }
        }
      },
    },

    VariableDefinition(def) {
      variableDefs.push(def);
    },
  };
}

/**
 * Sort ValueNode.
 *
 * This function returns a sorted copy of the given ValueNode.
 *
 * @internal
 */

function sortValueNode(valueNode) {
  switch (valueNode.kind) {
    case Kind.OBJECT:
      return { ...valueNode, fields: sortFields(valueNode.fields) };

    case Kind.LIST:
      return { ...valueNode, values: valueNode.values.map(sortValueNode) };

    case Kind.INT:
    case Kind.FLOAT:
    case Kind.STRING:
    case Kind.BOOLEAN:
    case Kind.NULL:
    case Kind.ENUM:
    case Kind.VARIABLE:
      return valueNode;
  }
}

function sortFields(fields) {
  return fields
    .map((fieldNode) => ({
      ...fieldNode,
      value: sortValueNode(fieldNode.value),
    }))
    .sort((fieldA, fieldB) =>
      naturalCompare(fieldA.name.value, fieldB.name.value),
    );
}

function reasonMessage(reason) {
  if (Array.isArray(reason)) {
    return reason
      .map(
        ([responseName, subReason]) =>
          `subfields "${responseName}" conflict because ` +
          reasonMessage(subReason),
      )
      .join(' and ');
  }

  return reason;
}
/**
 * Overlapping fields can be merged
 *
 * A selection set is only valid if all fields (including spreading any
 * fragments) either correspond to distinct response names or can be merged
 * without ambiguity.
 *
 * See https://spec.graphql.org/draft/#sec-Field-Selection-Merging
 */

function OverlappingFieldsCanBeMergedRule(context) {
  // A memoization for when two fragments are compared "between" each other for
  // conflicts. Two fragments may be compared many times, so memoizing this can
  // dramatically improve the performance of this validator.
  const comparedFragmentPairs = new PairSet(); // A cache for the "field map" and list of fragment names found in any given
  // selection set. Selection sets may be asked for this information multiple
  // times, so this improves the performance of this validator.

  const cachedFieldsAndFragmentNames = new Map();
  return {
    SelectionSet(selectionSet) {
      const conflicts = findConflictsWithinSelectionSet(
        context,
        cachedFieldsAndFragmentNames,
        comparedFragmentPairs,
        context.getParentType(),
        selectionSet,
      );

      for (const [[responseName, reason], fields1, fields2] of conflicts) {
        const reasonMsg = reasonMessage(reason);
        context.reportError(
          new GraphQLError(
            `Fields "${responseName}" conflict because ${reasonMsg}. Use different aliases on the fields to fetch both if this was intentional.`,
            {
              nodes: fields1.concat(fields2),
            },
          ),
        );
      }
    },
  };
}

/**
 * Algorithm:
 *
 * Conflicts occur when two fields exist in a query which will produce the same
 * response name, but represent differing values, thus creating a conflict.
 * The algorithm below finds all conflicts via making a series of comparisons
 * between fields. In order to compare as few fields as possible, this makes
 * a series of comparisons "within" sets of fields and "between" sets of fields.
 *
 * Given any selection set, a collection produces both a set of fields by
 * also including all inline fragments, as well as a list of fragments
 * referenced by fragment spreads.
 *
 * A) Each selection set represented in the document first compares "within" its
 * collected set of fields, finding any conflicts between every pair of
 * overlapping fields.
 * Note: This is the *only time* that a the fields "within" a set are compared
 * to each other. After this only fields "between" sets are compared.
 *
 * B) Also, if any fragment is referenced in a selection set, then a
 * comparison is made "between" the original set of fields and the
 * referenced fragment.
 *
 * C) Also, if multiple fragments are referenced, then comparisons
 * are made "between" each referenced fragment.
 *
 * D) When comparing "between" a set of fields and a referenced fragment, first
 * a comparison is made between each field in the original set of fields and
 * each field in the the referenced set of fields.
 *
 * E) Also, if any fragment is referenced in the referenced selection set,
 * then a comparison is made "between" the original set of fields and the
 * referenced fragment (recursively referring to step D).
 *
 * F) When comparing "between" two fragments, first a comparison is made between
 * each field in the first referenced set of fields and each field in the the
 * second referenced set of fields.
 *
 * G) Also, any fragments referenced by the first must be compared to the
 * second, and any fragments referenced by the second must be compared to the
 * first (recursively referring to step F).
 *
 * H) When comparing two fields, if both have selection sets, then a comparison
 * is made "between" both selection sets, first comparing the set of fields in
 * the first selection set with the set of fields in the second.
 *
 * I) Also, if any fragment is referenced in either selection set, then a
 * comparison is made "between" the other set of fields and the
 * referenced fragment.
 *
 * J) Also, if two fragments are referenced in both selection sets, then a
 * comparison is made "between" the two fragments.
 *
 */
// Find all conflicts found "within" a selection set, including those found
// via spreading in fragments. Called when visiting each SelectionSet in the
// GraphQL Document.
function findConflictsWithinSelectionSet(
  context,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  parentType,
  selectionSet,
) {
  const conflicts = [];
  const [fieldMap, fragmentNames] = getFieldsAndFragmentNames(
    context,
    cachedFieldsAndFragmentNames,
    parentType,
    selectionSet,
  ); // (A) Find find all conflicts "within" the fields of this selection set.
  // Note: this is the *only place* `collectConflictsWithin` is called.

  collectConflictsWithin(
    context,
    conflicts,
    cachedFieldsAndFragmentNames,
    comparedFragmentPairs,
    fieldMap,
  );

  if (fragmentNames.length !== 0) {
    // (B) Then collect conflicts between these fields and those represented by
    // each spread fragment name found.
    for (let i = 0; i < fragmentNames.length; i++) {
      collectConflictsBetweenFieldsAndFragment(
        context,
        conflicts,
        cachedFieldsAndFragmentNames,
        comparedFragmentPairs,
        false,
        fieldMap,
        fragmentNames[i],
      ); // (C) Then compare this fragment with all other fragments found in this
      // selection set to collect conflicts between fragments spread together.
      // This compares each item in the list of fragment names to every other
      // item in that same list (except for itself).

      for (let j = i + 1; j < fragmentNames.length; j++) {
        collectConflictsBetweenFragments(
          context,
          conflicts,
          cachedFieldsAndFragmentNames,
          comparedFragmentPairs,
          false,
          fragmentNames[i],
          fragmentNames[j],
        );
      }
    }
  }

  return conflicts;
} // Collect all conflicts found between a set of fields and a fragment reference
// including via spreading in any nested fragments.

function collectConflictsBetweenFieldsAndFragment(
  context,
  conflicts,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  areMutuallyExclusive,
  fieldMap,
  fragmentName,
) {
  const fragment = context.getFragment(fragmentName);

  if (!fragment) {
    return;
  }

  const [fieldMap2, referencedFragmentNames] =
    getReferencedFieldsAndFragmentNames(
      context,
      cachedFieldsAndFragmentNames,
      fragment,
    ); // Do not compare a fragment's fieldMap to itself.

  if (fieldMap === fieldMap2) {
    return;
  } // (D) First collect any conflicts between the provided collection of fields
  // and the collection of fields represented by the given fragment.

  collectConflictsBetween(
    context,
    conflicts,
    cachedFieldsAndFragmentNames,
    comparedFragmentPairs,
    areMutuallyExclusive,
    fieldMap,
    fieldMap2,
  ); // (E) Then collect any conflicts between the provided collection of fields
  // and any fragment names found in the given fragment.

  for (const referencedFragmentName of referencedFragmentNames) {
    // Memoize so two fragments are not compared for conflicts more than once.
    if (
      comparedFragmentPairs.has(
        referencedFragmentName,
        fragmentName,
        areMutuallyExclusive,
      )
    ) {
      continue;
    }

    comparedFragmentPairs.add(
      referencedFragmentName,
      fragmentName,
      areMutuallyExclusive,
    );
    collectConflictsBetweenFieldsAndFragment(
      context,
      conflicts,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      fieldMap,
      referencedFragmentName,
    );
  }
} // Collect all conflicts found between two fragments, including via spreading in
// any nested fragments.

function collectConflictsBetweenFragments(
  context,
  conflicts,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  areMutuallyExclusive,
  fragmentName1,
  fragmentName2,
) {
  // No need to compare a fragment to itself.
  if (fragmentName1 === fragmentName2) {
    return;
  } // Memoize so two fragments are not compared for conflicts more than once.

  if (
    comparedFragmentPairs.has(
      fragmentName1,
      fragmentName2,
      areMutuallyExclusive,
    )
  ) {
    return;
  }

  comparedFragmentPairs.add(fragmentName1, fragmentName2, areMutuallyExclusive);
  const fragment1 = context.getFragment(fragmentName1);
  const fragment2 = context.getFragment(fragmentName2);

  if (!fragment1 || !fragment2) {
    return;
  }

  const [fieldMap1, referencedFragmentNames1] =
    getReferencedFieldsAndFragmentNames(
      context,
      cachedFieldsAndFragmentNames,
      fragment1,
    );
  const [fieldMap2, referencedFragmentNames2] =
    getReferencedFieldsAndFragmentNames(
      context,
      cachedFieldsAndFragmentNames,
      fragment2,
    ); // (F) First, collect all conflicts between these two collections of fields
  // (not including any nested fragments).

  collectConflictsBetween(
    context,
    conflicts,
    cachedFieldsAndFragmentNames,
    comparedFragmentPairs,
    areMutuallyExclusive,
    fieldMap1,
    fieldMap2,
  ); // (G) Then collect conflicts between the first fragment and any nested
  // fragments spread in the second fragment.

  for (const referencedFragmentName2 of referencedFragmentNames2) {
    collectConflictsBetweenFragments(
      context,
      conflicts,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      fragmentName1,
      referencedFragmentName2,
    );
  } // (G) Then collect conflicts between the second fragment and any nested
  // fragments spread in the first fragment.

  for (const referencedFragmentName1 of referencedFragmentNames1) {
    collectConflictsBetweenFragments(
      context,
      conflicts,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      referencedFragmentName1,
      fragmentName2,
    );
  }
} // Find all conflicts found between two selection sets, including those found
// via spreading in fragments. Called when determining if conflicts exist
// between the sub-fields of two overlapping fields.

function findConflictsBetweenSubSelectionSets(
  context,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  areMutuallyExclusive,
  parentType1,
  selectionSet1,
  parentType2,
  selectionSet2,
) {
  const conflicts = [];
  const [fieldMap1, fragmentNames1] = getFieldsAndFragmentNames(
    context,
    cachedFieldsAndFragmentNames,
    parentType1,
    selectionSet1,
  );
  const [fieldMap2, fragmentNames2] = getFieldsAndFragmentNames(
    context,
    cachedFieldsAndFragmentNames,
    parentType2,
    selectionSet2,
  ); // (H) First, collect all conflicts between these two collections of field.

  collectConflictsBetween(
    context,
    conflicts,
    cachedFieldsAndFragmentNames,
    comparedFragmentPairs,
    areMutuallyExclusive,
    fieldMap1,
    fieldMap2,
  ); // (I) Then collect conflicts between the first collection of fields and
  // those referenced by each fragment name associated with the second.

  for (const fragmentName2 of fragmentNames2) {
    collectConflictsBetweenFieldsAndFragment(
      context,
      conflicts,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      fieldMap1,
      fragmentName2,
    );
  } // (I) Then collect conflicts between the second collection of fields and
  // those referenced by each fragment name associated with the first.

  for (const fragmentName1 of fragmentNames1) {
    collectConflictsBetweenFieldsAndFragment(
      context,
      conflicts,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      fieldMap2,
      fragmentName1,
    );
  } // (J) Also collect conflicts between any fragment names by the first and
  // fragment names by the second. This compares each item in the first set of
  // names to each item in the second set of names.

  for (const fragmentName1 of fragmentNames1) {
    for (const fragmentName2 of fragmentNames2) {
      collectConflictsBetweenFragments(
        context,
        conflicts,
        cachedFieldsAndFragmentNames,
        comparedFragmentPairs,
        areMutuallyExclusive,
        fragmentName1,
        fragmentName2,
      );
    }
  }

  return conflicts;
} // Collect all Conflicts "within" one collection of fields.

function collectConflictsWithin(
  context,
  conflicts,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  fieldMap,
) {
  // A field map is a keyed collection, where each key represents a response
  // name and the value at that key is a list of all fields which provide that
  // response name. For every response name, if there are multiple fields, they
  // must be compared to find a potential conflict.
  for (const [responseName, fields] of Object.entries(fieldMap)) {
    // This compares every field in the list to every other field in this list
    // (except to itself). If the list only has one item, nothing needs to
    // be compared.
    if (fields.length > 1) {
      for (let i = 0; i < fields.length; i++) {
        for (let j = i + 1; j < fields.length; j++) {
          const conflict = findConflict(
            context,
            cachedFieldsAndFragmentNames,
            comparedFragmentPairs,
            false, // within one collection is never mutually exclusive
            responseName,
            fields[i],
            fields[j],
          );

          if (conflict) {
            conflicts.push(conflict);
          }
        }
      }
    }
  }
} // Collect all Conflicts between two collections of fields. This is similar to,
// but different from the `collectConflictsWithin` function above. This check
// assumes that `collectConflictsWithin` has already been called on each
// provided collection of fields. This is true because this validator traverses
// each individual selection set.

function collectConflictsBetween(
  context,
  conflicts,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  parentFieldsAreMutuallyExclusive,
  fieldMap1,
  fieldMap2,
) {
  // A field map is a keyed collection, where each key represents a response
  // name and the value at that key is a list of all fields which provide that
  // response name. For any response name which appears in both provided field
  // maps, each field from the first field map must be compared to every field
  // in the second field map to find potential conflicts.
  for (const [responseName, fields1] of Object.entries(fieldMap1)) {
    const fields2 = fieldMap2[responseName];

    if (fields2) {
      for (const field1 of fields1) {
        for (const field2 of fields2) {
          const conflict = findConflict(
            context,
            cachedFieldsAndFragmentNames,
            comparedFragmentPairs,
            parentFieldsAreMutuallyExclusive,
            responseName,
            field1,
            field2,
          );

          if (conflict) {
            conflicts.push(conflict);
          }
        }
      }
    }
  }
} // Determines if there is a conflict between two particular fields, including
// comparing their sub-fields.

function findConflict(
  context,
  cachedFieldsAndFragmentNames,
  comparedFragmentPairs,
  parentFieldsAreMutuallyExclusive,
  responseName,
  field1,
  field2,
) {
  const [parentType1, node1, def1] = field1;
  const [parentType2, node2, def2] = field2; // If it is known that two fields could not possibly apply at the same
  // time, due to the parent types, then it is safe to permit them to diverge
  // in aliased field or arguments used as they will not present any ambiguity
  // by differing.
  // It is known that two parent types could never overlap if they are
  // different Object types. Interface or Union types might overlap - if not
  // in the current state of the schema, then perhaps in some future version,
  // thus may not safely diverge.

  const areMutuallyExclusive =
    parentFieldsAreMutuallyExclusive ||
    (parentType1 !== parentType2 &&
      isObjectType(parentType1) &&
      isObjectType(parentType2));

  if (!areMutuallyExclusive) {
    // Two aliases must refer to the same field.
    const name1 = node1.name.value;
    const name2 = node2.name.value;

    if (name1 !== name2) {
      return [
        [responseName, `"${name1}" and "${name2}" are different fields`],
        [node1],
        [node2],
      ];
    } // Two field calls must have the same arguments.

    if (!sameArguments(node1, node2)) {
      return [
        [responseName, 'they have differing arguments'],
        [node1],
        [node2],
      ];
    }
  } // The return type for each field.

  const type1 = def1 === null || def1 === void 0 ? void 0 : def1.type;
  const type2 = def2 === null || def2 === void 0 ? void 0 : def2.type;

  if (type1 && type2 && doTypesConflict(type1, type2)) {
    return [
      [
        responseName,
        `they return conflicting types "${inspect$1(type1)}" and "${inspect$1(
          type2,
        )}"`,
      ],
      [node1],
      [node2],
    ];
  } // Collect and compare sub-fields. Use the same "visited fragment names" list
  // for both collections so fields in a fragment reference are never
  // compared to themselves.

  const selectionSet1 = node1.selectionSet;
  const selectionSet2 = node2.selectionSet;

  if (selectionSet1 && selectionSet2) {
    const conflicts = findConflictsBetweenSubSelectionSets(
      context,
      cachedFieldsAndFragmentNames,
      comparedFragmentPairs,
      areMutuallyExclusive,
      getNamedType(type1),
      selectionSet1,
      getNamedType(type2),
      selectionSet2,
    );
    return subfieldConflicts(conflicts, responseName, node1, node2);
  }
}

function sameArguments(node1, node2) {
  const args1 = node1.arguments;
  const args2 = node2.arguments;

  if (args1 === undefined || args1.length === 0) {
    return args2 === undefined || args2.length === 0;
  }

  if (args2 === undefined || args2.length === 0) {
    return false;
  }
  /* c8 ignore next */

  if (args1.length !== args2.length) {
    /* c8 ignore next */
    return false;
    /* c8 ignore next */
  }

  const values2 = new Map(args2.map(({ name, value }) => [name.value, value]));
  return args1.every((arg1) => {
    const value1 = arg1.value;
    const value2 = values2.get(arg1.name.value);

    if (value2 === undefined) {
      return false;
    }

    return stringifyValue(value1) === stringifyValue(value2);
  });
}

function stringifyValue(value) {
  return print(sortValueNode(value));
} // Two types conflict if both types could not apply to a value simultaneously.
// Composite types are ignored as their individual field types will be compared
// later recursively. However List and Non-Null types must match.

function doTypesConflict(type1, type2) {
  if (isListType(type1)) {
    return isListType(type2)
      ? doTypesConflict(type1.ofType, type2.ofType)
      : true;
  }

  if (isListType(type2)) {
    return true;
  }

  if (isNonNullType(type1)) {
    return isNonNullType(type2)
      ? doTypesConflict(type1.ofType, type2.ofType)
      : true;
  }

  if (isNonNullType(type2)) {
    return true;
  }

  if (isLeafType(type1) || isLeafType(type2)) {
    return type1 !== type2;
  }

  return false;
} // Given a selection set, return the collection of fields (a mapping of response
// name to field nodes and definitions) as well as a list of fragment names
// referenced via fragment spreads.

function getFieldsAndFragmentNames(
  context,
  cachedFieldsAndFragmentNames,
  parentType,
  selectionSet,
) {
  const cached = cachedFieldsAndFragmentNames.get(selectionSet);

  if (cached) {
    return cached;
  }

  const nodeAndDefs = Object.create(null);
  const fragmentNames = Object.create(null);

  _collectFieldsAndFragmentNames(
    context,
    parentType,
    selectionSet,
    nodeAndDefs,
    fragmentNames,
  );

  const result = [nodeAndDefs, Object.keys(fragmentNames)];
  cachedFieldsAndFragmentNames.set(selectionSet, result);
  return result;
} // Given a reference to a fragment, return the represented collection of fields
// as well as a list of nested fragment names referenced via fragment spreads.

function getReferencedFieldsAndFragmentNames(
  context,
  cachedFieldsAndFragmentNames,
  fragment,
) {
  // Short-circuit building a type from the node if possible.
  const cached = cachedFieldsAndFragmentNames.get(fragment.selectionSet);

  if (cached) {
    return cached;
  }

  const fragmentType = typeFromAST(context.getSchema(), fragment.typeCondition);
  return getFieldsAndFragmentNames(
    context,
    cachedFieldsAndFragmentNames,
    fragmentType,
    fragment.selectionSet,
  );
}

function _collectFieldsAndFragmentNames(
  context,
  parentType,
  selectionSet,
  nodeAndDefs,
  fragmentNames,
) {
  for (const selection of selectionSet.selections) {
    switch (selection.kind) {
      case Kind.FIELD: {
        const fieldName = selection.name.value;
        let fieldDef;

        if (isObjectType(parentType) || isInterfaceType(parentType)) {
          fieldDef = parentType.getFields()[fieldName];
        }

        const responseName = selection.alias
          ? selection.alias.value
          : fieldName;

        if (!nodeAndDefs[responseName]) {
          nodeAndDefs[responseName] = [];
        }

        nodeAndDefs[responseName].push([parentType, selection, fieldDef]);
        break;
      }

      case Kind.FRAGMENT_SPREAD:
        fragmentNames[selection.name.value] = true;
        break;

      case Kind.INLINE_FRAGMENT: {
        const typeCondition = selection.typeCondition;
        const inlineFragmentType = typeCondition
          ? typeFromAST(context.getSchema(), typeCondition)
          : parentType;

        _collectFieldsAndFragmentNames(
          context,
          inlineFragmentType,
          selection.selectionSet,
          nodeAndDefs,
          fragmentNames,
        );

        break;
      }
    }
  }
} // Given a series of Conflicts which occurred between two sub-fields, generate
// a single Conflict.

function subfieldConflicts(conflicts, responseName, node1, node2) {
  if (conflicts.length > 0) {
    return [
      [responseName, conflicts.map(([reason]) => reason)],
      [node1, ...conflicts.map(([, fields1]) => fields1).flat()],
      [node2, ...conflicts.map(([, , fields2]) => fields2).flat()],
    ];
  }
}
/**
 * A way to keep track of pairs of things when the ordering of the pair does not matter.
 */

class PairSet {
  constructor() {
    this._data = new Map();
  }

  has(a, b, areMutuallyExclusive) {
    var _this$_data$get;

    const [key1, key2] = a < b ? [a, b] : [b, a];
    const result =
      (_this$_data$get = this._data.get(key1)) === null ||
      _this$_data$get === void 0
        ? void 0
        : _this$_data$get.get(key2);

    if (result === undefined) {
      return false;
    } // areMutuallyExclusive being false is a superset of being true, hence if
    // we want to know if this PairSet "has" these two with no exclusivity,
    // we have to ensure it was added as such.

    return areMutuallyExclusive ? true : areMutuallyExclusive === result;
  }

  add(a, b, areMutuallyExclusive) {
    const [key1, key2] = a < b ? [a, b] : [b, a];

    const map = this._data.get(key1);

    if (map === undefined) {
      this._data.set(key1, new Map([[key2, areMutuallyExclusive]]));
    } else {
      map.set(key2, areMutuallyExclusive);
    }
  }
}

/**
 * Possible fragment spread
 *
 * A fragment spread is only valid if the type condition could ever possibly
 * be true: if there is a non-empty intersection of the possible parent types,
 * and possible types which pass the type condition.
 */
function PossibleFragmentSpreadsRule(context) {
  return {
    InlineFragment(node) {
      const fragType = context.getType();
      const parentType = context.getParentType();

      if (
        isCompositeType(fragType) &&
        isCompositeType(parentType) &&
        !doTypesOverlap(context.getSchema(), fragType, parentType)
      ) {
        const parentTypeStr = inspect$1(parentType);
        const fragTypeStr = inspect$1(fragType);
        context.reportError(
          new GraphQLError(
            `Fragment cannot be spread here as objects of type "${parentTypeStr}" can never be of type "${fragTypeStr}".`,
            {
              nodes: node,
            },
          ),
        );
      }
    },

    FragmentSpread(node) {
      const fragName = node.name.value;
      const fragType = getFragmentType(context, fragName);
      const parentType = context.getParentType();

      if (
        fragType &&
        parentType &&
        !doTypesOverlap(context.getSchema(), fragType, parentType)
      ) {
        const parentTypeStr = inspect$1(parentType);
        const fragTypeStr = inspect$1(fragType);
        context.reportError(
          new GraphQLError(
            `Fragment "${fragName}" cannot be spread here as objects of type "${parentTypeStr}" can never be of type "${fragTypeStr}".`,
            {
              nodes: node,
            },
          ),
        );
      }
    },
  };
}

function getFragmentType(context, name) {
  const frag = context.getFragment(name);

  if (frag) {
    const type = typeFromAST(context.getSchema(), frag.typeCondition);

    if (isCompositeType(type)) {
      return type;
    }
  }
}

/**
 * Possible type extension
 *
 * A type extension is only valid if the type is defined and has the same kind.
 */
function PossibleTypeExtensionsRule(context) {
  const schema = context.getSchema();
  const definedTypes = Object.create(null);

  for (const def of context.getDocument().definitions) {
    if (isTypeDefinitionNode(def)) {
      definedTypes[def.name.value] = def;
    }
  }

  return {
    ScalarTypeExtension: checkExtension,
    ObjectTypeExtension: checkExtension,
    InterfaceTypeExtension: checkExtension,
    UnionTypeExtension: checkExtension,
    EnumTypeExtension: checkExtension,
    InputObjectTypeExtension: checkExtension,
  };

  function checkExtension(node) {
    const typeName = node.name.value;
    const defNode = definedTypes[typeName];
    const existingType =
      schema === null || schema === void 0 ? void 0 : schema.getType(typeName);
    let expectedKind;

    if (defNode) {
      expectedKind = defKindToExtKind[defNode.kind];
    } else if (existingType) {
      expectedKind = typeToExtKind(existingType);
    }

    if (expectedKind) {
      if (expectedKind !== node.kind) {
        const kindStr = extensionKindToTypeName(node.kind);
        context.reportError(
          new GraphQLError(`Cannot extend non-${kindStr} type "${typeName}".`, {
            nodes: defNode ? [defNode, node] : node,
          }),
        );
      }
    } else {
      const allTypeNames = Object.keys({
        ...definedTypes,
        ...(schema === null || schema === void 0
          ? void 0
          : schema.getTypeMap()),
      });
      const suggestedTypes = suggestionList(typeName, allTypeNames);
      context.reportError(
        new GraphQLError(
          `Cannot extend type "${typeName}" because it is not defined.` +
            didYouMean(suggestedTypes),
          {
            nodes: node.name,
          },
        ),
      );
    }
  }
}
const defKindToExtKind = {
  [Kind.SCALAR_TYPE_DEFINITION]: Kind.SCALAR_TYPE_EXTENSION,
  [Kind.OBJECT_TYPE_DEFINITION]: Kind.OBJECT_TYPE_EXTENSION,
  [Kind.INTERFACE_TYPE_DEFINITION]: Kind.INTERFACE_TYPE_EXTENSION,
  [Kind.UNION_TYPE_DEFINITION]: Kind.UNION_TYPE_EXTENSION,
  [Kind.ENUM_TYPE_DEFINITION]: Kind.ENUM_TYPE_EXTENSION,
  [Kind.INPUT_OBJECT_TYPE_DEFINITION]: Kind.INPUT_OBJECT_TYPE_EXTENSION,
};

function typeToExtKind(type) {
  if (isScalarType(type)) {
    return Kind.SCALAR_TYPE_EXTENSION;
  }

  if (isObjectType(type)) {
    return Kind.OBJECT_TYPE_EXTENSION;
  }

  if (isInterfaceType(type)) {
    return Kind.INTERFACE_TYPE_EXTENSION;
  }

  if (isUnionType(type)) {
    return Kind.UNION_TYPE_EXTENSION;
  }

  if (isEnumType(type)) {
    return Kind.ENUM_TYPE_EXTENSION;
  }

  if (isInputObjectType(type)) {
    return Kind.INPUT_OBJECT_TYPE_EXTENSION;
  }
  /* c8 ignore next 3 */
  // Not reachable. All possible types have been considered

  invariant(false, 'Unexpected type: ' + inspect$1(type));
}

function extensionKindToTypeName(kind) {
  switch (kind) {
    case Kind.SCALAR_TYPE_EXTENSION:
      return 'scalar';

    case Kind.OBJECT_TYPE_EXTENSION:
      return 'object';

    case Kind.INTERFACE_TYPE_EXTENSION:
      return 'interface';

    case Kind.UNION_TYPE_EXTENSION:
      return 'union';

    case Kind.ENUM_TYPE_EXTENSION:
      return 'enum';

    case Kind.INPUT_OBJECT_TYPE_EXTENSION:
      return 'input object';
    // Not reachable. All possible types have been considered

    /* c8 ignore next */

    default:
      invariant(false, 'Unexpected kind: ' + inspect$1(kind));
  }
}

/**
 * Provided required arguments
 *
 * A field or directive is only valid if all required (non-null without a
 * default value) field arguments have been provided.
 */
function ProvidedRequiredArgumentsRule(context) {
  return {
    // eslint-disable-next-line new-cap
    ...ProvidedRequiredArgumentsOnDirectivesRule(context),
    Field: {
      // Validate on leave to allow for deeper errors to appear first.
      leave(fieldNode) {
        var _fieldNode$arguments;

        const fieldDef = context.getFieldDef();

        if (!fieldDef) {
          return false;
        }

        const providedArgs = new Set( // FIXME: https://github.com/graphql/graphql-js/issues/2203
          /* c8 ignore next */
          (_fieldNode$arguments = fieldNode.arguments) === null ||
          _fieldNode$arguments === void 0
            ? void 0
            : _fieldNode$arguments.map((arg) => arg.name.value),
        );

        for (const argDef of fieldDef.args) {
          if (!providedArgs.has(argDef.name) && isRequiredArgument(argDef)) {
            const argTypeStr = inspect$1(argDef.type);
            context.reportError(
              new GraphQLError(
                `Field "${fieldDef.name}" argument "${argDef.name}" of type "${argTypeStr}" is required, but it was not provided.`,
                {
                  nodes: fieldNode,
                },
              ),
            );
          }
        }
      },
    },
  };
}
/**
 * @internal
 */

function ProvidedRequiredArgumentsOnDirectivesRule(context) {
  var _schema$getDirectives;

  const requiredArgsMap = Object.create(null);
  const schema = context.getSchema();
  const definedDirectives =
    (_schema$getDirectives =
      schema === null || schema === void 0
        ? void 0
        : schema.getDirectives()) !== null && _schema$getDirectives !== void 0
      ? _schema$getDirectives
      : specifiedDirectives;

  for (const directive of definedDirectives) {
    requiredArgsMap[directive.name] = keyMap(
      directive.args.filter(isRequiredArgument),
      (arg) => arg.name,
    );
  }

  const astDefinitions = context.getDocument().definitions;

  for (const def of astDefinitions) {
    if (def.kind === Kind.DIRECTIVE_DEFINITION) {
      var _def$arguments;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203

      /* c8 ignore next */
      const argNodes =
        (_def$arguments = def.arguments) !== null && _def$arguments !== void 0
          ? _def$arguments
          : [];
      requiredArgsMap[def.name.value] = keyMap(
        argNodes.filter(isRequiredArgumentNode),
        (arg) => arg.name.value,
      );
    }
  }

  return {
    Directive: {
      // Validate on leave to allow for deeper errors to appear first.
      leave(directiveNode) {
        const directiveName = directiveNode.name.value;
        const requiredArgs = requiredArgsMap[directiveName];

        if (requiredArgs) {
          var _directiveNode$argume;

          // FIXME: https://github.com/graphql/graphql-js/issues/2203

          /* c8 ignore next */
          const argNodes =
            (_directiveNode$argume = directiveNode.arguments) !== null &&
            _directiveNode$argume !== void 0
              ? _directiveNode$argume
              : [];
          const argNodeMap = new Set(argNodes.map((arg) => arg.name.value));

          for (const [argName, argDef] of Object.entries(requiredArgs)) {
            if (!argNodeMap.has(argName)) {
              const argType = isType(argDef.type)
                ? inspect$1(argDef.type)
                : print(argDef.type);
              context.reportError(
                new GraphQLError(
                  `Directive "@${directiveName}" argument "${argName}" of type "${argType}" is required, but it was not provided.`,
                  {
                    nodes: directiveNode,
                  },
                ),
              );
            }
          }
        }
      },
    },
  };
}

function isRequiredArgumentNode(arg) {
  return arg.type.kind === Kind.NON_NULL_TYPE && arg.defaultValue == null;
}

/**
 * Scalar leafs
 *
 * A GraphQL document is valid only if all leaf fields (fields without
 * sub selections) are of scalar or enum types.
 */
function ScalarLeafsRule(context) {
  return {
    Field(node) {
      const type = context.getType();
      const selectionSet = node.selectionSet;

      if (type) {
        if (isLeafType(getNamedType(type))) {
          if (selectionSet) {
            const fieldName = node.name.value;
            const typeStr = inspect$1(type);
            context.reportError(
              new GraphQLError(
                `Field "${fieldName}" must not have a selection since type "${typeStr}" has no subfields.`,
                {
                  nodes: selectionSet,
                },
              ),
            );
          }
        } else if (!selectionSet) {
          const fieldName = node.name.value;
          const typeStr = inspect$1(type);
          context.reportError(
            new GraphQLError(
              `Field "${fieldName}" of type "${typeStr}" must have a selection of subfields. Did you mean "${fieldName} { ... }"?`,
              {
                nodes: node,
              },
            ),
          );
        }
      }
    },
  };
}

/**
 * Build a string describing the path.
 */
function printPathArray(path) {
  return path
    .map((key) =>
      typeof key === 'number' ? '[' + key.toString() + ']' : '.' + key,
    )
    .join('');
}

/**
 * Given a Path and a key, return a new Path containing the new key.
 */
function addPath(prev, key, typename) {
  return {
    prev,
    key,
    typename,
  };
}
/**
 * Given a Path, return an Array of the path keys.
 */

function pathToArray(path) {
  const flattened = [];
  let curr = path;

  while (curr) {
    flattened.push(curr.key);
    curr = curr.prev;
  }

  return flattened.reverse();
}

/**
 * Coerces a JavaScript value given a GraphQL Input Type.
 */
function coerceInputValue(inputValue, type, onError = defaultOnError) {
  return coerceInputValueImpl(inputValue, type, onError, undefined);
}

function defaultOnError(path, invalidValue, error) {
  let errorPrefix = 'Invalid value ' + inspect$1(invalidValue);

  if (path.length > 0) {
    errorPrefix += ` at "value${printPathArray(path)}"`;
  }

  error.message = errorPrefix + ': ' + error.message;
  throw error;
}

function coerceInputValueImpl(inputValue, type, onError, path) {
  if (isNonNullType(type)) {
    if (inputValue != null) {
      return coerceInputValueImpl(inputValue, type.ofType, onError, path);
    }

    onError(
      pathToArray(path),
      inputValue,
      new GraphQLError(
        `Expected non-nullable type "${inspect$1(type)}" not to be null.`,
      ),
    );
    return;
  }

  if (inputValue == null) {
    // Explicitly return the value null.
    return null;
  }

  if (isListType(type)) {
    const itemType = type.ofType;

    if (isIterableObject$1(inputValue)) {
      return Array.from(inputValue, (itemValue, index) => {
        const itemPath = addPath(path, index, undefined);
        return coerceInputValueImpl(itemValue, itemType, onError, itemPath);
      });
    } // Lists accept a non-list value as a list of one.

    return [coerceInputValueImpl(inputValue, itemType, onError, path)];
  }

  if (isInputObjectType(type)) {
    if (!isObjectLike$1(inputValue)) {
      onError(
        pathToArray(path),
        inputValue,
        new GraphQLError(`Expected type "${type.name}" to be an object.`),
      );
      return;
    }

    const coercedValue = {};
    const fieldDefs = type.getFields();

    for (const field of Object.values(fieldDefs)) {
      const fieldValue = inputValue[field.name];

      if (fieldValue === undefined) {
        if (field.defaultValue !== undefined) {
          coercedValue[field.name] = field.defaultValue;
        } else if (isNonNullType(field.type)) {
          const typeStr = inspect$1(field.type);
          onError(
            pathToArray(path),
            inputValue,
            new GraphQLError(
              `Field "${field.name}" of required type "${typeStr}" was not provided.`,
            ),
          );
        }

        continue;
      }

      coercedValue[field.name] = coerceInputValueImpl(
        fieldValue,
        field.type,
        onError,
        addPath(path, field.name, type.name),
      );
    } // Ensure every provided field is defined.

    for (const fieldName of Object.keys(inputValue)) {
      if (!fieldDefs[fieldName]) {
        const suggestions = suggestionList(
          fieldName,
          Object.keys(type.getFields()),
        );
        onError(
          pathToArray(path),
          inputValue,
          new GraphQLError(
            `Field "${fieldName}" is not defined by type "${type.name}".` +
              didYouMean(suggestions),
          ),
        );
      }
    }

    if (type.isOneOf) {
      const keys = Object.keys(coercedValue);

      if (keys.length !== 1) {
        onError(
          pathToArray(path),
          inputValue,
          new GraphQLError(
            `Exactly one key must be specified for OneOf type "${type.name}".`,
          ),
        );
      }

      const key = keys[0];
      const value = coercedValue[key];

      if (value === null) {
        onError(
          pathToArray(path).concat(key),
          value,
          new GraphQLError(`Field "${key}" must be non-null.`),
        );
      }
    }

    return coercedValue;
  }

  if (isLeafType(type)) {
    let parseResult; // Scalars and Enums determine if a input value is valid via parseValue(),
    // which can throw to indicate failure. If it throws, maintain a reference
    // to the original error.

    try {
      parseResult = type.parseValue(inputValue);
    } catch (error) {
      if (error instanceof GraphQLError) {
        onError(pathToArray(path), inputValue, error);
      } else {
        onError(
          pathToArray(path),
          inputValue,
          new GraphQLError(`Expected type "${type.name}". ` + error.message, {
            originalError: error,
          }),
        );
      }

      return;
    }

    if (parseResult === undefined) {
      onError(
        pathToArray(path),
        inputValue,
        new GraphQLError(`Expected type "${type.name}".`),
      );
    }

    return parseResult;
  }
  /* c8 ignore next 3 */
  // Not reachable, all possible types have been considered.

  invariant(false, 'Unexpected input type: ' + inspect$1(type));
}

/**
 * Produces a JavaScript value given a GraphQL Value AST.
 *
 * A GraphQL type must be provided, which will be used to interpret different
 * GraphQL Value literals.
 *
 * Returns `undefined` when the value could not be validly coerced according to
 * the provided type.
 *
 * | GraphQL Value        | JSON Value    |
 * | -------------------- | ------------- |
 * | Input Object         | Object        |
 * | List                 | Array         |
 * | Boolean              | Boolean       |
 * | String               | String        |
 * | Int / Float          | Number        |
 * | Enum Value           | Unknown       |
 * | NullValue            | null          |
 *
 */

function valueFromAST(valueNode, type, variables) {
  if (!valueNode) {
    // When there is no node, then there is also no value.
    // Importantly, this is different from returning the value null.
    return;
  }

  if (valueNode.kind === Kind.VARIABLE) {
    const variableName = valueNode.name.value;

    if (variables == null || variables[variableName] === undefined) {
      // No valid return value.
      return;
    }

    const variableValue = variables[variableName];

    if (variableValue === null && isNonNullType(type)) {
      return; // Invalid: intentionally return no value.
    } // Note: This does no further checking that this variable is correct.
    // This assumes that this query has been validated and the variable
    // usage here is of the correct type.

    return variableValue;
  }

  if (isNonNullType(type)) {
    if (valueNode.kind === Kind.NULL) {
      return; // Invalid: intentionally return no value.
    }

    return valueFromAST(valueNode, type.ofType, variables);
  }

  if (valueNode.kind === Kind.NULL) {
    // This is explicitly returning the value null.
    return null;
  }

  if (isListType(type)) {
    const itemType = type.ofType;

    if (valueNode.kind === Kind.LIST) {
      const coercedValues = [];

      for (const itemNode of valueNode.values) {
        if (isMissingVariable(itemNode, variables)) {
          // If an array contains a missing variable, it is either coerced to
          // null or if the item type is non-null, it considered invalid.
          if (isNonNullType(itemType)) {
            return; // Invalid: intentionally return no value.
          }

          coercedValues.push(null);
        } else {
          const itemValue = valueFromAST(itemNode, itemType, variables);

          if (itemValue === undefined) {
            return; // Invalid: intentionally return no value.
          }

          coercedValues.push(itemValue);
        }
      }

      return coercedValues;
    }

    const coercedValue = valueFromAST(valueNode, itemType, variables);

    if (coercedValue === undefined) {
      return; // Invalid: intentionally return no value.
    }

    return [coercedValue];
  }

  if (isInputObjectType(type)) {
    if (valueNode.kind !== Kind.OBJECT) {
      return; // Invalid: intentionally return no value.
    }

    const coercedObj = Object.create(null);
    const fieldNodes = keyMap(valueNode.fields, (field) => field.name.value);

    for (const field of Object.values(type.getFields())) {
      const fieldNode = fieldNodes[field.name];

      if (!fieldNode || isMissingVariable(fieldNode.value, variables)) {
        if (field.defaultValue !== undefined) {
          coercedObj[field.name] = field.defaultValue;
        } else if (isNonNullType(field.type)) {
          return; // Invalid: intentionally return no value.
        }

        continue;
      }

      const fieldValue = valueFromAST(fieldNode.value, field.type, variables);

      if (fieldValue === undefined) {
        return; // Invalid: intentionally return no value.
      }

      coercedObj[field.name] = fieldValue;
    }

    if (type.isOneOf) {
      const keys = Object.keys(coercedObj);

      if (keys.length !== 1) {
        return; // Invalid: not exactly one key, intentionally return no value.
      }

      if (coercedObj[keys[0]] === null) {
        return; // Invalid: value not non-null, intentionally return no value.
      }
    }

    return coercedObj;
  }

  if (isLeafType(type)) {
    // Scalars and Enums fulfill parsing a literal value via parseLiteral().
    // Invalid values represent a failure to parse correctly, in which case
    // no value is returned.
    let result;

    try {
      result = type.parseLiteral(valueNode, variables);
    } catch (_error) {
      return; // Invalid: intentionally return no value.
    }

    if (result === undefined) {
      return; // Invalid: intentionally return no value.
    }

    return result;
  }
  /* c8 ignore next 3 */
  // Not reachable, all possible input types have been considered.

  invariant(false, 'Unexpected input type: ' + inspect$1(type));
} // Returns true if the provided valueNode is a variable which is not defined
// in the set of variables.

function isMissingVariable(valueNode, variables) {
  return (
    valueNode.kind === Kind.VARIABLE &&
    (variables == null || variables[valueNode.name.value] === undefined)
  );
}

/**
 * Prepares an object map of variableValues of the correct type based on the
 * provided variable definitions and arbitrary input. If the input cannot be
 * parsed to match the variable definitions, a GraphQLError will be thrown.
 *
 * Note: The returned value is a plain Object with a prototype, since it is
 * exposed to user code. Care should be taken to not pull values from the
 * Object prototype.
 */
function getVariableValues(schema, varDefNodes, inputs, options) {
  const errors = [];
  const maxErrors =
    options === null || options === void 0 ? void 0 : options.maxErrors;

  try {
    const coerced = coerceVariableValues(
      schema,
      varDefNodes,
      inputs,
      (error) => {
        if (maxErrors != null && errors.length >= maxErrors) {
          throw new GraphQLError(
            'Too many errors processing variables, error limit reached. Execution aborted.',
          );
        }

        errors.push(error);
      },
    );

    if (errors.length === 0) {
      return {
        coerced,
      };
    }
  } catch (error) {
    errors.push(error);
  }

  return {
    errors,
  };
}

function coerceVariableValues(schema, varDefNodes, inputs, onError) {
  const coercedValues = {};

  for (const varDefNode of varDefNodes) {
    const varName = varDefNode.variable.name.value;
    const varType = typeFromAST(schema, varDefNode.type);

    if (!isInputType(varType)) {
      // Must use input types for variables. This should be caught during
      // validation, however is checked again here for safety.
      const varTypeStr = print(varDefNode.type);
      onError(
        new GraphQLError(
          `Variable "$${varName}" expected value of type "${varTypeStr}" which cannot be used as an input type.`,
          {
            nodes: varDefNode.type,
          },
        ),
      );
      continue;
    }

    if (!hasOwnProperty(inputs, varName)) {
      if (varDefNode.defaultValue) {
        coercedValues[varName] = valueFromAST(varDefNode.defaultValue, varType);
      } else if (isNonNullType(varType)) {
        const varTypeStr = inspect$1(varType);
        onError(
          new GraphQLError(
            `Variable "$${varName}" of required type "${varTypeStr}" was not provided.`,
            {
              nodes: varDefNode,
            },
          ),
        );
      }

      continue;
    }

    const value = inputs[varName];

    if (value === null && isNonNullType(varType)) {
      const varTypeStr = inspect$1(varType);
      onError(
        new GraphQLError(
          `Variable "$${varName}" of non-null type "${varTypeStr}" must not be null.`,
          {
            nodes: varDefNode,
          },
        ),
      );
      continue;
    }

    coercedValues[varName] = coerceInputValue(
      value,
      varType,
      (path, invalidValue, error) => {
        let prefix =
          `Variable "$${varName}" got invalid value ` + inspect$1(invalidValue);

        if (path.length > 0) {
          prefix += ` at "${varName}${printPathArray(path)}"`;
        }

        onError(
          new GraphQLError(prefix + '; ' + error.message, {
            nodes: varDefNode,
            originalError: error,
          }),
        );
      },
    );
  }

  return coercedValues;
}
/**
 * Prepares an object map of argument values given a list of argument
 * definitions and list of argument AST nodes.
 *
 * Note: The returned value is a plain Object with a prototype, since it is
 * exposed to user code. Care should be taken to not pull values from the
 * Object prototype.
 */

function getArgumentValues(def, node, variableValues) {
  var _node$arguments;

  const coercedValues = {}; // FIXME: https://github.com/graphql/graphql-js/issues/2203

  /* c8 ignore next */

  const argumentNodes =
    (_node$arguments = node.arguments) !== null && _node$arguments !== void 0
      ? _node$arguments
      : [];
  const argNodeMap = keyMap(argumentNodes, (arg) => arg.name.value);

  for (const argDef of def.args) {
    const name = argDef.name;
    const argType = argDef.type;
    const argumentNode = argNodeMap[name];

    if (!argumentNode) {
      if (argDef.defaultValue !== undefined) {
        coercedValues[name] = argDef.defaultValue;
      } else if (isNonNullType(argType)) {
        throw new GraphQLError(
          `Argument "${name}" of required type "${inspect$1(argType)}" ` +
            'was not provided.',
          {
            nodes: node,
          },
        );
      }

      continue;
    }

    const valueNode = argumentNode.value;
    let isNull = valueNode.kind === Kind.NULL;

    if (valueNode.kind === Kind.VARIABLE) {
      const variableName = valueNode.name.value;

      if (
        variableValues == null ||
        !hasOwnProperty(variableValues, variableName)
      ) {
        if (argDef.defaultValue !== undefined) {
          coercedValues[name] = argDef.defaultValue;
        } else if (isNonNullType(argType)) {
          throw new GraphQLError(
            `Argument "${name}" of required type "${inspect$1(argType)}" ` +
              `was provided the variable "$${variableName}" which was not provided a runtime value.`,
            {
              nodes: valueNode,
            },
          );
        }

        continue;
      }

      isNull = variableValues[variableName] == null;
    }

    if (isNull && isNonNullType(argType)) {
      throw new GraphQLError(
        `Argument "${name}" of non-null type "${inspect$1(argType)}" ` +
          'must not be null.',
        {
          nodes: valueNode,
        },
      );
    }

    const coercedValue = valueFromAST(valueNode, argType, variableValues);

    if (coercedValue === undefined) {
      // Note: ValuesOfCorrectTypeRule validation should catch this before
      // execution. This is a runtime check to ensure execution does not
      // continue with an invalid argument value.
      throw new GraphQLError(
        `Argument "${name}" has invalid value ${print(valueNode)}.`,
        {
          nodes: valueNode,
        },
      );
    }

    coercedValues[name] = coercedValue;
  }

  return coercedValues;
}
/**
 * Prepares an object map of argument values given a directive definition
 * and a AST node which may contain directives. Optionally also accepts a map
 * of variable values.
 *
 * If the directive does not exist on the node, returns undefined.
 *
 * Note: The returned value is a plain Object with a prototype, since it is
 * exposed to user code. Care should be taken to not pull values from the
 * Object prototype.
 */

function getDirectiveValues(directiveDef, node, variableValues) {
  var _node$directives;

  const directiveNode =
    (_node$directives = node.directives) === null || _node$directives === void 0
      ? void 0
      : _node$directives.find(
          (directive) => directive.name.value === directiveDef.name,
        );

  if (directiveNode) {
    return getArgumentValues(directiveDef, directiveNode, variableValues);
  }
}

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}

/**
 * Given a selectionSet, collects all of the fields and returns them.
 *
 * CollectFields requires the "runtime type" of an object. For a field that
 * returns an Interface or Union type, the "runtime type" will be the actual
 * object type returned by that field.
 *
 * @internal
 */

function collectFields(
  schema,
  fragments,
  variableValues,
  runtimeType,
  selectionSet,
) {
  const fields = new Map();
  collectFieldsImpl(
    schema,
    fragments,
    variableValues,
    runtimeType,
    selectionSet,
    fields,
    new Set(),
  );
  return fields;
}
/**
 * Given an array of field nodes, collects all of the subfields of the passed
 * in fields, and returns them at the end.
 *
 * CollectSubFields requires the "return type" of an object. For a field that
 * returns an Interface or Union type, the "return type" will be the actual
 * object type returned by that field.
 *
 * @internal
 */

function collectSubfields$1(
  schema,
  fragments,
  variableValues,
  returnType,
  fieldNodes,
) {
  const subFieldNodes = new Map();
  const visitedFragmentNames = new Set();

  for (const node of fieldNodes) {
    if (node.selectionSet) {
      collectFieldsImpl(
        schema,
        fragments,
        variableValues,
        returnType,
        node.selectionSet,
        subFieldNodes,
        visitedFragmentNames,
      );
    }
  }

  return subFieldNodes;
}

function collectFieldsImpl(
  schema,
  fragments,
  variableValues,
  runtimeType,
  selectionSet,
  fields,
  visitedFragmentNames,
) {
  for (const selection of selectionSet.selections) {
    switch (selection.kind) {
      case Kind.FIELD: {
        if (!shouldIncludeNode(variableValues, selection)) {
          continue;
        }

        const name = getFieldEntryKey(selection);
        const fieldList = fields.get(name);

        if (fieldList !== undefined) {
          fieldList.push(selection);
        } else {
          fields.set(name, [selection]);
        }

        break;
      }

      case Kind.INLINE_FRAGMENT: {
        if (
          !shouldIncludeNode(variableValues, selection) ||
          !doesFragmentConditionMatch(schema, selection, runtimeType)
        ) {
          continue;
        }

        collectFieldsImpl(
          schema,
          fragments,
          variableValues,
          runtimeType,
          selection.selectionSet,
          fields,
          visitedFragmentNames,
        );
        break;
      }

      case Kind.FRAGMENT_SPREAD: {
        const fragName = selection.name.value;

        if (
          visitedFragmentNames.has(fragName) ||
          !shouldIncludeNode(variableValues, selection)
        ) {
          continue;
        }

        visitedFragmentNames.add(fragName);
        const fragment = fragments[fragName];

        if (
          !fragment ||
          !doesFragmentConditionMatch(schema, fragment, runtimeType)
        ) {
          continue;
        }

        collectFieldsImpl(
          schema,
          fragments,
          variableValues,
          runtimeType,
          fragment.selectionSet,
          fields,
          visitedFragmentNames,
        );
        break;
      }
    }
  }
}
/**
 * Determines if a field should be included based on the `@include` and `@skip`
 * directives, where `@skip` has higher precedence than `@include`.
 */

function shouldIncludeNode(variableValues, node) {
  const skip = getDirectiveValues(GraphQLSkipDirective, node, variableValues);

  if ((skip === null || skip === void 0 ? void 0 : skip.if) === true) {
    return false;
  }

  const include = getDirectiveValues(
    GraphQLIncludeDirective,
    node,
    variableValues,
  );

  if (
    (include === null || include === void 0 ? void 0 : include.if) === false
  ) {
    return false;
  }

  return true;
}
/**
 * Determines if a fragment is applicable to the given type.
 */

function doesFragmentConditionMatch(schema, fragment, type) {
  const typeConditionNode = fragment.typeCondition;

  if (!typeConditionNode) {
    return true;
  }

  const conditionalType = typeFromAST(schema, typeConditionNode);

  if (conditionalType === type) {
    return true;
  }

  if (isAbstractType(conditionalType)) {
    return schema.isSubType(conditionalType, type);
  }

  return false;
}
/**
 * Implements the logic to compute the key of a given field's entry
 */

function getFieldEntryKey(node) {
  return node.alias ? node.alias.value : node.name.value;
}

/**
 * Subscriptions must only include a non-introspection field.
 *
 * A GraphQL subscription is valid only if it contains a single root field and
 * that root field is not an introspection field.
 *
 * See https://spec.graphql.org/draft/#sec-Single-root-field
 */
function SingleFieldSubscriptionsRule(context) {
  return {
    OperationDefinition(node) {
      if (node.operation === 'subscription') {
        const schema = context.getSchema();
        const subscriptionType = schema.getSubscriptionType();

        if (subscriptionType) {
          const operationName = node.name ? node.name.value : null;
          const variableValues = Object.create(null);
          const document = context.getDocument();
          const fragments = Object.create(null);

          for (const definition of document.definitions) {
            if (definition.kind === Kind.FRAGMENT_DEFINITION) {
              fragments[definition.name.value] = definition;
            }
          }

          const fields = collectFields(
            schema,
            fragments,
            variableValues,
            subscriptionType,
            node.selectionSet,
          );

          if (fields.size > 1) {
            const fieldSelectionLists = [...fields.values()];
            const extraFieldSelectionLists = fieldSelectionLists.slice(1);
            const extraFieldSelections = extraFieldSelectionLists.flat();
            context.reportError(
              new GraphQLError(
                operationName != null
                  ? `Subscription "${operationName}" must select only one top level field.`
                  : 'Anonymous Subscription must select only one top level field.',
                {
                  nodes: extraFieldSelections,
                },
              ),
            );
          }

          for (const fieldNodes of fields.values()) {
            const field = fieldNodes[0];
            const fieldName = field.name.value;

            if (fieldName.startsWith('__')) {
              context.reportError(
                new GraphQLError(
                  operationName != null
                    ? `Subscription "${operationName}" must not select an introspection top level field.`
                    : 'Anonymous Subscription must not select an introspection top level field.',
                  {
                    nodes: fieldNodes,
                  },
                ),
              );
            }
          }
        }
      }
    },
  };
}

/**
 * Groups array items into a Map, given a function to produce grouping key.
 */
function groupBy(list, keyFn) {
  const result = new Map();

  for (const item of list) {
    const key = keyFn(item);
    const group = result.get(key);

    if (group === undefined) {
      result.set(key, [item]);
    } else {
      group.push(item);
    }
  }

  return result;
}

/**
 * Unique argument definition names
 *
 * A GraphQL Object or Interface type is only valid if all its fields have uniquely named arguments.
 * A GraphQL Directive is only valid if all its arguments are uniquely named.
 */
function UniqueArgumentDefinitionNamesRule(context) {
  return {
    DirectiveDefinition(directiveNode) {
      var _directiveNode$argume;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203

      /* c8 ignore next */
      const argumentNodes =
        (_directiveNode$argume = directiveNode.arguments) !== null &&
        _directiveNode$argume !== void 0
          ? _directiveNode$argume
          : [];
      return checkArgUniqueness(`@${directiveNode.name.value}`, argumentNodes);
    },

    InterfaceTypeDefinition: checkArgUniquenessPerField,
    InterfaceTypeExtension: checkArgUniquenessPerField,
    ObjectTypeDefinition: checkArgUniquenessPerField,
    ObjectTypeExtension: checkArgUniquenessPerField,
  };

  function checkArgUniquenessPerField(typeNode) {
    var _typeNode$fields;

    const typeName = typeNode.name.value; // FIXME: https://github.com/graphql/graphql-js/issues/2203

    /* c8 ignore next */

    const fieldNodes =
      (_typeNode$fields = typeNode.fields) !== null &&
      _typeNode$fields !== void 0
        ? _typeNode$fields
        : [];

    for (const fieldDef of fieldNodes) {
      var _fieldDef$arguments;

      const fieldName = fieldDef.name.value; // FIXME: https://github.com/graphql/graphql-js/issues/2203

      /* c8 ignore next */

      const argumentNodes =
        (_fieldDef$arguments = fieldDef.arguments) !== null &&
        _fieldDef$arguments !== void 0
          ? _fieldDef$arguments
          : [];
      checkArgUniqueness(`${typeName}.${fieldName}`, argumentNodes);
    }

    return false;
  }

  function checkArgUniqueness(parentName, argumentNodes) {
    const seenArgs = groupBy(argumentNodes, (arg) => arg.name.value);

    for (const [argName, argNodes] of seenArgs) {
      if (argNodes.length > 1) {
        context.reportError(
          new GraphQLError(
            `Argument "${parentName}(${argName}:)" can only be defined once.`,
            {
              nodes: argNodes.map((node) => node.name),
            },
          ),
        );
      }
    }

    return false;
  }
}

/**
 * Unique argument names
 *
 * A GraphQL field or directive is only valid if all supplied arguments are
 * uniquely named.
 *
 * See https://spec.graphql.org/draft/#sec-Argument-Names
 */
function UniqueArgumentNamesRule(context) {
  return {
    Field: checkArgUniqueness,
    Directive: checkArgUniqueness,
  };

  function checkArgUniqueness(parentNode) {
    var _parentNode$arguments;

    // FIXME: https://github.com/graphql/graphql-js/issues/2203

    /* c8 ignore next */
    const argumentNodes =
      (_parentNode$arguments = parentNode.arguments) !== null &&
      _parentNode$arguments !== void 0
        ? _parentNode$arguments
        : [];
    const seenArgs = groupBy(argumentNodes, (arg) => arg.name.value);

    for (const [argName, argNodes] of seenArgs) {
      if (argNodes.length > 1) {
        context.reportError(
          new GraphQLError(
            `There can be only one argument named "${argName}".`,
            {
              nodes: argNodes.map((node) => node.name),
            },
          ),
        );
      }
    }
  }
}

/**
 * Unique directive names
 *
 * A GraphQL document is only valid if all defined directives have unique names.
 */
function UniqueDirectiveNamesRule(context) {
  const knownDirectiveNames = Object.create(null);
  const schema = context.getSchema();
  return {
    DirectiveDefinition(node) {
      const directiveName = node.name.value;

      if (
        schema !== null &&
        schema !== void 0 &&
        schema.getDirective(directiveName)
      ) {
        context.reportError(
          new GraphQLError(
            `Directive "@${directiveName}" already exists in the schema. It cannot be redefined.`,
            {
              nodes: node.name,
            },
          ),
        );
        return;
      }

      if (knownDirectiveNames[directiveName]) {
        context.reportError(
          new GraphQLError(
            `There can be only one directive named "@${directiveName}".`,
            {
              nodes: [knownDirectiveNames[directiveName], node.name],
            },
          ),
        );
      } else {
        knownDirectiveNames[directiveName] = node.name;
      }

      return false;
    },
  };
}

/**
 * Unique directive names per location
 *
 * A GraphQL document is only valid if all non-repeatable directives at
 * a given location are uniquely named.
 *
 * See https://spec.graphql.org/draft/#sec-Directives-Are-Unique-Per-Location
 */
function UniqueDirectivesPerLocationRule(context) {
  const uniqueDirectiveMap = Object.create(null);
  const schema = context.getSchema();
  const definedDirectives = schema
    ? schema.getDirectives()
    : specifiedDirectives;

  for (const directive of definedDirectives) {
    uniqueDirectiveMap[directive.name] = !directive.isRepeatable;
  }

  const astDefinitions = context.getDocument().definitions;

  for (const def of astDefinitions) {
    if (def.kind === Kind.DIRECTIVE_DEFINITION) {
      uniqueDirectiveMap[def.name.value] = !def.repeatable;
    }
  }

  const schemaDirectives = Object.create(null);
  const typeDirectivesMap = Object.create(null);
  return {
    // Many different AST nodes may contain directives. Rather than listing
    // them all, just listen for entering any node, and check to see if it
    // defines any directives.
    enter(node) {
      if (!('directives' in node) || !node.directives) {
        return;
      }

      let seenDirectives;

      if (
        node.kind === Kind.SCHEMA_DEFINITION ||
        node.kind === Kind.SCHEMA_EXTENSION
      ) {
        seenDirectives = schemaDirectives;
      } else if (isTypeDefinitionNode(node) || isTypeExtensionNode(node)) {
        const typeName = node.name.value;
        seenDirectives = typeDirectivesMap[typeName];

        if (seenDirectives === undefined) {
          typeDirectivesMap[typeName] = seenDirectives = Object.create(null);
        }
      } else {
        seenDirectives = Object.create(null);
      }

      for (const directive of node.directives) {
        const directiveName = directive.name.value;

        if (uniqueDirectiveMap[directiveName]) {
          if (seenDirectives[directiveName]) {
            context.reportError(
              new GraphQLError(
                `The directive "@${directiveName}" can only be used once at this location.`,
                {
                  nodes: [seenDirectives[directiveName], directive],
                },
              ),
            );
          } else {
            seenDirectives[directiveName] = directive;
          }
        }
      }
    },
  };
}

/**
 * Unique enum value names
 *
 * A GraphQL enum type is only valid if all its values are uniquely named.
 */
function UniqueEnumValueNamesRule(context) {
  const schema = context.getSchema();
  const existingTypeMap = schema ? schema.getTypeMap() : Object.create(null);
  const knownValueNames = Object.create(null);
  return {
    EnumTypeDefinition: checkValueUniqueness,
    EnumTypeExtension: checkValueUniqueness,
  };

  function checkValueUniqueness(node) {
    var _node$values;

    const typeName = node.name.value;

    if (!knownValueNames[typeName]) {
      knownValueNames[typeName] = Object.create(null);
    } // FIXME: https://github.com/graphql/graphql-js/issues/2203

    /* c8 ignore next */

    const valueNodes =
      (_node$values = node.values) !== null && _node$values !== void 0
        ? _node$values
        : [];
    const valueNames = knownValueNames[typeName];

    for (const valueDef of valueNodes) {
      const valueName = valueDef.name.value;
      const existingType = existingTypeMap[typeName];

      if (isEnumType(existingType) && existingType.getValue(valueName)) {
        context.reportError(
          new GraphQLError(
            `Enum value "${typeName}.${valueName}" already exists in the schema. It cannot also be defined in this type extension.`,
            {
              nodes: valueDef.name,
            },
          ),
        );
      } else if (valueNames[valueName]) {
        context.reportError(
          new GraphQLError(
            `Enum value "${typeName}.${valueName}" can only be defined once.`,
            {
              nodes: [valueNames[valueName], valueDef.name],
            },
          ),
        );
      } else {
        valueNames[valueName] = valueDef.name;
      }
    }

    return false;
  }
}

/**
 * Unique field definition names
 *
 * A GraphQL complex type is only valid if all its fields are uniquely named.
 */
function UniqueFieldDefinitionNamesRule(context) {
  const schema = context.getSchema();
  const existingTypeMap = schema ? schema.getTypeMap() : Object.create(null);
  const knownFieldNames = Object.create(null);
  return {
    InputObjectTypeDefinition: checkFieldUniqueness,
    InputObjectTypeExtension: checkFieldUniqueness,
    InterfaceTypeDefinition: checkFieldUniqueness,
    InterfaceTypeExtension: checkFieldUniqueness,
    ObjectTypeDefinition: checkFieldUniqueness,
    ObjectTypeExtension: checkFieldUniqueness,
  };

  function checkFieldUniqueness(node) {
    var _node$fields;

    const typeName = node.name.value;

    if (!knownFieldNames[typeName]) {
      knownFieldNames[typeName] = Object.create(null);
    } // FIXME: https://github.com/graphql/graphql-js/issues/2203

    /* c8 ignore next */

    const fieldNodes =
      (_node$fields = node.fields) !== null && _node$fields !== void 0
        ? _node$fields
        : [];
    const fieldNames = knownFieldNames[typeName];

    for (const fieldDef of fieldNodes) {
      const fieldName = fieldDef.name.value;

      if (hasField(existingTypeMap[typeName], fieldName)) {
        context.reportError(
          new GraphQLError(
            `Field "${typeName}.${fieldName}" already exists in the schema. It cannot also be defined in this type extension.`,
            {
              nodes: fieldDef.name,
            },
          ),
        );
      } else if (fieldNames[fieldName]) {
        context.reportError(
          new GraphQLError(
            `Field "${typeName}.${fieldName}" can only be defined once.`,
            {
              nodes: [fieldNames[fieldName], fieldDef.name],
            },
          ),
        );
      } else {
        fieldNames[fieldName] = fieldDef.name;
      }
    }

    return false;
  }
}

function hasField(type, fieldName) {
  if (isObjectType(type) || isInterfaceType(type) || isInputObjectType(type)) {
    return type.getFields()[fieldName] != null;
  }

  return false;
}

/**
 * Unique fragment names
 *
 * A GraphQL document is only valid if all defined fragments have unique names.
 *
 * See https://spec.graphql.org/draft/#sec-Fragment-Name-Uniqueness
 */
function UniqueFragmentNamesRule(context) {
  const knownFragmentNames = Object.create(null);
  return {
    OperationDefinition: () => false,

    FragmentDefinition(node) {
      const fragmentName = node.name.value;

      if (knownFragmentNames[fragmentName]) {
        context.reportError(
          new GraphQLError(
            `There can be only one fragment named "${fragmentName}".`,
            {
              nodes: [knownFragmentNames[fragmentName], node.name],
            },
          ),
        );
      } else {
        knownFragmentNames[fragmentName] = node.name;
      }

      return false;
    },
  };
}

/**
 * Unique input field names
 *
 * A GraphQL input object value is only valid if all supplied fields are
 * uniquely named.
 *
 * See https://spec.graphql.org/draft/#sec-Input-Object-Field-Uniqueness
 */
function UniqueInputFieldNamesRule(context) {
  const knownNameStack = [];
  let knownNames = Object.create(null);
  return {
    ObjectValue: {
      enter() {
        knownNameStack.push(knownNames);
        knownNames = Object.create(null);
      },

      leave() {
        const prevKnownNames = knownNameStack.pop();
        prevKnownNames || invariant(false);
        knownNames = prevKnownNames;
      },
    },

    ObjectField(node) {
      const fieldName = node.name.value;

      if (knownNames[fieldName]) {
        context.reportError(
          new GraphQLError(
            `There can be only one input field named "${fieldName}".`,
            {
              nodes: [knownNames[fieldName], node.name],
            },
          ),
        );
      } else {
        knownNames[fieldName] = node.name;
      }
    },
  };
}

/**
 * Unique operation names
 *
 * A GraphQL document is only valid if all defined operations have unique names.
 *
 * See https://spec.graphql.org/draft/#sec-Operation-Name-Uniqueness
 */
function UniqueOperationNamesRule(context) {
  const knownOperationNames = Object.create(null);
  return {
    OperationDefinition(node) {
      const operationName = node.name;

      if (operationName) {
        if (knownOperationNames[operationName.value]) {
          context.reportError(
            new GraphQLError(
              `There can be only one operation named "${operationName.value}".`,
              {
                nodes: [
                  knownOperationNames[operationName.value],
                  operationName,
                ],
              },
            ),
          );
        } else {
          knownOperationNames[operationName.value] = operationName;
        }
      }

      return false;
    },

    FragmentDefinition: () => false,
  };
}

/**
 * Unique operation types
 *
 * A GraphQL document is only valid if it has only one type per operation.
 */
function UniqueOperationTypesRule(context) {
  const schema = context.getSchema();
  const definedOperationTypes = Object.create(null);
  const existingOperationTypes = schema
    ? {
        query: schema.getQueryType(),
        mutation: schema.getMutationType(),
        subscription: schema.getSubscriptionType(),
      }
    : {};
  return {
    SchemaDefinition: checkOperationTypes,
    SchemaExtension: checkOperationTypes,
  };

  function checkOperationTypes(node) {
    var _node$operationTypes;

    // See: https://github.com/graphql/graphql-js/issues/2203

    /* c8 ignore next */
    const operationTypesNodes =
      (_node$operationTypes = node.operationTypes) !== null &&
      _node$operationTypes !== void 0
        ? _node$operationTypes
        : [];

    for (const operationType of operationTypesNodes) {
      const operation = operationType.operation;
      const alreadyDefinedOperationType = definedOperationTypes[operation];

      if (existingOperationTypes[operation]) {
        context.reportError(
          new GraphQLError(
            `Type for ${operation} already defined in the schema. It cannot be redefined.`,
            {
              nodes: operationType,
            },
          ),
        );
      } else if (alreadyDefinedOperationType) {
        context.reportError(
          new GraphQLError(
            `There can be only one ${operation} type in schema.`,
            {
              nodes: [alreadyDefinedOperationType, operationType],
            },
          ),
        );
      } else {
        definedOperationTypes[operation] = operationType;
      }
    }

    return false;
  }
}

/**
 * Unique type names
 *
 * A GraphQL document is only valid if all defined types have unique names.
 */
function UniqueTypeNamesRule(context) {
  const knownTypeNames = Object.create(null);
  const schema = context.getSchema();
  return {
    ScalarTypeDefinition: checkTypeName,
    ObjectTypeDefinition: checkTypeName,
    InterfaceTypeDefinition: checkTypeName,
    UnionTypeDefinition: checkTypeName,
    EnumTypeDefinition: checkTypeName,
    InputObjectTypeDefinition: checkTypeName,
  };

  function checkTypeName(node) {
    const typeName = node.name.value;

    if (schema !== null && schema !== void 0 && schema.getType(typeName)) {
      context.reportError(
        new GraphQLError(
          `Type "${typeName}" already exists in the schema. It cannot also be defined in this type definition.`,
          {
            nodes: node.name,
          },
        ),
      );
      return;
    }

    if (knownTypeNames[typeName]) {
      context.reportError(
        new GraphQLError(`There can be only one type named "${typeName}".`, {
          nodes: [knownTypeNames[typeName], node.name],
        }),
      );
    } else {
      knownTypeNames[typeName] = node.name;
    }

    return false;
  }
}

/**
 * Unique variable names
 *
 * A GraphQL operation is only valid if all its variables are uniquely named.
 */
function UniqueVariableNamesRule(context) {
  return {
    OperationDefinition(operationNode) {
      var _operationNode$variab;

      // See: https://github.com/graphql/graphql-js/issues/2203

      /* c8 ignore next */
      const variableDefinitions =
        (_operationNode$variab = operationNode.variableDefinitions) !== null &&
        _operationNode$variab !== void 0
          ? _operationNode$variab
          : [];
      const seenVariableDefinitions = groupBy(
        variableDefinitions,
        (node) => node.variable.name.value,
      );

      for (const [variableName, variableNodes] of seenVariableDefinitions) {
        if (variableNodes.length > 1) {
          context.reportError(
            new GraphQLError(
              `There can be only one variable named "$${variableName}".`,
              {
                nodes: variableNodes.map((node) => node.variable.name),
              },
            ),
          );
        }
      }
    },
  };
}

/**
 * Value literals of correct type
 *
 * A GraphQL document is only valid if all value literals are of the type
 * expected at their position.
 *
 * See https://spec.graphql.org/draft/#sec-Values-of-Correct-Type
 */
function ValuesOfCorrectTypeRule(context) {
  let variableDefinitions = {};
  return {
    OperationDefinition: {
      enter() {
        variableDefinitions = {};
      },
    },

    VariableDefinition(definition) {
      variableDefinitions[definition.variable.name.value] = definition;
    },

    ListValue(node) {
      // Note: TypeInfo will traverse into a list's item type, so look to the
      // parent input type to check if it is a list.
      const type = getNullableType(context.getParentInputType());

      if (!isListType(type)) {
        isValidValueNode(context, node);
        return false; // Don't traverse further.
      }
    },

    ObjectValue(node) {
      const type = getNamedType(context.getInputType());

      if (!isInputObjectType(type)) {
        isValidValueNode(context, node);
        return false; // Don't traverse further.
      } // Ensure every required field exists.

      const fieldNodeMap = keyMap(node.fields, (field) => field.name.value);

      for (const fieldDef of Object.values(type.getFields())) {
        const fieldNode = fieldNodeMap[fieldDef.name];

        if (!fieldNode && isRequiredInputField(fieldDef)) {
          const typeStr = inspect$1(fieldDef.type);
          context.reportError(
            new GraphQLError(
              `Field "${type.name}.${fieldDef.name}" of required type "${typeStr}" was not provided.`,
              {
                nodes: node,
              },
            ),
          );
        }
      }

      if (type.isOneOf) {
        validateOneOfInputObject(
          context,
          node,
          type,
          fieldNodeMap,
          variableDefinitions,
        );
      }
    },

    ObjectField(node) {
      const parentType = getNamedType(context.getParentInputType());
      const fieldType = context.getInputType();

      if (!fieldType && isInputObjectType(parentType)) {
        const suggestions = suggestionList(
          node.name.value,
          Object.keys(parentType.getFields()),
        );
        context.reportError(
          new GraphQLError(
            `Field "${node.name.value}" is not defined by type "${parentType.name}".` +
              didYouMean(suggestions),
            {
              nodes: node,
            },
          ),
        );
      }
    },

    NullValue(node) {
      const type = context.getInputType();

      if (isNonNullType(type)) {
        context.reportError(
          new GraphQLError(
            `Expected value of type "${inspect$1(type)}", found ${print(node)}.`,
            {
              nodes: node,
            },
          ),
        );
      }
    },

    EnumValue: (node) => isValidValueNode(context, node),
    IntValue: (node) => isValidValueNode(context, node),
    FloatValue: (node) => isValidValueNode(context, node),
    StringValue: (node) => isValidValueNode(context, node),
    BooleanValue: (node) => isValidValueNode(context, node),
  };
}
/**
 * Any value literal may be a valid representation of a Scalar, depending on
 * that scalar type.
 */

function isValidValueNode(context, node) {
  // Report any error at the full type expected by the location.
  const locationType = context.getInputType();

  if (!locationType) {
    return;
  }

  const type = getNamedType(locationType);

  if (!isLeafType(type)) {
    const typeStr = inspect$1(locationType);
    context.reportError(
      new GraphQLError(
        `Expected value of type "${typeStr}", found ${print(node)}.`,
        {
          nodes: node,
        },
      ),
    );
    return;
  } // Scalars and Enums determine if a literal value is valid via parseLiteral(),
  // which may throw or return an invalid value to indicate failure.

  try {
    const parseResult = type.parseLiteral(
      node,
      undefined,
      /* variables */
    );

    if (parseResult === undefined) {
      const typeStr = inspect$1(locationType);
      context.reportError(
        new GraphQLError(
          `Expected value of type "${typeStr}", found ${print(node)}.`,
          {
            nodes: node,
          },
        ),
      );
    }
  } catch (error) {
    const typeStr = inspect$1(locationType);

    if (error instanceof GraphQLError) {
      context.reportError(error);
    } else {
      context.reportError(
        new GraphQLError(
          `Expected value of type "${typeStr}", found ${print(node)}; ` +
            error.message,
          {
            nodes: node,
            originalError: error,
          },
        ),
      );
    }
  }
}

function validateOneOfInputObject(
  context,
  node,
  type,
  fieldNodeMap,
  variableDefinitions,
) {
  var _fieldNodeMap$keys$;

  const keys = Object.keys(fieldNodeMap);
  const isNotExactlyOneField = keys.length !== 1;

  if (isNotExactlyOneField) {
    context.reportError(
      new GraphQLError(
        `OneOf Input Object "${type.name}" must specify exactly one key.`,
        {
          nodes: [node],
        },
      ),
    );
    return;
  }

  const value =
    (_fieldNodeMap$keys$ = fieldNodeMap[keys[0]]) === null ||
    _fieldNodeMap$keys$ === void 0
      ? void 0
      : _fieldNodeMap$keys$.value;
  const isNullLiteral = !value || value.kind === Kind.NULL;
  const isVariable =
    (value === null || value === void 0 ? void 0 : value.kind) ===
    Kind.VARIABLE;

  if (isNullLiteral) {
    context.reportError(
      new GraphQLError(`Field "${type.name}.${keys[0]}" must be non-null.`, {
        nodes: [node],
      }),
    );
    return;
  }

  if (isVariable) {
    const variableName = value.name.value;
    const definition = variableDefinitions[variableName];
    const isNullableVariable = definition.type.kind !== Kind.NON_NULL_TYPE;

    if (isNullableVariable) {
      context.reportError(
        new GraphQLError(
          `Variable "${variableName}" must be non-nullable to be used for OneOf Input Object "${type.name}".`,
          {
            nodes: [node],
          },
        ),
      );
    }
  }
}

/**
 * Variables are input types
 *
 * A GraphQL operation is only valid if all the variables it defines are of
 * input types (scalar, enum, or input object).
 *
 * See https://spec.graphql.org/draft/#sec-Variables-Are-Input-Types
 */
function VariablesAreInputTypesRule(context) {
  return {
    VariableDefinition(node) {
      const type = typeFromAST(context.getSchema(), node.type);

      if (type !== undefined && !isInputType(type)) {
        const variableName = node.variable.name.value;
        const typeName = print(node.type);
        context.reportError(
          new GraphQLError(
            `Variable "$${variableName}" cannot be non-input type "${typeName}".`,
            {
              nodes: node.type,
            },
          ),
        );
      }
    },
  };
}

/**
 * Variables in allowed position
 *
 * Variable usages must be compatible with the arguments they are passed to.
 *
 * See https://spec.graphql.org/draft/#sec-All-Variable-Usages-are-Allowed
 */
function VariablesInAllowedPositionRule(context) {
  let varDefMap = Object.create(null);
  return {
    OperationDefinition: {
      enter() {
        varDefMap = Object.create(null);
      },

      leave(operation) {
        const usages = context.getRecursiveVariableUsages(operation);

        for (const { node, type, defaultValue } of usages) {
          const varName = node.name.value;
          const varDef = varDefMap[varName];

          if (varDef && type) {
            // A var type is allowed if it is the same or more strict (e.g. is
            // a subtype of) than the expected type. It can be more strict if
            // the variable type is non-null when the expected type is nullable.
            // If both are list types, the variable item type can be more strict
            // than the expected item type (contravariant).
            const schema = context.getSchema();
            const varType = typeFromAST(schema, varDef.type);

            if (
              varType &&
              !allowedVariableUsage(
                schema,
                varType,
                varDef.defaultValue,
                type,
                defaultValue,
              )
            ) {
              const varTypeStr = inspect$1(varType);
              const typeStr = inspect$1(type);
              context.reportError(
                new GraphQLError(
                  `Variable "$${varName}" of type "${varTypeStr}" used in position expecting type "${typeStr}".`,
                  {
                    nodes: [varDef, node],
                  },
                ),
              );
            }
          }
        }
      },
    },

    VariableDefinition(node) {
      varDefMap[node.variable.name.value] = node;
    },
  };
}
/**
 * Returns true if the variable is allowed in the location it was found,
 * which includes considering if default values exist for either the variable
 * or the location at which it is located.
 */

function allowedVariableUsage(
  schema,
  varType,
  varDefaultValue,
  locationType,
  locationDefaultValue,
) {
  if (isNonNullType(locationType) && !isNonNullType(varType)) {
    const hasNonNullVariableDefaultValue =
      varDefaultValue != null && varDefaultValue.kind !== Kind.NULL;
    const hasLocationDefaultValue = locationDefaultValue !== undefined;

    if (!hasNonNullVariableDefaultValue && !hasLocationDefaultValue) {
      return false;
    }

    const nullableLocationType = locationType.ofType;
    return isTypeSubTypeOf(schema, varType, nullableLocationType);
  }

  return isTypeSubTypeOf(schema, varType, locationType);
}

// Spec Section: "Executable Definitions"

/**
 * Technically these aren't part of the spec but they are strongly encouraged
 * validation rules.
 */
const recommendedRules = Object.freeze([MaxIntrospectionDepthRule]);
/**
 * This set includes all validation rules defined by the GraphQL spec.
 *
 * The order of the rules in this list has been adjusted to lead to the
 * most clear output when encountering multiple validation errors.
 */

Object.freeze([
  ExecutableDefinitionsRule,
  UniqueOperationNamesRule,
  LoneAnonymousOperationRule,
  SingleFieldSubscriptionsRule,
  KnownTypeNamesRule,
  FragmentsOnCompositeTypesRule,
  VariablesAreInputTypesRule,
  ScalarLeafsRule,
  FieldsOnCorrectTypeRule,
  UniqueFragmentNamesRule,
  KnownFragmentNamesRule,
  NoUnusedFragmentsRule,
  PossibleFragmentSpreadsRule,
  NoFragmentCyclesRule,
  UniqueVariableNamesRule,
  NoUndefinedVariablesRule,
  NoUnusedVariablesRule,
  KnownDirectivesRule,
  UniqueDirectivesPerLocationRule,
  KnownArgumentNamesRule,
  UniqueArgumentNamesRule,
  ValuesOfCorrectTypeRule,
  ProvidedRequiredArgumentsRule,
  VariablesInAllowedPositionRule,
  OverlappingFieldsCanBeMergedRule,
  UniqueInputFieldNamesRule,
  ...recommendedRules,
]);
/**
 * @internal
 */

const specifiedSDLRules = Object.freeze([
  LoneSchemaDefinitionRule,
  UniqueOperationTypesRule,
  UniqueTypeNamesRule,
  UniqueEnumValueNamesRule,
  UniqueFieldDefinitionNamesRule,
  UniqueArgumentDefinitionNamesRule,
  UniqueDirectiveNamesRule,
  KnownTypeNamesRule,
  KnownDirectivesRule,
  UniqueDirectivesPerLocationRule,
  PossibleTypeExtensionsRule,
  KnownArgumentNamesOnDirectivesRule,
  UniqueArgumentNamesRule,
  UniqueInputFieldNamesRule,
  ProvidedRequiredArgumentsOnDirectivesRule,
]);

/**
 * An instance of this class is passed as the "this" context to all validators,
 * allowing access to commonly useful contextual information from within a
 * validation rule.
 */
class ASTValidationContext {
  constructor(ast, onError) {
    this._ast = ast;
    this._fragments = undefined;
    this._fragmentSpreads = new Map();
    this._recursivelyReferencedFragments = new Map();
    this._onError = onError;
  }

  get [Symbol.toStringTag]() {
    return 'ASTValidationContext';
  }

  reportError(error) {
    this._onError(error);
  }

  getDocument() {
    return this._ast;
  }

  getFragment(name) {
    let fragments;

    if (this._fragments) {
      fragments = this._fragments;
    } else {
      fragments = Object.create(null);

      for (const defNode of this.getDocument().definitions) {
        if (defNode.kind === Kind.FRAGMENT_DEFINITION) {
          fragments[defNode.name.value] = defNode;
        }
      }

      this._fragments = fragments;
    }

    return fragments[name];
  }

  getFragmentSpreads(node) {
    let spreads = this._fragmentSpreads.get(node);

    if (!spreads) {
      spreads = [];
      const setsToVisit = [node];
      let set;

      while ((set = setsToVisit.pop())) {
        for (const selection of set.selections) {
          if (selection.kind === Kind.FRAGMENT_SPREAD) {
            spreads.push(selection);
          } else if (selection.selectionSet) {
            setsToVisit.push(selection.selectionSet);
          }
        }
      }

      this._fragmentSpreads.set(node, spreads);
    }

    return spreads;
  }

  getRecursivelyReferencedFragments(operation) {
    let fragments = this._recursivelyReferencedFragments.get(operation);

    if (!fragments) {
      fragments = [];
      const collectedNames = Object.create(null);
      const nodesToVisit = [operation.selectionSet];
      let node;

      while ((node = nodesToVisit.pop())) {
        for (const spread of this.getFragmentSpreads(node)) {
          const fragName = spread.name.value;

          if (collectedNames[fragName] !== true) {
            collectedNames[fragName] = true;
            const fragment = this.getFragment(fragName);

            if (fragment) {
              fragments.push(fragment);
              nodesToVisit.push(fragment.selectionSet);
            }
          }
        }
      }

      this._recursivelyReferencedFragments.set(operation, fragments);
    }

    return fragments;
  }
}
class SDLValidationContext extends ASTValidationContext {
  constructor(ast, schema, onError) {
    super(ast, onError);
    this._schema = schema;
  }

  get [Symbol.toStringTag]() {
    return 'SDLValidationContext';
  }

  getSchema() {
    return this._schema;
  }
}

/**
 * @internal
 */

function validateSDL(
  documentAST,
  schemaToExtend,
  rules = specifiedSDLRules,
) {
  const errors = [];
  const context = new SDLValidationContext(
    documentAST,
    schemaToExtend,
    (error) => {
      errors.push(error);
    },
  );
  const visitors = rules.map((rule) => rule(context));
  visit(documentAST, visitInParallel(visitors));
  return errors;
}
/**
 * Utility function which asserts a SDL document is valid by throwing an error
 * if it is invalid.
 *
 * @internal
 */

function assertValidSDL(documentAST) {
  const errors = validateSDL(documentAST);

  if (errors.length !== 0) {
    throw new Error(errors.map((error) => error.message).join('\n\n'));
  }
}

/**
 * Memoizes the provided three-argument function.
 */
function memoize3(fn) {
  let cache0;
  return function memoized(a1, a2, a3) {
    if (cache0 === undefined) {
      cache0 = new WeakMap();
    }

    let cache1 = cache0.get(a1);

    if (cache1 === undefined) {
      cache1 = new WeakMap();
      cache0.set(a1, cache1);
    }

    let cache2 = cache1.get(a2);

    if (cache2 === undefined) {
      cache2 = new WeakMap();
      cache1.set(a2, cache2);
    }

    let fnResult = cache2.get(a3);

    if (fnResult === undefined) {
      fnResult = fn(a1, a2, a3);
      cache2.set(a3, fnResult);
    }

    return fnResult;
  };
}

/**
 * This function transforms a JS object `ObjMap<Promise<T>>` into
 * a `Promise<ObjMap<T>>`
 *
 * This is akin to bluebird's `Promise.props`, but implemented only using
 * `Promise.all` so it will work with any implementation of ES6 promises.
 */
function promiseForObject(object) {
  return Promise.all(Object.values(object)).then((resolvedValues) => {
    const resolvedObject = Object.create(null);

    for (const [i, key] of Object.keys(object).entries()) {
      resolvedObject[key] = resolvedValues[i];
    }

    return resolvedObject;
  });
}

/**
 * Similar to Array.prototype.reduce(), however the reducing callback may return
 * a Promise, in which case reduction will continue after each promise resolves.
 *
 * If the callback does not return a Promise, then this function will also not
 * return a Promise.
 */
function promiseReduce(values, callbackFn, initialValue) {
  let accumulator = initialValue;

  for (const value of values) {
    accumulator = isPromise(accumulator)
      ? accumulator.then((resolved) => callbackFn(resolved, value))
      : callbackFn(accumulator, value);
  }

  return accumulator;
}

/**
 * Sometimes a non-error is thrown, wrap it as an Error instance to ensure a consistent Error interface.
 */

function toError(thrownValue) {
  return thrownValue instanceof Error
    ? thrownValue
    : new NonErrorThrown(thrownValue);
}

class NonErrorThrown extends Error {
  constructor(thrownValue) {
    super('Unexpected error value: ' + inspect$1(thrownValue));
    this.name = 'NonErrorThrown';
    this.thrownValue = thrownValue;
  }
}

/**
 * Given an arbitrary value, presumably thrown while attempting to execute a
 * GraphQL operation, produce a new GraphQLError aware of the location in the
 * document responsible for the original Error.
 */

function locatedError(rawOriginalError, nodes, path) {
  var _nodes;

  const originalError = toError(rawOriginalError); // Note: this uses a brand-check to support GraphQL errors originating from other contexts.

  if (isLocatedGraphQLError(originalError)) {
    return originalError;
  }

  return new GraphQLError(originalError.message, {
    nodes:
      (_nodes = originalError.nodes) !== null && _nodes !== void 0
        ? _nodes
        : nodes,
    source: originalError.source,
    positions: originalError.positions,
    path,
    originalError,
  });
}

function isLocatedGraphQLError(error) {
  return Array.isArray(error.path);
}

/**
 * A memoized collection of relevant subfields with regard to the return
 * type. Memoizing ensures the subfields are not repeatedly calculated, which
 * saves overhead when resolving lists of values.
 */

const collectSubfields = memoize3((exeContext, returnType, fieldNodes) =>
  collectSubfields$1(
    exeContext.schema,
    exeContext.fragments,
    exeContext.variableValues,
    returnType,
    fieldNodes,
  ),
);
/**
 * Terminology
 *
 * "Definitions" are the generic name for top-level statements in the document.
 * Examples of this include:
 * 1) Operations (such as a query)
 * 2) Fragments
 *
 * "Operations" are a generic name for requests in the document.
 * Examples of this include:
 * 1) query,
 * 2) mutation
 *
 * "Selections" are the definitions that can appear legally and at
 * single level of the query. These include:
 * 1) field references e.g `a`
 * 2) fragment "spreads" e.g. `...c`
 * 3) inline fragment "spreads" e.g. `...on Type { a }`
 */

/**
 * Data that must be available at all points during query execution.
 *
 * Namely, schema of the type system that is currently executing,
 * and the fragments defined in the query document
 */

/**
 * Implements the "Executing requests" section of the GraphQL specification.
 *
 * Returns either a synchronous ExecutionResult (if all encountered resolvers
 * are synchronous), or a Promise of an ExecutionResult that will eventually be
 * resolved and never rejected.
 *
 * If the arguments to this function do not result in a legal execution context,
 * a GraphQLError will be thrown immediately explaining the invalid input.
 */
function execute(args) {
  // Temporary for v15 to v16 migration. Remove in v17
  arguments.length < 2 ||
    devAssert(
      false,
      'graphql@16 dropped long-deprecated support for positional arguments, please pass an object instead.',
    );
  const { schema, document, variableValues, rootValue } = args; // If arguments are missing or incorrect, throw an error.

  assertValidExecutionArguments(schema, document, variableValues); // If a valid execution context cannot be created due to incorrect arguments,
  // a "Response" with only errors is returned.

  const exeContext = buildExecutionContext(args); // Return early errors if execution context failed.

  if (!('schema' in exeContext)) {
    return {
      errors: exeContext,
    };
  } // Return a Promise that will eventually resolve to the data described by
  // The "Response" section of the GraphQL specification.
  //
  // If errors are encountered while executing a GraphQL field, only that
  // field and its descendants will be omitted, and sibling fields will still
  // be executed. An execution which encounters errors will still result in a
  // resolved Promise.
  //
  // Errors from sub-fields of a NonNull type may propagate to the top level,
  // at which point we still log the error and null the parent field, which
  // in this case is the entire response.

  try {
    const { operation } = exeContext;
    const result = executeOperation(exeContext, operation, rootValue);

    if (isPromise(result)) {
      return result.then(
        (data) => buildResponse(data, exeContext.errors),
        (error) => {
          exeContext.errors.push(error);
          return buildResponse(null, exeContext.errors);
        },
      );
    }

    return buildResponse(result, exeContext.errors);
  } catch (error) {
    exeContext.errors.push(error);
    return buildResponse(null, exeContext.errors);
  }
}
/**
 * Given a completed execution context and data, build the `{ errors, data }`
 * response defined by the "Response" section of the GraphQL specification.
 */

function buildResponse(data, errors) {
  return errors.length === 0
    ? {
        data,
      }
    : {
        errors,
        data,
      };
}
/**
 * Essential assertions before executing to provide developer feedback for
 * improper use of the GraphQL library.
 *
 * @internal
 */

function assertValidExecutionArguments(
  schema,
  document,
  rawVariableValues,
) {
  document || devAssert(false, 'Must provide document.'); // If the schema used for execution is invalid, throw an error.

  assertValidSchema(schema); // Variables, if provided, must be an object.

  rawVariableValues == null ||
    isObjectLike$1(rawVariableValues) ||
    devAssert(
      false,
      'Variables must be provided as an Object where each property is a variable value. Perhaps look to see if an unparsed JSON string was provided.',
    );
}
/**
 * Constructs a ExecutionContext object from the arguments passed to
 * execute, which we will pass throughout the other execution methods.
 *
 * Throws a GraphQLError if a valid execution context cannot be created.
 *
 * @internal
 */

function buildExecutionContext(args) {
  var _definition$name, _operation$variableDe;

  const {
    schema,
    document,
    rootValue,
    contextValue,
    variableValues: rawVariableValues,
    operationName,
    fieldResolver,
    typeResolver,
    subscribeFieldResolver,
  } = args;
  let operation;
  const fragments = Object.create(null);

  for (const definition of document.definitions) {
    switch (definition.kind) {
      case Kind.OPERATION_DEFINITION:
        if (operationName == null) {
          if (operation !== undefined) {
            return [
              new GraphQLError(
                'Must provide operation name if query contains multiple operations.',
              ),
            ];
          }

          operation = definition;
        } else if (
          ((_definition$name = definition.name) === null ||
          _definition$name === void 0
            ? void 0
            : _definition$name.value) === operationName
        ) {
          operation = definition;
        }

        break;

      case Kind.FRAGMENT_DEFINITION:
        fragments[definition.name.value] = definition;
        break;
    }
  }

  if (!operation) {
    if (operationName != null) {
      return [new GraphQLError(`Unknown operation named "${operationName}".`)];
    }

    return [new GraphQLError('Must provide an operation.')];
  } // FIXME: https://github.com/graphql/graphql-js/issues/2203

  /* c8 ignore next */

  const variableDefinitions =
    (_operation$variableDe = operation.variableDefinitions) !== null &&
    _operation$variableDe !== void 0
      ? _operation$variableDe
      : [];
  const coercedVariableValues = getVariableValues(
    schema,
    variableDefinitions,
    rawVariableValues !== null && rawVariableValues !== void 0
      ? rawVariableValues
      : {},
    {
      maxErrors: 50,
    },
  );

  if (coercedVariableValues.errors) {
    return coercedVariableValues.errors;
  }

  return {
    schema,
    fragments,
    rootValue,
    contextValue,
    operation,
    variableValues: coercedVariableValues.coerced,
    fieldResolver:
      fieldResolver !== null && fieldResolver !== void 0
        ? fieldResolver
        : defaultFieldResolver,
    typeResolver:
      typeResolver !== null && typeResolver !== void 0
        ? typeResolver
        : defaultTypeResolver,
    subscribeFieldResolver:
      subscribeFieldResolver !== null && subscribeFieldResolver !== void 0
        ? subscribeFieldResolver
        : defaultFieldResolver,
    errors: [],
  };
}
/**
 * Implements the "Executing operations" section of the spec.
 */

function executeOperation(exeContext, operation, rootValue) {
  const rootType = exeContext.schema.getRootType(operation.operation);

  if (rootType == null) {
    throw new GraphQLError(
      `Schema is not configured to execute ${operation.operation} operation.`,
      {
        nodes: operation,
      },
    );
  }

  const rootFields = collectFields(
    exeContext.schema,
    exeContext.fragments,
    exeContext.variableValues,
    rootType,
    operation.selectionSet,
  );
  const path = undefined;

  switch (operation.operation) {
    case OperationTypeNode$1.QUERY:
      return executeFields(exeContext, rootType, rootValue, path, rootFields);

    case OperationTypeNode$1.MUTATION:
      return executeFieldsSerially(
        exeContext,
        rootType,
        rootValue,
        path,
        rootFields,
      );

    case OperationTypeNode$1.SUBSCRIPTION:
      // TODO: deprecate `subscribe` and move all logic here
      // Temporary solution until we finish merging execute and subscribe together
      return executeFields(exeContext, rootType, rootValue, path, rootFields);
  }
}
/**
 * Implements the "Executing selection sets" section of the spec
 * for fields that must be executed serially.
 */

function executeFieldsSerially(
  exeContext,
  parentType,
  sourceValue,
  path,
  fields,
) {
  return promiseReduce(
    fields.entries(),
    (results, [responseName, fieldNodes]) => {
      const fieldPath = addPath(path, responseName, parentType.name);
      const result = executeField(
        exeContext,
        parentType,
        sourceValue,
        fieldNodes,
        fieldPath,
      );

      if (result === undefined) {
        return results;
      }

      if (isPromise(result)) {
        return result.then((resolvedResult) => {
          results[responseName] = resolvedResult;
          return results;
        });
      }

      results[responseName] = result;
      return results;
    },
    Object.create(null),
  );
}
/**
 * Implements the "Executing selection sets" section of the spec
 * for fields that may be executed in parallel.
 */

function executeFields(exeContext, parentType, sourceValue, path, fields) {
  const results = Object.create(null);
  let containsPromise = false;

  try {
    for (const [responseName, fieldNodes] of fields.entries()) {
      const fieldPath = addPath(path, responseName, parentType.name);
      const result = executeField(
        exeContext,
        parentType,
        sourceValue,
        fieldNodes,
        fieldPath,
      );

      if (result !== undefined) {
        results[responseName] = result;

        if (isPromise(result)) {
          containsPromise = true;
        }
      }
    }
  } catch (error) {
    if (containsPromise) {
      // Ensure that any promises returned by other fields are handled, as they may also reject.
      return promiseForObject(results).finally(() => {
        throw error;
      });
    }

    throw error;
  } // If there are no promises, we can just return the object

  if (!containsPromise) {
    return results;
  } // Otherwise, results is a map from field name to the result of resolving that
  // field, which is possibly a promise. Return a promise that will return this
  // same map, but with any promises replaced with the values they resolved to.

  return promiseForObject(results);
}
/**
 * Implements the "Executing fields" section of the spec
 * In particular, this function figures out the value that the field returns by
 * calling its resolve function, then calls completeValue to complete promises,
 * serialize scalars, or execute the sub-selection-set for objects.
 */

function executeField(exeContext, parentType, source, fieldNodes, path) {
  var _fieldDef$resolve;

  const fieldDef = getFieldDef(exeContext.schema, parentType, fieldNodes[0]);

  if (!fieldDef) {
    return;
  }

  const returnType = fieldDef.type;
  const resolveFn =
    (_fieldDef$resolve = fieldDef.resolve) !== null &&
    _fieldDef$resolve !== void 0
      ? _fieldDef$resolve
      : exeContext.fieldResolver;
  const info = buildResolveInfo(
    exeContext,
    fieldDef,
    fieldNodes,
    parentType,
    path,
  ); // Get the resolve function, regardless of if its result is normal or abrupt (error).

  try {
    // Build a JS object of arguments from the field.arguments AST, using the
    // variables scope to fulfill any variable references.
    // TODO: find a way to memoize, in case this field is within a List type.
    const args = getArgumentValues(
      fieldDef,
      fieldNodes[0],
      exeContext.variableValues,
    ); // The resolve function's optional third argument is a context value that
    // is provided to every resolve function within an execution. It is commonly
    // used to represent an authenticated user, or request-specific caches.

    const contextValue = exeContext.contextValue;
    const result = resolveFn(source, args, contextValue, info);
    let completed;

    if (isPromise(result)) {
      completed = result.then((resolved) =>
        completeValue(exeContext, returnType, fieldNodes, info, path, resolved),
      );
    } else {
      completed = completeValue(
        exeContext,
        returnType,
        fieldNodes,
        info,
        path,
        result,
      );
    }

    if (isPromise(completed)) {
      // Note: we don't rely on a `catch` method, but we do expect "thenable"
      // to take a second callback for the error case.
      return completed.then(undefined, (rawError) => {
        const error = locatedError(rawError, fieldNodes, pathToArray(path));
        return handleFieldError(error, returnType, exeContext);
      });
    }

    return completed;
  } catch (rawError) {
    const error = locatedError(rawError, fieldNodes, pathToArray(path));
    return handleFieldError(error, returnType, exeContext);
  }
}
/**
 * @internal
 */

function buildResolveInfo(
  exeContext,
  fieldDef,
  fieldNodes,
  parentType,
  path,
) {
  // The resolve function's optional fourth argument is a collection of
  // information about the current execution state.
  return {
    fieldName: fieldDef.name,
    fieldNodes,
    returnType: fieldDef.type,
    parentType,
    path,
    schema: exeContext.schema,
    fragments: exeContext.fragments,
    rootValue: exeContext.rootValue,
    operation: exeContext.operation,
    variableValues: exeContext.variableValues,
  };
}

function handleFieldError(error, returnType, exeContext) {
  // If the field type is non-nullable, then it is resolved without any
  // protection from errors, however it still properly locates the error.
  if (isNonNullType(returnType)) {
    throw error;
  } // Otherwise, error protection is applied, logging the error and resolving
  // a null value for this field if one is encountered.

  exeContext.errors.push(error);
  return null;
}
/**
 * Implements the instructions for completeValue as defined in the
 * "Value Completion" section of the spec.
 *
 * If the field type is Non-Null, then this recursively completes the value
 * for the inner type. It throws a field error if that completion returns null,
 * as per the "Nullability" section of the spec.
 *
 * If the field type is a List, then this recursively completes the value
 * for the inner type on each item in the list.
 *
 * If the field type is a Scalar or Enum, ensures the completed value is a legal
 * value of the type by calling the `serialize` method of GraphQL type
 * definition.
 *
 * If the field is an abstract type, determine the runtime type of the value
 * and then complete based on that type
 *
 * Otherwise, the field type expects a sub-selection set, and will complete the
 * value by executing all sub-selections.
 */

function completeValue(exeContext, returnType, fieldNodes, info, path, result) {
  // If result is an Error, throw a located error.
  if (result instanceof Error) {
    throw result;
  } // If field type is NonNull, complete for inner type, and throw field error
  // if result is null.

  if (isNonNullType(returnType)) {
    const completed = completeValue(
      exeContext,
      returnType.ofType,
      fieldNodes,
      info,
      path,
      result,
    );

    if (completed === null) {
      throw new Error(
        `Cannot return null for non-nullable field ${info.parentType.name}.${info.fieldName}.`,
      );
    }

    return completed;
  } // If result value is null or undefined then return null.

  if (result == null) {
    return null;
  } // If field type is List, complete each item in the list with the inner type

  if (isListType(returnType)) {
    return completeListValue(
      exeContext,
      returnType,
      fieldNodes,
      info,
      path,
      result,
    );
  } // If field type is a leaf type, Scalar or Enum, serialize to a valid value,
  // returning null if serialization is not possible.

  if (isLeafType(returnType)) {
    return completeLeafValue(returnType, result);
  } // If field type is an abstract type, Interface or Union, determine the
  // runtime Object type and complete for that type.

  if (isAbstractType(returnType)) {
    return completeAbstractValue(
      exeContext,
      returnType,
      fieldNodes,
      info,
      path,
      result,
    );
  } // If field type is Object, execute and complete all sub-selections.

  if (isObjectType(returnType)) {
    return completeObjectValue(
      exeContext,
      returnType,
      fieldNodes,
      info,
      path,
      result,
    );
  }
  /* c8 ignore next 6 */
  // Not reachable, all possible output types have been considered.

  invariant(
      false,
      'Cannot complete value of unexpected output type: ' + inspect$1(returnType),
    );
}
/**
 * Complete a list value by completing each item in the list with the
 * inner type
 */

function completeListValue(
  exeContext,
  returnType,
  fieldNodes,
  info,
  path,
  result,
) {
  if (!isIterableObject$1(result)) {
    throw new GraphQLError(
      `Expected Iterable, but did not find one for field "${info.parentType.name}.${info.fieldName}".`,
    );
  } // This is specified as a simple map, however we're optimizing the path
  // where the list contains no Promises by avoiding creating another Promise.

  const itemType = returnType.ofType;
  let containsPromise = false;
  const completedResults = Array.from(result, (item, index) => {
    // No need to modify the info object containing the path,
    // since from here on it is not ever accessed by resolver functions.
    const itemPath = addPath(path, index, undefined);

    try {
      let completedItem;

      if (isPromise(item)) {
        completedItem = item.then((resolved) =>
          completeValue(
            exeContext,
            itemType,
            fieldNodes,
            info,
            itemPath,
            resolved,
          ),
        );
      } else {
        completedItem = completeValue(
          exeContext,
          itemType,
          fieldNodes,
          info,
          itemPath,
          item,
        );
      }

      if (isPromise(completedItem)) {
        containsPromise = true; // Note: we don't rely on a `catch` method, but we do expect "thenable"
        // to take a second callback for the error case.

        return completedItem.then(undefined, (rawError) => {
          const error = locatedError(
            rawError,
            fieldNodes,
            pathToArray(itemPath),
          );
          return handleFieldError(error, itemType, exeContext);
        });
      }

      return completedItem;
    } catch (rawError) {
      const error = locatedError(rawError, fieldNodes, pathToArray(itemPath));
      return handleFieldError(error, itemType, exeContext);
    }
  });
  return containsPromise ? Promise.all(completedResults) : completedResults;
}
/**
 * Complete a Scalar or Enum by serializing to a valid value, returning
 * null if serialization is not possible.
 */

function completeLeafValue(returnType, result) {
  const serializedResult = returnType.serialize(result);

  if (serializedResult == null) {
    throw new Error(
      `Expected \`${inspect$1(returnType)}.serialize(${inspect$1(result)})\` to ` +
        `return non-nullable value, returned: ${inspect$1(serializedResult)}`,
    );
  }

  return serializedResult;
}
/**
 * Complete a value of an abstract type by determining the runtime object type
 * of that value, then complete the value for that type.
 */

function completeAbstractValue(
  exeContext,
  returnType,
  fieldNodes,
  info,
  path,
  result,
) {
  var _returnType$resolveTy;

  const resolveTypeFn =
    (_returnType$resolveTy = returnType.resolveType) !== null &&
    _returnType$resolveTy !== void 0
      ? _returnType$resolveTy
      : exeContext.typeResolver;
  const contextValue = exeContext.contextValue;
  const runtimeType = resolveTypeFn(result, contextValue, info, returnType);

  if (isPromise(runtimeType)) {
    return runtimeType.then((resolvedRuntimeType) =>
      completeObjectValue(
        exeContext,
        ensureValidRuntimeType(
          resolvedRuntimeType,
          exeContext,
          returnType,
          fieldNodes,
          info,
          result,
        ),
        fieldNodes,
        info,
        path,
        result,
      ),
    );
  }

  return completeObjectValue(
    exeContext,
    ensureValidRuntimeType(
      runtimeType,
      exeContext,
      returnType,
      fieldNodes,
      info,
      result,
    ),
    fieldNodes,
    info,
    path,
    result,
  );
}

function ensureValidRuntimeType(
  runtimeTypeName,
  exeContext,
  returnType,
  fieldNodes,
  info,
  result,
) {
  if (runtimeTypeName == null) {
    throw new GraphQLError(
      `Abstract type "${returnType.name}" must resolve to an Object type at runtime for field "${info.parentType.name}.${info.fieldName}". Either the "${returnType.name}" type should provide a "resolveType" function or each possible type should provide an "isTypeOf" function.`,
      fieldNodes,
    );
  } // releases before 16.0.0 supported returning `GraphQLObjectType` from `resolveType`
  // TODO: remove in 17.0.0 release

  if (isObjectType(runtimeTypeName)) {
    throw new GraphQLError(
      'Support for returning GraphQLObjectType from resolveType was removed in graphql-js@16.0.0 please return type name instead.',
    );
  }

  if (typeof runtimeTypeName !== 'string') {
    throw new GraphQLError(
      `Abstract type "${returnType.name}" must resolve to an Object type at runtime for field "${info.parentType.name}.${info.fieldName}" with ` +
        `value ${inspect$1(result)}, received "${inspect$1(runtimeTypeName)}".`,
    );
  }

  const runtimeType = exeContext.schema.getType(runtimeTypeName);

  if (runtimeType == null) {
    throw new GraphQLError(
      `Abstract type "${returnType.name}" was resolved to a type "${runtimeTypeName}" that does not exist inside the schema.`,
      {
        nodes: fieldNodes,
      },
    );
  }

  if (!isObjectType(runtimeType)) {
    throw new GraphQLError(
      `Abstract type "${returnType.name}" was resolved to a non-object type "${runtimeTypeName}".`,
      {
        nodes: fieldNodes,
      },
    );
  }

  if (!exeContext.schema.isSubType(returnType, runtimeType)) {
    throw new GraphQLError(
      `Runtime Object type "${runtimeType.name}" is not a possible type for "${returnType.name}".`,
      {
        nodes: fieldNodes,
      },
    );
  }

  return runtimeType;
}
/**
 * Complete an Object value by executing all sub-selections.
 */

function completeObjectValue(
  exeContext,
  returnType,
  fieldNodes,
  info,
  path,
  result,
) {
  // Collect sub-fields to execute to complete this value.
  const subFieldNodes = collectSubfields(exeContext, returnType, fieldNodes); // If there is an isTypeOf predicate function, call it with the
  // current result. If isTypeOf returns false, then raise an error rather
  // than continuing execution.

  if (returnType.isTypeOf) {
    const isTypeOf = returnType.isTypeOf(result, exeContext.contextValue, info);

    if (isPromise(isTypeOf)) {
      return isTypeOf.then((resolvedIsTypeOf) => {
        if (!resolvedIsTypeOf) {
          throw invalidReturnTypeError(returnType, result, fieldNodes);
        }

        return executeFields(
          exeContext,
          returnType,
          result,
          path,
          subFieldNodes,
        );
      });
    }

    if (!isTypeOf) {
      throw invalidReturnTypeError(returnType, result, fieldNodes);
    }
  }

  return executeFields(exeContext, returnType, result, path, subFieldNodes);
}

function invalidReturnTypeError(returnType, result, fieldNodes) {
  return new GraphQLError(
    `Expected value of type "${returnType.name}" but got: ${inspect$1(result)}.`,
    {
      nodes: fieldNodes,
    },
  );
}
/**
 * If a resolveType function is not given, then a default resolve behavior is
 * used which attempts two strategies:
 *
 * First, See if the provided value has a `__typename` field defined, if so, use
 * that value as name of the resolved type.
 *
 * Otherwise, test each possible type for the abstract type by calling
 * isTypeOf for the object being coerced, returning the first type that matches.
 */

const defaultTypeResolver = function (
  value,
  contextValue,
  info,
  abstractType,
) {
  // First, look for `__typename`.
  if (isObjectLike$1(value) && typeof value.__typename === 'string') {
    return value.__typename;
  } // Otherwise, test each possible type.

  const possibleTypes = info.schema.getPossibleTypes(abstractType);
  const promisedIsTypeOfResults = [];

  for (let i = 0; i < possibleTypes.length; i++) {
    const type = possibleTypes[i];

    if (type.isTypeOf) {
      const isTypeOfResult = type.isTypeOf(value, contextValue, info);

      if (isPromise(isTypeOfResult)) {
        promisedIsTypeOfResults[i] = isTypeOfResult;
      } else if (isTypeOfResult) {
        return type.name;
      }
    }
  }

  if (promisedIsTypeOfResults.length) {
    return Promise.all(promisedIsTypeOfResults).then((isTypeOfResults) => {
      for (let i = 0; i < isTypeOfResults.length; i++) {
        if (isTypeOfResults[i]) {
          return possibleTypes[i].name;
        }
      }
    });
  }
};
/**
 * If a resolve function is not given, then a default resolve behavior is used
 * which takes the property of the source object of the same name as the field
 * and returns it as the result, or if it's a function, returns the result
 * of calling that function while passing along args and context value.
 */

const defaultFieldResolver = function (
  source,
  args,
  contextValue,
  info,
) {
  // ensure source is a value for which property access is acceptable.
  if (isObjectLike$1(source) || typeof source === 'function') {
    const property = source[info.fieldName];

    if (typeof property === 'function') {
      return source[info.fieldName](args, contextValue, info);
    }

    return property;
  }
};
/**
 * This method looks up the field on the given type definition.
 * It has special casing for the three introspection fields,
 * __schema, __type and __typename. __typename is special because
 * it can always be queried as a field, even in situations where no
 * other fields are allowed, like on a Union. __schema and __type
 * could get automatically added to the query type, but that would
 * require mutating type definitions, which would cause issues.
 *
 * @internal
 */

function getFieldDef(schema, parentType, fieldNode) {
  const fieldName = fieldNode.name.value;

  if (
    fieldName === SchemaMetaFieldDef.name &&
    schema.getQueryType() === parentType
  ) {
    return SchemaMetaFieldDef;
  } else if (
    fieldName === TypeMetaFieldDef.name &&
    schema.getQueryType() === parentType
  ) {
    return TypeMetaFieldDef;
  } else if (fieldName === TypeNameMetaFieldDef.name) {
    return TypeNameMetaFieldDef;
  }

  return parentType.getFields()[fieldName];
}

/**
 * Returns true if the provided object implements the AsyncIterator protocol via
 * implementing a `Symbol.asyncIterator` method.
 */
function isAsyncIterable$1(maybeAsyncIterable) {
  return (
    typeof (maybeAsyncIterable === null || maybeAsyncIterable === void 0
      ? void 0
      : maybeAsyncIterable[Symbol.asyncIterator]) === 'function'
  );
}

/**
 * Given an AsyncIterable and a callback function, return an AsyncIterator
 * which produces values mapped via calling the callback function.
 */
function mapAsyncIterator(iterable, callback) {
  const iterator = iterable[Symbol.asyncIterator]();

  async function mapResult(result) {
    if (result.done) {
      return result;
    }

    try {
      return {
        value: await callback(result.value),
        done: false,
      };
    } catch (error) {
      /* c8 ignore start */
      // FIXME: add test case
      if (typeof iterator.return === 'function') {
        try {
          await iterator.return();
        } catch (_e) {
          /* ignore error */
        }
      }

      throw error;
      /* c8 ignore stop */
    }
  }

  return {
    async next() {
      return mapResult(await iterator.next());
    },

    async return() {
      // If iterator.return() does not exist, then type R must be undefined.
      return typeof iterator.return === 'function'
        ? mapResult(await iterator.return())
        : {
            value: undefined,
            done: true,
          };
    },

    async throw(error) {
      if (typeof iterator.throw === 'function') {
        return mapResult(await iterator.throw(error));
      }

      throw error;
    },

    [Symbol.asyncIterator]() {
      return this;
    },
  };
}

/**
 * Implements the "Subscribe" algorithm described in the GraphQL specification.
 *
 * Returns a Promise which resolves to either an AsyncIterator (if successful)
 * or an ExecutionResult (error). The promise will be rejected if the schema or
 * other arguments to this function are invalid, or if the resolved event stream
 * is not an async iterable.
 *
 * If the client-provided arguments to this function do not result in a
 * compliant subscription, a GraphQL Response (ExecutionResult) with
 * descriptive errors and no data will be returned.
 *
 * If the source stream could not be created due to faulty subscription
 * resolver logic or underlying systems, the promise will resolve to a single
 * ExecutionResult containing `errors` and no `data`.
 *
 * If the operation succeeded, the promise resolves to an AsyncIterator, which
 * yields a stream of ExecutionResults representing the response stream.
 *
 * Accepts either an object with named arguments, or individual arguments.
 */

async function subscribe(args) {
  // Temporary for v15 to v16 migration. Remove in v17
  arguments.length < 2 ||
    devAssert(
      false,
      'graphql@16 dropped long-deprecated support for positional arguments, please pass an object instead.',
    );
  const resultOrStream = await createSourceEventStream(args);

  if (!isAsyncIterable$1(resultOrStream)) {
    return resultOrStream;
  } // For each payload yielded from a subscription, map it over the normal
  // GraphQL `execute` function, with `payload` as the rootValue.
  // This implements the "MapSourceToResponseEvent" algorithm described in
  // the GraphQL specification. The `execute` function provides the
  // "ExecuteSubscriptionEvent" algorithm, as it is nearly identical to the
  // "ExecuteQuery" algorithm, for which `execute` is also used.

  const mapSourceToResponse = (payload) =>
    execute({ ...args, rootValue: payload }); // Map every source value to a ExecutionResult value as described above.

  return mapAsyncIterator(resultOrStream, mapSourceToResponse);
}

function toNormalizedArgs(args) {
  const firstArg = args[0];

  if (firstArg && 'document' in firstArg) {
    return firstArg;
  }

  return {
    schema: firstArg,
    // FIXME: when underlying TS bug fixed, see https://github.com/microsoft/TypeScript/issues/31613
    document: args[1],
    rootValue: args[2],
    contextValue: args[3],
    variableValues: args[4],
    operationName: args[5],
    subscribeFieldResolver: args[6],
  };
}
/**
 * Implements the "CreateSourceEventStream" algorithm described in the
 * GraphQL specification, resolving the subscription source event stream.
 *
 * Returns a Promise which resolves to either an AsyncIterable (if successful)
 * or an ExecutionResult (error). The promise will be rejected if the schema or
 * other arguments to this function are invalid, or if the resolved event stream
 * is not an async iterable.
 *
 * If the client-provided arguments to this function do not result in a
 * compliant subscription, a GraphQL Response (ExecutionResult) with
 * descriptive errors and no data will be returned.
 *
 * If the the source stream could not be created due to faulty subscription
 * resolver logic or underlying systems, the promise will resolve to a single
 * ExecutionResult containing `errors` and no `data`.
 *
 * If the operation succeeded, the promise resolves to the AsyncIterable for the
 * event stream returned by the resolver.
 *
 * A Source Event Stream represents a sequence of events, each of which triggers
 * a GraphQL execution for that event.
 *
 * This may be useful when hosting the stateful subscription service in a
 * different process or machine than the stateless GraphQL execution engine,
 * or otherwise separating these two steps. For more on this, see the
 * "Supporting Subscriptions at Scale" information in the GraphQL specification.
 */

async function createSourceEventStream(...rawArgs) {
  const args = toNormalizedArgs(rawArgs);
  const { schema, document, variableValues } = args; // If arguments are missing or incorrectly typed, this is an internal
  // developer mistake which should throw an early error.

  assertValidExecutionArguments(schema, document, variableValues); // If a valid execution context cannot be created due to incorrect arguments,
  // a "Response" with only errors is returned.

  const exeContext = buildExecutionContext(args); // Return early errors if execution context failed.

  if (!('schema' in exeContext)) {
    return {
      errors: exeContext,
    };
  }

  try {
    const eventStream = await executeSubscription(exeContext); // Assert field returned an event stream, otherwise yield an error.

    if (!isAsyncIterable$1(eventStream)) {
      throw new Error(
        'Subscription field must return Async Iterable. ' +
          `Received: ${inspect$1(eventStream)}.`,
      );
    }

    return eventStream;
  } catch (error) {
    // If it GraphQLError, report it as an ExecutionResult, containing only errors and no data.
    // Otherwise treat the error as a system-class error and re-throw it.
    if (error instanceof GraphQLError) {
      return {
        errors: [error],
      };
    }

    throw error;
  }
}

async function executeSubscription(exeContext) {
  const { schema, fragments, operation, variableValues, rootValue } =
    exeContext;
  const rootType = schema.getSubscriptionType();

  if (rootType == null) {
    throw new GraphQLError(
      'Schema is not configured to execute subscription operation.',
      {
        nodes: operation,
      },
    );
  }

  const rootFields = collectFields(
    schema,
    fragments,
    variableValues,
    rootType,
    operation.selectionSet,
  );
  const [responseName, fieldNodes] = [...rootFields.entries()][0];
  const fieldDef = getFieldDef(schema, rootType, fieldNodes[0]);

  if (!fieldDef) {
    const fieldName = fieldNodes[0].name.value;
    throw new GraphQLError(
      `The subscription field "${fieldName}" is not defined.`,
      {
        nodes: fieldNodes,
      },
    );
  }

  const path = addPath(undefined, responseName, rootType.name);
  const info = buildResolveInfo(
    exeContext,
    fieldDef,
    fieldNodes,
    rootType,
    path,
  );

  try {
    var _fieldDef$subscribe;

    // Implements the "ResolveFieldEventStream" algorithm from GraphQL specification.
    // It differs from "ResolveFieldValue" due to providing a different `resolveFn`.
    // Build a JS object of arguments from the field.arguments AST, using the
    // variables scope to fulfill any variable references.
    const args = getArgumentValues(fieldDef, fieldNodes[0], variableValues); // The resolve function's optional third argument is a context value that
    // is provided to every resolve function within an execution. It is commonly
    // used to represent an authenticated user, or request-specific caches.

    const contextValue = exeContext.contextValue; // Call the `subscribe()` resolver or the default resolver to produce an
    // AsyncIterable yielding raw payloads.

    const resolveFn =
      (_fieldDef$subscribe = fieldDef.subscribe) !== null &&
      _fieldDef$subscribe !== void 0
        ? _fieldDef$subscribe
        : exeContext.subscribeFieldResolver;
    const eventStream = await resolveFn(rootValue, args, contextValue, info);

    if (eventStream instanceof Error) {
      throw eventStream;
    }

    return eventStream;
  } catch (error) {
    throw locatedError(error, fieldNodes, pathToArray(path));
  }
}

/**
 * Returns an operation AST given a document AST and optionally an operation
 * name. If a name is not provided, an operation is only returned if only one is
 * provided in the document.
 */

function getOperationAST(documentAST, operationName) {
  let operation = null;

  for (const definition of documentAST.definitions) {
    if (definition.kind === Kind.OPERATION_DEFINITION) {
      var _definition$name;

      if (operationName == null) {
        // If no operation name was provided, only return an Operation if there
        // is one defined in the document. Upon encountering the second, return
        // null.
        if (operation) {
          return null;
        }

        operation = definition;
      } else if (
        ((_definition$name = definition.name) === null ||
        _definition$name === void 0
          ? void 0
          : _definition$name.value) === operationName
      ) {
        return definition;
      }
    }
  }

  return operation;
}

/**
 * @internal
 */

function extendSchemaImpl(schemaConfig, documentAST, options) {
  var _schemaDef, _schemaDef$descriptio, _schemaDef2, _options$assumeValid;

  // Collect the type definitions and extensions found in the document.
  const typeDefs = [];
  const typeExtensionsMap = Object.create(null); // New directives and types are separate because a directives and types can
  // have the same name. For example, a type named "skip".

  const directiveDefs = [];
  let schemaDef; // Schema extensions are collected which may add additional operation types.

  const schemaExtensions = [];

  for (const def of documentAST.definitions) {
    if (def.kind === Kind.SCHEMA_DEFINITION) {
      schemaDef = def;
    } else if (def.kind === Kind.SCHEMA_EXTENSION) {
      schemaExtensions.push(def);
    } else if (isTypeDefinitionNode(def)) {
      typeDefs.push(def);
    } else if (isTypeExtensionNode(def)) {
      const extendedTypeName = def.name.value;
      const existingTypeExtensions = typeExtensionsMap[extendedTypeName];
      typeExtensionsMap[extendedTypeName] = existingTypeExtensions
        ? existingTypeExtensions.concat([def])
        : [def];
    } else if (def.kind === Kind.DIRECTIVE_DEFINITION) {
      directiveDefs.push(def);
    }
  } // If this document contains no new types, extensions, or directives then
  // return the same unmodified GraphQLSchema instance.

  if (
    Object.keys(typeExtensionsMap).length === 0 &&
    typeDefs.length === 0 &&
    directiveDefs.length === 0 &&
    schemaExtensions.length === 0 &&
    schemaDef == null
  ) {
    return schemaConfig;
  }

  const typeMap = Object.create(null);

  for (const existingType of schemaConfig.types) {
    typeMap[existingType.name] = extendNamedType(existingType);
  }

  for (const typeNode of typeDefs) {
    var _stdTypeMap$name;

    const name = typeNode.name.value;
    typeMap[name] =
      (_stdTypeMap$name = stdTypeMap[name]) !== null &&
      _stdTypeMap$name !== void 0
        ? _stdTypeMap$name
        : buildType(typeNode);
  }

  const operationTypes = {
    // Get the extended root operation types.
    query: schemaConfig.query && replaceNamedType(schemaConfig.query),
    mutation: schemaConfig.mutation && replaceNamedType(schemaConfig.mutation),
    subscription:
      schemaConfig.subscription && replaceNamedType(schemaConfig.subscription),
    // Then, incorporate schema definition and all schema extensions.
    ...(schemaDef && getOperationTypes([schemaDef])),
    ...getOperationTypes(schemaExtensions),
  }; // Then produce and return a Schema config with these types.

  return {
    description:
      (_schemaDef = schemaDef) === null || _schemaDef === void 0
        ? void 0
        : (_schemaDef$descriptio = _schemaDef.description) === null ||
          _schemaDef$descriptio === void 0
        ? void 0
        : _schemaDef$descriptio.value,
    ...operationTypes,
    types: Object.values(typeMap),
    directives: [
      ...schemaConfig.directives.map(replaceDirective),
      ...directiveDefs.map(buildDirective),
    ],
    extensions: Object.create(null),
    astNode:
      (_schemaDef2 = schemaDef) !== null && _schemaDef2 !== void 0
        ? _schemaDef2
        : schemaConfig.astNode,
    extensionASTNodes: schemaConfig.extensionASTNodes.concat(schemaExtensions),
    assumeValid:
      (_options$assumeValid =
        options === null || options === void 0
          ? void 0
          : options.assumeValid) !== null && _options$assumeValid !== void 0
        ? _options$assumeValid
        : false,
  }; // Below are functions used for producing this schema that have closed over
  // this scope and have access to the schema, cache, and newly defined types.

  function replaceType(type) {
    if (isListType(type)) {
      // @ts-expect-error
      return new GraphQLList(replaceType(type.ofType));
    }

    if (isNonNullType(type)) {
      // @ts-expect-error
      return new GraphQLNonNull(replaceType(type.ofType));
    } // @ts-expect-error FIXME

    return replaceNamedType(type);
  }

  function replaceNamedType(type) {
    // Note: While this could make early assertions to get the correctly
    // typed values, that would throw immediately while type system
    // validation with validateSchema() will produce more actionable results.
    return typeMap[type.name];
  }

  function replaceDirective(directive) {
    const config = directive.toConfig();
    return new GraphQLDirective({
      ...config,
      args: mapValue(config.args, extendArg),
    });
  }

  function extendNamedType(type) {
    if (isIntrospectionType(type) || isSpecifiedScalarType(type)) {
      // Builtin types are not extended.
      return type;
    }

    if (isScalarType(type)) {
      return extendScalarType(type);
    }

    if (isObjectType(type)) {
      return extendObjectType(type);
    }

    if (isInterfaceType(type)) {
      return extendInterfaceType(type);
    }

    if (isUnionType(type)) {
      return extendUnionType(type);
    }

    if (isEnumType(type)) {
      return extendEnumType(type);
    }

    if (isInputObjectType(type)) {
      return extendInputObjectType(type);
    }
    /* c8 ignore next 3 */
    // Not reachable, all possible type definition nodes have been considered.

    invariant(false, 'Unexpected type: ' + inspect$1(type));
  }

  function extendInputObjectType(type) {
    var _typeExtensionsMap$co;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$co = typeExtensionsMap[config.name]) !== null &&
      _typeExtensionsMap$co !== void 0
        ? _typeExtensionsMap$co
        : [];
    return new GraphQLInputObjectType({
      ...config,
      fields: () => ({
        ...mapValue(config.fields, (field) => ({
          ...field,
          type: replaceType(field.type),
        })),
        ...buildInputFieldMap(extensions),
      }),
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendEnumType(type) {
    var _typeExtensionsMap$ty;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$ty = typeExtensionsMap[type.name]) !== null &&
      _typeExtensionsMap$ty !== void 0
        ? _typeExtensionsMap$ty
        : [];
    return new GraphQLEnumType({
      ...config,
      values: { ...config.values, ...buildEnumValueMap(extensions) },
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendScalarType(type) {
    var _typeExtensionsMap$co2;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$co2 = typeExtensionsMap[config.name]) !== null &&
      _typeExtensionsMap$co2 !== void 0
        ? _typeExtensionsMap$co2
        : [];
    let specifiedByURL = config.specifiedByURL;

    for (const extensionNode of extensions) {
      var _getSpecifiedByURL;

      specifiedByURL =
        (_getSpecifiedByURL = getSpecifiedByURL(extensionNode)) !== null &&
        _getSpecifiedByURL !== void 0
          ? _getSpecifiedByURL
          : specifiedByURL;
    }

    return new GraphQLScalarType({
      ...config,
      specifiedByURL,
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendObjectType(type) {
    var _typeExtensionsMap$co3;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$co3 = typeExtensionsMap[config.name]) !== null &&
      _typeExtensionsMap$co3 !== void 0
        ? _typeExtensionsMap$co3
        : [];
    return new GraphQLObjectType({
      ...config,
      interfaces: () => [
        ...type.getInterfaces().map(replaceNamedType),
        ...buildInterfaces(extensions),
      ],
      fields: () => ({
        ...mapValue(config.fields, extendField),
        ...buildFieldMap(extensions),
      }),
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendInterfaceType(type) {
    var _typeExtensionsMap$co4;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$co4 = typeExtensionsMap[config.name]) !== null &&
      _typeExtensionsMap$co4 !== void 0
        ? _typeExtensionsMap$co4
        : [];
    return new GraphQLInterfaceType({
      ...config,
      interfaces: () => [
        ...type.getInterfaces().map(replaceNamedType),
        ...buildInterfaces(extensions),
      ],
      fields: () => ({
        ...mapValue(config.fields, extendField),
        ...buildFieldMap(extensions),
      }),
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendUnionType(type) {
    var _typeExtensionsMap$co5;

    const config = type.toConfig();
    const extensions =
      (_typeExtensionsMap$co5 = typeExtensionsMap[config.name]) !== null &&
      _typeExtensionsMap$co5 !== void 0
        ? _typeExtensionsMap$co5
        : [];
    return new GraphQLUnionType({
      ...config,
      types: () => [
        ...type.getTypes().map(replaceNamedType),
        ...buildUnionTypes(extensions),
      ],
      extensionASTNodes: config.extensionASTNodes.concat(extensions),
    });
  }

  function extendField(field) {
    return {
      ...field,
      type: replaceType(field.type),
      args: field.args && mapValue(field.args, extendArg),
    };
  }

  function extendArg(arg) {
    return { ...arg, type: replaceType(arg.type) };
  }

  function getOperationTypes(nodes) {
    const opTypes = {};

    for (const node of nodes) {
      var _node$operationTypes;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      const operationTypesNodes =
        /* c8 ignore next */
        (_node$operationTypes = node.operationTypes) !== null &&
        _node$operationTypes !== void 0
          ? _node$operationTypes
          : [];

      for (const operationType of operationTypesNodes) {
        // Note: While this could make early assertions to get the correctly
        // typed values below, that would throw immediately while type system
        // validation with validateSchema() will produce more actionable results.
        // @ts-expect-error
        opTypes[operationType.operation] = getNamedType(operationType.type);
      }
    }

    return opTypes;
  }

  function getNamedType(node) {
    var _stdTypeMap$name2;

    const name = node.name.value;
    const type =
      (_stdTypeMap$name2 = stdTypeMap[name]) !== null &&
      _stdTypeMap$name2 !== void 0
        ? _stdTypeMap$name2
        : typeMap[name];

    if (type === undefined) {
      throw new Error(`Unknown type: "${name}".`);
    }

    return type;
  }

  function getWrappedType(node) {
    if (node.kind === Kind.LIST_TYPE) {
      return new GraphQLList(getWrappedType(node.type));
    }

    if (node.kind === Kind.NON_NULL_TYPE) {
      return new GraphQLNonNull(getWrappedType(node.type));
    }

    return getNamedType(node);
  }

  function buildDirective(node) {
    var _node$description;

    return new GraphQLDirective({
      name: node.name.value,
      description:
        (_node$description = node.description) === null ||
        _node$description === void 0
          ? void 0
          : _node$description.value,
      // @ts-expect-error
      locations: node.locations.map(({ value }) => value),
      isRepeatable: node.repeatable,
      args: buildArgumentMap(node.arguments),
      astNode: node,
    });
  }

  function buildFieldMap(nodes) {
    const fieldConfigMap = Object.create(null);

    for (const node of nodes) {
      var _node$fields;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      const nodeFields =
        /* c8 ignore next */
        (_node$fields = node.fields) !== null && _node$fields !== void 0
          ? _node$fields
          : [];

      for (const field of nodeFields) {
        var _field$description;

        fieldConfigMap[field.name.value] = {
          // Note: While this could make assertions to get the correctly typed
          // value, that would throw immediately while type system validation
          // with validateSchema() will produce more actionable results.
          type: getWrappedType(field.type),
          description:
            (_field$description = field.description) === null ||
            _field$description === void 0
              ? void 0
              : _field$description.value,
          args: buildArgumentMap(field.arguments),
          deprecationReason: getDeprecationReason(field),
          astNode: field,
        };
      }
    }

    return fieldConfigMap;
  }

  function buildArgumentMap(args) {
    // FIXME: https://github.com/graphql/graphql-js/issues/2203
    const argsNodes =
      /* c8 ignore next */
      args !== null && args !== void 0 ? args : [];
    const argConfigMap = Object.create(null);

    for (const arg of argsNodes) {
      var _arg$description;

      // Note: While this could make assertions to get the correctly typed
      // value, that would throw immediately while type system validation
      // with validateSchema() will produce more actionable results.
      const type = getWrappedType(arg.type);
      argConfigMap[arg.name.value] = {
        type,
        description:
          (_arg$description = arg.description) === null ||
          _arg$description === void 0
            ? void 0
            : _arg$description.value,
        defaultValue: valueFromAST(arg.defaultValue, type),
        deprecationReason: getDeprecationReason(arg),
        astNode: arg,
      };
    }

    return argConfigMap;
  }

  function buildInputFieldMap(nodes) {
    const inputFieldMap = Object.create(null);

    for (const node of nodes) {
      var _node$fields2;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      const fieldsNodes =
        /* c8 ignore next */
        (_node$fields2 = node.fields) !== null && _node$fields2 !== void 0
          ? _node$fields2
          : [];

      for (const field of fieldsNodes) {
        var _field$description2;

        // Note: While this could make assertions to get the correctly typed
        // value, that would throw immediately while type system validation
        // with validateSchema() will produce more actionable results.
        const type = getWrappedType(field.type);
        inputFieldMap[field.name.value] = {
          type,
          description:
            (_field$description2 = field.description) === null ||
            _field$description2 === void 0
              ? void 0
              : _field$description2.value,
          defaultValue: valueFromAST(field.defaultValue, type),
          deprecationReason: getDeprecationReason(field),
          astNode: field,
        };
      }
    }

    return inputFieldMap;
  }

  function buildEnumValueMap(nodes) {
    const enumValueMap = Object.create(null);

    for (const node of nodes) {
      var _node$values;

      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      const valuesNodes =
        /* c8 ignore next */
        (_node$values = node.values) !== null && _node$values !== void 0
          ? _node$values
          : [];

      for (const value of valuesNodes) {
        var _value$description;

        enumValueMap[value.name.value] = {
          description:
            (_value$description = value.description) === null ||
            _value$description === void 0
              ? void 0
              : _value$description.value,
          deprecationReason: getDeprecationReason(value),
          astNode: value,
        };
      }
    }

    return enumValueMap;
  }

  function buildInterfaces(nodes) {
    // Note: While this could make assertions to get the correctly typed
    // values below, that would throw immediately while type system
    // validation with validateSchema() will produce more actionable results.
    // @ts-expect-error
    return nodes.flatMap(
      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      (node) => {
        var _node$interfaces$map, _node$interfaces;

        return (
          /* c8 ignore next */
          (_node$interfaces$map =
            (_node$interfaces = node.interfaces) === null ||
            _node$interfaces === void 0
              ? void 0
              : _node$interfaces.map(getNamedType)) !== null &&
            _node$interfaces$map !== void 0
            ? _node$interfaces$map
            : []
        );
      },
    );
  }

  function buildUnionTypes(nodes) {
    // Note: While this could make assertions to get the correctly typed
    // values below, that would throw immediately while type system
    // validation with validateSchema() will produce more actionable results.
    // @ts-expect-error
    return nodes.flatMap(
      // FIXME: https://github.com/graphql/graphql-js/issues/2203
      (node) => {
        var _node$types$map, _node$types;

        return (
          /* c8 ignore next */
          (_node$types$map =
            (_node$types = node.types) === null || _node$types === void 0
              ? void 0
              : _node$types.map(getNamedType)) !== null &&
            _node$types$map !== void 0
            ? _node$types$map
            : []
        );
      },
    );
  }

  function buildType(astNode) {
    var _typeExtensionsMap$na;

    const name = astNode.name.value;
    const extensionASTNodes =
      (_typeExtensionsMap$na = typeExtensionsMap[name]) !== null &&
      _typeExtensionsMap$na !== void 0
        ? _typeExtensionsMap$na
        : [];

    switch (astNode.kind) {
      case Kind.OBJECT_TYPE_DEFINITION: {
        var _astNode$description;

        const allNodes = [astNode, ...extensionASTNodes];
        return new GraphQLObjectType({
          name,
          description:
            (_astNode$description = astNode.description) === null ||
            _astNode$description === void 0
              ? void 0
              : _astNode$description.value,
          interfaces: () => buildInterfaces(allNodes),
          fields: () => buildFieldMap(allNodes),
          astNode,
          extensionASTNodes,
        });
      }

      case Kind.INTERFACE_TYPE_DEFINITION: {
        var _astNode$description2;

        const allNodes = [astNode, ...extensionASTNodes];
        return new GraphQLInterfaceType({
          name,
          description:
            (_astNode$description2 = astNode.description) === null ||
            _astNode$description2 === void 0
              ? void 0
              : _astNode$description2.value,
          interfaces: () => buildInterfaces(allNodes),
          fields: () => buildFieldMap(allNodes),
          astNode,
          extensionASTNodes,
        });
      }

      case Kind.ENUM_TYPE_DEFINITION: {
        var _astNode$description3;

        const allNodes = [astNode, ...extensionASTNodes];
        return new GraphQLEnumType({
          name,
          description:
            (_astNode$description3 = astNode.description) === null ||
            _astNode$description3 === void 0
              ? void 0
              : _astNode$description3.value,
          values: buildEnumValueMap(allNodes),
          astNode,
          extensionASTNodes,
        });
      }

      case Kind.UNION_TYPE_DEFINITION: {
        var _astNode$description4;

        const allNodes = [astNode, ...extensionASTNodes];
        return new GraphQLUnionType({
          name,
          description:
            (_astNode$description4 = astNode.description) === null ||
            _astNode$description4 === void 0
              ? void 0
              : _astNode$description4.value,
          types: () => buildUnionTypes(allNodes),
          astNode,
          extensionASTNodes,
        });
      }

      case Kind.SCALAR_TYPE_DEFINITION: {
        var _astNode$description5;

        return new GraphQLScalarType({
          name,
          description:
            (_astNode$description5 = astNode.description) === null ||
            _astNode$description5 === void 0
              ? void 0
              : _astNode$description5.value,
          specifiedByURL: getSpecifiedByURL(astNode),
          astNode,
          extensionASTNodes,
        });
      }

      case Kind.INPUT_OBJECT_TYPE_DEFINITION: {
        var _astNode$description6;

        const allNodes = [astNode, ...extensionASTNodes];
        return new GraphQLInputObjectType({
          name,
          description:
            (_astNode$description6 = astNode.description) === null ||
            _astNode$description6 === void 0
              ? void 0
              : _astNode$description6.value,
          fields: () => buildInputFieldMap(allNodes),
          astNode,
          extensionASTNodes,
          isOneOf: isOneOf(astNode),
        });
      }
    }
  }
}
const stdTypeMap = keyMap(
  [...specifiedScalarTypes, ...introspectionTypes],
  (type) => type.name,
);
/**
 * Given a field or enum value node, returns the string value for the
 * deprecation reason.
 */

function getDeprecationReason(node) {
  const deprecated = getDirectiveValues(GraphQLDeprecatedDirective, node); // @ts-expect-error validated by `getDirectiveValues`

  return deprecated === null || deprecated === void 0
    ? void 0
    : deprecated.reason;
}
/**
 * Given a scalar node, returns the string value for the specifiedByURL.
 */

function getSpecifiedByURL(node) {
  const specifiedBy = getDirectiveValues(GraphQLSpecifiedByDirective, node); // @ts-expect-error validated by `getDirectiveValues`

  return specifiedBy === null || specifiedBy === void 0
    ? void 0
    : specifiedBy.url;
}
/**
 * Given an input object node, returns if the node should be OneOf.
 */

function isOneOf(node) {
  return Boolean(getDirectiveValues(GraphQLOneOfDirective, node));
}

/**
 * This takes the ast of a schema document produced by the parse function in
 * src/language/parser.js.
 *
 * If no schema definition is provided, then it will look for types named Query,
 * Mutation and Subscription.
 *
 * Given that AST it constructs a GraphQLSchema. The resulting schema
 * has no resolve methods, so execution will use default resolvers.
 */
function buildASTSchema(documentAST, options) {
  (documentAST != null && documentAST.kind === Kind.DOCUMENT) ||
    devAssert(false, 'Must provide valid Document AST.');

  if (
    (options === null || options === void 0 ? void 0 : options.assumeValid) !==
      true &&
    (options === null || options === void 0
      ? void 0
      : options.assumeValidSDL) !== true
  ) {
    assertValidSDL(documentAST);
  }

  const emptySchemaConfig = {
    description: undefined,
    types: [],
    directives: [],
    extensions: Object.create(null),
    extensionASTNodes: [],
    assumeValid: false,
  };
  const config = extendSchemaImpl(emptySchemaConfig, documentAST, options);

  if (config.astNode == null) {
    for (const type of config.types) {
      switch (type.name) {
        // Note: While this could make early assertions to get the correctly
        // typed values below, that would throw immediately while type system
        // validation with validateSchema() will produce more actionable results.
        case 'Query':
          // @ts-expect-error validated in `validateSchema`
          config.query = type;
          break;

        case 'Mutation':
          // @ts-expect-error validated in `validateSchema`
          config.mutation = type;
          break;

        case 'Subscription':
          // @ts-expect-error validated in `validateSchema`
          config.subscription = type;
          break;
      }
    }
  }

  const directives = [
    ...config.directives, // If specified directives were not explicitly declared, add them.
    ...specifiedDirectives.filter((stdDirective) =>
      config.directives.every(
        (directive) => directive.name !== stdDirective.name,
      ),
    ),
  ];
  return new GraphQLSchema({ ...config, directives });
}
/**
 * A helper function to build a GraphQLSchema directly from a source
 * document.
 */

function buildSchema(source, options) {
  const document = parse(source, {
    noLocation:
      options === null || options === void 0 ? void 0 : options.noLocation,
    allowLegacyFragmentVariables:
      options === null || options === void 0
        ? void 0
        : options.allowLegacyFragmentVariables,
  });
  return buildASTSchema(document, {
    assumeValidSDL:
      options === null || options === void 0 ? void 0 : options.assumeValidSDL,
    assumeValid:
      options === null || options === void 0 ? void 0 : options.assumeValid,
  });
}

class RecorderClientTransportBase {
    id;
    message$;
    subscription;
    constructor(id, message$){
        this.id = id;
        this.message$ = message$;
        this.subscription = new Subscription$1();
        this.subscription.add(this.message$.subscribe({
            next: (message)=>{
                this.handleMessage(message);
            },
            error: (error)=>{
                console.error(error);
            },
            complete: ()=>{
                this.stop();
            }
        }));
        bind$1(this);
    }
    stop() {
        this.subscription.unsubscribe();
    }
}

function storageObservable(storage, key) {
    return new Observable$1((subscriber)=>{
        function update() {
            storage.getItem(key).then((value)=>subscriber.next(value));
        }
        const unwatch = storage.watch((_event, changedKey)=>{
            if (changedKey !== key) {
                return;
            }
            update();
        });
        update();
        return ()=>{
            unwatch.then((stop)=>stop());
        };
    });
}

/*! *****************************************************************************
Copyright (C) Microsoft. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var Reflect$1;
(function (Reflect) {
    // Metadata Proposal
    // https://rbuckton.github.io/reflect-metadata/
    (function (factory) {
        var root = typeof globalThis === "object" ? globalThis :
            typeof commonjsGlobal === "object" ? commonjsGlobal :
                typeof self === "object" ? self :
                    typeof this === "object" ? this :
                        sloppyModeThis();
        var exporter = makeExporter(Reflect);
        if (typeof root.Reflect !== "undefined") {
            exporter = makeExporter(root.Reflect, exporter);
        }
        factory(exporter, root);
        if (typeof root.Reflect === "undefined") {
            root.Reflect = Reflect;
        }
        function makeExporter(target, previous) {
            return function (key, value) {
                Object.defineProperty(target, key, { configurable: true, writable: true, value: value });
                if (previous)
                    previous(key, value);
            };
        }
        function functionThis() {
            try {
                return Function("return this;")();
            }
            catch (_) { }
        }
        function indirectEvalThis() {
            try {
                return (void 0, eval)("(function() { return this; })()");
            }
            catch (_) { }
        }
        function sloppyModeThis() {
            return functionThis() || indirectEvalThis();
        }
    })(function (exporter, root) {
        var hasOwn = Object.prototype.hasOwnProperty;
        // feature test for Symbol support
        var supportsSymbol = typeof Symbol === "function";
        var toPrimitiveSymbol = supportsSymbol && typeof Symbol.toPrimitive !== "undefined" ? Symbol.toPrimitive : "@@toPrimitive";
        var iteratorSymbol = supportsSymbol && typeof Symbol.iterator !== "undefined" ? Symbol.iterator : "@@iterator";
        var supportsCreate = typeof Object.create === "function"; // feature test for Object.create support
        var supportsProto = { __proto__: [] } instanceof Array; // feature test for __proto__ support
        var downLevel = !supportsCreate && !supportsProto;
        var HashMap = {
            // create an object in dictionary mode (a.k.a. "slow" mode in v8)
            create: supportsCreate
                ? function () { return MakeDictionary(Object.create(null)); }
                : supportsProto
                    ? function () { return MakeDictionary({ __proto__: null }); }
                    : function () { return MakeDictionary({}); },
            has: downLevel
                ? function (map, key) { return hasOwn.call(map, key); }
                : function (map, key) { return key in map; },
            get: downLevel
                ? function (map, key) { return hasOwn.call(map, key) ? map[key] : undefined; }
                : function (map, key) { return map[key]; },
        };
        // Load global or shim versions of Map, Set, and WeakMap
        var functionPrototype = Object.getPrototypeOf(Function);
        var _Map = typeof Map === "function" && typeof Map.prototype.entries === "function" ? Map : CreateMapPolyfill();
        var _Set = typeof Set === "function" && typeof Set.prototype.entries === "function" ? Set : CreateSetPolyfill();
        var _WeakMap = typeof WeakMap === "function" ? WeakMap : CreateWeakMapPolyfill();
        var registrySymbol = supportsSymbol ? Symbol.for("@reflect-metadata:registry") : undefined;
        var metadataRegistry = GetOrCreateMetadataRegistry();
        var metadataProvider = CreateMetadataProvider(metadataRegistry);
        /**
         * Applies a set of decorators to a property of a target object.
         * @param decorators An array of decorators.
         * @param target The target object.
         * @param propertyKey (Optional) The property key to decorate.
         * @param attributes (Optional) The property descriptor for the target key.
         * @remarks Decorators are applied in reverse order.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     Example = Reflect.decorate(decoratorsArray, Example);
         *
         *     // property (on constructor)
         *     Reflect.decorate(decoratorsArray, Example, "staticProperty");
         *
         *     // property (on prototype)
         *     Reflect.decorate(decoratorsArray, Example.prototype, "property");
         *
         *     // method (on constructor)
         *     Object.defineProperty(Example, "staticMethod",
         *         Reflect.decorate(decoratorsArray, Example, "staticMethod",
         *             Object.getOwnPropertyDescriptor(Example, "staticMethod")));
         *
         *     // method (on prototype)
         *     Object.defineProperty(Example.prototype, "method",
         *         Reflect.decorate(decoratorsArray, Example.prototype, "method",
         *             Object.getOwnPropertyDescriptor(Example.prototype, "method")));
         *
         */
        function decorate(decorators, target, propertyKey, attributes) {
            if (!IsUndefined(propertyKey)) {
                if (!IsArray(decorators))
                    throw new TypeError();
                if (!IsObject(target))
                    throw new TypeError();
                if (!IsObject(attributes) && !IsUndefined(attributes) && !IsNull(attributes))
                    throw new TypeError();
                if (IsNull(attributes))
                    attributes = undefined;
                propertyKey = ToPropertyKey(propertyKey);
                return DecorateProperty(decorators, target, propertyKey, attributes);
            }
            else {
                if (!IsArray(decorators))
                    throw new TypeError();
                if (!IsConstructor(target))
                    throw new TypeError();
                return DecorateConstructor(decorators, target);
            }
        }
        exporter("decorate", decorate);
        // 4.1.2 Reflect.metadata(metadataKey, metadataValue)
        // https://rbuckton.github.io/reflect-metadata/#reflect.metadata
        /**
         * A default metadata decorator factory that can be used on a class, class member, or parameter.
         * @param metadataKey The key for the metadata entry.
         * @param metadataValue The value for the metadata entry.
         * @returns A decorator function.
         * @remarks
         * If `metadataKey` is already defined for the target and target key, the
         * metadataValue for that key will be overwritten.
         * @example
         *
         *     // constructor
         *     @Reflect.metadata(key, value)
         *     class Example {
         *     }
         *
         *     // property (on constructor, TypeScript only)
         *     class Example {
         *         @Reflect.metadata(key, value)
         *         static staticProperty;
         *     }
         *
         *     // property (on prototype, TypeScript only)
         *     class Example {
         *         @Reflect.metadata(key, value)
         *         property;
         *     }
         *
         *     // method (on constructor)
         *     class Example {
         *         @Reflect.metadata(key, value)
         *         static staticMethod() { }
         *     }
         *
         *     // method (on prototype)
         *     class Example {
         *         @Reflect.metadata(key, value)
         *         method() { }
         *     }
         *
         */
        function metadata(metadataKey, metadataValue) {
            function decorator(target, propertyKey) {
                if (!IsObject(target))
                    throw new TypeError();
                if (!IsUndefined(propertyKey) && !IsPropertyKey(propertyKey))
                    throw new TypeError();
                OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
            }
            return decorator;
        }
        exporter("metadata", metadata);
        /**
         * Define a unique metadata entry on the target.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param metadataValue A value that contains attached metadata.
         * @param target The target object on which to define metadata.
         * @param propertyKey (Optional) The property key for the target.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     Reflect.defineMetadata("custom:annotation", options, Example);
         *
         *     // property (on constructor)
         *     Reflect.defineMetadata("custom:annotation", options, Example, "staticProperty");
         *
         *     // property (on prototype)
         *     Reflect.defineMetadata("custom:annotation", options, Example.prototype, "property");
         *
         *     // method (on constructor)
         *     Reflect.defineMetadata("custom:annotation", options, Example, "staticMethod");
         *
         *     // method (on prototype)
         *     Reflect.defineMetadata("custom:annotation", options, Example.prototype, "method");
         *
         *     // decorator factory as metadata-producing annotation.
         *     function MyAnnotation(options): Decorator {
         *         return (target, key?) => Reflect.defineMetadata("custom:annotation", options, target, key);
         *     }
         *
         */
        function defineMetadata(metadataKey, metadataValue, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryDefineOwnMetadata(metadataKey, metadataValue, target, propertyKey);
        }
        exporter("defineMetadata", defineMetadata);
        /**
         * Gets a value indicating whether the target object or its prototype chain has the provided metadata key defined.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns `true` if the metadata key was defined on the target object or its prototype chain; otherwise, `false`.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.hasMetadata("custom:annotation", Example);
         *
         *     // property (on constructor)
         *     result = Reflect.hasMetadata("custom:annotation", Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.hasMetadata("custom:annotation", Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.hasMetadata("custom:annotation", Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.hasMetadata("custom:annotation", Example.prototype, "method");
         *
         */
        function hasMetadata(metadataKey, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryHasMetadata(metadataKey, target, propertyKey);
        }
        exporter("hasMetadata", hasMetadata);
        /**
         * Gets a value indicating whether the target object has the provided metadata key defined.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns `true` if the metadata key was defined on the target object; otherwise, `false`.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.hasOwnMetadata("custom:annotation", Example);
         *
         *     // property (on constructor)
         *     result = Reflect.hasOwnMetadata("custom:annotation", Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.hasOwnMetadata("custom:annotation", Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.hasOwnMetadata("custom:annotation", Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.hasOwnMetadata("custom:annotation", Example.prototype, "method");
         *
         */
        function hasOwnMetadata(metadataKey, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryHasOwnMetadata(metadataKey, target, propertyKey);
        }
        exporter("hasOwnMetadata", hasOwnMetadata);
        /**
         * Gets the metadata value for the provided metadata key on the target object or its prototype chain.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns The metadata value for the metadata key if found; otherwise, `undefined`.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.getMetadata("custom:annotation", Example);
         *
         *     // property (on constructor)
         *     result = Reflect.getMetadata("custom:annotation", Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.getMetadata("custom:annotation", Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.getMetadata("custom:annotation", Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.getMetadata("custom:annotation", Example.prototype, "method");
         *
         */
        function getMetadata(metadataKey, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryGetMetadata(metadataKey, target, propertyKey);
        }
        exporter("getMetadata", getMetadata);
        /**
         * Gets the metadata value for the provided metadata key on the target object.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns The metadata value for the metadata key if found; otherwise, `undefined`.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.getOwnMetadata("custom:annotation", Example);
         *
         *     // property (on constructor)
         *     result = Reflect.getOwnMetadata("custom:annotation", Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.getOwnMetadata("custom:annotation", Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.getOwnMetadata("custom:annotation", Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.getOwnMetadata("custom:annotation", Example.prototype, "method");
         *
         */
        function getOwnMetadata(metadataKey, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryGetOwnMetadata(metadataKey, target, propertyKey);
        }
        exporter("getOwnMetadata", getOwnMetadata);
        /**
         * Gets the metadata keys defined on the target object or its prototype chain.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns An array of unique metadata keys.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.getMetadataKeys(Example);
         *
         *     // property (on constructor)
         *     result = Reflect.getMetadataKeys(Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.getMetadataKeys(Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.getMetadataKeys(Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.getMetadataKeys(Example.prototype, "method");
         *
         */
        function getMetadataKeys(target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryMetadataKeys(target, propertyKey);
        }
        exporter("getMetadataKeys", getMetadataKeys);
        /**
         * Gets the unique metadata keys defined on the target object.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns An array of unique metadata keys.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.getOwnMetadataKeys(Example);
         *
         *     // property (on constructor)
         *     result = Reflect.getOwnMetadataKeys(Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.getOwnMetadataKeys(Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.getOwnMetadataKeys(Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.getOwnMetadataKeys(Example.prototype, "method");
         *
         */
        function getOwnMetadataKeys(target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            return OrdinaryOwnMetadataKeys(target, propertyKey);
        }
        exporter("getOwnMetadataKeys", getOwnMetadataKeys);
        /**
         * Deletes the metadata entry from the target object with the provided key.
         * @param metadataKey A key used to store and retrieve metadata.
         * @param target The target object on which the metadata is defined.
         * @param propertyKey (Optional) The property key for the target.
         * @returns `true` if the metadata entry was found and deleted; otherwise, false.
         * @example
         *
         *     class Example {
         *         // property declarations are not part of ES6, though they are valid in TypeScript:
         *         // static staticProperty;
         *         // property;
         *
         *         constructor(p) { }
         *         static staticMethod(p) { }
         *         method(p) { }
         *     }
         *
         *     // constructor
         *     result = Reflect.deleteMetadata("custom:annotation", Example);
         *
         *     // property (on constructor)
         *     result = Reflect.deleteMetadata("custom:annotation", Example, "staticProperty");
         *
         *     // property (on prototype)
         *     result = Reflect.deleteMetadata("custom:annotation", Example.prototype, "property");
         *
         *     // method (on constructor)
         *     result = Reflect.deleteMetadata("custom:annotation", Example, "staticMethod");
         *
         *     // method (on prototype)
         *     result = Reflect.deleteMetadata("custom:annotation", Example.prototype, "method");
         *
         */
        function deleteMetadata(metadataKey, target, propertyKey) {
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            if (!IsObject(target))
                throw new TypeError();
            if (!IsUndefined(propertyKey))
                propertyKey = ToPropertyKey(propertyKey);
            var provider = GetMetadataProvider(target, propertyKey, /*Create*/ false);
            if (IsUndefined(provider))
                return false;
            return provider.OrdinaryDeleteMetadata(metadataKey, target, propertyKey);
        }
        exporter("deleteMetadata", deleteMetadata);
        function DecorateConstructor(decorators, target) {
            for (var i = decorators.length - 1; i >= 0; --i) {
                var decorator = decorators[i];
                var decorated = decorator(target);
                if (!IsUndefined(decorated) && !IsNull(decorated)) {
                    if (!IsConstructor(decorated))
                        throw new TypeError();
                    target = decorated;
                }
            }
            return target;
        }
        function DecorateProperty(decorators, target, propertyKey, descriptor) {
            for (var i = decorators.length - 1; i >= 0; --i) {
                var decorator = decorators[i];
                var decorated = decorator(target, propertyKey, descriptor);
                if (!IsUndefined(decorated) && !IsNull(decorated)) {
                    if (!IsObject(decorated))
                        throw new TypeError();
                    descriptor = decorated;
                }
            }
            return descriptor;
        }
        // 3.1.1.1 OrdinaryHasMetadata(MetadataKey, O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinaryhasmetadata
        function OrdinaryHasMetadata(MetadataKey, O, P) {
            var hasOwn = OrdinaryHasOwnMetadata(MetadataKey, O, P);
            if (hasOwn)
                return true;
            var parent = OrdinaryGetPrototypeOf(O);
            if (!IsNull(parent))
                return OrdinaryHasMetadata(MetadataKey, parent, P);
            return false;
        }
        // 3.1.2.1 OrdinaryHasOwnMetadata(MetadataKey, O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinaryhasownmetadata
        function OrdinaryHasOwnMetadata(MetadataKey, O, P) {
            var provider = GetMetadataProvider(O, P, /*Create*/ false);
            if (IsUndefined(provider))
                return false;
            return ToBoolean(provider.OrdinaryHasOwnMetadata(MetadataKey, O, P));
        }
        // 3.1.3.1 OrdinaryGetMetadata(MetadataKey, O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinarygetmetadata
        function OrdinaryGetMetadata(MetadataKey, O, P) {
            var hasOwn = OrdinaryHasOwnMetadata(MetadataKey, O, P);
            if (hasOwn)
                return OrdinaryGetOwnMetadata(MetadataKey, O, P);
            var parent = OrdinaryGetPrototypeOf(O);
            if (!IsNull(parent))
                return OrdinaryGetMetadata(MetadataKey, parent, P);
            return undefined;
        }
        // 3.1.4.1 OrdinaryGetOwnMetadata(MetadataKey, O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinarygetownmetadata
        function OrdinaryGetOwnMetadata(MetadataKey, O, P) {
            var provider = GetMetadataProvider(O, P, /*Create*/ false);
            if (IsUndefined(provider))
                return;
            return provider.OrdinaryGetOwnMetadata(MetadataKey, O, P);
        }
        // 3.1.5.1 OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinarydefineownmetadata
        function OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P) {
            var provider = GetMetadataProvider(O, P, /*Create*/ true);
            provider.OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P);
        }
        // 3.1.6.1 OrdinaryMetadataKeys(O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinarymetadatakeys
        function OrdinaryMetadataKeys(O, P) {
            var ownKeys = OrdinaryOwnMetadataKeys(O, P);
            var parent = OrdinaryGetPrototypeOf(O);
            if (parent === null)
                return ownKeys;
            var parentKeys = OrdinaryMetadataKeys(parent, P);
            if (parentKeys.length <= 0)
                return ownKeys;
            if (ownKeys.length <= 0)
                return parentKeys;
            var set = new _Set();
            var keys = [];
            for (var _i = 0, ownKeys_1 = ownKeys; _i < ownKeys_1.length; _i++) {
                var key = ownKeys_1[_i];
                var hasKey = set.has(key);
                if (!hasKey) {
                    set.add(key);
                    keys.push(key);
                }
            }
            for (var _a = 0, parentKeys_1 = parentKeys; _a < parentKeys_1.length; _a++) {
                var key = parentKeys_1[_a];
                var hasKey = set.has(key);
                if (!hasKey) {
                    set.add(key);
                    keys.push(key);
                }
            }
            return keys;
        }
        // 3.1.7.1 OrdinaryOwnMetadataKeys(O, P)
        // https://rbuckton.github.io/reflect-metadata/#ordinaryownmetadatakeys
        function OrdinaryOwnMetadataKeys(O, P) {
            var provider = GetMetadataProvider(O, P, /*create*/ false);
            if (!provider) {
                return [];
            }
            return provider.OrdinaryOwnMetadataKeys(O, P);
        }
        // 6 ECMAScript Data Types and Values
        // https://tc39.github.io/ecma262/#sec-ecmascript-data-types-and-values
        function Type(x) {
            if (x === null)
                return 1 /* Null */;
            switch (typeof x) {
                case "undefined": return 0 /* Undefined */;
                case "boolean": return 2 /* Boolean */;
                case "string": return 3 /* String */;
                case "symbol": return 4 /* Symbol */;
                case "number": return 5 /* Number */;
                case "object": return x === null ? 1 /* Null */ : 6 /* Object */;
                default: return 6 /* Object */;
            }
        }
        // 6.1.1 The Undefined Type
        // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-undefined-type
        function IsUndefined(x) {
            return x === undefined;
        }
        // 6.1.2 The Null Type
        // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-null-type
        function IsNull(x) {
            return x === null;
        }
        // 6.1.5 The Symbol Type
        // https://tc39.github.io/ecma262/#sec-ecmascript-language-types-symbol-type
        function IsSymbol(x) {
            return typeof x === "symbol";
        }
        // 6.1.7 The Object Type
        // https://tc39.github.io/ecma262/#sec-object-type
        function IsObject(x) {
            return typeof x === "object" ? x !== null : typeof x === "function";
        }
        // 7.1 Type Conversion
        // https://tc39.github.io/ecma262/#sec-type-conversion
        // 7.1.1 ToPrimitive(input [, PreferredType])
        // https://tc39.github.io/ecma262/#sec-toprimitive
        function ToPrimitive(input, PreferredType) {
            switch (Type(input)) {
                case 0 /* Undefined */: return input;
                case 1 /* Null */: return input;
                case 2 /* Boolean */: return input;
                case 3 /* String */: return input;
                case 4 /* Symbol */: return input;
                case 5 /* Number */: return input;
            }
            var hint = "string" ;
            var exoticToPrim = GetMethod(input, toPrimitiveSymbol);
            if (exoticToPrim !== undefined) {
                var result = exoticToPrim.call(input, hint);
                if (IsObject(result))
                    throw new TypeError();
                return result;
            }
            return OrdinaryToPrimitive(input);
        }
        // 7.1.1.1 OrdinaryToPrimitive(O, hint)
        // https://tc39.github.io/ecma262/#sec-ordinarytoprimitive
        function OrdinaryToPrimitive(O, hint) {
            var valueOf, result; {
                var toString_1 = O.toString;
                if (IsCallable(toString_1)) {
                    var result = toString_1.call(O);
                    if (!IsObject(result))
                        return result;
                }
                var valueOf = O.valueOf;
                if (IsCallable(valueOf)) {
                    var result = valueOf.call(O);
                    if (!IsObject(result))
                        return result;
                }
            }
            throw new TypeError();
        }
        // 7.1.2 ToBoolean(argument)
        // https://tc39.github.io/ecma262/2016/#sec-toboolean
        function ToBoolean(argument) {
            return !!argument;
        }
        // 7.1.12 ToString(argument)
        // https://tc39.github.io/ecma262/#sec-tostring
        function ToString(argument) {
            return "" + argument;
        }
        // 7.1.14 ToPropertyKey(argument)
        // https://tc39.github.io/ecma262/#sec-topropertykey
        function ToPropertyKey(argument) {
            var key = ToPrimitive(argument);
            if (IsSymbol(key))
                return key;
            return ToString(key);
        }
        // 7.2 Testing and Comparison Operations
        // https://tc39.github.io/ecma262/#sec-testing-and-comparison-operations
        // 7.2.2 IsArray(argument)
        // https://tc39.github.io/ecma262/#sec-isarray
        function IsArray(argument) {
            return Array.isArray
                ? Array.isArray(argument)
                : argument instanceof Object
                    ? argument instanceof Array
                    : Object.prototype.toString.call(argument) === "[object Array]";
        }
        // 7.2.3 IsCallable(argument)
        // https://tc39.github.io/ecma262/#sec-iscallable
        function IsCallable(argument) {
            // NOTE: This is an approximation as we cannot check for [[Call]] internal method.
            return typeof argument === "function";
        }
        // 7.2.4 IsConstructor(argument)
        // https://tc39.github.io/ecma262/#sec-isconstructor
        function IsConstructor(argument) {
            // NOTE: This is an approximation as we cannot check for [[Construct]] internal method.
            return typeof argument === "function";
        }
        // 7.2.7 IsPropertyKey(argument)
        // https://tc39.github.io/ecma262/#sec-ispropertykey
        function IsPropertyKey(argument) {
            switch (Type(argument)) {
                case 3 /* String */: return true;
                case 4 /* Symbol */: return true;
                default: return false;
            }
        }
        function SameValueZero(x, y) {
            return x === y || x !== x && y !== y;
        }
        // 7.3 Operations on Objects
        // https://tc39.github.io/ecma262/#sec-operations-on-objects
        // 7.3.9 GetMethod(V, P)
        // https://tc39.github.io/ecma262/#sec-getmethod
        function GetMethod(V, P) {
            var func = V[P];
            if (func === undefined || func === null)
                return undefined;
            if (!IsCallable(func))
                throw new TypeError();
            return func;
        }
        // 7.4 Operations on Iterator Objects
        // https://tc39.github.io/ecma262/#sec-operations-on-iterator-objects
        function GetIterator(obj) {
            var method = GetMethod(obj, iteratorSymbol);
            if (!IsCallable(method))
                throw new TypeError(); // from Call
            var iterator = method.call(obj);
            if (!IsObject(iterator))
                throw new TypeError();
            return iterator;
        }
        // 7.4.4 IteratorValue(iterResult)
        // https://tc39.github.io/ecma262/2016/#sec-iteratorvalue
        function IteratorValue(iterResult) {
            return iterResult.value;
        }
        // 7.4.5 IteratorStep(iterator)
        // https://tc39.github.io/ecma262/#sec-iteratorstep
        function IteratorStep(iterator) {
            var result = iterator.next();
            return result.done ? false : result;
        }
        // 7.4.6 IteratorClose(iterator, completion)
        // https://tc39.github.io/ecma262/#sec-iteratorclose
        function IteratorClose(iterator) {
            var f = iterator["return"];
            if (f)
                f.call(iterator);
        }
        // 9.1 Ordinary Object Internal Methods and Internal Slots
        // https://tc39.github.io/ecma262/#sec-ordinary-object-internal-methods-and-internal-slots
        // 9.1.1.1 OrdinaryGetPrototypeOf(O)
        // https://tc39.github.io/ecma262/#sec-ordinarygetprototypeof
        function OrdinaryGetPrototypeOf(O) {
            var proto = Object.getPrototypeOf(O);
            if (typeof O !== "function" || O === functionPrototype)
                return proto;
            // TypeScript doesn't set __proto__ in ES5, as it's non-standard.
            // Try to determine the superclass constructor. Compatible implementations
            // must either set __proto__ on a subclass constructor to the superclass constructor,
            // or ensure each class has a valid `constructor` property on its prototype that
            // points back to the constructor.
            // If this is not the same as Function.[[Prototype]], then this is definately inherited.
            // This is the case when in ES6 or when using __proto__ in a compatible browser.
            if (proto !== functionPrototype)
                return proto;
            // If the super prototype is Object.prototype, null, or undefined, then we cannot determine the heritage.
            var prototype = O.prototype;
            var prototypeProto = prototype && Object.getPrototypeOf(prototype);
            if (prototypeProto == null || prototypeProto === Object.prototype)
                return proto;
            // If the constructor was not a function, then we cannot determine the heritage.
            var constructor = prototypeProto.constructor;
            if (typeof constructor !== "function")
                return proto;
            // If we have some kind of self-reference, then we cannot determine the heritage.
            if (constructor === O)
                return proto;
            // we have a pretty good guess at the heritage.
            return constructor;
        }
        // Global metadata registry
        // - Allows `import "reflect-metadata"` and `import "reflect-metadata/no-conflict"` to interoperate.
        // - Uses isolated metadata if `Reflect` is frozen before the registry can be installed.
        /**
         * Creates a registry used to allow multiple `reflect-metadata` providers.
         */
        function CreateMetadataRegistry() {
            var fallback;
            if (!IsUndefined(registrySymbol) &&
                typeof root.Reflect !== "undefined" &&
                !(registrySymbol in root.Reflect) &&
                typeof root.Reflect.defineMetadata === "function") {
                // interoperate with older version of `reflect-metadata` that did not support a registry.
                fallback = CreateFallbackProvider(root.Reflect);
            }
            var first;
            var second;
            var rest;
            var targetProviderMap = new _WeakMap();
            var registry = {
                registerProvider: registerProvider,
                getProvider: getProvider,
                setProvider: setProvider,
            };
            return registry;
            function registerProvider(provider) {
                if (!Object.isExtensible(registry)) {
                    throw new Error("Cannot add provider to a frozen registry.");
                }
                switch (true) {
                    case fallback === provider: break;
                    case IsUndefined(first):
                        first = provider;
                        break;
                    case first === provider: break;
                    case IsUndefined(second):
                        second = provider;
                        break;
                    case second === provider: break;
                    default:
                        if (rest === undefined)
                            rest = new _Set();
                        rest.add(provider);
                        break;
                }
            }
            function getProviderNoCache(O, P) {
                if (!IsUndefined(first)) {
                    if (first.isProviderFor(O, P))
                        return first;
                    if (!IsUndefined(second)) {
                        if (second.isProviderFor(O, P))
                            return first;
                        if (!IsUndefined(rest)) {
                            var iterator = GetIterator(rest);
                            while (true) {
                                var next = IteratorStep(iterator);
                                if (!next) {
                                    return undefined;
                                }
                                var provider = IteratorValue(next);
                                if (provider.isProviderFor(O, P)) {
                                    IteratorClose(iterator);
                                    return provider;
                                }
                            }
                        }
                    }
                }
                if (!IsUndefined(fallback) && fallback.isProviderFor(O, P)) {
                    return fallback;
                }
                return undefined;
            }
            function getProvider(O, P) {
                var providerMap = targetProviderMap.get(O);
                var provider;
                if (!IsUndefined(providerMap)) {
                    provider = providerMap.get(P);
                }
                if (!IsUndefined(provider)) {
                    return provider;
                }
                provider = getProviderNoCache(O, P);
                if (!IsUndefined(provider)) {
                    if (IsUndefined(providerMap)) {
                        providerMap = new _Map();
                        targetProviderMap.set(O, providerMap);
                    }
                    providerMap.set(P, provider);
                }
                return provider;
            }
            function hasProvider(provider) {
                if (IsUndefined(provider))
                    throw new TypeError();
                return first === provider || second === provider || !IsUndefined(rest) && rest.has(provider);
            }
            function setProvider(O, P, provider) {
                if (!hasProvider(provider)) {
                    throw new Error("Metadata provider not registered.");
                }
                var existingProvider = getProvider(O, P);
                if (existingProvider !== provider) {
                    if (!IsUndefined(existingProvider)) {
                        return false;
                    }
                    var providerMap = targetProviderMap.get(O);
                    if (IsUndefined(providerMap)) {
                        providerMap = new _Map();
                        targetProviderMap.set(O, providerMap);
                    }
                    providerMap.set(P, provider);
                }
                return true;
            }
        }
        /**
         * Gets or creates the shared registry of metadata providers.
         */
        function GetOrCreateMetadataRegistry() {
            var metadataRegistry;
            if (!IsUndefined(registrySymbol) && IsObject(root.Reflect) && Object.isExtensible(root.Reflect)) {
                metadataRegistry = root.Reflect[registrySymbol];
            }
            if (IsUndefined(metadataRegistry)) {
                metadataRegistry = CreateMetadataRegistry();
            }
            if (!IsUndefined(registrySymbol) && IsObject(root.Reflect) && Object.isExtensible(root.Reflect)) {
                Object.defineProperty(root.Reflect, registrySymbol, {
                    enumerable: false,
                    configurable: false,
                    writable: false,
                    value: metadataRegistry
                });
            }
            return metadataRegistry;
        }
        function CreateMetadataProvider(registry) {
            // [[Metadata]] internal slot
            // https://rbuckton.github.io/reflect-metadata/#ordinary-object-internal-methods-and-internal-slots
            var metadata = new _WeakMap();
            var provider = {
                isProviderFor: function (O, P) {
                    var targetMetadata = metadata.get(O);
                    if (IsUndefined(targetMetadata))
                        return false;
                    return targetMetadata.has(P);
                },
                OrdinaryDefineOwnMetadata: OrdinaryDefineOwnMetadata,
                OrdinaryHasOwnMetadata: OrdinaryHasOwnMetadata,
                OrdinaryGetOwnMetadata: OrdinaryGetOwnMetadata,
                OrdinaryOwnMetadataKeys: OrdinaryOwnMetadataKeys,
                OrdinaryDeleteMetadata: OrdinaryDeleteMetadata,
            };
            metadataRegistry.registerProvider(provider);
            return provider;
            function GetOrCreateMetadataMap(O, P, Create) {
                var targetMetadata = metadata.get(O);
                var createdTargetMetadata = false;
                if (IsUndefined(targetMetadata)) {
                    if (!Create)
                        return undefined;
                    targetMetadata = new _Map();
                    metadata.set(O, targetMetadata);
                    createdTargetMetadata = true;
                }
                var metadataMap = targetMetadata.get(P);
                if (IsUndefined(metadataMap)) {
                    if (!Create)
                        return undefined;
                    metadataMap = new _Map();
                    targetMetadata.set(P, metadataMap);
                    if (!registry.setProvider(O, P, provider)) {
                        targetMetadata.delete(P);
                        if (createdTargetMetadata) {
                            metadata.delete(O);
                        }
                        throw new Error("Wrong provider for target.");
                    }
                }
                return metadataMap;
            }
            // 3.1.2.1 OrdinaryHasOwnMetadata(MetadataKey, O, P)
            // https://rbuckton.github.io/reflect-metadata/#ordinaryhasownmetadata
            function OrdinaryHasOwnMetadata(MetadataKey, O, P) {
                var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
                if (IsUndefined(metadataMap))
                    return false;
                return ToBoolean(metadataMap.has(MetadataKey));
            }
            // 3.1.4.1 OrdinaryGetOwnMetadata(MetadataKey, O, P)
            // https://rbuckton.github.io/reflect-metadata/#ordinarygetownmetadata
            function OrdinaryGetOwnMetadata(MetadataKey, O, P) {
                var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
                if (IsUndefined(metadataMap))
                    return undefined;
                return metadataMap.get(MetadataKey);
            }
            // 3.1.5.1 OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P)
            // https://rbuckton.github.io/reflect-metadata/#ordinarydefineownmetadata
            function OrdinaryDefineOwnMetadata(MetadataKey, MetadataValue, O, P) {
                var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ true);
                metadataMap.set(MetadataKey, MetadataValue);
            }
            // 3.1.7.1 OrdinaryOwnMetadataKeys(O, P)
            // https://rbuckton.github.io/reflect-metadata/#ordinaryownmetadatakeys
            function OrdinaryOwnMetadataKeys(O, P) {
                var keys = [];
                var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
                if (IsUndefined(metadataMap))
                    return keys;
                var keysObj = metadataMap.keys();
                var iterator = GetIterator(keysObj);
                var k = 0;
                while (true) {
                    var next = IteratorStep(iterator);
                    if (!next) {
                        keys.length = k;
                        return keys;
                    }
                    var nextValue = IteratorValue(next);
                    try {
                        keys[k] = nextValue;
                    }
                    catch (e) {
                        try {
                            IteratorClose(iterator);
                        }
                        finally {
                            throw e;
                        }
                    }
                    k++;
                }
            }
            function OrdinaryDeleteMetadata(MetadataKey, O, P) {
                var metadataMap = GetOrCreateMetadataMap(O, P, /*Create*/ false);
                if (IsUndefined(metadataMap))
                    return false;
                if (!metadataMap.delete(MetadataKey))
                    return false;
                if (metadataMap.size === 0) {
                    var targetMetadata = metadata.get(O);
                    if (!IsUndefined(targetMetadata)) {
                        targetMetadata.delete(P);
                        if (targetMetadata.size === 0) {
                            metadata.delete(targetMetadata);
                        }
                    }
                }
                return true;
            }
        }
        function CreateFallbackProvider(reflect) {
            var defineMetadata = reflect.defineMetadata, hasOwnMetadata = reflect.hasOwnMetadata, getOwnMetadata = reflect.getOwnMetadata, getOwnMetadataKeys = reflect.getOwnMetadataKeys, deleteMetadata = reflect.deleteMetadata;
            var metadataOwner = new _WeakMap();
            var provider = {
                isProviderFor: function (O, P) {
                    var metadataPropertySet = metadataOwner.get(O);
                    if (!IsUndefined(metadataPropertySet) && metadataPropertySet.has(P)) {
                        return true;
                    }
                    if (getOwnMetadataKeys(O, P).length) {
                        if (IsUndefined(metadataPropertySet)) {
                            metadataPropertySet = new _Set();
                            metadataOwner.set(O, metadataPropertySet);
                        }
                        metadataPropertySet.add(P);
                        return true;
                    }
                    return false;
                },
                OrdinaryDefineOwnMetadata: defineMetadata,
                OrdinaryHasOwnMetadata: hasOwnMetadata,
                OrdinaryGetOwnMetadata: getOwnMetadata,
                OrdinaryOwnMetadataKeys: getOwnMetadataKeys,
                OrdinaryDeleteMetadata: deleteMetadata,
            };
            return provider;
        }
        /**
         * Gets the metadata provider for an object. If the object has no metadata provider and this is for a create operation,
         * then this module's metadata provider is assigned to the object.
         */
        function GetMetadataProvider(O, P, Create) {
            var registeredProvider = metadataRegistry.getProvider(O, P);
            if (!IsUndefined(registeredProvider)) {
                return registeredProvider;
            }
            if (Create) {
                if (metadataRegistry.setProvider(O, P, metadataProvider)) {
                    return metadataProvider;
                }
                throw new Error("Illegal state.");
            }
            return undefined;
        }
        // naive Map shim
        function CreateMapPolyfill() {
            var cacheSentinel = {};
            var arraySentinel = [];
            var MapIterator = /** @class */ (function () {
                function MapIterator(keys, values, selector) {
                    this._index = 0;
                    this._keys = keys;
                    this._values = values;
                    this._selector = selector;
                }
                MapIterator.prototype["@@iterator"] = function () { return this; };
                MapIterator.prototype[iteratorSymbol] = function () { return this; };
                MapIterator.prototype.next = function () {
                    var index = this._index;
                    if (index >= 0 && index < this._keys.length) {
                        var result = this._selector(this._keys[index], this._values[index]);
                        if (index + 1 >= this._keys.length) {
                            this._index = -1;
                            this._keys = arraySentinel;
                            this._values = arraySentinel;
                        }
                        else {
                            this._index++;
                        }
                        return { value: result, done: false };
                    }
                    return { value: undefined, done: true };
                };
                MapIterator.prototype.throw = function (error) {
                    if (this._index >= 0) {
                        this._index = -1;
                        this._keys = arraySentinel;
                        this._values = arraySentinel;
                    }
                    throw error;
                };
                MapIterator.prototype.return = function (value) {
                    if (this._index >= 0) {
                        this._index = -1;
                        this._keys = arraySentinel;
                        this._values = arraySentinel;
                    }
                    return { value: value, done: true };
                };
                return MapIterator;
            }());
            var Map = /** @class */ (function () {
                function Map() {
                    this._keys = [];
                    this._values = [];
                    this._cacheKey = cacheSentinel;
                    this._cacheIndex = -2;
                }
                Object.defineProperty(Map.prototype, "size", {
                    get: function () { return this._keys.length; },
                    enumerable: true,
                    configurable: true
                });
                Map.prototype.has = function (key) { return this._find(key, /*insert*/ false) >= 0; };
                Map.prototype.get = function (key) {
                    var index = this._find(key, /*insert*/ false);
                    return index >= 0 ? this._values[index] : undefined;
                };
                Map.prototype.set = function (key, value) {
                    var index = this._find(key, /*insert*/ true);
                    this._values[index] = value;
                    return this;
                };
                Map.prototype.delete = function (key) {
                    var index = this._find(key, /*insert*/ false);
                    if (index >= 0) {
                        var size = this._keys.length;
                        for (var i = index + 1; i < size; i++) {
                            this._keys[i - 1] = this._keys[i];
                            this._values[i - 1] = this._values[i];
                        }
                        this._keys.length--;
                        this._values.length--;
                        if (SameValueZero(key, this._cacheKey)) {
                            this._cacheKey = cacheSentinel;
                            this._cacheIndex = -2;
                        }
                        return true;
                    }
                    return false;
                };
                Map.prototype.clear = function () {
                    this._keys.length = 0;
                    this._values.length = 0;
                    this._cacheKey = cacheSentinel;
                    this._cacheIndex = -2;
                };
                Map.prototype.keys = function () { return new MapIterator(this._keys, this._values, getKey); };
                Map.prototype.values = function () { return new MapIterator(this._keys, this._values, getValue); };
                Map.prototype.entries = function () { return new MapIterator(this._keys, this._values, getEntry); };
                Map.prototype["@@iterator"] = function () { return this.entries(); };
                Map.prototype[iteratorSymbol] = function () { return this.entries(); };
                Map.prototype._find = function (key, insert) {
                    if (!SameValueZero(this._cacheKey, key)) {
                        this._cacheIndex = -1;
                        for (var i = 0; i < this._keys.length; i++) {
                            if (SameValueZero(this._keys[i], key)) {
                                this._cacheIndex = i;
                                break;
                            }
                        }
                    }
                    if (this._cacheIndex < 0 && insert) {
                        this._cacheIndex = this._keys.length;
                        this._keys.push(key);
                        this._values.push(undefined);
                    }
                    return this._cacheIndex;
                };
                return Map;
            }());
            return Map;
            function getKey(key, _) {
                return key;
            }
            function getValue(_, value) {
                return value;
            }
            function getEntry(key, value) {
                return [key, value];
            }
        }
        // naive Set shim
        function CreateSetPolyfill() {
            var Set = /** @class */ (function () {
                function Set() {
                    this._map = new _Map();
                }
                Object.defineProperty(Set.prototype, "size", {
                    get: function () { return this._map.size; },
                    enumerable: true,
                    configurable: true
                });
                Set.prototype.has = function (value) { return this._map.has(value); };
                Set.prototype.add = function (value) { return this._map.set(value, value), this; };
                Set.prototype.delete = function (value) { return this._map.delete(value); };
                Set.prototype.clear = function () { this._map.clear(); };
                Set.prototype.keys = function () { return this._map.keys(); };
                Set.prototype.values = function () { return this._map.keys(); };
                Set.prototype.entries = function () { return this._map.entries(); };
                Set.prototype["@@iterator"] = function () { return this.keys(); };
                Set.prototype[iteratorSymbol] = function () { return this.keys(); };
                return Set;
            }());
            return Set;
        }
        // naive WeakMap shim
        function CreateWeakMapPolyfill() {
            var UUID_SIZE = 16;
            var keys = HashMap.create();
            var rootKey = CreateUniqueKey();
            return /** @class */ (function () {
                function WeakMap() {
                    this._key = CreateUniqueKey();
                }
                WeakMap.prototype.has = function (target) {
                    var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                    return table !== undefined ? HashMap.has(table, this._key) : false;
                };
                WeakMap.prototype.get = function (target) {
                    var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                    return table !== undefined ? HashMap.get(table, this._key) : undefined;
                };
                WeakMap.prototype.set = function (target, value) {
                    var table = GetOrCreateWeakMapTable(target, /*create*/ true);
                    table[this._key] = value;
                    return this;
                };
                WeakMap.prototype.delete = function (target) {
                    var table = GetOrCreateWeakMapTable(target, /*create*/ false);
                    return table !== undefined ? delete table[this._key] : false;
                };
                WeakMap.prototype.clear = function () {
                    // NOTE: not a real clear, just makes the previous data unreachable
                    this._key = CreateUniqueKey();
                };
                return WeakMap;
            }());
            function CreateUniqueKey() {
                var key;
                do
                    key = "@@WeakMap@@" + CreateUUID();
                while (HashMap.has(keys, key));
                keys[key] = true;
                return key;
            }
            function GetOrCreateWeakMapTable(target, create) {
                if (!hasOwn.call(target, rootKey)) {
                    if (!create)
                        return undefined;
                    Object.defineProperty(target, rootKey, { value: HashMap.create() });
                }
                return target[rootKey];
            }
            function FillRandomBytes(buffer, size) {
                for (var i = 0; i < size; ++i)
                    buffer[i] = Math.random() * 0xff | 0;
                return buffer;
            }
            function GenRandomBytes(size) {
                if (typeof Uint8Array === "function") {
                    var array = new Uint8Array(size);
                    if (typeof crypto !== "undefined") {
                        crypto.getRandomValues(array);
                    }
                    else if (typeof msCrypto !== "undefined") {
                        msCrypto.getRandomValues(array);
                    }
                    else {
                        FillRandomBytes(array, size);
                    }
                    return array;
                }
                return FillRandomBytes(new Array(size), size);
            }
            function CreateUUID() {
                var data = GenRandomBytes(UUID_SIZE);
                // mark as random - RFC 4122 § 4.4
                data[6] = data[6] & 0x4f | 0x40;
                data[8] = data[8] & 0xbf | 0x80;
                var result = "";
                for (var offset = 0; offset < UUID_SIZE; ++offset) {
                    var byte = data[offset];
                    if (offset === 4 || offset === 6 || offset === 8)
                        result += "-";
                    if (byte < 16)
                        result += "0";
                    result += byte.toString(16).toLowerCase();
                }
                return result;
            }
        }
        // uses a heuristic used by v8 and chakra to force an object into dictionary mode.
        function MakeDictionary(obj) {
            obj.__ = undefined;
            delete obj.__;
            return obj;
        }
    });
})(Reflect$1 || (Reflect$1 = {}));

var dexie_min = {exports: {}};

(function (module, exports) {
	(function(e,t){module.exports=t();})(commonjsGlobal,function(){var s=function(e,t){return (s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t;}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);})(e,t)};var w=function(){return (w=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e}).apply(this,arguments)};function i(e,t,n){for(var r,i=0,o=t.length;i<o;i++)!r&&i in t||((r=r||Array.prototype.slice.call(t,0,i))[i]=t[i]);return e.concat(r||Array.prototype.slice.call(t))}var f="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:"undefined"!=typeof window?window:commonjsGlobal,_=Object.keys,x=Array.isArray;function a(t,n){return "object"!=typeof n||_(n).forEach(function(e){t[e]=n[e];}),t}"undefined"==typeof Promise||f.Promise||(f.Promise=Promise);var c=Object.getPrototypeOf,n={}.hasOwnProperty;function m(e,t){return n.call(e,t)}function r(t,n){"function"==typeof n&&(n=n(c(t))),("undefined"==typeof Reflect?_:Reflect.ownKeys)(n).forEach(function(e){l(t,e,n[e]);});}var u=Object.defineProperty;function l(e,t,n,r){u(e,t,a(n&&m(n,"get")&&"function"==typeof n.get?{get:n.get,set:n.set,configurable:!0}:{value:n,configurable:!0,writable:!0},r));}function o(t){return {from:function(e){return t.prototype=Object.create(e.prototype),l(t.prototype,"constructor",t),{extend:r.bind(null,t.prototype)}}}}var h=Object.getOwnPropertyDescriptor;var d=[].slice;function b(e,t,n){return d.call(e,t,n)}function p(e,t){return t(e)}function y(e){if(!e)throw new Error("Assertion Failed")}function v(e){f.setImmediate?setImmediate(e):setTimeout(e,0);}function k(e,t){if("string"==typeof t&&m(e,t))return e[t];if(!t)return e;if("string"!=typeof t){for(var n=[],r=0,i=t.length;r<i;++r){var o=k(e,t[r]);n.push(o);}return n}var a=t.indexOf(".");if(-1!==a){var u=e[t.substr(0,a)];return null==u?void 0:k(u,t.substr(a+1))}}function P(e,t,n){if(e&&void 0!==t&&!("isFrozen"in Object&&Object.isFrozen(e)))if("string"!=typeof t&&"length"in t){y("string"!=typeof n&&"length"in n);for(var r=0,i=t.length;r<i;++r)P(e,t[r],n[r]);}else {var o,a,u=t.indexOf(".");-1!==u?(o=t.substr(0,u),""===(a=t.substr(u+1))?void 0===n?x(e)&&!isNaN(parseInt(o))?e.splice(o,1):delete e[o]:e[o]=n:P(u=!(u=e[o])||!m(e,o)?e[o]={}:u,a,n)):void 0===n?x(e)&&!isNaN(parseInt(t))?e.splice(t,1):delete e[t]:e[t]=n;}}function g(e){var t,n={};for(t in e)m(e,t)&&(n[t]=e[t]);return n}var t=[].concat;function O(e){return t.apply([],e)}var e="BigUint64Array,BigInt64Array,Array,Boolean,String,Date,RegExp,Blob,File,FileList,FileSystemFileHandle,FileSystemDirectoryHandle,ArrayBuffer,DataView,Uint8ClampedArray,ImageBitmap,ImageData,Map,Set,CryptoKey".split(",").concat(O([8,16,32,64].map(function(t){return ["Int","Uint","Float"].map(function(e){return e+t+"Array"})}))).filter(function(e){return f[e]}),E=new Set(e.map(function(e){return f[e]}));var K=null;function S(e){K=new WeakMap;e=function e(t){if(!t||"object"!=typeof t)return t;var n=K.get(t);if(n)return n;if(x(t)){n=[],K.set(t,n);for(var r=0,i=t.length;r<i;++r)n.push(e(t[r]));}else if(E.has(t.constructor))n=t;else {var o,a=c(t);for(o in n=a===Object.prototype?{}:Object.create(a),K.set(t,n),t)m(t,o)&&(n[o]=e(t[o]));}return n}(e);return K=null,e}var j={}.toString;function A(e){return j.call(e).slice(8,-1)}var C="undefined"!=typeof Symbol?Symbol.iterator:"@@iterator",D="symbol"==typeof C?function(e){var t;return null!=e&&(t=e[C])&&t.apply(e)}:function(){return null};function T(e,t){t=e.indexOf(t);return 0<=t&&e.splice(t,1),0<=t}var q={};function I(e){var t,n,r,i;if(1===arguments.length){if(x(e))return e.slice();if(this===q&&"string"==typeof e)return [e];if(i=D(e)){for(n=[];!(r=i.next()).done;)n.push(r.value);return n}if(null==e)return [e];if("number"!=typeof(t=e.length))return [e];for(n=new Array(t);t--;)n[t]=e[t];return n}for(t=arguments.length,n=new Array(t);t--;)n[t]=arguments[t];return n}var B="undefined"!=typeof Symbol?function(e){return "AsyncFunction"===e[Symbol.toStringTag]}:function(){return !1},R=["Unknown","Constraint","Data","TransactionInactive","ReadOnly","Version","NotFound","InvalidState","InvalidAccess","Abort","Timeout","QuotaExceeded","Syntax","DataClone"],F=["Modify","Bulk","OpenFailed","VersionChange","Schema","Upgrade","InvalidTable","MissingAPI","NoSuchDatabase","InvalidArgument","SubTransaction","Unsupported","Internal","DatabaseClosed","PrematureCommit","ForeignAwait"].concat(R),M={VersionChanged:"Database version changed by other database connection",DatabaseClosed:"Database has been closed",Abort:"Transaction aborted",TransactionInactive:"Transaction has already completed or failed",MissingAPI:"IndexedDB API missing. Please visit https://tinyurl.com/y2uuvskb"};function N(e,t){this.name=e,this.message=t;}function L(e,t){return e+". Errors: "+Object.keys(t).map(function(e){return t[e].toString()}).filter(function(e,t,n){return n.indexOf(e)===t}).join("\n")}function U(e,t,n,r){this.failures=t,this.failedKeys=r,this.successCount=n,this.message=L(e,t);}function V(e,t){this.name="BulkError",this.failures=Object.keys(t).map(function(e){return t[e]}),this.failuresByPos=t,this.message=L(e,this.failures);}o(N).from(Error).extend({toString:function(){return this.name+": "+this.message}}),o(U).from(N),o(V).from(N);var z=F.reduce(function(e,t){return e[t]=t+"Error",e},{}),W=N,Y=F.reduce(function(e,n){var r=n+"Error";function t(e,t){this.name=r,e?"string"==typeof e?(this.message="".concat(e).concat(t?"\n "+t:""),this.inner=t||null):"object"==typeof e&&(this.message="".concat(e.name," ").concat(e.message),this.inner=e):(this.message=M[n]||r,this.inner=null);}return o(t).from(W),e[n]=t,e},{});Y.Syntax=SyntaxError,Y.Type=TypeError,Y.Range=RangeError;var $=R.reduce(function(e,t){return e[t+"Error"]=Y[t],e},{});var Q=F.reduce(function(e,t){return -1===["Syntax","Type","Range"].indexOf(t)&&(e[t+"Error"]=Y[t]),e},{});function G(){}function X(e){return e}function H(t,n){return null==t||t===X?n:function(e){return n(t(e))}}function J(e,t){return function(){e.apply(this,arguments),t.apply(this,arguments);}}function Z(i,o){return i===G?o:function(){var e=i.apply(this,arguments);void 0!==e&&(arguments[0]=e);var t=this.onsuccess,n=this.onerror;this.onsuccess=null,this.onerror=null;var r=o.apply(this,arguments);return t&&(this.onsuccess=this.onsuccess?J(t,this.onsuccess):t),n&&(this.onerror=this.onerror?J(n,this.onerror):n),void 0!==r?r:e}}function ee(n,r){return n===G?r:function(){n.apply(this,arguments);var e=this.onsuccess,t=this.onerror;this.onsuccess=this.onerror=null,r.apply(this,arguments),e&&(this.onsuccess=this.onsuccess?J(e,this.onsuccess):e),t&&(this.onerror=this.onerror?J(t,this.onerror):t);}}function te(i,o){return i===G?o:function(e){var t=i.apply(this,arguments);a(e,t);var n=this.onsuccess,r=this.onerror;this.onsuccess=null,this.onerror=null;e=o.apply(this,arguments);return n&&(this.onsuccess=this.onsuccess?J(n,this.onsuccess):n),r&&(this.onerror=this.onerror?J(r,this.onerror):r),void 0===t?void 0===e?void 0:e:a(t,e)}}function ne(e,t){return e===G?t:function(){return !1!==t.apply(this,arguments)&&e.apply(this,arguments)}}function re(i,o){return i===G?o:function(){var e=i.apply(this,arguments);if(e&&"function"==typeof e.then){for(var t=this,n=arguments.length,r=new Array(n);n--;)r[n]=arguments[n];return e.then(function(){return o.apply(t,r)})}return o.apply(this,arguments)}}Q.ModifyError=U,Q.DexieError=N,Q.BulkError=V;var ie="undefined"!=typeof location&&/^(http|https):\/\/(localhost|127\.0\.0\.1)/.test(location.href);function oe(e){ie=e;}var ae={},ue=100,e="undefined"==typeof Promise?[]:function(){var e=Promise.resolve();if("undefined"==typeof crypto||!crypto.subtle)return [e,c(e),e];var t=crypto.subtle.digest("SHA-512",new Uint8Array([0]));return [t,c(t),e]}(),R=e[0],F=e[1],e=e[2],F=F&&F.then,se=R&&R.constructor,ce=!!e;var le=function(e,t){be.push([e,t]),he&&(queueMicrotask(Se),he=!1);},fe=!0,he=!0,de=[],pe=[],ye=X,ve={id:"global",global:!0,ref:0,unhandleds:[],onunhandled:G,pgp:!1,env:{},finalize:G},me=ve,be=[],ge=0,we=[];function _e(e){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");this._listeners=[],this._lib=!1;var t=this._PSD=me;if("function"!=typeof e){if(e!==ae)throw new TypeError("Not a function");return this._state=arguments[1],this._value=arguments[2],void(!1===this._state&&Oe(this,this._value))}this._state=null,this._value=null,++t.ref,function t(r,e){try{e(function(n){if(null===r._state){if(n===r)throw new TypeError("A promise cannot be resolved with itself.");var e=r._lib&&je();n&&"function"==typeof n.then?t(r,function(e,t){n instanceof _e?n._then(e,t):n.then(e,t);}):(r._state=!0,r._value=n,Pe(r)),e&&Ae();}},Oe.bind(null,r));}catch(e){Oe(r,e);}}(this,e);}var xe={get:function(){var u=me,t=Fe;function e(n,r){var i=this,o=!u.global&&(u!==me||t!==Fe),a=o&&!Ue(),e=new _e(function(e,t){Ee(i,new ke(Qe(n,u,o,a),Qe(r,u,o,a),e,t,u));});return this._consoleTask&&(e._consoleTask=this._consoleTask),e}return e.prototype=ae,e},set:function(e){l(this,"then",e&&e.prototype===ae?xe:{get:function(){return e},set:xe.set});}};function ke(e,t,n,r,i){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof t?t:null,this.resolve=n,this.reject=r,this.psd=i;}function Oe(e,t){var n,r;pe.push(t),null===e._state&&(n=e._lib&&je(),t=ye(t),e._state=!1,e._value=t,r=e,de.some(function(e){return e._value===r._value})||de.push(r),Pe(e),n&&Ae());}function Pe(e){var t=e._listeners;e._listeners=[];for(var n=0,r=t.length;n<r;++n)Ee(e,t[n]);var i=e._PSD;--i.ref||i.finalize(),0===ge&&(++ge,le(function(){0==--ge&&Ce();},[]));}function Ee(e,t){if(null!==e._state){var n=e._state?t.onFulfilled:t.onRejected;if(null===n)return (e._state?t.resolve:t.reject)(e._value);++t.psd.ref,++ge,le(Ke,[n,e,t]);}else e._listeners.push(t);}function Ke(e,t,n){try{var r,i=t._value;!t._state&&pe.length&&(pe=[]),r=ie&&t._consoleTask?t._consoleTask.run(function(){return e(i)}):e(i),t._state||-1!==pe.indexOf(i)||function(e){var t=de.length;for(;t;)if(de[--t]._value===e._value)return de.splice(t,1)}(t),n.resolve(r);}catch(e){n.reject(e);}finally{0==--ge&&Ce(),--n.psd.ref||n.psd.finalize();}}function Se(){$e(ve,function(){je()&&Ae();});}function je(){var e=fe;return he=fe=!1,e}function Ae(){var e,t,n;do{for(;0<be.length;)for(e=be,be=[],n=e.length,t=0;t<n;++t){var r=e[t];r[0].apply(null,r[1]);}}while(0<be.length);he=fe=!0;}function Ce(){var e=de;de=[],e.forEach(function(e){e._PSD.onunhandled.call(null,e._value,e);});for(var t=we.slice(0),n=t.length;n;)t[--n]();}function De(e){return new _e(ae,!1,e)}function Te(n,r){var i=me;return function(){var e=je(),t=me;try{return We(i,!0),n.apply(this,arguments)}catch(e){r&&r(e);}finally{We(t,!1),e&&Ae();}}}r(_e.prototype,{then:xe,_then:function(e,t){Ee(this,new ke(null,null,e,t,me));},catch:function(e){if(1===arguments.length)return this.then(null,e);var t=e,n=arguments[1];return "function"==typeof t?this.then(null,function(e){return (e instanceof t?n:De)(e)}):this.then(null,function(e){return (e&&e.name===t?n:De)(e)})},finally:function(t){return this.then(function(e){return _e.resolve(t()).then(function(){return e})},function(e){return _e.resolve(t()).then(function(){return De(e)})})},timeout:function(r,i){var o=this;return r<1/0?new _e(function(e,t){var n=setTimeout(function(){return t(new Y.Timeout(i))},r);o.then(e,t).finally(clearTimeout.bind(null,n));}):this}}),"undefined"!=typeof Symbol&&Symbol.toStringTag&&l(_e.prototype,Symbol.toStringTag,"Dexie.Promise"),ve.env=Ye(),r(_e,{all:function(){var o=I.apply(null,arguments).map(Ve);return new _e(function(n,r){0===o.length&&n([]);var i=o.length;o.forEach(function(e,t){return _e.resolve(e).then(function(e){o[t]=e,--i||n(o);},r)});})},resolve:function(n){return n instanceof _e?n:n&&"function"==typeof n.then?new _e(function(e,t){n.then(e,t);}):new _e(ae,!0,n)},reject:De,race:function(){var e=I.apply(null,arguments).map(Ve);return new _e(function(t,n){e.map(function(e){return _e.resolve(e).then(t,n)});})},PSD:{get:function(){return me},set:function(e){return me=e}},totalEchoes:{get:function(){return Fe}},newPSD:Ne,usePSD:$e,scheduler:{get:function(){return le},set:function(e){le=e;}},rejectionMapper:{get:function(){return ye},set:function(e){ye=e;}},follow:function(i,n){return new _e(function(e,t){return Ne(function(n,r){var e=me;e.unhandleds=[],e.onunhandled=r,e.finalize=J(function(){var t,e=this;t=function(){0===e.unhandleds.length?n():r(e.unhandleds[0]);},we.push(function e(){t(),we.splice(we.indexOf(e),1);}),++ge,le(function(){0==--ge&&Ce();},[]);},e.finalize),i();},n,e,t)})}}),se&&(se.allSettled&&l(_e,"allSettled",function(){var e=I.apply(null,arguments).map(Ve);return new _e(function(n){0===e.length&&n([]);var r=e.length,i=new Array(r);e.forEach(function(e,t){return _e.resolve(e).then(function(e){return i[t]={status:"fulfilled",value:e}},function(e){return i[t]={status:"rejected",reason:e}}).then(function(){return --r||n(i)})});})}),se.any&&"undefined"!=typeof AggregateError&&l(_e,"any",function(){var e=I.apply(null,arguments).map(Ve);return new _e(function(n,r){0===e.length&&r(new AggregateError([]));var i=e.length,o=new Array(i);e.forEach(function(e,t){return _e.resolve(e).then(function(e){return n(e)},function(e){o[t]=e,--i||r(new AggregateError(o));})});})}));var qe={awaits:0,echoes:0,id:0},Ie=0,Be=[],Re=0,Fe=0,Me=0;function Ne(e,t,n,r){var i=me,o=Object.create(i);o.parent=i,o.ref=0,o.global=!1,o.id=++Me,ve.env,o.env=ce?{Promise:_e,PromiseProp:{value:_e,configurable:!0,writable:!0},all:_e.all,race:_e.race,allSettled:_e.allSettled,any:_e.any,resolve:_e.resolve,reject:_e.reject}:{},t&&a(o,t),++i.ref,o.finalize=function(){--this.parent.ref||this.parent.finalize();};r=$e(o,e,n,r);return 0===o.ref&&o.finalize(),r}function Le(){return qe.id||(qe.id=++Ie),++qe.awaits,qe.echoes+=ue,qe.id}function Ue(){return !!qe.awaits&&(0==--qe.awaits&&(qe.id=0),qe.echoes=qe.awaits*ue,!0)}function Ve(e){return qe.echoes&&e&&e.constructor===se?(Le(),e.then(function(e){return Ue(),e},function(e){return Ue(),Xe(e)})):e}function ze(){var e=Be[Be.length-1];Be.pop(),We(e,!1);}function We(e,t){var n,r=me;(t?!qe.echoes||Re++&&e===me:!Re||--Re&&e===me)||queueMicrotask(t?function(e){++Fe,qe.echoes&&0!=--qe.echoes||(qe.echoes=qe.awaits=qe.id=0),Be.push(me),We(e,!0);}.bind(null,e):ze),e!==me&&(me=e,r===ve&&(ve.env=Ye()),ce&&(n=ve.env.Promise,t=e.env,(r.global||e.global)&&(Object.defineProperty(f,"Promise",t.PromiseProp),n.all=t.all,n.race=t.race,n.resolve=t.resolve,n.reject=t.reject,t.allSettled&&(n.allSettled=t.allSettled),t.any&&(n.any=t.any))));}function Ye(){var e=f.Promise;return ce?{Promise:e,PromiseProp:Object.getOwnPropertyDescriptor(f,"Promise"),all:e.all,race:e.race,allSettled:e.allSettled,any:e.any,resolve:e.resolve,reject:e.reject}:{}}function $e(e,t,n,r,i){var o=me;try{return We(e,!0),t(n,r,i)}finally{We(o,!1);}}function Qe(t,n,r,i){return "function"!=typeof t?t:function(){var e=me;r&&Le(),We(n,!0);try{return t.apply(this,arguments)}finally{We(e,!1),i&&queueMicrotask(Ue);}}}function Ge(e){Promise===se&&0===qe.echoes?0===Re?e():enqueueNativeMicroTask(e):setTimeout(e,0);}-1===(""+F).indexOf("[native code]")&&(Le=Ue=G);var Xe=_e.reject;var He=String.fromCharCode(65535),Je="Invalid key provided. Keys must be of type string, number, Date or Array<string | number | Date>.",Ze="String expected.",et=[],tt="__dbnames",nt="readonly",rt="readwrite";function it(e,t){return e?t?function(){return e.apply(this,arguments)&&t.apply(this,arguments)}:e:t}var ot={type:3,lower:-1/0,lowerOpen:!1,upper:[[]],upperOpen:!1};function at(t){return "string"!=typeof t||/\./.test(t)?function(e){return e}:function(e){return void 0===e[t]&&t in e&&delete(e=S(e))[t],e}}function ut(){throw Y.Type()}function st(e,t){try{var n=ct(e),r=ct(t);if(n!==r)return "Array"===n?1:"Array"===r?-1:"binary"===n?1:"binary"===r?-1:"string"===n?1:"string"===r?-1:"Date"===n?1:"Date"!==r?NaN:-1;switch(n){case"number":case"Date":case"string":return t<e?1:e<t?-1:0;case"binary":return function(e,t){for(var n=e.length,r=t.length,i=n<r?n:r,o=0;o<i;++o)if(e[o]!==t[o])return e[o]<t[o]?-1:1;return n===r?0:n<r?-1:1}(lt(e),lt(t));case"Array":return function(e,t){for(var n=e.length,r=t.length,i=n<r?n:r,o=0;o<i;++o){var a=st(e[o],t[o]);if(0!==a)return a}return n===r?0:n<r?-1:1}(e,t)}}catch(e){}return NaN}function ct(e){var t=typeof e;if("object"!=t)return t;if(ArrayBuffer.isView(e))return "binary";e=A(e);return "ArrayBuffer"===e?"binary":e}function lt(e){return e instanceof Uint8Array?e:ArrayBuffer.isView(e)?new Uint8Array(e.buffer,e.byteOffset,e.byteLength):new Uint8Array(e)}var ft=(ht.prototype._trans=function(e,r,t){var n=this._tx||me.trans,i=this.name,o=ie&&"undefined"!=typeof console&&console.createTask&&console.createTask("Dexie: ".concat("readonly"===e?"read":"write"," ").concat(this.name));function a(e,t,n){if(!n.schema[i])throw new Y.NotFound("Table "+i+" not part of transaction");return r(n.idbtrans,n)}var u=je();try{var s=n&&n.db._novip===this.db._novip?n===me.trans?n._promise(e,a,t):Ne(function(){return n._promise(e,a,t)},{trans:n,transless:me.transless||me}):function t(n,r,i,o){if(n.idbdb&&(n._state.openComplete||me.letThrough||n._vip)){var a=n._createTransaction(r,i,n._dbSchema);try{a.create(),n._state.PR1398_maxLoop=3;}catch(e){return e.name===z.InvalidState&&n.isOpen()&&0<--n._state.PR1398_maxLoop?(console.warn("Dexie: Need to reopen db"),n.close({disableAutoOpen:!1}),n.open().then(function(){return t(n,r,i,o)})):Xe(e)}return a._promise(r,function(e,t){return Ne(function(){return me.trans=a,o(e,t,a)})}).then(function(e){if("readwrite"===r)try{a.idbtrans.commit();}catch(e){}return "readonly"===r?e:a._completion.then(function(){return e})})}if(n._state.openComplete)return Xe(new Y.DatabaseClosed(n._state.dbOpenError));if(!n._state.isBeingOpened){if(!n._state.autoOpen)return Xe(new Y.DatabaseClosed);n.open().catch(G);}return n._state.dbReadyPromise.then(function(){return t(n,r,i,o)})}(this.db,e,[this.name],a);return o&&(s._consoleTask=o,s=s.catch(function(e){return console.trace(e),Xe(e)})),s}finally{u&&Ae();}},ht.prototype.get=function(t,e){var n=this;return t&&t.constructor===Object?this.where(t).first(e):null==t?Xe(new Y.Type("Invalid argument to Table.get()")):this._trans("readonly",function(e){return n.core.get({trans:e,key:t}).then(function(e){return n.hook.reading.fire(e)})}).then(e)},ht.prototype.where=function(o){if("string"==typeof o)return new this.db.WhereClause(this,o);if(x(o))return new this.db.WhereClause(this,"[".concat(o.join("+"),"]"));var n=_(o);if(1===n.length)return this.where(n[0]).equals(o[n[0]]);var e=this.schema.indexes.concat(this.schema.primKey).filter(function(t){if(t.compound&&n.every(function(e){return 0<=t.keyPath.indexOf(e)})){for(var e=0;e<n.length;++e)if(-1===n.indexOf(t.keyPath[e]))return !1;return !0}return !1}).sort(function(e,t){return e.keyPath.length-t.keyPath.length})[0];if(e&&this.db._maxKey!==He){var t=e.keyPath.slice(0,n.length);return this.where(t).equals(t.map(function(e){return o[e]}))}!e&&ie&&console.warn("The query ".concat(JSON.stringify(o)," on ").concat(this.name," would benefit from a ")+"compound index [".concat(n.join("+"),"]"));var a=this.schema.idxByName,r=this.db._deps.indexedDB;function u(e,t){return 0===r.cmp(e,t)}var i=n.reduce(function(e,t){var n=e[0],r=e[1],e=a[t],i=o[t];return [n||e,n||!e?it(r,e&&e.multi?function(e){e=k(e,t);return x(e)&&e.some(function(e){return u(i,e)})}:function(e){return u(i,k(e,t))}):r]},[null,null]),t=i[0],i=i[1];return t?this.where(t.name).equals(o[t.keyPath]).filter(i):e?this.filter(i):this.where(n).equals("")},ht.prototype.filter=function(e){return this.toCollection().and(e)},ht.prototype.count=function(e){return this.toCollection().count(e)},ht.prototype.offset=function(e){return this.toCollection().offset(e)},ht.prototype.limit=function(e){return this.toCollection().limit(e)},ht.prototype.each=function(e){return this.toCollection().each(e)},ht.prototype.toArray=function(e){return this.toCollection().toArray(e)},ht.prototype.toCollection=function(){return new this.db.Collection(new this.db.WhereClause(this))},ht.prototype.orderBy=function(e){return new this.db.Collection(new this.db.WhereClause(this,x(e)?"[".concat(e.join("+"),"]"):e))},ht.prototype.reverse=function(){return this.toCollection().reverse()},ht.prototype.mapToClass=function(r){var e,t=this.db,n=this.name;function i(){return null!==e&&e.apply(this,arguments)||this}(this.schema.mappedClass=r).prototype instanceof ut&&(function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e;}s(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n);}(i,e=r),Object.defineProperty(i.prototype,"db",{get:function(){return t},enumerable:!1,configurable:!0}),i.prototype.table=function(){return n},r=i);for(var o=new Set,a=r.prototype;a;a=c(a))Object.getOwnPropertyNames(a).forEach(function(e){return o.add(e)});function u(e){if(!e)return e;var t,n=Object.create(r.prototype);for(t in e)if(!o.has(t))try{n[t]=e[t];}catch(e){}return n}return this.schema.readHook&&this.hook.reading.unsubscribe(this.schema.readHook),this.schema.readHook=u,this.hook("reading",u),r},ht.prototype.defineClass=function(){return this.mapToClass(function(e){a(this,e);})},ht.prototype.add=function(t,n){var r=this,e=this.schema.primKey,i=e.auto,o=e.keyPath,a=t;return o&&i&&(a=at(o)(t)),this._trans("readwrite",function(e){return r.core.mutate({trans:e,type:"add",keys:null!=n?[n]:null,values:[a]})}).then(function(e){return e.numFailures?_e.reject(e.failures[0]):e.lastResult}).then(function(e){if(o)try{P(t,o,e);}catch(e){}return e})},ht.prototype.update=function(e,t){if("object"!=typeof e||x(e))return this.where(":id").equals(e).modify(t);e=k(e,this.schema.primKey.keyPath);return void 0===e?Xe(new Y.InvalidArgument("Given object does not contain its primary key")):this.where(":id").equals(e).modify(t)},ht.prototype.put=function(t,n){var r=this,e=this.schema.primKey,i=e.auto,o=e.keyPath,a=t;return o&&i&&(a=at(o)(t)),this._trans("readwrite",function(e){return r.core.mutate({trans:e,type:"put",values:[a],keys:null!=n?[n]:null})}).then(function(e){return e.numFailures?_e.reject(e.failures[0]):e.lastResult}).then(function(e){if(o)try{P(t,o,e);}catch(e){}return e})},ht.prototype.delete=function(t){var n=this;return this._trans("readwrite",function(e){return n.core.mutate({trans:e,type:"delete",keys:[t]})}).then(function(e){return e.numFailures?_e.reject(e.failures[0]):void 0})},ht.prototype.clear=function(){var t=this;return this._trans("readwrite",function(e){return t.core.mutate({trans:e,type:"deleteRange",range:ot})}).then(function(e){return e.numFailures?_e.reject(e.failures[0]):void 0})},ht.prototype.bulkGet=function(t){var n=this;return this._trans("readonly",function(e){return n.core.getMany({keys:t,trans:e}).then(function(e){return e.map(function(e){return n.hook.reading.fire(e)})})})},ht.prototype.bulkAdd=function(r,e,t){var o=this,a=Array.isArray(e)?e:void 0,u=(t=t||(a?void 0:e))?t.allKeys:void 0;return this._trans("readwrite",function(e){var t=o.schema.primKey,n=t.auto,t=t.keyPath;if(t&&a)throw new Y.InvalidArgument("bulkAdd(): keys argument invalid on tables with inbound keys");if(a&&a.length!==r.length)throw new Y.InvalidArgument("Arguments objects and keys must have the same length");var i=r.length,t=t&&n?r.map(at(t)):r;return o.core.mutate({trans:e,type:"add",keys:a,values:t,wantResults:u}).then(function(e){var t=e.numFailures,n=e.results,r=e.lastResult,e=e.failures;if(0===t)return u?n:r;throw new V("".concat(o.name,".bulkAdd(): ").concat(t," of ").concat(i," operations failed"),e)})})},ht.prototype.bulkPut=function(r,e,t){var o=this,a=Array.isArray(e)?e:void 0,u=(t=t||(a?void 0:e))?t.allKeys:void 0;return this._trans("readwrite",function(e){var t=o.schema.primKey,n=t.auto,t=t.keyPath;if(t&&a)throw new Y.InvalidArgument("bulkPut(): keys argument invalid on tables with inbound keys");if(a&&a.length!==r.length)throw new Y.InvalidArgument("Arguments objects and keys must have the same length");var i=r.length,t=t&&n?r.map(at(t)):r;return o.core.mutate({trans:e,type:"put",keys:a,values:t,wantResults:u}).then(function(e){var t=e.numFailures,n=e.results,r=e.lastResult,e=e.failures;if(0===t)return u?n:r;throw new V("".concat(o.name,".bulkPut(): ").concat(t," of ").concat(i," operations failed"),e)})})},ht.prototype.bulkUpdate=function(t){var h=this,n=this.core,r=t.map(function(e){return e.key}),i=t.map(function(e){return e.changes}),d=[];return this._trans("readwrite",function(e){return n.getMany({trans:e,keys:r,cache:"clone"}).then(function(c){var l=[],f=[];t.forEach(function(e,t){var n=e.key,r=e.changes,i=c[t];if(i){for(var o=0,a=Object.keys(r);o<a.length;o++){var u=a[o],s=r[u];if(u===h.schema.primKey.keyPath){if(0!==st(s,n))throw new Y.Constraint("Cannot update primary key in bulkUpdate()")}else P(i,u,s);}d.push(t),l.push(n),f.push(i);}});var s=l.length;return n.mutate({trans:e,type:"put",keys:l,values:f,updates:{keys:r,changeSpecs:i}}).then(function(e){var t=e.numFailures,n=e.failures;if(0===t)return s;for(var r=0,i=Object.keys(n);r<i.length;r++){var o,a=i[r],u=d[Number(a)];null!=u&&(o=n[a],delete n[a],n[u]=o);}throw new V("".concat(h.name,".bulkUpdate(): ").concat(t," of ").concat(s," operations failed"),n)})})})},ht.prototype.bulkDelete=function(t){var r=this,i=t.length;return this._trans("readwrite",function(e){return r.core.mutate({trans:e,type:"delete",keys:t})}).then(function(e){var t=e.numFailures,n=e.lastResult,e=e.failures;if(0===t)return n;throw new V("".concat(r.name,".bulkDelete(): ").concat(t," of ").concat(i," operations failed"),e)})},ht);function ht(){}function dt(i){function t(e,t){if(t){for(var n=arguments.length,r=new Array(n-1);--n;)r[n-1]=arguments[n];return a[e].subscribe.apply(null,r),i}if("string"==typeof e)return a[e]}var a={};t.addEventType=u;for(var e=1,n=arguments.length;e<n;++e)u(arguments[e]);return t;function u(e,n,r){if("object"!=typeof e){var i;n=n||ne;var o={subscribers:[],fire:r=r||G,subscribe:function(e){-1===o.subscribers.indexOf(e)&&(o.subscribers.push(e),o.fire=n(o.fire,e));},unsubscribe:function(t){o.subscribers=o.subscribers.filter(function(e){return e!==t}),o.fire=o.subscribers.reduce(n,r);}};return a[e]=t[e]=o}_(i=e).forEach(function(e){var t=i[e];if(x(t))u(e,i[e][0],i[e][1]);else {if("asap"!==t)throw new Y.InvalidArgument("Invalid event config");var n=u(e,X,function(){for(var e=arguments.length,t=new Array(e);e--;)t[e]=arguments[e];n.subscribers.forEach(function(e){v(function(){e.apply(null,t);});});});}});}}function pt(e,t){return o(t).from({prototype:e}),t}function yt(e,t){return !(e.filter||e.algorithm||e.or)&&(t?e.justLimit:!e.replayFilter)}function vt(e,t){e.filter=it(e.filter,t);}function mt(e,t,n){var r=e.replayFilter;e.replayFilter=r?function(){return it(r(),t())}:t,e.justLimit=n&&!r;}function bt(e,t){if(e.isPrimKey)return t.primaryKey;var n=t.getIndexByKeyPath(e.index);if(!n)throw new Y.Schema("KeyPath "+e.index+" on object store "+t.name+" is not indexed");return n}function gt(e,t,n){var r=bt(e,t.schema);return t.openCursor({trans:n,values:!e.keysOnly,reverse:"prev"===e.dir,unique:!!e.unique,query:{index:r,range:e.range}})}function wt(e,o,t,n){var a=e.replayFilter?it(e.filter,e.replayFilter()):e.filter;if(e.or){var u={},r=function(e,t,n){var r,i;a&&!a(t,n,function(e){return t.stop(e)},function(e){return t.fail(e)})||("[object ArrayBuffer]"===(i=""+(r=t.primaryKey))&&(i=""+new Uint8Array(r)),m(u,i)||(u[i]=!0,o(e,t,n)));};return Promise.all([e.or._iterate(r,t),_t(gt(e,n,t),e.algorithm,r,!e.keysOnly&&e.valueMapper)])}return _t(gt(e,n,t),it(e.algorithm,a),o,!e.keysOnly&&e.valueMapper)}function _t(e,r,i,o){var a=Te(o?function(e,t,n){return i(o(e),t,n)}:i);return e.then(function(n){if(n)return n.start(function(){var t=function(){return n.continue()};r&&!r(n,function(e){return t=e},function(e){n.stop(e),t=G;},function(e){n.fail(e),t=G;})||a(n.value,n,function(e){return t=e}),t();})})}var e=Symbol(),xt=(kt.prototype.execute=function(e){if(void 0!==this.add){var t=this.add;if(x(t))return i(i([],x(e)?e:[],!0),t).sort();if("number"==typeof t)return (Number(e)||0)+t;if("bigint"==typeof t)try{return BigInt(e)+t}catch(e){return BigInt(0)+t}throw new TypeError("Invalid term ".concat(t))}if(void 0!==this.remove){var n=this.remove;if(x(n))return x(e)?e.filter(function(e){return !n.includes(e)}).sort():[];if("number"==typeof n)return Number(e)-n;if("bigint"==typeof n)try{return BigInt(e)-n}catch(e){return BigInt(0)-n}throw new TypeError("Invalid subtrahend ".concat(n))}t=null===(t=this.replacePrefix)||void 0===t?void 0:t[0];return t&&"string"==typeof e&&e.startsWith(t)?this.replacePrefix[1]+e.substring(t.length):e},kt);function kt(e){Object.assign(this,e);}var Ot=(Pt.prototype._read=function(e,t){var n=this._ctx;return n.error?n.table._trans(null,Xe.bind(null,n.error)):n.table._trans("readonly",e).then(t)},Pt.prototype._write=function(e){var t=this._ctx;return t.error?t.table._trans(null,Xe.bind(null,t.error)):t.table._trans("readwrite",e,"locked")},Pt.prototype._addAlgorithm=function(e){var t=this._ctx;t.algorithm=it(t.algorithm,e);},Pt.prototype._iterate=function(e,t){return wt(this._ctx,e,t,this._ctx.table.core)},Pt.prototype.clone=function(e){var t=Object.create(this.constructor.prototype),n=Object.create(this._ctx);return e&&a(n,e),t._ctx=n,t},Pt.prototype.raw=function(){return this._ctx.valueMapper=null,this},Pt.prototype.each=function(t){var n=this._ctx;return this._read(function(e){return wt(n,t,e,n.table.core)})},Pt.prototype.count=function(e){var i=this;return this._read(function(e){var t=i._ctx,n=t.table.core;if(yt(t,!0))return n.count({trans:e,query:{index:bt(t,n.schema),range:t.range}}).then(function(e){return Math.min(e,t.limit)});var r=0;return wt(t,function(){return ++r,!1},e,n).then(function(){return r})}).then(e)},Pt.prototype.sortBy=function(e,t){var n=e.split(".").reverse(),r=n[0],i=n.length-1;function o(e,t){return t?o(e[n[t]],t-1):e[r]}var a="next"===this._ctx.dir?1:-1;function u(e,t){e=o(e,i),t=o(t,i);return e<t?-a:t<e?a:0}return this.toArray(function(e){return e.sort(u)}).then(t)},Pt.prototype.toArray=function(e){var o=this;return this._read(function(e){var t=o._ctx;if("next"===t.dir&&yt(t,!0)&&0<t.limit){var n=t.valueMapper,r=bt(t,t.table.core.schema);return t.table.core.query({trans:e,limit:t.limit,values:!0,query:{index:r,range:t.range}}).then(function(e){e=e.result;return n?e.map(n):e})}var i=[];return wt(t,function(e){return i.push(e)},e,t.table.core).then(function(){return i})},e)},Pt.prototype.offset=function(t){var e=this._ctx;return t<=0||(e.offset+=t,yt(e)?mt(e,function(){var n=t;return function(e,t){return 0===n||(1===n?--n:t(function(){e.advance(n),n=0;}),!1)}}):mt(e,function(){var e=t;return function(){return --e<0}})),this},Pt.prototype.limit=function(e){return this._ctx.limit=Math.min(this._ctx.limit,e),mt(this._ctx,function(){var r=e;return function(e,t,n){return --r<=0&&t(n),0<=r}},!0),this},Pt.prototype.until=function(r,i){return vt(this._ctx,function(e,t,n){return !r(e.value)||(t(n),i)}),this},Pt.prototype.first=function(e){return this.limit(1).toArray(function(e){return e[0]}).then(e)},Pt.prototype.last=function(e){return this.reverse().first(e)},Pt.prototype.filter=function(t){var e;return vt(this._ctx,function(e){return t(e.value)}),(e=this._ctx).isMatch=it(e.isMatch,t),this},Pt.prototype.and=function(e){return this.filter(e)},Pt.prototype.or=function(e){return new this.db.WhereClause(this._ctx.table,e,this)},Pt.prototype.reverse=function(){return this._ctx.dir="prev"===this._ctx.dir?"next":"prev",this._ondirectionchange&&this._ondirectionchange(this._ctx.dir),this},Pt.prototype.desc=function(){return this.reverse()},Pt.prototype.eachKey=function(n){var e=this._ctx;return e.keysOnly=!e.isMatch,this.each(function(e,t){n(t.key,t);})},Pt.prototype.eachUniqueKey=function(e){return this._ctx.unique="unique",this.eachKey(e)},Pt.prototype.eachPrimaryKey=function(n){var e=this._ctx;return e.keysOnly=!e.isMatch,this.each(function(e,t){n(t.primaryKey,t);})},Pt.prototype.keys=function(e){var t=this._ctx;t.keysOnly=!t.isMatch;var n=[];return this.each(function(e,t){n.push(t.key);}).then(function(){return n}).then(e)},Pt.prototype.primaryKeys=function(e){var n=this._ctx;if("next"===n.dir&&yt(n,!0)&&0<n.limit)return this._read(function(e){var t=bt(n,n.table.core.schema);return n.table.core.query({trans:e,values:!1,limit:n.limit,query:{index:t,range:n.range}})}).then(function(e){return e.result}).then(e);n.keysOnly=!n.isMatch;var r=[];return this.each(function(e,t){r.push(t.primaryKey);}).then(function(){return r}).then(e)},Pt.prototype.uniqueKeys=function(e){return this._ctx.unique="unique",this.keys(e)},Pt.prototype.firstKey=function(e){return this.limit(1).keys(function(e){return e[0]}).then(e)},Pt.prototype.lastKey=function(e){return this.reverse().firstKey(e)},Pt.prototype.distinct=function(){var e=this._ctx,e=e.index&&e.table.schema.idxByName[e.index];if(!e||!e.multi)return this;var n={};return vt(this._ctx,function(e){var t=e.primaryKey.toString(),e=m(n,t);return n[t]=!0,!e}),this},Pt.prototype.modify=function(w){var n=this,r=this._ctx;return this._write(function(d){var a,u,p;p="function"==typeof w?w:(a=_(w),u=a.length,function(e){for(var t=!1,n=0;n<u;++n){var r=a[n],i=w[r],o=k(e,r);i instanceof xt?(P(e,r,i.execute(o)),t=!0):o!==i&&(P(e,r,i),t=!0);}return t});function y(e,t){var n=t.failures,t=t.numFailures;c+=e-t;for(var r=0,i=_(n);r<i.length;r++){var o=i[r];s.push(n[o]);}}var v=r.table.core,e=v.schema.primaryKey,m=e.outbound,b=e.extractKey,g=n.db._options.modifyChunkSize||200,s=[],c=0,t=[];return n.clone().primaryKeys().then(function(l){function f(s){var c=Math.min(g,l.length-s);return v.getMany({trans:d,keys:l.slice(s,s+c),cache:"immutable"}).then(function(e){for(var n=[],t=[],r=m?[]:null,i=[],o=0;o<c;++o){var a=e[o],u={value:S(a),primKey:l[s+o]};!1!==p.call(u,u.value,u)&&(null==u.value?i.push(l[s+o]):m||0===st(b(a),b(u.value))?(t.push(u.value),m&&r.push(l[s+o])):(i.push(l[s+o]),n.push(u.value)));}return Promise.resolve(0<n.length&&v.mutate({trans:d,type:"add",values:n}).then(function(e){for(var t in e.failures)i.splice(parseInt(t),1);y(n.length,e);})).then(function(){return (0<t.length||h&&"object"==typeof w)&&v.mutate({trans:d,type:"put",keys:r,values:t,criteria:h,changeSpec:"function"!=typeof w&&w,isAdditionalChunk:0<s}).then(function(e){return y(t.length,e)})}).then(function(){return (0<i.length||h&&w===Et)&&v.mutate({trans:d,type:"delete",keys:i,criteria:h,isAdditionalChunk:0<s}).then(function(e){return y(i.length,e)})}).then(function(){return l.length>s+c&&f(s+g)})})}var h=yt(r)&&r.limit===1/0&&("function"!=typeof w||w===Et)&&{index:r.index,range:r.range};return f(0).then(function(){if(0<s.length)throw new U("Error modifying one or more objects",s,c,t);return l.length})})})},Pt.prototype.delete=function(){var i=this._ctx,n=i.range;return yt(i)&&(i.isPrimKey||3===n.type)?this._write(function(e){var t=i.table.core.schema.primaryKey,r=n;return i.table.core.count({trans:e,query:{index:t,range:r}}).then(function(n){return i.table.core.mutate({trans:e,type:"deleteRange",range:r}).then(function(e){var t=e.failures;e.lastResult,e.results;e=e.numFailures;if(e)throw new U("Could not delete some values",Object.keys(t).map(function(e){return t[e]}),n-e);return n-e})})}):this.modify(Et)},Pt);function Pt(){}var Et=function(e,t){return t.value=null};function Kt(e,t){return e<t?-1:e===t?0:1}function St(e,t){return t<e?-1:e===t?0:1}function jt(e,t,n){e=e instanceof qt?new e.Collection(e):e;return e._ctx.error=new(n||TypeError)(t),e}function At(e){return new e.Collection(e,function(){return Tt("")}).limit(0)}function Ct(e,s,n,r){var i,c,l,f,h,d,p,y=n.length;if(!n.every(function(e){return "string"==typeof e}))return jt(e,Ze);function t(e){i="next"===e?function(e){return e.toUpperCase()}:function(e){return e.toLowerCase()},c="next"===e?function(e){return e.toLowerCase()}:function(e){return e.toUpperCase()},l="next"===e?Kt:St;var t=n.map(function(e){return {lower:c(e),upper:i(e)}}).sort(function(e,t){return l(e.lower,t.lower)});f=t.map(function(e){return e.upper}),h=t.map(function(e){return e.lower}),p="next"===(d=e)?"":r;}t("next");e=new e.Collection(e,function(){return Dt(f[0],h[y-1]+r)});e._ondirectionchange=function(e){t(e);};var v=0;return e._addAlgorithm(function(e,t,n){var r=e.key;if("string"!=typeof r)return !1;var i=c(r);if(s(i,h,v))return !0;for(var o=null,a=v;a<y;++a){var u=function(e,t,n,r,i,o){for(var a=Math.min(e.length,r.length),u=-1,s=0;s<a;++s){var c=t[s];if(c!==r[s])return i(e[s],n[s])<0?e.substr(0,s)+n[s]+n.substr(s+1):i(e[s],r[s])<0?e.substr(0,s)+r[s]+n.substr(s+1):0<=u?e.substr(0,u)+t[u]+n.substr(u+1):null;i(e[s],c)<0&&(u=s);}return a<r.length&&"next"===o?e+n.substr(e.length):a<e.length&&"prev"===o?e.substr(0,n.length):u<0?null:e.substr(0,u)+r[u]+n.substr(u+1)}(r,i,f[a],h[a],l,d);null===u&&null===o?v=a+1:(null===o||0<l(o,u))&&(o=u);}return t(null!==o?function(){e.continue(o+p);}:n),!1}),e}function Dt(e,t,n,r){return {type:2,lower:e,upper:t,lowerOpen:n,upperOpen:r}}function Tt(e){return {type:1,lower:e,upper:e}}var qt=(Object.defineProperty(It.prototype,"Collection",{get:function(){return this._ctx.table.db.Collection},enumerable:!1,configurable:!0}),It.prototype.between=function(e,t,n,r){n=!1!==n,r=!0===r;try{return 0<this._cmp(e,t)||0===this._cmp(e,t)&&(n||r)&&(!n||!r)?At(this):new this.Collection(this,function(){return Dt(e,t,!n,!r)})}catch(e){return jt(this,Je)}},It.prototype.equals=function(e){return null==e?jt(this,Je):new this.Collection(this,function(){return Tt(e)})},It.prototype.above=function(e){return null==e?jt(this,Je):new this.Collection(this,function(){return Dt(e,void 0,!0)})},It.prototype.aboveOrEqual=function(e){return null==e?jt(this,Je):new this.Collection(this,function(){return Dt(e,void 0,!1)})},It.prototype.below=function(e){return null==e?jt(this,Je):new this.Collection(this,function(){return Dt(void 0,e,!1,!0)})},It.prototype.belowOrEqual=function(e){return null==e?jt(this,Je):new this.Collection(this,function(){return Dt(void 0,e)})},It.prototype.startsWith=function(e){return "string"!=typeof e?jt(this,Ze):this.between(e,e+He,!0,!0)},It.prototype.startsWithIgnoreCase=function(e){return ""===e?this.startsWith(e):Ct(this,function(e,t){return 0===e.indexOf(t[0])},[e],He)},It.prototype.equalsIgnoreCase=function(e){return Ct(this,function(e,t){return e===t[0]},[e],"")},It.prototype.anyOfIgnoreCase=function(){var e=I.apply(q,arguments);return 0===e.length?At(this):Ct(this,function(e,t){return -1!==t.indexOf(e)},e,"")},It.prototype.startsWithAnyOfIgnoreCase=function(){var e=I.apply(q,arguments);return 0===e.length?At(this):Ct(this,function(t,e){return e.some(function(e){return 0===t.indexOf(e)})},e,He)},It.prototype.anyOf=function(){var t=this,i=I.apply(q,arguments),o=this._cmp;try{i.sort(o);}catch(e){return jt(this,Je)}if(0===i.length)return At(this);var e=new this.Collection(this,function(){return Dt(i[0],i[i.length-1])});e._ondirectionchange=function(e){o="next"===e?t._ascending:t._descending,i.sort(o);};var a=0;return e._addAlgorithm(function(e,t,n){for(var r=e.key;0<o(r,i[a]);)if(++a===i.length)return t(n),!1;return 0===o(r,i[a])||(t(function(){e.continue(i[a]);}),!1)}),e},It.prototype.notEqual=function(e){return this.inAnyRange([[-1/0,e],[e,this.db._maxKey]],{includeLowers:!1,includeUppers:!1})},It.prototype.noneOf=function(){var e=I.apply(q,arguments);if(0===e.length)return new this.Collection(this);try{e.sort(this._ascending);}catch(e){return jt(this,Je)}var t=e.reduce(function(e,t){return e?e.concat([[e[e.length-1][1],t]]):[[-1/0,t]]},null);return t.push([e[e.length-1],this.db._maxKey]),this.inAnyRange(t,{includeLowers:!1,includeUppers:!1})},It.prototype.inAnyRange=function(e,t){var o=this,a=this._cmp,u=this._ascending,n=this._descending,s=this._min,c=this._max;if(0===e.length)return At(this);if(!e.every(function(e){return void 0!==e[0]&&void 0!==e[1]&&u(e[0],e[1])<=0}))return jt(this,"First argument to inAnyRange() must be an Array of two-value Arrays [lower,upper] where upper must not be lower than lower",Y.InvalidArgument);var r=!t||!1!==t.includeLowers,i=t&&!0===t.includeUppers;var l,f=u;function h(e,t){return f(e[0],t[0])}try{(l=e.reduce(function(e,t){for(var n=0,r=e.length;n<r;++n){var i=e[n];if(a(t[0],i[1])<0&&0<a(t[1],i[0])){i[0]=s(i[0],t[0]),i[1]=c(i[1],t[1]);break}}return n===r&&e.push(t),e},[])).sort(h);}catch(e){return jt(this,Je)}var d=0,p=i?function(e){return 0<u(e,l[d][1])}:function(e){return 0<=u(e,l[d][1])},y=r?function(e){return 0<n(e,l[d][0])}:function(e){return 0<=n(e,l[d][0])};var v=p,e=new this.Collection(this,function(){return Dt(l[0][0],l[l.length-1][1],!r,!i)});return e._ondirectionchange=function(e){f="next"===e?(v=p,u):(v=y,n),l.sort(h);},e._addAlgorithm(function(e,t,n){for(var r,i=e.key;v(i);)if(++d===l.length)return t(n),!1;return !p(r=i)&&!y(r)||(0===o._cmp(i,l[d][1])||0===o._cmp(i,l[d][0])||t(function(){f===u?e.continue(l[d][0]):e.continue(l[d][1]);}),!1)}),e},It.prototype.startsWithAnyOf=function(){var e=I.apply(q,arguments);return e.every(function(e){return "string"==typeof e})?0===e.length?At(this):this.inAnyRange(e.map(function(e){return [e,e+He]})):jt(this,"startsWithAnyOf() only works with strings")},It);function It(){}function Bt(t){return Te(function(e){return Rt(e),t(e.target.error),!1})}function Rt(e){e.stopPropagation&&e.stopPropagation(),e.preventDefault&&e.preventDefault();}var Ft="storagemutated",Mt="x-storagemutated-1",Nt=dt(null,Ft),Lt=(Ut.prototype._lock=function(){return y(!me.global),++this._reculock,1!==this._reculock||me.global||(me.lockOwnerFor=this),this},Ut.prototype._unlock=function(){if(y(!me.global),0==--this._reculock)for(me.global||(me.lockOwnerFor=null);0<this._blockedFuncs.length&&!this._locked();){var e=this._blockedFuncs.shift();try{$e(e[1],e[0]);}catch(e){}}return this},Ut.prototype._locked=function(){return this._reculock&&me.lockOwnerFor!==this},Ut.prototype.create=function(t){var n=this;if(!this.mode)return this;var e=this.db.idbdb,r=this.db._state.dbOpenError;if(y(!this.idbtrans),!t&&!e)switch(r&&r.name){case"DatabaseClosedError":throw new Y.DatabaseClosed(r);case"MissingAPIError":throw new Y.MissingAPI(r.message,r);default:throw new Y.OpenFailed(r)}if(!this.active)throw new Y.TransactionInactive;return y(null===this._completion._state),(t=this.idbtrans=t||(this.db.core||e).transaction(this.storeNames,this.mode,{durability:this.chromeTransactionDurability})).onerror=Te(function(e){Rt(e),n._reject(t.error);}),t.onabort=Te(function(e){Rt(e),n.active&&n._reject(new Y.Abort(t.error)),n.active=!1,n.on("abort").fire(e);}),t.oncomplete=Te(function(){n.active=!1,n._resolve(),"mutatedParts"in t&&Nt.storagemutated.fire(t.mutatedParts);}),this},Ut.prototype._promise=function(n,r,i){var o=this;if("readwrite"===n&&"readwrite"!==this.mode)return Xe(new Y.ReadOnly("Transaction is readonly"));if(!this.active)return Xe(new Y.TransactionInactive);if(this._locked())return new _e(function(e,t){o._blockedFuncs.push([function(){o._promise(n,r,i).then(e,t);},me]);});if(i)return Ne(function(){var e=new _e(function(e,t){o._lock();var n=r(e,t,o);n&&n.then&&n.then(e,t);});return e.finally(function(){return o._unlock()}),e._lib=!0,e});var e=new _e(function(e,t){var n=r(e,t,o);n&&n.then&&n.then(e,t);});return e._lib=!0,e},Ut.prototype._root=function(){return this.parent?this.parent._root():this},Ut.prototype.waitFor=function(e){var t,r=this._root(),i=_e.resolve(e);r._waitingFor?r._waitingFor=r._waitingFor.then(function(){return i}):(r._waitingFor=i,r._waitingQueue=[],t=r.idbtrans.objectStore(r.storeNames[0]),function e(){for(++r._spinCount;r._waitingQueue.length;)r._waitingQueue.shift()();r._waitingFor&&(t.get(-1/0).onsuccess=e);}());var o=r._waitingFor;return new _e(function(t,n){i.then(function(e){return r._waitingQueue.push(Te(t.bind(null,e)))},function(e){return r._waitingQueue.push(Te(n.bind(null,e)))}).finally(function(){r._waitingFor===o&&(r._waitingFor=null);});})},Ut.prototype.abort=function(){this.active&&(this.active=!1,this.idbtrans&&this.idbtrans.abort(),this._reject(new Y.Abort));},Ut.prototype.table=function(e){var t=this._memoizedTables||(this._memoizedTables={});if(m(t,e))return t[e];var n=this.schema[e];if(!n)throw new Y.NotFound("Table "+e+" not part of transaction");n=new this.db.Table(e,n,this);return n.core=this.db.core.table(e),t[e]=n},Ut);function Ut(){}function Vt(e,t,n,r,i,o,a){return {name:e,keyPath:t,unique:n,multi:r,auto:i,compound:o,src:(n&&!a?"&":"")+(r?"*":"")+(i?"++":"")+zt(t)}}function zt(e){return "string"==typeof e?e:e?"["+[].join.call(e,"+")+"]":""}function Wt(e,t,n){return {name:e,primKey:t,indexes:n,mappedClass:null,idxByName:(r=function(e){return [e.name,e]},n.reduce(function(e,t,n){n=r(t,n);return n&&(e[n[0]]=n[1]),e},{}))};var r;}var Yt=function(e){try{return e.only([[]]),Yt=function(){return [[]]},[[]]}catch(e){return Yt=function(){return He},He}};function $t(t){return null==t?function(){}:"string"==typeof t?1===(n=t).split(".").length?function(e){return e[n]}:function(e){return k(e,n)}:function(e){return k(e,t)};var n;}function Qt(e){return [].slice.call(e)}var Gt=0;function Xt(e){return null==e?":id":"string"==typeof e?e:"[".concat(e.join("+"),"]")}function Ht(e,i,t){function _(e){if(3===e.type)return null;if(4===e.type)throw new Error("Cannot convert never type to IDBKeyRange");var t=e.lower,n=e.upper,r=e.lowerOpen,e=e.upperOpen;return void 0===t?void 0===n?null:i.upperBound(n,!!e):void 0===n?i.lowerBound(t,!!r):i.bound(t,n,!!r,!!e)}function n(e){var h,w=e.name;return {name:w,schema:e,mutate:function(e){var y=e.trans,v=e.type,m=e.keys,b=e.values,g=e.range;return new Promise(function(t,e){t=Te(t);var n=y.objectStore(w),r=null==n.keyPath,i="put"===v||"add"===v;if(!i&&"delete"!==v&&"deleteRange"!==v)throw new Error("Invalid operation type: "+v);var o,a=(m||b||{length:1}).length;if(m&&b&&m.length!==b.length)throw new Error("Given keys array must have same length as given values array.");if(0===a)return t({numFailures:0,failures:{},results:[],lastResult:void 0});function u(e){++l,Rt(e);}var s=[],c=[],l=0;if("deleteRange"===v){if(4===g.type)return t({numFailures:l,failures:c,results:[],lastResult:void 0});3===g.type?s.push(o=n.clear()):s.push(o=n.delete(_(g)));}else {var r=i?r?[b,m]:[b,null]:[m,null],f=r[0],h=r[1];if(i)for(var d=0;d<a;++d)s.push(o=h&&void 0!==h[d]?n[v](f[d],h[d]):n[v](f[d])),o.onerror=u;else for(d=0;d<a;++d)s.push(o=n[v](f[d])),o.onerror=u;}function p(e){e=e.target.result,s.forEach(function(e,t){return null!=e.error&&(c[t]=e.error)}),t({numFailures:l,failures:c,results:"delete"===v?m:s.map(function(e){return e.result}),lastResult:e});}o.onerror=function(e){u(e),p(e);},o.onsuccess=p;})},getMany:function(e){var f=e.trans,h=e.keys;return new Promise(function(t,e){t=Te(t);for(var n,r=f.objectStore(w),i=h.length,o=new Array(i),a=0,u=0,s=function(e){e=e.target;o[e._pos]=e.result,++u===a&&t(o);},c=Bt(e),l=0;l<i;++l)null!=h[l]&&((n=r.get(h[l]))._pos=l,n.onsuccess=s,n.onerror=c,++a);0===a&&t(o);})},get:function(e){var r=e.trans,i=e.key;return new Promise(function(t,e){t=Te(t);var n=r.objectStore(w).get(i);n.onsuccess=function(e){return t(e.target.result)},n.onerror=Bt(e);})},query:(h=s,function(f){return new Promise(function(n,e){n=Te(n);var r,i,o,t=f.trans,a=f.values,u=f.limit,s=f.query,c=u===1/0?void 0:u,l=s.index,s=s.range,t=t.objectStore(w),l=l.isPrimaryKey?t:t.index(l.name),s=_(s);if(0===u)return n({result:[]});h?((c=a?l.getAll(s,c):l.getAllKeys(s,c)).onsuccess=function(e){return n({result:e.target.result})},c.onerror=Bt(e)):(r=0,i=!a&&"openKeyCursor"in l?l.openKeyCursor(s):l.openCursor(s),o=[],i.onsuccess=function(e){var t=i.result;return t?(o.push(a?t.value:t.primaryKey),++r===u?n({result:o}):void t.continue()):n({result:o})},i.onerror=Bt(e));})}),openCursor:function(e){var c=e.trans,o=e.values,a=e.query,u=e.reverse,l=e.unique;return new Promise(function(t,n){t=Te(t);var e=a.index,r=a.range,i=c.objectStore(w),i=e.isPrimaryKey?i:i.index(e.name),e=u?l?"prevunique":"prev":l?"nextunique":"next",s=!o&&"openKeyCursor"in i?i.openKeyCursor(_(r),e):i.openCursor(_(r),e);s.onerror=Bt(n),s.onsuccess=Te(function(e){var r,i,o,a,u=s.result;u?(u.___id=++Gt,u.done=!1,r=u.continue.bind(u),i=(i=u.continuePrimaryKey)&&i.bind(u),o=u.advance.bind(u),a=function(){throw new Error("Cursor not stopped")},u.trans=c,u.stop=u.continue=u.continuePrimaryKey=u.advance=function(){throw new Error("Cursor not started")},u.fail=Te(n),u.next=function(){var e=this,t=1;return this.start(function(){return t--?e.continue():e.stop()}).then(function(){return e})},u.start=function(e){function t(){if(s.result)try{e();}catch(e){u.fail(e);}else u.done=!0,u.start=function(){throw new Error("Cursor behind last entry")},u.stop();}var n=new Promise(function(t,e){t=Te(t),s.onerror=Bt(e),u.fail=e,u.stop=function(e){u.stop=u.continue=u.continuePrimaryKey=u.advance=a,t(e);};});return s.onsuccess=Te(function(e){s.onsuccess=t,t();}),u.continue=r,u.continuePrimaryKey=i,u.advance=o,t(),n},t(u)):t(null);},n);})},count:function(e){var t=e.query,i=e.trans,o=t.index,a=t.range;return new Promise(function(t,e){var n=i.objectStore(w),r=o.isPrimaryKey?n:n.index(o.name),n=_(a),r=n?r.count(n):r.count();r.onsuccess=Te(function(e){return t(e.target.result)}),r.onerror=Bt(e);})}}}var r,o,a,u=(o=t,a=Qt((r=e).objectStoreNames),{schema:{name:r.name,tables:a.map(function(e){return o.objectStore(e)}).map(function(t){var e=t.keyPath,n=t.autoIncrement,r=x(e),i={},n={name:t.name,primaryKey:{name:null,isPrimaryKey:!0,outbound:null==e,compound:r,keyPath:e,autoIncrement:n,unique:!0,extractKey:$t(e)},indexes:Qt(t.indexNames).map(function(e){return t.index(e)}).map(function(e){var t=e.name,n=e.unique,r=e.multiEntry,e=e.keyPath,r={name:t,compound:x(e),keyPath:e,unique:n,multiEntry:r,extractKey:$t(e)};return i[Xt(e)]=r}),getIndexByKeyPath:function(e){return i[Xt(e)]}};return i[":id"]=n.primaryKey,null!=e&&(i[Xt(e)]=n.primaryKey),n})},hasGetAll:0<a.length&&"getAll"in o.objectStore(a[0])&&!("undefined"!=typeof navigator&&/Safari/.test(navigator.userAgent)&&!/(Chrome\/|Edge\/)/.test(navigator.userAgent)&&[].concat(navigator.userAgent.match(/Safari\/(\d*)/))[1]<604)}),t=u.schema,s=u.hasGetAll,u=t.tables.map(n),c={};return u.forEach(function(e){return c[e.name]=e}),{stack:"dbcore",transaction:e.transaction.bind(e),table:function(e){if(!c[e])throw new Error("Table '".concat(e,"' not found"));return c[e]},MIN_KEY:-1/0,MAX_KEY:Yt(i),schema:t}}function Jt(e,t,n,r){var i=n.IDBKeyRange;return n.indexedDB,{dbcore:(r=Ht(t,i,r),e.dbcore.reduce(function(e,t){t=t.create;return w(w({},e),t(e))},r))}}function Zt(n,e){var t=e.db,e=Jt(n._middlewares,t,n._deps,e);n.core=e.dbcore,n.tables.forEach(function(e){var t=e.name;n.core.schema.tables.some(function(e){return e.name===t})&&(e.core=n.core.table(t),n[t]instanceof n.Table&&(n[t].core=e.core));});}function en(i,e,t,o){t.forEach(function(n){var r=o[n];e.forEach(function(e){var t=function e(t,n){return h(t,n)||(t=c(t))&&e(t,n)}(e,n);(!t||"value"in t&&void 0===t.value)&&(e===i.Transaction.prototype||e instanceof i.Transaction?l(e,n,{get:function(){return this.table(n)},set:function(e){u(this,n,{value:e,writable:!0,configurable:!0,enumerable:!0});}}):e[n]=new i.Table(n,r));});});}function tn(n,e){e.forEach(function(e){for(var t in e)e[t]instanceof n.Table&&delete e[t];});}function nn(e,t){return e._cfg.version-t._cfg.version}function rn(n,r,i,e){var o=n._dbSchema;i.objectStoreNames.contains("$meta")&&!o.$meta&&(o.$meta=Wt("$meta",hn("")[0],[]),n._storeNames.push("$meta"));var a=n._createTransaction("readwrite",n._storeNames,o);a.create(i),a._completion.catch(e);var u=a._reject.bind(a),s=me.transless||me;Ne(function(){return me.trans=a,me.transless=s,0!==r?(Zt(n,i),t=r,((e=a).storeNames.includes("$meta")?e.table("$meta").get("version").then(function(e){return null!=e?e:t}):_e.resolve(t)).then(function(e){return c=e,l=a,f=i,t=[],e=(s=n)._versions,h=s._dbSchema=ln(0,s.idbdb,f),0!==(e=e.filter(function(e){return e._cfg.version>=c})).length?(e.forEach(function(u){t.push(function(){var t=h,e=u._cfg.dbschema;fn(s,t,f),fn(s,e,f),h=s._dbSchema=e;var n=an(t,e);n.add.forEach(function(e){un(f,e[0],e[1].primKey,e[1].indexes);}),n.change.forEach(function(e){if(e.recreate)throw new Y.Upgrade("Not yet support for changing primary key");var t=f.objectStore(e.name);e.add.forEach(function(e){return cn(t,e)}),e.change.forEach(function(e){t.deleteIndex(e.name),cn(t,e);}),e.del.forEach(function(e){return t.deleteIndex(e)});});var r=u._cfg.contentUpgrade;if(r&&u._cfg.version>c){Zt(s,f),l._memoizedTables={};var i=g(e);n.del.forEach(function(e){i[e]=t[e];}),tn(s,[s.Transaction.prototype]),en(s,[s.Transaction.prototype],_(i),i),l.schema=i;var o,a=B(r);a&&Le();n=_e.follow(function(){var e;(o=r(l))&&a&&(e=Ue.bind(null,null),o.then(e,e));});return o&&"function"==typeof o.then?_e.resolve(o):n.then(function(){return o})}}),t.push(function(e){var t,n,r=u._cfg.dbschema;t=r,n=e,[].slice.call(n.db.objectStoreNames).forEach(function(e){return null==t[e]&&n.db.deleteObjectStore(e)}),tn(s,[s.Transaction.prototype]),en(s,[s.Transaction.prototype],s._storeNames,s._dbSchema),l.schema=s._dbSchema;}),t.push(function(e){s.idbdb.objectStoreNames.contains("$meta")&&(Math.ceil(s.idbdb.version/10)===u._cfg.version?(s.idbdb.deleteObjectStore("$meta"),delete s._dbSchema.$meta,s._storeNames=s._storeNames.filter(function(e){return "$meta"!==e})):e.objectStore("$meta").put(u._cfg.version,"version"));});}),function e(){return t.length?_e.resolve(t.shift()(l.idbtrans)).then(e):_e.resolve()}().then(function(){sn(h,f);})):_e.resolve();var s,c,l,f,t,h;}).catch(u)):(_(o).forEach(function(e){un(i,e,o[e].primKey,o[e].indexes);}),Zt(n,i),void _e.follow(function(){return n.on.populate.fire(a)}).catch(u));var e,t;});}function on(e,r){sn(e._dbSchema,r),r.db.version%10!=0||r.objectStoreNames.contains("$meta")||r.db.createObjectStore("$meta").add(Math.ceil(r.db.version/10-1),"version");var t=ln(0,e.idbdb,r);fn(e,e._dbSchema,r);for(var n=0,i=an(t,e._dbSchema).change;n<i.length;n++){var o=function(t){if(t.change.length||t.recreate)return console.warn("Unable to patch indexes of table ".concat(t.name," because it has changes on the type of index or primary key.")),{value:void 0};var n=r.objectStore(t.name);t.add.forEach(function(e){ie&&console.debug("Dexie upgrade patch: Creating missing index ".concat(t.name,".").concat(e.src)),cn(n,e);});}(i[n]);if("object"==typeof o)return o.value}}function an(e,t){var n,r={del:[],add:[],change:[]};for(n in e)t[n]||r.del.push(n);for(n in t){var i=e[n],o=t[n];if(i){var a={name:n,def:o,recreate:!1,del:[],add:[],change:[]};if(""+(i.primKey.keyPath||"")!=""+(o.primKey.keyPath||"")||i.primKey.auto!==o.primKey.auto)a.recreate=!0,r.change.push(a);else {var u=i.idxByName,s=o.idxByName,c=void 0;for(c in u)s[c]||a.del.push(c);for(c in s){var l=u[c],f=s[c];l?l.src!==f.src&&a.change.push(f):a.add.push(f);}(0<a.del.length||0<a.add.length||0<a.change.length)&&r.change.push(a);}}else r.add.push([n,o]);}return r}function un(e,t,n,r){var i=e.db.createObjectStore(t,n.keyPath?{keyPath:n.keyPath,autoIncrement:n.auto}:{autoIncrement:n.auto});return r.forEach(function(e){return cn(i,e)}),i}function sn(t,n){_(t).forEach(function(e){n.db.objectStoreNames.contains(e)||(ie&&console.debug("Dexie: Creating missing table",e),un(n,e,t[e].primKey,t[e].indexes));});}function cn(e,t){e.createIndex(t.name,t.keyPath,{unique:t.unique,multiEntry:t.multi});}function ln(e,t,u){var s={};return b(t.objectStoreNames,0).forEach(function(e){for(var t=u.objectStore(e),n=Vt(zt(a=t.keyPath),a||"",!0,!1,!!t.autoIncrement,a&&"string"!=typeof a,!0),r=[],i=0;i<t.indexNames.length;++i){var o=t.index(t.indexNames[i]),a=o.keyPath,o=Vt(o.name,a,!!o.unique,!!o.multiEntry,!1,a&&"string"!=typeof a,!1);r.push(o);}s[e]=Wt(e,n,r);}),s}function fn(e,t,n){for(var r=n.db.objectStoreNames,i=0;i<r.length;++i){var o=r[i],a=n.objectStore(o);e._hasGetAll="getAll"in a;for(var u=0;u<a.indexNames.length;++u){var s=a.indexNames[u],c=a.index(s).keyPath,l="string"==typeof c?c:"["+b(c).join("+")+"]";!t[o]||(c=t[o].idxByName[l])&&(c.name=s,delete t[o].idxByName[l],t[o].idxByName[s]=c);}}"undefined"!=typeof navigator&&/Safari/.test(navigator.userAgent)&&!/(Chrome\/|Edge\/)/.test(navigator.userAgent)&&f.WorkerGlobalScope&&f instanceof f.WorkerGlobalScope&&[].concat(navigator.userAgent.match(/Safari\/(\d*)/))[1]<604&&(e._hasGetAll=!1);}function hn(e){return e.split(",").map(function(e,t){var n=(e=e.trim()).replace(/([&*]|\+\+)/g,""),r=/^\[/.test(n)?n.match(/^\[(.*)\]$/)[1].split("+"):n;return Vt(n,r||null,/\&/.test(e),/\*/.test(e),/\+\+/.test(e),x(r),0===t)})}var dn=(pn.prototype._parseStoresSpec=function(r,i){_(r).forEach(function(e){if(null!==r[e]){var t=hn(r[e]),n=t.shift();if(n.unique=!0,n.multi)throw new Y.Schema("Primary key cannot be multi-valued");t.forEach(function(e){if(e.auto)throw new Y.Schema("Only primary key can be marked as autoIncrement (++)");if(!e.keyPath)throw new Y.Schema("Index must have a name and cannot be an empty string")}),i[e]=Wt(e,n,t);}});},pn.prototype.stores=function(e){var t=this.db;this._cfg.storesSource=this._cfg.storesSource?a(this._cfg.storesSource,e):e;var e=t._versions,n={},r={};return e.forEach(function(e){a(n,e._cfg.storesSource),r=e._cfg.dbschema={},e._parseStoresSpec(n,r);}),t._dbSchema=r,tn(t,[t._allTables,t,t.Transaction.prototype]),en(t,[t._allTables,t,t.Transaction.prototype,this._cfg.tables],_(r),r),t._storeNames=_(r),this},pn.prototype.upgrade=function(e){return this._cfg.contentUpgrade=re(this._cfg.contentUpgrade||G,e),this},pn);function pn(){}function yn(e,t){var n=e._dbNamesDB;return n||(n=e._dbNamesDB=new er(tt,{addons:[],indexedDB:e,IDBKeyRange:t})).version(1).stores({dbnames:"name"}),n.table("dbnames")}function vn(e){return e&&"function"==typeof e.databases}function mn(e){return Ne(function(){return me.letThrough=!0,e()})}function bn(e){return !("from"in e)}var gn=function(e,t){if(!this){var n=new gn;return e&&"d"in e&&a(n,e),n}a(this,arguments.length?{d:1,from:e,to:1<arguments.length?t:e}:{d:0});};function wn(e,t,n){var r=st(t,n);if(!isNaN(r)){if(0<r)throw RangeError();if(bn(e))return a(e,{from:t,to:n,d:1});var i=e.l,r=e.r;if(st(n,e.from)<0)return i?wn(i,t,n):e.l={from:t,to:n,d:1,l:null,r:null},On(e);if(0<st(t,e.to))return r?wn(r,t,n):e.r={from:t,to:n,d:1,l:null,r:null},On(e);st(t,e.from)<0&&(e.from=t,e.l=null,e.d=r?r.d+1:1),0<st(n,e.to)&&(e.to=n,e.r=null,e.d=e.l?e.l.d+1:1);n=!e.r;i&&!e.l&&_n(e,i),r&&n&&_n(e,r);}}function _n(e,t){bn(t)||function e(t,n){var r=n.from,i=n.to,o=n.l,n=n.r;wn(t,r,i),o&&e(t,o),n&&e(t,n);}(e,t);}function xn(e,t){var n=kn(t),r=n.next();if(r.done)return !1;for(var i=r.value,o=kn(e),a=o.next(i.from),u=a.value;!r.done&&!a.done;){if(st(u.from,i.to)<=0&&0<=st(u.to,i.from))return !0;st(i.from,u.from)<0?i=(r=n.next(u.from)).value:u=(a=o.next(i.from)).value;}return !1}function kn(e){var n=bn(e)?null:{s:0,n:e};return {next:function(e){for(var t=0<arguments.length;n;)switch(n.s){case 0:if(n.s=1,t)for(;n.n.l&&st(e,n.n.from)<0;)n={up:n,n:n.n.l,s:1};else for(;n.n.l;)n={up:n,n:n.n.l,s:1};case 1:if(n.s=2,!t||st(e,n.n.to)<=0)return {value:n.n,done:!1};case 2:if(n.n.r){n.s=3,n={up:n,n:n.n.r,s:0};continue}case 3:n=n.up;}return {done:!0}}}}function On(e){var t,n,r=((null===(t=e.r)||void 0===t?void 0:t.d)||0)-((null===(n=e.l)||void 0===n?void 0:n.d)||0),i=1<r?"r":r<-1?"l":"";i&&(t="r"==i?"l":"r",n=w({},e),r=e[i],e.from=r.from,e.to=r.to,e[i]=r[i],n[i]=r[t],(e[t]=n).d=Pn(n)),e.d=Pn(e);}function Pn(e){var t=e.r,e=e.l;return (t?e?Math.max(t.d,e.d):t.d:e?e.d:0)+1}function En(t,n){return _(n).forEach(function(e){t[e]?_n(t[e],n[e]):t[e]=function e(t){var n,r,i={};for(n in t)m(t,n)&&(r=t[n],i[n]=!r||"object"!=typeof r||E.has(r.constructor)?r:e(r));return i}(n[e]);}),t}function Kn(t,n){return t.all||n.all||Object.keys(t).some(function(e){return n[e]&&xn(n[e],t[e])})}r(gn.prototype,((F={add:function(e){return _n(this,e),this},addKey:function(e){return wn(this,e,e),this},addKeys:function(e){var t=this;return e.forEach(function(e){return wn(t,e,e)}),this},hasKey:function(e){var t=kn(this).next(e).value;return t&&st(t.from,e)<=0&&0<=st(t.to,e)}})[C]=function(){return kn(this)},F));var Sn={},jn={},An=!1;function Cn(e){En(jn,e),An||(An=!0,setTimeout(function(){An=!1,Dn(jn,!(jn={}));},0));}function Dn(e,t){void 0===t&&(t=!1);var n=new Set;if(e.all)for(var r=0,i=Object.values(Sn);r<i.length;r++)Tn(a=i[r],e,n,t);else for(var o in e){var a,u=/^idb\:\/\/(.*)\/(.*)\//.exec(o);u&&(o=u[1],u=u[2],(a=Sn["idb://".concat(o,"/").concat(u)])&&Tn(a,e,n,t));}n.forEach(function(e){return e()});}function Tn(e,t,n,r){for(var i=[],o=0,a=Object.entries(e.queries.query);o<a.length;o++){for(var u=a[o],s=u[0],c=[],l=0,f=u[1];l<f.length;l++){var h=f[l];Kn(t,h.obsSet)?h.subscribers.forEach(function(e){return n.add(e)}):r&&c.push(h);}r&&i.push([s,c]);}if(r)for(var d=0,p=i;d<p.length;d++){var y=p[d],s=y[0],c=y[1];e.queries.query[s]=c;}}function qn(f){var h=f._state,r=f._deps.indexedDB;if(h.isBeingOpened||f.idbdb)return h.dbReadyPromise.then(function(){return h.dbOpenError?Xe(h.dbOpenError):f});h.isBeingOpened=!0,h.dbOpenError=null,h.openComplete=!1;var t=h.openCanceller,d=Math.round(10*f.verno),p=!1;function e(){if(h.openCanceller!==t)throw new Y.DatabaseClosed("db.open() was cancelled")}function y(){return new _e(function(s,n){if(e(),!r)throw new Y.MissingAPI;var c=f.name,l=h.autoSchema||!d?r.open(c):r.open(c,d);if(!l)throw new Y.MissingAPI;l.onerror=Bt(n),l.onblocked=Te(f._fireOnBlocked),l.onupgradeneeded=Te(function(e){var t;v=l.transaction,h.autoSchema&&!f._options.allowEmptyDB?(l.onerror=Rt,v.abort(),l.result.close(),(t=r.deleteDatabase(c)).onsuccess=t.onerror=Te(function(){n(new Y.NoSuchDatabase("Database ".concat(c," doesnt exist")));})):(v.onerror=Bt(n),e=e.oldVersion>Math.pow(2,62)?0:e.oldVersion,m=e<1,f.idbdb=l.result,p&&on(f,v),rn(f,e/10,v,n));},n),l.onsuccess=Te(function(){v=null;var e,t,n,r,i,o=f.idbdb=l.result,a=b(o.objectStoreNames);if(0<a.length)try{var u=o.transaction(1===(r=a).length?r[0]:r,"readonly");if(h.autoSchema)t=o,n=u,(e=f).verno=t.version/10,n=e._dbSchema=ln(0,t,n),e._storeNames=b(t.objectStoreNames,0),en(e,[e._allTables],_(n),n);else if(fn(f,f._dbSchema,u),((i=an(ln(0,(i=f).idbdb,u),i._dbSchema)).add.length||i.change.some(function(e){return e.add.length||e.change.length}))&&!p)return console.warn("Dexie SchemaDiff: Schema was extended without increasing the number passed to db.version(). Dexie will add missing parts and increment native version number to workaround this."),o.close(),d=o.version+1,p=!0,s(y());Zt(f,u);}catch(e){}et.push(f),o.onversionchange=Te(function(e){h.vcFired=!0,f.on("versionchange").fire(e);}),o.onclose=Te(function(e){f.on("close").fire(e);}),m&&(i=f._deps,u=c,o=i.indexedDB,i=i.IDBKeyRange,vn(o)||u===tt||yn(o,i).put({name:u}).catch(G)),s();},n);}).catch(function(e){switch(null==e?void 0:e.name){case"UnknownError":if(0<h.PR1398_maxLoop)return h.PR1398_maxLoop--,console.warn("Dexie: Workaround for Chrome UnknownError on open()"),y();break;case"VersionError":if(0<d)return d=0,y()}return _e.reject(e)})}var n,i=h.dbReadyResolve,v=null,m=!1;return _e.race([t,("undefined"==typeof navigator?_e.resolve():!navigator.userAgentData&&/Safari\//.test(navigator.userAgent)&&!/Chrom(e|ium)\//.test(navigator.userAgent)&&indexedDB.databases?new Promise(function(e){function t(){return indexedDB.databases().finally(e)}n=setInterval(t,100),t();}).finally(function(){return clearInterval(n)}):Promise.resolve()).then(y)]).then(function(){return e(),h.onReadyBeingFired=[],_e.resolve(mn(function(){return f.on.ready.fire(f.vip)})).then(function e(){if(0<h.onReadyBeingFired.length){var t=h.onReadyBeingFired.reduce(re,G);return h.onReadyBeingFired=[],_e.resolve(mn(function(){return t(f.vip)})).then(e)}})}).finally(function(){h.openCanceller===t&&(h.onReadyBeingFired=null,h.isBeingOpened=!1);}).catch(function(e){h.dbOpenError=e;try{v&&v.abort();}catch(e){}return t===h.openCanceller&&f._close(),Xe(e)}).finally(function(){h.openComplete=!0,i();}).then(function(){var n;return m&&(n={},f.tables.forEach(function(t){t.schema.indexes.forEach(function(e){e.name&&(n["idb://".concat(f.name,"/").concat(t.name,"/").concat(e.name)]=new gn(-1/0,[[[]]]));}),n["idb://".concat(f.name,"/").concat(t.name,"/")]=n["idb://".concat(f.name,"/").concat(t.name,"/:dels")]=new gn(-1/0,[[[]]]);}),Nt(Ft).fire(n),Dn(n,!0)),f})}function In(t){function e(e){return t.next(e)}var r=n(e),i=n(function(e){return t.throw(e)});function n(n){return function(e){var t=n(e),e=t.value;return t.done?e:e&&"function"==typeof e.then?e.then(r,i):x(e)?Promise.all(e).then(r,i):r(e)}}return n(e)()}function Bn(e,t,n){for(var r=x(e)?e.slice():[e],i=0;i<n;++i)r.push(t);return r}var Rn={stack:"dbcore",name:"VirtualIndexMiddleware",level:1,create:function(f){return w(w({},f),{table:function(e){var a=f.table(e),t=a.schema,u={},s=[];function c(e,t,n){var r=Xt(e),i=u[r]=u[r]||[],o=null==e?0:"string"==typeof e?1:e.length,a=0<t,a=w(w({},n),{name:a?"".concat(r,"(virtual-from:").concat(n.name,")"):n.name,lowLevelIndex:n,isVirtual:a,keyTail:t,keyLength:o,extractKey:$t(e),unique:!a&&n.unique});return i.push(a),a.isPrimaryKey||s.push(a),1<o&&c(2===o?e[0]:e.slice(0,o-1),t+1,n),i.sort(function(e,t){return e.keyTail-t.keyTail}),a}e=c(t.primaryKey.keyPath,0,t.primaryKey);u[":id"]=[e];for(var n=0,r=t.indexes;n<r.length;n++){var i=r[n];c(i.keyPath,0,i);}function l(e){var t,n=e.query.index;return n.isVirtual?w(w({},e),{query:{index:n.lowLevelIndex,range:(t=e.query.range,n=n.keyTail,{type:1===t.type?2:t.type,lower:Bn(t.lower,t.lowerOpen?f.MAX_KEY:f.MIN_KEY,n),lowerOpen:!0,upper:Bn(t.upper,t.upperOpen?f.MIN_KEY:f.MAX_KEY,n),upperOpen:!0})}}):e}return w(w({},a),{schema:w(w({},t),{primaryKey:e,indexes:s,getIndexByKeyPath:function(e){return (e=u[Xt(e)])&&e[0]}}),count:function(e){return a.count(l(e))},query:function(e){return a.query(l(e))},openCursor:function(t){var e=t.query.index,r=e.keyTail,n=e.isVirtual,i=e.keyLength;return n?a.openCursor(l(t)).then(function(e){return e&&o(e)}):a.openCursor(t);function o(n){return Object.create(n,{continue:{value:function(e){null!=e?n.continue(Bn(e,t.reverse?f.MAX_KEY:f.MIN_KEY,r)):t.unique?n.continue(n.key.slice(0,i).concat(t.reverse?f.MIN_KEY:f.MAX_KEY,r)):n.continue();}},continuePrimaryKey:{value:function(e,t){n.continuePrimaryKey(Bn(e,f.MAX_KEY,r),t);}},primaryKey:{get:function(){return n.primaryKey}},key:{get:function(){var e=n.key;return 1===i?e[0]:e.slice(0,i)}},value:{get:function(){return n.value}}})}}})}})}};function Fn(i,o,a,u){return a=a||{},u=u||"",_(i).forEach(function(e){var t,n,r;m(o,e)?(t=i[e],n=o[e],"object"==typeof t&&"object"==typeof n&&t&&n?(r=A(t))!==A(n)?a[u+e]=o[e]:"Object"===r?Fn(t,n,a,u+e+"."):t!==n&&(a[u+e]=o[e]):t!==n&&(a[u+e]=o[e])):a[u+e]=void 0;}),_(o).forEach(function(e){m(i,e)||(a[u+e]=o[e]);}),a}function Mn(e,t){return "delete"===t.type?t.keys:t.keys||t.values.map(e.extractKey)}var Nn={stack:"dbcore",name:"HooksMiddleware",level:2,create:function(e){return w(w({},e),{table:function(r){var y=e.table(r),v=y.schema.primaryKey;return w(w({},y),{mutate:function(e){var t=me.trans,n=t.table(r).hook,h=n.deleting,d=n.creating,p=n.updating;switch(e.type){case"add":if(d.fire===G)break;return t._promise("readwrite",function(){return a(e)},!0);case"put":if(d.fire===G&&p.fire===G)break;return t._promise("readwrite",function(){return a(e)},!0);case"delete":if(h.fire===G)break;return t._promise("readwrite",function(){return a(e)},!0);case"deleteRange":if(h.fire===G)break;return t._promise("readwrite",function(){return function n(r,i,o){return y.query({trans:r,values:!1,query:{index:v,range:i},limit:o}).then(function(e){var t=e.result;return a({type:"delete",keys:t,trans:r}).then(function(e){return 0<e.numFailures?Promise.reject(e.failures[0]):t.length<o?{failures:[],numFailures:0,lastResult:void 0}:n(r,w(w({},i),{lower:t[t.length-1],lowerOpen:!0}),o)})})}(e.trans,e.range,1e4)},!0)}return y.mutate(e);function a(c){var e,t,n,l=me.trans,f=c.keys||Mn(v,c);if(!f)throw new Error("Keys missing");return "delete"!==(c="add"===c.type||"put"===c.type?w(w({},c),{keys:f}):w({},c)).type&&(c.values=i([],c.values)),c.keys&&(c.keys=i([],c.keys)),e=y,n=f,("add"===(t=c).type?Promise.resolve([]):e.getMany({trans:t.trans,keys:n,cache:"immutable"})).then(function(u){var s=f.map(function(e,t){var n,r,i,o=u[t],a={onerror:null,onsuccess:null};return "delete"===c.type?h.fire.call(a,e,o,l):"add"===c.type||void 0===o?(n=d.fire.call(a,e,c.values[t],l),null==e&&null!=n&&(c.keys[t]=e=n,v.outbound||P(c.values[t],v.keyPath,e))):(n=Fn(o,c.values[t]),(r=p.fire.call(a,n,e,o,l))&&(i=c.values[t],Object.keys(r).forEach(function(e){m(i,e)?i[e]=r[e]:P(i,e,r[e]);}))),a});return y.mutate(c).then(function(e){for(var t=e.failures,n=e.results,r=e.numFailures,e=e.lastResult,i=0;i<f.length;++i){var o=(n||f)[i],a=s[i];null==o?a.onerror&&a.onerror(t[i]):a.onsuccess&&a.onsuccess("put"===c.type&&u[i]?c.values[i]:o);}return {failures:t,results:n,numFailures:r,lastResult:e}}).catch(function(t){return s.forEach(function(e){return e.onerror&&e.onerror(t)}),Promise.reject(t)})})}}})}})}};function Ln(e,t,n){try{if(!t)return null;if(t.keys.length<e.length)return null;for(var r=[],i=0,o=0;i<t.keys.length&&o<e.length;++i)0===st(t.keys[i],e[o])&&(r.push(n?S(t.values[i]):t.values[i]),++o);return r.length===e.length?r:null}catch(e){return null}}var Un={stack:"dbcore",level:-1,create:function(t){return {table:function(e){var n=t.table(e);return w(w({},n),{getMany:function(t){if(!t.cache)return n.getMany(t);var e=Ln(t.keys,t.trans._cache,"clone"===t.cache);return e?_e.resolve(e):n.getMany(t).then(function(e){return t.trans._cache={keys:t.keys,values:"clone"===t.cache?S(e):e},e})},mutate:function(e){return "add"!==e.type&&(e.trans._cache=null),n.mutate(e)}})}}}};function Vn(e,t){return "readonly"===e.trans.mode&&!!e.subscr&&!e.trans.explicit&&"disabled"!==e.trans.db._options.cache&&!t.schema.primaryKey.outbound}function zn(e,t){switch(e){case"query":return t.values&&!t.unique;case"get":case"getMany":case"count":case"openCursor":return !1}}var Wn={stack:"dbcore",level:0,name:"Observability",create:function(r){var b=r.schema.name,g=new gn(r.MIN_KEY,r.MAX_KEY);return w(w({},r),{transaction:function(e,t,n){if(me.subscr&&"readonly"!==t)throw new Y.ReadOnly("Readwrite transaction in liveQuery context. Querier source: ".concat(me.querier));return r.transaction(e,t,n)},table:function(d){var p=r.table(d),y=p.schema,v=y.primaryKey,e=y.indexes,c=v.extractKey,l=v.outbound,m=v.autoIncrement&&e.filter(function(e){return e.compound&&e.keyPath.includes(v.keyPath)}),t=w(w({},p),{mutate:function(i){function o(e){return e="idb://".concat(b,"/").concat(d,"/").concat(e),n[e]||(n[e]=new gn)}var e,a,u,t=i.trans,n=i.mutatedParts||(i.mutatedParts={}),r=o(""),s=o(":dels"),c=i.type,l="deleteRange"===i.type?[i.range]:"delete"===i.type?[i.keys]:i.values.length<50?[Mn(v,i).filter(function(e){return e}),i.values]:[],f=l[0],h=l[1],l=i.trans._cache;return x(f)?(r.addKeys(f),(l="delete"===c||f.length===h.length?Ln(f,l):null)||s.addKeys(f),(l||h)&&(e=o,a=l,u=h,y.indexes.forEach(function(t){var n=e(t.name||"");function r(e){return null!=e?t.extractKey(e):null}function i(e){return t.multiEntry&&x(e)?e.forEach(function(e){return n.addKey(e)}):n.addKey(e)}(a||u).forEach(function(e,t){var n=a&&r(a[t]),t=u&&r(u[t]);0!==st(n,t)&&(null!=n&&i(n),null!=t&&i(t));});}))):f?(h={from:f.lower,to:f.upper},s.add(h),r.add(h)):(r.add(g),s.add(g),y.indexes.forEach(function(e){return o(e.name).add(g)})),p.mutate(i).then(function(e){return !f||"add"!==i.type&&"put"!==i.type||(r.addKeys(e.results),m&&m.forEach(function(t){var n=i.values.map(function(e){return t.extractKey(e)}),r=t.keyPath.findIndex(function(e){return e===v.keyPath});e.results.forEach(function(e){return n[r]=e}),o(t.name).addKeys(n);})),t.mutatedParts=En(t.mutatedParts||{},n),e})}}),e=function(e){var t=e.query,e=t.index,t=t.range;return [e,new gn(null!==(e=t.lower)&&void 0!==e?e:r.MIN_KEY,null!==(t=t.upper)&&void 0!==t?t:r.MAX_KEY)]},f={get:function(e){return [v,new gn(e.key)]},getMany:function(e){return [v,(new gn).addKeys(e.keys)]},count:e,query:e,openCursor:e};return _(f).forEach(function(s){t[s]=function(i){var e=me.subscr,t=!!e,n=Vn(me,p)&&zn(s,i)?i.obsSet={}:e;if(t){var r=function(e){e="idb://".concat(b,"/").concat(d,"/").concat(e);return n[e]||(n[e]=new gn)},o=r(""),a=r(":dels"),e=f[s](i),t=e[0],e=e[1];if(("query"===s&&t.isPrimaryKey&&!i.values?a:r(t.name||"")).add(e),!t.isPrimaryKey){if("count"!==s){var u="query"===s&&l&&i.values&&p.query(w(w({},i),{values:!1}));return p[s].apply(this,arguments).then(function(t){if("query"===s){if(l&&i.values)return u.then(function(e){e=e.result;return o.addKeys(e),t});var e=i.values?t.result.map(c):t.result;(i.values?o:a).addKeys(e);}else if("openCursor"===s){var n=t,r=i.values;return n&&Object.create(n,{key:{get:function(){return a.addKey(n.primaryKey),n.key}},primaryKey:{get:function(){var e=n.primaryKey;return a.addKey(e),e}},value:{get:function(){return r&&o.addKey(n.primaryKey),n.value}}})}return t})}a.add(g);}}return p[s].apply(this,arguments)};}),t}})}};function Yn(e,t,n){if(0===n.numFailures)return t;if("deleteRange"===t.type)return null;var r=t.keys?t.keys.length:"values"in t&&t.values?t.values.length:1;if(n.numFailures===r)return null;t=w({},t);return x(t.keys)&&(t.keys=t.keys.filter(function(e,t){return !(t in n.failures)})),"values"in t&&x(t.values)&&(t.values=t.values.filter(function(e,t){return !(t in n.failures)})),t}function $n(e,t){return n=e,(void 0===(r=t).lower||(r.lowerOpen?0<st(n,r.lower):0<=st(n,r.lower)))&&(e=e,void 0===(t=t).upper||(t.upperOpen?st(e,t.upper)<0:st(e,t.upper)<=0));var n,r;}function Qn(e,h,t,n,r,i){if(!t||0===t.length)return e;var o=h.query.index,d=o.multiEntry,p=h.query.range,y=n.schema.primaryKey.extractKey,v=o.extractKey,a=(o.lowLevelIndex||o).extractKey,t=t.reduce(function(e,t){var n=e,r=[];if("add"===t.type||"put"===t.type)for(var i=new gn,o=t.values.length-1;0<=o;--o){var a,u=t.values[o],s=y(u);i.hasKey(s)||(a=v(u),(d&&x(a)?a.some(function(e){return $n(e,p)}):$n(a,p))&&(i.addKey(s),r.push(u)));}switch(t.type){case"add":n=e.concat(h.values?r:r.map(function(e){return y(e)}));break;case"put":var c=(new gn).addKeys(t.values.map(function(e){return y(e)})),n=e.filter(function(e){return !c.hasKey(h.values?y(e):e)}).concat(h.values?r:r.map(function(e){return y(e)}));break;case"delete":var l=(new gn).addKeys(t.keys);n=e.filter(function(e){return !l.hasKey(h.values?y(e):e)});break;case"deleteRange":var f=t.range;n=e.filter(function(e){return !$n(y(e),f)});}return n},e);return t===e?e:(t.sort(function(e,t){return st(a(e),a(t))||st(y(e),y(t))}),h.limit&&h.limit<1/0&&(t.length>h.limit?t.length=h.limit:e.length===h.limit&&t.length<h.limit&&(r.dirty=!0)),i?Object.freeze(t):t)}function Gn(e,t){return 0===st(e.lower,t.lower)&&0===st(e.upper,t.upper)&&!!e.lowerOpen==!!t.lowerOpen&&!!e.upperOpen==!!t.upperOpen}function Xn(e,t){return function(e,t,n,r){if(void 0===e)return void 0!==t?-1:0;if(void 0===t)return 1;if(0===(t=st(e,t))){if(n&&r)return 0;if(n)return 1;if(r)return -1}return t}(e.lower,t.lower,e.lowerOpen,t.lowerOpen)<=0&&0<=function(e,t,n,r){if(void 0===e)return void 0!==t?1:0;if(void 0===t)return -1;if(0===(t=st(e,t))){if(n&&r)return 0;if(n)return -1;if(r)return 1}return t}(e.upper,t.upper,e.upperOpen,t.upperOpen)}function Hn(n,r,i,e){n.subscribers.add(i),e.addEventListener("abort",function(){var e,t;n.subscribers.delete(i),0===n.subscribers.size&&(e=n,t=r,setTimeout(function(){0===e.subscribers.size&&T(t,e);},3e3));});}var Jn={stack:"dbcore",level:0,name:"Cache",create:function(k){var O=k.schema.name;return w(w({},k),{transaction:function(g,w,e){var _,t,x=k.transaction(g,w,e);return "readwrite"===w&&(t=(_=new AbortController).signal,e=function(b){return function(){if(_.abort(),"readwrite"===w){for(var t=new Set,e=0,n=g;e<n.length;e++){var r=n[e],i=Sn["idb://".concat(O,"/").concat(r)];if(i){var o=k.table(r),a=i.optimisticOps.filter(function(e){return e.trans===x});if(x._explicit&&b&&x.mutatedParts)for(var u=0,s=Object.values(i.queries.query);u<s.length;u++)for(var c=0,l=(d=s[u]).slice();c<l.length;c++)Kn((p=l[c]).obsSet,x.mutatedParts)&&(T(d,p),p.subscribers.forEach(function(e){return t.add(e)}));else if(0<a.length){i.optimisticOps=i.optimisticOps.filter(function(e){return e.trans!==x});for(var f=0,h=Object.values(i.queries.query);f<h.length;f++)for(var d,p,y,v=0,m=(d=h[f]).slice();v<m.length;v++)null!=(p=m[v]).res&&x.mutatedParts&&(b&&!p.dirty?(y=Object.isFrozen(p.res),y=Qn(p.res,p.req,a,o,p,y),p.dirty?(T(d,p),p.subscribers.forEach(function(e){return t.add(e)})):y!==p.res&&(p.res=y,p.promise=_e.resolve({result:y}))):(p.dirty&&T(d,p),p.subscribers.forEach(function(e){return t.add(e)})));}}}t.forEach(function(e){return e()});}}},x.addEventListener("abort",e(!1),{signal:t}),x.addEventListener("error",e(!1),{signal:t}),x.addEventListener("complete",e(!0),{signal:t})),x},table:function(c){var l=k.table(c),i=l.schema.primaryKey;return w(w({},l),{mutate:function(t){var e=me.trans;if(i.outbound||"disabled"===e.db._options.cache||e.explicit)return l.mutate(t);var n=Sn["idb://".concat(O,"/").concat(c)];if(!n)return l.mutate(t);e=l.mutate(t);return "add"!==t.type&&"put"!==t.type||!(50<=t.values.length||Mn(i,t).some(function(e){return null==e}))?(n.optimisticOps.push(t),t.mutatedParts&&Cn(t.mutatedParts),e.then(function(e){0<e.numFailures&&(T(n.optimisticOps,t),(e=Yn(0,t,e))&&n.optimisticOps.push(e),t.mutatedParts&&Cn(t.mutatedParts));}),e.catch(function(){T(n.optimisticOps,t),t.mutatedParts&&Cn(t.mutatedParts);})):e.then(function(r){var e=Yn(0,w(w({},t),{values:t.values.map(function(e,t){var n,e=null!==(n=i.keyPath)&&void 0!==n&&n.includes(".")?S(e):w({},e);return P(e,i.keyPath,r.results[t]),e})}),r);n.optimisticOps.push(e),queueMicrotask(function(){return t.mutatedParts&&Cn(t.mutatedParts)});}),e},query:function(t){if(!Vn(me,l)||!zn("query",t))return l.query(t);var i="immutable"===(null===(o=me.trans)||void 0===o?void 0:o.db._options.cache),e=me,n=e.requery,r=e.signal,o=function(e,t,n,r){var i=Sn["idb://".concat(e,"/").concat(t)];if(!i)return [];if(!(t=i.queries[n]))return [null,!1,i,null];var o=t[(r.query?r.query.index.name:null)||""];if(!o)return [null,!1,i,null];switch(n){case"query":var a=o.find(function(e){return e.req.limit===r.limit&&e.req.values===r.values&&Gn(e.req.query.range,r.query.range)});return a?[a,!0,i,o]:[o.find(function(e){return ("limit"in e.req?e.req.limit:1/0)>=r.limit&&(!r.values||e.req.values)&&Xn(e.req.query.range,r.query.range)}),!1,i,o];case"count":a=o.find(function(e){return Gn(e.req.query.range,r.query.range)});return [a,!!a,i,o]}}(O,c,"query",t),a=o[0],e=o[1],u=o[2],s=o[3];return a&&e?a.obsSet=t.obsSet:(e=l.query(t).then(function(e){var t=e.result;if(a&&(a.res=t),i){for(var n=0,r=t.length;n<r;++n)Object.freeze(t[n]);Object.freeze(t);}else e.result=S(t);return e}).catch(function(e){return s&&a&&T(s,a),Promise.reject(e)}),a={obsSet:t.obsSet,promise:e,subscribers:new Set,type:"query",req:t,dirty:!1},s?s.push(a):(s=[a],(u=u||(Sn["idb://".concat(O,"/").concat(c)]={queries:{query:{},count:{}},objs:new Map,optimisticOps:[],unsignaledParts:{}})).queries.query[t.query.index.name||""]=s)),Hn(a,s,n,r),a.promise.then(function(e){return {result:Qn(e.result,t,null==u?void 0:u.optimisticOps,l,a,i)}})}})}})}};function Zn(e,r){return new Proxy(e,{get:function(e,t,n){return "db"===t?r:Reflect.get(e,t,n)}})}var er=(tr.prototype.version=function(t){if(isNaN(t)||t<.1)throw new Y.Type("Given version is not a positive number");if(t=Math.round(10*t)/10,this.idbdb||this._state.isBeingOpened)throw new Y.Schema("Cannot add version when database is open");this.verno=Math.max(this.verno,t);var e=this._versions,n=e.filter(function(e){return e._cfg.version===t})[0];return n||(n=new this.Version(t),e.push(n),e.sort(nn),n.stores({}),this._state.autoSchema=!1,n)},tr.prototype._whenReady=function(e){var n=this;return this.idbdb&&(this._state.openComplete||me.letThrough||this._vip)?e():new _e(function(e,t){if(n._state.openComplete)return t(new Y.DatabaseClosed(n._state.dbOpenError));if(!n._state.isBeingOpened){if(!n._state.autoOpen)return void t(new Y.DatabaseClosed);n.open().catch(G);}n._state.dbReadyPromise.then(e,t);}).then(e)},tr.prototype.use=function(e){var t=e.stack,n=e.create,r=e.level,i=e.name;i&&this.unuse({stack:t,name:i});e=this._middlewares[t]||(this._middlewares[t]=[]);return e.push({stack:t,create:n,level:null==r?10:r,name:i}),e.sort(function(e,t){return e.level-t.level}),this},tr.prototype.unuse=function(e){var t=e.stack,n=e.name,r=e.create;return t&&this._middlewares[t]&&(this._middlewares[t]=this._middlewares[t].filter(function(e){return r?e.create!==r:!!n&&e.name!==n})),this},tr.prototype.open=function(){var e=this;return $e(ve,function(){return qn(e)})},tr.prototype._close=function(){var n=this._state,e=et.indexOf(this);if(0<=e&&et.splice(e,1),this.idbdb){try{this.idbdb.close();}catch(e){}this.idbdb=null;}n.isBeingOpened||(n.dbReadyPromise=new _e(function(e){n.dbReadyResolve=e;}),n.openCanceller=new _e(function(e,t){n.cancelOpen=t;}));},tr.prototype.close=function(e){var t=(void 0===e?{disableAutoOpen:!0}:e).disableAutoOpen,e=this._state;t?(e.isBeingOpened&&e.cancelOpen(new Y.DatabaseClosed),this._close(),e.autoOpen=!1,e.dbOpenError=new Y.DatabaseClosed):(this._close(),e.autoOpen=this._options.autoOpen||e.isBeingOpened,e.openComplete=!1,e.dbOpenError=null);},tr.prototype.delete=function(n){var i=this;void 0===n&&(n={disableAutoOpen:!0});var o=0<arguments.length&&"object"!=typeof arguments[0],a=this._state;return new _e(function(r,t){function e(){i.close(n);var e=i._deps.indexedDB.deleteDatabase(i.name);e.onsuccess=Te(function(){var e,t,n;e=i._deps,t=i.name,n=e.indexedDB,e=e.IDBKeyRange,vn(n)||t===tt||yn(n,e).delete(t).catch(G),r();}),e.onerror=Bt(t),e.onblocked=i._fireOnBlocked;}if(o)throw new Y.InvalidArgument("Invalid closeOptions argument to db.delete()");a.isBeingOpened?a.dbReadyPromise.then(e):e();})},tr.prototype.backendDB=function(){return this.idbdb},tr.prototype.isOpen=function(){return null!==this.idbdb},tr.prototype.hasBeenClosed=function(){var e=this._state.dbOpenError;return e&&"DatabaseClosed"===e.name},tr.prototype.hasFailed=function(){return null!==this._state.dbOpenError},tr.prototype.dynamicallyOpened=function(){return this._state.autoSchema},Object.defineProperty(tr.prototype,"tables",{get:function(){var t=this;return _(this._allTables).map(function(e){return t._allTables[e]})},enumerable:!1,configurable:!0}),tr.prototype.transaction=function(){var e=function(e,t,n){var r=arguments.length;if(r<2)throw new Y.InvalidArgument("Too few arguments");for(var i=new Array(r-1);--r;)i[r-1]=arguments[r];return n=i.pop(),[e,O(i),n]}.apply(this,arguments);return this._transaction.apply(this,e)},tr.prototype._transaction=function(e,t,n){var r=this,i=me.trans;i&&i.db===this&&-1===e.indexOf("!")||(i=null);var o,a,u=-1!==e.indexOf("?");e=e.replace("!","").replace("?","");try{if(a=t.map(function(e){e=e instanceof r.Table?e.name:e;if("string"!=typeof e)throw new TypeError("Invalid table argument to Dexie.transaction(). Only Table or String are allowed");return e}),"r"==e||e===nt)o=nt;else {if("rw"!=e&&e!=rt)throw new Y.InvalidArgument("Invalid transaction mode: "+e);o=rt;}if(i){if(i.mode===nt&&o===rt){if(!u)throw new Y.SubTransaction("Cannot enter a sub-transaction with READWRITE mode when parent transaction is READONLY");i=null;}i&&a.forEach(function(e){if(i&&-1===i.storeNames.indexOf(e)){if(!u)throw new Y.SubTransaction("Table "+e+" not included in parent transaction.");i=null;}}),u&&i&&!i.active&&(i=null);}}catch(n){return i?i._promise(null,function(e,t){t(n);}):Xe(n)}var s=function i(o,a,u,s,c){return _e.resolve().then(function(){var e=me.transless||me,t=o._createTransaction(a,u,o._dbSchema,s);if(t.explicit=!0,e={trans:t,transless:e},s)t.idbtrans=s.idbtrans;else try{t.create(),t.idbtrans._explicit=!0,o._state.PR1398_maxLoop=3;}catch(e){return e.name===z.InvalidState&&o.isOpen()&&0<--o._state.PR1398_maxLoop?(console.warn("Dexie: Need to reopen db"),o.close({disableAutoOpen:!1}),o.open().then(function(){return i(o,a,u,null,c)})):Xe(e)}var n,r=B(c);return r&&Le(),e=_e.follow(function(){var e;(n=c.call(t,t))&&(r?(e=Ue.bind(null,null),n.then(e,e)):"function"==typeof n.next&&"function"==typeof n.throw&&(n=In(n)));},e),(n&&"function"==typeof n.then?_e.resolve(n).then(function(e){return t.active?e:Xe(new Y.PrematureCommit("Transaction committed too early. See http://bit.ly/2kdckMn"))}):e.then(function(){return n})).then(function(e){return s&&t._resolve(),t._completion.then(function(){return e})}).catch(function(e){return t._reject(e),Xe(e)})})}.bind(null,this,o,a,i,n);return i?i._promise(o,s,"lock"):me.trans?$e(me.transless,function(){return r._whenReady(s)}):this._whenReady(s)},tr.prototype.table=function(e){if(!m(this._allTables,e))throw new Y.InvalidTable("Table ".concat(e," does not exist"));return this._allTables[e]},tr);function tr(e,t){var o=this;this._middlewares={},this.verno=0;var n=tr.dependencies;this._options=t=w({addons:tr.addons,autoOpen:!0,indexedDB:n.indexedDB,IDBKeyRange:n.IDBKeyRange,cache:"cloned"},t),this._deps={indexedDB:t.indexedDB,IDBKeyRange:t.IDBKeyRange};n=t.addons;this._dbSchema={},this._versions=[],this._storeNames=[],this._allTables={},this.idbdb=null,this._novip=this;var a,r,u,i,s,c={dbOpenError:null,isBeingOpened:!1,onReadyBeingFired:null,openComplete:!1,dbReadyResolve:G,dbReadyPromise:null,cancelOpen:G,openCanceller:null,autoSchema:!0,PR1398_maxLoop:3,autoOpen:t.autoOpen};c.dbReadyPromise=new _e(function(e){c.dbReadyResolve=e;}),c.openCanceller=new _e(function(e,t){c.cancelOpen=t;}),this._state=c,this.name=e,this.on=dt(this,"populate","blocked","versionchange","close",{ready:[re,G]}),this.on.ready.subscribe=p(this.on.ready.subscribe,function(i){return function(n,r){tr.vip(function(){var t,e=o._state;e.openComplete?(e.dbOpenError||_e.resolve().then(n),r&&i(n)):e.onReadyBeingFired?(e.onReadyBeingFired.push(n),r&&i(n)):(i(n),t=o,r||i(function e(){t.on.ready.unsubscribe(n),t.on.ready.unsubscribe(e);}));});}}),this.Collection=(a=this,pt(Ot.prototype,function(e,t){this.db=a;var n=ot,r=null;if(t)try{n=t();}catch(e){r=e;}var i=e._ctx,t=i.table,e=t.hook.reading.fire;this._ctx={table:t,index:i.index,isPrimKey:!i.index||t.schema.primKey.keyPath&&i.index===t.schema.primKey.name,range:n,keysOnly:!1,dir:"next",unique:"",algorithm:null,filter:null,replayFilter:null,justLimit:!0,isMatch:null,offset:0,limit:1/0,error:r,or:i.or,valueMapper:e!==X?e:null};})),this.Table=(r=this,pt(ft.prototype,function(e,t,n){this.db=r,this._tx=n,this.name=e,this.schema=t,this.hook=r._allTables[e]?r._allTables[e].hook:dt(null,{creating:[Z,G],reading:[H,X],updating:[te,G],deleting:[ee,G]});})),this.Transaction=(u=this,pt(Lt.prototype,function(e,t,n,r,i){var o=this;this.db=u,this.mode=e,this.storeNames=t,this.schema=n,this.chromeTransactionDurability=r,this.idbtrans=null,this.on=dt(this,"complete","error","abort"),this.parent=i||null,this.active=!0,this._reculock=0,this._blockedFuncs=[],this._resolve=null,this._reject=null,this._waitingFor=null,this._waitingQueue=null,this._spinCount=0,this._completion=new _e(function(e,t){o._resolve=e,o._reject=t;}),this._completion.then(function(){o.active=!1,o.on.complete.fire();},function(e){var t=o.active;return o.active=!1,o.on.error.fire(e),o.parent?o.parent._reject(e):t&&o.idbtrans&&o.idbtrans.abort(),Xe(e)});})),this.Version=(i=this,pt(dn.prototype,function(e){this.db=i,this._cfg={version:e,storesSource:null,dbschema:{},tables:{},contentUpgrade:null};})),this.WhereClause=(s=this,pt(qt.prototype,function(e,t,n){if(this.db=s,this._ctx={table:e,index:":id"===t?null:t,or:n},this._cmp=this._ascending=st,this._descending=function(e,t){return st(t,e)},this._max=function(e,t){return 0<st(e,t)?e:t},this._min=function(e,t){return st(e,t)<0?e:t},this._IDBKeyRange=s._deps.IDBKeyRange,!this._IDBKeyRange)throw new Y.MissingAPI})),this.on("versionchange",function(e){0<e.newVersion?console.warn("Another connection wants to upgrade database '".concat(o.name,"'. Closing db now to resume the upgrade.")):console.warn("Another connection wants to delete database '".concat(o.name,"'. Closing db now to resume the delete request.")),o.close({disableAutoOpen:!1});}),this.on("blocked",function(e){!e.newVersion||e.newVersion<e.oldVersion?console.warn("Dexie.delete('".concat(o.name,"') was blocked")):console.warn("Upgrade '".concat(o.name,"' blocked by other connection holding version ").concat(e.oldVersion/10));}),this._maxKey=Yt(t.IDBKeyRange),this._createTransaction=function(e,t,n,r){return new o.Transaction(e,t,n,o._options.chromeTransactionDurability,r)},this._fireOnBlocked=function(t){o.on("blocked").fire(t),et.filter(function(e){return e.name===o.name&&e!==o&&!e._state.vcFired}).map(function(e){return e.on("versionchange").fire(t)});},this.use(Un),this.use(Jn),this.use(Wn),this.use(Rn),this.use(Nn);var l=new Proxy(this,{get:function(e,t,n){if("_vip"===t)return !0;if("table"===t)return function(e){return Zn(o.table(e),l)};var r=Reflect.get(e,t,n);return r instanceof ft?Zn(r,l):"tables"===t?r.map(function(e){return Zn(e,l)}):"_createTransaction"===t?function(){return Zn(r.apply(this,arguments),l)}:r}});this.vip=l,n.forEach(function(e){return e(o)});}var nr,F="undefined"!=typeof Symbol&&"observable"in Symbol?Symbol.observable:"@@observable",rr=(ir.prototype.subscribe=function(e,t,n){return this._subscribe(e&&"function"!=typeof e?e:{next:e,error:t,complete:n})},ir.prototype[F]=function(){return this},ir);function ir(e){this._subscribe=e;}try{nr={indexedDB:f.indexedDB||f.mozIndexedDB||f.webkitIndexedDB||f.msIndexedDB,IDBKeyRange:f.IDBKeyRange||f.webkitIDBKeyRange};}catch(e){nr={indexedDB:null,IDBKeyRange:null};}function or(h){var d,p=!1,e=new rr(function(r){var i=B(h);var o,a=!1,u={},s={},e={get closed(){return a},unsubscribe:function(){a||(a=!0,o&&o.abort(),c&&Nt.storagemutated.unsubscribe(f));}};r.start&&r.start(e);var c=!1,l=function(){return Ge(t)};var f=function(e){En(u,e),Kn(s,u)&&l();},t=function(){var t,n,e;!a&&nr.indexedDB&&(u={},t={},o&&o.abort(),o=new AbortController,e=function(e){var t=je();try{i&&Le();var n=Ne(h,e);return n=i?n.finally(Ue):n}finally{t&&Ae();}}(n={subscr:t,signal:o.signal,requery:l,querier:h,trans:null}),Promise.resolve(e).then(function(e){p=!0,d=e,a||n.signal.aborted||(u={},function(e){for(var t in e)if(m(e,t))return;return 1}(s=t)||c||(Nt(Ft,f),c=!0),Ge(function(){return !a&&r.next&&r.next(e)}));},function(e){p=!1,["DatabaseClosedError","AbortError"].includes(null==e?void 0:e.name)||a||Ge(function(){a||r.error&&r.error(e);});}));};return setTimeout(l,0),e});return e.hasValue=function(){return p},e.getValue=function(){return d},e}var ar=er;function ur(e){var t=cr;try{cr=!0,Nt.storagemutated.fire(e),Dn(e,!0);}finally{cr=t;}}r(ar,w(w({},Q),{delete:function(e){return new ar(e,{addons:[]}).delete()},exists:function(e){return new ar(e,{addons:[]}).open().then(function(e){return e.close(),!0}).catch("NoSuchDatabaseError",function(){return !1})},getDatabaseNames:function(e){try{return t=ar.dependencies,n=t.indexedDB,t=t.IDBKeyRange,(vn(n)?Promise.resolve(n.databases()).then(function(e){return e.map(function(e){return e.name}).filter(function(e){return e!==tt})}):yn(n,t).toCollection().primaryKeys()).then(e)}catch(e){return Xe(new Y.MissingAPI)}var t,n;},defineClass:function(){return function(e){a(this,e);}},ignoreTransaction:function(e){return me.trans?$e(me.transless,e):e()},vip:mn,async:function(t){return function(){try{var e=In(t.apply(this,arguments));return e&&"function"==typeof e.then?e:_e.resolve(e)}catch(e){return Xe(e)}}},spawn:function(e,t,n){try{var r=In(e.apply(n,t||[]));return r&&"function"==typeof r.then?r:_e.resolve(r)}catch(e){return Xe(e)}},currentTransaction:{get:function(){return me.trans||null}},waitFor:function(e,t){t=_e.resolve("function"==typeof e?ar.ignoreTransaction(e):e).timeout(t||6e4);return me.trans?me.trans.waitFor(t):t},Promise:_e,debug:{get:function(){return ie},set:function(e){oe(e);}},derive:o,extend:a,props:r,override:p,Events:dt,on:Nt,liveQuery:or,extendObservabilitySet:En,getByKeyPath:k,setByKeyPath:P,delByKeyPath:function(t,e){"string"==typeof e?P(t,e,void 0):"length"in e&&[].map.call(e,function(e){P(t,e,void 0);});},shallowClone:g,deepClone:S,getObjectDiff:Fn,cmp:st,asap:v,minKey:-1/0,addons:[],connections:et,errnames:z,dependencies:nr,cache:Sn,semVer:"4.0.8",version:"4.0.8".split(".").map(function(e){return parseInt(e)}).reduce(function(e,t,n){return e+t/Math.pow(10,2*n)})})),ar.maxKey=Yt(ar.dependencies.IDBKeyRange),"undefined"!=typeof dispatchEvent&&"undefined"!=typeof addEventListener&&(Nt(Ft,function(e){cr||(e=new CustomEvent(Mt,{detail:e}),cr=!0,dispatchEvent(e),cr=!1);}),addEventListener(Mt,function(e){e=e.detail;cr||ur(e);}));var sr,cr=!1,lr=function(){};return "undefined"!=typeof BroadcastChannel&&((lr=function(){(sr=new BroadcastChannel(Mt)).onmessage=function(e){return e.data&&ur(e.data)};})(),"function"==typeof sr.unref&&sr.unref(),Nt(Ft,function(e){cr||sr.postMessage(e);})),"undefined"!=typeof addEventListener&&(addEventListener("pagehide",function(e){if(!er.disableBfCache&&e.persisted){ie&&console.debug("Dexie: handling persisted pagehide"),null!=sr&&sr.close();for(var t=0,n=et;t<n.length;t++)n[t].close({disableAutoOpen:!1});}}),addEventListener("pageshow",function(e){!er.disableBfCache&&e.persisted&&(ie&&console.debug("Dexie: handling persisted pageshow"),lr(),ur({all:new gn(-1/0,[[]])}));})),_e.rejectionMapper=function(e,t){return !e||e instanceof N||e instanceof TypeError||e instanceof SyntaxError||!e.name||!$[e.name]?e:(t=new $[e.name](t||e.message,e),"stack"in e&&l(t,"stack",{get:function(){return this.inner.stack}}),t)},oe(ie),w(er,Object.freeze({__proto__:null,Dexie:er,liveQuery:or,Entity:ut,cmp:st,PropModSymbol:e,PropModification:xt,replacePrefix:function(e,t){return new xt({replacePrefix:[e,t]})},add:function(e){return new xt({add:e})},remove:function(e){return new xt({remove:e})},default:er,RangeSet:gn,mergeRanges:_n,rangesOverlap:xn}),{default:er}),er});
	
} (dexie_min));

var dexie_minExports = dexie_min.exports;
const _Dexie = /*@__PURE__*/getDefaultExportFromCjs(dexie_minExports);

// Making the module version consumable via require - to prohibit
// multiple occurrancies of the same module in the same app
// (dual package hazard, https://nodejs.org/api/packages.html#dual-package-hazard)
const DexieSymbol = Symbol.for("Dexie");
const Dexie = globalThis[DexieSymbol] || (globalThis[DexieSymbol] = _Dexie);
if (_Dexie.semVer !== Dexie.semVer) {
    throw new Error(`Two different versions of Dexie loaded in the same app: ${_Dexie.semVer} and ${Dexie.semVer}`);
}
const {
    liveQuery, mergeRanges, rangesOverlap, RangeSet, cmp, Entity,
    PropModSymbol, PropModification, replacePrefix, add, remove } = Dexie;

function formatDependency(params, idx) {
  if (params === null) {
    return `at position #${idx}`;
  }
  const argName = params.split(",")[idx].trim();
  return `"${argName}" at position #${idx}`;
}
function composeErrorMessage(msg, e, indent = "    ") {
  return [msg, ...e.message.split("\n").map((l) => indent + l)].join("\n");
}
function formatErrorCtor(ctor, paramIdx, error) {
  const [, params = null] = ctor.toString().match(/constructor\(([\w, ]+)\)/) || [];
  const dep = formatDependency(params, paramIdx);
  return composeErrorMessage(
    `Cannot inject the dependency ${dep} of "${ctor.name}" constructor. Reason:`,
    error
  );
}

class RegistryBase {
  constructor() {
    this._registryMap = /* @__PURE__ */ new Map();
  }
  entries() {
    return this._registryMap.entries();
  }
  getAll(key) {
    this.ensure(key);
    return this._registryMap.get(key);
  }
  get(key) {
    this.ensure(key);
    const value = this._registryMap.get(key);
    return value[value.length - 1] || null;
  }
  set(key, value) {
    this.ensure(key);
    this._registryMap.get(key).push(value);
  }
  setAll(key, value) {
    this._registryMap.set(key, value);
  }
  has(key) {
    this.ensure(key);
    return this._registryMap.get(key).length > 0;
  }
  clear() {
    this._registryMap.clear();
  }
  delete(key) {
    this._registryMap.delete(key);
  }
  ensure(key) {
    if (!this._registryMap.has(key)) {
      this._registryMap.set(key, []);
    }
  }
}

class PreResolutionInterceptors extends RegistryBase {
}
class PostResolutionInterceptors extends RegistryBase {
}
class Interceptors {
  constructor() {
    this.preResolution = new PreResolutionInterceptors();
    this.postResolution = new PostResolutionInterceptors();
  }
}

class DelayedConstructor {
  constructor(wrap) {
    this.wrap = wrap;
    this.reflectMethods = [
      "get",
      "getPrototypeOf",
      "setPrototypeOf",
      "getOwnPropertyDescriptor",
      "defineProperty",
      "has",
      "set",
      "deleteProperty",
      "apply",
      "construct",
      "ownKeys"
    ];
  }
  createProxy(createObject) {
    const target = {};
    let init = false;
    let value;
    const delayedObject = () => {
      if (!init) {
        value = createObject(this.wrap());
        init = true;
      }
      return value;
    };
    return new Proxy(target, this.createHandler(delayedObject));
  }
  createHandler(delayedObject) {
    const handler = {};
    const install = (name) => {
      handler[name] = (...args) => {
        args[0] = delayedObject();
        const method = Reflect[name];
        return method(...args);
      };
    };
    this.reflectMethods.forEach(install);
    return handler;
  }
}

function isClassProvider(provider) {
  return Boolean(provider.useClass);
}

function isFactoryProvider(provider) {
  return Boolean(provider.useFactory);
}

function isNormalToken(token) {
  return typeof token === "string" || typeof token === "symbol";
}
function isTokenDescriptor(descriptor) {
  return typeof descriptor === "object" && "token" in descriptor && "multiple" in descriptor;
}
function isTransformDescriptor(descriptor) {
  return typeof descriptor === "object" && "token" in descriptor && "transform" in descriptor;
}
function isConstructorToken(token) {
  return typeof token === "function" || token instanceof DelayedConstructor;
}

function isTokenProvider(provider) {
  return Boolean(provider.useToken);
}

function isValueProvider(provider) {
  return Object.prototype.hasOwnProperty.call(provider, "useValue");
}

function isProvider(provider) {
  return isClassProvider(provider) || isValueProvider(provider) || isTokenProvider(provider) || isFactoryProvider(provider);
}

const INJECTION_TOKEN_METADATA_KEY = "injectionTokens";
const PARAM_INFOS_METADATA_KEY = "paramInfos";
function getParamInfo(target) {
  const params = Reflect.getMetadata("design:paramtypes", target) || [];
  const injectionTokens = Reflect.getOwnMetadata(INJECTION_TOKEN_METADATA_KEY, target) || {};
  Object.keys(injectionTokens).forEach((key) => {
    params[Number(key)] = injectionTokens[key];
  });
  return params;
}
function defineInjectionTokenMetadata(data, transform) {
  return function(target, _propertyKey, parameterIndex) {
    const descriptors = Reflect.getOwnMetadata(INJECTION_TOKEN_METADATA_KEY, target) || {};
    descriptors[parameterIndex] = data;
    Reflect.defineMetadata(INJECTION_TOKEN_METADATA_KEY, descriptors, target);
  };
}

class Registry extends RegistryBase {
}

class ResolutionContext {
  constructor() {
    this.scopedResolutions = /* @__PURE__ */ new Map();
  }
}

function isDisposable(value) {
  if (typeof value !== "object" || value === null) return false;
  if (!("dispose" in value)) return false;
  if (typeof value.dispose !== "function") return false;
  const disposeFn = value.dispose;
  if (disposeFn.length > 0) {
    return false;
  }
  return true;
}

var Lifecycle = /* @__PURE__ */ ((Lifecycle2) => {
  Lifecycle2[Lifecycle2["Transient"] = 0] = "Transient";
  Lifecycle2[Lifecycle2["Singleton"] = 1] = "Singleton";
  Lifecycle2[Lifecycle2["ResolutionScoped"] = 2] = "ResolutionScoped";
  Lifecycle2[Lifecycle2["ContainerScoped"] = 3] = "ContainerScoped";
  return Lifecycle2;
})(Lifecycle || {});

class InternalDependencyContainer {
  constructor(parent) {
    this.parent = parent;
    this._registry = new Registry();
    this.interceptors = new Interceptors();
    this.disposed = false;
    this.disposables = /* @__PURE__ */ new Set();
  }
  register(token, providerOrConstructor, options = { lifecycle: Lifecycle.Transient }) {
    this.ensureNotDisposed();
    let provider;
    if (!isProvider(providerOrConstructor)) {
      provider = { useClass: providerOrConstructor };
    } else {
      provider = providerOrConstructor;
    }
    if (isTokenProvider(provider)) {
      const path = [token];
      let tokenProvider = provider;
      while (tokenProvider != null) {
        const currentToken = tokenProvider.useToken;
        if (path.includes(currentToken)) {
          throw new Error(
            `Token registration cycle detected! ${[...path, currentToken].join(
              " -> "
            )}`
          );
        }
        path.push(currentToken);
        const registration = this._registry.get(currentToken);
        if (registration && isTokenProvider(registration.provider)) {
          tokenProvider = registration.provider;
        } else {
          tokenProvider = null;
        }
      }
    }
    if ((options.lifecycle === Lifecycle.Singleton || options.lifecycle === Lifecycle.ContainerScoped || options.lifecycle === Lifecycle.ResolutionScoped) && (isValueProvider(provider) || isFactoryProvider(provider))) {
      throw new Error(
        `Cannot use lifecycle "${Lifecycle[options.lifecycle]}" with ValueProviders or FactoryProviders`
      );
    }
    this._registry.set(token, { provider, options });
    return this;
  }
  registerType(from, to) {
    this.ensureNotDisposed();
    if (isNormalToken(to)) {
      return this.register(from, {
        useToken: to
      });
    }
    return this.register(from, {
      useClass: to
    });
  }
  registerInstance(token, instance2) {
    this.ensureNotDisposed();
    return this.register(token, {
      useValue: instance2
    });
  }
  registerSingleton(from, to) {
    this.ensureNotDisposed();
    if (isNormalToken(from)) {
      if (isNormalToken(to)) {
        return this.register(
          from,
          {
            useToken: to
          },
          { lifecycle: Lifecycle.Singleton }
        );
      }
      if (to) {
        return this.register(
          from,
          {
            useClass: to
          },
          { lifecycle: Lifecycle.Singleton }
        );
      }
      throw new Error(
        'Cannot register a type name as a singleton without a "to" token'
      );
    }
    let useClass = from;
    if (to && !isNormalToken(to)) {
      useClass = to;
    }
    return this.register(
      from,
      {
        useClass
      },
      { lifecycle: Lifecycle.Singleton }
    );
  }
  resolve(token, context = new ResolutionContext()) {
    this.ensureNotDisposed();
    const registration = this.getRegistration(token);
    if (!registration && isNormalToken(token)) {
      throw new Error(
        `Attempted to resolve unregistered dependency token: "${token.toString()}"`
      );
    }
    this.executePreResolutionInterceptor(token, "Single");
    if (registration) {
      const result = this.resolveRegistration(registration, context);
      this.executePostResolutionInterceptor(token, result, "Single");
      return result;
    }
    if (isConstructorToken(token)) {
      const result = this.construct(token, context);
      this.executePostResolutionInterceptor(token, result, "Single");
      return result;
    }
    throw new Error(
      "Attempted to construct an undefined constructor. Could mean a circular dependency problem. Try using `delay` function."
    );
  }
  executePreResolutionInterceptor(token, resolutionType) {
    if (this.interceptors.preResolution.has(token)) {
      const remainingInterceptors = [];
      for (const interceptor of this.interceptors.preResolution.getAll(token)) {
        if (interceptor.options.frequency !== "Once") {
          remainingInterceptors.push(interceptor);
        }
        interceptor.callback(token, resolutionType);
      }
      this.interceptors.preResolution.setAll(token, remainingInterceptors);
    }
  }
  executePostResolutionInterceptor(token, result, resolutionType) {
    if (this.interceptors.postResolution.has(token)) {
      const remainingInterceptors = [];
      for (const interceptor of this.interceptors.postResolution.getAll(
        token
      )) {
        if (interceptor.options.frequency !== "Once") {
          remainingInterceptors.push(interceptor);
        }
        interceptor.callback(token, result, resolutionType);
      }
      this.interceptors.postResolution.setAll(token, remainingInterceptors);
    }
  }
  resolveRegistration(registration, context) {
    this.ensureNotDisposed();
    if (registration.options.lifecycle === Lifecycle.ResolutionScoped && context.scopedResolutions.has(registration)) {
      return context.scopedResolutions.get(registration);
    }
    const isSingleton = registration.options.lifecycle === Lifecycle.Singleton;
    const isContainerScoped = registration.options.lifecycle === Lifecycle.ContainerScoped;
    const returnInstance = isSingleton || isContainerScoped;
    let newResolution = true;
    let resolved;
    if (isValueProvider(registration.provider)) {
      resolved = registration.provider.useValue;
    } else if (isTokenProvider(registration.provider)) {
      newResolution = returnInstance;
      resolved = returnInstance ? registration.instance || (registration.instance = this.resolve(
        registration.provider.useToken,
        context
      )) : this.resolve(registration.provider.useToken, context);
    } else if (isClassProvider(registration.provider)) {
      newResolution = returnInstance;
      resolved = returnInstance ? registration.instance || (registration.instance = this.construct(
        registration.provider.useClass,
        context
      )) : this.construct(registration.provider.useClass, context);
    } else if (isFactoryProvider(registration.provider)) {
      resolved = registration.provider.useFactory(this);
    } else {
      newResolution = false;
      resolved = this.construct(registration.provider, context);
    }
    if (registration.options.lifecycle === Lifecycle.ResolutionScoped) {
      context.scopedResolutions.set(registration, resolved);
    }
    if (newResolution && isDisposable(resolved)) {
      this.disposables.add(resolved);
    }
    return resolved;
  }
  resolveAll(token, context = new ResolutionContext()) {
    this.ensureNotDisposed();
    const registrations = this.getAllRegistrations(token);
    if (!registrations && isNormalToken(token)) {
      throw new Error(
        `Attempted to resolve unregistered dependency token: "${token.toString()}"`
      );
    }
    this.executePreResolutionInterceptor(token, "All");
    if (registrations) {
      const result2 = registrations.map(
        (item) => this.resolveRegistration(item, context)
      );
      this.executePostResolutionInterceptor(token, result2, "All");
      return result2;
    }
    const result = [this.construct(token, context)];
    this.executePostResolutionInterceptor(token, result, "All");
    return result;
  }
  isRegistered(token, recursive = false) {
    this.ensureNotDisposed();
    return this._registry.has(token) || ((recursive && this.parent?.isRegistered(token, true)) ?? false);
  }
  reset() {
    this.ensureNotDisposed();
    this._registry.clear();
    this.interceptors.preResolution.clear();
    this.interceptors.postResolution.clear();
  }
  unregisterAll() {
    this._registry.clear();
    this.interceptors.preResolution.clear();
    this.interceptors.postResolution.clear();
  }
  unregister(token) {
    const registration = this.getRegistration(token);
    if (!registration) {
      throw new Error(
        `Attempted to delete unregistered dependency token: "${token.toString()}"`
      );
    }
    this._registry.delete(token);
    this.interceptors.preResolution.delete(token);
    this.interceptors.postResolution.delete(token);
  }
  clearInstances() {
    this.ensureNotDisposed();
    for (const [token, registrations] of this._registry.entries()) {
      this._registry.setAll(
        token,
        registrations.filter((registration) => !isValueProvider(registration.provider)).map((registration) => {
          registration.instance = void 0;
          return registration;
        })
      );
    }
  }
  createChildContainer() {
    this.ensureNotDisposed();
    const childContainer = new InternalDependencyContainer(this);
    for (const [token, registrations] of this._registry.entries()) {
      if (registrations.some(
        ({ options }) => options.lifecycle === Lifecycle.ContainerScoped
      )) {
        childContainer._registry.setAll(
          token,
          registrations.map((registration) => {
            if (registration.options.lifecycle === Lifecycle.ContainerScoped) {
              return {
                provider: registration.provider,
                options: registration.options
              };
            }
            return registration;
          })
        );
      }
    }
    return childContainer;
  }
  beforeResolution(token, callback, options = { frequency: "Always" }) {
    this.interceptors.preResolution.set(token, {
      callback,
      options
    });
  }
  afterResolution(token, callback, options = { frequency: "Always" }) {
    this.interceptors.postResolution.set(token, {
      callback,
      options
    });
  }
  async dispose() {
    this.disposed = true;
    const promises = [];
    this.disposables.forEach((disposable) => {
      const maybePromise = disposable.dispose();
      if (maybePromise) {
        promises.push(maybePromise);
      }
    });
    await Promise.all(promises);
  }
  getRegistration(token) {
    if (this.isRegistered(token)) {
      return this._registry.get(token);
    }
    if (this.parent) {
      return this.parent.getRegistration(token);
    }
    return null;
  }
  getAllRegistrations(token) {
    if (this.isRegistered(token)) {
      return this._registry.getAll(token);
    }
    if (this.parent) {
      return this.parent.getAllRegistrations(token);
    }
    return null;
  }
  construct(ctor, context) {
    if (ctor instanceof DelayedConstructor) {
      return ctor.createProxy(
        (target) => this.resolve(target, context)
      );
    }
    const instance2 = (() => {
      const paramInfo = Reflect.getMetadata(PARAM_INFOS_METADATA_KEY, ctor);
      if (!paramInfo || paramInfo.length === 0) {
        if (ctor.length === 0) {
          return new ctor();
        }
        throw new Error(`TypeInfo not known for "${ctor.name}"`);
      }
      const params = paramInfo.map(this.resolveParams(context, ctor));
      return new ctor(...params);
    })();
    if (isDisposable(instance2)) {
      this.disposables.add(instance2);
    }
    return instance2;
  }
  resolveParams(context, ctor) {
    return (param, idx) => {
      try {
        if (isTokenDescriptor(param)) {
          if (isTransformDescriptor(param)) {
            return param.multiple ? this.resolve(param.transform).transform(
              this.resolveAll(param.token),
              ...param.transformArgs
            ) : this.resolve(param.transform).transform(
              this.resolve(param.token, context),
              ...param.transformArgs
            );
          }
          return param.multiple ? this.resolveAll(param.token) : this.resolve(param.token, context);
        }
        if (isTransformDescriptor(param)) {
          return this.resolve(param.transform, context).transform(
            this.resolve(param.token, context),
            ...param.transformArgs
          );
        }
        return this.resolve(param, context);
      } catch (error) {
        throw new Error(formatErrorCtor(ctor, idx, error));
      }
    };
  }
  ensureNotDisposed() {
    if (this.disposed) {
      throw new Error(
        "This container has been disposed, you cannot interact with a disposed container"
      );
    }
  }
}
const instance = new InternalDependencyContainer();

function inject(token) {
  return defineInjectionTokenMetadata(token);
}

function injectable() {
  return function(target) {
    const paramInfo = getParamInfo(target);
    Reflect.defineMetadata(PARAM_INFOS_METADATA_KEY, paramInfo, target);
  };
}

function singleton() {
  return function(target) {
    injectable()(target);
    instance.registerSingleton(target);
  };
}

if (typeof Reflect === "undefined" || !Reflect.getMetadata) {
  throw new Error(
    `tsyringe-neo requires a reflect polyfill. Please add 'import "reflect-metadata"' to the top of your entry point.`
  );
}

var FileStatus;
(function(FileStatus) {
    FileStatus["Created"] = "Created";
    FileStatus["Failed"] = "Failed";
    FileStatus["Finished"] = "Finished";
    FileStatus["Ignore"] = "Ignore";
    /** 流式文件本身没有结束状态，比如录制 canvas 的视频流 */ FileStatus["Stream"] = "Stream";
})(FileStatus || (FileStatus = {}));
var RecordingStatus;
(function(RecordingStatus) {
    RecordingStatus["Cancelled"] = "Cancelled";
    RecordingStatus["Completed"] = "Completed";
    RecordingStatus["CompletedWithWarning"] = "CompletedWithWarning";
    RecordingStatus["Failed"] = "Failed";
    RecordingStatus["Paused"] = "Paused";
    RecordingStatus["Pending"] = "Pending";
    RecordingStatus["Running"] = "Running";
    RecordingStatus["Stopped"] = "Stopped";
    RecordingStatus["Uploading"] = "Uploading";
    RecordingStatus["UploadingExtra"] = "UploadingExtra";
})(RecordingStatus || (RecordingStatus = {}));
var SelectElementActionType;
(function(SelectElementActionType) {
    SelectElementActionType["Stop"] = "Stop";
    SelectElementActionType["Submit"] = "Submit";
    SelectElementActionType["ZoomIn"] = "ZoomIn";
    SelectElementActionType["ZoomOut"] = "ZoomOut";
})(SelectElementActionType || (SelectElementActionType = {}));
var TaskType;
(function(TaskType) {
    TaskType["Snapshot"] = "Snapshot";
    TaskType["Tour"] = "Tour";
})(TaskType || (TaskType = {}));
var TaskVariance;
(function(TaskVariance) {
    TaskVariance["Full"] = "Full";
    TaskVariance["SelectElement"] = "SelectElement";
})(TaskVariance || (TaskVariance = {}));

const DEXIE_TRUE = 1;
const DEXIE_FALSE = 0;
class RecorderDB extends Dexie {
    constructor(){
        super('Recorder');
        this.version(23).stores({
            tasks: '++id, status',
            frames: '++id, taskId, timestamp',
            files: null,
            fileChunks: null
        });
        this.version(24).stores({
            tasks: '++id, status',
            frames: '++id, taskId, timestamp',
            files: '[taskId+url], taskId, url, fileType, status, hash, [taskId+uploaded]',
            fileChunks: '++id, [taskId+url]'
        });
        this.version(25).stores({
            tasks: '++id, status',
            frames: '++id, taskId, timestamp',
            files: '[taskId+url], taskId, url, fileType, status, hash, [taskId+uploaded], [taskId+fileType+uploaded]',
            fileChunks: '++id, [taskId+url]'
        });
    }
}
RecorderDB = __decorate([
    singleton(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [])
], RecorderDB);

const STORAGE = 'storage';
const LOGGER = 'logger';
const FETCH = 'fetch';
const UPLOADER_SERVICE = 'uploader.service';
const OAUTH_CLIENT = 'oauth-client';
const OAUTH_CONTROLLER = 'oauth-controller';
const FILE_STASH_SERVICE = 'file-stash.service';
const SELECT_ELEMENT_SERVICE = 'select-element.service';
const FONT_SETTINGS_SERVICE = 'font-settings.service';
const REGION = 'region';

function fromLiveQuery(source$) {
    return new Observable$1((subscriber)=>{
        const subscription = source$.subscribe(subscriber);
        return ()=>{
            subscription.unsubscribe();
        };
    });
}
function isAsyncIterable(val) {
    return typeof Object(val)[Symbol.asyncIterator] === 'function';
}
function isAsyncGenerator(val) {
    return 'return' in val && typeof val.return === 'function';
}
function waitForClientConnect() {
    return fromEvent$1(window, 'message').pipe(filter((event)=>{
        const { data, ports } = event;
        if (!data || ports?.length !== 1) {
            return false;
        }
        return data.magic === MAGIC && data.type === IntermediaryMessageTypes.Connect && !!event.source;
    }));
}
function thunkGetUserIdFromStorage(storage) {
    return ()=>storage.getItem(OAUTH_KEY).then((value)=>value?.userId ?? '');
}

const asArray = (fns) => (Array.isArray(fns) ? fns : fns ? [fns] : []);
function compareStrings(a, b) {
    if (String(a) < String(b)) {
        return -1;
    }
    if (String(a) > String(b)) {
        return 1;
    }
    return 0;
}
function nodeToString(a) {
    let name;
    if ('alias' in a) {
        name = a.alias?.value;
    }
    if (name == null && 'name' in a) {
        name = a.name?.value;
    }
    if (name == null) {
        name = a.kind;
    }
    return name;
}
function compareNodes(a, b, customFn) {
    const aStr = nodeToString(a);
    const bStr = nodeToString(b);
    if (typeof customFn === 'function') {
        return customFn(aStr, bStr);
    }
    return compareStrings(aStr, bStr);
}
function isSome(input) {
    return input != null;
}

// Taken from graphql-js
// https://github.com/graphql/graphql-js/blob/main/src/jsutils/inspect.ts
const MAX_RECURSIVE_DEPTH = 3;
/**
 * Used to print values in error messages.
 */
function inspect(value) {
    return formatValue(value, []);
}
function formatValue(value, seenValues) {
    switch (typeof value) {
        case 'string':
            return JSON.stringify(value);
        case 'function':
            return value.name ? `[function ${value.name}]` : '[function]';
        case 'object':
            return formatObjectValue(value, seenValues);
        default:
            return String(value);
    }
}
function formatError(value) {
    // eslint-disable-next-line no-constant-condition
    if ((value.name = 'GraphQLError')) {
        return value.toString();
    }
    return `${value.name}: ${value.message};\n ${value.stack}`;
}
function formatObjectValue(value, previouslySeenValues) {
    if (value === null) {
        return 'null';
    }
    if (value instanceof Error) {
        if (value.name === 'AggregateError') {
            return (formatError(value) +
                '\n' +
                formatArray(value.errors, previouslySeenValues));
        }
        return formatError(value);
    }
    if (previouslySeenValues.includes(value)) {
        return '[Circular]';
    }
    const seenValues = [...previouslySeenValues, value];
    if (isJSONable(value)) {
        const jsonValue = value.toJSON();
        // check for infinite recursion
        if (jsonValue !== value) {
            return typeof jsonValue === 'string' ? jsonValue : formatValue(jsonValue, seenValues);
        }
    }
    else if (Array.isArray(value)) {
        return formatArray(value, seenValues);
    }
    return formatObject(value, seenValues);
}
function isJSONable(value) {
    return typeof value.toJSON === 'function';
}
function formatObject(object, seenValues) {
    const entries = Object.entries(object);
    if (entries.length === 0) {
        return '{}';
    }
    if (seenValues.length > MAX_RECURSIVE_DEPTH) {
        return '[' + getObjectTag(object) + ']';
    }
    const properties = entries.map(([key, value]) => key + ': ' + formatValue(value, seenValues));
    return '{ ' + properties.join(', ') + ' }';
}
function formatArray(array, seenValues) {
    if (array.length === 0) {
        return '[]';
    }
    if (seenValues.length > MAX_RECURSIVE_DEPTH) {
        return '[Array]';
    }
    const len = array.length;
    const items = [];
    for (let i = 0; i < len; ++i) {
        items.push(formatValue(array[i], seenValues));
    }
    return '[' + items.join(', ') + ']';
}
function getObjectTag(object) {
    const tag = Object.prototype.toString
        .call(object)
        .replace(/^\[object /, '')
        .replace(/]$/, '');
    if (tag === 'Object' && typeof object.constructor === 'function') {
        const name = object.constructor.name;
        if (typeof name === 'string' && name !== '') {
            return name;
        }
    }
    return tag;
}

function isIterableObject(value) {
    return value != null && typeof value === 'object' && Symbol.iterator in value;
}
function isObjectLike(value) {
    return typeof value === 'object' && value !== null;
}

function getDirectivesInExtensions(node, pathToDirectivesInExtensions = ['directives']) {
    return pathToDirectivesInExtensions.reduce((acc, pathSegment) => (acc == null ? acc : acc[pathSegment]), node?.extensions);
}

function astFromType(type) {
    if (isNonNullType(type)) {
        const innerType = astFromType(type.ofType);
        if (innerType.kind === Kind.NON_NULL_TYPE) {
            throw new Error(`Invalid type node ${inspect(type)}. Inner type of non-null type cannot be a non-null type.`);
        }
        return {
            kind: Kind.NON_NULL_TYPE,
            type: innerType,
        };
    }
    else if (isListType(type)) {
        return {
            kind: Kind.LIST_TYPE,
            type: astFromType(type.ofType),
        };
    }
    return {
        kind: Kind.NAMED_TYPE,
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
    };
}

/**
 * Produces a GraphQL Value AST given a JavaScript object.
 * Function will match JavaScript/JSON values to GraphQL AST schema format
 * by using the following mapping.
 *
 * | JSON Value    | GraphQL Value        |
 * | ------------- | -------------------- |
 * | Object        | Input Object         |
 * | Array         | List                 |
 * | Boolean       | Boolean              |
 * | String        | String               |
 * | Number        | Int / Float          |
 * | BigInt        | Int                  |
 * | null          | NullValue            |
 *
 */
function astFromValueUntyped(value) {
    // only explicit null, not undefined, NaN
    if (value === null) {
        return { kind: Kind.NULL };
    }
    // undefined
    if (value === undefined) {
        return null;
    }
    // Convert JavaScript array to GraphQL list. If the GraphQLType is a list, but
    // the value is not an array, convert the value using the list's item type.
    if (Array.isArray(value)) {
        const valuesNodes = [];
        for (const item of value) {
            const itemNode = astFromValueUntyped(item);
            if (itemNode != null) {
                valuesNodes.push(itemNode);
            }
        }
        return { kind: Kind.LIST, values: valuesNodes };
    }
    if (typeof value === 'object') {
        if (value?.toJSON) {
            return astFromValueUntyped(value.toJSON());
        }
        const fieldNodes = [];
        for (const fieldName in value) {
            const fieldValue = value[fieldName];
            const ast = astFromValueUntyped(fieldValue);
            if (ast) {
                fieldNodes.push({
                    kind: Kind.OBJECT_FIELD,
                    name: { kind: Kind.NAME, value: fieldName },
                    value: ast,
                });
            }
        }
        return { kind: Kind.OBJECT, fields: fieldNodes };
    }
    // Others serialize based on their corresponding JavaScript scalar types.
    if (typeof value === 'boolean') {
        return { kind: Kind.BOOLEAN, value };
    }
    if (typeof value === 'bigint') {
        return { kind: Kind.INT, value: String(value) };
    }
    // JavaScript numbers can be Int or Float values.
    if (typeof value === 'number' && isFinite(value)) {
        const stringNum = String(value);
        return integerStringRegExp$1.test(stringNum)
            ? { kind: Kind.INT, value: stringNum }
            : { kind: Kind.FLOAT, value: stringNum };
    }
    if (typeof value === 'string') {
        return { kind: Kind.STRING, value };
    }
    throw new TypeError(`Cannot convert value to AST: ${value}.`);
}
/**
 * IntValue:
 *   - NegativeSign? 0
 *   - NegativeSign? NonZeroDigit ( Digit+ )?
 */
const integerStringRegExp$1 = /^-?(?:0|[1-9][0-9]*)$/;

/**
 * Produces a GraphQL Value AST given a JavaScript object.
 * Function will match JavaScript/JSON values to GraphQL AST schema format
 * by using suggested GraphQLInputType. For example:
 *
 *     astFromValue("value", GraphQLString)
 *
 * A GraphQL type must be provided, which will be used to interpret different
 * JavaScript values.
 *
 * | JSON Value    | GraphQL Value        |
 * | ------------- | -------------------- |
 * | Object        | Input Object         |
 * | Array         | List                 |
 * | Boolean       | Boolean              |
 * | String        | String / Enum Value  |
 * | Number        | Int / Float          |
 * | BigInt        | Int                  |
 * | Unknown       | Enum Value           |
 * | null          | NullValue            |
 *
 */
function astFromValue(value, type) {
    if (isNonNullType(type)) {
        const astValue = astFromValue(value, type.ofType);
        if (astValue?.kind === Kind.NULL) {
            return null;
        }
        return astValue;
    }
    // only explicit null, not undefined, NaN
    if (value === null) {
        return { kind: Kind.NULL };
    }
    // undefined
    if (value === undefined) {
        return null;
    }
    // Convert JavaScript array to GraphQL list. If the GraphQLType is a list, but
    // the value is not an array, convert the value using the list's item type.
    if (isListType(type)) {
        const itemType = type.ofType;
        if (isIterableObject(value)) {
            const valuesNodes = [];
            for (const item of value) {
                const itemNode = astFromValue(item, itemType);
                if (itemNode != null) {
                    valuesNodes.push(itemNode);
                }
            }
            return { kind: Kind.LIST, values: valuesNodes };
        }
        return astFromValue(value, itemType);
    }
    // Populate the fields of the input object by creating ASTs from each value
    // in the JavaScript object according to the fields in the input type.
    if (isInputObjectType(type)) {
        if (!isObjectLike(value)) {
            return null;
        }
        const fieldNodes = [];
        for (const field of Object.values(type.getFields())) {
            const fieldValue = astFromValue(value[field.name], field.type);
            if (fieldValue) {
                fieldNodes.push({
                    kind: Kind.OBJECT_FIELD,
                    name: { kind: Kind.NAME, value: field.name },
                    value: fieldValue,
                });
            }
        }
        return { kind: Kind.OBJECT, fields: fieldNodes };
    }
    if (isLeafType(type)) {
        // Since value is an internally represented value, it must be serialized
        // to an externally represented value before converting into an AST.
        const serialized = type.serialize(value);
        if (serialized == null) {
            return null;
        }
        if (isEnumType(type)) {
            return { kind: Kind.ENUM, value: serialized };
        }
        // ID types can use Int literals.
        if (type.name === 'ID' &&
            typeof serialized === 'string' &&
            integerStringRegExp.test(serialized)) {
            return { kind: Kind.INT, value: serialized };
        }
        return astFromValueUntyped(serialized);
    }
    /* c8 ignore next 3 */
    // Not reachable, all possible types have been considered.
    console.assert(false, 'Unexpected input type: ' + inspect(type));
}
/**
 * IntValue:
 *   - NegativeSign? 0
 *   - NegativeSign? NonZeroDigit ( Digit+ )?
 */
const integerStringRegExp = /^-?(?:0|[1-9][0-9]*)$/;

function getDescriptionNode(obj) {
    if (obj.astNode?.description) {
        return {
            ...obj.astNode.description,
            block: true,
        };
    }
    if (obj.description) {
        return {
            kind: Kind.STRING,
            value: obj.description,
            block: true,
        };
    }
}

function memoize1(fn) {
    const memoize1cache = new WeakMap();
    return function memoized(a1) {
        const cachedValue = memoize1cache.get(a1);
        if (cachedValue === undefined) {
            const newValue = fn(a1);
            memoize1cache.set(a1, newValue);
            return newValue;
        }
        return cachedValue;
    };
}

const getRootTypeMap = memoize1(function getRootTypeMap(schema) {
    const rootTypeMap = new Map();
    const queryType = schema.getQueryType();
    if (queryType) {
        rootTypeMap.set('query', queryType);
    }
    const mutationType = schema.getMutationType();
    if (mutationType) {
        rootTypeMap.set('mutation', mutationType);
    }
    const subscriptionType = schema.getSubscriptionType();
    if (subscriptionType) {
        rootTypeMap.set('subscription', subscriptionType);
    }
    return rootTypeMap;
});

function getDocumentNodeFromSchema(schema, options = {}) {
    const pathToDirectivesInExtensions = options.pathToDirectivesInExtensions;
    const typesMap = schema.getTypeMap();
    const schemaNode = astFromSchema(schema, pathToDirectivesInExtensions);
    const definitions = schemaNode != null ? [schemaNode] : [];
    const directives = schema.getDirectives();
    for (const directive of directives) {
        if (isSpecifiedDirective(directive)) {
            continue;
        }
        definitions.push(astFromDirective(directive, schema, pathToDirectivesInExtensions));
    }
    for (const typeName in typesMap) {
        const type = typesMap[typeName];
        const isPredefinedScalar = isSpecifiedScalarType(type);
        const isIntrospection = isIntrospectionType(type);
        if (isPredefinedScalar || isIntrospection) {
            continue;
        }
        if (isObjectType(type)) {
            definitions.push(astFromObjectType(type, schema, pathToDirectivesInExtensions));
        }
        else if (isInterfaceType(type)) {
            definitions.push(astFromInterfaceType(type, schema, pathToDirectivesInExtensions));
        }
        else if (isUnionType(type)) {
            definitions.push(astFromUnionType(type, schema, pathToDirectivesInExtensions));
        }
        else if (isInputObjectType(type)) {
            definitions.push(astFromInputObjectType(type, schema, pathToDirectivesInExtensions));
        }
        else if (isEnumType(type)) {
            definitions.push(astFromEnumType(type, schema, pathToDirectivesInExtensions));
        }
        else if (isScalarType(type)) {
            definitions.push(astFromScalarType(type, schema, pathToDirectivesInExtensions));
        }
        else {
            throw new Error(`Unknown type ${type}.`);
        }
    }
    return {
        kind: Kind.DOCUMENT,
        definitions,
    };
}
function astFromSchema(schema, pathToDirectivesInExtensions) {
    const operationTypeMap = new Map([
        ['query', undefined],
        ['mutation', undefined],
        ['subscription', undefined],
    ]);
    const nodes = [];
    if (schema.astNode != null) {
        nodes.push(schema.astNode);
    }
    if (schema.extensionASTNodes != null) {
        for (const extensionASTNode of schema.extensionASTNodes) {
            nodes.push(extensionASTNode);
        }
    }
    for (const node of nodes) {
        if (node.operationTypes) {
            for (const operationTypeDefinitionNode of node.operationTypes) {
                operationTypeMap.set(operationTypeDefinitionNode.operation, operationTypeDefinitionNode);
            }
        }
    }
    const rootTypeMap = getRootTypeMap(schema);
    for (const [operationTypeNode, operationTypeDefinitionNode] of operationTypeMap) {
        const rootType = rootTypeMap.get(operationTypeNode);
        if (rootType != null) {
            const rootTypeAST = astFromType(rootType);
            if (operationTypeDefinitionNode != null) {
                operationTypeDefinitionNode.type = rootTypeAST;
            }
            else {
                operationTypeMap.set(operationTypeNode, {
                    kind: Kind.OPERATION_TYPE_DEFINITION,
                    operation: operationTypeNode,
                    type: rootTypeAST,
                });
            }
        }
    }
    const operationTypes = [...operationTypeMap.values()].filter(isSome);
    const directives = getDirectiveNodes(schema, schema, pathToDirectivesInExtensions);
    if (!operationTypes.length && !directives.length) {
        return null;
    }
    const schemaNode = {
        kind: operationTypes != null ? Kind.SCHEMA_DEFINITION : Kind.SCHEMA_EXTENSION,
        operationTypes,
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: directives,
    };
    const descriptionNode = getDescriptionNode(schema);
    if (descriptionNode) {
        schemaNode.description = descriptionNode;
    }
    return schemaNode;
}
function astFromDirective(directive, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.DIRECTIVE_DEFINITION,
        description: getDescriptionNode(directive),
        name: {
            kind: Kind.NAME,
            value: directive.name,
        },
        arguments: directive.args?.map(arg => astFromArg(arg, schema, pathToDirectivesInExtensions)),
        repeatable: directive.isRepeatable,
        locations: directive.locations?.map(location => ({
            kind: Kind.NAME,
            value: location,
        })) || [],
    };
}
function getDirectiveNodes(entity, schema, pathToDirectivesInExtensions) {
    const directivesInExtensions = getDirectivesInExtensions(entity, pathToDirectivesInExtensions);
    let nodes = [];
    if (entity.astNode != null) {
        nodes.push(entity.astNode);
    }
    if ('extensionASTNodes' in entity && entity.extensionASTNodes != null) {
        nodes = nodes.concat(entity.extensionASTNodes);
    }
    let directives;
    if (directivesInExtensions != null) {
        directives = makeDirectiveNodes(schema, directivesInExtensions);
    }
    else {
        directives = [];
        for (const node of nodes) {
            if (node.directives) {
                directives.push(...node.directives);
            }
        }
    }
    return directives;
}
function getDeprecatableDirectiveNodes(entity, schema, pathToDirectivesInExtensions) {
    let directiveNodesBesidesDeprecated = [];
    let deprecatedDirectiveNode = null;
    const directivesInExtensions = getDirectivesInExtensions(entity, pathToDirectivesInExtensions);
    let directives;
    if (directivesInExtensions != null) {
        directives = makeDirectiveNodes(schema, directivesInExtensions);
    }
    else {
        directives = entity.astNode?.directives;
    }
    if (directives != null) {
        directiveNodesBesidesDeprecated = directives.filter(directive => directive.name.value !== 'deprecated');
        if (entity.deprecationReason != null) {
            deprecatedDirectiveNode = directives.filter(directive => directive.name.value === 'deprecated')?.[0];
        }
    }
    if (entity.deprecationReason != null &&
        deprecatedDirectiveNode == null) {
        deprecatedDirectiveNode = makeDeprecatedDirective(entity.deprecationReason);
    }
    return deprecatedDirectiveNode == null
        ? directiveNodesBesidesDeprecated
        : [deprecatedDirectiveNode].concat(directiveNodesBesidesDeprecated);
}
function astFromArg(arg, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.INPUT_VALUE_DEFINITION,
        description: getDescriptionNode(arg),
        name: {
            kind: Kind.NAME,
            value: arg.name,
        },
        type: astFromType(arg.type),
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        defaultValue: arg.defaultValue !== undefined
            ? astFromValue(arg.defaultValue, arg.type) ?? undefined
            : undefined,
        directives: getDeprecatableDirectiveNodes(arg, schema, pathToDirectivesInExtensions),
    };
}
function astFromObjectType(type, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.OBJECT_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        fields: Object.values(type.getFields()).map(field => astFromField(field, schema, pathToDirectivesInExtensions)),
        interfaces: Object.values(type.getInterfaces()).map(iFace => astFromType(iFace)),
        directives: getDirectiveNodes(type, schema, pathToDirectivesInExtensions),
    };
}
function astFromInterfaceType(type, schema, pathToDirectivesInExtensions) {
    const node = {
        kind: Kind.INTERFACE_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        fields: Object.values(type.getFields()).map(field => astFromField(field, schema, pathToDirectivesInExtensions)),
        directives: getDirectiveNodes(type, schema, pathToDirectivesInExtensions),
    };
    if ('getInterfaces' in type) {
        node.interfaces = Object.values(type.getInterfaces()).map(iFace => astFromType(iFace));
    }
    return node;
}
function astFromUnionType(type, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.UNION_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDirectiveNodes(type, schema, pathToDirectivesInExtensions),
        types: type.getTypes().map(type => astFromType(type)),
    };
}
function astFromInputObjectType(type, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.INPUT_OBJECT_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        fields: Object.values(type.getFields()).map(field => astFromInputField(field, schema, pathToDirectivesInExtensions)),
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDirectiveNodes(type, schema, pathToDirectivesInExtensions),
    };
}
function astFromEnumType(type, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.ENUM_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        values: Object.values(type.getValues()).map(value => astFromEnumValue(value, schema, pathToDirectivesInExtensions)),
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDirectiveNodes(type, schema, pathToDirectivesInExtensions),
    };
}
function astFromScalarType(type, schema, pathToDirectivesInExtensions) {
    const directivesInExtensions = getDirectivesInExtensions(type, pathToDirectivesInExtensions);
    const directives = directivesInExtensions
        ? makeDirectiveNodes(schema, directivesInExtensions)
        : type.astNode?.directives || [];
    const specifiedByValue = (type['specifiedByUrl'] ||
        type['specifiedByURL']);
    if (specifiedByValue &&
        !directives.some(directiveNode => directiveNode.name.value === 'specifiedBy')) {
        const specifiedByArgs = {
            url: specifiedByValue,
        };
        directives.push(makeDirectiveNode('specifiedBy', specifiedByArgs));
    }
    return {
        kind: Kind.SCALAR_TYPE_DEFINITION,
        description: getDescriptionNode(type),
        name: {
            kind: Kind.NAME,
            value: type.name,
        },
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: directives,
    };
}
function astFromField(field, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.FIELD_DEFINITION,
        description: getDescriptionNode(field),
        name: {
            kind: Kind.NAME,
            value: field.name,
        },
        arguments: field.args.map(arg => astFromArg(arg, schema, pathToDirectivesInExtensions)),
        type: astFromType(field.type),
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDeprecatableDirectiveNodes(field, schema, pathToDirectivesInExtensions),
    };
}
function astFromInputField(field, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.INPUT_VALUE_DEFINITION,
        description: getDescriptionNode(field),
        name: {
            kind: Kind.NAME,
            value: field.name,
        },
        type: astFromType(field.type),
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDeprecatableDirectiveNodes(field, schema, pathToDirectivesInExtensions),
        defaultValue: astFromValue(field.defaultValue, field.type) ?? undefined,
    };
}
function astFromEnumValue(value, schema, pathToDirectivesInExtensions) {
    return {
        kind: Kind.ENUM_VALUE_DEFINITION,
        description: getDescriptionNode(value),
        name: {
            kind: Kind.NAME,
            value: value.name,
        },
        // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
        directives: getDeprecatableDirectiveNodes(value, schema, pathToDirectivesInExtensions),
    };
}
function makeDeprecatedDirective(deprecationReason) {
    return makeDirectiveNode('deprecated', { reason: deprecationReason }, GraphQLDeprecatedDirective);
}
function makeDirectiveNode(name, args, directive) {
    const directiveArguments = [];
    if (directive != null) {
        for (const arg of directive.args) {
            const argName = arg.name;
            const argValue = args[argName];
            if (argValue !== undefined) {
                const value = astFromValue(argValue, arg.type);
                if (value) {
                    directiveArguments.push({
                        kind: Kind.ARGUMENT,
                        name: {
                            kind: Kind.NAME,
                            value: argName,
                        },
                        value,
                    });
                }
            }
        }
    }
    else {
        for (const argName in args) {
            const argValue = args[argName];
            const value = astFromValueUntyped(argValue);
            if (value) {
                directiveArguments.push({
                    kind: Kind.ARGUMENT,
                    name: {
                        kind: Kind.NAME,
                        value: argName,
                    },
                    value,
                });
            }
        }
    }
    return {
        kind: Kind.DIRECTIVE,
        name: {
            kind: Kind.NAME,
            value: name,
        },
        arguments: directiveArguments,
    };
}
function makeDirectiveNodes(schema, directiveValues) {
    const directiveNodes = [];
    for (const directiveName in directiveValues) {
        const arrayOrSingleValue = directiveValues[directiveName];
        const directive = schema?.getDirective(directiveName);
        if (Array.isArray(arrayOrSingleValue)) {
            for (const value of arrayOrSingleValue) {
                directiveNodes.push(makeDirectiveNode(directiveName, value, directive));
            }
        }
        else {
            directiveNodes.push(makeDirectiveNode(directiveName, arrayOrSingleValue, directive));
        }
    }
    return directiveNodes;
}

const MAX_LINE_LENGTH = 80;
let commentsRegistry = {};
function resetComments() {
    commentsRegistry = {};
}
function collectComment(node) {
    const entityName = node.name?.value;
    if (entityName == null) {
        return;
    }
    pushComment(node, entityName);
    switch (node.kind) {
        case 'EnumTypeDefinition':
            if (node.values) {
                for (const value of node.values) {
                    pushComment(value, entityName, value.name.value);
                }
            }
            break;
        case 'ObjectTypeDefinition':
        case 'InputObjectTypeDefinition':
        case 'InterfaceTypeDefinition':
            if (node.fields) {
                for (const field of node.fields) {
                    pushComment(field, entityName, field.name.value);
                    if (isFieldDefinitionNode(field) && field.arguments) {
                        for (const arg of field.arguments) {
                            pushComment(arg, entityName, field.name.value, arg.name.value);
                        }
                    }
                }
            }
            break;
    }
}
function pushComment(node, entity, field, argument) {
    const comment = getComment(node);
    if (typeof comment !== 'string' || comment.length === 0) {
        return;
    }
    const keys = [entity];
    if (field) {
        keys.push(field);
        if (argument) {
            keys.push(argument);
        }
    }
    const path = keys.join('.');
    if (!commentsRegistry[path]) {
        commentsRegistry[path] = [];
    }
    commentsRegistry[path].push(comment);
}
function printComment(comment) {
    return '\n# ' + comment.replace(/\n/g, '\n# ');
}
/**
 * Copyright (c) 2015-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * NOTE: ==> This file has been modified just to add comments to the printed AST
 * This is a temp measure, we will move to using the original non modified printer.js ASAP.
 */
/**
 * Given maybeArray, print an empty string if it is null or empty, otherwise
 * print all items together separated by separator if provided
 */
function join(maybeArray, separator) {
    return maybeArray ? maybeArray.filter(x => x).join(separator || '') : '';
}
function hasMultilineItems(maybeArray) {
    return maybeArray?.some(str => str.includes('\n')) ?? false;
}
function addDescription(cb) {
    return (node, _key, _parent, path, ancestors) => {
        const keys = [];
        const parent = path.reduce((prev, key) => {
            if (['fields', 'arguments', 'values'].includes(key) && prev.name) {
                keys.push(prev.name.value);
            }
            return prev[key];
        }, ancestors[0]);
        const key = [...keys, parent?.name?.value].filter(Boolean).join('.');
        const items = [];
        if (node.kind.includes('Definition') && commentsRegistry[key]) {
            items.push(...commentsRegistry[key]);
        }
        return join([...items.map(printComment), node.description, cb(node, _key, _parent, path, ancestors)], '\n');
    };
}
function indent(maybeString) {
    return maybeString && `  ${maybeString.replace(/\n/g, '\n  ')}`;
}
/**
 * Given array, print each item on its own line, wrapped in an
 * indented "{ }" block.
 */
function block(array) {
    return array && array.length !== 0 ? `{\n${indent(join(array, '\n'))}\n}` : '';
}
/**
 * If maybeString is not null or empty, then wrap with start and end, otherwise
 * print an empty string.
 */
function wrap(start, maybeString, end) {
    return maybeString ? start + maybeString + (end || '') : '';
}
/**
 * Print a block string in the indented block form by adding a leading and
 * trailing blank line. However, if a block string starts with whitespace and is
 * a single-line, adding a leading blank line would strip that whitespace.
 */
function printBlockString(value, isDescription = false) {
    const escaped = value.replace(/"""/g, '\\"""');
    return (value[0] === ' ' || value[0] === '\t') && value.indexOf('\n') === -1
        ? `"""${escaped.replace(/"$/, '"\n')}"""`
        : `"""\n${isDescription ? escaped : indent(escaped)}\n"""`;
}
const printDocASTReducer = {
    Name: { leave: node => node.value },
    Variable: { leave: node => '$' + node.name },
    // Document
    Document: {
        leave: node => join(node.definitions, '\n\n'),
    },
    OperationDefinition: {
        leave: node => {
            const varDefs = wrap('(', join(node.variableDefinitions, ', '), ')');
            const prefix = join([node.operation, join([node.name, varDefs]), join(node.directives, ' ')], ' ');
            // the query short form.
            return prefix + ' ' + node.selectionSet;
        },
    },
    VariableDefinition: {
        leave: ({ variable, type, defaultValue, directives }) => variable + ': ' + type + wrap(' = ', defaultValue) + wrap(' ', join(directives, ' ')),
    },
    SelectionSet: { leave: ({ selections }) => block(selections) },
    Field: {
        leave({ alias, name, arguments: args, directives, selectionSet }) {
            const prefix = wrap('', alias, ': ') + name;
            let argsLine = prefix + wrap('(', join(args, ', '), ')');
            if (argsLine.length > MAX_LINE_LENGTH) {
                argsLine = prefix + wrap('(\n', indent(join(args, '\n')), '\n)');
            }
            return join([argsLine, join(directives, ' '), selectionSet], ' ');
        },
    },
    Argument: { leave: ({ name, value }) => name + ': ' + value },
    // Fragments
    FragmentSpread: {
        leave: ({ name, directives }) => '...' + name + wrap(' ', join(directives, ' ')),
    },
    InlineFragment: {
        leave: ({ typeCondition, directives, selectionSet }) => join(['...', wrap('on ', typeCondition), join(directives, ' '), selectionSet], ' '),
    },
    FragmentDefinition: {
        leave: ({ name, typeCondition, variableDefinitions, directives, selectionSet }) => 
        // Note: fragment variable definitions are experimental and may be changed
        // or removed in the future.
        `fragment ${name}${wrap('(', join(variableDefinitions, ', '), ')')} ` +
            `on ${typeCondition} ${wrap('', join(directives, ' '), ' ')}` +
            selectionSet,
    },
    // Value
    IntValue: { leave: ({ value }) => value },
    FloatValue: { leave: ({ value }) => value },
    StringValue: {
        leave: ({ value, block: isBlockString }) => {
            if (isBlockString) {
                return printBlockString(value);
            }
            return JSON.stringify(value);
        },
    },
    BooleanValue: { leave: ({ value }) => (value ? 'true' : 'false') },
    NullValue: { leave: () => 'null' },
    EnumValue: { leave: ({ value }) => value },
    ListValue: { leave: ({ values }) => '[' + join(values, ', ') + ']' },
    ObjectValue: { leave: ({ fields }) => '{' + join(fields, ', ') + '}' },
    ObjectField: { leave: ({ name, value }) => name + ': ' + value },
    // Directive
    Directive: {
        leave: ({ name, arguments: args }) => '@' + name + wrap('(', join(args, ', '), ')'),
    },
    // Type
    NamedType: { leave: ({ name }) => name },
    ListType: { leave: ({ type }) => '[' + type + ']' },
    NonNullType: { leave: ({ type }) => type + '!' },
    // Type System Definitions
    SchemaDefinition: {
        leave: ({ directives, operationTypes }) => join(['schema', join(directives, ' '), block(operationTypes)], ' '),
    },
    OperationTypeDefinition: {
        leave: ({ operation, type }) => operation + ': ' + type,
    },
    ScalarTypeDefinition: {
        leave: ({ name, directives }) => join(['scalar', name, join(directives, ' ')], ' '),
    },
    ObjectTypeDefinition: {
        leave: ({ name, interfaces, directives, fields }) => join([
            'type',
            name,
            wrap('implements ', join(interfaces, ' & ')),
            join(directives, ' '),
            block(fields),
        ], ' '),
    },
    FieldDefinition: {
        leave: ({ name, arguments: args, type, directives }) => name +
            (hasMultilineItems(args)
                ? wrap('(\n', indent(join(args, '\n')), '\n)')
                : wrap('(', join(args, ', '), ')')) +
            ': ' +
            type +
            wrap(' ', join(directives, ' ')),
    },
    InputValueDefinition: {
        leave: ({ name, type, defaultValue, directives }) => join([name + ': ' + type, wrap('= ', defaultValue), join(directives, ' ')], ' '),
    },
    InterfaceTypeDefinition: {
        leave: ({ name, interfaces, directives, fields }) => join([
            'interface',
            name,
            wrap('implements ', join(interfaces, ' & ')),
            join(directives, ' '),
            block(fields),
        ], ' '),
    },
    UnionTypeDefinition: {
        leave: ({ name, directives, types }) => join(['union', name, join(directives, ' '), wrap('= ', join(types, ' | '))], ' '),
    },
    EnumTypeDefinition: {
        leave: ({ name, directives, values }) => join(['enum', name, join(directives, ' '), block(values)], ' '),
    },
    EnumValueDefinition: {
        leave: ({ name, directives }) => join([name, join(directives, ' ')], ' '),
    },
    InputObjectTypeDefinition: {
        leave: ({ name, directives, fields }) => join(['input', name, join(directives, ' '), block(fields)], ' '),
    },
    DirectiveDefinition: {
        leave: ({ name, arguments: args, repeatable, locations }) => 'directive @' +
            name +
            (hasMultilineItems(args)
                ? wrap('(\n', indent(join(args, '\n')), '\n)')
                : wrap('(', join(args, ', '), ')')) +
            (repeatable ? ' repeatable' : '') +
            ' on ' +
            join(locations, ' | '),
    },
    SchemaExtension: {
        leave: ({ directives, operationTypes }) => join(['extend schema', join(directives, ' '), block(operationTypes)], ' '),
    },
    ScalarTypeExtension: {
        leave: ({ name, directives }) => join(['extend scalar', name, join(directives, ' ')], ' '),
    },
    ObjectTypeExtension: {
        leave: ({ name, interfaces, directives, fields }) => join([
            'extend type',
            name,
            wrap('implements ', join(interfaces, ' & ')),
            join(directives, ' '),
            block(fields),
        ], ' '),
    },
    InterfaceTypeExtension: {
        leave: ({ name, interfaces, directives, fields }) => join([
            'extend interface',
            name,
            wrap('implements ', join(interfaces, ' & ')),
            join(directives, ' '),
            block(fields),
        ], ' '),
    },
    UnionTypeExtension: {
        leave: ({ name, directives, types }) => join(['extend union', name, join(directives, ' '), wrap('= ', join(types, ' | '))], ' '),
    },
    EnumTypeExtension: {
        leave: ({ name, directives, values }) => join(['extend enum', name, join(directives, ' '), block(values)], ' '),
    },
    InputObjectTypeExtension: {
        leave: ({ name, directives, fields }) => join(['extend input', name, join(directives, ' '), block(fields)], ' '),
    },
};
const printDocASTReducerWithComments = Object.keys(printDocASTReducer).reduce((prev, key) => ({
    ...prev,
    [key]: {
        leave: addDescription(printDocASTReducer[key].leave),
    },
}), {});
/**
 * Converts an AST into a string, using one set of reasonable
 * formatting rules.
 */
function printWithComments(ast) {
    return visit(ast, printDocASTReducerWithComments);
}
function isFieldDefinitionNode(node) {
    return node.kind === 'FieldDefinition';
}
function getComment(node) {
    const rawValue = getLeadingCommentBlock(node);
    if (rawValue !== undefined) {
        return dedentBlockStringValue(`\n${rawValue}`);
    }
}
function getLeadingCommentBlock(node) {
    const loc = node.loc;
    if (!loc) {
        return;
    }
    const comments = [];
    let token = loc.startToken.prev;
    while (token != null &&
        token.kind === TokenKind.COMMENT &&
        token.next != null &&
        token.prev != null &&
        token.line + 1 === token.next.line &&
        token.line !== token.prev.line) {
        const value = String(token.value);
        comments.push(value);
        token = token.prev;
    }
    return comments.length > 0 ? comments.reverse().join('\n') : undefined;
}
function dedentBlockStringValue(rawString) {
    // Expand a block string's raw value into independent lines.
    const lines = rawString.split(/\r\n|[\n\r]/g);
    // Remove common indentation from all lines but first.
    const commonIndent = getBlockStringIndentation(lines);
    if (commonIndent !== 0) {
        for (let i = 1; i < lines.length; i++) {
            lines[i] = lines[i].slice(commonIndent);
        }
    }
    // Remove leading and trailing blank lines.
    while (lines.length > 0 && isBlank(lines[0])) {
        lines.shift();
    }
    while (lines.length > 0 && isBlank(lines[lines.length - 1])) {
        lines.pop();
    }
    // Return a string of the lines joined with U+000A.
    return lines.join('\n');
}
/**
 * @internal
 */
function getBlockStringIndentation(lines) {
    let commonIndent = null;
    for (let i = 1; i < lines.length; i++) {
        const line = lines[i];
        const indent = leadingWhitespace(line);
        if (indent === line.length) {
            continue; // skip empty lines
        }
        if (commonIndent === null || indent < commonIndent) {
            commonIndent = indent;
            if (commonIndent === 0) {
                break;
            }
        }
    }
    return commonIndent === null ? 0 : commonIndent;
}
function leadingWhitespace(str) {
    let i = 0;
    while (i < str.length && (str[i] === ' ' || str[i] === '\t')) {
        i++;
    }
    return i;
}
function isBlank(str) {
    return leadingWhitespace(str) === str.length;
}

var MapperKind;
(function (MapperKind) {
    MapperKind["TYPE"] = "MapperKind.TYPE";
    MapperKind["SCALAR_TYPE"] = "MapperKind.SCALAR_TYPE";
    MapperKind["ENUM_TYPE"] = "MapperKind.ENUM_TYPE";
    MapperKind["COMPOSITE_TYPE"] = "MapperKind.COMPOSITE_TYPE";
    MapperKind["OBJECT_TYPE"] = "MapperKind.OBJECT_TYPE";
    MapperKind["INPUT_OBJECT_TYPE"] = "MapperKind.INPUT_OBJECT_TYPE";
    MapperKind["ABSTRACT_TYPE"] = "MapperKind.ABSTRACT_TYPE";
    MapperKind["UNION_TYPE"] = "MapperKind.UNION_TYPE";
    MapperKind["INTERFACE_TYPE"] = "MapperKind.INTERFACE_TYPE";
    MapperKind["ROOT_OBJECT"] = "MapperKind.ROOT_OBJECT";
    MapperKind["QUERY"] = "MapperKind.QUERY";
    MapperKind["MUTATION"] = "MapperKind.MUTATION";
    MapperKind["SUBSCRIPTION"] = "MapperKind.SUBSCRIPTION";
    MapperKind["DIRECTIVE"] = "MapperKind.DIRECTIVE";
    MapperKind["FIELD"] = "MapperKind.FIELD";
    MapperKind["COMPOSITE_FIELD"] = "MapperKind.COMPOSITE_FIELD";
    MapperKind["OBJECT_FIELD"] = "MapperKind.OBJECT_FIELD";
    MapperKind["ROOT_FIELD"] = "MapperKind.ROOT_FIELD";
    MapperKind["QUERY_ROOT_FIELD"] = "MapperKind.QUERY_ROOT_FIELD";
    MapperKind["MUTATION_ROOT_FIELD"] = "MapperKind.MUTATION_ROOT_FIELD";
    MapperKind["SUBSCRIPTION_ROOT_FIELD"] = "MapperKind.SUBSCRIPTION_ROOT_FIELD";
    MapperKind["INTERFACE_FIELD"] = "MapperKind.INTERFACE_FIELD";
    MapperKind["INPUT_OBJECT_FIELD"] = "MapperKind.INPUT_OBJECT_FIELD";
    MapperKind["ARGUMENT"] = "MapperKind.ARGUMENT";
    MapperKind["ENUM_VALUE"] = "MapperKind.ENUM_VALUE";
})(MapperKind || (MapperKind = {}));

function getObjectTypeFromTypeMap(typeMap, type) {
    if (type) {
        const maybeObjectType = typeMap[type.name];
        if (isObjectType(maybeObjectType)) {
            return maybeObjectType;
        }
    }
}

function isNamedStub(type) {
    if ('getFields' in type) {
        const fields = type.getFields();
        // eslint-disable-next-line no-unreachable-loop
        for (const fieldName in fields) {
            const field = fields[fieldName];
            return field.name === '_fake';
        }
    }
    return false;
}
function getBuiltInForStub(type) {
    switch (type.name) {
        case GraphQLInt.name:
            return GraphQLInt;
        case GraphQLFloat.name:
            return GraphQLFloat;
        case GraphQLString.name:
            return GraphQLString;
        case GraphQLBoolean.name:
            return GraphQLBoolean;
        case GraphQLID.name:
            return GraphQLID;
        default:
            return type;
    }
}

function rewireTypes(originalTypeMap, directives) {
    const referenceTypeMap = Object.create(null);
    for (const typeName in originalTypeMap) {
        referenceTypeMap[typeName] = originalTypeMap[typeName];
    }
    const newTypeMap = Object.create(null);
    for (const typeName in referenceTypeMap) {
        const namedType = referenceTypeMap[typeName];
        if (namedType == null || typeName.startsWith('__')) {
            continue;
        }
        const newName = namedType.name;
        if (newName.startsWith('__')) {
            continue;
        }
        if (newTypeMap[newName] != null) {
            console.warn(`Duplicate schema type name ${newName} found; keeping the existing one found in the schema`);
            continue;
        }
        newTypeMap[newName] = namedType;
    }
    for (const typeName in newTypeMap) {
        newTypeMap[typeName] = rewireNamedType(newTypeMap[typeName]);
    }
    const newDirectives = directives.map(directive => rewireDirective(directive));
    return {
        typeMap: newTypeMap,
        directives: newDirectives,
    };
    function rewireDirective(directive) {
        if (isSpecifiedDirective(directive)) {
            return directive;
        }
        const directiveConfig = directive.toConfig();
        directiveConfig.args = rewireArgs(directiveConfig.args);
        return new GraphQLDirective(directiveConfig);
    }
    function rewireArgs(args) {
        const rewiredArgs = {};
        for (const argName in args) {
            const arg = args[argName];
            const rewiredArgType = rewireType(arg.type);
            if (rewiredArgType != null) {
                arg.type = rewiredArgType;
                rewiredArgs[argName] = arg;
            }
        }
        return rewiredArgs;
    }
    function rewireNamedType(type) {
        if (isObjectType(type)) {
            const config = type.toConfig();
            const newConfig = {
                ...config,
                fields: () => rewireFields(config.fields),
                interfaces: () => rewireNamedTypes(config.interfaces),
            };
            return new GraphQLObjectType(newConfig);
        }
        else if (isInterfaceType(type)) {
            const config = type.toConfig();
            const newConfig = {
                ...config,
                fields: () => rewireFields(config.fields),
            };
            if ('interfaces' in newConfig) {
                newConfig.interfaces = () => rewireNamedTypes(config.interfaces);
            }
            return new GraphQLInterfaceType(newConfig);
        }
        else if (isUnionType(type)) {
            const config = type.toConfig();
            const newConfig = {
                ...config,
                types: () => rewireNamedTypes(config.types),
            };
            return new GraphQLUnionType(newConfig);
        }
        else if (isInputObjectType(type)) {
            const config = type.toConfig();
            const newConfig = {
                ...config,
                fields: () => rewireInputFields(config.fields),
            };
            return new GraphQLInputObjectType(newConfig);
        }
        else if (isEnumType(type)) {
            const enumConfig = type.toConfig();
            return new GraphQLEnumType(enumConfig);
        }
        else if (isScalarType(type)) {
            if (isSpecifiedScalarType(type)) {
                return type;
            }
            const scalarConfig = type.toConfig();
            return new GraphQLScalarType(scalarConfig);
        }
        throw new Error(`Unexpected schema type: ${type}`);
    }
    function rewireFields(fields) {
        const rewiredFields = {};
        for (const fieldName in fields) {
            const field = fields[fieldName];
            const rewiredFieldType = rewireType(field.type);
            if (rewiredFieldType != null && field.args) {
                field.type = rewiredFieldType;
                field.args = rewireArgs(field.args);
                rewiredFields[fieldName] = field;
            }
        }
        return rewiredFields;
    }
    function rewireInputFields(fields) {
        const rewiredFields = {};
        for (const fieldName in fields) {
            const field = fields[fieldName];
            const rewiredFieldType = rewireType(field.type);
            if (rewiredFieldType != null) {
                field.type = rewiredFieldType;
                rewiredFields[fieldName] = field;
            }
        }
        return rewiredFields;
    }
    function rewireNamedTypes(namedTypes) {
        const rewiredTypes = [];
        for (const namedType of namedTypes) {
            const rewiredType = rewireType(namedType);
            if (rewiredType != null) {
                rewiredTypes.push(rewiredType);
            }
        }
        return rewiredTypes;
    }
    function rewireType(type) {
        if (isListType(type)) {
            const rewiredType = rewireType(type.ofType);
            return rewiredType != null ? new GraphQLList(rewiredType) : null;
        }
        else if (isNonNullType(type)) {
            const rewiredType = rewireType(type.ofType);
            return rewiredType != null ? new GraphQLNonNull(rewiredType) : null;
        }
        else if (isNamedType(type)) {
            let rewiredType = referenceTypeMap[type.name];
            if (rewiredType === undefined) {
                rewiredType = isNamedStub(type) ? getBuiltInForStub(type) : rewireNamedType(type);
                newTypeMap[rewiredType.name] = referenceTypeMap[type.name] = rewiredType;
            }
            return rewiredType != null ? newTypeMap[rewiredType.name] : null;
        }
        return null;
    }
}

function transformInputValue(type, value, inputLeafValueTransformer = null, inputObjectValueTransformer = null) {
    if (value == null) {
        return value;
    }
    const nullableType = getNullableType(type);
    if (isLeafType(nullableType)) {
        return inputLeafValueTransformer != null
            ? inputLeafValueTransformer(nullableType, value)
            : value;
    }
    else if (isListType(nullableType)) {
        return asArray(value).map((listMember) => transformInputValue(nullableType.ofType, listMember, inputLeafValueTransformer, inputObjectValueTransformer));
    }
    else if (isInputObjectType(nullableType)) {
        const fields = nullableType.getFields();
        const newValue = {};
        for (const key in value) {
            const field = fields[key];
            if (field != null) {
                newValue[key] = transformInputValue(field.type, value[key], inputLeafValueTransformer, inputObjectValueTransformer);
            }
        }
        return inputObjectValueTransformer != null
            ? inputObjectValueTransformer(nullableType, newValue)
            : newValue;
    }
    // unreachable, no other possible return value
}
function serializeInputValue(type, value) {
    return transformInputValue(type, value, (t, v) => {
        try {
            return t.serialize(v);
        }
        catch {
            return v;
        }
    });
}
function parseInputValue(type, value) {
    return transformInputValue(type, value, (t, v) => {
        try {
            return t.parseValue(v);
        }
        catch {
            return v;
        }
    });
}

function mapSchema(schema, schemaMapper = {}) {
    const newTypeMap = mapArguments(mapFields(mapTypes(mapDefaultValues(mapEnumValues(mapTypes(mapDefaultValues(schema.getTypeMap(), schema, serializeInputValue), schema, schemaMapper, type => isLeafType(type)), schema, schemaMapper), schema, parseInputValue), schema, schemaMapper, type => !isLeafType(type)), schema, schemaMapper), schema, schemaMapper);
    const originalDirectives = schema.getDirectives();
    const newDirectives = mapDirectives(originalDirectives, schema, schemaMapper);
    const { typeMap, directives } = rewireTypes(newTypeMap, newDirectives);
    return new GraphQLSchema({
        ...schema.toConfig(),
        query: getObjectTypeFromTypeMap(typeMap, getObjectTypeFromTypeMap(newTypeMap, schema.getQueryType())),
        mutation: getObjectTypeFromTypeMap(typeMap, getObjectTypeFromTypeMap(newTypeMap, schema.getMutationType())),
        subscription: getObjectTypeFromTypeMap(typeMap, getObjectTypeFromTypeMap(newTypeMap, schema.getSubscriptionType())),
        types: Object.values(typeMap),
        directives,
    });
}
function mapTypes(originalTypeMap, schema, schemaMapper, testFn = () => true) {
    const newTypeMap = {};
    for (const typeName in originalTypeMap) {
        if (!typeName.startsWith('__')) {
            const originalType = originalTypeMap[typeName];
            if (originalType == null || !testFn(originalType)) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const typeMapper = getTypeMapper(schema, schemaMapper, typeName);
            if (typeMapper == null) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const maybeNewType = typeMapper(originalType, schema);
            if (maybeNewType === undefined) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            newTypeMap[typeName] = maybeNewType;
        }
    }
    return newTypeMap;
}
function mapEnumValues(originalTypeMap, schema, schemaMapper) {
    const enumValueMapper = getEnumValueMapper(schemaMapper);
    if (!enumValueMapper) {
        return originalTypeMap;
    }
    return mapTypes(originalTypeMap, schema, {
        [MapperKind.ENUM_TYPE]: type => {
            const config = type.toConfig();
            const originalEnumValueConfigMap = config.values;
            const newEnumValueConfigMap = {};
            for (const externalValue in originalEnumValueConfigMap) {
                const originalEnumValueConfig = originalEnumValueConfigMap[externalValue];
                const mappedEnumValue = enumValueMapper(originalEnumValueConfig, type.name, schema, externalValue);
                if (mappedEnumValue === undefined) {
                    newEnumValueConfigMap[externalValue] = originalEnumValueConfig;
                }
                else if (Array.isArray(mappedEnumValue)) {
                    const [newExternalValue, newEnumValueConfig] = mappedEnumValue;
                    newEnumValueConfigMap[newExternalValue] =
                        newEnumValueConfig === undefined ? originalEnumValueConfig : newEnumValueConfig;
                }
                else if (mappedEnumValue !== null) {
                    newEnumValueConfigMap[externalValue] = mappedEnumValue;
                }
            }
            return correctASTNodes(new GraphQLEnumType({
                ...config,
                values: newEnumValueConfigMap,
            }));
        },
    }, type => isEnumType(type));
}
function mapDefaultValues(originalTypeMap, schema, fn) {
    const newTypeMap = mapArguments(originalTypeMap, schema, {
        [MapperKind.ARGUMENT]: argumentConfig => {
            if (argumentConfig.defaultValue === undefined) {
                return argumentConfig;
            }
            const maybeNewType = getNewType(originalTypeMap, argumentConfig.type);
            if (maybeNewType != null) {
                return {
                    ...argumentConfig,
                    defaultValue: fn(maybeNewType, argumentConfig.defaultValue),
                };
            }
        },
    });
    return mapFields(newTypeMap, schema, {
        [MapperKind.INPUT_OBJECT_FIELD]: inputFieldConfig => {
            if (inputFieldConfig.defaultValue === undefined) {
                return inputFieldConfig;
            }
            const maybeNewType = getNewType(newTypeMap, inputFieldConfig.type);
            if (maybeNewType != null) {
                return {
                    ...inputFieldConfig,
                    defaultValue: fn(maybeNewType, inputFieldConfig.defaultValue),
                };
            }
        },
    });
}
function getNewType(newTypeMap, type) {
    if (isListType(type)) {
        const newType = getNewType(newTypeMap, type.ofType);
        return newType != null ? new GraphQLList(newType) : null;
    }
    else if (isNonNullType(type)) {
        const newType = getNewType(newTypeMap, type.ofType);
        return newType != null ? new GraphQLNonNull(newType) : null;
    }
    else if (isNamedType(type)) {
        const newType = newTypeMap[type.name];
        return newType != null ? newType : null;
    }
    return null;
}
function mapFields(originalTypeMap, schema, schemaMapper) {
    const newTypeMap = {};
    for (const typeName in originalTypeMap) {
        if (!typeName.startsWith('__')) {
            const originalType = originalTypeMap[typeName];
            if (!isObjectType(originalType) &&
                !isInterfaceType(originalType) &&
                !isInputObjectType(originalType)) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const fieldMapper = getFieldMapper(schema, schemaMapper, typeName);
            if (fieldMapper == null) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const config = originalType.toConfig();
            const originalFieldConfigMap = config.fields;
            const newFieldConfigMap = {};
            for (const fieldName in originalFieldConfigMap) {
                const originalFieldConfig = originalFieldConfigMap[fieldName];
                const mappedField = fieldMapper(originalFieldConfig, fieldName, typeName, schema);
                if (mappedField === undefined) {
                    newFieldConfigMap[fieldName] = originalFieldConfig;
                }
                else if (Array.isArray(mappedField)) {
                    const [newFieldName, newFieldConfig] = mappedField;
                    if (newFieldConfig.astNode != null) {
                        newFieldConfig.astNode = {
                            ...newFieldConfig.astNode,
                            name: {
                                ...newFieldConfig.astNode.name,
                                value: newFieldName,
                            },
                        };
                    }
                    newFieldConfigMap[newFieldName] =
                        newFieldConfig === undefined ? originalFieldConfig : newFieldConfig;
                }
                else if (mappedField !== null) {
                    newFieldConfigMap[fieldName] = mappedField;
                }
            }
            if (isObjectType(originalType)) {
                newTypeMap[typeName] = correctASTNodes(new GraphQLObjectType({
                    ...config,
                    fields: newFieldConfigMap,
                }));
            }
            else if (isInterfaceType(originalType)) {
                newTypeMap[typeName] = correctASTNodes(new GraphQLInterfaceType({
                    ...config,
                    fields: newFieldConfigMap,
                }));
            }
            else {
                newTypeMap[typeName] = correctASTNodes(new GraphQLInputObjectType({
                    ...config,
                    fields: newFieldConfigMap,
                }));
            }
        }
    }
    return newTypeMap;
}
function mapArguments(originalTypeMap, schema, schemaMapper) {
    const newTypeMap = {};
    for (const typeName in originalTypeMap) {
        if (!typeName.startsWith('__')) {
            const originalType = originalTypeMap[typeName];
            if (!isObjectType(originalType) && !isInterfaceType(originalType)) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const argumentMapper = getArgumentMapper(schemaMapper);
            if (argumentMapper == null) {
                newTypeMap[typeName] = originalType;
                continue;
            }
            const config = originalType.toConfig();
            const originalFieldConfigMap = config.fields;
            const newFieldConfigMap = {};
            for (const fieldName in originalFieldConfigMap) {
                const originalFieldConfig = originalFieldConfigMap[fieldName];
                const originalArgumentConfigMap = originalFieldConfig.args;
                if (originalArgumentConfigMap == null) {
                    newFieldConfigMap[fieldName] = originalFieldConfig;
                    continue;
                }
                const argumentNames = Object.keys(originalArgumentConfigMap);
                if (!argumentNames.length) {
                    newFieldConfigMap[fieldName] = originalFieldConfig;
                    continue;
                }
                const newArgumentConfigMap = {};
                for (const argumentName of argumentNames) {
                    const originalArgumentConfig = originalArgumentConfigMap[argumentName];
                    const mappedArgument = argumentMapper(originalArgumentConfig, fieldName, typeName, schema);
                    if (mappedArgument === undefined) {
                        newArgumentConfigMap[argumentName] = originalArgumentConfig;
                    }
                    else if (Array.isArray(mappedArgument)) {
                        const [newArgumentName, newArgumentConfig] = mappedArgument;
                        newArgumentConfigMap[newArgumentName] = newArgumentConfig;
                    }
                    else if (mappedArgument !== null) {
                        newArgumentConfigMap[argumentName] = mappedArgument;
                    }
                }
                newFieldConfigMap[fieldName] = {
                    ...originalFieldConfig,
                    args: newArgumentConfigMap,
                };
            }
            if (isObjectType(originalType)) {
                newTypeMap[typeName] = new GraphQLObjectType({
                    ...config,
                    fields: newFieldConfigMap,
                });
            }
            else if (isInterfaceType(originalType)) {
                newTypeMap[typeName] = new GraphQLInterfaceType({
                    ...config,
                    fields: newFieldConfigMap,
                });
            }
            else {
                newTypeMap[typeName] = new GraphQLInputObjectType({
                    ...config,
                    fields: newFieldConfigMap,
                });
            }
        }
    }
    return newTypeMap;
}
function mapDirectives(originalDirectives, schema, schemaMapper) {
    const directiveMapper = getDirectiveMapper(schemaMapper);
    if (directiveMapper == null) {
        return originalDirectives.slice();
    }
    const newDirectives = [];
    for (const directive of originalDirectives) {
        const mappedDirective = directiveMapper(directive, schema);
        if (mappedDirective === undefined) {
            newDirectives.push(directive);
        }
        else if (mappedDirective !== null) {
            newDirectives.push(mappedDirective);
        }
    }
    return newDirectives;
}
function getTypeSpecifiers(schema, typeName) {
    const type = schema.getType(typeName);
    const specifiers = [MapperKind.TYPE];
    if (isObjectType(type)) {
        specifiers.push(MapperKind.COMPOSITE_TYPE, MapperKind.OBJECT_TYPE);
        if (typeName === schema.getQueryType()?.name) {
            specifiers.push(MapperKind.ROOT_OBJECT, MapperKind.QUERY);
        }
        else if (typeName === schema.getMutationType()?.name) {
            specifiers.push(MapperKind.ROOT_OBJECT, MapperKind.MUTATION);
        }
        else if (typeName === schema.getSubscriptionType()?.name) {
            specifiers.push(MapperKind.ROOT_OBJECT, MapperKind.SUBSCRIPTION);
        }
    }
    else if (isInputObjectType(type)) {
        specifiers.push(MapperKind.INPUT_OBJECT_TYPE);
    }
    else if (isInterfaceType(type)) {
        specifiers.push(MapperKind.COMPOSITE_TYPE, MapperKind.ABSTRACT_TYPE, MapperKind.INTERFACE_TYPE);
    }
    else if (isUnionType(type)) {
        specifiers.push(MapperKind.COMPOSITE_TYPE, MapperKind.ABSTRACT_TYPE, MapperKind.UNION_TYPE);
    }
    else if (isEnumType(type)) {
        specifiers.push(MapperKind.ENUM_TYPE);
    }
    else if (isScalarType(type)) {
        specifiers.push(MapperKind.SCALAR_TYPE);
    }
    return specifiers;
}
function getTypeMapper(schema, schemaMapper, typeName) {
    const specifiers = getTypeSpecifiers(schema, typeName);
    let typeMapper;
    const stack = [...specifiers];
    while (!typeMapper && stack.length > 0) {
        // It is safe to use the ! operator here as we check the length.
        const next = stack.pop();
        typeMapper = schemaMapper[next];
    }
    return typeMapper != null ? typeMapper : null;
}
function getFieldSpecifiers(schema, typeName) {
    const type = schema.getType(typeName);
    const specifiers = [MapperKind.FIELD];
    if (isObjectType(type)) {
        specifiers.push(MapperKind.COMPOSITE_FIELD, MapperKind.OBJECT_FIELD);
        if (typeName === schema.getQueryType()?.name) {
            specifiers.push(MapperKind.ROOT_FIELD, MapperKind.QUERY_ROOT_FIELD);
        }
        else if (typeName === schema.getMutationType()?.name) {
            specifiers.push(MapperKind.ROOT_FIELD, MapperKind.MUTATION_ROOT_FIELD);
        }
        else if (typeName === schema.getSubscriptionType()?.name) {
            specifiers.push(MapperKind.ROOT_FIELD, MapperKind.SUBSCRIPTION_ROOT_FIELD);
        }
    }
    else if (isInterfaceType(type)) {
        specifiers.push(MapperKind.COMPOSITE_FIELD, MapperKind.INTERFACE_FIELD);
    }
    else if (isInputObjectType(type)) {
        specifiers.push(MapperKind.INPUT_OBJECT_FIELD);
    }
    return specifiers;
}
function getFieldMapper(schema, schemaMapper, typeName) {
    const specifiers = getFieldSpecifiers(schema, typeName);
    let fieldMapper;
    const stack = [...specifiers];
    while (!fieldMapper && stack.length > 0) {
        // It is safe to use the ! operator here as we check the length.
        const next = stack.pop();
        // TODO: fix this as unknown cast
        fieldMapper = schemaMapper[next];
    }
    return fieldMapper ?? null;
}
function getArgumentMapper(schemaMapper) {
    const argumentMapper = schemaMapper[MapperKind.ARGUMENT];
    return argumentMapper != null ? argumentMapper : null;
}
function getDirectiveMapper(schemaMapper) {
    const directiveMapper = schemaMapper[MapperKind.DIRECTIVE];
    return directiveMapper != null ? directiveMapper : null;
}
function getEnumValueMapper(schemaMapper) {
    const enumValueMapper = schemaMapper[MapperKind.ENUM_VALUE];
    return enumValueMapper != null ? enumValueMapper : null;
}
function correctASTNodes(type) {
    if (isObjectType(type)) {
        const config = type.toConfig();
        if (config.astNode != null) {
            const fields = [];
            for (const fieldName in config.fields) {
                const fieldConfig = config.fields[fieldName];
                if (fieldConfig.astNode != null) {
                    fields.push(fieldConfig.astNode);
                }
            }
            config.astNode = {
                ...config.astNode,
                kind: Kind.OBJECT_TYPE_DEFINITION,
                fields,
            };
        }
        if (config.extensionASTNodes != null) {
            config.extensionASTNodes = config.extensionASTNodes.map(node => ({
                ...node,
                kind: Kind.OBJECT_TYPE_EXTENSION,
                fields: undefined,
            }));
        }
        return new GraphQLObjectType(config);
    }
    else if (isInterfaceType(type)) {
        const config = type.toConfig();
        if (config.astNode != null) {
            const fields = [];
            for (const fieldName in config.fields) {
                const fieldConfig = config.fields[fieldName];
                if (fieldConfig.astNode != null) {
                    fields.push(fieldConfig.astNode);
                }
            }
            config.astNode = {
                ...config.astNode,
                kind: Kind.INTERFACE_TYPE_DEFINITION,
                fields,
            };
        }
        if (config.extensionASTNodes != null) {
            config.extensionASTNodes = config.extensionASTNodes.map(node => ({
                ...node,
                kind: Kind.INTERFACE_TYPE_EXTENSION,
                fields: undefined,
            }));
        }
        return new GraphQLInterfaceType(config);
    }
    else if (isInputObjectType(type)) {
        const config = type.toConfig();
        if (config.astNode != null) {
            const fields = [];
            for (const fieldName in config.fields) {
                const fieldConfig = config.fields[fieldName];
                if (fieldConfig.astNode != null) {
                    fields.push(fieldConfig.astNode);
                }
            }
            config.astNode = {
                ...config.astNode,
                kind: Kind.INPUT_OBJECT_TYPE_DEFINITION,
                fields,
            };
        }
        if (config.extensionASTNodes != null) {
            config.extensionASTNodes = config.extensionASTNodes.map(node => ({
                ...node,
                kind: Kind.INPUT_OBJECT_TYPE_EXTENSION,
                fields: undefined,
            }));
        }
        return new GraphQLInputObjectType(config);
    }
    else if (isEnumType(type)) {
        const config = type.toConfig();
        if (config.astNode != null) {
            const values = [];
            for (const enumKey in config.values) {
                const enumValueConfig = config.values[enumKey];
                if (enumValueConfig.astNode != null) {
                    values.push(enumValueConfig.astNode);
                }
            }
            config.astNode = {
                ...config.astNode,
                values,
            };
        }
        if (config.extensionASTNodes != null) {
            config.extensionASTNodes = config.extensionASTNodes.map(node => ({
                ...node,
                values: undefined,
            }));
        }
        return new GraphQLEnumType(config);
    }
    else {
        return type;
    }
}

// Update any references to named schema types that disagree with the named
// types found in schema.getTypeMap().
//
// healSchema and its callers (visitSchema/visitSchemaDirectives) all modify the schema in place.
// Therefore, private variables (such as the stored implementation map and the proper root types)
// are not updated.
//
// If this causes issues, the schema could be more aggressively healed as follows:
//
// healSchema(schema);
// const config = schema.toConfig()
// const healedSchema = new GraphQLSchema({
//   ...config,
//   query: schema.getType('<desired new root query type name>'),
//   mutation: schema.getType('<desired new root mutation type name>'),
//   subscription: schema.getType('<desired new root subscription type name>'),
// });
//
// One can then also -- if necessary --  assign the correct private variables to the initial schema
// as follows:
// Object.assign(schema, healedSchema);
//
// These steps are not taken automatically to preserve backwards compatibility with graphql-tools v4.
// See https://github.com/ardatan/graphql-tools/issues/1462
//
// They were briefly taken in v5, but can now be phased out as they were only required when other
// areas of the codebase were using healSchema and visitSchema more extensively.
//
function healSchema(schema) {
    healTypes(schema.getTypeMap(), schema.getDirectives());
    return schema;
}
function healTypes(originalTypeMap, directives) {
    const actualNamedTypeMap = Object.create(null);
    // If any of the .name properties of the GraphQLNamedType objects in
    // schema.getTypeMap() have changed, the keys of the type map need to
    // be updated accordingly.
    for (const typeName in originalTypeMap) {
        const namedType = originalTypeMap[typeName];
        if (namedType == null || typeName.startsWith('__')) {
            continue;
        }
        const actualName = namedType.name;
        if (actualName.startsWith('__')) {
            continue;
        }
        if (actualNamedTypeMap[actualName] != null) {
            console.warn(`Duplicate schema type name ${actualName} found; keeping the existing one found in the schema`);
            continue;
        }
        actualNamedTypeMap[actualName] = namedType;
        // Note: we are deliberately leaving namedType in the schema by its
        // original name (which might be different from actualName), so that
        // references by that name can be healed.
    }
    // Now add back every named type by its actual name.
    for (const typeName in actualNamedTypeMap) {
        const namedType = actualNamedTypeMap[typeName];
        originalTypeMap[typeName] = namedType;
    }
    // Directive declaration argument types can refer to named types.
    for (const decl of directives) {
        decl.args = decl.args.filter(arg => {
            arg.type = healType(arg.type);
            return arg.type !== null;
        });
    }
    for (const typeName in originalTypeMap) {
        const namedType = originalTypeMap[typeName];
        // Heal all named types, except for dangling references, kept only to redirect.
        if (!typeName.startsWith('__') && typeName in actualNamedTypeMap) {
            if (namedType != null) {
                healNamedType(namedType);
            }
        }
    }
    for (const typeName in originalTypeMap) {
        if (!typeName.startsWith('__') && !(typeName in actualNamedTypeMap)) {
            delete originalTypeMap[typeName];
        }
    }
    function healNamedType(type) {
        if (isObjectType(type)) {
            healFields(type);
            healInterfaces(type);
            return;
        }
        else if (isInterfaceType(type)) {
            healFields(type);
            if ('getInterfaces' in type) {
                healInterfaces(type);
            }
            return;
        }
        else if (isUnionType(type)) {
            healUnderlyingTypes(type);
            return;
        }
        else if (isInputObjectType(type)) {
            healInputFields(type);
            return;
        }
        else if (isLeafType(type)) {
            return;
        }
        throw new Error(`Unexpected schema type: ${type}`);
    }
    function healFields(type) {
        const fieldMap = type.getFields();
        for (const [key, field] of Object.entries(fieldMap)) {
            field.args
                .map(arg => {
                arg.type = healType(arg.type);
                return arg.type === null ? null : arg;
            })
                .filter(Boolean);
            field.type = healType(field.type);
            if (field.type === null) {
                delete fieldMap[key];
            }
        }
    }
    function healInterfaces(type) {
        if ('getInterfaces' in type) {
            const interfaces = type.getInterfaces();
            interfaces.push(...interfaces
                .splice(0)
                .map(iface => healType(iface))
                .filter(Boolean));
        }
    }
    function healInputFields(type) {
        const fieldMap = type.getFields();
        for (const [key, field] of Object.entries(fieldMap)) {
            field.type = healType(field.type);
            if (field.type === null) {
                delete fieldMap[key];
            }
        }
    }
    function healUnderlyingTypes(type) {
        const types = type.getTypes();
        types.push(...types
            .splice(0)
            .map(t => healType(t))
            .filter(Boolean));
    }
    function healType(type) {
        // Unwrap the two known wrapper types
        if (isListType(type)) {
            const healedType = healType(type.ofType);
            return healedType != null ? new GraphQLList(healedType) : null;
        }
        else if (isNonNullType(type)) {
            const healedType = healType(type.ofType);
            return healedType != null ? new GraphQLNonNull(healedType) : null;
        }
        else if (isNamedType(type)) {
            // If a type annotation on a field or an argument or a union member is
            // any `GraphQLNamedType` with a `name`, then it must end up identical
            // to `schema.getType(name)`, since `schema.getTypeMap()` is the source
            // of truth for all named schema types.
            // Note that new types can still be simply added by adding a field, as
            // the official type will be undefined, not null.
            const officialType = originalTypeMap[type.name];
            if (officialType && type !== officialType) {
                return officialType;
            }
        }
        return type;
    }
}

function forEachField(schema, fn) {
    const typeMap = schema.getTypeMap();
    for (const typeName in typeMap) {
        const type = typeMap[typeName];
        // TODO: maybe have an option to include these?
        if (!getNamedType(type).name.startsWith('__') && isObjectType(type)) {
            const fields = type.getFields();
            for (const fieldName in fields) {
                const field = fields[fieldName];
                fn(field, typeName, fieldName);
            }
        }
    }
}

function forEachDefaultValue(schema, fn) {
    const typeMap = schema.getTypeMap();
    for (const typeName in typeMap) {
        const type = typeMap[typeName];
        if (!getNamedType(type).name.startsWith('__')) {
            if (isObjectType(type)) {
                const fields = type.getFields();
                for (const fieldName in fields) {
                    const field = fields[fieldName];
                    for (const arg of field.args) {
                        arg.defaultValue = fn(arg.type, arg.defaultValue);
                    }
                }
            }
            else if (isInputObjectType(type)) {
                const fields = type.getFields();
                for (const fieldName in fields) {
                    const field = fields[fieldName];
                    field.defaultValue = fn(field.type, field.defaultValue);
                }
            }
        }
    }
}

function mergeDeep(sources, respectPrototype = false, respectArrays = false, respectArrayLength = false) {
    if (respectArrays && respectArrayLength) {
        let expectedLength;
        const areArraysInTheSameLength = sources.every(source => {
            if (Array.isArray(source)) {
                if (expectedLength === undefined) {
                    expectedLength = source.length;
                    return true;
                }
                else if (expectedLength === source.length) {
                    return true;
                }
            }
            return false;
        });
        if (areArraysInTheSameLength) {
            return new Array(expectedLength).fill(null).map((_, index) => mergeDeep(sources.map(source => source[index]), respectPrototype, respectArrays, respectArrayLength));
        }
    }
    const output = {};
    if (respectPrototype) {
        Object.setPrototypeOf(output, Object.create(Object.getPrototypeOf(sources[0])));
    }
    for (const source of sources) {
        if (isObject(source)) {
            if (respectPrototype) {
                const outputPrototype = Object.getPrototypeOf(output);
                const sourcePrototype = Object.getPrototypeOf(source);
                if (sourcePrototype) {
                    for (const key of Object.getOwnPropertyNames(sourcePrototype)) {
                        const descriptor = Object.getOwnPropertyDescriptor(sourcePrototype, key);
                        if (isSome(descriptor)) {
                            Object.defineProperty(outputPrototype, key, descriptor);
                        }
                    }
                }
            }
            for (const key in source) {
                if (isObject(source[key])) {
                    if (!(key in output)) {
                        Object.assign(output, { [key]: source[key] });
                    }
                    else {
                        output[key] = mergeDeep([output[key], source[key]], respectPrototype, respectArrays, respectArrayLength);
                    }
                }
                else if (respectArrays && Array.isArray(output[key])) {
                    if (Array.isArray(source[key])) {
                        if (respectArrayLength && output[key].length === source[key].length) {
                            output[key] = mergeDeep([output[key], source[key]], respectPrototype, respectArrays, respectArrayLength);
                        }
                        else {
                            output[key].push(...source[key]);
                        }
                    }
                    else {
                        output[key].push(source[key]);
                    }
                }
                else {
                    Object.assign(output, { [key]: source[key] });
                }
            }
        }
    }
    return output;
}
function isObject(item) {
    return item && typeof item === 'object' && !Array.isArray(item);
}

function isDocumentNode(object) {
    return object && typeof object === 'object' && 'kind' in object && object.kind === Kind.DOCUMENT;
}

function assertResolversPresent(schema, resolverValidationOptions = {}) {
    const { requireResolversForArgs, requireResolversForNonScalar, requireResolversForAllFields } = resolverValidationOptions;
    if (requireResolversForAllFields && (requireResolversForArgs || requireResolversForNonScalar)) {
        throw new TypeError('requireResolversForAllFields takes precedence over the more specific assertions. ' +
            'Please configure either requireResolversForAllFields or requireResolversForArgs / ' +
            'requireResolversForNonScalar, but not a combination of them.');
    }
    forEachField(schema, (field, typeName, fieldName) => {
        // requires a resolver for *every* field.
        if (requireResolversForAllFields) {
            expectResolver('requireResolversForAllFields', requireResolversForAllFields, field, typeName, fieldName);
        }
        // requires a resolver on every field that has arguments
        if (requireResolversForArgs && field.args.length > 0) {
            expectResolver('requireResolversForArgs', requireResolversForArgs, field, typeName, fieldName);
        }
        // requires a resolver on every field that returns a non-scalar type
        if (requireResolversForNonScalar !== 'ignore' && !isScalarType(getNamedType(field.type))) {
            expectResolver('requireResolversForNonScalar', requireResolversForNonScalar, field, typeName, fieldName);
        }
    });
}
function expectResolver(validator, behavior, field, typeName, fieldName) {
    if (!field.resolve) {
        const message = `Resolver missing for "${typeName}.${fieldName}".
To disable this validator, use:
  resolverValidationOptions: {
    ${validator}: 'ignore'
  }`;
        if (behavior === 'error') {
            throw new Error(message);
        }
        if (behavior === 'warn') {
            console.warn(message);
        }
        return;
    }
    if (typeof field.resolve !== 'function') {
        throw new Error(`Resolver "${typeName}.${fieldName}" must be a function`);
    }
}

// If we have any union or interface types throw if no there is no resolveType resolver
function checkForResolveTypeResolver(schema, requireResolversForResolveType) {
    mapSchema(schema, {
        [MapperKind.ABSTRACT_TYPE]: type => {
            if (!type.resolveType) {
                const message = `Type "${type.name}" is missing a "__resolveType" resolver. Pass 'ignore' into ` +
                    '"resolverValidationOptions.requireResolversForResolveType" to disable this error.';
                if (requireResolversForResolveType === 'error') {
                    throw new Error(message);
                }
                if (requireResolversForResolveType === 'warn') {
                    console.warn(message);
                }
            }
            return undefined;
        },
    });
}

function extendResolversFromInterfaces(schema, resolvers) {
    const extendedResolvers = {};
    const typeMap = schema.getTypeMap();
    for (const typeName in typeMap) {
        const type = typeMap[typeName];
        if ('getInterfaces' in type) {
            extendedResolvers[typeName] = {};
            for (const iFace of type.getInterfaces()) {
                if (resolvers[iFace.name]) {
                    for (const fieldName in resolvers[iFace.name]) {
                        if (fieldName === '__isTypeOf' || !fieldName.startsWith('__')) {
                            extendedResolvers[typeName][fieldName] = resolvers[iFace.name][fieldName];
                        }
                    }
                }
            }
            const typeResolvers = resolvers[typeName];
            extendedResolvers[typeName] = {
                ...extendedResolvers[typeName],
                ...typeResolvers,
            };
        }
        else {
            const typeResolvers = resolvers[typeName];
            if (typeResolvers != null) {
                extendedResolvers[typeName] = typeResolvers;
            }
        }
    }
    return extendedResolvers;
}

function addResolversToSchema({ schema, resolvers: inputResolvers, defaultFieldResolver, resolverValidationOptions = {}, inheritResolversFromInterfaces = false, updateResolversInPlace = false, }) {
    const { requireResolversToMatchSchema = 'error', requireResolversForResolveType } = resolverValidationOptions;
    const resolvers = inheritResolversFromInterfaces
        ? extendResolversFromInterfaces(schema, inputResolvers)
        : inputResolvers;
    for (const typeName in resolvers) {
        const resolverValue = resolvers[typeName];
        const resolverType = typeof resolverValue;
        if (resolverType !== 'object') {
            throw new Error(`"${typeName}" defined in resolvers, but has invalid value "${resolverValue}". The resolver's value must be of type object.`);
        }
        const type = schema.getType(typeName);
        if (type == null) {
            const msg = `"${typeName}" defined in resolvers, but not in schema`;
            if (requireResolversToMatchSchema && requireResolversToMatchSchema !== 'error') {
                if (requireResolversToMatchSchema === 'warn') {
                    console.warn(msg);
                }
                continue;
            }
            throw new Error(msg);
        }
        else if (isSpecifiedScalarType(type)) {
            // allow -- without recommending -- overriding of specified scalar types
            for (const fieldName in resolverValue) {
                if (fieldName.startsWith('__')) {
                    type[fieldName.substring(2)] = resolverValue[fieldName];
                }
                else {
                    type[fieldName] = resolverValue[fieldName];
                }
            }
        }
        else if (isEnumType(type)) {
            const values = type.getValues();
            for (const fieldName in resolverValue) {
                if (!fieldName.startsWith('__') &&
                    !values.some(value => value.name === fieldName) &&
                    requireResolversToMatchSchema &&
                    requireResolversToMatchSchema !== 'ignore') {
                    const msg = `${type.name}.${fieldName} was defined in resolvers, but not present within ${type.name}`;
                    if (requireResolversToMatchSchema === 'error') {
                        throw new Error(msg);
                    }
                    else {
                        console.warn(msg);
                    }
                }
            }
        }
        else if (isUnionType(type)) {
            for (const fieldName in resolverValue) {
                if (!fieldName.startsWith('__') &&
                    requireResolversToMatchSchema &&
                    requireResolversToMatchSchema !== 'ignore') {
                    const msg = `${type.name}.${fieldName} was defined in resolvers, but ${type.name} is not an object or interface type`;
                    if (requireResolversToMatchSchema === 'error') {
                        throw new Error(msg);
                    }
                    else {
                        console.warn(msg);
                    }
                }
            }
        }
        else if (isObjectType(type) || isInterfaceType(type)) {
            for (const fieldName in resolverValue) {
                if (!fieldName.startsWith('__')) {
                    const fields = type.getFields();
                    const field = fields[fieldName];
                    if (field == null) {
                        // Field present in resolver but not in schema
                        if (requireResolversToMatchSchema && requireResolversToMatchSchema !== 'ignore') {
                            const msg = `${typeName}.${fieldName} defined in resolvers, but not in schema`;
                            if (requireResolversToMatchSchema === 'error') {
                                throw new Error(msg);
                            }
                            else {
                                console.error(msg);
                            }
                        }
                    }
                    else {
                        // Field present in both the resolver and schema
                        const fieldResolve = resolverValue[fieldName];
                        if (typeof fieldResolve !== 'function' && typeof fieldResolve !== 'object') {
                            throw new Error(`Resolver ${typeName}.${fieldName} must be object or function`);
                        }
                    }
                }
            }
        }
    }
    schema = updateResolversInPlace
        ? addResolversToExistingSchema(schema, resolvers, defaultFieldResolver)
        : createNewSchemaWithResolvers(schema, resolvers, defaultFieldResolver);
    if (requireResolversForResolveType && requireResolversForResolveType !== 'ignore') {
        checkForResolveTypeResolver(schema, requireResolversForResolveType);
    }
    return schema;
}
function addResolversToExistingSchema(schema, resolvers, defaultFieldResolver) {
    const typeMap = schema.getTypeMap();
    for (const typeName in resolvers) {
        const type = schema.getType(typeName);
        const resolverValue = resolvers[typeName];
        if (isScalarType(type)) {
            for (const fieldName in resolverValue) {
                if (fieldName.startsWith('__')) {
                    type[fieldName.substring(2)] = resolverValue[fieldName];
                }
                else if (fieldName === 'astNode' && type.astNode != null) {
                    type.astNode = {
                        ...type.astNode,
                        description: resolverValue?.astNode?.description ??
                            type.astNode.description,
                        directives: (type.astNode.directives ?? []).concat(resolverValue?.astNode?.directives ?? []),
                    };
                }
                else if (fieldName === 'extensionASTNodes' && type.extensionASTNodes != null) {
                    type.extensionASTNodes = type.extensionASTNodes.concat(resolverValue?.extensionASTNodes ?? []);
                }
                else if (fieldName === 'extensions' &&
                    type.extensions != null &&
                    resolverValue.extensions != null) {
                    type.extensions = Object.assign(Object.create(null), type.extensions, resolverValue.extensions);
                }
                else {
                    type[fieldName] = resolverValue[fieldName];
                }
            }
        }
        else if (isEnumType(type)) {
            const config = type.toConfig();
            const enumValueConfigMap = config.values;
            for (const fieldName in resolverValue) {
                if (fieldName.startsWith('__')) {
                    config[fieldName.substring(2)] = resolverValue[fieldName];
                }
                else if (fieldName === 'astNode' && config.astNode != null) {
                    config.astNode = {
                        ...config.astNode,
                        description: resolverValue?.astNode?.description ??
                            config.astNode.description,
                        directives: (config.astNode.directives ?? []).concat(resolverValue?.astNode?.directives ?? []),
                    };
                }
                else if (fieldName === 'extensionASTNodes' && config.extensionASTNodes != null) {
                    config.extensionASTNodes = config.extensionASTNodes.concat(resolverValue?.extensionASTNodes ?? []);
                }
                else if (fieldName === 'extensions' &&
                    type.extensions != null &&
                    resolverValue.extensions != null) {
                    type.extensions = Object.assign(Object.create(null), type.extensions, resolverValue.extensions);
                }
                else if (enumValueConfigMap[fieldName]) {
                    enumValueConfigMap[fieldName].value = resolverValue[fieldName];
                }
            }
            typeMap[typeName] = new GraphQLEnumType(config);
        }
        else if (isUnionType(type)) {
            for (const fieldName in resolverValue) {
                if (fieldName.startsWith('__')) {
                    type[fieldName.substring(2)] = resolverValue[fieldName];
                }
            }
        }
        else if (isObjectType(type) || isInterfaceType(type)) {
            for (const fieldName in resolverValue) {
                if (fieldName.startsWith('__')) {
                    // this is for isTypeOf and resolveType and all the other stuff.
                    type[fieldName.substring(2)] = resolverValue[fieldName];
                    continue;
                }
                const fields = type.getFields();
                const field = fields[fieldName];
                if (field != null) {
                    const fieldResolve = resolverValue[fieldName];
                    if (typeof fieldResolve === 'function') {
                        // for convenience. Allows shorter syntax in resolver definition file
                        field.resolve = fieldResolve.bind(resolverValue);
                    }
                    else {
                        setFieldProperties(field, fieldResolve);
                    }
                }
            }
        }
    }
    // serialize all default values prior to healing fields with new scalar/enum types.
    forEachDefaultValue(schema, serializeInputValue);
    // schema may have new scalar/enum types that require healing
    healSchema(schema);
    // reparse all default values with new parsing functions.
    forEachDefaultValue(schema, parseInputValue);
    if (defaultFieldResolver != null) {
        forEachField(schema, field => {
            if (!field.resolve) {
                field.resolve = defaultFieldResolver;
            }
        });
    }
    return schema;
}
function createNewSchemaWithResolvers(schema, resolvers, defaultFieldResolver) {
    schema = mapSchema(schema, {
        [MapperKind.SCALAR_TYPE]: type => {
            const config = type.toConfig();
            const resolverValue = resolvers[type.name];
            if (!isSpecifiedScalarType(type) && resolverValue != null) {
                for (const fieldName in resolverValue) {
                    if (fieldName.startsWith('__')) {
                        config[fieldName.substring(2)] = resolverValue[fieldName];
                    }
                    else if (fieldName === 'astNode' && config.astNode != null) {
                        config.astNode = {
                            ...config.astNode,
                            description: resolverValue?.astNode?.description ??
                                config.astNode.description,
                            directives: (config.astNode.directives ?? []).concat(resolverValue?.astNode?.directives ?? []),
                        };
                    }
                    else if (fieldName === 'extensionASTNodes' && config.extensionASTNodes != null) {
                        config.extensionASTNodes = config.extensionASTNodes.concat(resolverValue?.extensionASTNodes ?? []);
                    }
                    else if (fieldName === 'extensions' &&
                        config.extensions != null &&
                        resolverValue.extensions != null) {
                        config.extensions = Object.assign(Object.create(null), type.extensions, resolverValue.extensions);
                    }
                    else {
                        config[fieldName] = resolverValue[fieldName];
                    }
                }
                return new GraphQLScalarType(config);
            }
        },
        [MapperKind.ENUM_TYPE]: type => {
            const resolverValue = resolvers[type.name];
            const config = type.toConfig();
            const enumValueConfigMap = config.values;
            if (resolverValue != null) {
                for (const fieldName in resolverValue) {
                    if (fieldName.startsWith('__')) {
                        config[fieldName.substring(2)] = resolverValue[fieldName];
                    }
                    else if (fieldName === 'astNode' && config.astNode != null) {
                        config.astNode = {
                            ...config.astNode,
                            description: resolverValue?.astNode?.description ??
                                config.astNode.description,
                            directives: (config.astNode.directives ?? []).concat(resolverValue?.astNode?.directives ?? []),
                        };
                    }
                    else if (fieldName === 'extensionASTNodes' && config.extensionASTNodes != null) {
                        config.extensionASTNodes = config.extensionASTNodes.concat(resolverValue?.extensionASTNodes ?? []);
                    }
                    else if (fieldName === 'extensions' &&
                        config.extensions != null &&
                        resolverValue.extensions != null) {
                        config.extensions = Object.assign(Object.create(null), type.extensions, resolverValue.extensions);
                    }
                    else if (enumValueConfigMap[fieldName]) {
                        enumValueConfigMap[fieldName].value = resolverValue[fieldName];
                    }
                }
                return new GraphQLEnumType(config);
            }
        },
        [MapperKind.UNION_TYPE]: type => {
            const resolverValue = resolvers[type.name];
            if (resolverValue != null) {
                const config = type.toConfig();
                if (resolverValue['__resolveType']) {
                    config.resolveType = resolverValue['__resolveType'];
                }
                return new GraphQLUnionType(config);
            }
        },
        [MapperKind.OBJECT_TYPE]: type => {
            const resolverValue = resolvers[type.name];
            if (resolverValue != null) {
                const config = type.toConfig();
                if (resolverValue['__isTypeOf']) {
                    config.isTypeOf = resolverValue['__isTypeOf'];
                }
                return new GraphQLObjectType(config);
            }
        },
        [MapperKind.INTERFACE_TYPE]: type => {
            const resolverValue = resolvers[type.name];
            if (resolverValue != null) {
                const config = type.toConfig();
                if (resolverValue['__resolveType']) {
                    config.resolveType = resolverValue['__resolveType'];
                }
                return new GraphQLInterfaceType(config);
            }
        },
        [MapperKind.COMPOSITE_FIELD]: (fieldConfig, fieldName, typeName) => {
            const resolverValue = resolvers[typeName];
            if (resolverValue != null) {
                const fieldResolve = resolverValue[fieldName];
                if (fieldResolve != null) {
                    const newFieldConfig = { ...fieldConfig };
                    if (typeof fieldResolve === 'function') {
                        // for convenience. Allows shorter syntax in resolver definition file
                        newFieldConfig.resolve = fieldResolve.bind(resolverValue);
                    }
                    else {
                        setFieldProperties(newFieldConfig, fieldResolve);
                    }
                    return newFieldConfig;
                }
            }
        },
    });
    if (defaultFieldResolver != null) {
        schema = mapSchema(schema, {
            [MapperKind.OBJECT_FIELD]: fieldConfig => ({
                ...fieldConfig,
                resolve: fieldConfig.resolve != null ? fieldConfig.resolve : defaultFieldResolver,
            }),
        });
    }
    return schema;
}
function setFieldProperties(field, propertiesObj) {
    for (const propertyName in propertiesObj) {
        field[propertyName] = propertiesObj[propertyName];
    }
}

/**
 * Deep merges multiple resolver definition objects into a single definition.
 * @param resolversDefinitions Resolver definitions to be merged
 * @param options Additional options
 *
 * ```js
 * const { mergeResolvers } = require('@graphql-tools/merge');
 * const clientResolver = require('./clientResolver');
 * const productResolver = require('./productResolver');
 *
 * const resolvers = mergeResolvers([
 *  clientResolver,
 *  productResolver,
 * ]);
 * ```
 *
 * If you don't want to manually create the array of resolver objects, you can
 * also use this function along with loadFiles:
 *
 * ```js
 * const path = require('path');
 * const { mergeResolvers } = require('@graphql-tools/merge');
 * const { loadFilesSync } = require('@graphql-tools/load-files');
 *
 * const resolversArray = loadFilesSync(path.join(__dirname, './resolvers'));
 *
 * const resolvers = mergeResolvers(resolversArray)
 * ```
 */
function mergeResolvers(resolversDefinitions, options) {
    if (!resolversDefinitions ||
        (Array.isArray(resolversDefinitions) && resolversDefinitions.length === 0)) {
        return {};
    }
    if (!Array.isArray(resolversDefinitions)) {
        return resolversDefinitions;
    }
    if (resolversDefinitions.length === 1) {
        return resolversDefinitions[0] || {};
    }
    const resolvers = new Array();
    for (let resolversDefinition of resolversDefinitions) {
        if (Array.isArray(resolversDefinition)) {
            resolversDefinition = mergeResolvers(resolversDefinition);
        }
        if (typeof resolversDefinition === 'object' && resolversDefinition) {
            resolvers.push(resolversDefinition);
        }
    }
    const result = mergeDeep(resolvers, true);
    return result;
}

function mergeArguments$1(args1, args2, config) {
    const result = deduplicateArguments([...args2, ...args1].filter(isSome), config);
    if (config && config.sort) {
        result.sort(compareNodes);
    }
    return result;
}
function deduplicateArguments(args, config) {
    return args.reduce((acc, current) => {
        const dupIndex = acc.findIndex(arg => arg.name.value === current.name.value);
        if (dupIndex === -1) {
            return acc.concat([current]);
        }
        else if (!config?.reverseArguments) {
            acc[dupIndex] = current;
        }
        return acc;
    }, []);
}

function directiveAlreadyExists(directivesArr, otherDirective) {
    return !!directivesArr.find(directive => directive.name.value === otherDirective.name.value);
}
function isRepeatableDirective(directive, directives) {
    return !!directives?.[directive.name.value]?.repeatable;
}
function nameAlreadyExists(name, namesArr) {
    return namesArr.some(({ value }) => value === name.value);
}
function mergeArguments(a1, a2) {
    const result = [...a2];
    for (const argument of a1) {
        const existingIndex = result.findIndex(a => a.name.value === argument.name.value);
        if (existingIndex > -1) {
            const existingArg = result[existingIndex];
            if (existingArg.value.kind === 'ListValue') {
                const source = existingArg.value.values;
                const target = argument.value.values;
                // merge values of two lists
                existingArg.value.values = deduplicateLists(source, target, (targetVal, source) => {
                    const value = targetVal.value;
                    return !value || !source.some((sourceVal) => sourceVal.value === value);
                });
            }
            else {
                existingArg.value = argument.value;
            }
        }
        else {
            result.push(argument);
        }
    }
    return result;
}
function deduplicateDirectives(directives, definitions) {
    return directives
        .map((directive, i, all) => {
        const firstAt = all.findIndex(d => d.name.value === directive.name.value);
        if (firstAt !== i && !isRepeatableDirective(directive, definitions)) {
            const dup = all[firstAt];
            directive.arguments = mergeArguments(directive.arguments, dup.arguments);
            return null;
        }
        return directive;
    })
        .filter(isSome);
}
function mergeDirectives(d1 = [], d2 = [], config, directives) {
    const reverseOrder = config && config.reverseDirectives;
    const asNext = reverseOrder ? d1 : d2;
    const asFirst = reverseOrder ? d2 : d1;
    const result = deduplicateDirectives([...asNext], directives);
    for (const directive of asFirst) {
        if (directiveAlreadyExists(result, directive) &&
            !isRepeatableDirective(directive, directives)) {
            const existingDirectiveIndex = result.findIndex(d => d.name.value === directive.name.value);
            const existingDirective = result[existingDirectiveIndex];
            result[existingDirectiveIndex].arguments = mergeArguments(directive.arguments || [], existingDirective.arguments || []);
        }
        else {
            result.push(directive);
        }
    }
    return result;
}
function mergeDirective(node, existingNode) {
    if (existingNode) {
        return {
            ...node,
            arguments: deduplicateLists(existingNode.arguments || [], node.arguments || [], (arg, existingArgs) => !nameAlreadyExists(arg.name, existingArgs.map(a => a.name))),
            locations: [
                ...existingNode.locations,
                ...node.locations.filter(name => !nameAlreadyExists(name, existingNode.locations)),
            ],
        };
    }
    return node;
}
function deduplicateLists(source, target, filterFn) {
    return source.concat(target.filter(val => filterFn(val, source)));
}

function mergeEnumValues(first, second, config, directives) {
    if (config?.consistentEnumMerge) {
        const reversed = [];
        if (first) {
            reversed.push(...first);
        }
        first = second;
        second = reversed;
    }
    const enumValueMap = new Map();
    if (first) {
        for (const firstValue of first) {
            enumValueMap.set(firstValue.name.value, firstValue);
        }
    }
    if (second) {
        for (const secondValue of second) {
            const enumValue = secondValue.name.value;
            if (enumValueMap.has(enumValue)) {
                const firstValue = enumValueMap.get(enumValue);
                firstValue.description = secondValue.description || firstValue.description;
                firstValue.directives = mergeDirectives(secondValue.directives, firstValue.directives, directives);
            }
            else {
                enumValueMap.set(enumValue, secondValue);
            }
        }
    }
    const result = [...enumValueMap.values()];
    if (config && config.sort) {
        result.sort(compareNodes);
    }
    return result;
}

function mergeEnum(e1, e2, config, directives) {
    if (e2) {
        return {
            name: e1.name,
            description: e1['description'] || e2['description'],
            kind: config?.convertExtensions ||
                e1.kind === 'EnumTypeDefinition' ||
                e2.kind === 'EnumTypeDefinition'
                ? 'EnumTypeDefinition'
                : 'EnumTypeExtension',
            loc: e1.loc,
            directives: mergeDirectives(e1.directives, e2.directives, config, directives),
            values: mergeEnumValues(e1.values, e2.values, config),
        };
    }
    return config?.convertExtensions
        ? {
            ...e1,
            kind: Kind.ENUM_TYPE_DEFINITION,
        }
        : e1;
}

function isStringTypes(types) {
    return typeof types === 'string';
}
function isSourceTypes(types) {
    return types instanceof Source;
}
function extractType(type) {
    let visitedType = type;
    while (visitedType.kind === Kind.LIST_TYPE || visitedType.kind === 'NonNullType') {
        visitedType = visitedType.type;
    }
    return visitedType;
}
function isWrappingTypeNode(type) {
    return type.kind !== Kind.NAMED_TYPE;
}
function isListTypeNode(type) {
    return type.kind === Kind.LIST_TYPE;
}
function isNonNullTypeNode(type) {
    return type.kind === Kind.NON_NULL_TYPE;
}
function printTypeNode(type) {
    if (isListTypeNode(type)) {
        return `[${printTypeNode(type.type)}]`;
    }
    if (isNonNullTypeNode(type)) {
        return `${printTypeNode(type.type)}!`;
    }
    return type.name.value;
}
var CompareVal;
(function (CompareVal) {
    CompareVal[CompareVal["A_SMALLER_THAN_B"] = -1] = "A_SMALLER_THAN_B";
    CompareVal[CompareVal["A_EQUALS_B"] = 0] = "A_EQUALS_B";
    CompareVal[CompareVal["A_GREATER_THAN_B"] = 1] = "A_GREATER_THAN_B";
})(CompareVal || (CompareVal = {}));
function defaultStringComparator(a, b) {
    if (a == null && b == null) {
        return CompareVal.A_EQUALS_B;
    }
    if (a == null) {
        return CompareVal.A_SMALLER_THAN_B;
    }
    if (b == null) {
        return CompareVal.A_GREATER_THAN_B;
    }
    if (a < b)
        return CompareVal.A_SMALLER_THAN_B;
    if (a > b)
        return CompareVal.A_GREATER_THAN_B;
    return CompareVal.A_EQUALS_B;
}

function fieldAlreadyExists(fieldsArr, otherField) {
    const resultIndex = fieldsArr.findIndex(field => field.name.value === otherField.name.value);
    return [resultIndex > -1 ? fieldsArr[resultIndex] : null, resultIndex];
}
function mergeFields(type, f1, f2, config, directives) {
    const result = [];
    if (f2 != null) {
        result.push(...f2);
    }
    if (f1 != null) {
        for (const field of f1) {
            const [existing, existingIndex] = fieldAlreadyExists(result, field);
            if (existing && !config?.ignoreFieldConflicts) {
                const newField = (config?.onFieldTypeConflict &&
                    config.onFieldTypeConflict(existing, field, type, config?.throwOnConflict)) ||
                    preventConflicts(type, existing, field, config?.throwOnConflict);
                newField.arguments = mergeArguments$1(field['arguments'] || [], existing['arguments'] || [], config);
                newField.directives = mergeDirectives(field.directives, existing.directives, config, directives);
                newField.description = field.description || existing.description;
                result[existingIndex] = newField;
            }
            else {
                result.push(field);
            }
        }
    }
    if (config && config.sort) {
        result.sort(compareNodes);
    }
    if (config && config.exclusions) {
        const exclusions = config.exclusions;
        return result.filter(field => !exclusions.includes(`${type.name.value}.${field.name.value}`));
    }
    return result;
}
function preventConflicts(type, a, b, ignoreNullability = false) {
    const aType = printTypeNode(a.type);
    const bType = printTypeNode(b.type);
    if (aType !== bType) {
        const t1 = extractType(a.type);
        const t2 = extractType(b.type);
        if (t1.name.value !== t2.name.value) {
            throw new Error(`Field "${b.name.value}" already defined with a different type. Declared as "${t1.name.value}", but you tried to override with "${t2.name.value}"`);
        }
        if (!safeChangeForFieldType(a.type, b.type, !ignoreNullability)) {
            throw new Error(`Field '${type.name.value}.${a.name.value}' changed type from '${aType}' to '${bType}'`);
        }
    }
    if (isNonNullTypeNode(b.type) && !isNonNullTypeNode(a.type)) {
        a.type = b.type;
    }
    return a;
}
function safeChangeForFieldType(oldType, newType, ignoreNullability = false) {
    // both are named
    if (!isWrappingTypeNode(oldType) && !isWrappingTypeNode(newType)) {
        return oldType.toString() === newType.toString();
    }
    // new is non-null
    if (isNonNullTypeNode(newType)) {
        const ofType = isNonNullTypeNode(oldType) ? oldType.type : oldType;
        return safeChangeForFieldType(ofType, newType.type);
    }
    // old is non-null
    if (isNonNullTypeNode(oldType)) {
        return safeChangeForFieldType(newType, oldType, ignoreNullability);
    }
    // old is list
    if (isListTypeNode(oldType)) {
        return ((isListTypeNode(newType) && safeChangeForFieldType(oldType.type, newType.type)) ||
            (isNonNullTypeNode(newType) && safeChangeForFieldType(oldType, newType['type'])));
    }
    return false;
}

function mergeInputType(node, existingNode, config, directives) {
    if (existingNode) {
        try {
            return {
                name: node.name,
                description: node['description'] || existingNode['description'],
                kind: config?.convertExtensions ||
                    node.kind === 'InputObjectTypeDefinition' ||
                    existingNode.kind === 'InputObjectTypeDefinition'
                    ? 'InputObjectTypeDefinition'
                    : 'InputObjectTypeExtension',
                loc: node.loc,
                fields: mergeFields(node, node.fields, existingNode.fields, config),
                directives: mergeDirectives(node.directives, existingNode.directives, config, directives),
            };
        }
        catch (e) {
            throw new Error(`Unable to merge GraphQL input type "${node.name.value}": ${e.message}`);
        }
    }
    return config?.convertExtensions
        ? {
            ...node,
            kind: Kind.INPUT_OBJECT_TYPE_DEFINITION,
        }
        : node;
}

function alreadyExists(arr, other) {
    return !!arr.find(i => i.name.value === other.name.value);
}
function mergeNamedTypeArray(first = [], second = [], config = {}) {
    const result = [...second, ...first.filter(d => !alreadyExists(second, d))];
    if (config && config.sort) {
        result.sort(compareNodes);
    }
    return result;
}

function mergeInterface(node, existingNode, config, directives) {
    if (existingNode) {
        try {
            return {
                name: node.name,
                description: node['description'] || existingNode['description'],
                kind: config?.convertExtensions ||
                    node.kind === 'InterfaceTypeDefinition' ||
                    existingNode.kind === 'InterfaceTypeDefinition'
                    ? 'InterfaceTypeDefinition'
                    : 'InterfaceTypeExtension',
                loc: node.loc,
                fields: mergeFields(node, node.fields, existingNode.fields, config),
                directives: mergeDirectives(node.directives, existingNode.directives, config, directives),
                interfaces: node['interfaces']
                    ? mergeNamedTypeArray(node['interfaces'], existingNode['interfaces'], config)
                    : undefined,
            };
        }
        catch (e) {
            throw new Error(`Unable to merge GraphQL interface "${node.name.value}": ${e.message}`);
        }
    }
    return config?.convertExtensions
        ? {
            ...node,
            kind: Kind.INTERFACE_TYPE_DEFINITION,
        }
        : node;
}

var ast = {};

Object.defineProperty(ast, '__esModule', {
  value: true,
});
ast.Token =
  ast.QueryDocumentKeys =
  ast.OperationTypeNode =
  ast.Location =
    void 0;
var isNode_1 = ast.isNode = isNode;

/**
 * Contains a range of UTF-8 character offsets and token references that
 * identify the region of the source from which the AST derived.
 */
class Location {
  /**
   * The character offset at which this Node begins.
   */

  /**
   * The character offset at which this Node ends.
   */

  /**
   * The Token at which this Node begins.
   */

  /**
   * The Token at which this Node ends.
   */

  /**
   * The Source document the AST represents.
   */
  constructor(startToken, endToken, source) {
    this.start = startToken.start;
    this.end = endToken.end;
    this.startToken = startToken;
    this.endToken = endToken;
    this.source = source;
  }

  get [Symbol.toStringTag]() {
    return 'Location';
  }

  toJSON() {
    return {
      start: this.start,
      end: this.end,
    };
  }
}
/**
 * Represents a range of characters represented by a lexical token
 * within a Source.
 */

ast.Location = Location;

class Token {
  /**
   * The kind of Token.
   */

  /**
   * The character offset at which this Node begins.
   */

  /**
   * The character offset at which this Node ends.
   */

  /**
   * The 1-indexed line number on which this Token appears.
   */

  /**
   * The 1-indexed column number at which this Token begins.
   */

  /**
   * For non-punctuation tokens, represents the interpreted value of the token.
   *
   * Note: is undefined for punctuation tokens, but typed as string for
   * convenience in the parser.
   */

  /**
   * Tokens exist as nodes in a double-linked-list amongst all tokens
   * including ignored tokens. <SOF> is always the first node and <EOF>
   * the last.
   */
  constructor(kind, start, end, line, column, value) {
    this.kind = kind;
    this.start = start;
    this.end = end;
    this.line = line;
    this.column = column; // eslint-disable-next-line @typescript-eslint/no-non-null-assertion

    this.value = value;
    this.prev = null;
    this.next = null;
  }

  get [Symbol.toStringTag]() {
    return 'Token';
  }

  toJSON() {
    return {
      kind: this.kind,
      value: this.value,
      line: this.line,
      column: this.column,
    };
  }
}
/**
 * The list of all possible AST node types.
 */

ast.Token = Token;

/**
 * @internal
 */
const QueryDocumentKeys = {
  Name: [],
  Document: ['definitions'],
  OperationDefinition: [
    'name',
    'variableDefinitions',
    'directives',
    'selectionSet',
  ],
  VariableDefinition: ['variable', 'type', 'defaultValue', 'directives'],
  Variable: ['name'],
  SelectionSet: ['selections'],
  Field: ['alias', 'name', 'arguments', 'directives', 'selectionSet'],
  Argument: ['name', 'value'],
  FragmentSpread: ['name', 'directives'],
  InlineFragment: ['typeCondition', 'directives', 'selectionSet'],
  FragmentDefinition: [
    'name', // Note: fragment variable definitions are deprecated and will removed in v17.0.0
    'variableDefinitions',
    'typeCondition',
    'directives',
    'selectionSet',
  ],
  IntValue: [],
  FloatValue: [],
  StringValue: [],
  BooleanValue: [],
  NullValue: [],
  EnumValue: [],
  ListValue: ['values'],
  ObjectValue: ['fields'],
  ObjectField: ['name', 'value'],
  Directive: ['name', 'arguments'],
  NamedType: ['name'],
  ListType: ['type'],
  NonNullType: ['type'],
  SchemaDefinition: ['description', 'directives', 'operationTypes'],
  OperationTypeDefinition: ['type'],
  ScalarTypeDefinition: ['description', 'name', 'directives'],
  ObjectTypeDefinition: [
    'description',
    'name',
    'interfaces',
    'directives',
    'fields',
  ],
  FieldDefinition: ['description', 'name', 'arguments', 'type', 'directives'],
  InputValueDefinition: [
    'description',
    'name',
    'type',
    'defaultValue',
    'directives',
  ],
  InterfaceTypeDefinition: [
    'description',
    'name',
    'interfaces',
    'directives',
    'fields',
  ],
  UnionTypeDefinition: ['description', 'name', 'directives', 'types'],
  EnumTypeDefinition: ['description', 'name', 'directives', 'values'],
  EnumValueDefinition: ['description', 'name', 'directives'],
  InputObjectTypeDefinition: ['description', 'name', 'directives', 'fields'],
  DirectiveDefinition: ['description', 'name', 'arguments', 'locations'],
  SchemaExtension: ['directives', 'operationTypes'],
  ScalarTypeExtension: ['name', 'directives'],
  ObjectTypeExtension: ['name', 'interfaces', 'directives', 'fields'],
  InterfaceTypeExtension: ['name', 'interfaces', 'directives', 'fields'],
  UnionTypeExtension: ['name', 'directives', 'types'],
  EnumTypeExtension: ['name', 'directives', 'values'],
  InputObjectTypeExtension: ['name', 'directives', 'fields'],
};
ast.QueryDocumentKeys = QueryDocumentKeys;
const kindValues = new Set(Object.keys(QueryDocumentKeys));
/**
 * @internal
 */

function isNode(maybeNode) {
  const maybeKind =
    maybeNode === null || maybeNode === void 0 ? void 0 : maybeNode.kind;
  return typeof maybeKind === 'string' && kindValues.has(maybeKind);
}
/** Name */

var OperationTypeNode;
ast.OperationTypeNode = OperationTypeNode;

(function (OperationTypeNode) {
  OperationTypeNode['QUERY'] = 'query';
  OperationTypeNode['MUTATION'] = 'mutation';
  OperationTypeNode['SUBSCRIPTION'] = 'subscription';
})(OperationTypeNode || (ast.OperationTypeNode = OperationTypeNode = {}));

function mergeScalar(node, existingNode, config, directives) {
    if (existingNode) {
        return {
            name: node.name,
            description: node['description'] || existingNode['description'],
            kind: config?.convertExtensions ||
                node.kind === 'ScalarTypeDefinition' ||
                existingNode.kind === 'ScalarTypeDefinition'
                ? 'ScalarTypeDefinition'
                : 'ScalarTypeExtension',
            loc: node.loc,
            directives: mergeDirectives(node.directives, existingNode.directives, config, directives),
        };
    }
    return config?.convertExtensions
        ? {
            ...node,
            kind: Kind.SCALAR_TYPE_DEFINITION,
        }
        : node;
}

const DEFAULT_OPERATION_TYPE_NAME_MAP = {
    query: 'Query',
    mutation: 'Mutation',
    subscription: 'Subscription',
};
function mergeOperationTypes(opNodeList = [], existingOpNodeList = []) {
    const finalOpNodeList = [];
    for (const opNodeType in DEFAULT_OPERATION_TYPE_NAME_MAP) {
        const opNode = opNodeList.find(n => n.operation === opNodeType) ||
            existingOpNodeList.find(n => n.operation === opNodeType);
        if (opNode) {
            finalOpNodeList.push(opNode);
        }
    }
    return finalOpNodeList;
}
function mergeSchemaDefs(node, existingNode, config, directives) {
    if (existingNode) {
        return {
            kind: node.kind === Kind.SCHEMA_DEFINITION || existingNode.kind === Kind.SCHEMA_DEFINITION
                ? Kind.SCHEMA_DEFINITION
                : Kind.SCHEMA_EXTENSION,
            description: node['description'] || existingNode['description'],
            directives: mergeDirectives(node.directives, existingNode.directives, config, directives),
            operationTypes: mergeOperationTypes(node.operationTypes, existingNode.operationTypes),
        };
    }
    return (config?.convertExtensions
        ? {
            ...node,
            kind: Kind.SCHEMA_DEFINITION,
        }
        : node);
}

function mergeType(node, existingNode, config, directives) {
    if (existingNode) {
        try {
            return {
                name: node.name,
                description: node['description'] || existingNode['description'],
                kind: config?.convertExtensions ||
                    node.kind === 'ObjectTypeDefinition' ||
                    existingNode.kind === 'ObjectTypeDefinition'
                    ? 'ObjectTypeDefinition'
                    : 'ObjectTypeExtension',
                loc: node.loc,
                fields: mergeFields(node, node.fields, existingNode.fields, config),
                directives: mergeDirectives(node.directives, existingNode.directives, config, directives),
                interfaces: mergeNamedTypeArray(node.interfaces, existingNode.interfaces, config),
            };
        }
        catch (e) {
            throw new Error(`Unable to merge GraphQL type "${node.name.value}": ${e.message}`);
        }
    }
    return config?.convertExtensions
        ? {
            ...node,
            kind: Kind.OBJECT_TYPE_DEFINITION,
        }
        : node;
}

function mergeUnion(first, second, config, directives) {
    if (second) {
        return {
            name: first.name,
            description: first['description'] || second['description'],
            // ConstXNode has been introduced in v16 but it is not compatible with XNode so we do `as any` for backwards compatibility
            directives: mergeDirectives(first.directives, second.directives, config, directives),
            kind: config?.convertExtensions ||
                first.kind === 'UnionTypeDefinition' ||
                second.kind === 'UnionTypeDefinition'
                ? Kind.UNION_TYPE_DEFINITION
                : Kind.UNION_TYPE_EXTENSION,
            loc: first.loc,
            types: mergeNamedTypeArray(first.types, second.types, config),
        };
    }
    return config?.convertExtensions
        ? {
            ...first,
            kind: Kind.UNION_TYPE_DEFINITION,
        }
        : first;
}

const schemaDefSymbol = 'SCHEMA_DEF_SYMBOL';
function isNamedDefinitionNode(definitionNode) {
    return 'name' in definitionNode;
}
function mergeGraphQLNodes(nodes, config, directives = {}) {
    const mergedResultMap = directives;
    for (const nodeDefinition of nodes) {
        if (isNamedDefinitionNode(nodeDefinition)) {
            const name = nodeDefinition.name?.value;
            if (config?.commentDescriptions) {
                collectComment(nodeDefinition);
            }
            if (name == null) {
                continue;
            }
            if (config?.exclusions?.includes(name + '.*') || config?.exclusions?.includes(name)) {
                delete mergedResultMap[name];
            }
            else {
                switch (nodeDefinition.kind) {
                    case Kind.OBJECT_TYPE_DEFINITION:
                    case Kind.OBJECT_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeType(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.ENUM_TYPE_DEFINITION:
                    case Kind.ENUM_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeEnum(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.UNION_TYPE_DEFINITION:
                    case Kind.UNION_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeUnion(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.SCALAR_TYPE_DEFINITION:
                    case Kind.SCALAR_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeScalar(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.INPUT_OBJECT_TYPE_DEFINITION:
                    case Kind.INPUT_OBJECT_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeInputType(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.INTERFACE_TYPE_DEFINITION:
                    case Kind.INTERFACE_TYPE_EXTENSION:
                        mergedResultMap[name] = mergeInterface(nodeDefinition, mergedResultMap[name], config, directives);
                        break;
                    case Kind.DIRECTIVE_DEFINITION:
                        if (mergedResultMap[name]) {
                            const isInheritedFromPrototype = name in {}; // i.e. toString
                            if (isInheritedFromPrototype) {
                                if (!isNode_1(mergedResultMap[name])) {
                                    mergedResultMap[name] = undefined;
                                }
                            }
                        }
                        mergedResultMap[name] = mergeDirective(nodeDefinition, mergedResultMap[name]);
                        break;
                }
            }
        }
        else if (nodeDefinition.kind === Kind.SCHEMA_DEFINITION ||
            nodeDefinition.kind === Kind.SCHEMA_EXTENSION) {
            mergedResultMap[schemaDefSymbol] = mergeSchemaDefs(nodeDefinition, mergedResultMap[schemaDefSymbol], config);
        }
    }
    return mergedResultMap;
}

function mergeTypeDefs(typeSource, config) {
    resetComments();
    const doc = {
        kind: Kind.DOCUMENT,
        definitions: mergeGraphQLTypes(typeSource, {
            useSchemaDefinition: true,
            forceSchemaDefinition: false,
            throwOnConflict: false,
            commentDescriptions: false,
            ...config,
        }),
    };
    let result;
    if (config?.commentDescriptions) {
        result = printWithComments(doc);
    }
    else {
        result = doc;
    }
    resetComments();
    return result;
}
function visitTypeSources(typeSource, options, allDirectives = [], allNodes = [], visitedTypeSources = new Set()) {
    if (typeSource && !visitedTypeSources.has(typeSource)) {
        visitedTypeSources.add(typeSource);
        if (typeof typeSource === 'function') {
            visitTypeSources(typeSource(), options, allDirectives, allNodes, visitedTypeSources);
        }
        else if (Array.isArray(typeSource)) {
            for (const type of typeSource) {
                visitTypeSources(type, options, allDirectives, allNodes, visitedTypeSources);
            }
        }
        else if (isSchema(typeSource)) {
            const documentNode = getDocumentNodeFromSchema(typeSource, options);
            visitTypeSources(documentNode.definitions, options, allDirectives, allNodes, visitedTypeSources);
        }
        else if (isStringTypes(typeSource) || isSourceTypes(typeSource)) {
            const documentNode = parse(typeSource, options);
            visitTypeSources(documentNode.definitions, options, allDirectives, allNodes, visitedTypeSources);
        }
        else if (typeof typeSource === 'object' && isDefinitionNode(typeSource)) {
            if (typeSource.kind === Kind.DIRECTIVE_DEFINITION) {
                allDirectives.push(typeSource);
            }
            else {
                allNodes.push(typeSource);
            }
        }
        else if (isDocumentNode(typeSource)) {
            visitTypeSources(typeSource.definitions, options, allDirectives, allNodes, visitedTypeSources);
        }
        else {
            throw new Error(`typeDefs must contain only strings, documents, schemas, or functions, got ${typeof typeSource}`);
        }
    }
    return { allDirectives, allNodes };
}
function mergeGraphQLTypes(typeSource, config) {
    resetComments();
    const { allDirectives, allNodes } = visitTypeSources(typeSource, config);
    const mergedDirectives = mergeGraphQLNodes(allDirectives, config);
    const mergedNodes = mergeGraphQLNodes(allNodes, config, mergedDirectives);
    if (config?.useSchemaDefinition) {
        // XXX: right now we don't handle multiple schema definitions
        const schemaDef = mergedNodes[schemaDefSymbol] || {
            kind: Kind.SCHEMA_DEFINITION,
            operationTypes: [],
        };
        const operationTypes = schemaDef.operationTypes;
        for (const opTypeDefNodeType in DEFAULT_OPERATION_TYPE_NAME_MAP) {
            const opTypeDefNode = operationTypes.find(operationType => operationType.operation === opTypeDefNodeType);
            if (!opTypeDefNode) {
                const possibleRootTypeName = DEFAULT_OPERATION_TYPE_NAME_MAP[opTypeDefNodeType];
                const existingPossibleRootType = mergedNodes[possibleRootTypeName];
                if (existingPossibleRootType != null && existingPossibleRootType.name != null) {
                    operationTypes.push({
                        kind: Kind.OPERATION_TYPE_DEFINITION,
                        type: {
                            kind: Kind.NAMED_TYPE,
                            name: existingPossibleRootType.name,
                        },
                        operation: opTypeDefNodeType,
                    });
                }
            }
        }
        if (schemaDef?.operationTypes?.length != null && schemaDef.operationTypes.length > 0) {
            mergedNodes[schemaDefSymbol] = schemaDef;
        }
    }
    if (config?.forceSchemaDefinition && !mergedNodes[schemaDefSymbol]?.operationTypes?.length) {
        mergedNodes[schemaDefSymbol] = {
            kind: Kind.SCHEMA_DEFINITION,
            operationTypes: [
                {
                    kind: Kind.OPERATION_TYPE_DEFINITION,
                    operation: 'query',
                    type: {
                        kind: Kind.NAMED_TYPE,
                        name: {
                            kind: Kind.NAME,
                            value: 'Query',
                        },
                    },
                },
            ],
        };
    }
    const mergedNodeDefinitions = Object.values(mergedNodes);
    if (config?.sort) {
        const sortFn = typeof config.sort === 'function' ? config.sort : defaultStringComparator;
        mergedNodeDefinitions.sort((a, b) => sortFn(a.name?.value, b.name?.value));
    }
    return mergedNodeDefinitions;
}

function mergeExtensions(extensions) {
    return mergeDeep(extensions, false, true);
}
function applyExtensionObject(obj, extensions) {
    if (!obj) {
        return;
    }
    obj.extensions = mergeDeep([obj.extensions || {}, extensions || {}], false, true);
}
function applyExtensions(schema, extensions) {
    applyExtensionObject(schema, extensions.schemaExtensions);
    for (const [typeName, data] of Object.entries(extensions.types || {})) {
        const type = schema.getType(typeName);
        if (type) {
            applyExtensionObject(type, data.extensions);
            if (data.type === 'object' || data.type === 'interface') {
                for (const [fieldName, fieldData] of Object.entries(data.fields)) {
                    const field = type.getFields()[fieldName];
                    if (field) {
                        applyExtensionObject(field, fieldData.extensions);
                        for (const [arg, argData] of Object.entries(fieldData.arguments)) {
                            applyExtensionObject(field.args.find(a => a.name === arg), argData);
                        }
                    }
                }
            }
            else if (data.type === 'input') {
                for (const [fieldName, fieldData] of Object.entries(data.fields)) {
                    const field = type.getFields()[fieldName];
                    applyExtensionObject(field, fieldData.extensions);
                }
            }
            else if (data.type === 'enum') {
                for (const [valueName, valueData] of Object.entries(data.values)) {
                    const value = type.getValue(valueName);
                    applyExtensionObject(value, valueData);
                }
            }
        }
    }
    return schema;
}

/**
 * Builds a schema from the provided type definitions and resolvers.
 *
 * The type definitions are written using Schema Definition Language (SDL). They
 * can be provided as a string, a `DocumentNode`, a function, or an array of any
 * of these. If a function is provided, it will be passed no arguments and
 * should return an array of strings or `DocumentNode`s.
 *
 * Note: You can use GraphQL magic comment provide additional syntax
 * highlighting in your editor (with the appropriate editor plugin).
 *
 * ```js
 * const typeDefs = /* GraphQL *\/ `
 *   type Query {
 *     posts: [Post]
 *     author(id: Int!): Author
 *   }
 * `;
 * ```
 *
 * The `resolvers` object should be a map of type names to nested object, which
 * themselves map the type's fields to their appropriate resolvers.
 * See the [Resolvers](/docs/resolvers) section of the documentation for more details.
 *
 * ```js
 * const resolvers = {
 *   Query: {
 *     posts: (obj, args, ctx, info) => getAllPosts(),
 *     author: (obj, args, ctx, info) => getAuthorById(args.id)
 *   }
 * };
 * ```
 *
 * Once you've defined both the `typeDefs` and `resolvers`, you can create your
 * schema:
 *
 * ```js
 * const schema = makeExecutableSchema({
 *   typeDefs,
 *   resolvers,
 * })
 * ```
 */
function makeExecutableSchema({ typeDefs, resolvers = {}, resolverValidationOptions = {}, inheritResolversFromInterfaces = false, updateResolversInPlace = false, schemaExtensions, defaultFieldResolver, ...otherOptions }) {
    // Validate and clean up arguments
    if (typeof resolverValidationOptions !== 'object') {
        throw new Error('Expected `resolverValidationOptions` to be an object');
    }
    if (!typeDefs) {
        throw new Error('Must provide typeDefs');
    }
    let schema;
    if (isSchema(typeDefs)) {
        schema = typeDefs;
    }
    else if (otherOptions?.commentDescriptions) {
        const mergedTypeDefs = mergeTypeDefs(typeDefs, {
            ...otherOptions,
            commentDescriptions: true,
        });
        schema = buildSchema(mergedTypeDefs, otherOptions);
    }
    else {
        const mergedTypeDefs = mergeTypeDefs(typeDefs, otherOptions);
        schema = buildASTSchema(mergedTypeDefs, otherOptions);
    }
    // We allow passing in an array of resolver maps, in which case we merge them
    schema = addResolversToSchema({
        schema,
        resolvers: mergeResolvers(resolvers),
        resolverValidationOptions,
        inheritResolversFromInterfaces,
        updateResolversInPlace,
        defaultFieldResolver,
    });
    if (Object.keys(resolverValidationOptions).length > 0) {
        assertResolversPresent(schema, resolverValidationOptions);
    }
    if (schemaExtensions) {
        schemaExtensions = mergeExtensions(asArray(schemaExtensions));
        applyExtensions(schema, schemaExtensions);
    }
    return schema;
}

const Authorization = new GraphQLScalarType({
    name: 'Authorization',
    description: 'Authorization description'
});

const Buffer$1 = new GraphQLScalarType({
    name: 'Buffer',
    description: 'Buffer description'
});

const FileDependency = new GraphQLScalarType({
    name: 'FileDependency',
    description: 'FileDependency description'
});

const FileDependencyResult = {
};

const Frame = new GraphQLScalarType({
    name: 'Frame',
    description: 'Frame description'
});

const LocalTask = {
};

const emitFrame = async (_parent, { frame, taskId }, { db })=>{
    const timestamp = frame.timestamp || Date.now();
    await db.frames.put({
        taskId,
        data: frame,
        timestamp
    });
    return true;
};

async function stashFileContent$1(taskId, url, blob, db) {
    const buffer = await blob.arrayBuffer();
    const hash = await sha1(buffer);
    await db.files.update({
        taskId,
        url
    }, {
        blob,
        contentType: blob.type,
        timestamp: new Date().toISOString()
    });
    return hash;
}

const debug$5 = createDebug('server:fetch');
const fetchFileProxy = async (_parent, arg, ctx)=>{
    const { taskId, url, referer, fileType, noStash } = arg;
    const { $fetch, logErrorObject, db, container } = ctx;
    const stashService = container.resolve(FILE_STASH_SERVICE);
    debug$5('start: %s', url);
    {
        try {
            const blob = await ofetch(url, {
                responseType: 'blob',
                headers: {
                    referer
                },
                cache: 'force-cache',
                retry: false
            });
            if (blob) {
                return await processBlob(blob);
            }
        } catch (e) {
            console.error(e);
            if (e && isStatusIgnored(e.status)) {
                await db.files.where({
                    taskId,
                    url
                }).modify({
                    status: FileStatus.Ignore
                });
                return undefined;
            }
        }
    }
    if (fileType !== StashFileType.Css) {
        await fileFail();
        return undefined;
    }
    try {
        const blob = await $fetch('/api/record/proxy-file', {
            responseType: 'blob',
            query: {
                url,
                referer
            },
            cache: 'force-cache'
        });
        return await processBlob(blob);
    } catch (error) {
        logErrorObject(`failed to fetch file with proxy ${url}`, error);
    }
    await fileFail();
    return undefined;
    function fileFail() {
        return db.files.where({
            taskId,
            url
        }).modify({
            status: FileStatus.Failed
        });
    }
    async function processBlob(blob) {
        debug$5('get blob, filesize: %s', blob.size);
        const contentType = blob.type;
        if (fileType === StashFileType.Css || noStash) {
            const content = await blob.text();
            return {
                content,
                contentType
            };
        }
        const hash = await stashFileContent$1(taskId, url, blob, db);
        await stashService.markFileStashed({
            taskId,
            url,
            contentType,
            hash,
            patch: false,
            status: FileStatus.Finished
        });
        return undefined;
    }
};
function isStatusIgnored(status) {
    status = status | 0;
    return status >= 400 && status < 500;
}

const login = async (_parent, { code }, ctx)=>{
    const oauthClient = ctx.container.resolve(OAUTH_CLIENT);
    const oauth = ctx.container.resolve(OAUTH_CONTROLLER);
    const auth = await oauthClient.getTokenByCode(code);
    await oauth.setToken(auth);
    return !!auth?.refreshToken;
};

const logout = async (_parent, _arg, ctx)=>{
    await ctx.container.resolve(OAUTH_CONTROLLER).logout();
    return true;
};

const recordDisable = async (_parent, _arg, { recorderState$ })=>{
    recorderState$.next({
        ...recorderState$.getValue(),
        enabled: false,
        status: RecordingStatus.Stopped,
        snapshotTabId: null,
        taskId: null
    });
    return true;
};

const recordEnable = async (_parent, _arg, { recorderState$ })=>{
    recorderState$.next({
        ...recorderState$.getValue(),
        enabled: true,
        status: RecordingStatus.Stopped,
        snapshotTabId: null,
        taskId: null
    });
    return true;
};

const recordPause = async (_parent, _arg, { db, recorderState$ })=>{
    const state = recorderState$.getValue();
    if (!state?.taskId) {
        return false;
    }
    await db.tasks.update(state.taskId, {
        status: RecordingStatus.Paused
    });
    recorderState$.next({
        ...state,
        status: RecordingStatus.Paused
    });
    return true;
};

const recordResume = async (_parent, _arg, { db, recorderState$ })=>{
    const state = recorderState$.getValue();
    if (!state || state.status !== RecordingStatus.Paused || !state.taskId) {
        return false;
    }
    await db.tasks.update(state.taskId, {
        status: RecordingStatus.Running
    });
    recorderState$.next({
        ...state,
        status: RecordingStatus.Running
    });
    return true;
};

function purgeTaskFiles(db, taskId) {
    if (!isSafeInteger(taskId)) {
        return Promise.resolve();
    }
    return db.files.where({
        taskId
    }).toArray().then((files)=>{
        return Promise.allSettled(files.map((file)=>({
                taskId: file.taskId,
                url: file.url
            })).map((where)=>db.fileChunks.where(where).delete().then(()=>db.files.where(where).delete())));
    }).then();
}
function deleteTaskFrames(db, taskId) {
    return db.frames.where({
        taskId
    }).delete().then();
}
async function refreshProfile(ctx) {
    const appId = await ctx.storage.getItem(APP_ID_KEY);
    const profile = await ctx.$fetch('/api/admin-user/profile');
    if (profile.applications?.length && !profile.applications.find((app)=>app.id === appId)) {
        checkAppId(profile.applications[0].id, REGION$1, thunkGetUserIdFromStorage(ctx.storage), {
            from: 'server-refresh-profile',
            profile: profile
        });
        await ctx.storage.setItem(APP_ID_KEY, profile.applications[0].id);
    }
    if (profile?.figmaPluginOpened) {
        await ctx.storage.setItem(FIGMA_PLUGIN_OPENED_KEY, true);
    } else {
        await ctx.storage.removeItem(FIGMA_PLUGIN_OPENED_KEY);
    }
    return profile;
}
function recordStop$1(recorderState$, keepRecorder) {
    const state = recorderState$.getValue();
    if (!state.taskId) {
        return false;
    }
    recorderState$.next({
        ...state,
        enabled: keepRecorder ?? false,
        status: RecordingStatus.Stopped,
        snapshotTabId: null,
        taskId: null
    });
    return true;
}
function deletePendingTasks(db) {
    return db.tasks.where({
        status: RecordingStatus.Pending
    }).toArray().then((tasks)=>{
        const list = tasks.map((item)=>item.id).filter((id)=>!!id);
        return Promise.all([
            db.files.bulkDelete(list),
            ...list.map((taskId)=>purgeTaskFiles(db, taskId))
        ]);
    });
}
async function clearCompletedTask(db) {
    const tasks = await db.tasks.where('status').anyOf([
        RecordingStatus.Completed,
        RecordingStatus.CompletedWithWarning,
        'completed'
    ]).toArray();
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    const taskIdList = tasks.map((task)=>task.id);
    await Promise.allSettled(taskIdList.map((taskId)=>Promise.allSettled([
            purgeTaskFiles(db, taskId),
            deleteTaskFrames(db, taskId)
        ])));
    await db.tasks.bulkDelete(taskIdList);
}

const recordStart = async (_parent, { name, url, taskType, taskId, snapshotTabId }, ctx)=>{
    const { db, recorderState$, tabId, logErrorObject } = ctx;
    const state = recorderState$.getValue();
    if (state.status !== RecordingStatus.Stopped) {
        return false;
    }
    if (isSafeInteger(taskId)) {
        const task = await db.tasks.get(taskId);
        if (!task) {
            return false;
        }
        await db.tasks.update(taskId, {
            name,
            url,
            status: RecordingStatus.Running,
            taskType
        });
    } else {
        taskId = await db.tasks.put({
            name,
            url,
            status: RecordingStatus.Running,
            taskType
        });
    }
    deletePendingTasks(db).catch((error)=>{
        logErrorObject('recordStart deletePendingTasks', error);
    });
    const nextState = {
        ...state,
        enabled: true,
        status: RecordingStatus.Running,
        taskId,
        taskType,
        snapshotTabId
    };
    if (taskType === TaskType.Snapshot) {
        nextState.snapshotTabId = tabId;
    }
    recorderState$.next(nextState);
    return true;
};

const recordStop = async (_parent, { keepRecorder }, ctx)=>{
    return recordStop$1(ctx.recorderState$, keepRecorder || false);
};

const selectElementAction = async (_parent, { action, frameId }, ctx)=>{
    const service = ctx.container.resolve(SELECT_ELEMENT_SERVICE);
    await service.selectElementAction(action, frameId);
    return true;
};

const selectElementFinish = async (_parent, { rect, taskId }, ctx)=>{
    const { session, startRecord } = ctx;
    if (!session || !startRecord) {
        return false;
    }
    await startRecord({
        taskId,
        taskType: TaskType.Snapshot,
        rect
    });
    return true;
};

const setAppId = async (_parent, arg, ctx)=>{
    await ctx.storage.setItem(APP_ID_KEY, arg.value);
    checkAppId(arg.value, REGION$1, thunkGetUserIdFromStorage(ctx.storage), {
        from: 'graph-ql-resolver'
    });
    return await ctx.storage.getItem(APP_ID_KEY);
};

const setEnv = async (_parent, arg, ctx)=>{
    await ctx.container.resolve(OAUTH_CONTROLLER).logout();
    await ctx.storage.setItem(ENV_KEY, arg.value);
    return await ctx.storage.getItem(ENV_KEY);
};

const setFigmaPluginOpened = async (_parent, arg, ctx)=>{
    await ctx.storage.setItem(FIGMA_PLUGIN_OPENED_KEY, arg.value);
    return true;
};

const setLocale = async (_parent, arg, ctx)=>{
    await ctx.storage.setItem(LOCALE_KEY, arg.value);
    return await ctx.storage.getItem(LOCALE_KEY);
};

const stashFileChunk = async (_parent, { taskId, url, data, timestamp, contentType }, { db })=>{
    const blob = new Blob([
        data
    ], {
        type: contentType
    });
    return await db.fileChunks.put({
        taskId,
        url,
        timestamp,
        blob
    });
};

const stashFileComplete = async (_parent, { taskId, url }, { db })=>{
    await db.files.where({
        taskId,
        url
    }).modify({
        status: FileStatus.Finished
    });
    return true;
};

const debug$4 = createDebug('server:stash-file-content');
const stashFileContent = async (_parent, { taskId, url, data, contentType, patch }, { db, container, logErrorObject })=>{
    const fileStashService = container.resolve(FILE_STASH_SERVICE);
    const file = await db.files.get({
        taskId,
        url
    });
    if (!file) {
        return undefined;
    }
    const buffer = data;
    debug$4('receive file data, size: %s, %s', buffer.byteLength, url);
    try {
        const blob = new Blob([
            buffer
        ], {
            type: contentType
        });
        debug$4('perform stash file content, size: %s, %s', blob.size, url);
        const hash = await stashFileContent$1(taskId, url, blob, db);
        debug$4('after stash file content, size: %s, hash: %s, %s', blob.size, hash, url);
        await fileStashService.markFileStashed({
            taskId,
            url,
            contentType,
            hash,
            patch,
            status: FileStatus$1.Finished
        });
        return hash;
    } catch (error) {
        logErrorObject('failed to stash file', error, {
            contentType,
            url,
            size: buffer.byteLength
        });
        await fileStashService.markFileStashed({
            taskId,
            url,
            contentType,
            hash: '',
            patch,
            status: FileStatus$1.Failed
        });
        return '';
    }
};

const stashVideoScreenshot = async (_parent, arg, ctx)=>{
    try {
        const { db, container } = ctx;
        const { videoUrl, dummyUrl, currentTime, taskId, width, height } = arg;
        const stashService = container.resolve(FILE_STASH_SERVICE);
        const video = document.createElement('video');
        video.muted = true;
        video.src = videoUrl;
        video.width = width;
        video.height = height;
        await video.play();
        video.currentTime = currentTime;
        video.pause();
        const blob = await captureImage(video, width, height);
        const file = await stashService.touchStashFile({
            fileType: StashFileType.Image,
            url: dummyUrl,
            taskId,
            timestamp: new Date().toISOString()
        });
        if (!file) {
            return;
        }
        const hash = await stashFileContent$1(taskId, dummyUrl, blob, db);
        await stashService.markFileStashed({
            url: dummyUrl,
            taskId,
            contentType: blob.type,
            hash,
            patch: false,
            status: FileStatus$1.Finished
        });
    } catch (e) {
        console.error(e);
    }
    return true;
};

const taskCancel = async (_parent, args, ctx)=>{
    const uploaderService = ctx.container.resolve(UPLOADER_SERVICE);
    await uploaderService.cancelTask(args);
    return true;
};

const taskClearComplete = async (_parent, _arg, ctx)=>{
    const { db } = ctx;
    clearCompletedTask(db);
    return true;
};

const taskCreate = async (_parent, { taskType, taskVariance, name, url }, ctx)=>{
    const { db, logErrorObject, storage, region } = ctx;
    const appId = await storage.getItem(APP_ID_KEY);
    if (!checkAppId(appId, region, thunkGetUserIdFromStorage(ctx.storage), {
        from: 'recordStart'
    })) {
        ctx.logout$.next();
        throw new Error('Please sign in again');
    }
    await deletePendingTasks(db).catch((error)=>{
        logErrorObject('deletePendingTasks', error);
    });
    const taskId = await db.tasks.put({
        name,
        url,
        status: RecordingStatus.Pending,
        taskType,
        taskVariance
    });
    return taskId;
};

const taskRemove = async (_parent, { taskId }, ctx)=>{
    const { db } = ctx;
    await Promise.allSettled([
        purgeTaskFiles(db, taskId),
        deleteTaskFrames(db, taskId)
    ]);
    await db.tasks.delete(taskId);
    return true;
};

const touchStashFile = async (_parent, args, { container })=>{
    const fileService = container.resolve(FILE_STASH_SERVICE);
    return fileService.touchStashFile(args);
};

const uploadTask = async (_parent, args, ctx)=>{
    try {
        const uploaderService = ctx.container.resolve(UPLOADER_SERVICE);
        await uploaderService.uploadTask(args);
        return true;
    } catch (e) {
        ctx.logErrorObject('upload task fail', e);
        ctx.db.tasks.update(args.taskId, {
            status: RecordingStatus.Failed
        });
        return false;
    }
};

const getBlocker = once(async ()=>{
    const { UrlBlocker } = await __vitePreload(async () => { const { UrlBlocker } = await import('./thunder_wasm-DZAZ0IUy.js');return { UrlBlocker }},true?[]:void 0);
    return new UrlBlocker();
});
const analyzeFileDependency = async (_parent, { code, fileType, baseURI, candidate }, ctx)=>{
    try {
        switch(fileType){
            case StashFileType.Css:
            case StashFileType.StyleElement:
                return getCSSDependencies(code, baseURI, candidate, 'StyleSheet');
            case StashFileType.StyleAttribute:
                return getCSSDependencies(code, baseURI, candidate, 'StyleAttribute');
            case StashFileType.Image:
                {
                    const blocker = await getBlocker();
                    const skip = blocker.should_ignore(code, baseURI, 'image');
                    await ctx.db.files.where({
                        url: code
                    }).modify({
                        status: FileStatus.Ignore
                    });
                    return {
                        skip,
                        files: [],
                        code: ''
                    };
                }
            default:
        }
    } catch (e) {
        console.error(e);
    }
    return {
        files: [],
        code: ''
    };
};
async function getCSSDependencies(code, baseURI, candidate, context) {
    const { CSSCompiler, stash_files } = await __vitePreload(async () => { const { CSSCompiler, stash_files } = await import('./thunder_wasm-DZAZ0IUy.js');return { CSSCompiler, stash_files }},true?[]:void 0);
    const blocker = await getBlocker();
    const compiler = new CSSCompiler({
        code: new TextEncoder().encode(code),
        context
    });
    const { fonts, imports, urls } = stash_files(compiler, baseURI, blocker);
    const existing = new Set();
    const files = [];
    for (const item of fonts){
        if (existing.has(item.url)) {
            continue;
        }
        existing.add(item.url);
        files.push({
            url: item.url,
            fileType: StashFileType.FontFace,
            extra: item.extra
        });
    }
    for (const item of imports){
        if (existing.has(item.url)) {
            continue;
        }
        existing.add(item.url);
        files.push({
            url: item.url,
            fileType: StashFileType.Css
        });
    }
    for (const item of urls){
        if (existing.has(item.url)) {
            continue;
        }
        existing.add(item.url);
        files.push({
            url: item.url,
            fileType: StashFileType.Image
        });
    }
    let extraRules = [];
    if (context === 'StyleSheet' && candidate) {
        extraRules = compiler.get_delta_rules({
            code: new TextEncoder().encode(candidate)
        });
    }
    const res = compiler.to_css();
    return {
        files,
        code: new TextDecoder().decode(res.code) + '\n' + extraRules.join('\n')
    };
}

const oauthCode = async (_parent, _arg, ctx)=>{
    const { code } = await ctx.$fetch('/api/admin-user/code', {
        method: 'POST'
    });
    return code;
};

const profile = async (_parent, _arg, ctx)=>{
    const auth = await ctx.storage.getItem(OAUTH_KEY);
    if (!auth?.refreshToken) {
        return null;
    }
    return await refreshProfile(ctx);
};

var papaparse_min = {exports: {}};

/* @license
Papa Parse
v5.4.1
https://github.com/mholt/PapaParse
License: MIT
*/

(function (module, exports) {
	!function(e,t){module.exports=t();}(commonjsGlobal,function s(){var f="undefined"!=typeof self?self:"undefined"!=typeof window?window:void 0!==f?f:{};var n=!f.document&&!!f.postMessage,o=f.IS_PAPA_WORKER||!1,a={},u=0,b={parse:function(e,t){var r=(t=t||{}).dynamicTyping||!1;J(r)&&(t.dynamicTypingFunction=r,r={});if(t.dynamicTyping=r,t.transform=!!J(t.transform)&&t.transform,t.worker&&b.WORKERS_SUPPORTED){var i=function(){if(!b.WORKERS_SUPPORTED)return !1;var e=(r=f.URL||f.webkitURL||null,i=s.toString(),b.BLOB_URL||(b.BLOB_URL=r.createObjectURL(new Blob(["var global = (function() { if (typeof self !== 'undefined') { return self; } if (typeof window !== 'undefined') { return window; } if (typeof global !== 'undefined') { return global; } return {}; })(); global.IS_PAPA_WORKER=true; ","(",i,")();"],{type:"text/javascript"})))),t=new f.Worker(e);var r,i;return t.onmessage=_,t.id=u++,a[t.id]=t}();return i.userStep=t.step,i.userChunk=t.chunk,i.userComplete=t.complete,i.userError=t.error,t.step=J(t.step),t.chunk=J(t.chunk),t.complete=J(t.complete),t.error=J(t.error),delete t.worker,void i.postMessage({input:e,config:t,workerId:i.id})}var n=null;b.NODE_STREAM_INPUT,"string"==typeof e?(e=function(e){if(65279===e.charCodeAt(0))return e.slice(1);return e}(e),n=t.download?new l(t):new p(t)):!0===e.readable&&J(e.read)&&J(e.on)?n=new g(t):(f.File&&e instanceof File||e instanceof Object)&&(n=new c(t));return n.stream(e)},unparse:function(e,t){var n=!1,_=!0,m=",",y="\r\n",s='"',a=s+s,r=!1,i=null,o=!1;!function(){if("object"!=typeof t)return;"string"!=typeof t.delimiter||b.BAD_DELIMITERS.filter(function(e){return -1!==t.delimiter.indexOf(e)}).length||(m=t.delimiter);("boolean"==typeof t.quotes||"function"==typeof t.quotes||Array.isArray(t.quotes))&&(n=t.quotes);"boolean"!=typeof t.skipEmptyLines&&"string"!=typeof t.skipEmptyLines||(r=t.skipEmptyLines);"string"==typeof t.newline&&(y=t.newline);"string"==typeof t.quoteChar&&(s=t.quoteChar);"boolean"==typeof t.header&&(_=t.header);if(Array.isArray(t.columns)){if(0===t.columns.length)throw new Error("Option columns is empty");i=t.columns;}void 0!==t.escapeChar&&(a=t.escapeChar+s);("boolean"==typeof t.escapeFormulae||t.escapeFormulae instanceof RegExp)&&(o=t.escapeFormulae instanceof RegExp?t.escapeFormulae:/^[=+\-@\t\r].*$/);}();var u=new RegExp(Q(s),"g");"string"==typeof e&&(e=JSON.parse(e));if(Array.isArray(e)){if(!e.length||Array.isArray(e[0]))return h(null,e,r);if("object"==typeof e[0])return h(i||Object.keys(e[0]),e,r)}else if("object"==typeof e)return "string"==typeof e.data&&(e.data=JSON.parse(e.data)),Array.isArray(e.data)&&(e.fields||(e.fields=e.meta&&e.meta.fields||i),e.fields||(e.fields=Array.isArray(e.data[0])?e.fields:"object"==typeof e.data[0]?Object.keys(e.data[0]):[]),Array.isArray(e.data[0])||"object"==typeof e.data[0]||(e.data=[e.data])),h(e.fields||[],e.data||[],r);throw new Error("Unable to serialize unrecognized input");function h(e,t,r){var i="";"string"==typeof e&&(e=JSON.parse(e)),"string"==typeof t&&(t=JSON.parse(t));var n=Array.isArray(e)&&0<e.length,s=!Array.isArray(t[0]);if(n&&_){for(var a=0;a<e.length;a++)0<a&&(i+=m),i+=v(e[a],a);0<t.length&&(i+=y);}for(var o=0;o<t.length;o++){var u=n?e.length:t[o].length,h=!1,f=n?0===Object.keys(t[o]).length:0===t[o].length;if(r&&!n&&(h="greedy"===r?""===t[o].join("").trim():1===t[o].length&&0===t[o][0].length),"greedy"===r&&n){for(var d=[],l=0;l<u;l++){var c=s?e[l]:l;d.push(t[o][c]);}h=""===d.join("").trim();}if(!h){for(var p=0;p<u;p++){0<p&&!f&&(i+=m);var g=n&&s?e[p]:p;i+=v(t[o][g],p);}o<t.length-1&&(!r||0<u&&!f)&&(i+=y);}}return i}function v(e,t){if(null==e)return "";if(e.constructor===Date)return JSON.stringify(e).slice(1,25);var r=!1;o&&"string"==typeof e&&o.test(e)&&(e="'"+e,r=!0);var i=e.toString().replace(u,a);return (r=r||!0===n||"function"==typeof n&&n(e,t)||Array.isArray(n)&&n[t]||function(e,t){for(var r=0;r<t.length;r++)if(-1<e.indexOf(t[r]))return !0;return !1}(i,b.BAD_DELIMITERS)||-1<i.indexOf(m)||" "===i.charAt(0)||" "===i.charAt(i.length-1))?s+i+s:i}}};if(b.RECORD_SEP=String.fromCharCode(30),b.UNIT_SEP=String.fromCharCode(31),b.BYTE_ORDER_MARK="\ufeff",b.BAD_DELIMITERS=["\r","\n",'"',b.BYTE_ORDER_MARK],b.WORKERS_SUPPORTED=!n&&!!f.Worker,b.NODE_STREAM_INPUT=1,b.LocalChunkSize=10485760,b.RemoteChunkSize=5242880,b.DefaultDelimiter=",",b.Parser=E,b.ParserHandle=r,b.NetworkStreamer=l,b.FileStreamer=c,b.StringStreamer=p,b.ReadableStreamStreamer=g,f.jQuery){var d=f.jQuery;d.fn.parse=function(o){var r=o.config||{},u=[];return this.each(function(e){if(!("INPUT"===d(this).prop("tagName").toUpperCase()&&"file"===d(this).attr("type").toLowerCase()&&f.FileReader)||!this.files||0===this.files.length)return !0;for(var t=0;t<this.files.length;t++)u.push({file:this.files[t],inputElem:this,instanceConfig:d.extend({},r)});}),e(),this;function e(){if(0!==u.length){var e,t,r,i,n=u[0];if(J(o.before)){var s=o.before(n.file,n.inputElem);if("object"==typeof s){if("abort"===s.action)return e="AbortError",t=n.file,r=n.inputElem,i=s.reason,void(J(o.error)&&o.error({name:e},t,r,i));if("skip"===s.action)return void h();"object"==typeof s.config&&(n.instanceConfig=d.extend(n.instanceConfig,s.config));}else if("skip"===s)return void h()}var a=n.instanceConfig.complete;n.instanceConfig.complete=function(e){J(a)&&a(e,n.file,n.inputElem),h();},b.parse(n.file,n.instanceConfig);}else J(o.complete)&&o.complete();}function h(){u.splice(0,1),e();}};}function h(e){this._handle=null,this._finished=!1,this._completed=!1,this._halted=!1,this._input=null,this._baseIndex=0,this._partialLine="",this._rowCount=0,this._start=0,this._nextChunk=null,this.isFirstChunk=!0,this._completeResults={data:[],errors:[],meta:{}},function(e){var t=w(e);t.chunkSize=parseInt(t.chunkSize),e.step||e.chunk||(t.chunkSize=null);this._handle=new r(t),(this._handle.streamer=this)._config=t;}.call(this,e),this.parseChunk=function(e,t){if(this.isFirstChunk&&J(this._config.beforeFirstChunk)){var r=this._config.beforeFirstChunk(e);void 0!==r&&(e=r);}this.isFirstChunk=!1,this._halted=!1;var i=this._partialLine+e;this._partialLine="";var n=this._handle.parse(i,this._baseIndex,!this._finished);if(!this._handle.paused()&&!this._handle.aborted()){var s=n.meta.cursor;this._finished||(this._partialLine=i.substring(s-this._baseIndex),this._baseIndex=s),n&&n.data&&(this._rowCount+=n.data.length);var a=this._finished||this._config.preview&&this._rowCount>=this._config.preview;if(o)f.postMessage({results:n,workerId:b.WORKER_ID,finished:a});else if(J(this._config.chunk)&&!t){if(this._config.chunk(n,this._handle),this._handle.paused()||this._handle.aborted())return void(this._halted=!0);n=void 0,this._completeResults=void 0;}return this._config.step||this._config.chunk||(this._completeResults.data=this._completeResults.data.concat(n.data),this._completeResults.errors=this._completeResults.errors.concat(n.errors),this._completeResults.meta=n.meta),this._completed||!a||!J(this._config.complete)||n&&n.meta.aborted||(this._config.complete(this._completeResults,this._input),this._completed=!0),a||n&&n.meta.paused||this._nextChunk(),n}this._halted=!0;},this._sendError=function(e){J(this._config.error)?this._config.error(e):o&&this._config.error&&f.postMessage({workerId:b.WORKER_ID,error:e,finished:!1});};}function l(e){var i;(e=e||{}).chunkSize||(e.chunkSize=b.RemoteChunkSize),h.call(this,e),this._nextChunk=n?function(){this._readChunk(),this._chunkLoaded();}:function(){this._readChunk();},this.stream=function(e){this._input=e,this._nextChunk();},this._readChunk=function(){if(this._finished)this._chunkLoaded();else {if(i=new XMLHttpRequest,this._config.withCredentials&&(i.withCredentials=this._config.withCredentials),n||(i.onload=v(this._chunkLoaded,this),i.onerror=v(this._chunkError,this)),i.open(this._config.downloadRequestBody?"POST":"GET",this._input,!n),this._config.downloadRequestHeaders){var e=this._config.downloadRequestHeaders;for(var t in e)i.setRequestHeader(t,e[t]);}if(this._config.chunkSize){var r=this._start+this._config.chunkSize-1;i.setRequestHeader("Range","bytes="+this._start+"-"+r);}try{i.send(this._config.downloadRequestBody);}catch(e){this._chunkError(e.message);}n&&0===i.status&&this._chunkError();}},this._chunkLoaded=function(){4===i.readyState&&(i.status<200||400<=i.status?this._chunkError():(this._start+=this._config.chunkSize?this._config.chunkSize:i.responseText.length,this._finished=!this._config.chunkSize||this._start>=function(e){var t=e.getResponseHeader("Content-Range");if(null===t)return -1;return parseInt(t.substring(t.lastIndexOf("/")+1))}(i),this.parseChunk(i.responseText)));},this._chunkError=function(e){var t=i.statusText||e;this._sendError(new Error(t));};}function c(e){var i,n;(e=e||{}).chunkSize||(e.chunkSize=b.LocalChunkSize),h.call(this,e);var s="undefined"!=typeof FileReader;this.stream=function(e){this._input=e,n=e.slice||e.webkitSlice||e.mozSlice,s?((i=new FileReader).onload=v(this._chunkLoaded,this),i.onerror=v(this._chunkError,this)):i=new FileReaderSync,this._nextChunk();},this._nextChunk=function(){this._finished||this._config.preview&&!(this._rowCount<this._config.preview)||this._readChunk();},this._readChunk=function(){var e=this._input;if(this._config.chunkSize){var t=Math.min(this._start+this._config.chunkSize,this._input.size);e=n.call(e,this._start,t);}var r=i.readAsText(e,this._config.encoding);s||this._chunkLoaded({target:{result:r}});},this._chunkLoaded=function(e){this._start+=this._config.chunkSize,this._finished=!this._config.chunkSize||this._start>=this._input.size,this.parseChunk(e.target.result);},this._chunkError=function(){this._sendError(i.error);};}function p(e){var r;h.call(this,e=e||{}),this.stream=function(e){return r=e,this._nextChunk()},this._nextChunk=function(){if(!this._finished){var e,t=this._config.chunkSize;return t?(e=r.substring(0,t),r=r.substring(t)):(e=r,r=""),this._finished=!r,this.parseChunk(e)}};}function g(e){h.call(this,e=e||{});var t=[],r=!0,i=!1;this.pause=function(){h.prototype.pause.apply(this,arguments),this._input.pause();},this.resume=function(){h.prototype.resume.apply(this,arguments),this._input.resume();},this.stream=function(e){this._input=e,this._input.on("data",this._streamData),this._input.on("end",this._streamEnd),this._input.on("error",this._streamError);},this._checkIsFinished=function(){i&&1===t.length&&(this._finished=!0);},this._nextChunk=function(){this._checkIsFinished(),t.length?this.parseChunk(t.shift()):r=!0;},this._streamData=v(function(e){try{t.push("string"==typeof e?e:e.toString(this._config.encoding)),r&&(r=!1,this._checkIsFinished(),this.parseChunk(t.shift()));}catch(e){this._streamError(e);}},this),this._streamError=v(function(e){this._streamCleanUp(),this._sendError(e);},this),this._streamEnd=v(function(){this._streamCleanUp(),i=!0,this._streamData("");},this),this._streamCleanUp=v(function(){this._input.removeListener("data",this._streamData),this._input.removeListener("end",this._streamEnd),this._input.removeListener("error",this._streamError);},this);}function r(m){var a,o,u,i=Math.pow(2,53),n=-i,s=/^\s*-?(\d+\.?|\.\d+|\d+\.\d+)([eE][-+]?\d+)?\s*$/,h=/^((\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z))|(\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d([+-][0-2]\d:[0-5]\d|Z)))$/,t=this,r=0,f=0,d=!1,e=!1,l=[],c={data:[],errors:[],meta:{}};if(J(m.step)){var p=m.step;m.step=function(e){if(c=e,_())g();else {if(g(),0===c.data.length)return;r+=e.data.length,m.preview&&r>m.preview?o.abort():(c.data=c.data[0],p(c,t));}};}function y(e){return "greedy"===m.skipEmptyLines?""===e.join("").trim():1===e.length&&0===e[0].length}function g(){return c&&u&&(k("Delimiter","UndetectableDelimiter","Unable to auto-detect delimiting character; defaulted to '"+b.DefaultDelimiter+"'"),u=!1),m.skipEmptyLines&&(c.data=c.data.filter(function(e){return !y(e)})),_()&&function(){if(!c)return;function e(e,t){J(m.transformHeader)&&(e=m.transformHeader(e,t)),l.push(e);}if(Array.isArray(c.data[0])){for(var t=0;_()&&t<c.data.length;t++)c.data[t].forEach(e);c.data.splice(0,1);}else c.data.forEach(e);}(),function(){if(!c||!m.header&&!m.dynamicTyping&&!m.transform)return c;function e(e,t){var r,i=m.header?{}:[];for(r=0;r<e.length;r++){var n=r,s=e[r];m.header&&(n=r>=l.length?"__parsed_extra":l[r]),m.transform&&(s=m.transform(s,n)),s=v(n,s),"__parsed_extra"===n?(i[n]=i[n]||[],i[n].push(s)):i[n]=s;}return m.header&&(r>l.length?k("FieldMismatch","TooManyFields","Too many fields: expected "+l.length+" fields but parsed "+r,f+t):r<l.length&&k("FieldMismatch","TooFewFields","Too few fields: expected "+l.length+" fields but parsed "+r,f+t)),i}var t=1;!c.data.length||Array.isArray(c.data[0])?(c.data=c.data.map(e),t=c.data.length):c.data=e(c.data,0);m.header&&c.meta&&(c.meta.fields=l);return f+=t,c}()}function _(){return m.header&&0===l.length}function v(e,t){return r=e,m.dynamicTypingFunction&&void 0===m.dynamicTyping[r]&&(m.dynamicTyping[r]=m.dynamicTypingFunction(r)),!0===(m.dynamicTyping[r]||m.dynamicTyping)?"true"===t||"TRUE"===t||"false"!==t&&"FALSE"!==t&&(function(e){if(s.test(e)){var t=parseFloat(e);if(n<t&&t<i)return !0}return !1}(t)?parseFloat(t):h.test(t)?new Date(t):""===t?null:t):t;var r;}function k(e,t,r,i){var n={type:e,code:t,message:r};void 0!==i&&(n.row=i),c.errors.push(n);}this.parse=function(e,t,r){var i=m.quoteChar||'"';if(m.newline||(m.newline=function(e,t){e=e.substring(0,1048576);var r=new RegExp(Q(t)+"([^]*?)"+Q(t),"gm"),i=(e=e.replace(r,"")).split("\r"),n=e.split("\n"),s=1<n.length&&n[0].length<i[0].length;if(1===i.length||s)return "\n";for(var a=0,o=0;o<i.length;o++)"\n"===i[o][0]&&a++;return a>=i.length/2?"\r\n":"\r"}(e,i)),u=!1,m.delimiter)J(m.delimiter)&&(m.delimiter=m.delimiter(e),c.meta.delimiter=m.delimiter);else {var n=function(e,t,r,i,n){var s,a,o,u;n=n||[",","\t","|",";",b.RECORD_SEP,b.UNIT_SEP];for(var h=0;h<n.length;h++){var f=n[h],d=0,l=0,c=0;o=void 0;for(var p=new E({comments:i,delimiter:f,newline:t,preview:10}).parse(e),g=0;g<p.data.length;g++)if(r&&y(p.data[g]))c++;else {var _=p.data[g].length;l+=_,void 0!==o?0<_&&(d+=Math.abs(_-o),o=_):o=_;}0<p.data.length&&(l/=p.data.length-c),(void 0===a||d<=a)&&(void 0===u||u<l)&&1.99<l&&(a=d,s=f,u=l);}return {successful:!!(m.delimiter=s),bestDelimiter:s}}(e,m.newline,m.skipEmptyLines,m.comments,m.delimitersToGuess);n.successful?m.delimiter=n.bestDelimiter:(u=!0,m.delimiter=b.DefaultDelimiter),c.meta.delimiter=m.delimiter;}var s=w(m);return m.preview&&m.header&&s.preview++,a=e,o=new E(s),c=o.parse(a,t,r),g(),d?{meta:{paused:!0}}:c||{meta:{paused:!1}}},this.paused=function(){return d},this.pause=function(){d=!0,o.abort(),a=J(m.chunk)?"":a.substring(o.getCharIndex());},this.resume=function(){t.streamer._halted?(d=!1,t.streamer.parseChunk(a,!0)):setTimeout(t.resume,3);},this.aborted=function(){return e},this.abort=function(){e=!0,o.abort(),c.meta.aborted=!0,J(m.complete)&&m.complete(c),a="";};}function Q(e){return e.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}function E(j){var z,M=(j=j||{}).delimiter,P=j.newline,U=j.comments,q=j.step,N=j.preview,B=j.fastMode,K=z=void 0===j.quoteChar||null===j.quoteChar?'"':j.quoteChar;if(void 0!==j.escapeChar&&(K=j.escapeChar),("string"!=typeof M||-1<b.BAD_DELIMITERS.indexOf(M))&&(M=","),U===M)throw new Error("Comment character same as delimiter");!0===U?U="#":("string"!=typeof U||-1<b.BAD_DELIMITERS.indexOf(U))&&(U=!1),"\n"!==P&&"\r"!==P&&"\r\n"!==P&&(P="\n");var W=0,H=!1;this.parse=function(i,t,r){if("string"!=typeof i)throw new Error("Input must be a string");var n=i.length,e=M.length,s=P.length,a=U.length,o=J(q),u=[],h=[],f=[],d=W=0;if(!i)return L();if(j.header&&!t){var l=i.split(P)[0].split(M),c=[],p={},g=!1;for(var _ in l){var m=l[_];J(j.transformHeader)&&(m=j.transformHeader(m,_));var y=m,v=p[m]||0;for(0<v&&(g=!0,y=m+"_"+v),p[m]=v+1;c.includes(y);)y=y+"_"+v;c.push(y);}if(g){var k=i.split(P);k[0]=c.join(M),i=k.join(P);}}if(B||!1!==B&&-1===i.indexOf(z)){for(var b=i.split(P),E=0;E<b.length;E++){if(f=b[E],W+=f.length,E!==b.length-1)W+=P.length;else if(r)return L();if(!U||f.substring(0,a)!==U){if(o){if(u=[],I(f.split(M)),F(),H)return L()}else I(f.split(M));if(N&&N<=E)return u=u.slice(0,N),L(!0)}}return L()}for(var w=i.indexOf(M,W),R=i.indexOf(P,W),C=new RegExp(Q(K)+Q(z),"g"),S=i.indexOf(z,W);;)if(i[W]!==z)if(U&&0===f.length&&i.substring(W,W+a)===U){if(-1===R)return L();W=R+s,R=i.indexOf(P,W),w=i.indexOf(M,W);}else if(-1!==w&&(w<R||-1===R))f.push(i.substring(W,w)),W=w+e,w=i.indexOf(M,W);else {if(-1===R)break;if(f.push(i.substring(W,R)),D(R+s),o&&(F(),H))return L();if(N&&u.length>=N)return L(!0)}else for(S=W,W++;;){if(-1===(S=i.indexOf(z,S+1)))return r||h.push({type:"Quotes",code:"MissingQuotes",message:"Quoted field unterminated",row:u.length,index:W}),T();if(S===n-1)return T(i.substring(W,S).replace(C,z));if(z!==K||i[S+1]!==K){if(z===K||0===S||i[S-1]!==K){-1!==w&&w<S+1&&(w=i.indexOf(M,S+1)),-1!==R&&R<S+1&&(R=i.indexOf(P,S+1));var O=A(-1===R?w:Math.min(w,R));if(i.substr(S+1+O,e)===M){f.push(i.substring(W,S).replace(C,z)),i[W=S+1+O+e]!==z&&(S=i.indexOf(z,W)),w=i.indexOf(M,W),R=i.indexOf(P,W);break}var x=A(R);if(i.substring(S+1+x,S+1+x+s)===P){if(f.push(i.substring(W,S).replace(C,z)),D(S+1+x+s),w=i.indexOf(M,W),S=i.indexOf(z,W),o&&(F(),H))return L();if(N&&u.length>=N)return L(!0);break}h.push({type:"Quotes",code:"InvalidQuotes",message:"Trailing quote on quoted field is malformed",row:u.length,index:W}),S++;}}else S++;}return T();function I(e){u.push(e),d=W;}function A(e){var t=0;if(-1!==e){var r=i.substring(S+1,e);r&&""===r.trim()&&(t=r.length);}return t}function T(e){return r||(void 0===e&&(e=i.substring(W)),f.push(e),W=n,I(f),o&&F()),L()}function D(e){W=e,I(f),f=[],R=i.indexOf(P,W);}function L(e){return {data:u,errors:h,meta:{delimiter:M,linebreak:P,aborted:H,truncated:!!e,cursor:d+(t||0)}}}function F(){q(L()),u=[],h=[];}},this.abort=function(){H=!0;},this.getCharIndex=function(){return W};}function _(e){var t=e.data,r=a[t.workerId],i=!1;if(t.error)r.userError(t.error,t.file);else if(t.results&&t.results.data){var n={abort:function(){i=!0,m(t.workerId,{data:[],errors:[],meta:{aborted:!0}});},pause:y,resume:y};if(J(r.userStep)){for(var s=0;s<t.results.data.length&&(r.userStep({data:t.results.data[s],errors:t.results.errors,meta:t.results.meta},n),!i);s++);delete t.results;}else J(r.userChunk)&&(r.userChunk(t.results,n,t.file),delete t.results);}t.finished&&!i&&m(t.workerId,t.results);}function m(e,t){var r=a[e];J(r.userComplete)&&r.userComplete(t),r.terminate(),delete a[e];}function y(){throw new Error("Not implemented.")}function w(e){if("object"!=typeof e||null===e)return e;var t=Array.isArray(e)?[]:{};for(var r in e)t[r]=w(e[r]);return t}function v(e,t){return function(){e.apply(t,arguments);}}function J(e){return "function"==typeof e}return o&&(f.onmessage=function(e){var t=e.data;void 0===b.WORKER_ID&&t&&(b.WORKER_ID=t.workerId);if("string"==typeof t.input)f.postMessage({workerId:b.WORKER_ID,results:b.parse(t.input,t.config),finished:!0});else if(f.File&&t.input instanceof File||t.input instanceof Object){var r=b.parse(t.input,t.config);r&&f.postMessage({workerId:b.WORKER_ID,results:r,finished:!0});}}),(l.prototype=Object.create(h.prototype)).constructor=l,(c.prototype=Object.create(h.prototype)).constructor=c,(p.prototype=Object.create(p.prototype)).constructor=p,(g.prototype=Object.create(h.prototype)).constructor=g,b}); 
} (papaparse_min));

var papaparse_minExports = papaparse_min.exports;
const Papa = /*@__PURE__*/getDefaultExportFromCjs(papaparse_minExports);

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * This program is based on JZlib 1.0.2 ymnk, JCraft,Inc.
 * JZlib is based on zlib-1.1.3, so all credit should go authors
 * Jean-loup Gailly(jloup@gzip.org) and Mark Adler(madler@alumni.caltech.edu)
 * and contributors of zlib.
 */

// deno-lint-ignore-file no-this-alias prefer-const

// Global

const MAX_BITS$1 = 15;
const D_CODES = 30;
const BL_CODES = 19;

const LENGTH_CODES = 29;
const LITERALS = 256;
const L_CODES = (LITERALS + 1 + LENGTH_CODES);
const HEAP_SIZE = (2 * L_CODES + 1);

const END_BLOCK = 256;

// Bit length codes must not exceed MAX_BL_BITS bits
const MAX_BL_BITS = 7;

// repeat previous bit length 3-6 times (2 bits of repeat count)
const REP_3_6 = 16;

// repeat a zero length 3-10 times (3 bits of repeat count)
const REPZ_3_10 = 17;

// repeat a zero length 11-138 times (7 bits of repeat count)
const REPZ_11_138 = 18;

// The lengths of the bit length codes are sent in order of decreasing
// probability, to avoid transmitting the lengths for unused bit
// length codes.

const Buf_size = 8 * 2;

// JZlib version : "1.0.2"
const Z_DEFAULT_COMPRESSION = -1;

// compression strategy
const Z_FILTERED = 1;
const Z_HUFFMAN_ONLY = 2;
const Z_DEFAULT_STRATEGY = 0;

const Z_NO_FLUSH$1 = 0;
const Z_PARTIAL_FLUSH = 1;
const Z_FULL_FLUSH = 3;
const Z_FINISH$1 = 4;

const Z_OK$1 = 0;
const Z_STREAM_END$1 = 1;
const Z_NEED_DICT$1 = 2;
const Z_STREAM_ERROR$1 = -2;
const Z_DATA_ERROR$1 = -3;
const Z_BUF_ERROR$1 = -5;

// Tree

function extractArray(array) {
	return flatArray(array.map(([length, value]) => (new Array(length)).fill(value, 0, length)));
}

function flatArray(array) {
	return array.reduce((a, b) => a.concat(Array.isArray(b) ? flatArray(b) : b), []);
}

// see definition of array dist_code below
const _dist_code = [0, 1, 2, 3].concat(...extractArray([
	[2, 4], [2, 5], [4, 6], [4, 7], [8, 8], [8, 9], [16, 10], [16, 11], [32, 12], [32, 13], [64, 14], [64, 15], [2, 0], [1, 16],
	[1, 17], [2, 18], [2, 19], [4, 20], [4, 21], [8, 22], [8, 23], [16, 24], [16, 25], [32, 26], [32, 27], [64, 28], [64, 29]
]));

function Tree() {
	const that = this;

	// dyn_tree; // the dynamic tree
	// max_code; // largest code with non zero frequency
	// stat_desc; // the corresponding static tree

	// Compute the optimal bit lengths for a tree and update the total bit
	// length
	// for the current block.
	// IN assertion: the fields freq and dad are set, heap[heap_max] and
	// above are the tree nodes sorted by increasing frequency.
	// OUT assertions: the field len is set to the optimal bit length, the
	// array bl_count contains the frequencies for each bit length.
	// The length opt_len is updated; static_len is also updated if stree is
	// not null.
	function gen_bitlen(s) {
		const tree = that.dyn_tree;
		const stree = that.stat_desc.static_tree;
		const extra = that.stat_desc.extra_bits;
		const base = that.stat_desc.extra_base;
		const max_length = that.stat_desc.max_length;
		let h; // heap index
		let n, m; // iterate over the tree elements
		let bits; // bit length
		let xbits; // extra bits
		let f; // frequency
		let overflow = 0; // number of elements with bit length too large

		for (bits = 0; bits <= MAX_BITS$1; bits++)
			s.bl_count[bits] = 0;

		// In a first pass, compute the optimal bit lengths (which may
		// overflow in the case of the bit length tree).
		tree[s.heap[s.heap_max] * 2 + 1] = 0; // root of the heap

		for (h = s.heap_max + 1; h < HEAP_SIZE; h++) {
			n = s.heap[h];
			bits = tree[tree[n * 2 + 1] * 2 + 1] + 1;
			if (bits > max_length) {
				bits = max_length;
				overflow++;
			}
			tree[n * 2 + 1] = bits;
			// We overwrite tree[n*2+1] which is no longer needed

			if (n > that.max_code)
				continue; // not a leaf node

			s.bl_count[bits]++;
			xbits = 0;
			if (n >= base)
				xbits = extra[n - base];
			f = tree[n * 2];
			s.opt_len += f * (bits + xbits);
			if (stree)
				s.static_len += f * (stree[n * 2 + 1] + xbits);
		}
		if (overflow === 0)
			return;

		// This happens for example on obj2 and pic of the Calgary corpus
		// Find the first bit length which could increase:
		do {
			bits = max_length - 1;
			while (s.bl_count[bits] === 0)
				bits--;
			s.bl_count[bits]--; // move one leaf down the tree
			s.bl_count[bits + 1] += 2; // move one overflow item as its brother
			s.bl_count[max_length]--;
			// The brother of the overflow item also moves one step up,
			// but this does not affect bl_count[max_length]
			overflow -= 2;
		} while (overflow > 0);

		for (bits = max_length; bits !== 0; bits--) {
			n = s.bl_count[bits];
			while (n !== 0) {
				m = s.heap[--h];
				if (m > that.max_code)
					continue;
				if (tree[m * 2 + 1] != bits) {
					s.opt_len += (bits - tree[m * 2 + 1]) * tree[m * 2];
					tree[m * 2 + 1] = bits;
				}
				n--;
			}
		}
	}

	// Reverse the first len bits of a code, using straightforward code (a
	// faster
	// method would use a table)
	// IN assertion: 1 <= len <= 15
	function bi_reverse(code, // the value to invert
		len // its bit length
	) {
		let res = 0;
		do {
			res |= code & 1;
			code >>>= 1;
			res <<= 1;
		} while (--len > 0);
		return res >>> 1;
	}

	// Generate the codes for a given tree and bit counts (which need not be
	// optimal).
	// IN assertion: the array bl_count contains the bit length statistics for
	// the given tree and the field len is set for all tree elements.
	// OUT assertion: the field code is set for all tree elements of non
	// zero code length.
	function gen_codes(tree, // the tree to decorate
		max_code, // largest code with non zero frequency
		bl_count // number of codes at each bit length
	) {
		const next_code = []; // next code value for each
		// bit length
		let code = 0; // running code value
		let bits; // bit index
		let n; // code index
		let len;

		// The distribution counts are first used to generate the code values
		// without bit reversal.
		for (bits = 1; bits <= MAX_BITS$1; bits++) {
			next_code[bits] = code = ((code + bl_count[bits - 1]) << 1);
		}

		// Check that the bit counts in bl_count are consistent. The last code
		// must be all ones.
		// Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
		// "inconsistent bit counts");
		// Tracev((stderr,"gen_codes: max_code %d ", max_code));

		for (n = 0; n <= max_code; n++) {
			len = tree[n * 2 + 1];
			if (len === 0)
				continue;
			// Now reverse the bits
			tree[n * 2] = bi_reverse(next_code[len]++, len);
		}
	}

	// Construct one Huffman tree and assigns the code bit strings and lengths.
	// Update the total bit length for the current block.
	// IN assertion: the field freq is set for all tree elements.
	// OUT assertions: the fields len and code are set to the optimal bit length
	// and corresponding code. The length opt_len is updated; static_len is
	// also updated if stree is not null. The field max_code is set.
	that.build_tree = function (s) {
		const tree = that.dyn_tree;
		const stree = that.stat_desc.static_tree;
		const elems = that.stat_desc.elems;
		let n, m; // iterate over heap elements
		let max_code = -1; // largest code with non zero frequency
		let node; // new node being created

		// Construct the initial heap, with least frequent element in
		// heap[1]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
		// heap[0] is not used.
		s.heap_len = 0;
		s.heap_max = HEAP_SIZE;

		for (n = 0; n < elems; n++) {
			if (tree[n * 2] !== 0) {
				s.heap[++s.heap_len] = max_code = n;
				s.depth[n] = 0;
			} else {
				tree[n * 2 + 1] = 0;
			}
		}

		// The pkzip format requires that at least one distance code exists,
		// and that at least one bit should be sent even if there is only one
		// possible code. So to avoid special checks later on we force at least
		// two codes of non zero frequency.
		while (s.heap_len < 2) {
			node = s.heap[++s.heap_len] = max_code < 2 ? ++max_code : 0;
			tree[node * 2] = 1;
			s.depth[node] = 0;
			s.opt_len--;
			if (stree)
				s.static_len -= stree[node * 2 + 1];
			// node is 0 or 1 so it does not have extra bits
		}
		that.max_code = max_code;

		// The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
		// establish sub-heaps of increasing lengths:

		for (n = Math.floor(s.heap_len / 2); n >= 1; n--)
			s.pqdownheap(tree, n);

		// Construct the Huffman tree by repeatedly combining the least two
		// frequent nodes.

		node = elems; // next internal node of the tree
		do {
			// n = node of least frequency
			n = s.heap[1];
			s.heap[1] = s.heap[s.heap_len--];
			s.pqdownheap(tree, 1);
			m = s.heap[1]; // m = node of next least frequency

			s.heap[--s.heap_max] = n; // keep the nodes sorted by frequency
			s.heap[--s.heap_max] = m;

			// Create a new node father of n and m
			tree[node * 2] = (tree[n * 2] + tree[m * 2]);
			s.depth[node] = Math.max(s.depth[n], s.depth[m]) + 1;
			tree[n * 2 + 1] = tree[m * 2 + 1] = node;

			// and insert the new node in the heap
			s.heap[1] = node++;
			s.pqdownheap(tree, 1);
		} while (s.heap_len >= 2);

		s.heap[--s.heap_max] = s.heap[1];

		// At this point, the fields freq and dad are set. We can now
		// generate the bit lengths.

		gen_bitlen(s);

		// The field len is now set, we can generate the bit codes
		gen_codes(tree, that.max_code, s.bl_count);
	};

}

Tree._length_code = [0, 1, 2, 3, 4, 5, 6, 7].concat(...extractArray([
	[2, 8], [2, 9], [2, 10], [2, 11], [4, 12], [4, 13], [4, 14], [4, 15], [8, 16], [8, 17], [8, 18], [8, 19],
	[16, 20], [16, 21], [16, 22], [16, 23], [32, 24], [32, 25], [32, 26], [31, 27], [1, 28]]));

Tree.base_length = [0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 12, 14, 16, 20, 24, 28, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 0];

Tree.base_dist = [0, 1, 2, 3, 4, 6, 8, 12, 16, 24, 32, 48, 64, 96, 128, 192, 256, 384, 512, 768, 1024, 1536, 2048, 3072, 4096, 6144, 8192, 12288, 16384,
	24576];

// Mapping from a distance to a distance code. dist is the distance - 1 and
// must not have side effects. _dist_code[256] and _dist_code[257] are never
// used.
Tree.d_code = function (dist) {
	return ((dist) < 256 ? _dist_code[dist] : _dist_code[256 + ((dist) >>> 7)]);
};

// extra bits for each length code
Tree.extra_lbits = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0];

// extra bits for each distance code
Tree.extra_dbits = [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13];

// extra bits for each bit length code
Tree.extra_blbits = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 7];

Tree.bl_order = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];

// StaticTree

function StaticTree(static_tree, extra_bits, extra_base, elems, max_length) {
	const that = this;
	that.static_tree = static_tree;
	that.extra_bits = extra_bits;
	that.extra_base = extra_base;
	that.elems = elems;
	that.max_length = max_length;
}

const static_ltree2_first_part = [12, 140, 76, 204, 44, 172, 108, 236, 28, 156, 92, 220, 60, 188, 124, 252, 2, 130, 66, 194, 34, 162, 98, 226, 18, 146, 82,
	210, 50, 178, 114, 242, 10, 138, 74, 202, 42, 170, 106, 234, 26, 154, 90, 218, 58, 186, 122, 250, 6, 134, 70, 198, 38, 166, 102, 230, 22, 150, 86,
	214, 54, 182, 118, 246, 14, 142, 78, 206, 46, 174, 110, 238, 30, 158, 94, 222, 62, 190, 126, 254, 1, 129, 65, 193, 33, 161, 97, 225, 17, 145, 81,
	209, 49, 177, 113, 241, 9, 137, 73, 201, 41, 169, 105, 233, 25, 153, 89, 217, 57, 185, 121, 249, 5, 133, 69, 197, 37, 165, 101, 229, 21, 149, 85,
	213, 53, 181, 117, 245, 13, 141, 77, 205, 45, 173, 109, 237, 29, 157, 93, 221, 61, 189, 125, 253, 19, 275, 147, 403, 83, 339, 211, 467, 51, 307,
	179, 435, 115, 371, 243, 499, 11, 267, 139, 395, 75, 331, 203, 459, 43, 299, 171, 427, 107, 363, 235, 491, 27, 283, 155, 411, 91, 347, 219, 475,
	59, 315, 187, 443, 123, 379, 251, 507, 7, 263, 135, 391, 71, 327, 199, 455, 39, 295, 167, 423, 103, 359, 231, 487, 23, 279, 151, 407, 87, 343, 215,
	471, 55, 311, 183, 439, 119, 375, 247, 503, 15, 271, 143, 399, 79, 335, 207, 463, 47, 303, 175, 431, 111, 367, 239, 495, 31, 287, 159, 415, 95,
	351, 223, 479, 63, 319, 191, 447, 127, 383, 255, 511, 0, 64, 32, 96, 16, 80, 48, 112, 8, 72, 40, 104, 24, 88, 56, 120, 4, 68, 36, 100, 20, 84, 52,
	116, 3, 131, 67, 195, 35, 163, 99, 227];
const static_ltree2_second_part = extractArray([[144, 8], [112, 9], [24, 7], [8, 8]]);
StaticTree.static_ltree = flatArray(static_ltree2_first_part.map((value, index) => [value, static_ltree2_second_part[index]]));

const static_dtree_first_part = [0, 16, 8, 24, 4, 20, 12, 28, 2, 18, 10, 26, 6, 22, 14, 30, 1, 17, 9, 25, 5, 21, 13, 29, 3, 19, 11, 27, 7, 23];
const static_dtree_second_part = extractArray([[30, 5]]);
StaticTree.static_dtree = flatArray(static_dtree_first_part.map((value, index) => [value, static_dtree_second_part[index]]));

StaticTree.static_l_desc = new StaticTree(StaticTree.static_ltree, Tree.extra_lbits, LITERALS + 1, L_CODES, MAX_BITS$1);

StaticTree.static_d_desc = new StaticTree(StaticTree.static_dtree, Tree.extra_dbits, 0, D_CODES, MAX_BITS$1);

StaticTree.static_bl_desc = new StaticTree(null, Tree.extra_blbits, 0, BL_CODES, MAX_BL_BITS);

// Deflate

const MAX_MEM_LEVEL = 9;
const DEF_MEM_LEVEL = 8;

function Config(good_length, max_lazy, nice_length, max_chain, func) {
	const that = this;
	that.good_length = good_length;
	that.max_lazy = max_lazy;
	that.nice_length = nice_length;
	that.max_chain = max_chain;
	that.func = func;
}

const STORED$1 = 0;
const FAST = 1;
const SLOW = 2;
const config_table = [
	new Config(0, 0, 0, 0, STORED$1),
	new Config(4, 4, 8, 4, FAST),
	new Config(4, 5, 16, 8, FAST),
	new Config(4, 6, 32, 32, FAST),
	new Config(4, 4, 16, 16, SLOW),
	new Config(8, 16, 32, 32, SLOW),
	new Config(8, 16, 128, 128, SLOW),
	new Config(8, 32, 128, 256, SLOW),
	new Config(32, 128, 258, 1024, SLOW),
	new Config(32, 258, 258, 4096, SLOW)
];

const z_errmsg = ["need dictionary", // Z_NEED_DICT
	// 2
	"stream end", // Z_STREAM_END 1
	"", // Z_OK 0
	"", // Z_ERRNO (-1)
	"stream error", // Z_STREAM_ERROR (-2)
	"data error", // Z_DATA_ERROR (-3)
	"", // Z_MEM_ERROR (-4)
	"buffer error", // Z_BUF_ERROR (-5)
	"",// Z_VERSION_ERROR (-6)
	""];

// block not completed, need more input or more output
const NeedMore = 0;

// block flush performed
const BlockDone = 1;

// finish started, need only more output at next deflate
const FinishStarted = 2;

// finish done, accept no more input or output
const FinishDone = 3;

// preset dictionary flag in zlib header
const PRESET_DICT$1 = 0x20;

const INIT_STATE = 42;
const BUSY_STATE = 113;
const FINISH_STATE = 666;

// The deflate compression method
const Z_DEFLATED$1 = 8;

const STORED_BLOCK = 0;
const STATIC_TREES = 1;
const DYN_TREES = 2;

const MIN_MATCH = 3;
const MAX_MATCH = 258;
const MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

function smaller(tree, n, m, depth) {
	const tn2 = tree[n * 2];
	const tm2 = tree[m * 2];
	return (tn2 < tm2 || (tn2 == tm2 && depth[n] <= depth[m]));
}

function Deflate() {

	const that = this;
	let strm; // pointer back to this zlib stream
	let status; // as the name implies
	// pending_buf; // output still pending
	let pending_buf_size; // size of pending_buf
	// pending_out; // next pending byte to output to the stream
	// pending; // nb of bytes in the pending buffer

	// dist_buf; // buffer for distances
	// lc_buf; // buffer for literals or lengths
	// To simplify the code, dist_buf and lc_buf have the same number of elements.
	// To use different lengths, an extra flag array would be necessary.

	let last_flush; // value of flush param for previous deflate call

	let w_size; // LZ77 win size (32K by default)
	let w_bits; // log2(w_size) (8..16)
	let w_mask; // w_size - 1

	let win;
	// Sliding win. Input bytes are read into the second half of the win,
	// and move to the first half later to keep a dictionary of at least wSize
	// bytes. With this organization, matches are limited to a distance of
	// wSize-MAX_MATCH bytes, but this ensures that IO is always
	// performed with a length multiple of the block size. Also, it limits
	// the win size to 64K, which is quite useful on MSDOS.
	// To do: use the user input buffer as sliding win.

	let window_size;
	// Actual size of win: 2*wSize, except when the user input buffer
	// is directly used as sliding win.

	let prev;
	// Link to older string with same hash index. To limit the size of this
	// array to 64K, this link is maintained only for the last 32K strings.
	// An index in this array is thus a win index modulo 32K.

	let head; // Heads of the hash chains or NIL.

	let ins_h; // hash index of string to be inserted
	let hash_size; // number of elements in hash table
	let hash_bits; // log2(hash_size)
	let hash_mask; // hash_size-1

	// Number of bits by which ins_h must be shifted at each input
	// step. It must be such that after MIN_MATCH steps, the oldest
	// byte no longer takes part in the hash key, that is:
	// hash_shift * MIN_MATCH >= hash_bits
	let hash_shift;

	// Window position at the beginning of the current output block. Gets
	// negative when the win is moved backwards.

	let block_start;

	let match_length; // length of best match
	let prev_match; // previous match
	let match_available; // set if previous match exists
	let strstart; // start of string to insert
	let match_start; // start of matching string
	let lookahead; // number of valid bytes ahead in win

	// Length of the best match at previous step. Matches not greater than this
	// are discarded. This is used in the lazy match evaluation.
	let prev_length;

	// To speed up deflation, hash chains are never searched beyond this
	// length. A higher limit improves compression ratio but degrades the speed.
	let max_chain_length;

	// Attempt to find a better match only when the current match is strictly
	// smaller than this value. This mechanism is used only for compression
	// levels >= 4.
	let max_lazy_match;

	// Insert new strings in the hash table only if the match length is not
	// greater than this length. This saves time but degrades compression.
	// max_insert_length is used only for compression levels <= 3.

	let level; // compression level (1..9)
	let strategy; // favor or force Huffman coding

	// Use a faster search when the previous match is longer than this
	let good_match;

	// Stop searching when current match exceeds this
	let nice_match;

	let dyn_ltree; // literal and length tree
	let dyn_dtree; // distance tree
	let bl_tree; // Huffman tree for bit lengths

	const l_desc = new Tree(); // desc for literal tree
	const d_desc = new Tree(); // desc for distance tree
	const bl_desc = new Tree(); // desc for bit length tree

	// that.heap_len; // number of elements in the heap
	// that.heap_max; // element of largest frequency
	// The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
	// The same heap array is used to build all trees.

	// Depth of each subtree used as tie breaker for trees of equal frequency
	that.depth = [];

	// Size of match buffer for literals/lengths. There are 4 reasons for
	// limiting lit_bufsize to 64K:
	// - frequencies can be kept in 16 bit counters
	// - if compression is not successful for the first block, all input
	// data is still in the win so we can still emit a stored block even
	// when input comes from standard input. (This can also be done for
	// all blocks if lit_bufsize is not greater than 32K.)
	// - if compression is not successful for a file smaller than 64K, we can
	// even emit a stored file instead of a stored block (saving 5 bytes).
	// This is applicable only for zip (not gzip or zlib).
	// - creating new Huffman trees less frequently may not provide fast
	// adaptation to changes in the input data statistics. (Take for
	// example a binary file with poorly compressible code followed by
	// a highly compressible string table.) Smaller buffer sizes give
	// fast adaptation but have of course the overhead of transmitting
	// trees more frequently.
	// - I can't count above 4
	let lit_bufsize;

	let last_lit; // running index in dist_buf and lc_buf

	// that.opt_len; // bit length of current block with optimal trees
	// that.static_len; // bit length of current block with static trees
	let matches; // number of string matches in current block
	let last_eob_len; // bit length of EOB code for last block

	// Output buffer. bits are inserted starting at the bottom (least
	// significant bits).
	let bi_buf;

	// Number of valid bits in bi_buf. All bits above the last valid bit
	// are always zero.
	let bi_valid;

	// number of codes at each bit length for an optimal tree
	that.bl_count = [];

	// heap used to build the Huffman trees
	that.heap = [];

	dyn_ltree = [];
	dyn_dtree = [];
	bl_tree = [];

	function lm_init() {
		window_size = 2 * w_size;

		head[hash_size - 1] = 0;
		for (let i = 0; i < hash_size - 1; i++) {
			head[i] = 0;
		}

		// Set the default configuration parameters:
		max_lazy_match = config_table[level].max_lazy;
		good_match = config_table[level].good_length;
		nice_match = config_table[level].nice_length;
		max_chain_length = config_table[level].max_chain;

		strstart = 0;
		block_start = 0;
		lookahead = 0;
		match_length = prev_length = MIN_MATCH - 1;
		match_available = 0;
		ins_h = 0;
	}

	function init_block() {
		let i;
		// Initialize the trees.
		for (i = 0; i < L_CODES; i++)
			dyn_ltree[i * 2] = 0;
		for (i = 0; i < D_CODES; i++)
			dyn_dtree[i * 2] = 0;
		for (i = 0; i < BL_CODES; i++)
			bl_tree[i * 2] = 0;

		dyn_ltree[END_BLOCK * 2] = 1;
		that.opt_len = that.static_len = 0;
		last_lit = matches = 0;
	}

	// Initialize the tree data structures for a new zlib stream.
	function tr_init() {

		l_desc.dyn_tree = dyn_ltree;
		l_desc.stat_desc = StaticTree.static_l_desc;

		d_desc.dyn_tree = dyn_dtree;
		d_desc.stat_desc = StaticTree.static_d_desc;

		bl_desc.dyn_tree = bl_tree;
		bl_desc.stat_desc = StaticTree.static_bl_desc;

		bi_buf = 0;
		bi_valid = 0;
		last_eob_len = 8; // enough lookahead for inflate

		// Initialize the first block of the first file:
		init_block();
	}

	// Restore the heap property by moving down the tree starting at node k,
	// exchanging a node with the smallest of its two sons if necessary,
	// stopping
	// when the heap property is re-established (each father smaller than its
	// two sons).
	that.pqdownheap = function (tree, // the tree to restore
		k // node to move down
	) {
		const heap = that.heap;
		const v = heap[k];
		let j = k << 1; // left son of k
		while (j <= that.heap_len) {
			// Set j to the smallest of the two sons:
			if (j < that.heap_len && smaller(tree, heap[j + 1], heap[j], that.depth)) {
				j++;
			}
			// Exit if v is smaller than both sons
			if (smaller(tree, v, heap[j], that.depth))
				break;

			// Exchange v with the smallest son
			heap[k] = heap[j];
			k = j;
			// And continue down the tree, setting j to the left son of k
			j <<= 1;
		}
		heap[k] = v;
	};

	// Scan a literal or distance tree to determine the frequencies of the codes
	// in the bit length tree.
	function scan_tree(tree,// the tree to be scanned
		max_code // and its largest code of non zero frequency
	) {
		let prevlen = -1; // last emitted length
		let curlen; // length of current code
		let nextlen = tree[0 * 2 + 1]; // length of next code
		let count = 0; // repeat count of the current code
		let max_count = 7; // max repeat count
		let min_count = 4; // min repeat count

		if (nextlen === 0) {
			max_count = 138;
			min_count = 3;
		}
		tree[(max_code + 1) * 2 + 1] = 0xffff; // guard

		for (let n = 0; n <= max_code; n++) {
			curlen = nextlen;
			nextlen = tree[(n + 1) * 2 + 1];
			if (++count < max_count && curlen == nextlen) {
				continue;
			} else if (count < min_count) {
				bl_tree[curlen * 2] += count;
			} else if (curlen !== 0) {
				if (curlen != prevlen)
					bl_tree[curlen * 2]++;
				bl_tree[REP_3_6 * 2]++;
			} else if (count <= 10) {
				bl_tree[REPZ_3_10 * 2]++;
			} else {
				bl_tree[REPZ_11_138 * 2]++;
			}
			count = 0;
			prevlen = curlen;
			if (nextlen === 0) {
				max_count = 138;
				min_count = 3;
			} else if (curlen == nextlen) {
				max_count = 6;
				min_count = 3;
			} else {
				max_count = 7;
				min_count = 4;
			}
		}
	}

	// Construct the Huffman tree for the bit lengths and return the index in
	// bl_order of the last bit length code to send.
	function build_bl_tree() {
		let max_blindex; // index of last bit length code of non zero freq

		// Determine the bit length frequencies for literal and distance trees
		scan_tree(dyn_ltree, l_desc.max_code);
		scan_tree(dyn_dtree, d_desc.max_code);

		// Build the bit length tree:
		bl_desc.build_tree(that);
		// opt_len now includes the length of the tree representations, except
		// the lengths of the bit lengths codes and the 5+5+4 bits for the
		// counts.

		// Determine the number of bit length codes to send. The pkzip format
		// requires that at least 4 bit length codes be sent. (appnote.txt says
		// 3 but the actual value used is 4.)
		for (max_blindex = BL_CODES - 1; max_blindex >= 3; max_blindex--) {
			if (bl_tree[Tree.bl_order[max_blindex] * 2 + 1] !== 0)
				break;
		}
		// Update opt_len to include the bit length tree and counts
		that.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;

		return max_blindex;
	}

	// Output a byte on the stream.
	// IN assertion: there is enough room in pending_buf.
	function put_byte(p) {
		that.pending_buf[that.pending++] = p;
	}

	function put_short(w) {
		put_byte(w & 0xff);
		put_byte((w >>> 8) & 0xff);
	}

	function putShortMSB(b) {
		put_byte((b >> 8) & 0xff);
		put_byte((b & 0xff) & 0xff);
	}

	function send_bits(value, length) {
		let val;
		const len = length;
		if (bi_valid > Buf_size - len) {
			val = value;
			// bi_buf |= (val << bi_valid);
			bi_buf |= ((val << bi_valid) & 0xffff);
			put_short(bi_buf);
			bi_buf = val >>> (Buf_size - bi_valid);
			bi_valid += len - Buf_size;
		} else {
			// bi_buf |= (value) << bi_valid;
			bi_buf |= (((value) << bi_valid) & 0xffff);
			bi_valid += len;
		}
	}

	function send_code(c, tree) {
		const c2 = c * 2;
		send_bits(tree[c2] & 0xffff, tree[c2 + 1] & 0xffff);
	}

	// Send a literal or distance tree in compressed form, using the codes in
	// bl_tree.
	function send_tree(tree,// the tree to be sent
		max_code // and its largest code of non zero frequency
	) {
		let n; // iterates over all tree elements
		let prevlen = -1; // last emitted length
		let curlen; // length of current code
		let nextlen = tree[0 * 2 + 1]; // length of next code
		let count = 0; // repeat count of the current code
		let max_count = 7; // max repeat count
		let min_count = 4; // min repeat count

		if (nextlen === 0) {
			max_count = 138;
			min_count = 3;
		}

		for (n = 0; n <= max_code; n++) {
			curlen = nextlen;
			nextlen = tree[(n + 1) * 2 + 1];
			if (++count < max_count && curlen == nextlen) {
				continue;
			} else if (count < min_count) {
				do {
					send_code(curlen, bl_tree);
				} while (--count !== 0);
			} else if (curlen !== 0) {
				if (curlen != prevlen) {
					send_code(curlen, bl_tree);
					count--;
				}
				send_code(REP_3_6, bl_tree);
				send_bits(count - 3, 2);
			} else if (count <= 10) {
				send_code(REPZ_3_10, bl_tree);
				send_bits(count - 3, 3);
			} else {
				send_code(REPZ_11_138, bl_tree);
				send_bits(count - 11, 7);
			}
			count = 0;
			prevlen = curlen;
			if (nextlen === 0) {
				max_count = 138;
				min_count = 3;
			} else if (curlen == nextlen) {
				max_count = 6;
				min_count = 3;
			} else {
				max_count = 7;
				min_count = 4;
			}
		}
	}

	// Send the header for a block using dynamic Huffman trees: the counts, the
	// lengths of the bit length codes, the literal tree and the distance tree.
	// IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
	function send_all_trees(lcodes, dcodes, blcodes) {
		let rank; // index in bl_order

		send_bits(lcodes - 257, 5); // not +255 as stated in appnote.txt
		send_bits(dcodes - 1, 5);
		send_bits(blcodes - 4, 4); // not -3 as stated in appnote.txt
		for (rank = 0; rank < blcodes; rank++) {
			send_bits(bl_tree[Tree.bl_order[rank] * 2 + 1], 3);
		}
		send_tree(dyn_ltree, lcodes - 1); // literal tree
		send_tree(dyn_dtree, dcodes - 1); // distance tree
	}

	// Flush the bit buffer, keeping at most 7 bits in it.
	function bi_flush() {
		if (bi_valid == 16) {
			put_short(bi_buf);
			bi_buf = 0;
			bi_valid = 0;
		} else if (bi_valid >= 8) {
			put_byte(bi_buf & 0xff);
			bi_buf >>>= 8;
			bi_valid -= 8;
		}
	}

	// Send one empty static block to give enough lookahead for inflate.
	// This takes 10 bits, of which 7 may remain in the bit buffer.
	// The current inflate code requires 9 bits of lookahead. If the
	// last two codes for the previous block (real code plus EOB) were coded
	// on 5 bits or less, inflate may have only 5+3 bits of lookahead to decode
	// the last real code. In this case we send two empty static blocks instead
	// of one. (There are no problems if the previous block is stored or fixed.)
	// To simplify the code, we assume the worst case of last real code encoded
	// on one bit only.
	function _tr_align() {
		send_bits(STATIC_TREES << 1, 3);
		send_code(END_BLOCK, StaticTree.static_ltree);

		bi_flush();

		// Of the 10 bits for the empty block, we have already sent
		// (10 - bi_valid) bits. The lookahead for the last real code (before
		// the EOB of the previous block) was thus at least one plus the length
		// of the EOB plus what we have just sent of the empty static block.
		if (1 + last_eob_len + 10 - bi_valid < 9) {
			send_bits(STATIC_TREES << 1, 3);
			send_code(END_BLOCK, StaticTree.static_ltree);
			bi_flush();
		}
		last_eob_len = 7;
	}

	// Save the match info and tally the frequency counts. Return true if
	// the current block must be flushed.
	function _tr_tally(dist, // distance of matched string
		lc // match length-MIN_MATCH or unmatched char (if dist==0)
	) {
		let out_length, in_length, dcode;
		that.dist_buf[last_lit] = dist;
		that.lc_buf[last_lit] = lc & 0xff;
		last_lit++;

		if (dist === 0) {
			// lc is the unmatched char
			dyn_ltree[lc * 2]++;
		} else {
			matches++;
			// Here, lc is the match length - MIN_MATCH
			dist--; // dist = match distance - 1
			dyn_ltree[(Tree._length_code[lc] + LITERALS + 1) * 2]++;
			dyn_dtree[Tree.d_code(dist) * 2]++;
		}

		if ((last_lit & 0x1fff) === 0 && level > 2) {
			// Compute an upper bound for the compressed length
			out_length = last_lit * 8;
			in_length = strstart - block_start;
			for (dcode = 0; dcode < D_CODES; dcode++) {
				out_length += dyn_dtree[dcode * 2] * (5 + Tree.extra_dbits[dcode]);
			}
			out_length >>>= 3;
			if ((matches < Math.floor(last_lit / 2)) && out_length < Math.floor(in_length / 2))
				return true;
		}

		return (last_lit == lit_bufsize - 1);
		// We avoid equality with lit_bufsize because of wraparound at 64K
		// on 16 bit machines and because stored blocks are restricted to
		// 64K-1 bytes.
	}

	// Send the block data compressed using the given Huffman trees
	function compress_block(ltree, dtree) {
		let dist; // distance of matched string
		let lc; // match length or unmatched char (if dist === 0)
		let lx = 0; // running index in dist_buf and lc_buf
		let code; // the code to send
		let extra; // number of extra bits to send

		if (last_lit !== 0) {
			do {
				dist = that.dist_buf[lx];
				lc = that.lc_buf[lx];
				lx++;

				if (dist === 0) {
					send_code(lc, ltree); // send a literal byte
				} else {
					// Here, lc is the match length - MIN_MATCH
					code = Tree._length_code[lc];

					send_code(code + LITERALS + 1, ltree); // send the length
					// code
					extra = Tree.extra_lbits[code];
					if (extra !== 0) {
						lc -= Tree.base_length[code];
						send_bits(lc, extra); // send the extra length bits
					}
					dist--; // dist is now the match distance - 1
					code = Tree.d_code(dist);

					send_code(code, dtree); // send the distance code
					extra = Tree.extra_dbits[code];
					if (extra !== 0) {
						dist -= Tree.base_dist[code];
						send_bits(dist, extra); // send the extra distance bits
					}
				} // literal or match pair ?
			} while (lx < last_lit);
		}

		send_code(END_BLOCK, ltree);
		last_eob_len = ltree[END_BLOCK * 2 + 1];
	}

	// Flush the bit buffer and align the output on a byte boundary
	function bi_windup() {
		if (bi_valid > 8) {
			put_short(bi_buf);
		} else if (bi_valid > 0) {
			put_byte(bi_buf & 0xff);
		}
		bi_buf = 0;
		bi_valid = 0;
	}

	// Copy a stored block, storing first the length and its
	// one's complement if requested.
	function copy_block(buf, // the input data
		len, // its length
		header // true if block header must be written
	) {
		bi_windup(); // align on byte boundary
		last_eob_len = 8; // enough lookahead for inflate

		{
			put_short(len);
			put_short(~len);
		}

		that.pending_buf.set(win.subarray(buf, buf + len), that.pending);
		that.pending += len;
	}

	// Send a stored block
	function _tr_stored_block(buf, // input block
		stored_len, // length of input block
		eof // true if this is the last block for a file
	) {
		send_bits((STORED_BLOCK << 1) + (eof ? 1 : 0), 3); // send block type
		copy_block(buf, stored_len); // with header
	}

	// Determine the best encoding for the current block: dynamic trees, static
	// trees or store, and output the encoded block to the zip file.
	function _tr_flush_block(buf, // input block, or NULL if too old
		stored_len, // length of input block
		eof // true if this is the last block for a file
	) {
		let opt_lenb, static_lenb;// opt_len and static_len in bytes
		let max_blindex = 0; // index of last bit length code of non zero freq

		// Build the Huffman trees unless a stored block is forced
		if (level > 0) {
			// Construct the literal and distance trees
			l_desc.build_tree(that);

			d_desc.build_tree(that);

			// At this point, opt_len and static_len are the total bit lengths
			// of
			// the compressed block data, excluding the tree representations.

			// Build the bit length tree for the above two trees, and get the
			// index
			// in bl_order of the last bit length code to send.
			max_blindex = build_bl_tree();

			// Determine the best encoding. Compute first the block length in
			// bytes
			opt_lenb = (that.opt_len + 3 + 7) >>> 3;
			static_lenb = (that.static_len + 3 + 7) >>> 3;

			if (static_lenb <= opt_lenb)
				opt_lenb = static_lenb;
		} else {
			opt_lenb = static_lenb = stored_len + 5; // force a stored block
		}

		if ((stored_len + 4 <= opt_lenb) && buf != -1) {
			// 4: two words for the lengths
			// The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
			// Otherwise we can't have processed more than WSIZE input bytes
			// since
			// the last block flush, because compression would have been
			// successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
			// transform a block into a stored block.
			_tr_stored_block(buf, stored_len, eof);
		} else if (static_lenb == opt_lenb) {
			send_bits((STATIC_TREES << 1) + (eof ? 1 : 0), 3);
			compress_block(StaticTree.static_ltree, StaticTree.static_dtree);
		} else {
			send_bits((DYN_TREES << 1) + (eof ? 1 : 0), 3);
			send_all_trees(l_desc.max_code + 1, d_desc.max_code + 1, max_blindex + 1);
			compress_block(dyn_ltree, dyn_dtree);
		}

		// The above check is made mod 2^32, for files larger than 512 MB
		// and uLong implemented on 32 bits.

		init_block();

		if (eof) {
			bi_windup();
		}
	}

	function flush_block_only(eof) {
		_tr_flush_block(block_start >= 0 ? block_start : -1, strstart - block_start, eof);
		block_start = strstart;
		strm.flush_pending();
	}

	// Fill the win when the lookahead becomes insufficient.
	// Updates strstart and lookahead.
	//
	// IN assertion: lookahead < MIN_LOOKAHEAD
	// OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
	// At least one byte has been read, or avail_in === 0; reads are
	// performed for at least two bytes (required for the zip translate_eol
	// option -- not supported here).
	function fill_window() {
		let n, m;
		let p;
		let more; // Amount of free space at the end of the win.

		do {
			more = (window_size - lookahead - strstart);

			// Deal with !@#$% 64K limit:
			if (more === 0 && strstart === 0 && lookahead === 0) {
				more = w_size;
			} else if (more == -1) {
				// Very unlikely, but possible on 16 bit machine if strstart ==
				// 0
				// and lookahead == 1 (input done one byte at time)
				more--;

				// If the win is almost full and there is insufficient
				// lookahead,
				// move the upper half to the lower one to make room in the
				// upper half.
			} else if (strstart >= w_size + w_size - MIN_LOOKAHEAD) {
				win.set(win.subarray(w_size, w_size + w_size), 0);

				match_start -= w_size;
				strstart -= w_size; // we now have strstart >= MAX_DIST
				block_start -= w_size;

				// Slide the hash table (could be avoided with 32 bit values
				// at the expense of memory usage). We slide even when level ==
				// 0
				// to keep the hash table consistent if we switch back to level
				// > 0
				// later. (Using level 0 permanently is not an optimal usage of
				// zlib, so we don't care about this pathological case.)

				n = hash_size;
				p = n;
				do {
					m = (head[--p] & 0xffff);
					head[p] = (m >= w_size ? m - w_size : 0);
				} while (--n !== 0);

				n = w_size;
				p = n;
				do {
					m = (prev[--p] & 0xffff);
					prev[p] = (m >= w_size ? m - w_size : 0);
					// If n is not on any hash chain, prev[n] is garbage but
					// its value will never be used.
				} while (--n !== 0);
				more += w_size;
			}

			if (strm.avail_in === 0)
				return;

			// If there was no sliding:
			// strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
			// more == window_size - lookahead - strstart
			// => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
			// => more >= window_size - 2*WSIZE + 2
			// In the BIG_MEM or MMAP case (not yet supported),
			// window_size == input_size + MIN_LOOKAHEAD &&
			// strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
			// Otherwise, window_size == 2*WSIZE so more >= 2.
			// If there was sliding, more >= WSIZE. So in all cases, more >= 2.

			n = strm.read_buf(win, strstart + lookahead, more);
			lookahead += n;

			// Initialize the hash value now that we have some input:
			if (lookahead >= MIN_MATCH) {
				ins_h = win[strstart] & 0xff;
				ins_h = (((ins_h) << hash_shift) ^ (win[strstart + 1] & 0xff)) & hash_mask;
			}
			// If the whole input has less than MIN_MATCH bytes, ins_h is
			// garbage,
			// but this is not important since only literal bytes will be
			// emitted.
		} while (lookahead < MIN_LOOKAHEAD && strm.avail_in !== 0);
	}

	// Copy without compression as much as possible from the input stream,
	// return
	// the current block state.
	// This function does not insert new strings in the dictionary since
	// uncompressible data is probably not useful. This function is used
	// only for the level=0 compression option.
	// NOTE: this function should be optimized to avoid extra copying from
	// win to pending_buf.
	function deflate_stored(flush) {
		// Stored blocks are limited to 0xffff bytes, pending_buf is limited
		// to pending_buf_size, and each stored block has a 5 byte header:

		let max_block_size = 0xffff;
		let max_start;

		if (max_block_size > pending_buf_size - 5) {
			max_block_size = pending_buf_size - 5;
		}

		// Copy as much as possible from input to output:
		// eslint-disable-next-line no-constant-condition
		while (true) {
			// Fill the win as much as possible:
			if (lookahead <= 1) {
				fill_window();
				if (lookahead === 0 && flush == Z_NO_FLUSH$1)
					return NeedMore;
				if (lookahead === 0)
					break; // flush the current block
			}

			strstart += lookahead;
			lookahead = 0;

			// Emit a stored block if pending_buf will be full:
			max_start = block_start + max_block_size;
			if (strstart === 0 || strstart >= max_start) {
				// strstart === 0 is possible when wraparound on 16-bit machine
				lookahead = (strstart - max_start);
				strstart = max_start;

				flush_block_only(false);
				if (strm.avail_out === 0)
					return NeedMore;

			}

			// Flush if we may have to slide, otherwise block_start may become
			// negative and the data will be gone:
			if (strstart - block_start >= w_size - MIN_LOOKAHEAD) {
				flush_block_only(false);
				if (strm.avail_out === 0)
					return NeedMore;
			}
		}

		flush_block_only(flush == Z_FINISH$1);
		if (strm.avail_out === 0)
			return (flush == Z_FINISH$1) ? FinishStarted : NeedMore;

		return flush == Z_FINISH$1 ? FinishDone : BlockDone;
	}

	function longest_match(cur_match) {
		let chain_length = max_chain_length; // max hash chain length
		let scan = strstart; // current string
		let match; // matched string
		let len; // length of current match
		let best_len = prev_length; // best match length so far
		const limit = strstart > (w_size - MIN_LOOKAHEAD) ? strstart - (w_size - MIN_LOOKAHEAD) : 0;
		let _nice_match = nice_match;

		// Stop when cur_match becomes <= limit. To simplify the code,
		// we prevent matches with the string of win index 0.

		const wmask = w_mask;

		const strend = strstart + MAX_MATCH;
		let scan_end1 = win[scan + best_len - 1];
		let scan_end = win[scan + best_len];

		// The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of
		// 16.
		// It is easy to get rid of this optimization if necessary.

		// Do not waste too much time if we already have a good match:
		if (prev_length >= good_match) {
			chain_length >>= 2;
		}

		// Do not look for matches beyond the end of the input. This is
		// necessary
		// to make deflate deterministic.
		if (_nice_match > lookahead)
			_nice_match = lookahead;

		do {
			match = cur_match;

			// Skip to next match if the match length cannot increase
			// or if the match length is less than 2:
			if (win[match + best_len] != scan_end || win[match + best_len - 1] != scan_end1 || win[match] != win[scan]
				|| win[++match] != win[scan + 1])
				continue;

			// The check at best_len-1 can be removed because it will be made
			// again later. (This heuristic is not always a win.)
			// It is not necessary to compare scan[2] and match[2] since they
			// are always equal when the other bytes match, given that
			// the hash keys are equal and that HASH_BITS >= 8.
			scan += 2;
			match++;

			// We check for insufficient lookahead only every 8th comparison;
			// the 256th check will be made at strstart+258.
			// eslint-disable-next-line no-empty
			do {
				// empty block
			} while (win[++scan] == win[++match] && win[++scan] == win[++match] && win[++scan] == win[++match]
			&& win[++scan] == win[++match] && win[++scan] == win[++match] && win[++scan] == win[++match]
			&& win[++scan] == win[++match] && win[++scan] == win[++match] && scan < strend);

			len = MAX_MATCH - (strend - scan);
			scan = strend - MAX_MATCH;

			if (len > best_len) {
				match_start = cur_match;
				best_len = len;
				if (len >= _nice_match)
					break;
				scan_end1 = win[scan + best_len - 1];
				scan_end = win[scan + best_len];
			}

		} while ((cur_match = (prev[cur_match & wmask] & 0xffff)) > limit && --chain_length !== 0);

		if (best_len <= lookahead)
			return best_len;
		return lookahead;
	}

	// Compress as much as possible from the input stream, return the current
	// block state.
	// This function does not perform lazy evaluation of matches and inserts
	// new strings in the dictionary only for unmatched strings or for short
	// matches. It is used only for the fast compression options.
	function deflate_fast(flush) {
		// short hash_head = 0; // head of the hash chain
		let hash_head = 0; // head of the hash chain
		let bflush; // set if current block must be flushed

		// eslint-disable-next-line no-constant-condition
		while (true) {
			// Make sure that we always have enough lookahead, except
			// at the end of the input file. We need MAX_MATCH bytes
			// for the next match, plus MIN_MATCH bytes to insert the
			// string following the next match.
			if (lookahead < MIN_LOOKAHEAD) {
				fill_window();
				if (lookahead < MIN_LOOKAHEAD && flush == Z_NO_FLUSH$1) {
					return NeedMore;
				}
				if (lookahead === 0)
					break; // flush the current block
			}

			// Insert the string win[strstart .. strstart+2] in the
			// dictionary, and set hash_head to the head of the hash chain:
			if (lookahead >= MIN_MATCH) {
				ins_h = (((ins_h) << hash_shift) ^ (win[(strstart) + (MIN_MATCH - 1)] & 0xff)) & hash_mask;

				// prev[strstart&w_mask]=hash_head=head[ins_h];
				hash_head = (head[ins_h] & 0xffff);
				prev[strstart & w_mask] = head[ins_h];
				head[ins_h] = strstart;
			}

			// Find the longest match, discarding those <= prev_length.
			// At this point we have always match_length < MIN_MATCH

			if (hash_head !== 0 && ((strstart - hash_head) & 0xffff) <= w_size - MIN_LOOKAHEAD) {
				// To simplify the code, we prevent matches with the string
				// of win index 0 (in particular we have to avoid a match
				// of the string with itself at the start of the input file).
				if (strategy != Z_HUFFMAN_ONLY) {
					match_length = longest_match(hash_head);
				}
				// longest_match() sets match_start
			}
			if (match_length >= MIN_MATCH) {
				// check_match(strstart, match_start, match_length);

				bflush = _tr_tally(strstart - match_start, match_length - MIN_MATCH);

				lookahead -= match_length;

				// Insert new strings in the hash table only if the match length
				// is not too large. This saves time but degrades compression.
				if (match_length <= max_lazy_match && lookahead >= MIN_MATCH) {
					match_length--; // string at strstart already in hash table
					do {
						strstart++;

						ins_h = ((ins_h << hash_shift) ^ (win[(strstart) + (MIN_MATCH - 1)] & 0xff)) & hash_mask;
						// prev[strstart&w_mask]=hash_head=head[ins_h];
						hash_head = (head[ins_h] & 0xffff);
						prev[strstart & w_mask] = head[ins_h];
						head[ins_h] = strstart;

						// strstart never exceeds WSIZE-MAX_MATCH, so there are
						// always MIN_MATCH bytes ahead.
					} while (--match_length !== 0);
					strstart++;
				} else {
					strstart += match_length;
					match_length = 0;
					ins_h = win[strstart] & 0xff;

					ins_h = (((ins_h) << hash_shift) ^ (win[strstart + 1] & 0xff)) & hash_mask;
					// If lookahead < MIN_MATCH, ins_h is garbage, but it does
					// not
					// matter since it will be recomputed at next deflate call.
				}
			} else {
				// No match, output a literal byte

				bflush = _tr_tally(0, win[strstart] & 0xff);
				lookahead--;
				strstart++;
			}
			if (bflush) {

				flush_block_only(false);
				if (strm.avail_out === 0)
					return NeedMore;
			}
		}

		flush_block_only(flush == Z_FINISH$1);
		if (strm.avail_out === 0) {
			if (flush == Z_FINISH$1)
				return FinishStarted;
			else
				return NeedMore;
		}
		return flush == Z_FINISH$1 ? FinishDone : BlockDone;
	}

	// Same as above, but achieves better compression. We use a lazy
	// evaluation for matches: a match is finally adopted only if there is
	// no better match at the next win position.
	function deflate_slow(flush) {
		// short hash_head = 0; // head of hash chain
		let hash_head = 0; // head of hash chain
		let bflush; // set if current block must be flushed
		let max_insert;

		// Process the input block.
		// eslint-disable-next-line no-constant-condition
		while (true) {
			// Make sure that we always have enough lookahead, except
			// at the end of the input file. We need MAX_MATCH bytes
			// for the next match, plus MIN_MATCH bytes to insert the
			// string following the next match.

			if (lookahead < MIN_LOOKAHEAD) {
				fill_window();
				if (lookahead < MIN_LOOKAHEAD && flush == Z_NO_FLUSH$1) {
					return NeedMore;
				}
				if (lookahead === 0)
					break; // flush the current block
			}

			// Insert the string win[strstart .. strstart+2] in the
			// dictionary, and set hash_head to the head of the hash chain:

			if (lookahead >= MIN_MATCH) {
				ins_h = (((ins_h) << hash_shift) ^ (win[(strstart) + (MIN_MATCH - 1)] & 0xff)) & hash_mask;
				// prev[strstart&w_mask]=hash_head=head[ins_h];
				hash_head = (head[ins_h] & 0xffff);
				prev[strstart & w_mask] = head[ins_h];
				head[ins_h] = strstart;
			}

			// Find the longest match, discarding those <= prev_length.
			prev_length = match_length;
			prev_match = match_start;
			match_length = MIN_MATCH - 1;

			if (hash_head !== 0 && prev_length < max_lazy_match && ((strstart - hash_head) & 0xffff) <= w_size - MIN_LOOKAHEAD) {
				// To simplify the code, we prevent matches with the string
				// of win index 0 (in particular we have to avoid a match
				// of the string with itself at the start of the input file).

				if (strategy != Z_HUFFMAN_ONLY) {
					match_length = longest_match(hash_head);
				}
				// longest_match() sets match_start

				if (match_length <= 5 && (strategy == Z_FILTERED || (match_length == MIN_MATCH && strstart - match_start > 4096))) {

					// If prev_match is also MIN_MATCH, match_start is garbage
					// but we will ignore the current match anyway.
					match_length = MIN_MATCH - 1;
				}
			}

			// If there was a match at the previous step and the current
			// match is not better, output the previous match:
			if (prev_length >= MIN_MATCH && match_length <= prev_length) {
				max_insert = strstart + lookahead - MIN_MATCH;
				// Do not insert strings in hash table beyond this.

				// check_match(strstart-1, prev_match, prev_length);

				bflush = _tr_tally(strstart - 1 - prev_match, prev_length - MIN_MATCH);

				// Insert in hash table all strings up to the end of the match.
				// strstart-1 and strstart are already inserted. If there is not
				// enough lookahead, the last two strings are not inserted in
				// the hash table.
				lookahead -= prev_length - 1;
				prev_length -= 2;
				do {
					if (++strstart <= max_insert) {
						ins_h = (((ins_h) << hash_shift) ^ (win[(strstart) + (MIN_MATCH - 1)] & 0xff)) & hash_mask;
						// prev[strstart&w_mask]=hash_head=head[ins_h];
						hash_head = (head[ins_h] & 0xffff);
						prev[strstart & w_mask] = head[ins_h];
						head[ins_h] = strstart;
					}
				} while (--prev_length !== 0);
				match_available = 0;
				match_length = MIN_MATCH - 1;
				strstart++;

				if (bflush) {
					flush_block_only(false);
					if (strm.avail_out === 0)
						return NeedMore;
				}
			} else if (match_available !== 0) {

				// If there was no match at the previous position, output a
				// single literal. If there was a match but the current match
				// is longer, truncate the previous match to a single literal.

				bflush = _tr_tally(0, win[strstart - 1] & 0xff);

				if (bflush) {
					flush_block_only(false);
				}
				strstart++;
				lookahead--;
				if (strm.avail_out === 0)
					return NeedMore;
			} else {
				// There is no previous match to compare with, wait for
				// the next step to decide.

				match_available = 1;
				strstart++;
				lookahead--;
			}
		}

		if (match_available !== 0) {
			bflush = _tr_tally(0, win[strstart - 1] & 0xff);
			match_available = 0;
		}
		flush_block_only(flush == Z_FINISH$1);

		if (strm.avail_out === 0) {
			if (flush == Z_FINISH$1)
				return FinishStarted;
			else
				return NeedMore;
		}

		return flush == Z_FINISH$1 ? FinishDone : BlockDone;
	}

	function deflateReset(strm) {
		strm.total_in = strm.total_out = 0;
		strm.msg = null; //

		that.pending = 0;
		that.pending_out = 0;

		status = BUSY_STATE;

		last_flush = Z_NO_FLUSH$1;

		tr_init();
		lm_init();
		return Z_OK$1;
	}

	that.deflateInit = function (strm, _level, bits, _method, memLevel, _strategy) {
		if (!_method)
			_method = Z_DEFLATED$1;
		if (!memLevel)
			memLevel = DEF_MEM_LEVEL;
		if (!_strategy)
			_strategy = Z_DEFAULT_STRATEGY;

		// byte[] my_version=ZLIB_VERSION;

		//
		// if (!version || version[0] != my_version[0]
		// || stream_size != sizeof(z_stream)) {
		// return Z_VERSION_ERROR;
		// }

		strm.msg = null;

		if (_level == Z_DEFAULT_COMPRESSION)
			_level = 6;

		if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || _method != Z_DEFLATED$1 || bits < 9 || bits > 15 || _level < 0 || _level > 9 || _strategy < 0
			|| _strategy > Z_HUFFMAN_ONLY) {
			return Z_STREAM_ERROR$1;
		}

		strm.dstate = that;

		w_bits = bits;
		w_size = 1 << w_bits;
		w_mask = w_size - 1;

		hash_bits = memLevel + 7;
		hash_size = 1 << hash_bits;
		hash_mask = hash_size - 1;
		hash_shift = Math.floor((hash_bits + MIN_MATCH - 1) / MIN_MATCH);

		win = new Uint8Array(w_size * 2);
		prev = [];
		head = [];

		lit_bufsize = 1 << (memLevel + 6); // 16K elements by default

		that.pending_buf = new Uint8Array(lit_bufsize * 4);
		pending_buf_size = lit_bufsize * 4;

		that.dist_buf = new Uint16Array(lit_bufsize);
		that.lc_buf = new Uint8Array(lit_bufsize);

		level = _level;

		strategy = _strategy;

		return deflateReset(strm);
	};

	that.deflateEnd = function () {
		if (status != INIT_STATE && status != BUSY_STATE && status != FINISH_STATE) {
			return Z_STREAM_ERROR$1;
		}
		// Deallocate in reverse order of allocations:
		that.lc_buf = null;
		that.dist_buf = null;
		that.pending_buf = null;
		head = null;
		prev = null;
		win = null;
		// free
		that.dstate = null;
		return status == BUSY_STATE ? Z_DATA_ERROR$1 : Z_OK$1;
	};

	that.deflateParams = function (strm, _level, _strategy) {
		let err = Z_OK$1;

		if (_level == Z_DEFAULT_COMPRESSION) {
			_level = 6;
		}
		if (_level < 0 || _level > 9 || _strategy < 0 || _strategy > Z_HUFFMAN_ONLY) {
			return Z_STREAM_ERROR$1;
		}

		if (config_table[level].func != config_table[_level].func && strm.total_in !== 0) {
			// Flush the last buffer:
			err = strm.deflate(Z_PARTIAL_FLUSH);
		}

		if (level != _level) {
			level = _level;
			max_lazy_match = config_table[level].max_lazy;
			good_match = config_table[level].good_length;
			nice_match = config_table[level].nice_length;
			max_chain_length = config_table[level].max_chain;
		}
		strategy = _strategy;
		return err;
	};

	that.deflateSetDictionary = function (_strm, dictionary, dictLength) {
		let length = dictLength;
		let n, index = 0;

		if (!dictionary || status != INIT_STATE)
			return Z_STREAM_ERROR$1;

		if (length < MIN_MATCH)
			return Z_OK$1;
		if (length > w_size - MIN_LOOKAHEAD) {
			length = w_size - MIN_LOOKAHEAD;
			index = dictLength - length; // use the tail of the dictionary
		}
		win.set(dictionary.subarray(index, index + length), 0);

		strstart = length;
		block_start = length;

		// Insert all strings in the hash table (except for the last two bytes).
		// s->lookahead stays null, so s->ins_h will be recomputed at the next
		// call of fill_window.

		ins_h = win[0] & 0xff;
		ins_h = (((ins_h) << hash_shift) ^ (win[1] & 0xff)) & hash_mask;

		for (n = 0; n <= length - MIN_MATCH; n++) {
			ins_h = (((ins_h) << hash_shift) ^ (win[(n) + (MIN_MATCH - 1)] & 0xff)) & hash_mask;
			prev[n & w_mask] = head[ins_h];
			head[ins_h] = n;
		}
		return Z_OK$1;
	};

	that.deflate = function (_strm, flush) {
		let i, header, level_flags, old_flush, bstate;

		if (flush > Z_FINISH$1 || flush < 0) {
			return Z_STREAM_ERROR$1;
		}

		if (!_strm.next_out || (!_strm.next_in && _strm.avail_in !== 0) || (status == FINISH_STATE && flush != Z_FINISH$1)) {
			_strm.msg = z_errmsg[Z_NEED_DICT$1 - (Z_STREAM_ERROR$1)];
			return Z_STREAM_ERROR$1;
		}
		if (_strm.avail_out === 0) {
			_strm.msg = z_errmsg[Z_NEED_DICT$1 - (Z_BUF_ERROR$1)];
			return Z_BUF_ERROR$1;
		}

		strm = _strm; // just in case
		old_flush = last_flush;
		last_flush = flush;

		// Write the zlib header
		if (status == INIT_STATE) {
			header = (Z_DEFLATED$1 + ((w_bits - 8) << 4)) << 8;
			level_flags = ((level - 1) & 0xff) >> 1;

			if (level_flags > 3)
				level_flags = 3;
			header |= (level_flags << 6);
			if (strstart !== 0)
				header |= PRESET_DICT$1;
			header += 31 - (header % 31);

			status = BUSY_STATE;
			putShortMSB(header);
		}

		// Flush as much pending output as possible
		if (that.pending !== 0) {
			strm.flush_pending();
			if (strm.avail_out === 0) {
				// console.log(" avail_out==0");
				// Since avail_out is 0, deflate will be called again with
				// more output space, but possibly with both pending and
				// avail_in equal to zero. There won't be anything to do,
				// but this is not an error situation so make sure we
				// return OK instead of BUF_ERROR at next call of deflate:
				last_flush = -1;
				return Z_OK$1;
			}

			// Make sure there is something to do and avoid duplicate
			// consecutive
			// flushes. For repeated and useless calls with Z_FINISH, we keep
			// returning Z_STREAM_END instead of Z_BUFF_ERROR.
		} else if (strm.avail_in === 0 && flush <= old_flush && flush != Z_FINISH$1) {
			strm.msg = z_errmsg[Z_NEED_DICT$1 - (Z_BUF_ERROR$1)];
			return Z_BUF_ERROR$1;
		}

		// User must not provide more input after the first FINISH:
		if (status == FINISH_STATE && strm.avail_in !== 0) {
			_strm.msg = z_errmsg[Z_NEED_DICT$1 - (Z_BUF_ERROR$1)];
			return Z_BUF_ERROR$1;
		}

		// Start a new block or continue the current one.
		if (strm.avail_in !== 0 || lookahead !== 0 || (flush != Z_NO_FLUSH$1 && status != FINISH_STATE)) {
			bstate = -1;
			switch (config_table[level].func) {
				case STORED$1:
					bstate = deflate_stored(flush);
					break;
				case FAST:
					bstate = deflate_fast(flush);
					break;
				case SLOW:
					bstate = deflate_slow(flush);
					break;
			}

			if (bstate == FinishStarted || bstate == FinishDone) {
				status = FINISH_STATE;
			}
			if (bstate == NeedMore || bstate == FinishStarted) {
				if (strm.avail_out === 0) {
					last_flush = -1; // avoid BUF_ERROR next call, see above
				}
				return Z_OK$1;
				// If flush != Z_NO_FLUSH && avail_out === 0, the next call
				// of deflate should use the same flush parameter to make sure
				// that the flush is complete. So we don't have to output an
				// empty block here, this will be done at next call. This also
				// ensures that for a very small output buffer, we emit at most
				// one empty block.
			}

			if (bstate == BlockDone) {
				if (flush == Z_PARTIAL_FLUSH) {
					_tr_align();
				} else { // FULL_FLUSH or SYNC_FLUSH
					_tr_stored_block(0, 0, false);
					// For a full flush, this empty block will be recognized
					// as a special marker by inflate_sync().
					if (flush == Z_FULL_FLUSH) {
						// state.head[s.hash_size-1]=0;
						for (i = 0; i < hash_size/*-1*/; i++)
							// forget history
							head[i] = 0;
					}
				}
				strm.flush_pending();
				if (strm.avail_out === 0) {
					last_flush = -1; // avoid BUF_ERROR at next call, see above
					return Z_OK$1;
				}
			}
		}

		if (flush != Z_FINISH$1)
			return Z_OK$1;
		return Z_STREAM_END$1;
	};
}

// ZStream

function ZStream$1() {
	const that = this;
	that.next_in_index = 0;
	that.next_out_index = 0;
	// that.next_in; // next input byte
	that.avail_in = 0; // number of bytes available at next_in
	that.total_in = 0; // total nb of input bytes read so far
	// that.next_out; // next output byte should be put there
	that.avail_out = 0; // remaining free space at next_out
	that.total_out = 0; // total nb of bytes output so far
	// that.msg;
	// that.dstate;
}

ZStream$1.prototype = {
	deflateInit(level, bits) {
		const that = this;
		that.dstate = new Deflate();
		if (!bits)
			bits = MAX_BITS$1;
		return that.dstate.deflateInit(that, level, bits);
	},

	deflate(flush) {
		const that = this;
		if (!that.dstate) {
			return Z_STREAM_ERROR$1;
		}
		return that.dstate.deflate(that, flush);
	},

	deflateEnd() {
		const that = this;
		if (!that.dstate)
			return Z_STREAM_ERROR$1;
		const ret = that.dstate.deflateEnd();
		that.dstate = null;
		return ret;
	},

	deflateParams(level, strategy) {
		const that = this;
		if (!that.dstate)
			return Z_STREAM_ERROR$1;
		return that.dstate.deflateParams(that, level, strategy);
	},

	deflateSetDictionary(dictionary, dictLength) {
		const that = this;
		if (!that.dstate)
			return Z_STREAM_ERROR$1;
		return that.dstate.deflateSetDictionary(that, dictionary, dictLength);
	},

	// Read a new buffer from the current input stream, update the
	// total number of bytes read. All deflate() input goes through
	// this function so some applications may wish to modify it to avoid
	// allocating a large strm->next_in buffer and copying from it.
	// (See also flush_pending()).
	read_buf(buf, start, size) {
		const that = this;
		let len = that.avail_in;
		if (len > size)
			len = size;
		if (len === 0)
			return 0;
		that.avail_in -= len;
		buf.set(that.next_in.subarray(that.next_in_index, that.next_in_index + len), start);
		that.next_in_index += len;
		that.total_in += len;
		return len;
	},

	// Flush as much pending output as possible. All deflate() output goes
	// through this function so some applications may wish to modify it
	// to avoid allocating a large strm->next_out buffer and copying into it.
	// (See also read_buf()).
	flush_pending() {
		const that = this;
		let len = that.dstate.pending;

		if (len > that.avail_out)
			len = that.avail_out;
		if (len === 0)
			return;

		// if (that.dstate.pending_buf.length <= that.dstate.pending_out || that.next_out.length <= that.next_out_index
		// || that.dstate.pending_buf.length < (that.dstate.pending_out + len) || that.next_out.length < (that.next_out_index +
		// len)) {
		// console.log(that.dstate.pending_buf.length + ", " + that.dstate.pending_out + ", " + that.next_out.length + ", " +
		// that.next_out_index + ", " + len);
		// console.log("avail_out=" + that.avail_out);
		// }

		that.next_out.set(that.dstate.pending_buf.subarray(that.dstate.pending_out, that.dstate.pending_out + len), that.next_out_index);

		that.next_out_index += len;
		that.dstate.pending_out += len;
		that.total_out += len;
		that.avail_out -= len;
		that.dstate.pending -= len;
		if (that.dstate.pending === 0) {
			that.dstate.pending_out = 0;
		}
	}
};

// Deflate

function ZipDeflate(options) {
	const that = this;
	const z = new ZStream$1();
	const bufsize = getMaximumCompressedSize$1(options && options.chunkSize ? options.chunkSize : 64 * 1024);
	const flush = Z_NO_FLUSH$1;
	const buf = new Uint8Array(bufsize);
	let level = options ? options.level : Z_DEFAULT_COMPRESSION;
	if (typeof level == "undefined")
		level = Z_DEFAULT_COMPRESSION;
	z.deflateInit(level);
	z.next_out = buf;

	that.append = function (data, onprogress) {
		let err, array, lastIndex = 0, bufferIndex = 0, bufferSize = 0;
		const buffers = [];
		if (!data.length)
			return;
		z.next_in_index = 0;
		z.next_in = data;
		z.avail_in = data.length;
		do {
			z.next_out_index = 0;
			z.avail_out = bufsize;
			err = z.deflate(flush);
			if (err != Z_OK$1)
				throw new Error("deflating: " + z.msg);
			if (z.next_out_index)
				if (z.next_out_index == bufsize)
					buffers.push(new Uint8Array(buf));
				else
					buffers.push(buf.subarray(0, z.next_out_index));
			bufferSize += z.next_out_index;
			if (onprogress && z.next_in_index > 0 && z.next_in_index != lastIndex) {
				onprogress(z.next_in_index);
				lastIndex = z.next_in_index;
			}
		} while (z.avail_in > 0 || z.avail_out === 0);
		if (buffers.length > 1) {
			array = new Uint8Array(bufferSize);
			buffers.forEach(function (chunk) {
				array.set(chunk, bufferIndex);
				bufferIndex += chunk.length;
			});
		} else {
			array = buffers[0] ? new Uint8Array(buffers[0]) : new Uint8Array();
		}
		return array;
	};
	that.flush = function () {
		let err, array, bufferIndex = 0, bufferSize = 0;
		const buffers = [];
		do {
			z.next_out_index = 0;
			z.avail_out = bufsize;
			err = z.deflate(Z_FINISH$1);
			if (err != Z_STREAM_END$1 && err != Z_OK$1)
				throw new Error("deflating: " + z.msg);
			if (bufsize - z.avail_out > 0)
				buffers.push(buf.slice(0, z.next_out_index));
			bufferSize += z.next_out_index;
		} while (z.avail_in > 0 || z.avail_out === 0);
		z.deflateEnd();
		array = new Uint8Array(bufferSize);
		buffers.forEach(function (chunk) {
			array.set(chunk, bufferIndex);
			bufferIndex += chunk.length;
		});
		return array;
	};
}

function getMaximumCompressedSize$1(uncompressedSize) {
	return uncompressedSize + (5 * (Math.floor(uncompressedSize / 16383) + 1));
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * This program is based on JZlib 1.0.2 ymnk, JCraft,Inc.
 * JZlib is based on zlib-1.1.3, so all credit should go authors
 * Jean-loup Gailly(jloup@gzip.org) and Mark Adler(madler@alumni.caltech.edu)
 * and contributors of zlib.
 */

// deno-lint-ignore-file no-this-alias prefer-const

// Global

const MAX_BITS = 15;

const Z_OK = 0;
const Z_STREAM_END = 1;
const Z_NEED_DICT = 2;
const Z_STREAM_ERROR = -2;
const Z_DATA_ERROR = -3;
const Z_MEM_ERROR = -4;
const Z_BUF_ERROR = -5;

const inflate_mask = [0x00000000, 0x00000001, 0x00000003, 0x00000007, 0x0000000f, 0x0000001f, 0x0000003f, 0x0000007f, 0x000000ff, 0x000001ff, 0x000003ff,
	0x000007ff, 0x00000fff, 0x00001fff, 0x00003fff, 0x00007fff, 0x0000ffff];

const MANY = 1440;

// JZlib version : "1.0.2"
const Z_NO_FLUSH = 0;
const Z_FINISH = 4;

// InfTree
const fixed_bl = 9;
const fixed_bd = 5;

const fixed_tl = [96, 7, 256, 0, 8, 80, 0, 8, 16, 84, 8, 115, 82, 7, 31, 0, 8, 112, 0, 8, 48, 0, 9, 192, 80, 7, 10, 0, 8, 96, 0, 8, 32, 0, 9, 160, 0, 8, 0,
	0, 8, 128, 0, 8, 64, 0, 9, 224, 80, 7, 6, 0, 8, 88, 0, 8, 24, 0, 9, 144, 83, 7, 59, 0, 8, 120, 0, 8, 56, 0, 9, 208, 81, 7, 17, 0, 8, 104, 0, 8, 40,
	0, 9, 176, 0, 8, 8, 0, 8, 136, 0, 8, 72, 0, 9, 240, 80, 7, 4, 0, 8, 84, 0, 8, 20, 85, 8, 227, 83, 7, 43, 0, 8, 116, 0, 8, 52, 0, 9, 200, 81, 7, 13,
	0, 8, 100, 0, 8, 36, 0, 9, 168, 0, 8, 4, 0, 8, 132, 0, 8, 68, 0, 9, 232, 80, 7, 8, 0, 8, 92, 0, 8, 28, 0, 9, 152, 84, 7, 83, 0, 8, 124, 0, 8, 60,
	0, 9, 216, 82, 7, 23, 0, 8, 108, 0, 8, 44, 0, 9, 184, 0, 8, 12, 0, 8, 140, 0, 8, 76, 0, 9, 248, 80, 7, 3, 0, 8, 82, 0, 8, 18, 85, 8, 163, 83, 7,
	35, 0, 8, 114, 0, 8, 50, 0, 9, 196, 81, 7, 11, 0, 8, 98, 0, 8, 34, 0, 9, 164, 0, 8, 2, 0, 8, 130, 0, 8, 66, 0, 9, 228, 80, 7, 7, 0, 8, 90, 0, 8,
	26, 0, 9, 148, 84, 7, 67, 0, 8, 122, 0, 8, 58, 0, 9, 212, 82, 7, 19, 0, 8, 106, 0, 8, 42, 0, 9, 180, 0, 8, 10, 0, 8, 138, 0, 8, 74, 0, 9, 244, 80,
	7, 5, 0, 8, 86, 0, 8, 22, 192, 8, 0, 83, 7, 51, 0, 8, 118, 0, 8, 54, 0, 9, 204, 81, 7, 15, 0, 8, 102, 0, 8, 38, 0, 9, 172, 0, 8, 6, 0, 8, 134, 0,
	8, 70, 0, 9, 236, 80, 7, 9, 0, 8, 94, 0, 8, 30, 0, 9, 156, 84, 7, 99, 0, 8, 126, 0, 8, 62, 0, 9, 220, 82, 7, 27, 0, 8, 110, 0, 8, 46, 0, 9, 188, 0,
	8, 14, 0, 8, 142, 0, 8, 78, 0, 9, 252, 96, 7, 256, 0, 8, 81, 0, 8, 17, 85, 8, 131, 82, 7, 31, 0, 8, 113, 0, 8, 49, 0, 9, 194, 80, 7, 10, 0, 8, 97,
	0, 8, 33, 0, 9, 162, 0, 8, 1, 0, 8, 129, 0, 8, 65, 0, 9, 226, 80, 7, 6, 0, 8, 89, 0, 8, 25, 0, 9, 146, 83, 7, 59, 0, 8, 121, 0, 8, 57, 0, 9, 210,
	81, 7, 17, 0, 8, 105, 0, 8, 41, 0, 9, 178, 0, 8, 9, 0, 8, 137, 0, 8, 73, 0, 9, 242, 80, 7, 4, 0, 8, 85, 0, 8, 21, 80, 8, 258, 83, 7, 43, 0, 8, 117,
	0, 8, 53, 0, 9, 202, 81, 7, 13, 0, 8, 101, 0, 8, 37, 0, 9, 170, 0, 8, 5, 0, 8, 133, 0, 8, 69, 0, 9, 234, 80, 7, 8, 0, 8, 93, 0, 8, 29, 0, 9, 154,
	84, 7, 83, 0, 8, 125, 0, 8, 61, 0, 9, 218, 82, 7, 23, 0, 8, 109, 0, 8, 45, 0, 9, 186, 0, 8, 13, 0, 8, 141, 0, 8, 77, 0, 9, 250, 80, 7, 3, 0, 8, 83,
	0, 8, 19, 85, 8, 195, 83, 7, 35, 0, 8, 115, 0, 8, 51, 0, 9, 198, 81, 7, 11, 0, 8, 99, 0, 8, 35, 0, 9, 166, 0, 8, 3, 0, 8, 131, 0, 8, 67, 0, 9, 230,
	80, 7, 7, 0, 8, 91, 0, 8, 27, 0, 9, 150, 84, 7, 67, 0, 8, 123, 0, 8, 59, 0, 9, 214, 82, 7, 19, 0, 8, 107, 0, 8, 43, 0, 9, 182, 0, 8, 11, 0, 8, 139,
	0, 8, 75, 0, 9, 246, 80, 7, 5, 0, 8, 87, 0, 8, 23, 192, 8, 0, 83, 7, 51, 0, 8, 119, 0, 8, 55, 0, 9, 206, 81, 7, 15, 0, 8, 103, 0, 8, 39, 0, 9, 174,
	0, 8, 7, 0, 8, 135, 0, 8, 71, 0, 9, 238, 80, 7, 9, 0, 8, 95, 0, 8, 31, 0, 9, 158, 84, 7, 99, 0, 8, 127, 0, 8, 63, 0, 9, 222, 82, 7, 27, 0, 8, 111,
	0, 8, 47, 0, 9, 190, 0, 8, 15, 0, 8, 143, 0, 8, 79, 0, 9, 254, 96, 7, 256, 0, 8, 80, 0, 8, 16, 84, 8, 115, 82, 7, 31, 0, 8, 112, 0, 8, 48, 0, 9,
	193, 80, 7, 10, 0, 8, 96, 0, 8, 32, 0, 9, 161, 0, 8, 0, 0, 8, 128, 0, 8, 64, 0, 9, 225, 80, 7, 6, 0, 8, 88, 0, 8, 24, 0, 9, 145, 83, 7, 59, 0, 8,
	120, 0, 8, 56, 0, 9, 209, 81, 7, 17, 0, 8, 104, 0, 8, 40, 0, 9, 177, 0, 8, 8, 0, 8, 136, 0, 8, 72, 0, 9, 241, 80, 7, 4, 0, 8, 84, 0, 8, 20, 85, 8,
	227, 83, 7, 43, 0, 8, 116, 0, 8, 52, 0, 9, 201, 81, 7, 13, 0, 8, 100, 0, 8, 36, 0, 9, 169, 0, 8, 4, 0, 8, 132, 0, 8, 68, 0, 9, 233, 80, 7, 8, 0, 8,
	92, 0, 8, 28, 0, 9, 153, 84, 7, 83, 0, 8, 124, 0, 8, 60, 0, 9, 217, 82, 7, 23, 0, 8, 108, 0, 8, 44, 0, 9, 185, 0, 8, 12, 0, 8, 140, 0, 8, 76, 0, 9,
	249, 80, 7, 3, 0, 8, 82, 0, 8, 18, 85, 8, 163, 83, 7, 35, 0, 8, 114, 0, 8, 50, 0, 9, 197, 81, 7, 11, 0, 8, 98, 0, 8, 34, 0, 9, 165, 0, 8, 2, 0, 8,
	130, 0, 8, 66, 0, 9, 229, 80, 7, 7, 0, 8, 90, 0, 8, 26, 0, 9, 149, 84, 7, 67, 0, 8, 122, 0, 8, 58, 0, 9, 213, 82, 7, 19, 0, 8, 106, 0, 8, 42, 0, 9,
	181, 0, 8, 10, 0, 8, 138, 0, 8, 74, 0, 9, 245, 80, 7, 5, 0, 8, 86, 0, 8, 22, 192, 8, 0, 83, 7, 51, 0, 8, 118, 0, 8, 54, 0, 9, 205, 81, 7, 15, 0, 8,
	102, 0, 8, 38, 0, 9, 173, 0, 8, 6, 0, 8, 134, 0, 8, 70, 0, 9, 237, 80, 7, 9, 0, 8, 94, 0, 8, 30, 0, 9, 157, 84, 7, 99, 0, 8, 126, 0, 8, 62, 0, 9,
	221, 82, 7, 27, 0, 8, 110, 0, 8, 46, 0, 9, 189, 0, 8, 14, 0, 8, 142, 0, 8, 78, 0, 9, 253, 96, 7, 256, 0, 8, 81, 0, 8, 17, 85, 8, 131, 82, 7, 31, 0,
	8, 113, 0, 8, 49, 0, 9, 195, 80, 7, 10, 0, 8, 97, 0, 8, 33, 0, 9, 163, 0, 8, 1, 0, 8, 129, 0, 8, 65, 0, 9, 227, 80, 7, 6, 0, 8, 89, 0, 8, 25, 0, 9,
	147, 83, 7, 59, 0, 8, 121, 0, 8, 57, 0, 9, 211, 81, 7, 17, 0, 8, 105, 0, 8, 41, 0, 9, 179, 0, 8, 9, 0, 8, 137, 0, 8, 73, 0, 9, 243, 80, 7, 4, 0, 8,
	85, 0, 8, 21, 80, 8, 258, 83, 7, 43, 0, 8, 117, 0, 8, 53, 0, 9, 203, 81, 7, 13, 0, 8, 101, 0, 8, 37, 0, 9, 171, 0, 8, 5, 0, 8, 133, 0, 8, 69, 0, 9,
	235, 80, 7, 8, 0, 8, 93, 0, 8, 29, 0, 9, 155, 84, 7, 83, 0, 8, 125, 0, 8, 61, 0, 9, 219, 82, 7, 23, 0, 8, 109, 0, 8, 45, 0, 9, 187, 0, 8, 13, 0, 8,
	141, 0, 8, 77, 0, 9, 251, 80, 7, 3, 0, 8, 83, 0, 8, 19, 85, 8, 195, 83, 7, 35, 0, 8, 115, 0, 8, 51, 0, 9, 199, 81, 7, 11, 0, 8, 99, 0, 8, 35, 0, 9,
	167, 0, 8, 3, 0, 8, 131, 0, 8, 67, 0, 9, 231, 80, 7, 7, 0, 8, 91, 0, 8, 27, 0, 9, 151, 84, 7, 67, 0, 8, 123, 0, 8, 59, 0, 9, 215, 82, 7, 19, 0, 8,
	107, 0, 8, 43, 0, 9, 183, 0, 8, 11, 0, 8, 139, 0, 8, 75, 0, 9, 247, 80, 7, 5, 0, 8, 87, 0, 8, 23, 192, 8, 0, 83, 7, 51, 0, 8, 119, 0, 8, 55, 0, 9,
	207, 81, 7, 15, 0, 8, 103, 0, 8, 39, 0, 9, 175, 0, 8, 7, 0, 8, 135, 0, 8, 71, 0, 9, 239, 80, 7, 9, 0, 8, 95, 0, 8, 31, 0, 9, 159, 84, 7, 99, 0, 8,
	127, 0, 8, 63, 0, 9, 223, 82, 7, 27, 0, 8, 111, 0, 8, 47, 0, 9, 191, 0, 8, 15, 0, 8, 143, 0, 8, 79, 0, 9, 255];
const fixed_td = [80, 5, 1, 87, 5, 257, 83, 5, 17, 91, 5, 4097, 81, 5, 5, 89, 5, 1025, 85, 5, 65, 93, 5, 16385, 80, 5, 3, 88, 5, 513, 84, 5, 33, 92, 5,
	8193, 82, 5, 9, 90, 5, 2049, 86, 5, 129, 192, 5, 24577, 80, 5, 2, 87, 5, 385, 83, 5, 25, 91, 5, 6145, 81, 5, 7, 89, 5, 1537, 85, 5, 97, 93, 5,
	24577, 80, 5, 4, 88, 5, 769, 84, 5, 49, 92, 5, 12289, 82, 5, 13, 90, 5, 3073, 86, 5, 193, 192, 5, 24577];

// Tables for deflate from PKZIP's appnote.txt.
const cplens = [ // Copy lengths for literal codes 257..285
	3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0];

// see note #13 above about 258
const cplext = [ // Extra bits for literal codes 257..285
	0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 112, 112 // 112==invalid
];

const cpdist = [ // Copy offsets for distance codes 0..29
	1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577];

const cpdext = [ // Extra bits for distance codes
	0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13];

// If BMAX needs to be larger than 16, then h and x[] should be uLong.
const BMAX = 15; // maximum bit length of any code

function InfTree() {
	const that = this;

	let hn; // hufts used in space
	let v; // work area for huft_build
	let c; // bit length count table
	let r; // table entry for structure assignment
	let u; // table stack
	let x; // bit offsets, then code stack

	function huft_build(b, // code lengths in bits (all assumed <=
		// BMAX)
		bindex, n, // number of codes (assumed <= 288)
		s, // number of simple-valued codes (0..s-1)
		d, // list of base values for non-simple codes
		e, // list of extra bits for non-simple codes
		t, // result: starting table
		m, // maximum lookup bits, returns actual
		hp,// space for trees
		hn,// hufts used in space
		v // working area: values in order of bit length
	) {
		// Given a list of code lengths and a maximum table size, make a set of
		// tables to decode that set of codes. Return Z_OK on success,
		// Z_BUF_ERROR
		// if the given code set is incomplete (the tables are still built in
		// this
		// case), Z_DATA_ERROR if the input is invalid (an over-subscribed set
		// of
		// lengths), or Z_MEM_ERROR if not enough memory.

		let a; // counter for codes of length k
		let f; // i repeats in table every f entries
		let g; // maximum code length
		let h; // table level
		let i; // counter, current code
		let j; // counter
		let k; // number of bits in current code
		let l; // bits per table (returned in m)
		let mask; // (1 << w) - 1, to avoid cc -O bug on HP
		let p; // pointer into c[], b[], or v[]
		let q; // points to current table
		let w; // bits before this table == (l * h)
		let xp; // pointer into x
		let y; // number of dummy codes added
		let z; // number of entries in current table

		// Generate counts for each bit length

		p = 0;
		i = n;
		do {
			c[b[bindex + p]]++;
			p++;
			i--; // assume all entries <= BMAX
		} while (i !== 0);

		if (c[0] == n) { // null input--all zero length codes
			t[0] = -1;
			m[0] = 0;
			return Z_OK;
		}

		// Find minimum and maximum length, bound *m by those
		l = m[0];
		for (j = 1; j <= BMAX; j++)
			if (c[j] !== 0)
				break;
		k = j; // minimum code length
		if (l < j) {
			l = j;
		}
		for (i = BMAX; i !== 0; i--) {
			if (c[i] !== 0)
				break;
		}
		g = i; // maximum code length
		if (l > i) {
			l = i;
		}
		m[0] = l;

		// Adjust last length count to fill out codes, if needed
		for (y = 1 << j; j < i; j++, y <<= 1) {
			if ((y -= c[j]) < 0) {
				return Z_DATA_ERROR;
			}
		}
		if ((y -= c[i]) < 0) {
			return Z_DATA_ERROR;
		}
		c[i] += y;

		// Generate starting offsets into the value table for each length
		x[1] = j = 0;
		p = 1;
		xp = 2;
		while (--i !== 0) { // note that i == g from above
			x[xp] = (j += c[p]);
			xp++;
			p++;
		}

		// Make a table of values in order of bit lengths
		i = 0;
		p = 0;
		do {
			if ((j = b[bindex + p]) !== 0) {
				v[x[j]++] = i;
			}
			p++;
		} while (++i < n);
		n = x[g]; // set n to length of v

		// Generate the Huffman codes and for each, make the table entries
		x[0] = i = 0; // first Huffman code is zero
		p = 0; // grab values in bit order
		h = -1; // no tables yet--level -1
		w = -l; // bits decoded == (l * h)
		u[0] = 0; // just to keep compilers happy
		q = 0; // ditto
		z = 0; // ditto

		// go through the bit lengths (k already is bits in shortest code)
		for (; k <= g; k++) {
			a = c[k];
			while (a-- !== 0) {
				// here i is the Huffman code of length k bits for value *p
				// make tables up to required level
				while (k > w + l) {
					h++;
					w += l; // previous table always l bits
					// compute minimum size table less than or equal to l bits
					z = g - w;
					z = (z > l) ? l : z; // table size upper limit
					if ((f = 1 << (j = k - w)) > a + 1) { // try a k-w bit table
						// too few codes for
						// k-w bit table
						f -= a + 1; // deduct codes from patterns left
						xp = k;
						if (j < z) {
							while (++j < z) { // try smaller tables up to z bits
								if ((f <<= 1) <= c[++xp])
									break; // enough codes to use up j bits
								f -= c[xp]; // else deduct codes from patterns
							}
						}
					}
					z = 1 << j; // table entries for j-bit table

					// allocate new table
					if (hn[0] + z > MANY) { // (note: doesn't matter for fixed)
						return Z_DATA_ERROR; // overflow of MANY
					}
					u[h] = q = /* hp+ */hn[0]; // DEBUG
					hn[0] += z;

					// connect to last table, if there is one
					if (h !== 0) {
						x[h] = i; // save pattern for backing up
						r[0] = /* (byte) */j; // bits in this table
						r[1] = /* (byte) */l; // bits to dump before this table
						j = i >>> (w - l);
						r[2] = /* (int) */(q - u[h - 1] - j); // offset to this table
						hp.set(r, (u[h - 1] + j) * 3);
						// to
						// last
						// table
					} else {
						t[0] = q; // first table is returned result
					}
				}

				// set up table entry in r
				r[1] = /* (byte) */(k - w);
				if (p >= n) {
					r[0] = 128 + 64; // out of values--invalid code
				} else if (v[p] < s) {
					r[0] = /* (byte) */(v[p] < 256 ? 0 : 32 + 64); // 256 is
					// end-of-block
					r[2] = v[p++]; // simple code is just the value
				} else {
					r[0] = /* (byte) */(e[v[p] - s] + 16 + 64); // non-simple--look
					// up in lists
					r[2] = d[v[p++] - s];
				}

				// fill code-like entries with r
				f = 1 << (k - w);
				for (j = i >>> w; j < z; j += f) {
					hp.set(r, (q + j) * 3);
				}

				// backwards increment the k-bit code i
				for (j = 1 << (k - 1); (i & j) !== 0; j >>>= 1) {
					i ^= j;
				}
				i ^= j;

				// backup over finished tables
				mask = (1 << w) - 1; // needed on HP, cc -O bug
				while ((i & mask) != x[h]) {
					h--; // don't need to update q
					w -= l;
					mask = (1 << w) - 1;
				}
			}
		}
		// Return Z_BUF_ERROR if we were given an incomplete table
		return y !== 0 && g != 1 ? Z_BUF_ERROR : Z_OK;
	}

	function initWorkArea(vsize) {
		let i;
		if (!hn) {
			hn = []; // []; //new Array(1);
			v = []; // new Array(vsize);
			c = new Int32Array(BMAX + 1); // new Array(BMAX + 1);
			r = []; // new Array(3);
			u = new Int32Array(BMAX); // new Array(BMAX);
			x = new Int32Array(BMAX + 1); // new Array(BMAX + 1);
		}
		if (v.length < vsize) {
			v = []; // new Array(vsize);
		}
		for (i = 0; i < vsize; i++) {
			v[i] = 0;
		}
		for (i = 0; i < BMAX + 1; i++) {
			c[i] = 0;
		}
		for (i = 0; i < 3; i++) {
			r[i] = 0;
		}
		// for(int i=0; i<BMAX; i++){u[i]=0;}
		u.set(c.subarray(0, BMAX), 0);
		// for(int i=0; i<BMAX+1; i++){x[i]=0;}
		x.set(c.subarray(0, BMAX + 1), 0);
	}

	that.inflate_trees_bits = function (c, // 19 code lengths
		bb, // bits tree desired/actual depth
		tb, // bits tree result
		hp, // space for trees
		z // for messages
	) {
		let result;
		initWorkArea(19);
		hn[0] = 0;
		result = huft_build(c, 0, 19, 19, null, null, tb, bb, hp, hn, v);

		if (result == Z_DATA_ERROR) {
			z.msg = "oversubscribed dynamic bit lengths tree";
		} else if (result == Z_BUF_ERROR || bb[0] === 0) {
			z.msg = "incomplete dynamic bit lengths tree";
			result = Z_DATA_ERROR;
		}
		return result;
	};

	that.inflate_trees_dynamic = function (nl, // number of literal/length codes
		nd, // number of distance codes
		c, // that many (total) code lengths
		bl, // literal desired/actual bit depth
		bd, // distance desired/actual bit depth
		tl, // literal/length tree result
		td, // distance tree result
		hp, // space for trees
		z // for messages
	) {
		let result;

		// build literal/length tree
		initWorkArea(288);
		hn[0] = 0;
		result = huft_build(c, 0, nl, 257, cplens, cplext, tl, bl, hp, hn, v);
		if (result != Z_OK || bl[0] === 0) {
			if (result == Z_DATA_ERROR) {
				z.msg = "oversubscribed literal/length tree";
			} else if (result != Z_MEM_ERROR) {
				z.msg = "incomplete literal/length tree";
				result = Z_DATA_ERROR;
			}
			return result;
		}

		// build distance tree
		initWorkArea(288);
		result = huft_build(c, nl, nd, 0, cpdist, cpdext, td, bd, hp, hn, v);

		if (result != Z_OK || (bd[0] === 0 && nl > 257)) {
			if (result == Z_DATA_ERROR) {
				z.msg = "oversubscribed distance tree";
			} else if (result == Z_BUF_ERROR) {
				z.msg = "incomplete distance tree";
				result = Z_DATA_ERROR;
			} else if (result != Z_MEM_ERROR) {
				z.msg = "empty distance tree with lengths";
				result = Z_DATA_ERROR;
			}
			return result;
		}

		return Z_OK;
	};

}

InfTree.inflate_trees_fixed = function (bl, // literal desired/actual bit depth
	bd, // distance desired/actual bit depth
	tl,// literal/length tree result
	td// distance tree result
) {
	bl[0] = fixed_bl;
	bd[0] = fixed_bd;
	tl[0] = fixed_tl;
	td[0] = fixed_td;
	return Z_OK;
};

// InfCodes

// waiting for "i:"=input,
// "o:"=output,
// "x:"=nothing
const START = 0; // x: set up for LEN
const LEN = 1; // i: get length/literal/eob next
const LENEXT = 2; // i: getting length extra (have base)
const DIST = 3; // i: get distance next
const DISTEXT = 4;// i: getting distance extra
const COPY = 5; // o: copying bytes in win, waiting
// for space
const LIT = 6; // o: got literal, waiting for output
// space
const WASH = 7; // o: got eob, possibly still output
// waiting
const END = 8; // x: got eob and all data flushed
const BADCODE = 9;// x: got error

function InfCodes() {
	const that = this;

	let mode; // current inflate_codes mode

	// mode dependent information
	let len = 0;

	let tree; // pointer into tree
	let tree_index = 0;
	let need = 0; // bits needed

	let lit = 0;

	// if EXT or COPY, where and how much
	let get = 0; // bits to get for extra
	let dist = 0; // distance back to copy from

	let lbits = 0; // ltree bits decoded per branch
	let dbits = 0; // dtree bits decoder per branch
	let ltree; // literal/length/eob tree
	let ltree_index = 0; // literal/length/eob tree
	let dtree; // distance tree
	let dtree_index = 0; // distance tree

	// Called with number of bytes left to write in win at least 258
	// (the maximum string length) and number of input bytes available
	// at least ten. The ten bytes are six bytes for the longest length/
	// distance pair plus four bytes for overloading the bit buffer.

	function inflate_fast(bl, bd, tl, tl_index, td, td_index, s, z) {
		let t; // temporary pointer
		let tp; // temporary pointer
		let tp_index; // temporary pointer
		let e; // extra bits or operation
		let b; // bit buffer
		let k; // bits in bit buffer
		let p; // input data pointer
		let n; // bytes available there
		let q; // output win write pointer
		let m; // bytes to end of win or read pointer
		let ml; // mask for literal/length tree
		let md; // mask for distance tree
		let c; // bytes to copy
		let d; // distance back to copy from
		let r; // copy source pointer

		let tp_index_t_3; // (tp_index+t)*3

		// load input, output, bit values
		p = z.next_in_index;
		n = z.avail_in;
		b = s.bitb;
		k = s.bitk;
		q = s.write;
		m = q < s.read ? s.read - q - 1 : s.end - q;

		// initialize masks
		ml = inflate_mask[bl];
		md = inflate_mask[bd];

		// do until not enough input or output space for fast loop
		do { // assume called with m >= 258 && n >= 10
			// get literal/length code
			while (k < (20)) { // max bits for literal/length code
				n--;
				b |= (z.read_byte(p++) & 0xff) << k;
				k += 8;
			}

			t = b & ml;
			tp = tl;
			tp_index = tl_index;
			tp_index_t_3 = (tp_index + t) * 3;
			if ((e = tp[tp_index_t_3]) === 0) {
				b >>= (tp[tp_index_t_3 + 1]);
				k -= (tp[tp_index_t_3 + 1]);

				s.win[q++] = /* (byte) */tp[tp_index_t_3 + 2];
				m--;
				continue;
			}
			do {

				b >>= (tp[tp_index_t_3 + 1]);
				k -= (tp[tp_index_t_3 + 1]);

				if ((e & 16) !== 0) {
					e &= 15;
					c = tp[tp_index_t_3 + 2] + (/* (int) */b & inflate_mask[e]);

					b >>= e;
					k -= e;

					// decode distance base of block to copy
					while (k < (15)) { // max bits for distance code
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					t = b & md;
					tp = td;
					tp_index = td_index;
					tp_index_t_3 = (tp_index + t) * 3;
					e = tp[tp_index_t_3];

					do {

						b >>= (tp[tp_index_t_3 + 1]);
						k -= (tp[tp_index_t_3 + 1]);

						if ((e & 16) !== 0) {
							// get extra bits to add to distance base
							e &= 15;
							while (k < (e)) { // get extra bits (up to 13)
								n--;
								b |= (z.read_byte(p++) & 0xff) << k;
								k += 8;
							}

							d = tp[tp_index_t_3 + 2] + (b & inflate_mask[e]);

							b >>= (e);
							k -= (e);

							// do the copy
							m -= c;
							if (q >= d) { // offset before dest
								// just copy
								r = q - d;
								if (q - r > 0 && 2 > (q - r)) {
									s.win[q++] = s.win[r++]; // minimum
									// count is
									// three,
									s.win[q++] = s.win[r++]; // so unroll
									// loop a
									// little
									c -= 2;
								} else {
									s.win.set(s.win.subarray(r, r + 2), q);
									q += 2;
									r += 2;
									c -= 2;
								}
							} else { // else offset after destination
								r = q - d;
								do {
									r += s.end; // force pointer in win
								} while (r < 0); // covers invalid distances
								e = s.end - r;
								if (c > e) { // if source crosses,
									c -= e; // wrapped copy
									if (q - r > 0 && e > (q - r)) {
										do {
											s.win[q++] = s.win[r++];
										} while (--e !== 0);
									} else {
										s.win.set(s.win.subarray(r, r + e), q);
										q += e;
										r += e;
										e = 0;
									}
									r = 0; // copy rest from start of win
								}

							}

							// copy all or what's left
							if (q - r > 0 && c > (q - r)) {
								do {
									s.win[q++] = s.win[r++];
								} while (--c !== 0);
							} else {
								s.win.set(s.win.subarray(r, r + c), q);
								q += c;
								r += c;
								c = 0;
							}
							break;
						} else if ((e & 64) === 0) {
							t += tp[tp_index_t_3 + 2];
							t += (b & inflate_mask[e]);
							tp_index_t_3 = (tp_index + t) * 3;
							e = tp[tp_index_t_3];
						} else {
							z.msg = "invalid distance code";

							c = z.avail_in - n;
							c = (k >> 3) < c ? k >> 3 : c;
							n += c;
							p -= c;
							k -= c << 3;

							s.bitb = b;
							s.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							s.write = q;

							return Z_DATA_ERROR;
						}
						// eslint-disable-next-line no-constant-condition
					} while (true);
					break;
				}

				if ((e & 64) === 0) {
					t += tp[tp_index_t_3 + 2];
					t += (b & inflate_mask[e]);
					tp_index_t_3 = (tp_index + t) * 3;
					if ((e = tp[tp_index_t_3]) === 0) {

						b >>= (tp[tp_index_t_3 + 1]);
						k -= (tp[tp_index_t_3 + 1]);

						s.win[q++] = /* (byte) */tp[tp_index_t_3 + 2];
						m--;
						break;
					}
				} else if ((e & 32) !== 0) {

					c = z.avail_in - n;
					c = (k >> 3) < c ? k >> 3 : c;
					n += c;
					p -= c;
					k -= c << 3;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;

					return Z_STREAM_END;
				} else {
					z.msg = "invalid literal/length code";

					c = z.avail_in - n;
					c = (k >> 3) < c ? k >> 3 : c;
					n += c;
					p -= c;
					k -= c << 3;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;

					return Z_DATA_ERROR;
				}
				// eslint-disable-next-line no-constant-condition
			} while (true);
		} while (m >= 258 && n >= 10);

		// not enough input or output--restore pointers and return
		c = z.avail_in - n;
		c = (k >> 3) < c ? k >> 3 : c;
		n += c;
		p -= c;
		k -= c << 3;

		s.bitb = b;
		s.bitk = k;
		z.avail_in = n;
		z.total_in += p - z.next_in_index;
		z.next_in_index = p;
		s.write = q;

		return Z_OK;
	}

	that.init = function (bl, bd, tl, tl_index, td, td_index) {
		mode = START;
		lbits = /* (byte) */bl;
		dbits = /* (byte) */bd;
		ltree = tl;
		ltree_index = tl_index;
		dtree = td;
		dtree_index = td_index;
		tree = null;
	};

	that.proc = function (s, z, r) {
		let j; // temporary storage
		let tindex; // temporary pointer
		let e; // extra bits or operation
		let b = 0; // bit buffer
		let k = 0; // bits in bit buffer
		let p = 0; // input data pointer
		let n; // bytes available there
		let q; // output win write pointer
		let m; // bytes to end of win or read pointer
		let f; // pointer to copy strings from

		// copy input/output information to locals (UPDATE macro restores)
		p = z.next_in_index;
		n = z.avail_in;
		b = s.bitb;
		k = s.bitk;
		q = s.write;
		m = q < s.read ? s.read - q - 1 : s.end - q;

		// process input and output based on current state
		// eslint-disable-next-line no-constant-condition
		while (true) {
			switch (mode) {
				// waiting for "i:"=input, "o:"=output, "x:"=nothing
				case START: // x: set up for LEN
					if (m >= 258 && n >= 10) {

						s.bitb = b;
						s.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						s.write = q;
						r = inflate_fast(lbits, dbits, ltree, ltree_index, dtree, dtree_index, s, z);

						p = z.next_in_index;
						n = z.avail_in;
						b = s.bitb;
						k = s.bitk;
						q = s.write;
						m = q < s.read ? s.read - q - 1 : s.end - q;

						if (r != Z_OK) {
							mode = r == Z_STREAM_END ? WASH : BADCODE;
							break;
						}
					}
					need = lbits;
					tree = ltree;
					tree_index = ltree_index;

					mode = LEN;
				/* falls through */
				case LEN: // i: get length/literal/eob next
					j = need;

					while (k < (j)) {
						if (n !== 0)
							r = Z_OK;
						else {

							s.bitb = b;
							s.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							s.write = q;
							return s.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					tindex = (tree_index + (b & inflate_mask[j])) * 3;

					b >>>= (tree[tindex + 1]);
					k -= (tree[tindex + 1]);

					e = tree[tindex];

					if (e === 0) { // literal
						lit = tree[tindex + 2];
						mode = LIT;
						break;
					}
					if ((e & 16) !== 0) { // length
						get = e & 15;
						len = tree[tindex + 2];
						mode = LENEXT;
						break;
					}
					if ((e & 64) === 0) { // next table
						need = e;
						tree_index = tindex / 3 + tree[tindex + 2];
						break;
					}
					if ((e & 32) !== 0) { // end of block
						mode = WASH;
						break;
					}
					mode = BADCODE; // invalid code
					z.msg = "invalid literal/length code";
					r = Z_DATA_ERROR;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;
					return s.inflate_flush(z, r);

				case LENEXT: // i: getting length extra (have base)
					j = get;

					while (k < (j)) {
						if (n !== 0)
							r = Z_OK;
						else {

							s.bitb = b;
							s.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							s.write = q;
							return s.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					len += (b & inflate_mask[j]);

					b >>= j;
					k -= j;

					need = dbits;
					tree = dtree;
					tree_index = dtree_index;
					mode = DIST;
				/* falls through */
				case DIST: // i: get distance next
					j = need;

					while (k < (j)) {
						if (n !== 0)
							r = Z_OK;
						else {

							s.bitb = b;
							s.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							s.write = q;
							return s.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					tindex = (tree_index + (b & inflate_mask[j])) * 3;

					b >>= tree[tindex + 1];
					k -= tree[tindex + 1];

					e = (tree[tindex]);
					if ((e & 16) !== 0) { // distance
						get = e & 15;
						dist = tree[tindex + 2];
						mode = DISTEXT;
						break;
					}
					if ((e & 64) === 0) { // next table
						need = e;
						tree_index = tindex / 3 + tree[tindex + 2];
						break;
					}
					mode = BADCODE; // invalid code
					z.msg = "invalid distance code";
					r = Z_DATA_ERROR;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;
					return s.inflate_flush(z, r);

				case DISTEXT: // i: getting distance extra
					j = get;

					while (k < (j)) {
						if (n !== 0)
							r = Z_OK;
						else {

							s.bitb = b;
							s.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							s.write = q;
							return s.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					dist += (b & inflate_mask[j]);

					b >>= j;
					k -= j;

					mode = COPY;
				/* falls through */
				case COPY: // o: copying bytes in win, waiting for space
					f = q - dist;
					while (f < 0) { // modulo win size-"while" instead
						f += s.end; // of "if" handles invalid distances
					}
					while (len !== 0) {

						if (m === 0) {
							if (q == s.end && s.read !== 0) {
								q = 0;
								m = q < s.read ? s.read - q - 1 : s.end - q;
							}
							if (m === 0) {
								s.write = q;
								r = s.inflate_flush(z, r);
								q = s.write;
								m = q < s.read ? s.read - q - 1 : s.end - q;

								if (q == s.end && s.read !== 0) {
									q = 0;
									m = q < s.read ? s.read - q - 1 : s.end - q;
								}

								if (m === 0) {
									s.bitb = b;
									s.bitk = k;
									z.avail_in = n;
									z.total_in += p - z.next_in_index;
									z.next_in_index = p;
									s.write = q;
									return s.inflate_flush(z, r);
								}
							}
						}

						s.win[q++] = s.win[f++];
						m--;

						if (f == s.end)
							f = 0;
						len--;
					}
					mode = START;
					break;
				case LIT: // o: got literal, waiting for output space
					if (m === 0) {
						if (q == s.end && s.read !== 0) {
							q = 0;
							m = q < s.read ? s.read - q - 1 : s.end - q;
						}
						if (m === 0) {
							s.write = q;
							r = s.inflate_flush(z, r);
							q = s.write;
							m = q < s.read ? s.read - q - 1 : s.end - q;

							if (q == s.end && s.read !== 0) {
								q = 0;
								m = q < s.read ? s.read - q - 1 : s.end - q;
							}
							if (m === 0) {
								s.bitb = b;
								s.bitk = k;
								z.avail_in = n;
								z.total_in += p - z.next_in_index;
								z.next_in_index = p;
								s.write = q;
								return s.inflate_flush(z, r);
							}
						}
					}
					r = Z_OK;

					s.win[q++] = /* (byte) */lit;
					m--;

					mode = START;
					break;
				case WASH: // o: got eob, possibly more output
					if (k > 7) { // return unused byte, if any
						k -= 8;
						n++;
						p--; // can always return one
					}

					s.write = q;
					r = s.inflate_flush(z, r);
					q = s.write;
					m = q < s.read ? s.read - q - 1 : s.end - q;

					if (s.read != s.write) {
						s.bitb = b;
						s.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						s.write = q;
						return s.inflate_flush(z, r);
					}
					mode = END;
				/* falls through */
				case END:
					r = Z_STREAM_END;
					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;
					return s.inflate_flush(z, r);

				case BADCODE: // x: got error

					r = Z_DATA_ERROR;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;
					return s.inflate_flush(z, r);

				default:
					r = Z_STREAM_ERROR;

					s.bitb = b;
					s.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					s.write = q;
					return s.inflate_flush(z, r);
			}
		}
	};

	that.free = function () {
		// ZFREE(z, c);
	};

}

// InfBlocks

// Table for deflate from PKZIP's appnote.txt.
const border = [ // Order of the bit length code lengths
	16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];

const TYPE = 0; // get type bits (3, including end bit)
const LENS = 1; // get lengths for stored
const STORED = 2;// processing stored block
const TABLE = 3; // get table lengths
const BTREE = 4; // get bit lengths tree for a dynamic
// block
const DTREE = 5; // get length, distance trees for a
// dynamic block
const CODES = 6; // processing fixed or dynamic block
const DRY = 7; // output remaining win bytes
const DONELOCKS = 8; // finished last block, done
const BADBLOCKS = 9; // ot a data error--stuck here

function InfBlocks(z, w) {
	const that = this;

	let mode = TYPE; // current inflate_block mode

	let left = 0; // if STORED, bytes left to copy

	let table = 0; // table lengths (14 bits)
	let index = 0; // index into blens (or border)
	let blens; // bit lengths of codes
	const bb = [0]; // bit length tree depth
	const tb = [0]; // bit length decoding tree

	const codes = new InfCodes(); // if CODES, current state

	let last = 0; // true if this block is the last block

	let hufts = new Int32Array(MANY * 3); // single malloc for tree space
	const check = 0; // check on output
	const inftree = new InfTree();

	that.bitk = 0; // bits in bit buffer
	that.bitb = 0; // bit buffer
	that.win = new Uint8Array(w); // sliding win
	that.end = w; // one byte after sliding win
	that.read = 0; // win read pointer
	that.write = 0; // win write pointer

	that.reset = function (z, c) {
		if (c)
			c[0] = check;
		// if (mode == BTREE || mode == DTREE) {
		// }
		if (mode == CODES) {
			codes.free(z);
		}
		mode = TYPE;
		that.bitk = 0;
		that.bitb = 0;
		that.read = that.write = 0;
	};

	that.reset(z, null);

	// copy as much as possible from the sliding win to the output area
	that.inflate_flush = function (z, r) {
		let n;
		let p;
		let q;

		// local copies of source and destination pointers
		p = z.next_out_index;
		q = that.read;

		// compute number of bytes to copy as far as end of win
		n = /* (int) */((q <= that.write ? that.write : that.end) - q);
		if (n > z.avail_out)
			n = z.avail_out;
		if (n !== 0 && r == Z_BUF_ERROR)
			r = Z_OK;

		// update counters
		z.avail_out -= n;
		z.total_out += n;

		// copy as far as end of win
		z.next_out.set(that.win.subarray(q, q + n), p);
		p += n;
		q += n;

		// see if more to copy at beginning of win
		if (q == that.end) {
			// wrap pointers
			q = 0;
			if (that.write == that.end)
				that.write = 0;

			// compute bytes to copy
			n = that.write - q;
			if (n > z.avail_out)
				n = z.avail_out;
			if (n !== 0 && r == Z_BUF_ERROR)
				r = Z_OK;

			// update counters
			z.avail_out -= n;
			z.total_out += n;

			// copy
			z.next_out.set(that.win.subarray(q, q + n), p);
			p += n;
			q += n;
		}

		// update pointers
		z.next_out_index = p;
		that.read = q;

		// done
		return r;
	};

	that.proc = function (z, r) {
		let t; // temporary storage
		let b; // bit buffer
		let k; // bits in bit buffer
		let p; // input data pointer
		let n; // bytes available there
		let q; // output win write pointer
		let m; // bytes to end of win or read pointer

		let i;

		// copy input/output information to locals (UPDATE macro restores)
		// {
		p = z.next_in_index;
		n = z.avail_in;
		b = that.bitb;
		k = that.bitk;
		// }
		// {
		q = that.write;
		m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);
		// }

		// process input based on current state
		// DEBUG dtree
		// eslint-disable-next-line no-constant-condition
		while (true) {
			let bl, bd, tl, td, bl_, bd_, tl_, td_;
			switch (mode) {
				case TYPE:

					while (k < (3)) {
						if (n !== 0) {
							r = Z_OK;
						} else {
							that.bitb = b;
							that.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							that.write = q;
							return that.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}
					t = /* (int) */(b & 7);
					last = t & 1;

					switch (t >>> 1) {
						case 0: // stored
							// {
							b >>>= (3);
							k -= (3);
							// }
							t = k & 7; // go to byte boundary

							// {
							b >>>= (t);
							k -= (t);
							// }
							mode = LENS; // get length of stored block
							break;
						case 1: // fixed
							// {
							bl = []; // new Array(1);
							bd = []; // new Array(1);
							tl = [[]]; // new Array(1);
							td = [[]]; // new Array(1);

							InfTree.inflate_trees_fixed(bl, bd, tl, td);
							codes.init(bl[0], bd[0], tl[0], 0, td[0], 0);
							// }

							// {
							b >>>= (3);
							k -= (3);
							// }

							mode = CODES;
							break;
						case 2: // dynamic

							// {
							b >>>= (3);
							k -= (3);
							// }

							mode = TABLE;
							break;
						case 3: // illegal

							// {
							b >>>= (3);
							k -= (3);
							// }
							mode = BADBLOCKS;
							z.msg = "invalid block type";
							r = Z_DATA_ERROR;

							that.bitb = b;
							that.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							that.write = q;
							return that.inflate_flush(z, r);
					}
					break;
				case LENS:

					while (k < (32)) {
						if (n !== 0) {
							r = Z_OK;
						} else {
							that.bitb = b;
							that.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							that.write = q;
							return that.inflate_flush(z, r);
						}
						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					if ((((~b) >>> 16) & 0xffff) != (b & 0xffff)) {
						mode = BADBLOCKS;
						z.msg = "invalid stored block lengths";
						r = Z_DATA_ERROR;

						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}
					left = (b & 0xffff);
					b = k = 0; // dump bits
					mode = left !== 0 ? STORED : (last !== 0 ? DRY : TYPE);
					break;
				case STORED:
					if (n === 0) {
						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}

					if (m === 0) {
						if (q == that.end && that.read !== 0) {
							q = 0;
							m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);
						}
						if (m === 0) {
							that.write = q;
							r = that.inflate_flush(z, r);
							q = that.write;
							m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);
							if (q == that.end && that.read !== 0) {
								q = 0;
								m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);
							}
							if (m === 0) {
								that.bitb = b;
								that.bitk = k;
								z.avail_in = n;
								z.total_in += p - z.next_in_index;
								z.next_in_index = p;
								that.write = q;
								return that.inflate_flush(z, r);
							}
						}
					}
					r = Z_OK;

					t = left;
					if (t > n)
						t = n;
					if (t > m)
						t = m;
					that.win.set(z.read_buf(p, t), q);
					p += t;
					n -= t;
					q += t;
					m -= t;
					if ((left -= t) !== 0)
						break;
					mode = last !== 0 ? DRY : TYPE;
					break;
				case TABLE:

					while (k < (14)) {
						if (n !== 0) {
							r = Z_OK;
						} else {
							that.bitb = b;
							that.bitk = k;
							z.avail_in = n;
							z.total_in += p - z.next_in_index;
							z.next_in_index = p;
							that.write = q;
							return that.inflate_flush(z, r);
						}

						n--;
						b |= (z.read_byte(p++) & 0xff) << k;
						k += 8;
					}

					table = t = (b & 0x3fff);
					if ((t & 0x1f) > 29 || ((t >> 5) & 0x1f) > 29) {
						mode = BADBLOCKS;
						z.msg = "too many length or distance symbols";
						r = Z_DATA_ERROR;

						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}
					t = 258 + (t & 0x1f) + ((t >> 5) & 0x1f);
					if (!blens || blens.length < t) {
						blens = []; // new Array(t);
					} else {
						for (i = 0; i < t; i++) {
							blens[i] = 0;
						}
					}

					// {
					b >>>= (14);
					k -= (14);
					// }

					index = 0;
					mode = BTREE;
				/* falls through */
				case BTREE:
					while (index < 4 + (table >>> 10)) {
						while (k < (3)) {
							if (n !== 0) {
								r = Z_OK;
							} else {
								that.bitb = b;
								that.bitk = k;
								z.avail_in = n;
								z.total_in += p - z.next_in_index;
								z.next_in_index = p;
								that.write = q;
								return that.inflate_flush(z, r);
							}
							n--;
							b |= (z.read_byte(p++) & 0xff) << k;
							k += 8;
						}

						blens[border[index++]] = b & 7;

						// {
						b >>>= (3);
						k -= (3);
						// }
					}

					while (index < 19) {
						blens[border[index++]] = 0;
					}

					bb[0] = 7;
					t = inftree.inflate_trees_bits(blens, bb, tb, hufts, z);
					if (t != Z_OK) {
						r = t;
						if (r == Z_DATA_ERROR) {
							blens = null;
							mode = BADBLOCKS;
						}

						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}

					index = 0;
					mode = DTREE;
				/* falls through */
				case DTREE:
					// eslint-disable-next-line no-constant-condition
					while (true) {
						t = table;
						if (index >= 258 + (t & 0x1f) + ((t >> 5) & 0x1f)) {
							break;
						}

						let j, c;

						t = bb[0];

						while (k < (t)) {
							if (n !== 0) {
								r = Z_OK;
							} else {
								that.bitb = b;
								that.bitk = k;
								z.avail_in = n;
								z.total_in += p - z.next_in_index;
								z.next_in_index = p;
								that.write = q;
								return that.inflate_flush(z, r);
							}
							n--;
							b |= (z.read_byte(p++) & 0xff) << k;
							k += 8;
						}

						// if (tb[0] == -1) {
						// System.err.println("null...");
						// }

						t = hufts[(tb[0] + (b & inflate_mask[t])) * 3 + 1];
						c = hufts[(tb[0] + (b & inflate_mask[t])) * 3 + 2];

						if (c < 16) {
							b >>>= (t);
							k -= (t);
							blens[index++] = c;
						} else { // c == 16..18
							i = c == 18 ? 7 : c - 14;
							j = c == 18 ? 11 : 3;

							while (k < (t + i)) {
								if (n !== 0) {
									r = Z_OK;
								} else {
									that.bitb = b;
									that.bitk = k;
									z.avail_in = n;
									z.total_in += p - z.next_in_index;
									z.next_in_index = p;
									that.write = q;
									return that.inflate_flush(z, r);
								}
								n--;
								b |= (z.read_byte(p++) & 0xff) << k;
								k += 8;
							}

							b >>>= (t);
							k -= (t);

							j += (b & inflate_mask[i]);

							b >>>= (i);
							k -= (i);

							i = index;
							t = table;
							if (i + j > 258 + (t & 0x1f) + ((t >> 5) & 0x1f) || (c == 16 && i < 1)) {
								blens = null;
								mode = BADBLOCKS;
								z.msg = "invalid bit length repeat";
								r = Z_DATA_ERROR;

								that.bitb = b;
								that.bitk = k;
								z.avail_in = n;
								z.total_in += p - z.next_in_index;
								z.next_in_index = p;
								that.write = q;
								return that.inflate_flush(z, r);
							}

							c = c == 16 ? blens[i - 1] : 0;
							do {
								blens[i++] = c;
							} while (--j !== 0);
							index = i;
						}
					}

					tb[0] = -1;
					// {
					bl_ = []; // new Array(1);
					bd_ = []; // new Array(1);
					tl_ = []; // new Array(1);
					td_ = []; // new Array(1);
					bl_[0] = 9; // must be <= 9 for lookahead assumptions
					bd_[0] = 6; // must be <= 9 for lookahead assumptions

					t = table;
					t = inftree.inflate_trees_dynamic(257 + (t & 0x1f), 1 + ((t >> 5) & 0x1f), blens, bl_, bd_, tl_, td_, hufts, z);

					if (t != Z_OK) {
						if (t == Z_DATA_ERROR) {
							blens = null;
							mode = BADBLOCKS;
						}
						r = t;

						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}
					codes.init(bl_[0], bd_[0], hufts, tl_[0], hufts, td_[0]);
					// }
					mode = CODES;
				/* falls through */
				case CODES:
					that.bitb = b;
					that.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					that.write = q;

					if ((r = codes.proc(that, z, r)) != Z_STREAM_END) {
						return that.inflate_flush(z, r);
					}
					r = Z_OK;
					codes.free(z);

					p = z.next_in_index;
					n = z.avail_in;
					b = that.bitb;
					k = that.bitk;
					q = that.write;
					m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);

					if (last === 0) {
						mode = TYPE;
						break;
					}
					mode = DRY;
				/* falls through */
				case DRY:
					that.write = q;
					r = that.inflate_flush(z, r);
					q = that.write;
					m = /* (int) */(q < that.read ? that.read - q - 1 : that.end - q);
					if (that.read != that.write) {
						that.bitb = b;
						that.bitk = k;
						z.avail_in = n;
						z.total_in += p - z.next_in_index;
						z.next_in_index = p;
						that.write = q;
						return that.inflate_flush(z, r);
					}
					mode = DONELOCKS;
				/* falls through */
				case DONELOCKS:
					r = Z_STREAM_END;

					that.bitb = b;
					that.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					that.write = q;
					return that.inflate_flush(z, r);
				case BADBLOCKS:
					r = Z_DATA_ERROR;

					that.bitb = b;
					that.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					that.write = q;
					return that.inflate_flush(z, r);

				default:
					r = Z_STREAM_ERROR;

					that.bitb = b;
					that.bitk = k;
					z.avail_in = n;
					z.total_in += p - z.next_in_index;
					z.next_in_index = p;
					that.write = q;
					return that.inflate_flush(z, r);
			}
		}
	};

	that.free = function (z) {
		that.reset(z, null);
		that.win = null;
		hufts = null;
		// ZFREE(z, s);
	};

	that.set_dictionary = function (d, start, n) {
		that.win.set(d.subarray(start, start + n), 0);
		that.read = that.write = n;
	};

	// Returns true if inflate is currently at the end of a block generated
	// by Z_SYNC_FLUSH or Z_FULL_FLUSH.
	that.sync_point = function () {
		return mode == LENS ? 1 : 0;
	};

}

// Inflate

// preset dictionary flag in zlib header
const PRESET_DICT = 0x20;

const Z_DEFLATED = 8;

const METHOD = 0; // waiting for method byte
const FLAG = 1; // waiting for flag byte
const DICT4 = 2; // four dictionary check bytes to go
const DICT3 = 3; // three dictionary check bytes to go
const DICT2 = 4; // two dictionary check bytes to go
const DICT1 = 5; // one dictionary check byte to go
const DICT0 = 6; // waiting for inflateSetDictionary
const BLOCKS = 7; // decompressing blocks
const DONE = 12; // finished check, done
const BAD = 13; // got an error--stay here

const mark = [0, 0, 0xff, 0xff];

function Inflate() {
	const that = this;

	that.mode = 0; // current inflate mode

	// mode dependent information
	that.method = 0; // if FLAGS, method byte

	// if CHECK, check values to compare
	that.was = [0]; // new Array(1); // computed check value
	that.need = 0; // stream check value

	// if BAD, inflateSync's marker bytes count
	that.marker = 0;

	// mode independent information
	that.wbits = 0; // log2(win size) (8..15, defaults to 15)

	// this.blocks; // current inflate_blocks state

	function inflateReset(z) {
		if (!z || !z.istate)
			return Z_STREAM_ERROR;

		z.total_in = z.total_out = 0;
		z.msg = null;
		z.istate.mode = BLOCKS;
		z.istate.blocks.reset(z, null);
		return Z_OK;
	}

	that.inflateEnd = function (z) {
		if (that.blocks)
			that.blocks.free(z);
		that.blocks = null;
		// ZFREE(z, z->state);
		return Z_OK;
	};

	that.inflateInit = function (z, w) {
		z.msg = null;
		that.blocks = null;

		// set win size
		if (w < 8 || w > 15) {
			that.inflateEnd(z);
			return Z_STREAM_ERROR;
		}
		that.wbits = w;

		z.istate.blocks = new InfBlocks(z, 1 << w);

		// reset state
		inflateReset(z);
		return Z_OK;
	};

	that.inflate = function (z, f) {
		let r;
		let b;

		if (!z || !z.istate || !z.next_in)
			return Z_STREAM_ERROR;
		const istate = z.istate;
		f = f == Z_FINISH ? Z_BUF_ERROR : Z_OK;
		r = Z_BUF_ERROR;
		// eslint-disable-next-line no-constant-condition
		while (true) {
			switch (istate.mode) {
				case METHOD:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					if (((istate.method = z.read_byte(z.next_in_index++)) & 0xf) != Z_DEFLATED) {
						istate.mode = BAD;
						z.msg = "unknown compression method";
						istate.marker = 5; // can't try inflateSync
						break;
					}
					if ((istate.method >> 4) + 8 > istate.wbits) {
						istate.mode = BAD;
						z.msg = "invalid win size";
						istate.marker = 5; // can't try inflateSync
						break;
					}
					istate.mode = FLAG;
				/* falls through */
				case FLAG:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					b = (z.read_byte(z.next_in_index++)) & 0xff;

					if ((((istate.method << 8) + b) % 31) !== 0) {
						istate.mode = BAD;
						z.msg = "incorrect header check";
						istate.marker = 5; // can't try inflateSync
						break;
					}

					if ((b & PRESET_DICT) === 0) {
						istate.mode = BLOCKS;
						break;
					}
					istate.mode = DICT4;
				/* falls through */
				case DICT4:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					istate.need = ((z.read_byte(z.next_in_index++) & 0xff) << 24) & 0xff000000;
					istate.mode = DICT3;
				/* falls through */
				case DICT3:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					istate.need += ((z.read_byte(z.next_in_index++) & 0xff) << 16) & 0xff0000;
					istate.mode = DICT2;
				/* falls through */
				case DICT2:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					istate.need += ((z.read_byte(z.next_in_index++) & 0xff) << 8) & 0xff00;
					istate.mode = DICT1;
				/* falls through */
				case DICT1:

					if (z.avail_in === 0)
						return r;
					r = f;

					z.avail_in--;
					z.total_in++;
					istate.need += (z.read_byte(z.next_in_index++) & 0xff);
					istate.mode = DICT0;
					return Z_NEED_DICT;
				case DICT0:
					istate.mode = BAD;
					z.msg = "need dictionary";
					istate.marker = 0; // can try inflateSync
					return Z_STREAM_ERROR;
				case BLOCKS:

					r = istate.blocks.proc(z, r);
					if (r == Z_DATA_ERROR) {
						istate.mode = BAD;
						istate.marker = 0; // can try inflateSync
						break;
					}
					if (r == Z_OK) {
						r = f;
					}
					if (r != Z_STREAM_END) {
						return r;
					}
					r = f;
					istate.blocks.reset(z, istate.was);
					istate.mode = DONE;
				/* falls through */
				case DONE:
					z.avail_in = 0;
					return Z_STREAM_END;
				case BAD:
					return Z_DATA_ERROR;
				default:
					return Z_STREAM_ERROR;
			}
		}
	};

	that.inflateSetDictionary = function (z, dictionary, dictLength) {
		let index = 0, length = dictLength;
		if (!z || !z.istate || z.istate.mode != DICT0)
			return Z_STREAM_ERROR;
		const istate = z.istate;
		if (length >= (1 << istate.wbits)) {
			length = (1 << istate.wbits) - 1;
			index = dictLength - length;
		}
		istate.blocks.set_dictionary(dictionary, index, length);
		istate.mode = BLOCKS;
		return Z_OK;
	};

	that.inflateSync = function (z) {
		let n; // number of bytes to look at
		let p; // pointer to bytes
		let m; // number of marker bytes found in a row
		let r, w; // temporaries to save total_in and total_out

		// set up
		if (!z || !z.istate)
			return Z_STREAM_ERROR;
		const istate = z.istate;
		if (istate.mode != BAD) {
			istate.mode = BAD;
			istate.marker = 0;
		}
		if ((n = z.avail_in) === 0)
			return Z_BUF_ERROR;
		p = z.next_in_index;
		m = istate.marker;

		// search
		while (n !== 0 && m < 4) {
			if (z.read_byte(p) == mark[m]) {
				m++;
			} else if (z.read_byte(p) !== 0) {
				m = 0;
			} else {
				m = 4 - m;
			}
			p++;
			n--;
		}

		// restore
		z.total_in += p - z.next_in_index;
		z.next_in_index = p;
		z.avail_in = n;
		istate.marker = m;

		// return no joy or set up to restart on a new block
		if (m != 4) {
			return Z_DATA_ERROR;
		}
		r = z.total_in;
		w = z.total_out;
		inflateReset(z);
		z.total_in = r;
		z.total_out = w;
		istate.mode = BLOCKS;
		return Z_OK;
	};

	// Returns true if inflate is currently at the end of a block generated
	// by Z_SYNC_FLUSH or Z_FULL_FLUSH. This function is used by one PPP
	// implementation to provide an additional safety check. PPP uses
	// Z_SYNC_FLUSH
	// but removes the length bytes of the resulting empty stored block. When
	// decompressing, PPP checks that at the end of input packet, inflate is
	// waiting for these length bytes.
	that.inflateSyncPoint = function (z) {
		if (!z || !z.istate || !z.istate.blocks)
			return Z_STREAM_ERROR;
		return z.istate.blocks.sync_point();
	};
}

// ZStream

function ZStream() {
}

ZStream.prototype = {
	inflateInit(bits) {
		const that = this;
		that.istate = new Inflate();
		if (!bits)
			bits = MAX_BITS;
		return that.istate.inflateInit(that, bits);
	},

	inflate(f) {
		const that = this;
		if (!that.istate)
			return Z_STREAM_ERROR;
		return that.istate.inflate(that, f);
	},

	inflateEnd() {
		const that = this;
		if (!that.istate)
			return Z_STREAM_ERROR;
		const ret = that.istate.inflateEnd(that);
		that.istate = null;
		return ret;
	},

	inflateSync() {
		const that = this;
		if (!that.istate)
			return Z_STREAM_ERROR;
		return that.istate.inflateSync(that);
	},
	inflateSetDictionary(dictionary, dictLength) {
		const that = this;
		if (!that.istate)
			return Z_STREAM_ERROR;
		return that.istate.inflateSetDictionary(that, dictionary, dictLength);
	},
	read_byte(start) {
		const that = this;
		return that.next_in[start];
	},
	read_buf(start, size) {
		const that = this;
		return that.next_in.subarray(start, start + size);
	}
};

// Inflater

function ZipInflate(options) {
	const that = this;
	const z = new ZStream();
	const bufsize = options && options.chunkSize ? Math.floor(options.chunkSize * 2) : 128 * 1024;
	const flush = Z_NO_FLUSH;
	const buf = new Uint8Array(bufsize);
	let nomoreinput = false;

	z.inflateInit();
	z.next_out = buf;

	that.append = function (data, onprogress) {
		const buffers = [];
		let err, array, lastIndex = 0, bufferIndex = 0, bufferSize = 0;
		if (data.length === 0)
			return;
		z.next_in_index = 0;
		z.next_in = data;
		z.avail_in = data.length;
		do {
			z.next_out_index = 0;
			z.avail_out = bufsize;
			if ((z.avail_in === 0) && (!nomoreinput)) { // if buffer is empty and more input is available, refill it
				z.next_in_index = 0;
				nomoreinput = true;
			}
			err = z.inflate(flush);
			if (nomoreinput && (err === Z_BUF_ERROR)) {
				if (z.avail_in !== 0)
					throw new Error("inflating: bad input");
			} else if (err !== Z_OK && err !== Z_STREAM_END)
				throw new Error("inflating: " + z.msg);
			if ((nomoreinput || err === Z_STREAM_END) && (z.avail_in === data.length))
				throw new Error("inflating: bad input");
			if (z.next_out_index)
				if (z.next_out_index === bufsize)
					buffers.push(new Uint8Array(buf));
				else
					buffers.push(buf.subarray(0, z.next_out_index));
			bufferSize += z.next_out_index;
			if (onprogress && z.next_in_index > 0 && z.next_in_index != lastIndex) {
				onprogress(z.next_in_index);
				lastIndex = z.next_in_index;
			}
		} while (z.avail_in > 0 || z.avail_out === 0);
		if (buffers.length > 1) {
			array = new Uint8Array(bufferSize);
			buffers.forEach(function (chunk) {
				array.set(chunk, bufferIndex);
				bufferIndex += chunk.length;
			});
		} else {
			array = buffers[0] ? new Uint8Array(buffers[0]) : new Uint8Array();
		}
		return array;
	};
	that.flush = function () {
		z.inflateEnd();
	};
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

const MAX_32_BITS = 0xffffffff;
const MAX_16_BITS = 0xffff;
const COMPRESSION_METHOD_DEFLATE = 0x08;
const COMPRESSION_METHOD_STORE = 0x00;
const COMPRESSION_METHOD_AES = 0x63;

const LOCAL_FILE_HEADER_SIGNATURE = 0x04034b50;
const SPLIT_ZIP_FILE_SIGNATURE = 0x08074b50;
const DATA_DESCRIPTOR_RECORD_SIGNATURE = SPLIT_ZIP_FILE_SIGNATURE;
const CENTRAL_FILE_HEADER_SIGNATURE = 0x02014b50;
const END_OF_CENTRAL_DIR_SIGNATURE = 0x06054b50;
const ZIP64_END_OF_CENTRAL_DIR_SIGNATURE = 0x06064b50;
const ZIP64_END_OF_CENTRAL_DIR_LOCATOR_SIGNATURE = 0x07064b50;
const END_OF_CENTRAL_DIR_LENGTH = 22;
const ZIP64_END_OF_CENTRAL_DIR_LOCATOR_LENGTH = 20;
const ZIP64_END_OF_CENTRAL_DIR_LENGTH = 56;
const ZIP64_END_OF_CENTRAL_DIR_TOTAL_LENGTH = END_OF_CENTRAL_DIR_LENGTH + ZIP64_END_OF_CENTRAL_DIR_LOCATOR_LENGTH + ZIP64_END_OF_CENTRAL_DIR_LENGTH;

const EXTRAFIELD_TYPE_ZIP64 = 0x0001;
const EXTRAFIELD_TYPE_AES = 0x9901;
const EXTRAFIELD_TYPE_NTFS = 0x000a;
const EXTRAFIELD_TYPE_NTFS_TAG1 = 0x0001;
const EXTRAFIELD_TYPE_EXTENDED_TIMESTAMP = 0x5455;
const EXTRAFIELD_TYPE_USDZ = 0x1986;

const BITFLAG_ENCRYPTED = 0x01;
const BITFLAG_DATA_DESCRIPTOR = 0x0008;
const BITFLAG_LANG_ENCODING_FLAG = 0x0800;
const FILE_ATTR_MSDOS_DIR_MASK = 0x10;

const VERSION_DEFLATE = 0x14;
const VERSION_ZIP64 = 0x2D;
const VERSION_AES = 0x33;

const DIRECTORY_SIGNATURE = "/";

const MAX_DATE = new Date(2107, 11, 31);
const MIN_DATE = new Date(1980, 0, 1);

const UNDEFINED_VALUE = undefined;
const UNDEFINED_TYPE = "undefined";
const FUNCTION_TYPE = "function";

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


class StreamAdapter {

	constructor(Codec) {
		return class extends TransformStream {
			constructor(_format, options) {
				const codec = new Codec(options);
				super({
					transform(chunk, controller) {
						controller.enqueue(codec.append(chunk));
					},
					flush(controller) {
						const chunk = codec.flush();
						if (chunk) {
							controller.enqueue(chunk);
						}
					}
				});
			}
		};
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const MINIMUM_CHUNK_SIZE = 64;
let maxWorkers = 2;
try {
	if (typeof navigator != UNDEFINED_TYPE && navigator.hardwareConcurrency) {
		maxWorkers = navigator.hardwareConcurrency;
	}
} catch (_error) {
	// ignored
}
const DEFAULT_CONFIGURATION = {
	chunkSize: 512 * 1024,
	maxWorkers,
	terminateWorkerTimeout: 5000,
	useWebWorkers: true,
	useCompressionStream: true,
	workerScripts: UNDEFINED_VALUE,
	CompressionStreamNative: typeof CompressionStream != UNDEFINED_TYPE && CompressionStream,
	DecompressionStreamNative: typeof DecompressionStream != UNDEFINED_TYPE && DecompressionStream
};

const config = Object.assign({}, DEFAULT_CONFIGURATION);

function getConfiguration() {
	return config;
}

function getChunkSize(config) {
	return Math.max(config.chunkSize, MINIMUM_CHUNK_SIZE);
}

function configure(configuration) {
	const {
		baseURL,
		chunkSize,
		maxWorkers,
		terminateWorkerTimeout,
		useCompressionStream,
		useWebWorkers,
		Deflate,
		Inflate,
		CompressionStream,
		DecompressionStream,
		workerScripts
	} = configuration;
	setIfDefined("baseURL", baseURL);
	setIfDefined("chunkSize", chunkSize);
	setIfDefined("maxWorkers", maxWorkers);
	setIfDefined("terminateWorkerTimeout", terminateWorkerTimeout);
	setIfDefined("useCompressionStream", useCompressionStream);
	setIfDefined("useWebWorkers", useWebWorkers);
	if (Deflate) {
		config.CompressionStream = new StreamAdapter(Deflate);
	}
	if (Inflate) {
		config.DecompressionStream = new StreamAdapter(Inflate);
	}
	setIfDefined("CompressionStream", CompressionStream);
	setIfDefined("DecompressionStream", DecompressionStream);
	if (workerScripts !== UNDEFINED_VALUE) {
		const { deflate, inflate } = workerScripts;
		if (deflate || inflate) {
			if (!config.workerScripts) {
				config.workerScripts = {};
			}
		}
		if (deflate) {
			if (!Array.isArray(deflate)) {
				throw new Error("workerScripts.deflate must be an array");
			}
			config.workerScripts.deflate = deflate;
		}
		if (inflate) {
			if (!Array.isArray(inflate)) {
				throw new Error("workerScripts.inflate must be an array");
			}
			config.workerScripts.inflate = inflate;
		}
	}
}

function setIfDefined(propertyName, propertyValue) {
	if (propertyValue !== UNDEFINED_VALUE) {
		config[propertyName] = propertyValue;
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const table$1 = {
	"application": {
		"andrew-inset": "ez",
		"annodex": "anx",
		"atom+xml": "atom",
		"atomcat+xml": "atomcat",
		"atomserv+xml": "atomsrv",
		"bbolin": "lin",
		"cu-seeme": "cu",
		"davmount+xml": "davmount",
		"dsptype": "tsp",
		"ecmascript": [
			"es",
			"ecma"
		],
		"futuresplash": "spl",
		"hta": "hta",
		"java-archive": "jar",
		"java-serialized-object": "ser",
		"java-vm": "class",
		"m3g": "m3g",
		"mac-binhex40": "hqx",
		"mathematica": [
			"nb",
			"ma",
			"mb"
		],
		"msaccess": "mdb",
		"msword": [
			"doc",
			"dot",
			"wiz"
		],
		"mxf": "mxf",
		"oda": "oda",
		"ogg": "ogx",
		"pdf": "pdf",
		"pgp-keys": "key",
		"pgp-signature": [
			"asc",
			"sig"
		],
		"pics-rules": "prf",
		"postscript": [
			"ps",
			"ai",
			"eps",
			"epsi",
			"epsf",
			"eps2",
			"eps3"
		],
		"rar": "rar",
		"rdf+xml": "rdf",
		"rss+xml": "rss",
		"rtf": "rtf",
		"xhtml+xml": [
			"xhtml",
			"xht"
		],
		"xml": [
			"xml",
			"xsl",
			"xsd",
			"xpdl"
		],
		"xspf+xml": "xspf",
		"zip": "zip",
		"vnd.android.package-archive": "apk",
		"vnd.cinderella": "cdy",
		"vnd.google-earth.kml+xml": "kml",
		"vnd.google-earth.kmz": "kmz",
		"vnd.mozilla.xul+xml": "xul",
		"vnd.ms-excel": [
			"xls",
			"xlb",
			"xlt",
			"xlm",
			"xla",
			"xlc",
			"xlw"
		],
		"vnd.ms-pki.seccat": "cat",
		"vnd.ms-pki.stl": "stl",
		"vnd.ms-powerpoint": [
			"ppt",
			"pps",
			"pot",
			"ppa",
			"pwz"
		],
		"vnd.oasis.opendocument.chart": "odc",
		"vnd.oasis.opendocument.database": "odb",
		"vnd.oasis.opendocument.formula": "odf",
		"vnd.oasis.opendocument.graphics": "odg",
		"vnd.oasis.opendocument.graphics-template": "otg",
		"vnd.oasis.opendocument.image": "odi",
		"vnd.oasis.opendocument.presentation": "odp",
		"vnd.oasis.opendocument.presentation-template": "otp",
		"vnd.oasis.opendocument.spreadsheet": "ods",
		"vnd.oasis.opendocument.spreadsheet-template": "ots",
		"vnd.oasis.opendocument.text": "odt",
		"vnd.oasis.opendocument.text-master": [
			"odm",
			"otm"
		],
		"vnd.oasis.opendocument.text-template": "ott",
		"vnd.oasis.opendocument.text-web": "oth",
		"vnd.openxmlformats-officedocument.spreadsheetml.sheet": "xlsx",
		"vnd.openxmlformats-officedocument.spreadsheetml.template": "xltx",
		"vnd.openxmlformats-officedocument.presentationml.presentation": "pptx",
		"vnd.openxmlformats-officedocument.presentationml.slideshow": "ppsx",
		"vnd.openxmlformats-officedocument.presentationml.template": "potx",
		"vnd.openxmlformats-officedocument.wordprocessingml.document": "docx",
		"vnd.openxmlformats-officedocument.wordprocessingml.template": "dotx",
		"vnd.smaf": "mmf",
		"vnd.stardivision.calc": "sdc",
		"vnd.stardivision.chart": "sds",
		"vnd.stardivision.draw": "sda",
		"vnd.stardivision.impress": "sdd",
		"vnd.stardivision.math": [
			"sdf",
			"smf"
		],
		"vnd.stardivision.writer": [
			"sdw",
			"vor"
		],
		"vnd.stardivision.writer-global": "sgl",
		"vnd.sun.xml.calc": "sxc",
		"vnd.sun.xml.calc.template": "stc",
		"vnd.sun.xml.draw": "sxd",
		"vnd.sun.xml.draw.template": "std",
		"vnd.sun.xml.impress": "sxi",
		"vnd.sun.xml.impress.template": "sti",
		"vnd.sun.xml.math": "sxm",
		"vnd.sun.xml.writer": "sxw",
		"vnd.sun.xml.writer.global": "sxg",
		"vnd.sun.xml.writer.template": "stw",
		"vnd.symbian.install": [
			"sis",
			"sisx"
		],
		"vnd.visio": [
			"vsd",
			"vst",
			"vss",
			"vsw",
			"vsdx",
			"vssx",
			"vstx",
			"vssm",
			"vstm"
		],
		"vnd.wap.wbxml": "wbxml",
		"vnd.wap.wmlc": "wmlc",
		"vnd.wap.wmlscriptc": "wmlsc",
		"vnd.wordperfect": "wpd",
		"vnd.wordperfect5.1": "wp5",
		"x-123": "wk",
		"x-7z-compressed": "7z",
		"x-abiword": "abw",
		"x-apple-diskimage": "dmg",
		"x-bcpio": "bcpio",
		"x-bittorrent": "torrent",
		"x-cbr": [
			"cbr",
			"cba",
			"cbt",
			"cb7"
		],
		"x-cbz": "cbz",
		"x-cdf": [
			"cdf",
			"cda"
		],
		"x-cdlink": "vcd",
		"x-chess-pgn": "pgn",
		"x-cpio": "cpio",
		"x-csh": "csh",
		"x-director": [
			"dir",
			"dxr",
			"cst",
			"cct",
			"cxt",
			"w3d",
			"fgd",
			"swa"
		],
		"x-dms": "dms",
		"x-doom": "wad",
		"x-dvi": "dvi",
		"x-httpd-eruby": "rhtml",
		"x-font": "pcf.Z",
		"x-freemind": "mm",
		"x-gnumeric": "gnumeric",
		"x-go-sgf": "sgf",
		"x-graphing-calculator": "gcf",
		"x-gtar": [
			"gtar",
			"taz"
		],
		"x-hdf": "hdf",
		"x-httpd-php": [
			"phtml",
			"pht",
			"php"
		],
		"x-httpd-php-source": "phps",
		"x-httpd-php3": "php3",
		"x-httpd-php3-preprocessed": "php3p",
		"x-httpd-php4": "php4",
		"x-httpd-php5": "php5",
		"x-ica": "ica",
		"x-info": "info",
		"x-internet-signup": [
			"ins",
			"isp"
		],
		"x-iphone": "iii",
		"x-iso9660-image": "iso",
		"x-java-jnlp-file": "jnlp",
		"x-jmol": "jmz",
		"x-killustrator": "kil",
		"x-latex": "latex",
		"x-lyx": "lyx",
		"x-lzx": "lzx",
		"x-maker": [
			"frm",
			"fb",
			"fbdoc"
		],
		"x-ms-wmd": "wmd",
		"x-msdos-program": [
			"com",
			"exe",
			"bat",
			"dll"
		],
		"x-netcdf": [
			"nc"
		],
		"x-ns-proxy-autoconfig": [
			"pac",
			"dat"
		],
		"x-nwc": "nwc",
		"x-object": "o",
		"x-oz-application": "oza",
		"x-pkcs7-certreqresp": "p7r",
		"x-python-code": [
			"pyc",
			"pyo"
		],
		"x-qgis": [
			"qgs",
			"shp",
			"shx"
		],
		"x-quicktimeplayer": "qtl",
		"x-redhat-package-manager": [
			"rpm",
			"rpa"
		],
		"x-ruby": "rb",
		"x-sh": "sh",
		"x-shar": "shar",
		"x-shockwave-flash": [
			"swf",
			"swfl"
		],
		"x-silverlight": "scr",
		"x-stuffit": "sit",
		"x-sv4cpio": "sv4cpio",
		"x-sv4crc": "sv4crc",
		"x-tar": "tar",
		"x-tex-gf": "gf",
		"x-tex-pk": "pk",
		"x-texinfo": [
			"texinfo",
			"texi"
		],
		"x-trash": [
			"~",
			"%",
			"bak",
			"old",
			"sik"
		],
		"x-ustar": "ustar",
		"x-wais-source": "src",
		"x-wingz": "wz",
		"x-x509-ca-cert": [
			"crt",
			"der",
			"cer"
		],
		"x-xcf": "xcf",
		"x-xfig": "fig",
		"x-xpinstall": "xpi",
		"applixware": "aw",
		"atomsvc+xml": "atomsvc",
		"ccxml+xml": "ccxml",
		"cdmi-capability": "cdmia",
		"cdmi-container": "cdmic",
		"cdmi-domain": "cdmid",
		"cdmi-object": "cdmio",
		"cdmi-queue": "cdmiq",
		"docbook+xml": "dbk",
		"dssc+der": "dssc",
		"dssc+xml": "xdssc",
		"emma+xml": "emma",
		"epub+zip": "epub",
		"exi": "exi",
		"font-tdpfr": "pfr",
		"gml+xml": "gml",
		"gpx+xml": "gpx",
		"gxf": "gxf",
		"hyperstudio": "stk",
		"inkml+xml": [
			"ink",
			"inkml"
		],
		"ipfix": "ipfix",
		"jsonml+json": "jsonml",
		"lost+xml": "lostxml",
		"mads+xml": "mads",
		"marc": "mrc",
		"marcxml+xml": "mrcx",
		"mathml+xml": [
			"mathml",
			"mml"
		],
		"mbox": "mbox",
		"mediaservercontrol+xml": "mscml",
		"metalink+xml": "metalink",
		"metalink4+xml": "meta4",
		"mets+xml": "mets",
		"mods+xml": "mods",
		"mp21": [
			"m21",
			"mp21"
		],
		"mp4": "mp4s",
		"oebps-package+xml": "opf",
		"omdoc+xml": "omdoc",
		"onenote": [
			"onetoc",
			"onetoc2",
			"onetmp",
			"onepkg"
		],
		"oxps": "oxps",
		"patch-ops-error+xml": "xer",
		"pgp-encrypted": "pgp",
		"pkcs10": "p10",
		"pkcs7-mime": [
			"p7m",
			"p7c"
		],
		"pkcs7-signature": "p7s",
		"pkcs8": "p8",
		"pkix-attr-cert": "ac",
		"pkix-crl": "crl",
		"pkix-pkipath": "pkipath",
		"pkixcmp": "pki",
		"pls+xml": "pls",
		"prs.cww": "cww",
		"pskc+xml": "pskcxml",
		"reginfo+xml": "rif",
		"relax-ng-compact-syntax": "rnc",
		"resource-lists+xml": "rl",
		"resource-lists-diff+xml": "rld",
		"rls-services+xml": "rs",
		"rpki-ghostbusters": "gbr",
		"rpki-manifest": "mft",
		"rpki-roa": "roa",
		"rsd+xml": "rsd",
		"sbml+xml": "sbml",
		"scvp-cv-request": "scq",
		"scvp-cv-response": "scs",
		"scvp-vp-request": "spq",
		"scvp-vp-response": "spp",
		"sdp": "sdp",
		"set-payment-initiation": "setpay",
		"set-registration-initiation": "setreg",
		"shf+xml": "shf",
		"sparql-query": "rq",
		"sparql-results+xml": "srx",
		"srgs": "gram",
		"srgs+xml": "grxml",
		"sru+xml": "sru",
		"ssdl+xml": "ssdl",
		"ssml+xml": "ssml",
		"tei+xml": [
			"tei",
			"teicorpus"
		],
		"thraud+xml": "tfi",
		"timestamped-data": "tsd",
		"vnd.3gpp.pic-bw-large": "plb",
		"vnd.3gpp.pic-bw-small": "psb",
		"vnd.3gpp.pic-bw-var": "pvb",
		"vnd.3gpp2.tcap": "tcap",
		"vnd.3m.post-it-notes": "pwn",
		"vnd.accpac.simply.aso": "aso",
		"vnd.accpac.simply.imp": "imp",
		"vnd.acucobol": "acu",
		"vnd.acucorp": [
			"atc",
			"acutc"
		],
		"vnd.adobe.air-application-installer-package+zip": "air",
		"vnd.adobe.formscentral.fcdt": "fcdt",
		"vnd.adobe.fxp": [
			"fxp",
			"fxpl"
		],
		"vnd.adobe.xdp+xml": "xdp",
		"vnd.adobe.xfdf": "xfdf",
		"vnd.ahead.space": "ahead",
		"vnd.airzip.filesecure.azf": "azf",
		"vnd.airzip.filesecure.azs": "azs",
		"vnd.amazon.ebook": "azw",
		"vnd.americandynamics.acc": "acc",
		"vnd.amiga.ami": "ami",
		"vnd.anser-web-certificate-issue-initiation": "cii",
		"vnd.anser-web-funds-transfer-initiation": "fti",
		"vnd.antix.game-component": "atx",
		"vnd.apple.installer+xml": "mpkg",
		"vnd.apple.mpegurl": "m3u8",
		"vnd.aristanetworks.swi": "swi",
		"vnd.astraea-software.iota": "iota",
		"vnd.audiograph": "aep",
		"vnd.blueice.multipass": "mpm",
		"vnd.bmi": "bmi",
		"vnd.businessobjects": "rep",
		"vnd.chemdraw+xml": "cdxml",
		"vnd.chipnuts.karaoke-mmd": "mmd",
		"vnd.claymore": "cla",
		"vnd.cloanto.rp9": "rp9",
		"vnd.clonk.c4group": [
			"c4g",
			"c4d",
			"c4f",
			"c4p",
			"c4u"
		],
		"vnd.cluetrust.cartomobile-config": "c11amc",
		"vnd.cluetrust.cartomobile-config-pkg": "c11amz",
		"vnd.commonspace": "csp",
		"vnd.contact.cmsg": "cdbcmsg",
		"vnd.cosmocaller": "cmc",
		"vnd.crick.clicker": "clkx",
		"vnd.crick.clicker.keyboard": "clkk",
		"vnd.crick.clicker.palette": "clkp",
		"vnd.crick.clicker.template": "clkt",
		"vnd.crick.clicker.wordbank": "clkw",
		"vnd.criticaltools.wbs+xml": "wbs",
		"vnd.ctc-posml": "pml",
		"vnd.cups-ppd": "ppd",
		"vnd.curl.car": "car",
		"vnd.curl.pcurl": "pcurl",
		"vnd.dart": "dart",
		"vnd.data-vision.rdz": "rdz",
		"vnd.dece.data": [
			"uvf",
			"uvvf",
			"uvd",
			"uvvd"
		],
		"vnd.dece.ttml+xml": [
			"uvt",
			"uvvt"
		],
		"vnd.dece.unspecified": [
			"uvx",
			"uvvx"
		],
		"vnd.dece.zip": [
			"uvz",
			"uvvz"
		],
		"vnd.denovo.fcselayout-link": "fe_launch",
		"vnd.dna": "dna",
		"vnd.dolby.mlp": "mlp",
		"vnd.dpgraph": "dpg",
		"vnd.dreamfactory": "dfac",
		"vnd.ds-keypoint": "kpxx",
		"vnd.dvb.ait": "ait",
		"vnd.dvb.service": "svc",
		"vnd.dynageo": "geo",
		"vnd.ecowin.chart": "mag",
		"vnd.enliven": "nml",
		"vnd.epson.esf": "esf",
		"vnd.epson.msf": "msf",
		"vnd.epson.quickanime": "qam",
		"vnd.epson.salt": "slt",
		"vnd.epson.ssf": "ssf",
		"vnd.eszigno3+xml": [
			"es3",
			"et3"
		],
		"vnd.ezpix-album": "ez2",
		"vnd.ezpix-package": "ez3",
		"vnd.fdf": "fdf",
		"vnd.fdsn.mseed": "mseed",
		"vnd.fdsn.seed": [
			"seed",
			"dataless"
		],
		"vnd.flographit": "gph",
		"vnd.fluxtime.clip": "ftc",
		"vnd.framemaker": [
			"fm",
			"frame",
			"maker",
			"book"
		],
		"vnd.frogans.fnc": "fnc",
		"vnd.frogans.ltf": "ltf",
		"vnd.fsc.weblaunch": "fsc",
		"vnd.fujitsu.oasys": "oas",
		"vnd.fujitsu.oasys2": "oa2",
		"vnd.fujitsu.oasys3": "oa3",
		"vnd.fujitsu.oasysgp": "fg5",
		"vnd.fujitsu.oasysprs": "bh2",
		"vnd.fujixerox.ddd": "ddd",
		"vnd.fujixerox.docuworks": "xdw",
		"vnd.fujixerox.docuworks.binder": "xbd",
		"vnd.fuzzysheet": "fzs",
		"vnd.genomatix.tuxedo": "txd",
		"vnd.geogebra.file": "ggb",
		"vnd.geogebra.tool": "ggt",
		"vnd.geometry-explorer": [
			"gex",
			"gre"
		],
		"vnd.geonext": "gxt",
		"vnd.geoplan": "g2w",
		"vnd.geospace": "g3w",
		"vnd.gmx": "gmx",
		"vnd.grafeq": [
			"gqf",
			"gqs"
		],
		"vnd.groove-account": "gac",
		"vnd.groove-help": "ghf",
		"vnd.groove-identity-message": "gim",
		"vnd.groove-injector": "grv",
		"vnd.groove-tool-message": "gtm",
		"vnd.groove-tool-template": "tpl",
		"vnd.groove-vcard": "vcg",
		"vnd.hal+xml": "hal",
		"vnd.handheld-entertainment+xml": "zmm",
		"vnd.hbci": "hbci",
		"vnd.hhe.lesson-player": "les",
		"vnd.hp-hpgl": "hpgl",
		"vnd.hp-hpid": "hpid",
		"vnd.hp-hps": "hps",
		"vnd.hp-jlyt": "jlt",
		"vnd.hp-pcl": "pcl",
		"vnd.hp-pclxl": "pclxl",
		"vnd.hydrostatix.sof-data": "sfd-hdstx",
		"vnd.ibm.minipay": "mpy",
		"vnd.ibm.modcap": [
			"afp",
			"listafp",
			"list3820"
		],
		"vnd.ibm.rights-management": "irm",
		"vnd.ibm.secure-container": "sc",
		"vnd.iccprofile": [
			"icc",
			"icm"
		],
		"vnd.igloader": "igl",
		"vnd.immervision-ivp": "ivp",
		"vnd.immervision-ivu": "ivu",
		"vnd.insors.igm": "igm",
		"vnd.intercon.formnet": [
			"xpw",
			"xpx"
		],
		"vnd.intergeo": "i2g",
		"vnd.intu.qbo": "qbo",
		"vnd.intu.qfx": "qfx",
		"vnd.ipunplugged.rcprofile": "rcprofile",
		"vnd.irepository.package+xml": "irp",
		"vnd.is-xpr": "xpr",
		"vnd.isac.fcs": "fcs",
		"vnd.jam": "jam",
		"vnd.jcp.javame.midlet-rms": "rms",
		"vnd.jisp": "jisp",
		"vnd.joost.joda-archive": "joda",
		"vnd.kahootz": [
			"ktz",
			"ktr"
		],
		"vnd.kde.karbon": "karbon",
		"vnd.kde.kchart": "chrt",
		"vnd.kde.kformula": "kfo",
		"vnd.kde.kivio": "flw",
		"vnd.kde.kontour": "kon",
		"vnd.kde.kpresenter": [
			"kpr",
			"kpt"
		],
		"vnd.kde.kspread": "ksp",
		"vnd.kde.kword": [
			"kwd",
			"kwt"
		],
		"vnd.kenameaapp": "htke",
		"vnd.kidspiration": "kia",
		"vnd.kinar": [
			"kne",
			"knp"
		],
		"vnd.koan": [
			"skp",
			"skd",
			"skt",
			"skm"
		],
		"vnd.kodak-descriptor": "sse",
		"vnd.las.las+xml": "lasxml",
		"vnd.llamagraphics.life-balance.desktop": "lbd",
		"vnd.llamagraphics.life-balance.exchange+xml": "lbe",
		"vnd.lotus-1-2-3": "123",
		"vnd.lotus-approach": "apr",
		"vnd.lotus-freelance": "pre",
		"vnd.lotus-notes": "nsf",
		"vnd.lotus-organizer": "org",
		"vnd.lotus-screencam": "scm",
		"vnd.lotus-wordpro": "lwp",
		"vnd.macports.portpkg": "portpkg",
		"vnd.mcd": "mcd",
		"vnd.medcalcdata": "mc1",
		"vnd.mediastation.cdkey": "cdkey",
		"vnd.mfer": "mwf",
		"vnd.mfmp": "mfm",
		"vnd.micrografx.flo": "flo",
		"vnd.micrografx.igx": "igx",
		"vnd.mif": "mif",
		"vnd.mobius.daf": "daf",
		"vnd.mobius.dis": "dis",
		"vnd.mobius.mbk": "mbk",
		"vnd.mobius.mqy": "mqy",
		"vnd.mobius.msl": "msl",
		"vnd.mobius.plc": "plc",
		"vnd.mobius.txf": "txf",
		"vnd.mophun.application": "mpn",
		"vnd.mophun.certificate": "mpc",
		"vnd.ms-artgalry": "cil",
		"vnd.ms-cab-compressed": "cab",
		"vnd.ms-excel.addin.macroenabled.12": "xlam",
		"vnd.ms-excel.sheet.binary.macroenabled.12": "xlsb",
		"vnd.ms-excel.sheet.macroenabled.12": "xlsm",
		"vnd.ms-excel.template.macroenabled.12": "xltm",
		"vnd.ms-fontobject": "eot",
		"vnd.ms-htmlhelp": "chm",
		"vnd.ms-ims": "ims",
		"vnd.ms-lrm": "lrm",
		"vnd.ms-officetheme": "thmx",
		"vnd.ms-powerpoint.addin.macroenabled.12": "ppam",
		"vnd.ms-powerpoint.presentation.macroenabled.12": "pptm",
		"vnd.ms-powerpoint.slide.macroenabled.12": "sldm",
		"vnd.ms-powerpoint.slideshow.macroenabled.12": "ppsm",
		"vnd.ms-powerpoint.template.macroenabled.12": "potm",
		"vnd.ms-project": [
			"mpp",
			"mpt"
		],
		"vnd.ms-word.document.macroenabled.12": "docm",
		"vnd.ms-word.template.macroenabled.12": "dotm",
		"vnd.ms-works": [
			"wps",
			"wks",
			"wcm",
			"wdb"
		],
		"vnd.ms-wpl": "wpl",
		"vnd.ms-xpsdocument": "xps",
		"vnd.mseq": "mseq",
		"vnd.musician": "mus",
		"vnd.muvee.style": "msty",
		"vnd.mynfc": "taglet",
		"vnd.neurolanguage.nlu": "nlu",
		"vnd.nitf": [
			"ntf",
			"nitf"
		],
		"vnd.noblenet-directory": "nnd",
		"vnd.noblenet-sealer": "nns",
		"vnd.noblenet-web": "nnw",
		"vnd.nokia.n-gage.data": "ngdat",
		"vnd.nokia.n-gage.symbian.install": "n-gage",
		"vnd.nokia.radio-preset": "rpst",
		"vnd.nokia.radio-presets": "rpss",
		"vnd.novadigm.edm": "edm",
		"vnd.novadigm.edx": "edx",
		"vnd.novadigm.ext": "ext",
		"vnd.oasis.opendocument.chart-template": "otc",
		"vnd.oasis.opendocument.formula-template": "odft",
		"vnd.oasis.opendocument.image-template": "oti",
		"vnd.olpc-sugar": "xo",
		"vnd.oma.dd2+xml": "dd2",
		"vnd.openofficeorg.extension": "oxt",
		"vnd.openxmlformats-officedocument.presentationml.slide": "sldx",
		"vnd.osgeo.mapguide.package": "mgp",
		"vnd.osgi.dp": "dp",
		"vnd.osgi.subsystem": "esa",
		"vnd.palm": [
			"pdb",
			"pqa",
			"oprc"
		],
		"vnd.pawaafile": "paw",
		"vnd.pg.format": "str",
		"vnd.pg.osasli": "ei6",
		"vnd.picsel": "efif",
		"vnd.pmi.widget": "wg",
		"vnd.pocketlearn": "plf",
		"vnd.powerbuilder6": "pbd",
		"vnd.previewsystems.box": "box",
		"vnd.proteus.magazine": "mgz",
		"vnd.publishare-delta-tree": "qps",
		"vnd.pvi.ptid1": "ptid",
		"vnd.quark.quarkxpress": [
			"qxd",
			"qxt",
			"qwd",
			"qwt",
			"qxl",
			"qxb"
		],
		"vnd.realvnc.bed": "bed",
		"vnd.recordare.musicxml": "mxl",
		"vnd.recordare.musicxml+xml": "musicxml",
		"vnd.rig.cryptonote": "cryptonote",
		"vnd.rn-realmedia": "rm",
		"vnd.rn-realmedia-vbr": "rmvb",
		"vnd.route66.link66+xml": "link66",
		"vnd.sailingtracker.track": "st",
		"vnd.seemail": "see",
		"vnd.sema": "sema",
		"vnd.semd": "semd",
		"vnd.semf": "semf",
		"vnd.shana.informed.formdata": "ifm",
		"vnd.shana.informed.formtemplate": "itp",
		"vnd.shana.informed.interchange": "iif",
		"vnd.shana.informed.package": "ipk",
		"vnd.simtech-mindmapper": [
			"twd",
			"twds"
		],
		"vnd.smart.teacher": "teacher",
		"vnd.solent.sdkm+xml": [
			"sdkm",
			"sdkd"
		],
		"vnd.spotfire.dxp": "dxp",
		"vnd.spotfire.sfs": "sfs",
		"vnd.stepmania.package": "smzip",
		"vnd.stepmania.stepchart": "sm",
		"vnd.sus-calendar": [
			"sus",
			"susp"
		],
		"vnd.svd": "svd",
		"vnd.syncml+xml": "xsm",
		"vnd.syncml.dm+wbxml": "bdm",
		"vnd.syncml.dm+xml": "xdm",
		"vnd.tao.intent-module-archive": "tao",
		"vnd.tcpdump.pcap": [
			"pcap",
			"cap",
			"dmp"
		],
		"vnd.tmobile-livetv": "tmo",
		"vnd.trid.tpt": "tpt",
		"vnd.triscape.mxs": "mxs",
		"vnd.trueapp": "tra",
		"vnd.ufdl": [
			"ufd",
			"ufdl"
		],
		"vnd.uiq.theme": "utz",
		"vnd.umajin": "umj",
		"vnd.unity": "unityweb",
		"vnd.uoml+xml": "uoml",
		"vnd.vcx": "vcx",
		"vnd.visionary": "vis",
		"vnd.vsf": "vsf",
		"vnd.webturbo": "wtb",
		"vnd.wolfram.player": "nbp",
		"vnd.wqd": "wqd",
		"vnd.wt.stf": "stf",
		"vnd.xara": "xar",
		"vnd.xfdl": "xfdl",
		"vnd.yamaha.hv-dic": "hvd",
		"vnd.yamaha.hv-script": "hvs",
		"vnd.yamaha.hv-voice": "hvp",
		"vnd.yamaha.openscoreformat": "osf",
		"vnd.yamaha.openscoreformat.osfpvg+xml": "osfpvg",
		"vnd.yamaha.smaf-audio": "saf",
		"vnd.yamaha.smaf-phrase": "spf",
		"vnd.yellowriver-custom-menu": "cmp",
		"vnd.zul": [
			"zir",
			"zirz"
		],
		"vnd.zzazz.deck+xml": "zaz",
		"voicexml+xml": "vxml",
		"widget": "wgt",
		"winhlp": "hlp",
		"wsdl+xml": "wsdl",
		"wspolicy+xml": "wspolicy",
		"x-ace-compressed": "ace",
		"x-authorware-bin": [
			"aab",
			"x32",
			"u32",
			"vox"
		],
		"x-authorware-map": "aam",
		"x-authorware-seg": "aas",
		"x-blorb": [
			"blb",
			"blorb"
		],
		"x-bzip": "bz",
		"x-bzip2": [
			"bz2",
			"boz"
		],
		"x-cfs-compressed": "cfs",
		"x-chat": "chat",
		"x-conference": "nsc",
		"x-dgc-compressed": "dgc",
		"x-dtbncx+xml": "ncx",
		"x-dtbook+xml": "dtb",
		"x-dtbresource+xml": "res",
		"x-eva": "eva",
		"x-font-bdf": "bdf",
		"x-font-ghostscript": "gsf",
		"x-font-linux-psf": "psf",
		"x-font-pcf": "pcf",
		"x-font-snf": "snf",
		"x-font-ttf": [
			"ttf",
			"ttc"
		],
		"x-font-type1": [
			"pfa",
			"pfb",
			"pfm",
			"afm"
		],
		"x-freearc": "arc",
		"x-gca-compressed": "gca",
		"x-glulx": "ulx",
		"x-gramps-xml": "gramps",
		"x-install-instructions": "install",
		"x-lzh-compressed": [
			"lzh",
			"lha"
		],
		"x-mie": "mie",
		"x-mobipocket-ebook": [
			"prc",
			"mobi"
		],
		"x-ms-application": "application",
		"x-ms-shortcut": "lnk",
		"x-ms-xbap": "xbap",
		"x-msbinder": "obd",
		"x-mscardfile": "crd",
		"x-msclip": "clp",
		"application/x-ms-installer": "msi",
		"x-msmediaview": [
			"mvb",
			"m13",
			"m14"
		],
		"x-msmetafile": [
			"wmf",
			"wmz",
			"emf",
			"emz"
		],
		"x-msmoney": "mny",
		"x-mspublisher": "pub",
		"x-msschedule": "scd",
		"x-msterminal": "trm",
		"x-mswrite": "wri",
		"x-nzb": "nzb",
		"x-pkcs12": [
			"p12",
			"pfx"
		],
		"x-pkcs7-certificates": [
			"p7b",
			"spc"
		],
		"x-research-info-systems": "ris",
		"x-silverlight-app": "xap",
		"x-sql": "sql",
		"x-stuffitx": "sitx",
		"x-subrip": "srt",
		"x-t3vm-image": "t3",
		"x-tex-tfm": "tfm",
		"x-tgif": "obj",
		"x-xliff+xml": "xlf",
		"x-xz": "xz",
		"x-zmachine": [
			"z1",
			"z2",
			"z3",
			"z4",
			"z5",
			"z6",
			"z7",
			"z8"
		],
		"xaml+xml": "xaml",
		"xcap-diff+xml": "xdf",
		"xenc+xml": "xenc",
		"xml-dtd": "dtd",
		"xop+xml": "xop",
		"xproc+xml": "xpl",
		"xslt+xml": "xslt",
		"xv+xml": [
			"mxml",
			"xhvml",
			"xvml",
			"xvm"
		],
		"yang": "yang",
		"yin+xml": "yin",
		"envoy": "evy",
		"fractals": "fif",
		"internet-property-stream": "acx",
		"olescript": "axs",
		"vnd.ms-outlook": "msg",
		"vnd.ms-pkicertstore": "sst",
		"x-compress": "z",
		"x-perfmon": [
			"pma",
			"pmc",
			"pmr",
			"pmw"
		],
		"ynd.ms-pkipko": "pko",
		"gzip": [
			"gz",
			"tgz"
		],
		"smil+xml": [
			"smi",
			"smil"
		],
		"vnd.debian.binary-package": [
			"deb",
			"udeb"
		],
		"vnd.hzn-3d-crossword": "x3d",
		"vnd.sqlite3": [
			"db",
			"sqlite",
			"sqlite3",
			"db-wal",
			"sqlite-wal",
			"db-shm",
			"sqlite-shm"
		],
		"vnd.wap.sic": "sic",
		"vnd.wap.slc": "slc",
		"x-krita": [
			"kra",
			"krz"
		],
		"x-perl": [
			"pm",
			"pl"
		],
		"yaml": [
			"yaml",
			"yml"
		]
	},
	"audio": {
		"amr": "amr",
		"amr-wb": "awb",
		"annodex": "axa",
		"basic": [
			"au",
			"snd"
		],
		"flac": "flac",
		"midi": [
			"mid",
			"midi",
			"kar",
			"rmi"
		],
		"mpeg": [
			"mpga",
			"mpega",
			"mp3",
			"m4a",
			"mp2a",
			"m2a",
			"m3a"
		],
		"mpegurl": "m3u",
		"ogg": [
			"oga",
			"ogg",
			"spx"
		],
		"prs.sid": "sid",
		"x-aiff": "aifc",
		"x-gsm": "gsm",
		"x-ms-wma": "wma",
		"x-ms-wax": "wax",
		"x-pn-realaudio": "ram",
		"x-realaudio": "ra",
		"x-sd2": "sd2",
		"adpcm": "adp",
		"mp4": "mp4a",
		"s3m": "s3m",
		"silk": "sil",
		"vnd.dece.audio": [
			"uva",
			"uvva"
		],
		"vnd.digital-winds": "eol",
		"vnd.dra": "dra",
		"vnd.dts": "dts",
		"vnd.dts.hd": "dtshd",
		"vnd.lucent.voice": "lvp",
		"vnd.ms-playready.media.pya": "pya",
		"vnd.nuera.ecelp4800": "ecelp4800",
		"vnd.nuera.ecelp7470": "ecelp7470",
		"vnd.nuera.ecelp9600": "ecelp9600",
		"vnd.rip": "rip",
		"webm": "weba",
		"x-caf": "caf",
		"x-matroska": "mka",
		"x-pn-realaudio-plugin": "rmp",
		"xm": "xm",
		"aac": "aac",
		"aiff": [
			"aiff",
			"aif",
			"aff"
		],
		"opus": "opus",
		"wav": "wav"
	},
	"chemical": {
		"x-alchemy": "alc",
		"x-cache": [
			"cac",
			"cache"
		],
		"x-cache-csf": "csf",
		"x-cactvs-binary": [
			"cbin",
			"cascii",
			"ctab"
		],
		"x-cdx": "cdx",
		"x-chem3d": "c3d",
		"x-cif": "cif",
		"x-cmdf": "cmdf",
		"x-cml": "cml",
		"x-compass": "cpa",
		"x-crossfire": "bsd",
		"x-csml": [
			"csml",
			"csm"
		],
		"x-ctx": "ctx",
		"x-cxf": [
			"cxf",
			"cef"
		],
		"x-embl-dl-nucleotide": [
			"emb",
			"embl"
		],
		"x-gamess-input": [
			"inp",
			"gam",
			"gamin"
		],
		"x-gaussian-checkpoint": [
			"fch",
			"fchk"
		],
		"x-gaussian-cube": "cub",
		"x-gaussian-input": [
			"gau",
			"gjc",
			"gjf"
		],
		"x-gaussian-log": "gal",
		"x-gcg8-sequence": "gcg",
		"x-genbank": "gen",
		"x-hin": "hin",
		"x-isostar": [
			"istr",
			"ist"
		],
		"x-jcamp-dx": [
			"jdx",
			"dx"
		],
		"x-kinemage": "kin",
		"x-macmolecule": "mcm",
		"x-macromodel-input": "mmod",
		"x-mdl-molfile": "mol",
		"x-mdl-rdfile": "rd",
		"x-mdl-rxnfile": "rxn",
		"x-mdl-sdfile": "sd",
		"x-mdl-tgf": "tgf",
		"x-mmcif": "mcif",
		"x-mol2": "mol2",
		"x-molconn-Z": "b",
		"x-mopac-graph": "gpt",
		"x-mopac-input": [
			"mop",
			"mopcrt",
			"zmt"
		],
		"x-mopac-out": "moo",
		"x-ncbi-asn1": "asn",
		"x-ncbi-asn1-ascii": [
			"prt",
			"ent"
		],
		"x-ncbi-asn1-binary": "val",
		"x-rosdal": "ros",
		"x-swissprot": "sw",
		"x-vamas-iso14976": "vms",
		"x-vmd": "vmd",
		"x-xtel": "xtel",
		"x-xyz": "xyz"
	},
	"font": {
		"otf": "otf",
		"woff": "woff",
		"woff2": "woff2"
	},
	"image": {
		"gif": "gif",
		"ief": "ief",
		"jpeg": [
			"jpeg",
			"jpg",
			"jpe",
			"jfif",
			"jfif-tbnl",
			"jif"
		],
		"pcx": "pcx",
		"png": "png",
		"svg+xml": [
			"svg",
			"svgz"
		],
		"tiff": [
			"tiff",
			"tif"
		],
		"vnd.djvu": [
			"djvu",
			"djv"
		],
		"vnd.wap.wbmp": "wbmp",
		"x-canon-cr2": "cr2",
		"x-canon-crw": "crw",
		"x-cmu-raster": "ras",
		"x-coreldraw": "cdr",
		"x-coreldrawpattern": "pat",
		"x-coreldrawtemplate": "cdt",
		"x-corelphotopaint": "cpt",
		"x-epson-erf": "erf",
		"x-icon": "ico",
		"x-jg": "art",
		"x-jng": "jng",
		"x-nikon-nef": "nef",
		"x-olympus-orf": "orf",
		"x-portable-anymap": "pnm",
		"x-portable-bitmap": "pbm",
		"x-portable-graymap": "pgm",
		"x-portable-pixmap": "ppm",
		"x-rgb": "rgb",
		"x-xbitmap": "xbm",
		"x-xpixmap": "xpm",
		"x-xwindowdump": "xwd",
		"bmp": "bmp",
		"cgm": "cgm",
		"g3fax": "g3",
		"ktx": "ktx",
		"prs.btif": "btif",
		"sgi": "sgi",
		"vnd.dece.graphic": [
			"uvi",
			"uvvi",
			"uvg",
			"uvvg"
		],
		"vnd.dwg": "dwg",
		"vnd.dxf": "dxf",
		"vnd.fastbidsheet": "fbs",
		"vnd.fpx": "fpx",
		"vnd.fst": "fst",
		"vnd.fujixerox.edmics-mmr": "mmr",
		"vnd.fujixerox.edmics-rlc": "rlc",
		"vnd.ms-modi": "mdi",
		"vnd.ms-photo": "wdp",
		"vnd.net-fpx": "npx",
		"vnd.xiff": "xif",
		"webp": "webp",
		"x-3ds": "3ds",
		"x-cmx": "cmx",
		"x-freehand": [
			"fh",
			"fhc",
			"fh4",
			"fh5",
			"fh7"
		],
		"x-pict": [
			"pic",
			"pct"
		],
		"x-tga": "tga",
		"cis-cod": "cod",
		"avif": "avifs",
		"heic": [
			"heif",
			"heic"
		],
		"pjpeg": [
			"pjpg"
		],
		"vnd.adobe.photoshop": "psd",
		"x-adobe-dng": "dng",
		"x-fuji-raf": "raf",
		"x-icns": "icns",
		"x-kodak-dcr": "dcr",
		"x-kodak-k25": "k25",
		"x-kodak-kdc": "kdc",
		"x-minolta-mrw": "mrw",
		"x-panasonic-raw": [
			"raw",
			"rw2",
			"rwl"
		],
		"x-pentax-pef": [
			"pef",
			"ptx"
		],
		"x-sigma-x3f": "x3f",
		"x-sony-arw": "arw",
		"x-sony-sr2": "sr2",
		"x-sony-srf": "srf"
	},
	"message": {
		"rfc822": [
			"eml",
			"mime",
			"mht",
			"mhtml",
			"nws"
		]
	},
	"model": {
		"iges": [
			"igs",
			"iges"
		],
		"mesh": [
			"msh",
			"mesh",
			"silo"
		],
		"vrml": [
			"wrl",
			"vrml"
		],
		"x3d+vrml": [
			"x3dv",
			"x3dvz"
		],
		"x3d+xml": "x3dz",
		"x3d+binary": [
			"x3db",
			"x3dbz"
		],
		"vnd.collada+xml": "dae",
		"vnd.dwf": "dwf",
		"vnd.gdl": "gdl",
		"vnd.gtw": "gtw",
		"vnd.mts": "mts",
		"vnd.usdz+zip": "usdz",
		"vnd.vtu": "vtu"
	},
	"text": {
		"cache-manifest": [
			"manifest",
			"appcache"
		],
		"calendar": [
			"ics",
			"icz",
			"ifb"
		],
		"css": "css",
		"csv": "csv",
		"h323": "323",
		"html": [
			"html",
			"htm",
			"shtml",
			"stm"
		],
		"iuls": "uls",
		"plain": [
			"txt",
			"text",
			"brf",
			"conf",
			"def",
			"list",
			"log",
			"in",
			"bas",
			"diff",
			"ksh"
		],
		"richtext": "rtx",
		"scriptlet": [
			"sct",
			"wsc"
		],
		"texmacs": "tm",
		"tab-separated-values": "tsv",
		"vnd.sun.j2me.app-descriptor": "jad",
		"vnd.wap.wml": "wml",
		"vnd.wap.wmlscript": "wmls",
		"x-bibtex": "bib",
		"x-boo": "boo",
		"x-c++hdr": [
			"h++",
			"hpp",
			"hxx",
			"hh"
		],
		"x-c++src": [
			"c++",
			"cpp",
			"cxx",
			"cc"
		],
		"x-component": "htc",
		"x-dsrc": "d",
		"x-diff": "patch",
		"x-haskell": "hs",
		"x-java": "java",
		"x-literate-haskell": "lhs",
		"x-moc": "moc",
		"x-pascal": [
			"p",
			"pas",
			"pp",
			"inc"
		],
		"x-pcs-gcd": "gcd",
		"x-python": "py",
		"x-scala": "scala",
		"x-setext": "etx",
		"x-tcl": [
			"tcl",
			"tk"
		],
		"x-tex": [
			"tex",
			"ltx",
			"sty",
			"cls"
		],
		"x-vcalendar": "vcs",
		"x-vcard": "vcf",
		"n3": "n3",
		"prs.lines.tag": "dsc",
		"sgml": [
			"sgml",
			"sgm"
		],
		"troff": [
			"t",
			"tr",
			"roff",
			"man",
			"me",
			"ms"
		],
		"turtle": "ttl",
		"uri-list": [
			"uri",
			"uris",
			"urls"
		],
		"vcard": "vcard",
		"vnd.curl": "curl",
		"vnd.curl.dcurl": "dcurl",
		"vnd.curl.scurl": "scurl",
		"vnd.curl.mcurl": "mcurl",
		"vnd.dvb.subtitle": "sub",
		"vnd.fly": "fly",
		"vnd.fmi.flexstor": "flx",
		"vnd.graphviz": "gv",
		"vnd.in3d.3dml": "3dml",
		"vnd.in3d.spot": "spot",
		"x-asm": [
			"s",
			"asm"
		],
		"x-c": [
			"c",
			"h",
			"dic"
		],
		"x-fortran": [
			"f",
			"for",
			"f77",
			"f90"
		],
		"x-opml": "opml",
		"x-nfo": "nfo",
		"x-sfv": "sfv",
		"x-uuencode": "uu",
		"webviewhtml": "htt",
		"javascript": "js",
		"json": "json",
		"markdown": [
			"md",
			"markdown",
			"mdown",
			"markdn"
		],
		"vnd.wap.si": "si",
		"vnd.wap.sl": "sl"
	},
	"video": {
		"avif": "avif",
		"3gpp": "3gp",
		"annodex": "axv",
		"dl": "dl",
		"dv": [
			"dif",
			"dv"
		],
		"fli": "fli",
		"gl": "gl",
		"mpeg": [
			"mpeg",
			"mpg",
			"mpe",
			"m1v",
			"m2v",
			"mp2",
			"mpa",
			"mpv2"
		],
		"mp4": [
			"mp4",
			"mp4v",
			"mpg4"
		],
		"quicktime": [
			"qt",
			"mov"
		],
		"ogg": "ogv",
		"vnd.mpegurl": [
			"mxu",
			"m4u"
		],
		"x-flv": "flv",
		"x-la-asf": [
			"lsf",
			"lsx"
		],
		"x-mng": "mng",
		"x-ms-asf": [
			"asf",
			"asx",
			"asr"
		],
		"x-ms-wm": "wm",
		"x-ms-wmv": "wmv",
		"x-ms-wmx": "wmx",
		"x-ms-wvx": "wvx",
		"x-msvideo": "avi",
		"x-sgi-movie": "movie",
		"x-matroska": [
			"mpv",
			"mkv",
			"mk3d",
			"mks"
		],
		"3gpp2": "3g2",
		"h261": "h261",
		"h263": "h263",
		"h264": "h264",
		"jpeg": "jpgv",
		"jpm": [
			"jpm",
			"jpgm"
		],
		"mj2": [
			"mj2",
			"mjp2"
		],
		"vnd.dece.hd": [
			"uvh",
			"uvvh"
		],
		"vnd.dece.mobile": [
			"uvm",
			"uvvm"
		],
		"vnd.dece.pd": [
			"uvp",
			"uvvp"
		],
		"vnd.dece.sd": [
			"uvs",
			"uvvs"
		],
		"vnd.dece.video": [
			"uvv",
			"uvvv"
		],
		"vnd.dvb.file": "dvb",
		"vnd.fvt": "fvt",
		"vnd.ms-playready.media.pyv": "pyv",
		"vnd.uvvu.mp4": [
			"uvu",
			"uvvu"
		],
		"vnd.vivo": "viv",
		"webm": "webm",
		"x-f4v": "f4v",
		"x-m4v": "m4v",
		"x-ms-vob": "vob",
		"x-smv": "smv",
		"mp2t": "ts"
	},
	"x-conference": {
		"x-cooltalk": "ice"
	},
	"x-world": {
		"x-vrml": [
			"vrm",
			"flr",
			"wrz",
			"xaf",
			"xof"
		]
	}
};

(() => {
	const mimeTypes = {};
	for (const type of Object.keys(table$1)) {
		for (const subtype of Object.keys(table$1[type])) {
			const value = table$1[type][subtype];
			if (typeof value == "string") {
				mimeTypes[value] = type + "/" + subtype;
			} else {
				for (let indexMimeType = 0; indexMimeType < value.length; indexMimeType++) {
					mimeTypes[value[indexMimeType]] = type + "/" + subtype;
				}
			}
		}
	}
	return mimeTypes;
})();

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

const table = [];
for (let i = 0; i < 256; i++) {
	let t = i;
	for (let j = 0; j < 8; j++) {
		if (t & 1) {
			t = (t >>> 1) ^ 0xEDB88320;
		} else {
			t = t >>> 1;
		}
	}
	table[i] = t;
}

class Crc32 {

	constructor(crc) {
		this.crc = crc || -1;
	}

	append(data) {
		let crc = this.crc | 0;
		for (let offset = 0, length = data.length | 0; offset < length; offset++) {
			crc = (crc >>> 8) ^ table[(crc ^ data[offset]) & 0xFF];
		}
		this.crc = crc;
	}

	get() {
		return ~this.crc;
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


class Crc32Stream extends TransformStream {

	constructor() {
		let stream;
		const crc32 = new Crc32();
		super({
			transform(chunk, controller) {
				crc32.append(chunk);
				controller.enqueue(chunk);
			},
			flush() {
				const value = new Uint8Array(4);
				const dataView = new DataView(value.buffer);
				dataView.setUint32(0, crc32.get());
				stream.value = value;
			}
		});
		stream = this;
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


function encodeText(value) {
	if (typeof TextEncoder == UNDEFINED_TYPE) {
		value = unescape(encodeURIComponent(value));
		const result = new Uint8Array(value.length);
		for (let i = 0; i < result.length; i++) {
			result[i] = value.charCodeAt(i);
		}
		return result;
	} else {
		return new TextEncoder().encode(value);
	}
}

// Derived from https://github.com/xqdoo00o/jszip/blob/master/lib/sjcl.js and https://github.com/bitwiseshiftleft/sjcl

// deno-lint-ignore-file no-this-alias

/*
 * SJCL is open. You can use, modify and redistribute it under a BSD
 * license or under the GNU GPL, version 2.0.
 */

/** @fileOverview Javascript cryptography implementation.
 *
 * Crush to remove comments, shorten variable names and
 * generally reduce transmission size.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

/*jslint indent: 2, bitwise: false, nomen: false, plusplus: false, white: false, regexp: false */

/** @fileOverview Arrays of bits, encoded as arrays of Numbers.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

/**
 * Arrays of bits, encoded as arrays of Numbers.
 * @namespace
 * @description
 * <p>
 * These objects are the currency accepted by SJCL's crypto functions.
 * </p>
 *
 * <p>
 * Most of our crypto primitives operate on arrays of 4-byte words internally,
 * but many of them can take arguments that are not a multiple of 4 bytes.
 * This library encodes arrays of bits (whose size need not be a multiple of 8
 * bits) as arrays of 32-bit words.  The bits are packed, big-endian, into an
 * array of words, 32 bits at a time.  Since the words are double-precision
 * floating point numbers, they fit some extra data.  We use this (in a private,
 * possibly-changing manner) to encode the number of bits actually  present
 * in the last word of the array.
 * </p>
 *
 * <p>
 * Because bitwise ops clear this out-of-band data, these arrays can be passed
 * to ciphers like AES which want arrays of words.
 * </p>
 */
const bitArray = {
	/**
	 * Concatenate two bit arrays.
	 * @param {bitArray} a1 The first array.
	 * @param {bitArray} a2 The second array.
	 * @return {bitArray} The concatenation of a1 and a2.
	 */
	concat(a1, a2) {
		if (a1.length === 0 || a2.length === 0) {
			return a1.concat(a2);
		}

		const last = a1[a1.length - 1], shift = bitArray.getPartial(last);
		if (shift === 32) {
			return a1.concat(a2);
		} else {
			return bitArray._shiftRight(a2, shift, last | 0, a1.slice(0, a1.length - 1));
		}
	},

	/**
	 * Find the length of an array of bits.
	 * @param {bitArray} a The array.
	 * @return {Number} The length of a, in bits.
	 */
	bitLength(a) {
		const l = a.length;
		if (l === 0) {
			return 0;
		}
		const x = a[l - 1];
		return (l - 1) * 32 + bitArray.getPartial(x);
	},

	/**
	 * Truncate an array.
	 * @param {bitArray} a The array.
	 * @param {Number} len The length to truncate to, in bits.
	 * @return {bitArray} A new array, truncated to len bits.
	 */
	clamp(a, len) {
		if (a.length * 32 < len) {
			return a;
		}
		a = a.slice(0, Math.ceil(len / 32));
		const l = a.length;
		len = len & 31;
		if (l > 0 && len) {
			a[l - 1] = bitArray.partial(len, a[l - 1] & 0x80000000 >> (len - 1), 1);
		}
		return a;
	},

	/**
	 * Make a partial word for a bit array.
	 * @param {Number} len The number of bits in the word.
	 * @param {Number} x The bits.
	 * @param {Number} [_end=0] Pass 1 if x has already been shifted to the high side.
	 * @return {Number} The partial word.
	 */
	partial(len, x, _end) {
		if (len === 32) {
			return x;
		}
		return (_end ? x | 0 : x << (32 - len)) + len * 0x10000000000;
	},

	/**
	 * Get the number of bits used by a partial word.
	 * @param {Number} x The partial word.
	 * @return {Number} The number of bits used by the partial word.
	 */
	getPartial(x) {
		return Math.round(x / 0x10000000000) || 32;
	},

	/** Shift an array right.
	 * @param {bitArray} a The array to shift.
	 * @param {Number} shift The number of bits to shift.
	 * @param {Number} [carry=0] A byte to carry in
	 * @param {bitArray} [out=[]] An array to prepend to the output.
	 * @private
	 */
	_shiftRight(a, shift, carry, out) {
		if (out === undefined) {
			out = [];
		}

		for (; shift >= 32; shift -= 32) {
			out.push(carry);
			carry = 0;
		}
		if (shift === 0) {
			return out.concat(a);
		}

		for (let i = 0; i < a.length; i++) {
			out.push(carry | a[i] >>> shift);
			carry = a[i] << (32 - shift);
		}
		const last2 = a.length ? a[a.length - 1] : 0;
		const shift2 = bitArray.getPartial(last2);
		out.push(bitArray.partial(shift + shift2 & 31, (shift + shift2 > 32) ? carry : out.pop(), 1));
		return out;
	}
};

/** @fileOverview Bit array codec implementations.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

/**
 * Arrays of bytes
 * @namespace
 */
const codec = {
	bytes: {
		/** Convert from a bitArray to an array of bytes. */
		fromBits(arr) {
			const bl = bitArray.bitLength(arr);
			const byteLength = bl / 8;
			const out = new Uint8Array(byteLength);
			let tmp;
			for (let i = 0; i < byteLength; i++) {
				if ((i & 3) === 0) {
					tmp = arr[i / 4];
				}
				out[i] = tmp >>> 24;
				tmp <<= 8;
			}
			return out;
		},
		/** Convert from an array of bytes to a bitArray. */
		toBits(bytes) {
			const out = [];
			let i;
			let tmp = 0;
			for (i = 0; i < bytes.length; i++) {
				tmp = tmp << 8 | bytes[i];
				if ((i & 3) === 3) {
					out.push(tmp);
					tmp = 0;
				}
			}
			if (i & 3) {
				out.push(bitArray.partial(8 * (i & 3), tmp));
			}
			return out;
		}
	}
};

const hash = {};

/**
 * Context for a SHA-1 operation in progress.
 * @constructor
 */
hash.sha1 = class {
	constructor(hash) {
		const sha1 = this;
		/**
		 * The hash's block size, in bits.
		 * @constant
		 */
		sha1.blockSize = 512;
		/**
		 * The SHA-1 initialization vector.
		 * @private
		 */
		sha1._init = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476, 0xC3D2E1F0];
		/**
		 * The SHA-1 hash key.
		 * @private
		 */
		sha1._key = [0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xCA62C1D6];
		if (hash) {
			sha1._h = hash._h.slice(0);
			sha1._buffer = hash._buffer.slice(0);
			sha1._length = hash._length;
		} else {
			sha1.reset();
		}
	}

	/**
	 * Reset the hash state.
	 * @return this
	 */
	reset() {
		const sha1 = this;
		sha1._h = sha1._init.slice(0);
		sha1._buffer = [];
		sha1._length = 0;
		return sha1;
	}

	/**
	 * Input several words to the hash.
	 * @param {bitArray|String} data the data to hash.
	 * @return this
	 */
	update(data) {
		const sha1 = this;
		if (typeof data === "string") {
			data = codec.utf8String.toBits(data);
		}
		const b = sha1._buffer = bitArray.concat(sha1._buffer, data);
		const ol = sha1._length;
		const nl = sha1._length = ol + bitArray.bitLength(data);
		if (nl > 9007199254740991) {
			throw new Error("Cannot hash more than 2^53 - 1 bits");
		}
		const c = new Uint32Array(b);
		let j = 0;
		for (let i = sha1.blockSize + ol - ((sha1.blockSize + ol) & (sha1.blockSize - 1)); i <= nl;
			i += sha1.blockSize) {
			sha1._block(c.subarray(16 * j, 16 * (j + 1)));
			j += 1;
		}
		b.splice(0, 16 * j);
		return sha1;
	}

	/**
	 * Complete hashing and output the hash value.
	 * @return {bitArray} The hash value, an array of 5 big-endian words. TODO
	 */
	finalize() {
		const sha1 = this;
		let b = sha1._buffer;
		const h = sha1._h;

		// Round out and push the buffer
		b = bitArray.concat(b, [bitArray.partial(1, 1)]);
		// Round out the buffer to a multiple of 16 words, less the 2 length words.
		for (let i = b.length + 2; i & 15; i++) {
			b.push(0);
		}

		// append the length
		b.push(Math.floor(sha1._length / 0x100000000));
		b.push(sha1._length | 0);

		while (b.length) {
			sha1._block(b.splice(0, 16));
		}

		sha1.reset();
		return h;
	}

	/**
	 * The SHA-1 logical functions f(0), f(1), ..., f(79).
	 * @private
	 */
	_f(t, b, c, d) {
		if (t <= 19) {
			return (b & c) | (~b & d);
		} else if (t <= 39) {
			return b ^ c ^ d;
		} else if (t <= 59) {
			return (b & c) | (b & d) | (c & d);
		} else if (t <= 79) {
			return b ^ c ^ d;
		}
	}

	/**
	 * Circular left-shift operator.
	 * @private
	 */
	_S(n, x) {
		return (x << n) | (x >>> 32 - n);
	}

	/**
	 * Perform one cycle of SHA-1.
	 * @param {Uint32Array|bitArray} words one block of words.
	 * @private
	 */
	_block(words) {
		const sha1 = this;
		const h = sha1._h;
		// When words is passed to _block, it has 16 elements. SHA1 _block
		// function extends words with new elements (at the end there are 80 elements). 
		// The problem is that if we use Uint32Array instead of Array, 
		// the length of Uint32Array cannot be changed. Thus, we replace words with a 
		// normal Array here.
		const w = Array(80); // do not use Uint32Array here as the instantiation is slower
		for (let j = 0; j < 16; j++) {
			w[j] = words[j];
		}

		let a = h[0];
		let b = h[1];
		let c = h[2];
		let d = h[3];
		let e = h[4];

		for (let t = 0; t <= 79; t++) {
			if (t >= 16) {
				w[t] = sha1._S(1, w[t - 3] ^ w[t - 8] ^ w[t - 14] ^ w[t - 16]);
			}
			const tmp = (sha1._S(5, a) + sha1._f(t, b, c, d) + e + w[t] +
				sha1._key[Math.floor(t / 20)]) | 0;
			e = d;
			d = c;
			c = sha1._S(30, b);
			b = a;
			a = tmp;
		}

		h[0] = (h[0] + a) | 0;
		h[1] = (h[1] + b) | 0;
		h[2] = (h[2] + c) | 0;
		h[3] = (h[3] + d) | 0;
		h[4] = (h[4] + e) | 0;
	}
};

/** @fileOverview Low-level AES implementation.
 *
 * This file contains a low-level implementation of AES, optimized for
 * size and for efficiency on several browsers.  It is based on
 * OpenSSL's aes_core.c, a public-domain implementation by Vincent
 * Rijmen, Antoon Bosselaers and Paulo Barreto.
 *
 * An older version of this implementation is available in the public
 * domain, but this one is (c) Emily Stark, Mike Hamburg, Dan Boneh,
 * Stanford University 2008-2010 and BSD-licensed for liability
 * reasons.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

const cipher = {};

/**
 * Schedule out an AES key for both encryption and decryption.  This
 * is a low-level class.  Use a cipher mode to do bulk encryption.
 *
 * @constructor
 * @param {Array} key The key as an array of 4, 6 or 8 words.
 */
cipher.aes = class {
	constructor(key) {
		/**
		 * The expanded S-box and inverse S-box tables.  These will be computed
		 * on the client so that we don't have to send them down the wire.
		 *
		 * There are two tables, _tables[0] is for encryption and
		 * _tables[1] is for decryption.
		 *
		 * The first 4 sub-tables are the expanded S-box with MixColumns.  The
		 * last (_tables[01][4]) is the S-box itself.
		 *
		 * @private
		 */
		const aes = this;
		aes._tables = [[[], [], [], [], []], [[], [], [], [], []]];

		if (!aes._tables[0][0][0]) {
			aes._precompute();
		}

		const sbox = aes._tables[0][4];
		const decTable = aes._tables[1];
		const keyLen = key.length;

		let i, encKey, decKey, rcon = 1;

		if (keyLen !== 4 && keyLen !== 6 && keyLen !== 8) {
			throw new Error("invalid aes key size");
		}

		aes._key = [encKey = key.slice(0), decKey = []];

		// schedule encryption keys
		for (i = keyLen; i < 4 * keyLen + 28; i++) {
			let tmp = encKey[i - 1];

			// apply sbox
			if (i % keyLen === 0 || (keyLen === 8 && i % keyLen === 4)) {
				tmp = sbox[tmp >>> 24] << 24 ^ sbox[tmp >> 16 & 255] << 16 ^ sbox[tmp >> 8 & 255] << 8 ^ sbox[tmp & 255];

				// shift rows and add rcon
				if (i % keyLen === 0) {
					tmp = tmp << 8 ^ tmp >>> 24 ^ rcon << 24;
					rcon = rcon << 1 ^ (rcon >> 7) * 283;
				}
			}

			encKey[i] = encKey[i - keyLen] ^ tmp;
		}

		// schedule decryption keys
		for (let j = 0; i; j++, i--) {
			const tmp = encKey[j & 3 ? i : i - 4];
			if (i <= 4 || j < 4) {
				decKey[j] = tmp;
			} else {
				decKey[j] = decTable[0][sbox[tmp >>> 24]] ^
					decTable[1][sbox[tmp >> 16 & 255]] ^
					decTable[2][sbox[tmp >> 8 & 255]] ^
					decTable[3][sbox[tmp & 255]];
			}
		}
	}
	// public
	/* Something like this might appear here eventually
	name: "AES",
	blockSize: 4,
	keySizes: [4,6,8],
	*/

	/**
	 * Encrypt an array of 4 big-endian words.
	 * @param {Array} data The plaintext.
	 * @return {Array} The ciphertext.
	 */
	encrypt(data) {
		return this._crypt(data, 0);
	}

	/**
	 * Decrypt an array of 4 big-endian words.
	 * @param {Array} data The ciphertext.
	 * @return {Array} The plaintext.
	 */
	decrypt(data) {
		return this._crypt(data, 1);
	}

	/**
	 * Expand the S-box tables.
	 *
	 * @private
	 */
	_precompute() {
		const encTable = this._tables[0];
		const decTable = this._tables[1];
		const sbox = encTable[4];
		const sboxInv = decTable[4];
		const d = [];
		const th = [];
		let xInv, x2, x4, x8;

		// Compute double and third tables
		for (let i = 0; i < 256; i++) {
			th[(d[i] = i << 1 ^ (i >> 7) * 283) ^ i] = i;
		}

		for (let x = xInv = 0; !sbox[x]; x ^= x2 || 1, xInv = th[xInv] || 1) {
			// Compute sbox
			let s = xInv ^ xInv << 1 ^ xInv << 2 ^ xInv << 3 ^ xInv << 4;
			s = s >> 8 ^ s & 255 ^ 99;
			sbox[x] = s;
			sboxInv[s] = x;

			// Compute MixColumns
			x8 = d[x4 = d[x2 = d[x]]];
			let tDec = x8 * 0x1010101 ^ x4 * 0x10001 ^ x2 * 0x101 ^ x * 0x1010100;
			let tEnc = d[s] * 0x101 ^ s * 0x1010100;

			for (let i = 0; i < 4; i++) {
				encTable[i][x] = tEnc = tEnc << 24 ^ tEnc >>> 8;
				decTable[i][s] = tDec = tDec << 24 ^ tDec >>> 8;
			}
		}

		// Compactify.  Considerable speedup on Firefox.
		for (let i = 0; i < 5; i++) {
			encTable[i] = encTable[i].slice(0);
			decTable[i] = decTable[i].slice(0);
		}
	}

	/**
	 * Encryption and decryption core.
	 * @param {Array} input Four words to be encrypted or decrypted.
	 * @param dir The direction, 0 for encrypt and 1 for decrypt.
	 * @return {Array} The four encrypted or decrypted words.
	 * @private
	 */
	_crypt(input, dir) {
		if (input.length !== 4) {
			throw new Error("invalid aes block size");
		}

		const key = this._key[dir];

		const nInnerRounds = key.length / 4 - 2;
		const out = [0, 0, 0, 0];
		const table = this._tables[dir];

		// load up the tables
		const t0 = table[0];
		const t1 = table[1];
		const t2 = table[2];
		const t3 = table[3];
		const sbox = table[4];

		// state variables a,b,c,d are loaded with pre-whitened data
		let a = input[0] ^ key[0];
		let b = input[dir ? 3 : 1] ^ key[1];
		let c = input[2] ^ key[2];
		let d = input[dir ? 1 : 3] ^ key[3];
		let kIndex = 4;
		let a2, b2, c2;

		// Inner rounds.  Cribbed from OpenSSL.
		for (let i = 0; i < nInnerRounds; i++) {
			a2 = t0[a >>> 24] ^ t1[b >> 16 & 255] ^ t2[c >> 8 & 255] ^ t3[d & 255] ^ key[kIndex];
			b2 = t0[b >>> 24] ^ t1[c >> 16 & 255] ^ t2[d >> 8 & 255] ^ t3[a & 255] ^ key[kIndex + 1];
			c2 = t0[c >>> 24] ^ t1[d >> 16 & 255] ^ t2[a >> 8 & 255] ^ t3[b & 255] ^ key[kIndex + 2];
			d = t0[d >>> 24] ^ t1[a >> 16 & 255] ^ t2[b >> 8 & 255] ^ t3[c & 255] ^ key[kIndex + 3];
			kIndex += 4;
			a = a2; b = b2; c = c2;
		}

		// Last round.
		for (let i = 0; i < 4; i++) {
			out[dir ? 3 & -i : i] =
				sbox[a >>> 24] << 24 ^
				sbox[b >> 16 & 255] << 16 ^
				sbox[c >> 8 & 255] << 8 ^
				sbox[d & 255] ^
				key[kIndex++];
			a2 = a; a = b; b = c; c = d; d = a2;
		}

		return out;
	}
};

/**
 * Random values
 * @namespace
 */
const random = {
	/** 
	 * Generate random words with pure js, cryptographically not as strong & safe as native implementation.
	 * @param {TypedArray} typedArray The array to fill.
	 * @return {TypedArray} The random values.
	 */
	getRandomValues(typedArray) {
		const words = new Uint32Array(typedArray.buffer);
		const r = (m_w) => {
			let m_z = 0x3ade68b1;
			const mask = 0xffffffff;
			return function () {
				m_z = (0x9069 * (m_z & 0xFFFF) + (m_z >> 0x10)) & mask;
				m_w = (0x4650 * (m_w & 0xFFFF) + (m_w >> 0x10)) & mask;
				const result = ((((m_z << 0x10) + m_w) & mask) / 0x100000000) + .5;
				return result * (Math.random() > .5 ? 1 : -1);
			};
		};
		for (let i = 0, rcache; i < typedArray.length; i += 4) {
			const _r = r((rcache || Math.random()) * 0x100000000);
			rcache = _r() * 0x3ade67b7;
			words[i / 4] = (_r() * 0x100000000) | 0;
		}
		return typedArray;
	}
};

/** @fileOverview CTR mode implementation.
 *
 * Special thanks to Roy Nicholson for pointing out a bug in our
 * implementation.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

/** Brian Gladman's CTR Mode.
* @constructor
* @param {Object} _prf The aes instance to generate key.
* @param {bitArray} _iv The iv for ctr mode, it must be 128 bits.
*/

const mode = {};

/**
 * Brian Gladman's CTR Mode.
 * @namespace
 */
mode.ctrGladman = class {
	constructor(prf, iv) {
		this._prf = prf;
		this._initIv = iv;
		this._iv = iv;
	}

	reset() {
		this._iv = this._initIv;
	}

	/** Input some data to calculate.
	 * @param {bitArray} data the data to process, it must be intergral multiple of 128 bits unless it's the last.
	 */
	update(data) {
		return this.calculate(this._prf, data, this._iv);
	}

	incWord(word) {
		if (((word >> 24) & 0xff) === 0xff) { //overflow
			let b1 = (word >> 16) & 0xff;
			let b2 = (word >> 8) & 0xff;
			let b3 = word & 0xff;

			if (b1 === 0xff) { // overflow b1   
				b1 = 0;
				if (b2 === 0xff) {
					b2 = 0;
					if (b3 === 0xff) {
						b3 = 0;
					} else {
						++b3;
					}
				} else {
					++b2;
				}
			} else {
				++b1;
			}

			word = 0;
			word += (b1 << 16);
			word += (b2 << 8);
			word += b3;
		} else {
			word += (0x01 << 24);
		}
		return word;
	}

	incCounter(counter) {
		if ((counter[0] = this.incWord(counter[0])) === 0) {
			// encr_data in fileenc.c from  Dr Brian Gladman's counts only with DWORD j < 8
			counter[1] = this.incWord(counter[1]);
		}
	}

	calculate(prf, data, iv) {
		let l;
		if (!(l = data.length)) {
			return [];
		}
		const bl = bitArray.bitLength(data);
		for (let i = 0; i < l; i += 4) {
			this.incCounter(iv);
			const e = prf.encrypt(iv);
			data[i] ^= e[0];
			data[i + 1] ^= e[1];
			data[i + 2] ^= e[2];
			data[i + 3] ^= e[3];
		}
		return bitArray.clamp(data, bl);
	}
};

const misc = {
	importKey(password) {
		return new misc.hmacSha1(codec.bytes.toBits(password));
	},
	pbkdf2(prf, salt, count, length) {
		count = count || 10000;
		if (length < 0 || count < 0) {
			throw new Error("invalid params to pbkdf2");
		}
		const byteLength = ((length >> 5) + 1) << 2;
		let u, ui, i, j, k;
		const arrayBuffer = new ArrayBuffer(byteLength);
		const out = new DataView(arrayBuffer);
		let outLength = 0;
		const b = bitArray;
		salt = codec.bytes.toBits(salt);
		for (k = 1; outLength < (byteLength || 1); k++) {
			u = ui = prf.encrypt(b.concat(salt, [k]));
			for (i = 1; i < count; i++) {
				ui = prf.encrypt(ui);
				for (j = 0; j < ui.length; j++) {
					u[j] ^= ui[j];
				}
			}
			for (i = 0; outLength < (byteLength || 1) && i < u.length; i++) {
				out.setInt32(outLength, u[i]);
				outLength += 4;
			}
		}
		return arrayBuffer.slice(0, length / 8);
	}
};

/** @fileOverview HMAC implementation.
 *
 * @author Emily Stark
 * @author Mike Hamburg
 * @author Dan Boneh
 */

/** HMAC with the specified hash function.
 * @constructor
 * @param {bitArray} key the key for HMAC.
 * @param {Object} [Hash=hash.sha1] The hash function to use.
 */
misc.hmacSha1 = class {

	constructor(key) {
		const hmac = this;
		const Hash = hmac._hash = hash.sha1;
		const exKey = [[], []];
		hmac._baseHash = [new Hash(), new Hash()];
		const bs = hmac._baseHash[0].blockSize / 32;

		if (key.length > bs) {
			key = new Hash().update(key).finalize();
		}

		for (let i = 0; i < bs; i++) {
			exKey[0][i] = key[i] ^ 0x36363636;
			exKey[1][i] = key[i] ^ 0x5C5C5C5C;
		}

		hmac._baseHash[0].update(exKey[0]);
		hmac._baseHash[1].update(exKey[1]);
		hmac._resultHash = new Hash(hmac._baseHash[0]);
	}
	reset() {
		const hmac = this;
		hmac._resultHash = new hmac._hash(hmac._baseHash[0]);
		hmac._updated = false;
	}

	update(data) {
		const hmac = this;
		hmac._updated = true;
		hmac._resultHash.update(data);
	}

	digest() {
		const hmac = this;
		const w = hmac._resultHash.finalize();
		const result = new (hmac._hash)(hmac._baseHash[1]).update(w).finalize();

		hmac.reset();

		return result;
	}

	encrypt(data) {
		if (!this._updated) {
			this.update(data);
			return this.digest(data);
		} else {
			throw new Error("encrypt on already updated hmac called!");
		}
	}
};

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const GET_RANDOM_VALUES_SUPPORTED = typeof crypto != UNDEFINED_TYPE && typeof crypto.getRandomValues == FUNCTION_TYPE;

const ERR_INVALID_PASSWORD = "Invalid password";
const ERR_INVALID_SIGNATURE = "Invalid signature";
const ERR_ABORT_CHECK_PASSWORD = "zipjs-abort-check-password";

function getRandomValues(array) {
	if (GET_RANDOM_VALUES_SUPPORTED) {
		return crypto.getRandomValues(array);
	} else {
		return random.getRandomValues(array);
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const BLOCK_LENGTH = 16;
const RAW_FORMAT = "raw";
const PBKDF2_ALGORITHM = { name: "PBKDF2" };
const HASH_ALGORITHM = { name: "HMAC" };
const HASH_FUNCTION = "SHA-1";
const BASE_KEY_ALGORITHM = Object.assign({ hash: HASH_ALGORITHM }, PBKDF2_ALGORITHM);
const DERIVED_BITS_ALGORITHM = Object.assign({ iterations: 1000, hash: { name: HASH_FUNCTION } }, PBKDF2_ALGORITHM);
const DERIVED_BITS_USAGE = ["deriveBits"];
const SALT_LENGTH = [8, 12, 16];
const KEY_LENGTH = [16, 24, 32];
const SIGNATURE_LENGTH = 10;
const COUNTER_DEFAULT_VALUE = [0, 0, 0, 0];
// deno-lint-ignore valid-typeof
const CRYPTO_API_SUPPORTED = typeof crypto != UNDEFINED_TYPE;
const subtle = CRYPTO_API_SUPPORTED && crypto.subtle;
const SUBTLE_API_SUPPORTED = CRYPTO_API_SUPPORTED && typeof subtle != UNDEFINED_TYPE;
const codecBytes = codec.bytes;
const Aes = cipher.aes;
const CtrGladman = mode.ctrGladman;
const HmacSha1 = misc.hmacSha1;

let IMPORT_KEY_SUPPORTED = CRYPTO_API_SUPPORTED && SUBTLE_API_SUPPORTED && typeof subtle.importKey == FUNCTION_TYPE;
let DERIVE_BITS_SUPPORTED = CRYPTO_API_SUPPORTED && SUBTLE_API_SUPPORTED && typeof subtle.deriveBits == FUNCTION_TYPE;

class AESDecryptionStream extends TransformStream {

	constructor({ password, rawPassword, signed, encryptionStrength, checkPasswordOnly }) {
		super({
			start() {
				Object.assign(this, {
					ready: new Promise(resolve => this.resolveReady = resolve),
					password: encodePassword(password, rawPassword),
					signed,
					strength: encryptionStrength - 1,
					pending: new Uint8Array()
				});
			},
			async transform(chunk, controller) {
				const aesCrypto = this;
				const {
					password,
					strength,
					resolveReady,
					ready
				} = aesCrypto;
				if (password) {
					await createDecryptionKeys(aesCrypto, strength, password, subarray(chunk, 0, SALT_LENGTH[strength] + 2));
					chunk = subarray(chunk, SALT_LENGTH[strength] + 2);
					if (checkPasswordOnly) {
						controller.error(new Error(ERR_ABORT_CHECK_PASSWORD));
					} else {
						resolveReady();
					}
				} else {
					await ready;
				}
				const output = new Uint8Array(chunk.length - SIGNATURE_LENGTH - ((chunk.length - SIGNATURE_LENGTH) % BLOCK_LENGTH));
				controller.enqueue(append(aesCrypto, chunk, output, 0, SIGNATURE_LENGTH, true));
			},
			async flush(controller) {
				const {
					signed,
					ctr,
					hmac,
					pending,
					ready
				} = this;
				if (hmac && ctr) {
					await ready;
					const chunkToDecrypt = subarray(pending, 0, pending.length - SIGNATURE_LENGTH);
					const originalSignature = subarray(pending, pending.length - SIGNATURE_LENGTH);
					let decryptedChunkArray = new Uint8Array();
					if (chunkToDecrypt.length) {
						const encryptedChunk = toBits(codecBytes, chunkToDecrypt);
						hmac.update(encryptedChunk);
						const decryptedChunk = ctr.update(encryptedChunk);
						decryptedChunkArray = fromBits(codecBytes, decryptedChunk);
					}
					if (signed) {
						const signature = subarray(fromBits(codecBytes, hmac.digest()), 0, SIGNATURE_LENGTH);
						for (let indexSignature = 0; indexSignature < SIGNATURE_LENGTH; indexSignature++) {
							if (signature[indexSignature] != originalSignature[indexSignature]) {
								throw new Error(ERR_INVALID_SIGNATURE);
							}
						}
					}
					controller.enqueue(decryptedChunkArray);
				}
			}
		});
	}
}

class AESEncryptionStream extends TransformStream {

	constructor({ password, rawPassword, encryptionStrength }) {
		// deno-lint-ignore prefer-const
		let stream;
		super({
			start() {
				Object.assign(this, {
					ready: new Promise(resolve => this.resolveReady = resolve),
					password: encodePassword(password, rawPassword),
					strength: encryptionStrength - 1,
					pending: new Uint8Array()
				});
			},
			async transform(chunk, controller) {
				const aesCrypto = this;
				const {
					password,
					strength,
					resolveReady,
					ready
				} = aesCrypto;
				let preamble = new Uint8Array();
				if (password) {
					preamble = await createEncryptionKeys(aesCrypto, strength, password);
					resolveReady();
				} else {
					await ready;
				}
				const output = new Uint8Array(preamble.length + chunk.length - (chunk.length % BLOCK_LENGTH));
				output.set(preamble, 0);
				controller.enqueue(append(aesCrypto, chunk, output, preamble.length, 0));
			},
			async flush(controller) {
				const {
					ctr,
					hmac,
					pending,
					ready
				} = this;
				if (hmac && ctr) {
					await ready;
					let encryptedChunkArray = new Uint8Array();
					if (pending.length) {
						const encryptedChunk = ctr.update(toBits(codecBytes, pending));
						hmac.update(encryptedChunk);
						encryptedChunkArray = fromBits(codecBytes, encryptedChunk);
					}
					stream.signature = fromBits(codecBytes, hmac.digest()).slice(0, SIGNATURE_LENGTH);
					controller.enqueue(concat(encryptedChunkArray, stream.signature));
				}
			}
		});
		stream = this;
	}
}

function append(aesCrypto, input, output, paddingStart, paddingEnd, verifySignature) {
	const {
		ctr,
		hmac,
		pending
	} = aesCrypto;
	const inputLength = input.length - paddingEnd;
	if (pending.length) {
		input = concat(pending, input);
		output = expand(output, inputLength - (inputLength % BLOCK_LENGTH));
	}
	let offset;
	for (offset = 0; offset <= inputLength - BLOCK_LENGTH; offset += BLOCK_LENGTH) {
		const inputChunk = toBits(codecBytes, subarray(input, offset, offset + BLOCK_LENGTH));
		if (verifySignature) {
			hmac.update(inputChunk);
		}
		const outputChunk = ctr.update(inputChunk);
		if (!verifySignature) {
			hmac.update(outputChunk);
		}
		output.set(fromBits(codecBytes, outputChunk), offset + paddingStart);
	}
	aesCrypto.pending = subarray(input, offset);
	return output;
}

async function createDecryptionKeys(decrypt, strength, password, preamble) {
	const passwordVerificationKey = await createKeys$1(decrypt, strength, password, subarray(preamble, 0, SALT_LENGTH[strength]));
	const passwordVerification = subarray(preamble, SALT_LENGTH[strength]);
	if (passwordVerificationKey[0] != passwordVerification[0] || passwordVerificationKey[1] != passwordVerification[1]) {
		throw new Error(ERR_INVALID_PASSWORD);
	}
}

async function createEncryptionKeys(encrypt, strength, password) {
	const salt = getRandomValues(new Uint8Array(SALT_LENGTH[strength]));
	const passwordVerification = await createKeys$1(encrypt, strength, password, salt);
	return concat(salt, passwordVerification);
}

async function createKeys$1(aesCrypto, strength, password, salt) {
	aesCrypto.password = null;
	const baseKey = await importKey(RAW_FORMAT, password, BASE_KEY_ALGORITHM, false, DERIVED_BITS_USAGE);
	const derivedBits = await deriveBits(Object.assign({ salt }, DERIVED_BITS_ALGORITHM), baseKey, 8 * ((KEY_LENGTH[strength] * 2) + 2));
	const compositeKey = new Uint8Array(derivedBits);
	const key = toBits(codecBytes, subarray(compositeKey, 0, KEY_LENGTH[strength]));
	const authentication = toBits(codecBytes, subarray(compositeKey, KEY_LENGTH[strength], KEY_LENGTH[strength] * 2));
	const passwordVerification = subarray(compositeKey, KEY_LENGTH[strength] * 2);
	Object.assign(aesCrypto, {
		keys: {
			key,
			authentication,
			passwordVerification
		},
		ctr: new CtrGladman(new Aes(key), Array.from(COUNTER_DEFAULT_VALUE)),
		hmac: new HmacSha1(authentication)
	});
	return passwordVerification;
}

async function importKey(format, password, algorithm, extractable, keyUsages) {
	if (IMPORT_KEY_SUPPORTED) {
		try {
			return await subtle.importKey(format, password, algorithm, extractable, keyUsages);
		} catch (_error) {
			IMPORT_KEY_SUPPORTED = false;
			return misc.importKey(password);
		}
	} else {
		return misc.importKey(password);
	}
}

async function deriveBits(algorithm, baseKey, length) {
	if (DERIVE_BITS_SUPPORTED) {
		try {
			return await subtle.deriveBits(algorithm, baseKey, length);
		} catch (_error) {
			DERIVE_BITS_SUPPORTED = false;
			return misc.pbkdf2(baseKey, algorithm.salt, DERIVED_BITS_ALGORITHM.iterations, length);
		}
	} else {
		return misc.pbkdf2(baseKey, algorithm.salt, DERIVED_BITS_ALGORITHM.iterations, length);
	}
}

function encodePassword(password, rawPassword) {
	if (rawPassword === UNDEFINED_VALUE) {
		return encodeText(password);
	} else {
		return rawPassword;
	}
}

function concat(leftArray, rightArray) {
	let array = leftArray;
	if (leftArray.length + rightArray.length) {
		array = new Uint8Array(leftArray.length + rightArray.length);
		array.set(leftArray, 0);
		array.set(rightArray, leftArray.length);
	}
	return array;
}

function expand(inputArray, length) {
	if (length && length > inputArray.length) {
		const array = inputArray;
		inputArray = new Uint8Array(length);
		inputArray.set(array, 0);
	}
	return inputArray;
}

function subarray(array, begin, end) {
	return array.subarray(begin, end);
}

function fromBits(codecBytes, chunk) {
	return codecBytes.fromBits(chunk);
}
function toBits(codecBytes, chunk) {
	return codecBytes.toBits(chunk);
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const HEADER_LENGTH = 12;

class ZipCryptoDecryptionStream extends TransformStream {

	constructor({ password, passwordVerification, checkPasswordOnly }) {
		super({
			start() {
				Object.assign(this, {
					password,
					passwordVerification
				});
				createKeys(this, password);
			},
			transform(chunk, controller) {
				const zipCrypto = this;
				if (zipCrypto.password) {
					const decryptedHeader = decrypt(zipCrypto, chunk.subarray(0, HEADER_LENGTH));
					zipCrypto.password = null;
					if (decryptedHeader[HEADER_LENGTH - 1] != zipCrypto.passwordVerification) {
						throw new Error(ERR_INVALID_PASSWORD);
					}
					chunk = chunk.subarray(HEADER_LENGTH);
				}
				if (checkPasswordOnly) {
					controller.error(new Error(ERR_ABORT_CHECK_PASSWORD));
				} else {
					controller.enqueue(decrypt(zipCrypto, chunk));
				}
			}
		});
	}
}

class ZipCryptoEncryptionStream extends TransformStream {

	constructor({ password, passwordVerification }) {
		super({
			start() {
				Object.assign(this, {
					password,
					passwordVerification
				});
				createKeys(this, password);
			},
			transform(chunk, controller) {
				const zipCrypto = this;
				let output;
				let offset;
				if (zipCrypto.password) {
					zipCrypto.password = null;
					const header = getRandomValues(new Uint8Array(HEADER_LENGTH));
					header[HEADER_LENGTH - 1] = zipCrypto.passwordVerification;
					output = new Uint8Array(chunk.length + header.length);
					output.set(encrypt(zipCrypto, header), 0);
					offset = HEADER_LENGTH;
				} else {
					output = new Uint8Array(chunk.length);
					offset = 0;
				}
				output.set(encrypt(zipCrypto, chunk), offset);
				controller.enqueue(output);
			}
		});
	}
}

function decrypt(target, input) {
	const output = new Uint8Array(input.length);
	for (let index = 0; index < input.length; index++) {
		output[index] = getByte(target) ^ input[index];
		updateKeys(target, output[index]);
	}
	return output;
}

function encrypt(target, input) {
	const output = new Uint8Array(input.length);
	for (let index = 0; index < input.length; index++) {
		output[index] = getByte(target) ^ input[index];
		updateKeys(target, input[index]);
	}
	return output;
}

function createKeys(target, password) {
	const keys = [0x12345678, 0x23456789, 0x34567890];
	Object.assign(target, {
		keys,
		crcKey0: new Crc32(keys[0]),
		crcKey2: new Crc32(keys[2]),
	});
	for (let index = 0; index < password.length; index++) {
		updateKeys(target, password.charCodeAt(index));
	}
}

function updateKeys(target, byte) {
	let [key0, key1, key2] = target.keys;
	target.crcKey0.append([byte]);
	key0 = ~target.crcKey0.get();
	key1 = getInt32(Math.imul(getInt32(key1 + getInt8(key0)), 134775813) + 1);
	target.crcKey2.append([key1 >>> 24]);
	key2 = ~target.crcKey2.get();
	target.keys = [key0, key1, key2];
}

function getByte(target) {
	const temp = target.keys[2] | 2;
	return getInt8(Math.imul(temp, (temp ^ 1)) >>> 8);
}

function getInt8(number) {
	return number & 0xFF;
}

function getInt32(number) {
	return number & 0xFFFFFFFF;
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const COMPRESSION_FORMAT = "deflate-raw";

class DeflateStream extends TransformStream {

	constructor(options, { chunkSize, CompressionStream, CompressionStreamNative }) {
		super({});
		const { compressed, encrypted, useCompressionStream, zipCrypto, signed, level } = options;
		const stream = this;
		let crc32Stream, encryptionStream;
		let readable = filterEmptyChunks(super.readable);
		if ((!encrypted || zipCrypto) && signed) {
			crc32Stream = new Crc32Stream();
			readable = pipeThrough(readable, crc32Stream);
		}
		if (compressed) {
			readable = pipeThroughCommpressionStream(readable, useCompressionStream, { level, chunkSize }, CompressionStreamNative, CompressionStream);
		}
		if (encrypted) {
			if (zipCrypto) {
				readable = pipeThrough(readable, new ZipCryptoEncryptionStream(options));
			} else {
				encryptionStream = new AESEncryptionStream(options);
				readable = pipeThrough(readable, encryptionStream);
			}
		}
		setReadable(stream, readable, () => {
			let signature;
			if (encrypted && !zipCrypto) {
				signature = encryptionStream.signature;
			}
			if ((!encrypted || zipCrypto) && signed) {
				signature = new DataView(crc32Stream.value.buffer).getUint32(0);
			}
			stream.signature = signature;
		});
	}
}

class InflateStream extends TransformStream {

	constructor(options, { chunkSize, DecompressionStream, DecompressionStreamNative }) {
		super({});
		const { zipCrypto, encrypted, signed, signature, compressed, useCompressionStream } = options;
		let crc32Stream, decryptionStream;
		let readable = filterEmptyChunks(super.readable);
		if (encrypted) {
			if (zipCrypto) {
				readable = pipeThrough(readable, new ZipCryptoDecryptionStream(options));
			} else {
				decryptionStream = new AESDecryptionStream(options);
				readable = pipeThrough(readable, decryptionStream);
			}
		}
		if (compressed) {
			readable = pipeThroughCommpressionStream(readable, useCompressionStream, { chunkSize }, DecompressionStreamNative, DecompressionStream);
		}
		if ((!encrypted || zipCrypto) && signed) {
			crc32Stream = new Crc32Stream();
			readable = pipeThrough(readable, crc32Stream);
		}
		setReadable(this, readable, () => {
			if ((!encrypted || zipCrypto) && signed) {
				const dataViewSignature = new DataView(crc32Stream.value.buffer);
				if (signature != dataViewSignature.getUint32(0, false)) {
					throw new Error(ERR_INVALID_SIGNATURE);
				}
			}
		});
	}
}

function filterEmptyChunks(readable) {
	return pipeThrough(readable, new TransformStream({
		transform(chunk, controller) {
			if (chunk && chunk.length) {
				controller.enqueue(chunk);
			}
		}
	}));
}

function setReadable(stream, readable, flush) {
	readable = pipeThrough(readable, new TransformStream({ flush }));
	Object.defineProperty(stream, "readable", {
		get() {
			return readable;
		}
	});
}

function pipeThroughCommpressionStream(readable, useCompressionStream, options, CodecStreamNative, CodecStream) {
	try {
		const CompressionStream = useCompressionStream && CodecStreamNative ? CodecStreamNative : CodecStream;
		readable = pipeThrough(readable, new CompressionStream(COMPRESSION_FORMAT, options));
	} catch (error) {
		if (useCompressionStream) {
			try {
				readable = pipeThrough(readable, new CodecStream(COMPRESSION_FORMAT, options));
			} catch (error) {
				return readable;
			}
		} else {
			return readable;
		}
	}
	return readable;
}

function pipeThrough(readable, transformStream) {
	return readable.pipeThrough(transformStream);
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const MESSAGE_EVENT_TYPE = "message";
const MESSAGE_START = "start";
const MESSAGE_PULL = "pull";
const MESSAGE_DATA = "data";
const MESSAGE_ACK_DATA = "ack";
const MESSAGE_CLOSE = "close";
const CODEC_DEFLATE = "deflate";
const CODEC_INFLATE = "inflate";

class CodecStream extends TransformStream {

	constructor(options, config) {
		super({});
		const codec = this;
		const { codecType } = options;
		let Stream;
		if (codecType.startsWith(CODEC_DEFLATE)) {
			Stream = DeflateStream;
		} else if (codecType.startsWith(CODEC_INFLATE)) {
			Stream = InflateStream;
		}
		let outputSize = 0;
		let inputSize = 0;
		const stream = new Stream(options, config);
		const readable = super.readable;
		const inputSizeStream = new TransformStream({
			transform(chunk, controller) {
				if (chunk && chunk.length) {
					inputSize += chunk.length;
					controller.enqueue(chunk);
				}
			},
			flush() {
				Object.assign(codec, {
					inputSize
				});
			}
		});
		const outputSizeStream = new TransformStream({
			transform(chunk, controller) {
				if (chunk && chunk.length) {
					outputSize += chunk.length;
					controller.enqueue(chunk);
				}
			},
			flush() {
				const { signature } = stream;
				Object.assign(codec, {
					signature,
					outputSize,
					inputSize
				});
			}
		});
		Object.defineProperty(codec, "readable", {
			get() {
				return readable.pipeThrough(inputSizeStream).pipeThrough(stream).pipeThrough(outputSizeStream);
			}
		});
	}
}

class ChunkStream extends TransformStream {

	constructor(chunkSize) {
		let pendingChunk;
		super({
			transform,
			flush(controller) {
				if (pendingChunk && pendingChunk.length) {
					controller.enqueue(pendingChunk);
				}
			}
		});

		function transform(chunk, controller) {
			if (pendingChunk) {
				const newChunk = new Uint8Array(pendingChunk.length + chunk.length);
				newChunk.set(pendingChunk);
				newChunk.set(chunk, pendingChunk.length);
				chunk = newChunk;
				pendingChunk = null;
			}
			if (chunk.length > chunkSize) {
				controller.enqueue(chunk.slice(0, chunkSize));
				transform(chunk.slice(chunkSize), controller);
			} else {
				pendingChunk = chunk;
			}
		}
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


// deno-lint-ignore valid-typeof
let WEB_WORKERS_SUPPORTED = typeof Worker != UNDEFINED_TYPE;

class CodecWorker {

	constructor(workerData, { readable, writable }, { options, config, streamOptions, useWebWorkers, transferStreams, scripts }, onTaskFinished) {
		const { signal } = streamOptions;
		Object.assign(workerData, {
			busy: true,
			readable: readable
				.pipeThrough(new ChunkStream(config.chunkSize))
				.pipeThrough(new ProgressWatcherStream(readable, streamOptions), { signal }),
			writable,
			options: Object.assign({}, options),
			scripts,
			transferStreams,
			terminate() {
				return new Promise(resolve => {
					const { worker, busy } = workerData;
					if (worker) {
						if (busy) {
							workerData.resolveTerminated = resolve;
						} else {
							worker.terminate();
							resolve();
						}
						workerData.interface = null;
					} else {
						resolve();
					}
				});
			},
			onTaskFinished() {
				const { resolveTerminated } = workerData;
				if (resolveTerminated) {
					workerData.resolveTerminated = null;
					workerData.terminated = true;
					workerData.worker.terminate();
					resolveTerminated();
				}
				workerData.busy = false;
				onTaskFinished(workerData);
			}
		});
		return (useWebWorkers && WEB_WORKERS_SUPPORTED ? createWebWorkerInterface : createWorkerInterface)(workerData, config);
	}
}

class ProgressWatcherStream extends TransformStream {

	constructor(readableSource, { onstart, onprogress, size, onend }) {
		let chunkOffset = 0;
		super({
			async start() {
				if (onstart) {
					await callHandler(onstart, size);
				}
			},
			async transform(chunk, controller) {
				chunkOffset += chunk.length;
				if (onprogress) {
					await callHandler(onprogress, chunkOffset, size);
				}
				controller.enqueue(chunk);
			},
			async flush() {
				readableSource.size = chunkOffset;
				if (onend) {
					await callHandler(onend, chunkOffset);
				}
			}
		});
	}
}

async function callHandler(handler, ...parameters) {
	try {
		await handler(...parameters);
	} catch (_error) {
		// ignored
	}
}

function createWorkerInterface(workerData, config) {
	return {
		run: () => runWorker$1(workerData, config)
	};
}

function createWebWorkerInterface(workerData, config) {
	const { baseURL, chunkSize } = config;
	if (!workerData.interface) {
		let worker;
		try {
			worker = getWebWorker(workerData.scripts[0], baseURL, workerData);
		} catch (error) {
			WEB_WORKERS_SUPPORTED = false;
			return createWorkerInterface(workerData, config);
		}
		Object.assign(workerData, {
			worker,
			interface: {
				run: () => runWebWorker(workerData, { chunkSize })
			}
		});
	}
	return workerData.interface;
}

async function runWorker$1({ options, readable, writable, onTaskFinished }, config) {
	try {
		const codecStream = new CodecStream(options, config);
		await readable.pipeThrough(codecStream).pipeTo(writable, { preventClose: true, preventAbort: true });
		const {
			signature,
			inputSize,
			outputSize
		} = codecStream;
		return {
			signature,
			inputSize,
			outputSize
		};
	} finally {
		onTaskFinished();
	}
}

async function runWebWorker(workerData, config) {
	let resolveResult, rejectResult;
	const result = new Promise((resolve, reject) => {
		resolveResult = resolve;
		rejectResult = reject;
	});
	Object.assign(workerData, {
		reader: null,
		writer: null,
		resolveResult,
		rejectResult,
		result
	});
	const { readable, options, scripts } = workerData;
	const { writable, closed } = watchClosedStream(workerData.writable);
	const streamsTransferred = sendMessage({
		type: MESSAGE_START,
		scripts: scripts.slice(1),
		options,
		config,
		readable,
		writable
	}, workerData);
	if (!streamsTransferred) {
		Object.assign(workerData, {
			reader: readable.getReader(),
			writer: writable.getWriter()
		});
	}
	const resultValue = await result;
	if (!streamsTransferred) {
		await writable.getWriter().close();
	}
	await closed;
	return resultValue;
}

function watchClosedStream(writableSource) {
	let resolveStreamClosed;
	const closed = new Promise(resolve => resolveStreamClosed = resolve);
	const writable = new WritableStream({
		async write(chunk) {
			const writer = writableSource.getWriter();
			await writer.ready;
			await writer.write(chunk);
			writer.releaseLock();
		},
		close() {
			resolveStreamClosed();
		},
		abort(reason) {
			const writer = writableSource.getWriter();
			return writer.abort(reason);
		}
	});
	return { writable, closed };
}

let classicWorkersSupported = true;
let transferStreamsSupported = true;

function getWebWorker(url, baseURL, workerData) {
	const workerOptions = { type: "module" };
	let scriptUrl, worker;
	// deno-lint-ignore valid-typeof
	if (typeof url == FUNCTION_TYPE) {
		url = url();
	}
	try {
		scriptUrl = new URL(url, baseURL);
	} catch (_error) {
		scriptUrl = url;
	}
	if (classicWorkersSupported) {
		try {
			worker = new Worker(scriptUrl);
		} catch (_error) {
			classicWorkersSupported = false;
			worker = new Worker(scriptUrl, workerOptions);
		}
	} else {
		worker = new Worker(scriptUrl, workerOptions);
	}
	worker.addEventListener(MESSAGE_EVENT_TYPE, event => onMessage(event, workerData));
	return worker;
}

function sendMessage(message, { worker, writer, onTaskFinished, transferStreams }) {
	try {
		let { value, readable, writable } = message;
		const transferables = [];
		if (value) {
			if (value.byteLength < value.buffer.byteLength) {
				message.value = value.buffer.slice(0, value.byteLength);
			}
			else {
				message.value = value.buffer;
			}
			transferables.push(message.value);
		}
		if (transferStreams && transferStreamsSupported) {
			if (readable) {
				transferables.push(readable);
			}
			if (writable) {
				transferables.push(writable);
			}
		} else {
			message.readable = message.writable = null;
		}
		if (transferables.length) {
			try {
				worker.postMessage(message, transferables);
				return true;
			} catch (_error) {
				transferStreamsSupported = false;
				message.readable = message.writable = null;
				worker.postMessage(message);
			}
		} else {
			worker.postMessage(message);
		}
	} catch (error) {
		if (writer) {
			writer.releaseLock();
		}
		onTaskFinished();
		throw error;
	}
}

async function onMessage({ data }, workerData) {
	const { type, value, messageId, result, error } = data;
	const { reader, writer, resolveResult, rejectResult, onTaskFinished } = workerData;
	try {
		if (error) {
			const { message, stack, code, name } = error;
			const responseError = new Error(message);
			Object.assign(responseError, { stack, code, name });
			close(responseError);
		} else {
			if (type == MESSAGE_PULL) {
				const { value, done } = await reader.read();
				sendMessage({ type: MESSAGE_DATA, value, done, messageId }, workerData);
			}
			if (type == MESSAGE_DATA) {
				await writer.ready;
				await writer.write(new Uint8Array(value));
				sendMessage({ type: MESSAGE_ACK_DATA, messageId }, workerData);
			}
			if (type == MESSAGE_CLOSE) {
				close(null, result);
			}
		}
	} catch (error) {
		sendMessage({ type: MESSAGE_CLOSE, messageId }, workerData);
		close(error);
	}

	function close(error, result) {
		if (error) {
			rejectResult(error);
		} else {
			resolveResult(result);
		}
		if (writer) {
			writer.releaseLock();
		}
		onTaskFinished();
	}
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


let pool = [];
const pendingRequests = [];

let indexWorker = 0;

async function runWorker(stream, workerOptions) {
	const { options, config } = workerOptions;
	const { transferStreams, useWebWorkers, useCompressionStream, codecType, compressed, signed, encrypted } = options;
	const { workerScripts, maxWorkers } = config;
	workerOptions.transferStreams = transferStreams || transferStreams === UNDEFINED_VALUE;
	const streamCopy = !compressed && !signed && !encrypted && !workerOptions.transferStreams;
	workerOptions.useWebWorkers = !streamCopy && (useWebWorkers || (useWebWorkers === UNDEFINED_VALUE && config.useWebWorkers));
	workerOptions.scripts = workerOptions.useWebWorkers && workerScripts ? workerScripts[codecType] : [];
	options.useCompressionStream = useCompressionStream || (useCompressionStream === UNDEFINED_VALUE && config.useCompressionStream);
	return (await getWorker()).run();

	async function getWorker() {
		const workerData = pool.find(workerData => !workerData.busy);
		if (workerData) {
			clearTerminateTimeout(workerData);
			return new CodecWorker(workerData, stream, workerOptions, onTaskFinished);
		} else if (pool.length < maxWorkers) {
			const workerData = { indexWorker };
			indexWorker++;
			pool.push(workerData);
			return new CodecWorker(workerData, stream, workerOptions, onTaskFinished);
		} else {
			return new Promise(resolve => pendingRequests.push({ resolve, stream, workerOptions }));
		}
	}

	function onTaskFinished(workerData) {
		if (pendingRequests.length) {
			const [{ resolve, stream, workerOptions }] = pendingRequests.splice(0, 1);
			resolve(new CodecWorker(workerData, stream, workerOptions, onTaskFinished));
		} else if (workerData.worker) {
			clearTerminateTimeout(workerData);
			terminateWorker(workerData, workerOptions);
		} else {
			pool = pool.filter(data => data != workerData);
		}
	}
}

function terminateWorker(workerData, workerOptions) {
	const { config } = workerOptions;
	const { terminateWorkerTimeout } = config;
	if (Number.isFinite(terminateWorkerTimeout) && terminateWorkerTimeout >= 0) {
		if (workerData.terminated) {
			workerData.terminated = false;
		} else {
			workerData.terminateTimeout = setTimeout(async () => {
				pool = pool.filter(data => data != workerData);
				try {
					await workerData.terminate();
				} catch (_error) {
					// ignored
				}
			}, terminateWorkerTimeout);
		}
	}
}

function clearTerminateTimeout(workerData) {
	const { terminateTimeout } = workerData;
	if (terminateTimeout) {
		clearTimeout(terminateTimeout);
		workerData.terminateTimeout = null;
	}
}

function e(e,t={}){const n='const{Array:e,Object:t,Number:n,Math:r,Error:s,Uint8Array:i,Uint16Array:o,Uint32Array:c,Int32Array:f,Map:a,DataView:l,Promise:u,TextEncoder:w,crypto:h,postMessage:d,TransformStream:p,ReadableStream:y,WritableStream:m,CompressionStream:b,DecompressionStream:g}=self,k=void 0,v="undefined",S="function";class z{constructor(e){return class extends p{constructor(t,n){const r=new e(n);super({transform(e,t){t.enqueue(r.append(e))},flush(e){const t=r.flush();t&&e.enqueue(t)}})}}}}const C=[];for(let e=0;256>e;e++){let t=e;for(let e=0;8>e;e++)1&t?t=t>>>1^3988292384:t>>>=1;C[e]=t}class x{constructor(e){this.t=e||-1}append(e){let t=0|this.t;for(let n=0,r=0|e.length;r>n;n++)t=t>>>8^C[255&(t^e[n])];this.t=t}get(){return~this.t}}class A extends p{constructor(){let e;const t=new x;super({transform(e,n){t.append(e),n.enqueue(e)},flush(){const n=new i(4);new l(n.buffer).setUint32(0,t.get()),e.value=n}}),e=this}}const _={concat(e,t){if(0===e.length||0===t.length)return e.concat(t);const n=e[e.length-1],r=_.i(n);return 32===r?e.concat(t):_.o(t,r,0|n,e.slice(0,e.length-1))},l(e){const t=e.length;if(0===t)return 0;const n=e[t-1];return 32*(t-1)+_.i(n)},u(e,t){if(32*e.length<t)return e;const n=(e=e.slice(0,r.ceil(t/32))).length;return t&=31,n>0&&t&&(e[n-1]=_.h(t,e[n-1]&2147483648>>t-1,1)),e},h:(e,t,n)=>32===e?t:(n?0|t:t<<32-e)+1099511627776*e,i:e=>r.round(e/1099511627776)||32,o(e,t,n,r){for(void 0===r&&(r=[]);t>=32;t-=32)r.push(n),n=0;if(0===t)return r.concat(e);for(let s=0;s<e.length;s++)r.push(n|e[s]>>>t),n=e[s]<<32-t;const s=e.length?e[e.length-1]:0,i=_.i(s);return r.push(_.h(t+i&31,t+i>32?n:r.pop(),1)),r}},I={p:{m(e){const t=_.l(e)/8,n=new i(t);let r;for(let s=0;t>s;s++)3&s||(r=e[s/4]),n[s]=r>>>24,r<<=8;return n},k(e){const t=[];let n,r=0;for(n=0;n<e.length;n++)r=r<<8|e[n],3&~n||(t.push(r),r=0);return 3&n&&t.push(_.h(8*(3&n),r)),t}}},P=class{constructor(e){const t=this;t.blockSize=512,t.v=[1732584193,4023233417,2562383102,271733878,3285377520],t.S=[1518500249,1859775393,2400959708,3395469782],e?(t.C=e.C.slice(0),t.A=e.A.slice(0),t._=e._):t.reset()}reset(){const e=this;return e.C=e.v.slice(0),e.A=[],e._=0,e}update(e){const t=this;"string"==typeof e&&(e=I.I.k(e));const n=t.A=_.concat(t.A,e),r=t._,i=t._=r+_.l(e);if(i>9007199254740991)throw new s("Cannot hash more than 2^53 - 1 bits");const o=new c(n);let f=0;for(let e=t.blockSize+r-(t.blockSize+r&t.blockSize-1);i>=e;e+=t.blockSize)t.P(o.subarray(16*f,16*(f+1))),f+=1;return n.splice(0,16*f),t}D(){const e=this;let t=e.A;const n=e.C;t=_.concat(t,[_.h(1,1)]);for(let e=t.length+2;15&e;e++)t.push(0);for(t.push(r.floor(e._/4294967296)),t.push(0|e._);t.length;)e.P(t.splice(0,16));return e.reset(),n}V(e,t,n,r){return e>19?e>39?e>59?e>79?void 0:t^n^r:t&n|t&r|n&r:t^n^r:t&n|~t&r}R(e,t){return t<<e|t>>>32-e}P(t){const n=this,s=n.C,i=e(80);for(let e=0;16>e;e++)i[e]=t[e];let o=s[0],c=s[1],f=s[2],a=s[3],l=s[4];for(let e=0;79>=e;e++){16>e||(i[e]=n.R(1,i[e-3]^i[e-8]^i[e-14]^i[e-16]));const t=n.R(5,o)+n.V(e,c,f,a)+l+i[e]+n.S[r.floor(e/20)]|0;l=a,a=f,f=n.R(30,c),c=o,o=t}s[0]=s[0]+o|0,s[1]=s[1]+c|0,s[2]=s[2]+f|0,s[3]=s[3]+a|0,s[4]=s[4]+l|0}},D={getRandomValues(e){const t=new c(e.buffer),n=e=>{let t=987654321;const n=4294967295;return()=>(t=36969*(65535&t)+(t>>16)&n,(((t<<16)+(e=18e3*(65535&e)+(e>>16)&n)&n)/4294967296+.5)*(r.random()>.5?1:-1))};for(let s,i=0;i<e.length;i+=4){const e=n(4294967296*(s||r.random()));s=987654071*e(),t[i/4]=4294967296*e()|0}return e}},V={importKey:e=>new V.B(I.p.k(e)),M(e,t,n,r){if(n=n||1e4,0>r||0>n)throw new s("invalid params to pbkdf2");const i=1+(r>>5)<<2;let o,c,f,a,u;const w=new ArrayBuffer(i),h=new l(w);let d=0;const p=_;for(t=I.p.k(t),u=1;(i||1)>d;u++){for(o=c=e.encrypt(p.concat(t,[u])),f=1;n>f;f++)for(c=e.encrypt(c),a=0;a<c.length;a++)o[a]^=c[a];for(f=0;(i||1)>d&&f<o.length;f++)h.setInt32(d,o[f]),d+=4}return w.slice(0,r/8)},B:class{constructor(e){const t=this,n=t.U=P,r=[[],[]];t.K=[new n,new n];const s=t.K[0].blockSize/32;e.length>s&&(e=(new n).update(e).D());for(let t=0;s>t;t++)r[0][t]=909522486^e[t],r[1][t]=1549556828^e[t];t.K[0].update(r[0]),t.K[1].update(r[1]),t.N=new n(t.K[0])}reset(){const e=this;e.N=new e.U(e.K[0]),e.O=!1}update(e){this.O=!0,this.N.update(e)}digest(){const e=this,t=e.N.D(),n=new e.U(e.K[1]).update(t).D();return e.reset(),n}encrypt(e){if(this.O)throw new s("encrypt on already updated hmac called!");return this.update(e),this.digest(e)}}},R=typeof h!=v&&typeof h.getRandomValues==S,B="Invalid password",E="Invalid signature",M="zipjs-abort-check-password";function U(e){return R?h.getRandomValues(e):D.getRandomValues(e)}const K=16,N={name:"PBKDF2"},O=t.assign({hash:{name:"HMAC"}},N),T=t.assign({iterations:1e3,hash:{name:"SHA-1"}},N),W=["deriveBits"],j=[8,12,16],H=[16,24,32],L=10,F=[0,0,0,0],q=typeof h!=v,G=q&&h.subtle,J=q&&typeof G!=v,Q=I.p,X=class{constructor(e){const t=this;t.T=[[[],[],[],[],[]],[[],[],[],[],[]]],t.T[0][0][0]||t.W();const n=t.T[0][4],r=t.T[1],i=e.length;let o,c,f,a=1;if(4!==i&&6!==i&&8!==i)throw new s("invalid aes key size");for(t.S=[c=e.slice(0),f=[]],o=i;4*i+28>o;o++){let e=c[o-1];(o%i==0||8===i&&o%i==4)&&(e=n[e>>>24]<<24^n[e>>16&255]<<16^n[e>>8&255]<<8^n[255&e],o%i==0&&(e=e<<8^e>>>24^a<<24,a=a<<1^283*(a>>7))),c[o]=c[o-i]^e}for(let e=0;o;e++,o--){const t=c[3&e?o:o-4];f[e]=4>=o||4>e?t:r[0][n[t>>>24]]^r[1][n[t>>16&255]]^r[2][n[t>>8&255]]^r[3][n[255&t]]}}encrypt(e){return this.j(e,0)}decrypt(e){return this.j(e,1)}W(){const e=this.T[0],t=this.T[1],n=e[4],r=t[4],s=[],i=[];let o,c,f,a;for(let e=0;256>e;e++)i[(s[e]=e<<1^283*(e>>7))^e]=e;for(let l=o=0;!n[l];l^=c||1,o=i[o]||1){let i=o^o<<1^o<<2^o<<3^o<<4;i=i>>8^255&i^99,n[l]=i,r[i]=l,a=s[f=s[c=s[l]]];let u=16843009*a^65537*f^257*c^16843008*l,w=257*s[i]^16843008*i;for(let n=0;4>n;n++)e[n][l]=w=w<<24^w>>>8,t[n][i]=u=u<<24^u>>>8}for(let n=0;5>n;n++)e[n]=e[n].slice(0),t[n]=t[n].slice(0)}j(e,t){if(4!==e.length)throw new s("invalid aes block size");const n=this.S[t],r=n.length/4-2,i=[0,0,0,0],o=this.T[t],c=o[0],f=o[1],a=o[2],l=o[3],u=o[4];let w,h,d,p=e[0]^n[0],y=e[t?3:1]^n[1],m=e[2]^n[2],b=e[t?1:3]^n[3],g=4;for(let e=0;r>e;e++)w=c[p>>>24]^f[y>>16&255]^a[m>>8&255]^l[255&b]^n[g],h=c[y>>>24]^f[m>>16&255]^a[b>>8&255]^l[255&p]^n[g+1],d=c[m>>>24]^f[b>>16&255]^a[p>>8&255]^l[255&y]^n[g+2],b=c[b>>>24]^f[p>>16&255]^a[y>>8&255]^l[255&m]^n[g+3],g+=4,p=w,y=h,m=d;for(let e=0;4>e;e++)i[t?3&-e:e]=u[p>>>24]<<24^u[y>>16&255]<<16^u[m>>8&255]<<8^u[255&b]^n[g++],w=p,p=y,y=m,m=b,b=w;return i}},Y=class{constructor(e,t){this.H=e,this.L=t,this.F=t}reset(){this.F=this.L}update(e){return this.q(this.H,e,this.F)}G(e){if(255&~(e>>24))e+=1<<24;else{let t=e>>16&255,n=e>>8&255,r=255&e;255===t?(t=0,255===n?(n=0,255===r?r=0:++r):++n):++t,e=0,e+=t<<16,e+=n<<8,e+=r}return e}J(e){0===(e[0]=this.G(e[0]))&&(e[1]=this.G(e[1]))}q(e,t,n){let r;if(!(r=t.length))return[];const s=_.l(t);for(let s=0;r>s;s+=4){this.J(n);const r=e.encrypt(n);t[s]^=r[0],t[s+1]^=r[1],t[s+2]^=r[2],t[s+3]^=r[3]}return _.u(t,s)}},Z=V.B;let $=q&&J&&typeof G.importKey==S,ee=q&&J&&typeof G.deriveBits==S;class te extends p{constructor({password:e,rawPassword:n,signed:r,encryptionStrength:o,checkPasswordOnly:c}){super({start(){t.assign(this,{ready:new u((e=>this.X=e)),password:ie(e,n),signed:r,Y:o-1,pending:new i})},async transform(e,t){const n=this,{password:r,Y:o,X:f,ready:a}=n;r?(await(async(e,t,n,r)=>{const i=await se(e,t,n,ce(r,0,j[t])),o=ce(r,j[t]);if(i[0]!=o[0]||i[1]!=o[1])throw new s(B)})(n,o,r,ce(e,0,j[o]+2)),e=ce(e,j[o]+2),c?t.error(new s(M)):f()):await a;const l=new i(e.length-L-(e.length-L)%K);t.enqueue(re(n,e,l,0,L,!0))},async flush(e){const{signed:t,Z:n,$:r,pending:o,ready:c}=this;if(r&&n){await c;const f=ce(o,0,o.length-L),a=ce(o,o.length-L);let l=new i;if(f.length){const e=ae(Q,f);r.update(e);const t=n.update(e);l=fe(Q,t)}if(t){const e=ce(fe(Q,r.digest()),0,L);for(let t=0;L>t;t++)if(e[t]!=a[t])throw new s(E)}e.enqueue(l)}}})}}class ne extends p{constructor({password:e,rawPassword:n,encryptionStrength:r}){let s;super({start(){t.assign(this,{ready:new u((e=>this.X=e)),password:ie(e,n),Y:r-1,pending:new i})},async transform(e,t){const n=this,{password:r,Y:s,X:o,ready:c}=n;let f=new i;r?(f=await(async(e,t,n)=>{const r=U(new i(j[t]));return oe(r,await se(e,t,n,r))})(n,s,r),o()):await c;const a=new i(f.length+e.length-e.length%K);a.set(f,0),t.enqueue(re(n,e,a,f.length,0))},async flush(e){const{Z:t,$:n,pending:r,ready:o}=this;if(n&&t){await o;let c=new i;if(r.length){const e=t.update(ae(Q,r));n.update(e),c=fe(Q,e)}s.signature=fe(Q,n.digest()).slice(0,L),e.enqueue(oe(c,s.signature))}}}),s=this}}function re(e,t,n,r,s,o){const{Z:c,$:f,pending:a}=e,l=t.length-s;let u;for(a.length&&(t=oe(a,t),n=((e,t)=>{if(t&&t>e.length){const n=e;(e=new i(t)).set(n,0)}return e})(n,l-l%K)),u=0;l-K>=u;u+=K){const e=ae(Q,ce(t,u,u+K));o&&f.update(e);const s=c.update(e);o||f.update(s),n.set(fe(Q,s),u+r)}return e.pending=ce(t,u),n}async function se(n,r,s,o){n.password=null;const c=await(async(e,t,n,r,s)=>{if(!$)return V.importKey(t);try{return await G.importKey("raw",t,n,!1,s)}catch(e){return $=!1,V.importKey(t)}})(0,s,O,0,W),f=await(async(e,t,n)=>{if(!ee)return V.M(t,e.salt,T.iterations,n);try{return await G.deriveBits(e,t,n)}catch(r){return ee=!1,V.M(t,e.salt,T.iterations,n)}})(t.assign({salt:o},T),c,8*(2*H[r]+2)),a=new i(f),l=ae(Q,ce(a,0,H[r])),u=ae(Q,ce(a,H[r],2*H[r])),w=ce(a,2*H[r]);return t.assign(n,{keys:{key:l,ee:u,passwordVerification:w},Z:new Y(new X(l),e.from(F)),$:new Z(u)}),w}function ie(e,t){return t===k?(e=>{if(typeof w==v){const t=new i((e=unescape(encodeURIComponent(e))).length);for(let n=0;n<t.length;n++)t[n]=e.charCodeAt(n);return t}return(new w).encode(e)})(e):t}function oe(e,t){let n=e;return e.length+t.length&&(n=new i(e.length+t.length),n.set(e,0),n.set(t,e.length)),n}function ce(e,t,n){return e.subarray(t,n)}function fe(e,t){return e.m(t)}function ae(e,t){return e.k(t)}class le extends p{constructor({password:e,passwordVerification:n,checkPasswordOnly:r}){super({start(){t.assign(this,{password:e,passwordVerification:n}),de(this,e)},transform(e,t){const n=this;if(n.password){const t=we(n,e.subarray(0,12));if(n.password=null,t[11]!=n.passwordVerification)throw new s(B);e=e.subarray(12)}r?t.error(new s(M)):t.enqueue(we(n,e))}})}}class ue extends p{constructor({password:e,passwordVerification:n}){super({start(){t.assign(this,{password:e,passwordVerification:n}),de(this,e)},transform(e,t){const n=this;let r,s;if(n.password){n.password=null;const t=U(new i(12));t[11]=n.passwordVerification,r=new i(e.length+t.length),r.set(he(n,t),0),s=12}else r=new i(e.length),s=0;r.set(he(n,e),s),t.enqueue(r)}})}}function we(e,t){const n=new i(t.length);for(let r=0;r<t.length;r++)n[r]=ye(e)^t[r],pe(e,n[r]);return n}function he(e,t){const n=new i(t.length);for(let r=0;r<t.length;r++)n[r]=ye(e)^t[r],pe(e,t[r]);return n}function de(e,n){const r=[305419896,591751049,878082192];t.assign(e,{keys:r,te:new x(r[0]),ne:new x(r[2])});for(let t=0;t<n.length;t++)pe(e,n.charCodeAt(t))}function pe(e,t){let[n,s,i]=e.keys;e.te.append([t]),n=~e.te.get(),s=be(r.imul(be(s+me(n)),134775813)+1),e.ne.append([s>>>24]),i=~e.ne.get(),e.keys=[n,s,i]}function ye(e){const t=2|e.keys[2];return me(r.imul(t,1^t)>>>8)}function me(e){return 255&e}function be(e){return 4294967295&e}const ge="deflate-raw";class ke extends p{constructor(e,{chunkSize:t,CompressionStream:n,CompressionStreamNative:r}){super({});const{compressed:s,encrypted:i,useCompressionStream:o,zipCrypto:c,signed:f,level:a}=e,u=this;let w,h,d=Se(super.readable);i&&!c||!f||(w=new A,d=xe(d,w)),s&&(d=Ce(d,o,{level:a,chunkSize:t},r,n)),i&&(c?d=xe(d,new ue(e)):(h=new ne(e),d=xe(d,h))),ze(u,d,(()=>{let e;i&&!c&&(e=h.signature),i&&!c||!f||(e=new l(w.value.buffer).getUint32(0)),u.signature=e}))}}class ve extends p{constructor(e,{chunkSize:t,DecompressionStream:n,DecompressionStreamNative:r}){super({});const{zipCrypto:i,encrypted:o,signed:c,signature:f,compressed:a,useCompressionStream:u}=e;let w,h,d=Se(super.readable);o&&(i?d=xe(d,new le(e)):(h=new te(e),d=xe(d,h))),a&&(d=Ce(d,u,{chunkSize:t},r,n)),o&&!i||!c||(w=new A,d=xe(d,w)),ze(this,d,(()=>{if((!o||i)&&c){const e=new l(w.value.buffer);if(f!=e.getUint32(0,!1))throw new s(E)}}))}}function Se(e){return xe(e,new p({transform(e,t){e&&e.length&&t.enqueue(e)}}))}function ze(e,n,r){n=xe(n,new p({flush:r})),t.defineProperty(e,"readable",{get:()=>n})}function Ce(e,t,n,r,s){try{e=xe(e,new(t&&r?r:s)(ge,n))}catch(r){if(!t)return e;try{e=xe(e,new s(ge,n))}catch(t){return e}}return e}function xe(e,t){return e.pipeThrough(t)}const Ae="data",_e="close";class Ie extends p{constructor(e,n){super({});const r=this,{codecType:s}=e;let i;s.startsWith("deflate")?i=ke:s.startsWith("inflate")&&(i=ve);let o=0,c=0;const f=new i(e,n),a=super.readable,l=new p({transform(e,t){e&&e.length&&(c+=e.length,t.enqueue(e))},flush(){t.assign(r,{inputSize:c})}}),u=new p({transform(e,t){e&&e.length&&(o+=e.length,t.enqueue(e))},flush(){const{signature:e}=f;t.assign(r,{signature:e,outputSize:o,inputSize:c})}});t.defineProperty(r,"readable",{get:()=>a.pipeThrough(l).pipeThrough(f).pipeThrough(u)})}}class Pe extends p{constructor(e){let t;super({transform:function n(r,s){if(t){const e=new i(t.length+r.length);e.set(t),e.set(r,t.length),r=e,t=null}r.length>e?(s.enqueue(r.slice(0,e)),n(r.slice(e),s)):t=r},flush(e){t&&t.length&&e.enqueue(t)}})}}const De=new a,Ve=new a;let Re,Be=0,Ee=!0;async function Me(e){try{const{options:t,scripts:r,config:s}=e;if(r&&r.length)try{Ee?importScripts.apply(k,r):await Ue(r)}catch(e){Ee=!1,await Ue(r)}self.initCodec&&self.initCodec(),s.CompressionStreamNative=self.CompressionStream,s.DecompressionStreamNative=self.DecompressionStream,self.Deflate&&(s.CompressionStream=new z(self.Deflate)),self.Inflate&&(s.DecompressionStream=new z(self.Inflate));const i={highWaterMark:1},o=e.readable||new y({async pull(e){const t=new u((e=>De.set(Be,e)));Ke({type:"pull",messageId:Be}),Be=(Be+1)%n.MAX_SAFE_INTEGER;const{value:r,done:s}=await t;e.enqueue(r),s&&e.close()}},i),c=e.writable||new m({async write(e){let t;const r=new u((e=>t=e));Ve.set(Be,t),Ke({type:Ae,value:e,messageId:Be}),Be=(Be+1)%n.MAX_SAFE_INTEGER,await r}},i),f=new Ie(t,s);Re=new AbortController;const{signal:a}=Re;await o.pipeThrough(f).pipeThrough(new Pe(s.chunkSize)).pipeTo(c,{signal:a,preventClose:!0,preventAbort:!0}),await c.getWriter().close();const{signature:l,inputSize:w,outputSize:h}=f;Ke({type:_e,result:{signature:l,inputSize:w,outputSize:h}})}catch(e){Ne(e)}}async function Ue(e){for(const t of e)await import(t)}function Ke(e){let{value:t}=e;if(t)if(t.length)try{t=new i(t),e.value=t.buffer,d(e,[e.value])}catch(t){d(e)}else d(e);else d(e)}function Ne(e=new s("Unknown error")){const{message:t,stack:n,code:r,name:i}=e;d({error:{message:t,stack:n,code:r,name:i}})}addEventListener("message",(({data:e})=>{const{type:t,messageId:n,value:r,done:s}=e;try{if("start"==t&&Me(e),t==Ae){const e=De.get(n);De.delete(n),e({value:new i(r),done:s})}if("ack"==t){const e=Ve.get(n);Ve.delete(n),e()}t==_e&&Re.abort()}catch(e){Ne(e)}}));const Oe=15,Te=573,We=-2;function je(t){return He(t.map((([t,n])=>new e(t).fill(n,0,t))))}function He(t){return t.reduce(((t,n)=>t.concat(e.isArray(n)?He(n):n)),[])}const Le=[0,1,2,3].concat(...je([[2,4],[2,5],[4,6],[4,7],[8,8],[8,9],[16,10],[16,11],[32,12],[32,13],[64,14],[64,15],[2,0],[1,16],[1,17],[2,18],[2,19],[4,20],[4,21],[8,22],[8,23],[16,24],[16,25],[32,26],[32,27],[64,28],[64,29]]));function Fe(){const e=this;function t(e,t){let n=0;do{n|=1&e,e>>>=1,n<<=1}while(--t>0);return n>>>1}e.re=n=>{const s=e.se,i=e.oe.ie,o=e.oe.ce;let c,f,a,l=-1;for(n.fe=0,n.ae=Te,c=0;o>c;c++)0!==s[2*c]?(n.le[++n.fe]=l=c,n.ue[c]=0):s[2*c+1]=0;for(;2>n.fe;)a=n.le[++n.fe]=2>l?++l:0,s[2*a]=1,n.ue[a]=0,n.we--,i&&(n.he-=i[2*a+1]);for(e.de=l,c=r.floor(n.fe/2);c>=1;c--)n.pe(s,c);a=o;do{c=n.le[1],n.le[1]=n.le[n.fe--],n.pe(s,1),f=n.le[1],n.le[--n.ae]=c,n.le[--n.ae]=f,s[2*a]=s[2*c]+s[2*f],n.ue[a]=r.max(n.ue[c],n.ue[f])+1,s[2*c+1]=s[2*f+1]=a,n.le[1]=a++,n.pe(s,1)}while(n.fe>=2);n.le[--n.ae]=n.le[1],(t=>{const n=e.se,r=e.oe.ie,s=e.oe.ye,i=e.oe.me,o=e.oe.be;let c,f,a,l,u,w,h=0;for(l=0;Oe>=l;l++)t.ge[l]=0;for(n[2*t.le[t.ae]+1]=0,c=t.ae+1;Te>c;c++)f=t.le[c],l=n[2*n[2*f+1]+1]+1,l>o&&(l=o,h++),n[2*f+1]=l,f>e.de||(t.ge[l]++,u=0,i>f||(u=s[f-i]),w=n[2*f],t.we+=w*(l+u),r&&(t.he+=w*(r[2*f+1]+u)));if(0!==h){do{for(l=o-1;0===t.ge[l];)l--;t.ge[l]--,t.ge[l+1]+=2,t.ge[o]--,h-=2}while(h>0);for(l=o;0!==l;l--)for(f=t.ge[l];0!==f;)a=t.le[--c],a>e.de||(n[2*a+1]!=l&&(t.we+=(l-n[2*a+1])*n[2*a],n[2*a+1]=l),f--)}})(n),((e,n,r)=>{const s=[];let i,o,c,f=0;for(i=1;Oe>=i;i++)s[i]=f=f+r[i-1]<<1;for(o=0;n>=o;o++)c=e[2*o+1],0!==c&&(e[2*o]=t(s[c]++,c))})(s,e.de,n.ge)}}function qe(e,t,n,r,s){const i=this;i.ie=e,i.ye=t,i.me=n,i.ce=r,i.be=s}Fe.ke=[0,1,2,3,4,5,6,7].concat(...je([[2,8],[2,9],[2,10],[2,11],[4,12],[4,13],[4,14],[4,15],[8,16],[8,17],[8,18],[8,19],[16,20],[16,21],[16,22],[16,23],[32,24],[32,25],[32,26],[31,27],[1,28]])),Fe.ve=[0,1,2,3,4,5,6,7,8,10,12,14,16,20,24,28,32,40,48,56,64,80,96,112,128,160,192,224,0],Fe.Se=[0,1,2,3,4,6,8,12,16,24,32,48,64,96,128,192,256,384,512,768,1024,1536,2048,3072,4096,6144,8192,12288,16384,24576],Fe.ze=e=>256>e?Le[e]:Le[256+(e>>>7)],Fe.Ce=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],Fe.xe=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],Fe.Ae=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],Fe._e=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];const Ge=je([[144,8],[112,9],[24,7],[8,8]]);qe.Ie=He([12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,19,275,147,403,83,339,211,467,51,307,179,435,115,371,243,499,11,267,139,395,75,331,203,459,43,299,171,427,107,363,235,491,27,283,155,411,91,347,219,475,59,315,187,443,123,379,251,507,7,263,135,391,71,327,199,455,39,295,167,423,103,359,231,487,23,279,151,407,87,343,215,471,55,311,183,439,119,375,247,503,15,271,143,399,79,335,207,463,47,303,175,431,111,367,239,495,31,287,159,415,95,351,223,479,63,319,191,447,127,383,255,511,0,64,32,96,16,80,48,112,8,72,40,104,24,88,56,120,4,68,36,100,20,84,52,116,3,131,67,195,35,163,99,227].map(((e,t)=>[e,Ge[t]])));const Je=je([[30,5]]);function Qe(e,t,n,r,s){const i=this;i.Pe=e,i.De=t,i.Ve=n,i.Re=r,i.Be=s}qe.Ee=He([0,16,8,24,4,20,12,28,2,18,10,26,6,22,14,30,1,17,9,25,5,21,13,29,3,19,11,27,7,23].map(((e,t)=>[e,Je[t]]))),qe.Me=new qe(qe.Ie,Fe.Ce,257,286,Oe),qe.Ue=new qe(qe.Ee,Fe.xe,0,30,Oe),qe.Ke=new qe(null,Fe.Ae,0,19,7);const Xe=[new Qe(0,0,0,0,0),new Qe(4,4,8,4,1),new Qe(4,5,16,8,1),new Qe(4,6,32,32,1),new Qe(4,4,16,16,2),new Qe(8,16,32,32,2),new Qe(8,16,128,128,2),new Qe(8,32,128,256,2),new Qe(32,128,258,1024,2),new Qe(32,258,258,4096,2)],Ye=["need dictionary","stream end","","","stream error","data error","","buffer error","",""],Ze=113,$e=666,et=262;function tt(e,t,n,r){const s=e[2*t],i=e[2*n];return i>s||s==i&&r[t]<=r[n]}function nt(){const e=this;let t,n,s,c,f,a,l,u,w,h,d,p,y,m,b,g,k,v,S,z,C,x,A,_,I,P,D,V,R,B,E,M,U;const K=new Fe,N=new Fe,O=new Fe;let T,W,j,H,L,F;function q(){let t;for(t=0;286>t;t++)E[2*t]=0;for(t=0;30>t;t++)M[2*t]=0;for(t=0;19>t;t++)U[2*t]=0;E[512]=1,e.we=e.he=0,W=j=0}function G(e,t){let n,r=-1,s=e[1],i=0,o=7,c=4;0===s&&(o=138,c=3),e[2*(t+1)+1]=65535;for(let f=0;t>=f;f++)n=s,s=e[2*(f+1)+1],++i<o&&n==s||(c>i?U[2*n]+=i:0!==n?(n!=r&&U[2*n]++,U[32]++):i>10?U[36]++:U[34]++,i=0,r=n,0===s?(o=138,c=3):n==s?(o=6,c=3):(o=7,c=4))}function J(t){e.Ne[e.pending++]=t}function Q(e){J(255&e),J(e>>>8&255)}function X(e,t){let n;const r=t;F>16-r?(n=e,L|=n<<F&65535,Q(L),L=n>>>16-F,F+=r-16):(L|=e<<F&65535,F+=r)}function Y(e,t){const n=2*e;X(65535&t[n],65535&t[n+1])}function Z(e,t){let n,r,s=-1,i=e[1],o=0,c=7,f=4;for(0===i&&(c=138,f=3),n=0;t>=n;n++)if(r=i,i=e[2*(n+1)+1],++o>=c||r!=i){if(f>o)do{Y(r,U)}while(0!=--o);else 0!==r?(r!=s&&(Y(r,U),o--),Y(16,U),X(o-3,2)):o>10?(Y(18,U),X(o-11,7)):(Y(17,U),X(o-3,3));o=0,s=r,0===i?(c=138,f=3):r==i?(c=6,f=3):(c=7,f=4)}}function $(){16==F?(Q(L),L=0,F=0):8>F||(J(255&L),L>>>=8,F-=8)}function ee(t,n){let s,i,o;if(e.Oe[W]=t,e.Te[W]=255&n,W++,0===t?E[2*n]++:(j++,t--,E[2*(Fe.ke[n]+256+1)]++,M[2*Fe.ze(t)]++),!(8191&W)&&D>2){for(s=8*W,i=C-k,o=0;30>o;o++)s+=M[2*o]*(5+Fe.xe[o]);if(s>>>=3,j<r.floor(W/2)&&s<r.floor(i/2))return!0}return W==T-1}function te(t,n){let r,s,i,o,c=0;if(0!==W)do{r=e.Oe[c],s=e.Te[c],c++,0===r?Y(s,t):(i=Fe.ke[s],Y(i+256+1,t),o=Fe.Ce[i],0!==o&&(s-=Fe.ve[i],X(s,o)),r--,i=Fe.ze(r),Y(i,n),o=Fe.xe[i],0!==o&&(r-=Fe.Se[i],X(r,o)))}while(W>c);Y(256,t),H=t[513]}function ne(){F>8?Q(L):F>0&&J(255&L),L=0,F=0}function re(t,n,r){X(0+(r?1:0),3),((t,n)=>{ne(),H=8,Q(n),Q(~n),e.Ne.set(u.subarray(t,t+n),e.pending),e.pending+=n})(t,n)}function se(n){((t,n,r)=>{let s,i,o=0;D>0?(K.re(e),N.re(e),o=(()=>{let t;for(G(E,K.de),G(M,N.de),O.re(e),t=18;t>=3&&0===U[2*Fe._e[t]+1];t--);return e.we+=14+3*(t+1),t})(),s=e.we+3+7>>>3,i=e.he+3+7>>>3,i>s||(s=i)):s=i=n+5,n+4>s||-1==t?i==s?(X(2+(r?1:0),3),te(qe.Ie,qe.Ee)):(X(4+(r?1:0),3),((e,t,n)=>{let r;for(X(e-257,5),X(t-1,5),X(n-4,4),r=0;n>r;r++)X(U[2*Fe._e[r]+1],3);Z(E,e-1),Z(M,t-1)})(K.de+1,N.de+1,o+1),te(E,M)):re(t,n,r),q(),r&&ne()})(0>k?-1:k,C-k,n),k=C,t.We()}function ie(){let e,n,r,s;do{if(s=w-A-C,0===s&&0===C&&0===A)s=f;else if(-1==s)s--;else if(C>=f+f-et){u.set(u.subarray(f,f+f),0),x-=f,C-=f,k-=f,e=y,r=e;do{n=65535&d[--r],d[r]=f>n?0:n-f}while(0!=--e);e=f,r=e;do{n=65535&h[--r],h[r]=f>n?0:n-f}while(0!=--e);s+=f}if(0===t.je)return;e=t.He(u,C+A,s),A+=e,3>A||(p=255&u[C],p=(p<<g^255&u[C+1])&b)}while(et>A&&0!==t.je)}function oe(e){let t,n,r=I,s=C,i=_;const o=C>f-et?C-(f-et):0;let c=B;const a=l,w=C+258;let d=u[s+i-1],p=u[s+i];R>_||(r>>=2),c>A&&(c=A);do{if(t=e,u[t+i]==p&&u[t+i-1]==d&&u[t]==u[s]&&u[++t]==u[s+1]){s+=2,t++;do{}while(u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&u[++s]==u[++t]&&w>s);if(n=258-(w-s),s=w-258,n>i){if(x=e,i=n,n>=c)break;d=u[s+i-1],p=u[s+i]}}}while((e=65535&h[e&a])>o&&0!=--r);return i>A?A:i}e.ue=[],e.ge=[],e.le=[],E=[],M=[],U=[],e.pe=(t,n)=>{const r=e.le,s=r[n];let i=n<<1;for(;i<=e.fe&&(i<e.fe&&tt(t,r[i+1],r[i],e.ue)&&i++,!tt(t,s,r[i],e.ue));)r[n]=r[i],n=i,i<<=1;r[n]=s},e.Le=(t,S,x,W,j,G)=>(W||(W=8),j||(j=8),G||(G=0),t.Fe=null,-1==S&&(S=6),1>j||j>9||8!=W||9>x||x>15||0>S||S>9||0>G||G>2?We:(t.qe=e,a=x,f=1<<a,l=f-1,m=j+7,y=1<<m,b=y-1,g=r.floor((m+3-1)/3),u=new i(2*f),h=[],d=[],T=1<<j+6,e.Ne=new i(4*T),s=4*T,e.Oe=new o(T),e.Te=new i(T),D=S,V=G,(t=>(t.Ge=t.Je=0,t.Fe=null,e.pending=0,e.Qe=0,n=Ze,c=0,K.se=E,K.oe=qe.Me,N.se=M,N.oe=qe.Ue,O.se=U,O.oe=qe.Ke,L=0,F=0,H=8,q(),(()=>{w=2*f,d[y-1]=0;for(let e=0;y-1>e;e++)d[e]=0;P=Xe[D].De,R=Xe[D].Pe,B=Xe[D].Ve,I=Xe[D].Re,C=0,k=0,A=0,v=_=2,z=0,p=0})(),0))(t))),e.Xe=()=>42!=n&&n!=Ze&&n!=$e?We:(e.Te=null,e.Oe=null,e.Ne=null,d=null,h=null,u=null,e.qe=null,n==Ze?-3:0),e.Ye=(e,t,n)=>{let r=0;return-1==t&&(t=6),0>t||t>9||0>n||n>2?We:(Xe[D].Be!=Xe[t].Be&&0!==e.Ge&&(r=e.Ze(1)),D!=t&&(D=t,P=Xe[D].De,R=Xe[D].Pe,B=Xe[D].Ve,I=Xe[D].Re),V=n,r)},e.$e=(e,t,r)=>{let s,i=r,o=0;if(!t||42!=n)return We;if(3>i)return 0;for(i>f-et&&(i=f-et,o=r-i),u.set(t.subarray(o,o+i),0),C=i,k=i,p=255&u[0],p=(p<<g^255&u[1])&b,s=0;i-3>=s;s++)p=(p<<g^255&u[s+2])&b,h[s&l]=d[p],d[p]=s;return 0},e.Ze=(r,i)=>{let o,w,m,I,R;if(i>4||0>i)return We;if(!r.et||!r.tt&&0!==r.je||n==$e&&4!=i)return r.Fe=Ye[4],We;if(0===r.nt)return r.Fe=Ye[7],-5;var B;if(t=r,I=c,c=i,42==n&&(w=8+(a-8<<4)<<8,m=(D-1&255)>>1,m>3&&(m=3),w|=m<<6,0!==C&&(w|=32),w+=31-w%31,n=Ze,J((B=w)>>8&255),J(255&B)),0!==e.pending){if(t.We(),0===t.nt)return c=-1,0}else if(0===t.je&&I>=i&&4!=i)return t.Fe=Ye[7],-5;if(n==$e&&0!==t.je)return r.Fe=Ye[7],-5;if(0!==t.je||0!==A||0!=i&&n!=$e){switch(R=-1,Xe[D].Be){case 0:R=(e=>{let n,r=65535;for(r>s-5&&(r=s-5);;){if(1>=A){if(ie(),0===A&&0==e)return 0;if(0===A)break}if(C+=A,A=0,n=k+r,(0===C||C>=n)&&(A=C-n,C=n,se(!1),0===t.nt))return 0;if(C-k>=f-et&&(se(!1),0===t.nt))return 0}return se(4==e),0===t.nt?4==e?2:0:4==e?3:1})(i);break;case 1:R=(e=>{let n,r=0;for(;;){if(et>A){if(ie(),et>A&&0==e)return 0;if(0===A)break}if(3>A||(p=(p<<g^255&u[C+2])&b,r=65535&d[p],h[C&l]=d[p],d[p]=C),0===r||(C-r&65535)>f-et||2!=V&&(v=oe(r)),3>v)n=ee(0,255&u[C]),A--,C++;else if(n=ee(C-x,v-3),A-=v,v>P||3>A)C+=v,v=0,p=255&u[C],p=(p<<g^255&u[C+1])&b;else{v--;do{C++,p=(p<<g^255&u[C+2])&b,r=65535&d[p],h[C&l]=d[p],d[p]=C}while(0!=--v);C++}if(n&&(se(!1),0===t.nt))return 0}return se(4==e),0===t.nt?4==e?2:0:4==e?3:1})(i);break;case 2:R=(e=>{let n,r,s=0;for(;;){if(et>A){if(ie(),et>A&&0==e)return 0;if(0===A)break}if(3>A||(p=(p<<g^255&u[C+2])&b,s=65535&d[p],h[C&l]=d[p],d[p]=C),_=v,S=x,v=2,0!==s&&P>_&&f-et>=(C-s&65535)&&(2!=V&&(v=oe(s)),5>=v&&(1==V||3==v&&C-x>4096)&&(v=2)),3>_||v>_)if(0!==z){if(n=ee(0,255&u[C-1]),n&&se(!1),C++,A--,0===t.nt)return 0}else z=1,C++,A--;else{r=C+A-3,n=ee(C-1-S,_-3),A-=_-1,_-=2;do{++C>r||(p=(p<<g^255&u[C+2])&b,s=65535&d[p],h[C&l]=d[p],d[p]=C)}while(0!=--_);if(z=0,v=2,C++,n&&(se(!1),0===t.nt))return 0}}return 0!==z&&(n=ee(0,255&u[C-1]),z=0),se(4==e),0===t.nt?4==e?2:0:4==e?3:1})(i)}if(2!=R&&3!=R||(n=$e),0==R||2==R)return 0===t.nt&&(c=-1),0;if(1==R){if(1==i)X(2,3),Y(256,qe.Ie),$(),9>1+H+10-F&&(X(2,3),Y(256,qe.Ie),$()),H=7;else if(re(0,0,!1),3==i)for(o=0;y>o;o++)d[o]=0;if(t.We(),0===t.nt)return c=-1,0}}return 4!=i?0:1}}function rt(){const e=this;e.rt=0,e.st=0,e.je=0,e.Ge=0,e.nt=0,e.Je=0}function st(e){const t=new rt,n=(o=e&&e.chunkSize?e.chunkSize:65536)+5*(r.floor(o/16383)+1);var o;const c=new i(n);let f=e?e.level:-1;void 0===f&&(f=-1),t.Le(f),t.et=c,this.append=(e,r)=>{let o,f,a=0,l=0,u=0;const w=[];if(e.length){t.rt=0,t.tt=e,t.je=e.length;do{if(t.st=0,t.nt=n,o=t.Ze(0),0!=o)throw new s("deflating: "+t.Fe);t.st&&(t.st==n?w.push(new i(c)):w.push(c.subarray(0,t.st))),u+=t.st,r&&t.rt>0&&t.rt!=a&&(r(t.rt),a=t.rt)}while(t.je>0||0===t.nt);return w.length>1?(f=new i(u),w.forEach((e=>{f.set(e,l),l+=e.length}))):f=w[0]?new i(w[0]):new i,f}},this.flush=()=>{let e,r,o=0,f=0;const a=[];do{if(t.st=0,t.nt=n,e=t.Ze(4),1!=e&&0!=e)throw new s("deflating: "+t.Fe);n-t.nt>0&&a.push(c.slice(0,t.st)),f+=t.st}while(t.je>0||0===t.nt);return t.Xe(),r=new i(f),a.forEach((e=>{r.set(e,o),o+=e.length})),r}}rt.prototype={Le(e,t){const n=this;return n.qe=new nt,t||(t=Oe),n.qe.Le(n,e,t)},Ze(e){const t=this;return t.qe?t.qe.Ze(t,e):We},Xe(){const e=this;if(!e.qe)return We;const t=e.qe.Xe();return e.qe=null,t},Ye(e,t){const n=this;return n.qe?n.qe.Ye(n,e,t):We},$e(e,t){const n=this;return n.qe?n.qe.$e(n,e,t):We},He(e,t,n){const r=this;let s=r.je;return s>n&&(s=n),0===s?0:(r.je-=s,e.set(r.tt.subarray(r.rt,r.rt+s),t),r.rt+=s,r.Ge+=s,s)},We(){const e=this;let t=e.qe.pending;t>e.nt&&(t=e.nt),0!==t&&(e.et.set(e.qe.Ne.subarray(e.qe.Qe,e.qe.Qe+t),e.st),e.st+=t,e.qe.Qe+=t,e.Je+=t,e.nt-=t,e.qe.pending-=t,0===e.qe.pending&&(e.qe.Qe=0))}};const it=0,ot=1,ct=-2,ft=-3,at=-4,lt=-5,ut=[0,1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,16383,32767,65535],wt=1440,ht=[96,7,256,0,8,80,0,8,16,84,8,115,82,7,31,0,8,112,0,8,48,0,9,192,80,7,10,0,8,96,0,8,32,0,9,160,0,8,0,0,8,128,0,8,64,0,9,224,80,7,6,0,8,88,0,8,24,0,9,144,83,7,59,0,8,120,0,8,56,0,9,208,81,7,17,0,8,104,0,8,40,0,9,176,0,8,8,0,8,136,0,8,72,0,9,240,80,7,4,0,8,84,0,8,20,85,8,227,83,7,43,0,8,116,0,8,52,0,9,200,81,7,13,0,8,100,0,8,36,0,9,168,0,8,4,0,8,132,0,8,68,0,9,232,80,7,8,0,8,92,0,8,28,0,9,152,84,7,83,0,8,124,0,8,60,0,9,216,82,7,23,0,8,108,0,8,44,0,9,184,0,8,12,0,8,140,0,8,76,0,9,248,80,7,3,0,8,82,0,8,18,85,8,163,83,7,35,0,8,114,0,8,50,0,9,196,81,7,11,0,8,98,0,8,34,0,9,164,0,8,2,0,8,130,0,8,66,0,9,228,80,7,7,0,8,90,0,8,26,0,9,148,84,7,67,0,8,122,0,8,58,0,9,212,82,7,19,0,8,106,0,8,42,0,9,180,0,8,10,0,8,138,0,8,74,0,9,244,80,7,5,0,8,86,0,8,22,192,8,0,83,7,51,0,8,118,0,8,54,0,9,204,81,7,15,0,8,102,0,8,38,0,9,172,0,8,6,0,8,134,0,8,70,0,9,236,80,7,9,0,8,94,0,8,30,0,9,156,84,7,99,0,8,126,0,8,62,0,9,220,82,7,27,0,8,110,0,8,46,0,9,188,0,8,14,0,8,142,0,8,78,0,9,252,96,7,256,0,8,81,0,8,17,85,8,131,82,7,31,0,8,113,0,8,49,0,9,194,80,7,10,0,8,97,0,8,33,0,9,162,0,8,1,0,8,129,0,8,65,0,9,226,80,7,6,0,8,89,0,8,25,0,9,146,83,7,59,0,8,121,0,8,57,0,9,210,81,7,17,0,8,105,0,8,41,0,9,178,0,8,9,0,8,137,0,8,73,0,9,242,80,7,4,0,8,85,0,8,21,80,8,258,83,7,43,0,8,117,0,8,53,0,9,202,81,7,13,0,8,101,0,8,37,0,9,170,0,8,5,0,8,133,0,8,69,0,9,234,80,7,8,0,8,93,0,8,29,0,9,154,84,7,83,0,8,125,0,8,61,0,9,218,82,7,23,0,8,109,0,8,45,0,9,186,0,8,13,0,8,141,0,8,77,0,9,250,80,7,3,0,8,83,0,8,19,85,8,195,83,7,35,0,8,115,0,8,51,0,9,198,81,7,11,0,8,99,0,8,35,0,9,166,0,8,3,0,8,131,0,8,67,0,9,230,80,7,7,0,8,91,0,8,27,0,9,150,84,7,67,0,8,123,0,8,59,0,9,214,82,7,19,0,8,107,0,8,43,0,9,182,0,8,11,0,8,139,0,8,75,0,9,246,80,7,5,0,8,87,0,8,23,192,8,0,83,7,51,0,8,119,0,8,55,0,9,206,81,7,15,0,8,103,0,8,39,0,9,174,0,8,7,0,8,135,0,8,71,0,9,238,80,7,9,0,8,95,0,8,31,0,9,158,84,7,99,0,8,127,0,8,63,0,9,222,82,7,27,0,8,111,0,8,47,0,9,190,0,8,15,0,8,143,0,8,79,0,9,254,96,7,256,0,8,80,0,8,16,84,8,115,82,7,31,0,8,112,0,8,48,0,9,193,80,7,10,0,8,96,0,8,32,0,9,161,0,8,0,0,8,128,0,8,64,0,9,225,80,7,6,0,8,88,0,8,24,0,9,145,83,7,59,0,8,120,0,8,56,0,9,209,81,7,17,0,8,104,0,8,40,0,9,177,0,8,8,0,8,136,0,8,72,0,9,241,80,7,4,0,8,84,0,8,20,85,8,227,83,7,43,0,8,116,0,8,52,0,9,201,81,7,13,0,8,100,0,8,36,0,9,169,0,8,4,0,8,132,0,8,68,0,9,233,80,7,8,0,8,92,0,8,28,0,9,153,84,7,83,0,8,124,0,8,60,0,9,217,82,7,23,0,8,108,0,8,44,0,9,185,0,8,12,0,8,140,0,8,76,0,9,249,80,7,3,0,8,82,0,8,18,85,8,163,83,7,35,0,8,114,0,8,50,0,9,197,81,7,11,0,8,98,0,8,34,0,9,165,0,8,2,0,8,130,0,8,66,0,9,229,80,7,7,0,8,90,0,8,26,0,9,149,84,7,67,0,8,122,0,8,58,0,9,213,82,7,19,0,8,106,0,8,42,0,9,181,0,8,10,0,8,138,0,8,74,0,9,245,80,7,5,0,8,86,0,8,22,192,8,0,83,7,51,0,8,118,0,8,54,0,9,205,81,7,15,0,8,102,0,8,38,0,9,173,0,8,6,0,8,134,0,8,70,0,9,237,80,7,9,0,8,94,0,8,30,0,9,157,84,7,99,0,8,126,0,8,62,0,9,221,82,7,27,0,8,110,0,8,46,0,9,189,0,8,14,0,8,142,0,8,78,0,9,253,96,7,256,0,8,81,0,8,17,85,8,131,82,7,31,0,8,113,0,8,49,0,9,195,80,7,10,0,8,97,0,8,33,0,9,163,0,8,1,0,8,129,0,8,65,0,9,227,80,7,6,0,8,89,0,8,25,0,9,147,83,7,59,0,8,121,0,8,57,0,9,211,81,7,17,0,8,105,0,8,41,0,9,179,0,8,9,0,8,137,0,8,73,0,9,243,80,7,4,0,8,85,0,8,21,80,8,258,83,7,43,0,8,117,0,8,53,0,9,203,81,7,13,0,8,101,0,8,37,0,9,171,0,8,5,0,8,133,0,8,69,0,9,235,80,7,8,0,8,93,0,8,29,0,9,155,84,7,83,0,8,125,0,8,61,0,9,219,82,7,23,0,8,109,0,8,45,0,9,187,0,8,13,0,8,141,0,8,77,0,9,251,80,7,3,0,8,83,0,8,19,85,8,195,83,7,35,0,8,115,0,8,51,0,9,199,81,7,11,0,8,99,0,8,35,0,9,167,0,8,3,0,8,131,0,8,67,0,9,231,80,7,7,0,8,91,0,8,27,0,9,151,84,7,67,0,8,123,0,8,59,0,9,215,82,7,19,0,8,107,0,8,43,0,9,183,0,8,11,0,8,139,0,8,75,0,9,247,80,7,5,0,8,87,0,8,23,192,8,0,83,7,51,0,8,119,0,8,55,0,9,207,81,7,15,0,8,103,0,8,39,0,9,175,0,8,7,0,8,135,0,8,71,0,9,239,80,7,9,0,8,95,0,8,31,0,9,159,84,7,99,0,8,127,0,8,63,0,9,223,82,7,27,0,8,111,0,8,47,0,9,191,0,8,15,0,8,143,0,8,79,0,9,255],dt=[80,5,1,87,5,257,83,5,17,91,5,4097,81,5,5,89,5,1025,85,5,65,93,5,16385,80,5,3,88,5,513,84,5,33,92,5,8193,82,5,9,90,5,2049,86,5,129,192,5,24577,80,5,2,87,5,385,83,5,25,91,5,6145,81,5,7,89,5,1537,85,5,97,93,5,24577,80,5,4,88,5,769,84,5,49,92,5,12289,82,5,13,90,5,3073,86,5,193,192,5,24577],pt=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],yt=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,112,112],mt=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],bt=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],gt=15;function kt(){let e,t,n,r,s,i;function o(e,t,o,c,f,a,l,u,w,h,d){let p,y,m,b,g,k,v,S,z,C,x,A,_,I,P;C=0,g=o;do{n[e[t+C]]++,C++,g--}while(0!==g);if(n[0]==o)return l[0]=-1,u[0]=0,it;for(S=u[0],k=1;gt>=k&&0===n[k];k++);for(v=k,k>S&&(S=k),g=gt;0!==g&&0===n[g];g--);for(m=g,S>g&&(S=g),u[0]=S,I=1<<k;g>k;k++,I<<=1)if(0>(I-=n[k]))return ft;if(0>(I-=n[g]))return ft;for(n[g]+=I,i[1]=k=0,C=1,_=2;0!=--g;)i[_]=k+=n[C],_++,C++;g=0,C=0;do{0!==(k=e[t+C])&&(d[i[k]++]=g),C++}while(++g<o);for(o=i[m],i[0]=g=0,C=0,b=-1,A=-S,s[0]=0,x=0,P=0;m>=v;v++)for(p=n[v];0!=p--;){for(;v>A+S;){if(b++,A+=S,P=m-A,P=P>S?S:P,(y=1<<(k=v-A))>p+1&&(y-=p+1,_=v,P>k))for(;++k<P&&(y<<=1)>n[++_];)y-=n[_];if(P=1<<k,h[0]+P>wt)return ft;s[b]=x=h[0],h[0]+=P,0!==b?(i[b]=g,r[0]=k,r[1]=S,k=g>>>A-S,r[2]=x-s[b-1]-k,w.set(r,3*(s[b-1]+k))):l[0]=x}for(r[1]=v-A,o>C?d[C]<c?(r[0]=256>d[C]?0:96,r[2]=d[C++]):(r[0]=a[d[C]-c]+16+64,r[2]=f[d[C++]-c]):r[0]=192,y=1<<v-A,k=g>>>A;P>k;k+=y)w.set(r,3*(x+k));for(k=1<<v-1;g&k;k>>>=1)g^=k;for(g^=k,z=(1<<A)-1;(g&z)!=i[b];)b--,A-=S,z=(1<<A)-1}return 0!==I&&1!=m?lt:it}function c(o){let c;for(e||(e=[],t=[],n=new f(gt+1),r=[],s=new f(gt),i=new f(gt+1)),t.length<o&&(t=[]),c=0;o>c;c++)t[c]=0;for(c=0;gt+1>c;c++)n[c]=0;for(c=0;3>c;c++)r[c]=0;s.set(n.subarray(0,gt),0),i.set(n.subarray(0,gt+1),0)}this.it=(n,r,s,i,f)=>{let a;return c(19),e[0]=0,a=o(n,0,19,19,null,null,s,r,i,e,t),a==ft?f.Fe="oversubscribed dynamic bit lengths tree":a!=lt&&0!==r[0]||(f.Fe="incomplete dynamic bit lengths tree",a=ft),a},this.ot=(n,r,s,i,f,a,l,u,w)=>{let h;return c(288),e[0]=0,h=o(s,0,n,257,pt,yt,a,i,u,e,t),h!=it||0===i[0]?(h==ft?w.Fe="oversubscribed literal/length tree":h!=at&&(w.Fe="incomplete literal/length tree",h=ft),h):(c(288),h=o(s,n,r,0,mt,bt,l,f,u,e,t),h!=it||0===f[0]&&n>257?(h==ft?w.Fe="oversubscribed distance tree":h==lt?(w.Fe="incomplete distance tree",h=ft):h!=at&&(w.Fe="empty distance tree with lengths",h=ft),h):it)}}kt.ct=(e,t,n,r)=>(e[0]=9,t[0]=5,n[0]=ht,r[0]=dt,it);const vt=0,St=1,zt=2,Ct=3,xt=4,At=5,_t=6,It=7,Pt=8,Dt=9;function Vt(){const e=this;let t,n,r,s,i=0,o=0,c=0,f=0,a=0,l=0,u=0,w=0,h=0,d=0;function p(e,t,n,r,s,i,o,c){let f,a,l,u,w,h,d,p,y,m,b,g,k,v,S,z;d=c.rt,p=c.je,w=o.ft,h=o.lt,y=o.write,m=y<o.read?o.read-y-1:o.end-y,b=ut[e],g=ut[t];do{for(;20>h;)p--,w|=(255&c.ut(d++))<<h,h+=8;if(f=w&b,a=n,l=r,z=3*(l+f),0!==(u=a[z]))for(;;){if(w>>=a[z+1],h-=a[z+1],16&u){for(u&=15,k=a[z+2]+(w&ut[u]),w>>=u,h-=u;15>h;)p--,w|=(255&c.ut(d++))<<h,h+=8;for(f=w&g,a=s,l=i,z=3*(l+f),u=a[z];;){if(w>>=a[z+1],h-=a[z+1],16&u){for(u&=15;u>h;)p--,w|=(255&c.ut(d++))<<h,h+=8;if(v=a[z+2]+(w&ut[u]),w>>=u,h-=u,m-=k,v>y){S=y-v;do{S+=o.end}while(0>S);if(u=o.end-S,k>u){if(k-=u,y-S>0&&u>y-S)do{o.wt[y++]=o.wt[S++]}while(0!=--u);else o.wt.set(o.wt.subarray(S,S+u),y),y+=u,S+=u,u=0;S=0}}else S=y-v,y-S>0&&2>y-S?(o.wt[y++]=o.wt[S++],o.wt[y++]=o.wt[S++],k-=2):(o.wt.set(o.wt.subarray(S,S+2),y),y+=2,S+=2,k-=2);if(y-S>0&&k>y-S)do{o.wt[y++]=o.wt[S++]}while(0!=--k);else o.wt.set(o.wt.subarray(S,S+k),y),y+=k,S+=k,k=0;break}if(64&u)return c.Fe="invalid distance code",k=c.je-p,k=k>h>>3?h>>3:k,p+=k,d-=k,h-=k<<3,o.ft=w,o.lt=h,c.je=p,c.Ge+=d-c.rt,c.rt=d,o.write=y,ft;f+=a[z+2],f+=w&ut[u],z=3*(l+f),u=a[z]}break}if(64&u)return 32&u?(k=c.je-p,k=k>h>>3?h>>3:k,p+=k,d-=k,h-=k<<3,o.ft=w,o.lt=h,c.je=p,c.Ge+=d-c.rt,c.rt=d,o.write=y,ot):(c.Fe="invalid literal/length code",k=c.je-p,k=k>h>>3?h>>3:k,p+=k,d-=k,h-=k<<3,o.ft=w,o.lt=h,c.je=p,c.Ge+=d-c.rt,c.rt=d,o.write=y,ft);if(f+=a[z+2],f+=w&ut[u],z=3*(l+f),0===(u=a[z])){w>>=a[z+1],h-=a[z+1],o.wt[y++]=a[z+2],m--;break}}else w>>=a[z+1],h-=a[z+1],o.wt[y++]=a[z+2],m--}while(m>=258&&p>=10);return k=c.je-p,k=k>h>>3?h>>3:k,p+=k,d-=k,h-=k<<3,o.ft=w,o.lt=h,c.je=p,c.Ge+=d-c.rt,c.rt=d,o.write=y,it}e.init=(e,i,o,c,f,a)=>{t=vt,u=e,w=i,r=o,h=c,s=f,d=a,n=null},e.ht=(e,y,m)=>{let b,g,k,v,S,z,C,x=0,A=0,_=0;for(_=y.rt,v=y.je,x=e.ft,A=e.lt,S=e.write,z=S<e.read?e.read-S-1:e.end-S;;)switch(t){case vt:if(z>=258&&v>=10&&(e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,m=p(u,w,r,h,s,d,e,y),_=y.rt,v=y.je,x=e.ft,A=e.lt,S=e.write,z=S<e.read?e.read-S-1:e.end-S,m!=it)){t=m==ot?It:Dt;break}c=u,n=r,o=h,t=St;case St:for(b=c;b>A;){if(0===v)return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);m=it,v--,x|=(255&y.ut(_++))<<A,A+=8}if(g=3*(o+(x&ut[b])),x>>>=n[g+1],A-=n[g+1],k=n[g],0===k){f=n[g+2],t=_t;break}if(16&k){a=15&k,i=n[g+2],t=zt;break}if(!(64&k)){c=k,o=g/3+n[g+2];break}if(32&k){t=It;break}return t=Dt,y.Fe="invalid literal/length code",m=ft,e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);case zt:for(b=a;b>A;){if(0===v)return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);m=it,v--,x|=(255&y.ut(_++))<<A,A+=8}i+=x&ut[b],x>>=b,A-=b,c=w,n=s,o=d,t=Ct;case Ct:for(b=c;b>A;){if(0===v)return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);m=it,v--,x|=(255&y.ut(_++))<<A,A+=8}if(g=3*(o+(x&ut[b])),x>>=n[g+1],A-=n[g+1],k=n[g],16&k){a=15&k,l=n[g+2],t=xt;break}if(!(64&k)){c=k,o=g/3+n[g+2];break}return t=Dt,y.Fe="invalid distance code",m=ft,e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);case xt:for(b=a;b>A;){if(0===v)return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);m=it,v--,x|=(255&y.ut(_++))<<A,A+=8}l+=x&ut[b],x>>=b,A-=b,t=At;case At:for(C=S-l;0>C;)C+=e.end;for(;0!==i;){if(0===z&&(S==e.end&&0!==e.read&&(S=0,z=S<e.read?e.read-S-1:e.end-S),0===z&&(e.write=S,m=e.dt(y,m),S=e.write,z=S<e.read?e.read-S-1:e.end-S,S==e.end&&0!==e.read&&(S=0,z=S<e.read?e.read-S-1:e.end-S),0===z)))return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);e.wt[S++]=e.wt[C++],z--,C==e.end&&(C=0),i--}t=vt;break;case _t:if(0===z&&(S==e.end&&0!==e.read&&(S=0,z=S<e.read?e.read-S-1:e.end-S),0===z&&(e.write=S,m=e.dt(y,m),S=e.write,z=S<e.read?e.read-S-1:e.end-S,S==e.end&&0!==e.read&&(S=0,z=S<e.read?e.read-S-1:e.end-S),0===z)))return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);m=it,e.wt[S++]=f,z--,t=vt;break;case It:if(A>7&&(A-=8,v++,_--),e.write=S,m=e.dt(y,m),S=e.write,z=S<e.read?e.read-S-1:e.end-S,e.read!=e.write)return e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);t=Pt;case Pt:return m=ot,e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);case Dt:return m=ft,e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m);default:return m=ct,e.ft=x,e.lt=A,y.je=v,y.Ge+=_-y.rt,y.rt=_,e.write=S,e.dt(y,m)}},e.yt=()=>{}}const Rt=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],Bt=0,Et=1,Mt=2,Ut=3,Kt=4,Nt=5,Ot=6,Tt=7,Wt=8,jt=9;function Ht(e,t){const n=this;let r,s=Bt,o=0,c=0,a=0;const l=[0],u=[0],w=new Vt;let h=0,d=new f(3*wt);const p=new kt;n.lt=0,n.ft=0,n.wt=new i(t),n.end=t,n.read=0,n.write=0,n.reset=(e,t)=>{t&&(t[0]=0),s==Ot&&w.yt(e),s=Bt,n.lt=0,n.ft=0,n.read=n.write=0},n.reset(e,null),n.dt=(e,t)=>{let r,s,i;return s=e.st,i=n.read,r=(i>n.write?n.end:n.write)-i,r>e.nt&&(r=e.nt),0!==r&&t==lt&&(t=it),e.nt-=r,e.Je+=r,e.et.set(n.wt.subarray(i,i+r),s),s+=r,i+=r,i==n.end&&(i=0,n.write==n.end&&(n.write=0),r=n.write-i,r>e.nt&&(r=e.nt),0!==r&&t==lt&&(t=it),e.nt-=r,e.Je+=r,e.et.set(n.wt.subarray(i,i+r),s),s+=r,i+=r),e.st=s,n.read=i,t},n.ht=(e,t)=>{let i,f,y,m,b,g,k,v;for(m=e.rt,b=e.je,f=n.ft,y=n.lt,g=n.write,k=g<n.read?n.read-g-1:n.end-g;;){let S,z,C,x,A,_,I,P;switch(s){case Bt:for(;3>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}switch(i=7&f,h=1&i,i>>>1){case 0:f>>>=3,y-=3,i=7&y,f>>>=i,y-=i,s=Et;break;case 1:S=[],z=[],C=[[]],x=[[]],kt.ct(S,z,C,x),w.init(S[0],z[0],C[0],0,x[0],0),f>>>=3,y-=3,s=Ot;break;case 2:f>>>=3,y-=3,s=Ut;break;case 3:return f>>>=3,y-=3,s=jt,e.Fe="invalid block type",t=ft,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t)}break;case Et:for(;32>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}if((~f>>>16&65535)!=(65535&f))return s=jt,e.Fe="invalid stored block lengths",t=ft,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);o=65535&f,f=y=0,s=0!==o?Mt:0!==h?Tt:Bt;break;case Mt:if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);if(0===k&&(g==n.end&&0!==n.read&&(g=0,k=g<n.read?n.read-g-1:n.end-g),0===k&&(n.write=g,t=n.dt(e,t),g=n.write,k=g<n.read?n.read-g-1:n.end-g,g==n.end&&0!==n.read&&(g=0,k=g<n.read?n.read-g-1:n.end-g),0===k)))return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);if(t=it,i=o,i>b&&(i=b),i>k&&(i=k),n.wt.set(e.He(m,i),g),m+=i,b-=i,g+=i,k-=i,0!=(o-=i))break;s=0!==h?Tt:Bt;break;case Ut:for(;14>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}if(c=i=16383&f,(31&i)>29||(i>>5&31)>29)return s=jt,e.Fe="too many length or distance symbols",t=ft,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);if(i=258+(31&i)+(i>>5&31),!r||r.length<i)r=[];else for(v=0;i>v;v++)r[v]=0;f>>>=14,y-=14,a=0,s=Kt;case Kt:for(;4+(c>>>10)>a;){for(;3>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}r[Rt[a++]]=7&f,f>>>=3,y-=3}for(;19>a;)r[Rt[a++]]=0;if(l[0]=7,i=p.it(r,l,u,d,e),i!=it)return(t=i)==ft&&(r=null,s=jt),n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);a=0,s=Nt;case Nt:for(;i=c,258+(31&i)+(i>>5&31)>a;){let o,w;for(i=l[0];i>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}if(i=d[3*(u[0]+(f&ut[i]))+1],w=d[3*(u[0]+(f&ut[i]))+2],16>w)f>>>=i,y-=i,r[a++]=w;else{for(v=18==w?7:w-14,o=18==w?11:3;i+v>y;){if(0===b)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);t=it,b--,f|=(255&e.ut(m++))<<y,y+=8}if(f>>>=i,y-=i,o+=f&ut[v],f>>>=v,y-=v,v=a,i=c,v+o>258+(31&i)+(i>>5&31)||16==w&&1>v)return r=null,s=jt,e.Fe="invalid bit length repeat",t=ft,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);w=16==w?r[v-1]:0;do{r[v++]=w}while(0!=--o);a=v}}if(u[0]=-1,A=[],_=[],I=[],P=[],A[0]=9,_[0]=6,i=c,i=p.ot(257+(31&i),1+(i>>5&31),r,A,_,I,P,d,e),i!=it)return i==ft&&(r=null,s=jt),t=i,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);w.init(A[0],_[0],d,I[0],d,P[0]),s=Ot;case Ot:if(n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,(t=w.ht(n,e,t))!=ot)return n.dt(e,t);if(t=it,w.yt(e),m=e.rt,b=e.je,f=n.ft,y=n.lt,g=n.write,k=g<n.read?n.read-g-1:n.end-g,0===h){s=Bt;break}s=Tt;case Tt:if(n.write=g,t=n.dt(e,t),g=n.write,k=g<n.read?n.read-g-1:n.end-g,n.read!=n.write)return n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);s=Wt;case Wt:return t=ot,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);case jt:return t=ft,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t);default:return t=ct,n.ft=f,n.lt=y,e.je=b,e.Ge+=m-e.rt,e.rt=m,n.write=g,n.dt(e,t)}}},n.yt=e=>{n.reset(e,null),n.wt=null,d=null},n.bt=(e,t,r)=>{n.wt.set(e.subarray(t,t+r),0),n.read=n.write=r},n.gt=()=>s==Et?1:0}const Lt=13,Ft=[0,0,255,255];function qt(){const e=this;function t(e){return e&&e.kt?(e.Ge=e.Je=0,e.Fe=null,e.kt.mode=7,e.kt.vt.reset(e,null),it):ct}e.mode=0,e.method=0,e.St=[0],e.zt=0,e.marker=0,e.Ct=0,e.xt=t=>(e.vt&&e.vt.yt(t),e.vt=null,it),e.At=(n,r)=>(n.Fe=null,e.vt=null,8>r||r>15?(e.xt(n),ct):(e.Ct=r,n.kt.vt=new Ht(n,1<<r),t(n),it)),e._t=(e,t)=>{let n,r;if(!e||!e.kt||!e.tt)return ct;const s=e.kt;for(t=4==t?lt:it,n=lt;;)switch(s.mode){case 0:if(0===e.je)return n;if(n=t,e.je--,e.Ge++,8!=(15&(s.method=e.ut(e.rt++)))){s.mode=Lt,e.Fe="unknown compression method",s.marker=5;break}if(8+(s.method>>4)>s.Ct){s.mode=Lt,e.Fe="invalid win size",s.marker=5;break}s.mode=1;case 1:if(0===e.je)return n;if(n=t,e.je--,e.Ge++,r=255&e.ut(e.rt++),((s.method<<8)+r)%31!=0){s.mode=Lt,e.Fe="incorrect header check",s.marker=5;break}if(!(32&r)){s.mode=7;break}s.mode=2;case 2:if(0===e.je)return n;n=t,e.je--,e.Ge++,s.zt=(255&e.ut(e.rt++))<<24&4278190080,s.mode=3;case 3:if(0===e.je)return n;n=t,e.je--,e.Ge++,s.zt+=(255&e.ut(e.rt++))<<16&16711680,s.mode=4;case 4:if(0===e.je)return n;n=t,e.je--,e.Ge++,s.zt+=(255&e.ut(e.rt++))<<8&65280,s.mode=5;case 5:return 0===e.je?n:(n=t,e.je--,e.Ge++,s.zt+=255&e.ut(e.rt++),s.mode=6,2);case 6:return s.mode=Lt,e.Fe="need dictionary",s.marker=0,ct;case 7:if(n=s.vt.ht(e,n),n==ft){s.mode=Lt,s.marker=0;break}if(n==it&&(n=t),n!=ot)return n;n=t,s.vt.reset(e,s.St),s.mode=12;case 12:return e.je=0,ot;case Lt:return ft;default:return ct}},e.It=(e,t,n)=>{let r=0,s=n;if(!e||!e.kt||6!=e.kt.mode)return ct;const i=e.kt;return s<1<<i.Ct||(s=(1<<i.Ct)-1,r=n-s),i.vt.bt(t,r,s),i.mode=7,it},e.Pt=e=>{let n,r,s,i,o;if(!e||!e.kt)return ct;const c=e.kt;if(c.mode!=Lt&&(c.mode=Lt,c.marker=0),0===(n=e.je))return lt;for(r=e.rt,s=c.marker;0!==n&&4>s;)e.ut(r)==Ft[s]?s++:s=0!==e.ut(r)?0:4-s,r++,n--;return e.Ge+=r-e.rt,e.rt=r,e.je=n,c.marker=s,4!=s?ft:(i=e.Ge,o=e.Je,t(e),e.Ge=i,e.Je=o,c.mode=7,it)},e.Dt=e=>e&&e.kt&&e.kt.vt?e.kt.vt.gt():ct}function Gt(){}function Jt(e){const t=new Gt,n=e&&e.chunkSize?r.floor(2*e.chunkSize):131072,o=new i(n);let c=!1;t.At(),t.et=o,this.append=(e,r)=>{const f=[];let a,l,u=0,w=0,h=0;if(0!==e.length){t.rt=0,t.tt=e,t.je=e.length;do{if(t.st=0,t.nt=n,0!==t.je||c||(t.rt=0,c=!0),a=t._t(0),c&&a===lt){if(0!==t.je)throw new s("inflating: bad input")}else if(a!==it&&a!==ot)throw new s("inflating: "+t.Fe);if((c||a===ot)&&t.je===e.length)throw new s("inflating: bad input");t.st&&(t.st===n?f.push(new i(o)):f.push(o.subarray(0,t.st))),h+=t.st,r&&t.rt>0&&t.rt!=u&&(r(t.rt),u=t.rt)}while(t.je>0||0===t.nt);return f.length>1?(l=new i(h),f.forEach((e=>{l.set(e,w),w+=e.length}))):l=f[0]?new i(f[0]):new i,l}},this.flush=()=>{t.xt()}}Gt.prototype={At(e){const t=this;return t.kt=new qt,e||(e=15),t.kt.At(t,e)},_t(e){const t=this;return t.kt?t.kt._t(t,e):ct},xt(){const e=this;if(!e.kt)return ct;const t=e.kt.xt(e);return e.kt=null,t},Pt(){const e=this;return e.kt?e.kt.Pt(e):ct},It(e,t){const n=this;return n.kt?n.kt.It(n,e,t):ct},ut(e){return this.tt[e]},He(e,t){return this.tt.subarray(e,e+t)}},self.initCodec=()=>{self.Deflate=st,self.Inflate=Jt};\n',r=()=>t.useDataURI?"data:text/javascript,"+encodeURIComponent(n):URL.createObjectURL(new Blob([n],{type:"text/javascript"}));e({workerScripts:{inflate:[r],deflate:[r]}});}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

const ERR_ITERATOR_COMPLETED_TOO_SOON = "Writer iterator completed too soon";
const HTTP_HEADER_CONTENT_TYPE = "Content-Type";
const DEFAULT_CHUNK_SIZE = 64 * 1024;

const PROPERTY_NAME_WRITABLE = "writable";

class Stream {

	constructor() {
		this.size = 0;
	}

	init() {
		this.initialized = true;
	}
}

class Reader extends Stream {

	get readable() {
		const reader = this;
		const { chunkSize = DEFAULT_CHUNK_SIZE } = reader;
		const readable = new ReadableStream({
			start() {
				this.chunkOffset = 0;
			},
			async pull(controller) {
				const { offset = 0, size, diskNumberStart } = readable;
				const { chunkOffset } = this;
				controller.enqueue(await readUint8Array(reader, offset + chunkOffset, Math.min(chunkSize, size - chunkOffset), diskNumberStart));
				if (chunkOffset + chunkSize > size) {
					controller.close();
				} else {
					this.chunkOffset += chunkSize;
				}
			}
		});
		return readable;
	}
}

class BlobReader extends Reader {

	constructor(blob) {
		super();
		Object.assign(this, {
			blob,
			size: blob.size
		});
	}

	async readUint8Array(offset, length) {
		const reader = this;
		const offsetEnd = offset + length;
		const blob = offset || offsetEnd < reader.size ? reader.blob.slice(offset, offsetEnd) : reader.blob;
		let arrayBuffer = await blob.arrayBuffer();
		if (arrayBuffer.byteLength > length) {
			arrayBuffer = arrayBuffer.slice(offset, offsetEnd);
		}
		return new Uint8Array(arrayBuffer);
	}
}

class BlobWriter extends Stream {

	constructor(contentType) {
		super();
		const writer = this;
		const transformStream = new TransformStream();
		const headers = [];
		if (contentType) {
			headers.push([HTTP_HEADER_CONTENT_TYPE, contentType]);
		}
		Object.defineProperty(writer, PROPERTY_NAME_WRITABLE, {
			get() {
				return transformStream.writable;
			}
		});
		writer.blob = new Response(transformStream.readable, { headers }).blob();
	}

	getData() {
		return this.blob;
	}
}

class SplitDataReader extends Reader {

	constructor(readers) {
		super();
		this.readers = readers;
	}

	async init() {
		const reader = this;
		const { readers } = reader;
		reader.lastDiskNumber = 0;
		reader.lastDiskOffset = 0;
		await Promise.all(readers.map(async (diskReader, indexDiskReader) => {
			await diskReader.init();
			if (indexDiskReader != readers.length - 1) {
				reader.lastDiskOffset += diskReader.size;
			}
			reader.size += diskReader.size;
		}));
		super.init();
	}

	async readUint8Array(offset, length, diskNumber = 0) {
		const reader = this;
		const { readers } = this;
		let result;
		let currentDiskNumber = diskNumber;
		if (currentDiskNumber == -1) {
			currentDiskNumber = readers.length - 1;
		}
		let currentReaderOffset = offset;
		while (currentReaderOffset >= readers[currentDiskNumber].size) {
			currentReaderOffset -= readers[currentDiskNumber].size;
			currentDiskNumber++;
		}
		const currentReader = readers[currentDiskNumber];
		const currentReaderSize = currentReader.size;
		if (currentReaderOffset + length <= currentReaderSize) {
			result = await readUint8Array(currentReader, currentReaderOffset, length);
		} else {
			const chunkLength = currentReaderSize - currentReaderOffset;
			result = new Uint8Array(length);
			result.set(await readUint8Array(currentReader, currentReaderOffset, chunkLength));
			result.set(await reader.readUint8Array(offset + chunkLength, length - chunkLength, diskNumber), chunkLength);
		}
		reader.lastDiskNumber = Math.max(currentDiskNumber, reader.lastDiskNumber);
		return result;
	}
}

class SplitDataWriter extends Stream {

	constructor(writerGenerator, maxSize = 4294967295) {
		super();
		const writer = this;
		Object.assign(writer, {
			diskNumber: 0,
			diskOffset: 0,
			size: 0,
			maxSize,
			availableSize: maxSize
		});
		let diskSourceWriter, diskWritable, diskWriter;
		const writable = new WritableStream({
			async write(chunk) {
				const { availableSize } = writer;
				if (!diskWriter) {
					const { value, done } = await writerGenerator.next();
					if (done && !value) {
						throw new Error(ERR_ITERATOR_COMPLETED_TOO_SOON);
					} else {
						diskSourceWriter = value;
						diskSourceWriter.size = 0;
						if (diskSourceWriter.maxSize) {
							writer.maxSize = diskSourceWriter.maxSize;
						}
						writer.availableSize = writer.maxSize;
						await initStream(diskSourceWriter);
						diskWritable = value.writable;
						diskWriter = diskWritable.getWriter();
					}
					await this.write(chunk);
				} else if (chunk.length >= availableSize) {
					await writeChunk(chunk.slice(0, availableSize));
					await closeDisk();
					writer.diskOffset += diskSourceWriter.size;
					writer.diskNumber++;
					diskWriter = null;
					await this.write(chunk.slice(availableSize));
				} else {
					await writeChunk(chunk);
				}
			},
			async close() {
				await diskWriter.ready;
				await closeDisk();
			}
		});
		Object.defineProperty(writer, PROPERTY_NAME_WRITABLE, {
			get() {
				return writable;
			}
		});

		async function writeChunk(chunk) {
			const chunkLength = chunk.length;
			if (chunkLength) {
				await diskWriter.ready;
				await diskWriter.write(chunk);
				diskSourceWriter.size += chunkLength;
				writer.size += chunkLength;
				writer.availableSize -= chunkLength;
			}
		}

		async function closeDisk() {
			diskWritable.size = diskSourceWriter.size;
			await diskWriter.close();
		}
	}
}

async function initStream(stream, initSize) {
	if (stream.init && !stream.initialized) {
		await stream.init(initSize);
	} else {
		return Promise.resolve();
	}
}

function initReader(reader) {
	if (Array.isArray(reader)) {
		reader = new SplitDataReader(reader);
	}
	if (reader instanceof ReadableStream) {
		reader = {
			readable: reader
		};
	}
	return reader;
}

function initWriter(writer) {
	if (writer.writable === UNDEFINED_VALUE && typeof writer.next == FUNCTION_TYPE) {
		writer = new SplitDataWriter(writer);
	}
	if (writer instanceof WritableStream) {
		writer = {
			writable: writer
		};
	}
	const { writable } = writer;
	if (writable.size === UNDEFINED_VALUE) {
		writable.size = 0;
	}
	if (!(writer instanceof SplitDataWriter)) {
		Object.assign(writer, {
			diskNumber: 0,
			diskOffset: 0,
			availableSize: Infinity,
			maxSize: Infinity
		});
	}
	return writer;
}

function readUint8Array(reader, offset, size, diskNumber) {
	return reader.readUint8Array(offset, size, diskNumber);
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* global TextDecoder */

const CP437 = "\0☺☻♥♦♣♠•◘○◙♂♀♪♫☼►◄↕‼¶§▬↨↑↓→←∟↔▲▼ !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~⌂ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜ¢£¥₧ƒáíóúñÑªº¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ ".split("");
CP437.length == 256;

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright 
 notice, this list of conditions and the following disclaimer in 
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

const PROPERTY_NAME_FILENAME = "filename";
const PROPERTY_NAME_RAW_FILENAME = "rawFilename";
const PROPERTY_NAME_COMMENT = "comment";
const PROPERTY_NAME_RAW_COMMENT = "rawComment";
const PROPERTY_NAME_UNCOMPPRESSED_SIZE = "uncompressedSize";
const PROPERTY_NAME_COMPPRESSED_SIZE = "compressedSize";
const PROPERTY_NAME_OFFSET = "offset";
const PROPERTY_NAME_DISK_NUMBER_START = "diskNumberStart";
const PROPERTY_NAME_LAST_MODIFICATION_DATE = "lastModDate";
const PROPERTY_NAME_RAW_LAST_MODIFICATION_DATE = "rawLastModDate";
const PROPERTY_NAME_LAST_ACCESS_DATE = "lastAccessDate";
const PROPERTY_NAME_CREATION_DATE = "creationDate";
const PROPERTY_NAME_INTERNAL_FILE_ATTRIBUTE = "internalFileAttribute";
const PROPERTY_NAME_EXTERNAL_FILE_ATTRIBUTE = "externalFileAttribute";
const PROPERTY_NAME_MS_DOS_COMPATIBLE = "msDosCompatible";
const PROPERTY_NAME_ZIP64 = "zip64";
const PROPERTY_NAME_ENCRYPTED = "encrypted";
const PROPERTY_NAME_VERSION = "version";
const PROPERTY_NAME_VERSION_MADE_BY = "versionMadeBy";
const PROPERTY_NAME_ZIPCRYPTO = "zipCrypto";

const PROPERTY_NAMES = [
	PROPERTY_NAME_FILENAME, PROPERTY_NAME_RAW_FILENAME, PROPERTY_NAME_COMPPRESSED_SIZE, PROPERTY_NAME_UNCOMPPRESSED_SIZE,
	PROPERTY_NAME_LAST_MODIFICATION_DATE, PROPERTY_NAME_RAW_LAST_MODIFICATION_DATE, PROPERTY_NAME_COMMENT, PROPERTY_NAME_RAW_COMMENT,
	PROPERTY_NAME_LAST_ACCESS_DATE, PROPERTY_NAME_CREATION_DATE, PROPERTY_NAME_OFFSET, PROPERTY_NAME_DISK_NUMBER_START,
	PROPERTY_NAME_DISK_NUMBER_START, PROPERTY_NAME_INTERNAL_FILE_ATTRIBUTE, PROPERTY_NAME_EXTERNAL_FILE_ATTRIBUTE,
	PROPERTY_NAME_MS_DOS_COMPATIBLE, PROPERTY_NAME_ZIP64, PROPERTY_NAME_ENCRYPTED, PROPERTY_NAME_VERSION, PROPERTY_NAME_VERSION_MADE_BY,
	PROPERTY_NAME_ZIPCRYPTO, "directory", "bitFlag", "signature", "filenameUTF8", "commentUTF8", "compressionMethod", "extraField", "rawExtraField",
	"extraFieldZip64", "extraFieldUnicodePath", "extraFieldUnicodeComment", "extraFieldAES", "extraFieldNTFS", "extraFieldExtendedTimestamp"];

class Entry {

	constructor(data) {
		PROPERTY_NAMES.forEach(name => this[name] = data[name]);
	}

}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


const ERR_DUPLICATED_NAME = "File already exists";
const ERR_INVALID_COMMENT = "Zip file comment exceeds 64KB";
const ERR_INVALID_ENTRY_COMMENT = "File entry comment exceeds 64KB";
const ERR_INVALID_ENTRY_NAME = "File entry name exceeds 64KB";
const ERR_INVALID_VERSION = "Version exceeds 65535";
const ERR_INVALID_ENCRYPTION_STRENGTH = "The strength must equal 1, 2, or 3";
const ERR_INVALID_EXTRAFIELD_TYPE = "Extra field type exceeds 65535";
const ERR_INVALID_EXTRAFIELD_DATA = "Extra field data exceeds 64KB";
const ERR_UNSUPPORTED_FORMAT = "Zip64 is not supported (make sure 'keepOrder' is set to 'true')";
const ERR_UNDEFINED_UNCOMPRESSED_SIZE = "Undefined uncompressed size";

const EXTRAFIELD_DATA_AES = new Uint8Array([0x07, 0x00, 0x02, 0x00, 0x41, 0x45, 0x03, 0x00, 0x00]);

let workers = 0;
const pendingEntries = [];

class ZipWriter {

	constructor(writer, options = {}) {
		writer = initWriter(writer);
		const addSplitZipSignature =
			writer.availableSize !== UNDEFINED_VALUE && writer.availableSize > 0 && writer.availableSize !== Infinity &&
			writer.maxSize !== UNDEFINED_VALUE && writer.maxSize > 0 && writer.maxSize !== Infinity;
		Object.assign(this, {
			writer,
			addSplitZipSignature,
			options,
			config: getConfiguration(),
			files: new Map(),
			filenames: new Set(),
			offset: options.offset === UNDEFINED_VALUE ? writer.writable.size : options.offset,
			pendingEntriesSize: 0,
			pendingAddFileCalls: new Set(),
			bufferedWrites: 0
		});
	}

	async add(name = "", reader, options = {}) {
		const zipWriter = this;
		const {
			pendingAddFileCalls,
			config
		} = zipWriter;
		if (workers < config.maxWorkers) {
			workers++;
		} else {
			await new Promise(resolve => pendingEntries.push(resolve));
		}
		let promiseAddFile;
		try {
			name = name.trim();
			if (zipWriter.filenames.has(name)) {
				throw new Error(ERR_DUPLICATED_NAME);
			}
			zipWriter.filenames.add(name);
			promiseAddFile = addFile(zipWriter, name, reader, options);
			pendingAddFileCalls.add(promiseAddFile);
			return await promiseAddFile;
		} catch (error) {
			zipWriter.filenames.delete(name);
			throw error;
		} finally {
			pendingAddFileCalls.delete(promiseAddFile);
			const pendingEntry = pendingEntries.shift();
			if (pendingEntry) {
				pendingEntry();
			} else {
				workers--;
			}
		}
	}

	async close(comment = new Uint8Array(), options = {}) {
		const zipWriter = this;
		const { pendingAddFileCalls, writer } = this;
		const { writable } = writer;
		while (pendingAddFileCalls.size) {
			await Promise.allSettled(Array.from(pendingAddFileCalls));
		}
		await closeFile(this, comment, options);
		const preventClose = getOptionValue(zipWriter, options, "preventClose");
		if (!preventClose) {
			await writable.getWriter().close();
		}
		return writer.getData ? writer.getData() : writable;
	}
}

async function addFile(zipWriter, name, reader, options) {
	name = name.trim();
	if (options.directory && (!name.endsWith(DIRECTORY_SIGNATURE))) {
		name += DIRECTORY_SIGNATURE;
	} else {
		options.directory = name.endsWith(DIRECTORY_SIGNATURE);
	}
	const encode = getOptionValue(zipWriter, options, "encodeText", encodeText);
	let rawFilename = encode(name);
	if (rawFilename === UNDEFINED_VALUE) {
		rawFilename = encodeText(name);
	}
	if (getLength(rawFilename) > MAX_16_BITS) {
		throw new Error(ERR_INVALID_ENTRY_NAME);
	}
	const comment = options.comment || "";
	let rawComment = encode(comment);
	if (rawComment === UNDEFINED_VALUE) {
		rawComment = encodeText(comment);
	}
	if (getLength(rawComment) > MAX_16_BITS) {
		throw new Error(ERR_INVALID_ENTRY_COMMENT);
	}
	const version = getOptionValue(zipWriter, options, PROPERTY_NAME_VERSION, VERSION_DEFLATE);
	if (version > MAX_16_BITS) {
		throw new Error(ERR_INVALID_VERSION);
	}
	const versionMadeBy = getOptionValue(zipWriter, options, PROPERTY_NAME_VERSION_MADE_BY, 20);
	if (versionMadeBy > MAX_16_BITS) {
		throw new Error(ERR_INVALID_VERSION);
	}
	const lastModDate = getOptionValue(zipWriter, options, PROPERTY_NAME_LAST_MODIFICATION_DATE, new Date());
	const lastAccessDate = getOptionValue(zipWriter, options, PROPERTY_NAME_LAST_ACCESS_DATE);
	const creationDate = getOptionValue(zipWriter, options, PROPERTY_NAME_CREATION_DATE);
	const msDosCompatible = getOptionValue(zipWriter, options, PROPERTY_NAME_MS_DOS_COMPATIBLE, true);
	const internalFileAttribute = getOptionValue(zipWriter, options, PROPERTY_NAME_INTERNAL_FILE_ATTRIBUTE, 0);
	const externalFileAttribute = getOptionValue(zipWriter, options, PROPERTY_NAME_EXTERNAL_FILE_ATTRIBUTE, 0);
	const passThrough = getOptionValue(zipWriter, options, "passThrough");
	let password, rawPassword;
	if (!passThrough) {
		password = getOptionValue(zipWriter, options, "password");
		rawPassword = getOptionValue(zipWriter, options, "rawPassword");
	}
	const encryptionStrength = getOptionValue(zipWriter, options, "encryptionStrength", 3);
	const zipCrypto = getOptionValue(zipWriter, options, PROPERTY_NAME_ZIPCRYPTO);
	const extendedTimestamp = getOptionValue(zipWriter, options, "extendedTimestamp", true);
	const keepOrder = getOptionValue(zipWriter, options, "keepOrder", true);
	const level = getOptionValue(zipWriter, options, "level");
	const useWebWorkers = getOptionValue(zipWriter, options, "useWebWorkers");
	const bufferedWrite = getOptionValue(zipWriter, options, "bufferedWrite");
	const dataDescriptorSignature = getOptionValue(zipWriter, options, "dataDescriptorSignature", false);
	const signal = getOptionValue(zipWriter, options, "signal");
	const useUnicodeFileNames = getOptionValue(zipWriter, options, "useUnicodeFileNames", true);
	const useCompressionStream = getOptionValue(zipWriter, options, "useCompressionStream");
	const compressionMethod = getOptionValue(zipWriter, options, "compressionMethod");
	let dataDescriptor = getOptionValue(zipWriter, options, "dataDescriptor", true);
	let zip64 = getOptionValue(zipWriter, options, PROPERTY_NAME_ZIP64);
	if (!zipCrypto && (password !== UNDEFINED_VALUE || rawPassword !== UNDEFINED_VALUE) && !(encryptionStrength >= 1 && encryptionStrength <= 3)) {
		throw new Error(ERR_INVALID_ENCRYPTION_STRENGTH);
	}
	let rawExtraField = new Uint8Array();
	const { extraField } = options;
	if (extraField) {
		let extraFieldSize = 0;
		let offset = 0;
		extraField.forEach(data => extraFieldSize += 4 + getLength(data));
		rawExtraField = new Uint8Array(extraFieldSize);
		extraField.forEach((data, type) => {
			if (type > MAX_16_BITS) {
				throw new Error(ERR_INVALID_EXTRAFIELD_TYPE);
			}
			if (getLength(data) > MAX_16_BITS) {
				throw new Error(ERR_INVALID_EXTRAFIELD_DATA);
			}
			arraySet(rawExtraField, new Uint16Array([type]), offset);
			arraySet(rawExtraField, new Uint16Array([getLength(data)]), offset + 2);
			arraySet(rawExtraField, data, offset + 4);
			offset += 4 + getLength(data);
		});
	}
	let maximumCompressedSize = 0;
	let maximumEntrySize = 0;
	let uncompressedSize = 0;
	if (passThrough) {
		({ uncompressedSize } = options);
		if (uncompressedSize === UNDEFINED_VALUE) {
			throw new Error(ERR_UNDEFINED_UNCOMPRESSED_SIZE);
		}
	}
	const zip64Enabled = zip64 === true;
	if (reader) {
		reader = initReader(reader);
		await initStream(reader);
		if (!passThrough) {
			if (reader.size === UNDEFINED_VALUE) {
				dataDescriptor = true;
				if (zip64 || zip64 === UNDEFINED_VALUE) {
					zip64 = true;
					uncompressedSize = maximumCompressedSize = MAX_32_BITS + 1;
				}
			} else {
				uncompressedSize = reader.size;
				maximumCompressedSize = getMaximumCompressedSize(uncompressedSize);
			}
		} else {
			maximumCompressedSize = getMaximumCompressedSize(uncompressedSize);
		}
	}
	const { diskOffset, diskNumber, maxSize } = zipWriter.writer;
	const zip64UncompressedSize = zip64Enabled || uncompressedSize > MAX_32_BITS;
	const zip64CompressedSize = zip64Enabled || maximumCompressedSize > MAX_32_BITS;
	const zip64Offset = zip64Enabled || zipWriter.offset + zipWriter.pendingEntriesSize - diskOffset > MAX_32_BITS;
	const supportZip64SplitFile = getOptionValue(zipWriter, options, "supportZip64SplitFile", true);
	const zip64DiskNumberStart = (supportZip64SplitFile && zip64Enabled) || diskNumber + Math.ceil(zipWriter.pendingEntriesSize / maxSize) > MAX_16_BITS;
	if (zip64Offset || zip64UncompressedSize || zip64CompressedSize || zip64DiskNumberStart) {
		if (zip64 === false || !keepOrder) {
			throw new Error(ERR_UNSUPPORTED_FORMAT);
		} else {
			zip64 = true;
		}
	}
	zip64 = zip64 || false;
	const encrypted = getOptionValue(zipWriter, options, PROPERTY_NAME_ENCRYPTED);
	const { signature } = options;
	options = Object.assign({}, options, {
		rawFilename,
		rawComment,
		version,
		versionMadeBy,
		lastModDate,
		lastAccessDate,
		creationDate,
		rawExtraField,
		zip64,
		zip64UncompressedSize,
		zip64CompressedSize,
		zip64Offset,
		zip64DiskNumberStart,
		password,
		rawPassword,
		level: !useCompressionStream && (zipWriter.config.CompressionStream === UNDEFINED_VALUE && zipWriter.config.CompressionStreamNative === UNDEFINED_VALUE) ? 0 : level,
		useWebWorkers,
		encryptionStrength,
		extendedTimestamp,
		zipCrypto,
		bufferedWrite,
		keepOrder,
		useUnicodeFileNames,
		dataDescriptor,
		dataDescriptorSignature,
		signal,
		msDosCompatible,
		internalFileAttribute,
		externalFileAttribute,
		useCompressionStream,
		passThrough,
		encrypted: Boolean((password && getLength(password)) || (rawPassword && getLength(rawPassword))) || (passThrough && encrypted),
		signature,
		compressionMethod
	});
	const headerInfo = getHeaderInfo(options);
	const dataDescriptorInfo = getDataDescriptorInfo(options);
	const metadataSize = getLength(headerInfo.localHeaderArray, dataDescriptorInfo.dataDescriptorArray);
	maximumEntrySize = metadataSize + maximumCompressedSize;
	if (zipWriter.options.usdz) {
		maximumEntrySize += maximumEntrySize + 64;
	}
	zipWriter.pendingEntriesSize += maximumEntrySize;
	let fileEntry;
	try {
		fileEntry = await getFileEntry(zipWriter, name, reader, { headerInfo, dataDescriptorInfo, metadataSize }, options);
	} finally {
		zipWriter.pendingEntriesSize -= maximumEntrySize;
	}
	Object.assign(fileEntry, { name, comment, extraField });
	return new Entry(fileEntry);
}

async function getFileEntry(zipWriter, name, reader, entryInfo, options) {
	const {
		files,
		writer
	} = zipWriter;
	const {
		keepOrder,
		dataDescriptor,
		signal
	} = options;
	const {
		headerInfo
	} = entryInfo;
	const { usdz } = zipWriter.options;
	const previousFileEntry = Array.from(files.values()).pop();
	let fileEntry = {};
	let bufferedWrite;
	let releaseLockWriter;
	let releaseLockCurrentFileEntry;
	let writingBufferedEntryData;
	let writingEntryData;
	let fileWriter;
	let blobPromise;
	files.set(name, fileEntry);
	try {
		let lockPreviousFileEntry;
		if (keepOrder) {
			lockPreviousFileEntry = previousFileEntry && previousFileEntry.lock;
			requestLockCurrentFileEntry();
		}
		if ((options.bufferedWrite || zipWriter.writerLocked || (zipWriter.bufferedWrites && keepOrder) || !dataDescriptor) && !usdz) {
			fileWriter = new TransformStream();
			blobPromise = new Response(fileWriter.readable).blob();
			fileWriter.writable.size = 0;
			bufferedWrite = true;
			zipWriter.bufferedWrites++;
			await initStream(writer);
		} else {
			fileWriter = writer;
			await requestLockWriter();
		}
		await initStream(fileWriter);
		const { writable } = writer;
		let { diskOffset } = writer;
		if (zipWriter.addSplitZipSignature) {
			delete zipWriter.addSplitZipSignature;
			const signatureArray = new Uint8Array(4);
			const signatureArrayView = getDataView(signatureArray);
			setUint32(signatureArrayView, 0, SPLIT_ZIP_FILE_SIGNATURE);
			await writeData(writable, signatureArray);
			zipWriter.offset += 4;
		}
		if (usdz) {
			appendExtraFieldUSDZ(entryInfo, zipWriter.offset - diskOffset);
		}
		if (!bufferedWrite) {
			await lockPreviousFileEntry;
			await skipDiskIfNeeded(writable);
		}
		const { diskNumber } = writer;
		writingEntryData = true;
		fileEntry.diskNumberStart = diskNumber;
		fileEntry = await createFileEntry(reader, fileWriter, fileEntry, entryInfo, zipWriter.config, options);
		writingEntryData = false;
		files.set(name, fileEntry);
		fileEntry.filename = name;
		if (bufferedWrite) {
			await fileWriter.writable.getWriter().close();
			let blob = await blobPromise;
			await lockPreviousFileEntry;
			await requestLockWriter();
			writingBufferedEntryData = true;
			if (!dataDescriptor) {
				blob = await writeExtraHeaderInfo(fileEntry, blob, writable, options);
			}
			await skipDiskIfNeeded(writable);
			fileEntry.diskNumberStart = writer.diskNumber;
			diskOffset = writer.diskOffset;
			await blob.stream().pipeTo(writable, { preventClose: true, preventAbort: true, signal });
			writable.size += blob.size;
			writingBufferedEntryData = false;
		}
		fileEntry.offset = zipWriter.offset - diskOffset;
		if (fileEntry.zip64) {
			setZip64ExtraInfo(fileEntry, options);
		} else if (fileEntry.offset > MAX_32_BITS) {
			throw new Error(ERR_UNSUPPORTED_FORMAT);
		}
		zipWriter.offset += fileEntry.size;
		return fileEntry;
	} catch (error) {
		if ((bufferedWrite && writingBufferedEntryData) || (!bufferedWrite && writingEntryData)) {
			zipWriter.hasCorruptedEntries = true;
			if (error) {
				try {
					error.corruptedEntry = true;
				} catch (_error) {
					// ignored
				}
			}
			if (bufferedWrite) {
				zipWriter.offset += fileWriter.writable.size;
			} else {
				zipWriter.offset = fileWriter.writable.size;
			}
		}
		files.delete(name);
		throw error;
	} finally {
		if (bufferedWrite) {
			zipWriter.bufferedWrites--;
		}
		if (releaseLockCurrentFileEntry) {
			releaseLockCurrentFileEntry();
		}
		if (releaseLockWriter) {
			releaseLockWriter();
		}
	}

	function requestLockCurrentFileEntry() {
		fileEntry.lock = new Promise(resolve => releaseLockCurrentFileEntry = resolve);
	}

	async function requestLockWriter() {
		zipWriter.writerLocked = true;
		const { lockWriter } = zipWriter;
		zipWriter.lockWriter = new Promise(resolve => releaseLockWriter = () => {
			zipWriter.writerLocked = false;
			resolve();
		});
		await lockWriter;
	}

	async function skipDiskIfNeeded(writable) {
		if (getLength(headerInfo.localHeaderArray) > writer.availableSize) {
			writer.availableSize = 0;
			await writeData(writable, new Uint8Array());
		}
	}
}

async function createFileEntry(reader, writer, { diskNumberStart, lock }, entryInfo, config, options) {
	const {
		headerInfo,
		dataDescriptorInfo,
		metadataSize
	} = entryInfo;
	const {
		localHeaderArray,
		headerArray,
		lastModDate,
		rawLastModDate,
		encrypted,
		compressed,
		version,
		compressionMethod,
		rawExtraFieldExtendedTimestamp,
		extraFieldExtendedTimestampFlag,
		rawExtraFieldNTFS,
		rawExtraFieldAES
	} = headerInfo;
	const { dataDescriptorArray } = dataDescriptorInfo;
	const {
		rawFilename,
		lastAccessDate,
		creationDate,
		password,
		rawPassword,
		level,
		zip64,
		zip64UncompressedSize,
		zip64CompressedSize,
		zip64Offset,
		zip64DiskNumberStart,
		zipCrypto,
		dataDescriptor,
		directory,
		versionMadeBy,
		rawComment,
		rawExtraField,
		useWebWorkers,
		onstart,
		onprogress,
		onend,
		signal,
		encryptionStrength,
		extendedTimestamp,
		msDosCompatible,
		internalFileAttribute,
		externalFileAttribute,
		useCompressionStream,
		passThrough
	} = options;
	const fileEntry = {
		lock,
		versionMadeBy,
		zip64,
		directory: Boolean(directory),
		filenameUTF8: true,
		rawFilename,
		commentUTF8: true,
		rawComment,
		rawExtraFieldExtendedTimestamp,
		rawExtraFieldNTFS,
		rawExtraFieldAES,
		rawExtraField,
		extendedTimestamp,
		msDosCompatible,
		internalFileAttribute,
		externalFileAttribute,
		diskNumberStart
	};
	let {
		signature,
		uncompressedSize
	} = options;
	let compressedSize = 0;
	if (!passThrough) {
		uncompressedSize = 0;
	}
	const { writable } = writer;
	if (reader) {
		reader.chunkSize = getChunkSize(config);
		await writeData(writable, localHeaderArray);
		const readable = reader.readable;
		const size = readable.size = reader.size;
		const workerOptions = {
			options: {
				codecType: CODEC_DEFLATE,
				level,
				rawPassword,
				password,
				encryptionStrength,
				zipCrypto: encrypted && zipCrypto,
				passwordVerification: encrypted && zipCrypto && (rawLastModDate >> 8) & 0xFF,
				signed: !passThrough,
				compressed: compressed && !passThrough,
				encrypted: encrypted && !passThrough,
				useWebWorkers,
				useCompressionStream,
				transferStreams: false
			},
			config,
			streamOptions: { signal, size, onstart, onprogress, onend }
		};
		const result = await runWorker({ readable, writable }, workerOptions);
		compressedSize = result.outputSize;
		if (!passThrough) {
			uncompressedSize = result.inputSize;
			signature = result.signature;
		}
		writable.size += uncompressedSize;
	} else {
		await writeData(writable, localHeaderArray);
	}
	let rawExtraFieldZip64;
	if (zip64) {
		let rawExtraFieldZip64Length = 4;
		if (zip64UncompressedSize) {
			rawExtraFieldZip64Length += 8;
		}
		if (zip64CompressedSize) {
			rawExtraFieldZip64Length += 8;
		}
		if (zip64Offset) {
			rawExtraFieldZip64Length += 8;
		}
		if (zip64DiskNumberStart) {
			rawExtraFieldZip64Length += 4;
		}
		rawExtraFieldZip64 = new Uint8Array(rawExtraFieldZip64Length);
	} else {
		rawExtraFieldZip64 = new Uint8Array();
	}
	setEntryInfo({
		signature,
		rawExtraFieldZip64,
		compressedSize,
		uncompressedSize,
		headerInfo,
		dataDescriptorInfo
	}, options);
	if (dataDescriptor) {
		await writeData(writable, dataDescriptorArray);
	}
	Object.assign(fileEntry, {
		uncompressedSize,
		compressedSize,
		lastModDate,
		rawLastModDate,
		creationDate,
		lastAccessDate,
		encrypted,
		zipCrypto,
		size: metadataSize + compressedSize,
		compressionMethod,
		version,
		headerArray,
		signature,
		rawExtraFieldZip64,
		extraFieldExtendedTimestampFlag,
		zip64UncompressedSize,
		zip64CompressedSize,
		zip64Offset,
		zip64DiskNumberStart
	});
	return fileEntry;
}

function getHeaderInfo(options) {
	const {
		rawFilename,
		lastModDate,
		lastAccessDate,
		creationDate,
		level,
		zip64,
		zipCrypto,
		useUnicodeFileNames,
		dataDescriptor,
		directory,
		rawExtraField,
		encryptionStrength,
		extendedTimestamp,
		encrypted
	} = options;
	const compressed = level !== 0 && !directory;
	let { version, compressionMethod } = options;
	let rawExtraFieldAES;
	if (encrypted && !zipCrypto) {
		rawExtraFieldAES = new Uint8Array(getLength(EXTRAFIELD_DATA_AES) + 2);
		const extraFieldAESView = getDataView(rawExtraFieldAES);
		setUint16(extraFieldAESView, 0, EXTRAFIELD_TYPE_AES);
		arraySet(rawExtraFieldAES, EXTRAFIELD_DATA_AES, 2);
		setUint8(extraFieldAESView, 8, encryptionStrength);
	} else {
		rawExtraFieldAES = new Uint8Array();
	}
	let rawExtraFieldNTFS;
	let rawExtraFieldExtendedTimestamp;
	let extraFieldExtendedTimestampFlag;
	if (extendedTimestamp) {
		rawExtraFieldExtendedTimestamp = new Uint8Array(9 + (lastAccessDate ? 4 : 0) + (creationDate ? 4 : 0));
		const extraFieldExtendedTimestampView = getDataView(rawExtraFieldExtendedTimestamp);
		setUint16(extraFieldExtendedTimestampView, 0, EXTRAFIELD_TYPE_EXTENDED_TIMESTAMP);
		setUint16(extraFieldExtendedTimestampView, 2, getLength(rawExtraFieldExtendedTimestamp) - 4);
		extraFieldExtendedTimestampFlag = 0x1 + (lastAccessDate ? 0x2 : 0) + (creationDate ? 0x4 : 0);
		setUint8(extraFieldExtendedTimestampView, 4, extraFieldExtendedTimestampFlag);
		let offset = 5;
		setUint32(extraFieldExtendedTimestampView, offset, Math.floor(lastModDate.getTime() / 1000));
		offset += 4;
		if (lastAccessDate) {
			setUint32(extraFieldExtendedTimestampView, offset, Math.floor(lastAccessDate.getTime() / 1000));
			offset += 4;
		}
		if (creationDate) {
			setUint32(extraFieldExtendedTimestampView, offset, Math.floor(creationDate.getTime() / 1000));
		}
		try {
			rawExtraFieldNTFS = new Uint8Array(36);
			const extraFieldNTFSView = getDataView(rawExtraFieldNTFS);
			const lastModTimeNTFS = getTimeNTFS(lastModDate);
			setUint16(extraFieldNTFSView, 0, EXTRAFIELD_TYPE_NTFS);
			setUint16(extraFieldNTFSView, 2, 32);
			setUint16(extraFieldNTFSView, 8, EXTRAFIELD_TYPE_NTFS_TAG1);
			setUint16(extraFieldNTFSView, 10, 24);
			setBigUint64(extraFieldNTFSView, 12, lastModTimeNTFS);
			setBigUint64(extraFieldNTFSView, 20, getTimeNTFS(lastAccessDate) || lastModTimeNTFS);
			setBigUint64(extraFieldNTFSView, 28, getTimeNTFS(creationDate) || lastModTimeNTFS);
		} catch (_error) {
			rawExtraFieldNTFS = new Uint8Array();
		}
	} else {
		rawExtraFieldNTFS = rawExtraFieldExtendedTimestamp = new Uint8Array();
	}
	let bitFlag = 0;
	if (useUnicodeFileNames) {
		bitFlag = bitFlag | BITFLAG_LANG_ENCODING_FLAG;
	}
	if (dataDescriptor) {
		bitFlag = bitFlag | BITFLAG_DATA_DESCRIPTOR;
	}
	if (compressionMethod === UNDEFINED_VALUE) {
		compressionMethod = compressed ? COMPRESSION_METHOD_DEFLATE : COMPRESSION_METHOD_STORE;
	}
	if (compressed) {
		if (level >= 1 && level < 3) {
			bitFlag = bitFlag | 0b110;
		}
		if (level >= 3 && level < 5) {
			bitFlag = bitFlag | 0b01;
		}
		if (level === 9) {
			bitFlag = bitFlag | 0b10;
		}
	}
	if (zip64) {
		version = version > VERSION_ZIP64 ? version : VERSION_ZIP64;
	}
	if (encrypted) {
		bitFlag = bitFlag | BITFLAG_ENCRYPTED;
		if (!zipCrypto) {
			version = version > VERSION_AES ? version : VERSION_AES;
			rawExtraFieldAES[9] = compressionMethod;
			compressionMethod = COMPRESSION_METHOD_AES;
		}
	}
	const headerArray = new Uint8Array(26);
	const headerView = getDataView(headerArray);
	setUint16(headerView, 0, version);
	setUint16(headerView, 2, bitFlag);
	setUint16(headerView, 4, compressionMethod);
	const dateArray = new Uint32Array(1);
	const dateView = getDataView(dateArray);
	let lastModDateMsDos;
	if (lastModDate < MIN_DATE) {
		lastModDateMsDos = MIN_DATE;
	} else if (lastModDate > MAX_DATE) {
		lastModDateMsDos = MAX_DATE;
	} else {
		lastModDateMsDos = lastModDate;
	}
	setUint16(dateView, 0, (((lastModDateMsDos.getHours() << 6) | lastModDateMsDos.getMinutes()) << 5) | lastModDateMsDos.getSeconds() / 2);
	setUint16(dateView, 2, ((((lastModDateMsDos.getFullYear() - 1980) << 4) | (lastModDateMsDos.getMonth() + 1)) << 5) | lastModDateMsDos.getDate());
	const rawLastModDate = dateArray[0];
	setUint32(headerView, 6, rawLastModDate);
	setUint16(headerView, 22, getLength(rawFilename));
	const extraFieldLength = getLength(rawExtraFieldAES, rawExtraFieldExtendedTimestamp, rawExtraFieldNTFS, rawExtraField);
	setUint16(headerView, 24, extraFieldLength);
	const localHeaderArray = new Uint8Array(30 + getLength(rawFilename) + extraFieldLength);
	const localHeaderView = getDataView(localHeaderArray);
	setUint32(localHeaderView, 0, LOCAL_FILE_HEADER_SIGNATURE);
	arraySet(localHeaderArray, headerArray, 4);
	arraySet(localHeaderArray, rawFilename, 30);
	arraySet(localHeaderArray, rawExtraFieldAES, 30 + getLength(rawFilename));
	arraySet(localHeaderArray, rawExtraFieldExtendedTimestamp, 30 + getLength(rawFilename, rawExtraFieldAES));
	arraySet(localHeaderArray, rawExtraFieldNTFS, 30 + getLength(rawFilename, rawExtraFieldAES, rawExtraFieldExtendedTimestamp));
	arraySet(localHeaderArray, rawExtraField, 30 + getLength(rawFilename, rawExtraFieldAES, rawExtraFieldExtendedTimestamp, rawExtraFieldNTFS));
	return {
		localHeaderArray,
		headerArray,
		headerView,
		lastModDate,
		rawLastModDate,
		encrypted,
		compressed,
		version,
		compressionMethod,
		extraFieldExtendedTimestampFlag,
		rawExtraFieldExtendedTimestamp,
		rawExtraFieldNTFS,
		rawExtraFieldAES,
		extraFieldLength
	};
}

function appendExtraFieldUSDZ(entryInfo, zipWriterOffset) {
	const { headerInfo } = entryInfo;
	let { localHeaderArray, extraFieldLength } = headerInfo;
	let localHeaderArrayView = getDataView(localHeaderArray);
	let extraBytesLength = 64 - ((zipWriterOffset + getLength(localHeaderArray)) % 64);
	if (extraBytesLength < 4) {
		extraBytesLength += 64;
	}
	const rawExtraFieldUSDZ = new Uint8Array(extraBytesLength);
	const extraFieldUSDZView = getDataView(rawExtraFieldUSDZ);
	setUint16(extraFieldUSDZView, 0, EXTRAFIELD_TYPE_USDZ);
	setUint16(extraFieldUSDZView, 2, extraBytesLength - 2);
	const previousLocalHeaderArray = localHeaderArray;
	headerInfo.localHeaderArray = localHeaderArray = new Uint8Array(getLength(previousLocalHeaderArray) + extraBytesLength);
	arraySet(localHeaderArray, previousLocalHeaderArray);
	arraySet(localHeaderArray, rawExtraFieldUSDZ, getLength(previousLocalHeaderArray));
	localHeaderArrayView = getDataView(localHeaderArray);
	setUint16(localHeaderArrayView, 28, extraFieldLength + extraBytesLength);
	entryInfo.metadataSize += extraBytesLength;
}

function getDataDescriptorInfo(options) {
	const {
		zip64,
		dataDescriptor,
		dataDescriptorSignature
	} = options;
	let dataDescriptorArray = new Uint8Array();
	let dataDescriptorView, dataDescriptorOffset = 0;
	if (dataDescriptor) {
		dataDescriptorArray = new Uint8Array(zip64 ? (dataDescriptorSignature ? 24 : 20) : (dataDescriptorSignature ? 16 : 12));
		dataDescriptorView = getDataView(dataDescriptorArray);
		if (dataDescriptorSignature) {
			dataDescriptorOffset = 4;
			setUint32(dataDescriptorView, 0, DATA_DESCRIPTOR_RECORD_SIGNATURE);
		}
	}
	return {
		dataDescriptorArray,
		dataDescriptorView,
		dataDescriptorOffset
	};
}

function setEntryInfo(entryInfo, options) {
	const {
		signature,
		rawExtraFieldZip64,
		compressedSize,
		uncompressedSize,
		headerInfo,
		dataDescriptorInfo
	} = entryInfo;
	const {
		headerView,
		encrypted
	} = headerInfo;
	const {
		dataDescriptorView,
		dataDescriptorOffset
	} = dataDescriptorInfo;
	const {
		zip64,
		zip64UncompressedSize,
		zip64CompressedSize,
		zipCrypto,
		dataDescriptor
	} = options;
	if ((!encrypted || zipCrypto) && signature !== UNDEFINED_VALUE) {
		setUint32(headerView, 10, signature);
		if (dataDescriptor) {
			setUint32(dataDescriptorView, dataDescriptorOffset, signature);
		}
	}
	if (zip64) {
		const rawExtraFieldZip64View = getDataView(rawExtraFieldZip64);
		setUint16(rawExtraFieldZip64View, 0, EXTRAFIELD_TYPE_ZIP64);
		setUint16(rawExtraFieldZip64View, 2, getLength(rawExtraFieldZip64) - 4);
		let rawExtraFieldZip64Offset = 4;
		if (zip64UncompressedSize) {
			setUint32(headerView, 18, MAX_32_BITS);
			setBigUint64(rawExtraFieldZip64View, rawExtraFieldZip64Offset, BigInt(uncompressedSize));
			rawExtraFieldZip64Offset += 8;
		}
		if (zip64CompressedSize) {
			setUint32(headerView, 14, MAX_32_BITS);
			setBigUint64(rawExtraFieldZip64View, rawExtraFieldZip64Offset, BigInt(compressedSize));
		}
		if (dataDescriptor) {
			setBigUint64(dataDescriptorView, dataDescriptorOffset + 4, BigInt(compressedSize));
			setBigUint64(dataDescriptorView, dataDescriptorOffset + 12, BigInt(uncompressedSize));
		}
	} else {
		setUint32(headerView, 14, compressedSize);
		setUint32(headerView, 18, uncompressedSize);
		if (dataDescriptor) {
			setUint32(dataDescriptorView, dataDescriptorOffset + 4, compressedSize);
			setUint32(dataDescriptorView, dataDescriptorOffset + 8, uncompressedSize);
		}
	}
}

async function writeExtraHeaderInfo(fileEntry, entryData, writable, { zipCrypto }) {
	let arrayBuffer;
	arrayBuffer = await entryData.slice(0, 26).arrayBuffer();
	if (arrayBuffer.byteLength != 26) {
		arrayBuffer = arrayBuffer.slice(0, 26);
	}
	const arrayBufferView = new DataView(arrayBuffer);
	if (!fileEntry.encrypted || zipCrypto) {
		setUint32(arrayBufferView, 14, fileEntry.signature);
	}
	if (fileEntry.zip64) {
		setUint32(arrayBufferView, 18, MAX_32_BITS);
		setUint32(arrayBufferView, 22, MAX_32_BITS);
	} else {
		setUint32(arrayBufferView, 18, fileEntry.compressedSize);
		setUint32(arrayBufferView, 22, fileEntry.uncompressedSize);
	}
	await writeData(writable, new Uint8Array(arrayBuffer));
	return entryData.slice(arrayBuffer.byteLength);
}

function setZip64ExtraInfo(fileEntry, options) {
	const { rawExtraFieldZip64, offset, diskNumberStart } = fileEntry;
	const { zip64UncompressedSize, zip64CompressedSize, zip64Offset, zip64DiskNumberStart } = options;
	const rawExtraFieldZip64View = getDataView(rawExtraFieldZip64);
	let rawExtraFieldZip64Offset = 4;
	if (zip64UncompressedSize) {
		rawExtraFieldZip64Offset += 8;
	}
	if (zip64CompressedSize) {
		rawExtraFieldZip64Offset += 8;
	}
	if (zip64Offset) {
		setBigUint64(rawExtraFieldZip64View, rawExtraFieldZip64Offset, BigInt(offset));
		rawExtraFieldZip64Offset += 8;
	}
	if (zip64DiskNumberStart) {
		setUint32(rawExtraFieldZip64View, rawExtraFieldZip64Offset, diskNumberStart);
	}
}

async function closeFile(zipWriter, comment, options) {
	const { files, writer } = zipWriter;
	const { diskOffset, writable } = writer;
	let { diskNumber } = writer;
	let offset = 0;
	let directoryDataLength = 0;
	let directoryOffset = zipWriter.offset - diskOffset;
	let filesLength = files.size;
	for (const [, fileEntry] of files) {
		const {
			rawFilename,
			rawExtraFieldZip64,
			rawExtraFieldAES,
			rawComment,
			rawExtraFieldNTFS,
			rawExtraField,
			extendedTimestamp,
			extraFieldExtendedTimestampFlag,
			lastModDate
		} = fileEntry;
		let rawExtraFieldTimestamp;
		if (extendedTimestamp) {
			rawExtraFieldTimestamp = new Uint8Array(9);
			const extraFieldExtendedTimestampView = getDataView(rawExtraFieldTimestamp);
			setUint16(extraFieldExtendedTimestampView, 0, EXTRAFIELD_TYPE_EXTENDED_TIMESTAMP);
			setUint16(extraFieldExtendedTimestampView, 2, 5);
			setUint8(extraFieldExtendedTimestampView, 4, extraFieldExtendedTimestampFlag);
			setUint32(extraFieldExtendedTimestampView, 5, Math.floor(lastModDate.getTime() / 1000));
		} else {
			rawExtraFieldTimestamp = new Uint8Array();
		}
		fileEntry.rawExtraFieldCDExtendedTimestamp = rawExtraFieldTimestamp;
		directoryDataLength += 46 +
			getLength(
				rawFilename,
				rawComment,
				rawExtraFieldZip64,
				rawExtraFieldAES,
				rawExtraFieldNTFS,
				rawExtraFieldTimestamp,
				rawExtraField);
	}
	const directoryArray = new Uint8Array(directoryDataLength);
	const directoryView = getDataView(directoryArray);
	await initStream(writer);
	let directoryDiskOffset = 0;
	for (const [indexFileEntry, fileEntry] of Array.from(files.values()).entries()) {
		const {
			offset: fileEntryOffset,
			rawFilename,
			rawExtraFieldZip64,
			rawExtraFieldAES,
			rawExtraFieldCDExtendedTimestamp,
			rawExtraFieldNTFS,
			rawExtraField,
			rawComment,
			versionMadeBy,
			headerArray,
			directory,
			zip64,
			zip64UncompressedSize,
			zip64CompressedSize,
			zip64DiskNumberStart,
			zip64Offset,
			msDosCompatible,
			internalFileAttribute,
			externalFileAttribute,
			diskNumberStart,
			uncompressedSize,
			compressedSize
		} = fileEntry;
		const extraFieldLength = getLength(rawExtraFieldZip64, rawExtraFieldAES, rawExtraFieldCDExtendedTimestamp, rawExtraFieldNTFS, rawExtraField);
		setUint32(directoryView, offset, CENTRAL_FILE_HEADER_SIGNATURE);
		setUint16(directoryView, offset + 4, versionMadeBy);
		const headerView = getDataView(headerArray);
		if (!zip64UncompressedSize) {
			setUint32(headerView, 18, uncompressedSize);
		}
		if (!zip64CompressedSize) {
			setUint32(headerView, 14, compressedSize);
		}
		arraySet(directoryArray, headerArray, offset + 6);
		setUint16(directoryView, offset + 30, extraFieldLength);
		setUint16(directoryView, offset + 32, getLength(rawComment));
		setUint16(directoryView, offset + 34, zip64 && zip64DiskNumberStart ? MAX_16_BITS : diskNumberStart);
		setUint16(directoryView, offset + 36, internalFileAttribute);
		if (externalFileAttribute) {
			setUint32(directoryView, offset + 38, externalFileAttribute);
		} else if (directory && msDosCompatible) {
			setUint8(directoryView, offset + 38, FILE_ATTR_MSDOS_DIR_MASK);
		}
		setUint32(directoryView, offset + 42, zip64 && zip64Offset ? MAX_32_BITS : fileEntryOffset);
		arraySet(directoryArray, rawFilename, offset + 46);
		arraySet(directoryArray, rawExtraFieldZip64, offset + 46 + getLength(rawFilename));
		arraySet(directoryArray, rawExtraFieldAES, offset + 46 + getLength(rawFilename, rawExtraFieldZip64));
		arraySet(directoryArray, rawExtraFieldCDExtendedTimestamp, offset + 46 + getLength(rawFilename, rawExtraFieldZip64, rawExtraFieldAES));
		arraySet(directoryArray, rawExtraFieldNTFS, offset + 46 + getLength(rawFilename, rawExtraFieldZip64, rawExtraFieldAES, rawExtraFieldCDExtendedTimestamp));
		arraySet(directoryArray, rawExtraField, offset + 46 + getLength(rawFilename, rawExtraFieldZip64, rawExtraFieldAES, rawExtraFieldCDExtendedTimestamp, rawExtraFieldNTFS));
		arraySet(directoryArray, rawComment, offset + 46 + getLength(rawFilename) + extraFieldLength);
		const directoryEntryLength = 46 + getLength(rawFilename, rawComment) + extraFieldLength;
		if (offset - directoryDiskOffset > writer.availableSize) {
			writer.availableSize = 0;
			await writeData(writable, directoryArray.slice(directoryDiskOffset, offset));
			directoryDiskOffset = offset;
		}
		offset += directoryEntryLength;
		if (options.onprogress) {
			try {
				await options.onprogress(indexFileEntry + 1, files.size, new Entry(fileEntry));
			} catch (_error) {
				// ignored
			}
		}
	}
	await writeData(writable, directoryDiskOffset ? directoryArray.slice(directoryDiskOffset) : directoryArray);
	let lastDiskNumber = writer.diskNumber;
	const { availableSize } = writer;
	if (availableSize < END_OF_CENTRAL_DIR_LENGTH) {
		lastDiskNumber++;
	}
	let zip64 = getOptionValue(zipWriter, options, PROPERTY_NAME_ZIP64);
	if (directoryOffset > MAX_32_BITS || directoryDataLength > MAX_32_BITS || filesLength > MAX_16_BITS || lastDiskNumber > MAX_16_BITS) {
		if (zip64 === false) {
			throw new Error(ERR_UNSUPPORTED_FORMAT);
		} else {
			zip64 = true;
		}
	}
	const endOfdirectoryArray = new Uint8Array(zip64 ? ZIP64_END_OF_CENTRAL_DIR_TOTAL_LENGTH : END_OF_CENTRAL_DIR_LENGTH);
	const endOfdirectoryView = getDataView(endOfdirectoryArray);
	offset = 0;
	if (zip64) {
		setUint32(endOfdirectoryView, 0, ZIP64_END_OF_CENTRAL_DIR_SIGNATURE);
		setBigUint64(endOfdirectoryView, 4, BigInt(44));
		setUint16(endOfdirectoryView, 12, 45);
		setUint16(endOfdirectoryView, 14, 45);
		setUint32(endOfdirectoryView, 16, lastDiskNumber);
		setUint32(endOfdirectoryView, 20, diskNumber);
		setBigUint64(endOfdirectoryView, 24, BigInt(filesLength));
		setBigUint64(endOfdirectoryView, 32, BigInt(filesLength));
		setBigUint64(endOfdirectoryView, 40, BigInt(directoryDataLength));
		setBigUint64(endOfdirectoryView, 48, BigInt(directoryOffset));
		setUint32(endOfdirectoryView, 56, ZIP64_END_OF_CENTRAL_DIR_LOCATOR_SIGNATURE);
		setBigUint64(endOfdirectoryView, 64, BigInt(directoryOffset) + BigInt(directoryDataLength));
		setUint32(endOfdirectoryView, 72, lastDiskNumber + 1);
		const supportZip64SplitFile = getOptionValue(zipWriter, options, "supportZip64SplitFile", true);
		if (supportZip64SplitFile) {
			lastDiskNumber = MAX_16_BITS;
			diskNumber = MAX_16_BITS;
		}
		filesLength = MAX_16_BITS;
		directoryOffset = MAX_32_BITS;
		directoryDataLength = MAX_32_BITS;
		offset += ZIP64_END_OF_CENTRAL_DIR_LENGTH + ZIP64_END_OF_CENTRAL_DIR_LOCATOR_LENGTH;
	}
	setUint32(endOfdirectoryView, offset, END_OF_CENTRAL_DIR_SIGNATURE);
	setUint16(endOfdirectoryView, offset + 4, lastDiskNumber);
	setUint16(endOfdirectoryView, offset + 6, diskNumber);
	setUint16(endOfdirectoryView, offset + 8, filesLength);
	setUint16(endOfdirectoryView, offset + 10, filesLength);
	setUint32(endOfdirectoryView, offset + 12, directoryDataLength);
	setUint32(endOfdirectoryView, offset + 16, directoryOffset);
	const commentLength = getLength(comment);
	if (commentLength) {
		if (commentLength <= MAX_16_BITS) {
			setUint16(endOfdirectoryView, offset + 20, commentLength);
		} else {
			throw new Error(ERR_INVALID_COMMENT);
		}
	}
	await writeData(writable, endOfdirectoryArray);
	if (commentLength) {
		await writeData(writable, comment);
	}
}

async function writeData(writable, array) {
	const streamWriter = writable.getWriter();
	try {
		await streamWriter.ready;
		writable.size += getLength(array);
		await streamWriter.write(array);
	} finally {
		streamWriter.releaseLock();
	}
}

function getTimeNTFS(date) {
	if (date) {
		return ((BigInt(date.getTime()) + BigInt(11644473600000)) * BigInt(10000));
	}
}

function getOptionValue(zipWriter, options, name, defaultValue) {
	const result = options[name] === UNDEFINED_VALUE ? zipWriter.options[name] : options[name];
	return result === UNDEFINED_VALUE ? defaultValue : result;
}

function getMaximumCompressedSize(uncompressedSize) {
	return uncompressedSize + (5 * (Math.floor(uncompressedSize / 16383) + 1));
}

function setUint8(view, offset, value) {
	view.setUint8(offset, value);
}

function setUint16(view, offset, value) {
	view.setUint16(offset, value, true);
}

function setUint32(view, offset, value) {
	view.setUint32(offset, value, true);
}

function setBigUint64(view, offset, value) {
	view.setBigUint64(offset, value, true);
}

function arraySet(array, typedArray, offset) {
	array.set(typedArray, offset);
}

function getDataView(array) {
	return new DataView(array.buffer);
}

function getLength(...arrayLikes) {
	let result = 0;
	arrayLikes.forEach(arrayLike => arrayLike && (result += arrayLike.length));
	return result;
}

/*
 Copyright (c) 2022 Gildas Lormeau. All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with the distribution.

 3. The names of the authors may not be used to endorse or promote products
 derived from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
 INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


let baseURL;
try {
	baseURL = import.meta.url;
} catch (_error) {
	// ignored
}
configure({ baseURL });
e(configure);

/// <reference types="./index.d.ts" />


configure({ Deflate: ZipDeflate, Inflate: ZipInflate });

var cosJsSdkV5 = {exports: {}};

(function (module, exports) {
	(function webpackUniversalModuleDefinition(root, factory) {
	  module.exports = factory();
	})(commonjsGlobal, function() {
	  return (
	    /******/
	    function(modules) {
	      var installedModules = {};
	      function __webpack_require__(moduleId) {
	        if (installedModules[moduleId]) {
	          return installedModules[moduleId].exports;
	        }
	        var module2 = installedModules[moduleId] = {
	          /******/
	          i: moduleId,
	          /******/
	          l: false,
	          /******/
	          exports: {}
	          /******/
	        };
	        modules[moduleId].call(module2.exports, module2, module2.exports, __webpack_require__);
	        module2.l = true;
	        return module2.exports;
	      }
	      __webpack_require__.m = modules;
	      __webpack_require__.c = installedModules;
	      __webpack_require__.d = function(exports2, name, getter) {
	        if (!__webpack_require__.o(exports2, name)) {
	          Object.defineProperty(exports2, name, { enumerable: true, get: getter });
	        }
	      };
	      __webpack_require__.r = function(exports2) {
	        if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
	          Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
	        }
	        Object.defineProperty(exports2, "__esModule", { value: true });
	      };
	      __webpack_require__.t = function(value, mode) {
	        if (mode & 1) value = __webpack_require__(value);
	        if (mode & 8) return value;
	        if (mode & 4 && typeof value === "object" && value && value.__esModule) return value;
	        var ns = /* @__PURE__ */ Object.create(null);
	        __webpack_require__.r(ns);
	        Object.defineProperty(ns, "default", { enumerable: true, value });
	        if (mode & 2 && typeof value != "string") for (var key in value) __webpack_require__.d(ns, key, function(key2) {
	          return value[key2];
	        }.bind(null, key));
	        return ns;
	      };
	      __webpack_require__.n = function(module2) {
	        var getter = module2 && module2.__esModule ? (
	          /******/
	          function getDefault() {
	            return module2["default"];
	          }
	        ) : (
	          /******/
	          function getModuleExports() {
	            return module2;
	          }
	        );
	        __webpack_require__.d(getter, "a", getter);
	        return getter;
	      };
	      __webpack_require__.o = function(object, property) {
	        return Object.prototype.hasOwnProperty.call(object, property);
	      };
	      __webpack_require__.p = "/dist/";
	      return __webpack_require__(__webpack_require__.s = "./index.js");
	    }({
	      /***/
	      "./index.js": (
	        /*!******************!*\
	          !*** ./index.js ***!
	          \******************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var COS = __webpack_require__(
	            /*! ./src/cos */
	            "./src/cos.js"
	          );
	          module2.exports = COS;
	        }
	      ),
	      /***/
	      "./lib/base64.js": (
	        /*!***********************!*\
	          !*** ./lib/base64.js ***!
	          \***********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          var Base64 = function(global) {
	            global = global || {};
	            var _Base64 = global.Base64;
	            var version = "2.1.9";
	            var b64chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	            var b64tab = function(bin) {
	              var t = {};
	              for (var i = 0, l = bin.length; i < l; i++) t[bin.charAt(i)] = i;
	              return t;
	            }(b64chars);
	            var fromCharCode = String.fromCharCode;
	            var cb_utob = function cb_utob2(c) {
	              if (c.length < 2) {
	                var cc = c.charCodeAt(0);
	                return cc < 128 ? c : cc < 2048 ? fromCharCode(192 | cc >>> 6) + fromCharCode(128 | cc & 63) : fromCharCode(224 | cc >>> 12 & 15) + fromCharCode(128 | cc >>> 6 & 63) + fromCharCode(128 | cc & 63);
	              } else {
	                var cc = 65536 + (c.charCodeAt(0) - 55296) * 1024 + (c.charCodeAt(1) - 56320);
	                return fromCharCode(240 | cc >>> 18 & 7) + fromCharCode(128 | cc >>> 12 & 63) + fromCharCode(128 | cc >>> 6 & 63) + fromCharCode(128 | cc & 63);
	              }
	            };
	            var re_utob = /[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g;
	            var utob = function utob2(u) {
	              return u.replace(re_utob, cb_utob);
	            };
	            var cb_encode = function cb_encode2(ccc) {
	              var padlen = [0, 2, 1][ccc.length % 3], ord = ccc.charCodeAt(0) << 16 | (ccc.length > 1 ? ccc.charCodeAt(1) : 0) << 8 | (ccc.length > 2 ? ccc.charCodeAt(2) : 0), chars = [b64chars.charAt(ord >>> 18), b64chars.charAt(ord >>> 12 & 63), padlen >= 2 ? "=" : b64chars.charAt(ord >>> 6 & 63), padlen >= 1 ? "=" : b64chars.charAt(ord & 63)];
	              return chars.join("");
	            };
	            var btoa2 = global.btoa ? function(b) {
	              return global.btoa(b);
	            } : function(b) {
	              return b.replace(/[\s\S]{1,3}/g, cb_encode);
	            };
	            var _encode = function(u) {
	              return btoa2(utob(u));
	            };
	            var encode = function encode2(u, urisafe) {
	              return !urisafe ? _encode(String(u)) : _encode(String(u)).replace(/[+\/]/g, function(m0) {
	                return m0 == "+" ? "-" : "_";
	              }).replace(/=/g, "");
	            };
	            var encodeURI = function encodeURI2(u) {
	              return encode(u, true);
	            };
	            var re_btou = new RegExp(["[À-ß][-¿]", "[à-ï][-¿]{2}", "[ð-÷][-¿]{3}"].join("|"), "g");
	            var cb_btou = function cb_btou2(cccc) {
	              switch (cccc.length) {
	                case 4:
	                  var cp = (7 & cccc.charCodeAt(0)) << 18 | (63 & cccc.charCodeAt(1)) << 12 | (63 & cccc.charCodeAt(2)) << 6 | 63 & cccc.charCodeAt(3), offset = cp - 65536;
	                  return fromCharCode((offset >>> 10) + 55296) + fromCharCode((offset & 1023) + 56320);
	                case 3:
	                  return fromCharCode((15 & cccc.charCodeAt(0)) << 12 | (63 & cccc.charCodeAt(1)) << 6 | 63 & cccc.charCodeAt(2));
	                default:
	                  return fromCharCode((31 & cccc.charCodeAt(0)) << 6 | 63 & cccc.charCodeAt(1));
	              }
	            };
	            var btou = function btou2(b) {
	              return b.replace(re_btou, cb_btou);
	            };
	            var cb_decode = function cb_decode2(cccc) {
	              var len = cccc.length, padlen = len % 4, n = (len > 0 ? b64tab[cccc.charAt(0)] << 18 : 0) | (len > 1 ? b64tab[cccc.charAt(1)] << 12 : 0) | (len > 2 ? b64tab[cccc.charAt(2)] << 6 : 0) | (len > 3 ? b64tab[cccc.charAt(3)] : 0), chars = [fromCharCode(n >>> 16), fromCharCode(n >>> 8 & 255), fromCharCode(n & 255)];
	              chars.length -= [0, 0, 2, 1][padlen];
	              return chars.join("");
	            };
	            var atob2 = global.atob ? function(a) {
	              return global.atob(a);
	            } : function(a) {
	              return a.replace(/[\s\S]{1,4}/g, cb_decode);
	            };
	            var _decode = function(a) {
	              return btou(atob2(a));
	            };
	            var decode = function decode2(a) {
	              return _decode(String(a).replace(/[-_]/g, function(m0) {
	                return m0 == "-" ? "+" : "/";
	              }).replace(/[^A-Za-z0-9\+\/]/g, ""));
	            };
	            var noConflict = function noConflict2() {
	              var Base643 = global.Base64;
	              global.Base64 = _Base64;
	              return Base643;
	            };
	            var Base642 = {
	              VERSION: version,
	              atob: atob2,
	              btoa: btoa2,
	              fromBase64: decode,
	              toBase64: encode,
	              utob,
	              encode,
	              encodeURI,
	              btou,
	              decode,
	              noConflict
	            };
	            return Base642;
	          }();
	          module2.exports = Base64;
	        }
	      ),
	      /***/
	      "./lib/crypto.js": (
	        /*!***********************!*\
	          !*** ./lib/crypto.js ***!
	          \***********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          (function(module3) {
	            var _typeof = __webpack_require__(
	              /*! @babel/runtime/helpers/typeof */
	              "./node_modules/@babel/runtime/helpers/typeof.js"
	            );
	            var CryptoJS = CryptoJS || function(g, l) {
	              var e = {}, d = e.lib = {}, m = function m2() {
	              }, k = d.Base = {
	                extend: function extend(a) {
	                  m.prototype = this;
	                  var c = new m();
	                  a && c.mixIn(a);
	                  c.hasOwnProperty("init") || (c.init = function() {
	                    c.$super.init.apply(this, arguments);
	                  });
	                  c.init.prototype = c;
	                  c.$super = this;
	                  return c;
	                },
	                create: function create() {
	                  var a = this.extend();
	                  a.init.apply(a, arguments);
	                  return a;
	                },
	                init: function init() {
	                },
	                mixIn: function mixIn(a) {
	                  for (var c in a) a.hasOwnProperty(c) && (this[c] = a[c]);
	                  a.hasOwnProperty("toString") && (this.toString = a.toString);
	                },
	                clone: function clone() {
	                  return this.init.prototype.extend(this);
	                }
	              }, p = d.WordArray = k.extend({
	                init: function init(a, c) {
	                  a = this.words = a || [];
	                  this.sigBytes = c != l ? c : 4 * a.length;
	                },
	                toString: function toString(a) {
	                  return (a || n).stringify(this);
	                },
	                concat: function concat(a) {
	                  var c = this.words, q = a.words, f = this.sigBytes;
	                  a = a.sigBytes;
	                  this.clamp();
	                  if (f % 4) for (var b2 = 0; b2 < a; b2++) c[f + b2 >>> 2] |= (q[b2 >>> 2] >>> 24 - 8 * (b2 % 4) & 255) << 24 - 8 * ((f + b2) % 4);
	                  else if (65535 < q.length) for (b2 = 0; b2 < a; b2 += 4) c[f + b2 >>> 2] = q[b2 >>> 2];
	                  else c.push.apply(c, q);
	                  this.sigBytes += a;
	                  return this;
	                },
	                clamp: function clamp() {
	                  var a = this.words, c = this.sigBytes;
	                  a[c >>> 2] &= 4294967295 << 32 - 8 * (c % 4);
	                  a.length = g.ceil(c / 4);
	                },
	                clone: function clone() {
	                  var a = k.clone.call(this);
	                  a.words = this.words.slice(0);
	                  return a;
	                },
	                random: function random(a) {
	                  for (var c = [], b2 = 0; b2 < a; b2 += 4) c.push(4294967296 * g.random() | 0);
	                  return new p.init(c, a);
	                }
	              }), b = e.enc = {}, n = b.Hex = {
	                stringify: function stringify(a) {
	                  var c = a.words;
	                  a = a.sigBytes;
	                  for (var b2 = [], f = 0; f < a; f++) {
	                    var d2 = c[f >>> 2] >>> 24 - 8 * (f % 4) & 255;
	                    b2.push((d2 >>> 4).toString(16));
	                    b2.push((d2 & 15).toString(16));
	                  }
	                  return b2.join("");
	                },
	                parse: function parse(a) {
	                  for (var c = a.length, b2 = [], f = 0; f < c; f += 2) b2[f >>> 3] |= parseInt(a.substr(f, 2), 16) << 24 - 4 * (f % 8);
	                  return new p.init(b2, c / 2);
	                }
	              }, j = b.Latin1 = {
	                stringify: function stringify(a) {
	                  var c = a.words;
	                  a = a.sigBytes;
	                  for (var b2 = [], f = 0; f < a; f++) b2.push(String.fromCharCode(c[f >>> 2] >>> 24 - 8 * (f % 4) & 255));
	                  return b2.join("");
	                },
	                parse: function parse(a) {
	                  for (var c = a.length, b2 = [], f = 0; f < c; f++) b2[f >>> 2] |= (a.charCodeAt(f) & 255) << 24 - 8 * (f % 4);
	                  return new p.init(b2, c);
	                }
	              }, h = b.Utf8 = {
	                stringify: function stringify(a) {
	                  try {
	                    return decodeURIComponent(escape(j.stringify(a)));
	                  } catch (c) {
	                    throw Error("Malformed UTF-8 data");
	                  }
	                },
	                parse: function parse(a) {
	                  return j.parse(unescape(encodeURIComponent(a)));
	                }
	              }, r = d.BufferedBlockAlgorithm = k.extend({
	                reset: function reset() {
	                  this._data = new p.init();
	                  this._nDataBytes = 0;
	                },
	                _append: function _append(a) {
	                  "string" == typeof a && (a = h.parse(a));
	                  this._data.concat(a);
	                  this._nDataBytes += a.sigBytes;
	                },
	                _process: function _process(a) {
	                  var c = this._data, b2 = c.words, f = c.sigBytes, d2 = this.blockSize, e2 = f / (4 * d2), e2 = a ? g.ceil(e2) : g.max((e2 | 0) - this._minBufferSize, 0);
	                  a = e2 * d2;
	                  f = g.min(4 * a, f);
	                  if (a) {
	                    for (var k2 = 0; k2 < a; k2 += d2) this._doProcessBlock(b2, k2);
	                    k2 = b2.splice(0, a);
	                    c.sigBytes -= f;
	                  }
	                  return new p.init(k2, f);
	                },
	                clone: function clone() {
	                  var a = k.clone.call(this);
	                  a._data = this._data.clone();
	                  return a;
	                },
	                _minBufferSize: 0
	              });
	              d.Hasher = r.extend({
	                cfg: k.extend(),
	                init: function init(a) {
	                  this.cfg = this.cfg.extend(a);
	                  this.reset();
	                },
	                reset: function reset() {
	                  r.reset.call(this);
	                  this._doReset();
	                },
	                update: function update(a) {
	                  this._append(a);
	                  this._process();
	                  return this;
	                },
	                finalize: function finalize(a) {
	                  a && this._append(a);
	                  return this._doFinalize();
	                },
	                blockSize: 16,
	                _createHelper: function _createHelper(a) {
	                  return function(b2, d2) {
	                    return new a.init(d2).finalize(b2);
	                  };
	                },
	                _createHmacHelper: function _createHmacHelper(a) {
	                  return function(b2, d2) {
	                    return new s.HMAC.init(a, d2).finalize(b2);
	                  };
	                }
	              });
	              var s = e.algo = {};
	              return e;
	            }(Math);
	            (function() {
	              var g = CryptoJS, l = g.lib, e = l.WordArray, d = l.Hasher, m = [], l = g.algo.SHA1 = d.extend({
	                _doReset: function _doReset() {
	                  this._hash = new e.init([1732584193, 4023233417, 2562383102, 271733878, 3285377520]);
	                },
	                _doProcessBlock: function _doProcessBlock(d2, e2) {
	                  for (var b = this._hash.words, n = b[0], j = b[1], h = b[2], g2 = b[3], l2 = b[4], a = 0; 80 > a; a++) {
	                    if (16 > a) m[a] = d2[e2 + a] | 0;
	                    else {
	                      var c = m[a - 3] ^ m[a - 8] ^ m[a - 14] ^ m[a - 16];
	                      m[a] = c << 1 | c >>> 31;
	                    }
	                    c = (n << 5 | n >>> 27) + l2 + m[a];
	                    c = 20 > a ? c + ((j & h | ~j & g2) + 1518500249) : 40 > a ? c + ((j ^ h ^ g2) + 1859775393) : 60 > a ? c + ((j & h | j & g2 | h & g2) - 1894007588) : c + ((j ^ h ^ g2) - 899497514);
	                    l2 = g2;
	                    g2 = h;
	                    h = j << 30 | j >>> 2;
	                    j = n;
	                    n = c;
	                  }
	                  b[0] = b[0] + n | 0;
	                  b[1] = b[1] + j | 0;
	                  b[2] = b[2] + h | 0;
	                  b[3] = b[3] + g2 | 0;
	                  b[4] = b[4] + l2 | 0;
	                },
	                _doFinalize: function _doFinalize() {
	                  var d2 = this._data, e2 = d2.words, b = 8 * this._nDataBytes, g2 = 8 * d2.sigBytes;
	                  e2[g2 >>> 5] |= 128 << 24 - g2 % 32;
	                  e2[(g2 + 64 >>> 9 << 4) + 14] = Math.floor(b / 4294967296);
	                  e2[(g2 + 64 >>> 9 << 4) + 15] = b;
	                  d2.sigBytes = 4 * e2.length;
	                  this._process();
	                  return this._hash;
	                },
	                clone: function clone() {
	                  var e2 = d.clone.call(this);
	                  e2._hash = this._hash.clone();
	                  return e2;
	                }
	              });
	              g.SHA1 = d._createHelper(l);
	              g.HmacSHA1 = d._createHmacHelper(l);
	            })();
	            (function() {
	              var g = CryptoJS, l = g.enc.Utf8;
	              g.algo.HMAC = g.lib.Base.extend({
	                init: function init(e, d) {
	                  e = this._hasher = new e.init();
	                  "string" == typeof d && (d = l.parse(d));
	                  var g2 = e.blockSize, k = 4 * g2;
	                  d.sigBytes > k && (d = e.finalize(d));
	                  d.clamp();
	                  for (var p = this._oKey = d.clone(), b = this._iKey = d.clone(), n = p.words, j = b.words, h = 0; h < g2; h++) n[h] ^= 1549556828, j[h] ^= 909522486;
	                  p.sigBytes = b.sigBytes = k;
	                  this.reset();
	                },
	                reset: function reset() {
	                  var e = this._hasher;
	                  e.reset();
	                  e.update(this._iKey);
	                },
	                update: function update(e) {
	                  this._hasher.update(e);
	                  return this;
	                },
	                finalize: function finalize(e) {
	                  var d = this._hasher;
	                  e = d.finalize(e);
	                  d.reset();
	                  return d.finalize(this._oKey.clone().concat(e));
	                }
	              });
	            })();
	            (function() {
	              var C = CryptoJS;
	              var C_lib = C.lib;
	              var WordArray = C_lib.WordArray;
	              var C_enc = C.enc;
	              C_enc.Base64 = {
	                /**
	                 * Converts a word array to a Base64 string.
	                 *
	                 * @param {WordArray} wordArray The word array.
	                 *
	                 * @return {string} The Base64 string.
	                 *
	                 * @static
	                 *
	                 * @example
	                 *
	                 *     var base64String = CryptoJS.enc.Base64.stringify(wordArray);
	                 */
	                stringify: function stringify(wordArray) {
	                  var words = wordArray.words;
	                  var sigBytes = wordArray.sigBytes;
	                  var map = this._map;
	                  wordArray.clamp();
	                  var base64Chars = [];
	                  for (var i = 0; i < sigBytes; i += 3) {
	                    var byte1 = words[i >>> 2] >>> 24 - i % 4 * 8 & 255;
	                    var byte2 = words[i + 1 >>> 2] >>> 24 - (i + 1) % 4 * 8 & 255;
	                    var byte3 = words[i + 2 >>> 2] >>> 24 - (i + 2) % 4 * 8 & 255;
	                    var triplet = byte1 << 16 | byte2 << 8 | byte3;
	                    for (var j = 0; j < 4 && i + j * 0.75 < sigBytes; j++) {
	                      base64Chars.push(map.charAt(triplet >>> 6 * (3 - j) & 63));
	                    }
	                  }
	                  var paddingChar = map.charAt(64);
	                  if (paddingChar) {
	                    while (base64Chars.length % 4) {
	                      base64Chars.push(paddingChar);
	                    }
	                  }
	                  return base64Chars.join("");
	                },
	                /**
	                 * Converts a Base64 string to a word array.
	                 *
	                 * @param {string} base64Str The Base64 string.
	                 *
	                 * @return {WordArray} The word array.
	                 *
	                 * @static
	                 *
	                 * @example
	                 *
	                 *     var wordArray = CryptoJS.enc.Base64.parse(base64String);
	                 */
	                parse: function parse(base64Str) {
	                  var base64StrLength = base64Str.length;
	                  var map = this._map;
	                  var paddingChar = map.charAt(64);
	                  if (paddingChar) {
	                    var paddingIndex = base64Str.indexOf(paddingChar);
	                    if (paddingIndex != -1) {
	                      base64StrLength = paddingIndex;
	                    }
	                  }
	                  var words = [];
	                  var nBytes = 0;
	                  for (var i = 0; i < base64StrLength; i++) {
	                    if (i % 4) {
	                      var bits1 = map.indexOf(base64Str.charAt(i - 1)) << i % 4 * 2;
	                      var bits2 = map.indexOf(base64Str.charAt(i)) >>> 6 - i % 4 * 2;
	                      words[nBytes >>> 2] |= (bits1 | bits2) << 24 - nBytes % 4 * 8;
	                      nBytes++;
	                    }
	                  }
	                  return WordArray.create(words, nBytes);
	                },
	                _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
	              };
	            })();
	            if ((_typeof(module3)) === "object") {
	              module3.exports = CryptoJS;
	            } else {
	              window.CryptoJS = CryptoJS;
	            }
	          }).call(this, __webpack_require__(
	            /*! ./../node_modules/webpack/buildin/module.js */
	            "./node_modules/webpack/buildin/module.js"
	          )(module2));
	        }
	      ),
	      /***/
	      "./lib/json2xml.js": (
	        /*!*************************!*\
	          !*** ./lib/json2xml.js ***!
	          \*************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! @babel/runtime/helpers/typeof */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          );
	          var element_start_char = "a-zA-Z_À-ÖØ-öø-ÿͰ-ͽͿ-῿‌-‍⁰-↏Ⰰ-⿿、-퟿豈-﷏ﷰ-�";
	          var element_non_start_char = "-.0-9·̀-ͯ‿⁀";
	          var element_replace = new RegExp("^([^" + element_start_char + "])|^((x|X)(m|M)(l|L))|([^" + element_start_char + element_non_start_char + "])", "g");
	          var not_safe_in_xml = /[^\x09\x0A\x0D\x20-\xFF\x85\xA0-\uD7FF\uE000-\uFDCF\uFDE0-\uFFFD]/gm;
	          var objKeys = function objKeys2(obj) {
	            var l = [];
	            if (obj instanceof Object) {
	              for (var k in obj) {
	                if (obj.hasOwnProperty(k)) {
	                  l.push(k);
	                }
	              }
	            }
	            return l;
	          };
	          var process_to_xml = function process_to_xml2(node_data, options) {
	            var makeNode = function makeNode2(name, content, attributes, level, hasSubNodes) {
	              var indent_value = options.indent !== void 0 ? options.indent : "	";
	              var indent = options.prettyPrint ? "\n" + new Array(level).join(indent_value) : "";
	              if (options.removeIllegalNameCharacters) {
	                name = name.replace(element_replace, "_");
	              }
	              var node = [indent, "<", name, ""];
	              if (content && content.length > 0) {
	                node.push(">");
	                node.push(content);
	                hasSubNodes && node.push(indent);
	                node.push("</");
	                node.push(name);
	                node.push(">");
	              } else {
	                node.push("/>");
	              }
	              return node.join("");
	            };
	            return function fn(node_data2, node_descriptor, level) {
	              var type = _typeof(node_data2);
	              if (Array.isArray ? Array.isArray(node_data2) : node_data2 instanceof Array) {
	                type = "array";
	              } else if (node_data2 instanceof Date) {
	                type = "date";
	              }
	              switch (type) {
	                case "array":
	                  var ret = [];
	                  node_data2.map(function(v) {
	                    ret.push(fn(v, 1, level + 1));
	                  });
	                  options.prettyPrint && ret.push("\n");
	                  return ret.join("");
	                case "date":
	                  return node_data2.toJSON ? node_data2.toJSON() : node_data2 + "";
	                case "object":
	                  var nodes = [];
	                  for (var name in node_data2) {
	                    if (node_data2.hasOwnProperty(name)) {
	                      if (node_data2[name] instanceof Array) {
	                        for (var j = 0; j < node_data2[name].length; j++) {
	                          if (node_data2[name].hasOwnProperty(j)) {
	                            nodes.push(makeNode(name, fn(node_data2[name][j], 0, level + 1), null, level + 1, objKeys(node_data2[name][j]).length));
	                          }
	                        }
	                      } else {
	                        nodes.push(makeNode(name, fn(node_data2[name], 0, level + 1), null, level + 1));
	                      }
	                    }
	                  }
	                  options.prettyPrint && nodes.length > 0 && nodes.push("\n");
	                  return nodes.join("");
	                case "function":
	                  return node_data2();
	                default:
	                  return options.escape ? esc(node_data2) : "" + node_data2;
	              }
	            }(node_data, 0, 0);
	          };
	          var xml_header = function xml_header2(standalone) {
	            var ret = ['<?xml version="1.0" encoding="UTF-8"'];
	            if (standalone) {
	              ret.push(' standalone="yes"');
	            }
	            ret.push("?>");
	            return ret.join("");
	          };
	          function esc(str) {
	            return ("" + str).replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/'/g, "&apos;").replace(/"/g, "&quot;").replace(not_safe_in_xml, "");
	          }
	          module2.exports = function(obj, options) {
	            if (!options) {
	              options = {
	                xmlHeader: {
	                  standalone: true
	                },
	                prettyPrint: true,
	                indent: "  ",
	                escape: true
	              };
	            }
	            if (typeof obj == "string") {
	              try {
	                obj = JSON.parse(obj.toString());
	              } catch (e) {
	                return false;
	              }
	            }
	            var xmlheader = "";
	            var docType = "";
	            if (options) {
	              if (_typeof(options) == "object") {
	                if (options.xmlHeader) {
	                  xmlheader = xml_header(!!options.xmlHeader.standalone);
	                }
	                if (typeof options.docType != "undefined") {
	                  docType = "<!DOCTYPE " + options.docType + ">";
	                }
	              } else {
	                xmlheader = xml_header();
	              }
	            }
	            options = options || {};
	            var ret = [xmlheader, options.prettyPrint && docType ? "\n" : "", docType, process_to_xml(obj, options)];
	            return ret.join("").replace(/\n{2,}/g, "\n").replace(/\s+$/g, "");
	          };
	        }
	      ),
	      /***/
	      "./lib/md5.js": (
	        /*!********************!*\
	          !*** ./lib/md5.js ***!
	          \********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          (function(module3) {
	            var __WEBPACK_AMD_DEFINE_RESULT__;
	            var _typeof = __webpack_require__(
	              /*! @babel/runtime/helpers/typeof */
	              "./node_modules/@babel/runtime/helpers/typeof.js"
	            );
	            (function() {
	              var WINDOW = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object";
	              var root = WINDOW ? window : {};
	              if (root.JS_MD5_NO_WINDOW) {
	                WINDOW = false;
	              }
	              var WEB_WORKER = !WINDOW && (typeof self === "undefined" ? "undefined" : _typeof(self)) === "object";
	              if (WEB_WORKER) {
	                root = self;
	              }
	              var COMMON_JS = !root.JS_MD5_NO_COMMON_JS && (_typeof(module3)) === "object" && module3.exports;
	              var AMD = __webpack_require__(
	                /*! !webpack amd options */
	                "./node_modules/webpack/buildin/amd-options.js"
	              );
	              var ARRAY_BUFFER = !root.JS_MD5_NO_ARRAY_BUFFER && typeof ArrayBuffer !== "undefined";
	              var HEX_CHARS = "0123456789abcdef".split("");
	              var EXTRA = [128, 32768, 8388608, -2147483648];
	              var SHIFT = [0, 8, 16, 24];
	              var OUTPUT_TYPES = ["hex", "array", "digest", "buffer", "arrayBuffer", "base64"];
	              var BASE64_ENCODE_CHAR = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
	              var blocks = [], buffer8;
	              if (ARRAY_BUFFER) {
	                var buffer = new ArrayBuffer(68);
	                buffer8 = new Uint8Array(buffer);
	                blocks = new Uint32Array(buffer);
	              }
	              if (root.JS_MD5_NO_NODE_JS || !Array.isArray) {
	                Array.isArray = function(obj) {
	                  return Object.prototype.toString.call(obj) === "[object Array]";
	                };
	              }
	              if (ARRAY_BUFFER && (root.JS_MD5_NO_ARRAY_BUFFER_IS_VIEW || !ArrayBuffer.isView)) {
	                ArrayBuffer.isView = function(obj) {
	                  return _typeof(obj) === "object" && obj.buffer && obj.buffer.constructor === ArrayBuffer;
	                };
	              }
	              var createOutputMethod = function createOutputMethod2(outputType) {
	                return function(message, isBinStr) {
	                  return new Md5(true).update(message, isBinStr)[outputType]();
	                };
	              };
	              var createMethod = function createMethod2() {
	                var method = createOutputMethod("hex");
	                method.getCtx = method.create = function() {
	                  return new Md5();
	                };
	                method.update = function(message) {
	                  return method.create().update(message);
	                };
	                for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
	                  var type = OUTPUT_TYPES[i];
	                  method[type] = createOutputMethod(type);
	                }
	                return method;
	              };
	              function Md5(sharedMemory) {
	                if (sharedMemory) {
	                  blocks[0] = blocks[16] = blocks[1] = blocks[2] = blocks[3] = blocks[4] = blocks[5] = blocks[6] = blocks[7] = blocks[8] = blocks[9] = blocks[10] = blocks[11] = blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
	                  this.blocks = blocks;
	                  this.buffer8 = buffer8;
	                } else {
	                  if (ARRAY_BUFFER) {
	                    var buffer2 = new ArrayBuffer(68);
	                    this.buffer8 = new Uint8Array(buffer2);
	                    this.blocks = new Uint32Array(buffer2);
	                  } else {
	                    this.blocks = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
	                  }
	                }
	                this.h0 = this.h1 = this.h2 = this.h3 = this.start = this.bytes = this.hBytes = 0;
	                this.finalized = this.hashed = false;
	                this.first = true;
	              }
	              Md5.prototype.update = function(message, isBinStr) {
	                if (this.finalized) {
	                  return;
	                }
	                var code, index = 0, i, length = message.length, blocks2 = this.blocks;
	                var buffer82 = this.buffer8;
	                while (index < length) {
	                  if (this.hashed) {
	                    this.hashed = false;
	                    blocks2[0] = blocks2[16];
	                    blocks2[16] = blocks2[1] = blocks2[2] = blocks2[3] = blocks2[4] = blocks2[5] = blocks2[6] = blocks2[7] = blocks2[8] = blocks2[9] = blocks2[10] = blocks2[11] = blocks2[12] = blocks2[13] = blocks2[14] = blocks2[15] = 0;
	                  }
	                  if (ARRAY_BUFFER) {
	                    for (i = this.start; index < length && i < 64; ++index) {
	                      code = message.charCodeAt(index);
	                      if (isBinStr || code < 128) {
	                        buffer82[i++] = code;
	                      } else if (code < 2048) {
	                        buffer82[i++] = 192 | code >> 6;
	                        buffer82[i++] = 128 | code & 63;
	                      } else if (code < 55296 || code >= 57344) {
	                        buffer82[i++] = 224 | code >> 12;
	                        buffer82[i++] = 128 | code >> 6 & 63;
	                        buffer82[i++] = 128 | code & 63;
	                      } else {
	                        code = 65536 + ((code & 1023) << 10 | message.charCodeAt(++index) & 1023);
	                        buffer82[i++] = 240 | code >> 18;
	                        buffer82[i++] = 128 | code >> 12 & 63;
	                        buffer82[i++] = 128 | code >> 6 & 63;
	                        buffer82[i++] = 128 | code & 63;
	                      }
	                    }
	                  } else {
	                    for (i = this.start; index < length && i < 64; ++index) {
	                      code = message.charCodeAt(index);
	                      if (isBinStr || code < 128) {
	                        blocks2[i >> 2] |= code << SHIFT[i++ & 3];
	                      } else if (code < 2048) {
	                        blocks2[i >> 2] |= (192 | code >> 6) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code & 63) << SHIFT[i++ & 3];
	                      } else if (code < 55296 || code >= 57344) {
	                        blocks2[i >> 2] |= (224 | code >> 12) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code >> 6 & 63) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code & 63) << SHIFT[i++ & 3];
	                      } else {
	                        code = 65536 + ((code & 1023) << 10 | message.charCodeAt(++index) & 1023);
	                        blocks2[i >> 2] |= (240 | code >> 18) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code >> 12 & 63) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code >> 6 & 63) << SHIFT[i++ & 3];
	                        blocks2[i >> 2] |= (128 | code & 63) << SHIFT[i++ & 3];
	                      }
	                    }
	                  }
	                  this.lastByteIndex = i;
	                  this.bytes += i - this.start;
	                  if (i >= 64) {
	                    this.start = i - 64;
	                    this.hash();
	                    this.hashed = true;
	                  } else {
	                    this.start = i;
	                  }
	                }
	                if (this.bytes > 4294967295) {
	                  this.hBytes += this.bytes / 4294967296 << 0;
	                  this.bytes = this.bytes % 4294967296;
	                }
	                return this;
	              };
	              Md5.prototype.finalize = function() {
	                if (this.finalized) {
	                  return;
	                }
	                this.finalized = true;
	                var blocks2 = this.blocks, i = this.lastByteIndex;
	                blocks2[i >> 2] |= EXTRA[i & 3];
	                if (i >= 56) {
	                  if (!this.hashed) {
	                    this.hash();
	                  }
	                  blocks2[0] = blocks2[16];
	                  blocks2[16] = blocks2[1] = blocks2[2] = blocks2[3] = blocks2[4] = blocks2[5] = blocks2[6] = blocks2[7] = blocks2[8] = blocks2[9] = blocks2[10] = blocks2[11] = blocks2[12] = blocks2[13] = blocks2[14] = blocks2[15] = 0;
	                }
	                blocks2[14] = this.bytes << 3;
	                blocks2[15] = this.hBytes << 3 | this.bytes >>> 29;
	                this.hash();
	              };
	              Md5.prototype.hash = function() {
	                var a, b, c, d, bc, da, blocks2 = this.blocks;
	                if (this.first) {
	                  a = blocks2[0] - 680876937;
	                  a = (a << 7 | a >>> 25) - 271733879 << 0;
	                  d = (-1732584194 ^ a & 2004318071) + blocks2[1] - 117830708;
	                  d = (d << 12 | d >>> 20) + a << 0;
	                  c = (-271733879 ^ d & (a ^ -271733879)) + blocks2[2] - 1126478375;
	                  c = (c << 17 | c >>> 15) + d << 0;
	                  b = (a ^ c & (d ^ a)) + blocks2[3] - 1316259209;
	                  b = (b << 22 | b >>> 10) + c << 0;
	                } else {
	                  a = this.h0;
	                  b = this.h1;
	                  c = this.h2;
	                  d = this.h3;
	                  a += (d ^ b & (c ^ d)) + blocks2[0] - 680876936;
	                  a = (a << 7 | a >>> 25) + b << 0;
	                  d += (c ^ a & (b ^ c)) + blocks2[1] - 389564586;
	                  d = (d << 12 | d >>> 20) + a << 0;
	                  c += (b ^ d & (a ^ b)) + blocks2[2] + 606105819;
	                  c = (c << 17 | c >>> 15) + d << 0;
	                  b += (a ^ c & (d ^ a)) + blocks2[3] - 1044525330;
	                  b = (b << 22 | b >>> 10) + c << 0;
	                }
	                a += (d ^ b & (c ^ d)) + blocks2[4] - 176418897;
	                a = (a << 7 | a >>> 25) + b << 0;
	                d += (c ^ a & (b ^ c)) + blocks2[5] + 1200080426;
	                d = (d << 12 | d >>> 20) + a << 0;
	                c += (b ^ d & (a ^ b)) + blocks2[6] - 1473231341;
	                c = (c << 17 | c >>> 15) + d << 0;
	                b += (a ^ c & (d ^ a)) + blocks2[7] - 45705983;
	                b = (b << 22 | b >>> 10) + c << 0;
	                a += (d ^ b & (c ^ d)) + blocks2[8] + 1770035416;
	                a = (a << 7 | a >>> 25) + b << 0;
	                d += (c ^ a & (b ^ c)) + blocks2[9] - 1958414417;
	                d = (d << 12 | d >>> 20) + a << 0;
	                c += (b ^ d & (a ^ b)) + blocks2[10] - 42063;
	                c = (c << 17 | c >>> 15) + d << 0;
	                b += (a ^ c & (d ^ a)) + blocks2[11] - 1990404162;
	                b = (b << 22 | b >>> 10) + c << 0;
	                a += (d ^ b & (c ^ d)) + blocks2[12] + 1804603682;
	                a = (a << 7 | a >>> 25) + b << 0;
	                d += (c ^ a & (b ^ c)) + blocks2[13] - 40341101;
	                d = (d << 12 | d >>> 20) + a << 0;
	                c += (b ^ d & (a ^ b)) + blocks2[14] - 1502002290;
	                c = (c << 17 | c >>> 15) + d << 0;
	                b += (a ^ c & (d ^ a)) + blocks2[15] + 1236535329;
	                b = (b << 22 | b >>> 10) + c << 0;
	                a += (c ^ d & (b ^ c)) + blocks2[1] - 165796510;
	                a = (a << 5 | a >>> 27) + b << 0;
	                d += (b ^ c & (a ^ b)) + blocks2[6] - 1069501632;
	                d = (d << 9 | d >>> 23) + a << 0;
	                c += (a ^ b & (d ^ a)) + blocks2[11] + 643717713;
	                c = (c << 14 | c >>> 18) + d << 0;
	                b += (d ^ a & (c ^ d)) + blocks2[0] - 373897302;
	                b = (b << 20 | b >>> 12) + c << 0;
	                a += (c ^ d & (b ^ c)) + blocks2[5] - 701558691;
	                a = (a << 5 | a >>> 27) + b << 0;
	                d += (b ^ c & (a ^ b)) + blocks2[10] + 38016083;
	                d = (d << 9 | d >>> 23) + a << 0;
	                c += (a ^ b & (d ^ a)) + blocks2[15] - 660478335;
	                c = (c << 14 | c >>> 18) + d << 0;
	                b += (d ^ a & (c ^ d)) + blocks2[4] - 405537848;
	                b = (b << 20 | b >>> 12) + c << 0;
	                a += (c ^ d & (b ^ c)) + blocks2[9] + 568446438;
	                a = (a << 5 | a >>> 27) + b << 0;
	                d += (b ^ c & (a ^ b)) + blocks2[14] - 1019803690;
	                d = (d << 9 | d >>> 23) + a << 0;
	                c += (a ^ b & (d ^ a)) + blocks2[3] - 187363961;
	                c = (c << 14 | c >>> 18) + d << 0;
	                b += (d ^ a & (c ^ d)) + blocks2[8] + 1163531501;
	                b = (b << 20 | b >>> 12) + c << 0;
	                a += (c ^ d & (b ^ c)) + blocks2[13] - 1444681467;
	                a = (a << 5 | a >>> 27) + b << 0;
	                d += (b ^ c & (a ^ b)) + blocks2[2] - 51403784;
	                d = (d << 9 | d >>> 23) + a << 0;
	                c += (a ^ b & (d ^ a)) + blocks2[7] + 1735328473;
	                c = (c << 14 | c >>> 18) + d << 0;
	                b += (d ^ a & (c ^ d)) + blocks2[12] - 1926607734;
	                b = (b << 20 | b >>> 12) + c << 0;
	                bc = b ^ c;
	                a += (bc ^ d) + blocks2[5] - 378558;
	                a = (a << 4 | a >>> 28) + b << 0;
	                d += (bc ^ a) + blocks2[8] - 2022574463;
	                d = (d << 11 | d >>> 21) + a << 0;
	                da = d ^ a;
	                c += (da ^ b) + blocks2[11] + 1839030562;
	                c = (c << 16 | c >>> 16) + d << 0;
	                b += (da ^ c) + blocks2[14] - 35309556;
	                b = (b << 23 | b >>> 9) + c << 0;
	                bc = b ^ c;
	                a += (bc ^ d) + blocks2[1] - 1530992060;
	                a = (a << 4 | a >>> 28) + b << 0;
	                d += (bc ^ a) + blocks2[4] + 1272893353;
	                d = (d << 11 | d >>> 21) + a << 0;
	                da = d ^ a;
	                c += (da ^ b) + blocks2[7] - 155497632;
	                c = (c << 16 | c >>> 16) + d << 0;
	                b += (da ^ c) + blocks2[10] - 1094730640;
	                b = (b << 23 | b >>> 9) + c << 0;
	                bc = b ^ c;
	                a += (bc ^ d) + blocks2[13] + 681279174;
	                a = (a << 4 | a >>> 28) + b << 0;
	                d += (bc ^ a) + blocks2[0] - 358537222;
	                d = (d << 11 | d >>> 21) + a << 0;
	                da = d ^ a;
	                c += (da ^ b) + blocks2[3] - 722521979;
	                c = (c << 16 | c >>> 16) + d << 0;
	                b += (da ^ c) + blocks2[6] + 76029189;
	                b = (b << 23 | b >>> 9) + c << 0;
	                bc = b ^ c;
	                a += (bc ^ d) + blocks2[9] - 640364487;
	                a = (a << 4 | a >>> 28) + b << 0;
	                d += (bc ^ a) + blocks2[12] - 421815835;
	                d = (d << 11 | d >>> 21) + a << 0;
	                da = d ^ a;
	                c += (da ^ b) + blocks2[15] + 530742520;
	                c = (c << 16 | c >>> 16) + d << 0;
	                b += (da ^ c) + blocks2[2] - 995338651;
	                b = (b << 23 | b >>> 9) + c << 0;
	                a += (c ^ (b | ~d)) + blocks2[0] - 198630844;
	                a = (a << 6 | a >>> 26) + b << 0;
	                d += (b ^ (a | ~c)) + blocks2[7] + 1126891415;
	                d = (d << 10 | d >>> 22) + a << 0;
	                c += (a ^ (d | ~b)) + blocks2[14] - 1416354905;
	                c = (c << 15 | c >>> 17) + d << 0;
	                b += (d ^ (c | ~a)) + blocks2[5] - 57434055;
	                b = (b << 21 | b >>> 11) + c << 0;
	                a += (c ^ (b | ~d)) + blocks2[12] + 1700485571;
	                a = (a << 6 | a >>> 26) + b << 0;
	                d += (b ^ (a | ~c)) + blocks2[3] - 1894986606;
	                d = (d << 10 | d >>> 22) + a << 0;
	                c += (a ^ (d | ~b)) + blocks2[10] - 1051523;
	                c = (c << 15 | c >>> 17) + d << 0;
	                b += (d ^ (c | ~a)) + blocks2[1] - 2054922799;
	                b = (b << 21 | b >>> 11) + c << 0;
	                a += (c ^ (b | ~d)) + blocks2[8] + 1873313359;
	                a = (a << 6 | a >>> 26) + b << 0;
	                d += (b ^ (a | ~c)) + blocks2[15] - 30611744;
	                d = (d << 10 | d >>> 22) + a << 0;
	                c += (a ^ (d | ~b)) + blocks2[6] - 1560198380;
	                c = (c << 15 | c >>> 17) + d << 0;
	                b += (d ^ (c | ~a)) + blocks2[13] + 1309151649;
	                b = (b << 21 | b >>> 11) + c << 0;
	                a += (c ^ (b | ~d)) + blocks2[4] - 145523070;
	                a = (a << 6 | a >>> 26) + b << 0;
	                d += (b ^ (a | ~c)) + blocks2[11] - 1120210379;
	                d = (d << 10 | d >>> 22) + a << 0;
	                c += (a ^ (d | ~b)) + blocks2[2] + 718787259;
	                c = (c << 15 | c >>> 17) + d << 0;
	                b += (d ^ (c | ~a)) + blocks2[9] - 343485551;
	                b = (b << 21 | b >>> 11) + c << 0;
	                if (this.first) {
	                  this.h0 = a + 1732584193 << 0;
	                  this.h1 = b - 271733879 << 0;
	                  this.h2 = c - 1732584194 << 0;
	                  this.h3 = d + 271733878 << 0;
	                  this.first = false;
	                } else {
	                  this.h0 = this.h0 + a << 0;
	                  this.h1 = this.h1 + b << 0;
	                  this.h2 = this.h2 + c << 0;
	                  this.h3 = this.h3 + d << 0;
	                }
	              };
	              Md5.prototype.hex = function() {
	                this.finalize();
	                var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3;
	                return HEX_CHARS[h0 >> 4 & 15] + HEX_CHARS[h0 & 15] + HEX_CHARS[h0 >> 12 & 15] + HEX_CHARS[h0 >> 8 & 15] + HEX_CHARS[h0 >> 20 & 15] + HEX_CHARS[h0 >> 16 & 15] + HEX_CHARS[h0 >> 28 & 15] + HEX_CHARS[h0 >> 24 & 15] + HEX_CHARS[h1 >> 4 & 15] + HEX_CHARS[h1 & 15] + HEX_CHARS[h1 >> 12 & 15] + HEX_CHARS[h1 >> 8 & 15] + HEX_CHARS[h1 >> 20 & 15] + HEX_CHARS[h1 >> 16 & 15] + HEX_CHARS[h1 >> 28 & 15] + HEX_CHARS[h1 >> 24 & 15] + HEX_CHARS[h2 >> 4 & 15] + HEX_CHARS[h2 & 15] + HEX_CHARS[h2 >> 12 & 15] + HEX_CHARS[h2 >> 8 & 15] + HEX_CHARS[h2 >> 20 & 15] + HEX_CHARS[h2 >> 16 & 15] + HEX_CHARS[h2 >> 28 & 15] + HEX_CHARS[h2 >> 24 & 15] + HEX_CHARS[h3 >> 4 & 15] + HEX_CHARS[h3 & 15] + HEX_CHARS[h3 >> 12 & 15] + HEX_CHARS[h3 >> 8 & 15] + HEX_CHARS[h3 >> 20 & 15] + HEX_CHARS[h3 >> 16 & 15] + HEX_CHARS[h3 >> 28 & 15] + HEX_CHARS[h3 >> 24 & 15];
	              };
	              Md5.prototype.toString = Md5.prototype.hex;
	              Md5.prototype.digest = function(format) {
	                if (format === "hex") return this.hex();
	                this.finalize();
	                var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3;
	                var res = [h0 & 255, h0 >> 8 & 255, h0 >> 16 & 255, h0 >> 24 & 255, h1 & 255, h1 >> 8 & 255, h1 >> 16 & 255, h1 >> 24 & 255, h2 & 255, h2 >> 8 & 255, h2 >> 16 & 255, h2 >> 24 & 255, h3 & 255, h3 >> 8 & 255, h3 >> 16 & 255, h3 >> 24 & 255];
	                return res;
	              };
	              Md5.prototype.array = Md5.prototype.digest;
	              Md5.prototype.arrayBuffer = function() {
	                this.finalize();
	                var buffer2 = new ArrayBuffer(16);
	                var blocks2 = new Uint32Array(buffer2);
	                blocks2[0] = this.h0;
	                blocks2[1] = this.h1;
	                blocks2[2] = this.h2;
	                blocks2[3] = this.h3;
	                return buffer2;
	              };
	              Md5.prototype.buffer = Md5.prototype.arrayBuffer;
	              Md5.prototype.base64 = function() {
	                var v1, v2, v3, base64Str = "", bytes = this.array();
	                for (var i = 0; i < 15; ) {
	                  v1 = bytes[i++];
	                  v2 = bytes[i++];
	                  v3 = bytes[i++];
	                  base64Str += BASE64_ENCODE_CHAR[v1 >>> 2] + BASE64_ENCODE_CHAR[(v1 << 4 | v2 >>> 4) & 63] + BASE64_ENCODE_CHAR[(v2 << 2 | v3 >>> 6) & 63] + BASE64_ENCODE_CHAR[v3 & 63];
	                }
	                v1 = bytes[i];
	                base64Str += BASE64_ENCODE_CHAR[v1 >>> 2] + BASE64_ENCODE_CHAR[v1 << 4 & 63] + "==";
	                return base64Str;
	              };
	              var exports3 = createMethod();
	              if (COMMON_JS) {
	                module3.exports = exports3;
	              } else {
	                root.md5 = exports3;
	                if (AMD) {
	                  !(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
	                    return exports3;
	                  }.call(exports3, __webpack_require__, exports3, module3), __WEBPACK_AMD_DEFINE_RESULT__ !== void 0 && (module3.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	                }
	              }
	            })();
	          }).call(this, __webpack_require__(
	            /*! ./../node_modules/webpack/buildin/module.js */
	            "./node_modules/webpack/buildin/module.js"
	          )(module2));
	        }
	      ),
	      /***/
	      "./lib/request.js": (
	        /*!************************!*\
	          !*** ./lib/request.js ***!
	          \************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! @babel/runtime/helpers/typeof */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          );
	          var stringifyPrimitive = function stringifyPrimitive2(v) {
	            switch (_typeof(v)) {
	              case "string":
	                return v;
	              case "boolean":
	                return v ? "true" : "false";
	              case "number":
	                return isFinite(v) ? v : "";
	              default:
	                return "";
	            }
	          };
	          var queryStringify = function queryStringify2(obj, sep, eq, name) {
	            sep = sep || "&";
	            eq = eq || "=";
	            if (obj === null) {
	              obj = void 0;
	            }
	            if (_typeof(obj) === "object") {
	              return Object.keys(obj).map(function(k) {
	                var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
	                if (Array.isArray(obj[k])) {
	                  return obj[k].map(function(v) {
	                    return ks + encodeURIComponent(stringifyPrimitive(v));
	                  }).join(sep);
	                } else {
	                  return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
	                }
	              }).filter(Boolean).join(sep);
	            }
	            return "";
	          };
	          var xhrRes = function xhrRes2(err, xhr, body) {
	            var headers = {};
	            var strHeaders = xhr.getAllResponseHeaders();
	            if (strHeaders && strHeaders.length > 0) {
	              strHeaders.trim().split("\n").forEach(function(item) {
	                if (item) {
	                  var index = item.indexOf(":");
	                  var key = item.substr(0, index).trim().toLowerCase();
	                  var val = item.substr(index + 1).trim();
	                  headers[key] = val;
	                }
	              });
	            }
	            return {
	              error: err,
	              statusCode: xhr.status,
	              statusMessage: xhr.statusText,
	              headers,
	              body
	            };
	          };
	          var xhrBody = function xhrBody2(xhr, dataType) {
	            return !dataType && dataType === "text" ? xhr.responseText : xhr.response;
	          };
	          var request = function request2(opt, callback) {
	            var method = (opt.method || "GET").toUpperCase();
	            var url = opt.url;
	            if (opt.qs) {
	              var qsStr = queryStringify(opt.qs);
	              if (qsStr) {
	                url += (url.indexOf("?") === -1 ? "?" : "&") + qsStr;
	              }
	            }
	            var xhr = new XMLHttpRequest();
	            xhr.open(method, url, true);
	            xhr.responseType = opt.dataType || "text";
	            if (opt.xhrFields) {
	              for (var xhrField in opt.xhrFields) {
	                xhr[xhrField] = opt.xhrFields[xhrField];
	              }
	            }
	            var headers = opt.headers;
	            if (headers) {
	              for (var key in headers) {
	                if (headers.hasOwnProperty(key) && key.toLowerCase() !== "content-length" && key.toLowerCase() !== "user-agent" && key.toLowerCase() !== "origin" && key.toLowerCase() !== "host") {
	                  xhr.setRequestHeader(key, headers[key]);
	                }
	              }
	            }
	            if (opt.onProgress && xhr.upload) xhr.upload.onprogress = opt.onProgress;
	            if (opt.onDownloadProgress) xhr.onprogress = opt.onDownloadProgress;
	            if (opt.timeout) xhr.timeout = opt.timeout;
	            xhr.ontimeout = function(event) {
	              var error = new Error("timeout");
	              callback(xhrRes(error, xhr));
	            };
	            xhr.onload = function() {
	              callback(xhrRes(null, xhr, xhrBody(xhr, opt.dataType)));
	            };
	            xhr.onerror = function(err) {
	              var body = xhrBody(xhr, opt.dataType);
	              if (body) {
	                callback(xhrRes(null, xhr, body));
	              } else {
	                var error = xhr.statusText;
	                if (!error && xhr.status === 0) error = new Error("CORS blocked or network error");
	                callback(xhrRes(error, xhr, body));
	              }
	            };
	            xhr.send(opt.body || "");
	            return xhr;
	          };
	          module2.exports = request;
	        }
	      ),
	      /***/
	      "./lib/xml2json.js": (
	        /*!*************************!*\
	          !*** ./lib/xml2json.js ***!
	          \*************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var DOMParser = __webpack_require__(
	            /*! @xmldom/xmldom */
	            "./node_modules/@xmldom/xmldom/lib/index.js"
	          ).DOMParser;
	          var xmlToJSON = function() {
	            this.version = "1.3.5";
	            var options = {
	              // set up the default options
	              mergeCDATA: true,
	              // extract cdata and merge with text
	              normalize: true,
	              // collapse multiple spaces to single space
	              stripElemPrefix: true
	              // for elements of same name in diff namespaces, you can enable namespaces and access the nskey property
	            };
	            var prefixMatch = new RegExp(/(?!xmlns)^.*:/);
	            this.grokType = function(sValue) {
	              if (/^\s*$/.test(sValue)) {
	                return null;
	              }
	              if (/^(?:true|false)$/i.test(sValue)) {
	                return sValue.toLowerCase() === "true";
	              }
	              if (isFinite(sValue)) {
	                return parseFloat(sValue);
	              }
	              return sValue;
	            };
	            this.parseString = function(xmlString, opt) {
	              if (xmlString) {
	                var xml = this.stringToXML(xmlString);
	                if (xml.getElementsByTagName("parsererror").length) {
	                  return null;
	                } else {
	                  return this.parseXML(xml, opt);
	                }
	              } else {
	                return null;
	              }
	            };
	            this.parseXML = function(oXMLParent, opt) {
	              for (var key in opt) {
	                options[key] = opt[key];
	              }
	              var vResult = {}, nLength = 0, sCollectedTxt = "";
	              var childNum = oXMLParent.childNodes.length;
	              if (childNum) {
	                for (var oNode, sProp, vContent, nItem = 0; nItem < oXMLParent.childNodes.length; nItem++) {
	                  oNode = oXMLParent.childNodes.item(nItem);
	                  if (oNode.nodeType === 4) {
	                    if (options.mergeCDATA) {
	                      sCollectedTxt += oNode.nodeValue;
	                    }
	                  } else if (oNode.nodeType === 3) {
	                    sCollectedTxt += oNode.nodeValue;
	                  } else if (oNode.nodeType === 1) {
	                    if (nLength === 0) {
	                      vResult = {};
	                    }
	                    if (options.stripElemPrefix) {
	                      sProp = oNode.nodeName.replace(prefixMatch, "");
	                    } else {
	                      sProp = oNode.nodeName;
	                    }
	                    vContent = xmlToJSON.parseXML(oNode);
	                    if (vResult.hasOwnProperty(sProp)) {
	                      if (vResult[sProp].constructor !== Array) {
	                        vResult[sProp] = [vResult[sProp]];
	                      }
	                      vResult[sProp].push(vContent);
	                    } else {
	                      vResult[sProp] = vContent;
	                      nLength++;
	                    }
	                  }
	                }
	              }
	              if (!Object.keys(vResult).length) {
	                vResult = sCollectedTxt || "";
	              }
	              return vResult;
	            };
	            this.xmlToString = function(xmlDoc) {
	              try {
	                var xmlString = xmlDoc.xml ? xmlDoc.xml : new XMLSerializer().serializeToString(xmlDoc);
	                return xmlString;
	              } catch (err) {
	                return null;
	              }
	            };
	            this.stringToXML = function(xmlString) {
	              try {
	                var xmlDoc = null;
	                if (window.DOMParser) {
	                  var parser = new DOMParser();
	                  xmlDoc = parser.parseFromString(xmlString, "text/xml");
	                  return xmlDoc;
	                } else {
	                  xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	                  xmlDoc.async = false;
	                  xmlDoc.loadXML(xmlString);
	                  return xmlDoc;
	                }
	              } catch (e) {
	                return null;
	              }
	            };
	            return this;
	          }.call({});
	          var xml2json = function xml2json2(xmlString) {
	            return xmlToJSON.parseString(xmlString);
	          };
	          module2.exports = xml2json;
	        }
	      ),
	      /***/
	      "./node_modules/@babel/runtime/helpers/classCallCheck.js": (
	        /*!***************************************************************!*\
	          !*** ./node_modules/@babel/runtime/helpers/classCallCheck.js ***!
	          \***************************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          function _classCallCheck(instance, Constructor) {
	            if (!(instance instanceof Constructor)) {
	              throw new TypeError("Cannot call a class as a function");
	            }
	          }
	          module2.exports = _classCallCheck, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
	        }
	      ),
	      /***/
	      "./node_modules/@babel/runtime/helpers/createClass.js": (
	        /*!************************************************************!*\
	          !*** ./node_modules/@babel/runtime/helpers/createClass.js ***!
	          \************************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var toPropertyKey = __webpack_require__(
	            /*! ./toPropertyKey.js */
	            "./node_modules/@babel/runtime/helpers/toPropertyKey.js"
	          );
	          function _defineProperties(target, props) {
	            for (var i = 0; i < props.length; i++) {
	              var descriptor = props[i];
	              descriptor.enumerable = descriptor.enumerable || false;
	              descriptor.configurable = true;
	              if ("value" in descriptor) descriptor.writable = true;
	              Object.defineProperty(target, toPropertyKey(descriptor.key), descriptor);
	            }
	          }
	          function _createClass(Constructor, protoProps, staticProps) {
	            if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	            if (staticProps) _defineProperties(Constructor, staticProps);
	            Object.defineProperty(Constructor, "prototype", {
	              writable: false
	            });
	            return Constructor;
	          }
	          module2.exports = _createClass, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
	        }
	      ),
	      /***/
	      "./node_modules/@babel/runtime/helpers/toPrimitive.js": (
	        /*!************************************************************!*\
	          !*** ./node_modules/@babel/runtime/helpers/toPrimitive.js ***!
	          \************************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! ./typeof.js */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          )["default"];
	          function _toPrimitive(input, hint) {
	            if (_typeof(input) !== "object" || input === null) return input;
	            var prim = input[Symbol.toPrimitive];
	            if (prim !== void 0) {
	              var res = prim.call(input, hint || "default");
	              if (_typeof(res) !== "object") return res;
	              throw new TypeError("@@toPrimitive must return a primitive value.");
	            }
	            return (hint === "string" ? String : Number)(input);
	          }
	          module2.exports = _toPrimitive, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
	        }
	      ),
	      /***/
	      "./node_modules/@babel/runtime/helpers/toPropertyKey.js": (
	        /*!**************************************************************!*\
	          !*** ./node_modules/@babel/runtime/helpers/toPropertyKey.js ***!
	          \**************************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! ./typeof.js */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          )["default"];
	          var toPrimitive = __webpack_require__(
	            /*! ./toPrimitive.js */
	            "./node_modules/@babel/runtime/helpers/toPrimitive.js"
	          );
	          function _toPropertyKey(arg) {
	            var key = toPrimitive(arg, "string");
	            return _typeof(key) === "symbol" ? key : String(key);
	          }
	          module2.exports = _toPropertyKey, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
	        }
	      ),
	      /***/
	      "./node_modules/@babel/runtime/helpers/typeof.js": (
	        /*!*******************************************************!*\
	          !*** ./node_modules/@babel/runtime/helpers/typeof.js ***!
	          \*******************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          function _typeof(o) {
	            "@babel/helpers - typeof";
	            return module2.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(o2) {
	              return typeof o2;
	            } : function(o2) {
	              return o2 && "function" == typeof Symbol && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
	            }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports, _typeof(o);
	          }
	          module2.exports = _typeof, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/conventions.js": (
	        /*!********************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/conventions.js ***!
	          \********************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          function find(list, predicate, ac) {
	            if (ac === void 0) {
	              ac = Array.prototype;
	            }
	            if (list && typeof ac.find === "function") {
	              return ac.find.call(list, predicate);
	            }
	            for (var i = 0; i < list.length; i++) {
	              if (Object.prototype.hasOwnProperty.call(list, i)) {
	                var item = list[i];
	                if (predicate.call(void 0, item, i, list)) {
	                  return item;
	                }
	              }
	            }
	          }
	          function freeze(object, oc) {
	            if (oc === void 0) {
	              oc = Object;
	            }
	            return oc && typeof oc.freeze === "function" ? oc.freeze(object) : object;
	          }
	          function assign(target, source) {
	            if (target === null || typeof target !== "object") {
	              throw new TypeError("target is not an object");
	            }
	            for (var key in source) {
	              if (Object.prototype.hasOwnProperty.call(source, key)) {
	                target[key] = source[key];
	              }
	            }
	            return target;
	          }
	          var MIME_TYPE = freeze({
	            /**
	             * `text/html`, the only mime type that triggers treating an XML document as HTML.
	             *
	             * @see DOMParser.SupportedType.isHTML
	             * @see https://www.iana.org/assignments/media-types/text/html IANA MimeType registration
	             * @see https://en.wikipedia.org/wiki/HTML Wikipedia
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMParser/parseFromString MDN
	             * @see https://html.spec.whatwg.org/multipage/dynamic-markup-insertion.html#dom-domparser-parsefromstring WHATWG HTML Spec
	             */
	            HTML: "text/html",
	            /**
	             * Helper method to check a mime type if it indicates an HTML document
	             *
	             * @param {string} [value]
	             * @returns {boolean}
	             *
	             * @see https://www.iana.org/assignments/media-types/text/html IANA MimeType registration
	             * @see https://en.wikipedia.org/wiki/HTML Wikipedia
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMParser/parseFromString MDN
	             * @see https://html.spec.whatwg.org/multipage/dynamic-markup-insertion.html#dom-domparser-parsefromstring 	 */
	            isHTML: function(value) {
	              return value === MIME_TYPE.HTML;
	            },
	            /**
	             * `application/xml`, the standard mime type for XML documents.
	             *
	             * @see https://www.iana.org/assignments/media-types/application/xml IANA MimeType registration
	             * @see https://tools.ietf.org/html/rfc7303#section-9.1 RFC 7303
	             * @see https://en.wikipedia.org/wiki/XML_and_MIME Wikipedia
	             */
	            XML_APPLICATION: "application/xml",
	            /**
	             * `text/html`, an alias for `application/xml`.
	             *
	             * @see https://tools.ietf.org/html/rfc7303#section-9.2 RFC 7303
	             * @see https://www.iana.org/assignments/media-types/text/xml IANA MimeType registration
	             * @see https://en.wikipedia.org/wiki/XML_and_MIME Wikipedia
	             */
	            XML_TEXT: "text/xml",
	            /**
	             * `application/xhtml+xml`, indicates an XML document that has the default HTML namespace,
	             * but is parsed as an XML document.
	             *
	             * @see https://www.iana.org/assignments/media-types/application/xhtml+xml IANA MimeType registration
	             * @see https://dom.spec.whatwg.org/#dom-domimplementation-createdocument WHATWG DOM Spec
	             * @see https://en.wikipedia.org/wiki/XHTML Wikipedia
	             */
	            XML_XHTML_APPLICATION: "application/xhtml+xml",
	            /**
	             * `image/svg+xml`,
	             *
	             * @see https://www.iana.org/assignments/media-types/image/svg+xml IANA MimeType registration
	             * @see https://www.w3.org/TR/SVG11/ W3C SVG 1.1
	             * @see https://en.wikipedia.org/wiki/Scalable_Vector_Graphics Wikipedia
	             */
	            XML_SVG_IMAGE: "image/svg+xml"
	          });
	          var NAMESPACE = freeze({
	            /**
	             * The XHTML namespace.
	             *
	             * @see http://www.w3.org/1999/xhtml
	             */
	            HTML: "http://www.w3.org/1999/xhtml",
	            /**
	             * Checks if `uri` equals `NAMESPACE.HTML`.
	             *
	             * @param {string} [uri]
	             *
	             * @see NAMESPACE.HTML
	             */
	            isHTML: function(uri) {
	              return uri === NAMESPACE.HTML;
	            },
	            /**
	             * The SVG namespace.
	             *
	             * @see http://www.w3.org/2000/svg
	             */
	            SVG: "http://www.w3.org/2000/svg",
	            /**
	             * The `xml:` namespace.
	             *
	             * @see http://www.w3.org/XML/1998/namespace
	             */
	            XML: "http://www.w3.org/XML/1998/namespace",
	            /**
	             * The `xmlns:` namespace
	             *
	             * @see https://www.w3.org/2000/xmlns/
	             */
	            XMLNS: "http://www.w3.org/2000/xmlns/"
	          });
	          exports2.assign = assign;
	          exports2.find = find;
	          exports2.freeze = freeze;
	          exports2.MIME_TYPE = MIME_TYPE;
	          exports2.NAMESPACE = NAMESPACE;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/dom-parser.js": (
	        /*!*******************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/dom-parser.js ***!
	          \*******************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var conventions = __webpack_require__(
	            /*! ./conventions */
	            "./node_modules/@xmldom/xmldom/lib/conventions.js"
	          );
	          var dom = __webpack_require__(
	            /*! ./dom */
	            "./node_modules/@xmldom/xmldom/lib/dom.js"
	          );
	          var entities = __webpack_require__(
	            /*! ./entities */
	            "./node_modules/@xmldom/xmldom/lib/entities.js"
	          );
	          var sax = __webpack_require__(
	            /*! ./sax */
	            "./node_modules/@xmldom/xmldom/lib/sax.js"
	          );
	          var DOMImplementation = dom.DOMImplementation;
	          var NAMESPACE = conventions.NAMESPACE;
	          var ParseError = sax.ParseError;
	          var XMLReader = sax.XMLReader;
	          function normalizeLineEndings(input) {
	            return input.replace(/\r[\n\u0085]/g, "\n").replace(/[\r\u0085\u2028]/g, "\n");
	          }
	          function DOMParser(options) {
	            this.options = options || { locator: {} };
	          }
	          DOMParser.prototype.parseFromString = function(source, mimeType) {
	            var options = this.options;
	            var sax2 = new XMLReader();
	            var domBuilder = options.domBuilder || new DOMHandler();
	            var errorHandler = options.errorHandler;
	            var locator = options.locator;
	            var defaultNSMap = options.xmlns || {};
	            var isHTML = /\/x?html?$/.test(mimeType);
	            var entityMap = isHTML ? entities.HTML_ENTITIES : entities.XML_ENTITIES;
	            if (locator) {
	              domBuilder.setDocumentLocator(locator);
	            }
	            sax2.errorHandler = buildErrorHandler(errorHandler, domBuilder, locator);
	            sax2.domBuilder = options.domBuilder || domBuilder;
	            if (isHTML) {
	              defaultNSMap[""] = NAMESPACE.HTML;
	            }
	            defaultNSMap.xml = defaultNSMap.xml || NAMESPACE.XML;
	            var normalize = options.normalizeLineEndings || normalizeLineEndings;
	            if (source && typeof source === "string") {
	              sax2.parse(
	                normalize(source),
	                defaultNSMap,
	                entityMap
	              );
	            } else {
	              sax2.errorHandler.error("invalid doc source");
	            }
	            return domBuilder.doc;
	          };
	          function buildErrorHandler(errorImpl, domBuilder, locator) {
	            if (!errorImpl) {
	              if (domBuilder instanceof DOMHandler) {
	                return domBuilder;
	              }
	              errorImpl = domBuilder;
	            }
	            var errorHandler = {};
	            var isCallback = errorImpl instanceof Function;
	            locator = locator || {};
	            function build(key) {
	              var fn = errorImpl[key];
	              if (!fn && isCallback) {
	                fn = errorImpl.length == 2 ? function(msg) {
	                  errorImpl(key, msg);
	                } : errorImpl;
	              }
	              errorHandler[key] = fn && function(msg) {
	                fn("[xmldom " + key + "]	" + msg + _locator(locator));
	              } || function() {
	              };
	            }
	            build("warning");
	            build("error");
	            build("fatalError");
	            return errorHandler;
	          }
	          function DOMHandler() {
	            this.cdata = false;
	          }
	          function position(locator, node) {
	            node.lineNumber = locator.lineNumber;
	            node.columnNumber = locator.columnNumber;
	          }
	          DOMHandler.prototype = {
	            startDocument: function() {
	              this.doc = new DOMImplementation().createDocument(null, null, null);
	              if (this.locator) {
	                this.doc.documentURI = this.locator.systemId;
	              }
	            },
	            startElement: function(namespaceURI, localName, qName, attrs) {
	              var doc = this.doc;
	              var el = doc.createElementNS(namespaceURI, qName || localName);
	              var len = attrs.length;
	              appendElement(this, el);
	              this.currentElement = el;
	              this.locator && position(this.locator, el);
	              for (var i = 0; i < len; i++) {
	                var namespaceURI = attrs.getURI(i);
	                var value = attrs.getValue(i);
	                var qName = attrs.getQName(i);
	                var attr = doc.createAttributeNS(namespaceURI, qName);
	                this.locator && position(attrs.getLocator(i), attr);
	                attr.value = attr.nodeValue = value;
	                el.setAttributeNode(attr);
	              }
	            },
	            endElement: function(namespaceURI, localName, qName) {
	              var current = this.currentElement;
	              current.tagName;
	              this.currentElement = current.parentNode;
	            },
	            startPrefixMapping: function(prefix, uri) {
	            },
	            endPrefixMapping: function(prefix) {
	            },
	            processingInstruction: function(target, data) {
	              var ins = this.doc.createProcessingInstruction(target, data);
	              this.locator && position(this.locator, ins);
	              appendElement(this, ins);
	            },
	            ignorableWhitespace: function(ch, start, length) {
	            },
	            characters: function(chars, start, length) {
	              chars = _toString.apply(this, arguments);
	              if (chars) {
	                if (this.cdata) {
	                  var charNode = this.doc.createCDATASection(chars);
	                } else {
	                  var charNode = this.doc.createTextNode(chars);
	                }
	                if (this.currentElement) {
	                  this.currentElement.appendChild(charNode);
	                } else if (/^\s*$/.test(chars)) {
	                  this.doc.appendChild(charNode);
	                }
	                this.locator && position(this.locator, charNode);
	              }
	            },
	            skippedEntity: function(name) {
	            },
	            endDocument: function() {
	              this.doc.normalize();
	            },
	            setDocumentLocator: function(locator) {
	              if (this.locator = locator) {
	                locator.lineNumber = 0;
	              }
	            },
	            //LexicalHandler
	            comment: function(chars, start, length) {
	              chars = _toString.apply(this, arguments);
	              var comm = this.doc.createComment(chars);
	              this.locator && position(this.locator, comm);
	              appendElement(this, comm);
	            },
	            startCDATA: function() {
	              this.cdata = true;
	            },
	            endCDATA: function() {
	              this.cdata = false;
	            },
	            startDTD: function(name, publicId, systemId) {
	              var impl = this.doc.implementation;
	              if (impl && impl.createDocumentType) {
	                var dt = impl.createDocumentType(name, publicId, systemId);
	                this.locator && position(this.locator, dt);
	                appendElement(this, dt);
	                this.doc.doctype = dt;
	              }
	            },
	            /**
	             * @see org.xml.sax.ErrorHandler
	             * @link http://www.saxproject.org/apidoc/org/xml/sax/ErrorHandler.html
	             */
	            warning: function(error) {
	              console.warn("[xmldom warning]	" + error, _locator(this.locator));
	            },
	            error: function(error) {
	              console.error("[xmldom error]	" + error, _locator(this.locator));
	            },
	            fatalError: function(error) {
	              throw new ParseError(error, this.locator);
	            }
	          };
	          function _locator(l) {
	            if (l) {
	              return "\n@" + (l.systemId || "") + "#[line:" + l.lineNumber + ",col:" + l.columnNumber + "]";
	            }
	          }
	          function _toString(chars, start, length) {
	            if (typeof chars == "string") {
	              return chars.substr(start, length);
	            } else {
	              if (chars.length >= start + length || start) {
	                return new java.lang.String(chars, start, length) + "";
	              }
	              return chars;
	            }
	          }
	          "endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g, function(key) {
	            DOMHandler.prototype[key] = function() {
	              return null;
	            };
	          });
	          function appendElement(hander, node) {
	            if (!hander.currentElement) {
	              hander.doc.appendChild(node);
	            } else {
	              hander.currentElement.appendChild(node);
	            }
	          }
	          exports2.__DOMHandler = DOMHandler;
	          exports2.normalizeLineEndings = normalizeLineEndings;
	          exports2.DOMParser = DOMParser;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/dom.js": (
	        /*!************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/dom.js ***!
	          \************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var conventions = __webpack_require__(
	            /*! ./conventions */
	            "./node_modules/@xmldom/xmldom/lib/conventions.js"
	          );
	          var find = conventions.find;
	          var NAMESPACE = conventions.NAMESPACE;
	          function notEmptyString(input) {
	            return input !== "";
	          }
	          function splitOnASCIIWhitespace(input) {
	            return input ? input.split(/[\t\n\f\r ]+/).filter(notEmptyString) : [];
	          }
	          function orderedSetReducer(current, element) {
	            if (!current.hasOwnProperty(element)) {
	              current[element] = true;
	            }
	            return current;
	          }
	          function toOrderedSet(input) {
	            if (!input) return [];
	            var list = splitOnASCIIWhitespace(input);
	            return Object.keys(list.reduce(orderedSetReducer, {}));
	          }
	          function arrayIncludes(list) {
	            return function(element) {
	              return list && list.indexOf(element) !== -1;
	            };
	          }
	          function copy(src, dest) {
	            for (var p in src) {
	              if (Object.prototype.hasOwnProperty.call(src, p)) {
	                dest[p] = src[p];
	              }
	            }
	          }
	          function _extends(Class, Super) {
	            var pt = Class.prototype;
	            if (!(pt instanceof Super)) {
	              let t2 = function() {
	              };
	              t2.prototype = Super.prototype;
	              t2 = new t2();
	              copy(pt, t2);
	              Class.prototype = pt = t2;
	            }
	            if (pt.constructor != Class) {
	              if (typeof Class != "function") {
	                console.error("unknown Class:" + Class);
	              }
	              pt.constructor = Class;
	            }
	          }
	          var NodeType = {};
	          var ELEMENT_NODE = NodeType.ELEMENT_NODE = 1;
	          var ATTRIBUTE_NODE = NodeType.ATTRIBUTE_NODE = 2;
	          var TEXT_NODE = NodeType.TEXT_NODE = 3;
	          var CDATA_SECTION_NODE = NodeType.CDATA_SECTION_NODE = 4;
	          var ENTITY_REFERENCE_NODE = NodeType.ENTITY_REFERENCE_NODE = 5;
	          var ENTITY_NODE = NodeType.ENTITY_NODE = 6;
	          var PROCESSING_INSTRUCTION_NODE = NodeType.PROCESSING_INSTRUCTION_NODE = 7;
	          var COMMENT_NODE = NodeType.COMMENT_NODE = 8;
	          var DOCUMENT_NODE = NodeType.DOCUMENT_NODE = 9;
	          var DOCUMENT_TYPE_NODE = NodeType.DOCUMENT_TYPE_NODE = 10;
	          var DOCUMENT_FRAGMENT_NODE = NodeType.DOCUMENT_FRAGMENT_NODE = 11;
	          var NOTATION_NODE = NodeType.NOTATION_NODE = 12;
	          var ExceptionCode = {};
	          var ExceptionMessage = {};
	          ExceptionCode.INDEX_SIZE_ERR = (ExceptionMessage[1] = "Index size error", 1);
	          ExceptionCode.DOMSTRING_SIZE_ERR = (ExceptionMessage[2] = "DOMString size error", 2);
	          var HIERARCHY_REQUEST_ERR = ExceptionCode.HIERARCHY_REQUEST_ERR = (ExceptionMessage[3] = "Hierarchy request error", 3);
	          ExceptionCode.WRONG_DOCUMENT_ERR = (ExceptionMessage[4] = "Wrong document", 4);
	          ExceptionCode.INVALID_CHARACTER_ERR = (ExceptionMessage[5] = "Invalid character", 5);
	          ExceptionCode.NO_DATA_ALLOWED_ERR = (ExceptionMessage[6] = "No data allowed", 6);
	          ExceptionCode.NO_MODIFICATION_ALLOWED_ERR = (ExceptionMessage[7] = "No modification allowed", 7);
	          var NOT_FOUND_ERR = ExceptionCode.NOT_FOUND_ERR = (ExceptionMessage[8] = "Not found", 8);
	          ExceptionCode.NOT_SUPPORTED_ERR = (ExceptionMessage[9] = "Not supported", 9);
	          var INUSE_ATTRIBUTE_ERR = ExceptionCode.INUSE_ATTRIBUTE_ERR = (ExceptionMessage[10] = "Attribute in use", 10);
	          ExceptionCode.INVALID_STATE_ERR = (ExceptionMessage[11] = "Invalid state", 11);
	          ExceptionCode.SYNTAX_ERR = (ExceptionMessage[12] = "Syntax error", 12);
	          ExceptionCode.INVALID_MODIFICATION_ERR = (ExceptionMessage[13] = "Invalid modification", 13);
	          ExceptionCode.NAMESPACE_ERR = (ExceptionMessage[14] = "Invalid namespace", 14);
	          ExceptionCode.INVALID_ACCESS_ERR = (ExceptionMessage[15] = "Invalid access", 15);
	          function DOMException(code, message) {
	            if (message instanceof Error) {
	              var error = message;
	            } else {
	              error = this;
	              Error.call(this, ExceptionMessage[code]);
	              this.message = ExceptionMessage[code];
	              if (Error.captureStackTrace) Error.captureStackTrace(this, DOMException);
	            }
	            error.code = code;
	            if (message) this.message = this.message + ": " + message;
	            return error;
	          }
	          DOMException.prototype = Error.prototype;
	          copy(ExceptionCode, DOMException);
	          function NodeList() {
	          }
	          NodeList.prototype = {
	            /**
	             * The number of nodes in the list. The range of valid child node indices is 0 to length-1 inclusive.
	             * @standard level1
	             */
	            length: 0,
	            /**
	             * Returns the indexth item in the collection. If index is greater than or equal to the number of nodes in the list, this returns null.
	             * @standard level1
	             * @param index  unsigned long
	             *   Index into the collection.
	             * @return Node
	             * 	The node at the indexth position in the NodeList, or null if that is not a valid index.
	             */
	            item: function(index) {
	              return index >= 0 && index < this.length ? this[index] : null;
	            },
	            toString: function(isHTML, nodeFilter) {
	              for (var buf = [], i = 0; i < this.length; i++) {
	                serializeToString(this[i], buf, isHTML, nodeFilter);
	              }
	              return buf.join("");
	            },
	            /**
	             * @private
	             * @param {function (Node):boolean} predicate
	             * @returns {Node[]}
	             */
	            filter: function(predicate) {
	              return Array.prototype.filter.call(this, predicate);
	            },
	            /**
	             * @private
	             * @param {Node} item
	             * @returns {number}
	             */
	            indexOf: function(item) {
	              return Array.prototype.indexOf.call(this, item);
	            }
	          };
	          function LiveNodeList(node, refresh) {
	            this._node = node;
	            this._refresh = refresh;
	            _updateLiveList(this);
	          }
	          function _updateLiveList(list) {
	            var inc = list._node._inc || list._node.ownerDocument._inc;
	            if (list._inc !== inc) {
	              var ls = list._refresh(list._node);
	              __set__(list, "length", ls.length);
	              if (!list.$$length || ls.length < list.$$length) {
	                for (var i = ls.length; i in list; i++) {
	                  if (Object.prototype.hasOwnProperty.call(list, i)) {
	                    delete list[i];
	                  }
	                }
	              }
	              copy(ls, list);
	              list._inc = inc;
	            }
	          }
	          LiveNodeList.prototype.item = function(i) {
	            _updateLiveList(this);
	            return this[i] || null;
	          };
	          _extends(LiveNodeList, NodeList);
	          function NamedNodeMap() {
	          }
	          function _findNodeIndex(list, node) {
	            var i = list.length;
	            while (i--) {
	              if (list[i] === node) {
	                return i;
	              }
	            }
	          }
	          function _addNamedNode(el, list, newAttr, oldAttr) {
	            if (oldAttr) {
	              list[_findNodeIndex(list, oldAttr)] = newAttr;
	            } else {
	              list[list.length++] = newAttr;
	            }
	            if (el) {
	              newAttr.ownerElement = el;
	              var doc = el.ownerDocument;
	              if (doc) {
	                oldAttr && _onRemoveAttribute(doc, el, oldAttr);
	                _onAddAttribute(doc, el, newAttr);
	              }
	            }
	          }
	          function _removeNamedNode(el, list, attr) {
	            var i = _findNodeIndex(list, attr);
	            if (i >= 0) {
	              var lastIndex = list.length - 1;
	              while (i < lastIndex) {
	                list[i] = list[++i];
	              }
	              list.length = lastIndex;
	              if (el) {
	                var doc = el.ownerDocument;
	                if (doc) {
	                  _onRemoveAttribute(doc, el, attr);
	                  attr.ownerElement = null;
	                }
	              }
	            } else {
	              throw new DOMException(NOT_FOUND_ERR, new Error(el.tagName + "@" + attr));
	            }
	          }
	          NamedNodeMap.prototype = {
	            length: 0,
	            item: NodeList.prototype.item,
	            getNamedItem: function(key) {
	              var i = this.length;
	              while (i--) {
	                var attr = this[i];
	                if (attr.nodeName == key) {
	                  return attr;
	                }
	              }
	            },
	            setNamedItem: function(attr) {
	              var el = attr.ownerElement;
	              if (el && el != this._ownerElement) {
	                throw new DOMException(INUSE_ATTRIBUTE_ERR);
	              }
	              var oldAttr = this.getNamedItem(attr.nodeName);
	              _addNamedNode(this._ownerElement, this, attr, oldAttr);
	              return oldAttr;
	            },
	            /* returns Node */
	            setNamedItemNS: function(attr) {
	              var el = attr.ownerElement, oldAttr;
	              if (el && el != this._ownerElement) {
	                throw new DOMException(INUSE_ATTRIBUTE_ERR);
	              }
	              oldAttr = this.getNamedItemNS(attr.namespaceURI, attr.localName);
	              _addNamedNode(this._ownerElement, this, attr, oldAttr);
	              return oldAttr;
	            },
	            /* returns Node */
	            removeNamedItem: function(key) {
	              var attr = this.getNamedItem(key);
	              _removeNamedNode(this._ownerElement, this, attr);
	              return attr;
	            },
	            // raises: NOT_FOUND_ERR,NO_MODIFICATION_ALLOWED_ERR
	            //for level2
	            removeNamedItemNS: function(namespaceURI, localName) {
	              var attr = this.getNamedItemNS(namespaceURI, localName);
	              _removeNamedNode(this._ownerElement, this, attr);
	              return attr;
	            },
	            getNamedItemNS: function(namespaceURI, localName) {
	              var i = this.length;
	              while (i--) {
	                var node = this[i];
	                if (node.localName == localName && node.namespaceURI == namespaceURI) {
	                  return node;
	                }
	              }
	              return null;
	            }
	          };
	          function DOMImplementation() {
	          }
	          DOMImplementation.prototype = {
	            /**
	             * The DOMImplementation.hasFeature() method returns a Boolean flag indicating if a given feature is supported.
	             * The different implementations fairly diverged in what kind of features were reported.
	             * The latest version of the spec settled to force this method to always return true, where the functionality was accurate and in use.
	             *
	             * @deprecated It is deprecated and modern browsers return true in all cases.
	             *
	             * @param {string} feature
	             * @param {string} [version]
	             * @returns {boolean} always true
	             *
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMImplementation/hasFeature MDN
	             * @see https://www.w3.org/TR/REC-DOM-Level-1/level-one-core.html#ID-5CED94D7 DOM Level 1 Core
	             * @see https://dom.spec.whatwg.org/#dom-domimplementation-hasfeature DOM Living Standard
	             */
	            hasFeature: function(feature, version) {
	              return true;
	            },
	            /**
	             * Creates an XML Document object of the specified type with its document element.
	             *
	             * __It behaves slightly different from the description in the living standard__:
	             * - There is no interface/class `XMLDocument`, it returns a `Document` instance.
	             * - `contentType`, `encoding`, `mode`, `origin`, `url` fields are currently not declared.
	             * - this implementation is not validating names or qualified names
	             *   (when parsing XML strings, the SAX parser takes care of that)
	             *
	             * @param {string|null} namespaceURI
	             * @param {string} qualifiedName
	             * @param {DocumentType=null} doctype
	             * @returns {Document}
	             *
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMImplementation/createDocument MDN
	             * @see https://www.w3.org/TR/DOM-Level-2-Core/core.html#Level-2-Core-DOM-createDocument DOM Level 2 Core (initial)
	             * @see https://dom.spec.whatwg.org/#dom-domimplementation-createdocument  DOM Level 2 Core
	             *
	             * @see https://dom.spec.whatwg.org/#validate-and-extract DOM: Validate and extract
	             * @see https://www.w3.org/TR/xml/#NT-NameStartChar XML Spec: Names
	             * @see https://www.w3.org/TR/xml-names/#ns-qualnames XML Namespaces: Qualified names
	             */
	            createDocument: function(namespaceURI, qualifiedName, doctype) {
	              var doc = new Document();
	              doc.implementation = this;
	              doc.childNodes = new NodeList();
	              doc.doctype = doctype || null;
	              if (doctype) {
	                doc.appendChild(doctype);
	              }
	              if (qualifiedName) {
	                var root = doc.createElementNS(namespaceURI, qualifiedName);
	                doc.appendChild(root);
	              }
	              return doc;
	            },
	            /**
	             * Returns a doctype, with the given `qualifiedName`, `publicId`, and `systemId`.
	             *
	             * __This behavior is slightly different from the in the specs__:
	             * - this implementation is not validating names or qualified names
	             *   (when parsing XML strings, the SAX parser takes care of that)
	             *
	             * @param {string} qualifiedName
	             * @param {string} [publicId]
	             * @param {string} [systemId]
	             * @returns {DocumentType} which can either be used with `DOMImplementation.createDocument` upon document creation
	             * 				  or can be put into the document via methods like `Node.insertBefore()` or `Node.replaceChild()`
	             *
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/DOMImplementation/createDocumentType MDN
	             * @see https://www.w3.org/TR/DOM-Level-2-Core/core.html#Level-2-Core-DOM-createDocType DOM Level 2 Core
	             * @see https://dom.spec.whatwg.org/#dom-domimplementation-createdocumenttype DOM Living Standard
	             *
	             * @see https://dom.spec.whatwg.org/#validate-and-extract DOM: Validate and extract
	             * @see https://www.w3.org/TR/xml/#NT-NameStartChar XML Spec: Names
	             * @see https://www.w3.org/TR/xml-names/#ns-qualnames XML Namespaces: Qualified names
	             */
	            createDocumentType: function(qualifiedName, publicId, systemId) {
	              var node = new DocumentType();
	              node.name = qualifiedName;
	              node.nodeName = qualifiedName;
	              node.publicId = publicId || "";
	              node.systemId = systemId || "";
	              return node;
	            }
	          };
	          function Node() {
	          }
	          Node.prototype = {
	            firstChild: null,
	            lastChild: null,
	            previousSibling: null,
	            nextSibling: null,
	            attributes: null,
	            parentNode: null,
	            childNodes: null,
	            ownerDocument: null,
	            nodeValue: null,
	            namespaceURI: null,
	            prefix: null,
	            localName: null,
	            // Modified in DOM Level 2:
	            insertBefore: function(newChild, refChild) {
	              return _insertBefore(this, newChild, refChild);
	            },
	            replaceChild: function(newChild, oldChild) {
	              _insertBefore(this, newChild, oldChild, assertPreReplacementValidityInDocument);
	              if (oldChild) {
	                this.removeChild(oldChild);
	              }
	            },
	            removeChild: function(oldChild) {
	              return _removeChild(this, oldChild);
	            },
	            appendChild: function(newChild) {
	              return this.insertBefore(newChild, null);
	            },
	            hasChildNodes: function() {
	              return this.firstChild != null;
	            },
	            cloneNode: function(deep) {
	              return cloneNode(this.ownerDocument || this, this, deep);
	            },
	            // Modified in DOM Level 2:
	            normalize: function() {
	              var child = this.firstChild;
	              while (child) {
	                var next = child.nextSibling;
	                if (next && next.nodeType == TEXT_NODE && child.nodeType == TEXT_NODE) {
	                  this.removeChild(next);
	                  child.appendData(next.data);
	                } else {
	                  child.normalize();
	                  child = next;
	                }
	              }
	            },
	            // Introduced in DOM Level 2:
	            isSupported: function(feature, version) {
	              return this.ownerDocument.implementation.hasFeature(feature, version);
	            },
	            // Introduced in DOM Level 2:
	            hasAttributes: function() {
	              return this.attributes.length > 0;
	            },
	            /**
	             * Look up the prefix associated to the given namespace URI, starting from this node.
	             * **The default namespace declarations are ignored by this method.**
	             * See Namespace Prefix Lookup for details on the algorithm used by this method.
	             *
	             * _Note: The implementation seems to be incomplete when compared to the algorithm described in the specs._
	             *
	             * @param {string | null} namespaceURI
	             * @returns {string | null}
	             * @see https://www.w3.org/TR/DOM-Level-3-Core/core.html#Node3-lookupNamespacePrefix
	             * @see https://www.w3.org/TR/DOM-Level-3-Core/namespaces-algorithms.html#lookupNamespacePrefixAlgo
	             * @see https://dom.spec.whatwg.org/#dom-node-lookupprefix
	             * @see https://github.com/xmldom/xmldom/issues/322
	             */
	            lookupPrefix: function(namespaceURI) {
	              var el = this;
	              while (el) {
	                var map = el._nsMap;
	                if (map) {
	                  for (var n in map) {
	                    if (Object.prototype.hasOwnProperty.call(map, n) && map[n] === namespaceURI) {
	                      return n;
	                    }
	                  }
	                }
	                el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
	              }
	              return null;
	            },
	            // Introduced in DOM Level 3:
	            lookupNamespaceURI: function(prefix) {
	              var el = this;
	              while (el) {
	                var map = el._nsMap;
	                if (map) {
	                  if (Object.prototype.hasOwnProperty.call(map, prefix)) {
	                    return map[prefix];
	                  }
	                }
	                el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
	              }
	              return null;
	            },
	            // Introduced in DOM Level 3:
	            isDefaultNamespace: function(namespaceURI) {
	              var prefix = this.lookupPrefix(namespaceURI);
	              return prefix == null;
	            }
	          };
	          function _xmlEncoder(c) {
	            return c == "<" && "&lt;" || c == ">" && "&gt;" || c == "&" && "&amp;" || c == '"' && "&quot;" || "&#" + c.charCodeAt() + ";";
	          }
	          copy(NodeType, Node);
	          copy(NodeType, Node.prototype);
	          function _visitNode(node, callback) {
	            if (callback(node)) {
	              return true;
	            }
	            if (node = node.firstChild) {
	              do {
	                if (_visitNode(node, callback)) {
	                  return true;
	                }
	              } while (node = node.nextSibling);
	            }
	          }
	          function Document() {
	            this.ownerDocument = this;
	          }
	          function _onAddAttribute(doc, el, newAttr) {
	            doc && doc._inc++;
	            var ns = newAttr.namespaceURI;
	            if (ns === NAMESPACE.XMLNS) {
	              el._nsMap[newAttr.prefix ? newAttr.localName : ""] = newAttr.value;
	            }
	          }
	          function _onRemoveAttribute(doc, el, newAttr, remove) {
	            doc && doc._inc++;
	            var ns = newAttr.namespaceURI;
	            if (ns === NAMESPACE.XMLNS) {
	              delete el._nsMap[newAttr.prefix ? newAttr.localName : ""];
	            }
	          }
	          function _onUpdateChild(doc, el, newChild) {
	            if (doc && doc._inc) {
	              doc._inc++;
	              var cs = el.childNodes;
	              if (newChild) {
	                cs[cs.length++] = newChild;
	              } else {
	                var child = el.firstChild;
	                var i = 0;
	                while (child) {
	                  cs[i++] = child;
	                  child = child.nextSibling;
	                }
	                cs.length = i;
	                delete cs[cs.length];
	              }
	            }
	          }
	          function _removeChild(parentNode, child) {
	            var previous = child.previousSibling;
	            var next = child.nextSibling;
	            if (previous) {
	              previous.nextSibling = next;
	            } else {
	              parentNode.firstChild = next;
	            }
	            if (next) {
	              next.previousSibling = previous;
	            } else {
	              parentNode.lastChild = previous;
	            }
	            child.parentNode = null;
	            child.previousSibling = null;
	            child.nextSibling = null;
	            _onUpdateChild(parentNode.ownerDocument, parentNode);
	            return child;
	          }
	          function hasValidParentNodeType(node) {
	            return node && (node.nodeType === Node.DOCUMENT_NODE || node.nodeType === Node.DOCUMENT_FRAGMENT_NODE || node.nodeType === Node.ELEMENT_NODE);
	          }
	          function hasInsertableNodeType(node) {
	            return node && (isElementNode(node) || isTextNode(node) || isDocTypeNode(node) || node.nodeType === Node.DOCUMENT_FRAGMENT_NODE || node.nodeType === Node.COMMENT_NODE || node.nodeType === Node.PROCESSING_INSTRUCTION_NODE);
	          }
	          function isDocTypeNode(node) {
	            return node && node.nodeType === Node.DOCUMENT_TYPE_NODE;
	          }
	          function isElementNode(node) {
	            return node && node.nodeType === Node.ELEMENT_NODE;
	          }
	          function isTextNode(node) {
	            return node && node.nodeType === Node.TEXT_NODE;
	          }
	          function isElementInsertionPossible(doc, child) {
	            var parentChildNodes = doc.childNodes || [];
	            if (find(parentChildNodes, isElementNode) || isDocTypeNode(child)) {
	              return false;
	            }
	            var docTypeNode = find(parentChildNodes, isDocTypeNode);
	            return !(child && docTypeNode && parentChildNodes.indexOf(docTypeNode) > parentChildNodes.indexOf(child));
	          }
	          function isElementReplacementPossible(doc, child) {
	            var parentChildNodes = doc.childNodes || [];
	            function hasElementChildThatIsNotChild(node) {
	              return isElementNode(node) && node !== child;
	            }
	            if (find(parentChildNodes, hasElementChildThatIsNotChild)) {
	              return false;
	            }
	            var docTypeNode = find(parentChildNodes, isDocTypeNode);
	            return !(child && docTypeNode && parentChildNodes.indexOf(docTypeNode) > parentChildNodes.indexOf(child));
	          }
	          function assertPreInsertionValidity1to5(parent, node, child) {
	            if (!hasValidParentNodeType(parent)) {
	              throw new DOMException(HIERARCHY_REQUEST_ERR, "Unexpected parent node type " + parent.nodeType);
	            }
	            if (child && child.parentNode !== parent) {
	              throw new DOMException(NOT_FOUND_ERR, "child not in parent");
	            }
	            if (
	              // 4. If `node` is not a DocumentFragment, DocumentType, Element, or CharacterData node, then throw a "HierarchyRequestError" DOMException.
	              !hasInsertableNodeType(node) || // 5. If either `node` is a Text node and `parent` is a document,
	              // the sax parser currently adds top level text nodes, this will be fixed in 0.9.0
	              // || (node.nodeType === Node.TEXT_NODE && parent.nodeType === Node.DOCUMENT_NODE)
	              // or `node` is a doctype and `parent` is not a document, then throw a "HierarchyRequestError" DOMException.
	              isDocTypeNode(node) && parent.nodeType !== Node.DOCUMENT_NODE
	            ) {
	              throw new DOMException(
	                HIERARCHY_REQUEST_ERR,
	                "Unexpected node type " + node.nodeType + " for parent node type " + parent.nodeType
	              );
	            }
	          }
	          function assertPreInsertionValidityInDocument(parent, node, child) {
	            var parentChildNodes = parent.childNodes || [];
	            var nodeChildNodes = node.childNodes || [];
	            if (node.nodeType === Node.DOCUMENT_FRAGMENT_NODE) {
	              var nodeChildElements = nodeChildNodes.filter(isElementNode);
	              if (nodeChildElements.length > 1 || find(nodeChildNodes, isTextNode)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "More than one element or text in fragment");
	              }
	              if (nodeChildElements.length === 1 && !isElementInsertionPossible(parent, child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Element in fragment can not be inserted before doctype");
	              }
	            }
	            if (isElementNode(node)) {
	              if (!isElementInsertionPossible(parent, child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Only one element can be added and only after doctype");
	              }
	            }
	            if (isDocTypeNode(node)) {
	              if (find(parentChildNodes, isDocTypeNode)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Only one doctype is allowed");
	              }
	              var parentElementChild = find(parentChildNodes, isElementNode);
	              if (child && parentChildNodes.indexOf(parentElementChild) < parentChildNodes.indexOf(child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Doctype can only be inserted before an element");
	              }
	              if (!child && parentElementChild) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Doctype can not be appended since element is present");
	              }
	            }
	          }
	          function assertPreReplacementValidityInDocument(parent, node, child) {
	            var parentChildNodes = parent.childNodes || [];
	            var nodeChildNodes = node.childNodes || [];
	            if (node.nodeType === Node.DOCUMENT_FRAGMENT_NODE) {
	              var nodeChildElements = nodeChildNodes.filter(isElementNode);
	              if (nodeChildElements.length > 1 || find(nodeChildNodes, isTextNode)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "More than one element or text in fragment");
	              }
	              if (nodeChildElements.length === 1 && !isElementReplacementPossible(parent, child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Element in fragment can not be inserted before doctype");
	              }
	            }
	            if (isElementNode(node)) {
	              if (!isElementReplacementPossible(parent, child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Only one element can be added and only after doctype");
	              }
	            }
	            if (isDocTypeNode(node)) {
	              let hasDoctypeChildThatIsNotChild2 = function(node2) {
	                return isDocTypeNode(node2) && node2 !== child;
	              };
	              if (find(parentChildNodes, hasDoctypeChildThatIsNotChild2)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Only one doctype is allowed");
	              }
	              var parentElementChild = find(parentChildNodes, isElementNode);
	              if (child && parentChildNodes.indexOf(parentElementChild) < parentChildNodes.indexOf(child)) {
	                throw new DOMException(HIERARCHY_REQUEST_ERR, "Doctype can only be inserted before an element");
	              }
	            }
	          }
	          function _insertBefore(parent, node, child, _inDocumentAssertion) {
	            assertPreInsertionValidity1to5(parent, node, child);
	            if (parent.nodeType === Node.DOCUMENT_NODE) {
	              (_inDocumentAssertion || assertPreInsertionValidityInDocument)(parent, node, child);
	            }
	            var cp = node.parentNode;
	            if (cp) {
	              cp.removeChild(node);
	            }
	            if (node.nodeType === DOCUMENT_FRAGMENT_NODE) {
	              var newFirst = node.firstChild;
	              if (newFirst == null) {
	                return node;
	              }
	              var newLast = node.lastChild;
	            } else {
	              newFirst = newLast = node;
	            }
	            var pre = child ? child.previousSibling : parent.lastChild;
	            newFirst.previousSibling = pre;
	            newLast.nextSibling = child;
	            if (pre) {
	              pre.nextSibling = newFirst;
	            } else {
	              parent.firstChild = newFirst;
	            }
	            if (child == null) {
	              parent.lastChild = newLast;
	            } else {
	              child.previousSibling = newLast;
	            }
	            do {
	              newFirst.parentNode = parent;
	            } while (newFirst !== newLast && (newFirst = newFirst.nextSibling));
	            _onUpdateChild(parent.ownerDocument || parent, parent);
	            if (node.nodeType == DOCUMENT_FRAGMENT_NODE) {
	              node.firstChild = node.lastChild = null;
	            }
	            return node;
	          }
	          function _appendSingleChild(parentNode, newChild) {
	            if (newChild.parentNode) {
	              newChild.parentNode.removeChild(newChild);
	            }
	            newChild.parentNode = parentNode;
	            newChild.previousSibling = parentNode.lastChild;
	            newChild.nextSibling = null;
	            if (newChild.previousSibling) {
	              newChild.previousSibling.nextSibling = newChild;
	            } else {
	              parentNode.firstChild = newChild;
	            }
	            parentNode.lastChild = newChild;
	            _onUpdateChild(parentNode.ownerDocument, parentNode, newChild);
	            return newChild;
	          }
	          Document.prototype = {
	            //implementation : null,
	            nodeName: "#document",
	            nodeType: DOCUMENT_NODE,
	            /**
	             * The DocumentType node of the document.
	             *
	             * @readonly
	             * @type DocumentType
	             */
	            doctype: null,
	            documentElement: null,
	            _inc: 1,
	            insertBefore: function(newChild, refChild) {
	              if (newChild.nodeType == DOCUMENT_FRAGMENT_NODE) {
	                var child = newChild.firstChild;
	                while (child) {
	                  var next = child.nextSibling;
	                  this.insertBefore(child, refChild);
	                  child = next;
	                }
	                return newChild;
	              }
	              _insertBefore(this, newChild, refChild);
	              newChild.ownerDocument = this;
	              if (this.documentElement === null && newChild.nodeType === ELEMENT_NODE) {
	                this.documentElement = newChild;
	              }
	              return newChild;
	            },
	            removeChild: function(oldChild) {
	              if (this.documentElement == oldChild) {
	                this.documentElement = null;
	              }
	              return _removeChild(this, oldChild);
	            },
	            replaceChild: function(newChild, oldChild) {
	              _insertBefore(this, newChild, oldChild, assertPreReplacementValidityInDocument);
	              newChild.ownerDocument = this;
	              if (oldChild) {
	                this.removeChild(oldChild);
	              }
	              if (isElementNode(newChild)) {
	                this.documentElement = newChild;
	              }
	            },
	            // Introduced in DOM Level 2:
	            importNode: function(importedNode, deep) {
	              return importNode(this, importedNode, deep);
	            },
	            // Introduced in DOM Level 2:
	            getElementById: function(id) {
	              var rtv = null;
	              _visitNode(this.documentElement, function(node) {
	                if (node.nodeType == ELEMENT_NODE) {
	                  if (node.getAttribute("id") == id) {
	                    rtv = node;
	                    return true;
	                  }
	                }
	              });
	              return rtv;
	            },
	            /**
	             * The `getElementsByClassName` method of `Document` interface returns an array-like object
	             * of all child elements which have **all** of the given class name(s).
	             *
	             * Returns an empty list if `classeNames` is an empty string or only contains HTML white space characters.
	             *
	             *
	             * Warning: This is a live LiveNodeList.
	             * Changes in the DOM will reflect in the array as the changes occur.
	             * If an element selected by this array no longer qualifies for the selector,
	             * it will automatically be removed. Be aware of this for iteration purposes.
	             *
	             * @param {string} classNames is a string representing the class name(s) to match; multiple class names are separated by (ASCII-)whitespace
	             *
	             * @see https://developer.mozilla.org/en-US/docs/Web/API/Document/getElementsByClassName
	             * @see https://dom.spec.whatwg.org/#concept-getelementsbyclassname
	             */
	            getElementsByClassName: function(classNames) {
	              var classNamesSet = toOrderedSet(classNames);
	              return new LiveNodeList(this, function(base) {
	                var ls = [];
	                if (classNamesSet.length > 0) {
	                  _visitNode(base.documentElement, function(node) {
	                    if (node !== base && node.nodeType === ELEMENT_NODE) {
	                      var nodeClassNames = node.getAttribute("class");
	                      if (nodeClassNames) {
	                        var matches = classNames === nodeClassNames;
	                        if (!matches) {
	                          var nodeClassNamesSet = toOrderedSet(nodeClassNames);
	                          matches = classNamesSet.every(arrayIncludes(nodeClassNamesSet));
	                        }
	                        if (matches) {
	                          ls.push(node);
	                        }
	                      }
	                    }
	                  });
	                }
	                return ls;
	              });
	            },
	            //document factory method:
	            createElement: function(tagName) {
	              var node = new Element();
	              node.ownerDocument = this;
	              node.nodeName = tagName;
	              node.tagName = tagName;
	              node.localName = tagName;
	              node.childNodes = new NodeList();
	              var attrs = node.attributes = new NamedNodeMap();
	              attrs._ownerElement = node;
	              return node;
	            },
	            createDocumentFragment: function() {
	              var node = new DocumentFragment();
	              node.ownerDocument = this;
	              node.childNodes = new NodeList();
	              return node;
	            },
	            createTextNode: function(data) {
	              var node = new Text();
	              node.ownerDocument = this;
	              node.appendData(data);
	              return node;
	            },
	            createComment: function(data) {
	              var node = new Comment();
	              node.ownerDocument = this;
	              node.appendData(data);
	              return node;
	            },
	            createCDATASection: function(data) {
	              var node = new CDATASection();
	              node.ownerDocument = this;
	              node.appendData(data);
	              return node;
	            },
	            createProcessingInstruction: function(target, data) {
	              var node = new ProcessingInstruction();
	              node.ownerDocument = this;
	              node.tagName = node.nodeName = node.target = target;
	              node.nodeValue = node.data = data;
	              return node;
	            },
	            createAttribute: function(name) {
	              var node = new Attr();
	              node.ownerDocument = this;
	              node.name = name;
	              node.nodeName = name;
	              node.localName = name;
	              node.specified = true;
	              return node;
	            },
	            createEntityReference: function(name) {
	              var node = new EntityReference();
	              node.ownerDocument = this;
	              node.nodeName = name;
	              return node;
	            },
	            // Introduced in DOM Level 2:
	            createElementNS: function(namespaceURI, qualifiedName) {
	              var node = new Element();
	              var pl = qualifiedName.split(":");
	              var attrs = node.attributes = new NamedNodeMap();
	              node.childNodes = new NodeList();
	              node.ownerDocument = this;
	              node.nodeName = qualifiedName;
	              node.tagName = qualifiedName;
	              node.namespaceURI = namespaceURI;
	              if (pl.length == 2) {
	                node.prefix = pl[0];
	                node.localName = pl[1];
	              } else {
	                node.localName = qualifiedName;
	              }
	              attrs._ownerElement = node;
	              return node;
	            },
	            // Introduced in DOM Level 2:
	            createAttributeNS: function(namespaceURI, qualifiedName) {
	              var node = new Attr();
	              var pl = qualifiedName.split(":");
	              node.ownerDocument = this;
	              node.nodeName = qualifiedName;
	              node.name = qualifiedName;
	              node.namespaceURI = namespaceURI;
	              node.specified = true;
	              if (pl.length == 2) {
	                node.prefix = pl[0];
	                node.localName = pl[1];
	              } else {
	                node.localName = qualifiedName;
	              }
	              return node;
	            }
	          };
	          _extends(Document, Node);
	          function Element() {
	            this._nsMap = {};
	          }
	          Element.prototype = {
	            nodeType: ELEMENT_NODE,
	            hasAttribute: function(name) {
	              return this.getAttributeNode(name) != null;
	            },
	            getAttribute: function(name) {
	              var attr = this.getAttributeNode(name);
	              return attr && attr.value || "";
	            },
	            getAttributeNode: function(name) {
	              return this.attributes.getNamedItem(name);
	            },
	            setAttribute: function(name, value) {
	              var attr = this.ownerDocument.createAttribute(name);
	              attr.value = attr.nodeValue = "" + value;
	              this.setAttributeNode(attr);
	            },
	            removeAttribute: function(name) {
	              var attr = this.getAttributeNode(name);
	              attr && this.removeAttributeNode(attr);
	            },
	            //four real opeartion method
	            appendChild: function(newChild) {
	              if (newChild.nodeType === DOCUMENT_FRAGMENT_NODE) {
	                return this.insertBefore(newChild, null);
	              } else {
	                return _appendSingleChild(this, newChild);
	              }
	            },
	            setAttributeNode: function(newAttr) {
	              return this.attributes.setNamedItem(newAttr);
	            },
	            setAttributeNodeNS: function(newAttr) {
	              return this.attributes.setNamedItemNS(newAttr);
	            },
	            removeAttributeNode: function(oldAttr) {
	              return this.attributes.removeNamedItem(oldAttr.nodeName);
	            },
	            //get real attribute name,and remove it by removeAttributeNode
	            removeAttributeNS: function(namespaceURI, localName) {
	              var old = this.getAttributeNodeNS(namespaceURI, localName);
	              old && this.removeAttributeNode(old);
	            },
	            hasAttributeNS: function(namespaceURI, localName) {
	              return this.getAttributeNodeNS(namespaceURI, localName) != null;
	            },
	            getAttributeNS: function(namespaceURI, localName) {
	              var attr = this.getAttributeNodeNS(namespaceURI, localName);
	              return attr && attr.value || "";
	            },
	            setAttributeNS: function(namespaceURI, qualifiedName, value) {
	              var attr = this.ownerDocument.createAttributeNS(namespaceURI, qualifiedName);
	              attr.value = attr.nodeValue = "" + value;
	              this.setAttributeNode(attr);
	            },
	            getAttributeNodeNS: function(namespaceURI, localName) {
	              return this.attributes.getNamedItemNS(namespaceURI, localName);
	            },
	            getElementsByTagName: function(tagName) {
	              return new LiveNodeList(this, function(base) {
	                var ls = [];
	                _visitNode(base, function(node) {
	                  if (node !== base && node.nodeType == ELEMENT_NODE && (tagName === "*" || node.tagName == tagName)) {
	                    ls.push(node);
	                  }
	                });
	                return ls;
	              });
	            },
	            getElementsByTagNameNS: function(namespaceURI, localName) {
	              return new LiveNodeList(this, function(base) {
	                var ls = [];
	                _visitNode(base, function(node) {
	                  if (node !== base && node.nodeType === ELEMENT_NODE && (namespaceURI === "*" || node.namespaceURI === namespaceURI) && (localName === "*" || node.localName == localName)) {
	                    ls.push(node);
	                  }
	                });
	                return ls;
	              });
	            }
	          };
	          Document.prototype.getElementsByTagName = Element.prototype.getElementsByTagName;
	          Document.prototype.getElementsByTagNameNS = Element.prototype.getElementsByTagNameNS;
	          _extends(Element, Node);
	          function Attr() {
	          }
	          Attr.prototype.nodeType = ATTRIBUTE_NODE;
	          _extends(Attr, Node);
	          function CharacterData() {
	          }
	          CharacterData.prototype = {
	            data: "",
	            substringData: function(offset, count) {
	              return this.data.substring(offset, offset + count);
	            },
	            appendData: function(text) {
	              text = this.data + text;
	              this.nodeValue = this.data = text;
	              this.length = text.length;
	            },
	            insertData: function(offset, text) {
	              this.replaceData(offset, 0, text);
	            },
	            appendChild: function(newChild) {
	              throw new Error(ExceptionMessage[HIERARCHY_REQUEST_ERR]);
	            },
	            deleteData: function(offset, count) {
	              this.replaceData(offset, count, "");
	            },
	            replaceData: function(offset, count, text) {
	              var start = this.data.substring(0, offset);
	              var end = this.data.substring(offset + count);
	              text = start + text + end;
	              this.nodeValue = this.data = text;
	              this.length = text.length;
	            }
	          };
	          _extends(CharacterData, Node);
	          function Text() {
	          }
	          Text.prototype = {
	            nodeName: "#text",
	            nodeType: TEXT_NODE,
	            splitText: function(offset) {
	              var text = this.data;
	              var newText = text.substring(offset);
	              text = text.substring(0, offset);
	              this.data = this.nodeValue = text;
	              this.length = text.length;
	              var newNode = this.ownerDocument.createTextNode(newText);
	              if (this.parentNode) {
	                this.parentNode.insertBefore(newNode, this.nextSibling);
	              }
	              return newNode;
	            }
	          };
	          _extends(Text, CharacterData);
	          function Comment() {
	          }
	          Comment.prototype = {
	            nodeName: "#comment",
	            nodeType: COMMENT_NODE
	          };
	          _extends(Comment, CharacterData);
	          function CDATASection() {
	          }
	          CDATASection.prototype = {
	            nodeName: "#cdata-section",
	            nodeType: CDATA_SECTION_NODE
	          };
	          _extends(CDATASection, CharacterData);
	          function DocumentType() {
	          }
	          DocumentType.prototype.nodeType = DOCUMENT_TYPE_NODE;
	          _extends(DocumentType, Node);
	          function Notation() {
	          }
	          Notation.prototype.nodeType = NOTATION_NODE;
	          _extends(Notation, Node);
	          function Entity() {
	          }
	          Entity.prototype.nodeType = ENTITY_NODE;
	          _extends(Entity, Node);
	          function EntityReference() {
	          }
	          EntityReference.prototype.nodeType = ENTITY_REFERENCE_NODE;
	          _extends(EntityReference, Node);
	          function DocumentFragment() {
	          }
	          DocumentFragment.prototype.nodeName = "#document-fragment";
	          DocumentFragment.prototype.nodeType = DOCUMENT_FRAGMENT_NODE;
	          _extends(DocumentFragment, Node);
	          function ProcessingInstruction() {
	          }
	          ProcessingInstruction.prototype.nodeType = PROCESSING_INSTRUCTION_NODE;
	          _extends(ProcessingInstruction, Node);
	          function XMLSerializer2() {
	          }
	          XMLSerializer2.prototype.serializeToString = function(node, isHtml, nodeFilter) {
	            return nodeSerializeToString.call(node, isHtml, nodeFilter);
	          };
	          Node.prototype.toString = nodeSerializeToString;
	          function nodeSerializeToString(isHtml, nodeFilter) {
	            var buf = [];
	            var refNode = this.nodeType == 9 && this.documentElement || this;
	            var prefix = refNode.prefix;
	            var uri = refNode.namespaceURI;
	            if (uri && prefix == null) {
	              var prefix = refNode.lookupPrefix(uri);
	              if (prefix == null) {
	                var visibleNamespaces = [
	                  { namespace: uri, prefix: null }
	                  //{namespace:uri,prefix:''}
	                ];
	              }
	            }
	            serializeToString(this, buf, isHtml, nodeFilter, visibleNamespaces);
	            return buf.join("");
	          }
	          function needNamespaceDefine(node, isHTML, visibleNamespaces) {
	            var prefix = node.prefix || "";
	            var uri = node.namespaceURI;
	            if (!uri) {
	              return false;
	            }
	            if (prefix === "xml" && uri === NAMESPACE.XML || uri === NAMESPACE.XMLNS) {
	              return false;
	            }
	            var i = visibleNamespaces.length;
	            while (i--) {
	              var ns = visibleNamespaces[i];
	              if (ns.prefix === prefix) {
	                return ns.namespace !== uri;
	              }
	            }
	            return true;
	          }
	          function addSerializedAttribute(buf, qualifiedName, value) {
	            buf.push(" ", qualifiedName, '="', value.replace(/[<>&"\t\n\r]/g, _xmlEncoder), '"');
	          }
	          function serializeToString(node, buf, isHTML, nodeFilter, visibleNamespaces) {
	            if (!visibleNamespaces) {
	              visibleNamespaces = [];
	            }
	            if (nodeFilter) {
	              node = nodeFilter(node);
	              if (node) {
	                if (typeof node == "string") {
	                  buf.push(node);
	                  return;
	                }
	              } else {
	                return;
	              }
	            }
	            switch (node.nodeType) {
	              case ELEMENT_NODE:
	                var attrs = node.attributes;
	                var len = attrs.length;
	                var child = node.firstChild;
	                var nodeName = node.tagName;
	                isHTML = NAMESPACE.isHTML(node.namespaceURI) || isHTML;
	                var prefixedNodeName = nodeName;
	                if (!isHTML && !node.prefix && node.namespaceURI) {
	                  var defaultNS;
	                  for (var ai = 0; ai < attrs.length; ai++) {
	                    if (attrs.item(ai).name === "xmlns") {
	                      defaultNS = attrs.item(ai).value;
	                      break;
	                    }
	                  }
	                  if (!defaultNS) {
	                    for (var nsi = visibleNamespaces.length - 1; nsi >= 0; nsi--) {
	                      var namespace = visibleNamespaces[nsi];
	                      if (namespace.prefix === "" && namespace.namespace === node.namespaceURI) {
	                        defaultNS = namespace.namespace;
	                        break;
	                      }
	                    }
	                  }
	                  if (defaultNS !== node.namespaceURI) {
	                    for (var nsi = visibleNamespaces.length - 1; nsi >= 0; nsi--) {
	                      var namespace = visibleNamespaces[nsi];
	                      if (namespace.namespace === node.namespaceURI) {
	                        if (namespace.prefix) {
	                          prefixedNodeName = namespace.prefix + ":" + nodeName;
	                        }
	                        break;
	                      }
	                    }
	                  }
	                }
	                buf.push("<", prefixedNodeName);
	                for (var i = 0; i < len; i++) {
	                  var attr = attrs.item(i);
	                  if (attr.prefix == "xmlns") {
	                    visibleNamespaces.push({ prefix: attr.localName, namespace: attr.value });
	                  } else if (attr.nodeName == "xmlns") {
	                    visibleNamespaces.push({ prefix: "", namespace: attr.value });
	                  }
	                }
	                for (var i = 0; i < len; i++) {
	                  var attr = attrs.item(i);
	                  if (needNamespaceDefine(attr, isHTML, visibleNamespaces)) {
	                    var prefix = attr.prefix || "";
	                    var uri = attr.namespaceURI;
	                    addSerializedAttribute(buf, prefix ? "xmlns:" + prefix : "xmlns", uri);
	                    visibleNamespaces.push({ prefix, namespace: uri });
	                  }
	                  serializeToString(attr, buf, isHTML, nodeFilter, visibleNamespaces);
	                }
	                if (nodeName === prefixedNodeName && needNamespaceDefine(node, isHTML, visibleNamespaces)) {
	                  var prefix = node.prefix || "";
	                  var uri = node.namespaceURI;
	                  addSerializedAttribute(buf, prefix ? "xmlns:" + prefix : "xmlns", uri);
	                  visibleNamespaces.push({ prefix, namespace: uri });
	                }
	                if (child || isHTML && !/^(?:meta|link|img|br|hr|input)$/i.test(nodeName)) {
	                  buf.push(">");
	                  if (isHTML && /^script$/i.test(nodeName)) {
	                    while (child) {
	                      if (child.data) {
	                        buf.push(child.data);
	                      } else {
	                        serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
	                      }
	                      child = child.nextSibling;
	                    }
	                  } else {
	                    while (child) {
	                      serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
	                      child = child.nextSibling;
	                    }
	                  }
	                  buf.push("</", prefixedNodeName, ">");
	                } else {
	                  buf.push("/>");
	                }
	                return;
	              case DOCUMENT_NODE:
	              case DOCUMENT_FRAGMENT_NODE:
	                var child = node.firstChild;
	                while (child) {
	                  serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
	                  child = child.nextSibling;
	                }
	                return;
	              case ATTRIBUTE_NODE:
	                return addSerializedAttribute(buf, node.name, node.value);
	              case TEXT_NODE:
	                return buf.push(
	                  node.data.replace(/[<&>]/g, _xmlEncoder)
	                );
	              case CDATA_SECTION_NODE:
	                return buf.push("<![CDATA[", node.data, "]]>");
	              case COMMENT_NODE:
	                return buf.push("<!--", node.data, "-->");
	              case DOCUMENT_TYPE_NODE:
	                var pubid = node.publicId;
	                var sysid = node.systemId;
	                buf.push("<!DOCTYPE ", node.name);
	                if (pubid) {
	                  buf.push(" PUBLIC ", pubid);
	                  if (sysid && sysid != ".") {
	                    buf.push(" ", sysid);
	                  }
	                  buf.push(">");
	                } else if (sysid && sysid != ".") {
	                  buf.push(" SYSTEM ", sysid, ">");
	                } else {
	                  var sub = node.internalSubset;
	                  if (sub) {
	                    buf.push(" [", sub, "]");
	                  }
	                  buf.push(">");
	                }
	                return;
	              case PROCESSING_INSTRUCTION_NODE:
	                return buf.push("<?", node.target, " ", node.data, "?>");
	              case ENTITY_REFERENCE_NODE:
	                return buf.push("&", node.nodeName, ";");
	              default:
	                buf.push("??", node.nodeName);
	            }
	          }
	          function importNode(doc, node, deep) {
	            var node2;
	            switch (node.nodeType) {
	              case ELEMENT_NODE:
	                node2 = node.cloneNode(false);
	                node2.ownerDocument = doc;
	              case DOCUMENT_FRAGMENT_NODE:
	                break;
	              case ATTRIBUTE_NODE:
	                deep = true;
	                break;
	            }
	            if (!node2) {
	              node2 = node.cloneNode(false);
	            }
	            node2.ownerDocument = doc;
	            node2.parentNode = null;
	            if (deep) {
	              var child = node.firstChild;
	              while (child) {
	                node2.appendChild(importNode(doc, child, deep));
	                child = child.nextSibling;
	              }
	            }
	            return node2;
	          }
	          function cloneNode(doc, node, deep) {
	            var node2 = new node.constructor();
	            for (var n in node) {
	              if (Object.prototype.hasOwnProperty.call(node, n)) {
	                var v = node[n];
	                if (typeof v != "object") {
	                  if (v != node2[n]) {
	                    node2[n] = v;
	                  }
	                }
	              }
	            }
	            if (node.childNodes) {
	              node2.childNodes = new NodeList();
	            }
	            node2.ownerDocument = doc;
	            switch (node2.nodeType) {
	              case ELEMENT_NODE:
	                var attrs = node.attributes;
	                var attrs2 = node2.attributes = new NamedNodeMap();
	                var len = attrs.length;
	                attrs2._ownerElement = node2;
	                for (var i = 0; i < len; i++) {
	                  node2.setAttributeNode(cloneNode(doc, attrs.item(i), true));
	                }
	                break;
	              case ATTRIBUTE_NODE:
	                deep = true;
	            }
	            if (deep) {
	              var child = node.firstChild;
	              while (child) {
	                node2.appendChild(cloneNode(doc, child, deep));
	                child = child.nextSibling;
	              }
	            }
	            return node2;
	          }
	          function __set__(object, key, value) {
	            object[key] = value;
	          }
	          try {
	            if (Object.defineProperty) {
	              let getTextContent2 = function(node) {
	                switch (node.nodeType) {
	                  case ELEMENT_NODE:
	                  case DOCUMENT_FRAGMENT_NODE:
	                    var buf = [];
	                    node = node.firstChild;
	                    while (node) {
	                      if (node.nodeType !== 7 && node.nodeType !== 8) {
	                        buf.push(getTextContent2(node));
	                      }
	                      node = node.nextSibling;
	                    }
	                    return buf.join("");
	                  default:
	                    return node.nodeValue;
	                }
	              };
	              var getTextContent = getTextContent2;
	              Object.defineProperty(LiveNodeList.prototype, "length", {
	                get: function() {
	                  _updateLiveList(this);
	                  return this.$$length;
	                }
	              });
	              Object.defineProperty(Node.prototype, "textContent", {
	                get: function() {
	                  return getTextContent2(this);
	                },
	                set: function(data) {
	                  switch (this.nodeType) {
	                    case ELEMENT_NODE:
	                    case DOCUMENT_FRAGMENT_NODE:
	                      while (this.firstChild) {
	                        this.removeChild(this.firstChild);
	                      }
	                      if (data || String(data)) {
	                        this.appendChild(this.ownerDocument.createTextNode(data));
	                      }
	                      break;
	                    default:
	                      this.data = data;
	                      this.value = data;
	                      this.nodeValue = data;
	                  }
	                }
	              });
	              __set__ = function(object, key, value) {
	                object["$$" + key] = value;
	              };
	            }
	          } catch (e) {
	          }
	          exports2.DocumentType = DocumentType;
	          exports2.DOMException = DOMException;
	          exports2.DOMImplementation = DOMImplementation;
	          exports2.Element = Element;
	          exports2.Node = Node;
	          exports2.NodeList = NodeList;
	          exports2.XMLSerializer = XMLSerializer2;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/entities.js": (
	        /*!*****************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/entities.js ***!
	          \*****************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var freeze = __webpack_require__(
	            /*! ./conventions */
	            "./node_modules/@xmldom/xmldom/lib/conventions.js"
	          ).freeze;
	          exports2.XML_ENTITIES = freeze({
	            amp: "&",
	            apos: "'",
	            gt: ">",
	            lt: "<",
	            quot: '"'
	          });
	          exports2.HTML_ENTITIES = freeze({
	            Aacute: "Á",
	            aacute: "á",
	            Abreve: "Ă",
	            abreve: "ă",
	            ac: "∾",
	            acd: "∿",
	            acE: "∾̳",
	            Acirc: "Â",
	            acirc: "â",
	            acute: "´",
	            Acy: "А",
	            acy: "а",
	            AElig: "Æ",
	            aelig: "æ",
	            af: "⁡",
	            Afr: "𝔄",
	            afr: "𝔞",
	            Agrave: "À",
	            agrave: "à",
	            alefsym: "ℵ",
	            aleph: "ℵ",
	            Alpha: "Α",
	            alpha: "α",
	            Amacr: "Ā",
	            amacr: "ā",
	            amalg: "⨿",
	            AMP: "&",
	            amp: "&",
	            And: "⩓",
	            and: "∧",
	            andand: "⩕",
	            andd: "⩜",
	            andslope: "⩘",
	            andv: "⩚",
	            ang: "∠",
	            ange: "⦤",
	            angle: "∠",
	            angmsd: "∡",
	            angmsdaa: "⦨",
	            angmsdab: "⦩",
	            angmsdac: "⦪",
	            angmsdad: "⦫",
	            angmsdae: "⦬",
	            angmsdaf: "⦭",
	            angmsdag: "⦮",
	            angmsdah: "⦯",
	            angrt: "∟",
	            angrtvb: "⊾",
	            angrtvbd: "⦝",
	            angsph: "∢",
	            angst: "Å",
	            angzarr: "⍼",
	            Aogon: "Ą",
	            aogon: "ą",
	            Aopf: "𝔸",
	            aopf: "𝕒",
	            ap: "≈",
	            apacir: "⩯",
	            apE: "⩰",
	            ape: "≊",
	            apid: "≋",
	            apos: "'",
	            ApplyFunction: "⁡",
	            approx: "≈",
	            approxeq: "≊",
	            Aring: "Å",
	            aring: "å",
	            Ascr: "𝒜",
	            ascr: "𝒶",
	            Assign: "≔",
	            ast: "*",
	            asymp: "≈",
	            asympeq: "≍",
	            Atilde: "Ã",
	            atilde: "ã",
	            Auml: "Ä",
	            auml: "ä",
	            awconint: "∳",
	            awint: "⨑",
	            backcong: "≌",
	            backepsilon: "϶",
	            backprime: "‵",
	            backsim: "∽",
	            backsimeq: "⋍",
	            Backslash: "∖",
	            Barv: "⫧",
	            barvee: "⊽",
	            Barwed: "⌆",
	            barwed: "⌅",
	            barwedge: "⌅",
	            bbrk: "⎵",
	            bbrktbrk: "⎶",
	            bcong: "≌",
	            Bcy: "Б",
	            bcy: "б",
	            bdquo: "„",
	            becaus: "∵",
	            Because: "∵",
	            because: "∵",
	            bemptyv: "⦰",
	            bepsi: "϶",
	            bernou: "ℬ",
	            Bernoullis: "ℬ",
	            Beta: "Β",
	            beta: "β",
	            beth: "ℶ",
	            between: "≬",
	            Bfr: "𝔅",
	            bfr: "𝔟",
	            bigcap: "⋂",
	            bigcirc: "◯",
	            bigcup: "⋃",
	            bigodot: "⨀",
	            bigoplus: "⨁",
	            bigotimes: "⨂",
	            bigsqcup: "⨆",
	            bigstar: "★",
	            bigtriangledown: "▽",
	            bigtriangleup: "△",
	            biguplus: "⨄",
	            bigvee: "⋁",
	            bigwedge: "⋀",
	            bkarow: "⤍",
	            blacklozenge: "⧫",
	            blacksquare: "▪",
	            blacktriangle: "▴",
	            blacktriangledown: "▾",
	            blacktriangleleft: "◂",
	            blacktriangleright: "▸",
	            blank: "␣",
	            blk12: "▒",
	            blk14: "░",
	            blk34: "▓",
	            block: "█",
	            bne: "=⃥",
	            bnequiv: "≡⃥",
	            bNot: "⫭",
	            bnot: "⌐",
	            Bopf: "𝔹",
	            bopf: "𝕓",
	            bot: "⊥",
	            bottom: "⊥",
	            bowtie: "⋈",
	            boxbox: "⧉",
	            boxDL: "╗",
	            boxDl: "╖",
	            boxdL: "╕",
	            boxdl: "┐",
	            boxDR: "╔",
	            boxDr: "╓",
	            boxdR: "╒",
	            boxdr: "┌",
	            boxH: "═",
	            boxh: "─",
	            boxHD: "╦",
	            boxHd: "╤",
	            boxhD: "╥",
	            boxhd: "┬",
	            boxHU: "╩",
	            boxHu: "╧",
	            boxhU: "╨",
	            boxhu: "┴",
	            boxminus: "⊟",
	            boxplus: "⊞",
	            boxtimes: "⊠",
	            boxUL: "╝",
	            boxUl: "╜",
	            boxuL: "╛",
	            boxul: "┘",
	            boxUR: "╚",
	            boxUr: "╙",
	            boxuR: "╘",
	            boxur: "└",
	            boxV: "║",
	            boxv: "│",
	            boxVH: "╬",
	            boxVh: "╫",
	            boxvH: "╪",
	            boxvh: "┼",
	            boxVL: "╣",
	            boxVl: "╢",
	            boxvL: "╡",
	            boxvl: "┤",
	            boxVR: "╠",
	            boxVr: "╟",
	            boxvR: "╞",
	            boxvr: "├",
	            bprime: "‵",
	            Breve: "˘",
	            breve: "˘",
	            brvbar: "¦",
	            Bscr: "ℬ",
	            bscr: "𝒷",
	            bsemi: "⁏",
	            bsim: "∽",
	            bsime: "⋍",
	            bsol: "\\",
	            bsolb: "⧅",
	            bsolhsub: "⟈",
	            bull: "•",
	            bullet: "•",
	            bump: "≎",
	            bumpE: "⪮",
	            bumpe: "≏",
	            Bumpeq: "≎",
	            bumpeq: "≏",
	            Cacute: "Ć",
	            cacute: "ć",
	            Cap: "⋒",
	            cap: "∩",
	            capand: "⩄",
	            capbrcup: "⩉",
	            capcap: "⩋",
	            capcup: "⩇",
	            capdot: "⩀",
	            CapitalDifferentialD: "ⅅ",
	            caps: "∩︀",
	            caret: "⁁",
	            caron: "ˇ",
	            Cayleys: "ℭ",
	            ccaps: "⩍",
	            Ccaron: "Č",
	            ccaron: "č",
	            Ccedil: "Ç",
	            ccedil: "ç",
	            Ccirc: "Ĉ",
	            ccirc: "ĉ",
	            Cconint: "∰",
	            ccups: "⩌",
	            ccupssm: "⩐",
	            Cdot: "Ċ",
	            cdot: "ċ",
	            cedil: "¸",
	            Cedilla: "¸",
	            cemptyv: "⦲",
	            cent: "¢",
	            CenterDot: "·",
	            centerdot: "·",
	            Cfr: "ℭ",
	            cfr: "𝔠",
	            CHcy: "Ч",
	            chcy: "ч",
	            check: "✓",
	            checkmark: "✓",
	            Chi: "Χ",
	            chi: "χ",
	            cir: "○",
	            circ: "ˆ",
	            circeq: "≗",
	            circlearrowleft: "↺",
	            circlearrowright: "↻",
	            circledast: "⊛",
	            circledcirc: "⊚",
	            circleddash: "⊝",
	            CircleDot: "⊙",
	            circledR: "®",
	            circledS: "Ⓢ",
	            CircleMinus: "⊖",
	            CirclePlus: "⊕",
	            CircleTimes: "⊗",
	            cirE: "⧃",
	            cire: "≗",
	            cirfnint: "⨐",
	            cirmid: "⫯",
	            cirscir: "⧂",
	            ClockwiseContourIntegral: "∲",
	            CloseCurlyDoubleQuote: "”",
	            CloseCurlyQuote: "’",
	            clubs: "♣",
	            clubsuit: "♣",
	            Colon: "∷",
	            colon: ":",
	            Colone: "⩴",
	            colone: "≔",
	            coloneq: "≔",
	            comma: ",",
	            commat: "@",
	            comp: "∁",
	            compfn: "∘",
	            complement: "∁",
	            complexes: "ℂ",
	            cong: "≅",
	            congdot: "⩭",
	            Congruent: "≡",
	            Conint: "∯",
	            conint: "∮",
	            ContourIntegral: "∮",
	            Copf: "ℂ",
	            copf: "𝕔",
	            coprod: "∐",
	            Coproduct: "∐",
	            COPY: "©",
	            copy: "©",
	            copysr: "℗",
	            CounterClockwiseContourIntegral: "∳",
	            crarr: "↵",
	            Cross: "⨯",
	            cross: "✗",
	            Cscr: "𝒞",
	            cscr: "𝒸",
	            csub: "⫏",
	            csube: "⫑",
	            csup: "⫐",
	            csupe: "⫒",
	            ctdot: "⋯",
	            cudarrl: "⤸",
	            cudarrr: "⤵",
	            cuepr: "⋞",
	            cuesc: "⋟",
	            cularr: "↶",
	            cularrp: "⤽",
	            Cup: "⋓",
	            cup: "∪",
	            cupbrcap: "⩈",
	            CupCap: "≍",
	            cupcap: "⩆",
	            cupcup: "⩊",
	            cupdot: "⊍",
	            cupor: "⩅",
	            cups: "∪︀",
	            curarr: "↷",
	            curarrm: "⤼",
	            curlyeqprec: "⋞",
	            curlyeqsucc: "⋟",
	            curlyvee: "⋎",
	            curlywedge: "⋏",
	            curren: "¤",
	            curvearrowleft: "↶",
	            curvearrowright: "↷",
	            cuvee: "⋎",
	            cuwed: "⋏",
	            cwconint: "∲",
	            cwint: "∱",
	            cylcty: "⌭",
	            Dagger: "‡",
	            dagger: "†",
	            daleth: "ℸ",
	            Darr: "↡",
	            dArr: "⇓",
	            darr: "↓",
	            dash: "‐",
	            Dashv: "⫤",
	            dashv: "⊣",
	            dbkarow: "⤏",
	            dblac: "˝",
	            Dcaron: "Ď",
	            dcaron: "ď",
	            Dcy: "Д",
	            dcy: "д",
	            DD: "ⅅ",
	            dd: "ⅆ",
	            ddagger: "‡",
	            ddarr: "⇊",
	            DDotrahd: "⤑",
	            ddotseq: "⩷",
	            deg: "°",
	            Del: "∇",
	            Delta: "Δ",
	            delta: "δ",
	            demptyv: "⦱",
	            dfisht: "⥿",
	            Dfr: "𝔇",
	            dfr: "𝔡",
	            dHar: "⥥",
	            dharl: "⇃",
	            dharr: "⇂",
	            DiacriticalAcute: "´",
	            DiacriticalDot: "˙",
	            DiacriticalDoubleAcute: "˝",
	            DiacriticalGrave: "`",
	            DiacriticalTilde: "˜",
	            diam: "⋄",
	            Diamond: "⋄",
	            diamond: "⋄",
	            diamondsuit: "♦",
	            diams: "♦",
	            die: "¨",
	            DifferentialD: "ⅆ",
	            digamma: "ϝ",
	            disin: "⋲",
	            div: "÷",
	            divide: "÷",
	            divideontimes: "⋇",
	            divonx: "⋇",
	            DJcy: "Ђ",
	            djcy: "ђ",
	            dlcorn: "⌞",
	            dlcrop: "⌍",
	            dollar: "$",
	            Dopf: "𝔻",
	            dopf: "𝕕",
	            Dot: "¨",
	            dot: "˙",
	            DotDot: "⃜",
	            doteq: "≐",
	            doteqdot: "≑",
	            DotEqual: "≐",
	            dotminus: "∸",
	            dotplus: "∔",
	            dotsquare: "⊡",
	            doublebarwedge: "⌆",
	            DoubleContourIntegral: "∯",
	            DoubleDot: "¨",
	            DoubleDownArrow: "⇓",
	            DoubleLeftArrow: "⇐",
	            DoubleLeftRightArrow: "⇔",
	            DoubleLeftTee: "⫤",
	            DoubleLongLeftArrow: "⟸",
	            DoubleLongLeftRightArrow: "⟺",
	            DoubleLongRightArrow: "⟹",
	            DoubleRightArrow: "⇒",
	            DoubleRightTee: "⊨",
	            DoubleUpArrow: "⇑",
	            DoubleUpDownArrow: "⇕",
	            DoubleVerticalBar: "∥",
	            DownArrow: "↓",
	            Downarrow: "⇓",
	            downarrow: "↓",
	            DownArrowBar: "⤓",
	            DownArrowUpArrow: "⇵",
	            DownBreve: "̑",
	            downdownarrows: "⇊",
	            downharpoonleft: "⇃",
	            downharpoonright: "⇂",
	            DownLeftRightVector: "⥐",
	            DownLeftTeeVector: "⥞",
	            DownLeftVector: "↽",
	            DownLeftVectorBar: "⥖",
	            DownRightTeeVector: "⥟",
	            DownRightVector: "⇁",
	            DownRightVectorBar: "⥗",
	            DownTee: "⊤",
	            DownTeeArrow: "↧",
	            drbkarow: "⤐",
	            drcorn: "⌟",
	            drcrop: "⌌",
	            Dscr: "𝒟",
	            dscr: "𝒹",
	            DScy: "Ѕ",
	            dscy: "ѕ",
	            dsol: "⧶",
	            Dstrok: "Đ",
	            dstrok: "đ",
	            dtdot: "⋱",
	            dtri: "▿",
	            dtrif: "▾",
	            duarr: "⇵",
	            duhar: "⥯",
	            dwangle: "⦦",
	            DZcy: "Џ",
	            dzcy: "џ",
	            dzigrarr: "⟿",
	            Eacute: "É",
	            eacute: "é",
	            easter: "⩮",
	            Ecaron: "Ě",
	            ecaron: "ě",
	            ecir: "≖",
	            Ecirc: "Ê",
	            ecirc: "ê",
	            ecolon: "≕",
	            Ecy: "Э",
	            ecy: "э",
	            eDDot: "⩷",
	            Edot: "Ė",
	            eDot: "≑",
	            edot: "ė",
	            ee: "ⅇ",
	            efDot: "≒",
	            Efr: "𝔈",
	            efr: "𝔢",
	            eg: "⪚",
	            Egrave: "È",
	            egrave: "è",
	            egs: "⪖",
	            egsdot: "⪘",
	            el: "⪙",
	            Element: "∈",
	            elinters: "⏧",
	            ell: "ℓ",
	            els: "⪕",
	            elsdot: "⪗",
	            Emacr: "Ē",
	            emacr: "ē",
	            empty: "∅",
	            emptyset: "∅",
	            EmptySmallSquare: "◻",
	            emptyv: "∅",
	            EmptyVerySmallSquare: "▫",
	            emsp: " ",
	            emsp13: " ",
	            emsp14: " ",
	            ENG: "Ŋ",
	            eng: "ŋ",
	            ensp: " ",
	            Eogon: "Ę",
	            eogon: "ę",
	            Eopf: "𝔼",
	            eopf: "𝕖",
	            epar: "⋕",
	            eparsl: "⧣",
	            eplus: "⩱",
	            epsi: "ε",
	            Epsilon: "Ε",
	            epsilon: "ε",
	            epsiv: "ϵ",
	            eqcirc: "≖",
	            eqcolon: "≕",
	            eqsim: "≂",
	            eqslantgtr: "⪖",
	            eqslantless: "⪕",
	            Equal: "⩵",
	            equals: "=",
	            EqualTilde: "≂",
	            equest: "≟",
	            Equilibrium: "⇌",
	            equiv: "≡",
	            equivDD: "⩸",
	            eqvparsl: "⧥",
	            erarr: "⥱",
	            erDot: "≓",
	            Escr: "ℰ",
	            escr: "ℯ",
	            esdot: "≐",
	            Esim: "⩳",
	            esim: "≂",
	            Eta: "Η",
	            eta: "η",
	            ETH: "Ð",
	            eth: "ð",
	            Euml: "Ë",
	            euml: "ë",
	            euro: "€",
	            excl: "!",
	            exist: "∃",
	            Exists: "∃",
	            expectation: "ℰ",
	            ExponentialE: "ⅇ",
	            exponentiale: "ⅇ",
	            fallingdotseq: "≒",
	            Fcy: "Ф",
	            fcy: "ф",
	            female: "♀",
	            ffilig: "ﬃ",
	            fflig: "ﬀ",
	            ffllig: "ﬄ",
	            Ffr: "𝔉",
	            ffr: "𝔣",
	            filig: "ﬁ",
	            FilledSmallSquare: "◼",
	            FilledVerySmallSquare: "▪",
	            fjlig: "fj",
	            flat: "♭",
	            fllig: "ﬂ",
	            fltns: "▱",
	            fnof: "ƒ",
	            Fopf: "𝔽",
	            fopf: "𝕗",
	            ForAll: "∀",
	            forall: "∀",
	            fork: "⋔",
	            forkv: "⫙",
	            Fouriertrf: "ℱ",
	            fpartint: "⨍",
	            frac12: "½",
	            frac13: "⅓",
	            frac14: "¼",
	            frac15: "⅕",
	            frac16: "⅙",
	            frac18: "⅛",
	            frac23: "⅔",
	            frac25: "⅖",
	            frac34: "¾",
	            frac35: "⅗",
	            frac38: "⅜",
	            frac45: "⅘",
	            frac56: "⅚",
	            frac58: "⅝",
	            frac78: "⅞",
	            frasl: "⁄",
	            frown: "⌢",
	            Fscr: "ℱ",
	            fscr: "𝒻",
	            gacute: "ǵ",
	            Gamma: "Γ",
	            gamma: "γ",
	            Gammad: "Ϝ",
	            gammad: "ϝ",
	            gap: "⪆",
	            Gbreve: "Ğ",
	            gbreve: "ğ",
	            Gcedil: "Ģ",
	            Gcirc: "Ĝ",
	            gcirc: "ĝ",
	            Gcy: "Г",
	            gcy: "г",
	            Gdot: "Ġ",
	            gdot: "ġ",
	            gE: "≧",
	            ge: "≥",
	            gEl: "⪌",
	            gel: "⋛",
	            geq: "≥",
	            geqq: "≧",
	            geqslant: "⩾",
	            ges: "⩾",
	            gescc: "⪩",
	            gesdot: "⪀",
	            gesdoto: "⪂",
	            gesdotol: "⪄",
	            gesl: "⋛︀",
	            gesles: "⪔",
	            Gfr: "𝔊",
	            gfr: "𝔤",
	            Gg: "⋙",
	            gg: "≫",
	            ggg: "⋙",
	            gimel: "ℷ",
	            GJcy: "Ѓ",
	            gjcy: "ѓ",
	            gl: "≷",
	            gla: "⪥",
	            glE: "⪒",
	            glj: "⪤",
	            gnap: "⪊",
	            gnapprox: "⪊",
	            gnE: "≩",
	            gne: "⪈",
	            gneq: "⪈",
	            gneqq: "≩",
	            gnsim: "⋧",
	            Gopf: "𝔾",
	            gopf: "𝕘",
	            grave: "`",
	            GreaterEqual: "≥",
	            GreaterEqualLess: "⋛",
	            GreaterFullEqual: "≧",
	            GreaterGreater: "⪢",
	            GreaterLess: "≷",
	            GreaterSlantEqual: "⩾",
	            GreaterTilde: "≳",
	            Gscr: "𝒢",
	            gscr: "ℊ",
	            gsim: "≳",
	            gsime: "⪎",
	            gsiml: "⪐",
	            Gt: "≫",
	            GT: ">",
	            gt: ">",
	            gtcc: "⪧",
	            gtcir: "⩺",
	            gtdot: "⋗",
	            gtlPar: "⦕",
	            gtquest: "⩼",
	            gtrapprox: "⪆",
	            gtrarr: "⥸",
	            gtrdot: "⋗",
	            gtreqless: "⋛",
	            gtreqqless: "⪌",
	            gtrless: "≷",
	            gtrsim: "≳",
	            gvertneqq: "≩︀",
	            gvnE: "≩︀",
	            Hacek: "ˇ",
	            hairsp: " ",
	            half: "½",
	            hamilt: "ℋ",
	            HARDcy: "Ъ",
	            hardcy: "ъ",
	            hArr: "⇔",
	            harr: "↔",
	            harrcir: "⥈",
	            harrw: "↭",
	            Hat: "^",
	            hbar: "ℏ",
	            Hcirc: "Ĥ",
	            hcirc: "ĥ",
	            hearts: "♥",
	            heartsuit: "♥",
	            hellip: "…",
	            hercon: "⊹",
	            Hfr: "ℌ",
	            hfr: "𝔥",
	            HilbertSpace: "ℋ",
	            hksearow: "⤥",
	            hkswarow: "⤦",
	            hoarr: "⇿",
	            homtht: "∻",
	            hookleftarrow: "↩",
	            hookrightarrow: "↪",
	            Hopf: "ℍ",
	            hopf: "𝕙",
	            horbar: "―",
	            HorizontalLine: "─",
	            Hscr: "ℋ",
	            hscr: "𝒽",
	            hslash: "ℏ",
	            Hstrok: "Ħ",
	            hstrok: "ħ",
	            HumpDownHump: "≎",
	            HumpEqual: "≏",
	            hybull: "⁃",
	            hyphen: "‐",
	            Iacute: "Í",
	            iacute: "í",
	            ic: "⁣",
	            Icirc: "Î",
	            icirc: "î",
	            Icy: "И",
	            icy: "и",
	            Idot: "İ",
	            IEcy: "Е",
	            iecy: "е",
	            iexcl: "¡",
	            iff: "⇔",
	            Ifr: "ℑ",
	            ifr: "𝔦",
	            Igrave: "Ì",
	            igrave: "ì",
	            ii: "ⅈ",
	            iiiint: "⨌",
	            iiint: "∭",
	            iinfin: "⧜",
	            iiota: "℩",
	            IJlig: "Ĳ",
	            ijlig: "ĳ",
	            Im: "ℑ",
	            Imacr: "Ī",
	            imacr: "ī",
	            image: "ℑ",
	            ImaginaryI: "ⅈ",
	            imagline: "ℐ",
	            imagpart: "ℑ",
	            imath: "ı",
	            imof: "⊷",
	            imped: "Ƶ",
	            Implies: "⇒",
	            in: "∈",
	            incare: "℅",
	            infin: "∞",
	            infintie: "⧝",
	            inodot: "ı",
	            Int: "∬",
	            int: "∫",
	            intcal: "⊺",
	            integers: "ℤ",
	            Integral: "∫",
	            intercal: "⊺",
	            Intersection: "⋂",
	            intlarhk: "⨗",
	            intprod: "⨼",
	            InvisibleComma: "⁣",
	            InvisibleTimes: "⁢",
	            IOcy: "Ё",
	            iocy: "ё",
	            Iogon: "Į",
	            iogon: "į",
	            Iopf: "𝕀",
	            iopf: "𝕚",
	            Iota: "Ι",
	            iota: "ι",
	            iprod: "⨼",
	            iquest: "¿",
	            Iscr: "ℐ",
	            iscr: "𝒾",
	            isin: "∈",
	            isindot: "⋵",
	            isinE: "⋹",
	            isins: "⋴",
	            isinsv: "⋳",
	            isinv: "∈",
	            it: "⁢",
	            Itilde: "Ĩ",
	            itilde: "ĩ",
	            Iukcy: "І",
	            iukcy: "і",
	            Iuml: "Ï",
	            iuml: "ï",
	            Jcirc: "Ĵ",
	            jcirc: "ĵ",
	            Jcy: "Й",
	            jcy: "й",
	            Jfr: "𝔍",
	            jfr: "𝔧",
	            jmath: "ȷ",
	            Jopf: "𝕁",
	            jopf: "𝕛",
	            Jscr: "𝒥",
	            jscr: "𝒿",
	            Jsercy: "Ј",
	            jsercy: "ј",
	            Jukcy: "Є",
	            jukcy: "є",
	            Kappa: "Κ",
	            kappa: "κ",
	            kappav: "ϰ",
	            Kcedil: "Ķ",
	            kcedil: "ķ",
	            Kcy: "К",
	            kcy: "к",
	            Kfr: "𝔎",
	            kfr: "𝔨",
	            kgreen: "ĸ",
	            KHcy: "Х",
	            khcy: "х",
	            KJcy: "Ќ",
	            kjcy: "ќ",
	            Kopf: "𝕂",
	            kopf: "𝕜",
	            Kscr: "𝒦",
	            kscr: "𝓀",
	            lAarr: "⇚",
	            Lacute: "Ĺ",
	            lacute: "ĺ",
	            laemptyv: "⦴",
	            lagran: "ℒ",
	            Lambda: "Λ",
	            lambda: "λ",
	            Lang: "⟪",
	            lang: "⟨",
	            langd: "⦑",
	            langle: "⟨",
	            lap: "⪅",
	            Laplacetrf: "ℒ",
	            laquo: "«",
	            Larr: "↞",
	            lArr: "⇐",
	            larr: "←",
	            larrb: "⇤",
	            larrbfs: "⤟",
	            larrfs: "⤝",
	            larrhk: "↩",
	            larrlp: "↫",
	            larrpl: "⤹",
	            larrsim: "⥳",
	            larrtl: "↢",
	            lat: "⪫",
	            lAtail: "⤛",
	            latail: "⤙",
	            late: "⪭",
	            lates: "⪭︀",
	            lBarr: "⤎",
	            lbarr: "⤌",
	            lbbrk: "❲",
	            lbrace: "{",
	            lbrack: "[",
	            lbrke: "⦋",
	            lbrksld: "⦏",
	            lbrkslu: "⦍",
	            Lcaron: "Ľ",
	            lcaron: "ľ",
	            Lcedil: "Ļ",
	            lcedil: "ļ",
	            lceil: "⌈",
	            lcub: "{",
	            Lcy: "Л",
	            lcy: "л",
	            ldca: "⤶",
	            ldquo: "“",
	            ldquor: "„",
	            ldrdhar: "⥧",
	            ldrushar: "⥋",
	            ldsh: "↲",
	            lE: "≦",
	            le: "≤",
	            LeftAngleBracket: "⟨",
	            LeftArrow: "←",
	            Leftarrow: "⇐",
	            leftarrow: "←",
	            LeftArrowBar: "⇤",
	            LeftArrowRightArrow: "⇆",
	            leftarrowtail: "↢",
	            LeftCeiling: "⌈",
	            LeftDoubleBracket: "⟦",
	            LeftDownTeeVector: "⥡",
	            LeftDownVector: "⇃",
	            LeftDownVectorBar: "⥙",
	            LeftFloor: "⌊",
	            leftharpoondown: "↽",
	            leftharpoonup: "↼",
	            leftleftarrows: "⇇",
	            LeftRightArrow: "↔",
	            Leftrightarrow: "⇔",
	            leftrightarrow: "↔",
	            leftrightarrows: "⇆",
	            leftrightharpoons: "⇋",
	            leftrightsquigarrow: "↭",
	            LeftRightVector: "⥎",
	            LeftTee: "⊣",
	            LeftTeeArrow: "↤",
	            LeftTeeVector: "⥚",
	            leftthreetimes: "⋋",
	            LeftTriangle: "⊲",
	            LeftTriangleBar: "⧏",
	            LeftTriangleEqual: "⊴",
	            LeftUpDownVector: "⥑",
	            LeftUpTeeVector: "⥠",
	            LeftUpVector: "↿",
	            LeftUpVectorBar: "⥘",
	            LeftVector: "↼",
	            LeftVectorBar: "⥒",
	            lEg: "⪋",
	            leg: "⋚",
	            leq: "≤",
	            leqq: "≦",
	            leqslant: "⩽",
	            les: "⩽",
	            lescc: "⪨",
	            lesdot: "⩿",
	            lesdoto: "⪁",
	            lesdotor: "⪃",
	            lesg: "⋚︀",
	            lesges: "⪓",
	            lessapprox: "⪅",
	            lessdot: "⋖",
	            lesseqgtr: "⋚",
	            lesseqqgtr: "⪋",
	            LessEqualGreater: "⋚",
	            LessFullEqual: "≦",
	            LessGreater: "≶",
	            lessgtr: "≶",
	            LessLess: "⪡",
	            lesssim: "≲",
	            LessSlantEqual: "⩽",
	            LessTilde: "≲",
	            lfisht: "⥼",
	            lfloor: "⌊",
	            Lfr: "𝔏",
	            lfr: "𝔩",
	            lg: "≶",
	            lgE: "⪑",
	            lHar: "⥢",
	            lhard: "↽",
	            lharu: "↼",
	            lharul: "⥪",
	            lhblk: "▄",
	            LJcy: "Љ",
	            ljcy: "љ",
	            Ll: "⋘",
	            ll: "≪",
	            llarr: "⇇",
	            llcorner: "⌞",
	            Lleftarrow: "⇚",
	            llhard: "⥫",
	            lltri: "◺",
	            Lmidot: "Ŀ",
	            lmidot: "ŀ",
	            lmoust: "⎰",
	            lmoustache: "⎰",
	            lnap: "⪉",
	            lnapprox: "⪉",
	            lnE: "≨",
	            lne: "⪇",
	            lneq: "⪇",
	            lneqq: "≨",
	            lnsim: "⋦",
	            loang: "⟬",
	            loarr: "⇽",
	            lobrk: "⟦",
	            LongLeftArrow: "⟵",
	            Longleftarrow: "⟸",
	            longleftarrow: "⟵",
	            LongLeftRightArrow: "⟷",
	            Longleftrightarrow: "⟺",
	            longleftrightarrow: "⟷",
	            longmapsto: "⟼",
	            LongRightArrow: "⟶",
	            Longrightarrow: "⟹",
	            longrightarrow: "⟶",
	            looparrowleft: "↫",
	            looparrowright: "↬",
	            lopar: "⦅",
	            Lopf: "𝕃",
	            lopf: "𝕝",
	            loplus: "⨭",
	            lotimes: "⨴",
	            lowast: "∗",
	            lowbar: "_",
	            LowerLeftArrow: "↙",
	            LowerRightArrow: "↘",
	            loz: "◊",
	            lozenge: "◊",
	            lozf: "⧫",
	            lpar: "(",
	            lparlt: "⦓",
	            lrarr: "⇆",
	            lrcorner: "⌟",
	            lrhar: "⇋",
	            lrhard: "⥭",
	            lrm: "‎",
	            lrtri: "⊿",
	            lsaquo: "‹",
	            Lscr: "ℒ",
	            lscr: "𝓁",
	            Lsh: "↰",
	            lsh: "↰",
	            lsim: "≲",
	            lsime: "⪍",
	            lsimg: "⪏",
	            lsqb: "[",
	            lsquo: "‘",
	            lsquor: "‚",
	            Lstrok: "Ł",
	            lstrok: "ł",
	            Lt: "≪",
	            LT: "<",
	            lt: "<",
	            ltcc: "⪦",
	            ltcir: "⩹",
	            ltdot: "⋖",
	            lthree: "⋋",
	            ltimes: "⋉",
	            ltlarr: "⥶",
	            ltquest: "⩻",
	            ltri: "◃",
	            ltrie: "⊴",
	            ltrif: "◂",
	            ltrPar: "⦖",
	            lurdshar: "⥊",
	            luruhar: "⥦",
	            lvertneqq: "≨︀",
	            lvnE: "≨︀",
	            macr: "¯",
	            male: "♂",
	            malt: "✠",
	            maltese: "✠",
	            Map: "⤅",
	            map: "↦",
	            mapsto: "↦",
	            mapstodown: "↧",
	            mapstoleft: "↤",
	            mapstoup: "↥",
	            marker: "▮",
	            mcomma: "⨩",
	            Mcy: "М",
	            mcy: "м",
	            mdash: "—",
	            mDDot: "∺",
	            measuredangle: "∡",
	            MediumSpace: " ",
	            Mellintrf: "ℳ",
	            Mfr: "𝔐",
	            mfr: "𝔪",
	            mho: "℧",
	            micro: "µ",
	            mid: "∣",
	            midast: "*",
	            midcir: "⫰",
	            middot: "·",
	            minus: "−",
	            minusb: "⊟",
	            minusd: "∸",
	            minusdu: "⨪",
	            MinusPlus: "∓",
	            mlcp: "⫛",
	            mldr: "…",
	            mnplus: "∓",
	            models: "⊧",
	            Mopf: "𝕄",
	            mopf: "𝕞",
	            mp: "∓",
	            Mscr: "ℳ",
	            mscr: "𝓂",
	            mstpos: "∾",
	            Mu: "Μ",
	            mu: "μ",
	            multimap: "⊸",
	            mumap: "⊸",
	            nabla: "∇",
	            Nacute: "Ń",
	            nacute: "ń",
	            nang: "∠⃒",
	            nap: "≉",
	            napE: "⩰̸",
	            napid: "≋̸",
	            napos: "ŉ",
	            napprox: "≉",
	            natur: "♮",
	            natural: "♮",
	            naturals: "ℕ",
	            nbsp: " ",
	            nbump: "≎̸",
	            nbumpe: "≏̸",
	            ncap: "⩃",
	            Ncaron: "Ň",
	            ncaron: "ň",
	            Ncedil: "Ņ",
	            ncedil: "ņ",
	            ncong: "≇",
	            ncongdot: "⩭̸",
	            ncup: "⩂",
	            Ncy: "Н",
	            ncy: "н",
	            ndash: "–",
	            ne: "≠",
	            nearhk: "⤤",
	            neArr: "⇗",
	            nearr: "↗",
	            nearrow: "↗",
	            nedot: "≐̸",
	            NegativeMediumSpace: "​",
	            NegativeThickSpace: "​",
	            NegativeThinSpace: "​",
	            NegativeVeryThinSpace: "​",
	            nequiv: "≢",
	            nesear: "⤨",
	            nesim: "≂̸",
	            NestedGreaterGreater: "≫",
	            NestedLessLess: "≪",
	            NewLine: "\n",
	            nexist: "∄",
	            nexists: "∄",
	            Nfr: "𝔑",
	            nfr: "𝔫",
	            ngE: "≧̸",
	            nge: "≱",
	            ngeq: "≱",
	            ngeqq: "≧̸",
	            ngeqslant: "⩾̸",
	            nges: "⩾̸",
	            nGg: "⋙̸",
	            ngsim: "≵",
	            nGt: "≫⃒",
	            ngt: "≯",
	            ngtr: "≯",
	            nGtv: "≫̸",
	            nhArr: "⇎",
	            nharr: "↮",
	            nhpar: "⫲",
	            ni: "∋",
	            nis: "⋼",
	            nisd: "⋺",
	            niv: "∋",
	            NJcy: "Њ",
	            njcy: "њ",
	            nlArr: "⇍",
	            nlarr: "↚",
	            nldr: "‥",
	            nlE: "≦̸",
	            nle: "≰",
	            nLeftarrow: "⇍",
	            nleftarrow: "↚",
	            nLeftrightarrow: "⇎",
	            nleftrightarrow: "↮",
	            nleq: "≰",
	            nleqq: "≦̸",
	            nleqslant: "⩽̸",
	            nles: "⩽̸",
	            nless: "≮",
	            nLl: "⋘̸",
	            nlsim: "≴",
	            nLt: "≪⃒",
	            nlt: "≮",
	            nltri: "⋪",
	            nltrie: "⋬",
	            nLtv: "≪̸",
	            nmid: "∤",
	            NoBreak: "⁠",
	            NonBreakingSpace: " ",
	            Nopf: "ℕ",
	            nopf: "𝕟",
	            Not: "⫬",
	            not: "¬",
	            NotCongruent: "≢",
	            NotCupCap: "≭",
	            NotDoubleVerticalBar: "∦",
	            NotElement: "∉",
	            NotEqual: "≠",
	            NotEqualTilde: "≂̸",
	            NotExists: "∄",
	            NotGreater: "≯",
	            NotGreaterEqual: "≱",
	            NotGreaterFullEqual: "≧̸",
	            NotGreaterGreater: "≫̸",
	            NotGreaterLess: "≹",
	            NotGreaterSlantEqual: "⩾̸",
	            NotGreaterTilde: "≵",
	            NotHumpDownHump: "≎̸",
	            NotHumpEqual: "≏̸",
	            notin: "∉",
	            notindot: "⋵̸",
	            notinE: "⋹̸",
	            notinva: "∉",
	            notinvb: "⋷",
	            notinvc: "⋶",
	            NotLeftTriangle: "⋪",
	            NotLeftTriangleBar: "⧏̸",
	            NotLeftTriangleEqual: "⋬",
	            NotLess: "≮",
	            NotLessEqual: "≰",
	            NotLessGreater: "≸",
	            NotLessLess: "≪̸",
	            NotLessSlantEqual: "⩽̸",
	            NotLessTilde: "≴",
	            NotNestedGreaterGreater: "⪢̸",
	            NotNestedLessLess: "⪡̸",
	            notni: "∌",
	            notniva: "∌",
	            notnivb: "⋾",
	            notnivc: "⋽",
	            NotPrecedes: "⊀",
	            NotPrecedesEqual: "⪯̸",
	            NotPrecedesSlantEqual: "⋠",
	            NotReverseElement: "∌",
	            NotRightTriangle: "⋫",
	            NotRightTriangleBar: "⧐̸",
	            NotRightTriangleEqual: "⋭",
	            NotSquareSubset: "⊏̸",
	            NotSquareSubsetEqual: "⋢",
	            NotSquareSuperset: "⊐̸",
	            NotSquareSupersetEqual: "⋣",
	            NotSubset: "⊂⃒",
	            NotSubsetEqual: "⊈",
	            NotSucceeds: "⊁",
	            NotSucceedsEqual: "⪰̸",
	            NotSucceedsSlantEqual: "⋡",
	            NotSucceedsTilde: "≿̸",
	            NotSuperset: "⊃⃒",
	            NotSupersetEqual: "⊉",
	            NotTilde: "≁",
	            NotTildeEqual: "≄",
	            NotTildeFullEqual: "≇",
	            NotTildeTilde: "≉",
	            NotVerticalBar: "∤",
	            npar: "∦",
	            nparallel: "∦",
	            nparsl: "⫽⃥",
	            npart: "∂̸",
	            npolint: "⨔",
	            npr: "⊀",
	            nprcue: "⋠",
	            npre: "⪯̸",
	            nprec: "⊀",
	            npreceq: "⪯̸",
	            nrArr: "⇏",
	            nrarr: "↛",
	            nrarrc: "⤳̸",
	            nrarrw: "↝̸",
	            nRightarrow: "⇏",
	            nrightarrow: "↛",
	            nrtri: "⋫",
	            nrtrie: "⋭",
	            nsc: "⊁",
	            nsccue: "⋡",
	            nsce: "⪰̸",
	            Nscr: "𝒩",
	            nscr: "𝓃",
	            nshortmid: "∤",
	            nshortparallel: "∦",
	            nsim: "≁",
	            nsime: "≄",
	            nsimeq: "≄",
	            nsmid: "∤",
	            nspar: "∦",
	            nsqsube: "⋢",
	            nsqsupe: "⋣",
	            nsub: "⊄",
	            nsubE: "⫅̸",
	            nsube: "⊈",
	            nsubset: "⊂⃒",
	            nsubseteq: "⊈",
	            nsubseteqq: "⫅̸",
	            nsucc: "⊁",
	            nsucceq: "⪰̸",
	            nsup: "⊅",
	            nsupE: "⫆̸",
	            nsupe: "⊉",
	            nsupset: "⊃⃒",
	            nsupseteq: "⊉",
	            nsupseteqq: "⫆̸",
	            ntgl: "≹",
	            Ntilde: "Ñ",
	            ntilde: "ñ",
	            ntlg: "≸",
	            ntriangleleft: "⋪",
	            ntrianglelefteq: "⋬",
	            ntriangleright: "⋫",
	            ntrianglerighteq: "⋭",
	            Nu: "Ν",
	            nu: "ν",
	            num: "#",
	            numero: "№",
	            numsp: " ",
	            nvap: "≍⃒",
	            nVDash: "⊯",
	            nVdash: "⊮",
	            nvDash: "⊭",
	            nvdash: "⊬",
	            nvge: "≥⃒",
	            nvgt: ">⃒",
	            nvHarr: "⤄",
	            nvinfin: "⧞",
	            nvlArr: "⤂",
	            nvle: "≤⃒",
	            nvlt: "<⃒",
	            nvltrie: "⊴⃒",
	            nvrArr: "⤃",
	            nvrtrie: "⊵⃒",
	            nvsim: "∼⃒",
	            nwarhk: "⤣",
	            nwArr: "⇖",
	            nwarr: "↖",
	            nwarrow: "↖",
	            nwnear: "⤧",
	            Oacute: "Ó",
	            oacute: "ó",
	            oast: "⊛",
	            ocir: "⊚",
	            Ocirc: "Ô",
	            ocirc: "ô",
	            Ocy: "О",
	            ocy: "о",
	            odash: "⊝",
	            Odblac: "Ő",
	            odblac: "ő",
	            odiv: "⨸",
	            odot: "⊙",
	            odsold: "⦼",
	            OElig: "Œ",
	            oelig: "œ",
	            ofcir: "⦿",
	            Ofr: "𝔒",
	            ofr: "𝔬",
	            ogon: "˛",
	            Ograve: "Ò",
	            ograve: "ò",
	            ogt: "⧁",
	            ohbar: "⦵",
	            ohm: "Ω",
	            oint: "∮",
	            olarr: "↺",
	            olcir: "⦾",
	            olcross: "⦻",
	            oline: "‾",
	            olt: "⧀",
	            Omacr: "Ō",
	            omacr: "ō",
	            Omega: "Ω",
	            omega: "ω",
	            Omicron: "Ο",
	            omicron: "ο",
	            omid: "⦶",
	            ominus: "⊖",
	            Oopf: "𝕆",
	            oopf: "𝕠",
	            opar: "⦷",
	            OpenCurlyDoubleQuote: "“",
	            OpenCurlyQuote: "‘",
	            operp: "⦹",
	            oplus: "⊕",
	            Or: "⩔",
	            or: "∨",
	            orarr: "↻",
	            ord: "⩝",
	            order: "ℴ",
	            orderof: "ℴ",
	            ordf: "ª",
	            ordm: "º",
	            origof: "⊶",
	            oror: "⩖",
	            orslope: "⩗",
	            orv: "⩛",
	            oS: "Ⓢ",
	            Oscr: "𝒪",
	            oscr: "ℴ",
	            Oslash: "Ø",
	            oslash: "ø",
	            osol: "⊘",
	            Otilde: "Õ",
	            otilde: "õ",
	            Otimes: "⨷",
	            otimes: "⊗",
	            otimesas: "⨶",
	            Ouml: "Ö",
	            ouml: "ö",
	            ovbar: "⌽",
	            OverBar: "‾",
	            OverBrace: "⏞",
	            OverBracket: "⎴",
	            OverParenthesis: "⏜",
	            par: "∥",
	            para: "¶",
	            parallel: "∥",
	            parsim: "⫳",
	            parsl: "⫽",
	            part: "∂",
	            PartialD: "∂",
	            Pcy: "П",
	            pcy: "п",
	            percnt: "%",
	            period: ".",
	            permil: "‰",
	            perp: "⊥",
	            pertenk: "‱",
	            Pfr: "𝔓",
	            pfr: "𝔭",
	            Phi: "Φ",
	            phi: "φ",
	            phiv: "ϕ",
	            phmmat: "ℳ",
	            phone: "☎",
	            Pi: "Π",
	            pi: "π",
	            pitchfork: "⋔",
	            piv: "ϖ",
	            planck: "ℏ",
	            planckh: "ℎ",
	            plankv: "ℏ",
	            plus: "+",
	            plusacir: "⨣",
	            plusb: "⊞",
	            pluscir: "⨢",
	            plusdo: "∔",
	            plusdu: "⨥",
	            pluse: "⩲",
	            PlusMinus: "±",
	            plusmn: "±",
	            plussim: "⨦",
	            plustwo: "⨧",
	            pm: "±",
	            Poincareplane: "ℌ",
	            pointint: "⨕",
	            Popf: "ℙ",
	            popf: "𝕡",
	            pound: "£",
	            Pr: "⪻",
	            pr: "≺",
	            prap: "⪷",
	            prcue: "≼",
	            prE: "⪳",
	            pre: "⪯",
	            prec: "≺",
	            precapprox: "⪷",
	            preccurlyeq: "≼",
	            Precedes: "≺",
	            PrecedesEqual: "⪯",
	            PrecedesSlantEqual: "≼",
	            PrecedesTilde: "≾",
	            preceq: "⪯",
	            precnapprox: "⪹",
	            precneqq: "⪵",
	            precnsim: "⋨",
	            precsim: "≾",
	            Prime: "″",
	            prime: "′",
	            primes: "ℙ",
	            prnap: "⪹",
	            prnE: "⪵",
	            prnsim: "⋨",
	            prod: "∏",
	            Product: "∏",
	            profalar: "⌮",
	            profline: "⌒",
	            profsurf: "⌓",
	            prop: "∝",
	            Proportion: "∷",
	            Proportional: "∝",
	            propto: "∝",
	            prsim: "≾",
	            prurel: "⊰",
	            Pscr: "𝒫",
	            pscr: "𝓅",
	            Psi: "Ψ",
	            psi: "ψ",
	            puncsp: " ",
	            Qfr: "𝔔",
	            qfr: "𝔮",
	            qint: "⨌",
	            Qopf: "ℚ",
	            qopf: "𝕢",
	            qprime: "⁗",
	            Qscr: "𝒬",
	            qscr: "𝓆",
	            quaternions: "ℍ",
	            quatint: "⨖",
	            quest: "?",
	            questeq: "≟",
	            QUOT: '"',
	            quot: '"',
	            rAarr: "⇛",
	            race: "∽̱",
	            Racute: "Ŕ",
	            racute: "ŕ",
	            radic: "√",
	            raemptyv: "⦳",
	            Rang: "⟫",
	            rang: "⟩",
	            rangd: "⦒",
	            range: "⦥",
	            rangle: "⟩",
	            raquo: "»",
	            Rarr: "↠",
	            rArr: "⇒",
	            rarr: "→",
	            rarrap: "⥵",
	            rarrb: "⇥",
	            rarrbfs: "⤠",
	            rarrc: "⤳",
	            rarrfs: "⤞",
	            rarrhk: "↪",
	            rarrlp: "↬",
	            rarrpl: "⥅",
	            rarrsim: "⥴",
	            Rarrtl: "⤖",
	            rarrtl: "↣",
	            rarrw: "↝",
	            rAtail: "⤜",
	            ratail: "⤚",
	            ratio: "∶",
	            rationals: "ℚ",
	            RBarr: "⤐",
	            rBarr: "⤏",
	            rbarr: "⤍",
	            rbbrk: "❳",
	            rbrace: "}",
	            rbrack: "]",
	            rbrke: "⦌",
	            rbrksld: "⦎",
	            rbrkslu: "⦐",
	            Rcaron: "Ř",
	            rcaron: "ř",
	            Rcedil: "Ŗ",
	            rcedil: "ŗ",
	            rceil: "⌉",
	            rcub: "}",
	            Rcy: "Р",
	            rcy: "р",
	            rdca: "⤷",
	            rdldhar: "⥩",
	            rdquo: "”",
	            rdquor: "”",
	            rdsh: "↳",
	            Re: "ℜ",
	            real: "ℜ",
	            realine: "ℛ",
	            realpart: "ℜ",
	            reals: "ℝ",
	            rect: "▭",
	            REG: "®",
	            reg: "®",
	            ReverseElement: "∋",
	            ReverseEquilibrium: "⇋",
	            ReverseUpEquilibrium: "⥯",
	            rfisht: "⥽",
	            rfloor: "⌋",
	            Rfr: "ℜ",
	            rfr: "𝔯",
	            rHar: "⥤",
	            rhard: "⇁",
	            rharu: "⇀",
	            rharul: "⥬",
	            Rho: "Ρ",
	            rho: "ρ",
	            rhov: "ϱ",
	            RightAngleBracket: "⟩",
	            RightArrow: "→",
	            Rightarrow: "⇒",
	            rightarrow: "→",
	            RightArrowBar: "⇥",
	            RightArrowLeftArrow: "⇄",
	            rightarrowtail: "↣",
	            RightCeiling: "⌉",
	            RightDoubleBracket: "⟧",
	            RightDownTeeVector: "⥝",
	            RightDownVector: "⇂",
	            RightDownVectorBar: "⥕",
	            RightFloor: "⌋",
	            rightharpoondown: "⇁",
	            rightharpoonup: "⇀",
	            rightleftarrows: "⇄",
	            rightleftharpoons: "⇌",
	            rightrightarrows: "⇉",
	            rightsquigarrow: "↝",
	            RightTee: "⊢",
	            RightTeeArrow: "↦",
	            RightTeeVector: "⥛",
	            rightthreetimes: "⋌",
	            RightTriangle: "⊳",
	            RightTriangleBar: "⧐",
	            RightTriangleEqual: "⊵",
	            RightUpDownVector: "⥏",
	            RightUpTeeVector: "⥜",
	            RightUpVector: "↾",
	            RightUpVectorBar: "⥔",
	            RightVector: "⇀",
	            RightVectorBar: "⥓",
	            ring: "˚",
	            risingdotseq: "≓",
	            rlarr: "⇄",
	            rlhar: "⇌",
	            rlm: "‏",
	            rmoust: "⎱",
	            rmoustache: "⎱",
	            rnmid: "⫮",
	            roang: "⟭",
	            roarr: "⇾",
	            robrk: "⟧",
	            ropar: "⦆",
	            Ropf: "ℝ",
	            ropf: "𝕣",
	            roplus: "⨮",
	            rotimes: "⨵",
	            RoundImplies: "⥰",
	            rpar: ")",
	            rpargt: "⦔",
	            rppolint: "⨒",
	            rrarr: "⇉",
	            Rrightarrow: "⇛",
	            rsaquo: "›",
	            Rscr: "ℛ",
	            rscr: "𝓇",
	            Rsh: "↱",
	            rsh: "↱",
	            rsqb: "]",
	            rsquo: "’",
	            rsquor: "’",
	            rthree: "⋌",
	            rtimes: "⋊",
	            rtri: "▹",
	            rtrie: "⊵",
	            rtrif: "▸",
	            rtriltri: "⧎",
	            RuleDelayed: "⧴",
	            ruluhar: "⥨",
	            rx: "℞",
	            Sacute: "Ś",
	            sacute: "ś",
	            sbquo: "‚",
	            Sc: "⪼",
	            sc: "≻",
	            scap: "⪸",
	            Scaron: "Š",
	            scaron: "š",
	            sccue: "≽",
	            scE: "⪴",
	            sce: "⪰",
	            Scedil: "Ş",
	            scedil: "ş",
	            Scirc: "Ŝ",
	            scirc: "ŝ",
	            scnap: "⪺",
	            scnE: "⪶",
	            scnsim: "⋩",
	            scpolint: "⨓",
	            scsim: "≿",
	            Scy: "С",
	            scy: "с",
	            sdot: "⋅",
	            sdotb: "⊡",
	            sdote: "⩦",
	            searhk: "⤥",
	            seArr: "⇘",
	            searr: "↘",
	            searrow: "↘",
	            sect: "§",
	            semi: ";",
	            seswar: "⤩",
	            setminus: "∖",
	            setmn: "∖",
	            sext: "✶",
	            Sfr: "𝔖",
	            sfr: "𝔰",
	            sfrown: "⌢",
	            sharp: "♯",
	            SHCHcy: "Щ",
	            shchcy: "щ",
	            SHcy: "Ш",
	            shcy: "ш",
	            ShortDownArrow: "↓",
	            ShortLeftArrow: "←",
	            shortmid: "∣",
	            shortparallel: "∥",
	            ShortRightArrow: "→",
	            ShortUpArrow: "↑",
	            shy: "­",
	            Sigma: "Σ",
	            sigma: "σ",
	            sigmaf: "ς",
	            sigmav: "ς",
	            sim: "∼",
	            simdot: "⩪",
	            sime: "≃",
	            simeq: "≃",
	            simg: "⪞",
	            simgE: "⪠",
	            siml: "⪝",
	            simlE: "⪟",
	            simne: "≆",
	            simplus: "⨤",
	            simrarr: "⥲",
	            slarr: "←",
	            SmallCircle: "∘",
	            smallsetminus: "∖",
	            smashp: "⨳",
	            smeparsl: "⧤",
	            smid: "∣",
	            smile: "⌣",
	            smt: "⪪",
	            smte: "⪬",
	            smtes: "⪬︀",
	            SOFTcy: "Ь",
	            softcy: "ь",
	            sol: "/",
	            solb: "⧄",
	            solbar: "⌿",
	            Sopf: "𝕊",
	            sopf: "𝕤",
	            spades: "♠",
	            spadesuit: "♠",
	            spar: "∥",
	            sqcap: "⊓",
	            sqcaps: "⊓︀",
	            sqcup: "⊔",
	            sqcups: "⊔︀",
	            Sqrt: "√",
	            sqsub: "⊏",
	            sqsube: "⊑",
	            sqsubset: "⊏",
	            sqsubseteq: "⊑",
	            sqsup: "⊐",
	            sqsupe: "⊒",
	            sqsupset: "⊐",
	            sqsupseteq: "⊒",
	            squ: "□",
	            Square: "□",
	            square: "□",
	            SquareIntersection: "⊓",
	            SquareSubset: "⊏",
	            SquareSubsetEqual: "⊑",
	            SquareSuperset: "⊐",
	            SquareSupersetEqual: "⊒",
	            SquareUnion: "⊔",
	            squarf: "▪",
	            squf: "▪",
	            srarr: "→",
	            Sscr: "𝒮",
	            sscr: "𝓈",
	            ssetmn: "∖",
	            ssmile: "⌣",
	            sstarf: "⋆",
	            Star: "⋆",
	            star: "☆",
	            starf: "★",
	            straightepsilon: "ϵ",
	            straightphi: "ϕ",
	            strns: "¯",
	            Sub: "⋐",
	            sub: "⊂",
	            subdot: "⪽",
	            subE: "⫅",
	            sube: "⊆",
	            subedot: "⫃",
	            submult: "⫁",
	            subnE: "⫋",
	            subne: "⊊",
	            subplus: "⪿",
	            subrarr: "⥹",
	            Subset: "⋐",
	            subset: "⊂",
	            subseteq: "⊆",
	            subseteqq: "⫅",
	            SubsetEqual: "⊆",
	            subsetneq: "⊊",
	            subsetneqq: "⫋",
	            subsim: "⫇",
	            subsub: "⫕",
	            subsup: "⫓",
	            succ: "≻",
	            succapprox: "⪸",
	            succcurlyeq: "≽",
	            Succeeds: "≻",
	            SucceedsEqual: "⪰",
	            SucceedsSlantEqual: "≽",
	            SucceedsTilde: "≿",
	            succeq: "⪰",
	            succnapprox: "⪺",
	            succneqq: "⪶",
	            succnsim: "⋩",
	            succsim: "≿",
	            SuchThat: "∋",
	            Sum: "∑",
	            sum: "∑",
	            sung: "♪",
	            Sup: "⋑",
	            sup: "⊃",
	            sup1: "¹",
	            sup2: "²",
	            sup3: "³",
	            supdot: "⪾",
	            supdsub: "⫘",
	            supE: "⫆",
	            supe: "⊇",
	            supedot: "⫄",
	            Superset: "⊃",
	            SupersetEqual: "⊇",
	            suphsol: "⟉",
	            suphsub: "⫗",
	            suplarr: "⥻",
	            supmult: "⫂",
	            supnE: "⫌",
	            supne: "⊋",
	            supplus: "⫀",
	            Supset: "⋑",
	            supset: "⊃",
	            supseteq: "⊇",
	            supseteqq: "⫆",
	            supsetneq: "⊋",
	            supsetneqq: "⫌",
	            supsim: "⫈",
	            supsub: "⫔",
	            supsup: "⫖",
	            swarhk: "⤦",
	            swArr: "⇙",
	            swarr: "↙",
	            swarrow: "↙",
	            swnwar: "⤪",
	            szlig: "ß",
	            Tab: "	",
	            target: "⌖",
	            Tau: "Τ",
	            tau: "τ",
	            tbrk: "⎴",
	            Tcaron: "Ť",
	            tcaron: "ť",
	            Tcedil: "Ţ",
	            tcedil: "ţ",
	            Tcy: "Т",
	            tcy: "т",
	            tdot: "⃛",
	            telrec: "⌕",
	            Tfr: "𝔗",
	            tfr: "𝔱",
	            there4: "∴",
	            Therefore: "∴",
	            therefore: "∴",
	            Theta: "Θ",
	            theta: "θ",
	            thetasym: "ϑ",
	            thetav: "ϑ",
	            thickapprox: "≈",
	            thicksim: "∼",
	            ThickSpace: "  ",
	            thinsp: " ",
	            ThinSpace: " ",
	            thkap: "≈",
	            thksim: "∼",
	            THORN: "Þ",
	            thorn: "þ",
	            Tilde: "∼",
	            tilde: "˜",
	            TildeEqual: "≃",
	            TildeFullEqual: "≅",
	            TildeTilde: "≈",
	            times: "×",
	            timesb: "⊠",
	            timesbar: "⨱",
	            timesd: "⨰",
	            tint: "∭",
	            toea: "⤨",
	            top: "⊤",
	            topbot: "⌶",
	            topcir: "⫱",
	            Topf: "𝕋",
	            topf: "𝕥",
	            topfork: "⫚",
	            tosa: "⤩",
	            tprime: "‴",
	            TRADE: "™",
	            trade: "™",
	            triangle: "▵",
	            triangledown: "▿",
	            triangleleft: "◃",
	            trianglelefteq: "⊴",
	            triangleq: "≜",
	            triangleright: "▹",
	            trianglerighteq: "⊵",
	            tridot: "◬",
	            trie: "≜",
	            triminus: "⨺",
	            TripleDot: "⃛",
	            triplus: "⨹",
	            trisb: "⧍",
	            tritime: "⨻",
	            trpezium: "⏢",
	            Tscr: "𝒯",
	            tscr: "𝓉",
	            TScy: "Ц",
	            tscy: "ц",
	            TSHcy: "Ћ",
	            tshcy: "ћ",
	            Tstrok: "Ŧ",
	            tstrok: "ŧ",
	            twixt: "≬",
	            twoheadleftarrow: "↞",
	            twoheadrightarrow: "↠",
	            Uacute: "Ú",
	            uacute: "ú",
	            Uarr: "↟",
	            uArr: "⇑",
	            uarr: "↑",
	            Uarrocir: "⥉",
	            Ubrcy: "Ў",
	            ubrcy: "ў",
	            Ubreve: "Ŭ",
	            ubreve: "ŭ",
	            Ucirc: "Û",
	            ucirc: "û",
	            Ucy: "У",
	            ucy: "у",
	            udarr: "⇅",
	            Udblac: "Ű",
	            udblac: "ű",
	            udhar: "⥮",
	            ufisht: "⥾",
	            Ufr: "𝔘",
	            ufr: "𝔲",
	            Ugrave: "Ù",
	            ugrave: "ù",
	            uHar: "⥣",
	            uharl: "↿",
	            uharr: "↾",
	            uhblk: "▀",
	            ulcorn: "⌜",
	            ulcorner: "⌜",
	            ulcrop: "⌏",
	            ultri: "◸",
	            Umacr: "Ū",
	            umacr: "ū",
	            uml: "¨",
	            UnderBar: "_",
	            UnderBrace: "⏟",
	            UnderBracket: "⎵",
	            UnderParenthesis: "⏝",
	            Union: "⋃",
	            UnionPlus: "⊎",
	            Uogon: "Ų",
	            uogon: "ų",
	            Uopf: "𝕌",
	            uopf: "𝕦",
	            UpArrow: "↑",
	            Uparrow: "⇑",
	            uparrow: "↑",
	            UpArrowBar: "⤒",
	            UpArrowDownArrow: "⇅",
	            UpDownArrow: "↕",
	            Updownarrow: "⇕",
	            updownarrow: "↕",
	            UpEquilibrium: "⥮",
	            upharpoonleft: "↿",
	            upharpoonright: "↾",
	            uplus: "⊎",
	            UpperLeftArrow: "↖",
	            UpperRightArrow: "↗",
	            Upsi: "ϒ",
	            upsi: "υ",
	            upsih: "ϒ",
	            Upsilon: "Υ",
	            upsilon: "υ",
	            UpTee: "⊥",
	            UpTeeArrow: "↥",
	            upuparrows: "⇈",
	            urcorn: "⌝",
	            urcorner: "⌝",
	            urcrop: "⌎",
	            Uring: "Ů",
	            uring: "ů",
	            urtri: "◹",
	            Uscr: "𝒰",
	            uscr: "𝓊",
	            utdot: "⋰",
	            Utilde: "Ũ",
	            utilde: "ũ",
	            utri: "▵",
	            utrif: "▴",
	            uuarr: "⇈",
	            Uuml: "Ü",
	            uuml: "ü",
	            uwangle: "⦧",
	            vangrt: "⦜",
	            varepsilon: "ϵ",
	            varkappa: "ϰ",
	            varnothing: "∅",
	            varphi: "ϕ",
	            varpi: "ϖ",
	            varpropto: "∝",
	            vArr: "⇕",
	            varr: "↕",
	            varrho: "ϱ",
	            varsigma: "ς",
	            varsubsetneq: "⊊︀",
	            varsubsetneqq: "⫋︀",
	            varsupsetneq: "⊋︀",
	            varsupsetneqq: "⫌︀",
	            vartheta: "ϑ",
	            vartriangleleft: "⊲",
	            vartriangleright: "⊳",
	            Vbar: "⫫",
	            vBar: "⫨",
	            vBarv: "⫩",
	            Vcy: "В",
	            vcy: "в",
	            VDash: "⊫",
	            Vdash: "⊩",
	            vDash: "⊨",
	            vdash: "⊢",
	            Vdashl: "⫦",
	            Vee: "⋁",
	            vee: "∨",
	            veebar: "⊻",
	            veeeq: "≚",
	            vellip: "⋮",
	            Verbar: "‖",
	            verbar: "|",
	            Vert: "‖",
	            vert: "|",
	            VerticalBar: "∣",
	            VerticalLine: "|",
	            VerticalSeparator: "❘",
	            VerticalTilde: "≀",
	            VeryThinSpace: " ",
	            Vfr: "𝔙",
	            vfr: "𝔳",
	            vltri: "⊲",
	            vnsub: "⊂⃒",
	            vnsup: "⊃⃒",
	            Vopf: "𝕍",
	            vopf: "𝕧",
	            vprop: "∝",
	            vrtri: "⊳",
	            Vscr: "𝒱",
	            vscr: "𝓋",
	            vsubnE: "⫋︀",
	            vsubne: "⊊︀",
	            vsupnE: "⫌︀",
	            vsupne: "⊋︀",
	            Vvdash: "⊪",
	            vzigzag: "⦚",
	            Wcirc: "Ŵ",
	            wcirc: "ŵ",
	            wedbar: "⩟",
	            Wedge: "⋀",
	            wedge: "∧",
	            wedgeq: "≙",
	            weierp: "℘",
	            Wfr: "𝔚",
	            wfr: "𝔴",
	            Wopf: "𝕎",
	            wopf: "𝕨",
	            wp: "℘",
	            wr: "≀",
	            wreath: "≀",
	            Wscr: "𝒲",
	            wscr: "𝓌",
	            xcap: "⋂",
	            xcirc: "◯",
	            xcup: "⋃",
	            xdtri: "▽",
	            Xfr: "𝔛",
	            xfr: "𝔵",
	            xhArr: "⟺",
	            xharr: "⟷",
	            Xi: "Ξ",
	            xi: "ξ",
	            xlArr: "⟸",
	            xlarr: "⟵",
	            xmap: "⟼",
	            xnis: "⋻",
	            xodot: "⨀",
	            Xopf: "𝕏",
	            xopf: "𝕩",
	            xoplus: "⨁",
	            xotime: "⨂",
	            xrArr: "⟹",
	            xrarr: "⟶",
	            Xscr: "𝒳",
	            xscr: "𝓍",
	            xsqcup: "⨆",
	            xuplus: "⨄",
	            xutri: "△",
	            xvee: "⋁",
	            xwedge: "⋀",
	            Yacute: "Ý",
	            yacute: "ý",
	            YAcy: "Я",
	            yacy: "я",
	            Ycirc: "Ŷ",
	            ycirc: "ŷ",
	            Ycy: "Ы",
	            ycy: "ы",
	            yen: "¥",
	            Yfr: "𝔜",
	            yfr: "𝔶",
	            YIcy: "Ї",
	            yicy: "ї",
	            Yopf: "𝕐",
	            yopf: "𝕪",
	            Yscr: "𝒴",
	            yscr: "𝓎",
	            YUcy: "Ю",
	            yucy: "ю",
	            Yuml: "Ÿ",
	            yuml: "ÿ",
	            Zacute: "Ź",
	            zacute: "ź",
	            Zcaron: "Ž",
	            zcaron: "ž",
	            Zcy: "З",
	            zcy: "з",
	            Zdot: "Ż",
	            zdot: "ż",
	            zeetrf: "ℨ",
	            ZeroWidthSpace: "​",
	            Zeta: "Ζ",
	            zeta: "ζ",
	            Zfr: "ℨ",
	            zfr: "𝔷",
	            ZHcy: "Ж",
	            zhcy: "ж",
	            zigrarr: "⇝",
	            Zopf: "ℤ",
	            zopf: "𝕫",
	            Zscr: "𝒵",
	            zscr: "𝓏",
	            zwj: "‍",
	            zwnj: "‌"
	          });
	          exports2.entityMap = exports2.HTML_ENTITIES;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/index.js": (
	        /*!**************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/index.js ***!
	          \**************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var dom = __webpack_require__(
	            /*! ./dom */
	            "./node_modules/@xmldom/xmldom/lib/dom.js"
	          );
	          exports2.DOMImplementation = dom.DOMImplementation;
	          exports2.XMLSerializer = dom.XMLSerializer;
	          exports2.DOMParser = __webpack_require__(
	            /*! ./dom-parser */
	            "./node_modules/@xmldom/xmldom/lib/dom-parser.js"
	          ).DOMParser;
	        }
	      ),
	      /***/
	      "./node_modules/@xmldom/xmldom/lib/sax.js": (
	        /*!************************************************!*\
	          !*** ./node_modules/@xmldom/xmldom/lib/sax.js ***!
	          \************************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var NAMESPACE = __webpack_require__(
	            /*! ./conventions */
	            "./node_modules/@xmldom/xmldom/lib/conventions.js"
	          ).NAMESPACE;
	          var nameStartChar = /[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
	          var nameChar = new RegExp("[\\-\\.0-9" + nameStartChar.source.slice(1, -1) + "\\u00B7\\u0300-\\u036F\\u203F-\\u2040]");
	          var tagNamePattern = new RegExp("^" + nameStartChar.source + nameChar.source + "*(?::" + nameStartChar.source + nameChar.source + "*)?$");
	          var S_TAG = 0;
	          var S_ATTR = 1;
	          var S_ATTR_SPACE = 2;
	          var S_EQ = 3;
	          var S_ATTR_NOQUOT_VALUE = 4;
	          var S_ATTR_END = 5;
	          var S_TAG_SPACE = 6;
	          var S_TAG_CLOSE = 7;
	          function ParseError(message, locator) {
	            this.message = message;
	            this.locator = locator;
	            if (Error.captureStackTrace) Error.captureStackTrace(this, ParseError);
	          }
	          ParseError.prototype = new Error();
	          ParseError.prototype.name = ParseError.name;
	          function XMLReader() {
	          }
	          XMLReader.prototype = {
	            parse: function(source, defaultNSMap, entityMap) {
	              var domBuilder = this.domBuilder;
	              domBuilder.startDocument();
	              _copy(defaultNSMap, defaultNSMap = {});
	              parse(
	                source,
	                defaultNSMap,
	                entityMap,
	                domBuilder,
	                this.errorHandler
	              );
	              domBuilder.endDocument();
	            }
	          };
	          function parse(source, defaultNSMapCopy, entityMap, domBuilder, errorHandler) {
	            function fixedFromCharCode(code) {
	              if (code > 65535) {
	                code -= 65536;
	                var surrogate1 = 55296 + (code >> 10), surrogate2 = 56320 + (code & 1023);
	                return String.fromCharCode(surrogate1, surrogate2);
	              } else {
	                return String.fromCharCode(code);
	              }
	            }
	            function entityReplacer(a2) {
	              var k = a2.slice(1, -1);
	              if (Object.hasOwnProperty.call(entityMap, k)) {
	                return entityMap[k];
	              } else if (k.charAt(0) === "#") {
	                return fixedFromCharCode(parseInt(k.substr(1).replace("x", "0x")));
	              } else {
	                errorHandler.error("entity not found:" + a2);
	                return a2;
	              }
	            }
	            function appendText(end2) {
	              if (end2 > start) {
	                var xt = source.substring(start, end2).replace(/&#?\w+;/g, entityReplacer);
	                locator && position(start);
	                domBuilder.characters(xt, 0, end2 - start);
	                start = end2;
	              }
	            }
	            function position(p, m) {
	              while (p >= lineEnd && (m = linePattern.exec(source))) {
	                lineStart = m.index;
	                lineEnd = lineStart + m[0].length;
	                locator.lineNumber++;
	              }
	              locator.columnNumber = p - lineStart + 1;
	            }
	            var lineStart = 0;
	            var lineEnd = 0;
	            var linePattern = /.*(?:\r\n?|\n)|.*$/g;
	            var locator = domBuilder.locator;
	            var parseStack = [{ currentNSMap: defaultNSMapCopy }];
	            var closeMap = {};
	            var start = 0;
	            while (true) {
	              try {
	                var tagStart = source.indexOf("<", start);
	                if (tagStart < 0) {
	                  if (!source.substr(start).match(/^\s*$/)) {
	                    var doc = domBuilder.doc;
	                    var text = doc.createTextNode(source.substr(start));
	                    doc.appendChild(text);
	                    domBuilder.currentElement = text;
	                  }
	                  return;
	                }
	                if (tagStart > start) {
	                  appendText(tagStart);
	                }
	                switch (source.charAt(tagStart + 1)) {
	                  case "/":
	                    var end = source.indexOf(">", tagStart + 3);
	                    var tagName = source.substring(tagStart + 2, end).replace(/[ \t\n\r]+$/g, "");
	                    var config = parseStack.pop();
	                    if (end < 0) {
	                      tagName = source.substring(tagStart + 2).replace(/[\s<].*/, "");
	                      errorHandler.error("end tag name: " + tagName + " is not complete:" + config.tagName);
	                      end = tagStart + 1 + tagName.length;
	                    } else if (tagName.match(/\s</)) {
	                      tagName = tagName.replace(/[\s<].*/, "");
	                      errorHandler.error("end tag name: " + tagName + " maybe not complete");
	                      end = tagStart + 1 + tagName.length;
	                    }
	                    var localNSMap = config.localNSMap;
	                    var endMatch = config.tagName == tagName;
	                    var endIgnoreCaseMach = endMatch || config.tagName && config.tagName.toLowerCase() == tagName.toLowerCase();
	                    if (endIgnoreCaseMach) {
	                      domBuilder.endElement(config.uri, config.localName, tagName);
	                      if (localNSMap) {
	                        for (var prefix in localNSMap) {
	                          if (Object.prototype.hasOwnProperty.call(localNSMap, prefix)) {
	                            domBuilder.endPrefixMapping(prefix);
	                          }
	                        }
	                      }
	                      if (!endMatch) {
	                        errorHandler.fatalError("end tag name: " + tagName + " is not match the current start tagName:" + config.tagName);
	                      }
	                    } else {
	                      parseStack.push(config);
	                    }
	                    end++;
	                    break;
	                  case "?":
	                    locator && position(tagStart);
	                    end = parseInstruction(source, tagStart, domBuilder);
	                    break;
	                  case "!":
	                    locator && position(tagStart);
	                    end = parseDCC(source, tagStart, domBuilder, errorHandler);
	                    break;
	                  default:
	                    locator && position(tagStart);
	                    var el = new ElementAttributes();
	                    var currentNSMap = parseStack[parseStack.length - 1].currentNSMap;
	                    var end = parseElementStartPart(source, tagStart, el, currentNSMap, entityReplacer, errorHandler);
	                    var len = el.length;
	                    if (!el.closed && fixSelfClosed(source, end, el.tagName, closeMap)) {
	                      el.closed = true;
	                      if (!entityMap.nbsp) {
	                        errorHandler.warning("unclosed xml attribute");
	                      }
	                    }
	                    if (locator && len) {
	                      var locator2 = copyLocator(locator, {});
	                      for (var i = 0; i < len; i++) {
	                        var a = el[i];
	                        position(a.offset);
	                        a.locator = copyLocator(locator, {});
	                      }
	                      domBuilder.locator = locator2;
	                      if (appendElement(el, domBuilder, currentNSMap)) {
	                        parseStack.push(el);
	                      }
	                      domBuilder.locator = locator;
	                    } else {
	                      if (appendElement(el, domBuilder, currentNSMap)) {
	                        parseStack.push(el);
	                      }
	                    }
	                    if (NAMESPACE.isHTML(el.uri) && !el.closed) {
	                      end = parseHtmlSpecialContent(source, end, el.tagName, entityReplacer, domBuilder);
	                    } else {
	                      end++;
	                    }
	                }
	              } catch (e) {
	                if (e instanceof ParseError) {
	                  throw e;
	                }
	                errorHandler.error("element parse error: " + e);
	                end = -1;
	              }
	              if (end > start) {
	                start = end;
	              } else {
	                appendText(Math.max(tagStart, start) + 1);
	              }
	            }
	          }
	          function copyLocator(f, t) {
	            t.lineNumber = f.lineNumber;
	            t.columnNumber = f.columnNumber;
	            return t;
	          }
	          function parseElementStartPart(source, start, el, currentNSMap, entityReplacer, errorHandler) {
	            function addAttribute(qname, value2, startIndex) {
	              if (el.attributeNames.hasOwnProperty(qname)) {
	                errorHandler.fatalError("Attribute " + qname + " redefined");
	              }
	              el.addValue(
	                qname,
	                // @see https://www.w3.org/TR/xml/#AVNormalize
	                // since the xmldom sax parser does not "interpret" DTD the following is not implemented:
	                // - recursive replacement of (DTD) entity references
	                // - trimming and collapsing multiple spaces into a single one for attributes that are not of type CDATA
	                value2.replace(/[\t\n\r]/g, " ").replace(/&#?\w+;/g, entityReplacer),
	                startIndex
	              );
	            }
	            var attrName;
	            var value;
	            var p = ++start;
	            var s = S_TAG;
	            while (true) {
	              var c = source.charAt(p);
	              switch (c) {
	                case "=":
	                  if (s === S_ATTR) {
	                    attrName = source.slice(start, p);
	                    s = S_EQ;
	                  } else if (s === S_ATTR_SPACE) {
	                    s = S_EQ;
	                  } else {
	                    throw new Error("attribute equal must after attrName");
	                  }
	                  break;
	                case "'":
	                case '"':
	                  if (s === S_EQ || s === S_ATTR) {
	                    if (s === S_ATTR) {
	                      errorHandler.warning('attribute value must after "="');
	                      attrName = source.slice(start, p);
	                    }
	                    start = p + 1;
	                    p = source.indexOf(c, start);
	                    if (p > 0) {
	                      value = source.slice(start, p);
	                      addAttribute(attrName, value, start - 1);
	                      s = S_ATTR_END;
	                    } else {
	                      throw new Error("attribute value no end '" + c + "' match");
	                    }
	                  } else if (s == S_ATTR_NOQUOT_VALUE) {
	                    value = source.slice(start, p);
	                    addAttribute(attrName, value, start);
	                    errorHandler.warning('attribute "' + attrName + '" missed start quot(' + c + ")!!");
	                    start = p + 1;
	                    s = S_ATTR_END;
	                  } else {
	                    throw new Error('attribute value must after "="');
	                  }
	                  break;
	                case "/":
	                  switch (s) {
	                    case S_TAG:
	                      el.setTagName(source.slice(start, p));
	                    case S_ATTR_END:
	                    case S_TAG_SPACE:
	                    case S_TAG_CLOSE:
	                      s = S_TAG_CLOSE;
	                      el.closed = true;
	                    case S_ATTR_NOQUOT_VALUE:
	                    case S_ATTR:
	                      break;
	                    case S_ATTR_SPACE:
	                      el.closed = true;
	                      break;
	                    default:
	                      throw new Error("attribute invalid close char('/')");
	                  }
	                  break;
	                case "":
	                  errorHandler.error("unexpected end of input");
	                  if (s == S_TAG) {
	                    el.setTagName(source.slice(start, p));
	                  }
	                  return p;
	                case ">":
	                  switch (s) {
	                    case S_TAG:
	                      el.setTagName(source.slice(start, p));
	                    case S_ATTR_END:
	                    case S_TAG_SPACE:
	                    case S_TAG_CLOSE:
	                      break;
	                    case S_ATTR_NOQUOT_VALUE:
	                    case S_ATTR:
	                      value = source.slice(start, p);
	                      if (value.slice(-1) === "/") {
	                        el.closed = true;
	                        value = value.slice(0, -1);
	                      }
	                    case S_ATTR_SPACE:
	                      if (s === S_ATTR_SPACE) {
	                        value = attrName;
	                      }
	                      if (s == S_ATTR_NOQUOT_VALUE) {
	                        errorHandler.warning('attribute "' + value + '" missed quot(")!');
	                        addAttribute(attrName, value, start);
	                      } else {
	                        if (!NAMESPACE.isHTML(currentNSMap[""]) || !value.match(/^(?:disabled|checked|selected)$/i)) {
	                          errorHandler.warning('attribute "' + value + '" missed value!! "' + value + '" instead!!');
	                        }
	                        addAttribute(value, value, start);
	                      }
	                      break;
	                    case S_EQ:
	                      throw new Error("attribute value missed!!");
	                  }
	                  return p;
	                case "":
	                  c = " ";
	                default:
	                  if (c <= " ") {
	                    switch (s) {
	                      case S_TAG:
	                        el.setTagName(source.slice(start, p));
	                        s = S_TAG_SPACE;
	                        break;
	                      case S_ATTR:
	                        attrName = source.slice(start, p);
	                        s = S_ATTR_SPACE;
	                        break;
	                      case S_ATTR_NOQUOT_VALUE:
	                        var value = source.slice(start, p);
	                        errorHandler.warning('attribute "' + value + '" missed quot(")!!');
	                        addAttribute(attrName, value, start);
	                      case S_ATTR_END:
	                        s = S_TAG_SPACE;
	                        break;
	                    }
	                  } else {
	                    switch (s) {
	                      case S_ATTR_SPACE:
	                        el.tagName;
	                        if (!NAMESPACE.isHTML(currentNSMap[""]) || !attrName.match(/^(?:disabled|checked|selected)$/i)) {
	                          errorHandler.warning('attribute "' + attrName + '" missed value!! "' + attrName + '" instead2!!');
	                        }
	                        addAttribute(attrName, attrName, start);
	                        start = p;
	                        s = S_ATTR;
	                        break;
	                      case S_ATTR_END:
	                        errorHandler.warning('attribute space is required"' + attrName + '"!!');
	                      case S_TAG_SPACE:
	                        s = S_ATTR;
	                        start = p;
	                        break;
	                      case S_EQ:
	                        s = S_ATTR_NOQUOT_VALUE;
	                        start = p;
	                        break;
	                      case S_TAG_CLOSE:
	                        throw new Error("elements closed character '/' and '>' must be connected to");
	                    }
	                  }
	              }
	              p++;
	            }
	          }
	          function appendElement(el, domBuilder, currentNSMap) {
	            var tagName = el.tagName;
	            var localNSMap = null;
	            var i = el.length;
	            while (i--) {
	              var a = el[i];
	              var qName = a.qName;
	              var value = a.value;
	              var nsp = qName.indexOf(":");
	              if (nsp > 0) {
	                var prefix = a.prefix = qName.slice(0, nsp);
	                var localName = qName.slice(nsp + 1);
	                var nsPrefix = prefix === "xmlns" && localName;
	              } else {
	                localName = qName;
	                prefix = null;
	                nsPrefix = qName === "xmlns" && "";
	              }
	              a.localName = localName;
	              if (nsPrefix !== false) {
	                if (localNSMap == null) {
	                  localNSMap = {};
	                  _copy(currentNSMap, currentNSMap = {});
	                }
	                currentNSMap[nsPrefix] = localNSMap[nsPrefix] = value;
	                a.uri = NAMESPACE.XMLNS;
	                domBuilder.startPrefixMapping(nsPrefix, value);
	              }
	            }
	            var i = el.length;
	            while (i--) {
	              a = el[i];
	              var prefix = a.prefix;
	              if (prefix) {
	                if (prefix === "xml") {
	                  a.uri = NAMESPACE.XML;
	                }
	                if (prefix !== "xmlns") {
	                  a.uri = currentNSMap[prefix || ""];
	                }
	              }
	            }
	            var nsp = tagName.indexOf(":");
	            if (nsp > 0) {
	              prefix = el.prefix = tagName.slice(0, nsp);
	              localName = el.localName = tagName.slice(nsp + 1);
	            } else {
	              prefix = null;
	              localName = el.localName = tagName;
	            }
	            var ns = el.uri = currentNSMap[prefix || ""];
	            domBuilder.startElement(ns, localName, tagName, el);
	            if (el.closed) {
	              domBuilder.endElement(ns, localName, tagName);
	              if (localNSMap) {
	                for (prefix in localNSMap) {
	                  if (Object.prototype.hasOwnProperty.call(localNSMap, prefix)) {
	                    domBuilder.endPrefixMapping(prefix);
	                  }
	                }
	              }
	            } else {
	              el.currentNSMap = currentNSMap;
	              el.localNSMap = localNSMap;
	              return true;
	            }
	          }
	          function parseHtmlSpecialContent(source, elStartEnd, tagName, entityReplacer, domBuilder) {
	            if (/^(?:script|textarea)$/i.test(tagName)) {
	              var elEndStart = source.indexOf("</" + tagName + ">", elStartEnd);
	              var text = source.substring(elStartEnd + 1, elEndStart);
	              if (/[&<]/.test(text)) {
	                if (/^script$/i.test(tagName)) {
	                  domBuilder.characters(text, 0, text.length);
	                  return elEndStart;
	                }
	                text = text.replace(/&#?\w+;/g, entityReplacer);
	                domBuilder.characters(text, 0, text.length);
	                return elEndStart;
	              }
	            }
	            return elStartEnd + 1;
	          }
	          function fixSelfClosed(source, elStartEnd, tagName, closeMap) {
	            var pos = closeMap[tagName];
	            if (pos == null) {
	              pos = source.lastIndexOf("</" + tagName + ">");
	              if (pos < elStartEnd) {
	                pos = source.lastIndexOf("</" + tagName);
	              }
	              closeMap[tagName] = pos;
	            }
	            return pos < elStartEnd;
	          }
	          function _copy(source, target) {
	            for (var n in source) {
	              if (Object.prototype.hasOwnProperty.call(source, n)) {
	                target[n] = source[n];
	              }
	            }
	          }
	          function parseDCC(source, start, domBuilder, errorHandler) {
	            var next = source.charAt(start + 2);
	            switch (next) {
	              case "-":
	                if (source.charAt(start + 3) === "-") {
	                  var end = source.indexOf("-->", start + 4);
	                  if (end > start) {
	                    domBuilder.comment(source, start + 4, end - start - 4);
	                    return end + 3;
	                  } else {
	                    errorHandler.error("Unclosed comment");
	                    return -1;
	                  }
	                } else {
	                  return -1;
	                }
	              default:
	                if (source.substr(start + 3, 6) == "CDATA[") {
	                  var end = source.indexOf("]]>", start + 9);
	                  domBuilder.startCDATA();
	                  domBuilder.characters(source, start + 9, end - start - 9);
	                  domBuilder.endCDATA();
	                  return end + 3;
	                }
	                var matchs = split(source, start);
	                var len = matchs.length;
	                if (len > 1 && /!doctype/i.test(matchs[0][0])) {
	                  var name = matchs[1][0];
	                  var pubid = false;
	                  var sysid = false;
	                  if (len > 3) {
	                    if (/^public$/i.test(matchs[2][0])) {
	                      pubid = matchs[3][0];
	                      sysid = len > 4 && matchs[4][0];
	                    } else if (/^system$/i.test(matchs[2][0])) {
	                      sysid = matchs[3][0];
	                    }
	                  }
	                  var lastMatch = matchs[len - 1];
	                  domBuilder.startDTD(name, pubid, sysid);
	                  domBuilder.endDTD();
	                  return lastMatch.index + lastMatch[0].length;
	                }
	            }
	            return -1;
	          }
	          function parseInstruction(source, start, domBuilder) {
	            var end = source.indexOf("?>", start);
	            if (end) {
	              var match = source.substring(start, end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);
	              if (match) {
	                match[0].length;
	                domBuilder.processingInstruction(match[1], match[2]);
	                return end + 2;
	              } else {
	                return -1;
	              }
	            }
	            return -1;
	          }
	          function ElementAttributes() {
	            this.attributeNames = {};
	          }
	          ElementAttributes.prototype = {
	            setTagName: function(tagName) {
	              if (!tagNamePattern.test(tagName)) {
	                throw new Error("invalid tagName:" + tagName);
	              }
	              this.tagName = tagName;
	            },
	            addValue: function(qName, value, offset) {
	              if (!tagNamePattern.test(qName)) {
	                throw new Error("invalid attribute:" + qName);
	              }
	              this.attributeNames[qName] = this.length;
	              this[this.length++] = { qName, value, offset };
	            },
	            length: 0,
	            getLocalName: function(i) {
	              return this[i].localName;
	            },
	            getLocator: function(i) {
	              return this[i].locator;
	            },
	            getQName: function(i) {
	              return this[i].qName;
	            },
	            getURI: function(i) {
	              return this[i].uri;
	            },
	            getValue: function(i) {
	              return this[i].value;
	            }
	            //	,getIndex:function(uri, localName)){
	            //		if(localName){
	            //
	            //		}else{
	            //			var qName = uri
	            //		}
	            //	},
	            //	getValue:function(){return this.getValue(this.getIndex.apply(this,arguments))},
	            //	getType:function(uri,localName){}
	            //	getType:function(i){},
	          };
	          function split(source, start) {
	            var match;
	            var buf = [];
	            var reg = /'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;
	            reg.lastIndex = start;
	            reg.exec(source);
	            while (match = reg.exec(source)) {
	              buf.push(match);
	              if (match[1]) return buf;
	            }
	          }
	          exports2.XMLReader = XMLReader;
	          exports2.ParseError = ParseError;
	        }
	      ),
	      /***/
	      "./node_modules/process/browser.js": (
	        /*!*****************************************!*\
	          !*** ./node_modules/process/browser.js ***!
	          \*****************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          var process = module2.exports = {};
	          var cachedSetTimeout;
	          var cachedClearTimeout;
	          function defaultSetTimout() {
	            throw new Error("setTimeout has not been defined");
	          }
	          function defaultClearTimeout() {
	            throw new Error("clearTimeout has not been defined");
	          }
	          (function() {
	            try {
	              if (typeof setTimeout === "function") {
	                cachedSetTimeout = setTimeout;
	              } else {
	                cachedSetTimeout = defaultSetTimout;
	              }
	            } catch (e) {
	              cachedSetTimeout = defaultSetTimout;
	            }
	            try {
	              if (typeof clearTimeout === "function") {
	                cachedClearTimeout = clearTimeout;
	              } else {
	                cachedClearTimeout = defaultClearTimeout;
	              }
	            } catch (e) {
	              cachedClearTimeout = defaultClearTimeout;
	            }
	          })();
	          function runTimeout(fun) {
	            if (cachedSetTimeout === setTimeout) {
	              return setTimeout(fun, 0);
	            }
	            if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
	              cachedSetTimeout = setTimeout;
	              return setTimeout(fun, 0);
	            }
	            try {
	              return cachedSetTimeout(fun, 0);
	            } catch (e) {
	              try {
	                return cachedSetTimeout.call(null, fun, 0);
	              } catch (e2) {
	                return cachedSetTimeout.call(this, fun, 0);
	              }
	            }
	          }
	          function runClearTimeout(marker) {
	            if (cachedClearTimeout === clearTimeout) {
	              return clearTimeout(marker);
	            }
	            if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
	              cachedClearTimeout = clearTimeout;
	              return clearTimeout(marker);
	            }
	            try {
	              return cachedClearTimeout(marker);
	            } catch (e) {
	              try {
	                return cachedClearTimeout.call(null, marker);
	              } catch (e2) {
	                return cachedClearTimeout.call(this, marker);
	              }
	            }
	          }
	          var queue = [];
	          var draining = false;
	          var currentQueue;
	          var queueIndex = -1;
	          function cleanUpNextTick() {
	            if (!draining || !currentQueue) {
	              return;
	            }
	            draining = false;
	            if (currentQueue.length) {
	              queue = currentQueue.concat(queue);
	            } else {
	              queueIndex = -1;
	            }
	            if (queue.length) {
	              drainQueue();
	            }
	          }
	          function drainQueue() {
	            if (draining) {
	              return;
	            }
	            var timeout = runTimeout(cleanUpNextTick);
	            draining = true;
	            var len = queue.length;
	            while (len) {
	              currentQueue = queue;
	              queue = [];
	              while (++queueIndex < len) {
	                if (currentQueue) {
	                  currentQueue[queueIndex].run();
	                }
	              }
	              queueIndex = -1;
	              len = queue.length;
	            }
	            currentQueue = null;
	            draining = false;
	            runClearTimeout(timeout);
	          }
	          process.nextTick = function(fun) {
	            var args = new Array(arguments.length - 1);
	            if (arguments.length > 1) {
	              for (var i = 1; i < arguments.length; i++) {
	                args[i - 1] = arguments[i];
	              }
	            }
	            queue.push(new Item(fun, args));
	            if (queue.length === 1 && !draining) {
	              runTimeout(drainQueue);
	            }
	          };
	          function Item(fun, array) {
	            this.fun = fun;
	            this.array = array;
	          }
	          Item.prototype.run = function() {
	            this.fun.apply(null, this.array);
	          };
	          process.title = "browser";
	          process.browser = true;
	          process.env = {};
	          process.argv = [];
	          process.version = "";
	          process.versions = {};
	          function noop() {
	          }
	          process.on = noop;
	          process.addListener = noop;
	          process.once = noop;
	          process.off = noop;
	          process.removeListener = noop;
	          process.removeAllListeners = noop;
	          process.emit = noop;
	          process.prependListener = noop;
	          process.prependOnceListener = noop;
	          process.listeners = function(name) {
	            return [];
	          };
	          process.binding = function(name) {
	            throw new Error("process.binding is not supported");
	          };
	          process.cwd = function() {
	            return "/";
	          };
	          process.chdir = function(dir) {
	            throw new Error("process.chdir is not supported");
	          };
	          process.umask = function() {
	            return 0;
	          };
	        }
	      ),
	      /***/
	      "./node_modules/webpack/buildin/amd-options.js": (
	        /*!****************************************!*\
	          !*** (webpack)/buildin/amd-options.js ***!
	          \****************************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          (function(__webpack_amd_options__) {
	            module2.exports = __webpack_amd_options__;
	          }).call(this, {});
	        }
	      ),
	      /***/
	      "./node_modules/webpack/buildin/module.js": (
	        /*!***********************************!*\
	          !*** (webpack)/buildin/module.js ***!
	          \***********************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          module2.exports = function(module3) {
	            if (!module3.webpackPolyfill) {
	              module3.deprecate = function() {
	              };
	              module3.paths = [];
	              if (!module3.children) module3.children = [];
	              Object.defineProperty(module3, "loaded", {
	                enumerable: true,
	                get: function() {
	                  return module3.l;
	                }
	              });
	              Object.defineProperty(module3, "id", {
	                enumerable: true,
	                get: function() {
	                  return module3.i;
	                }
	              });
	              module3.webpackPolyfill = 1;
	            }
	            return module3;
	          };
	        }
	      ),
	      /***/
	      "./package.json": (
	        /*!**********************!*\
	          !*** ./package.json ***!
	          \**********************/
	        /*! exports provided: name, version, description, main, types, scripts, repository, keywords, author, license, bugs, homepage, dependencies, devDependencies, default */
	        /***/
	        function(module2) {
	          module2.exports = JSON.parse('{"name":"cos-js-sdk-v5","version":"1.8.2","description":"JavaScript SDK for [腾讯云对象存储](https://cloud.tencent.com/product/cos)","main":"dist/cos-js-sdk-v5.js","types":"index.d.ts","scripts":{"prettier":"prettier --write src demo/demo.js demo/CIDemos/*.js test/test.js server/sts.js lib/request.js index.d.ts","server":"node server/sts.js","dev":"cross-env NODE_ENV=development webpack -w --mode=development","build":"cross-env NODE_ENV=production webpack --mode=production","cos-auth.min.js":"uglifyjs ./demo/common/cos-auth.js -o ./demo/common/cos-auth.min.js -c -m","test":"jest --runInBand --coverage"},"repository":{"type":"git","url":"git+https://github.com/tencentyun/cos-js-sdk-v5.git"},"keywords":[],"author":"carsonxu","license":"ISC","bugs":{"url":"https://github.com/tencentyun/cos-js-sdk-v5/issues"},"homepage":"https://github.com/tencentyun/cos-js-sdk-v5#readme","dependencies":{"@xmldom/xmldom":"^0.8.6"},"devDependencies":{"@babel/core":"7.17.9","@babel/plugin-transform-runtime":"7.18.10","@babel/preset-env":"7.16.11","babel-loader":"8.2.5","body-parser":"^1.18.3","cross-env":"^5.2.0","express":"^4.16.4","jest":"^29.3.1","jest-environment-jsdom":"^29.3.1","prettier":"^3.0.1","qcloud-cos-sts":"^3.0.2","request":"^2.87.0","terser-webpack-plugin":"4.2.3","uglifyjs":"^2.4.11","webpack":"4.46.0","webpack-cli":"4.10.0"}}');
	        }
	      ),
	      /***/
	      "./src/advance.js": (
	        /*!************************!*\
	          !*** ./src/advance.js ***!
	          \************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! @babel/runtime/helpers/typeof */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          );
	          var session = __webpack_require__(
	            /*! ./session */
	            "./src/session.js"
	          );
	          var Async = __webpack_require__(
	            /*! ./async */
	            "./src/async.js"
	          );
	          var EventProxy = __webpack_require__(
	            /*! ./event */
	            "./src/event.js"
	          ).EventProxy;
	          var util = __webpack_require__(
	            /*! ./util */
	            "./src/util.js"
	          );
	          var Tracker = __webpack_require__(
	            /*! ./tracker */
	            "./src/tracker.js"
	          );
	          function sliceUploadFile(params, callback) {
	            var self2 = this;
	            var ep = new EventProxy();
	            var TaskId = params.TaskId;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var Body = params.Body;
	            var ChunkSize = params.ChunkSize || params.SliceSize || self2.options.ChunkSize;
	            var AsyncLimit = params.AsyncLimit;
	            var StorageClass = params.StorageClass;
	            var ServerSideEncryption = params.ServerSideEncryption;
	            var FileSize;
	            var onProgress;
	            var onHashProgress = params.onHashProgress;
	            var tracker = params.tracker;
	            tracker && tracker.setParams({
	              chunkSize: ChunkSize
	            });
	            ep.on("error", function(err) {
	              if (!self2._isRunningTask(TaskId)) return;
	              err.UploadId = params.UploadData.UploadId || "";
	              return callback(err);
	            });
	            ep.on("upload_complete", function(UploadCompleteData) {
	              var _UploadCompleteData = util.extend({
	                UploadId: params.UploadData.UploadId || ""
	              }, UploadCompleteData);
	              callback(null, _UploadCompleteData);
	            });
	            ep.on("upload_slice_complete", function(UploadData) {
	              var metaHeaders = {};
	              util.each(params.Headers, function(val, k) {
	                var shortKey = k.toLowerCase();
	                if (shortKey.indexOf("x-cos-meta-") === 0 || ["pic-operations", "x-cos-callback", "x-cos-callback-var", "x-cos-return-body"].includes(shortKey)) {
	                  metaHeaders[k] = val;
	                }
	              });
	              uploadSliceComplete.call(self2, {
	                Bucket,
	                Region,
	                Key,
	                UploadId: UploadData.UploadId,
	                SliceList: UploadData.SliceList,
	                Headers: metaHeaders,
	                tracker
	              }, function(err, data) {
	                if (!self2._isRunningTask(TaskId)) return;
	                session.removeUsing(UploadData.UploadId);
	                if (err) {
	                  onProgress(null, true);
	                  return ep.emit("error", err);
	                }
	                session.removeUploadId.call(self2, UploadData.UploadId);
	                onProgress({
	                  loaded: FileSize,
	                  total: FileSize
	                }, true);
	                ep.emit("upload_complete", data);
	              });
	            });
	            ep.on("get_upload_data_finish", function(UploadData) {
	              var uuid = session.getFileId(Body, params.ChunkSize, Bucket, Key);
	              uuid && session.saveUploadId.call(self2, uuid, UploadData.UploadId, self2.options.UploadIdCacheLimit);
	              session.setUsing(UploadData.UploadId);
	              onProgress(null, true);
	              uploadSliceList.call(self2, {
	                TaskId,
	                Bucket,
	                Region,
	                Key,
	                Body,
	                FileSize,
	                SliceSize: ChunkSize,
	                AsyncLimit,
	                ServerSideEncryption,
	                UploadData,
	                Headers: params.Headers,
	                onProgress,
	                tracker
	              }, function(err, data) {
	                if (!self2._isRunningTask(TaskId)) return;
	                if (err) {
	                  onProgress(null, true);
	                  return ep.emit("error", err);
	                }
	                ep.emit("upload_slice_complete", data);
	              });
	            });
	            ep.on("get_file_size_finish", function() {
	              onProgress = util.throttleOnProgress.call(self2, FileSize, params.onProgress);
	              if (params.UploadData.UploadId) {
	                ep.emit("get_upload_data_finish", params.UploadData);
	              } else {
	                var _params = util.extend({
	                  TaskId,
	                  Bucket,
	                  Region,
	                  Key,
	                  Headers: params.Headers,
	                  StorageClass,
	                  Body,
	                  FileSize,
	                  SliceSize: ChunkSize,
	                  onHashProgress,
	                  tracker
	                }, params);
	                getUploadIdAndPartList.call(self2, _params, function(err, UploadData) {
	                  if (!self2._isRunningTask(TaskId)) return;
	                  if (err) return ep.emit("error", err);
	                  params.UploadData.UploadId = UploadData.UploadId;
	                  params.UploadData.PartList = UploadData.PartList;
	                  ep.emit("get_upload_data_finish", params.UploadData);
	                });
	              }
	            });
	            FileSize = params.ContentLength;
	            delete params.ContentLength;
	            !params.Headers && (params.Headers = {});
	            util.each(params.Headers, function(item, key) {
	              if (key.toLowerCase() === "content-length") {
	                delete params.Headers[key];
	              }
	            });
	            (function() {
	              var SIZE = [1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 1024 * 2, 1024 * 4, 1024 * 5];
	              var AutoChunkSize = 1024 * 1024;
	              for (var i = 0; i < SIZE.length; i++) {
	                AutoChunkSize = SIZE[i] * 1024 * 1024;
	                if (FileSize / AutoChunkSize <= self2.options.MaxPartNumber) break;
	              }
	              params.ChunkSize = params.SliceSize = ChunkSize = Math.max(ChunkSize, AutoChunkSize);
	            })();
	            if (FileSize === 0) {
	              params.Body = "";
	              params.ContentLength = 0;
	              params.SkipTask = true;
	              self2.putObject(params, callback);
	            } else {
	              ep.emit("get_file_size_finish");
	            }
	          }
	          function getUploadIdAndPartList(params, callback) {
	            var TaskId = params.TaskId;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var StorageClass = params.StorageClass;
	            var self2 = this;
	            var ETagMap = {};
	            var FileSize = params.FileSize;
	            var SliceSize = params.SliceSize;
	            var SliceCount = Math.ceil(FileSize / SliceSize);
	            var FinishSize = 0;
	            var onHashProgress = util.throttleOnProgress.call(self2, FileSize, params.onHashProgress);
	            var getChunkETag = function getChunkETag2(PartNumber, callback2) {
	              var start = SliceSize * (PartNumber - 1);
	              var end = Math.min(start + SliceSize, FileSize);
	              var ChunkSize = end - start;
	              if (ETagMap[PartNumber]) {
	                callback2(null, {
	                  PartNumber,
	                  ETag: ETagMap[PartNumber],
	                  Size: ChunkSize
	                });
	              } else {
	                util.fileSlice(params.Body, start, end, false, function(chunkItem) {
	                  util.getFileMd5(chunkItem, function(err, md5) {
	                    if (err) return callback2(util.error(err));
	                    var ETag = '"' + md5 + '"';
	                    ETagMap[PartNumber] = ETag;
	                    FinishSize += ChunkSize;
	                    onHashProgress({
	                      loaded: FinishSize,
	                      total: FileSize
	                    });
	                    callback2(null, {
	                      PartNumber,
	                      ETag,
	                      Size: ChunkSize
	                    });
	                  });
	                });
	              }
	            };
	            var isAvailableUploadList = function isAvailableUploadList2(PartList, callback2) {
	              var PartCount = PartList.length;
	              if (PartCount === 0) {
	                return callback2(null, true);
	              }
	              if (PartCount > SliceCount) {
	                return callback2(null, false);
	              }
	              if (PartCount > 1) {
	                var PartSliceSize = Math.max(PartList[0].Size, PartList[1].Size);
	                if (PartSliceSize !== SliceSize) {
	                  return callback2(null, false);
	                }
	              }
	              var next = function next2(index) {
	                if (index < PartCount) {
	                  var Part = PartList[index];
	                  getChunkETag(Part.PartNumber, function(err, chunk) {
	                    if (chunk && chunk.ETag === Part.ETag && chunk.Size === Part.Size) {
	                      next2(index + 1);
	                    } else {
	                      callback2(null, false);
	                    }
	                  });
	                } else {
	                  callback2(null, true);
	                }
	              };
	              next(0);
	            };
	            var ep = new EventProxy();
	            ep.on("error", function(errData) {
	              if (!self2._isRunningTask(TaskId)) return;
	              return callback(errData);
	            });
	            ep.on("upload_id_available", function(UploadData) {
	              var map = {};
	              var list = [];
	              util.each(UploadData.PartList, function(item2) {
	                map[item2.PartNumber] = item2;
	              });
	              for (var PartNumber = 1; PartNumber <= SliceCount; PartNumber++) {
	                var item = map[PartNumber];
	                if (item) {
	                  item.PartNumber = PartNumber;
	                  item.Uploaded = true;
	                } else {
	                  item = {
	                    PartNumber,
	                    ETag: null,
	                    Uploaded: false
	                  };
	                }
	                list.push(item);
	              }
	              UploadData.PartList = list;
	              callback(null, UploadData);
	            });
	            ep.on("no_available_upload_id", function() {
	              if (!self2._isRunningTask(TaskId)) return;
	              var _params = util.extend({
	                Bucket,
	                Region,
	                Key,
	                Query: util.clone(params.Query),
	                StorageClass,
	                Body: params.Body,
	                calledBySdk: "sliceUploadFile",
	                tracker: params.tracker
	              }, params);
	              var headers = util.clone(params.Headers);
	              delete headers["x-cos-mime-limit"];
	              _params.Headers = headers;
	              self2.multipartInit(_params, function(err, data) {
	                if (!self2._isRunningTask(TaskId)) return;
	                if (err) return ep.emit("error", err);
	                var UploadId = data.UploadId;
	                if (!UploadId) {
	                  return callback(util.error(new Error("no such upload id")));
	                }
	                ep.emit("upload_id_available", {
	                  UploadId,
	                  PartList: []
	                });
	              });
	            });
	            ep.on("has_and_check_upload_id", function(UploadIdList) {
	              UploadIdList = UploadIdList.reverse();
	              Async.eachLimit(UploadIdList, 1, function(UploadId, asyncCallback) {
	                if (!self2._isRunningTask(TaskId)) return;
	                if (session.using[UploadId]) {
	                  asyncCallback();
	                  return;
	                }
	                wholeMultipartListPart.call(self2, {
	                  Bucket,
	                  Region,
	                  Key,
	                  UploadId,
	                  tracker: params.tracker
	                }, function(err, PartListData) {
	                  if (!self2._isRunningTask(TaskId)) return;
	                  if (err) {
	                    session.removeUsing(UploadId);
	                    return ep.emit("error", err);
	                  }
	                  var PartList = PartListData.PartList;
	                  PartList.forEach(function(item) {
	                    item.PartNumber *= 1;
	                    item.Size *= 1;
	                    item.ETag = item.ETag || "";
	                  });
	                  isAvailableUploadList(PartList, function(err2, isAvailable) {
	                    if (!self2._isRunningTask(TaskId)) return;
	                    if (err2) return ep.emit("error", err2);
	                    if (isAvailable) {
	                      asyncCallback({
	                        UploadId,
	                        PartList
	                      });
	                    } else {
	                      asyncCallback();
	                    }
	                  });
	                });
	              }, function(AvailableUploadData) {
	                if (!self2._isRunningTask(TaskId)) return;
	                onHashProgress(null, true);
	                if (AvailableUploadData && AvailableUploadData.UploadId) {
	                  ep.emit("upload_id_available", AvailableUploadData);
	                } else {
	                  ep.emit("no_available_upload_id");
	                }
	              });
	            });
	            ep.on("seek_local_avail_upload_id", function(RemoteUploadIdList) {
	              var uuid = session.getFileId(params.Body, params.ChunkSize, Bucket, Key);
	              var LocalUploadIdList = session.getUploadIdList.call(self2, uuid);
	              if (!uuid || !LocalUploadIdList) {
	                ep.emit("has_and_check_upload_id", RemoteUploadIdList);
	                return;
	              }
	              var next = function next2(index) {
	                if (index >= LocalUploadIdList.length) {
	                  ep.emit("has_and_check_upload_id", RemoteUploadIdList);
	                  return;
	                }
	                var UploadId = LocalUploadIdList[index];
	                if (!util.isInArray(RemoteUploadIdList, UploadId)) {
	                  session.removeUploadId.call(self2, UploadId);
	                  next2(index + 1);
	                  return;
	                }
	                if (session.using[UploadId]) {
	                  next2(index + 1);
	                  return;
	                }
	                wholeMultipartListPart.call(self2, {
	                  Bucket,
	                  Region,
	                  Key,
	                  UploadId,
	                  tracker: params.tracker
	                }, function(err, PartListData) {
	                  if (!self2._isRunningTask(TaskId)) return;
	                  if (err) {
	                    session.removeUploadId.call(self2, UploadId);
	                    next2(index + 1);
	                  } else {
	                    ep.emit("upload_id_available", {
	                      UploadId,
	                      PartList: PartListData.PartList
	                    });
	                  }
	                });
	              };
	              next(0);
	            });
	            ep.on("get_remote_upload_id_list", function() {
	              wholeMultipartList.call(self2, {
	                Bucket,
	                Region,
	                Key,
	                tracker: params.tracker
	              }, function(err, data) {
	                if (!self2._isRunningTask(TaskId)) return;
	                if (err) return ep.emit("error", err);
	                var RemoteUploadIdList = util.filter(data.UploadList, function(item) {
	                  return item.Key === Key && (!StorageClass || item.StorageClass.toUpperCase() === StorageClass.toUpperCase());
	                }).reverse().map(function(item) {
	                  return item.UploadId || item.UploadID;
	                });
	                if (RemoteUploadIdList.length) {
	                  ep.emit("seek_local_avail_upload_id", RemoteUploadIdList);
	                } else {
	                  var uuid = session.getFileId(params.Body, params.ChunkSize, Bucket, Key), LocalUploadIdList;
	                  if (uuid && (LocalUploadIdList = session.getUploadIdList.call(self2, uuid))) {
	                    util.each(LocalUploadIdList, function(UploadId) {
	                      session.removeUploadId.call(self2, UploadId);
	                    });
	                  }
	                  ep.emit("no_available_upload_id");
	                }
	              });
	            });
	            ep.emit("get_remote_upload_id_list");
	          }
	          function wholeMultipartList(params, callback) {
	            var self2 = this;
	            var UploadList = [];
	            var sendParams = {
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Prefix: params.Key,
	              calledBySdk: params.calledBySdk || "sliceUploadFile",
	              tracker: params.tracker
	            };
	            var next = function next2() {
	              self2.multipartList(sendParams, function(err, data) {
	                if (err) return callback(err);
	                UploadList.push.apply(UploadList, data.Upload || []);
	                if (data.IsTruncated === "true") {
	                  sendParams.KeyMarker = data.NextKeyMarker;
	                  sendParams.UploadIdMarker = data.NextUploadIdMarker;
	                  next2();
	                } else {
	                  callback(null, {
	                    UploadList
	                  });
	                }
	              });
	            };
	            next();
	          }
	          function wholeMultipartListPart(params, callback) {
	            var self2 = this;
	            var PartList = [];
	            var sendParams = {
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              UploadId: params.UploadId,
	              calledBySdk: "sliceUploadFile",
	              tracker: params.tracker
	            };
	            var next = function next2() {
	              self2.multipartListPart(sendParams, function(err, data) {
	                if (err) return callback(err);
	                PartList.push.apply(PartList, data.Part || []);
	                if (data.IsTruncated === "true") {
	                  sendParams.PartNumberMarker = data.NextPartNumberMarker;
	                  next2();
	                } else {
	                  callback(null, {
	                    PartList
	                  });
	                }
	              });
	            };
	            next();
	          }
	          function uploadSliceList(params, cb) {
	            var self2 = this;
	            var TaskId = params.TaskId;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var UploadData = params.UploadData;
	            var FileSize = params.FileSize;
	            var SliceSize = params.SliceSize;
	            var ChunkParallel = Math.min(params.AsyncLimit || self2.options.ChunkParallelLimit || 1, 256);
	            var Body = params.Body;
	            var SliceCount = Math.ceil(FileSize / SliceSize);
	            var FinishSize = 0;
	            var ServerSideEncryption = params.ServerSideEncryption;
	            var Headers = params.Headers;
	            var needUploadSlices = util.filter(UploadData.PartList, function(SliceItem) {
	              if (SliceItem["Uploaded"]) {
	                FinishSize += SliceItem["PartNumber"] >= SliceCount ? FileSize % SliceSize || SliceSize : SliceSize;
	              }
	              return !SliceItem["Uploaded"];
	            });
	            var _onProgress2 = params.onProgress;
	            Async.eachLimit(needUploadSlices, ChunkParallel, function(SliceItem, asyncCallback) {
	              if (!self2._isRunningTask(TaskId)) return;
	              var PartNumber = SliceItem["PartNumber"];
	              var currentSize = Math.min(FileSize, SliceItem["PartNumber"] * SliceSize) - (SliceItem["PartNumber"] - 1) * SliceSize;
	              var preAddSize = 0;
	              uploadSliceItem.call(self2, {
	                TaskId,
	                Bucket,
	                Region,
	                Key,
	                SliceSize,
	                FileSize,
	                PartNumber,
	                ServerSideEncryption,
	                Body,
	                UploadData,
	                Headers,
	                onProgress: function onProgress(data) {
	                  FinishSize += data.loaded - preAddSize;
	                  preAddSize = data.loaded;
	                  _onProgress2({
	                    loaded: FinishSize,
	                    total: FileSize
	                  });
	                },
	                tracker: params.tracker
	              }, function(err, data) {
	                if (!self2._isRunningTask(TaskId)) return;
	                if (!err && !data.ETag) err = 'get ETag error, please add "ETag" to CORS ExposeHeader setting.( 获取ETag失败，请在CORS ExposeHeader设置中添加ETag，请参考文档：https://cloud.tencent.com/document/product/436/13318 )';
	                if (err) {
	                  FinishSize -= preAddSize;
	                } else {
	                  FinishSize += currentSize - preAddSize;
	                  SliceItem.ETag = data.ETag;
	                }
	                _onProgress2({
	                  loaded: FinishSize,
	                  total: FileSize
	                });
	                asyncCallback(err || null, data);
	              });
	            }, function(err) {
	              if (!self2._isRunningTask(TaskId)) return;
	              if (err) return cb(err);
	              cb(null, {
	                UploadId: UploadData.UploadId,
	                SliceList: UploadData.PartList
	              });
	            });
	          }
	          function uploadSliceItem(params, callback) {
	            var self2 = this;
	            var TaskId = params.TaskId;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var FileSize = params.FileSize;
	            var FileBody = params.Body;
	            var PartNumber = params.PartNumber * 1;
	            var SliceSize = params.SliceSize;
	            var ServerSideEncryption = params.ServerSideEncryption;
	            var UploadData = params.UploadData;
	            var Headers = params.Headers || {};
	            var ChunkRetryTimes = self2.options.ChunkRetryTimes + 1;
	            var start = SliceSize * (PartNumber - 1);
	            var ContentLength = SliceSize;
	            var end = start + SliceSize;
	            if (end > FileSize) {
	              end = FileSize;
	              ContentLength = end - start;
	            }
	            var headersWhiteList = ["x-cos-traffic-limit", "x-cos-mime-limit"];
	            var headers = {};
	            util.each(Headers, function(v, k) {
	              if (headersWhiteList.indexOf(k) > -1) {
	                headers[k] = v;
	              }
	            });
	            var PartItem = UploadData.PartList[PartNumber - 1];
	            Async.retry(ChunkRetryTimes, function(tryCallback) {
	              if (!self2._isRunningTask(TaskId)) return;
	              util.fileSlice(FileBody, start, end, true, function(Body) {
	                self2.multipartUpload({
	                  TaskId,
	                  Bucket,
	                  Region,
	                  Key,
	                  ContentLength,
	                  PartNumber,
	                  UploadId: UploadData.UploadId,
	                  ServerSideEncryption,
	                  Body,
	                  Headers: headers,
	                  onProgress: params.onProgress,
	                  calledBySdk: "sliceUploadFile",
	                  tracker: params.tracker
	                }, function(err, data) {
	                  if (!self2._isRunningTask(TaskId)) return;
	                  if (err) return tryCallback(err);
	                  PartItem.Uploaded = true;
	                  return tryCallback(null, data);
	                });
	              });
	            }, function(err, data) {
	              if (!self2._isRunningTask(TaskId)) return;
	              return callback(err, data);
	            });
	          }
	          function uploadSliceComplete(params, callback) {
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var UploadId = params.UploadId;
	            var SliceList = params.SliceList;
	            var self2 = this;
	            var ChunkRetryTimes = this.options.ChunkRetryTimes + 1;
	            var Headers = params.Headers;
	            var Parts = SliceList.map(function(item) {
	              return {
	                PartNumber: item.PartNumber,
	                ETag: item.ETag
	              };
	            });
	            Async.retry(ChunkRetryTimes, function(tryCallback) {
	              self2.multipartComplete({
	                Bucket,
	                Region,
	                Key,
	                UploadId,
	                Parts,
	                Headers,
	                calledBySdk: "sliceUploadFile",
	                tracker: params.tracker
	              }, tryCallback);
	            }, function(err, data) {
	              callback(err, data);
	            });
	          }
	          function abortUploadTask(params, callback) {
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var UploadId = params.UploadId;
	            var Level = params.Level || "task";
	            var AsyncLimit = params.AsyncLimit;
	            var self2 = this;
	            var ep = new EventProxy();
	            ep.on("error", function(errData) {
	              return callback(errData);
	            });
	            ep.on("get_abort_array", function(AbortArray) {
	              abortUploadTaskArray.call(self2, {
	                Bucket,
	                Region,
	                Key,
	                Headers: params.Headers,
	                AsyncLimit,
	                AbortArray
	              }, callback);
	            });
	            if (Level === "bucket") {
	              wholeMultipartList.call(self2, {
	                Bucket,
	                Region,
	                calledBySdk: "abortUploadTask"
	              }, function(err, data) {
	                if (err) return callback(err);
	                ep.emit("get_abort_array", data.UploadList || []);
	              });
	            } else if (Level === "file") {
	              if (!Key) return callback(util.error(new Error("abort_upload_task_no_key")));
	              wholeMultipartList.call(self2, {
	                Bucket,
	                Region,
	                Key,
	                calledBySdk: "abortUploadTask"
	              }, function(err, data) {
	                if (err) return callback(err);
	                ep.emit("get_abort_array", data.UploadList || []);
	              });
	            } else if (Level === "task") {
	              if (!UploadId) return callback(util.error(new Error("abort_upload_task_no_id")));
	              if (!Key) return callback(util.error(new Error("abort_upload_task_no_key")));
	              ep.emit("get_abort_array", [{
	                Key,
	                UploadId
	              }]);
	            } else {
	              return callback(util.error(new Error("abort_unknown_level")));
	            }
	          }
	          function abortUploadTaskArray(params, callback) {
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var AbortArray = params.AbortArray;
	            var AsyncLimit = params.AsyncLimit || 1;
	            var self2 = this;
	            var index = 0;
	            var resultList = new Array(AbortArray.length);
	            Async.eachLimit(AbortArray, AsyncLimit, function(AbortItem, nextItem) {
	              var eachIndex = index;
	              if (Key && Key !== AbortItem.Key) {
	                resultList[eachIndex] = {
	                  error: {
	                    KeyNotMatch: true
	                  }
	                };
	                nextItem(null);
	                return;
	              }
	              var UploadId = AbortItem.UploadId || AbortItem.UploadID;
	              self2.multipartAbort({
	                Bucket,
	                Region,
	                Key: AbortItem.Key,
	                Headers: params.Headers,
	                UploadId
	              }, function(err) {
	                var task = {
	                  Bucket,
	                  Region,
	                  Key: AbortItem.Key,
	                  UploadId
	                };
	                resultList[eachIndex] = {
	                  error: err,
	                  task
	                };
	                nextItem(null);
	              });
	              index++;
	            }, function(err) {
	              if (err) return callback(err);
	              var successList = [];
	              var errorList = [];
	              for (var i = 0, len = resultList.length; i < len; i++) {
	                var item = resultList[i];
	                if (item["task"]) {
	                  if (item["error"]) {
	                    errorList.push(item["task"]);
	                  } else {
	                    successList.push(item["task"]);
	                  }
	                }
	              }
	              return callback(null, {
	                successList,
	                errorList
	              });
	            });
	          }
	          function uploadFile(params, callback) {
	            var self2 = this;
	            var SliceSize = params.SliceSize === void 0 ? self2.options.SliceSize : params.SliceSize;
	            var taskList = [];
	            var Body = params.Body;
	            var FileSize = Body.size || Body.length || 0;
	            var fileInfo = {
	              TaskId: ""
	            };
	            if (self2.options.EnableReporter) {
	              var accelerate = self2.options.UseAccelerate || typeof self2.options.Domain === "string" && self2.options.Domain.includes("accelerate.");
	              var realApi = FileSize > SliceSize ? "sliceUploadFile" : "putObject";
	              params.tracker = new Tracker({
	                Beacon: self2.options.BeaconReporter,
	                clsReporter: self2.options.ClsReporter,
	                bucket: params.Bucket,
	                region: params.Region,
	                apiName: "uploadFile",
	                realApi,
	                fileKey: params.Key,
	                fileSize: FileSize,
	                accelerate,
	                deepTracker: self2.options.DeepTracker,
	                customId: self2.options.CustomId,
	                delay: self2.options.TrackerDelay
	              });
	            }
	            util.each(params, function(v, k) {
	              if (_typeof(v) !== "object" && typeof v !== "function") {
	                fileInfo[k] = v;
	              }
	            });
	            var _onTaskReady = params.onTaskReady;
	            var onTaskReady = function onTaskReady2(tid) {
	              fileInfo.TaskId = tid;
	              _onTaskReady && _onTaskReady(tid);
	            };
	            params.onTaskReady = onTaskReady;
	            var api = FileSize > SliceSize ? "sliceUploadFile" : "putObject";
	            var _onFileFinish = params.onFileFinish;
	            var onFileFinish = function onFileFinish2(err, data) {
	              params.tracker && params.tracker.report(err, data);
	              _onFileFinish && _onFileFinish(err, data, fileInfo);
	              callback && callback(err, data);
	            };
	            taskList.push({
	              api,
	              params,
	              callback: onFileFinish
	            });
	            self2._addTasks(taskList);
	          }
	          function uploadFiles(params, callback) {
	            var self2 = this;
	            var SliceSize = params.SliceSize === void 0 ? self2.options.SliceSize : params.SliceSize;
	            var TotalSize = 0;
	            var TotalFinish = 0;
	            var onTotalProgress = util.throttleOnProgress.call(self2, TotalFinish, params.onProgress);
	            var unFinishCount = params.files.length;
	            var _onTotalFileFinish = params.onFileFinish;
	            var resultList = Array(unFinishCount);
	            var onTotalFileFinish = function onTotalFileFinish2(err, data, options) {
	              onTotalProgress(null, true);
	              _onTotalFileFinish && _onTotalFileFinish(err, data, options);
	              resultList[options.Index] = {
	                options,
	                error: err,
	                data
	              };
	              if (--unFinishCount <= 0 && callback) {
	                callback(null, {
	                  files: resultList
	                });
	              }
	            };
	            var taskList = [];
	            util.each(params.files, function(fileParams, index) {
	              (function() {
	                var Body = fileParams.Body;
	                var FileSize = Body.size || Body.length || 0;
	                var fileInfo = {
	                  Index: index,
	                  TaskId: ""
	                };
	                if (!self2.options.UseRawKey && fileParams.Key && fileParams.Key.substr(0, 1) === "/") {
	                  fileParams.Key = fileParams.Key.substr(1);
	                }
	                TotalSize += FileSize;
	                if (self2.options.EnableReporter) {
	                  var accelerate = self2.options.UseAccelerate || typeof self2.options.Domain === "string" && self2.options.Domain.includes("accelerate.");
	                  var realApi = FileSize > SliceSize ? "sliceUploadFile" : "putObject";
	                  fileParams.tracker = new Tracker({
	                    Beacon: self2.options.BeaconReporter,
	                    clsReporter: self2.options.ClsReporter,
	                    bucket: fileParams.Bucket,
	                    region: fileParams.Region,
	                    apiName: "uploadFiles",
	                    realApi,
	                    fileKey: fileParams.Key,
	                    fileSize: FileSize,
	                    accelerate,
	                    deepTracker: self2.options.DeepTracker,
	                    customId: self2.options.CustomId,
	                    delay: self2.options.TrackerDelay
	                  });
	                }
	                util.each(fileParams, function(v, k) {
	                  if (_typeof(v) !== "object" && typeof v !== "function") {
	                    fileInfo[k] = v;
	                  }
	                });
	                var _onTaskReady = fileParams.onTaskReady;
	                var onTaskReady = function onTaskReady2(tid) {
	                  fileInfo.TaskId = tid;
	                  _onTaskReady && _onTaskReady(tid);
	                };
	                fileParams.onTaskReady = onTaskReady;
	                var PreAddSize = 0;
	                var _onProgress = fileParams.onProgress;
	                var onProgress = function onProgress2(info) {
	                  TotalFinish = TotalFinish - PreAddSize + info.loaded;
	                  PreAddSize = info.loaded;
	                  _onProgress && _onProgress(info);
	                  onTotalProgress({
	                    loaded: TotalFinish,
	                    total: TotalSize
	                  });
	                };
	                fileParams.onProgress = onProgress;
	                var api = FileSize > SliceSize ? "sliceUploadFile" : "putObject";
	                var _onFileFinish = fileParams.onFileFinish;
	                var onFileFinish = function onFileFinish2(err, data) {
	                  fileParams.tracker && fileParams.tracker.report(err, data);
	                  _onFileFinish && _onFileFinish(err, data);
	                  onTotalFileFinish && onTotalFileFinish(err, data, fileInfo);
	                };
	                taskList.push({
	                  api,
	                  params: fileParams,
	                  callback: onFileFinish
	                });
	              })();
	            });
	            self2._addTasks(taskList);
	          }
	          function sliceCopyFile(params, callback) {
	            var ep = new EventProxy();
	            var self2 = this;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var CopySource = params.CopySource;
	            var m = util.getSourceParams.call(this, CopySource);
	            if (!m) {
	              callback(util.error(new Error("CopySource format error")));
	              return;
	            }
	            var SourceBucket = m.Bucket;
	            var SourceRegion = m.Region;
	            var SourceKey = decodeURIComponent(m.Key);
	            var CopySliceSize = params.CopySliceSize === void 0 ? self2.options.CopySliceSize : params.CopySliceSize;
	            CopySliceSize = Math.max(0, CopySliceSize);
	            var ChunkSize = params.CopyChunkSize || this.options.CopyChunkSize;
	            var ChunkParallel = this.options.CopyChunkParallelLimit;
	            var ChunkRetryTimes = this.options.ChunkRetryTimes + 1;
	            var ChunkCount = 0;
	            var FinishSize = 0;
	            var FileSize;
	            var onProgress;
	            var SourceResHeaders = {};
	            var SourceHeaders = {};
	            var TargetHeader = {};
	            ep.on("copy_slice_complete", function(UploadData) {
	              util.each(params.Headers, function(val, k) {
	                if (k.toLowerCase().indexOf("x-cos-meta-") === 0) ;
	              });
	              var Parts = util.map(UploadData.PartList, function(item) {
	                return {
	                  PartNumber: item.PartNumber,
	                  ETag: item.ETag
	                };
	              });
	              Async.retry(ChunkRetryTimes, function(tryCallback) {
	                self2.multipartComplete({
	                  Bucket,
	                  Region,
	                  Key,
	                  UploadId: UploadData.UploadId,
	                  Parts,
	                  tracker: params.tracker,
	                  calledBySdk: "sliceCopyFile"
	                }, tryCallback);
	              }, function(err, data) {
	                session.removeUsing(UploadData.UploadId);
	                if (err) {
	                  onProgress(null, true);
	                  return callback(err);
	                }
	                session.removeUploadId(UploadData.UploadId);
	                onProgress({
	                  loaded: FileSize,
	                  total: FileSize
	                }, true);
	                callback(null, data);
	              });
	            });
	            ep.on("get_copy_data_finish", function(UploadData) {
	              var uuid = session.getCopyFileId(CopySource, SourceResHeaders, ChunkSize, Bucket, Key);
	              uuid && session.saveUploadId(uuid, UploadData.UploadId, self2.options.UploadIdCacheLimit);
	              session.setUsing(UploadData.UploadId);
	              var needCopySlices = util.filter(UploadData.PartList, function(SliceItem) {
	                if (SliceItem["Uploaded"]) {
	                  FinishSize += SliceItem["PartNumber"] >= ChunkCount ? FileSize % ChunkSize || ChunkSize : ChunkSize;
	                }
	                return !SliceItem["Uploaded"];
	              });
	              Async.eachLimit(needCopySlices, ChunkParallel, function(SliceItem, asyncCallback) {
	                var PartNumber = SliceItem.PartNumber;
	                var CopySourceRange = SliceItem.CopySourceRange;
	                var currentSize = SliceItem.end - SliceItem.start;
	                Async.retry(ChunkRetryTimes, function(tryCallback) {
	                  copySliceItem.call(self2, {
	                    Bucket,
	                    Region,
	                    Key,
	                    CopySource,
	                    UploadId: UploadData.UploadId,
	                    PartNumber,
	                    CopySourceRange,
	                    tracker: params.tracker,
	                    calledBySdk: "sliceCopyFile"
	                  }, tryCallback);
	                }, function(err, data) {
	                  if (err) return asyncCallback(err);
	                  FinishSize += currentSize;
	                  onProgress({
	                    loaded: FinishSize,
	                    total: FileSize
	                  });
	                  SliceItem.ETag = data.ETag;
	                  asyncCallback(err || null, data);
	                });
	              }, function(err) {
	                if (err) {
	                  session.removeUsing(UploadData.UploadId);
	                  onProgress(null, true);
	                  return callback(err);
	                }
	                ep.emit("copy_slice_complete", UploadData);
	              });
	            });
	            ep.on("get_chunk_size_finish", function() {
	              var createNewUploadId = function createNewUploadId2() {
	                self2.multipartInit({
	                  Bucket,
	                  Region,
	                  Key,
	                  Headers: TargetHeader,
	                  tracker: params.tracker,
	                  calledBySdk: "sliceCopyFile"
	                }, function(err, data) {
	                  if (err) return callback(err);
	                  params.UploadId = data.UploadId;
	                  ep.emit("get_copy_data_finish", {
	                    UploadId: params.UploadId,
	                    PartList: params.PartList
	                  });
	                });
	              };
	              var uuid = session.getCopyFileId(CopySource, SourceResHeaders, ChunkSize, Bucket, Key);
	              var LocalUploadIdList = session.getUploadIdList(uuid);
	              if (!uuid || !LocalUploadIdList) return createNewUploadId();
	              var next = function next2(index) {
	                if (index >= LocalUploadIdList.length) return createNewUploadId();
	                var UploadId = LocalUploadIdList[index];
	                if (session.using[UploadId]) return next2(index + 1);
	                wholeMultipartListPart.call(self2, {
	                  Bucket,
	                  Region,
	                  Key,
	                  UploadId,
	                  tracker: params.tracker,
	                  calledBySdk: "sliceCopyFile"
	                }, function(err, PartListData) {
	                  if (err) {
	                    session.removeUploadId(UploadId);
	                    next2(index + 1);
	                  } else {
	                    if (session.using[UploadId]) return next2(index + 1);
	                    var finishETagMap = {};
	                    var offset = 0;
	                    util.each(PartListData.PartList, function(PartItem) {
	                      var size = parseInt(PartItem.Size);
	                      var end = offset + size - 1;
	                      finishETagMap[PartItem.PartNumber + "|" + offset + "|" + end] = PartItem.ETag;
	                      offset += size;
	                    });
	                    util.each(params.PartList, function(PartItem) {
	                      var ETag = finishETagMap[PartItem.PartNumber + "|" + PartItem.start + "|" + PartItem.end];
	                      if (ETag) {
	                        PartItem.ETag = ETag;
	                        PartItem.Uploaded = true;
	                      }
	                    });
	                    ep.emit("get_copy_data_finish", {
	                      UploadId,
	                      PartList: params.PartList
	                    });
	                  }
	                });
	              };
	              next(0);
	            });
	            ep.on("get_file_size_finish", function() {
	              (function() {
	                var SIZE = [1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 1024 * 2, 1024 * 4, 1024 * 5];
	                var AutoChunkSize = 1024 * 1024;
	                for (var i = 0; i < SIZE.length; i++) {
	                  AutoChunkSize = SIZE[i] * 1024 * 1024;
	                  if (FileSize / AutoChunkSize <= self2.options.MaxPartNumber) break;
	                }
	                params.ChunkSize = ChunkSize = Math.max(ChunkSize, AutoChunkSize);
	                ChunkCount = Math.ceil(FileSize / ChunkSize);
	                var list = [];
	                for (var partNumber = 1; partNumber <= ChunkCount; partNumber++) {
	                  var start = (partNumber - 1) * ChunkSize;
	                  var end = partNumber * ChunkSize < FileSize ? partNumber * ChunkSize - 1 : FileSize - 1;
	                  var item = {
	                    PartNumber: partNumber,
	                    start,
	                    end,
	                    CopySourceRange: "bytes=" + start + "-" + end
	                  };
	                  list.push(item);
	                }
	                params.PartList = list;
	              })();
	              if (params.Headers["x-cos-metadata-directive"] === "Replaced") {
	                TargetHeader = params.Headers;
	              } else {
	                TargetHeader = SourceHeaders;
	              }
	              TargetHeader["x-cos-storage-class"] = params.Headers["x-cos-storage-class"] || SourceHeaders["x-cos-storage-class"];
	              TargetHeader = util.clearKey(TargetHeader);
	              if (SourceHeaders["x-cos-storage-class"] === "ARCHIVE" || SourceHeaders["x-cos-storage-class"] === "DEEP_ARCHIVE") {
	                var restoreHeader = SourceHeaders["x-cos-restore"];
	                if (!restoreHeader || restoreHeader === 'ongoing-request="true"') {
	                  callback(util.error(new Error("Unrestored archive object is not allowed to be copied")));
	                  return;
	                }
	              }
	              delete TargetHeader["x-cos-copy-source"];
	              delete TargetHeader["x-cos-metadata-directive"];
	              delete TargetHeader["x-cos-copy-source-If-Modified-Since"];
	              delete TargetHeader["x-cos-copy-source-If-Unmodified-Since"];
	              delete TargetHeader["x-cos-copy-source-If-Match"];
	              delete TargetHeader["x-cos-copy-source-If-None-Match"];
	              ep.emit("get_chunk_size_finish");
	            });
	            self2.headObject({
	              Bucket: SourceBucket,
	              Region: SourceRegion,
	              Key: SourceKey,
	              tracker: params.tracker,
	              calledBySdk: "sliceCopyFile"
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode && err.statusCode === 404) {
	                  callback(util.error(err, {
	                    ErrorStatus: SourceKey + " Not Exist"
	                  }));
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              FileSize = params.FileSize = data.headers["content-length"];
	              if (FileSize === void 0 || !FileSize) {
	                callback(util.error(new Error('get Content-Length error, please add "Content-Length" to CORS ExposeHeader setting.（ 获取Content-Length失败，请在CORS ExposeHeader设置中添加Content-Length，请参考文档：https://cloud.tencent.com/document/product/436/13318 ）')));
	                return;
	              }
	              params.tracker && params.tracker.setParams({
	                httpSize: FileSize
	              });
	              onProgress = util.throttleOnProgress.call(self2, FileSize, params.onProgress);
	              if (FileSize <= CopySliceSize) {
	                if (!params.Headers["x-cos-metadata-directive"]) {
	                  params.Headers["x-cos-metadata-directive"] = "Copy";
	                }
	                self2.putObjectCopy(Object.assign(params, {
	                  calledBySdk: "sliceCopyFile"
	                }), function(err2, data2) {
	                  if (err2) {
	                    onProgress(null, true);
	                    return callback(err2);
	                  }
	                  onProgress({
	                    loaded: FileSize,
	                    total: FileSize
	                  }, true);
	                  callback(err2, data2);
	                });
	              } else {
	                var resHeaders = data.headers;
	                SourceResHeaders = resHeaders;
	                SourceHeaders = {
	                  "Cache-Control": resHeaders["cache-control"],
	                  "Content-Disposition": resHeaders["content-disposition"],
	                  "Content-Encoding": resHeaders["content-encoding"],
	                  "Content-Type": resHeaders["content-type"],
	                  Expires: resHeaders["expires"],
	                  "x-cos-storage-class": resHeaders["x-cos-storage-class"]
	                };
	                util.each(resHeaders, function(v, k) {
	                  var metaPrefix = "x-cos-meta-";
	                  if (k.indexOf(metaPrefix) === 0 && k.length > metaPrefix.length) {
	                    SourceHeaders[k] = v;
	                  }
	                });
	                ep.emit("get_file_size_finish");
	              }
	            });
	          }
	          function copySliceItem(params, callback) {
	            var TaskId = params.TaskId;
	            var Bucket = params.Bucket;
	            var Region = params.Region;
	            var Key = params.Key;
	            var CopySource = params.CopySource;
	            var UploadId = params.UploadId;
	            var PartNumber = params.PartNumber * 1;
	            var CopySourceRange = params.CopySourceRange;
	            var ChunkRetryTimes = this.options.ChunkRetryTimes + 1;
	            var self2 = this;
	            Async.retry(ChunkRetryTimes, function(tryCallback) {
	              self2.uploadPartCopy({
	                TaskId,
	                Bucket,
	                Region,
	                Key,
	                CopySource,
	                UploadId,
	                PartNumber,
	                CopySourceRange,
	                tracker: params.tracker,
	                calledBySdk: params.calledBySdk
	              }, function(err, data) {
	                tryCallback(err || null, data);
	              });
	            }, function(err, data) {
	              return callback(err, data);
	            });
	          }
	          var API_MAP = {
	            sliceUploadFile,
	            abortUploadTask,
	            uploadFile,
	            uploadFiles,
	            sliceCopyFile
	          };
	          module2.exports.init = function(COS, task) {
	            task.transferToTaskMethod(API_MAP, "sliceUploadFile");
	            util.each(API_MAP, function(fn, apiName) {
	              COS.prototype[apiName] = util.apiWrapper(apiName, fn);
	            });
	          };
	        }
	      ),
	      /***/
	      "./src/async.js": (
	        /*!**********************!*\
	          !*** ./src/async.js ***!
	          \**********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          var eachLimit = function eachLimit2(arr, limit, iterator, callback) {
	            callback = callback || function() {
	            };
	            if (!arr.length || limit <= 0) {
	              return callback();
	            }
	            var completed = 0;
	            var started = 0;
	            var running = 0;
	            (function replenish() {
	              if (completed >= arr.length) {
	                return callback();
	              }
	              while (running < limit && started < arr.length) {
	                started += 1;
	                running += 1;
	                iterator(arr[started - 1], function(err) {
	                  if (err) {
	                    callback(err);
	                    callback = function callback2() {
	                    };
	                  } else {
	                    completed += 1;
	                    running -= 1;
	                    if (completed >= arr.length) {
	                      callback();
	                    } else {
	                      replenish();
	                    }
	                  }
	                });
	              }
	            })();
	          };
	          var retry = function retry2(times, iterator, callback) {
	            var next = function next2(index) {
	              iterator(function(err, data) {
	                if (err && index < times) {
	                  next2(index + 1);
	                } else {
	                  callback(err, data);
	                }
	              });
	            };
	            if (times < 1) {
	              callback();
	            } else {
	              next(1);
	            }
	          };
	          var async = {
	            eachLimit,
	            retry
	          };
	          module2.exports = async;
	        }
	      ),
	      /***/
	      "./src/base.js": (
	        /*!*********************!*\
	          !*** ./src/base.js ***!
	          \*********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _typeof = __webpack_require__(
	            /*! @babel/runtime/helpers/typeof */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          );
	          var REQUEST = __webpack_require__(
	            /*! ../lib/request */
	            "./lib/request.js"
	          );
	          var util = __webpack_require__(
	            /*! ./util */
	            "./src/util.js"
	          );
	          function getService(params, callback) {
	            var protocol = this.options.Protocol || (util.isBrowser && (typeof location === "undefined" ? "undefined" : _typeof(location)) === "object" && location.protocol === "http:" ? "http:" : "https:");
	            var domain = this.options.ServiceDomain;
	            var appId = params.AppId || this.options.appId;
	            var region = params.Region;
	            if (domain) {
	              domain = domain.replace(/\{\{AppId\}\}/gi, appId || "").replace(/\{\{Region\}\}/gi, region || "").replace(/\{\{.*?\}\}/gi, "");
	              if (!/^[a-zA-Z]+:\/\//.test(domain)) {
	                domain = protocol + "//" + domain;
	              }
	              if (domain.slice(-1) === "/") {
	                domain = domain.slice(0, -1);
	              }
	            } else if (region) {
	              domain = protocol + "//cos." + region + ".myqcloud.com";
	            } else {
	              domain = protocol + "//service.cos.myqcloud.com";
	            }
	            var SignHost = "";
	            var standardHost = region ? "cos." + region + ".myqcloud.com" : "service.cos.myqcloud.com";
	            var urlHost = domain.replace(/^https?:\/\/([^/]+)(\/.*)?$/, "$1");
	            if (standardHost === urlHost) SignHost = standardHost;
	            submitRequest.call(this, {
	              Action: "name/cos:GetService",
	              url: domain,
	              method: "GET",
	              headers: params.Headers,
	              SignHost,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var buckets = data && data.ListAllMyBucketsResult && data.ListAllMyBucketsResult.Buckets && data.ListAllMyBucketsResult.Buckets.Bucket || [];
	              buckets = util.isArray(buckets) ? buckets : [buckets];
	              var owner = data && data.ListAllMyBucketsResult && data.ListAllMyBucketsResult.Owner || {};
	              callback(null, {
	                Buckets: buckets,
	                Owner: owner,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucket(params, callback) {
	            var self2 = this;
	            var xml = "";
	            if (params["BucketAZConfig"]) {
	              var CreateBucketConfiguration = {
	                BucketAZConfig: params.BucketAZConfig
	              };
	              xml = util.json2xml({
	                CreateBucketConfiguration
	              });
	            }
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucket",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              body: xml,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var url = getUrl({
	                protocol: self2.options.Protocol,
	                domain: self2.options.Domain,
	                bucket: params.Bucket,
	                region: params.Region,
	                isLocation: true
	              });
	              callback(null, {
	                Location: url,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function headBucket(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:HeadBucket",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              method: "HEAD",
	              tracker: params.tracker
	            }, callback);
	          }
	          function getBucket(params, callback) {
	            var reqParams = {};
	            reqParams["prefix"] = params["Prefix"] || "";
	            reqParams["delimiter"] = params["Delimiter"];
	            reqParams["marker"] = params["Marker"];
	            reqParams["max-keys"] = params["MaxKeys"];
	            reqParams["encoding-type"] = params["EncodingType"];
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucket",
	              ResourceKey: reqParams["prefix"],
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              qs: reqParams,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var ListBucketResult = data.ListBucketResult || {};
	              var Contents = ListBucketResult.Contents || [];
	              var CommonPrefixes = ListBucketResult.CommonPrefixes || [];
	              Contents = util.isArray(Contents) ? Contents : [Contents];
	              CommonPrefixes = util.isArray(CommonPrefixes) ? CommonPrefixes : [CommonPrefixes];
	              var result = util.clone(ListBucketResult);
	              util.extend(result, {
	                Contents,
	                CommonPrefixes,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function deleteBucket(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucket",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              method: "DELETE",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketAcl(params, callback) {
	            var headers = params.Headers;
	            var xml = "";
	            if (params["AccessControlPolicy"]) {
	              var AccessControlPolicy = util.clone(params["AccessControlPolicy"] || {});
	              var Grants = AccessControlPolicy.Grants || AccessControlPolicy.Grant;
	              Grants = util.isArray(Grants) ? Grants : [Grants];
	              delete AccessControlPolicy.Grant;
	              delete AccessControlPolicy.Grants;
	              AccessControlPolicy.AccessControlList = {
	                Grant: Grants
	              };
	              xml = util.json2xml({
	                AccessControlPolicy
	              });
	              headers["Content-Type"] = "application/xml";
	              headers["Content-MD5"] = util.b64(util.md5(xml));
	            }
	            util.each(headers, function(val, key) {
	              if (key.indexOf("x-cos-grant-") === 0) {
	                headers[key] = uniqGrant(headers[key]);
	              }
	            });
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketACL",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers,
	              action: "acl",
	              body: xml,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketAcl(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketACL",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "acl",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var AccessControlPolicy = data.AccessControlPolicy || {};
	              var Owner = AccessControlPolicy.Owner || {};
	              var Grant = AccessControlPolicy.AccessControlList.Grant || [];
	              Grant = util.isArray(Grant) ? Grant : [Grant];
	              var result = decodeAcl(AccessControlPolicy);
	              if (data.headers && data.headers["x-cos-acl"]) {
	                result.ACL = data.headers["x-cos-acl"];
	              }
	              result = util.extend(result, {
	                Owner,
	                Grants: Grant,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function putBucketCors(params, callback) {
	            var CORSConfiguration = params["CORSConfiguration"] || {};
	            var CORSRules = CORSConfiguration["CORSRules"] || params["CORSRules"] || [];
	            CORSRules = util.clone(util.isArray(CORSRules) ? CORSRules : [CORSRules]);
	            util.each(CORSRules, function(rule) {
	              util.each(["AllowedOrigin", "AllowedHeader", "AllowedMethod", "ExposeHeader"], function(key) {
	                var sKey = key + "s";
	                var val = rule[sKey] || rule[key] || [];
	                delete rule[sKey];
	                rule[key] = util.isArray(val) ? val : [val];
	              });
	            });
	            var Conf = {
	              CORSRule: CORSRules
	            };
	            if (params.ResponseVary) Conf.ResponseVary = params.ResponseVary;
	            var xml = util.json2xml({
	              CORSConfiguration: Conf
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketCORS",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "cors",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketCors(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketCORS",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "cors",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error && err.error.Code === "NoSuchCORSConfiguration") {
	                  var result = {
	                    CORSRules: [],
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var CORSConfiguration = data.CORSConfiguration || {};
	              var CORSRules = CORSConfiguration.CORSRules || CORSConfiguration.CORSRule || [];
	              CORSRules = util.clone(util.isArray(CORSRules) ? CORSRules : [CORSRules]);
	              var ResponseVary = CORSConfiguration.ResponseVary;
	              util.each(CORSRules, function(rule) {
	                util.each(["AllowedOrigin", "AllowedHeader", "AllowedMethod", "ExposeHeader"], function(key) {
	                  var sKey = key + "s";
	                  var val = rule[sKey] || rule[key] || [];
	                  delete rule[key];
	                  rule[sKey] = util.isArray(val) ? val : [val];
	                });
	              });
	              callback(null, {
	                CORSRules,
	                ResponseVary,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketCors(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketCORS",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "cors",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode || err.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketLocation(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketLocation",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "location",
	              tracker: params.tracker
	            }, callback);
	          }
	          function putBucketPolicy(params, callback) {
	            var Policy = params["Policy"];
	            try {
	              if (typeof Policy === "string") Policy = JSON.parse(Policy);
	            } catch (e) {
	            }
	            if (!Policy || typeof Policy === "string") return callback(util.error(new Error("Policy format error")));
	            var PolicyStr = JSON.stringify(Policy);
	            if (!Policy.version) Policy.version = "2.0";
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/json";
	            headers["Content-MD5"] = util.b64(util.md5(PolicyStr));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketPolicy",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              action: "policy",
	              body: PolicyStr,
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketPolicy(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketPolicy",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "policy",
	              rawBody: true,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode && err.statusCode === 403) {
	                  return callback(util.error(err, {
	                    ErrorStatus: "Access Denied"
	                  }));
	                }
	                if (err.statusCode && err.statusCode === 405) {
	                  return callback(util.error(err, {
	                    ErrorStatus: "Method Not Allowed"
	                  }));
	                }
	                if (err.statusCode && err.statusCode === 404) {
	                  return callback(util.error(err, {
	                    ErrorStatus: "Policy Not Found"
	                  }));
	                }
	                return callback(err);
	              }
	              var Policy = {};
	              try {
	                Policy = JSON.parse(data.body);
	              } catch (e) {
	              }
	              callback(null, {
	                Policy,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketPolicy(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketPolicy",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "policy",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode || err.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketTagging(params, callback) {
	            var Tagging = params["Tagging"] || {};
	            var Tags = Tagging.TagSet || Tagging.Tags || params["Tags"] || [];
	            Tags = util.clone(util.isArray(Tags) ? Tags : [Tags]);
	            var xml = util.json2xml({
	              Tagging: {
	                TagSet: {
	                  Tag: Tags
	                }
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketTagging",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "tagging",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketTagging(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketTagging",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "tagging",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error && (err.error === "Not Found" || err.error.Code === "NoSuchTagSet")) {
	                  var result = {
	                    Tags: [],
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var Tags = [];
	              try {
	                Tags = data.Tagging.TagSet.Tag || [];
	              } catch (e) {
	              }
	              Tags = util.clone(util.isArray(Tags) ? Tags : [Tags]);
	              callback(null, {
	                Tags,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketTagging(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketTagging",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "tagging",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketLifecycle(params, callback) {
	            var LifecycleConfiguration = params["LifecycleConfiguration"] || {};
	            var Rules = LifecycleConfiguration.Rules || params.Rules || [];
	            Rules = util.clone(Rules);
	            var xml = util.json2xml({
	              LifecycleConfiguration: {
	                Rule: Rules
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketLifecycle",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "lifecycle",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketLifecycle(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketLifecycle",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "lifecycle",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error && err.error.Code === "NoSuchLifecycleConfiguration") {
	                  var result = {
	                    Rules: [],
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var Rules = [];
	              try {
	                Rules = data.LifecycleConfiguration.Rule || [];
	              } catch (e) {
	              }
	              Rules = util.clone(util.isArray(Rules) ? Rules : [Rules]);
	              callback(null, {
	                Rules,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketLifecycle(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketLifecycle",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "lifecycle",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketVersioning(params, callback) {
	            if (!params["VersioningConfiguration"]) {
	              callback(util.error(new Error("missing param VersioningConfiguration")));
	              return;
	            }
	            var VersioningConfiguration = params["VersioningConfiguration"] || {};
	            var xml = util.json2xml({
	              VersioningConfiguration
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketVersioning",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "versioning",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketVersioning(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketVersioning",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "versioning",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (!err) {
	                !data.VersioningConfiguration && (data.VersioningConfiguration = {});
	              }
	              callback(err, data);
	            });
	          }
	          function putBucketReplication(params, callback) {
	            var ReplicationConfiguration = util.clone(params.ReplicationConfiguration);
	            var xml = util.json2xml({
	              ReplicationConfiguration
	            });
	            xml = xml.replace(/<(\/?)Rules>/gi, "<$1Rule>");
	            xml = xml.replace(/<(\/?)Tags>/gi, "<$1Tag>");
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketReplication",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "replication",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketReplication(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketReplication",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "replication",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error && (err.error === "Not Found" || err.error.Code === "ReplicationConfigurationnotFoundError")) {
	                  var result = {
	                    ReplicationConfiguration: {
	                      Rules: []
	                    },
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              !data.ReplicationConfiguration && (data.ReplicationConfiguration = {});
	              if (data.ReplicationConfiguration.Rule) {
	                data.ReplicationConfiguration.Rules = util.makeArray(data.ReplicationConfiguration.Rule);
	                delete data.ReplicationConfiguration.Rule;
	              }
	              callback(err, data);
	            });
	          }
	          function deleteBucketReplication(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketReplication",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "replication",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketWebsite(params, callback) {
	            if (!params["WebsiteConfiguration"]) {
	              callback(util.error(new Error("missing param WebsiteConfiguration")));
	              return;
	            }
	            var WebsiteConfiguration = util.clone(params["WebsiteConfiguration"] || {});
	            var RoutingRules = WebsiteConfiguration["RoutingRules"] || WebsiteConfiguration["RoutingRule"] || [];
	            RoutingRules = util.isArray(RoutingRules) ? RoutingRules : [RoutingRules];
	            delete WebsiteConfiguration.RoutingRule;
	            delete WebsiteConfiguration.RoutingRules;
	            if (RoutingRules.length) WebsiteConfiguration.RoutingRules = {
	              RoutingRule: RoutingRules
	            };
	            var xml = util.json2xml({
	              WebsiteConfiguration
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketWebsite",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "website",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketWebsite(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketWebsite",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              action: "website",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error.Code === "NoSuchWebsiteConfiguration") {
	                  var result = {
	                    WebsiteConfiguration: {},
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var WebsiteConfiguration = data.WebsiteConfiguration || {};
	              if (WebsiteConfiguration["RoutingRules"]) {
	                var RoutingRules = util.clone(WebsiteConfiguration["RoutingRules"].RoutingRule || []);
	                RoutingRules = util.makeArray(RoutingRules);
	                WebsiteConfiguration.RoutingRules = RoutingRules;
	              }
	              callback(null, {
	                WebsiteConfiguration,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketWebsite(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketWebsite",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "website",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketReferer(params, callback) {
	            if (!params["RefererConfiguration"]) {
	              callback(util.error(new Error("missing param RefererConfiguration")));
	              return;
	            }
	            var RefererConfiguration = util.clone(params["RefererConfiguration"] || {});
	            var DomainList = RefererConfiguration["DomainList"] || {};
	            var Domains = DomainList["Domains"] || DomainList["Domain"] || [];
	            Domains = util.isArray(Domains) ? Domains : [Domains];
	            if (Domains.length) RefererConfiguration.DomainList = {
	              Domain: Domains
	            };
	            var xml = util.json2xml({
	              RefererConfiguration
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketReferer",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "referer",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketReferer(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketReferer",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              action: "referer",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error.Code === "NoSuchRefererConfiguration") {
	                  var result = {
	                    WebsiteConfiguration: {},
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var RefererConfiguration = data.RefererConfiguration || {};
	              if (RefererConfiguration["DomainList"]) {
	                var Domains = util.makeArray(RefererConfiguration["DomainList"].Domain || []);
	                RefererConfiguration.DomainList = {
	                  Domains
	                };
	              }
	              callback(null, {
	                RefererConfiguration,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketDomain(params, callback) {
	            var DomainConfiguration = params["DomainConfiguration"] || {};
	            var DomainRule = DomainConfiguration.DomainRule || params.DomainRule || [];
	            DomainRule = util.clone(DomainRule);
	            var xml = util.json2xml({
	              DomainConfiguration: {
	                DomainRule
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketDomain",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "domain",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketDomain(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketDomain",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "domain",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var DomainRule = [];
	              try {
	                DomainRule = data.DomainConfiguration.DomainRule || [];
	              } catch (e) {
	              }
	              DomainRule = util.clone(util.isArray(DomainRule) ? DomainRule : [DomainRule]);
	              callback(null, {
	                DomainRule,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketDomain(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketDomain",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "domain",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketOrigin(params, callback) {
	            var OriginConfiguration = params["OriginConfiguration"] || {};
	            var OriginRule = OriginConfiguration.OriginRule || params.OriginRule || [];
	            OriginRule = util.clone(OriginRule);
	            var xml = util.json2xml({
	              OriginConfiguration: {
	                OriginRule
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketOrigin",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "origin",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketOrigin(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketOrigin",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "origin",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var OriginRule = [];
	              try {
	                OriginRule = data.OriginConfiguration.OriginRule || [];
	              } catch (e) {
	              }
	              OriginRule = util.clone(util.isArray(OriginRule) ? OriginRule : [OriginRule]);
	              callback(null, {
	                OriginRule,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteBucketOrigin(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketOrigin",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "origin",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketLogging(params, callback) {
	            var xml = util.json2xml({
	              BucketLoggingStatus: params["BucketLoggingStatus"] || ""
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketLogging",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "logging",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketLogging(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketLogging",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "logging",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                BucketLoggingStatus: data.BucketLoggingStatus,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function submitBucketInventory(method, params, callback) {
	            var InventoryConfiguration = util.clone(params["InventoryConfiguration"]);
	            if (InventoryConfiguration.OptionalFields) {
	              var Field = InventoryConfiguration.OptionalFields || [];
	              InventoryConfiguration.OptionalFields = {
	                Field
	              };
	            }
	            if (InventoryConfiguration.Destination && InventoryConfiguration.Destination.COSBucketDestination && InventoryConfiguration.Destination.COSBucketDestination.Encryption) {
	              var Encryption = InventoryConfiguration.Destination.COSBucketDestination.Encryption;
	              if (Object.keys(Encryption).indexOf("SSECOS") > -1) {
	                Encryption["SSE-COS"] = Encryption["SSECOS"];
	                delete Encryption["SSECOS"];
	              }
	            }
	            var xml = util.json2xml({
	              InventoryConfiguration
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            var action = method === "PUT" ? "name/cos:PutBucketInventory" : "name/cos:PostBucketInventory";
	            submitRequest.call(this, {
	              Action: action,
	              method,
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "inventory",
	              qs: {
	                id: params["Id"]
	              },
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketInventory(params, callback) {
	            return submitBucketInventory.call(this, "PUT", params, callback);
	          }
	          function postBucketInventory(params, callback) {
	            return submitBucketInventory.call(this, "POST", params, callback);
	          }
	          function getBucketInventory(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketInventory",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "inventory",
	              qs: {
	                id: params["Id"]
	              },
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var InventoryConfiguration = data["InventoryConfiguration"];
	              if (InventoryConfiguration && InventoryConfiguration.OptionalFields && InventoryConfiguration.OptionalFields.Field) {
	                var Field = InventoryConfiguration.OptionalFields.Field;
	                if (!util.isArray(Field)) {
	                  Field = [Field];
	                }
	                InventoryConfiguration.OptionalFields = Field;
	              }
	              if (InventoryConfiguration.Destination && InventoryConfiguration.Destination.COSBucketDestination && InventoryConfiguration.Destination.COSBucketDestination.Encryption) {
	                var Encryption = InventoryConfiguration.Destination.COSBucketDestination.Encryption;
	                if (Object.keys(Encryption).indexOf("SSE-COS") > -1) {
	                  Encryption["SSECOS"] = Encryption["SSE-COS"];
	                  delete Encryption["SSE-COS"];
	                }
	              }
	              callback(null, {
	                InventoryConfiguration,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function listBucketInventory(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:ListBucketInventory",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "inventory",
	              qs: {
	                "continuation-token": params["ContinuationToken"]
	              },
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var ListInventoryConfigurationResult = data["ListInventoryConfigurationResult"];
	              var InventoryConfigurations = ListInventoryConfigurationResult.InventoryConfiguration || [];
	              InventoryConfigurations = util.isArray(InventoryConfigurations) ? InventoryConfigurations : [InventoryConfigurations];
	              delete ListInventoryConfigurationResult["InventoryConfiguration"];
	              util.each(InventoryConfigurations, function(InventoryConfiguration) {
	                if (InventoryConfiguration && InventoryConfiguration.OptionalFields && InventoryConfiguration.OptionalFields.Field) {
	                  var Field = InventoryConfiguration.OptionalFields.Field;
	                  if (!util.isArray(Field)) {
	                    Field = [Field];
	                  }
	                  InventoryConfiguration.OptionalFields = Field;
	                }
	                if (InventoryConfiguration.Destination && InventoryConfiguration.Destination.COSBucketDestination && InventoryConfiguration.Destination.COSBucketDestination.Encryption) {
	                  var Encryption = InventoryConfiguration.Destination.COSBucketDestination.Encryption;
	                  if (Object.keys(Encryption).indexOf("SSE-COS") > -1) {
	                    Encryption["SSECOS"] = Encryption["SSE-COS"];
	                    delete Encryption["SSE-COS"];
	                  }
	                }
	              });
	              ListInventoryConfigurationResult.InventoryConfigurations = InventoryConfigurations;
	              util.extend(ListInventoryConfigurationResult, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, ListInventoryConfigurationResult);
	            });
	          }
	          function deleteBucketInventory(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketInventory",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "inventory",
	              qs: {
	                id: params["Id"]
	              },
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putBucketAccelerate(params, callback) {
	            if (!params["AccelerateConfiguration"]) {
	              callback(util.error(new Error("missing param AccelerateConfiguration")));
	              return;
	            }
	            var configuration = {
	              AccelerateConfiguration: params.AccelerateConfiguration || {}
	            };
	            var xml = util.json2xml(configuration);
	            var headers = {};
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketAccelerate",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "accelerate",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketAccelerate(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketAccelerate",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              action: "accelerate",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (!err) {
	                !data.AccelerateConfiguration && (data.AccelerateConfiguration = {});
	              }
	              callback(err, data);
	            });
	          }
	          function putBucketEncryption(params, callback) {
	            var conf = params.ServerSideEncryptionConfiguration || {};
	            var Rules = conf.Rule || conf.Rules || [];
	            var xml = util.json2xml({
	              ServerSideEncryptionConfiguration: {
	                Rule: Rules
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutBucketEncryption",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "encryption",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getBucketEncryption(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketEncryption",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "encryption",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.code === "NoSuchEncryptionConfiguration") {
	                  var result = {
	                    EncryptionConfiguration: {
	                      Rules: []
	                    },
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var Rules = util.makeArray(data.EncryptionConfiguration && data.EncryptionConfiguration.Rule || []);
	              data.EncryptionConfiguration = {
	                Rules
	              };
	              callback(err, data);
	            });
	          }
	          function deleteBucketEncryption(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteBucketReplication",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "encryption",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function headObject(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:HeadObject",
	              method: "HEAD",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              VersionId: params.VersionId,
	              headers: params.Headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                var statusCode = err.statusCode;
	                if (params.Headers["If-Modified-Since"] && statusCode && statusCode === 304) {
	                  return callback(null, {
	                    NotModified: true,
	                    statusCode
	                  });
	                }
	                return callback(err);
	              }
	              data.ETag = util.attr(data.headers, "etag", "");
	              callback(null, data);
	            });
	          }
	          function listObjectVersions(params, callback) {
	            var reqParams = {};
	            reqParams["prefix"] = params["Prefix"] || "";
	            reqParams["delimiter"] = params["Delimiter"];
	            reqParams["key-marker"] = params["KeyMarker"];
	            reqParams["version-id-marker"] = params["VersionIdMarker"];
	            reqParams["max-keys"] = params["MaxKeys"];
	            reqParams["encoding-type"] = params["EncodingType"];
	            submitRequest.call(this, {
	              Action: "name/cos:GetBucketObjectVersions",
	              ResourceKey: reqParams["prefix"],
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              qs: reqParams,
	              action: "versions",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var ListVersionsResult = data.ListVersionsResult || {};
	              var DeleteMarkers = ListVersionsResult.DeleteMarker || [];
	              DeleteMarkers = util.isArray(DeleteMarkers) ? DeleteMarkers : [DeleteMarkers];
	              var Versions = ListVersionsResult.Version || [];
	              Versions = util.isArray(Versions) ? Versions : [Versions];
	              var result = util.clone(ListVersionsResult);
	              delete result.DeleteMarker;
	              delete result.Version;
	              util.extend(result, {
	                DeleteMarkers,
	                Versions,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function getObject(params, callback) {
	            if (this.options.ObjectKeySimplifyCheck) {
	              var formatKey = util.simplifyPath(params.Key);
	              if (formatKey === "/") {
	                callback(util.error(new Error("The Getobject Key is illegal")));
	                return;
	              }
	            }
	            var reqParams = params.Query || {};
	            var reqParamsStr = params.QueryString || "";
	            var onProgress = util.throttleOnProgress.call(this, 0, params.onProgress);
	            var tracker = params.tracker;
	            tracker && tracker.setParams({
	              signStartTime: (/* @__PURE__ */ new Date()).getTime()
	            });
	            reqParams["response-content-type"] = params["ResponseContentType"];
	            reqParams["response-content-language"] = params["ResponseContentLanguage"];
	            reqParams["response-expires"] = params["ResponseExpires"];
	            reqParams["response-cache-control"] = params["ResponseCacheControl"];
	            reqParams["response-content-disposition"] = params["ResponseContentDisposition"];
	            reqParams["response-content-encoding"] = params["ResponseContentEncoding"];
	            submitRequest.call(this, {
	              Action: "name/cos:GetObject",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              VersionId: params.VersionId,
	              DataType: params.DataType,
	              headers: params.Headers,
	              qs: reqParams,
	              qsStr: reqParamsStr,
	              rawBody: true,
	              onDownloadProgress: onProgress,
	              tracker
	            }, function(err, data) {
	              onProgress(null, true);
	              if (err) {
	                var statusCode = err.statusCode;
	                if (params.Headers["If-Modified-Since"] && statusCode && statusCode === 304) {
	                  return callback(null, {
	                    NotModified: true
	                  });
	                }
	                return callback(err);
	              }
	              callback(null, {
	                Body: data.body,
	                ETag: util.attr(data.headers, "etag", ""),
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putObject(params, callback) {
	            var self2 = this;
	            var FileSize = params.ContentLength;
	            var onProgress = util.throttleOnProgress.call(self2, FileSize, params.onProgress);
	            var headers = params.Headers;
	            if (!headers["Cache-Control"] && !headers["cache-control"]) headers["Cache-Control"] = "";
	            if (!headers["Content-Type"] && !headers["content-type"]) headers["Content-Type"] = params.Body && params.Body.type || "";
	            var needCalcMd5 = params.UploadAddMetaMd5 || self2.options.UploadAddMetaMd5 || self2.options.UploadCheckContentMd5;
	            var tracker = params.tracker;
	            needCalcMd5 && tracker && tracker.setParams({
	              md5StartTime: (/* @__PURE__ */ new Date()).getTime()
	            });
	            util.getBodyMd5(needCalcMd5, params.Body, function(md5) {
	              if (md5) {
	                tracker && tracker.setParams({
	                  md5EndTime: (/* @__PURE__ */ new Date()).getTime()
	                });
	                if (self2.options.UploadCheckContentMd5) headers["Content-MD5"] = util.b64(md5);
	                if (params.UploadAddMetaMd5 || self2.options.UploadAddMetaMd5) headers["x-cos-meta-md5"] = md5;
	              }
	              if (params.ContentLength !== void 0) headers["Content-Length"] = params.ContentLength;
	              onProgress(null, true);
	              submitRequest.call(self2, {
	                Action: "name/cos:PutObject",
	                TaskId: params.TaskId,
	                method: "PUT",
	                Bucket: params.Bucket,
	                Region: params.Region,
	                Key: params.Key,
	                headers: params.Headers,
	                qs: params.Query,
	                body: params.Body,
	                onProgress,
	                tracker
	              }, function(err, data) {
	                if (err) {
	                  onProgress(null, true);
	                  return callback(err);
	                }
	                onProgress({
	                  loaded: FileSize,
	                  total: FileSize
	                }, true);
	                var url = getUrl({
	                  ForcePathStyle: self2.options.ForcePathStyle,
	                  protocol: self2.options.Protocol,
	                  domain: self2.options.Domain,
	                  bucket: params.Bucket,
	                  region: !self2.options.UseAccelerate ? params.Region : "accelerate",
	                  object: params.Key
	                });
	                url = url.substr(url.indexOf("://") + 3);
	                data.Location = url;
	                data.ETag = util.attr(data.headers, "etag", "");
	                callback(null, data);
	              });
	            }, params.onHashProgress);
	          }
	          function deleteObject(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteObject",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              VersionId: params.VersionId,
	              action: params.Recursive ? "recursive" : "",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                var statusCode = err.statusCode;
	                if (statusCode && statusCode === 404) {
	                  return callback(null, {
	                    BucketNotFound: true,
	                    statusCode
	                  });
	                } else {
	                  return callback(err);
	                }
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getObjectAcl(params, callback) {
	            var reqParams = {};
	            if (params.VersionId) {
	              reqParams.versionId = params.VersionId;
	            }
	            submitRequest.call(this, {
	              Action: "name/cos:GetObjectACL",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              qs: reqParams,
	              action: "acl",
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var AccessControlPolicy = data.AccessControlPolicy || {};
	              var Owner = AccessControlPolicy.Owner || {};
	              var Grant = AccessControlPolicy.AccessControlList && AccessControlPolicy.AccessControlList.Grant || [];
	              Grant = util.isArray(Grant) ? Grant : [Grant];
	              var result = decodeAcl(AccessControlPolicy);
	              delete result.GrantWrite;
	              if (data.headers && data.headers["x-cos-acl"]) {
	                result.ACL = data.headers["x-cos-acl"];
	              }
	              result = util.extend(result, {
	                Owner,
	                Grants: Grant,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function putObjectAcl(params, callback) {
	            var headers = params.Headers;
	            var xml = "";
	            if (params["AccessControlPolicy"]) {
	              var AccessControlPolicy = util.clone(params["AccessControlPolicy"] || {});
	              var Grants = AccessControlPolicy.Grants || AccessControlPolicy.Grant;
	              Grants = util.isArray(Grants) ? Grants : [Grants];
	              delete AccessControlPolicy.Grant;
	              delete AccessControlPolicy.Grants;
	              AccessControlPolicy.AccessControlList = {
	                Grant: Grants
	              };
	              xml = util.json2xml({
	                AccessControlPolicy
	              });
	              headers["Content-Type"] = "application/xml";
	              headers["Content-MD5"] = util.b64(util.md5(xml));
	            }
	            util.each(headers, function(val, key) {
	              if (key.indexOf("x-cos-grant-") === 0) {
	                headers[key] = uniqGrant(headers[key]);
	              }
	            });
	            submitRequest.call(this, {
	              Action: "name/cos:PutObjectACL",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              action: "acl",
	              headers,
	              body: xml,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function optionsObject(params, callback) {
	            var headers = params.Headers;
	            headers["Origin"] = params["Origin"];
	            headers["Access-Control-Request-Method"] = params["AccessControlRequestMethod"];
	            headers["Access-Control-Request-Headers"] = params["AccessControlRequestHeaders"];
	            submitRequest.call(this, {
	              Action: "name/cos:OptionsObject",
	              method: "OPTIONS",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode && err.statusCode === 403) {
	                  return callback(null, {
	                    OptionsForbidden: true,
	                    statusCode: err.statusCode
	                  });
	                }
	                return callback(err);
	              }
	              var headers2 = data.headers || {};
	              callback(null, {
	                AccessControlAllowOrigin: headers2["access-control-allow-origin"],
	                AccessControlAllowMethods: headers2["access-control-allow-methods"],
	                AccessControlAllowHeaders: headers2["access-control-allow-headers"],
	                AccessControlExposeHeaders: headers2["access-control-expose-headers"],
	                AccessControlMaxAge: headers2["access-control-max-age"],
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function putObjectCopy(params, callback) {
	            var self2 = this;
	            var headers = params.Headers;
	            if (!headers["Cache-Control"] && !headers["cache-control"]) headers["Cache-Control"] = "";
	            var CopySource = params.CopySource || "";
	            var m = util.getSourceParams.call(this, CopySource);
	            if (!m) {
	              callback(util.error(new Error("CopySource format error")));
	              return;
	            }
	            var SourceBucket = m.Bucket;
	            var SourceRegion = m.Region;
	            var SourceKey = decodeURIComponent(m.Key);
	            submitRequest.call(this, {
	              Scope: [{
	                action: "name/cos:GetObject",
	                bucket: SourceBucket,
	                region: SourceRegion,
	                prefix: SourceKey
	              }, {
	                action: "name/cos:PutObject",
	                bucket: params.Bucket,
	                region: params.Region,
	                prefix: params.Key
	              }],
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              VersionId: params.VersionId,
	              headers: params.Headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var result = util.clone(data.CopyObjectResult || {});
	              var url = getUrl({
	                ForcePathStyle: self2.options.ForcePathStyle,
	                protocol: self2.options.Protocol,
	                domain: self2.options.Domain,
	                bucket: params.Bucket,
	                region: params.Region,
	                object: params.Key,
	                isLocation: true
	              });
	              util.extend(result, {
	                Location: url,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function uploadPartCopy(params, callback) {
	            var CopySource = params.CopySource || "";
	            var m = util.getSourceParams.call(this, CopySource);
	            if (!m) {
	              callback(util.error(new Error("CopySource format error")));
	              return;
	            }
	            var SourceBucket = m.Bucket;
	            var SourceRegion = m.Region;
	            var SourceKey = decodeURIComponent(m.Key);
	            submitRequest.call(this, {
	              Scope: [{
	                action: "name/cos:GetObject",
	                bucket: SourceBucket,
	                region: SourceRegion,
	                prefix: SourceKey
	              }, {
	                action: "name/cos:PutObject",
	                bucket: params.Bucket,
	                region: params.Region,
	                prefix: params.Key
	              }],
	              method: "PUT",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              VersionId: params.VersionId,
	              qs: {
	                partNumber: params["PartNumber"],
	                uploadId: params["UploadId"]
	              },
	              headers: params.Headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var result = util.clone(data.CopyPartResult || {});
	              util.extend(result, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function deleteMultipleObject(params, callback) {
	            var Objects = params.Objects || [];
	            var Quiet = params.Quiet;
	            Objects = util.isArray(Objects) ? Objects : [Objects];
	            var xml = util.json2xml({
	              Delete: {
	                Object: Objects,
	                Quiet: Quiet || false
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            var Scope = util.map(Objects, function(v) {
	              return {
	                action: "name/cos:DeleteObject",
	                bucket: params.Bucket,
	                region: params.Region,
	                prefix: v.Key
	              };
	            });
	            submitRequest.call(this, {
	              Scope,
	              method: "POST",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              body: xml,
	              action: "delete",
	              headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              var DeleteResult = data.DeleteResult || {};
	              var Deleted = DeleteResult.Deleted || [];
	              var Errors = DeleteResult.Error || [];
	              Deleted = util.isArray(Deleted) ? Deleted : [Deleted];
	              Errors = util.isArray(Errors) ? Errors : [Errors];
	              var result = util.clone(DeleteResult);
	              util.extend(result, {
	                Error: Errors,
	                Deleted,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function restoreObject(params, callback) {
	            var headers = params.Headers;
	            if (!params["RestoreRequest"]) {
	              callback(util.error(new Error("missing param RestoreRequest")));
	              return;
	            }
	            var RestoreRequest = params.RestoreRequest || {};
	            var xml = util.json2xml({
	              RestoreRequest
	            });
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:RestoreObject",
	              method: "POST",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              VersionId: params.VersionId,
	              body: xml,
	              action: "restore",
	              headers,
	              tracker: params.tracker
	            }, callback);
	          }
	          function putObjectTagging(params, callback) {
	            var Tagging = params["Tagging"] || {};
	            var Tags = Tagging.TagSet || Tagging.Tags || params["Tags"] || [];
	            Tags = util.clone(util.isArray(Tags) ? Tags : [Tags]);
	            var xml = util.json2xml({
	              Tagging: {
	                TagSet: {
	                  Tag: Tags
	                }
	              }
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:PutObjectTagging",
	              method: "PUT",
	              Bucket: params.Bucket,
	              Key: params.Key,
	              Region: params.Region,
	              body: xml,
	              action: "tagging",
	              headers,
	              VersionId: params.VersionId,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function getObjectTagging(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:GetObjectTagging",
	              method: "GET",
	              Key: params.Key,
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              action: "tagging",
	              VersionId: params.VersionId,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) {
	                if (err.statusCode === 404 && err.error && (err.error === "Not Found" || err.error.Code === "NoSuchTagSet")) {
	                  var result = {
	                    Tags: [],
	                    statusCode: err.statusCode
	                  };
	                  err.headers && (result.headers = err.headers);
	                  callback(null, result);
	                } else {
	                  callback(err);
	                }
	                return;
	              }
	              var Tags = [];
	              try {
	                Tags = data.Tagging.TagSet.Tag || [];
	              } catch (e) {
	              }
	              Tags = util.clone(util.isArray(Tags) ? Tags : [Tags]);
	              callback(null, {
	                Tags,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function deleteObjectTagging(params, callback) {
	            submitRequest.call(this, {
	              Action: "name/cos:DeleteObjectTagging",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              action: "tagging",
	              VersionId: params.VersionId,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function selectObjectContent(params, callback) {
	            var SelectType = params["SelectType"];
	            if (!SelectType) return callback(util.error(new Error("missing param SelectType")));
	            var SelectRequest = params["SelectRequest"] || {};
	            var xml = util.json2xml({
	              SelectRequest
	            });
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:GetObject",
	              method: "POST",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              action: "select",
	              qs: {
	                "select-type": params["SelectType"]
	              },
	              VersionId: params.VersionId,
	              body: xml,
	              DataType: "arraybuffer",
	              rawBody: true,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err && err.statusCode === 204) {
	                return callback(null, {
	                  statusCode: err.statusCode
	                });
	              } else if (err) {
	                return callback(err);
	              }
	              var result = util.parseSelectPayload(data.body);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers,
	                Body: result.body,
	                Payload: result.payload
	              });
	            });
	          }
	          function multipartInit(params, callback) {
	            var self2 = this;
	            var headers = params.Headers;
	            var tracker = params.tracker;
	            if (!headers["Cache-Control"] && !headers["cache-control"]) headers["Cache-Control"] = "";
	            if (!headers["Content-Type"] && !headers["content-type"]) headers["Content-Type"] = params.Body && params.Body.type || "";
	            var needCalcMd5 = params.Body && (params.UploadAddMetaMd5 || self2.options.UploadAddMetaMd5);
	            needCalcMd5 && tracker && tracker.setParams({
	              md5StartTime: (/* @__PURE__ */ new Date()).getTime()
	            });
	            util.getBodyMd5(needCalcMd5, params.Body, function(md5) {
	              if (md5) params.Headers["x-cos-meta-md5"] = md5;
	              needCalcMd5 && tracker && tracker.setParams({
	                md5EndTime: (/* @__PURE__ */ new Date()).getTime()
	              });
	              submitRequest.call(self2, {
	                Action: "name/cos:InitiateMultipartUpload",
	                method: "POST",
	                Bucket: params.Bucket,
	                Region: params.Region,
	                Key: params.Key,
	                action: "uploads",
	                headers: params.Headers,
	                qs: params.Query,
	                tracker
	              }, function(err, data) {
	                if (err) {
	                  tracker && tracker.parent && tracker.parent.setParams({
	                    errorNode: "multipartInit"
	                  });
	                  return callback(err);
	                }
	                data = util.clone(data || {});
	                if (data && data.InitiateMultipartUploadResult) {
	                  return callback(null, util.extend(data.InitiateMultipartUploadResult, {
	                    statusCode: data.statusCode,
	                    headers: data.headers
	                  }));
	                }
	                callback(null, data);
	              });
	            }, params.onHashProgress);
	          }
	          function multipartUpload(params, callback) {
	            var self2 = this;
	            util.getFileSize("multipartUpload", params, function() {
	              var tracker = params.tracker;
	              var needCalcMd5 = self2.options.UploadCheckContentMd5;
	              needCalcMd5 && tracker && tracker.setParams({
	                md5StartTime: (/* @__PURE__ */ new Date()).getTime()
	              });
	              util.getBodyMd5(needCalcMd5, params.Body, function(md5) {
	                if (md5) params.Headers["Content-MD5"] = util.b64(md5);
	                needCalcMd5 && tracker && tracker.setParams({
	                  md5EndTime: (/* @__PURE__ */ new Date()).getTime()
	                });
	                tracker && tracker.setParams({
	                  partNumber: params.PartNumber
	                });
	                submitRequest.call(self2, {
	                  Action: "name/cos:UploadPart",
	                  TaskId: params.TaskId,
	                  method: "PUT",
	                  Bucket: params.Bucket,
	                  Region: params.Region,
	                  Key: params.Key,
	                  qs: {
	                    partNumber: params["PartNumber"],
	                    uploadId: params["UploadId"]
	                  },
	                  headers: params.Headers,
	                  onProgress: params.onProgress,
	                  body: params.Body || null,
	                  tracker
	                }, function(err, data) {
	                  if (err) {
	                    tracker && tracker.parent && tracker.parent.setParams({
	                      errorNode: "multipartUpload"
	                    });
	                    return callback(err);
	                  }
	                  callback(null, {
	                    ETag: util.attr(data.headers, "etag", ""),
	                    statusCode: data.statusCode,
	                    headers: data.headers
	                  });
	                });
	              });
	            });
	          }
	          function multipartComplete(params, callback) {
	            var self2 = this;
	            var UploadId = params.UploadId;
	            var Parts = params["Parts"];
	            var tracker = params.tracker;
	            for (var i = 0, len = Parts.length; i < len; i++) {
	              if (Parts[i]["ETag"] && Parts[i]["ETag"].indexOf('"') === 0) {
	                continue;
	              }
	              Parts[i]["ETag"] = '"' + Parts[i]["ETag"] + '"';
	            }
	            var xml = util.json2xml({
	              CompleteMultipartUpload: {
	                Part: Parts
	              }
	            });
	            xml = xml.replace(/\n\s*/g, "");
	            var headers = params.Headers;
	            headers["Content-Type"] = "application/xml";
	            headers["Content-MD5"] = util.b64(util.md5(xml));
	            submitRequest.call(this, {
	              Action: "name/cos:CompleteMultipartUpload",
	              method: "POST",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              qs: {
	                uploadId: UploadId
	              },
	              body: xml,
	              headers,
	              tracker
	            }, function(err, data) {
	              if (err) {
	                tracker && tracker.parent && tracker.parent.setParams({
	                  errorNode: "multipartComplete"
	                });
	                return callback(err);
	              }
	              var url = getUrl({
	                ForcePathStyle: self2.options.ForcePathStyle,
	                protocol: self2.options.Protocol,
	                domain: self2.options.Domain,
	                bucket: params.Bucket,
	                region: params.Region,
	                object: params.Key,
	                isLocation: true
	              });
	              var res = data.CompleteMultipartUploadResult || {};
	              if (res.ProcessResults) {
	                res.UploadResult = {
	                  OriginalInfo: {
	                    Key: res.Key,
	                    Location: url,
	                    ETag: res.ETag,
	                    ImageInfo: res.ImageInfo
	                  },
	                  ProcessResults: res.ProcessResults
	                };
	                delete res.ImageInfo;
	                delete res.ProcessResults;
	              }
	              if (res.CallbackResult) {
	                var callbackResult = res.CallbackResult;
	                if (callbackResult.Status === "200" && callbackResult.CallbackBody) {
	                  try {
	                    res.CallbackBody = JSON.parse(util.decodeBase64(callbackResult.CallbackBody));
	                  } catch (e) {
	                    res.CallbackBody = {};
	                  }
	                } else {
	                  res.CallbackError = callbackResult.Error || {};
	                }
	                delete res.CallbackResult;
	              }
	              if (res.ReturnBodyResult) {
	                var returnBodyResult = res.ReturnBodyResult;
	                if (returnBodyResult.Status === "200" && returnBodyResult.ReturnBody) {
	                  try {
	                    res.ReturnBody = JSON.parse(util.decodeBase64(returnBodyResult.ReturnBody));
	                  } catch (e) {
	                    res.ReturnBody = {};
	                  }
	                } else {
	                  res.ReturnError = {
	                    Code: returnBodyResult.Code,
	                    Message: returnBodyResult.Message,
	                    Status: returnBodyResult.Status
	                  };
	                }
	                delete res.ReturnBodyResult;
	              }
	              var result = util.extend(res, {
	                Location: url,
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function multipartList(params, callback) {
	            var reqParams = {};
	            reqParams["delimiter"] = params["Delimiter"];
	            reqParams["encoding-type"] = params["EncodingType"];
	            reqParams["prefix"] = params["Prefix"] || "";
	            reqParams["max-uploads"] = params["MaxUploads"];
	            reqParams["key-marker"] = params["KeyMarker"];
	            reqParams["upload-id-marker"] = params["UploadIdMarker"];
	            reqParams = util.clearKey(reqParams);
	            var tracker = params.tracker;
	            tracker && tracker.setParams({
	              signStartTime: (/* @__PURE__ */ new Date()).getTime()
	            });
	            submitRequest.call(this, {
	              Action: "name/cos:ListMultipartUploads",
	              ResourceKey: reqParams["prefix"],
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              headers: params.Headers,
	              qs: reqParams,
	              action: "uploads",
	              tracker
	            }, function(err, data) {
	              if (err) {
	                tracker && tracker.parent && tracker.parent.setParams({
	                  errorNode: "multipartList"
	                });
	                return callback(err);
	              }
	              if (data && data.ListMultipartUploadsResult) {
	                var Upload = data.ListMultipartUploadsResult.Upload || [];
	                Upload = util.isArray(Upload) ? Upload : [Upload];
	                data.ListMultipartUploadsResult.Upload = Upload;
	              }
	              var result = util.clone(data.ListMultipartUploadsResult || {});
	              util.extend(result, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function multipartListPart(params, callback) {
	            var reqParams = {};
	            var tracker = params.tracker;
	            reqParams["uploadId"] = params["UploadId"];
	            reqParams["encoding-type"] = params["EncodingType"];
	            reqParams["max-parts"] = params["MaxParts"];
	            reqParams["part-number-marker"] = params["PartNumberMarker"];
	            submitRequest.call(this, {
	              Action: "name/cos:ListParts",
	              method: "GET",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              qs: reqParams,
	              tracker
	            }, function(err, data) {
	              if (err) {
	                tracker && tracker.parent && tracker.parent.setParams({
	                  errorNode: "multipartListPart"
	                });
	                return callback(err);
	              }
	              var ListPartsResult = data.ListPartsResult || {};
	              var Part = ListPartsResult.Part || [];
	              Part = util.isArray(Part) ? Part : [Part];
	              ListPartsResult.Part = Part;
	              var result = util.clone(ListPartsResult);
	              util.extend(result, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	              callback(null, result);
	            });
	          }
	          function multipartAbort(params, callback) {
	            var reqParams = {};
	            reqParams["uploadId"] = params["UploadId"];
	            submitRequest.call(this, {
	              Action: "name/cos:AbortMultipartUpload",
	              method: "DELETE",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              headers: params.Headers,
	              qs: reqParams,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, {
	                statusCode: data.statusCode,
	                headers: data.headers
	              });
	            });
	          }
	          function request(params, callback) {
	            submitRequest.call(this, {
	              method: params.Method,
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Key: params.Key,
	              action: params.Action,
	              headers: params.Headers,
	              qs: params.Query,
	              body: params.Body,
	              Url: params.Url,
	              rawBody: params.RawBody,
	              DataType: params.DataType,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              if (data && data.body) {
	                data.Body = data.body;
	                delete data.body;
	              }
	              callback(err, data);
	            });
	          }
	          function appendObject(params, callback) {
	            var headers = params.Headers;
	            if (!headers["Cache-Control"] && !headers["cache-control"]) headers["Cache-Control"] = "";
	            if (!headers["Content-Type"] && !headers["content-type"]) headers["Content-Type"] = params.Body && params.Body.type || "";
	            submitRequest.call(this, {
	              Action: "name/cos:AppendObject",
	              method: "POST",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              action: "append",
	              Key: params.Key,
	              body: params.Body,
	              qs: {
	                position: params.Position
	              },
	              headers: params.Headers,
	              tracker: params.tracker
	            }, function(err, data) {
	              if (err) return callback(err);
	              callback(null, data);
	            });
	          }
	          function getAuth(params) {
	            var self2 = this;
	            return util.getAuth({
	              SecretId: params.SecretId || this.options.SecretId || "",
	              SecretKey: params.SecretKey || this.options.SecretKey || "",
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Method: params.Method,
	              Key: params.Key,
	              Query: params.Query,
	              Headers: params.Headers,
	              Expires: params.Expires,
	              UseRawKey: self2.options.UseRawKey,
	              SystemClockOffset: self2.options.SystemClockOffset
	            });
	          }
	          function getObjectUrl(params, callback) {
	            var self2 = this;
	            var useAccelerate = params.UseAccelerate === void 0 ? self2.options.UseAccelerate : params.UseAccelerate;
	            var url = getUrl({
	              ForcePathStyle: self2.options.ForcePathStyle,
	              protocol: params.Protocol || self2.options.Protocol,
	              domain: params.Domain || self2.options.Domain,
	              bucket: params.Bucket,
	              region: useAccelerate ? "accelerate" : params.Region,
	              object: params.Key
	            });
	            var queryParamsStr = "";
	            if (params.Query) {
	              queryParamsStr += util.obj2str(params.Query);
	            }
	            if (params.QueryString) {
	              queryParamsStr += (queryParamsStr ? "&" : "") + params.QueryString;
	            }
	            var syncUrl = url;
	            if (params.Sign !== void 0 && !params.Sign) {
	              queryParamsStr && (syncUrl += "?" + queryParamsStr);
	              callback(null, {
	                Url: syncUrl
	              });
	              return syncUrl;
	            }
	            var SignHost = getSignHost.call(this, {
	              Bucket: params.Bucket,
	              Region: params.Region,
	              UseAccelerate: params.UseAccelerate,
	              Url: url
	            });
	            var AuthData = getAuthorizationAsync.call(this, {
	              Action: (params.Method || "").toUpperCase() === "PUT" ? "name/cos:PutObject" : "name/cos:GetObject",
	              Bucket: params.Bucket || "",
	              Region: params.Region || "",
	              Method: params.Method || "get",
	              Key: params.Key,
	              Expires: params.Expires,
	              Headers: params.Headers,
	              Query: params.Query,
	              SignHost,
	              ForceSignHost: params.ForceSignHost === false ? false : self2.options.ForceSignHost
	              // getObjectUrl支持传参ForceSignHost
	            }, function(err, AuthData2) {
	              if (!callback) return;
	              if (err) {
	                callback(err);
	                return;
	              }
	              var replaceUrlParamList = function replaceUrlParamList2(url2) {
	                var urlParams = url2.match(/q-url-param-list.*?(?=&)/g)[0];
	                var encodedParams = "q-url-param-list=" + encodeURIComponent(urlParams.replace(/q-url-param-list=/, "")).toLowerCase();
	                var reg = new RegExp(urlParams, "g");
	                var replacedUrl = url2.replace(reg, encodedParams);
	                return replacedUrl;
	              };
	              var signUrl = url;
	              signUrl += "?" + (AuthData2.Authorization.indexOf("q-signature") > -1 ? replaceUrlParamList(AuthData2.Authorization) : "sign=" + encodeURIComponent(AuthData2.Authorization));
	              AuthData2.SecurityToken && (signUrl += "&x-cos-security-token=" + AuthData2.SecurityToken);
	              AuthData2.ClientIP && (signUrl += "&clientIP=" + AuthData2.ClientIP);
	              AuthData2.ClientUA && (signUrl += "&clientUA=" + AuthData2.ClientUA);
	              AuthData2.Token && (signUrl += "&token=" + AuthData2.Token);
	              queryParamsStr && (signUrl += "&" + queryParamsStr);
	              setTimeout(function() {
	                callback(null, {
	                  Url: signUrl
	                });
	              });
	            });
	            if (AuthData) {
	              syncUrl += "?" + AuthData.Authorization + (AuthData.SecurityToken ? "&x-cos-security-token=" + AuthData.SecurityToken : "");
	              queryParamsStr && (syncUrl += "&" + queryParamsStr);
	            } else {
	              queryParamsStr && (syncUrl += "?" + queryParamsStr);
	            }
	            return syncUrl;
	          }
	          function decodeAcl(AccessControlPolicy) {
	            var result = {
	              GrantFullControl: [],
	              GrantWrite: [],
	              GrantRead: [],
	              GrantReadAcp: [],
	              GrantWriteAcp: [],
	              ACL: ""
	            };
	            var GrantMap = {
	              FULL_CONTROL: "GrantFullControl",
	              WRITE: "GrantWrite",
	              READ: "GrantRead",
	              READ_ACP: "GrantReadAcp",
	              WRITE_ACP: "GrantWriteAcp"
	            };
	            var AccessControlList = AccessControlPolicy && AccessControlPolicy.AccessControlList || {};
	            var Grant = AccessControlList.Grant;
	            if (Grant) {
	              Grant = util.isArray(Grant) ? Grant : [Grant];
	            }
	            var PublicAcl = {
	              READ: 0,
	              WRITE: 0,
	              FULL_CONTROL: 0
	            };
	            Grant && Grant.length && util.each(Grant, function(item) {
	              if (item.Grantee.ID === "qcs::cam::anyone:anyone" || item.Grantee.URI === "http://cam.qcloud.com/groups/global/AllUsers") {
	                PublicAcl[item.Permission] = 1;
	              } else if (item.Grantee.ID !== AccessControlPolicy.Owner.ID) {
	                result[GrantMap[item.Permission]].push('id="' + item.Grantee.ID + '"');
	              }
	            });
	            if (PublicAcl.FULL_CONTROL || PublicAcl.WRITE && PublicAcl.READ) {
	              result.ACL = "public-read-write";
	            } else if (PublicAcl.READ) {
	              result.ACL = "public-read";
	            } else {
	              result.ACL = "private";
	            }
	            util.each(GrantMap, function(item) {
	              result[item] = uniqGrant(result[item].join(","));
	            });
	            return result;
	          }
	          function uniqGrant(str) {
	            var arr = str.split(",");
	            var exist = {};
	            var i, item;
	            for (i = 0; i < arr.length; ) {
	              item = arr[i].trim();
	              if (exist[item]) {
	                arr.splice(i, 1);
	              } else {
	                exist[item] = true;
	                arr[i] = item;
	                i++;
	              }
	            }
	            return arr.join(",");
	          }
	          function getUrl(params) {
	            var region = params.region || "";
	            var longBucket = params.bucket || "";
	            var shortBucket = longBucket.substr(0, longBucket.lastIndexOf("-"));
	            var appId = longBucket.substr(longBucket.lastIndexOf("-") + 1);
	            var domain = params.domain;
	            var object = params.object;
	            if (typeof domain === "function") {
	              domain = domain({
	                Bucket: longBucket,
	                Region: region
	              });
	            }
	            if (["http", "https"].includes(params.protocol)) {
	              params.protocol = params.protocol + ":";
	            }
	            var protocol = params.protocol || (util.isBrowser && (typeof location === "undefined" ? "undefined" : _typeof(location)) === "object" && location.protocol === "http:" ? "http:" : "https:");
	            if (!domain) {
	              if (["cn-south", "cn-south-2", "cn-north", "cn-east", "cn-southwest", "sg"].indexOf(region) > -1) {
	                domain = "{Region}.myqcloud.com";
	              } else {
	                domain = "cos.{Region}.myqcloud.com";
	              }
	              if (!params.ForcePathStyle) {
	                domain = "{Bucket}." + domain;
	              }
	            }
	            domain = domain.replace(/\{\{AppId\}\}/gi, appId).replace(/\{\{Bucket\}\}/gi, shortBucket).replace(/\{\{Region\}\}/gi, region).replace(/\{\{.*?\}\}/gi, "");
	            domain = domain.replace(/\{AppId\}/gi, appId).replace(/\{BucketName\}/gi, shortBucket).replace(/\{Bucket\}/gi, longBucket).replace(/\{Region\}/gi, region).replace(/\{.*?\}/gi, "");
	            if (!/^[a-zA-Z]+:\/\//.test(domain)) {
	              domain = protocol + "//" + domain;
	            }
	            if (domain.slice(-1) === "/") {
	              domain = domain.slice(0, -1);
	            }
	            var url = domain;
	            if (params.ForcePathStyle) {
	              url += "/" + longBucket;
	            }
	            url += "/";
	            if (object) {
	              url += util.camSafeUrlEncode(object).replace(/%2F/g, "/");
	            }
	            if (params.isLocation) {
	              url = url.replace(/^https?:\/\//, "");
	            }
	            return url;
	          }
	          var getSignHost = function getSignHost2(opt) {
	            if (!opt.Bucket || !opt.Region) return "";
	            var useAccelerate = opt.UseAccelerate === void 0 ? this.options.UseAccelerate : opt.UseAccelerate;
	            var url = opt.Url || getUrl({
	              ForcePathStyle: this.options.ForcePathStyle,
	              protocol: this.options.Protocol,
	              domain: this.options.Domain,
	              bucket: opt.Bucket,
	              region: useAccelerate ? "accelerate" : opt.Region
	            });
	            var urlHost = url.replace(/^https?:\/\/([^/]+)(\/.*)?$/, "$1");
	            return urlHost;
	          };
	          function getAuthorizationAsync(params, callback) {
	            var headers = util.clone(params.Headers);
	            var headerHost = "";
	            util.each(headers, function(v, k) {
	              (v === "" || ["content-type", "cache-control", "expires"].indexOf(k.toLowerCase()) > -1) && delete headers[k];
	              if (k.toLowerCase() === "host") headerHost = v;
	            });
	            var forceSignHost = params.ForceSignHost === false ? false : true;
	            if (!headerHost && params.SignHost && forceSignHost) headers.Host = params.SignHost;
	            var cbDone = false;
	            var cb = function cb2(err, AuthData) {
	              if (cbDone) return;
	              cbDone = true;
	              if (AuthData && AuthData.XCosSecurityToken && !AuthData.SecurityToken) {
	                AuthData = util.clone(AuthData);
	                AuthData.SecurityToken = AuthData.XCosSecurityToken;
	                delete AuthData.XCosSecurityToken;
	              }
	              callback && callback(err, AuthData);
	            };
	            var self2 = this;
	            var Bucket = params.Bucket || "";
	            var Region = params.Region || "";
	            var KeyName = params.Key || "";
	            if (self2.options.ForcePathStyle && Bucket) {
	              KeyName = Bucket + "/" + KeyName;
	            }
	            var Pathname = "/" + KeyName;
	            var StsData = {};
	            var Scope = params.Scope;
	            if (!Scope) {
	              var Action = params.Action || "";
	              var ResourceKey = params.ResourceKey || params.Key || "";
	              Scope = params.Scope || [{
	                action: Action,
	                bucket: Bucket,
	                region: Region,
	                prefix: ResourceKey
	              }];
	            }
	            var ScopeKey = util.md5(JSON.stringify(Scope));
	            self2._StsCache = self2._StsCache || [];
	            (function() {
	              var i, AuthData;
	              for (i = self2._StsCache.length - 1; i >= 0; i--) {
	                AuthData = self2._StsCache[i];
	                var compareTime = Math.round(util.getSkewTime(self2.options.SystemClockOffset) / 1e3) + 30;
	                if (AuthData.StartTime && compareTime < AuthData.StartTime || compareTime >= AuthData.ExpiredTime) {
	                  self2._StsCache.splice(i, 1);
	                  continue;
	                }
	                if (!AuthData.ScopeLimit || AuthData.ScopeLimit && AuthData.ScopeKey === ScopeKey) {
	                  StsData = AuthData;
	                  break;
	                }
	              }
	            })();
	            var calcAuthByTmpKey = function calcAuthByTmpKey2() {
	              var KeyTime = "";
	              if (StsData.StartTime && params.Expires) KeyTime = StsData.StartTime + ";" + (StsData.StartTime + params.Expires * 1);
	              else if (StsData.StartTime && StsData.ExpiredTime) KeyTime = StsData.StartTime + ";" + StsData.ExpiredTime;
	              var Authorization = util.getAuth({
	                SecretId: StsData.TmpSecretId,
	                SecretKey: StsData.TmpSecretKey,
	                Method: params.Method,
	                Pathname,
	                Query: params.Query,
	                Headers: headers,
	                Expires: params.Expires,
	                UseRawKey: self2.options.UseRawKey,
	                SystemClockOffset: self2.options.SystemClockOffset,
	                KeyTime,
	                ForceSignHost: forceSignHost
	              });
	              var AuthData = {
	                Authorization,
	                SecurityToken: StsData.SecurityToken || StsData.XCosSecurityToken || "",
	                Token: StsData.Token || "",
	                ClientIP: StsData.ClientIP || "",
	                ClientUA: StsData.ClientUA || "",
	                SignFrom: "client"
	              };
	              cb(null, AuthData);
	            };
	            var checkAuthError = function checkAuthError2(AuthData) {
	              if (AuthData.Authorization) {
	                var formatAllow = false;
	                var auth = AuthData.Authorization;
	                if (auth) {
	                  if (auth.indexOf(" ") > -1) {
	                    formatAllow = false;
	                  } else if (auth.indexOf("q-sign-algorithm=") > -1 && auth.indexOf("q-ak=") > -1 && auth.indexOf("q-sign-time=") > -1 && auth.indexOf("q-key-time=") > -1 && auth.indexOf("q-url-param-list=") > -1) {
	                    formatAllow = true;
	                  } else {
	                    try {
	                      auth = atob(auth);
	                      if (auth.indexOf("a=") > -1 && auth.indexOf("k=") > -1 && auth.indexOf("t=") > -1 && auth.indexOf("r=") > -1 && auth.indexOf("b=") > -1) {
	                        formatAllow = true;
	                      }
	                    } catch (e) {
	                    }
	                  }
	                }
	                if (!formatAllow) return util.error(new Error("getAuthorization callback params format error"));
	              } else {
	                if (!AuthData.TmpSecretId) return util.error(new Error('getAuthorization callback params missing "TmpSecretId"'));
	                if (!AuthData.TmpSecretKey) return util.error(new Error('getAuthorization callback params missing "TmpSecretKey"'));
	                if (!AuthData.SecurityToken && !AuthData.XCosSecurityToken) return util.error(new Error('getAuthorization callback params missing "SecurityToken"'));
	                if (!AuthData.ExpiredTime) return util.error(new Error('getAuthorization callback params missing "ExpiredTime"'));
	                if (AuthData.ExpiredTime && AuthData.ExpiredTime.toString().length !== 10) return util.error(new Error('getAuthorization callback params "ExpiredTime" should be 10 digits'));
	                if (AuthData.StartTime && AuthData.StartTime.toString().length !== 10) return util.error(new Error('getAuthorization callback params "StartTime" should be 10 StartTime'));
	              }
	              return false;
	            };
	            if (StsData.ExpiredTime && StsData.ExpiredTime - util.getSkewTime(self2.options.SystemClockOffset) / 1e3 > 60) {
	              calcAuthByTmpKey();
	            } else if (self2.options.getAuthorization) {
	              self2.options.getAuthorization.call(self2, {
	                Bucket,
	                Region,
	                Method: params.Method,
	                Key: KeyName,
	                Pathname,
	                Query: params.Query,
	                Headers: headers,
	                Scope,
	                SystemClockOffset: self2.options.SystemClockOffset,
	                ForceSignHost: forceSignHost
	              }, function(AuthData) {
	                if (typeof AuthData === "string") AuthData = {
	                  Authorization: AuthData
	                };
	                var AuthError = checkAuthError(AuthData);
	                if (AuthError) return cb(AuthError);
	                if (AuthData.Authorization) {
	                  cb(null, AuthData);
	                } else {
	                  StsData = AuthData || {};
	                  StsData.Scope = Scope;
	                  StsData.ScopeKey = ScopeKey;
	                  self2._StsCache.push(StsData);
	                  calcAuthByTmpKey();
	                }
	              });
	            } else if (self2.options.getSTS) {
	              self2.options.getSTS.call(self2, {
	                Bucket,
	                Region
	              }, function(data) {
	                StsData = data || {};
	                StsData.Scope = Scope;
	                StsData.ScopeKey = ScopeKey;
	                if (!StsData.TmpSecretId) StsData.TmpSecretId = StsData.SecretId;
	                if (!StsData.TmpSecretKey) StsData.TmpSecretKey = StsData.SecretKey;
	                var AuthError = checkAuthError(StsData);
	                if (AuthError) return cb(AuthError);
	                self2._StsCache.push(StsData);
	                calcAuthByTmpKey();
	              });
	            } else {
	              return function() {
	                var Authorization = util.getAuth({
	                  SecretId: params.SecretId || self2.options.SecretId,
	                  SecretKey: params.SecretKey || self2.options.SecretKey,
	                  Method: params.Method,
	                  Pathname,
	                  Query: params.Query,
	                  Headers: headers,
	                  Expires: params.Expires,
	                  UseRawKey: self2.options.UseRawKey,
	                  SystemClockOffset: self2.options.SystemClockOffset,
	                  ForceSignHost: forceSignHost
	                });
	                var AuthData = {
	                  Authorization,
	                  SecurityToken: self2.options.SecurityToken || self2.options.XCosSecurityToken,
	                  SignFrom: "client"
	                };
	                cb(null, AuthData);
	                return AuthData;
	              }();
	            }
	            return "";
	          }
	          function allowRetry(err) {
	            var self2 = this;
	            var canRetry = false;
	            var isTimeError = false;
	            var networkError = false;
	            var serverDate = err.headers && (err.headers.date || err.headers.Date) || err.error && err.error.ServerTime;
	            try {
	              var errorCode = err.error.Code;
	              var errorMessage = err.error.Message;
	              if (errorCode === "RequestTimeTooSkewed" || errorCode === "AccessDenied" && errorMessage === "Request has expired") {
	                isTimeError = true;
	              }
	            } catch (e) {
	            }
	            if (err) {
	              if (isTimeError && serverDate) {
	                var serverTime = Date.parse(serverDate);
	                if (this.options.CorrectClockSkew && Math.abs(util.getSkewTime(this.options.SystemClockOffset) - serverTime) >= 3e4) {
	                  console.error("error: Local time is too skewed.");
	                  this.options.SystemClockOffset = serverTime - Date.now();
	                  canRetry = true;
	                }
	              } else if (Math.floor(err.statusCode / 100) === 5) {
	                canRetry = true;
	              } else if (err.message === "CORS blocked or network error") {
	                networkError = true;
	                canRetry = self2.options.AutoSwitchHost;
	              }
	            }
	            return {
	              canRetry,
	              networkError
	            };
	          }
	          function canSwitchHost(_ref) {
	            var requestUrl = _ref.requestUrl, clientCalcSign = _ref.clientCalcSign, networkError = _ref.networkError;
	            if (!this.options.AutoSwitchHost) return false;
	            if (!requestUrl) return false;
	            if (!clientCalcSign) return false;
	            if (!networkError) return false;
	            var commonReg = /^https?:\/\/[^\/]*\.cos\.[^\/]*\.myqcloud\.com(\/.*)?$/;
	            var accelerateReg = /^https?:\/\/[^\/]*\.cos\.accelerate\.myqcloud\.com(\/.*)?$/;
	            var isCommonCosHost = commonReg.test(requestUrl) && !accelerateReg.test(requestUrl);
	            return isCommonCosHost;
	          }
	          function submitRequest(params, callback) {
	            var self2 = this;
	            !params.headers && (params.headers = {});
	            !params.qs && (params.qs = {});
	            params.VersionId && (params.qs.versionId = params.VersionId);
	            params.qs = util.clearKey(params.qs);
	            params.headers && (params.headers = util.clearKey(params.headers));
	            params.qs && (params.qs = util.clearKey(params.qs));
	            var Query = util.clone(params.qs);
	            params.action && (Query[params.action] = "");
	            var paramsUrl = params.url || params.Url;
	            var SignHost = params.SignHost || getSignHost.call(this, {
	              Bucket: params.Bucket,
	              Region: params.Region,
	              Url: paramsUrl
	            });
	            var tracker = params.tracker;
	            var next = function next2(tryTimes) {
	              var oldClockOffset = self2.options.SystemClockOffset;
	              tracker && tracker.setParams({
	                signStartTime: (/* @__PURE__ */ new Date()).getTime(),
	                httpRetryTimes: tryTimes - 1
	              });
	              if (params.SwitchHost) {
	                SignHost = SignHost.replace(/myqcloud.com/, "tencentcos.cn");
	              }
	              getAuthorizationAsync.call(self2, {
	                Bucket: params.Bucket || "",
	                Region: params.Region || "",
	                Method: params.method,
	                Key: params.Key,
	                Query,
	                Headers: params.headers,
	                SignHost,
	                Action: params.Action,
	                ResourceKey: params.ResourceKey,
	                Scope: params.Scope,
	                ForceSignHost: self2.options.ForceSignHost,
	                SwitchHost: params.SwitchHost
	              }, function(err, AuthData) {
	                if (err) {
	                  callback(err);
	                  return;
	                }
	                tracker && tracker.setParams({
	                  signEndTime: (/* @__PURE__ */ new Date()).getTime(),
	                  httpStartTime: (/* @__PURE__ */ new Date()).getTime()
	                });
	                params.AuthData = AuthData;
	                _submitRequest.call(self2, params, function(err2, data) {
	                  tracker && tracker.setParams({
	                    httpEndTime: (/* @__PURE__ */ new Date()).getTime()
	                  });
	                  var canRetry = false;
	                  var networkError = false;
	                  if (err2) {
	                    var info = allowRetry.call(self2, err2);
	                    canRetry = info.canRetry || oldClockOffset !== self2.options.SystemClockOffset;
	                    networkError = info.networkError;
	                  }
	                  if (err2 && tryTimes < 2 && canRetry) {
	                    if (params.headers) {
	                      delete params.headers.Authorization;
	                      delete params.headers["token"];
	                      delete params.headers["clientIP"];
	                      delete params.headers["clientUA"];
	                      params.headers["x-cos-security-token"] && delete params.headers["x-cos-security-token"];
	                      params.headers["x-ci-security-token"] && delete params.headers["x-ci-security-token"];
	                    }
	                    var switchHost = canSwitchHost.call(self2, {
	                      requestUrl: (err2 === null || err2 === void 0 ? void 0 : err2.url) || "",
	                      clientCalcSign: AuthData.SignFrom === "client",
	                      networkError
	                    });
	                    params.SwitchHost = switchHost;
	                    next2(tryTimes + 1);
	                  } else {
	                    callback(err2, data);
	                  }
	                });
	              });
	            };
	            next(1);
	          }
	          function _submitRequest(params, callback) {
	            var self2 = this;
	            var TaskId = params.TaskId;
	            if (TaskId && !self2._isRunningTask(TaskId)) return;
	            var bucket = params.Bucket;
	            var region = params.Region;
	            var object = params.Key;
	            var method = params.method || "GET";
	            var url = params.Url || params.url;
	            var body = params.body;
	            var rawBody = params.rawBody;
	            if (self2.options.UseAccelerate) {
	              region = "accelerate";
	            }
	            url = url || getUrl({
	              ForcePathStyle: self2.options.ForcePathStyle,
	              protocol: self2.options.Protocol,
	              domain: self2.options.Domain,
	              bucket,
	              region,
	              object
	            });
	            if (params.SwitchHost) {
	              url = url.replace(/myqcloud.com/, "tencentcos.cn");
	            }
	            var repoterUrl = object ? url : "";
	            if (params.action) {
	              url = url + "?" + (util.isIOS_QQ ? "".concat(params.action, "=") : params.action);
	            }
	            if (params.qsStr) {
	              if (url.indexOf("?") > -1) {
	                url = url + "&" + params.qsStr;
	              } else {
	                url = url + "?" + params.qsStr;
	              }
	            }
	            var opt = {
	              method,
	              url,
	              headers: params.headers,
	              qs: params.qs,
	              body
	            };
	            var token = "x-cos-security-token";
	            if (util.isCIHost(url)) {
	              token = "x-ci-security-token";
	            }
	            opt.headers.Authorization = params.AuthData.Authorization;
	            params.AuthData.Token && (opt.headers["token"] = params.AuthData.Token);
	            params.AuthData.ClientIP && (opt.headers["clientIP"] = params.AuthData.ClientIP);
	            params.AuthData.ClientUA && (opt.headers["clientUA"] = params.AuthData.ClientUA);
	            params.AuthData.SecurityToken && (opt.headers[token] = params.AuthData.SecurityToken);
	            opt.headers && (opt.headers = util.clearKey(opt.headers));
	            opt = util.clearKey(opt);
	            if (params.onProgress && typeof params.onProgress === "function") {
	              var contentLength = body && (body.size || body.length) || 0;
	              opt.onProgress = function(e) {
	                if (TaskId && !self2._isRunningTask(TaskId)) return;
	                var loaded = e ? e.loaded : 0;
	                params.onProgress({
	                  loaded,
	                  total: contentLength
	                });
	              };
	            }
	            if (params.onDownloadProgress) {
	              opt.onDownloadProgress = params.onDownloadProgress;
	            }
	            if (params.DataType) {
	              opt.dataType = params.DataType;
	            }
	            if (this.options.Timeout) {
	              opt.timeout = this.options.Timeout;
	            }
	            self2.options.ForcePathStyle && (opt.pathStyle = self2.options.ForcePathStyle);
	            self2.emit("before-send", opt);
	            var useAccelerate = opt.url.includes("accelerate.");
	            var queryString = opt.qs ? Object.keys(opt.qs).map(function(key) {
	              return "".concat(key, "=").concat(opt.qs[key]);
	            }).join("&") : "";
	            var fullUrl = queryString ? opt.url + "?" + queryString : opt.url;
	            if (params.tracker) {
	              var _opt$body;
	              params.tracker.setParams({
	                url: fullUrl,
	                httpMethod: opt.method,
	                accelerate: useAccelerate,
	                httpSize: ((_opt$body = opt.body) === null || _opt$body === void 0 ? void 0 : _opt$body.size) || 0
	              });
	              if (params.tracker.parent && !params.tracker.parent.params.url) {
	                params.tracker.parent.setParams({
	                  url: repoterUrl,
	                  accelerate: useAccelerate
	                });
	              }
	            }
	            var sender = (self2.options.Request || REQUEST)(opt, function(r) {
	              if (r && r.error === "abort") return;
	              var receive = {
	                options: opt,
	                error: r && r.error,
	                statusCode: r && r.statusCode || 0,
	                statusMessage: r && r.statusMessage || "",
	                headers: r && r.headers || {},
	                body: r && r.body
	              };
	              self2.emit("after-receive", receive);
	              var err = receive.error;
	              var body2 = receive.body;
	              var response = {
	                statusCode: receive.statusCode,
	                statusMessage: receive.statusMessage,
	                headers: receive.headers
	              };
	              var hasReturned;
	              var cb = function cb2(err2, data) {
	                TaskId && self2.off("inner-kill-task", killTask);
	                if (hasReturned) return;
	                hasReturned = true;
	                var attrs = {};
	                response && response.statusCode && (attrs.statusCode = response.statusCode);
	                response && response.headers && (attrs.headers = response.headers);
	                if (err2) {
	                  opt.url && (attrs.url = opt.url);
	                  opt.method && (attrs.method = opt.method);
	                  err2 = util.extend(err2 || {}, attrs);
	                  callback(err2, null);
	                } else {
	                  if (params.Action === "name/cos:PutObject") {
	                    var pHeaders = {};
	                    for (var i in params.headers) {
	                      var key = i.toLowerCase();
	                      pHeaders[key] = params.headers[i];
	                    }
	                    if (pHeaders["x-cos-callback"]) {
	                      if (data.Error) {
	                        data.CallbackError = util.clone(data.Error);
	                        delete data.Error;
	                      } else {
	                        data.CallbackBody = util.clone(data);
	                      }
	                    } else if (pHeaders["x-cos-return-body"]) {
	                      if (data.Error) {
	                        data.ReturnError = util.clone(data.Error);
	                        delete data.Error;
	                      } else {
	                        data.ReturnBody = util.clone(data);
	                      }
	                    }
	                  }
	                  data = util.extend(data || {}, attrs);
	                  callback(null, data);
	                }
	                sender = null;
	              };
	              if (err) return cb(util.error(err));
	              var statusCode = response.statusCode;
	              var statusSuccess = Math.floor(statusCode / 100) === 2;
	              if (rawBody) {
	                if (statusSuccess) {
	                  return cb(null, {
	                    body: body2
	                  });
	                } else {
	                  if (body2 instanceof Blob) {
	                    util.readAsBinaryString(body2, function(content) {
	                      var json2 = util.parseResBody(content);
	                      var errorBody2 = json2.Error || json2;
	                      return cb(util.error(new Error(errorBody2.Message || "response body error"), {
	                        code: errorBody2.Code,
	                        error: errorBody2
	                      }));
	                    });
	                    return;
	                  }
	                }
	              }
	              var json = util.parseResBody(body2);
	              var errorBody = json.Error || json;
	              if (statusSuccess) {
	                cb(null, json);
	              } else if (errorBody) {
	                cb(util.error(new Error(errorBody.Message), {
	                  code: errorBody.Code,
	                  error: errorBody
	                }));
	              } else if (statusCode) {
	                cb(util.error(new Error(response.statusMessage), {
	                  code: "" + statusCode
	                }));
	              } else if (statusCode) {
	                cb(util.error(new Error("statusCode error")));
	              }
	            });
	            var killTask = function killTask2(data) {
	              if (data.TaskId === TaskId) {
	                sender && sender.abort && sender.abort();
	                self2.off("inner-kill-task", killTask2);
	              }
	            };
	            TaskId && self2.on("inner-kill-task", killTask);
	          }
	          var API_MAP = {
	            // Bucket 相关方法
	            getService,
	            // Bucket
	            putBucket,
	            headBucket,
	            // Bucket
	            getBucket,
	            deleteBucket,
	            putBucketAcl,
	            // BucketACL
	            getBucketAcl,
	            putBucketCors,
	            // BucketCors
	            getBucketCors,
	            deleteBucketCors,
	            getBucketLocation,
	            // BucketLocation
	            getBucketPolicy,
	            // BucketPolicy
	            putBucketPolicy,
	            deleteBucketPolicy,
	            putBucketTagging,
	            // BucketTagging
	            getBucketTagging,
	            deleteBucketTagging,
	            putBucketLifecycle,
	            // BucketLifecycle
	            getBucketLifecycle,
	            deleteBucketLifecycle,
	            putBucketVersioning,
	            // BucketVersioning
	            getBucketVersioning,
	            putBucketReplication,
	            // BucketReplication
	            getBucketReplication,
	            deleteBucketReplication,
	            putBucketWebsite,
	            // BucketWebsite
	            getBucketWebsite,
	            deleteBucketWebsite,
	            putBucketReferer,
	            // BucketReferer
	            getBucketReferer,
	            putBucketDomain,
	            // BucketDomain
	            getBucketDomain,
	            deleteBucketDomain,
	            putBucketOrigin,
	            // BucketOrigin
	            getBucketOrigin,
	            deleteBucketOrigin,
	            putBucketLogging,
	            // BucketLogging
	            getBucketLogging,
	            putBucketInventory,
	            // BucketInventory
	            postBucketInventory,
	            getBucketInventory,
	            listBucketInventory,
	            deleteBucketInventory,
	            putBucketAccelerate,
	            getBucketAccelerate,
	            putBucketEncryption,
	            getBucketEncryption,
	            deleteBucketEncryption,
	            // Object 相关方法
	            getObject,
	            headObject,
	            listObjectVersions,
	            putObject,
	            deleteObject,
	            getObjectAcl,
	            putObjectAcl,
	            optionsObject,
	            putObjectCopy,
	            deleteMultipleObject,
	            restoreObject,
	            putObjectTagging,
	            getObjectTagging,
	            deleteObjectTagging,
	            selectObjectContent,
	            appendObject,
	            // 分块上传相关方法
	            uploadPartCopy,
	            multipartInit,
	            multipartUpload,
	            multipartComplete,
	            multipartList,
	            multipartListPart,
	            multipartAbort,
	            // 工具方法
	            request,
	            getObjectUrl,
	            getAuth
	          };
	          function warnOldApi(apiName, fn, proto) {
	            util.each(["Cors", "Acl"], function(suffix) {
	              if (apiName.slice(-suffix.length) === suffix) {
	                var oldName = apiName.slice(0, -suffix.length) + suffix.toUpperCase();
	                var apiFn = util.apiWrapper(apiName, fn);
	                var warned = false;
	                proto[oldName] = function() {
	                  !warned && console.warn("warning: cos." + oldName + " has been deprecated. Please Use cos." + apiName + " instead.");
	                  warned = true;
	                  apiFn.apply(this, arguments);
	                };
	              }
	            });
	          }
	          module2.exports.init = function(COS, task) {
	            task.transferToTaskMethod(API_MAP, "putObject");
	            util.each(API_MAP, function(fn, apiName) {
	              COS.prototype[apiName] = util.apiWrapper(apiName, fn);
	              warnOldApi(apiName, fn, COS.prototype);
	            });
	          };
	        }
	      ),
	      /***/
	      "./src/cos.js": (
	        /*!********************!*\
	          !*** ./src/cos.js ***!
	          \********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var util = __webpack_require__(
	            /*! ./util */
	            "./src/util.js"
	          );
	          var event = __webpack_require__(
	            /*! ./event */
	            "./src/event.js"
	          );
	          var task = __webpack_require__(
	            /*! ./task */
	            "./src/task.js"
	          );
	          var base = __webpack_require__(
	            /*! ./base */
	            "./src/base.js"
	          );
	          var advance = __webpack_require__(
	            /*! ./advance */
	            "./src/advance.js"
	          );
	          var pkg = __webpack_require__(
	            /*! ../package.json */
	            "./package.json"
	          );
	          var defaultOptions = {
	            AppId: "",
	            // AppId 已废弃，请拼接到 Bucket 后传入，例如：test-1250000000
	            SecretId: "",
	            SecretKey: "",
	            SecurityToken: "",
	            // 使用临时密钥需要注意自行刷新 Token
	            ChunkRetryTimes: 2,
	            FileParallelLimit: 3,
	            ChunkParallelLimit: 3,
	            ChunkSize: 1024 * 1024,
	            SliceSize: 1024 * 1024,
	            CopyChunkParallelLimit: 20,
	            CopyChunkSize: 1024 * 1024 * 10,
	            CopySliceSize: 1024 * 1024 * 10,
	            MaxPartNumber: 1e4,
	            ProgressInterval: 1e3,
	            Domain: "",
	            ServiceDomain: "",
	            Protocol: "",
	            CompatibilityMode: false,
	            ForcePathStyle: false,
	            UseRawKey: false,
	            Timeout: 0,
	            // 单位毫秒，0 代表不设置超时时间
	            CorrectClockSkew: true,
	            SystemClockOffset: 0,
	            // 单位毫秒，ms
	            UploadCheckContentMd5: false,
	            UploadQueueSize: 1e4,
	            UploadAddMetaMd5: false,
	            UploadIdCacheLimit: 50,
	            UseAccelerate: false,
	            ForceSignHost: true,
	            // 默认将host加入签名计算，关闭后可能导致越权风险，建议保持为true
	            AutoSwitchHost: true,
	            CopySourceParser: null,
	            // 自定义拷贝源解析器
	            ObjectKeySimplifyCheck: true,
	            // 开启合并校验 getObject Key
	            /** 上报相关 **/
	            DeepTracker: false,
	            // 上报时是否对每个分块上传做单独上报
	            TrackerDelay: 5e3,
	            // 周期性上报，单位毫秒。0代表实时上报
	            CustomId: "",
	            // 自定义上报id
	            BeaconReporter: null,
	            // 灯塔上报组件，如有需要请自行传入，传入即代表开启上报
	            ClsReporter: null
	            // cls 上报组件，如有需要请自行传入，传入即代表开启上报
	          };
	          var COS = function COS2(options) {
	            this.options = util.extend(util.clone(defaultOptions), options || {});
	            this.options.FileParallelLimit = Math.max(1, this.options.FileParallelLimit);
	            this.options.ChunkParallelLimit = Math.max(1, this.options.ChunkParallelLimit);
	            this.options.ChunkRetryTimes = Math.max(0, this.options.ChunkRetryTimes);
	            this.options.ChunkSize = Math.max(1024 * 1024, this.options.ChunkSize);
	            this.options.CopyChunkParallelLimit = Math.max(1, this.options.CopyChunkParallelLimit);
	            this.options.CopyChunkSize = Math.max(1024 * 1024, this.options.CopyChunkSize);
	            this.options.CopySliceSize = Math.max(0, this.options.CopySliceSize);
	            this.options.MaxPartNumber = Math.max(1024, Math.min(1e4, this.options.MaxPartNumber));
	            this.options.Timeout = Math.max(0, this.options.Timeout);
	            this.options.EnableReporter = this.options.BeaconReporter || this.options.ClsReporter;
	            if (this.options.AppId) {
	              console.warn('warning: AppId has been deprecated, Please put it at the end of parameter Bucket(E.g: "test-1250000000").');
	            }
	            if (this.options.SecretId && this.options.SecretId.indexOf(" ") > -1) {
	              console.error("error: SecretId格式错误，请检查");
	              console.error("error: SecretId format is incorrect. Please check");
	            }
	            if (this.options.SecretKey && this.options.SecretKey.indexOf(" ") > -1) {
	              console.error("error: SecretKey格式错误，请检查");
	              console.error("error: SecretKey format is incorrect. Please check");
	            }
	            if (util.isNode()) {
	              console.log("Tip: Next.js、Nuxt.js 等服务端渲染技术可正常使用JavaScript SDK，请忽略下方 nodejs 环境警告");
	              console.warn("warning: cos-js-sdk-v5 不支持 nodejs 环境使用，请改用 cos-nodejs-sdk-v5，参考文档： https://cloud.tencent.com/document/product/436/8629");
	              console.warn("warning: cos-js-sdk-v5 does not support nodejs environment. Please use cos-nodejs-sdk-v5 instead. See: https://cloud.tencent.com/document/product/436/8629");
	            }
	            if (this.options.ForcePathStyle) {
	              console.warn("cos-js-sdk-v5不再支持使用path-style，仅支持使用virtual-hosted-style，参考文档：https://cloud.tencent.com/document/product/436/96243");
	              throw new Error("ForcePathStyle is not supported");
	            }
	            event.init(this);
	            task.init(this);
	          };
	          base.init(COS, task);
	          advance.init(COS, task);
	          COS.util = {
	            md5: util.md5,
	            xml2json: util.xml2json,
	            json2xml: util.json2xml,
	            encodeBase64: util.encodeBase64
	          };
	          COS.getAuthorization = util.getAuth;
	          COS.version = pkg.version;
	          module2.exports = COS;
	        }
	      ),
	      /***/
	      "./src/event.js": (
	        /*!**********************!*\
	          !*** ./src/event.js ***!
	          \**********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2) {
	          var initEvent = function initEvent2(cos) {
	            var listeners = {};
	            var getList = function getList2(action) {
	              !listeners[action] && (listeners[action] = []);
	              return listeners[action];
	            };
	            cos.on = function(action, callback) {
	              if (action === "task-list-update") {
	                console.warn('warning: Event "' + action + '" has been deprecated. Please use "list-update" instead.');
	              }
	              getList(action).push(callback);
	            };
	            cos.off = function(action, callback) {
	              var list = getList(action);
	              for (var i = list.length - 1; i >= 0; i--) {
	                callback === list[i] && list.splice(i, 1);
	              }
	            };
	            cos.emit = function(action, data) {
	              var list = getList(action).map(function(cb) {
	                return cb;
	              });
	              for (var i = 0; i < list.length; i++) {
	                list[i](data);
	              }
	            };
	          };
	          var EventProxy = function EventProxy2() {
	            initEvent(this);
	          };
	          module2.exports.init = initEvent;
	          module2.exports.EventProxy = EventProxy;
	        }
	      ),
	      /***/
	      "./src/session.js": (
	        /*!************************!*\
	          !*** ./src/session.js ***!
	          \************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var util = __webpack_require__(
	            /*! ./util */
	            "./src/util.js"
	          );
	          var cacheKey = "cos_sdk_upload_cache";
	          var expires = 30 * 24 * 3600;
	          var cache;
	          var timer;
	          var getCache = function getCache2() {
	            try {
	              var val = JSON.parse(localStorage.getItem(cacheKey));
	            } catch (e) {
	            }
	            if (!val) val = [];
	            cache = val;
	          };
	          var setCache = function setCache2() {
	            try {
	              if (cache.length) localStorage.setItem(cacheKey, JSON.stringify(cache));
	              else localStorage.removeItem(cacheKey);
	            } catch (e) {
	            }
	          };
	          var init = function init2() {
	            if (cache) return;
	            getCache.call(this);
	            var changed = false;
	            var now = Math.round(Date.now() / 1e3);
	            for (var i = cache.length - 1; i >= 0; i--) {
	              var mtime = cache[i][2];
	              if (!mtime || mtime + expires < now) {
	                cache.splice(i, 1);
	                changed = true;
	              }
	            }
	            changed && setCache();
	          };
	          var save = function save2() {
	            if (timer) return;
	            timer = setTimeout(function() {
	              setCache();
	              timer = null;
	            }, 400);
	          };
	          var mod = {
	            using: {},
	            // 标记 UploadId 正在使用
	            setUsing: function setUsing(uuid) {
	              mod.using[uuid] = true;
	            },
	            // 标记 UploadId 已经没在使用
	            removeUsing: function removeUsing(uuid) {
	              delete mod.using[uuid];
	            },
	            // 用上传参数生成哈希值
	            getFileId: function getFileId(file, ChunkSize, Bucket, Key) {
	              if (file.name && file.size && file.lastModifiedDate && ChunkSize) {
	                return util.md5([file.name, file.size, file.lastModifiedDate, ChunkSize, Bucket, Key].join("::"));
	              } else {
	                return null;
	              }
	            },
	            // 用上传参数生成哈希值
	            getCopyFileId: function getCopyFileId(copySource, sourceHeaders, ChunkSize, Bucket, Key) {
	              var size = sourceHeaders["content-length"];
	              var etag = sourceHeaders.etag || "";
	              var lastModified = sourceHeaders["last-modified"];
	              if (copySource && ChunkSize) {
	                return util.md5([copySource, size, etag, lastModified, ChunkSize, Bucket, Key].join("::"));
	              } else {
	                return null;
	              }
	            },
	            // 获取文件对应的 UploadId 列表
	            getUploadIdList: function getUploadIdList(uuid) {
	              if (!uuid) return null;
	              init.call(this);
	              var list = [];
	              for (var i = 0; i < cache.length; i++) {
	                if (cache[i][0] === uuid) list.push(cache[i][1]);
	              }
	              return list.length ? list : null;
	            },
	            // 缓存 UploadId
	            saveUploadId: function saveUploadId(uuid, UploadId, limit) {
	              init.call(this);
	              if (!uuid) return;
	              for (var i = cache.length - 1; i >= 0; i--) {
	                var item = cache[i];
	                if (item[0] === uuid && item[1] === UploadId) {
	                  cache.splice(i, 1);
	                }
	              }
	              cache.unshift([uuid, UploadId, Math.round(Date.now() / 1e3)]);
	              if (cache.length > limit) cache.splice(limit);
	              save();
	            },
	            // UploadId 已用完，移除掉
	            removeUploadId: function removeUploadId(UploadId) {
	              init.call(this);
	              delete mod.using[UploadId];
	              for (var i = cache.length - 1; i >= 0; i--) {
	                if (cache[i][1] === UploadId) cache.splice(i, 1);
	              }
	              save();
	            }
	          };
	          module2.exports = mod;
	        }
	      ),
	      /***/
	      "./src/task.js": (
	        /*!*********************!*\
	          !*** ./src/task.js ***!
	          \*********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var session = __webpack_require__(
	            /*! ./session */
	            "./src/session.js"
	          );
	          var util = __webpack_require__(
	            /*! ./util */
	            "./src/util.js"
	          );
	          var originApiMap = {};
	          var transferToTaskMethod = function transferToTaskMethod2(apiMap, apiName) {
	            originApiMap[apiName] = apiMap[apiName];
	            apiMap[apiName] = function(params, callback) {
	              if (params.SkipTask) {
	                originApiMap[apiName].call(this, params, callback);
	              } else {
	                this._addTask(apiName, params, callback);
	              }
	            };
	          };
	          var initTask = function initTask2(cos) {
	            var queue = [];
	            var tasks = {};
	            var uploadingFileCount = 0;
	            var nextUploadIndex = 0;
	            var formatTask = function formatTask2(task) {
	              var t = {
	                id: task.id,
	                Bucket: task.Bucket,
	                Region: task.Region,
	                Key: task.Key,
	                FilePath: task.FilePath,
	                state: task.state,
	                loaded: task.loaded,
	                size: task.size,
	                speed: task.speed,
	                percent: task.percent,
	                hashPercent: task.hashPercent,
	                error: task.error
	              };
	              if (task.FilePath) t.FilePath = task.FilePath;
	              if (task._custom) t._custom = task._custom;
	              return t;
	            };
	            var emitListUpdate = /* @__PURE__ */ function() {
	              var timer;
	              var emit = function emit2() {
	                timer = 0;
	                cos.emit("task-list-update", {
	                  list: util.map(queue, formatTask)
	                });
	                cos.emit("list-update", {
	                  list: util.map(queue, formatTask)
	                });
	              };
	              return function() {
	                if (!timer) timer = setTimeout(emit);
	              };
	            }();
	            var clearQueue = function clearQueue2() {
	              if (queue.length <= cos.options.UploadQueueSize) return;
	              for (var i = 0; i < nextUploadIndex && // 小于当前操作的 index 才清理
	              i < queue.length && // 大于队列才清理
	              queue.length > cos.options.UploadQueueSize; ) {
	                var isActive = queue[i].state === "waiting" || queue[i].state === "checking" || queue[i].state === "uploading";
	                if (!queue[i] || !isActive) {
	                  tasks[queue[i].id] && delete tasks[queue[i].id];
	                  queue.splice(i, 1);
	                  nextUploadIndex--;
	                } else {
	                  i++;
	                }
	              }
	              emitListUpdate();
	            };
	            var startNextTask = function startNextTask2() {
	              if (uploadingFileCount >= cos.options.FileParallelLimit) return;
	              while (queue[nextUploadIndex] && queue[nextUploadIndex].state !== "waiting") nextUploadIndex++;
	              if (nextUploadIndex >= queue.length) return;
	              var task = queue[nextUploadIndex];
	              nextUploadIndex++;
	              uploadingFileCount++;
	              task.state = "checking";
	              task.params.onTaskStart && task.params.onTaskStart(formatTask(task));
	              !task.params.UploadData && (task.params.UploadData = {});
	              var apiParams = util.formatParams(task.api, task.params);
	              originApiMap[task.api].call(cos, apiParams, function(err, data) {
	                if (!cos._isRunningTask(task.id)) return;
	                if (task.state === "checking" || task.state === "uploading") {
	                  task.state = err ? "error" : "success";
	                  err && (task.error = err);
	                  uploadingFileCount--;
	                  emitListUpdate();
	                  startNextTask2();
	                  task.callback && task.callback(err, data);
	                  if (task.state === "success") {
	                    if (task.params) {
	                      delete task.params.UploadData;
	                      delete task.params.Body;
	                      delete task.params;
	                    }
	                    delete task.callback;
	                  }
	                }
	                clearQueue();
	              });
	              emitListUpdate();
	              setTimeout(startNextTask2);
	            };
	            var killTask = function killTask2(id, switchToState) {
	              var task = tasks[id];
	              if (!task) return;
	              var waiting = task && task.state === "waiting";
	              var running = task && (task.state === "checking" || task.state === "uploading");
	              if (switchToState === "canceled" && task.state !== "canceled" || switchToState === "paused" && waiting || switchToState === "paused" && running) {
	                task.state = switchToState;
	                cos.emit("inner-kill-task", {
	                  TaskId: id,
	                  toState: switchToState
	                });
	                try {
	                  var UploadId = task && task.params && task.params.UploadData.UploadId;
	                } catch (e) {
	                }
	                if (switchToState === "canceled" && UploadId) session.removeUsing(UploadId);
	                emitListUpdate();
	                if (running) {
	                  uploadingFileCount--;
	                  startNextTask();
	                }
	                if (switchToState === "canceled") {
	                  if (task.params) {
	                    delete task.params.UploadData;
	                    delete task.params.Body;
	                    delete task.params;
	                  }
	                  delete task.callback;
	                }
	              }
	              clearQueue();
	            };
	            cos._addTasks = function(taskList) {
	              util.each(taskList, function(task) {
	                cos._addTask(task.api, task.params, task.callback, true);
	              });
	              emitListUpdate();
	            };
	            var isTaskReadyWarning = true;
	            cos._addTask = function(api, params, callback, ignoreAddEvent) {
	              params = util.formatParams(api, params);
	              var id = util.uuid();
	              params.TaskId = id;
	              params.onTaskReady && params.onTaskReady(id);
	              if (params.TaskReady) {
	                params.TaskReady(id);
	                isTaskReadyWarning && console.warn('warning: Param "TaskReady" has been deprecated. Please use "onTaskReady" instead.');
	                isTaskReadyWarning = false;
	              }
	              var task = {
	                // env
	                params,
	                callback,
	                api,
	                index: queue.length,
	                // task
	                id,
	                Bucket: params.Bucket,
	                Region: params.Region,
	                Key: params.Key,
	                FilePath: params.FilePath || "",
	                state: "waiting",
	                loaded: 0,
	                size: 0,
	                speed: 0,
	                percent: 0,
	                hashPercent: 0,
	                error: null,
	                _custom: params._custom
	              };
	              var onHashProgress = params.onHashProgress;
	              params.onHashProgress = function(info) {
	                if (!cos._isRunningTask(task.id)) return;
	                task.hashPercent = info.percent;
	                onHashProgress && onHashProgress(info);
	                emitListUpdate();
	              };
	              var onProgress = params.onProgress;
	              params.onProgress = function(info) {
	                if (!cos._isRunningTask(task.id)) return;
	                task.state === "checking" && (task.state = "uploading");
	                task.loaded = info.loaded;
	                task.speed = info.speed;
	                task.percent = info.percent;
	                onProgress && onProgress(info);
	                emitListUpdate();
	              };
	              util.getFileSize(api, params, function(err, size) {
	                if (err) return callback(util.error(err));
	                tasks[id] = task;
	                queue.push(task);
	                task.size = size;
	                !ignoreAddEvent && emitListUpdate();
	                startNextTask();
	                clearQueue();
	              });
	              return id;
	            };
	            cos._isRunningTask = function(id) {
	              var task = tasks[id];
	              return !!(task && (task.state === "checking" || task.state === "uploading"));
	            };
	            cos.getTaskList = function() {
	              return util.map(queue, formatTask);
	            };
	            cos.cancelTask = function(id) {
	              killTask(id, "canceled");
	            };
	            cos.pauseTask = function(id) {
	              killTask(id, "paused");
	            };
	            cos.restartTask = function(id) {
	              var task = tasks[id];
	              if (task && (task.state === "paused" || task.state === "error")) {
	                task.state = "waiting";
	                emitListUpdate();
	                nextUploadIndex = Math.min(nextUploadIndex, task.index);
	                startNextTask();
	              }
	            };
	            cos.isUploadRunning = function() {
	              return uploadingFileCount || nextUploadIndex < queue.length;
	            };
	          };
	          module2.exports.transferToTaskMethod = transferToTaskMethod;
	          module2.exports.init = initTask;
	        }
	      ),
	      /***/
	      "./src/tracker.js": (
	        /*!************************!*\
	          !*** ./src/tracker.js ***!
	          \************************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          var _classCallCheck = __webpack_require__(
	            /*! @babel/runtime/helpers/classCallCheck */
	            "./node_modules/@babel/runtime/helpers/classCallCheck.js"
	          );
	          var _createClass = __webpack_require__(
	            /*! @babel/runtime/helpers/createClass */
	            "./node_modules/@babel/runtime/helpers/createClass.js"
	          );
	          var _typeof = __webpack_require__(
	            /*! @babel/runtime/helpers/typeof */
	            "./node_modules/@babel/runtime/helpers/typeof.js"
	          );
	          var pkg = __webpack_require__(
	            /*! ../package.json */
	            "./package.json"
	          );
	          var beacon = null;
	          var getBeacon = function getBeacon2(Beacon, delay) {
	            if (!beacon) {
	              if (typeof Beacon !== "function") {
	                throw new Error("Beacon not found");
	              }
	              beacon = new Beacon({
	                appkey: "0WEB05PY6MHRGK0U",
	                versionCode: pkg.version,
	                channelID: "js_sdk",
	                //渠道,选填
	                openid: "openid",
	                // 用户id, 选填
	                unionid: "unid",
	                //用户unionid , 类似idfv,选填
	                strictMode: false,
	                //严苛模式开关, 打开严苛模式会主动抛出异常, 上线请务必关闭!!!
	                delay,
	                // 普通事件延迟上报时间(单位毫秒), 默认1000(1秒),选填
	                sessionDuration: 60 * 1e3
	                // session变更的时间间隔, 一个用户持续30分钟(默认值)没有任何上报则算另一次 session,每变更一次session上报一次启动事件(rqd_applaunched),使用毫秒(ms),最小值30秒,选填
	              });
	            }
	            return beacon;
	          };
	          var ms2s = function ms2s2(ms) {
	            if (!ms || ms < 0) return 0;
	            return (ms / 1e3).toFixed(3);
	          };
	          var utils = {
	            // 生成uid 每个链路对应唯一一条uid
	            getUid: function getUid() {
	              var S4 = function S42() {
	                return ((1 + Math.random()) * 65536 | 0).toString(16).substring(1);
	              };
	              return S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4();
	            },
	            // 获取网络类型 4g ｜ wifi
	            getNetType: function getNetType() {
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) === "object") {
	                var connection = navigator.connection || navigator.mozConnection || navigator.webkitConnection;
	                return (connection === null || connection === void 0 ? void 0 : connection.type) || (connection === null || connection === void 0 ? void 0 : connection.effectiveType) || "unknown";
	              }
	              return "unknown";
	            },
	            // http | https
	            getProtocol: function getProtocol() {
	              if ((typeof location === "undefined" ? "undefined" : _typeof(location)) === "object") {
	                return location.protocol.replace(/:/, "");
	              }
	              return "unknown protocol";
	            },
	            // 获取pc端操作系统类型
	            getOsType: function getOsType() {
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) !== "object") {
	                return "unknown os";
	              }
	              var agent = navigator.userAgent.toLowerCase();
	              var isMac = /macintosh|mac os x/i.test(navigator.userAgent);
	              if (agent.indexOf("win32") >= 0 || agent.indexOf("wow32") >= 0) {
	                return "win32";
	              }
	              if (agent.indexOf("win64") >= 0 || agent.indexOf("wow64") >= 0) {
	                return "win64";
	              }
	              if (isMac) {
	                return "mac";
	              }
	              return "unknown os";
	            },
	            isMobile: function isMobile2() {
	              var exp = /(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i;
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) === "object" && navigator.userAgent.match(exp)) {
	                return true;
	              }
	              return false;
	            },
	            isAndroid: function isAndroid2() {
	              var exp = /(Android|Adr|Linux)/i;
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) === "object" && navigator.userAgent.match(exp)) {
	                return true;
	              }
	              return false;
	            },
	            isIOS: function isIOS2() {
	              var exp = /(iPhone|iPod|iPad|iOS)/i;
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) === "object" && navigator.userAgent.match(exp)) {
	                return true;
	              }
	              return false;
	            },
	            isOtherMobile: function isOtherMobile() {
	              return isMobile && !isAndroid && !isIOS;
	            },
	            getUA: function getUA() {
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) !== "object") {
	                return "unknown device";
	              }
	              var explorer = navigator.userAgent;
	              return explorer;
	            }
	          };
	          var isMobile = utils.isMobile();
	          var mobileOsType = utils.isAndroid() ? "android" : utils.isIOS ? "ios" : "other_mobile";
	          var pcOsType = utils.getOsType();
	          var devicePlatform = isMobile ? mobileOsType : pcOsType;
	          var ua = utils.getUA();
	          var protocol = utils.getProtocol();
	          var transApiName = function transApiName2(api) {
	            if (["putObject", "sliceUploadFile", "uploadFile", "uploadFiles"].includes(api)) {
	              return "UploadTask";
	            } else if (api === "getObject") {
	              return "DownloadTask";
	            } else if (["putObjectCopy", "sliceCopyFile"].includes(api)) {
	              return "CopyTask";
	            }
	            return api;
	          };
	          function camel2underline(key) {
	            return key.replace(/([A-Z])/g, "_$1").toLowerCase();
	          }
	          function formatParams(params) {
	            var formattedParams = {};
	            var successKeys = ["sdkVersionName", "sdkVersionCode", "osName", "networkType", "requestName", "requestResult", "bucket", "region", "appid", "accelerate", "url", "host", "requestPath", "userAgent", "networkProtocol", "httpMethod", "httpSize", "httpSpeed", "httpTookTime", "httpMd5", "httpSign", "httpFullTime", "httpDomain", "partNumber", "httpRetryTimes", "customId", "traceId", "realApi"];
	            var failureKeys = [].concat(successKeys, ["errorNode", "errorCode", "errorName", "errorMessage", "errorRequestId", "errorHttpCode", "errorServiceName", "errorType", "fullError"]);
	            var reporterKeys = params.requestResult === "Success" ? successKeys : failureKeys;
	            for (var key in params) {
	              if (!reporterKeys.includes(key)) continue;
	              var formattedKey = camel2underline(key);
	              formattedParams[formattedKey] = params[key];
	            }
	            formattedParams["request_name"] = params.realApi ? transApiName(params.realApi) : params.requestName;
	            return formattedParams;
	          }
	          var Tracker = /* @__PURE__ */ function() {
	            function Tracker2(opt) {
	              _classCallCheck(this, Tracker2);
	              var parent = opt.parent, traceId = opt.traceId, bucket = opt.bucket, region = opt.region, apiName = opt.apiName, realApi = opt.realApi, httpMethod = opt.httpMethod, fileKey = opt.fileKey, fileSize = opt.fileSize, accelerate = opt.accelerate, customId = opt.customId, delay = opt.delay, deepTracker = opt.deepTracker, Beacon = opt.Beacon, clsReporter = opt.clsReporter;
	              var appid = bucket && bucket.substr(bucket.lastIndexOf("-") + 1) || "";
	              this.parent = parent;
	              this.deepTracker = deepTracker;
	              this.delay = delay;
	              if (clsReporter && !this.clsReporter) {
	                this.clsReporter = clsReporter;
	              }
	              this.params = {
	                // 通用字段
	                sdkVersionName: "cos-js-sdk-v5",
	                sdkVersionCode: pkg.version,
	                osName: devicePlatform,
	                networkType: "",
	                requestName: apiName || "",
	                requestResult: "",
	                // sdk api调用结果Success、Failure
	                realApi,
	                bucket,
	                region,
	                accelerate,
	                httpMethod,
	                url: "",
	                // 请求url
	                host: "",
	                httpDomain: "",
	                requestPath: fileKey || "",
	                userAgent: ua,
	                networkProtocol: protocol,
	                errorType: "",
	                errorCode: "",
	                errorName: "",
	                errorMessage: "",
	                errorRequestId: "",
	                errorHttpCode: 0,
	                errorServiceName: "",
	                errorNode: "",
	                httpTookTime: 0,
	                // http整体耗时
	                httpSize: fileSize || 0,
	                // 主要是文件大小，大小 B
	                httpMd5: 0,
	                // MD5耗时
	                httpSign: 0,
	                // 计算签名耗时
	                httpFullTime: 0,
	                // 任务整体耗时(包括md5、签名等)
	                httpSpeed: 0,
	                // 主要关注上传速度，KB/s
	                md5StartTime: 0,
	                // md5计算开始时间
	                md5EndTime: 0,
	                // md5计算结束时间
	                signStartTime: 0,
	                // 计算签名开始时间
	                signEndTime: 0,
	                // 计算签名结束时间
	                httpStartTime: 0,
	                // 发起网络请求开始时间
	                httpEndTime: 0,
	                // 网路请求结束时间
	                startTime: (/* @__PURE__ */ new Date()).getTime(),
	                // sdk api调用起始时间，不是纯网络耗时
	                endTime: 0,
	                //  sdk api调用结束时间，不是纯网络耗时
	                // js补充字段
	                traceId: traceId || utils.getUid(),
	                // 每条上报唯一标识
	                appid,
	                partNumber: 0,
	                // 分块上传编号
	                httpRetryTimes: 0,
	                // sdk内部发起的请求重试
	                customId: customId || "",
	                // 业务id
	                partTime: 0
	              };
	              if (Beacon) {
	                this.beacon = getBeacon(Beacon, delay);
	              }
	            }
	            _createClass(Tracker2, [{
	              key: "formatResult",
	              value: function formatResult(err, data) {
	                var _err$error, _err$error2, _err$error3, _err$error4, _err$error5, _err$error6;
	                var now = (/* @__PURE__ */ new Date()).getTime();
	                var networkType = utils.getNetType();
	                var errorCode = err ? (err === null || err === void 0 ? void 0 : err.code) || (err === null || err === void 0 ? void 0 : (_err$error = err.error) === null || _err$error === void 0 ? void 0 : _err$error.code) || (err === null || err === void 0 ? void 0 : (_err$error2 = err.error) === null || _err$error2 === void 0 ? void 0 : _err$error2.Code) : "";
	                var errorMessage = err ? (err === null || err === void 0 ? void 0 : err.message) || (err === null || err === void 0 ? void 0 : (_err$error3 = err.error) === null || _err$error3 === void 0 ? void 0 : _err$error3.message) || (err === null || err === void 0 ? void 0 : (_err$error4 = err.error) === null || _err$error4 === void 0 ? void 0 : _err$error4.Message) : "";
	                var errorName = errorMessage;
	                var errorServiceName = err ? (err === null || err === void 0 ? void 0 : err.resource) || (err === null || err === void 0 ? void 0 : (_err$error5 = err.error) === null || _err$error5 === void 0 ? void 0 : _err$error5.resource) || (err === null || err === void 0 ? void 0 : (_err$error6 = err.error) === null || _err$error6 === void 0 ? void 0 : _err$error6.Resource) : "";
	                var errorHttpCode = err ? err === null || err === void 0 ? void 0 : err.statusCode : data.statusCode;
	                var requestId = err ? (err === null || err === void 0 ? void 0 : err.headers) && (err === null || err === void 0 ? void 0 : err.headers["x-cos-request-id"]) : (data === null || data === void 0 ? void 0 : data.headers) && (data === null || data === void 0 ? void 0 : data.headers["x-cos-request-id"]);
	                var errorType = err ? requestId ? "Server" : "Client" : "";
	                if (this.params.requestName === "getObject") {
	                  this.params.httpSize = data ? data.headers && data.headers["content-length"] : 0;
	                }
	                var isSliceUploadFile = this.params.realApi === "sliceUploadFile";
	                var isSliceCopyFile = this.params.realApi === "sliceCopyFile";
	                if (isSliceUploadFile || isSliceCopyFile) {
	                  var speed = this.params.httpSize / 1024 / this.params.partTime;
	                  Object.assign(this.params, {
	                    httpSpeed: speed < 0 ? 0 : speed.toFixed(3)
	                  });
	                } else {
	                  var httpFullTime = now - this.params.startTime;
	                  var httpTookTime = this.params.httpEndTime - this.params.httpStartTime;
	                  var _speed = this.params.httpSize / 1024 / (httpTookTime / 1e3);
	                  var httpMd5 = this.params.md5EndTime - this.params.md5StartTime;
	                  var httpSign = this.params.signEndTime - this.params.signStartTime;
	                  if (this.parent) {
	                    this.parent.addParamValue("httpTookTime", ms2s(httpTookTime));
	                    this.parent.addParamValue("httpFullTime", ms2s(httpFullTime));
	                    this.parent.addParamValue("httpMd5", ms2s(httpMd5));
	                    this.parent.addParamValue("httpSign", ms2s(httpSign));
	                    if (["multipartUpload", "uploadPartCopy", "putObjectCopy"].includes(this.params.requestName)) {
	                      this.parent.addParamValue("partTime", ms2s(httpTookTime));
	                    }
	                  }
	                  Object.assign(this.params, {
	                    httpFullTime: ms2s(httpFullTime),
	                    httpMd5: ms2s(httpMd5),
	                    httpSign: ms2s(httpSign),
	                    httpTookTime: ms2s(httpTookTime),
	                    httpSpeed: _speed < 0 ? 0 : _speed.toFixed(3)
	                  });
	                }
	                Object.assign(this.params, {
	                  networkType,
	                  requestResult: err ? "Failure" : "Success",
	                  errorType,
	                  errorCode,
	                  errorHttpCode,
	                  errorName,
	                  errorMessage,
	                  errorServiceName,
	                  errorRequestId: requestId
	                });
	                if (err && (!errorCode || !errorMessage)) {
	                  this.params.fullError = err ? JSON.stringify(err) : "";
	                }
	                if (this.params.url) {
	                  try {
	                    var execRes = /^http(s)?:\/\/(.*?)\//.exec(this.params.url);
	                    this.params.host = execRes[2];
	                  } catch (e) {
	                    this.params.host = this.params.url;
	                  }
	                  this.params.httpDomain = this.params.host;
	                }
	              }
	              // 上报
	            }, {
	              key: "report",
	              value: function report(err, data) {
	                if (!this.beacon && !this.clsReporter) return;
	                this.formatResult(err, data);
	                var formattedParams = formatParams(this.params);
	                if (this.beacon) {
	                  this.sendEventsToBeacon(formattedParams);
	                }
	                if (this.clsReporter) {
	                  this.sendEventsToCLS(formattedParams);
	                }
	              }
	              // 设置当前链路的参数
	            }, {
	              key: "setParams",
	              value: function setParams(params) {
	                Object.assign(this.params, params);
	              }
	            }, {
	              key: "addParamValue",
	              value: function addParamValue(key, value) {
	                this.params[key] = (+this.params[key] + +value).toFixed(3);
	              }
	              // 上报灯塔
	            }, {
	              key: "sendEventsToBeacon",
	              value: function sendEventsToBeacon(formattedParams) {
	                var isSliceUploadFile = this.params.requestName === "sliceUploadFile" || this.params.realApi === "sliceUploadFile";
	                if (isSliceUploadFile && !this.deepTracker) {
	                  return;
	                }
	                var eventCode = "qcloud_track_cos_sdk";
	                if (this.delay === 0) {
	                  this.beacon && this.beacon.onDirectUserAction(eventCode, formattedParams);
	                } else {
	                  this.beacon && this.beacon.onUserAction(eventCode, formattedParams);
	                }
	              }
	              // 上报 cls
	            }, {
	              key: "sendEventsToCLS",
	              value: function sendEventsToCLS(formattedParams) {
	                var immediate = !!(this.delay === 0);
	                this.clsReporter.log(formattedParams, immediate);
	              }
	              // 生成子实例，与父所属一个链路，可用于分块上传内部流程上报单个分块操作
	            }, {
	              key: "generateSubTracker",
	              value: function generateSubTracker(subParams) {
	                Object.assign(subParams, {
	                  parent: this,
	                  deepTracker: this.deepTracker,
	                  traceId: this.params.traceId,
	                  bucket: this.params.bucket,
	                  region: this.params.region,
	                  accelerate: this.params.accelerate,
	                  fileKey: this.params.requestPath,
	                  customId: this.params.customId,
	                  delay: this.delay,
	                  clsReporter: this.clsReporter
	                });
	                return new Tracker2(subParams);
	              }
	            }]);
	            return Tracker2;
	          }();
	          module2.exports = Tracker;
	        }
	      ),
	      /***/
	      "./src/util.js": (
	        /*!*********************!*\
	          !*** ./src/util.js ***!
	          \*********************/
	        /*! no static exports found */
	        /***/
	        function(module2, exports2, __webpack_require__) {
	          (function(process) {
	            var _typeof = __webpack_require__(
	              /*! @babel/runtime/helpers/typeof */
	              "./node_modules/@babel/runtime/helpers/typeof.js"
	            );
	            function _createForOfIteratorHelper(o, allowArrayLike) {
	              var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
	              if (!it) {
	                if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike  ) {
	                  if (it) o = it;
	                  var i = 0;
	                  var F = function F2() {
	                  };
	                  return { s: F, n: function n() {
	                    if (i >= o.length) return { done: true };
	                    return { done: false, value: o[i++] };
	                  }, e: function e(_e) {
	                    throw _e;
	                  }, f: F };
	                }
	                throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
	              }
	              var normalCompletion = true, didErr = false, err;
	              return { s: function s() {
	                it = it.call(o);
	              }, n: function n() {
	                var step = it.next();
	                normalCompletion = step.done;
	                return step;
	              }, e: function e(_e2) {
	                didErr = true;
	                err = _e2;
	              }, f: function f() {
	                try {
	                  if (!normalCompletion && it.return != null) it.return();
	                } finally {
	                  if (didErr) throw err;
	                }
	              } };
	            }
	            function _unsupportedIterableToArray(o, minLen) {
	              if (!o) return;
	              if (typeof o === "string") return _arrayLikeToArray(o, minLen);
	              var n = Object.prototype.toString.call(o).slice(8, -1);
	              if (n === "Object" && o.constructor) n = o.constructor.name;
	              if (n === "Map" || n === "Set") return Array.from(o);
	              if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
	            }
	            function _arrayLikeToArray(arr, len) {
	              if (len == null || len > arr.length) len = arr.length;
	              for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
	              return arr2;
	            }
	            var md5 = __webpack_require__(
	              /*! ../lib/md5 */
	              "./lib/md5.js"
	            );
	            var CryptoJS = __webpack_require__(
	              /*! ../lib/crypto */
	              "./lib/crypto.js"
	            );
	            var xml2json = __webpack_require__(
	              /*! ../lib/xml2json */
	              "./lib/xml2json.js"
	            );
	            var json2xml = __webpack_require__(
	              /*! ../lib/json2xml */
	              "./lib/json2xml.js"
	            );
	            var base64 = __webpack_require__(
	              /*! ../lib/base64 */
	              "./lib/base64.js"
	            );
	            var Tracker = __webpack_require__(
	              /*! ./tracker */
	              "./src/tracker.js"
	            );
	            function camSafeUrlEncode(str) {
	              return encodeURIComponent(str).replace(/!/g, "%21").replace(/'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29").replace(/\*/g, "%2A");
	            }
	            function getObjectKeys(obj, forKey) {
	              var list = [];
	              for (var key in obj) {
	                if (obj.hasOwnProperty(key)) {
	                  list.push(forKey ? camSafeUrlEncode(key).toLowerCase() : key);
	                }
	              }
	              return list.sort(function(a, b) {
	                a = a.toLowerCase();
	                b = b.toLowerCase();
	                return a === b ? 0 : a > b ? 1 : -1;
	              });
	            }
	            var obj2str = function obj2str2(obj, lowerCaseKey) {
	              var i, key, val;
	              var list = [];
	              var keyList = getObjectKeys(obj);
	              for (i = 0; i < keyList.length; i++) {
	                key = keyList[i];
	                val = obj[key] === void 0 || obj[key] === null ? "" : "" + obj[key];
	                key = lowerCaseKey ? camSafeUrlEncode(key).toLowerCase() : camSafeUrlEncode(key);
	                val = camSafeUrlEncode(val) || "";
	                list.push(key + "=" + val);
	              }
	              return list.join("&");
	            };
	            var signHeaders = ["cache-control", "content-disposition", "content-encoding", "content-length", "content-md5", "expect", "expires", "host", "if-match", "if-modified-since", "if-none-match", "if-unmodified-since", "origin", "range", "transfer-encoding", "pic-operations"];
	            var getSignHeaderObj = function getSignHeaderObj2(headers) {
	              var signHeaderObj = {};
	              for (var i in headers) {
	                var key = i.toLowerCase();
	                if (key.indexOf("x-cos-") > -1 || signHeaders.indexOf(key) > -1) {
	                  signHeaderObj[i] = headers[i];
	                }
	              }
	              return signHeaderObj;
	            };
	            var getAuth = function getAuth2(opt) {
	              opt = opt || {};
	              var SecretId = opt.SecretId;
	              var SecretKey = opt.SecretKey;
	              var KeyTime = opt.KeyTime;
	              var method = (opt.method || opt.Method || "get").toLowerCase();
	              var queryParams = clone(opt.Query || opt.params || {});
	              var headers = getSignHeaderObj(clone(opt.Headers || opt.headers || {}));
	              var Key = opt.Key || "";
	              var pathname;
	              if (opt.UseRawKey) {
	                pathname = opt.Pathname || opt.pathname || "/" + Key;
	              } else {
	                pathname = opt.Pathname || opt.pathname || Key;
	                pathname.indexOf("/") !== 0 && (pathname = "/" + pathname);
	              }
	              var forceSignHost = opt.ForceSignHost === false ? false : true;
	              if (!headers.Host && !headers.host && opt.Bucket && opt.Region && forceSignHost) headers.Host = opt.Bucket + ".cos." + opt.Region + ".myqcloud.com";
	              if (!SecretId) throw new Error("missing param SecretId");
	              if (!SecretKey) throw new Error("missing param SecretKey");
	              var now = Math.round(getSkewTime(opt.SystemClockOffset) / 1e3) - 1;
	              var exp = now;
	              var Expires = opt.Expires || opt.expires;
	              if (Expires === void 0) {
	                exp += 900;
	              } else {
	                exp += Expires * 1 || 0;
	              }
	              var qSignAlgorithm = "sha1";
	              var qAk = SecretId;
	              var qSignTime = KeyTime || now + ";" + exp;
	              var qKeyTime = KeyTime || now + ";" + exp;
	              var qHeaderList = getObjectKeys(headers, true).join(";").toLowerCase();
	              var qUrlParamList = getObjectKeys(queryParams, true).join(";").toLowerCase();
	              var signKey = CryptoJS.HmacSHA1(qKeyTime, SecretKey).toString();
	              var formatString = [method, pathname, util.obj2str(queryParams, true), util.obj2str(headers, true), ""].join("\n");
	              var stringToSign = ["sha1", qSignTime, CryptoJS.SHA1(formatString).toString(), ""].join("\n");
	              var qSignature = CryptoJS.HmacSHA1(stringToSign, signKey).toString();
	              var authorization = ["q-sign-algorithm=" + qSignAlgorithm, "q-ak=" + qAk, "q-sign-time=" + qSignTime, "q-key-time=" + qKeyTime, "q-header-list=" + qHeaderList, "q-url-param-list=" + qUrlParamList, "q-signature=" + qSignature].join("&");
	              return authorization;
	            };
	            var readIntBE = function readIntBE2(chunk, size, offset) {
	              var bytes = size / 8;
	              var buf = chunk.slice(offset, offset + bytes);
	              new Uint8Array(buf).reverse();
	              return new {
	                8: Uint8Array,
	                16: Uint16Array,
	                32: Uint32Array
	              }[size](buf)[0];
	            };
	            var buf2str = function buf2str2(chunk, start, end, isUtf8) {
	              var buf = chunk.slice(start, end);
	              var str = "";
	              new Uint8Array(buf).forEach(function(charCode) {
	                str += String.fromCharCode(charCode);
	              });
	              if (isUtf8) str = decodeURIComponent(escape(str));
	              return str;
	            };
	            var parseSelectPayload = function parseSelectPayload2(chunk) {
	              var header = {};
	              var body = buf2str(chunk);
	              var result = {
	                records: []
	              };
	              while (chunk.byteLength) {
	                var totalLength = readIntBE(chunk, 32, 0);
	                var headerLength = readIntBE(chunk, 32, 4);
	                var payloadRestLength = totalLength - headerLength - 16;
	                var offset = 0;
	                var content;
	                chunk = chunk.slice(12);
	                while (offset < headerLength) {
	                  var headerNameLength = readIntBE(chunk, 8, offset);
	                  var headerName = buf2str(chunk, offset + 1, offset + 1 + headerNameLength);
	                  var headerValueLength = readIntBE(chunk, 16, offset + headerNameLength + 2);
	                  var headerValue = buf2str(chunk, offset + headerNameLength + 4, offset + headerNameLength + 4 + headerValueLength);
	                  header[headerName] = headerValue;
	                  offset += headerNameLength + 4 + headerValueLength;
	                }
	                if (header[":event-type"] === "Records") {
	                  content = buf2str(chunk, offset, offset + payloadRestLength, true);
	                  result.records.push(content);
	                } else if (header[":event-type"] === "Stats") {
	                  content = buf2str(chunk, offset, offset + payloadRestLength, true);
	                  result.stats = util.xml2json(content).Stats;
	                } else if (header[":event-type"] === "error") {
	                  var errCode = header[":error-code"];
	                  var errMessage = header[":error-message"];
	                  var err = new Error(errMessage);
	                  err.message = errMessage;
	                  err.name = err.code = errCode;
	                  result.error = err;
	                } else ;
	                chunk = chunk.slice(offset + payloadRestLength + 4);
	              }
	              return {
	                payload: result.records.join(""),
	                body
	              };
	            };
	            var getSourceParams = function getSourceParams2(source) {
	              var parser = this.options.CopySourceParser;
	              if (parser) return parser(source);
	              var m = source.match(/^([^.]+-\d+)\.cos(v6|-cdc|-cdz|-internal)?\.([^.]+)\.((myqcloud\.com)|(tencentcos\.cn))\/(.+)$/);
	              if (!m) return null;
	              return {
	                Bucket: m[1],
	                Region: m[3],
	                Key: m[7]
	              };
	            };
	            var noop = function noop2() {
	            };
	            var clearKey = function clearKey2(obj) {
	              var retObj = {};
	              for (var key in obj) {
	                if (obj.hasOwnProperty(key) && obj[key] !== void 0 && obj[key] !== null) {
	                  retObj[key] = obj[key];
	                }
	              }
	              return retObj;
	            };
	            var readAsBinaryString = function readAsBinaryString2(blob, callback) {
	              var readFun;
	              var fr = new FileReader();
	              if (FileReader.prototype.readAsBinaryString) {
	                readFun = FileReader.prototype.readAsBinaryString;
	                fr.onload = function() {
	                  callback(this.result);
	                };
	              } else if (FileReader.prototype.readAsArrayBuffer) {
	                readFun = function readFun2(fileData) {
	                  var binary = "";
	                  var reader = new FileReader();
	                  reader.onload = function(e) {
	                    var bytes = new Uint8Array(reader.result);
	                    var length = bytes.byteLength;
	                    for (var i = 0; i < length; i++) {
	                      binary += String.fromCharCode(bytes[i]);
	                    }
	                    callback(binary);
	                  };
	                  reader.readAsArrayBuffer(fileData);
	                };
	              } else {
	                console.error("FileReader not support readAsBinaryString");
	              }
	              readFun.call(fr, blob);
	            };
	            var fileSliceNeedCopy = function() {
	              var compareVersion = function compareVersion2(a, b) {
	                a = a.split(".");
	                b = b.split(".");
	                for (var i = 0; i < b.length; i++) {
	                  if (a[i] !== b[i]) {
	                    return parseInt(a[i]) > parseInt(b[i]) ? 1 : -1;
	                  }
	                }
	                return 0;
	              };
	              var check = function check2(ua) {
	                if (!ua) return false;
	                var ChromeVersion = (ua.match(/Chrome\/([.\d]+)/) || [])[1];
	                var QBCoreVersion = (ua.match(/QBCore\/([.\d]+)/) || [])[1];
	                var QQBrowserVersion = (ua.match(/QQBrowser\/([.\d]+)/) || [])[1];
	                var need = ChromeVersion && compareVersion(ChromeVersion, "53.0.2785.116") < 0 && QBCoreVersion && compareVersion(QBCoreVersion, "3.53.991.400") < 0 && QQBrowserVersion && compareVersion(QQBrowserVersion, "9.0.2524.400") <= 0 || false;
	                return need;
	              };
	              return check(typeof navigator !== "undefined" && navigator.userAgent);
	            }();
	            var fileSlice = function fileSlice2(file, start, end, isUseToUpload, callback) {
	              var blob;
	              if (file.slice) {
	                blob = file.slice(start, end);
	              } else if (file.mozSlice) {
	                blob = file.mozSlice(start, end);
	              } else if (file.webkitSlice) {
	                blob = file.webkitSlice(start, end);
	              }
	              if (isUseToUpload && fileSliceNeedCopy) {
	                var reader = new FileReader();
	                reader.onload = function(e) {
	                  blob = null;
	                  callback(new Blob([reader.result]));
	                };
	                reader.readAsArrayBuffer(blob);
	              } else {
	                callback(blob);
	              }
	            };
	            var getBodyMd5 = function getBodyMd52(UploadCheckContentMd5, Body, callback, onProgress) {
	              callback = callback || noop;
	              if (UploadCheckContentMd5) {
	                if (typeof Body === "string") {
	                  callback(util.md5(Body, true));
	                } else if (Blob && Body instanceof Blob) {
	                  util.getFileMd5(Body, function(err, md52) {
	                    callback(md52);
	                  }, onProgress);
	                } else {
	                  callback();
	                }
	              } else {
	                callback();
	              }
	            };
	            var md5ChunkSize = 1024 * 1024;
	            var getFileMd5 = function getFileMd52(blob, callback, onProgress) {
	              var size = blob.size;
	              var loaded = 0;
	              var md5ctx = md5.getCtx();
	              var next = function next2(start) {
	                if (start >= size) {
	                  var hash = md5ctx.digest("hex");
	                  callback(null, hash);
	                  return;
	                }
	                var end = Math.min(size, start + md5ChunkSize);
	                util.fileSlice(blob, start, end, false, function(chunk) {
	                  readAsBinaryString(chunk, function(content) {
	                    chunk = null;
	                    md5ctx = md5ctx.update(content, true);
	                    loaded += content.length;
	                    content = null;
	                    if (onProgress) onProgress({
	                      loaded,
	                      total: size,
	                      percent: Math.round(loaded / size * 1e4) / 1e4
	                    });
	                    next2(start + md5ChunkSize);
	                  });
	                });
	              };
	              next(0);
	            };
	            function clone(obj) {
	              return map(obj, function(v) {
	                return _typeof(v) === "object" && v !== null ? clone(v) : v;
	              });
	            }
	            function attr(obj, name, defaultValue) {
	              return obj && name in obj ? obj[name] : defaultValue;
	            }
	            function extend(target, source) {
	              each(source, function(val, key) {
	                target[key] = source[key];
	              });
	              return target;
	            }
	            function isArray(arr) {
	              return arr instanceof Array;
	            }
	            function isInArray(arr, item) {
	              var flag = false;
	              for (var i = 0; i < arr.length; i++) {
	                if (item === arr[i]) {
	                  flag = true;
	                  break;
	                }
	              }
	              return flag;
	            }
	            function makeArray(arr) {
	              return isArray(arr) ? arr : [arr];
	            }
	            function each(obj, fn) {
	              for (var i in obj) {
	                if (obj.hasOwnProperty(i)) {
	                  fn(obj[i], i);
	                }
	              }
	            }
	            function map(obj, fn) {
	              var o = isArray(obj) ? [] : {};
	              for (var i in obj) {
	                if (obj.hasOwnProperty(i)) {
	                  o[i] = fn(obj[i], i);
	                }
	              }
	              return o;
	            }
	            function filter(obj, fn) {
	              var iaArr = isArray(obj);
	              var o = iaArr ? [] : {};
	              for (var i in obj) {
	                if (obj.hasOwnProperty(i)) {
	                  if (fn(obj[i], i)) {
	                    if (iaArr) {
	                      o.push(obj[i]);
	                    } else {
	                      o[i] = obj[i];
	                    }
	                  }
	                }
	              }
	              return o;
	            }
	            var b64 = function b642(str) {
	              var i, len, char, res = "";
	              for (i = 0, len = str.length / 2; i < len; i++) {
	                char = parseInt(str[i * 2] + str[i * 2 + 1], 16);
	                res += String.fromCharCode(char);
	              }
	              return btoa(res);
	            };
	            var uuid = function uuid2() {
	              var S4 = function S42() {
	                return ((1 + Math.random()) * 65536 | 0).toString(16).substring(1);
	              };
	              return S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4();
	            };
	            var hasMissingParams = function hasMissingParams2(apiName, params) {
	              var Bucket = params.Bucket;
	              var Region = params.Region;
	              var Key = params.Key;
	              var Domain = this.options.Domain;
	              var checkBucket = !Domain || typeof Domain === "string" && Domain.indexOf("{Bucket}") > -1;
	              var checkRegion = !Domain || typeof Domain === "string" && Domain.indexOf("{Region}") > -1;
	              if (apiName.indexOf("Bucket") > -1 || apiName === "deleteMultipleObject" || apiName === "multipartList" || apiName === "listObjectVersions") {
	                if (checkBucket && !Bucket) return "Bucket";
	                if (checkRegion && !Region) return "Region";
	              } else if (apiName.indexOf("Object") > -1 || apiName.indexOf("multipart") > -1 || apiName === "sliceUploadFile" || apiName === "abortUploadTask" || apiName === "uploadFile") {
	                if (checkBucket && !Bucket) return "Bucket";
	                if (checkRegion && !Region) return "Region";
	                if (!Key) return "Key";
	              }
	              return false;
	            };
	            var formatParams = function formatParams2(apiName, params) {
	              params = extend({}, params);
	              if (apiName !== "getAuth" && apiName !== "getV4Auth" && apiName !== "getObjectUrl") {
	                var Headers = params.Headers || {};
	                if (params && _typeof(params) === "object") {
	                  (function() {
	                    for (var key in params) {
	                      if (params.hasOwnProperty(key) && key.indexOf("x-cos-") > -1) {
	                        Headers[key] = params[key];
	                      }
	                    }
	                  })();
	                  var headerMap = {
	                    // params headers
	                    "x-cos-mfa": "MFA",
	                    "Content-MD5": "ContentMD5",
	                    "Content-Length": "ContentLength",
	                    "Content-Type": "ContentType",
	                    Expect: "Expect",
	                    Expires: "Expires",
	                    "Cache-Control": "CacheControl",
	                    "Content-Disposition": "ContentDisposition",
	                    "Content-Encoding": "ContentEncoding",
	                    Range: "Range",
	                    "If-Modified-Since": "IfModifiedSince",
	                    "If-Unmodified-Since": "IfUnmodifiedSince",
	                    "If-Match": "IfMatch",
	                    "If-None-Match": "IfNoneMatch",
	                    "x-cos-copy-source": "CopySource",
	                    "x-cos-copy-source-Range": "CopySourceRange",
	                    "x-cos-metadata-directive": "MetadataDirective",
	                    "x-cos-copy-source-If-Modified-Since": "CopySourceIfModifiedSince",
	                    "x-cos-copy-source-If-Unmodified-Since": "CopySourceIfUnmodifiedSince",
	                    "x-cos-copy-source-If-Match": "CopySourceIfMatch",
	                    "x-cos-copy-source-If-None-Match": "CopySourceIfNoneMatch",
	                    "x-cos-acl": "ACL",
	                    "x-cos-grant-read": "GrantRead",
	                    "x-cos-grant-write": "GrantWrite",
	                    "x-cos-grant-full-control": "GrantFullControl",
	                    "x-cos-grant-read-acp": "GrantReadAcp",
	                    "x-cos-grant-write-acp": "GrantWriteAcp",
	                    "x-cos-storage-class": "StorageClass",
	                    "x-cos-traffic-limit": "TrafficLimit",
	                    "x-cos-mime-limit": "MimeLimit",
	                    // SSE-C
	                    "x-cos-server-side-encryption-customer-algorithm": "SSECustomerAlgorithm",
	                    "x-cos-server-side-encryption-customer-key": "SSECustomerKey",
	                    "x-cos-server-side-encryption-customer-key-MD5": "SSECustomerKeyMD5",
	                    // SSE-COS、SSE-KMS
	                    "x-cos-server-side-encryption": "ServerSideEncryption",
	                    "x-cos-server-side-encryption-cos-kms-key-id": "SSEKMSKeyId",
	                    "x-cos-server-side-encryption-context": "SSEContext",
	                    // 上传时图片处理
	                    "Pic-Operations": "PicOperations",
	                    "x-cos-callback": "Callback",
	                    "x-cos-callback-var": "CallbackVar",
	                    "x-cos-return-body": "ReturnBody"
	                  };
	                  util.each(headerMap, function(paramKey, headerKey) {
	                    if (params[paramKey] !== void 0) {
	                      Headers[headerKey] = params[paramKey];
	                    }
	                  });
	                  params.Headers = clearKey(Headers);
	                }
	              }
	              return params;
	            };
	            var apiWrapper = function apiWrapper2(apiName, apiFn) {
	              return function(params, callback) {
	                var self2 = this;
	                if (typeof params === "function") {
	                  callback = params;
	                  params = {};
	                }
	                params = formatParams(apiName, params);
	                var tracker;
	                if (self2.options.EnableReporter) {
	                  if (params.calledBySdk === "sliceUploadFile" || params.calledBySdk === "sliceCopyFile") {
	                    tracker = params.tracker && params.tracker.generateSubTracker({
	                      apiName
	                    });
	                  } else if (["uploadFile", "uploadFiles"].includes(apiName)) {
	                    tracker = null;
	                  } else {
	                    var fileSize = 0;
	                    if (params.Body) {
	                      fileSize = typeof params.Body === "string" ? params.Body.length : params.Body.size || params.Body.byteLength || 0;
	                    }
	                    var accelerate = self2.options.UseAccelerate || typeof self2.options.Domain === "string" && self2.options.Domain.includes("accelerate.");
	                    tracker = new Tracker({
	                      Beacon: self2.options.BeaconReporter,
	                      clsReporter: self2.options.ClsReporter,
	                      bucket: params.Bucket,
	                      region: params.Region,
	                      apiName,
	                      realApi: apiName,
	                      accelerate,
	                      fileKey: params.Key,
	                      fileSize,
	                      deepTracker: self2.options.DeepTracker,
	                      customId: self2.options.CustomId,
	                      delay: self2.options.TrackerDelay
	                    });
	                  }
	                }
	                params.tracker = tracker;
	                var formatResult = function formatResult2(result) {
	                  if (result && result.headers) {
	                    result.headers["x-cos-request-id"] && (result.RequestId = result.headers["x-cos-request-id"]);
	                    result.headers["x-ci-request-id"] && (result.RequestId = result.headers["x-ci-request-id"]);
	                    result.headers["x-cos-version-id"] && (result.VersionId = result.headers["x-cos-version-id"]);
	                    result.headers["x-cos-delete-marker"] && (result.DeleteMarker = result.headers["x-cos-delete-marker"]);
	                  }
	                  return result;
	                };
	                var _callback = function _callback2(err, data) {
	                  tracker && tracker.report(err, data);
	                  callback && callback(formatResult(err), formatResult(data));
	                };
	                var checkParams = function checkParams2() {
	                  if (apiName !== "getService" && apiName !== "abortUploadTask") {
	                    var missingResult = hasMissingParams.call(self2, apiName, params);
	                    if (missingResult) {
	                      return "missing param " + missingResult;
	                    }
	                    if (params.Region) {
	                      if (self2.options.CompatibilityMode) {
	                        if (!/^([a-z\d-.]+)$/.test(params.Region)) {
	                          return "Region format error.";
	                        }
	                      } else {
	                        if (params.Region.indexOf("cos.") > -1) {
	                          return 'param Region should not be start with "cos."';
	                        } else if (!/^([a-z\d-]+)$/.test(params.Region)) {
	                          return "Region format error.";
	                        }
	                      }
	                      if (!self2.options.CompatibilityMode && params.Region.indexOf("-") === -1 && params.Region !== "yfb" && params.Region !== "default" && params.Region !== "accelerate") {
	                        console.warn("warning: param Region format error, find help here: https://cloud.tencent.com/document/product/436/6224");
	                      }
	                    }
	                    if (params.Bucket) {
	                      if (!/^([a-z\d-]+)-(\d+)$/.test(params.Bucket)) {
	                        if (params.AppId) {
	                          params.Bucket = params.Bucket + "-" + params.AppId;
	                        } else if (self2.options.AppId) {
	                          params.Bucket = params.Bucket + "-" + self2.options.AppId;
	                        } else {
	                          return 'Bucket should format as "test-1250000000".';
	                        }
	                      }
	                      if (params.AppId) {
	                        console.warn('warning: AppId has been deprecated, Please put it at the end of parameter Bucket(E.g Bucket:"test-1250000000" ).');
	                        delete params.AppId;
	                      }
	                    }
	                    if (!self2.options.UseRawKey && params.Key && params.Key.substr(0, 1) === "/") {
	                      params.Key = params.Key.substr(1);
	                    }
	                  }
	                };
	                var errMsg = checkParams();
	                var isSync = ["getAuth", "getObjectUrl"].includes(apiName);
	                if (typeof Promise === "function" && !isSync && !callback) {
	                  return new Promise(function(resolve, reject) {
	                    callback = function callback2(err, data) {
	                      err ? reject(err) : resolve(data);
	                    };
	                    if (errMsg) return _callback(util.error(new Error(errMsg)));
	                    apiFn.call(self2, params, _callback);
	                  });
	                } else {
	                  if (errMsg) return _callback(util.error(new Error(errMsg)));
	                  var res = apiFn.call(self2, params, _callback);
	                  if (isSync) return res;
	                }
	              };
	            };
	            var throttleOnProgress = function throttleOnProgress2(total, onProgress) {
	              var self2 = this;
	              var size0 = 0;
	              var size1 = 0;
	              var time0 = Date.now();
	              var time1;
	              var timer;
	              function update() {
	                timer = 0;
	                if (onProgress && typeof onProgress === "function") {
	                  time1 = Date.now();
	                  var speed = Math.max(0, Math.round((size1 - size0) / ((time1 - time0) / 1e3) * 100) / 100) || 0;
	                  var percent;
	                  if (size1 === 0 && total === 0) {
	                    percent = 1;
	                  } else {
	                    percent = Math.floor(size1 / total * 100) / 100 || 0;
	                  }
	                  time0 = time1;
	                  size0 = size1;
	                  try {
	                    onProgress({
	                      loaded: size1,
	                      total,
	                      speed,
	                      percent
	                    });
	                  } catch (e) {
	                  }
	                }
	              }
	              return function(info, immediately) {
	                if (info) {
	                  size1 = info.loaded;
	                  total = info.total;
	                }
	                if (immediately) {
	                  clearTimeout(timer);
	                  update();
	                } else {
	                  if (timer) return;
	                  timer = setTimeout(update, self2.options.ProgressInterval);
	                }
	              };
	            };
	            var getFileSize = function getFileSize2(api, params, callback) {
	              var size;
	              if (typeof params.Body === "string") {
	                params.Body = new Blob([params.Body], {
	                  type: "text/plain"
	                });
	              } else if (params.Body instanceof ArrayBuffer) {
	                params.Body = new Blob([params.Body]);
	              }
	              if (params.Body && (params.Body instanceof Blob || params.Body.toString() === "[object File]" || params.Body.toString() === "[object Blob]")) {
	                size = params.Body.size;
	              } else {
	                callback(util.error(new Error("params body format error, Only allow File|Blob|String.")));
	                return;
	              }
	              params.ContentLength = size;
	              callback(null, size);
	            };
	            var getSkewTime = function getSkewTime2(offset) {
	              return Date.now() + (offset || 0);
	            };
	            var error = function error2(err, opt) {
	              var sourceErr = err;
	              err.message = err.message || null;
	              if (typeof opt === "string") {
	                err.error = opt;
	                err.message = opt;
	              } else if (_typeof(opt) === "object" && opt !== null) {
	                extend(err, opt);
	                if (opt.code || opt.name) err.code = opt.code || opt.name;
	                if (opt.message) err.message = opt.message;
	                if (opt.stack) err.stack = opt.stack;
	              }
	              if (typeof Object.defineProperty === "function") {
	                Object.defineProperty(err, "name", {
	                  writable: true,
	                  enumerable: false
	                });
	                Object.defineProperty(err, "message", {
	                  enumerable: true
	                });
	              }
	              err.name = opt && opt.name || err.name || err.code || "Error";
	              if (!err.code) err.code = err.name;
	              if (!err.error) err.error = clone(sourceErr);
	              return err;
	            };
	            var isWebWorker = function isWebWorker2() {
	              return (typeof globalThis === "undefined" ? "undefined" : _typeof(globalThis)) === "object" && (globalThis.constructor.name === "DedicatedWorkerGlobalScope" || globalThis.FileReaderSync);
	            };
	            var isNode = function isNode2() {
	              return (typeof window === "undefined" ? "undefined" : _typeof(window)) !== "object" && (typeof process === "undefined" ? "undefined" : _typeof(process)) === "object" && true && !isWebWorker();
	            };
	            var isCIHost = function isCIHost2(url) {
	              return /^https?:\/\/([^/]+\.)?ci\.[^/]+/.test(url);
	            };
	            var isIOS2 = function() {
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) !== "object") {
	                return false;
	              }
	              var u = navigator.userAgent;
	              var isIOS3 = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
	              return isIOS3;
	            }();
	            var isQQ = function() {
	              if ((typeof navigator === "undefined" ? "undefined" : _typeof(navigator)) !== "object") {
	                return false;
	              }
	              return /\sQQ/i.test(navigator.userAgent);
	            }();
	            var encodeBase64 = function encodeBase642(str, safe) {
	              var base64Str = base64.encode(str);
	              if (safe) {
	                base64Str = base64Str.replaceAll("+", "-").replaceAll("/", "_").replaceAll("=", "");
	              }
	              return base64Str;
	            };
	            var decodeBase64 = function decodeBase642(base64Str) {
	              if (!base64Str) return "";
	              return base64.decode(base64Str);
	            };
	            var simplifyPath = function simplifyPath2(path) {
	              var names = path.split("/");
	              var stack = [];
	              var _iterator = _createForOfIteratorHelper(names), _step;
	              try {
	                for (_iterator.s(); !(_step = _iterator.n()).done; ) {
	                  var name = _step.value;
	                  if (name === "..") {
	                    if (stack.length) {
	                      stack.pop();
	                    }
	                  } else if (name.length && name !== ".") {
	                    stack.push(name);
	                  }
	                }
	              } catch (err) {
	                _iterator.e(err);
	              } finally {
	                _iterator.f();
	              }
	              return "/" + stack.join("/");
	            };
	            var parseResBody = function parseResBody2(responseBody) {
	              var json;
	              if (responseBody && typeof responseBody === "string") {
	                var trimBody = responseBody.trim();
	                var isXml = trimBody.indexOf("<") === 0;
	                var isJson = trimBody.indexOf("{") === 0;
	                if (isXml) {
	                  json = util.xml2json(responseBody) || {};
	                } else if (isJson) {
	                  try {
	                    var formatBody = responseBody.replace(/\n/g, " ");
	                    var parsedBody = JSON.parse(formatBody);
	                    if (Object.prototype.toString.call(parsedBody) === "[object Object]") {
	                      json = parsedBody;
	                    } else {
	                      json = responseBody;
	                    }
	                  } catch (e) {
	                    json = responseBody;
	                  }
	                } else {
	                  json = responseBody;
	                }
	              } else {
	                json = responseBody || {};
	              }
	              return json;
	            };
	            var util = {
	              noop,
	              formatParams,
	              apiWrapper,
	              xml2json,
	              json2xml,
	              md5,
	              clearKey,
	              fileSlice,
	              getBodyMd5,
	              getFileMd5,
	              b64,
	              extend,
	              isArray,
	              isInArray,
	              makeArray,
	              each,
	              map,
	              filter,
	              clone,
	              attr,
	              uuid,
	              camSafeUrlEncode,
	              throttleOnProgress,
	              getFileSize,
	              getSkewTime,
	              error,
	              obj2str,
	              getAuth,
	              parseSelectPayload,
	              getSourceParams,
	              isBrowser: true,
	              isNode,
	              isCIHost,
	              isIOS_QQ: isIOS2 && isQQ,
	              encodeBase64,
	              decodeBase64,
	              simplifyPath,
	              readAsBinaryString,
	              parseResBody
	            };
	            module2.exports = util;
	          }).call(this, __webpack_require__(
	            /*! ./../node_modules/process/browser.js */
	            "./node_modules/process/browser.js"
	          ));
	        }
	      )
	      /******/
	    })
	  );
	}); 
} (cosJsSdkV5));

var cosJsSdkV5Exports = cosJsSdkV5.exports;
const COS = /*@__PURE__*/getDefaultExportFromCjs(cosJsSdkV5Exports);

const debug$3 = createDebug('uploader:cos');
const RECORD_FILE_CATEGORY_LEGACY = '';
const RECORD_FILE_CATEGORY_NEXT = 'stash';
class CosService {
    storage;
    $fetch;
    db;
    logger;
    region;
    constructor(storage, $fetch, db, logger, region){
        this.storage = storage;
        this.$fetch = $fetch;
        this.db = db;
        this.logger = logger;
        this.region = region;
    }
    async uploadFiles(appId, prefix, credentialData, files, force, taskId, signal) {
        signal.throwIfAborted();
        const candidates = uniqBy(files.filter((file)=>!!(!file.uploaded && file.blob && file.Key)), 'hash');
        if (!candidates.length) {
            return [];
        }
        const filesWithData = force ? candidates : await this.getFilesRequireUpload(candidates);
        signal.throwIfAborted();
        if (!filesWithData.length) {
            return [];
        }
        const { db } = this;
        const cosClient = createCOSClient(credentialData, this.region);
        const taskIdList = [];
        function onTaskReady(taskId) {
            if (signal.aborted) {
                cosClient.cancelTask(taskId);
                return;
            }
            taskIdList.push(taskId);
        }
        const cancel = firstValueFrom(fromEvent$1(signal, 'abort'));
        cancel.then(()=>{
            taskIdList.forEach((taskId)=>{
                cosClient.cancelTask(taskId);
            });
        });
        const succeed = new Set();
        const failed = [];
        const uploadList = await this.packFiles(taskId, filesWithData);
        function setFileUploaded(file) {
            succeed.add(file.url);
            db.files.where({
                hash: file.hash,
                taskId
            }).modify({
                uploaded: DEXIE_TRUE
            });
        }
        const uploadParams = uploadList.filter((it)=>Boolean(it.url && it.taskId)).map((it)=>{
            const url = new URL(it.url);
            const filename = basename(it.Key || url.pathname);
            return {
                Key: it.Key,
                Body: it.blob,
                ContentType: it.contentType,
                filename,
                onTaskReady,
                onFileFinish (err) {
                    if (err) {
                        failed.push({
                            source: it.url,
                            target: join$1(prefix, appId, it.Key),
                            fileSize: it.blob.size
                        });
                    } else if (it.packedFiles) {
                        it.packedFiles.forEach((file)=>{
                            setFileUploaded(file);
                        });
                    } else {
                        setFileUploaded(it);
                    }
                }
            };
        });
        try {
            await Promise.race([
                cancel,
                uploadFiles(uploadParams, appId, prefix, cosClient)
            ]);
        } catch (e) {
            console.error(e);
            files.forEach((file)=>{
                if (!succeed.has(file.url)) {
                    failed.push({
                        source: file.url,
                        target: file.Key || null,
                        fileSize: file.blob?.size || 0
                    });
                }
            });
        }
        signal.throwIfAborted();
        return failed;
    }
    async uploadRecord(task, key, data, recordId, credentials) {
        if (!credentials || task.recordUploaded) {
            return;
        }
        const cosClient = createCOSClient(credentials, this.region);
        const record = {
            data: data.map((it)=>it.data),
            url: task.url,
            ua: navigator.userAgent
        };
        const blob = await encode(key, record);
        const env = await this.getUploadEnv();
        const Key = join$1('record', env, recordId, 'tape.bin');
        await cosClient.uploadFile(await createUploadFileItemParams({
            params: {
                Key,
                Body: blob,
                ContentType: 'application/octet-stream'
            },
            appId: ''
        }));
        await this.db.tasks.update(task.id, {
            recordUploaded: true
        });
    }
    async uploadScreenshot(file, demoId, recordId, credentials) {
        const { $fetch, db } = this;
        const env = await this.getUploadEnv();
        const Key = getDemoCoverPath(recordId, env);
        debug$3('start upload screenshot');
        try {
            const Body = file.blob;
            if (!Body) {
                console.error('screenshot no body', file);
                return;
            }
            const cosClient = createCOSClient(credentials, this.region);
            await cosClient.uploadFile(await createUploadFileItemParams({
                params: {
                    Key,
                    Body,
                    ContentType: Body.type
                },
                appId: '',
                picOperationsRules: [
                    {
                        rule: 'style/demo_cover'
                    }
                ]
            }));
            debug$3('upload screenshot to cos finished');
            await $fetch(join$1('api', 'demo', demoId), {
                method: 'patch',
                body: {
                    screenshotAt: new Date().toISOString()
                }
            });
            debug$3('patch demo screenshotAt finished');
            await db.files.where({
                taskId: file.taskId,
                url: file.url
            }).modify({
                uploaded: DEXIE_TRUE
            });
        } catch (error) {
            this.logger.logErrorObject('failed to upload demo screenshot', error);
            this.$fetch('/api/action-log', {
                method: 'POST',
                body: {
                    actionType: ActionType.RECORD_UPLOAD_FILE_FAIL,
                    resourceType: 'Demo',
                    resourceId: demoId,
                    data: {
                        taskId: file.taskId,
                        failedFiles: [
                            {
                                source: 'screenshot',
                                target: Key,
                                fileSize: file.blob.size
                            }
                        ]
                    }
                }
            });
        }
    }
    async getFilesRequireUpload(files) {
        try {
            const { $fetch, db } = this;
            const hashes = files.map((file)=>file.hash);
            const data = await $fetch('/api/record/file', {
                method: 'post',
                body: {
                    files: hashes
                }
            });
            const filesToUpload = [];
            const notExist = new Set(data.notExisted);
            files.forEach((file)=>{
                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                if (!notExist.has(file.hash)) {
                    db.files.where({
                        hash: file.hash
                    }).modify({
                        uploaded: DEXIE_TRUE
                    }).catch((error)=>{
                        this.logger.logErrorObject('mark file as uploaded fail', error);
                    });
                } else {
                    filesToUpload.push(file);
                }
            });
            return filesToUpload;
        } catch (error) {
            this.logger.logErrorObject('getFilesRequireUpload', error);
            return files;
        }
    }
    async getUploadEnv() {
        let env = await this.storage.getItem(ENV_KEY) || 'production';
        if (env === 'pre') {
            env = 'production';
        }
        return env;
    }
    async packFiles(taskId, input) {
        const PACK_THRESHOLD = 200 * 1024;
        const CHUNK_THRESHOLD = 5 * 1024 * 1024;
        const packed = [];
        const list = [];
        let sizeCount = 0;
        let zipWriter = new ZipWriter(new BlobWriter('application/zip'), {
            compressionMethod: 8
        });
        async function flipZipFile() {
            const blob = await zipWriter.close();
            const data = await blob.arrayBuffer();
            const hash = await sha1(data);
            list.push({
                blob,
                Key: `data_pack_${taskId}_${hash}.zip`,
                contentType: blob.type,
                taskId,
                url: `demoway://pack/${hash}`,
                fileType: StashFileType.Pack,
                uploaded: DEXIE_FALSE,
                timestamp: new Date().toISOString(),
                patch: 0,
                status: FileStatus.Finished,
                packedFiles: packed.slice()
            });
            sizeCount = 0;
            packed.length = 0;
        }
        for (const file of input){
            if (STYLE_SHEET_FILE_TYPES.includes(file.fileType) || file.blob.size < PACK_THRESHOLD) {
                await zipWriter.add(file.Key, new BlobReader(file.blob));
                sizeCount += file.blob.size;
                packed.push(file);
                file.packed = true;
                if (sizeCount >= CHUNK_THRESHOLD) {
                    await flipZipFile();
                    zipWriter = new ZipWriter(new BlobWriter('application/zip'), {
                        compressionMethod: 8
                    });
                }
            } else {
                // console.log('no pack file', file.data.byteLength, file.hash, file.url);
                list.push(file);
            }
        }
        if (sizeCount > 0) {
            await flipZipFile();
        }
        return list;
    }
}
CosService = __decorate([
    singleton(),
    __param(0, inject(STORAGE)),
    __param(1, inject(FETCH)),
    __param(3, inject(LOGGER)),
    __param(4, inject(REGION)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [
        typeof Storage === "undefined" ? Object : Storage,
        typeof $Fetch === "undefined" ? Object : $Fetch,
        typeof RecorderDB === "undefined" ? Object : RecorderDB,
        typeof ILoggerService === "undefined" ? Object : ILoggerService,
        typeof Region$1 === "undefined" ? Object : Region$1
    ])
], CosService);
function createCOSClient({ credentials, startTime, expiredTime }, region) {
    if (!credentials) {
        throw new Error('credentials invalid');
    }
    const cosDomain = region === Region$1.CHINA ? 's-ca.dwimg.top' : 's-a.dwimg.top';
    return new COS({
        UseAccelerate: true,
        Domain: cosDomain,
        FileParallelLimit: 6,
        getAuthorization: async function(_options, callback) {
            return callback({
                TmpSecretId: credentials.tmpSecretId,
                TmpSecretKey: credentials.tmpSecretKey,
                XCosSecurityToken: credentials.sessionToken,
                // 时间戳，单位秒，如：1580000000，建议返回服务器时间作为签名的开始时间，避免用户浏览器本地时间偏差过大导致签名错误
                StartTime: startTime,
                ExpiredTime: expiredTime
            });
        }
    });
}

const baseDebug = createDebug('files-stash');
const debug$2 = createDebug('service:files');
class FilesService {
    db;
    storage;
    $fetch;
    cosService;
    logger;
    constructor(db, storage, $fetch, cosService, logger){
        this.db = db;
        this.storage = storage;
        this.$fetch = $fetch;
        this.cosService = cosService;
        this.logger = logger;
    }
    async uploadTaskFiles(taskId, demoId, recordId, timeout, force, critical, category, signal) {
        const { $fetch, storage } = this;
        const credentialData = await $fetch('/api/cloud/cos', {
            query: {
                category
            }
        });
        const appId = credentialData.appId || await storage.getItem(APP_ID_KEY);
        if (!appId) {
            throw new Error('Invalid app id');
        }
        const logFileType = critical ? 'critical' : 'other';
        const fileTypes = critical ? CRITICAL_FILE_TYPES : undefined;
        this.logger.event(`waitForStashFinish ${logFileType} files`);
        await this.waitForStashFinish(taskId, timeout, fileTypes);
        this.logger.event(`start upload ${logFileType} files`);
        const files = await this.collectFilesWithData(taskId, fileTypes);
        const failedFiles = await this.cosService.uploadFiles(appId, category, credentialData, files, force, taskId, signal);
        if (failedFiles.length > 0) {
            this.$fetch('/api/action-log', {
                method: 'POST',
                body: {
                    actionType: ActionType.RECORD_UPLOAD_FILE_FAIL,
                    resourceType: 'Demo',
                    resourceId: demoId,
                    data: {
                        taskId,
                        failedFiles,
                        critical
                    }
                }
            });
            if (critical) {
                throw new Error(`failed to upload ${logFileType} files`);
            }
        }
        await this.submitFileList(appId, recordId, category, files, new Set(failedFiles.map((item)=>item.source)), critical);
        this.logger.event(`upload ${logFileType} files finish`);
    }
    waitForStashFinish(taskId, timeout, fileTypes) {
        const { db } = this;
        const debug = baseDebug.extend(String(taskId));
        const where = {
            taskId,
            status: FileStatus.Created
        };
        return firstValueFrom(race(interval(timeout * 1000).pipe(tap(()=>{
            debug('wait file finish timeout exceed %s seconds', timeout);
            db.files.where(where).modify({
                status: FileStatus.Failed
            });
        })), this.observeFileStashStatus(taskId, fileTypes).pipe(tap(({ total, stashed, failed })=>{
            if (debug.enabled) {
                debug('stashed status %s', JSON.stringify(fileTypes), {
                    total,
                    stashed,
                    failed
                });
            }
            if (total - stashed - failed < 5) {
                db.files.where(where).toArray().then((files)=>{
                    debug('unfinished tasks', files);
                });
            }
        }), filter(({ total, stashed, failed })=>stashed + failed >= total), tap(()=>{
            if (debug.enabled) {
                debug('all stashed file finished %s', JSON.stringify(fileTypes));
            }
        }))));
    }
    markAllFilesNotUpload(taskId) {
        return this.db.files.where({
            taskId
        }).modify({
            uploaded: 0
        });
    }
    async getTaskScreenshot(taskId) {
        const { db } = this;
        const debug = baseDebug.extend(String(taskId));
        const getFile = ()=>{
            return db.files.where({
                taskId,
                fileType: StashFileType.Screenshot,
                status: FileStatus.Finished
            }).first();
        };
        let screenshot = await getFile();
        if (!screenshot) {
            screenshot = await firstValueFrom(race([
                interval(30000).pipe(map$1(()=>{
                    debug('get screenshot timeout');
                    return undefined;
                })),
                fromLiveQuery(liveQuery(getFile)).pipe(filter(Boolean))
            ]));
        }
        if (!screenshot) {
            debug('no screenshot');
            return undefined;
        }
        const file = await db.files.get({
            taskId: screenshot.taskId,
            url: screenshot.url
        });
        if (!file?.blob) {
            debug('no screenshot content');
            return undefined;
        }
        return {
            ...screenshot,
            blob: file.blob
        };
    }
    async collectFilesWithData(taskId, fileTypes) {
        const { db } = this;
        const where = {
            taskId
        };
        const files = await db.files.where(where).and((file)=>{
            if (fileTypes && !fileTypes.includes(file.fileType)) {
                return false;
            }
            return file.fileType !== StashFileType.Screenshot && file.status !== FileStatus.Ignore;
        }).toArray();
        return await Promise.all(files.map(async (file)=>{
            let blob;
            let timestamp;
            if (file.blob) {
                blob = file.blob;
                timestamp = new Date(file.timestamp).getTime();
            } else {
                const chunks = await db.fileChunks.where({
                    taskId: file.taskId,
                    url: file.url
                }).toArray();
                if (!chunks.length) {
                    return file;
                }
                blob = new Blob(chunks.map((chunk)=>chunk.blob), {
                    type: file.contentType
                });
                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                const lastChunk = chunks.at(-1);
                timestamp = new Date(lastChunk.timestamp).getTime();
            }
            let hash = file.hash;
            if (!hash) {
                const buffer = await blob.arrayBuffer();
                hash = await sha1(buffer);
            }
            const Key = await getStashFilename(file.url, hash, file.contentType, file.fileType, timestamp);
            return {
                ...file,
                blob,
                Key,
                hash
            };
        }));
    }
    getFileStashStatus(taskId, fileTypes) {
        return firstValueFrom(this.observeFileStashStatus(taskId, fileTypes));
    }
    observeFileStashStatus(taskId, fileTypes) {
        const { db } = this;
        const debug = baseDebug.extend(String(taskId));
        if (debug.enabled) {
            debug('observeFileStashStatus %s', JSON.stringify(fileTypes));
        }
        return combineLatest({
            file: fromLiveQuery(liveQuery(()=>this.queryFileStashStatus(taskId, fileTypes))),
            task: fromLiveQuery(liveQuery(()=>db.tasks.get(taskId)))
        }).pipe(map$1(({ file, task })=>{
            let total = 0;
            let accomplished = 0;
            if (file) {
                total += file.failed + file.stashed * 2;
                accomplished = file.failed + file.stashed + file.uploaded;
            }
            const percent = Math.round(60 * (accomplished / total)) + (task?.serverId ? 40 : 0);
            if (debug.enabled) {
                debug('upload percent change demo-id: %s, file types: %s, total: %s, accomplished: %s', task?.serverId, JSON.stringify(fileTypes), total, accomplished);
            }
            return {
                ...file,
                taskId,
                taskStatus: task?.status,
                serverId: task?.serverId,
                percent,
                errorMessage: task?.errorMessage
            };
        }));
    }
    queryFileStashStatus(taskId, fileTypes) {
        const { db } = this;
        let collection = db.files.where({
            taskId
        });
        if (fileTypes?.length) {
            collection = collection.and((file)=>fileTypes.includes(file.fileType));
        }
        return collection.toArray().then((files)=>{
            let stashed = 0;
            let uploaded = 0;
            let failed = 0;
            let stream = 0;
            let total = files.length;
            files.forEach((file)=>{
                if (file.uploaded === DEXIE_TRUE) {
                    uploaded += 1;
                }
                switch(file.status){
                    case FileStatus.Stream:
                        stream += 1;
                        stashed += 1;
                        break;
                    case FileStatus.Finished:
                        stashed += 1;
                        break;
                    case FileStatus.Failed:
                        failed += 1;
                        break;
                    case FileStatus.Ignore:
                        total -= 1;
                        break;
                }
            });
            return {
                total,
                stashed,
                uploaded,
                failed,
                stream
            };
        });
    }
    async submitFileList(appId, recordId, category, filesWithData, failedFiles, critical) {
        const { $fetch } = this;
        const res = await $fetch(`/api/record/${recordId}/files`, {
            method: 'post',
            body: {
                critical,
                files: filesWithData.filter((file)=>{
                    if (!file.url.startsWith('demoway:')) {
                        return true;
                    }
                    return file.hash;
                }).map((file)=>{
                    if (failedFiles.has(file.url)) {
                        return {
                            url: file.url,
                            hash: '',
                            fileType: file.fileType,
                            contentType: file.contentType,
                            patch: false,
                            cdnPath: '',
                            extra: file.extra
                        };
                    }
                    return {
                        url: file.url,
                        hash: file.hash || '',
                        fileType: file.fileType,
                        contentType: file.contentType || '',
                        patch: !!file.patch,
                        cdnPath: file.Key ? join$1(category, appId, file.Key) : '',
                        extra: file.extra
                    };
                })
            }
        });
        if (!res) {
            throw new Error('update file list failed');
        }
    }
    touchStashFile(args) {
        const { url, fileType, contentType, timestamp, taskId, extra } = args;
        const task = this.db.tasks.get(taskId);
        if (!task) {
            return Promise.reject(false);
        }
        const status = fileType === StashFileType.Capture ? FileStatus.Stream : FileStatus.Created;
        return this.db.files.add({
            url,
            fileType: fileType,
            uploaded: DEXIE_FALSE,
            taskId,
            patch: DEXIE_FALSE,
            contentType: contentType || undefined,
            timestamp,
            status,
            extra: extra ?? undefined
        }).then(()=>{
            debug$2('add new file %s', url);
            return true;
        }, ()=>{
            debug$2('already exist, skip, %s', url);
            return false;
        });
    }
    markFileStashed({ taskId, url, hash, contentType, patch, status = FileStatus.Finished }) {
        return this.db.files.where({
            taskId,
            url
        }).modify({
            hash,
            contentType,
            patch: Number(patch),
            status
        });
    }
}
FilesService = __decorate([
    singleton(),
    __param(1, inject(STORAGE)),
    __param(2, inject(FETCH)),
    __param(4, inject(LOGGER)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [
        typeof RecorderDB === "undefined" ? Object : RecorderDB,
        typeof Storage === "undefined" ? Object : Storage,
        typeof $Fetch === "undefined" ? Object : $Fetch,
        typeof CosService === "undefined" ? Object : CosService,
        typeof ILoggerService === "undefined" ? Object : ILoggerService
    ])
], FilesService);

const taskDetail = async (_parent, { taskId }, ctx)=>{
    const { db, container } = ctx;
    const task = await db.tasks.get(taskId);
    if (!task) {
        return '';
    }
    const recordSize = await db.frames.where({
        taskId
    }).count();
    const values = [
        {
            type: 'task',
            name: task.name,
            url: task.url,
            uploaded: !!task.serverId,
            stashed: true,
            size: recordSize
        }
    ];
    const filesService = container.resolve(FilesService);
    const files = await filesService.collectFilesWithData(taskId, undefined);
    values.push(...files.map((file)=>({
            type: 'file',
            name: file.url,
            url: file.url,
            uploaded: !!file.uploaded,
            stashed: file.status === FileStatus.Finished,
            size: file.blob?.size ?? 0
        })));
    return Papa.unparse(values);
};

const taskList$1 = async (_parent, _arg, ctx)=>{
    return await firstValueFrom(ctx.taskList$);
};

const taskUploadStatus = async (_parent, { taskId }, { container })=>{
    const filesService = container.resolve(FILE_STASH_SERVICE);
    return filesService.getFileStashStatus(taskId, undefined);
};

const version = async (_parent, _arg, _ctx)=>{
    return 3;
};

const RecorderState = {
};

const StashFileProxyResult = {
};

class Deferred {
    constructor() {
        this.resolve = null;
        this.reject = null;
        this.promise = new Promise((a, b) => {
            this.resolve = a;
            this.reject = b;
        });
    }
}

const RESOLVED = Promise.resolve();
/**
 * Will subscribe to the provided `source` observable,
 * allowing `for await..of` loops to iterate and get the
 * most recent value that was emitted. Will not iterate out
 * the same emission twice.
 *
 * This is a lossy subscription method. Do not use if
 * every value is important.
 *
 * Example usage:
 *
 * ```ts
 * async function test() {
 *   const source$ = getSomeObservable();
 *
 *   for await(const value of latestValueFrom(source$)) {
 *     console.log(value);
 *   }
 * }
 * ```
 *
 * @param source the Observable source to await values from
 */
async function* latestValueFrom(source) {
    let deferred = undefined;
    let latestValue;
    let hasLatestValue = false;
    let hasError = false;
    let error = null;
    let completed = false;
    const subs = source.subscribe({
        next: (value) => {
            hasLatestValue = true;
            latestValue = value;
            if (deferred) {
                deferred.resolve(RESOLVED.then(() => {
                    hasLatestValue = false;
                    return { value: latestValue, done: false };
                }));
            }
        },
        error: (err) => {
            hasError = true;
            error = err;
            if (deferred) {
                deferred.reject(err);
            }
        },
        complete: () => {
            completed = true;
            if (deferred) {
                hasLatestValue = false;
                deferred.resolve({ value: undefined, done: true });
            }
        },
    });
    try {
        while (true) {
            if (hasLatestValue) {
                await RESOLVED;
                const value = latestValue;
                hasLatestValue = false;
                yield value;
            }
            else if (completed) {
                return;
            }
            else if (hasError) {
                throw error;
            }
            else {
                deferred = new Deferred();
                const result = await deferred.promise;
                if (result.done) {
                    return;
                }
                else {
                    yield result.value;
                }
            }
        }
    }
    catch (err) {
        throw err;
    }
    finally {
        subs.unsubscribe();
    }
}
/**
 * Subscribes to the provided `source` observable and allows
 * `for await..of` loops to iterate over it, such that
 * all values are dropped until the iteration occurs, then
 * the very next value that arrives is provided to the
 * `for await` loop.
 *
 * This is a lossy subscription method. Do not use if
 * every value is important.
 *
 * Example usage:
 *
 * ```ts
 * async function test() {
 *   const source$ = getSomeObservable();
 *
 *   for await(const value of nextValueFrom(source$)) {
 *     console.log(value);
 *   }
 * }
 * ```
 *
 * @param source the Observable source to await values from
 */
async function* nextValueFrom(source) {
    let deferred = undefined;
    let hasError = false;
    let error = null;
    let completed = false;
    const subs = source.subscribe({
        next: (value) => {
            if (deferred) {
                deferred.resolve({ value, done: false });
            }
        },
        error: (err) => {
            hasError = true;
            error = err;
            if (deferred) {
                deferred.reject(err);
            }
        },
        complete: () => {
            completed = true;
            if (deferred) {
                deferred.resolve({ value: undefined, done: true });
            }
        },
    });
    try {
        while (true) {
            if (completed) {
                return;
            }
            else if (hasError) {
                throw error;
            }
            else {
                deferred = new Deferred();
                const result = await deferred.promise;
                if (result.done) {
                    return;
                }
                else {
                    yield result.value;
                }
            }
        }
    }
    catch (err) {
        throw err;
    }
    finally {
        subs.unsubscribe();
    }
}

const activeTab = {
    subscribe: async function*(_parent, _arg, ctx) {
        for await (const value of latestValueFrom(ctx.activeTab$)){
            yield {
                activeTab: value
            };
        }
    }
};

const appId = {
    subscribe: async function*(_parent, _arg, ctx) {
        const value$ = storageObservable(ctx.storage, APP_ID_KEY);
        for await (const value of latestValueFrom(value$)){
            yield {
                appId: value
            };
        }
    }
};

const env = {
    subscribe: async function*(_parent, _arg, ctx) {
        const value$ = storageObservable(ctx.storage, ENV_KEY);
        for await (const value of latestValueFrom(value$)){
            yield {
                env: value || 'production'
            };
        }
    }
};

const figmaPluginOpened = {
    subscribe: async function*(_parent, _arg, ctx) {
        const value$ = storageObservable(ctx.storage, FIGMA_PLUGIN_OPENED_KEY);
        for await (const value of latestValueFrom(value$)){
            yield {
                figmaPluginOpened: value || false
            };
        }
    }
};

const locale = {
    subscribe: async function*(_parent, _arg, ctx) {
        const value$ = storageObservable(ctx.storage, LOCALE_KEY);
        for await (const value of latestValueFrom(value$)){
            yield {
                locale: value || DEFAULT_LOCALE
            };
        }
    }
};

const recorderState = {
    subscribe: async function*(_parent, _arg, { recorderState$ }) {
        for await (const state of latestValueFrom(recorderState$)){
            yield {
                recorderState: state
            };
        }
    }
};

var UploadStatus;
(function(UploadStatus) {
    UploadStatus["Pending"] = "pending";
    UploadStatus["Processing"] = "processing";
    UploadStatus["Completed"] = "completed";
    UploadStatus["Failed"] = "failed";
})(UploadStatus || (UploadStatus = {}));
const adaptLegacyStatus = (status)=>{
    switch(status){
        case "completed":
            return RecordingStatus.Completed;
        case "failed":
            return RecordingStatus.Failed;
        case "pending":
        case "processing":
            return RecordingStatus.Uploading;
        default:
            if (status in RecordingStatus) {
                return status;
            }
            return RecordingStatus.Completed;
    }
};
const taskList = {
    subscribe: async function*(_parent, _arg, { taskList$ }) {
        for await (const list of nextValueFrom(taskList$)){
            yield {
                taskList: list.map((item)=>({
                        ...item,
                        status: adaptLegacyStatus(item.status)
                    }))
            };
        }
    }
};

const taskUploadStatusChange = {
    subscribe: async function*(_parent, { taskId }, { taskStatusChange$ }) {
        const values = latestValueFrom(taskStatusChange$.pipe(filter((status)=>status.taskId === taskId)));
        for await (const value of values){
            yield {
                taskUploadStatusChange: value
            };
        }
    }
};

const tipLore = {
    subscribe: async function*(_parent, _arg, ctx) {
        const tipLore$ = storageObservable(ctx.storage, TIP_LORE_KEY);
        for await (const value of latestValueFrom(tipLore$)){
            yield {
                tipLore: value || {
                    title: '',
                    url: '',
                    description: ''
                }
            };
        }
    }
};

const TaskUploadStatus = {
};

const TipLore = {
};

const UserProfile = new GraphQLScalarType({
    name: 'UserProfile',
    description: 'UserProfile description'
});

function createGraphQLError(message, options) {
    if (versionInfo.major >= 17) {
        return new GraphQLError(message, options);
    }
    return new GraphQLError(message, options === null || options === void 0 ? void 0 : options.nodes, options === null || options === void 0 ? void 0 : options.source, options === null || options === void 0 ? void 0 : options.positions, options === null || options === void 0 ? void 0 : options.path, options === null || options === void 0 ? void 0 : options.originalError, options === null || options === void 0 ? void 0 : options.extensions);
}

// eslint-disable-next-line @typescript-eslint/ban-types
function ensureObject(value, ast) {
    if (typeof value !== 'object' || value === null || Array.isArray(value)) {
        throw createGraphQLError(`JSONObject cannot represent non-object value: ${value}`, ast
            ? {
                nodes: ast,
            }
            : undefined);
    }
    return value;
}
function parseObject(ast, variables) {
    if (ast.kind !== Kind.OBJECT) {
        throw createGraphQLError(`JSONObject cannot represent non-object value: ${print(ast)}`, ast
            ? {
                nodes: ast,
            }
            : undefined);
    }
    const value = Object.create(null);
    ast.fields.forEach(field => {
        // eslint-disable-next-line no-use-before-define
        value[field.name.value] = parseLiteral(field.value, variables);
    });
    return value;
}
function parseLiteral(ast, variables) {
    switch (ast.kind) {
        case Kind.STRING:
        case Kind.BOOLEAN:
            return ast.value;
        case Kind.INT:
        case Kind.FLOAT:
            return parseFloat(ast.value);
        case Kind.OBJECT:
            return parseObject(ast, variables);
        case Kind.LIST:
            return ast.values.map(n => parseLiteral(n, variables));
        case Kind.NULL:
            return null;
        case Kind.VARIABLE: {
            const name = ast.name.value;
            return variables ? variables[name] : undefined;
        }
    }
}

/* eslint-disable @typescript-eslint/ban-types */
const specifiedByURL = 'http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-404.pdf';
const GraphQLJSONObjectConfig =  {
    name: 'JSONObject',
    description: 'The `JSONObject` scalar type represents JSON objects as specified by [ECMA-404](http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-404.pdf).',
    serialize: ensureObject,
    parseValue: ensureObject,
    parseLiteral: parseObject,
    specifiedByURL,
    specifiedByUrl: specifiedByURL,
    extensions: {
        codegenScalarType: 'Record<string, any>',
        jsonSchema: {
            type: 'object',
            additionalProperties: true,
        },
    },
};
const GraphQLJSONObject = /*#__PURE__*/ new GraphQLScalarType(GraphQLJSONObjectConfig);

const resolvers = {
    Query: {
        analyzeFileDependency: analyzeFileDependency,
        oauthCode: oauthCode,
        profile: profile,
        taskDetail: taskDetail,
        taskList: taskList$1,
        taskUploadStatus: taskUploadStatus,
        version: version
    },
    Mutation: {
        emitFrame: emitFrame,
        fetchFileProxy: fetchFileProxy,
        login: login,
        logout: logout,
        recordDisable: recordDisable,
        recordEnable: recordEnable,
        recordPause: recordPause,
        recordResume: recordResume,
        recordStart: recordStart,
        recordStop: recordStop,
        selectElementAction: selectElementAction,
        selectElementFinish: selectElementFinish,
        setAppId: setAppId,
        setEnv: setEnv,
        setFigmaPluginOpened: setFigmaPluginOpened,
        setLocale: setLocale,
        stashFileChunk: stashFileChunk,
        stashFileComplete: stashFileComplete,
        stashFileContent: stashFileContent,
        stashVideoScreenshot: stashVideoScreenshot,
        taskCancel: taskCancel,
        taskClearComplete: taskClearComplete,
        taskCreate: taskCreate,
        taskRemove: taskRemove,
        touchStashFile: touchStashFile,
        uploadTask: uploadTask
    },
    Subscription: {
        activeTab: activeTab,
        appId: appId,
        env: env,
        figmaPluginOpened: figmaPluginOpened,
        locale: locale,
        recorderState: recorderState,
        taskList: taskList,
        taskUploadStatusChange: taskUploadStatusChange,
        tipLore: tipLore
    },
    Authorization: Authorization,
    Buffer: Buffer$1,
    FileDependency: FileDependency,
    FileDependencyResult: FileDependencyResult,
    Frame: Frame,
    LocalTask: LocalTask,
    RecorderState: RecorderState,
    StashFileProxyResult: StashFileProxyResult,
    TaskUploadStatus: TaskUploadStatus,
    TipLore: TipLore,
    UserProfile: UserProfile,
    JSONObject: GraphQLJSONObject
};

const typeDefs = {
    kind: 'Document',
    definitions: [
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Buffer',
                loc: {
                    start: 7,
                    end: 13
                }
            },
            directives: [],
            loc: {
                start: 0,
                end: 13
            }
        },
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Frame',
                loc: {
                    start: 22,
                    end: 27
                }
            },
            directives: [],
            loc: {
                start: 15,
                end: 27
            }
        },
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Authorization',
                loc: {
                    start: 36,
                    end: 49
                }
            },
            directives: [],
            loc: {
                start: 29,
                end: 49
            }
        },
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'UserProfile',
                loc: {
                    start: 58,
                    end: 69
                }
            },
            directives: [],
            loc: {
                start: 51,
                end: 69
            }
        },
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'JSONObject',
                loc: {
                    start: 78,
                    end: 88
                }
            },
            directives: [],
            loc: {
                start: 71,
                end: 88
            }
        },
        {
            kind: 'ScalarTypeDefinition',
            name: {
                kind: 'Name',
                value: 'FileDependency',
                loc: {
                    start: 97,
                    end: 111
                }
            },
            directives: [],
            loc: {
                start: 90,
                end: 111
            }
        },
        {
            kind: 'EnumTypeDefinition',
            name: {
                kind: 'Name',
                value: 'RecordingStatus',
                loc: {
                    start: 118,
                    end: 133
                }
            },
            directives: [],
            values: [
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Pending',
                        loc: {
                            start: 138,
                            end: 145
                        }
                    },
                    directives: [],
                    loc: {
                        start: 138,
                        end: 145
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Running',
                        loc: {
                            start: 148,
                            end: 155
                        }
                    },
                    directives: [],
                    loc: {
                        start: 148,
                        end: 155
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Paused',
                        loc: {
                            start: 158,
                            end: 164
                        }
                    },
                    directives: [],
                    loc: {
                        start: 158,
                        end: 164
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Stopped',
                        loc: {
                            start: 167,
                            end: 174
                        }
                    },
                    directives: [],
                    loc: {
                        start: 167,
                        end: 174
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Uploading',
                        loc: {
                            start: 177,
                            end: 186
                        }
                    },
                    directives: [],
                    loc: {
                        start: 177,
                        end: 186
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'UploadingExtra',
                        loc: {
                            start: 189,
                            end: 203
                        }
                    },
                    directives: [],
                    loc: {
                        start: 189,
                        end: 203
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Completed',
                        loc: {
                            start: 206,
                            end: 215
                        }
                    },
                    directives: [],
                    loc: {
                        start: 206,
                        end: 215
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Failed',
                        loc: {
                            start: 218,
                            end: 224
                        }
                    },
                    directives: [],
                    loc: {
                        start: 218,
                        end: 224
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'CompletedWithWarning',
                        loc: {
                            start: 227,
                            end: 247
                        }
                    },
                    directives: [],
                    loc: {
                        start: 227,
                        end: 247
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Cancelled',
                        loc: {
                            start: 250,
                            end: 259
                        }
                    },
                    directives: [],
                    loc: {
                        start: 250,
                        end: 259
                    }
                }
            ],
            loc: {
                start: 113,
                end: 261
            }
        },
        {
            kind: 'EnumTypeDefinition',
            name: {
                kind: 'Name',
                value: 'FileStatus',
                loc: {
                    start: 268,
                    end: 278
                }
            },
            directives: [],
            values: [
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Created',
                        loc: {
                            start: 283,
                            end: 290
                        }
                    },
                    directives: [],
                    loc: {
                        start: 283,
                        end: 290
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    description: {
                        kind: 'StringValue',
                        value: '流式文件本身没有结束状态，比如录制 canvas 的视频流',
                        block: true,
                        loc: {
                            start: 293,
                            end: 336
                        }
                    },
                    name: {
                        kind: 'Name',
                        value: 'Stream',
                        loc: {
                            start: 339,
                            end: 345
                        }
                    },
                    directives: [],
                    loc: {
                        start: 293,
                        end: 345
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Finished',
                        loc: {
                            start: 348,
                            end: 356
                        }
                    },
                    directives: [],
                    loc: {
                        start: 348,
                        end: 356
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Failed',
                        loc: {
                            start: 359,
                            end: 365
                        }
                    },
                    directives: [],
                    loc: {
                        start: 359,
                        end: 365
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Ignore',
                        loc: {
                            start: 368,
                            end: 374
                        }
                    },
                    directives: [],
                    loc: {
                        start: 368,
                        end: 374
                    }
                }
            ],
            loc: {
                start: 263,
                end: 376
            }
        },
        {
            kind: 'EnumTypeDefinition',
            name: {
                kind: 'Name',
                value: 'TaskType',
                loc: {
                    start: 383,
                    end: 391
                }
            },
            directives: [],
            values: [
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Tour',
                        loc: {
                            start: 396,
                            end: 400
                        }
                    },
                    directives: [],
                    loc: {
                        start: 396,
                        end: 400
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Snapshot',
                        loc: {
                            start: 403,
                            end: 411
                        }
                    },
                    directives: [],
                    loc: {
                        start: 403,
                        end: 411
                    }
                }
            ],
            loc: {
                start: 378,
                end: 413
            }
        },
        {
            kind: 'EnumTypeDefinition',
            name: {
                kind: 'Name',
                value: 'TaskVariance',
                loc: {
                    start: 420,
                    end: 432
                }
            },
            directives: [],
            values: [
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Full',
                        loc: {
                            start: 437,
                            end: 441
                        }
                    },
                    directives: [],
                    loc: {
                        start: 437,
                        end: 441
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'SelectElement',
                        loc: {
                            start: 444,
                            end: 457
                        }
                    },
                    directives: [],
                    loc: {
                        start: 444,
                        end: 457
                    }
                }
            ],
            loc: {
                start: 415,
                end: 459
            }
        },
        {
            kind: 'EnumTypeDefinition',
            name: {
                kind: 'Name',
                value: 'SelectElementActionType',
                loc: {
                    start: 466,
                    end: 489
                }
            },
            directives: [],
            values: [
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'ZoomIn',
                        loc: {
                            start: 494,
                            end: 500
                        }
                    },
                    directives: [],
                    loc: {
                        start: 494,
                        end: 500
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'ZoomOut',
                        loc: {
                            start: 503,
                            end: 510
                        }
                    },
                    directives: [],
                    loc: {
                        start: 503,
                        end: 510
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Stop',
                        loc: {
                            start: 513,
                            end: 517
                        }
                    },
                    directives: [],
                    loc: {
                        start: 513,
                        end: 517
                    }
                },
                {
                    kind: 'EnumValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'Submit',
                        loc: {
                            start: 520,
                            end: 526
                        }
                    },
                    directives: [],
                    loc: {
                        start: 520,
                        end: 526
                    }
                }
            ],
            loc: {
                start: 461,
                end: 528
            }
        },
        {
            kind: 'InputObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Rect',
                loc: {
                    start: 536,
                    end: 540
                }
            },
            directives: [],
            fields: [
                {
                    kind: 'InputValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'x',
                        loc: {
                            start: 545,
                            end: 546
                        }
                    },
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Float',
                                loc: {
                                    start: 548,
                                    end: 553
                                }
                            },
                            loc: {
                                start: 548,
                                end: 553
                            }
                        },
                        loc: {
                            start: 548,
                            end: 554
                        }
                    },
                    directives: [],
                    loc: {
                        start: 545,
                        end: 554
                    }
                },
                {
                    kind: 'InputValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'y',
                        loc: {
                            start: 557,
                            end: 558
                        }
                    },
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Float',
                                loc: {
                                    start: 560,
                                    end: 565
                                }
                            },
                            loc: {
                                start: 560,
                                end: 565
                            }
                        },
                        loc: {
                            start: 560,
                            end: 566
                        }
                    },
                    directives: [],
                    loc: {
                        start: 557,
                        end: 566
                    }
                },
                {
                    kind: 'InputValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'width',
                        loc: {
                            start: 569,
                            end: 574
                        }
                    },
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Float',
                                loc: {
                                    start: 576,
                                    end: 581
                                }
                            },
                            loc: {
                                start: 576,
                                end: 581
                            }
                        },
                        loc: {
                            start: 576,
                            end: 582
                        }
                    },
                    directives: [],
                    loc: {
                        start: 569,
                        end: 582
                    }
                },
                {
                    kind: 'InputValueDefinition',
                    name: {
                        kind: 'Name',
                        value: 'height',
                        loc: {
                            start: 585,
                            end: 591
                        }
                    },
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Float',
                                loc: {
                                    start: 593,
                                    end: 598
                                }
                            },
                            loc: {
                                start: 593,
                                end: 598
                            }
                        },
                        loc: {
                            start: 593,
                            end: 599
                        }
                    },
                    directives: [],
                    loc: {
                        start: 585,
                        end: 599
                    }
                }
            ],
            loc: {
                start: 530,
                end: 601
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'RecorderState',
                loc: {
                    start: 608,
                    end: 621
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'enabled',
                        loc: {
                            start: 626,
                            end: 633
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 635,
                                    end: 642
                                }
                            },
                            loc: {
                                start: 635,
                                end: 642
                            }
                        },
                        loc: {
                            start: 635,
                            end: 643
                        }
                    },
                    directives: [],
                    loc: {
                        start: 626,
                        end: 643
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'status',
                        loc: {
                            start: 646,
                            end: 652
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'RecordingStatus',
                                loc: {
                                    start: 654,
                                    end: 669
                                }
                            },
                            loc: {
                                start: 654,
                                end: 669
                            }
                        },
                        loc: {
                            start: 654,
                            end: 670
                        }
                    },
                    directives: [],
                    loc: {
                        start: 646,
                        end: 670
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskId',
                        loc: {
                            start: 673,
                            end: 679
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Int',
                            loc: {
                                start: 681,
                                end: 684
                            }
                        },
                        loc: {
                            start: 681,
                            end: 684
                        }
                    },
                    directives: [],
                    loc: {
                        start: 673,
                        end: 684
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskType',
                        loc: {
                            start: 687,
                            end: 695
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'TaskType',
                            loc: {
                                start: 697,
                                end: 705
                            }
                        },
                        loc: {
                            start: 697,
                            end: 705
                        }
                    },
                    directives: [],
                    loc: {
                        start: 687,
                        end: 705
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'snapshotTabId',
                        loc: {
                            start: 708,
                            end: 721
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 723,
                                end: 729
                            }
                        },
                        loc: {
                            start: 723,
                            end: 729
                        }
                    },
                    directives: [],
                    loc: {
                        start: 708,
                        end: 729
                    }
                }
            ],
            loc: {
                start: 603,
                end: 731
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'LocalTask',
                loc: {
                    start: 738,
                    end: 747
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'id',
                        loc: {
                            start: 752,
                            end: 754
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Int',
                            loc: {
                                start: 756,
                                end: 759
                            }
                        },
                        loc: {
                            start: 756,
                            end: 759
                        }
                    },
                    directives: [],
                    loc: {
                        start: 752,
                        end: 759
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'name',
                        loc: {
                            start: 762,
                            end: 766
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 768,
                                    end: 774
                                }
                            },
                            loc: {
                                start: 768,
                                end: 774
                            }
                        },
                        loc: {
                            start: 768,
                            end: 775
                        }
                    },
                    directives: [],
                    loc: {
                        start: 762,
                        end: 775
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'url',
                        loc: {
                            start: 778,
                            end: 781
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 783,
                                    end: 789
                                }
                            },
                            loc: {
                                start: 783,
                                end: 789
                            }
                        },
                        loc: {
                            start: 783,
                            end: 790
                        }
                    },
                    directives: [],
                    loc: {
                        start: 778,
                        end: 790
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'status',
                        loc: {
                            start: 793,
                            end: 799
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'RecordingStatus',
                                loc: {
                                    start: 801,
                                    end: 816
                                }
                            },
                            loc: {
                                start: 801,
                                end: 816
                            }
                        },
                        loc: {
                            start: 801,
                            end: 817
                        }
                    },
                    directives: [],
                    loc: {
                        start: 793,
                        end: 817
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'serverId',
                        loc: {
                            start: 820,
                            end: 828
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 830,
                                end: 836
                            }
                        },
                        loc: {
                            start: 830,
                            end: 836
                        }
                    },
                    directives: [],
                    loc: {
                        start: 820,
                        end: 836
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordId',
                        loc: {
                            start: 839,
                            end: 847
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 849,
                                end: 855
                            }
                        },
                        loc: {
                            start: 849,
                            end: 855
                        }
                    },
                    directives: [],
                    loc: {
                        start: 839,
                        end: 855
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskType',
                        loc: {
                            start: 858,
                            end: 866
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'TaskType',
                            loc: {
                                start: 868,
                                end: 876
                            }
                        },
                        loc: {
                            start: 868,
                            end: 876
                        }
                    },
                    directives: [],
                    loc: {
                        start: 858,
                        end: 876
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskVariance',
                        loc: {
                            start: 879,
                            end: 891
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'TaskVariance',
                            loc: {
                                start: 893,
                                end: 905
                            }
                        },
                        loc: {
                            start: 893,
                            end: 905
                        }
                    },
                    directives: [],
                    loc: {
                        start: 879,
                        end: 905
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordUploaded',
                        loc: {
                            start: 908,
                            end: 922
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 924,
                                end: 931
                            }
                        },
                        loc: {
                            start: 924,
                            end: 931
                        }
                    },
                    directives: [],
                    loc: {
                        start: 908,
                        end: 931
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'errorMessage',
                        loc: {
                            start: 934,
                            end: 946
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 948,
                                end: 954
                            }
                        },
                        loc: {
                            start: 948,
                            end: 954
                        }
                    },
                    directives: [],
                    loc: {
                        start: 934,
                        end: 954
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'errorStack',
                        loc: {
                            start: 957,
                            end: 967
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 969,
                                end: 975
                            }
                        },
                        loc: {
                            start: 969,
                            end: 975
                        }
                    },
                    directives: [],
                    loc: {
                        start: 957,
                        end: 975
                    }
                }
            ],
            loc: {
                start: 733,
                end: 977
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'TaskUploadStatus',
                loc: {
                    start: 984,
                    end: 1000
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskId',
                        loc: {
                            start: 1005,
                            end: 1011
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1013,
                                    end: 1016
                                }
                            },
                            loc: {
                                start: 1013,
                                end: 1016
                            }
                        },
                        loc: {
                            start: 1013,
                            end: 1017
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1005,
                        end: 1017
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'total',
                        loc: {
                            start: 1020,
                            end: 1025
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1027,
                                    end: 1030
                                }
                            },
                            loc: {
                                start: 1027,
                                end: 1030
                            }
                        },
                        loc: {
                            start: 1027,
                            end: 1031
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1020,
                        end: 1031
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stashed',
                        loc: {
                            start: 1034,
                            end: 1041
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1043,
                                    end: 1046
                                }
                            },
                            loc: {
                                start: 1043,
                                end: 1046
                            }
                        },
                        loc: {
                            start: 1043,
                            end: 1047
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1034,
                        end: 1047
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'uploaded',
                        loc: {
                            start: 1050,
                            end: 1058
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1060,
                                    end: 1063
                                }
                            },
                            loc: {
                                start: 1060,
                                end: 1063
                            }
                        },
                        loc: {
                            start: 1060,
                            end: 1064
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1050,
                        end: 1064
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'failed',
                        loc: {
                            start: 1067,
                            end: 1073
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1075,
                                    end: 1078
                                }
                            },
                            loc: {
                                start: 1075,
                                end: 1078
                            }
                        },
                        loc: {
                            start: 1075,
                            end: 1079
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1067,
                        end: 1079
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stream',
                        loc: {
                            start: 1082,
                            end: 1088
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1090,
                                    end: 1093
                                }
                            },
                            loc: {
                                start: 1090,
                                end: 1093
                            }
                        },
                        loc: {
                            start: 1090,
                            end: 1094
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1082,
                        end: 1094
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'serverId',
                        loc: {
                            start: 1097,
                            end: 1105
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 1107,
                                end: 1113
                            }
                        },
                        loc: {
                            start: 1107,
                            end: 1113
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1097,
                        end: 1113
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskStatus',
                        loc: {
                            start: 1116,
                            end: 1126
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'RecordingStatus',
                            loc: {
                                start: 1128,
                                end: 1143
                            }
                        },
                        loc: {
                            start: 1128,
                            end: 1143
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1116,
                        end: 1143
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'percent',
                        loc: {
                            start: 1146,
                            end: 1153
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1155,
                                    end: 1158
                                }
                            },
                            loc: {
                                start: 1155,
                                end: 1158
                            }
                        },
                        loc: {
                            start: 1155,
                            end: 1159
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1146,
                        end: 1159
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'errorMessage',
                        loc: {
                            start: 1162,
                            end: 1174
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 1176,
                                end: 1182
                            }
                        },
                        loc: {
                            start: 1176,
                            end: 1182
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1162,
                        end: 1182
                    }
                }
            ],
            loc: {
                start: 979,
                end: 1184
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'StashFileProxyResult',
                loc: {
                    start: 1191,
                    end: 1211
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'contentType',
                        loc: {
                            start: 1216,
                            end: 1227
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 1229,
                                    end: 1235
                                }
                            },
                            loc: {
                                start: 1229,
                                end: 1235
                            }
                        },
                        loc: {
                            start: 1229,
                            end: 1236
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1216,
                        end: 1236
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'content',
                        loc: {
                            start: 1239,
                            end: 1246
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 1248,
                                    end: 1254
                                }
                            },
                            loc: {
                                start: 1248,
                                end: 1254
                            }
                        },
                        loc: {
                            start: 1248,
                            end: 1255
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1239,
                        end: 1255
                    }
                }
            ],
            loc: {
                start: 1186,
                end: 1257
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'FileDependencyResult',
                loc: {
                    start: 1264,
                    end: 1284
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'skip',
                        loc: {
                            start: 1289,
                            end: 1293
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 1295,
                                end: 1302
                            }
                        },
                        loc: {
                            start: 1295,
                            end: 1302
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1289,
                        end: 1302
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'files',
                        loc: {
                            start: 1305,
                            end: 1310
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'ListType',
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'FileDependency',
                                        loc: {
                                            start: 1313,
                                            end: 1327
                                        }
                                    },
                                    loc: {
                                        start: 1313,
                                        end: 1327
                                    }
                                },
                                loc: {
                                    start: 1313,
                                    end: 1328
                                }
                            },
                            loc: {
                                start: 1312,
                                end: 1329
                            }
                        },
                        loc: {
                            start: 1312,
                            end: 1330
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1305,
                        end: 1330
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'code',
                        loc: {
                            start: 1333,
                            end: 1337
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 1339,
                                    end: 1345
                                }
                            },
                            loc: {
                                start: 1339,
                                end: 1345
                            }
                        },
                        loc: {
                            start: 1339,
                            end: 1346
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1333,
                        end: 1346
                    }
                }
            ],
            loc: {
                start: 1259,
                end: 1348
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Query',
                loc: {
                    start: 1355,
                    end: 1360
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'version',
                        loc: {
                            start: 1365,
                            end: 1372
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 1374,
                                    end: 1377
                                }
                            },
                            loc: {
                                start: 1374,
                                end: 1377
                            }
                        },
                        loc: {
                            start: 1374,
                            end: 1378
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1365,
                        end: 1378
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskDetail',
                        loc: {
                            start: 1381,
                            end: 1391
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 1392,
                                    end: 1398
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 1400,
                                            end: 1403
                                        }
                                    },
                                    loc: {
                                        start: 1400,
                                        end: 1403
                                    }
                                },
                                loc: {
                                    start: 1400,
                                    end: 1404
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1392,
                                end: 1404
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 1407,
                                    end: 1413
                                }
                            },
                            loc: {
                                start: 1407,
                                end: 1413
                            }
                        },
                        loc: {
                            start: 1407,
                            end: 1414
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1381,
                        end: 1414
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'profile',
                        loc: {
                            start: 1417,
                            end: 1424
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'UserProfile',
                            loc: {
                                start: 1426,
                                end: 1437
                            }
                        },
                        loc: {
                            start: 1426,
                            end: 1437
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1417,
                        end: 1437
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskList',
                        loc: {
                            start: 1440,
                            end: 1448
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'ListType',
                        type: {
                            kind: 'NonNullType',
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'LocalTask',
                                    loc: {
                                        start: 1451,
                                        end: 1460
                                    }
                                },
                                loc: {
                                    start: 1451,
                                    end: 1460
                                }
                            },
                            loc: {
                                start: 1451,
                                end: 1461
                            }
                        },
                        loc: {
                            start: 1450,
                            end: 1462
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1440,
                        end: 1462
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskUploadStatus',
                        loc: {
                            start: 1465,
                            end: 1481
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 1482,
                                    end: 1488
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 1490,
                                            end: 1493
                                        }
                                    },
                                    loc: {
                                        start: 1490,
                                        end: 1493
                                    }
                                },
                                loc: {
                                    start: 1490,
                                    end: 1494
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1482,
                                end: 1494
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'TaskUploadStatus',
                                loc: {
                                    start: 1497,
                                    end: 1513
                                }
                            },
                            loc: {
                                start: 1497,
                                end: 1513
                            }
                        },
                        loc: {
                            start: 1497,
                            end: 1514
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1465,
                        end: 1514
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'analyzeFileDependency',
                        loc: {
                            start: 1517,
                            end: 1538
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 1539,
                                    end: 1545
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 1547,
                                            end: 1550
                                        }
                                    },
                                    loc: {
                                        start: 1547,
                                        end: 1550
                                    }
                                },
                                loc: {
                                    start: 1547,
                                    end: 1551
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1539,
                                end: 1551
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'code',
                                loc: {
                                    start: 1553,
                                    end: 1557
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1559,
                                            end: 1565
                                        }
                                    },
                                    loc: {
                                        start: 1559,
                                        end: 1565
                                    }
                                },
                                loc: {
                                    start: 1559,
                                    end: 1566
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1553,
                                end: 1566
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'fileType',
                                loc: {
                                    start: 1568,
                                    end: 1576
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1578,
                                            end: 1584
                                        }
                                    },
                                    loc: {
                                        start: 1578,
                                        end: 1584
                                    }
                                },
                                loc: {
                                    start: 1578,
                                    end: 1585
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1568,
                                end: 1585
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'baseURI',
                                loc: {
                                    start: 1587,
                                    end: 1594
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1596,
                                            end: 1602
                                        }
                                    },
                                    loc: {
                                        start: 1596,
                                        end: 1602
                                    }
                                },
                                loc: {
                                    start: 1596,
                                    end: 1603
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1587,
                                end: 1603
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'candidate',
                                loc: {
                                    start: 1605,
                                    end: 1614
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'String',
                                    loc: {
                                        start: 1616,
                                        end: 1622
                                    }
                                },
                                loc: {
                                    start: 1616,
                                    end: 1622
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1605,
                                end: 1622
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'FileDependencyResult',
                                loc: {
                                    start: 1625,
                                    end: 1645
                                }
                            },
                            loc: {
                                start: 1625,
                                end: 1645
                            }
                        },
                        loc: {
                            start: 1625,
                            end: 1646
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1517,
                        end: 1646
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'oauthCode',
                        loc: {
                            start: 1649,
                            end: 1658
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 1660,
                                    end: 1666
                                }
                            },
                            loc: {
                                start: 1660,
                                end: 1666
                            }
                        },
                        loc: {
                            start: 1660,
                            end: 1667
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1649,
                        end: 1667
                    }
                }
            ],
            loc: {
                start: 1350,
                end: 1669
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Mutation',
                loc: {
                    start: 1676,
                    end: 1684
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'setEnv',
                        loc: {
                            start: 1689,
                            end: 1695
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'value',
                                loc: {
                                    start: 1696,
                                    end: 1701
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1703,
                                            end: 1709
                                        }
                                    },
                                    loc: {
                                        start: 1703,
                                        end: 1709
                                    }
                                },
                                loc: {
                                    start: 1703,
                                    end: 1710
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1696,
                                end: 1710
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 1713,
                                end: 1719
                            }
                        },
                        loc: {
                            start: 1713,
                            end: 1719
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1689,
                        end: 1719
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'setFigmaPluginOpened',
                        loc: {
                            start: 1722,
                            end: 1742
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'value',
                                loc: {
                                    start: 1743,
                                    end: 1748
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Boolean',
                                        loc: {
                                            start: 1750,
                                            end: 1757
                                        }
                                    },
                                    loc: {
                                        start: 1750,
                                        end: 1757
                                    }
                                },
                                loc: {
                                    start: 1750,
                                    end: 1758
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1743,
                                end: 1758
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 1761,
                                end: 1768
                            }
                        },
                        loc: {
                            start: 1761,
                            end: 1768
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1722,
                        end: 1768
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'setLocale',
                        loc: {
                            start: 1771,
                            end: 1780
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'value',
                                loc: {
                                    start: 1781,
                                    end: 1786
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1788,
                                            end: 1794
                                        }
                                    },
                                    loc: {
                                        start: 1788,
                                        end: 1794
                                    }
                                },
                                loc: {
                                    start: 1788,
                                    end: 1795
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1781,
                                end: 1795
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 1798,
                                end: 1804
                            }
                        },
                        loc: {
                            start: 1798,
                            end: 1804
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1771,
                        end: 1804
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'setAppId',
                        loc: {
                            start: 1807,
                            end: 1815
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'value',
                                loc: {
                                    start: 1816,
                                    end: 1821
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1823,
                                            end: 1829
                                        }
                                    },
                                    loc: {
                                        start: 1823,
                                        end: 1829
                                    }
                                },
                                loc: {
                                    start: 1823,
                                    end: 1830
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1816,
                                end: 1830
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 1833,
                                end: 1839
                            }
                        },
                        loc: {
                            start: 1833,
                            end: 1839
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1807,
                        end: 1839
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'login',
                        loc: {
                            start: 1842,
                            end: 1847
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'code',
                                loc: {
                                    start: 1848,
                                    end: 1852
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1854,
                                            end: 1860
                                        }
                                    },
                                    loc: {
                                        start: 1854,
                                        end: 1860
                                    }
                                },
                                loc: {
                                    start: 1854,
                                    end: 1861
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1848,
                                end: 1861
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 1864,
                                end: 1871
                            }
                        },
                        loc: {
                            start: 1864,
                            end: 1871
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1842,
                        end: 1871
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'logout',
                        loc: {
                            start: 1874,
                            end: 1880
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 1882,
                                end: 1889
                            }
                        },
                        loc: {
                            start: 1882,
                            end: 1889
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1874,
                        end: 1889
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'touchStashFile',
                        loc: {
                            start: 1892,
                            end: 1906
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 1907,
                                    end: 1910
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1912,
                                            end: 1918
                                        }
                                    },
                                    loc: {
                                        start: 1912,
                                        end: 1918
                                    }
                                },
                                loc: {
                                    start: 1912,
                                    end: 1919
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1907,
                                end: 1919
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'fileType',
                                loc: {
                                    start: 1921,
                                    end: 1929
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1931,
                                            end: 1937
                                        }
                                    },
                                    loc: {
                                        start: 1931,
                                        end: 1937
                                    }
                                },
                                loc: {
                                    start: 1931,
                                    end: 1938
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1921,
                                end: 1938
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 1940,
                                    end: 1946
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 1948,
                                            end: 1951
                                        }
                                    },
                                    loc: {
                                        start: 1948,
                                        end: 1951
                                    }
                                },
                                loc: {
                                    start: 1948,
                                    end: 1952
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1940,
                                end: 1952
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'contentType',
                                loc: {
                                    start: 1954,
                                    end: 1965
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'String',
                                    loc: {
                                        start: 1967,
                                        end: 1973
                                    }
                                },
                                loc: {
                                    start: 1967,
                                    end: 1973
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1954,
                                end: 1973
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'timestamp',
                                loc: {
                                    start: 1975,
                                    end: 1984
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 1986,
                                            end: 1992
                                        }
                                    },
                                    loc: {
                                        start: 1986,
                                        end: 1992
                                    }
                                },
                                loc: {
                                    start: 1986,
                                    end: 1993
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1975,
                                end: 1993
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'extra',
                                loc: {
                                    start: 1995,
                                    end: 2000
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'JSONObject',
                                    loc: {
                                        start: 2002,
                                        end: 2012
                                    }
                                },
                                loc: {
                                    start: 2002,
                                    end: 2012
                                }
                            },
                            directives: [],
                            loc: {
                                start: 1995,
                                end: 2012
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2015,
                                    end: 2022
                                }
                            },
                            loc: {
                                start: 2015,
                                end: 2022
                            }
                        },
                        loc: {
                            start: 2015,
                            end: 2023
                        }
                    },
                    directives: [],
                    loc: {
                        start: 1892,
                        end: 2023
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stashFileContent',
                        loc: {
                            start: 2026,
                            end: 2042
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2043,
                                    end: 2049
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2051,
                                            end: 2054
                                        }
                                    },
                                    loc: {
                                        start: 2051,
                                        end: 2054
                                    }
                                },
                                loc: {
                                    start: 2051,
                                    end: 2055
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2043,
                                end: 2055
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2057,
                                    end: 2060
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2062,
                                            end: 2068
                                        }
                                    },
                                    loc: {
                                        start: 2062,
                                        end: 2068
                                    }
                                },
                                loc: {
                                    start: 2062,
                                    end: 2069
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2057,
                                end: 2069
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'data',
                                loc: {
                                    start: 2071,
                                    end: 2075
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Buffer',
                                        loc: {
                                            start: 2077,
                                            end: 2083
                                        }
                                    },
                                    loc: {
                                        start: 2077,
                                        end: 2083
                                    }
                                },
                                loc: {
                                    start: 2077,
                                    end: 2084
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2071,
                                end: 2084
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'contentType',
                                loc: {
                                    start: 2086,
                                    end: 2097
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2099,
                                            end: 2105
                                        }
                                    },
                                    loc: {
                                        start: 2099,
                                        end: 2105
                                    }
                                },
                                loc: {
                                    start: 2099,
                                    end: 2106
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2086,
                                end: 2106
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'patch',
                                loc: {
                                    start: 2108,
                                    end: 2113
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Boolean',
                                        loc: {
                                            start: 2115,
                                            end: 2122
                                        }
                                    },
                                    loc: {
                                        start: 2115,
                                        end: 2122
                                    }
                                },
                                loc: {
                                    start: 2115,
                                    end: 2123
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2108,
                                end: 2123
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 2126,
                                end: 2132
                            }
                        },
                        loc: {
                            start: 2126,
                            end: 2132
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2026,
                        end: 2132
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stashFileChunk',
                        loc: {
                            start: 2135,
                            end: 2149
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2150,
                                    end: 2156
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2158,
                                            end: 2161
                                        }
                                    },
                                    loc: {
                                        start: 2158,
                                        end: 2161
                                    }
                                },
                                loc: {
                                    start: 2158,
                                    end: 2162
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2150,
                                end: 2162
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2164,
                                    end: 2167
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2169,
                                            end: 2175
                                        }
                                    },
                                    loc: {
                                        start: 2169,
                                        end: 2175
                                    }
                                },
                                loc: {
                                    start: 2169,
                                    end: 2176
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2164,
                                end: 2176
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'timestamp',
                                loc: {
                                    start: 2178,
                                    end: 2187
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2189,
                                            end: 2195
                                        }
                                    },
                                    loc: {
                                        start: 2189,
                                        end: 2195
                                    }
                                },
                                loc: {
                                    start: 2189,
                                    end: 2196
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2178,
                                end: 2196
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'data',
                                loc: {
                                    start: 2198,
                                    end: 2202
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Buffer',
                                        loc: {
                                            start: 2204,
                                            end: 2210
                                        }
                                    },
                                    loc: {
                                        start: 2204,
                                        end: 2210
                                    }
                                },
                                loc: {
                                    start: 2204,
                                    end: 2211
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2198,
                                end: 2211
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'contentType',
                                loc: {
                                    start: 2213,
                                    end: 2224
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2226,
                                            end: 2232
                                        }
                                    },
                                    loc: {
                                        start: 2226,
                                        end: 2232
                                    }
                                },
                                loc: {
                                    start: 2226,
                                    end: 2233
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2213,
                                end: 2233
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Int',
                                loc: {
                                    start: 2236,
                                    end: 2239
                                }
                            },
                            loc: {
                                start: 2236,
                                end: 2239
                            }
                        },
                        loc: {
                            start: 2236,
                            end: 2240
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2135,
                        end: 2240
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stashFileComplete',
                        loc: {
                            start: 2243,
                            end: 2260
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2261,
                                    end: 2267
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2269,
                                            end: 2272
                                        }
                                    },
                                    loc: {
                                        start: 2269,
                                        end: 2272
                                    }
                                },
                                loc: {
                                    start: 2269,
                                    end: 2273
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2261,
                                end: 2273
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2275,
                                    end: 2278
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2280,
                                            end: 2286
                                        }
                                    },
                                    loc: {
                                        start: 2280,
                                        end: 2286
                                    }
                                },
                                loc: {
                                    start: 2280,
                                    end: 2287
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2275,
                                end: 2287
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 2290,
                                end: 2297
                            }
                        },
                        loc: {
                            start: 2290,
                            end: 2297
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2243,
                        end: 2297
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'stashVideoScreenshot',
                        loc: {
                            start: 2300,
                            end: 2320
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'videoUrl',
                                loc: {
                                    start: 2321,
                                    end: 2329
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2331,
                                            end: 2337
                                        }
                                    },
                                    loc: {
                                        start: 2331,
                                        end: 2337
                                    }
                                },
                                loc: {
                                    start: 2331,
                                    end: 2338
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2321,
                                end: 2338
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'dummyUrl',
                                loc: {
                                    start: 2340,
                                    end: 2348
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2350,
                                            end: 2356
                                        }
                                    },
                                    loc: {
                                        start: 2350,
                                        end: 2356
                                    }
                                },
                                loc: {
                                    start: 2350,
                                    end: 2357
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2340,
                                end: 2357
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'currentTime',
                                loc: {
                                    start: 2359,
                                    end: 2370
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Float',
                                        loc: {
                                            start: 2372,
                                            end: 2377
                                        }
                                    },
                                    loc: {
                                        start: 2372,
                                        end: 2377
                                    }
                                },
                                loc: {
                                    start: 2372,
                                    end: 2378
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2359,
                                end: 2378
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2380,
                                    end: 2386
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2388,
                                            end: 2391
                                        }
                                    },
                                    loc: {
                                        start: 2388,
                                        end: 2391
                                    }
                                },
                                loc: {
                                    start: 2388,
                                    end: 2392
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2380,
                                end: 2392
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'width',
                                loc: {
                                    start: 2394,
                                    end: 2399
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Float',
                                        loc: {
                                            start: 2401,
                                            end: 2406
                                        }
                                    },
                                    loc: {
                                        start: 2401,
                                        end: 2406
                                    }
                                },
                                loc: {
                                    start: 2401,
                                    end: 2407
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2394,
                                end: 2407
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'height',
                                loc: {
                                    start: 2409,
                                    end: 2415
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Float',
                                        loc: {
                                            start: 2417,
                                            end: 2422
                                        }
                                    },
                                    loc: {
                                        start: 2417,
                                        end: 2422
                                    }
                                },
                                loc: {
                                    start: 2417,
                                    end: 2423
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2409,
                                end: 2423
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Boolean',
                            loc: {
                                start: 2426,
                                end: 2433
                            }
                        },
                        loc: {
                            start: 2426,
                            end: 2433
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2300,
                        end: 2433
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'fetchFileProxy',
                        loc: {
                            start: 2436,
                            end: 2450
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2451,
                                    end: 2457
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2459,
                                            end: 2462
                                        }
                                    },
                                    loc: {
                                        start: 2459,
                                        end: 2462
                                    }
                                },
                                loc: {
                                    start: 2459,
                                    end: 2463
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2451,
                                end: 2463
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2465,
                                    end: 2468
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2470,
                                            end: 2476
                                        }
                                    },
                                    loc: {
                                        start: 2470,
                                        end: 2476
                                    }
                                },
                                loc: {
                                    start: 2470,
                                    end: 2477
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2465,
                                end: 2477
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'referer',
                                loc: {
                                    start: 2479,
                                    end: 2486
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2488,
                                            end: 2494
                                        }
                                    },
                                    loc: {
                                        start: 2488,
                                        end: 2494
                                    }
                                },
                                loc: {
                                    start: 2488,
                                    end: 2495
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2479,
                                end: 2495
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'fileType',
                                loc: {
                                    start: 2497,
                                    end: 2505
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2507,
                                            end: 2513
                                        }
                                    },
                                    loc: {
                                        start: 2507,
                                        end: 2513
                                    }
                                },
                                loc: {
                                    start: 2507,
                                    end: 2514
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2497,
                                end: 2514
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'noStash',
                                loc: {
                                    start: 2516,
                                    end: 2523
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Boolean',
                                    loc: {
                                        start: 2525,
                                        end: 2532
                                    }
                                },
                                loc: {
                                    start: 2525,
                                    end: 2532
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2516,
                                end: 2532
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'StashFileProxyResult',
                            loc: {
                                start: 2535,
                                end: 2555
                            }
                        },
                        loc: {
                            start: 2535,
                            end: 2555
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2436,
                        end: 2555
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskCreate',
                        loc: {
                            start: 2558,
                            end: 2568
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskType',
                                loc: {
                                    start: 2569,
                                    end: 2577
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'TaskType',
                                    loc: {
                                        start: 2579,
                                        end: 2587
                                    }
                                },
                                loc: {
                                    start: 2579,
                                    end: 2587
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2569,
                                end: 2587
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'name',
                                loc: {
                                    start: 2589,
                                    end: 2593
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2595,
                                            end: 2601
                                        }
                                    },
                                    loc: {
                                        start: 2595,
                                        end: 2601
                                    }
                                },
                                loc: {
                                    start: 2595,
                                    end: 2602
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2589,
                                end: 2602
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2604,
                                    end: 2607
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2609,
                                            end: 2615
                                        }
                                    },
                                    loc: {
                                        start: 2609,
                                        end: 2615
                                    }
                                },
                                loc: {
                                    start: 2609,
                                    end: 2616
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2604,
                                end: 2616
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskVariance',
                                loc: {
                                    start: 2618,
                                    end: 2630
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'TaskVariance',
                                    loc: {
                                        start: 2632,
                                        end: 2644
                                    }
                                },
                                loc: {
                                    start: 2632,
                                    end: 2644
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2618,
                                end: 2644
                            }
                        }
                    ],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'Int',
                            loc: {
                                start: 2647,
                                end: 2650
                            }
                        },
                        loc: {
                            start: 2647,
                            end: 2650
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2558,
                        end: 2650
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordEnable',
                        loc: {
                            start: 2653,
                            end: 2665
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2667,
                                    end: 2674
                                }
                            },
                            loc: {
                                start: 2667,
                                end: 2674
                            }
                        },
                        loc: {
                            start: 2667,
                            end: 2675
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2653,
                        end: 2675
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordDisable',
                        loc: {
                            start: 2678,
                            end: 2691
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2693,
                                    end: 2700
                                }
                            },
                            loc: {
                                start: 2693,
                                end: 2700
                            }
                        },
                        loc: {
                            start: 2693,
                            end: 2701
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2678,
                        end: 2701
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordStart',
                        loc: {
                            start: 2704,
                            end: 2715
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'name',
                                loc: {
                                    start: 2716,
                                    end: 2720
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2722,
                                            end: 2728
                                        }
                                    },
                                    loc: {
                                        start: 2722,
                                        end: 2728
                                    }
                                },
                                loc: {
                                    start: 2722,
                                    end: 2729
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2716,
                                end: 2729
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'url',
                                loc: {
                                    start: 2731,
                                    end: 2734
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'String',
                                        loc: {
                                            start: 2736,
                                            end: 2742
                                        }
                                    },
                                    loc: {
                                        start: 2736,
                                        end: 2742
                                    }
                                },
                                loc: {
                                    start: 2736,
                                    end: 2743
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2731,
                                end: 2743
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskType',
                                loc: {
                                    start: 2745,
                                    end: 2753
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'TaskType',
                                    loc: {
                                        start: 2755,
                                        end: 2763
                                    }
                                },
                                loc: {
                                    start: 2755,
                                    end: 2763
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2745,
                                end: 2763
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2765,
                                    end: 2771
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Int',
                                    loc: {
                                        start: 2773,
                                        end: 2776
                                    }
                                },
                                loc: {
                                    start: 2773,
                                    end: 2776
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2765,
                                end: 2776
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'snapshotTabId',
                                loc: {
                                    start: 2778,
                                    end: 2791
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'String',
                                    loc: {
                                        start: 2793,
                                        end: 2799
                                    }
                                },
                                loc: {
                                    start: 2793,
                                    end: 2799
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2778,
                                end: 2799
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2802,
                                    end: 2809
                                }
                            },
                            loc: {
                                start: 2802,
                                end: 2809
                            }
                        },
                        loc: {
                            start: 2802,
                            end: 2810
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2704,
                        end: 2810
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordPause',
                        loc: {
                            start: 2813,
                            end: 2824
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2826,
                                    end: 2833
                                }
                            },
                            loc: {
                                start: 2826,
                                end: 2833
                            }
                        },
                        loc: {
                            start: 2826,
                            end: 2834
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2813,
                        end: 2834
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordResume',
                        loc: {
                            start: 2837,
                            end: 2849
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2851,
                                    end: 2858
                                }
                            },
                            loc: {
                                start: 2851,
                                end: 2858
                            }
                        },
                        loc: {
                            start: 2851,
                            end: 2859
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2837,
                        end: 2859
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'emitFrame',
                        loc: {
                            start: 2862,
                            end: 2871
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'frame',
                                loc: {
                                    start: 2872,
                                    end: 2877
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Frame',
                                        loc: {
                                            start: 2879,
                                            end: 2884
                                        }
                                    },
                                    loc: {
                                        start: 2879,
                                        end: 2884
                                    }
                                },
                                loc: {
                                    start: 2879,
                                    end: 2885
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2872,
                                end: 2885
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 2887,
                                    end: 2893
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 2895,
                                            end: 2898
                                        }
                                    },
                                    loc: {
                                        start: 2895,
                                        end: 2898
                                    }
                                },
                                loc: {
                                    start: 2895,
                                    end: 2899
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2887,
                                end: 2899
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2902,
                                    end: 2909
                                }
                            },
                            loc: {
                                start: 2902,
                                end: 2909
                            }
                        },
                        loc: {
                            start: 2902,
                            end: 2910
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2862,
                        end: 2910
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recordStop',
                        loc: {
                            start: 2913,
                            end: 2923
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'keepRecorder',
                                loc: {
                                    start: 2924,
                                    end: 2936
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Boolean',
                                    loc: {
                                        start: 2938,
                                        end: 2945
                                    }
                                },
                                loc: {
                                    start: 2938,
                                    end: 2945
                                }
                            },
                            directives: [],
                            loc: {
                                start: 2924,
                                end: 2945
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2948,
                                    end: 2955
                                }
                            },
                            loc: {
                                start: 2948,
                                end: 2955
                            }
                        },
                        loc: {
                            start: 2948,
                            end: 2956
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2913,
                        end: 2956
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskClearComplete',
                        loc: {
                            start: 2959,
                            end: 2976
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 2978,
                                    end: 2985
                                }
                            },
                            loc: {
                                start: 2978,
                                end: 2985
                            }
                        },
                        loc: {
                            start: 2978,
                            end: 2986
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2959,
                        end: 2986
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskRemove',
                        loc: {
                            start: 2989,
                            end: 2999
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 3000,
                                    end: 3006
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 3008,
                                            end: 3011
                                        }
                                    },
                                    loc: {
                                        start: 3008,
                                        end: 3011
                                    }
                                },
                                loc: {
                                    start: 3008,
                                    end: 3012
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3000,
                                end: 3012
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3015,
                                    end: 3022
                                }
                            },
                            loc: {
                                start: 3015,
                                end: 3022
                            }
                        },
                        loc: {
                            start: 3015,
                            end: 3023
                        }
                    },
                    directives: [],
                    loc: {
                        start: 2989,
                        end: 3023
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'uploadTask',
                        loc: {
                            start: 3026,
                            end: 3036
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 3037,
                                    end: 3043
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 3045,
                                            end: 3048
                                        }
                                    },
                                    loc: {
                                        start: 3045,
                                        end: 3048
                                    }
                                },
                                loc: {
                                    start: 3045,
                                    end: 3049
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3037,
                                end: 3049
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'force',
                                loc: {
                                    start: 3051,
                                    end: 3056
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Boolean',
                                    loc: {
                                        start: 3058,
                                        end: 3065
                                    }
                                },
                                loc: {
                                    start: 3058,
                                    end: 3065
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3051,
                                end: 3065
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'timeout',
                                loc: {
                                    start: 3067,
                                    end: 3074
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Int',
                                    loc: {
                                        start: 3076,
                                        end: 3079
                                    }
                                },
                                loc: {
                                    start: 3076,
                                    end: 3079
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3067,
                                end: 3079
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3082,
                                    end: 3089
                                }
                            },
                            loc: {
                                start: 3082,
                                end: 3089
                            }
                        },
                        loc: {
                            start: 3082,
                            end: 3090
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3026,
                        end: 3090
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskCancel',
                        loc: {
                            start: 3093,
                            end: 3103
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 3104,
                                    end: 3110
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 3112,
                                            end: 3115
                                        }
                                    },
                                    loc: {
                                        start: 3112,
                                        end: 3115
                                    }
                                },
                                loc: {
                                    start: 3112,
                                    end: 3116
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3104,
                                end: 3116
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3119,
                                    end: 3126
                                }
                            },
                            loc: {
                                start: 3119,
                                end: 3126
                            }
                        },
                        loc: {
                            start: 3119,
                            end: 3127
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3093,
                        end: 3127
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'selectElementAction',
                        loc: {
                            start: 3130,
                            end: 3149
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'action',
                                loc: {
                                    start: 3150,
                                    end: 3156
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'SelectElementActionType',
                                        loc: {
                                            start: 3158,
                                            end: 3181
                                        }
                                    },
                                    loc: {
                                        start: 3158,
                                        end: 3181
                                    }
                                },
                                loc: {
                                    start: 3158,
                                    end: 3182
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3150,
                                end: 3182
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'frameId',
                                loc: {
                                    start: 3184,
                                    end: 3191
                                }
                            },
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'Int',
                                    loc: {
                                        start: 3193,
                                        end: 3196
                                    }
                                },
                                loc: {
                                    start: 3193,
                                    end: 3196
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3184,
                                end: 3196
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3199,
                                    end: 3206
                                }
                            },
                            loc: {
                                start: 3199,
                                end: 3206
                            }
                        },
                        loc: {
                            start: 3199,
                            end: 3207
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3130,
                        end: 3207
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'selectElementFinish',
                        loc: {
                            start: 3210,
                            end: 3229
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'rect',
                                loc: {
                                    start: 3230,
                                    end: 3234
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Rect',
                                        loc: {
                                            start: 3236,
                                            end: 3240
                                        }
                                    },
                                    loc: {
                                        start: 3236,
                                        end: 3240
                                    }
                                },
                                loc: {
                                    start: 3236,
                                    end: 3241
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3230,
                                end: 3241
                            }
                        },
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 3243,
                                    end: 3249
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 3251,
                                            end: 3254
                                        }
                                    },
                                    loc: {
                                        start: 3251,
                                        end: 3254
                                    }
                                },
                                loc: {
                                    start: 3251,
                                    end: 3255
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3243,
                                end: 3255
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3258,
                                    end: 3265
                                }
                            },
                            loc: {
                                start: 3258,
                                end: 3265
                            }
                        },
                        loc: {
                            start: 3258,
                            end: 3266
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3210,
                        end: 3266
                    }
                }
            ],
            loc: {
                start: 1671,
                end: 3268
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'TipLore',
                loc: {
                    start: 3275,
                    end: 3282
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'title',
                        loc: {
                            start: 3287,
                            end: 3292
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 3294,
                                    end: 3300
                                }
                            },
                            loc: {
                                start: 3294,
                                end: 3300
                            }
                        },
                        loc: {
                            start: 3294,
                            end: 3301
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3287,
                        end: 3301
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'url',
                        loc: {
                            start: 3304,
                            end: 3307
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 3309,
                                end: 3315
                            }
                        },
                        loc: {
                            start: 3309,
                            end: 3315
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3304,
                        end: 3315
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'urlText',
                        loc: {
                            start: 3318,
                            end: 3325
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 3327,
                                end: 3333
                            }
                        },
                        loc: {
                            start: 3327,
                            end: 3333
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3318,
                        end: 3333
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'description',
                        loc: {
                            start: 3336,
                            end: 3347
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 3349,
                                end: 3355
                            }
                        },
                        loc: {
                            start: 3349,
                            end: 3355
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3336,
                        end: 3355
                    }
                }
            ],
            loc: {
                start: 3270,
                end: 3357
            }
        },
        {
            kind: 'ObjectTypeDefinition',
            name: {
                kind: 'Name',
                value: 'Subscription',
                loc: {
                    start: 3364,
                    end: 3376
                }
            },
            interfaces: [],
            directives: [],
            fields: [
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'env',
                        loc: {
                            start: 3381,
                            end: 3384
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 3386,
                                    end: 3392
                                }
                            },
                            loc: {
                                start: 3386,
                                end: 3392
                            }
                        },
                        loc: {
                            start: 3386,
                            end: 3393
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3381,
                        end: 3393
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'figmaPluginOpened',
                        loc: {
                            start: 3396,
                            end: 3413
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'Boolean',
                                loc: {
                                    start: 3415,
                                    end: 3422
                                }
                            },
                            loc: {
                                start: 3415,
                                end: 3422
                            }
                        },
                        loc: {
                            start: 3415,
                            end: 3423
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3396,
                        end: 3423
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'locale',
                        loc: {
                            start: 3426,
                            end: 3432
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'String',
                                loc: {
                                    start: 3434,
                                    end: 3440
                                }
                            },
                            loc: {
                                start: 3434,
                                end: 3440
                            }
                        },
                        loc: {
                            start: 3434,
                            end: 3441
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3426,
                        end: 3441
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'appId',
                        loc: {
                            start: 3444,
                            end: 3449
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 3451,
                                end: 3457
                            }
                        },
                        loc: {
                            start: 3451,
                            end: 3457
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3444,
                        end: 3457
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'tipLore',
                        loc: {
                            start: 3460,
                            end: 3467
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'TipLore',
                                loc: {
                                    start: 3469,
                                    end: 3476
                                }
                            },
                            loc: {
                                start: 3469,
                                end: 3476
                            }
                        },
                        loc: {
                            start: 3469,
                            end: 3477
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3460,
                        end: 3477
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'recorderState',
                        loc: {
                            start: 3480,
                            end: 3493
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'RecorderState',
                                loc: {
                                    start: 3495,
                                    end: 3508
                                }
                            },
                            loc: {
                                start: 3495,
                                end: 3508
                            }
                        },
                        loc: {
                            start: 3495,
                            end: 3509
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3480,
                        end: 3509
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskUploadStatusChange',
                        loc: {
                            start: 3512,
                            end: 3534
                        }
                    },
                    arguments: [
                        {
                            kind: 'InputValueDefinition',
                            name: {
                                kind: 'Name',
                                value: 'taskId',
                                loc: {
                                    start: 3535,
                                    end: 3541
                                }
                            },
                            type: {
                                kind: 'NonNullType',
                                type: {
                                    kind: 'NamedType',
                                    name: {
                                        kind: 'Name',
                                        value: 'Int',
                                        loc: {
                                            start: 3543,
                                            end: 3546
                                        }
                                    },
                                    loc: {
                                        start: 3543,
                                        end: 3546
                                    }
                                },
                                loc: {
                                    start: 3543,
                                    end: 3547
                                }
                            },
                            directives: [],
                            loc: {
                                start: 3535,
                                end: 3547
                            }
                        }
                    ],
                    type: {
                        kind: 'NonNullType',
                        type: {
                            kind: 'NamedType',
                            name: {
                                kind: 'Name',
                                value: 'TaskUploadStatus',
                                loc: {
                                    start: 3550,
                                    end: 3566
                                }
                            },
                            loc: {
                                start: 3550,
                                end: 3566
                            }
                        },
                        loc: {
                            start: 3550,
                            end: 3567
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3512,
                        end: 3567
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'activeTab',
                        loc: {
                            start: 3570,
                            end: 3579
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'NamedType',
                        name: {
                            kind: 'Name',
                            value: 'String',
                            loc: {
                                start: 3581,
                                end: 3587
                            }
                        },
                        loc: {
                            start: 3581,
                            end: 3587
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3570,
                        end: 3587
                    }
                },
                {
                    kind: 'FieldDefinition',
                    name: {
                        kind: 'Name',
                        value: 'taskList',
                        loc: {
                            start: 3590,
                            end: 3598
                        }
                    },
                    arguments: [],
                    type: {
                        kind: 'ListType',
                        type: {
                            kind: 'NonNullType',
                            type: {
                                kind: 'NamedType',
                                name: {
                                    kind: 'Name',
                                    value: 'LocalTask',
                                    loc: {
                                        start: 3601,
                                        end: 3610
                                    }
                                },
                                loc: {
                                    start: 3601,
                                    end: 3610
                                }
                            },
                            loc: {
                                start: 3601,
                                end: 3611
                            }
                        },
                        loc: {
                            start: 3600,
                            end: 3612
                        }
                    },
                    directives: [],
                    loc: {
                        start: 3590,
                        end: 3612
                    }
                }
            ],
            loc: {
                start: 3359,
                end: 3614
            }
        }
    ],
    loc: {
        start: 0,
        end: 3615
    }
};

const schema = makeExecutableSchema({
    typeDefs,
    resolvers
});

const debug$1 = createDebug('server:transport');
class RecorderClientTransport extends RecorderClientTransportBase {
    contextValue;
    subscriptions;
    constructor(message$, contextValue){
        super(contextValue.tabId, message$);
        this.contextValue = contextValue;
        this.subscriptions = new Map();
    }
    stop() {
        this.subscriptions.forEach((subscription)=>{
            if (isAsyncIterable(subscription) && isAsyncGenerator(subscription)) {
                subscription.return(undefined);
            }
        });
        this.subscriptions.clear();
        super.stop();
    }
    handleMessage(message) {
        switch(message.type){
            case ClientRequestTypes.GraphQLRequest:
                this.handleRequest(message);
                break;
            case ClientRequestTypes.Ping:
                this.message$.sendMessage({
                    type: ServerResponseTypes.Pong
                });
                break;
            case ClientRequestTypes.Cancel:
                this.handleCancel(message);
                break;
        }
    }
    onConnectAck(documentId) {
        this.message$.sendMessage({
            type: ServerResponseTypes.ConnectAck,
            tabId: this.id,
            documentId
        });
    }
    async handleCancel(message) {
        const { id } = message;
        const operationResult = this.subscriptions.get(id);
        this.subscriptions.delete(id);
        if (operationResult && isAsyncIterable(operationResult) && isAsyncGenerator(operationResult)) {
            await operationResult.return(undefined);
        }
    }
    async handleRequest(message) {
        const { id } = message;
        if (this.subscriptions.has(id)) {
            return;
        }
        // if this turns out to be a streaming operation, the subscription value
        // will change to an `AsyncIterable`, otherwise it will stay as is
        this.subscriptions.set(id, null);
        const abortController = new AbortController();
        this.message$.subscribe({
            complete: ()=>{
                abortController.abort();
            }
        });
        const { logErrorObject } = this.contextValue;
        const contextValue = {
            ...this.contextValue,
            abortController,
            attributes: message.attributes
        };
        try {
            const { operationName, variables } = message;
            const query = JSON.parse(message.query);
            const operationAST = getOperationAST(query, operationName);
            if (!operationAST) {
                const error = new GraphQLError('Unable to identify operation');
                this.message$.sendMessage({
                    id: message.id,
                    type: ServerResponseTypes.Error,
                    payload: JSON.stringify(error)
                });
                logErrorObject('Unable to identify operation', error, {
                    operationName,
                    query
                });
                return;
            }
            debug$1('start %s', operationName);
            const isSubscription = operationAST.operation === 'subscription';
            const operationResult = await (isSubscription ? subscribe : execute)({
                schema,
                operationName,
                document: query,
                variableValues: variables,
                contextValue
            });
            if (isAsyncIterable(operationResult)) {
                debug$1('subscription %s', operationName);
                /** multiple emitted results */ if (!this.subscriptions.has(id)) {
                    // subscription was completed/canceled before the operation settled
                    if (isAsyncGenerator(operationResult)) {
                        await operationResult.return(undefined);
                    }
                } else {
                    this.subscriptions.set(id, operationResult);
                    for await (const result of operationResult){
                        if (abortController.signal.aborted) {
                            debug$1('abort %s', operationName);
                            break;
                        }
                        debug$1('yield %s', operationName);
                        this.sendNext(message.id, contextValue, result);
                    }
                }
            } else if (isSubscription) {
                /** single emitted result */ // if the client completed the subscription before the single result
                // became available, he effectively canceled it and no data should be sent
                if (this.subscriptions.has(id)) {
                    debug$1('send single value %s', operationName);
                    this.sendNext(message.id, contextValue, operationResult);
                }
            } else {
                debug$1('send single value %s', operationName);
                this.sendNext(message.id, contextValue, operationResult);
            }
            this.sendComplete(message.id, message.attributes);
            debug$1('complete %s', operationName);
        } catch (e) {
            logErrorObject('handle client message error', e, message.query);
        } finally{
            this.subscriptions.delete(id);
        }
    }
    sendNext(id, context, result) {
        const { attributes } = context;
        if (result.errors) {
            result.errors.forEach((error)=>{
                console.error(error);
            });
        }
        this.message$.sendMessage({
            id,
            type: ServerResponseTypes.Next,
            payload: JSON.stringify(result),
            attributes
        });
    }
    sendComplete(id, attributes) {
        this.message$.sendMessage({
            id,
            type: ServerResponseTypes.Complete,
            attributes
        });
    }
}

const debug = createDebug('uploader:task');
function isAbort(error) {
    return error instanceof DOMException && error.name === 'AbortError';
}
const ABORT_MESSAGE = 'Aborted by user';
class UploaderService {
    db;
    $fetch;
    filesService;
    logger;
    cosService;
    fontSettingsService;
    region;
    storage;
    taskStatusChange$;
    uploadingTasks;
    constructor(db, $fetch, filesService, logger, cosService, fontSettingsService, region, storage){
        this.db = db;
        this.$fetch = $fetch;
        this.filesService = filesService;
        this.logger = logger;
        this.cosService = cosService;
        this.fontSettingsService = fontSettingsService;
        this.region = region;
        this.storage = storage;
        this.taskStatusChange$ = new Subject$1();
        this.uploadingTasks = new Map();
    }
    async uploadTask(args) {
        const { taskId } = args;
        const { db, uploadingTasks } = this;
        const subscription = new Subscription$1();
        const beginTime = Date.now();
        let criticalFilesDuration;
        let totalDuration;
        let demoId;
        try {
            const force = args.force ?? false;
            const timeout = args.timeout ?? 60;
            const abortController = new AbortController();
            uploadingTasks.set(taskId, abortController);
            subscription.add(()=>{
                uploadingTasks.delete(taskId);
            });
            const { signal } = abortController;
            const task = await db.tasks.get(taskId);
            if (!isSafeInteger(task?.id)) {
                debug('upload fail, task id not exist');
                return;
            }
            subscription.add(this.filesService.observeFileStashStatus(taskId, undefined).subscribe(this.taskStatusChange$));
            this.logger.event('start upload');
            await db.tasks.update(task.id, {
                status: RecordingStatus.Uploading,
                errorMessage: '',
                errorStack: ''
            });
            if (force) {
                this.filesService.markAllFilesNotUpload(taskId);
            }
            const record = await this.createRecord(task, signal);
            demoId = record.demoId;
            const { recordId, recordCredential, screenshotCredential, data: recordData, secret, isNewStashPath } = record;
            const category = isNewStashPath ? RECORD_FILE_CATEGORY_NEXT : RECORD_FILE_CATEGORY_LEGACY;
            debug('upload record to cos');
            this.logger.event('upload screenshot and critical files');
            await Promise.all([
                this.cosService.uploadRecord(task, secret, recordData, recordId, recordCredential),
                this.filesService.uploadTaskFiles(taskId, demoId, recordId, timeout, force, true, category, signal)
            ]);
            this.db.tasks.update(taskId, {
                status: RecordingStatus.UploadingExtra
            });
            await this.postProcess(demoId, task);
            criticalFilesDuration = Date.now() - beginTime;
            this.logger.event('upload critical files finish');
            if (screenshotCredential && CLIENT !== 'sdk') {
                const screenshot = await this.filesService.getTaskScreenshot(taskId);
                if (screenshot) {
                    await this.cosService.uploadScreenshot(screenshot, record.demoId, record.recordId, screenshotCredential);
                }
            }
            this.logger.event('upload screenshot finish');
            await this.filesService.uploadTaskFiles(taskId, demoId, recordId, timeout, force, false, category, signal);
            debug('before queryFileStashStatus');
            const fileStashStatus = await this.filesService.queryFileStashStatus(taskId, undefined);
            this.logger.event('query fileStashStatus finish');
            signal.throwIfAborted();
            if (fileStashStatus.uploaded < fileStashStatus.total) {
                await db.tasks.update(task.id, {
                    status: RecordingStatus.CompletedWithWarning
                });
                debug('finished with warning');
            } else {
                await db.tasks.update(task.id, {
                    status: RecordingStatus.Completed
                });
                debug('finished');
            }
            totalDuration = Date.now() - beginTime;
            this.$fetch('/api/action-log', {
                method: 'POST',
                body: {
                    actionType: ActionType.RECORD_UPLOAD_DURATION,
                    resourceType: 'Demo',
                    resourceId: demoId,
                    data: {
                        taskId,
                        duration: totalDuration,
                        criticalFilesDuration
                    }
                }
            });
        } catch (error) {
            totalDuration = Date.now() - beginTime;
            if (error === ABORT_MESSAGE || isAbort(error) || error?.cause === ABORT_MESSAGE) {
                this.logger.event('upload cancelled');
                this.$fetch('/api/action-log', {
                    method: 'POST',
                    body: {
                        actionType: ActionType.RECORD_UPLOAD_CANCEL,
                        resourceType: 'Demo',
                        resourceId: demoId,
                        data: {
                            taskId,
                            duration: totalDuration,
                            criticalFilesDuration
                        }
                    }
                });
                console.warn(`task ${taskId} cancelled`);
                await db.tasks.update(taskId, {
                    status: RecordingStatus.Cancelled
                });
            } else {
                this.$fetch('/api/action-log', {
                    method: 'POST',
                    body: {
                        actionType: ActionType.RECORD_UPLOAD_FAIL,
                        resourceType: 'Demo',
                        resourceId: demoId,
                        data: {
                            taskId,
                            duration: totalDuration,
                            criticalFilesDuration
                        }
                    }
                });
                this.logger.logErrorObject(`upload error ${taskId}`, error);
                this.logger.logUploadFailure('critical error', error, {
                    taskId
                });
                await db.tasks.update(taskId, {
                    status: RecordingStatus.Failed,
                    errorMessage: error?.message,
                    errorStack: error?.stack
                });
            }
        } finally{
            subscription.unsubscribe();
            this.filesService.getFileStashStatus(taskId, undefined).then((value)=>{
                this.taskStatusChange$.next(value);
            });
        }
    }
    async createRecord(task, signal) {
        if (!task.id) {
            throw new Error(`invalid task id: ${task.id}`);
        }
        const { db, $fetch } = this;
        const data = await db.frames.where('taskId').equals(task.id).sortBy('timestamp');
        if (task.serverId && task.recordId) {
            const { screenshotCredential, recordCredential, shareKey, isNewStashPath } = await $fetch('/api/record/redo-upload', {
                method: 'POST',
                body: {
                    demoId: task.serverId
                }
            });
            return {
                data,
                screenshotCredential,
                recordCredential,
                demoId: task.serverId,
                recordId: task.recordId,
                secret: hexToBuffer(shareKey),
                isNewStashPath
            };
        }
        this.logger.event('create record');
        const demoType = this.getDemoType();
        const secret = await getRandomValues$1(32);
        const shareKey = bufferToHex(secret);
        const fontsMap = await this.fontSettingsService.getGenericFontFamilyFonts();
        const payload = {
            shareKey,
            name: task.name,
            url: task.url,
            ua: navigator.userAgent,
            type: demoType,
            isSelect: task.taskVariance === TaskVariance.SelectElement,
            uploadScreenshot: true,
            recordType: adaptRecordType(task.taskType),
            extra: {
                clientVersion: FULL_VERSION,
                fontsMap
            }
        };
        const createRecord = await $fetch('/api/record', {
            method: 'post',
            body: payload,
            signal
        });
        if (!createRecord) {
            throw new Error('Invalid response');
        }
        this.logger.event('create record finish');
        const { id: demoId, recordId, uploadCredential, uploadRecordCredential, isNewStashPath } = createRecord;
        await db.tasks.update(task.id, {
            serverId: demoId,
            recordId,
            status: RecordingStatus.Uploading
        });
        debug('upload record finished, task-id:%s, server-id:%s', task.id, recordId);
        return {
            data,
            secret,
            demoId,
            recordId,
            screenshotCredential: uploadCredential,
            recordCredential: uploadRecordCredential,
            isNewStashPath
        };
    }
    async cancelTask({ taskId }) {
        debug('abort task %s', taskId);
        this.uploadingTasks.get(taskId)?.abort(ABORT_MESSAGE);
    }
    getDemoType() {
        switch(BUSINESS){
            case 'design':
                return DemoType.FIGMA;
            case 'mark':
                return DemoType.MARK;
            default:
                return DemoType.DEMO;
        }
    }
    async postProcess(demoId, task) {
        const abortController = new AbortController();
        setTimeout(async ()=>{
            if (abortController.signal.aborted) {
                return;
            }
            const oauth = await this.storage.getItem(OAUTH_KEY);
            const appId = await this.storage.getItem(APP_ID_KEY);
            await $logCls(this.region, [
                {
                    time: Date.now(),
                    contents: {
                        context: 'uploader service',
                        subject: 'post process timeout',
                        message: 'post process timeout',
                        stack: '',
                        userId: oauth?.userId || '',
                        appId: appId || '',
                        client: CLIENT,
                        level: 'error'
                    }
                }
            ]);
        }, 5000);
        await this.$fetch('/api/record/post-process', {
            method: 'POST',
            body: {
                demoId,
                type: task.taskType !== TaskType.Snapshot ? 'steps' : 'indexing'
            }
        });
        abortController.abort();
    }
}
UploaderService = __decorate([
    singleton(),
    __param(1, inject(FETCH)),
    __param(3, inject(LOGGER)),
    __param(5, inject(FONT_SETTINGS_SERVICE)),
    __param(6, inject(REGION)),
    __param(7, inject(STORAGE)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [
        typeof RecorderDB === "undefined" ? Object : RecorderDB,
        typeof $Fetch === "undefined" ? Object : $Fetch,
        typeof FilesService === "undefined" ? Object : FilesService,
        typeof ILoggerService === "undefined" ? Object : ILoggerService,
        typeof CosService === "undefined" ? Object : CosService,
        typeof IFontSettingsService === "undefined" ? Object : IFontSettingsService,
        typeof Region === "undefined" ? Object : Region,
        typeof Storage === "undefined" ? Object : Storage
    ])
], UploaderService);
function adaptRecordType(taskType) {
    if (!taskType || taskType === 'Demo') {
        return RecordType.Tour;
    }
    return taskType;
}

const RecorderStateInitialValue = {
    enabled: false,
    status: RecordingStatus.Stopped
};
async function resetTasks(db) {
    await db.tasks.where('status').noneOf([
        RecordingStatus.Completed,
        RecordingStatus.CompletedWithWarning,
        RecordingStatus.Failed
    ]).modify({
        status: RecordingStatus.Failed
    });
    await db.files.where('status').equals(FileStatus.Created).modify({
        status: FileStatus.Failed
    });
    // treat stream data as complete, partial stream data works
    await db.files.where('status').equals(FileStatus.Stream).modify({
        status: FileStatus.Finished
    });
}
function setupServer(client, storage, tabId, logger, $fetch, region) {
    const recorderState$ = new BehaviorSubject$1(RecorderStateInitialValue);
    const activeTab$ = new BehaviorSubject$1(null);
    const taskList$ = fromLiveQuery(liveQuery(()=>db.tasks.orderBy('id').reverse().toArray())).pipe(shareReplay({
        bufferSize: 1,
        refCount: true
    }));
    instance.register(STORAGE, {
        useValue: storage
    }).register(FETCH, {
        useValue: $fetch
    }).register(LOGGER, {
        useValue: logger
    }).register(REGION, {
        useValue: region
    });
    const db = instance.resolve(RecorderDB);
    const ctx = {
        tabId,
        db,
        recorderState$,
        taskList$,
        activeTab$,
        client,
        logErrorObject: logger.logErrorObject,
        storage,
        $fetch,
        container: instance,
        taskStatusChange$: new Subject$1(),
        region,
        logout$: new Subject$1()
    };
    return {
        ctx
    };
}

class ExtensionAuthClient extends OAuthController {
    async logout() {
        await super.logout();
        const env = await this.storage.getItem(ENV_KEY);
        await this.storage.clear();
        await this.storage.setItem(ENV_KEY, env);
    }
}

function setupWebExtensionOAuth(storage) {
    const oauthClient = new OAuthClient({
        $fetch: createPublicFetch({
            query: {
                version: VERSION,
                client: CLIENT
            }
        })
    });
    function updateOAuthClient() {
        storage.getItem(ENV_KEY).then((env)=>{
            oauthClient.setBaseURL(getServerOrigin(env || 'production'));
        });
    }
    storage.watch((_, key)=>{
        if (key !== ENV_KEY) {
            return;
        }
        updateOAuthClient();
    });
    updateOAuthClient();
    const oauth = new ExtensionAuthClient({
        storage,
        client: oauthClient,
        scheduleRefresh: false
    });
    return {
        oauthClient,
        oauth
    };
}

function wrapToPromise(value) {
  if (!value || typeof value.then !== "function") {
    return Promise.resolve(value);
  }
  return value;
}
function asyncCall(function_, ...arguments_) {
  try {
    return wrapToPromise(function_(...arguments_));
  } catch (error) {
    return Promise.reject(error);
  }
}
function isPrimitive(value) {
  const type = typeof value;
  return value === null || type !== "object" && type !== "function";
}
function isPureObject(value) {
  const proto = Object.getPrototypeOf(value);
  return !proto || proto.isPrototypeOf(Object);
}
function stringify(value) {
  if (isPrimitive(value)) {
    return String(value);
  }
  if (isPureObject(value) || Array.isArray(value)) {
    return JSON.stringify(value);
  }
  if (typeof value.toJSON === "function") {
    return stringify(value.toJSON());
  }
  throw new Error("[unstorage] Cannot stringify value!");
}
function checkBufferSupport() {
  if (typeof Buffer === void 0) {
    throw new TypeError("[unstorage] Buffer is not supported!");
  }
}
const BASE64_PREFIX = "base64:";
function serializeRaw(value) {
  if (typeof value === "string") {
    return value;
  }
  checkBufferSupport();
  const base64 = Buffer.from(value).toString("base64");
  return BASE64_PREFIX + base64;
}
function deserializeRaw(value) {
  if (typeof value !== "string") {
    return value;
  }
  if (!value.startsWith(BASE64_PREFIX)) {
    return value;
  }
  checkBufferSupport();
  return Buffer.from(value.slice(BASE64_PREFIX.length), "base64");
}
function normalizeKey(key) {
  if (!key) {
    return "";
  }
  return key.split("?")[0].replace(/[/\\]/g, ":").replace(/:+/g, ":").replace(/^:|:$/g, "");
}
function joinKeys(...keys) {
  return normalizeKey(keys.join(":"));
}
function normalizeBaseKey(base) {
  base = normalizeKey(base);
  return base ? base + ":" : "";
}

function defineDriver(factory) {
  return factory;
}

const DRIVER_NAME = "memory";
const memory = defineDriver(() => {
  const data = /* @__PURE__ */ new Map();
  return {
    name: DRIVER_NAME,
    options: {},
    hasItem(key) {
      return data.has(key);
    },
    getItem(key) {
      return data.get(key) ?? null;
    },
    getItemRaw(key) {
      return data.get(key) ?? null;
    },
    setItem(key, value) {
      data.set(key, value);
    },
    setItemRaw(key, value) {
      data.set(key, value);
    },
    removeItem(key) {
      data.delete(key);
    },
    getKeys() {
      return Array.from(data.keys());
    },
    clear() {
      data.clear();
    },
    dispose() {
      data.clear();
    }
  };
});

function createStorage(options = {}) {
  const context = {
    mounts: { "": options.driver || memory() },
    mountpoints: [""],
    watching: false,
    watchListeners: [],
    unwatch: {}
  };
  const getMount = (key) => {
    for (const base of context.mountpoints) {
      if (key.startsWith(base)) {
        return {
          base,
          relativeKey: key.slice(base.length),
          driver: context.mounts[base]
        };
      }
    }
    return {
      base: "",
      relativeKey: key,
      driver: context.mounts[""]
    };
  };
  const getMounts = (base, includeParent) => {
    return context.mountpoints.filter(
      (mountpoint) => mountpoint.startsWith(base) || includeParent && base.startsWith(mountpoint)
    ).map((mountpoint) => ({
      relativeBase: base.length > mountpoint.length ? base.slice(mountpoint.length) : void 0,
      mountpoint,
      driver: context.mounts[mountpoint]
    }));
  };
  const onChange = (event, key) => {
    if (!context.watching) {
      return;
    }
    key = normalizeKey(key);
    for (const listener of context.watchListeners) {
      listener(event, key);
    }
  };
  const startWatch = async () => {
    if (context.watching) {
      return;
    }
    context.watching = true;
    for (const mountpoint in context.mounts) {
      context.unwatch[mountpoint] = await watch(
        context.mounts[mountpoint],
        onChange,
        mountpoint
      );
    }
  };
  const stopWatch = async () => {
    if (!context.watching) {
      return;
    }
    for (const mountpoint in context.unwatch) {
      await context.unwatch[mountpoint]();
    }
    context.unwatch = {};
    context.watching = false;
  };
  const runBatch = (items, commonOptions, cb) => {
    const batches = /* @__PURE__ */ new Map();
    const getBatch = (mount) => {
      let batch = batches.get(mount.base);
      if (!batch) {
        batch = {
          driver: mount.driver,
          base: mount.base,
          items: []
        };
        batches.set(mount.base, batch);
      }
      return batch;
    };
    for (const item of items) {
      const isStringItem = typeof item === "string";
      const key = normalizeKey(isStringItem ? item : item.key);
      const value = isStringItem ? void 0 : item.value;
      const options2 = isStringItem || !item.options ? commonOptions : { ...commonOptions, ...item.options };
      const mount = getMount(key);
      getBatch(mount).items.push({
        key,
        value,
        relativeKey: mount.relativeKey,
        options: options2
      });
    }
    return Promise.all([...batches.values()].map((batch) => cb(batch))).then(
      (r) => r.flat()
    );
  };
  const storage = {
    // Item
    hasItem(key, opts = {}) {
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      return asyncCall(driver.hasItem, relativeKey, opts);
    },
    getItem(key, opts = {}) {
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      return asyncCall(driver.getItem, relativeKey, opts).then(
        (value) => destr(value)
      );
    },
    getItems(items, commonOptions) {
      return runBatch(items, commonOptions, (batch) => {
        if (batch.driver.getItems) {
          return asyncCall(
            batch.driver.getItems,
            batch.items.map((item) => ({
              key: item.relativeKey,
              options: item.options
            })),
            commonOptions
          ).then(
            (r) => r.map((item) => ({
              key: joinKeys(batch.base, item.key),
              value: destr(item.value)
            }))
          );
        }
        return Promise.all(
          batch.items.map((item) => {
            return asyncCall(
              batch.driver.getItem,
              item.relativeKey,
              item.options
            ).then((value) => ({
              key: item.key,
              value: destr(value)
            }));
          })
        );
      });
    },
    getItemRaw(key, opts = {}) {
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      if (driver.getItemRaw) {
        return asyncCall(driver.getItemRaw, relativeKey, opts);
      }
      return asyncCall(driver.getItem, relativeKey, opts).then(
        (value) => deserializeRaw(value)
      );
    },
    async setItem(key, value, opts = {}) {
      if (value === void 0) {
        return storage.removeItem(key);
      }
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      if (!driver.setItem) {
        return;
      }
      await asyncCall(driver.setItem, relativeKey, stringify(value), opts);
      if (!driver.watch) {
        onChange("update", key);
      }
    },
    async setItems(items, commonOptions) {
      await runBatch(items, commonOptions, async (batch) => {
        if (batch.driver.setItems) {
          return asyncCall(
            batch.driver.setItems,
            batch.items.map((item) => ({
              key: item.relativeKey,
              value: stringify(item.value),
              options: item.options
            })),
            commonOptions
          );
        }
        if (!batch.driver.setItem) {
          return;
        }
        await Promise.all(
          batch.items.map((item) => {
            return asyncCall(
              batch.driver.setItem,
              item.relativeKey,
              stringify(item.value),
              item.options
            );
          })
        );
      });
    },
    async setItemRaw(key, value, opts = {}) {
      if (value === void 0) {
        return storage.removeItem(key, opts);
      }
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      if (driver.setItemRaw) {
        await asyncCall(driver.setItemRaw, relativeKey, value, opts);
      } else if (driver.setItem) {
        await asyncCall(driver.setItem, relativeKey, serializeRaw(value), opts);
      } else {
        return;
      }
      if (!driver.watch) {
        onChange("update", key);
      }
    },
    async removeItem(key, opts = {}) {
      if (typeof opts === "boolean") {
        opts = { removeMeta: opts };
      }
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      if (!driver.removeItem) {
        return;
      }
      await asyncCall(driver.removeItem, relativeKey, opts);
      if (opts.removeMeta || opts.removeMata) {
        await asyncCall(driver.removeItem, relativeKey + "$", opts);
      }
      if (!driver.watch) {
        onChange("remove", key);
      }
    },
    // Meta
    async getMeta(key, opts = {}) {
      if (typeof opts === "boolean") {
        opts = { nativeOnly: opts };
      }
      key = normalizeKey(key);
      const { relativeKey, driver } = getMount(key);
      const meta = /* @__PURE__ */ Object.create(null);
      if (driver.getMeta) {
        Object.assign(meta, await asyncCall(driver.getMeta, relativeKey, opts));
      }
      if (!opts.nativeOnly) {
        const value = await asyncCall(
          driver.getItem,
          relativeKey + "$",
          opts
        ).then((value_) => destr(value_));
        if (value && typeof value === "object") {
          if (typeof value.atime === "string") {
            value.atime = new Date(value.atime);
          }
          if (typeof value.mtime === "string") {
            value.mtime = new Date(value.mtime);
          }
          Object.assign(meta, value);
        }
      }
      return meta;
    },
    setMeta(key, value, opts = {}) {
      return this.setItem(key + "$", value, opts);
    },
    removeMeta(key, opts = {}) {
      return this.removeItem(key + "$", opts);
    },
    // Keys
    async getKeys(base, opts = {}) {
      base = normalizeBaseKey(base);
      const mounts = getMounts(base, true);
      let maskedMounts = [];
      const allKeys = [];
      for (const mount of mounts) {
        const rawKeys = await asyncCall(
          mount.driver.getKeys,
          mount.relativeBase,
          opts
        );
        const keys = rawKeys.map((key) => mount.mountpoint + normalizeKey(key)).filter((key) => !maskedMounts.some((p) => key.startsWith(p)));
        allKeys.push(...keys);
        maskedMounts = [
          mount.mountpoint,
          ...maskedMounts.filter((p) => !p.startsWith(mount.mountpoint))
        ];
      }
      return base ? allKeys.filter((key) => key.startsWith(base) && !key.endsWith("$")) : allKeys.filter((key) => !key.endsWith("$"));
    },
    // Utils
    async clear(base, opts = {}) {
      base = normalizeBaseKey(base);
      await Promise.all(
        getMounts(base, false).map(async (m) => {
          if (m.driver.clear) {
            return asyncCall(m.driver.clear, m.relativeBase, opts);
          }
          if (m.driver.removeItem) {
            const keys = await m.driver.getKeys(m.relativeBase || "", opts);
            return Promise.all(
              keys.map((key) => m.driver.removeItem(key, opts))
            );
          }
        })
      );
    },
    async dispose() {
      await Promise.all(
        Object.values(context.mounts).map((driver) => dispose(driver))
      );
    },
    async watch(callback) {
      await startWatch();
      context.watchListeners.push(callback);
      return async () => {
        context.watchListeners = context.watchListeners.filter(
          (listener) => listener !== callback
        );
        if (context.watchListeners.length === 0) {
          await stopWatch();
        }
      };
    },
    async unwatch() {
      context.watchListeners = [];
      await stopWatch();
    },
    // Mount
    mount(base, driver) {
      base = normalizeBaseKey(base);
      if (base && context.mounts[base]) {
        throw new Error(`already mounted at ${base}`);
      }
      if (base) {
        context.mountpoints.push(base);
        context.mountpoints.sort((a, b) => b.length - a.length);
      }
      context.mounts[base] = driver;
      if (context.watching) {
        Promise.resolve(watch(driver, onChange, base)).then((unwatcher) => {
          context.unwatch[base] = unwatcher;
        }).catch(console.error);
      }
      return storage;
    },
    async unmount(base, _dispose = true) {
      base = normalizeBaseKey(base);
      if (!base || !context.mounts[base]) {
        return;
      }
      if (context.watching && base in context.unwatch) {
        context.unwatch[base]();
        delete context.unwatch[base];
      }
      if (_dispose) {
        await dispose(context.mounts[base]);
      }
      context.mountpoints = context.mountpoints.filter((key) => key !== base);
      delete context.mounts[base];
    },
    getMount(key = "") {
      key = normalizeKey(key) + ":";
      const m = getMount(key);
      return {
        driver: m.driver,
        base: m.base
      };
    },
    getMounts(base = "", opts = {}) {
      base = normalizeKey(base);
      const mounts = getMounts(base, opts.parents);
      return mounts.map((m) => ({
        driver: m.driver,
        base: m.mountpoint
      }));
    }
  };
  return storage;
}
function watch(driver, onChange, base) {
  return driver.watch ? driver.watch((event, key) => onChange(event, base + key)) : () => {
  };
}
async function dispose(driver) {
  if (typeof driver.dispose === "function") {
    await asyncCall(driver.dispose);
  }
}

const WebExtensionDriver = defineDriver((opts = {})=>{
    function isValid() {
        return !!browser.runtime?.id;
    }
    const r = (key)=>(opts.base ? opts.base + ':' : '') + key;
    const storage = opts.storage || browser.storage.local;
    async function getKeys() {
        if (!isValid()) {
            return [];
        }
        const result = await storage.get();
        return Object.keys(result);
    }
    return {
        name: 'browser.storage',
        options: opts,
        getInstance: ()=>storage,
        async hasItem (key) {
            if (!isValid()) {
                return false;
            }
            const result = await storage.get();
            return Object.prototype.hasOwnProperty.call(result, r(key));
        },
        async getItem (key) {
            if (!isValid()) {
                return null;
            }
            const result = await storage.get(key);
            return result[key];
        },
        async getItems (items) {
            if (!isValid()) {
                return [];
            }
            const keys = items.map(({ key })=>key);
            return storage.get(keys).then((result)=>{
                return Object.entries(result).map(([key, value])=>({
                        key,
                        value: value
                    }));
            });
        },
        async setItem (key, value) {
            if (!isValid()) {
                return;
            }
            return storage.set({
                [key]: value
            });
        },
        async setItems (items) {
            if (!isValid()) {
                return;
            }
            const record = Object.fromEntries(items.map(({ key, value })=>[
                    key,
                    value
                ]));
            return storage.set(record);
        },
        async removeItem (key) {
            if (!isValid()) {
                return;
            }
            return storage.remove(key);
        },
        getKeys,
        async clear () {
            if (!isValid()) {
                return;
            }
            if (opts.base) {
                const keys = await getKeys();
                await storage.remove(keys);
            } else {
                await storage.clear();
            }
        },
        watch (callback) {
            if (!isValid()) {
                return noop$1;
            }
            function listener(changes) {
                const keys = Object.keys(changes);
                for (const key of keys){
                    const change = changes[key];
                    const event = 'newValue' in change ? 'update' : 'remove';
                    callback(event, key);
                }
            }
            if (storage === browser.storage.session) {
                browser.storage.session.onChanged.addListener(listener);
                return ()=>browser.storage.session.onChanged.removeListener(listener);
            }
            let area = '';
            if (storage === browser.storage.local) {
                area = 'local';
            } else if (storage === browser.storage.sync) {
                area = 'sync';
            } else if (storage === browser.storage.managed) {
                area = 'managed';
            }
            function listenerWithArea(changes, areaName) {
                if (areaName !== area) {
                    return;
                }
                listener(changes);
            }
            browser.storage.onChanged.addListener(listenerWithArea);
            return ()=>{
                browser.storage.onChanged.removeListener(listenerWithArea);
            };
        }
    };
});
async function syncStorage(state$, storage, storageKey, defaultValue) {
    let storedValue;
    let initialized = false;
    async function update() {
        const value = await storage.getItem(storageKey);
        storedValue = value ?? defaultValue;
        state$.next(storedValue);
        initialized = true;
    }
    const subscription = state$.subscribe(async (value)=>{
        if (!initialized || Object.is(storedValue, value)) {
            return;
        }
        await storage.setItem(storageKey, value);
        storedValue = value;
    });
    subscription.add(await storage.watch((_event, key)=>{
        if (storageKey !== key) {
            return;
        }
        update();
    }));
    await update();
    return subscription;
}

let sharedStorage;
function getSharedStorage() {
    if (!sharedStorage) {
        sharedStorage = createStorage({
            driver: WebExtensionDriver({
                storage: browser.storage.local
            })
        });
    }
    return sharedStorage;
}
let sessionStorage;
function getSessionStorage() {
    if (!sessionStorage) {
        sessionStorage = createStorage({
            driver: WebExtensionDriver({
                storage: browser.storage.session
            })
        });
    }
    return sessionStorage;
}
function syncRecorderState(recorderState$) {
    return syncStorage(recorderState$, getSessionStorage(), 'recorder-state', RecorderStateInitialValue);
}

const CLIENT_ID_KEY = 'client-id';
async function getClientId() {
    const storage = getSharedStorage();
    let id = await storage.getItem(CLIENT_ID_KEY);
    if (!id) {
        id = crypto.randomUUID();
        await storage.setItem(CLIENT_ID_KEY, id);
    }
    return id;
}
const publicFetch = createPublicFetch({
    async onRequest (context, next) {
        await next();
        const storage = getSharedStorage();
        const appId = await storage.getItem(APP_ID_KEY);
        const auth = await storage.getItem(OAUTH_KEY);
        const env = await storage.getItem(ENV_KEY);
        context.options.query = {
            ...context.options.query ?? {},
            ...getFetchQuery(appId)
        };
        context.options.baseURL = getServerOrigin(env || 'production');
        if (auth?.accessToken) {
            context.options.query['accessToken'] = auth.accessToken;
        }
    }
});

export { singleton as $, arrayPush as A, keys as B, getSymbols as C, stubArray as D, baseGetAllKeys as E, FETCH as F, getTag as G, getAllKeys as H, toNumber as I, baseFindIndex as J, baseIteratee as K, LOGGER as L, baseGet as M, baseIsEqual as N, castPath as O, toKey as P, hasIn as Q, REGION as R, STORAGE as S, baseUniq as T, UploaderService as U, get as V, memoize as W, setupServer as X, OAUTH_CLIENT as Y, OAUTH_CONTROLLER as Z, RecorderClientTransport as _, getSharedStorage as a, inject as a0, UPLOADER_SERVICE as a1, FILE_STASH_SERVICE as a2, SELECT_ELEMENT_SERVICE as a3, $logCls as a4, createStorage as b, checkAppId as c, defineDriver as d, createFetch as e, FONT_SETTINGS_SERVICE as f, getSessionStorage as g, FilesService as h, instance as i, RecorderDB as j, storageObservable as k, RecorderStateInitialValue as l, syncRecorderState as m, RecordingStatus as n, syncStorage as o, resetTasks as p, getClientId as q, recordStop$1 as r, setupWebExtensionOAuth as s, publicFetch as t, SelectElementActionType as u, stashFileContent$1 as v, waitForClientConnect as w, FileStatus as x, clearCompletedTask as y, FetchContextKey as z };
